/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/buffer","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/resources","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/base/node/pfs","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,n=Q.length;D<n;D++)e[D]=ie[Q[D]];return e};define(ie[106],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,k){if(!n)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=D}),define(ie[48],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(I,E,C){this.id=I,this.definition=E,this.description=C,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(A,I){const E=["codicon","codicon-"+A];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=k;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(P){if(P instanceof n)return["codicon","codicon-"+P.id];const p=I.exec(P.id);if(!p)return E(n.error);let[,y,g]=p;const v=["codicon","codicon-"+y];return g&&v.push("codicon-modifier-"+g.substr(1)),v}A.asClassNameArray=E;function C(P){return E(P).join(" ")}A.asClassName=C;function R(P){return"."+E(P).join(".")}A.asCSSSelector=R})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ie[69],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(R){const P=[];for(let p in R)D.call(R,p)&&P.push(R[p]);return P}e.values=n;function k(R,P){for(let p in R)if(D.call(R,p)&&P({key:p,value:R[p]},function(){delete R[p]})===!1)return}e.forEach=k;function T(R,P){const p=Object.create(null);for(const y of R){const g=P(y);let v=p[g];v||(v=p[g]=[]),v.push(y)}return p}e.groupBy=T;function A(R){const P=Object.create(null);return R&&R.forEach((p,y)=>{P[y]=p}),P}e.fromMap=A;function I(R,P){const p=[],y=[];for(let g of R)P.has(g)||p.push(g);for(let g of P)R.has(g)||y.push(g);return{removed:p,added:y}}e.diffSets=I;function E(R,P){const p=[],y=[];for(let[g,v]of R)P.has(g)||p.push(v);for(let[g,v]of P)R.has(g)||y.push(v);return{removed:p,added:y}}e.diffMaps=E;class C{constructor(){this.map=new Map}add(P,p){let y=this.map.get(P);y||(y=new Set,this.map.set(P,y)),y.add(p)}delete(P,p){const y=this.map.get(P);!y||(y.delete(p),y.size===0&&this.map.delete(P))}forEach(P,p){const y=this.map.get(P);!y||y.forEach(p)}}e.SetMap=C}),define(ie[55],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(I,E,C)=>{let R=null,P=null;if(typeof C.value=="function"?(R="value",P=C.value):typeof C.get=="function"&&(R="get",P=C.get),!P)throw new Error("not supported");C[R]=A(P,E)}}e.createDecorator=D;function n(A,I,E){let C=null,R=null;if(typeof E.value=="function"?(C="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",R=E.get),!R)throw new Error("not supported");const P=`$memoize$${I}`;E[C]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[P]}}e.memoize=n;function k(A,I,E){return D((C,R)=>{const P=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...y){this[p]||(this[p]=E?E():void 0),clearTimeout(this[P]),I&&(this[p]=I(this[p],...y),y=[this[p]]),this[P]=setTimeout(()=>{C.apply(this,y),this[p]=E?E():void 0},A)}})}e.debounce=k;function T(A,I,E){return D((C,R)=>{const P=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...v){if(this[p]||(this[p]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...v)),this[g])return;const f=this[y]+A;f<=Date.now()?(this[y]=Date.now(),C.apply(this,[this[p]]),this[p]=E?E():void 0):(this[g]=!0,this[P]=setTimeout(()=>{this[g]=!1,this[y]=Date.now(),C.apply(this,[this[p]]),this[p]=E?E():void 0},f-Date.now()))}})}e.throttle=T}),define(ie[8],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(c=>{c(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function k(u){E(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function T(u){E(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=T;function A(u){if(u instanceof Error){let{name:t,message:c}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:t,message:c,stack:i}}return u}e.transformErrorForSerialization=A;const I="Canceled";function E(u){return u instanceof C?!0:u instanceof Error&&u.name===I&&u.message===I}e.isCancellationError=E;class C extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=C;function R(){const u=new Error(I);return u.name=u.message,u}e.canceled=R;function P(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=P;function p(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=p;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function g(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=g;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=v;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class d extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=d;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;class w extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(t){if(t&&t instanceof w)return t;if(t&&t instanceof Error){const c=new w;return c.name=t.name,c.message=t.message,c.stack=t.stack,c}return new w(t)}}e.ErrorNoTelemetry=w;class m extends Error{constructor(t){super(t);Object.setPrototypeOf(this,m.prototype);debugger}}e.BugIndicatingError=m}),define(ie[17],re([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(M,j=0){return M[M.length-(1+j)]}e.tail=n;function k(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=k;function T(M,j,B=(J,ne)=>J===ne){if(M===j)return!0;if(!M||!j||M.length!==j.length)return!1;for(let J=0,ne=M.length;J<ne;J++)if(!B(M[J],j[J]))return!1;return!0}e.equals=T;function A(M,j,B){let J=0,ne=M.length-1;for(;J<=ne;){const ae=(J+ne)/2|0,he=B(M[ae],j);if(he<0)J=ae+1;else if(he>0)ne=ae-1;else return ae}return-(J+1)}e.binarySearch=A;function I(M,j){let B=0,J=M.length;if(J===0)return 0;for(;B<J;){const ne=Math.floor((B+J)/2);j(M[ne])?J=ne:B=ne+1}return B}e.findFirstInSorted=I;function E(M,j,B){if(M=M|0,M>=j.length)throw new TypeError("invalid index");let J=j[Math.floor(j.length*Math.random())],ne=[],ae=[],he=[];for(let ve of j){const we=B(ve,J);we<0?ne.push(ve):we>0?ae.push(ve):he.push(ve)}return M<ne.length?E(M,ne,B):M<ne.length+he.length?he[0]:E(M-(ne.length+he.length),ae,B)}e.quickSelect=E;function C(M,j){const B=[];let J;for(const ne of M.slice(0).sort(j))!J||j(J[0],ne)!==0?(J=[ne],B.push(J)):J.push(ne);return B}e.groupBy=C;function R(M,j,B){const J=[];function ne(ve,we,ge){if(we===0&&ge.length===0)return;const ye=J[J.length-1];ye&&ye.start+ye.deleteCount===ve?(ye.deleteCount+=we,ye.toInsert.push(...ge)):J.push({start:ve,deleteCount:we,toInsert:ge})}let ae=0,he=0;for(;;){if(ae===M.length){ne(ae,0,j.slice(he));break}if(he===j.length){ne(ae,M.length-ae,[]);break}const ve=M[ae],we=j[he],ge=B(ve,we);ge===0?(ae+=1,he+=1):ge<0?(ne(ae,1,[]),ae+=1):ge>0&&(ne(ae,0,[we]),he+=1)}return J}e.sortedDiff=R;function P(M,j,B){const J=R(M,j,B),ne=[],ae=[];for(const he of J)ne.push(...M.slice(he.start,he.start+he.deleteCount)),ae.push(...he.toInsert);return{removed:ne,added:ae}}e.delta=P;function p(M,j,B){if(B===0)return[];const J=M.slice(0,B).sort(j);return g(M,j,J,B,M.length),J}e.top=p;function y(M,j,B,J,ne){return B===0?Promise.resolve([]):new Promise((ae,he)=>{(async()=>{const ve=M.length,we=M.slice(0,B).sort(j);for(let ge=B,ye=Math.min(B+J,ve);ge<ve;ge=ye,ye=Math.min(ye+J,ve)){if(ge>B&&await new Promise(De=>setTimeout(De)),ne&&ne.isCancellationRequested)throw new D.CancellationError;g(M,j,we,ge,ye)}return we})().then(ae,he)})}e.topAsync=y;function g(M,j,B,J,ne){for(const ae=B.length;J<ne;J++){const he=M[J];if(j(he,B[ae-1])<0){B.pop();const ve=I(B,we=>j(he,we)<0);B.splice(ve,0,he)}}}function v(M){return M.filter(j=>!!j)}e.coalesce=v;function f(M){let j=0;for(let B=0;B<M.length;B++)M[B]&&(M[j]=M[B],j+=1);M.length=j}e.coalesceInPlace=f;function d(M,j,B){M.splice(B,0,M.splice(j,1)[0])}e.move=d;function S(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=S;function w(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=w;function m(M,j=B=>B){const B=new Set;return M.filter(J=>{const ne=j(J);return B.has(ne)?!1:(B.add(ne),!0)})}e.distinct=m;function u(M){const j=new Set;return B=>{const J=M(B);return j.has(J)?!1:(j.add(J),!0)}}e.uniqueFilter=u;function t(M,j){const B=c(M,j);if(B!==-1)return M[B]}e.findLast=t;function c(M,j){for(let B=M.length-1;B>=0;B--){const J=M[B];if(j(J))return B}return-1}e.lastIndex=c;function i(M,j){return M.length>0?M[0]:j}e.firstOrDefault=i;function o(M,j){return M.length>0?M[M.length-1]:j}e.lastOrDefault=o;function a(M,j,B=(J,ne)=>J===ne){let J=0;for(let ne=0,ae=Math.min(M.length,j.length);ne<ae&&B(M[ne],j[ne]);ne++)J++;return J}e.commonPrefixLength=a;function r(M){return[].concat(...M)}e.flatten=r;function s(M,j){let B=typeof j=="number"?M:0;typeof j=="number"?B=M:(B=0,j=M);const J=[];if(B<=j)for(let ne=B;ne<j;ne++)J.push(ne);else for(let ne=B;ne>j;ne--)J.push(ne);return J}e.range=s;function l(M,j,B){return M.reduce((J,ne)=>(J[j(ne)]=B?B(ne):ne,J),Object.create(null))}e.index=l;function h(M,j){return M.push(j),()=>b(M,j)}e.insert=h;function b(M,j){const B=M.indexOf(j);if(B>-1)return M.splice(B,1),j}e.remove=b;function _(M,j,B){const J=M.slice(0,j),ne=M.slice(j);return J.concat(B,ne)}e.arrayInsert=_;function U(M,j){let B;if(typeof j=="number"){let J=j;B=()=>{const ne=Math.sin(J++)*179426549;return ne-Math.floor(ne)}}else B=Math.random;for(let J=M.length-1;J>0;J-=1){const ne=Math.floor(B()*(J+1)),ae=M[J];M[J]=M[ne],M[ne]=ae}}e.shuffle=U;function N(M,j){const B=M.indexOf(j);B>-1&&(M.splice(B,1),M.unshift(j))}e.pushToStart=N;function L(M,j){const B=M.indexOf(j);B>-1&&(M.splice(B,1),M.push(j))}e.pushToEnd=L;function F(M,j){for(const B of j)M.push(B)}e.pushMany=F;function O(M,j){return Array.isArray(M)?M.map(j):j(M)}e.mapArrayOrNot=O;function W(M){return Array.isArray(M)?M:[M]}e.asArray=W;function H(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=H;function te(M,j){for(const B of M){const J=j(B);if(J!==void 0)return J}}e.mapFind=te;function G(M,j,B){const J=q(M,j),ne=M.length,ae=B.length;M.length=ne+ae;for(let he=ne-1;he>=J;he--)M[he+ae]=M[he];for(let he=0;he<ae;he++)M[he+J]=B[he]}e.insertInto=G;function $(M,j,B,J){const ne=q(M,j),ae=M.splice(ne,B);return G(M,ne,J),ae}e.splice=$;function q(M,j){return j<0?Math.max(j+M.length,0):Math.min(j,M.length)}function V(M,j){return(B,J)=>j(M(B),M(J))}e.compareBy=V;const x=(M,j)=>M-j;e.numberComparator=x;function K(M,j){if(M.length===0)return;let B=M[0];for(let J=1;J<M.length;J++){const ne=M[J];j(ne,B)>0&&(B=ne)}return B}e.findMaxBy=K;function Z(M,j){if(M.length===0)return;let B=M[0];for(let J=1;J<M.length;J++){const ne=M[J];j(ne,B)>=0&&(B=ne)}return B}e.findLastMaxBy=Z;function X(M,j){return K(M,(B,J)=>-j(B,J))}e.findMinBy=X;class z{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let B=this.firstIdx;for(;B<this.items.length&&j(this.items[B]);)B++;const J=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,J}takeFromEndWhile(j){let B=this.lastIdx;for(;B>=0&&j(this.items[B]);)B--;const J=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,J}peek(){return this.items[this.firstIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}takeCount(j){const B=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,B}}e.ArrayQueue=z}),define(ie[70],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const k=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(k,arguments)),A}}e.once=D}),define(ie[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function k(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=k;const T=Object.freeze([]);function A(){return T}n.empty=A;function*I(u){yield u}n.single=I;function E(u){return u||T}n.from=E;function C(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=C;function R(u){return u[Symbol.iterator]().next().value}n.first=R;function P(u,t){for(const c of u)if(t(c))return!0;return!1}n.some=P;function p(u,t){for(const c of u)if(t(c))return c}n.find=p;function*y(u,t){for(const c of u)t(c)&&(yield c)}n.filter=y;function*g(u,t){let c=0;for(const i of u)yield t(i,c++)}n.map=g;function*v(...u){for(const t of u)for(const c of t)yield c}n.concat=v;function*f(u){for(const t of u)for(const c of t)yield c}n.concatNested=f;function d(u,t,c){let i=c;for(const o of u)i=t(i,o);return i}n.reduce=d;function*S(u,t,c=u.length){for(t<0&&(t+=u.length),c<0?c+=u.length:c>u.length&&(c=u.length);t<c;t++)yield u[t]}n.slice=S;function w(u,t=Number.POSITIVE_INFINITY){const c=[];if(t===0)return[c,u];const i=u[Symbol.iterator]();for(let o=0;o<t;o++){const a=i.next();if(a.done)return[c,n.empty()];c.push(a.value)}return[c,{[Symbol.iterator](){return i}}]}n.consume=w;function m(u,t,c=(i,o)=>i===o){const i=u[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=i.next(),r=o.next();if(a.done!==r.done)return!1;if(a.done)return!0;if(!c(a.value,r.value))return!1}}n.equals=m})(D=e.Iterable||(e.Iterable={}))}),define(ie[33],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(t,c=!1){let i=0,o=t.length,a="",r=0,s=16,l=0;function h(O){let W=0,H=0;for(;W<O;){const te=t.charCodeAt(i);if(te>=48&&te<=57)H=H*16+te-48;else if(te>=65&&te<=70)H=H*16+te-65+10;else if(te>=97&&te<=102)H=H*16+te-97+10;else break;i++,W++}return W<O&&(H=-1),H}function b(O){i=O,a="",r=0,s=16,l=0}function _(){const O=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&C(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&C(t.charCodeAt(i)))for(i++;i<t.length&&C(t.charCodeAt(i));)i++;else return l=3,t.substring(O,i);let W=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&C(t.charCodeAt(i))){for(i++;i<t.length&&C(t.charCodeAt(i));)i++;W=i}else l=3;return t.substring(O,W)}function U(){let O="",W=i;for(;;){if(i>=o){O+=t.substring(W,i),l=2;break}const H=t.charCodeAt(i);if(H===34){O+=t.substring(W,i),i++;break}if(H===92){if(O+=t.substring(W,i),i++,i>=o){l=2;break}switch(t.charCodeAt(i++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const G=h(4);G>=0?O+=String.fromCharCode(G):l=4;break}default:l=5}W=i;continue}if(H>=0&&H<=31)if(E(H)){O+=t.substring(W,i),l=2;break}else l=6;i++}return O}function N(){if(a="",l=0,r=i,i>=o)return r=o,s=17;let O=t.charCodeAt(i);if(I(O)){do i++,a+=String.fromCharCode(O),O=t.charCodeAt(i);while(I(O));return s=15}if(E(O))return i++,a+=String.fromCharCode(O),O===13&&t.charCodeAt(i)===10&&(i++,a+=`
`),s=14;switch(O){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,a=U(),s=10;case 47:{const W=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<o&&!E(t.charCodeAt(i));)i++;return a=t.substring(W,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const H=o-1;let te=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,te=!0;break}i++}return te||(i++,l=1),a=t.substring(W,i),s=13}return a+=String.fromCharCode(O),i++,s=16}case 45:if(a+=String.fromCharCode(O),i++,i===o||!C(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=_(),s=11;default:for(;i<o&&L(O);)i++,O=t.charCodeAt(i);if(r!==i){switch(a=t.substring(r,i),a){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return a+=String.fromCharCode(O),i++,s=16}}function L(O){if(I(O)||E(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:b,getPosition:()=>i,scan:c?F:N,getToken:()=>s,getTokenValue:()=>a,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>l}}e.createScanner=A;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function P(t,c){const i=[],o=new Object;let a;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(h,b,_,U){r.value=h,r.offset=b,r.length=_,r.type=U,r.colonOffset=void 0,a=r}try{w(t,{onObjectBegin:(h,b)=>{if(c<=h)throw o;a=void 0,s=c>h,i.push("")},onObjectProperty:(h,b,_)=>{if(c<b||(l(h,b,_,"property"),i[i.length-1]=h,c<=b+_))throw o},onObjectEnd:(h,b)=>{if(c<=h)throw o;a=void 0,i.pop()},onArrayBegin:(h,b)=>{if(c<=h)throw o;a=void 0,i.push(0)},onArrayEnd:(h,b)=>{if(c<=h)throw o;a=void 0,i.pop()},onLiteralValue:(h,b,_)=>{if(c<b||(l(h,b,_,u(h)),c<=b+_))throw o},onSeparator:(h,b,_)=>{if(c<=b)throw o;if(h===":"&&a&&a.type==="property")a.colonOffset=b,s=!1,a=void 0;else if(h===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(s=!0,i[i.length-1]=""),a=void 0}}})}catch(h){if(h!==o)throw h}return{path:i,previousNode:a,isAtPropertyKey:s,matches:h=>{let b=0;for(let _=0;b<h.length&&_<i.length;_++)if(h[b]===i[_]||h[b]==="*")b++;else if(h[b]!=="**")return!1;return b===h.length}}}e.getLocation=P;function p(t,c=[],i=T.DEFAULT){let o=null,a=[];const r=[];function s(h){Array.isArray(a)?a.push(h):o!==null&&(a[o]=h)}return w(t,{onObjectBegin:()=>{const h={};s(h),r.push(a),a=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const h=[];s(h),r.push(a),a=h,o=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:s,onError:(h,b,_)=>{c.push({error:h,offset:b,length:_})}},i),a[0]}e.parse=p;function y(t,c=[],i=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function r(h){return o.children.push(h),h}w(t,{onObjectBegin:h=>{o=r({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,b,_)=>{o=r({type:"property",offset:b,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:b,length:_,parent:o})},onObjectEnd:(h,b)=>{o.length=h+b-o.offset,o=o.parent,a(h+b)},onArrayBegin:(h,b)=>{o=r({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,b)=>{o.length=h+b-o.offset,o=o.parent,a(h+b)},onLiteralValue:(h,b,_)=>{r({type:u(h),offset:b,length:_,parent:o,value:h}),a(b+_)},onSeparator:(h,b,_)=>{o.type==="property"&&(h===":"?o.colonOffset=b:h===","&&a(b))},onError:(h,b,_)=>{c.push({error:h,offset:b,length:_})}},i);const l=o.children[0];return l&&delete l.parent,l}e.parseTree=y;function g(t,c){if(!t)return;let i=t;for(let o of c)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===o){i=r.children[1],a=!0;break}if(!a)return}else{const a=o;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=g;function v(t){if(!t.parent||!t.parent.children)return[];const c=v(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=v;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const c=Object.create(null);for(let i of t.children){const o=i.children[1];o&&(c[i.children[0].value]=f(o))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function d(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=d;function S(t,c,i=!1){if(d(t,c,i)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=c;a++){const r=S(o[a],c,i);if(r)return r}return t}}e.findNodeAtOffset=S;function w(t,c,i=T.DEFAULT){const o=A(t,!1);function a(Z){return Z?()=>Z(o.getTokenOffset(),o.getTokenLength()):()=>!0}function r(Z){return Z?X=>Z(X,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=a(c.onObjectBegin),l=r(c.onObjectProperty),h=a(c.onObjectEnd),b=a(c.onArrayBegin),_=a(c.onArrayEnd),U=r(c.onLiteralValue),N=r(c.onSeparator),L=a(c.onComment),F=r(c.onError),O=i&&i.disallowComments,W=i&&i.allowTrailingComma;function H(){for(;;){const Z=o.scan();switch(o.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:O||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(Z){case 12:case 13:O?te(10):L();break;case 16:te(1);break;case 15:case 14:break;default:return Z}}}function te(Z,X=[],z=[]){if(F(Z),X.length+z.length>0){let M=o.getToken();for(;M!==17;){if(X.indexOf(M)!==-1){H();break}else if(z.indexOf(M)!==-1)break;M=H()}}}function G(Z){const X=o.getTokenValue();return Z?U(X):l(X),H(),!0}function $(){switch(o.getToken()){case 11:{let Z=0;try{Z=JSON.parse(o.getTokenValue()),typeof Z!="number"&&(te(2),Z=0)}catch{te(2)}U(Z);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return H(),!0}function q(){return o.getToken()!==10?(te(3,[],[2,5]),!1):(G(!1),o.getToken()===6?(N(":"),H(),K()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function V(){s(),H();let Z=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Z||te(4,[],[]),N(","),H(),o.getToken()===2&&W)break}else Z&&te(6,[],[]);q()||te(4,[],[2,5]),Z=!0}return h(),o.getToken()!==2?te(7,[2],[]):H(),!0}function x(){b(),H();let Z=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Z||te(4,[],[]),N(","),H(),o.getToken()===4&&W)break}else Z&&te(6,[],[]);K()||te(4,[],[4,5]),Z=!0}return _(),o.getToken()!==4?te(8,[4],[]):H(),!0}function K(){switch(o.getToken()){case 3:return x();case 1:return V();case 10:return G(!0);default:return $()}}return H(),o.getToken()===17?i.allowEmptyContent?!0:(te(4,[],[]),!1):K()?(o.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=w;function m(t,c){let i=A(t),o=[],a,r=0,s;do switch(s=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:r!==s&&o.push(t.substring(r,s)),c!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,c)),r=i.getPosition();break}while(a!==17);return o.join("")}e.stripComments=m;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ie[49],re([0,1,33]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(C,R,P){let p,y,g,v,f;if(R){for(v=R.offset,f=v+R.length,g=v;g>0&&!E(C,g-1);)g--;let s=f;for(;s<C.length&&!E(C,s);)s++;y=C.substring(g,s),p=A(y,P)}else y=C,p=0,g=0,v=0,f=C.length;const d=I(P,C);let S=!1,w=0,m;P.insertSpaces?m=T(" ",P.tabSize||4):m="	";const u=(0,D.createScanner)(y,!1);let t=!1;function c(){return d+T(m,p+w)}function i(){let s=u.scan();for(S=!1;s===15||s===14;)S=S||s===14,s=u.scan();return t=s===16||u.getTokenError()!==0,s}const o=[];function a(s,l,h){!t&&l<f&&h>v&&C.substring(l,h)!==s&&o.push({offset:l,length:h-l,content:s})}let r=i();if(r!==17){const s=u.getTokenOffset()+g,l=T(m,p);a(l,g,s)}for(;r!==17;){let s=u.getTokenOffset()+u.getTokenLength()+g,l=i(),h="";for(;!S&&(l===12||l===13);){const _=u.getTokenOffset()+g;a(" ",s,_),s=u.getTokenOffset()+u.getTokenLength()+g,h=l===12?c():"",l=i()}if(l===2)r!==1&&(w--,h=c());else if(l===4)r!==3&&(w--,h=c());else{switch(r){case 3:case 1:w++,h=c();break;case 5:case 12:h=c();break;case 13:S?h=c():h=" ";break;case 6:h=" ";break;case 10:if(l===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?h=" ":l!==5&&l!==17&&(t=!0);break;case 16:t=!0;break}S&&(l===12||l===13)&&(h=c())}const b=u.getTokenOffset()+g;a(h,s,b),r=l}return o}e.format=n;function k(C,R){const P=JSON.stringify(C,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?P.replace(/\r\n|\r|\n/g,R.eol):P}e.toFormattedString=k;function T(C,R){let P="";for(let p=0;p<R;p++)P+=C;return P}function A(C,R){let P=0,p=0;const y=R.tabSize||4;for(;P<C.length;){const g=C.charAt(P);if(g===" ")p++;else if(g==="	")p+=y;else break;P++}return Math.floor(p/y)}function I(C,R){for(let P=0;P<R.length;P++){const p=R.charAt(P);if(p==="\r")return P+1<R.length&&R.charAt(P+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=I;function E(C,R){return`\r
`.indexOf(C.charAt(R))!==-1}e.isEOL=E}),define(ie[71],re([0,1,33,49]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(C,R,P){return T(C,R,void 0,P)}e.removeProperty=k;function T(C,R,P,p,y){const g=R.slice(),v=[],f=(0,D.parseTree)(C,v);let d,S;for(;g.length>0&&(S=g.pop(),d=(0,D.findNodeAtLocation)(f,g),d===void 0&&P!==void 0);)typeof S=="string"?P={[S]:P}:P=[P];if(d)if(d.type==="object"&&typeof S=="string"&&Array.isArray(d.children)){const w=(0,D.findNodeAtLocation)(d,[S]);if(w!==void 0)if(P===void 0){if(!w.parent)throw new Error("Malformed AST");const m=d.children.indexOf(w.parent);let u,t=w.parent.offset+w.parent.length;if(m>0){const c=d.children[m-1];u=c.offset+c.length}else u=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return A(C,{offset:u,length:t-u,content:""},p)}else return A(C,{offset:w.offset,length:w.length,content:JSON.stringify(P)},p);else{if(P===void 0)return[];const m=`${JSON.stringify(S)}: ${JSON.stringify(P)}`,u=y?y(d.children.map(c=>c.children[0].value)):d.children.length;let t;if(u>0){const c=d.children[u-1];t={offset:c.offset+c.length,length:0,content:","+m}}else d.children.length===0?t={offset:d.offset+1,length:0,content:m}:t={offset:d.offset+1,length:0,content:m+","};return A(C,t,p)}}else if(d.type==="array"&&typeof S=="number"&&Array.isArray(d.children))if(P!==void 0){const w=`${JSON.stringify(P)}`;let m;if(d.children.length===0||S===0)m={offset:d.offset+1,length:0,content:d.children.length===0?w:w+","};else{const u=S===-1||S>d.children.length?d.children.length:S,t=d.children[u-1];m={offset:t.offset+t.length,length:0,content:","+w}}return A(C,m,p)}else{const w=S,m=d.children[w];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===w){const t=d.children[w-1],c=t.offset+t.length,i=d.offset+d.length;u={offset:c,length:i-2-c,content:""}}else u={offset:m.offset,length:d.children[w+1].offset-m.offset,content:""};return A(C,u,p)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${d.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(P)},p)}}e.setProperty=T;function A(C,R,P){let p=I(C,R),y=R.offset,g=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;y>0&&!(0,n.isEOL)(p,y-1);)y--;for(;g<p.length&&!(0,n.isEOL)(p,g);)g++}const v=(0,n.format)(p,{offset:y,length:g-y},P);for(let d=v.length-1;d>=0;d--){const S=v[d];p=I(p,S),y=Math.min(y,S.offset),g=Math.max(g,S.offset+S.length),g+=S.content.length-S.length}const f=C.length-(p.length-g)-y;return[{offset:y,length:f,content:p.substring(y,g)}]}e.withFormatting=A;function I(C,R){return C.substring(0,R.offset)+R.content+C.substring(R.offset+R.length)}e.applyEdit=I;function E(C,R){let P=R.slice(0).sort((y,g)=>{const v=y.offset-g.offset;return v===0?y.length-g.length:v}),p=C.length;for(let y=P.length-1;y>=0;y--){let g=P[y];if(g.offset+g.length<=p)C=I(C,g);else throw new Error("Overlapping edit");p=g.offset}return C}e.applyEdits=E}),define(ie[107],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new D(()=>k(this.getValue()))}}e.Lazy=D}),define(ie[2],re([0,1,70,56]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let T=null;function A(a){T=a}if(e.setDisposableTracker=A,k){const a="__is_disposable_tracked__";A(new class{trackDisposable(r){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(s)},3e3)}setParent(r,s){if(r&&r!==S.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==S.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function I(a){return T?.trackDisposable(a),a}function E(a){T?.markAsDisposed(a)}function C(a,r){T?.setParent(a,r)}function R(a,r){if(!!T)for(const s of a)T.setParent(s,r)}function P(a){return T?.markAsSingleton(a),a}e.markAsSingleton=P;class p extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=p;function y(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=y;function g(a){if(n.Iterable.is(a)){let r=[];for(const s of a)if(s)try{s.dispose()}catch(l){r.push(l)}if(r.length===1)throw r[0];if(r.length>1)throw new p(r);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=g;function v(...a){const r=f(()=>g(a));return R(a,r),r}e.combinedDisposable=v;function f(a){const r=I({dispose:(0,D.once)(()=>{E(r),a()})});return r}e.toDisposable=f;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return C(r,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new d,I(this),C(this._store,this)}dispose(){E(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&C(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&C(r,null),r}}e.MutableDisposable=w;class m{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=m;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(r){let s=r;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,E(this))},this}}e.SafeDisposable=u;class t{constructor(){this.references=new Map}acquire(r,...s){let l=this.references.get(r);l||(l={counter:0,object:this.createReferencedObject(r,...s)},this.references.set(r,l));const{object:h}=l,b=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(r,l.object),this.references.delete(r))});return l.counter++,{object:h,dispose:b}}}e.ReferenceCollection=t;class c{constructor(r){this.referenceCollection=r}async acquire(r,...s){const l=this.referenceCollection.acquire(r,...s);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=c;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function o(a){const r=new d;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=o}),define(ie[108],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const I=new D(T);if(this._first===D.Undefined)this._first=I,this._last=I;else if(A){const C=this._last;this._last=I,I.prev=C,C.next=I}else{const C=this._first;this._first=I,I.next=C,C.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function Q(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function A(E){T.push(E,Date.now())}function I(){const E=[];for(let C=0;C<T.length;C+=2)E.push({name:T[C],startTime:T[C+1]});return E}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(k+A.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(ie[4],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const D="en";let n=!1,k=!1,T=!1,A=!1,I=!1,E=!1,C=!1,R=!1,P=!1,p,y=D,g,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const d=typeof f?.versions?.electron=="string",S=d&&f?.type==="renderer";if(typeof navigator=="object"&&!S)v=navigator.userAgent,n=v.indexOf("Windows")>=0,k=v.indexOf("Macintosh")>=0,R=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=v.indexOf("Linux")>=0,E=!0,p=navigator.language,y=p;else if(typeof f=="object"){n=f.platform==="win32",k=f.platform==="darwin",T=f.platform==="linux",A=T&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,C=d,P=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=D,y=D;const r=f.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),l=s.availableLanguages["*"];p=s.locale,y=l||D,g=s._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function m(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let u=0;k?u=1:n?u=3:T&&(u=2),e.isWindows=n,e.isMacintosh=k,e.isLinux=T,e.isLinuxSnap=A,e.isNative=I,e.isElectron=C,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isCI=P,e.platform=u,e.userAgent=v,e.language=y;var t;(function(r){function s(){return e.language}r.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function h(){return e.language==="en"}r.isDefault=h})(t=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let h=0,b=r.length;h<b;h++){const _=r[h];if(_.id===l.data.vscodeScheduleAsyncWork){r.splice(h,1),_.callback();return}}});let s=0;return l=>{const h=++s;r.push({id:h,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return r=>setTimeout(r)})();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||R?2:n?1:3;let i=!0,o=!1;function a(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,i=new Uint16Array(r.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[34],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const k=D.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ie[10],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,T=90,A=122,I=46,E=47,C=92,R=58,P=63;class p extends Error{constructor(m,u,t){let c;typeof u=="string"&&u.indexOf("not ")===0?(c="must not be",u=u.replace(/^not /,"")):c="must be";const i=m.indexOf(".")!==-1?"property":"argument";let o=`The "${m}" ${i} ${c} of type ${u}`;o+=`. Received type ${typeof t}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function y(w,m){if(typeof w!="string")throw new p(m,"string",w)}function g(w){return w===E||w===C}function v(w){return w===E}function f(w){return w>=n&&w<=T||w>=k&&w<=A}function d(w,m,u,t){let c="",i=0,o=-1,a=0,r=0;for(let s=0;s<=w.length;++s){if(s<w.length)r=w.charCodeAt(s);else{if(t(r))break;r=E}if(t(r)){if(!(o===s-1||a===1))if(a===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==I||c.charCodeAt(c.length-2)!==I){if(c.length>2){const l=c.lastIndexOf(u);l===-1?(c="",i=0):(c=c.slice(0,l),i=c.length-1-c.lastIndexOf(u)),o=s,a=0;continue}else if(c.length!==0){c="",i=0,o=s,a=0;continue}}m&&(c+=c.length>0?`${u}..`:"..",i=2)}else c.length>0?c+=`${u}${w.slice(o+1,s)}`:c=w.slice(o+1,s),i=s-o-1;o=s,a=0}else r===I&&a!==-1?++a:a=-1}return c}function S(w,m){if(m===null||typeof m!="object")throw new p("pathObject","Object",m);const u=m.dir||m.root,t=m.base||`${m.name||""}${m.ext||""}`;return u?u===m.root?`${u}${t}`:`${u}${w}${t}`:t}e.win32={resolve(...w){let m="",u="",t=!1;for(let c=w.length-1;c>=-1;c--){let i;if(c>=0){if(i=w[c],y(i,"path"),i.length===0)continue}else m.length===0?i=D.cwd():(i=D.env[`=${m}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==m.toLowerCase()&&i.charCodeAt(2)===C)&&(i=`${m}\\`));const o=i.length;let a=0,r="",s=!1;const l=i.charCodeAt(0);if(o===1)g(l)&&(a=1,s=!0);else if(g(l))if(s=!0,g(i.charCodeAt(1))){let h=2,b=h;for(;h<o&&!g(i.charCodeAt(h));)h++;if(h<o&&h!==b){const _=i.slice(b,h);for(b=h;h<o&&g(i.charCodeAt(h));)h++;if(h<o&&h!==b){for(b=h;h<o&&!g(i.charCodeAt(h));)h++;(h===o||h!==b)&&(r=`\\\\${_}\\${i.slice(b,h)}`,a=h)}}}else a=1;else f(l)&&i.charCodeAt(1)===R&&(r=i.slice(0,2),a=2,o>2&&g(i.charCodeAt(2))&&(s=!0,a=3));if(r.length>0)if(m.length>0){if(r.toLowerCase()!==m.toLowerCase())continue}else m=r;if(t){if(m.length>0)break}else if(u=`${i.slice(a)}\\${u}`,t=s,s&&m.length>0)break}return u=d(u,!t,"\\",g),t?`${m}\\${u}`:`${m}${u}`||"."},normalize(w){y(w,"path");const m=w.length;if(m===0)return".";let u=0,t,c=!1;const i=w.charCodeAt(0);if(m===1)return v(i)?"\\":w;if(g(i))if(c=!0,g(w.charCodeAt(1))){let a=2,r=a;for(;a<m&&!g(w.charCodeAt(a));)a++;if(a<m&&a!==r){const s=w.slice(r,a);for(r=a;a<m&&g(w.charCodeAt(a));)a++;if(a<m&&a!==r){for(r=a;a<m&&!g(w.charCodeAt(a));)a++;if(a===m)return`\\\\${s}\\${w.slice(r)}\\`;a!==r&&(t=`\\\\${s}\\${w.slice(r,a)}`,u=a)}}}else u=1;else f(i)&&w.charCodeAt(1)===R&&(t=w.slice(0,2),u=2,m>2&&g(w.charCodeAt(2))&&(c=!0,u=3));let o=u<m?d(w.slice(u),!c,"\\",g):"";return o.length===0&&!c&&(o="."),o.length>0&&g(w.charCodeAt(m-1))&&(o+="\\"),t===void 0?c?`\\${o}`:o:c?`${t}\\${o}`:`${t}${o}`},isAbsolute(w){y(w,"path");const m=w.length;if(m===0)return!1;const u=w.charCodeAt(0);return g(u)||m>2&&f(u)&&w.charCodeAt(1)===R&&g(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let m,u;for(let i=0;i<w.length;++i){const o=w[i];y(o,"path"),o.length>0&&(m===void 0?m=u=o:m+=`\\${o}`)}if(m===void 0)return".";let t=!0,c=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++c;const i=u.length;i>1&&g(u.charCodeAt(1))&&(++c,i>2&&(g(u.charCodeAt(2))?++c:t=!1))}if(t){for(;c<m.length&&g(m.charCodeAt(c));)c++;c>=2&&(m=`\\${m.slice(c)}`)}return e.win32.normalize(m)},relative(w,m){if(y(w,"from"),y(m,"to"),w===m)return"";const u=e.win32.resolve(w),t=e.win32.resolve(m);if(u===t||(w=u.toLowerCase(),m=t.toLowerCase(),w===m))return"";let c=0;for(;c<w.length&&w.charCodeAt(c)===C;)c++;let i=w.length;for(;i-1>c&&w.charCodeAt(i-1)===C;)i--;const o=i-c;let a=0;for(;a<m.length&&m.charCodeAt(a)===C;)a++;let r=m.length;for(;r-1>a&&m.charCodeAt(r-1)===C;)r--;const s=r-a,l=o<s?o:s;let h=-1,b=0;for(;b<l;b++){const U=w.charCodeAt(c+b);if(U!==m.charCodeAt(a+b))break;U===C&&(h=b)}if(b!==l){if(h===-1)return t}else{if(s>l){if(m.charCodeAt(a+b)===C)return t.slice(a+b+1);if(b===2)return t.slice(a+b)}o>l&&(w.charCodeAt(c+b)===C?h=b:b===2&&(h=3)),h===-1&&(h=0)}let _="";for(b=c+h+1;b<=i;++b)(b===i||w.charCodeAt(b)===C)&&(_+=_.length===0?"..":"\\..");return a+=h,_.length>0?`${_}${t.slice(a,r)}`:(t.charCodeAt(a)===C&&++a,t.slice(a,r))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const m=e.win32.resolve(w);if(m.length<=2)return w;if(m.charCodeAt(0)===C){if(m.charCodeAt(1)===C){const u=m.charCodeAt(2);if(u!==P&&u!==I)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(f(m.charCodeAt(0))&&m.charCodeAt(1)===R&&m.charCodeAt(2)===C)return`\\\\?\\${m}`;return w},dirname(w){y(w,"path");const m=w.length;if(m===0)return".";let u=-1,t=0;const c=w.charCodeAt(0);if(m===1)return g(c)?w:".";if(g(c)){if(u=t=1,g(w.charCodeAt(1))){let a=2,r=a;for(;a<m&&!g(w.charCodeAt(a));)a++;if(a<m&&a!==r){for(r=a;a<m&&g(w.charCodeAt(a));)a++;if(a<m&&a!==r){for(r=a;a<m&&!g(w.charCodeAt(a));)a++;if(a===m)return w;a!==r&&(u=t=a+1)}}}}else f(c)&&w.charCodeAt(1)===R&&(u=m>2&&g(w.charCodeAt(2))?3:2,t=u);let i=-1,o=!0;for(let a=m-1;a>=t;--a)if(g(w.charCodeAt(a))){if(!o){i=a;break}}else o=!1;if(i===-1){if(u===-1)return".";i=u}return w.slice(0,i)},basename(w,m){m!==void 0&&y(m,"ext"),y(w,"path");let u=0,t=-1,c=!0,i;if(w.length>=2&&f(w.charCodeAt(0))&&w.charCodeAt(1)===R&&(u=2),m!==void 0&&m.length>0&&m.length<=w.length){if(m===w)return"";let o=m.length-1,a=-1;for(i=w.length-1;i>=u;--i){const r=w.charCodeAt(i);if(g(r)){if(!c){u=i+1;break}}else a===-1&&(c=!1,a=i+1),o>=0&&(r===m.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=a))}return u===t?t=a:t===-1&&(t=w.length),w.slice(u,t)}for(i=w.length-1;i>=u;--i)if(g(w.charCodeAt(i))){if(!c){u=i+1;break}}else t===-1&&(c=!1,t=i+1);return t===-1?"":w.slice(u,t)},extname(w){y(w,"path");let m=0,u=-1,t=0,c=-1,i=!0,o=0;w.length>=2&&w.charCodeAt(1)===R&&f(w.charCodeAt(0))&&(m=t=2);for(let a=w.length-1;a>=m;--a){const r=w.charCodeAt(a);if(g(r)){if(!i){t=a+1;break}continue}c===-1&&(i=!1,c=a+1),r===I?u===-1?u=a:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||c===-1||o===0||o===1&&u===c-1&&u===t+1?"":w.slice(u,c)},format:S.bind(null,"\\"),parse(w){y(w,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return m;const u=w.length;let t=0,c=w.charCodeAt(0);if(u===1)return g(c)?(m.root=m.dir=w,m):(m.base=m.name=w,m);if(g(c)){if(t=1,g(w.charCodeAt(1))){let h=2,b=h;for(;h<u&&!g(w.charCodeAt(h));)h++;if(h<u&&h!==b){for(b=h;h<u&&g(w.charCodeAt(h));)h++;if(h<u&&h!==b){for(b=h;h<u&&!g(w.charCodeAt(h));)h++;h===u?t=h:h!==b&&(t=h+1)}}}}else if(f(c)&&w.charCodeAt(1)===R){if(u<=2)return m.root=m.dir=w,m;if(t=2,g(w.charCodeAt(2))){if(u===3)return m.root=m.dir=w,m;t=3}}t>0&&(m.root=w.slice(0,t));let i=-1,o=t,a=-1,r=!0,s=w.length-1,l=0;for(;s>=t;--s){if(c=w.charCodeAt(s),g(c)){if(!r){o=s+1;break}continue}a===-1&&(r=!1,a=s+1),c===I?i===-1?i=s:l!==1&&(l=1):i!==-1&&(l=-1)}return a!==-1&&(i===-1||l===0||l===1&&i===a-1&&i===o+1?m.base=m.name=w.slice(o,a):(m.name=w.slice(o,i),m.base=w.slice(o,a),m.ext=w.slice(i,a))),o>0&&o!==t?m.dir=w.slice(0,o-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let m="",u=!1;for(let t=w.length-1;t>=-1&&!u;t--){const c=t>=0?w[t]:D.cwd();y(c,"path"),c.length!==0&&(m=`${c}/${m}`,u=c.charCodeAt(0)===E)}return m=d(m,!u,"/",v),u?`/${m}`:m.length>0?m:"."},normalize(w){if(y(w,"path"),w.length===0)return".";const m=w.charCodeAt(0)===E,u=w.charCodeAt(w.length-1)===E;return w=d(w,!m,"/",v),w.length===0?m?"/":u?"./":".":(u&&(w+="/"),m?`/${w}`:w)},isAbsolute(w){return y(w,"path"),w.length>0&&w.charCodeAt(0)===E},join(...w){if(w.length===0)return".";let m;for(let u=0;u<w.length;++u){const t=w[u];y(t,"path"),t.length>0&&(m===void 0?m=t:m+=`/${t}`)}return m===void 0?".":e.posix.normalize(m)},relative(w,m){if(y(w,"from"),y(m,"to"),w===m||(w=e.posix.resolve(w),m=e.posix.resolve(m),w===m))return"";const u=1,t=w.length,c=t-u,i=1,o=m.length-i,a=c<o?c:o;let r=-1,s=0;for(;s<a;s++){const h=w.charCodeAt(u+s);if(h!==m.charCodeAt(i+s))break;h===E&&(r=s)}if(s===a)if(o>a){if(m.charCodeAt(i+s)===E)return m.slice(i+s+1);if(s===0)return m.slice(i+s)}else c>a&&(w.charCodeAt(u+s)===E?r=s:s===0&&(r=0));let l="";for(s=u+r+1;s<=t;++s)(s===t||w.charCodeAt(s)===E)&&(l+=l.length===0?"..":"/..");return`${l}${m.slice(i+r)}`},toNamespacedPath(w){return w},dirname(w){if(y(w,"path"),w.length===0)return".";const m=w.charCodeAt(0)===E;let u=-1,t=!0;for(let c=w.length-1;c>=1;--c)if(w.charCodeAt(c)===E){if(!t){u=c;break}}else t=!1;return u===-1?m?"/":".":m&&u===1?"//":w.slice(0,u)},basename(w,m){m!==void 0&&y(m,"ext"),y(w,"path");let u=0,t=-1,c=!0,i;if(m!==void 0&&m.length>0&&m.length<=w.length){if(m===w)return"";let o=m.length-1,a=-1;for(i=w.length-1;i>=0;--i){const r=w.charCodeAt(i);if(r===E){if(!c){u=i+1;break}}else a===-1&&(c=!1,a=i+1),o>=0&&(r===m.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=a))}return u===t?t=a:t===-1&&(t=w.length),w.slice(u,t)}for(i=w.length-1;i>=0;--i)if(w.charCodeAt(i)===E){if(!c){u=i+1;break}}else t===-1&&(c=!1,t=i+1);return t===-1?"":w.slice(u,t)},extname(w){y(w,"path");let m=-1,u=0,t=-1,c=!0,i=0;for(let o=w.length-1;o>=0;--o){const a=w.charCodeAt(o);if(a===E){if(!c){u=o+1;break}continue}t===-1&&(c=!1,t=o+1),a===I?m===-1?m=o:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||t===-1||i===0||i===1&&m===t-1&&m===u+1?"":w.slice(m,t)},format:S.bind(null,"/"),parse(w){y(w,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return m;const u=w.charCodeAt(0)===E;let t;u?(m.root="/",t=1):t=0;let c=-1,i=0,o=-1,a=!0,r=w.length-1,s=0;for(;r>=t;--r){const l=w.charCodeAt(r);if(l===E){if(!a){i=r+1;break}continue}o===-1&&(a=!1,o=r+1),l===I?c===-1?c=r:s!==1&&(s=1):c!==-1&&(s=-1)}if(o!==-1){const l=i===0&&u?1:i;c===-1||s===0||s===1&&c===o-1&&c===i+1?m.base=m.name=w.slice(l,o):(m.name=w.slice(l,c),m.base=w.slice(l,o),m.ext=w.slice(c,o))}return i>0?m.dir=w.slice(0,i-1):u&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ie[109],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(P){P.text="text/plain",P.binary="application/octet-stream",P.unknown="application/unknown",P.markdown="text/markdown",P.latex="text/latex",P.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const p=(0,D.extname)(P),y=k[p.toLowerCase()];return y!==void 0?y:I(P)}e.getMediaOrTextMime=A;function I(P){const p=(0,D.extname)(P);return T[p.toLowerCase()]}e.getMediaMime=I;function E(P){for(const p in T)if(T[p]===P)return p}e.getExtensionForMimeType=E;const C=/^(.+)\/(.+?)(;.+)?$/;function R(P,p){const y=C.exec(P);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:p?void 0:P}e.normalizeMimeType=R}),define(ie[72],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(I,...E){const C=E.reduce((p,y)=>(p[y]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!C[p]).forEach(p=>{for(let y=0;y<R.length;y++)if(p.search(R[y])!==-1){delete I[p];break}})}e.sanitizeProcessEnvironment=T;function A(I){!I||(delete I.DEBUG,D.isMacintosh&&delete I.DYLD_LIBRARY_PATH,D.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:Q)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function D(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return Q[n].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=Q,D.c=e,D.d=function(n,k,T){D.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:T})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,k){if(1&k&&(n=D(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var A in n)D.d(T,A,function(I){return n[I]}.bind(null,A));return T},D.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(k,"a",k),k},D.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},D.p="",D(D.s=0)}([function(Q,e,D){(function(n){var k;e=Q.exports=z,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],E=e.src=[],C=0,R=C++;E[R]="0|[1-9]\\d*";var P=C++;E[P]="[0-9]+";var p=C++;E[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=C++;E[y]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var g=C++;E[g]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var v=C++;E[v]="(?:"+E[R]+"|"+E[p]+")";var f=C++;E[f]="(?:"+E[P]+"|"+E[p]+")";var d=C++;E[d]="(?:-("+E[v]+"(?:\\."+E[v]+")*))";var S=C++;E[S]="(?:-?("+E[f]+"(?:\\."+E[f]+")*))";var w=C++;E[w]="[0-9A-Za-z-]+";var m=C++;E[m]="(?:\\+("+E[w]+"(?:\\."+E[w]+")*))";var u=C++,t="v?"+E[y]+E[d]+"?"+E[m]+"?";E[u]="^"+t+"$";var c="[v=\\s]*"+E[g]+E[S]+"?"+E[m]+"?",i=C++;E[i]="^"+c+"$";var o=C++;E[o]="((?:<|>)?=?)";var a=C++;E[a]=E[P]+"|x|X|\\*";var r=C++;E[r]=E[R]+"|x|X|\\*";var s=C++;E[s]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[d]+")?"+E[m]+"?)?)?";var l=C++;E[l]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[S]+")?"+E[m]+"?)?)?";var h=C++;E[h]="^"+E[o]+"\\s*"+E[s]+"$";var b=C++;E[b]="^"+E[o]+"\\s*"+E[l]+"$";var _=C++;E[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=C++;E[U]="(?:~>?)";var N=C++;E[N]="(\\s*)"+E[U]+"\\s+",I[N]=new RegExp(E[N],"g");var L=C++;E[L]="^"+E[U]+E[s]+"$";var F=C++;E[F]="^"+E[U]+E[l]+"$";var O=C++;E[O]="(?:\\^)";var W=C++;E[W]="(\\s*)"+E[O]+"\\s+",I[W]=new RegExp(E[W],"g");var H=C++;E[H]="^"+E[O]+E[s]+"$";var te=C++;E[te]="^"+E[O]+E[l]+"$";var G=C++;E[G]="^"+E[o]+"\\s*("+c+")$|^$";var $=C++;E[$]="^"+E[o]+"\\s*("+t+")$|^$";var q=C++;E[q]="(\\s*)"+E[o]+"\\s*("+c+"|"+E[s]+")",I[q]=new RegExp(E[q],"g");var V=C++;E[V]="^\\s*("+E[s]+")\\s+-\\s+("+E[s]+")\\s*$";var x=C++;E[x]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var K=C++;E[K]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)k(Z,E[Z]),I[Z]||(I[Z]=new RegExp(E[Z]));function X(se,ce){if(se instanceof z)return se;if(typeof se!="string"||se.length>T||!(ce?I[i]:I[u]).test(se))return null;try{return new z(se,ce)}catch{return null}}function z(se,ce){if(se instanceof z){if(se.loose===ce)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof z))return new z(se,ce);k("SemVer",se,ce),this.loose=ce;var le=se.trim().match(ce?I[i]:I[u]);if(!le)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ce=+Ee;if(Ce>=0&&Ce<A)return Ce}return Ee}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=X,e.valid=function(se,ce){var le=X(se,ce);return le?le.version:null},e.clean=function(se,ce){var le=X(se.trim().replace(/^[=v]+/,""),ce);return le?le.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(se){return k("SemVer.compare",this.version,this.loose,se),se instanceof z||(se=new z(se,this.loose)),this.compareMain(se)||this.comparePre(se)},z.prototype.compareMain=function(se){return se instanceof z||(se=new z(se,this.loose)),j(this.major,se.major)||j(this.minor,se.minor)||j(this.patch,se.patch)},z.prototype.comparePre=function(se){if(se instanceof z||(se=new z(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var ce=0;do{var le=this.prerelease[ce],Ee=se.prerelease[ce];if(k("prerelease compare",ce,le,Ee),le===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(le===void 0)return-1;if(le!==Ee)return j(le,Ee)}while(++ce)},z.prototype.inc=function(se,ce){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,ce,le,Ee){typeof le=="string"&&(Ee=le,le=void 0);try{return new z(se,le).inc(ce,Ee).version}catch{return null}},e.diff=function(se,ce){if(ae(se,ce))return null;var le=X(se),Ee=X(ce);if(le.prerelease.length||Ee.prerelease.length){for(var Ce in le)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&le[Ce]!==Ee[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in le)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&le[Ce]!==Ee[Ce])return Ce},e.compareIdentifiers=j;var M=/^[0-9]+$/;function j(se,ce){var le=M.test(se),Ee=M.test(ce);return le&&Ee&&(se=+se,ce=+ce),le&&!Ee?-1:Ee&&!le?1:se<ce?-1:se>ce?1:0}function B(se,ce,le){return new z(se,le).compare(new z(ce,le))}function J(se,ce,le){return B(se,ce,le)>0}function ne(se,ce,le){return B(se,ce,le)<0}function ae(se,ce,le){return B(se,ce,le)===0}function he(se,ce,le){return B(se,ce,le)!==0}function ve(se,ce,le){return B(se,ce,le)>=0}function we(se,ce,le){return B(se,ce,le)<=0}function ge(se,ce,le,Ee){var Ce;switch(ce){case"===":typeof se=="object"&&(se=se.version),typeof le=="object"&&(le=le.version),Ce=se===le;break;case"!==":typeof se=="object"&&(se=se.version),typeof le=="object"&&(le=le.version),Ce=se!==le;break;case"":case"=":case"==":Ce=ae(se,le,Ee);break;case"!=":Ce=he(se,le,Ee);break;case">":Ce=J(se,le,Ee);break;case">=":Ce=ve(se,le,Ee);break;case"<":Ce=ne(se,le,Ee);break;case"<=":Ce=we(se,le,Ee);break;default:throw new TypeError("Invalid operator: "+ce)}return Ce}function ye(se,ce){if(se instanceof ye){if(se.loose===ce)return se;se=se.value}if(!(this instanceof ye))return new ye(se,ce);k("comparator",se,ce),this.loose=ce,this.parse(se),this.semver===De?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(se,ce){return j(ce,se)},e.major=function(se,ce){return new z(se,ce).major},e.minor=function(se,ce){return new z(se,ce).minor},e.patch=function(se,ce){return new z(se,ce).patch},e.compare=B,e.compareLoose=function(se,ce){return B(se,ce,!0)},e.rcompare=function(se,ce,le){return B(ce,se,le)},e.sort=function(se,ce){return se.sort(function(le,Ee){return e.compare(le,Ee,ce)})},e.rsort=function(se,ce){return se.sort(function(le,Ee){return e.rcompare(le,Ee,ce)})},e.gt=J,e.lt=ne,e.eq=ae,e.neq=he,e.gte=ve,e.lte=we,e.cmp=ge,e.Comparator=ye;var De={};function Ie(se,ce){if(se instanceof Ie)return se.loose===ce?se:new Ie(se.raw,ce);if(se instanceof ye)return new Ie(se.value,ce);if(!(this instanceof Ie))return new Ie(se,ce);if(this.loose=ce,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function Re(se){return!se||se.toLowerCase()==="x"||se==="*"}function qe(se,ce,le,Ee,Ce,Ue,Le,Me,Ae,_e,ee,oe,ue){return((ce=Re(le)?"":Re(Ee)?">="+le+".0.0":Re(Ce)?">="+le+"."+Ee+".0":">="+ce)+" "+(Me=Re(Ae)?"":Re(_e)?"<"+(+Ae+1)+".0.0":Re(ee)?"<"+Ae+"."+(+_e+1)+".0":oe?"<="+Ae+"."+_e+"."+ee+"-"+oe:"<="+Me)).trim()}function Qe(se,ce){for(var le=0;le<se.length;le++)if(!se[le].test(ce))return!1;if(ce.prerelease.length){for(le=0;le<se.length;le++)if(k(se[le].semver),se[le].semver!==De&&se[le].semver.prerelease.length>0){var Ee=se[le].semver;if(Ee.major===ce.major&&Ee.minor===ce.minor&&Ee.patch===ce.patch)return!0}return!1}return!0}function xe(se,ce,le){try{ce=new Ie(ce,le)}catch{return!1}return ce.test(se)}function Ve(se,ce,le,Ee){var Ce,Ue,Le,Me,Ae;switch(se=new z(se,Ee),ce=new Ie(ce,Ee),le){case">":Ce=J,Ue=we,Le=ne,Me=">",Ae=">=";break;case"<":Ce=ne,Ue=ve,Le=J,Me="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(se,ce,Ee))return!1;for(var _e=0;_e<ce.set.length;++_e){var ee=ce.set[_e],oe=null,ue=null;if(ee.forEach(function(fe){fe.semver===De&&(fe=new ye(">=0.0.0")),oe=oe||fe,ue=ue||fe,Ce(fe.semver,oe.semver,Ee)?oe=fe:Le(fe.semver,ue.semver,Ee)&&(ue=fe)}),oe.operator===Me||oe.operator===Ae||(!ue.operator||ue.operator===Me)&&Ue(se,ue.semver)||ue.operator===Ae&&Le(se,ue.semver))return!1}return!0}ye.prototype.parse=function(se){var ce=this.loose?I[G]:I[$],le=se.match(ce);if(!le)throw new TypeError("Invalid comparator: "+se);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new z(le[2],this.loose):this.semver=De},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(se){return k("Comparator.test",se,this.loose),this.semver===De||(typeof se=="string"&&(se=new z(se,this.loose)),ge(se,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(se,ce){if(!(se instanceof ye))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ie(se.value,ce),xe(this.value,le,ce);if(se.operator==="")return le=new Ie(this.value,ce),xe(se.semver,le,ce);var Ee=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Ue=this.semver.version===se.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),Me=ge(this.semver,"<",se.semver,ce)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Ae=ge(this.semver,">",se.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ee||Ce||Ue&&Le||Me||Ae},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(se){var ce=this.loose;se=se.trim(),k("range",se,ce);var le=ce?I[x]:I[V];se=se.replace(le,qe),k("hyphen replace",se),se=se.replace(I[q],"$1$2$3"),k("comparator trim",se,I[q]),se=(se=(se=se.replace(I[N],"$1~")).replace(I[W],"$1^")).split(/\s+/).join(" ");var Ee=ce?I[G]:I[$],Ce=se.split(" ").map(function(Ue){return function(Le,Me){return k("comp",Le),Le=function(Ae,_e){return Ae.trim().split(/\s+/).map(function(ee){return function(oe,ue){k("caret",oe,ue);var fe=ue?I[te]:I[H];return oe.replace(fe,function(pe,me,be,ke,Te){var Pe;return k("caret",oe,pe,me,be,ke,Te),Re(me)?Pe="":Re(be)?Pe=">="+me+".0.0 <"+(+me+1)+".0.0":Re(ke)?Pe=me==="0"?">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":">="+me+"."+be+".0 <"+(+me+1)+".0.0":Te?(k("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Pe=me==="0"?be==="0"?">="+me+"."+be+"."+ke+Te+" <"+me+"."+be+"."+(+ke+1):">="+me+"."+be+"."+ke+Te+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+ke+Te+" <"+(+me+1)+".0.0"):(k("no pr"),Pe=me==="0"?be==="0"?">="+me+"."+be+"."+ke+" <"+me+"."+be+"."+(+ke+1):">="+me+"."+be+"."+ke+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+ke+" <"+(+me+1)+".0.0"),k("caret return",Pe),Pe})}(ee,_e)}).join(" ")}(Le,Me),k("caret",Le),Le=function(Ae,_e){return Ae.trim().split(/\s+/).map(function(ee){return function(oe,ue){var fe=ue?I[F]:I[L];return oe.replace(fe,function(pe,me,be,ke,Te){var Pe;return k("tilde",oe,pe,me,be,ke,Te),Re(me)?Pe="":Re(be)?Pe=">="+me+".0.0 <"+(+me+1)+".0.0":Re(ke)?Pe=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":Te?(k("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Pe=">="+me+"."+be+"."+ke+Te+" <"+me+"."+(+be+1)+".0"):Pe=">="+me+"."+be+"."+ke+" <"+me+"."+(+be+1)+".0",k("tilde return",Pe),Pe})}(ee,_e)}).join(" ")}(Le,Me),k("tildes",Le),Le=function(Ae,_e){return k("replaceXRanges",Ae,_e),Ae.split(/\s+/).map(function(ee){return function(oe,ue){oe=oe.trim();var fe=ue?I[b]:I[h];return oe.replace(fe,function(pe,me,be,ke,Te,Pe){k("xRange",oe,pe,me,be,ke,Te,Pe);var Ne=Re(be),Fe=Ne||Re(ke),We=Fe||Re(Te);return me==="="&&We&&(me=""),Ne?pe=me===">"||me==="<"?"<0.0.0":"*":me&&We?(Fe&&(ke=0),We&&(Te=0),me===">"?(me=">=",Fe?(be=+be+1,ke=0,Te=0):We&&(ke=+ke+1,Te=0)):me==="<="&&(me="<",Fe?be=+be+1:ke=+ke+1),pe=me+be+"."+ke+"."+Te):Fe?pe=">="+be+".0.0 <"+(+be+1)+".0.0":We&&(pe=">="+be+"."+ke+".0 <"+be+"."+(+ke+1)+".0"),k("xRange return",pe),pe})}(ee,_e)}).join(" ")}(Le,Me),k("xrange",Le),Le=function(Ae,_e){return k("replaceStars",Ae,_e),Ae.trim().replace(I[K],"")}(Le,Me),k("stars",Le),Le}(Ue,ce)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ue){return!!Ue.match(Ee)})),Ce=Ce.map(function(Ue){return new ye(Ue,ce)})},Ie.prototype.intersects=function(se,ce){if(!(se instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Ee){return se.set.some(function(Ce){return Ce.every(function(Ue){return Ee.intersects(Ue,ce)})})})})},e.toComparators=function(se,ce){return new Ie(se,ce).set.map(function(le){return le.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new z(se,this.loose));for(var ce=0;ce<this.set.length;ce++)if(Qe(this.set[ce],se))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(se,ce,le){var Ee=null,Ce=null;try{var Ue=new Ie(ce,le)}catch{return null}return se.forEach(function(Le){Ue.test(Le)&&(Ee&&Ce.compare(Le)!==-1||(Ce=new z(Ee=Le,le)))}),Ee},e.minSatisfying=function(se,ce,le){var Ee=null,Ce=null;try{var Ue=new Ie(ce,le)}catch{return null}return se.forEach(function(Le){Ue.test(Le)&&(Ee&&Ce.compare(Le)!==1||(Ce=new z(Ee=Le,le)))}),Ee},e.validRange=function(se,ce){try{return new Ie(se,ce).range||"*"}catch{return null}},e.ltr=function(se,ce,le){return Ve(se,ce,"<",le)},e.gtr=function(se,ce,le){return Ve(se,ce,">",le)},e.outside=Ve,e.prerelease=function(se,ce){var le=X(se,ce);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(se,ce,le){return se=new Ie(se,le),ce=new Ie(ce,le),se.intersects(ce)},e.coerce=function(se){if(se instanceof z)return se;if(typeof se!="string")return null;var ce=se.match(I[_]);return ce==null?null:X((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,n,k=Q.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(f){if(D===setTimeout)return setTimeout(f,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var E,C=[],R=!1,P=-1;function p(){R&&E&&(R=!1,E.length?C=E.concat(C):P=-1,C.length&&y())}function y(){if(!R){var f=I(p);R=!0;for(var d=C.length;d;){for(E=C,C=[];++P<d;)E&&E[P].run();P=-1,d=C.length}E=null,R=!1,function(S){if(n===clearTimeout)return clearTimeout(S);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(S);try{n(S)}catch{try{return n.call(null,S)}catch{return n.call(this,S)}}}(f)}}function g(f,d){this.fun=f,this.array=d}function v(){}k.nextTick=function(f){var d=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)d[S-1]=arguments[S];C.push(new g(f,d)),C.length!==1||R||I(y)},g.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=v,k.addListener=v,k.once=v,k.off=v,k.removeListener=v,k.removeAllListeners=v,k.emit=v,k.prependListener=v,k.prependOnceListener=v,k.listeners=function(f){return[]},k.binding=function(f){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(f){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ie[110],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(I,E,C){this.level=I,this.key=E,this.value=C,this.forward=[]}}const k=void 0;class T{constructor(I,E=2**16){this.comparator=I,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(I){return Boolean(T._search(this,I,this.comparator))}get(I){return T._search(this,I,this.comparator)?.value}set(I,E){return T._insert(this,I,E,this.comparator)&&(this._size+=1),this}delete(I){const E=T._delete(this,I,this.comparator);return E&&(this._size-=1),E}forEach(I,E){let C=this._header.forward[0];for(;C;)I.call(E,C.value,C.key,this),C=C.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",E=this._header.forward[0];for(;E;)I+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return I}static _search(I,E,C){let R=I._header;for(let P=I._level-1;P>=0;P--)for(;R.forward[P]&&C(R.forward[P].key,E)<0;)R=R.forward[P];if(R=R.forward[0],R&&C(R.key,E)===0)return R}static _insert(I,E,C,R){let P=[],p=I._header;for(let y=I._level-1;y>=0;y--){for(;p.forward[y]&&R(p.forward[y].key,E)<0;)p=p.forward[y];P[y]=p}if(p=p.forward[0],p&&R(p.key,E)===0)return p.value=C,!1;{let y=T._randomLevel(I);if(y>I._level){for(let g=I._level;g<y;g++)P[g]=I._header;I._level=y}p=new n(y,E,C);for(let g=0;g<y;g++)p.forward[g]=P[g].forward[g],P[g].forward[g]=p;return!0}}static _randomLevel(I,E=.5){let C=1;for(;Math.random()<E&&C<I._maxLevel;)C+=1;return C}static _delete(I,E,C){let R=[],P=I._header;for(let p=I._level-1;p>=0;p--){for(;P.forward[p]&&C(P.forward[p].key,E)<0;)P=P.forward[p];R[p]=P}if(P=P.forward[0],!P||C(P.key,E)!==0)return!1;for(let p=0;p<I._level&&R[p].forward[p]===P;p++)R[p].forward[p]=P.forward[p];for(;I._level>0&&I._header.forward[I._level-1]===k;)I._level-=1;return!0}}e.SkipList=T}),define(ie[111],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class k{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ie[3],re([0,1,8,70,2,108,111]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let I=!1,E=!1;var C;(function(r){r.None=()=>k.Disposable.None;function s(X){if(E){const{onListenerDidAdd:z}=X,M=g.create();let j=0;X.onListenerDidAdd=()=>{++j==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),M.print()),z?.()}}}function l(X){return(z,M=null,j)=>{let B=!1,J;return J=X(ne=>{if(!B)return J?J.dispose():B=!0,z.call(M,ne)},null,j),B&&J.dispose(),J}}r.once=l;function h(X,z,M){return F((j,B=null,J)=>X(ne=>j.call(B,z(ne)),null,J),M)}r.map=h;function b(X,z,M){return F((j,B=null,J)=>X(ne=>{z(ne),j.call(B,ne)},null,J),M)}r.forEach=b;function _(X,z,M){return F((j,B=null,J)=>X(ne=>z(ne)&&j.call(B,ne),null,J),M)}r.filter=_;function U(X){return X}r.signal=U;function N(...X){return(z,M=null,j)=>(0,k.combinedDisposable)(...X.map(B=>B(J=>z.call(M,J),null,j)))}r.any=N;function L(X,z,M,j){let B=M;return h(X,J=>(B=z(B,J),B),j)}r.reduce=L;function F(X,z){let M;const j={onFirstListenerAdd(){M=X(B.fire,B)},onLastListenerRemove(){M.dispose()}};z||s(j);const B=new f(j);return z&&z.add(B),B.event}function O(X,z,M=100,j=!1,B,J){let ne,ae,he,ve=0;const we={leakWarningThreshold:B,onFirstListenerAdd(){ne=X(ye=>{ve++,ae=z(ae,ye),j&&!he&&(ge.fire(ae),ae=void 0),clearTimeout(he),he=setTimeout(()=>{const De=ae;ae=void 0,he=void 0,(!j||ve>1)&&ge.fire(De),ve=0},M)})},onLastListenerRemove(){ne.dispose()}};J||s(we);const ge=new f(we);return J&&J.add(ge),ge.event}r.debounce=O;function W(X,z=(j,B)=>j===B,M){let j=!0,B;return _(X,J=>{const ne=j||!z(J,B);return j=!1,B=J,ne},M)}r.latch=W;function H(X,z,M){return[r.filter(X,z,M),r.filter(X,j=>!z(j),M)]}r.split=H;function te(X,z=!1,M=[]){let j=M.slice(),B=X(ae=>{j?j.push(ae):ne.fire(ae)});const J=()=>{j&&j.forEach(ae=>ne.fire(ae)),j=null},ne=new f({onFirstListenerAdd(){B||(B=X(ae=>ne.fire(ae)))},onFirstListenerDidAdd(){j&&(z?setTimeout(J):J())},onLastListenerRemove(){B&&B.dispose(),B=null}});return ne.event}r.buffer=te;class G{constructor(z){this.event=z}map(z){return new G(h(this.event,z))}forEach(z){return new G(b(this.event,z))}filter(z){return new G(_(this.event,z))}reduce(z,M){return new G(L(this.event,z,M))}latch(){return new G(W(this.event))}debounce(z,M=100,j=!1,B){return new G(O(this.event,z,M,j,B))}on(z,M,j){return this.event(z,M,j)}once(z,M,j){return l(this.event)(z,M,j)}}function $(X){return new G(X)}r.chain=$;function q(X,z,M=j=>j){const j=(...ae)=>ne.fire(M(...ae)),B=()=>X.on(z,j),J=()=>X.removeListener(z,j),ne=new f({onFirstListenerAdd:B,onLastListenerRemove:J});return ne.event}r.fromNodeEventEmitter=q;function V(X,z,M=j=>j){const j=(...ae)=>ne.fire(M(...ae)),B=()=>X.addEventListener(z,j),J=()=>X.removeEventListener(z,j),ne=new f({onFirstListenerAdd:B,onLastListenerRemove:J});return ne.event}r.fromDOMEventEmitter=V;function x(X){return new Promise(z=>l(X)(z))}r.toPromise=x;function K(X,z){return z(void 0),X(M=>z(M))}r.runAndSubscribe=K;function Z(X,z){let M=null;function j(J){M?.dispose(),M=new k.DisposableStore,z(J,M)}j(void 0);const B=X(J=>j(J));return(0,k.toDisposable)(()=>{B.dispose(),M?.dispose()})}r.runAndSubscribeWithStore=Z})(C=e.Event||(e.Event={}));class R{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${R._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let P=-1;function p(r){const s=P;return P=r,{dispose(){P=s}}}e.setGlobalLeakWarningThreshold=p;class y{constructor(s,l=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,l){let h=P;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const b=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,b+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let _,U=0;for(const[N,L]of this._stacks)(!_||U<L)&&(_=N,U=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${U}):`),console.warn(_)}return()=>{const _=this._stacks.get(s.value)||0;this._stacks.set(s.value,_-1)}}}class g{constructor(s){this.value=s}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(s,l,h){this.callback=s,this.callbackThis=l,this.stack=h,this.subscription=new k.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class f{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=P>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const l of s)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,l,h)=>{this._listeners||(this._listeners=new T.LinkedList);const b=this._listeners.isEmpty();b&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let _,U;this._leakageMon&&this._listeners.size>=30&&(U=g.create(),_=this._leakageMon.check(U,this._listeners.size+1)),I&&(U=U??g.create());const N=new v(s,l,U),L=this._listeners.push(N);b&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,l);const F=N.subscription.set(()=>{_&&_(),this._disposed||(L(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof k.DisposableStore?h.add(F):Array.isArray(h)&&h.push(F),F}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(let l of this._listeners)this._deliveryQueue.push(this,l,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class d{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(s,l,h){this._queue.push(new w(s,l,h))}clear(s){const l=new T.LinkedList;for(const h of this._queue)h.emitter!==s&&l.push(h);this._queue=l}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(l){(0,D.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=d;class S extends d{clear(s){this._queue.clear()}}class w{constructor(s,l,h){this.emitter=s,this.listener=l,this.event=h}}class m extends f{async fireAsync(s,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const b of this._listeners)this._asyncDeliveryQueue.push([b,s]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[b,_]=this._asyncDeliveryQueue.shift(),U=[],N={..._,token:l,waitUntil:L=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");h&&(L=h(L,b.callback)),U.push(L)}};try{b.invoke(N)}catch(L){(0,D.onUnexpectedError)(L);continue}Object.freeze(U),await Promise.allSettled(U).then(L=>{for(const F of L)F.status==="rejected"&&(0,D.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=m;class u extends f{constructor(s){super(s);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=u;class t extends u{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=t;class c extends f{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=c;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const l={event:s,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const b=this.events.indexOf(l);this.events.splice(b,1)};return(0,k.toDisposable)((0,n.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(l=>this.emitter.fire(l))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(s){return(l,h,b)=>s(_=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>l.call(h,_)):l.call(h,_)},void 0,b)}bufferEvents(s){const l=[];this.buffers.push(l);const h=s();return this.buffers.pop(),l.forEach(b=>b()),h}}e.EventBufferer=o;class a{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=k.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(ie[25],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(I,E){const C=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(C)}}});var k;(function(I){function E(C){return C===I.None||C===I.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=k.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ie[112],re([0,1,25]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new D.CancellationTokenSource,E=this.task(I.token);return this.result={promise:E,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=n;class k{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const E=JSON.stringify(I);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=k;class T{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const E=this.fn(I);return this._map.set(I,E),E}}e.CachedFunction=T}),define(ie[73],re([0,1,3,2]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:D.Event.None,value:A});e.staticObservableValue=k;class T extends n.Disposable{constructor(I){super();this._value=I,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=T}),define(ie[40],re([0,1,8,2]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(m){const u=m;return u?typeof u.read=="function":!1}e.isReadable=k;function T(m){const u=m;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=T;function A(m){const u=m;return u?T(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(m,u){return new E(m,u)}e.newWriteableStream=I;class E{constructor(u,t){this.reducer=u,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(t=>t(u))}emitError(u){this.listeners.error.length===0?(0,D.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(t=>t(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,t){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(u,t){if(this.state.destroyed)return;let c;switch(u){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(m,u){const t=[];let c;for(;(c=m.read())!==null;)t.push(c);return u(t)}e.consumeReadable=C;function R(m,u,t){const c=[];let i;for(;(i=m.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?u(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return m.read()}}}e.peekReadable=R;function P(m,u){return new Promise((t,c)=>{const i=[];p(m,{onData:o=>{u&&i.push(o)},onError:o=>{u?c(o):t(void 0)},onEnd:()=>{t(u?u(i):void 0)}})})}e.consumeStream=P;function p(m,u){let t=!1;return m.on("error",c=>{t||u.onError(c)}),m.on("end",()=>{t||u.onEnd()}),m.on("data",c=>{t||u.onData(c)}),(0,n.toDisposable)(()=>t=!0)}e.listenStream=p;function y(m,u){return new Promise((t,c)=>{const i=new n.DisposableStore,o=[],a=l=>{if(o.push(l),o.length>u)return i.dispose(),m.pause(),t({stream:m,buffer:o,ended:!1})},r=l=>c(l),s=()=>t({stream:m,buffer:o,ended:!0});i.add((0,n.toDisposable)(()=>m.removeListener("error",r))),m.on("error",r),i.add((0,n.toDisposable)(()=>m.removeListener("end",s))),m.on("end",s),i.add((0,n.toDisposable)(()=>m.removeListener("data",a))),m.on("data",a)})}e.peekStream=y;function g(m,u){const t=I(u);return t.end(m),t}e.toStream=g;function v(){const m=I(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=v;function f(m){let u=!1;return{read:()=>u?null:(u=!0,m)}}e.toReadable=f;function d(m,u,t){const c=I(t);return p(m,{onData:i=>c.write(u.data(i)),onError:i=>c.error(u.error?u.error(i):i),onEnd:()=>c.end()}),c}e.transform=d;function S(m,u,t){let c=!1;return{read:()=>{const i=u.read();return c?i:(c=!0,i!==null?t([m,i]):m)}}}e.prefixedReadable=S;function w(m,u,t){let c=!1;const i=I(t);return p(u,{onData:o=>c?i.write(o):(c=!0,i.write(t([m,o]))),onError:o=>i.error(o),onEnd:()=>{c||(c=!0,i.write(m)),i.end()}}),i}e.prefixedStream=w}),define(ie[16],re([0,1,40]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let k,T;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(l)):(k||(k=new TextEncoder),new A(k.encode(l)))}static fromByteArray(l){const h=A.alloc(l.length);for(let b=0,_=l.length;b<_;b++)h.buffer[b]=l[b];return h}static concat(l,h){if(typeof h=="undefined"){h=0;for(let U=0,N=l.length;U<N;U++)h+=l[U].byteLength}const b=A.alloc(h);let _=0;for(let U=0,N=l.length;U<N;U++){const L=l[U];b.set(L,_),_+=L.byteLength}return b}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(l,h){return new A(this.buffer.subarray(l,h))}set(l,h){if(l instanceof A)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return C(this.buffer,l)}writeUInt32BE(l,h){R(this.buffer,l,h)}readUInt32LE(l){return P(this.buffer,l)}writeUInt32LE(l,h){p(this.buffer,l,h)}readUInt8(l){return y(this.buffer,l)}writeUInt8(l,h){g(this.buffer,l,h)}}e.VSBuffer=A;function I(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=I;function E(s,l,h){s[h+0]=l&255,l=l>>>8,s[h+1]=l&255}e.writeUInt16LE=E;function C(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=C;function R(s,l,h){s[h+3]=l,l=l>>>8,s[h+2]=l,l=l>>>8,s[h+1]=l,l=l>>>8,s[h]=l}e.writeUInt32BE=R;function P(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=P;function p(s,l,h){s[h+0]=l&255,l=l>>>8,s[h+1]=l&255,l=l>>>8,s[h+2]=l&255,l=l>>>8,s[h+3]=l&255}e.writeUInt32LE=p;function y(s,l){return s[l]}e.readUInt8=y;function g(s,l,h){s[h]=l}e.writeUInt8=g;function v(s){return D.consumeReadable(s,l=>A.concat(l))}e.readableToBuffer=v;function f(s){return D.toReadable(s)}e.bufferToReadable=f;function d(s){return D.consumeStream(s,l=>A.concat(l))}e.streamToBuffer=d;async function S(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await d(s.stream)])}e.bufferedStreamToBuffer=S;function w(s){return D.toStream(s,l=>A.concat(l))}e.bufferToStream=w;function m(s){return D.transform(s,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=m;function u(s){return D.newWriteableStream(l=>A.concat(l),s)}e.newWriteableBufferStream=u;function t(s,l){return D.prefixedReadable(s,l,h=>A.concat(h))}e.prefixedBufferReadable=t;function c(s,l){return D.prefixedStream(s,l,h=>A.concat(h))}e.prefixedBufferStream=c;function i(s){let l=0,h=0,b=0;const _=new Uint8Array(Math.floor(s.length/4*3)),U=L=>{switch(h){case 3:_[b++]=l|L,h=0;break;case 2:_[b++]=l|L>>>2,l=L<<6,h=3;break;case 1:_[b++]=l|L>>>4,l=L<<4,h=2;break;default:l=L<<2,h=1}};for(let L=0;L<s.length;L++){const F=s.charCodeAt(L);if(F>=65&&F<=90)U(F-65);else if(F>=97&&F<=122)U(F-97+26);else if(F>=48&&F<=57)U(F-48+52);else if(F===43||F===45)U(62);else if(F===47||F===95)U(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${s[L]}`)}}const N=b;for(;h>0;)U(0);return A.wrap(_).slice(0,N)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:s},l=!0,h=!1){const b=h?a:o;let _="";const U=s.byteLength%3;let N=0;for(;N<s.byteLength-U;N+=3){const L=s[N+0],F=s[N+1],O=s[N+2];_+=b[L>>>2],_+=b[(L<<4|F>>>4)&63],_+=b[(F<<2|O>>>6)&63],_+=b[O&63]}if(U===1){const L=s[N+0];_+=b[L>>>2],_+=b[L<<4&63],l&&(_+="==")}else if(U===2){const L=s[N+0],F=s[N+1];_+=b[L>>>2],_+=b[(L<<4|F>>>4)&63],_+=b[F<<2&63],l&&(_+="=")}return _}e.encodeBase64=r}),define(ie[26],re([0,1,112,107]),function(Q,e,D,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function I(ee,...oe){return oe.length===0?ee:ee.replace(A,function(ue,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=oe.length?ue:oe[pe]})}e.format=I;const E=/{([^}]+)}/g;function C(ee,oe){return ee.replace(E,(ue,fe)=>oe[fe]??ue)}e.format2=C;function R(ee){return ee.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=R;function P(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function p(ee,oe){let ue=0;const fe=oe.charCodeAt(0);for(let pe=ee.length-1;pe>=0;pe--)ee.charCodeAt(pe)===fe&&ue++;return ue}e.count=p;function y(ee,oe,ue="\u2026"){return ee.length<=oe?ee:`${ee.substr(0,oe)}${ue}`}e.truncate=y;function g(ee,oe=" "){const ue=v(ee,oe);return f(ue,oe)}e.trim=g;function v(ee,oe){if(!ee||!oe)return ee;const ue=oe.length;if(ue===0||ee.length===0)return ee;let fe=0;for(;ee.indexOf(oe,fe)===fe;)fe=fe+ue;return ee.substring(fe)}e.ltrim=v;function f(ee,oe){if(!ee||!oe)return ee;const ue=oe.length,fe=ee.length;if(ue===0||fe===0)return ee;let pe=fe,me=-1;for(;me=ee.lastIndexOf(oe,pe-1),!(me===-1||me+ue!==pe);){if(me===0)return"";pe=me}return ee.substring(0,pe)}e.rtrim=f;function d(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function S(ee){return ee.replace(/\*/g,"")}e.stripWildcards=S;function w(ee,oe,ue={}){if(!ee)throw new Error("Cannot create regex from empty string");oe||(ee=P(ee)),ue.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(ee,fe)}e.createRegExp=w;function m(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function u(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function t(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=t;function c(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=c;function i(ee){for(let oe=0,ue=ee.length;oe<ue;oe++){const fe=ee.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function o(ee,oe=0,ue=ee.length){for(let fe=oe;fe<ue;fe++){const pe=ee.charCodeAt(fe);if(pe!==32&&pe!==9)return ee.substring(oe,fe)}return ee.substring(oe,ue)}e.getLeadingWhitespace=o;function a(ee,oe=ee.length-1){for(let ue=oe;ue>=0;ue--){const fe=ee.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=a;function r(ee,oe,ue){let fe=[],pe=0;for(const me of ee.matchAll(oe)){if(fe.push(ee.slice(pe,me.index)),me.index===void 0)throw new Error("match.index should be defined");pe=me.index+me[0].length,fe.push(ue(me[0],...me.slice(1),me.index,ee,me.groups))}return fe.push(ee.slice(pe)),Promise.all(fe).then(me=>me.join(""))}e.replaceAsync=r;function s(ee,oe){return ee<oe?-1:ee>oe?1:0}e.compare=s;function l(ee,oe,ue=0,fe=ee.length,pe=0,me=oe.length){for(;ue<fe&&pe<me;ue++,pe++){let Te=ee.charCodeAt(ue),Pe=oe.charCodeAt(pe);if(Te<Pe)return-1;if(Te>Pe)return 1}const be=fe-ue,ke=me-pe;return be<ke?-1:be>ke?1:0}e.compareSubstring=l;function h(ee,oe){return b(ee,oe,0,ee.length,0,oe.length)}e.compareIgnoreCase=h;function b(ee,oe,ue=0,fe=ee.length,pe=0,me=oe.length){for(;ue<fe&&pe<me;ue++,pe++){let Te=ee.charCodeAt(ue),Pe=oe.charCodeAt(pe);if(Te===Pe)continue;if(Te>=128||Pe>=128)return l(ee.toLowerCase(),oe.toLowerCase(),ue,fe,pe,me);_(Te)&&(Te-=32),_(Pe)&&(Pe-=32);const Ne=Te-Pe;if(Ne!==0)return Ne}const be=fe-ue,ke=me-pe;return be<ke?-1:be>ke?1:0}e.compareSubstringIgnoreCase=b;function _(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=_;function U(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=U;function N(ee,oe){return ee.length===oe.length&&b(ee,oe)===0}e.equalsIgnoreCase=N;function L(ee,oe){const ue=oe.length;return oe.length>ee.length?!1:b(ee,oe,0,ue)===0}e.startsWithIgnoreCase=L;function F(ee,oe){let ue,fe=Math.min(ee.length,oe.length);for(ue=0;ue<fe;ue++)if(ee.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=F;function O(ee,oe){let ue,fe=Math.min(ee.length,oe.length);const pe=ee.length-1,me=oe.length-1;for(ue=0;ue<fe;ue++)if(ee.charCodeAt(pe-ue)!==oe.charCodeAt(me-ue))return ue;return fe}e.commonSuffixLength=O;function W(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=W;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function te(ee,oe){return(ee-55296<<10)+(oe-56320)+65536}e.computeCodePoint=te;function G(ee,oe,ue){const fe=ee.charCodeAt(ue);if(W(fe)&&ue+1<oe){const pe=ee.charCodeAt(ue+1);if(H(pe))return te(fe,pe)}return fe}e.getNextCodePoint=G;function $(ee,oe){const ue=ee.charCodeAt(oe-1);if(H(ue)&&oe>1){const fe=ee.charCodeAt(oe-2);if(W(fe))return te(fe,ue)}return ue}class q{constructor(oe,ue=0){this._str=oe,this._len=oe.length,this._offset=ue}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=$(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class V{constructor(oe,ue=0){this._iterator=new q(oe,ue)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=le.getInstance(),ue=this._iterator,fe=ue.offset;let pe=oe.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const me=ue.offset,be=oe.getGraphemeBreakType(ue.nextCodePoint());if(se(pe,be)){ue.setOffset(me);break}pe=be}return ue.offset-fe}prevGraphemeLength(){const oe=le.getInstance(),ue=this._iterator,fe=ue.offset;let pe=oe.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const me=ue.offset,be=oe.getGraphemeBreakType(ue.prevCodePoint());if(se(be,pe)){ue.setOffset(me);break}pe=be}return fe-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function x(ee,oe){return new V(ee,oe).nextGraphemeLength()}e.nextCharLength=x;function K(ee,oe){return new V(ee,oe).prevGraphemeLength()}e.prevCharLength=K;function Z(ee,oe){oe>0&&H(ee.charCodeAt(oe))&&oe--;const ue=oe+x(ee,oe);return[ue-K(ee,ue),ue]}e.getCharContainingOffset=Z;const X=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function z(ee){return X.test(ee)}e.containsRTL=z;const M=/^[\t\n\r\x20-\x7E]*$/;function j(ee){return M.test(ee)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=B;function J(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=J;function ne(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ne;function ae(ee,oe){if(ee.length<oe)return ee;const ue=/\b/g;let fe=0;for(;ue.test(ee)&&!(ee.length-ue.lastIndex<oe);)fe=ue.lastIndex,ue.lastIndex+=1;return ee.substring(fe).replace(/^\s/,"")}e.lcut=ae;const he=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function ge(ee){return ee&&(ee=ee.replace(he,""),ee=ee.replace(ve,""),ee=ee.replace(we,"")),ee}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function De(ee){return ye(ee)?ee.substr(1):ee}e.stripUTF8BOM=De;function Ie(ee,oe){if(!ee||!oe||ee.length<oe.length)return!1;const ue=oe.length,fe=ee.toLowerCase();let pe=0,me=-1;for(;pe<ue;){const be=fe.indexOf(oe[pe],me+1);if(be<0)return!1;me=be,pe++}return!0}e.fuzzyContains=Ie;function Re(ee,oe=!1){return ee?(oe&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=Re;function qe(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=qe;function Qe(ee,oe=1){if(oe===0)return"";let ue=-1;do ue=ee.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?ee:(ee[ue-1]==="\r"&&ue--,ee.substr(0,ue))}e.getNLines=Qe;function xe(ee){const oe=90-65+1;return ee=ee%(2*oe),ee<oe?String.fromCharCode(97+ee):String.fromCharCode(65+ee-oe)}e.singleLetterHash=xe;function Ve(ee){return le.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=Ve;function se(ee,oe){return ee===0?oe!==5&&oe!==7:ee===2&&oe===3?!1:ee===4||ee===2||ee===3||oe===4||oe===2||oe===3?!0:!(ee===8&&(oe===8||oe===9||oe===11||oe===12)||(ee===11||ee===9)&&(oe===9||oe===10)||(ee===12||ee===10)&&oe===10||oe===5||oe===13||oe===7||ee===1||ee===13&&oe===14||ee===6&&oe===6)}var ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class le{constructor(){this._data=Ee()}static getInstance(){return le._INSTANCE||(le._INSTANCE=new le),le._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,fe=ue.length/3;let pe=1;for(;pe<=fe;)if(oe<ue[3*pe])pe=2*pe;else if(oe>ue[3*pe+1])pe=2*pe+1;else return ue[3*pe+2];return 0}}le._INSTANCE=null;function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(ee,oe){if(ee===0)return 0;const ue=Ue(ee,oe);if(ue!==void 0)return ue;const fe=new q(oe,ee);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=Ce;function Ue(ee,oe){const ue=new q(oe,ee);let fe=ue.prevCodePoint();for(;Le(fe)||fe===65039||fe===8419;){if(ue.offset===0)return;fe=ue.prevCodePoint()}if(!ne(fe))return;let pe=ue.offset;return pe>0&&ue.prevCodePoint()===8205&&(pe=ue.offset),pe}function Le(ee){return 127995<=ee&&ee<=127999}var Me;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ae{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Ae.cache.get(Array.from(oe))}static getLocales(){return Ae._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ae,k=Ae,Ae.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ae.cache=new D.LRUCachedFunction(ee=>{function oe(Pe){const Ne=new Map;for(let Fe=0;Fe<Pe.length;Fe+=2)Ne.set(Pe[Fe],Pe[Fe+1]);return Ne}function ue(Pe,Ne){const Fe=new Map(Pe);for(const[We,tt]of Ne)Fe.set(We,tt);return Fe}function fe(Pe,Ne){if(!Pe)return Ne;const Fe=new Map;for(const[We,tt]of Pe)Ne.has(We)&&Fe.set(We,tt);return Fe}const pe=k.ambiguousCharacterData.getValue();let me=ee.filter(Pe=>!Pe.startsWith("_")&&Pe in pe);me.length===0&&(me=["_default"]);let be;for(const Pe of me){const Ne=oe(pe[Pe]);be=fe(be,Ne)}const ke=oe(pe._common),Te=ue(ke,be);return new Ae(Te)}),Ae._locales=new n.Lazy(()=>Object.keys(Ae.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ie[74],re([0,1,26]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(d){return k(d,0)}e.hash=n;function k(d,S){switch(typeof d){case"object":return d===null?T(349,S):Array.isArray(d)?E(d,S):C(d,S);case"string":return I(d,S);case"boolean":return A(d,S);case"number":return T(d,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=k;function T(d,S){return(S<<5)-S+d|0}e.numberHash=T;function A(d,S){return T(d?433:863,S)}function I(d,S){S=T(149417,S);for(let w=0,m=d.length;w<m;w++)S=T(d.charCodeAt(w),S);return S}e.stringHash=I;function E(d,S){return S=T(104579,S),d.reduce((w,m)=>k(m,w),S)}function C(d,S){return S=T(181387,S),Object.keys(d).sort().reduce((w,m)=>(w=I(m,w),k(d[m],w)),S)}class R{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=R;var P;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(d,S,w=32){const m=w-S,u=~((1<<m)-1);return(d<<S|(u&d)>>>m)>>>0}function y(d,S=0,w=d.byteLength,m=0){for(let u=0;u<w;u++)d[S+u]=m}function g(d,S,w="0"){for(;d.length<S;)d=w+d;return d}function v(d,S=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(w=>w.toString(16).padStart(2,"0")).join(""):g((d>>>0).toString(16),S/4)}e.toHexString=v;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const w=S.length;if(w===0)return;const m=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,c,i;for(t!==0?(c=t,i=-1,t=0):(c=S.charCodeAt(0),i=0);;){let o=c;if(D.isHighSurrogate(c))if(i+1<w){const a=S.charCodeAt(i+1);D.isLowSurrogate(a)?(i++,o=D.computeCodePoint(c,a)):o=65533}else{t=c;break}else D.isLowSurrogate(c)&&(o=65533);if(u=this._push(m,u,o),i++,i<w)c=S.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(S,w,m){return m<128?S[w++]=m:m<2048?(S[w++]=192|(m&1984)>>>6,S[w++]=128|(m&63)>>>0):m<65536?(S[w++]=224|(m&61440)>>>12,S[w++]=128|(m&4032)>>>6,S[w++]=128|(m&63)>>>0):(S[w++]=240|(m&1835008)>>>18,S[w++]=128|(m&258048)>>>12,S[w++]=128|(m&4032)>>>6,S[w++]=128|(m&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=f._bigBlock32,w=this._buffDV;for(let s=0;s<64;s+=4)S.setUint32(s,w.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)S.setUint32(s,p(S.getUint32(s-12,!1)^S.getUint32(s-32,!1)^S.getUint32(s-56,!1)^S.getUint32(s-64,!1),1),!1);let m=this._h0,u=this._h1,t=this._h2,c=this._h3,i=this._h4,o,a,r;for(let s=0;s<80;s++)s<20?(o=u&t|~u&c,a=1518500249):s<40?(o=u^t^c,a=1859775393):s<60?(o=u&t|u&c|t&c,a=2400959708):(o=u^t^c,a=3395469782),r=p(m,5)+o+i+a+S.getUint32(s*4,!1)&4294967295,i=c,c=t,t=p(u,30),u=m,m=r;this._h0=this._h0+m&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(Q,e,D,n,k){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?k.call(Q,D):k?k.value=D:e.set(Q,D),D},Be=this&&this.__classPrivateFieldGet||function(Q,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(Q):n?n.value:e.get(Q)};define(ie[39],re([0,1,17,26]),function(Q,e,D,n){"use strict";var k,T,A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(a,r,s){let l=a.get(r);return l===void 0&&(l=s,a.set(r,l)),l}e.getOrSet=E;function C(a){const r=[];return a.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=C;function R(a){const r=[];return a.forEach(s=>{r.push(s)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=R;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=P;class p{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,n.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class y{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const l=this._value.charCodeAt(s);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,n.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var g;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(g||(g={}));class v{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,n.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(d||(d={}));class S{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new S(new v(r,s))}static forPaths(r=!1){return new S(new y(void 0,!r))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new p)}clear(){this._root=void 0}fill(r,s){if(s){const l=s.slice(0);(0,D.shuffle)(l);for(let h of l)this.set(h,r)}else{const l=r.slice(0);(0,D.shuffle)(l);for(let h of l)this.set(h[0],h[1])}}set(r,s){const l=this._iter.reset(r);let h;this._root||(this._root=new f,this._root.segment=l.value());const b=[];for(h=this._root;;){const U=l.cmp(h.segment);if(U>0)h.left||(h.left=new f,h.left.segment=l.value()),b.push([-1,h]),h=h.left;else if(U<0)h.right||(h.right=new f,h.right.segment=l.value()),b.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new f,h.mid.segment=l.value()),b.push([0,h]),h=h.mid;else break}const _=h.value;h.value=s,h.key=r;for(let U=b.length-1;U>=0;U--){const N=b[U][1];N.updateHeight();const L=N.balanceFactor();if(L<-1||L>1){const F=b[U][0],O=b[U+1][0];if(F===1&&O===1)b[U][1]=N.rotateLeft();else if(F===-1&&O===-1)b[U][1]=N.rotateRight();else if(F===1&&O===-1)N.right=b[U+1][1]=b[U+1][1].rotateRight(),b[U][1]=N.rotateLeft();else if(F===-1&&O===1)N.left=b[U+1][1]=b[U+1][1].rotateLeft(),b[U][1]=N.rotateRight();else throw new Error;if(U>0)switch(b[U-1][0]){case-1:b[U-1][1].left=b[U][1];break;case 1:b[U-1][1].right=b[U][1];break;case 0:b[U-1][1].mid=b[U][1];break}else this._root=b[0][1]}}return _}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),h=[];let b=this._root;for(;b;){const _=l.cmp(b.segment);if(_>0)h.push([-1,b]),b=b.left;else if(_<0)h.push([1,b]),b=b.right;else if(l.hasNext())l.next(),h.push([0,b]),b=b.mid;else break}if(!!b){if(s?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const _=this._min(b.right),{key:U,value:N,segment:L}=_;this._delete(_.key,!1),b.key=U,b.value=N,b.segment=L}else{const _=b.left??b.right;if(h.length>0){const[U,N]=h[h.length-1];switch(U){case-1:N.left=_;break;case 0:N.mid=_;break;case 1:N.right=_;break}}else this._root=_}for(let _=h.length-1;_>=0;_--){const U=h[_][1];U.updateHeight();const N=U.balanceFactor();if(N>1?(U.right.balanceFactor()>=0||(U.right=U.right.rotateRight()),h[_][1]=U.rotateLeft()):N<-1&&(U.left.balanceFactor()<=0||(U.left=U.left.rotateLeft()),h[_][1]=U.rotateRight()),_>0)switch(h[_-1][0]){case-1:h[_-1][1].left=h[_][1];break;case 1:h[_-1][1].right=h[_][1];break;case 0:h[_-1][1].mid=h[_][1];break}else this._root=h[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let l=this._root,h;for(;l;){const b=s.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(s.hasNext())s.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=s=>{if(!s)return!0;const l=s.balanceFactor();return l<-1||l>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=S;class w{constructor(r,s){this.uri=r,this.value=s}}class m{constructor(r,s){this[k]="ResourceMap",r instanceof m?(this.map=new Map(r.map),this.toKey=s??m.defaultToKey):(this.map=new Map,this.toKey=r??m.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new w(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[l,h]of this.map)r(h.value,h.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=m,m.defaultToKey=a=>a.toString();class u{constructor(r,s){this[T]="ResourceSet",!r||typeof r=="function"?this._map=new m(r):(this._map=new m(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((l,h)=>r.call(s,h,h,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var t;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(t=e.Touch||(e.Touch={}));class c{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let h=this._map.get(r);if(h)h.value=s,l!==0&&this.touch(h,l);else{switch(h={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return h}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,h=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=c;class i extends c{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{constructor(r){I.set(this,void 0),Et(this,I,r,"f")}get size(){return Be(this,I,"f").size}forEach(r,s){Be(this,I,"f").forEach(r,s)}get(r){return Be(this,I,"f").get(r)}has(r){return Be(this,I,"f").has(r)}entries(){return Be(this,I,"f").entries()}keys(){return Be(this,I,"f").keys()}values(){return Be(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Be(this,I,"f").entries()}}e.ReadonlyMapView=o}),define(ie[75],re([0,1,39]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function k(C){return E(C,"NFC",n)}e.normalizeNFC=k;const T=new D.LRUCache(1e4);function A(C){return E(C,"NFD",T)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function E(C,R,P){if(!C)return C;const p=P.get(C);if(p)return p;let y;return I.test(C)?y=C.normalize(R):y=C,P.set(C,y),y}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return A(R).replace(C,"")}}()}),define(ie[76],re([0,1,26]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(n||(n={})),function(k){const T="error",A="warning",I="warn",E="info",C="ignore";function R(p){return p?D.equalsIgnoreCase(T,p)?k.Error:D.equalsIgnoreCase(A,p)||D.equalsIgnoreCase(I,p)?k.Warning:D.equalsIgnoreCase(E,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function P(p){switch(p){case k.Error:return T;case k.Warning:return A;case k.Info:return E;default:return C}}k.toString=P}(n||(n={})),e.default=n}),define(ie[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(s){return Array.isArray(s)}e.isArray=D;function n(s){return typeof s=="string"}e.isString=n;function k(s){return Array.isArray(s)&&s.every(l=>n(l))}e.isStringArray=k;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="object"&&(s instanceof Uint8Array||s instanceof Uint16Array||s instanceof Uint32Array||s instanceof Float32Array||s instanceof Float64Array||s instanceof Int8Array||s instanceof Int16Array||s instanceof Int32Array||s instanceof BigInt64Array||s instanceof BigUint64Array||s instanceof Uint8ClampedArray)}e.isTypedArray=A;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function E(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=E;function C(s){return s===!0||s===!1}e.isBoolean=C;function R(s){return typeof s=="undefined"}e.isUndefined=R;function P(s){return!p(s)}e.isDefined=P;function p(s){return R(s)||s===null}e.isUndefinedOrNull=p;function y(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=y;function g(s){if(p(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=g;function v(...s){const l=[];for(let h=0;h<s.length;h++){const b=s[h];if(p(b))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(b)}return l}e.assertAllDefined=v;const f=Object.prototype.hasOwnProperty;function d(s){if(!T(s))return!1;for(let l in s)if(f.call(s,l))return!1;return!0}e.isEmptyObject=d;function S(s){return typeof s=="function"}e.isFunction=S;function w(...s){return s.length>0&&s.every(S)}e.areFunctions=w;function m(s,l){const h=Math.min(s.length,l.length);for(let b=0;b<h;b++)u(s[b],l[b])}e.validateConstraints=m;function u(s,l){if(n(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(S(l)){try{if(s instanceof l)return}catch{}if(!p(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function t(s){let l=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=t;function c(s){const l=[];for(const h of t(s))typeof s[h]=="function"&&l.push(h);return l}e.getAllMethodNames=c;function i(s,l){const h=_=>function(){const U=Array.prototype.slice.call(arguments,0);return l(_,U)};let b={};for(const _ of s)b[_]=h(_);return b}e.createProxyObject=i;function o(s){return s===null?void 0:s}e.withNullAsUndefined=o;function a(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=a;function r(s,l="Unreachable"){throw new Error(l)}e.assertNever=r}),define(ie[41],re([0,1,10,4,26,15]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(a){return a===47||a===92}e.isPathSeparator=A;function I(a){return a.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=I;function E(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=E;function C(a,r=D.posix.sep){if(!a)return"";const s=a.length,l=a.charCodeAt(0);if(A(l)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let b=3;const _=b;for(;b<s&&!A(a.charCodeAt(b));b++);if(_!==b&&!A(a.charCodeAt(b+1))){for(b+=1;b<s;b++)if(A(a.charCodeAt(b)))return a.slice(0,b+1).replace(/[\\/]/g,r)}}return r}else if(d(l)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let h=a.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(A(a.charCodeAt(h)))return a.slice(0,h+1)}return""}e.getRoot=C;function R(a){if(!n.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let s=2;const l=s;for(;s<a.length&&(r=a.charCodeAt(s),r!==92);s++);return!(l===s||(r=a.charCodeAt(s+1),isNaN(r)||r===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(a,r=n.isWindows){const s=r?P:p;return!(!a||a.length===0||/^\s+$/.test(a)||(s.lastIndex=0,s.test(a))||r&&y.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=g;function v(a,r,s){const l=a===r;return!s||l?l:!a||!r?!1:(0,k.equalsIgnoreCase)(a,r)}e.isEqual=v;function f(a,r,s,l=D.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let b=r.length;return r.charAt(r.length-1)===l&&b--,a.charAt(b)===l}return r.charAt(r.length-1)!==l&&(r+=l),a.indexOf(r)===0}e.isEqualOrParent=f;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=d;function S(a,r){return n.isWindows&&a.endsWith(":")&&(a+=D.sep),(0,D.isAbsolute)(a)||(a=(0,D.join)(r,a)),a=(0,D.normalize)(a),n.isWindows?(a=(0,k.rtrim)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,k.rtrim)(a,D.sep),a||(a=D.sep)),a}e.sanitizeFilePath=S;function w(a){const r=(0,D.normalize)(a);return n.isWindows?a.length>3?!1:m(r)&&(a.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=w;function m(a,r=n.isWindows){return r?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function u(a){return m(a)?a[0]:void 0}e.getDriveLetter=u;function t(a,r,s){return r.length>a.length?-1:a===r?0:(s&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=t;function c(a){const r=a.split(":");let s,l,h;for(const b of r){const _=Number(b);(0,T.isNumber)(_)?l===void 0?l=_:h===void 0&&(h=_):s=s?[s,b].join(":"):b}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,r,s=8){let l="";for(let b=0;b<s;b++)l+=i.charAt(Math.floor(Math.random()*i.length));let h;return r?h=`${r}-${l}`:h=l,a?(0,D.join)(a,h):h}e.randomPath=o}),define(ie[28],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const f=Array.isArray(v)?[]:{};return Object.keys(v).forEach(d=>{v[d]&&typeof v[d]=="object"?f[d]=n(v[d]):f[d]=v[d]}),f}e.deepClone=n;function k(v){if(!v||typeof v!="object")return v;const f=[v];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const S in d)if(T.call(d,S)){const w=d[S];typeof w=="object"&&!Object.isFrozen(w)&&!(0,D.isTypedArray)(w)&&f.push(w)}}return v}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function A(v,f){return I(v,f,new Set)}e.cloneAndChange=A;function I(v,f,d){if((0,D.isUndefinedOrNull)(v))return v;const S=f(v);if(typeof S!="undefined")return S;if((0,D.isArray)(v)){const w=[];for(const m of v)w.push(I(m,f,d));return w}if((0,D.isObject)(v)){if(d.has(v))throw new Error("Cannot clone recursive data-structure");d.add(v);const w={};for(let m in v)T.call(v,m)&&(w[m]=I(v[m],f,d));return d.delete(v),w}return v}function E(v,f,d=!0){return(0,D.isObject)(v)?((0,D.isObject)(f)&&Object.keys(f).forEach(S=>{S in v?d&&((0,D.isObject)(v[S])&&(0,D.isObject)(f[S])?E(v[S],f[S],d):v[S]=f[S]):v[S]=f[S]}),v):f}e.mixin=E;function C(v,f){if(v===f)return!0;if(v==null||f===null||f===void 0||typeof v!=typeof f||typeof v!="object"||Array.isArray(v)!==Array.isArray(f))return!1;let d,S;if(Array.isArray(v)){if(v.length!==f.length)return!1;for(d=0;d<v.length;d++)if(!C(v[d],f[d]))return!1}else{const w=[];for(S in v)w.push(S);w.sort();const m=[];for(S in f)m.push(S);if(m.sort(),!C(w,m))return!1;for(d=0;d<w.length;d++)if(!C(v[w[d]],f[w[d]]))return!1}return!0}e.equals=C;function R(v){const f=new Set;return JSON.stringify(v,(d,S)=>{if((0,D.isObject)(S)||Array.isArray(S)){if(f.has(S))return"[Circular]";f.add(S)}return S})}e.safeStringify=R;function P(v,f,d){const S=f(v);return typeof S=="undefined"?d:S}e.getOrDefault=P;function p(v,f){const d=Object.create(null);return!v||!f||Object.keys(f).forEach(w=>{const m=v[w],u=f[w];C(m,u)||(d[w]=u)}),d}e.distinct=p;function y(v,f){const d=f.toLowerCase(),S=Object.keys(v).find(w=>w.toLowerCase()===d);return S?v[S]:v[f]}e.getCaseInsensitive=y;function g(v,f){const d=Object.create(null);for(const[S,w]of Object.entries(v))f(S,w)&&(d[S]=w);return d}e.filter=g}),define(ie[7],re([0,1,10,4]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function I(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,o){return!i&&!o?"file":i}function C(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const R="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(o,a,r,s,l,h=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=E(o,h),this.authority=a||R,this.path=C(this.scheme,r||R),this.query=s||R,this.fragment=l||R,I(this,h))}static isUri(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return w(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:r,path:s,query:l,fragment:h}=o;return a===void 0?a=this.scheme:a===null&&(a=R),r===void 0?r=this.authority:r===null&&(r=R),s===void 0?s=this.path:s===null&&(s=R),l===void 0?l=this.query:l===null&&(l=R),h===void 0?h=this.fragment:h===null&&(h=R),a===this.scheme&&r===this.authority&&s===this.path&&l===this.query&&h===this.fragment?this:new v(a,r,s,l,h)}static parse(o,a=!1){const r=p.exec(o);return r?new v(r[2]||R,c(r[4]||R),c(r[5]||R),c(r[7]||R),c(r[9]||R),a):new v(R,R,R,R,R)}static file(o){let a=R;if(n.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const r=o.indexOf(P,2);r===-1?(a=o.substring(2),o=P):(a=o.substring(2,r),o=o.substring(r)||P)}return new v("file",a,o,R,R)}static from(o){const a=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return I(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let r;return n.isWindows&&o.scheme==="file"?r=y.file(D.win32.join(w(o,!0),...a)).path:r=D.posix.join(o.path,...a),o.with({path:r})}toString(o=!1){return m(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof y)return o;{const a=new v(o);return a._formatted=o.external,a._fsPath=o._sep===g?o.fsPath:null,a}}else return o}}e.URI=y;const g=n.isWindows?1:void 0;class v extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(o=!1){return o?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=g),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,o){let a,r=-1;for(let s=0;s<i.length;s++){const l=i.charCodeAt(s);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||o&&l===47)r!==-1&&(a+=encodeURIComponent(i.substring(r,s)),r=-1),a!==void 0&&(a+=i.charAt(s));else{a===void 0&&(a=i.substr(0,s));const h=f[l];h!==void 0?(r!==-1&&(a+=encodeURIComponent(i.substring(r,s)),r=-1),a+=h):r===-1&&(r=s)}}return r!==-1&&(a+=encodeURIComponent(i.substring(r))),a!==void 0?a:i}function S(i){let o;for(let a=0;a<i.length;a++){const r=i.charCodeAt(a);r===35||r===63?(o===void 0&&(o=i.substr(0,a)),o+=f[r]):o!==void 0&&(o+=i[a])}return o!==void 0?o:i}function w(i,o){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,n.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=w;function m(i,o){const a=o?S:d;let r="",{scheme:s,authority:l,path:h,query:b,fragment:_}=i;if(s&&(r+=s,r+=":"),(l||s==="file")&&(r+=P,r+=P),l){let U=l.indexOf("@");if(U!==-1){const N=l.substr(0,U);l=l.substr(U+1),U=N.indexOf(":"),U===-1?r+=a(N,!1):(r+=a(N.substr(0,U),!1),r+=":",r+=a(N.substr(U+1),!1)),r+="@"}l=l.toLowerCase(),U=l.indexOf(":"),U===-1?r+=a(l,!1):(r+=a(l.substr(0,U),!1),r+=l.substr(U))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const U=h.charCodeAt(1);U>=65&&U<=90&&(h=`/${String.fromCharCode(U+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const U=h.charCodeAt(0);U>=65&&U<=90&&(h=`${String.fromCharCode(U+32)}:${h.substr(2)}`)}r+=a(h,!0)}return b&&(r+="?",r+=a(b,!1)),_&&(r+="#",r+=o?_:d(_,!1)),r}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,o=>u(o)):i}}),define(ie[113],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(C){const R=C;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=n;function k(C){const R=[];let P;try{const p=JSON.parse(C.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),P=y.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",C.arguments)}return{args:R,stack:P}}e.parse=k;function T(C){if(typeof C!="string")return T(k(C).stack);const R=C;if(R){const P=A(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=T;function A(C){if(!C)return C;const R=C.indexOf(`
`);return R===-1?C:C.substring(0,R)}function I(C,R){const{args:P,stack:p}=k(C),y=typeof P[0]=="string"&&P.length===1;let g=A(p);g&&(g=`(${g.trim()})`);let v=[];if(typeof P[0]=="string"?g&&y?v=[`%c[${R}] %c${P[0]} %c${g}`,E("blue"),E(""),E("grey")]:v=[`%c[${R}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:v=[`%c[${R}]%`,E("blue"),...P],g&&!y&&v.push(g),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,v)}e.log=I;function E(C){return`color: ${C}`}}),define(ie[77],re([0,1,16,26,7]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,I)}e.stringify=T;function A(C){let R=JSON.parse(C);return R=E(R),R}e.parse=A;function I(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,n.regExpFlags)(R)}:R}function E(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return k.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 14:return new Date(C.source)}if(C instanceof D.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=E(C[P],R+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=E(C[P],R+1))}return C}e.revive=E}),define(ie[19],re([0,1,4,7]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,C,R){this._hosts[E]=C,this._ports[E]=R}setConnectionToken(E,C){this._connectionTokens[E]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const C=E.authority;let R=this._hosts[C];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const P=this._ports[C],p=this._connectionTokens[C];let y=`path=${encodeURIComponent(E.path)}`;return typeof p=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${R}:${P}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new T;class A{asBrowserUri(E,C){const R=this.toUri(E,C);return R.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===k.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?R.with({scheme:k.vscodeFileResource,authority:R.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,C){const R=this.toUri(E,C);return R.scheme===k.vscodeFileResource?R.with({scheme:k.file,authority:R.authority!==A.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,C){return n.URI.isUri(E)?E:n.URI.parse(C.toUrl(E))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ie[20],re([0,1,41,19,10,4,26,7]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(y){return(0,I.uriToFsPath)(y,!0)}e.originalFSPath=E;class C{constructor(g){this._ignorePathCasing=g}compare(g,v,f=!1){return g===v?0:(0,A.compare)(this.getComparisonKey(g,f),this.getComparisonKey(v,f))}isEqual(g,v,f=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,f)===this.getComparisonKey(v,f)}getComparisonKey(g,v=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,v,f=!1){if(g.scheme===v.scheme){if(g.scheme===n.Schemas.file)return D.isEqualOrParent(E(g),E(v),this._ignorePathCasing(g))&&g.query===v.query&&(f||g.fragment===v.fragment);if((0,e.isEqualAuthority)(g.authority,v.authority))return D.isEqualOrParent(g.path,v.path,this._ignorePathCasing(g),"/")&&g.query===v.query&&(f||g.fragment===v.fragment)}return!1}joinPath(g,...v){return I.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return k.posix.basename(g.path)}extname(g){return k.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===n.Schemas.file?v=I.URI.file(k.dirname(E(g))).path:(v=k.posix.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===n.Schemas.file?v=I.URI.file(k.normalize(E(g))).path:v=k.posix.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.isEqualAuthority)(g.authority,v.authority))return;if(g.scheme===n.Schemas.file){const S=k.relative(E(g),E(v));return T.isWindows?D.toSlashes(S):S}let f=g.path||"/",d=v.path||"/";if(this._ignorePathCasing(g)){let S=0;for(const w=Math.min(f.length,d.length);S<w&&!(f.charCodeAt(S)!==d.charCodeAt(S)&&f.charAt(S).toLowerCase()!==d.charAt(S).toLowerCase());S++);f=d.substr(0,S)+f.substr(S)}return k.posix.relative(f,d)}resolvePath(g,v){if(g.scheme===n.Schemas.file){const f=I.URI.file(k.resolve(E(g),v));return g.with({authority:f.authority,path:f.path})}return v=D.toPosixPath(v),g.with({path:k.posix.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(g,v)}hasTrailingPathSeparator(g,v=k.sep){if(g.scheme===n.Schemas.file){const f=E(g);return f.length>D.getRoot(f).length&&f[f.length-1]===v}else{const f=g.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=k.sep){return(0,e.hasTrailingPathSeparator)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=k.sep){let f=!1;if(g.scheme===n.Schemas.file){const d=E(g);f=d!==void 0&&d.length===D.getRoot(d).length&&d[d.length-1]===v}else{v="/";const d=g.path;f=d.length===1&&d.charCodeAt(d.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(g,v)?g.with({path:g.path+"/"}):g}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(y=>y.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new C(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,g){const v=[];for(let f=0;f<y.length;f++){const d=g(y[f]);y.some((S,w)=>w===f?!1:(0,e.isEqualOrParent)(d,g(S)))||v.push(y[f])}return v}e.distinctParents=R;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function g(v){const f=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(w=>{const[m,u]=w.split(":");m&&u&&f.set(m,u)});const S=v.path.substring(0,v.path.indexOf(";"));return S&&f.set(y.META_DATA_MIME,S),f}y.parseMetaData=g})(P=e.DataUri||(e.DataUri={}));function p(y,g,v){if(g){let f=y.path;return f&&f[0]!==k.posix.sep&&(f=k.posix.sep+f),y.with({scheme:v,authority:g,path:f})}return y.with({scheme:v})}e.toLocalResource=p}),define(ie[5],re([0,1,25,8,3,2,20,4]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(X){return!!X&&typeof X.then=="function"}e.isThenable=E;function C(X){const z=new D.CancellationTokenSource,M=X(z.token),j=new Promise((B,J)=>{const ne=z.token.onCancellationRequested(()=>{ne.dispose(),z.dispose(),J(new n.CancellationError)});Promise.resolve(M).then(ae=>{ne.dispose(),z.dispose(),B(ae)},ae=>{ne.dispose(),z.dispose(),J(ae)})});return new class{cancel(){z.cancel()}then(B,J){return j.then(B,J)}catch(B){return this.then(void 0,B)}finally(B){return j.finally(B)}}}e.createCancelablePromise=C;function R(X,z,M){return new Promise((j,B)=>{const J=z.onCancellationRequested(()=>{J.dispose(),j(M)});X.then(j,B).finally(()=>J.dispose())})}e.raceCancellation=R;function P(X,z){return new Promise((M,j)=>{const B=z.onCancellationRequested(()=>{B.dispose(),j(new n.CancellationError)});X.then(M,j).finally(()=>B.dispose())})}e.raceCancellationError=P;async function p(X){let z=-1;const M=X.map((B,J)=>B.then(ne=>(z=J,ne))),j=await Promise.race(M);return X.forEach((B,J)=>{J!==z&&B.cancel()}),j}e.raceCancellablePromises=p;function y(X,z,M){let j;const B=setTimeout(()=>{j?.(void 0),M?.()},z);return Promise.race([X.finally(()=>clearTimeout(B)),new Promise(J=>j=J)])}e.raceTimeout=y;function g(X){return new Promise((z,M)=>{const j=X();E(j)?j.then(z,M):z(j)})}e.asPromise=g;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(M,M).then(j)})}return new Promise((M,j)=>{this.queuedPromise.then(M,j)})}return this.activePromise=z(),new Promise((M,j)=>{this.activePromise.then(B=>{this.activePromise=null,M(B)},B=>{this.activePromise=null,j(B)})})}}e.Throttler=v;class f{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=f;class d{constructor(){this.promiseMap=new Map}queue(z,M){const B=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(z)===B&&this.promiseMap.delete(z)});return this.promiseMap.set(z,B),B}}e.SequencerByKey=d;const S=(X,z)=>{let M=!0;const j=setTimeout(()=>{M=!1,z()},X);return{isTriggered:()=>M,dispose:()=>{clearTimeout(j),M=!1}}},w=X=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,X())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class m{constructor(z){this.defaultDelay=z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,M=this.defaultDelay){this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,J)=>{this.doResolve=B,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?w(j):S(M,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class u{constructor(z){this.delayer=new m(z),this.throttler=new v}trigger(z,M){return this.delayer.trigger(()=>this.throttler.queue(z),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class t{constructor(){this._isOpen=!1,this._promise=new Promise((z,M)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class c extends t{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function i(X,z){return z?new Promise((M,j)=>{const B=setTimeout(()=>{J.dispose(),M()},X),J=z.onCancellationRequested(()=>{clearTimeout(B),J.dispose(),j(new n.CancellationError)})}):C(M=>i(X,M))}e.timeout=i;function o(X,z=0){const M=setTimeout(X,z);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=o;function a(X){const z=[];let M=0;const j=X.length;function B(){return M<j?X[M++]():null}function J(ne){ne!=null&&z.push(ne);const ae=B();return ae?ae.then(J):Promise.resolve(z)}return Promise.resolve(null).then(J)}e.sequence=a;function r(X,z=j=>!!j,M=null){let j=0;const B=X.length,J=()=>{if(j>=B)return Promise.resolve(M);const ne=X[j++];return Promise.resolve(ne()).then(he=>z(he)?Promise.resolve(he):J())};return J()}e.first=r;function s(X,z=j=>!!j,M=null){if(X.length===0)return Promise.resolve(M);let j=X.length;const B=()=>{j=-1;for(const J of X)J.cancel?.()};return new Promise((J,ne)=>{for(const ae of X)ae.then(he=>{--j>=0&&z(he)?(B(),J(he)):j===0&&J(M)}).catch(he=>{--j>=0&&(B(),ne(he))})})}e.firstParallel=s;class l{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(z){return this._size++,new Promise((M,j)=>{this.outstandingPromises.push({factory:z,c:M,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const M=z.factory();M.then(z.c,z.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class b{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const z=new $;return this.drainers.add(z),z.p}isDrained(){for(const[,z]of this.queues)if(z.size>0)return!1;return!0}queueFor(z,M=A.extUri){const j=M.getComparisonKey(z);let B=this.queues.get(j);return B||(B=new h,k.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,B)),B}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const z of this.drainers)z.complete();this.drainers.clear()}dispose(){for(const[,z]of this.queues)z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=b;class _{constructor(z,M){this._token=-1,typeof z=="function"&&typeof M=="number"&&this.setIfNotSet(z,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},M)}setIfNotSet(z,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},M))}}e.TimeoutTimer=_;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,M){this.cancel(),this._token=setInterval(()=>{z()},M)}}e.IntervalTimer=U;class N{constructor(z,M){this.timeoutToken=-1,this.runner=z,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class L{constructor(z,M){M%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=L;class F extends N{constructor(z,M){super(z,M);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class O extends T.Disposable{constructor(z,M){super();this.options=z,this.handler=M,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.options.maxBufferedWork)return!1}else if(this.pending+z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,I.setTimeout0)(()=>{if(z)return;const M=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.runWhenIdle=(X,z)=>{const M=requestIdleCallback(X,typeof z=="number"?{timeout:z}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(M))}}}}();class W{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function H(X,z,M){let j;for(let B=0;B<M;B++)try{return await X()}catch(J){j=J,await i(z)}throw j}e.retry=H;class te{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,M,j){return this._pending={taskId:z,cancel:()=>j?.(),promise:M},M.then(()=>this.donePending(z),()=>this.donePending(z)),M}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let M,j;const B=new Promise((J,ne)=>{M=J,j=ne});this._next={run:z,promise:B,promiseResolve:M,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=te;class G{constructor(z,M=()=>Date.now()){this.interval=z,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const z=this.nowFn();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,M)=>{this.completeCallback=z,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(M=>{this.completeCallback(z),this.resolved=!0,M()})}error(z){return new Promise(M=>{this.errorCallback(z),this.rejected=!0,M()})}cancel(){new Promise(z=>{this.errorCallback(new n.CancellationError),this.rejected=!0,z()})}}e.DeferredPromise=$;var q;(function(X){async function z(j){let B;const J=await Promise.all(j.map(ne=>ne.then(ae=>ae,ae=>{B||(B=ae)})));if(typeof B!="undefined")throw B;return J}X.settled=z;function M(j){return new Promise(async(B,J)=>{try{await j(B,J)}catch(ne){J(ne)}})}X.withAsyncBody=M})(q=e.Promises||(e.Promises={}));var V;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(V||(V={}));class x{constructor(z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const M={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(z(M)),this.resolve()}catch(j){this.reject(j)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}static fromArray(z){return new x(M=>{M.emitMany(z)})}static fromPromise(z){return new x(async M=>{M.emitMany(await z)})}static fromPromises(z){return new x(async M=>{await Promise.all(z.map(async j=>M.emitOne(await j)))})}static merge(z){return new x(async M=>{await Promise.all(z.map(async j=>{for await(const B of j)M.emitOne(B)}))})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(z<this._results.length)return{done:!1,value:this._results[z++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(z,M){return new x(async j=>{for await(const B of z)j.emitOne(M(B))})}map(z){return x.map(this,z)}static filter(z,M){return new x(async j=>{for await(const B of z)M(B)&&j.emitOne(B)})}filter(z){return x.filter(this,z)}static coalesce(z){return x.filter(z,M=>!!M)}coalesce(){return x.coalesce(this)}static async toPromise(z){const M=[];for await(const j of z)M.push(j);return M}toPromise(){return x.toPromise(this)}emitOne(z){this._state===0&&(this._results.push(z),this._onStateChanged.fire())}emitMany(z){this._state===0&&(this._results=this._results.concat(z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(z){this._state===0&&(this._state=2,this._error=z,this._onStateChanged.fire())}}e.AsyncIterableObject=x,x.EMPTY=x.fromArray([]);class K extends x{constructor(z,M){super(M);this._source=z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function Z(X){const z=new D.CancellationTokenSource,M=X(z.token);return new K(z,async j=>{const B=z.token.onCancellationRequested(()=>{B.dispose(),z.dispose(),j.reject(new n.CancellationError)});try{for await(const J of M){if(z.token.isCancellationRequested)return;j.emitOne(J)}B.dispose(),z.dispose()}catch(J){B.dispose(),z.dispose(),j.reject(J)}})}e.createCancelableAsyncIterable=Z}),define(ie[78],re([0,1,17,5,41,39,10,4,26]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",P="[^/\\\\]",p=/\//g;function y($,q){switch($){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${q?`|${R}${P}+`:""})*?`}}function g($,q){if(!$)return[];const V=[];let x=!1,K=!1,Z="";for(const X of $){switch(X){case q:if(!x&&!K){V.push(Z),Z="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":K=!0;break;case"]":K=!1;break}Z+=X}return Z&&V.push(Z),V}e.splitGlobAware=g;function v($){if(!$)return"";let q="";const V=g($,e.GLOB_SPLIT);if(V.every(x=>x===e.GLOBSTAR))q=".*";else{let x=!1;V.forEach((K,Z)=>{if(K===e.GLOBSTAR){if(x)return;q+=y(2,Z===V.length-1)}else{let X=!1,z="",M=!1,j="";for(const B of K){if(B!=="}"&&X){z+=B;continue}if(M&&(B!=="]"||!j)){let J;B==="-"?J=B:(B==="^"||B==="!")&&!j?J="^":B===e.GLOB_SPLIT?J="":J=(0,E.escapeRegExpCharacters)(B),j+=J;continue}switch(B){case"{":X=!0;continue;case"[":M=!0;continue;case"}":{q+=`(?:${g(z,",").map(ae=>v(ae)).join("|")})`,X=!1,z="";break}case"]":{q+="["+j+"]",M=!1,j="";break}case"?":q+=P;continue;case"*":q+=y(1);continue;default:q+=(0,E.escapeRegExpCharacters)(B)}}Z<V.length-1&&(V[Z+1]!==e.GLOBSTAR||Z+2<V.length)&&(q+=R)}x=K===e.GLOBSTAR})}return q}const f=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),c=function(){return!1},i=function(){return null};function o($,q){if(!$)return i;let V;typeof $!="string"?V=$.pattern:V=$,V=V.trim();const x=`${V}_${!!q.trimForExclusions}`;let K=t.get(x);if(K)return a(K,$);let Z;return f.test(V)?K=s(V.substr(4),V):(Z=d.exec(r(V,q)))?K=l(Z[1],V):(q.trimForExclusions?w:S).test(V)?K=h(V,q):(Z=m.exec(r(V,q)))?K=b(Z[1].substr(1),V,!0):(Z=u.exec(r(V,q)))?K=b(Z[1],V,!1):K=_(V),t.set(x,K),a(K,$)}function a($,q){if(typeof q=="string")return $;const V=function(x,K){return(0,k.isEqualOrParent)(x,q.base,!I.isLinux)?$(x.substr(q.base.length+1),K):null};return V.allBasenames=$.allBasenames,V.allPaths=$.allPaths,V.basenames=$.basenames,V.patterns=$.patterns,V}function r($,q){return q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function s($,q){return function(V,x){return typeof V=="string"&&V.endsWith($)?q:null}}function l($,q){const V=`/${$}`,x=`\\${$}`,K=function(X,z){return typeof X!="string"?null:z?z===$?q:null:X===$||X.endsWith(V)||X.endsWith(x)?q:null},Z=[$];return K.basenames=Z,K.patterns=[q],K.allBasenames=Z,K}function h($,q){const V=te($.slice(1,-1).split(",").map(z=>o(z,q)).filter(z=>z!==i),$),x=V.length;if(!x)return i;if(x===1)return V[0];const K=function(z,M){for(let j=0,B=V.length;j<B;j++)if(V[j](z,M))return $;return null},Z=V.find(z=>!!z.allBasenames);Z&&(K.allBasenames=Z.allBasenames);const X=V.reduce((z,M)=>M.allPaths?z.concat(M.allPaths):z,[]);return X.length&&(K.allPaths=X),K}function b($,q,V){const x=A.sep===A.posix.sep,K=x?$:$.replace(p,A.sep),Z=A.sep+K,X=A.posix.sep+$;let z;return V?z=function(M,j){return typeof M=="string"&&(M===K||M.endsWith(Z)||!x&&(M===$||M.endsWith(X)))?q:null}:z=function(M,j){return typeof M=="string"&&(M===K||!x&&M===$)?q:null},z.allPaths=[(V?"*/":"./")+$],z}function _($){try{const q=new RegExp(`^${v($)}$`);return function(V){return q.lastIndex=0,typeof V=="string"&&q.test(V)?$:null}}catch{return i}}function U($,q,V){return!$||typeof q!="string"?!1:N($)(q,void 0,V)}e.match=U;function N($,q={}){if(!$)return c;if(typeof $=="string"||L($)){const V=o($,q);if(V===i)return c;const x=function(K,Z){return!!V(K,Z)};return V.allBasenames&&(x.allBasenames=V.allBasenames),V.allPaths&&(x.allPaths=V.allPaths),x}return W($,q)}e.parse=N;function L($){const q=$;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=L;function F($){return $.allBasenames||[]}e.getBasenameTerms=F;function O($){return $.allPaths||[]}e.getPathTerms=O;function W($,q){const V=te(Object.getOwnPropertyNames($).map(z=>H(z,$[z],q)).filter(z=>z!==i)),x=V.length;if(!x)return i;if(!V.some(z=>!!z.requiresSiblings)){if(x===1)return V[0];const z=function(B,J){let ne;for(let ae=0,he=V.length;ae<he;ae++){const ve=V[ae](B,J);if(typeof ve=="string")return ve;(0,n.isThenable)(ve)&&(ne||(ne=[]),ne.push(ve))}return ne?(async()=>{for(const ae of ne){const he=await ae;if(typeof he=="string")return he}return null})():null},M=V.find(B=>!!B.allBasenames);M&&(z.allBasenames=M.allBasenames);const j=V.reduce((B,J)=>J.allPaths?B.concat(J.allPaths):B,[]);return j.length&&(z.allPaths=j),z}const K=function(z,M,j){let B,J;for(let ne=0,ae=V.length;ne<ae;ne++){const he=V[ne];he.requiresSiblings&&j&&(M||(M=(0,A.basename)(z)),B||(B=M.substr(0,M.length-(0,A.extname)(z).length)));const ve=he(z,M,B,j);if(typeof ve=="string")return ve;(0,n.isThenable)(ve)&&(J||(J=[]),J.push(ve))}return J?(async()=>{for(const ne of J){const ae=await ne;if(typeof ae=="string")return ae}return null})():null},Z=V.find(z=>!!z.allBasenames);Z&&(K.allBasenames=Z.allBasenames);const X=V.reduce((z,M)=>M.allPaths?z.concat(M.allPaths):z,[]);return X.length&&(K.allPaths=X),K}function H($,q,V){if(q===!1)return i;const x=o($,V);if(x===i)return i;if(typeof q=="boolean")return x;if(q){const K=q.when;if(typeof K=="string"){const Z=(X,z,M,j)=>{if(!j||!x(X,z))return null;const B=K.replace("$(basename)",M),J=j(B);return(0,n.isThenable)(J)?J.then(ne=>ne?$:null):J?$:null};return Z.requiresSiblings=!0,Z}}return x}function te($,q){const V=$.filter(z=>!!z.basenames);if(V.length<2)return $;const x=V.reduce((z,M)=>{const j=M.basenames;return j?z.concat(j):z},[]);let K;if(q){K=[];for(let z=0,M=x.length;z<M;z++)K.push(q)}else K=V.reduce((z,M)=>{const j=M.patterns;return j?z.concat(j):z},[]);const Z=function(z,M){if(typeof z!="string")return null;if(!M){let B;for(B=z.length;B>0;B--){const J=z.charCodeAt(B-1);if(J===47||J===92)break}M=z.substr(B)}const j=x.indexOf(M);return j!==-1?K[j]:null};Z.basenames=x,Z.patterns=K,Z.allBasenames=x;const X=$.filter(z=>!z.basenames);return X.push(Z),X}function G($,q){return(0,D.equals)($,q,(V,x)=>typeof V=="string"&&typeof x=="string"?V===x:typeof V!="string"&&typeof x!="string"?V.base===x.base&&V.pattern===x.pattern:!1)}e.patternsEquals=G}),define(ie[114],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(R){return R.toJSON()}class k{constructor(P){this._uriTransformer=P}transformIncoming(P){const p=this._uriTransformer.transformIncoming(P);return p===P?P:n(D.URI.from(p))}transformOutgoing(P){const p=this._uriTransformer.transformOutgoing(P);return p===P?P:n(D.URI.from(p))}transformOutgoingURI(P){const p=this._uriTransformer.transformOutgoing(P);return p===P?P:D.URI.from(p)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,P,p){if(!R||p>200)return null;if(typeof R=="object"){if(R instanceof D.URI)return P.transformOutgoing(R);for(let y in R)if(Object.hasOwnProperty.call(R,y)){const g=T(R[y],P,p+1);g!==null&&(R[y]=g)}}return null}function A(R,P){const p=T(R,P,0);return p===null?R:p}e.transformOutgoingURIs=A;function I(R,P,p,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return p?D.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(let g in R)if(Object.hasOwnProperty.call(R,g)){const v=I(R[g],P,p,y+1);v!==null&&(R[g]=v)}}return null}function E(R,P){const p=I(R,P,!1,0);return p===null?R:p}e.transformIncomingURIs=E;function C(R,P){const p=I(R,P,!0,0);return p===null?R:p}e.transformAndReviveIncomingURIs=C}),define(ie[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(E){return D.test(E)}e.isUUID=n;const k=new Uint8Array(16),T=[];for(let E=0;E<256;E++)T.push(E.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(E){for(let C=0;C<E.length;C++)E[C]=Math.floor(Math.random()*256);return E};function I(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let E=0,C="";return C+=T[k[E++]],C+=T[k[E++]],C+=T[k[E++]],C+=T[k[E++]],C+="-",C+=T[k[E++]],C+=T[k[E++]],C+="-",C+=T[k[E++]],C+=T[k[E++]],C+="-",C+=T[k[E++]],C+=T[k[E++]],C+="-",C+=T[k[E++]],C+=T[k[E++]],C+=T[k[E++]],C+=T[k[E++]],C+=T[k[E++]],C+=T[k[E++]],C}e.generateUuid=I}),define(ie[115],re([0,1,255]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(I.length<1)return A;let E=0,C,R=E;for(;R<I.length;)if(C=I.charCodeAt(R),C===13||C===10){if(A.push(I.substring(E,R)),R++,R<I.length){const P=C;C=I.charCodeAt(R),(P===13&&C===10||P===10&&C===13)&&R++}E=R}else R++;return this.remaining=E<I.length?I.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(ie[116],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const I=A.replace(/\-/g,":").toLowerCase();return!n.has(I)}function T(){const A=(0,D.networkInterfaces)();for(let I in A){const E=A[I];if(E){for(const{mac:C}of E)if(k(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ie[117],re([0,1,35,8,39,30,116]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,P=0;const p=(0,D.networkInterfaces)();for(let y in p){const g=p[y];if(g)for(const{mac:v,internal:f}of g)f||(P+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(R+=1))}this._value=P>0?R/P:0}return this._value}};let I;async function E(){return I||(I=(async()=>await C()||T.generateUuid())()),I}e.getMachineId=E;async function C(){try{const R=await new Promise((p,y)=>{Q(["crypto"],p,y)}),P=(0,A.getMac)();return R.createHash("sha256").update(P,"utf8").digest("hex")}catch(R){n.onUnexpectedError(R);return}}}),define(ie[27],re([0,1,50,35,256,5,41,75,10,4,20,7]),function(Q,e,D,n,k,T,A,I,E,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function y(O,W=p.UNLINK){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return W===p.UNLINK?v(O):g(O)}async function g(O){try{const W=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename(O,W)}catch{return v(O)}v(W).catch(H=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function v(O){return(0,k.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function f(O){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function d(O,W){return m(await(W?S(O):(0,k.promisify)(D.readdir)(O)))}async function S(O){try{return await(0,k.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const W=[],H=await d(O);for(const te of H){let G=!1,$=!1,q=!1;try{const V=await e.Promises.lstat((0,E.join)(O,te));G=V.isFile(),$=V.isDirectory(),q=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}W.push({name:te,isFile:()=>G,isDirectory:()=>$,isSymbolicLink:()=>q})}return W}function w(O){return m(D.readdirSync(O))}e.readdirSync=w;function m(O){return O.map(W=>typeof W=="string"?C.isMacintosh?(0,I.normalizeNFC)(W):W:(W.name=C.isMacintosh?(0,I.normalizeNFC)(W.name):W.name,W))}async function u(O){const W=await d(O),H=[];for(const te of W)await c.existsDirectory((0,E.join)(O,te))&&H.push(te);return H}function t(O,W=1e3){return new Promise(H=>{let te=!1;const G=setInterval(()=>{te||(te=!0,D.access(O,$=>{te=!1,$&&(clearInterval(G),H(void 0))}))},W)})}e.whenDeleted=t;var c;(function(O){async function W(G){let $;try{if($=await e.Promises.lstat(G),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(C.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw V}throw q}}O.stat=W;async function H(G){try{const{stat:$,symbolicLink:q}=await O.stat(G);return $.isFile()&&q?.dangling!==!0}catch{}return!1}O.existsFile=H;async function te(G){try{const{stat:$,symbolicLink:q}=await O.stat(G);return $.isDirectory()&&q?.dangling!==!0}catch{}return!1}O.existsDirectory=te})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function o(O,W,H){return i.queueFor(P.URI.file(O),R.extUriBiasedIgnorePathCase).queue(()=>{const te=l(H);return new Promise((G,$)=>r(O,W,te,q=>q?$(q):G()))})}let a=!0;function r(O,W,H,te){if(!a)return D.writeFile(O,W,{mode:H.mode,flag:H.flag},te);D.open(O,H.flag,H.mode,(G,$)=>{if(G)return te(G);D.writeFile($,W,q=>{if(q)return D.close($,()=>te(q));D.fdatasync($,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a=!1),D.close($,x=>te(x))))})})}function s(O,W,H){const te=l(H);if(!a)return D.writeFileSync(O,W,{mode:te.mode,flag:te.flag});const G=D.openSync(O,te.flag,te.mode);try{D.writeFileSync(G,W);try{D.fdatasyncSync(G)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),a=!1}}finally{D.closeSync(G)}}e.writeFileSync=s;function l(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function h(O,W){if(O!==W)try{await e.Promises.rename(O,W)}catch(H){if(O.toLowerCase()!==W.toLowerCase()&&H.code==="EXDEV"||O.endsWith("."))await b(O,W,{preserveSymlinks:!1}),await y(O,p.MOVE);else throw H}}async function b(O,W,H){return U(O,W,{root:{source:O,target:W},options:H,handledSourcePaths:new Set})}const _=511;async function U(O,W,H){if(H.handledSourcePaths.has(O))return;H.handledSourcePaths.add(O);const{stat:te,symbolicLink:G}=await c.stat(O);if(G){if(H.options.preserveSymlinks)try{return await F(O,W,H)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(G.dangling)return}return te.isDirectory()?N(O,W,te.mode&_,H):L(O,W,te.mode&_)}async function N(O,W,H,te){await e.Promises.mkdir(W,{recursive:!0,mode:H});const G=await d(O);for(const $ of G)await U((0,E.join)(O,$),(0,E.join)(W,$),te)}async function L(O,W,H){await e.Promises.copyFile(O,W),await e.Promises.chmod(W,H)}async function F(O,W,H){let te=await e.Promises.readlink(O);(0,A.isEqualOrParent)(te,H.root.source,!C.isLinux)&&(te=(0,E.join)(H.root.target,te.substr(H.root.source.length+1))),await e.Promises.symlink(te,W)}e.Promises=new class{get access(){return(0,k.promisify)(D.access)}get stat(){return(0,k.promisify)(D.stat)}get lstat(){return(0,k.promisify)(D.lstat)}get utimes(){return(0,k.promisify)(D.utimes)}get read(){return(O,W,H,te,G)=>new Promise(($,q)=>{D.read(O,W,H,te,G,(V,x,K)=>V?q(V):$({bytesRead:x,buffer:K}))})}get readFile(){return(0,k.promisify)(D.readFile)}get write(){return(O,W,H,te,G)=>new Promise(($,q)=>{D.write(O,W,H,te,G,(V,x,K)=>V?q(V):$({bytesWritten:x,buffer:K}))})}get appendFile(){return(0,k.promisify)(D.appendFile)}get fdatasync(){return(0,k.promisify)(D.fdatasync)}get truncate(){return(0,k.promisify)(D.truncate)}get rename(){return(0,k.promisify)(D.rename)}get copyFile(){return(0,k.promisify)(D.copyFile)}get open(){return(0,k.promisify)(D.open)}get close(){return(0,k.promisify)(D.close)}get symlink(){return(0,k.promisify)(D.symlink)}get readlink(){return(0,k.promisify)(D.readlink)}get chmod(){return(0,k.promisify)(D.chmod)}get mkdir(){return(0,k.promisify)(D.mkdir)}get unlink(){return(0,k.promisify)(D.unlink)}get rmdir(){return(0,k.promisify)(D.rmdir)}get realpath(){return(0,k.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return o}get rm(){return y}get move(){return h}get copy(){return b}}}),define(ie[118],re([0,1,50,10,4,26,27]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(p){if(k.isLinux)return p;const y=(0,n.dirname)(p);if(p===y)return p;const g=((0,n.basename)(p)||p).toLowerCase();try{const f=(0,A.readdirSync)(y).filter(d=>d.toLowerCase()===g);if(f.length===1){const d=I(y);if(d)return(0,n.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(g);if(d>=0){const S=I(y);if(S)return(0,n.join)(S,f[d])}}}catch{}return null}e.realcaseSync=I;async function E(p){if(k.isLinux)return p;const y=(0,n.dirname)(p);if(p===y)return p;const g=((0,n.basename)(p)||p).toLowerCase();try{const f=(await A.Promises.readdir(y)).filter(d=>d.toLowerCase()===g);if(f.length===1){const d=await E(y);if(d)return(0,n.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(g);if(d>=0){const S=await E(y);if(S)return(0,n.join)(S,f[d])}}}catch{}return null}e.realcase=E;async function C(p){try{return await A.Promises.realpath(p)}catch{const g=P(p);return await A.Promises.access(g,D.constants.R_OK),g}}e.realpath=C;function R(p){try{return D.realpathSync(p)}catch{const g=P(p);return D.accessSync(g,D.constants.R_OK),g}}e.realpathSync=R;function P(p){return(0,T.rtrim)((0,n.normalize)(p),n.sep)}}),define(ie[119],re([0,1,57]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(I,E,C,R=1){let P=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!P)return P=!0,p(0)},C);k(I,E,R,g=>{if(!P)return P=!0,clearTimeout(y),p(g)})})}e.findFreePort=n;function k(I,E,C,R){if(E===0)return R(0);const P=new D.Socket;P.once("connect",()=>(A(P),k(I+C,E-1,C,R))),P.once("data",()=>{}),P.once("error",p=>(A(P),p.code!=="ECONNREFUSED"?k(I+C,E-1,C,R):R(I))),P.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(I,E,C){let R=!1,P,p=1;const y=D.createServer({pauseOnConnect:!0});function g(v,f){R||(R=!0,y.removeAllListeners(),y.close(),P&&clearTimeout(P),f(v))}return new Promise(v=>{P=setTimeout(()=>{g(0,v)},C),y.on("listening",()=>{g(I,v)}),y.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&p<E?(I++,p++,y.listen(I,"127.0.0.1")):g(0,v)}),y.on("close",()=>{g(0,v)}),y.listen(I,"127.0.0.1")})}e.findFreePortFaster=T;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(E){console.error(E)}}}),define(ie[79],re([0,1,35,10,27]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var E;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(E||(E={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class P{constructor(u,t,c){this.exePath=u,this.displayName=t,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:m=!1}={}){return m?C===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:u=!1}={}){const t=p({useAlternateBitness:m});if(!t)return null;const c=n.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(c))return null;let i=-1,o=null;for(const s of await k.Promises.readdir(c)){let l=-1;if(u){const b=s.indexOf("-");if(b<0)continue;const _=s.substring(0,b);if(!T.test(_)||s.substring(b+1)!=="preview")continue;l=parseInt(_,10)}else{if(!T.test(s))continue;l=parseInt(s,10)}if(l<=i)continue;const h=n.join(c,s,"pwsh.exe");!await k.SymlinkSupport.existsFile(h)||(o=h,i=l)}if(!o)return null;const a=t.includes("x86")?" (x86)":"",r=u?" Preview":"";return new P(o,`PowerShell${r}${a}`,!0)}async function g({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const u=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=m?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(u))if(t.test(i)){const o=n.join(u,i,"pwsh.exe");return new P(o,c)}return null}function v(){const m=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new P(m,".NET Core PowerShell Global Tool")}function f(){const m=n.join(process.env.windir,C===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(m,"Windows PowerShell",!0)}async function*d(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await g(),m&&(yield m),m=v(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await g({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=f(),m&&(yield m)}async function*S(){for await(const m of d())await m.exists()&&(yield m)}e.enumeratePowerShellInstallations=S;async function w(){for await(const m of S())return m;return null}e.getFirstAvailablePowerShellInstallation=w}),define(ie[120],re([0,1,45,19]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((I,E)=>{let C;const R=new Map;function P(y,g,v,f,d){const S=R.get(g);if(y===A||S){const w={name:p(v),cmd:v,pid:y,ppid:g,load:f,mem:d};R.set(y,w),y===A&&(C=w),S&&(S.children||(S.children=[]),S.children.push(w),S.children.length>1&&(S.children=S.children.sort((m,u)=>m.pid-u.pid)))}}function p(y){const g=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,S=/--crashes-directory/,w=/\\pipe\\winpty-control/,m=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(S.exec(y))return"electron-crash-reporter";if(w.exec(y))return"winpty-process";if(m.exec(y))return"console-window-host (Windows internal process)";let t=u.exec(y);if(t&&t.length===2)return t[1]==="renderer"?g.exec(y)?"shared-process":v.exec(y)?"issue-reporter":f.exec(y)?"process-explorer":"window":t[1]==="utility"&&d.exec(y)?"utility-network-service":t[1];const c=/[a-zA-Z-]+\.js/g;let i="";do t=c.exec(y),t&&(i+=t+" ");while(t);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,v)=>{Q(["windows-process-tree"],g,v)}).then(g=>{g.getProcessList(A,v=>{if(!v){E(new Error(`Root process ${A} not found`));return}g.getProcessCpuUsage(v,f=>{const d=new Map;f.forEach(S=>{const w=y(S.commandLine||"");d.set(S.pid,{name:p(w),cmd:w,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),C=d.get(A),C?(d.forEach(S=>{const w=d.get(S.ppid);w&&(w.children||(w.children=[]),w.children.push(S))}),d.forEach(S=>{S.children&&(S.children=S.children.sort((w,m)=>w.pid-m.pid))}),I(C)):E(new Error(`Root process ${A} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let y=function(){let g=[C];const v=[];for(;g.length;){const d=g.shift();d&&(v.push(d.pid),d.children&&(g=g.concat(d.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);f+=" "+v.join(" "),(0,D.exec)(f,{},(d,S,w)=>{if(d||w)E(d||new Error(w.toString()));else{const m=S.toString().split(`
`);for(let u=0;u<v.length;u++){const t=R.get(v[u]);t.load=parseFloat(m[u])}if(!C){E(new Error(`Root process ${A} not found`));return}I(C)}})};(0,D.exec)("which ps",{},(g,v,f)=>{if(g||f)if(process.platform!=="linux")E(g||new Error(f.toString()));else{const d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(d,{},(S,w,m)=>{S||m?E(S||new Error(m.toString())):(T(w,P),y())})}else{const d=v.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${d} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,m,u)=>{w||u&&!u.includes("screen size is bogus")?E(w||new Error(u.toString())):(T(m,P),process.platform==="linux"?y():C?I(C):E(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function T(A,I){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=A.toString().split(`
`);for(const R of C){const P=E.exec(R.trim());P&&P.length===6&&I(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}});var de=this&&this.__decorate||function(Q,e,D,n){var k=arguments.length,T=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,D,n);else for(var I=Q.length-1;I>=0;I--)(A=Q[I])&&(T=(k<3?A(T):k>3?A(e,D,T):A(e,D))||T);return k>3&&T&&Object.defineProperty(e,D,T),T};define(ie[36],re([0,1,17,5,16,25,55,8,3,2,77,26,15]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function g($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function f($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(d||(d={}));class S{constructor(q){this.buffer=q,this.pos=0}read(q){const V=this.buffer.slice(this.pos,this.pos+q);return this.pos+=V.byteLength,V}}class w{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var m;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(m||(m={}));function u($){const q=k.VSBuffer.alloc(4);return q.writeUInt32BE($,0),q}function t($){return $.read(4).readUInt32BE(0)}function c($){const q=k.VSBuffer.alloc(1);return q.writeUInt8($,0),q}const i={Undefined:c(m.Undefined),String:c(m.String),Buffer:c(m.Buffer),VSBuffer:c(m.VSBuffer),Array:c(m.Array),Object:c(m.Object)},o=typeof Buffer!="undefined";function a($,q){if(typeof q=="undefined")$.write(i.Undefined);else if(typeof q=="string"){const V=k.VSBuffer.fromString(q);$.write(i.String),$.write(u(V.byteLength)),$.write(V)}else if(o&&Buffer.isBuffer(q)){const V=k.VSBuffer.wrap(q);$.write(i.Buffer),$.write(u(V.byteLength)),$.write(V)}else if(q instanceof k.VSBuffer)$.write(i.VSBuffer),$.write(u(q.byteLength)),$.write(q);else if(Array.isArray(q)){$.write(i.Array),$.write(u(q.length));for(const V of q)a($,V)}else{const V=k.VSBuffer.fromString(JSON.stringify(q));$.write(i.Object),$.write(u(V.byteLength)),$.write(V)}}function r($){switch($.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return $.read(t($)).toString();case m.Buffer:return $.read(t($)).buffer;case m.VSBuffer:return $.read(t($));case m.Array:{const V=t($),x=[];for(let K=0;K<V;K++)x.push(r($));return x}case m.Object:return JSON.parse($.read(t($)).toString())}}class s{constructor(q,V,x=null,K=1e3){this.protocol=q,this.ctx=V,this.logger=x,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(q,V){this.channels.set(q,V),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const V=this.send([q.type]);this.logger?.logOutgoing(V,0,1,f(q.type));return}case 201:case 202:case 204:case 203:{const V=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(V,q.id,1,f(q.type),q.data);return}}}send(q,V=void 0){const x=new w;return a(x,q),a(x,V),this.sendBuffer(x.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const V=new S(q),x=r(V),K=r(V),Z=x[0];switch(Z){case 100:return this.logger?.logIncoming(q.byteLength,x[1],1,`${g(Z)}: ${x[2]}.${x[3]}`,K),this.onPromise({type:Z,id:x[1],channelName:x[2],name:x[3],arg:K});case 102:return this.logger?.logIncoming(q.byteLength,x[1],1,`${g(Z)}: ${x[2]}.${x[3]}`,K),this.onEventListen({type:Z,id:x[1],channelName:x[2],name:x[3],arg:K});case 101:return this.logger?.logIncoming(q.byteLength,x[1],1,`${g(Z)}`),this.disposeActiveRequest({type:Z,id:x[1]});case 103:return this.logger?.logIncoming(q.byteLength,x[1],1,`${g(Z)}`),this.disposeActiveRequest({type:Z,id:x[1]})}}onPromise(q){const V=this.channels.get(q.channelName);if(!V){this.collectPendingRequest(q);return}const x=new T.CancellationTokenSource;let K;try{K=V.call(this.ctx,q.name,q.arg,x.token)}catch(z){K=Promise.reject(z)}const Z=q.id;K.then(z=>{this.sendResponse({id:Z,data:z,type:201}),this.activeRequests.delete(q.id)},z=>{z instanceof Error?this.sendResponse({id:Z,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:Z,data:z,type:203}),this.activeRequests.delete(q.id)});const X=(0,C.toDisposable)(()=>x.cancel());this.activeRequests.set(q.id,X)}onEventListen(q){const V=this.channels.get(q.channelName);if(!V){this.collectPendingRequest(q);return}const x=q.id,Z=V.listen(this.ctx,q.name,q.arg)(X=>this.sendResponse({id:x,data:X,type:204}));this.activeRequests.set(q.id,Z)}disposeActiveRequest(q){const V=this.activeRequests.get(q.id);V&&(V.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let V=this.pendingRequests.get(q.channelName);V||(V=[],this.pendingRequests.set(q.channelName,V));const x=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:q,timeoutTimer:x})}flushPendingRequests(q){const V=this.pendingRequests.get(q);if(V){for(const x of V)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var l;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(q,V=null){this.protocol=q,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=V}getChannel(q){const V=this;return{call(x,K,Z){return V.isDisposed?Promise.reject(I.canceled()):V.requestPromise(q,x,K,Z)},listen(x,K){return V.isDisposed?E.Event.None:V.requestEvent(q,x,K)}}}requestPromise(q,V,x,K=T.CancellationToken.None){const Z=this.lastRequestId++,z={id:Z,type:100,channelName:q,name:V,arg:x};if(K.isCancellationRequested)return Promise.reject(I.canceled());let M;return new Promise((B,J)=>{if(K.isCancellationRequested)return J(I.canceled());const ne=()=>{const we=ge=>{switch(ge.type){case 201:this.handlers.delete(Z),B(ge.data);break;case 202:{this.handlers.delete(Z);const ye=new Error(ge.data.message);ye.stack=ge.data.stack,ye.name=ge.data.name,J(ye);break}case 203:this.handlers.delete(Z),J(ge.data);break}};this.handlers.set(Z,we),this.sendRequest(z)};let ae=null;this.state===d.Idle?ne():(ae=(0,n.createCancelablePromise)(we=>this.whenInitialized()),ae.then(()=>{ae=null,ne()}));const he=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:Z,type:101}),J(I.canceled())},ve=K.onCancellationRequested(he);M=(0,C.combinedDisposable)((0,C.toDisposable)(he),ve),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(q,V,x){const K=this.lastRequestId++,X={id:K,type:102,channelName:q,name:V,arg:x};let z=null;const M=new E.Emitter({onFirstListenerAdd:()=>{z=(0,n.createCancelablePromise)(B=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(M),this.sendRequest(X)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(M),this.sendRequest({id:K,type:103}))}}),j=B=>M.fire(B.data);return this.handlers.set(K,j),M.event}sendRequest(q){switch(q.type){case 100:case 102:{const V=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(V,q.id,0,`${g(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const V=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(V,q.id,0,g(q.type));return}}}send(q,V=void 0){const x=new w;return a(x,q),a(x,V),this.sendBuffer(x.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const V=new S(q),x=r(V),K=r(V),Z=x[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,f(Z)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,x[1],0,f(Z),K),this.onResponse({type:x[0],id:x[1],data:K})}}onResponse(q){if(q.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(q.id);V&&V(q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([A.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class b{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:V,onDidClientDisconnect:x})=>{E.Event.once(V.onMessage)(Z=>{const X=new S(Z),z=r(X),M=new s(V,z),j=new h(V);this.channels.forEach((J,ne)=>M.registerChannel(ne,J));const B={channelServer:M,channelClient:j,ctx:z};this._connections.add(B),this._onDidAddConnection.fire(B),x(()=>{M.dispose(),j.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const q=[];return this._connections.forEach(V=>q.push(V)),q}getChannel(q,V){const x=this;return{call(K,Z,X){let z;if((0,p.isFunction)(V)){let j=(0,D.getRandomElement)(x.connections.filter(V));z=j?Promise.resolve(j):E.Event.toPromise(E.Event.filter(x.onDidAddConnection,V))}else z=V.routeCall(x,K,Z);const M=z.then(j=>j.channelClient.getChannel(q));return U(M).call(K,Z,X)},listen(K,Z){if((0,p.isFunction)(V))return x.getMulticastEvent(q,V,K,Z);const X=V.routeEvent(x,K,Z).then(z=>z.channelClient.getChannel(q));return U(X).listen(K,Z)}}}getMulticastEvent(q,V,x,K){const Z=this;let X=new C.DisposableStore;const z=new E.Emitter({onFirstListenerAdd:()=>{X=new C.DisposableStore;const M=new E.EventMultiplexer,j=new Map,B=ne=>{const he=ne.channelClient.getChannel(q).listen(x,K),ve=M.add(he);j.set(ne,ve)},J=ne=>{const ae=j.get(ne);!ae||(ae.dispose(),j.delete(ne))};Z.connections.filter(V).forEach(B),E.Event.filter(Z.onDidAddConnection,V)(B,void 0,X),Z.onDidRemoveConnection(J,void 0,X),M.event(z.fire,z,X),X.add(M)},onLastListenerRemove:()=>{X.dispose()}});return z.event}registerChannel(q,V){this.channels.set(q,V),this._connections.forEach(x=>{x.channelServer.registerChannel(q,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class _{constructor(q,V,x=null){const K=new w;a(K,V),q.send(K.buffer),this.channelClient=new h(q,x),this.channelServer=new s(q,V,x)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,V){this.channelServer.registerChannel(q,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function U($){return{call(q,V,x){return $.then(K=>K.call(q,V,x))},listen(q,V){const x=new E.Relay;return $.then(K=>x.input=K.listen(q,V)),x.event}}}e.getDelayedChannel=U;function N($){let q=!1;return{call(V,x,K){return q?$.call(V,x,K):(0,n.timeout)(0).then(()=>q=!0).then(()=>$.call(V,x,K))},listen(V,x){if(q)return $.listen(V,x);const K=new E.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>K.input=$.listen(V,x)),K.event}}}e.getNextTickChannel=N;class L{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const V of q.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await E.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=L;var F;(function($){function q(Z,X){const z=Z,M=X&&X.disableMarshalling,j=new Map;for(const B in z)x(B)&&j.set(B,E.Event.buffer(z[B],!0));return new class{listen(B,J,ne){const ae=j.get(J);if(ae)return ae;if(K(J)){const he=z[J];if(typeof he=="function")return he.call(z,ne)}throw new Error(`Event not found: ${J}`)}call(B,J,ne){const ae=z[J];if(typeof ae=="function"){if(!M&&Array.isArray(ne))for(let he=0;he<ne.length;he++)ne[he]=(0,R.revive)(ne[he]);return ae.apply(z,ne)}throw new Error(`Method not found: ${J}`)}}}$.fromService=q;function V(Z,X){const z=X&&X.disableMarshalling;return new Proxy({},{get(M,j){if(typeof j=="string")return X?.properties?.has(j)?X.properties.get(j):K(j)?function(B){return Z.listen(j,B)}:x(j)?Z.listen(j):async function(...B){let J;X&&!(0,p.isUndefinedOrNull)(X.context)?J=[X.context,...B]:J=B;const ne=await Z.call(j,J);return z?ne:(0,R.revive)(ne)};throw new Error(`Property not found: ${String(j)}`)}})}$.toService=V;function x(Z){return Z[0]==="o"&&Z[1]==="n"&&P.isUpperAsciiLetter(Z.charCodeAt(2))}function K(Z){return/^onDynamic/.test(Z)&&P.isUpperAsciiLetter(Z.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let q=$.toString();if(q!=="[object Object]")return q}return $}function H($){return Array.isArray($)?$.map(W):W($)}function te($,q,V,x,K,Z,X){X=H(X);const z=O[K],M=z[x%z.length];let j=[`%c[${$}]%c[${String(q).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Z)?(j=j.concat(X),j.push(")")):j.push(X),console.log.apply(console,j)}e.logWithColors=te;class G{constructor(q,V){this._outgoingPrefix=q,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,V,x,K,Z){this._totalOutgoing+=q,te(this._outgoingPrefix,this._totalOutgoing,q,V,x,K,Z)}logIncoming(q,V,x,K,Z){this._totalIncoming+=q,te(this._incomingPrefix,this._totalIncoming,q,V,x,K,Z)}}e.IPCLogger=G}),define(ie[121],re([0,1,16,3,36]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(E){this.port=E,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",C=>D.VSBuffer.wrap(C.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends k.IPCClient{constructor(E,C){const R=new T(E);super(R,C);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ie[80],re([0,1,16,3,2,36]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(o){o.enableDiagnostics=!1,o.records=[];const a=new WeakMap;let r=0;function s(h,b){if(!a.has(h)){const _=String(++r);a.set(h,_)}return a.get(h)}function l(h,b,_,U){if(!o.enableDiagnostics)return;const N=s(h,b);if(U instanceof D.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const L=D.VSBuffer.alloc(U.byteLength);L.set(U),o.records.push({timestamp:Date.now(),id:N,label:b,type:_,buff:L})}else o.records.push({timestamp:Date.now(),id:N,label:b,type:_,data:U})}o.traceSocketEvent=l})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=D.VSBuffer.alloc(0)),C}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,r){if(a===0)return R();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const b=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=a),b}if(this._chunks[0].byteLength>a){const b=this._chunks[0].slice(0,a);return r&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),b}let s=D.VSBuffer.alloc(a),l=0,h=0;for(;a>0;){const b=this._chunks[h];if(b.byteLength>a){const _=b.slice(0,a);s.set(_,l),l+=a,r&&(this._chunks[h]=b.slice(a),this._totalLength-=a),a-=a}else s.set(b,l),l+=b.byteLength,r?(this._chunks.shift(),this._totalLength-=b.byteLength):h++,a-=b.byteLength}return s}}e.ChunkStream=P;var p;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume"})(p||(p={}));function y(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(a,r,s,l){this.type=a,this.id=r,this.ack=s,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends k.Disposable{constructor(a){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const s=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new v(s,l,h,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.VSBuffer.alloc(13);r.writeUInt8(a.type,0),r.writeUInt32BE(a.id,1),r.writeUInt32BE(a.ack,5),r.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(r,a.data)}_bufferAdd(a,r){const s=this._totalLength===0;return this._data.push(a,r),this._totalLength+=a.byteLength+r.byteLength,s}_bufferTake(){const a=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,r){this._bufferAdd(a,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class S extends k.Disposable{constructor(a){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new v(1,0,0,a))}}e.Protocol=S;class w extends T.IPCClient{constructor(a,r,s=null){super(a,r,s);this.protocol=a}static fromSocket(a,r){return new w(new S(a),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=w;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class u{constructor(a){this.data=a,this.next=null}}class t{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],r=0,s=this._first;for(;s;)a[r++]=s.data,s=s.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const r=new u(a);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class c{constructor(){this.lastRuns=[];const a=Date.now();for(let r=0;r<c._HISTORY_LENGTH;r++)this.lastRuns[r]=a-1e3*r;setInterval(()=>{for(let r=c._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const a=Date.now(),r=(1+c._HISTORY_LENGTH)*1e3;let s=0;for(let l=0;l<c._HISTORY_LENGTH;l++)a-this.lastRuns[l]<=r&&s++;return 1-s/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class i{constructor(a,r=null,s=c.getInstance()){this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),r&&this._socketReader.acceptChunk(r)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new v(5,0,0,R());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new v(7,0,0,R());this._socketWriter.write(a)}sendResume(){const a=new v(8,0,0,R());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,r){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new v(3,0,this._incomingAckId,R());this._socketWriter.write(a);const r=this._outgoingUnackMsg.toArray();for(let s=0,l=r.length;s<l;s++)this._socketWriter.write(r[s]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new v(6,0,0,R())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let s=0,l=r.length;s<l;s++)this._socketWriter.write(r[s]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new v(1,r,this._incomingAckId,a);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(a){const r=new v(2,0,0,a);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),r=Date.now()-a.writtenTime,s=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&s>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-r,2e4-s,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new v(3,0,this._incomingAckId,R());this._socketWriter.write(a)}}e.PersistentProtocol=i}),define(ie[122],re([0,1,81,3,36,121]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const E=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(C,R)=>R);return n.Event.map(E,C=>{const{port1:R,port2:P}=new MessageChannel,y={protocol:new T.Protocol(R),onDidClientDisconnect:n.Event.fromDOMEventEmitter(R,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[P]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ie[123],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function n(T){return T instanceof k?!0:T instanceof Error&&T.name===D&&T.message===D}e.isOfflineError=n;class k extends Error{constructor(){super(D);this.name=this.message}}e.OfflineError=k}),define(ie[124],re([0,1,16,8,123]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(E,C){if(!navigator.onLine)throw new k.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const R=new XMLHttpRequest;return new Promise((P,p)=>{R.open(E.type||"GET",E.url||"",!0,E.user,E.password),A(R,E),R.responseType="arraybuffer",R.onerror=y=>p(new Error(R.statusText&&"XHR failed: "+R.statusText||"XHR failed")),R.onload=y=>{P({res:{statusCode:R.status,headers:I(R)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(R.response)))})},R.ontimeout=y=>p(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(R.timeout=E.timeout),R.send(E.data),C.onCancellationRequested(()=>{R.abort(),p((0,n.canceled)())})})}e.request=T;function A(E,C){if(C.headers){e:for(let R in C.headers){switch(R){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(R,C.headers[R])}}}function I(E){const C=Object.create(null);for(const R of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(R){const P=R.indexOf(":");C[R.substr(0,P).trim().toLowerCase()]=R.substr(P+1).trim()}return C}}),define(ie[82],re([0,1,5,3,2,15]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function I(P){const p=P;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var E;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class C extends k.Disposable{constructor(p,y=Object.create(null)){super();this.database=p,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((y,g)=>this.accept(g,y)),p.deleted?.forEach(y=>this.accept(y,void 0))}accept(p,y){if(this.state===E.Closed)return;let g=!1;(0,T.isUndefinedOrNull)(y)?g=this.cache.delete(p):this.cache.get(p)!==y&&(this.cache.set(p,y),g=!0),g&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,y){const g=this.cache.get(p);return(0,T.isUndefinedOrNull)(g)?y:g}getBoolean(p,y){const g=this.get(p);return(0,T.isUndefinedOrNull)(g)?y:g==="true"}getNumber(p,y){const g=this.get(p);return(0,T.isUndefinedOrNull)(g)?y:parseInt(g,10)}async set(p,y){if(this.state===E.Closed)return;if((0,T.isUndefinedOrNull)(y))return this.delete(p);const g=String(y);if(this.cache.get(p)!==g)return this.cache.set(p,g),this.pendingInserts.set(p,g),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===E.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class R{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((y,g)=>this.items.set(g,y)),p.delete&&p.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=R}),define(ie[125],re([11,12]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ie[58],re([0,1,125]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,T=k*24,A=T*7,I=T*30,E=T*365;function C(P,p,y){typeof P!="number"&&(P=P.getTime());const g=Math.round((new Date().getTime()-P)/1e3);if(g<-30)return(0,D.localize)(0,null,C(new Date().getTime()+g*1e3,!1));if(g<30)return(0,D.localize)(1,null);let v;return g<n?(v=g,p?v===1?y?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):y?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?y?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):y?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):g<k?(v=Math.floor(g/n),p?v===1?y?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):y?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?y?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):y?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):g<T?(v=Math.floor(g/k),p?v===1?y?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):y?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?y?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):y?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):g<A?(v=Math.floor(g/T),p?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):g<I?(v=Math.floor(g/A),p?v===1?y?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):y?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?y?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):y?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):g<E?(v=Math.floor(g/I),p?v===1?y?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):y?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?y?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):y?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(g/E),p?v===1?y?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):y?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?y?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):y?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=C;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ie[126],re([11,12]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ie[37],re([0,1,17,15,126]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(P,p){return p&&(P.stack||P.stacktrace)?k.localize(0,null,I(P),A(P.stack)||A(P.stacktrace)):I(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function E(P=null,p=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const y=D.coalesce(P),g=E(y[0],p);return y.length>1?k.localize(4,null,g,y.length):g}if(n.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return T(y.error,p);if(y.exception)return T(y.exception,p)}return P.stack?T(P,p):P.message?P.message:k.localize(5,null)}e.toErrorMessage=E;function C(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=C;function R(P,p){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=p,y}e.createErrorWithActions=R}),define(ie[127],re([11,12]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ie[128],re([0,1,127]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(ie[129],re([11,12]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ie[83],re([0,1,45,41,19,28,10,4,34,72,15,115,27,129]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function g(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(u,t){if(I.isWindows)try{const c={stdio:["pipe","pipe","ignore"]};t&&(c.cwd=t);const i=D.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],c);return new Promise(o=>{i.once("error",a=>{o({success:!1,error:a})}),i.once("exit",(a,r)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(c){return Promise.resolve({success:!1,error:c,code:c.status?g(c.status):1})}else if(I.isLinux||I.isMacintosh)try{const c=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(i=>{D.execFile(c,[u.pid.toString()],{encoding:"utf8",shell:!0},(o,a,r)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(c){return Promise.resolve({success:!1,error:c})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function f(u=E.env){return u.comspec||"cmd.exe"}e.getWindowsShell=f;class d{constructor(t,c,i,o){if(c!==void 0&&i!==void 0&&o!==void 0)this.cmd=t,this.args=c,this.shell=i,this.options=o;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(E.env).forEach(r=>{a[r]=E.env[r]}),Object.keys(this.options.env).forEach(r=>{a[r]=this.options.env[r]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const c=t.lastIndexOf(A.sep);return c!==-1&&(t=t.substring(c+1)),d.WellKnowCommands[t]?t:"other"}start(t){return I.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(E.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(c=>{let i,o;const a=new Promise((r,s)=>{i=r,o=s});if(c){let r=this.cmd;this.args&&(r=r+" "+this.args.join(" ")),this.childProcess=D.exec(r,this.options,(s,l,h)=>{this.childProcess=null;const b=s;b&&b.killed?o({killed:this.terminateRequested,stdout:l.toString(),stderr:h.toString()}):this.handleExec(i,t,s,l,h)})}else{let r=null;const s=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,i,t,o);const h={terminated:this.terminateRequested};R.isNumber(l)&&(h.cmdCode=l),i(h)};if(this.shell&&I.isWindows){const l=T.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let h=!1,b=!1;const _=[];let U=this.ensureQuotes(this.cmd);_.push(U.value),h=U.quoted,this.args&&this.args.forEach(L=>{U=this.ensureQuotes(L),_.push(U.value),b=b&&U.quoted});const N=["/s","/c"];h?b?N.push('"'+_.join(" ")+'"'):_.length>1?N.push('"'+_[0]+'" '+_.slice(1).join(" ")):N.push('"'+_[0]+'"'):N.push(_.join(" ")),r=D.spawn(f(),N,l)}else this.cmd&&(r=D.spawn(this.cmd,this.args,this.options));r&&(this.childProcess=r,this.childProcessPromise=Promise.resolve(r),this.pidResolve&&(this.pidResolve(R.isNumber(r.pid)?r.pid:-1),this.pidResolve=void 0),r.on("error",l=>{this.childProcess=null,o({terminated:this.terminateRequested,error:l})}),r.pid&&(this.childProcess.on("close",s),this.handleSpawn(r,i,t,o,!0)))}return a})}handleClose(t,c,i,o){}ensureQuotes(t){return d.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,v(t,this.options.cwd).then(c=>(c.success&&(this.childProcess=null),c))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!I.isWindows)return t(!1);const c=D.spawn(f(),["/s","/c"]);c.on("error",i=>t(!0)),c.on("exit",i=>t(!1))})}}e.AbstractProcess=d,d.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},d.regexp=/^[^"].* .*[^"]/;class S extends d{constructor(t,c,i,o){super(t,c,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,c,i,o,a){[o,a].forEach((r,s)=>{const l=new P.LineDecoder;l.write(r).forEach(_=>{c({line:_,source:s===0?0:1})});const b=l.end();b&&c({line:b,source:s===0?0:1})}),t({terminated:this.terminateRequested,error:i})}handleSpawn(t,c,i,o,a){const r=new P.LineDecoder,s=new P.LineDecoder;t.stdout.on("data",l=>{r.write(l).forEach(b=>i({line:b,source:0}))}),t.stderr.on("data",l=>{s.write(l).forEach(b=>i({line:b,source:1}))}),this.stdoutLineDecoder=r,this.stderrLineDecoder=s}handleClose(t,c,i,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const r=this.stderrLineDecoder?this.stderrLineDecoder.end():null;r&&i({line:r,source:1})}}e.LineProcess=S;function w(u){let t=[],c=!1;const i=function(o){if(c){t.push(o);return}(!u.send(o,r=>{if(r&&console.error(r),c=!1,t.length>0){const s=t.slice(0);t=[],s.forEach(l=>i(l))}})||I.isWindows)&&(c=!0)};return{send:i}}e.createQueuedSender=w;var m;(function(u){async function t(c,i,o){if(A.isAbsolute(c))return c;if(i===void 0&&(i=E.cwd()),A.dirname(c)!=="."||(o===void 0&&R.isString(E.env.PATH)&&(o=E.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(i,c);async function r(s){if(await p.Promises.exists(s)){let l;try{l=await p.Promises.stat(s)}catch(h){h.message.startsWith("EACCES")&&(l=await p.Promises.lstat(s))}return l?!l.isDirectory():!1}return!1}for(let s of o){let l;if(A.isAbsolute(s)?l=A.join(s,c):l=A.join(i,s,c),await r(l))return l;let h=l+".com";if(await r(h)||(h=l+".exe",await r(h)))return h}return A.join(i,c)}u.findExecutable=t})(m=e.win32||(e.win32={}))}),define(ie[130],re([0,1,35,4,79,83]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,g){return y===1?n.isWindows?P():T.getWindowsShell(g):C(y,g)}e.getSystemShell=A;function I(y,g){return y===1?n.isWindows?p(g):T.getWindowsShell(g):C(y,g)}e.getSystemShellSync=I;let E=null;function C(y,g){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!E){let v;if(n.isWindows)v="/bin/bash";else{if(v=g.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}E=v}return E}let R=null;async function P(){return R||(R=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),R}function p(y){if(R)return R;const g=n.isWindows&&parseFloat((0,D.release)())>=10,v=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${y.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?f:T.getWindowsShell(y)}}),define(ie[59],re([0,1,45,5,16,25,113,8,3,2,28,83,72,36]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends y.ChannelServer{constructor(d){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=g;class v{constructor(d,S){this.modulePath=d,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const S=this;return{call(w,m,u){return S.requestPromise(d,w,m,u)},listen(w,m){return S.requestEvent(d,w,m)}}}requestPromise(d,S,w,m=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(d),t=(0,n.createCancelablePromise)(o=>u.call(S,w,o)),c=m.onCancellationRequested(()=>t.cancel()),i=(0,C.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{c.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(d,S,w){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let m;const u=new E.Emitter({onFirstListenerAdd:()=>{m=this.getCachedChannel(d).listen(S,w)(u.fire,u),this.activeRequests.add(m)},onLastListenerRemove:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,p.removeDangerousEnvVariables)(S.env),this.child=(0,D.fork)(this.modulePath,d,S);const w=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,A.isRemoteConsoleLog)(a)){(0,A.log)(a,`IPC Library: ${this.options.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(a,"base64")))});const u=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&u.send(a.buffer.toString("base64")),c=w.event,i={send:t,onMessage:c};this._client=new y.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,r)=>{process.removeListener("exit",o),this.activeRequests.forEach(s=>(0,C.dispose)(s)),this.activeRequests.clear(),a!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:r})})}return this._client}getCachedChannel(d){let S=this.channels.get(d);return S||(S=this.client.getChannel(d),this.channels.set(d,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(ie[131],re([11,12]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ie[132],re([11,12]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[133],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ie[134],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ie[135],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[136],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[137],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[138],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ie[139],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[140],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[141],re([11,12]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[142],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ie[143],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ie[144],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ie[145],re([11,12]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[146],re([11,12]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ie[147],re([11,12]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ie[148],re([11,12]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[149],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[150],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[151],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ie[152],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ie[153],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ie[154],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ie[155],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ie[156],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ie[84],re([0,1,58,55,19,10,34,20,7]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(v,f,d){this._args=v,this.paths=f,this.productService=d}get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(E.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=A.env.VSCODE_PORTABLE;return v?E.URI.file((0,T.join)(v,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,T.resolve)(v):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=this.args["extensions-download-dir"];return v?(0,T.resolve)(v):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,T.resolve)(v);const f=A.env.VSCODE_EXTENSIONS;if(f)return f;const d=A.env.VSCODE_PORTABLE;return d?(0,T.join)(d,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(f=>/^[^:/?#]+?:\/\//.test(f)?E.URI.parse(f):E.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?E.URI.parse(v):E.URI.file((0,T.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],C.prototype,"appRoot",null),de([n.memoize],C.prototype,"userHome",null),de([n.memoize],C.prototype,"userDataPath",null),de([n.memoize],C.prototype,"appSettingsHome",null),de([n.memoize],C.prototype,"tmpDir",null),de([n.memoize],C.prototype,"cacheHome",null),de([n.memoize],C.prototype,"userRoamingDataHome",null),de([n.memoize],C.prototype,"settingsResource",null),de([n.memoize],C.prototype,"userDataSyncHome",null),de([n.memoize],C.prototype,"userDataSyncLogResource",null),de([n.memoize],C.prototype,"sync",null),de([n.memoize],C.prototype,"machineSettingsResource",null),de([n.memoize],C.prototype,"globalStorageHome",null),de([n.memoize],C.prototype,"workspaceStorageHome",null),de([n.memoize],C.prototype,"localHistoryHome",null),de([n.memoize],C.prototype,"keybindingsResource",null),de([n.memoize],C.prototype,"keyboardLayoutResource",null),de([n.memoize],C.prototype,"argvResource",null),de([n.memoize],C.prototype,"snippetsHome",null),de([n.memoize],C.prototype,"isExtensionDevelopment",null),de([n.memoize],C.prototype,"untitledWorkspacesHome",null),de([n.memoize],C.prototype,"installSourcePath",null),de([n.memoize],C.prototype,"builtinExtensionsPath",null),de([n.memoize],C.prototype,"extensionsPath",null),de([n.memoize],C.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],C.prototype,"extensionDevelopmentKind",null),de([n.memoize],C.prototype,"extensionTestsLocationURI",null),de([n.memoize],C.prototype,"debugExtensionHost",null),de([n.memoize],C.prototype,"serviceMachineIdResource",null),de([n.memoize],C.prototype,"telemetryLogResource",null),de([n.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function R(g,v){return y(g["inspect-extensions"],g["inspect-brk-extensions"],5870,v,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=R;function P(g,v){return y(g["inspect-search"],g["inspect-brk-search"],5876,v,g.extensionEnvironment)}e.parseSearchPort=P;function p(g,v){return y(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,v,g.extensionEnvironment)}e.parsePtyHostPort=p;function y(g,v,f,d,S,w){const u=Number(v||g)||(d?null:f),t=u?Boolean(!!v):!1;let c;if(w)try{c=JSON.parse(w)}catch{}return{port:u,break:t,debugId:S,env:c}}}),define(ie[157],re([0,1,257,4,133]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(g,v,f=A){const d={},S=["_"],w=[];for(let c in v){const i=v[c];i.alias&&(d[c]=i.alias),i.type==="string"||i.type==="string[]"?(S.push(c),i.deprecates&&S.push(...i.deprecates)):i.type==="boolean"&&(w.push(c),i.deprecates&&w.push(...i.deprecates))}const m=D(g,{string:S,boolean:w,alias:d}),u={},t=m;u._=m._.map(c=>String(c)).filter(c=>c.length>0),delete t._;for(let c in v){const i=v[c];i.alias&&delete t[i.alias];let o=t[c];if(i.deprecates)for(const a of i.deprecates)t.hasOwnProperty(a)&&(o||(o=t[a],o&&f.onDeprecatedOption(a,i.deprecationMessage||(0,k.localize)(33,null,c))),delete t[a]);typeof o!="undefined"&&(i.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):i.type==="string"&&Array.isArray(o)&&(o=o.pop(),f.onMultipleValues(c,o)),u[c]=o,i.deprecationMessage&&f.onDeprecatedOption(c,i.deprecationMessage)),delete t[c]}for(let c in t)f.onUnknownOption(c);return u}e.parseArgs=I;function E(g,v){let f="";return v.args&&(Array.isArray(v.args)?f=` <${v.args.join("> <")}>`:f=` <${v.args}>`),v.alias?`-${v.alias} --${g}${f}`:`--${g}${f}`}function C(g,v){let f=0,d=[];for(const u in g){const t=g[u],c=E(u,t);f=Math.max(f,c.length),d.push([c,t.description])}let S=f+2+1;if(v-S<25)return d.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let w=v-S-1,m=[];for(const u of d){let t=u[0],c=P(u[1],w),i=R(S-t.length-2);m.push("  "+t+i+c[0]);for(let o=1;o<c.length;o++)m.push(R(S)+c[o])}return m}e.formatOptions=C;function R(g){return" ".repeat(g)}function P(g,v){let f=[];for(;g.length;){let d=g.length<v?g.length:g.lastIndexOf(" ",v),S=g.slice(0,d).trim();g=g.slice(d),f.push(S)}return f}function p(g,v,f,d,S){const w=process.stdout.isTTY&&process.stdout.columns||80,m=S?.noInputFiles!==!0?`[${(0,k.localize)(34,null)}...]`:"",u=[`${g} ${f}`];u.push(""),u.push(`${(0,k.localize)(35,null)}: ${v} [${(0,k.localize)(36,null)}]${m}`),u.push(""),S?.noPipe!==!0&&(n.isWindows?u.push((0,k.localize)(37,null,v)):u.push((0,k.localize)(38,null,v)),u.push(""));const t={};for(const c in d){const i=d[c];if(i.description&&i.cat){let o=t[i.cat];o||(t[i.cat]=o={}),o[c]=i}}for(let c in t){const i=c;let o=t[i];o&&(u.push(T[i]),u.push(...C(o,w)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=p;function y(g,v){return`${g||(0,k.localize)(39,null)}
${v||(0,k.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ie[158],re([0,1,258,134,157]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(p,y){const g={onUnknownOption:f=>{console.warn((0,n.localize)(0,null,f))},onMultipleValues:(f,d)=>{console.warn((0,n.localize)(1,null,f,d))},onDeprecatedOption:(f,d)=>{console.warn((0,n.localize)(2,null,f,d))}},v=(0,k.parseArgs)(p,k.OPTIONS,y?g:void 0);return v.goto&&v._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,n.localize)(3,null))),v["max-memory"]&&D(parseInt(v["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),v}function I(p){const y=p.findIndex(g=>!/^-/.test(g));if(y>-1)return[...p.slice(0,y),...p.slice(y+1)]}function E(p){let[,...y]=p;process.env.VSCODE_DEV&&(y=I(y)||[]);const g=!P(process.env);return A(y,g)}e.parseMainProcessArgv=E;function C(p){const[,,...y]=p;return A(y,!0)}e.parseCLIProcessArgv=C;function R(p,...y){const g=p.indexOf("--");return g===-1?p.push(...y):p.splice(g,0,...y),p}e.addArg=R;function P(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function Q(e,D,n,k){function T(I){const E=A(I),C=[E];return e.isAbsolute(E)||C.unshift(k),e.resolve(...C)}function A(I){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,n);const R=I["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(P,"AppData","Roaming")}break;case"darwin":C=e.join(D.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,n)}return{getUserDataPath:T}}if(typeof define=="function")define(ie[85],re([0,259,35,19,20,34]),function(e,D,n,k,T,A){const I=T.dirname(k.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(T.joinPath(I,"package.json").fsPath);return Q(D,n,E.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=Q(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[159],re([0,1,35,84,85]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(I,E){super(I,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(I)},E)}}e.NativeEnvironmentService=T}),define(ie[160],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(f){const d=f.match(A);return d?d[1]:null}function R(f){if(f.indexOf("://")===-1){const d=f.match(n);return d?C(d[2]):null}try{const d=D.URI.parse(f);if(d.authority)return C(d.authority)}catch{}return null}function P(f,d){const S=new Set;let w;for(;w=I.exec(f);){const u=R(w[1]);u&&S.add(u)}const m=new Set(d);return Array.from(S).map(u=>m.has(u)?u:u.replace(E,"a"))}e.getDomainsOfRemotes=P;function p(f){const d=f.match(T);return d?d[2]:null}function y(f,d,S){return f&&d?(S&&d.endsWith(".git")&&(d=d.substr(0,d.length-4)),d.indexOf("/")===0?`${f}${d}`:`${f}/${d}`):null}function g(f,d){if(f.indexOf("://")===-1){const S=f.match(k);if(S)return y(S[2],S[3],d)}try{const S=D.URI.parse(f);if(S.authority)return y(p(S.authority),S.path,d)}catch{}return null}function v(f,d=!1){const S=[];let w;for(;w=I.exec(f);){const m=g(w[1],d);m&&S.push(m)}return S}e.getRemotes=v}),define(ie[161],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,I,E){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,I,E])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ie[60],re([0,1,20,76,141,51]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=E;function C(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=d.match(A);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=C;function R(d){if(!d)return null;let S=d.majorBase,w=d.majorMustEqual,m=d.minorBase,u=d.minorMustEqual,t=d.patchBase,c=d.patchMustEqual;d.hasCaret&&(S===0||(u=!1),c=!1);let i=0;if(d.preRelease){const o=I.exec(d.preRelease);if(o){const[,a,r,s]=o;i=Date.UTC(Number(a),Number(r)-1,Number(s))}}return{majorBase:S,majorMustEqual:w,minorBase:m,minorMustEqual:u,patchBase:t,patchMustEqual:c,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function P(d,S,w){let m;typeof d=="string"?m=R(C(d)):m=d;let u;S instanceof Date?u=S.getTime():typeof S=="string"&&(u=new Date(S).getTime());let t;if(typeof w=="string"?t=R(C(w)):t=w,!m||!t)return!1;let c=m.majorBase,i=m.minorBase,o=m.patchBase,a=t.majorBase,r=t.minorBase,s=t.patchBase,l=t.notBefore,h=t.majorMustEqual,b=t.minorMustEqual,_=t.patchMustEqual;return t.isMinimum?c>a?!0:c<a?!1:i>r?!0:i<r||u&&u<l?!1:o>=s:(c===1&&a===0&&(!h||!b||!_)&&(a=1,r=0,s=0,h=!0,b=!1,_=!1),c<a?!1:c>a?!h:i<r?!1:i>r?!b:o<s?!1:o>s?!_:!(u&&u<l))}e.isValidVersion=P;function p(d,S,w,m,u){const t=[];if(typeof m.publisher!="undefined"&&typeof m.publisher!="string")return t.push([n.default.Error,k.localize(0,null)]),t;if(typeof m.name!="string")return t.push([n.default.Error,k.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([n.default.Error,k.localize(2,null,"version")]),t;if(!m.engines)return t.push([n.default.Error,k.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([n.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies!="undefined"&&!f(m.extensionDependencies))return t.push([n.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents!="undefined"){if(!f(m.activationEvents))return t.push([n.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof m.main=="undefined"&&typeof m.browser=="undefined")return t.push([n.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof m.extensionKind!="undefined"&&typeof m.main=="undefined"&&t.push([n.default.Warning,k.localize(8,null,"extensionKind")]),typeof m.main!="undefined"){if(typeof m.main!="string")return t.push([n.default.Error,k.localize(9,null,"main")]),t;{const o=(0,D.joinPath)(w,m.main);(0,D.isEqualOrParent)(o,w)||t.push([n.default.Warning,k.localize(10,null,o.path,w.path)])}if(typeof m.activationEvents=="undefined")return t.push([n.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof m.browser!="undefined"){if(typeof m.browser!="string")return t.push([n.default.Error,k.localize(12,null,"browser")]),t;{const o=(0,D.joinPath)(w,m.browser);(0,D.isEqualOrParent)(o,w)||t.push([n.default.Warning,k.localize(13,null,o.path,w.path)])}if(typeof m.activationEvents=="undefined")return t.push([n.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!T.valid(m.version))return t.push([n.default.Error,k.localize(15,null)]),t;const c=[];if(!y(d,S,m,u,c))for(const o of c)t.push([n.default.Error,o]);return t}e.validateExtensionManifest=p;function y(d,S,w,m,u){return m||typeof w.main=="undefined"&&typeof w.browser=="undefined"?!0:v(d,S,w.engines.vscode,u)}e.isValidExtensionVersion=y;function g(d,S,w){return d==="*"||v(S,w,d)}e.isEngineValid=g;function v(d,S,w,m=[]){let u=R(C(w));if(!u)return m.push(k.localize(16,null,w)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return m.push(k.localize(17,null,w)),!1}else if(!u.majorMustEqual)return m.push(k.localize(18,null,w)),!1;return P(d,S,u)?!0:(m.push(k.localize(19,null,d,w)),!1)}function f(d){if(!Array.isArray(d))return!1;for(let S=0,w=d.length;S<w;S++)if(typeof d[S]!="string")return!1;return!0}}),define(ie[46],re([0,1,16,30]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,A,I){let E=I&&I.get("storage.serviceMachineId",0)||null;if(E)return E;try{const R=(await A.readFile(T.serviceMachineIdResource)).value.toString();E=(0,n.isUUID)(R)?R:null}catch{E=null}if(!E){E=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(E))}catch{}}return I&&I.store("storage.serviceMachineId",E,0,1),E}e.getServiceMachineId=k}),define(ie[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(k,T=[],A=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(ie[86],re([0,1,52]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function k(A,I,E){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],E)),n.push([A,I])}e.registerSingleton=k;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ie[162],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const I=this.lookupOrInsertNode(T),E=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(T),I)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let I=this._nodes.get(A);return I||(I=new D(T),this._nodes.set(A,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,I]of this._nodes)T.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const I=new Set([T]),E=this._findCycle(A,I);if(E)return E}}_findCycle(T,A){for(let[I,E]of T.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const C=this._findCycle(E,A);if(C)return C;A.delete(I)}}}e.Graph=n}),define(ie[6],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(D=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(A,I,E){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:A,index:E}):(I[D.DI_DEPENDENCIES]=[{id:A,index:E}],I[D.DI_TARGET]=I)}function k(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const I=function(E,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(I,E,R)};return I.toString=()=>A,D.serviceIds.set(A,I),I}e.createDecorator=k;function T(A){return A}e.refineServiceDecorator=T}),define(ie[163],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ie[18],re([0,1,15,7,6]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function C(d,S){const w=Object.create(null);for(let m in d)R(w,m,d[m],S);return w}e.toValuesTree=C;function R(d,S,w,m){const u=S.split("."),t=u.pop();let c=d;for(let i=0;i<u.length;i++){let o=u[i],a=c[o];switch(typeof a){case"undefined":a=c[o]=Object.create(null);break;case"object":break;default:m(`Ignoring ${S} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(a)}`);return}c=a}if(typeof c=="object"&&c!==null)try{c[t]=w}catch{m(`Ignoring ${S} as ${u.join(".")} is ${JSON.stringify(c)}`)}else m(`Ignoring ${S} as ${u.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=R;function P(d,S){const w=S.split(".");p(d,w)}e.removeFromValueTree=P;function p(d,S){const w=S.shift();if(S.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const m=d[w];typeof m=="object"&&!Array.isArray(m)&&(p(m,S),Object.keys(m).length===0&&delete d[w])}}function y(d,S,w){function m(c,i){let o=c;for(const a of i){if(typeof o!="object"||o===null)return;o=o[a]}return o}const u=S.split("."),t=m(d,u);return typeof t=="undefined"?w:t}e.getConfigurationValue=y;function g(d,S,w){Object.keys(S).forEach(m=>{m!=="__proto__"&&(m in d?D.isObject(d[m])&&D.isObject(S[m])?g(d[m],S[m],w):w&&(d[m]=S[m]):d[m]=S[m])})}e.merge=g;function v(d,S,w){const m=d.inspect(S),u=d.inspect(w);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:m.defaultValue}e.getMigratedSettingValue=v;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ie[164],re([0,1,4,26,6]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return P.INSTANCE}static true(){return p.INSTANCE}static has(L){return y.create(L)}static equals(L,F){return g.create(L,F)}static notEquals(L,F){return d.create(L,F)}static regex(L,F){return i.create(L,F)}static in(L,F){return v.create(L,F)}static not(L){return S.create(L)}static and(...L){return r.create(L,null)}static or(...L){return s.create(L,null,!0)}static greater(L,F){return m.create(L,F)}static greaterEquals(L,F){return u.create(L,F)}static smaller(L,F){return t.create(L,F)}static smallerEquals(L,F){return c.create(L,F)}static deserialize(L,F=!1){if(!!L)return this._deserializeOrExpression(L,F)}static _deserializeOrExpression(L,F){let O=L.split("||");return s.create(O.map(W=>this._deserializeAndExpression(W,F)),null,!0)}static _deserializeAndExpression(L,F){let O=L.split("&&");return r.create(O.map(W=>this._deserializeOne(W,F)),null)}static _deserializeOne(L,F){if(L=L.trim(),L.indexOf("!=")>=0){let O=L.split("!=");return d.create(O[0].trim(),this._deserializeValue(O[1],F))}if(L.indexOf("==")>=0){let O=L.split("==");return g.create(O[0].trim(),this._deserializeValue(O[1],F))}if(L.indexOf("=~")>=0){let O=L.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(L.indexOf(" in ")>=0){let O=L.split(" in ");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const O=L.split(">=");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const O=L.split(">");return m.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const O=L.split("<=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const O=L.split("<");return t.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(L)?S.create(L.substr(1).trim()):y.create(L)}static _deserializeValue(L,F){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let O=/^'([^']*)'$/.exec(L);return O?O[1].trim():L}static _deserializeRegexValue(L,F){if((0,n.isFalsyOrWhitespace)(L)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=L.indexOf("/"),W=L.lastIndexOf("/");if(O===W||O<0){if(F)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let H=L.slice(O+1,W),te=L[W+1]==="i"?"i":"";try{return new RegExp(H,te)}catch(G){if(F)throw new Error(`bad regexp-value '${L}', parse error: ${G}`);return console.warn(`bad regexp-value '${L}', parse error: ${G}`),null}}}e.ContextKeyExpr=E;function C(N,L){const F=N?N.substituteConstants():void 0,O=L?L.substituteConstants():void 0;return!F&&!O?!0:!F||!O?!1:F.equals(O)}e.expressionsAreEqualWithConstantSubstitution=C;function R(N,L){return N.cmp(L)}class P{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class y{constructor(L,F){this.key=L,this.negated=F,this.type=2}static create(L,F=null){const O=T.get(L);return typeof O=="boolean"?O?p.INSTANCE:P.INSTANCE:new y(L,F)}cmp(L){return L.type!==this.type?this.type-L.type:h(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:P.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class g{constructor(L,F,O){this.key=L,this.value=F,this.negated=O,this.type=4}static create(L,F,O=null){if(typeof F=="boolean")return F?y.create(L,O):S.create(L,O);const W=T.get(L);return typeof W=="boolean"?F===(W?"true":"false")?p.INSTANCE:P.INSTANCE:new g(L,F,O)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const F=L?"true":"false";return this.value===F?p.INSTANCE:P.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class v{constructor(L,F){this.key=L,this.valueKey=F,this.type=10,this.negated=null}static create(L,F){return new v(L,F)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.valueKey),O=L.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?A.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=v;class f{constructor(L){this._actual=L,this.type=11}static create(L){return new f(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new f(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class d{constructor(L,F,O){this.key=L,this.value=F,this.negated=O,this.type=5}static create(L,F,O=null){if(typeof F=="boolean")return F?S.create(L,O):y.create(L,O);const W=T.get(L);return typeof W=="boolean"?F===(W?"true":"false")?P.INSTANCE:p.INSTANCE:new d(L,F,O)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const F=L?"true":"false";return this.value===F?P.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class S{constructor(L,F){this.key=L,this.negated=F,this.type=3}static create(L,F=null){const O=T.get(L);return typeof O=="boolean"?O?P.INSTANCE:p.INSTANCE:new S(L,F)}cmp(L){return L.type!==this.type?this.type-L.type:h(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?P.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;function w(N,L){if(typeof N=="string"){const F=parseFloat(N);isNaN(F)||(N=F)}return typeof N=="string"||typeof N=="number"?L(N):P.INSTANCE}class m{constructor(L,F,O){this.key=L,this.value=F,this.negated=O,this.type=12}static create(L,F,O=null){return w(F,W=>new m(L,W,O))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=m;class u{constructor(L,F,O){this.key=L,this.value=F,this.negated=O,this.type=13}static create(L,F,O=null){return w(F,W=>new u(L,W,O))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class t{constructor(L,F,O){this.key=L,this.value=F,this.negated=O,this.type=14}static create(L,F,O=null){return w(F,W=>new t(L,W,O))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class c{constructor(L,F,O){this.key=L,this.value=F,this.negated=O,this.type=15}static create(L,F,O=null){return w(F,W=>new c(L,W,O))}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class i{constructor(L,F){this.key=L,this.regexp=F,this.type=7,this.negated=null}static create(L,F){return new i(L,F)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const F=this.regexp?this.regexp.source:"",O=L.regexp?L.regexp.source:"";return F<O?-1:F>O?1:0}equals(L){if(L.type===this.type){const F=this.regexp?this.regexp.source:"",O=L.regexp?L.regexp.source:"";return this.key===L.key&&F===O}return!1}substituteConstants(){return this}evaluate(L){let F=L.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{constructor(L){this._actual=L,this.type=8}static create(L){return new o(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new o(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function a(N){let L=null;for(let F=0,O=N.length;F<O;F++){const W=N[F].substituteConstants();if(N[F]!==W&&L===null){L=[];for(let H=0;H<F;H++)L[H]=N[H]}L!==null&&(L[F]=W)}return L===null?N:L}class r{constructor(L,F){this.expr=L,this.negated=F,this.type=6}static create(L,F){return r._normalizeArr(L,F)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const W=R(this.expr[F],L.expr[F]);if(W!==0)return W}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:r.create(L,this.negated)}evaluate(L){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(L))return!1;return!0}static _normalizeArr(L,F){const O=[];let W=!1;for(const H of L)if(!!H){if(H.type===1){W=!0;continue}if(H.type===0)return P.INSTANCE;if(H.type===6){O.push(...H.expr);continue}O.push(H)}if(O.length===0&&W)return p.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(R);for(let H=1;H<O.length;H++)O[H-1].equals(O[H])&&(O.splice(H,1),H--);if(O.length===1)return O[0];for(;O.length>1;){const H=O[O.length-1];if(H.type!==9)break;O.pop();const te=O.pop(),G=O.length===0,$=s.create(H.expr.map(q=>r.create([q,te],null)),null,G);$&&(O.push($),O.sort(R))}return O.length===1?O[0]:new r(O,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let F of this.expr)L.push(...F.keys());return L}map(L){return new r(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.negated){const L=[];for(let F of this.expr)L.push(F.negate());this.negated=s.create(L,this,!0)}return this.negated}}class s{constructor(L,F){this.expr=L,this.negated=F,this.type=9}static create(L,F,O){return s._normalizeArr(L,F,O)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const W=R(this.expr[F],L.expr[F]);if(W!==0)return W}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:s.create(L,this.negated,!1)}evaluate(L){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(L))return!0;return!1}static _normalizeArr(L,F,O){let W=[],H=!1;if(L){for(let te=0,G=L.length;te<G;te++){const $=L[te];if(!!$){if($.type===0){H=!0;continue}if($.type===1)return p.INSTANCE;if($.type===9){W=W.concat($.expr);continue}W.push($)}}if(W.length===0&&H)return P.INSTANCE;W.sort(R)}if(W.length!==0){if(W.length===1)return W[0];for(let te=1;te<W.length;te++)W[te-1].equals(W[te])&&(W.splice(te,1),te--);if(W.length===1)return W[0];if(O){for(let te=0;te<W.length;te++)for(let G=te+1;G<W.length;G++)_(W[te],W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0]}return new s(W,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let F of this.expr)L.push(...F.keys());return L}map(L){return new s(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.negated){let L=[];for(let F of this.expr)L.push(F.negate());for(;L.length>1;){const F=L.shift(),O=L.shift(),W=[];for(const te of U(F))for(const G of U(O))W.push(r.create([te,G],null));const H=L.length===0;L.unshift(s.create(W,null,H))}this.negated=L[0]}return this.negated}}class l extends y{constructor(L,F,O){super(L,null);this._defaultValue=F,typeof O=="object"?l._info.push({...O,key:L}):O!==!0&&l._info.push({key:L,description:O,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return g.create(this.key,L)}notEqualsTo(L){return d.create(this.key,L)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(N,L){return N<L?-1:N>L?1:0}function b(N,L,F,O){return N<F?-1:N>F?1:L<O?-1:L>O?1:0}function _(N,L){if(L.type===6&&N.type!==9&&N.type!==6){for(const W of L.expr)if(N.equals(W))return!0}const F=N.negate(),O=U(F).concat(U(L));O.sort(R);for(let W=0;W<O.length;W++){const te=O[W].negate();for(let G=W+1;G<O.length;G++){const $=O[G];if(te.equals($))return!0}}return!1}e.implies=_;function U(N){return N.type===9?N.expr:[N]}}),define(ie[87],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=n;class k{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ie[88],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ie[13],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[29],re([0,1,136,6]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(d,S){switch(d){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function I(d,S){return S==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function E(d,S,w){return I(S,w)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===w?!0:C(w).includes(d)}e.isTargetPlatformCompatible=E;function C(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var P;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var p;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var y;(function(d){d.Install="install",d.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var v;(function(d){d.Unsupported="Unsupported",d.UnsupportedPreRelease="UnsupportedPreRelease",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(S,w){super(S);this.code=w,this.name=w}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(ie[165],re([0,1,3,2,28,7,114,29]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(v,f){return T.URI.revive(f?f.transformIncoming(v):v)}function C(v,f){return f?f.transformOutgoingURI(v):v}function R(v,f){f=f||A.DefaultURITransformer;const d=v.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...v,manifest:void 0},f),manifest:d}}function P(v,f){return f?(0,k.cloneAndChange)(v,d=>d instanceof T.URI?f.transformOutgoingURI(d):void 0):v}class p{constructor(f,d){this.service=f,this.getUriTransformer=d,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,d){const S=this.getUriTransformer(f);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,w=>w.map(m=>({...m,local:m.local?P(m.local,S):m.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,d,S){const w=this.getUriTransformer(f);switch(d){case"zip":return this.service.zip(R(S[0],w)).then(m=>C(m,w));case"unzip":return this.service.unzip(E(S[0],w));case"install":return this.service.install(E(S[0],w),S[1]);case"getManifest":return this.service.getManifest(E(S[0],w));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(S[0]);case"installFromGallery":return this.service.installFromGallery(S[0],S[1]);case"uninstall":return this.service.uninstall(R(S[0],w),S[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(R(S[0],w));case"getInstalled":return this.service.getInstalled(S[0]).then(m=>m.map(u=>P(u,w)));case"updateMetadata":return this.service.updateMetadata(R(S[0],w),S[1]).then(m=>P(m,w));case"updateExtensionScope":return this.service.updateExtensionScope(R(S[0],w),S[1]).then(m=>P(m,w));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class y extends n.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(d=>this._onInstallExtension.fire({identifier:d.identifier,source:this.isUriComponents(d.source)?T.URI.revive(d.source):d.source}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this._onDidInstallExtensions.fire(d.map(S=>({...S,local:S.local?R(S.local,null):S.local,source:this.isUriComponents(S.source)?T.URI.revive(S.source):S.source}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this._onUninstallExtension.fire(d))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this._onDidUninstallExtension.fire(d)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const d=await this.getTargetPlatform();return f.allTargetPlatforms.some(S=>(0,I.isTargetPlatformCompatible)(S,f.allTargetPlatforms,d))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(d=>T.URI.revive(d)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,d){return Promise.resolve(this.channel.call("install",[f,d])).then(S=>R(S,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,d){return Promise.resolve(this.channel.call("installFromGallery",[f,d])).then(S=>R(S,null))}uninstall(f,d){return Promise.resolve(this.channel.call("uninstall",[f,d]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(d=>d.map(S=>R(S,null)))}updateMetadata(f,d){return Promise.resolve(this.channel.call("updateMetadata",[f,d])).then(S=>R(S,null))}updateExtensionScope(f,d){return Promise.resolve(this.channel.call("updateExtensionScope",[f,d])).then(S=>R(S,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class g{constructor(f){this.service=f}listen(f,d){throw new Error("Invalid listen")}call(f,d,S){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(S[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(ie[89],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ie[14],re([0,1,8,39,10,26,15,7,143,6]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R(G){return G.create===!0}e.isFileOpenForWriteOptions=R;var P;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var p;(function(G){G[G.Readonly=1]="Readonly"})(p=e.FilePermission||(e.FilePermission={}));var y;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=g;function v(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=v;function f(G){return!!(G.capabilities&32768)}e.hasFileCloneCapability=f;function d(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function S(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=S;function w(G){return g(G)?!!(G.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var m;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor($,q){super($);this.code=q}}e.FileSystemProviderError=u;function t(G,$){const q=new u(G.toString(),$);return i(q,$),q}e.createFileSystemProviderError=t;function c(G){return G||t((0,E.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function i(G,$){return G.name=$?`${$} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=i;function o(G){if(!G)return m.Unknown;if(G instanceof u)return G.code;const $=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!$)return m.Unknown;switch($[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=o;function a(G){if(G instanceof _)return G.fileOperationResult;switch(o(G)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor($,q,V){this.resource=$,this.operation=q,this.target=V}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var l;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const V=new Map;for(const x of $){const K=V.get(x.type);switch(K?K.push([x.resource,x]):V.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,K]of V)switch(x){case 1:this.added=n.TernarySearchTree.forUris(()=>q),this.added.fill(K);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>q),this.updated.fill(K);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>q),this.deleted.fill(K);break}}contains($,...q){return this.doContains($,{includeChildren:!1},...q)}affects($,...q){return this.doContains($,{includeChildren:!0},...q)}doContains($,q,...V){if(!$)return!1;const x=V.length>0;return!!((!x||V.includes(1))&&(this.added?.get($)||q.includeChildren&&this.added?.findSuperstr($))||(!x||V.includes(0))&&(this.updated?.get($)||q.includeChildren&&this.updated?.findSuperstr($))||(!x||V.includes(2))&&(this.deleted?.findSubstr($)||q.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function b(G,$,q){return!G||!$||G===$||$.length>G.length?!1:($.charAt($.length-1)!==k.sep&&($+=k.sep),q?(0,T.startsWithIgnoreCase)(G,$):G.indexOf($)===0)}e.isParent=b;class _ extends D.ErrorNoTelemetry{constructor($,q,V){super($);this.fileOperationResult=q,this.options=V}}e.FileOperationError=_;class U extends _{constructor($,q,V){super($,2,V);this.stat=q}}e.NotModifiedSinceFileOperationError=U;var N;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=F;async function O(G,$){if(!$.hasProvider(I.URI.from({scheme:G.scheme})))return new Promise(q=>{const V=$.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===G.scheme&&x.added&&(V.dispose(),q())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize($){return(0,A.isNumber)($)||($=0),$<W.KB?(0,E.localize)(1,null,$.toFixed(0)):$<W.MB?(0,E.localize)(2,null,($/W.KB).toFixed(2)):$<W.GB?(0,E.localize)(3,null,($/W.MB).toFixed(2)):$<W.TB?(0,E.localize)(4,null,($/W.GB).toFixed(2)):(0,E.localize)(5,null,($/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var H;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function te(G){return{maxFileSize:G===0?300*W.MB:16*W.GB,maxHeapSize:G===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=te});var Y=this&&this.__param||function(Q,e){return function(D,n){e(D,n,Q)}};define(ie[166],re([0,1,90,40,14]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(I){this.fileService=I}async checksum(I){const E=(await this.fileService.readFileStream(I)).value;return new Promise((C,R)=>{const P=(0,D.createHash)("md5");(0,n.listenStream)(E,{onData:p=>P.update(p.buffer),onError:p=>R(p),onEnd:()=>C(P.digest("base64").replace(/=+$/,""))})})}};T=de([Y(0,k.IFileService)],T),e.ChecksumService=T}),define(ie[167],re([0,1,16,37,8,3,2,40,7,30,14]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends A.Disposable{constructor(y,g){super();this.channel=y,this.extraCapabilities=g,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,C.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,g){const{buffer:v}=await this.channel.call("readFile",[y,g]);return v}readFileStream(y,g,v){const f=(0,I.newWriteableStream)(S=>D.VSBuffer.concat(S.map(w=>D.VSBuffer.wrap(w))).buffer),d=this.channel.listen("readFileStream",[y,g])(S=>{if(S instanceof D.VSBuffer)f.write(S.buffer);else{if(S==="end")f.end();else{let w=S;w instanceof Error||(w=(0,R.createFileSystemProviderError)((0,n.toErrorMessage)(w),R.FileSystemProviderErrorCode.Unknown)),f.error(w),f.end()}d.dispose()}});return v.onCancellationRequested(()=>{f.error((0,k.canceled)()),f.end(),d.dispose()}),f}writeFile(y,g,v){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(g),v])}open(y,g){return this.channel.call("open",[y,g])}close(y){return this.channel.call("close",[y])}async read(y,g,v,f,d){const[S,w]=await this.channel.call("read",[y,g,d]);return v.set(S.buffer.slice(0,w),f),w}write(y,g,v,f,d){return this.channel.call("write",[y,g,D.VSBuffer.wrap(v),f,d])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,g){return this.channel.call("delete",[y,g])}rename(y,g,v){return this.channel.call("rename",[y,g,v])}copy(y,g,v){return this.channel.call("copy",[y,g,v])}cloneFile(y,g){return this.channel.call("cloneFile",[y,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const g=y;this._onDidChange.fire(g.map(v=>({resource:E.URI.revive(v.resource),type:v.type})))}else{const g=y;this._onDidWatchError.fire(g)}}))}watch(y,g){const v=(0,C.generateUuid)();return this.channel.call("watch",[this.sessionId,v,y,g]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=P}),define(ie[91],re([0,1,16,8,144,14]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(R,P,p,y,g,v){let f;try{await I(R,P,p,y,g,v)}catch(d){f=d}finally{f&&g.errorTransformer&&(f=g.errorTransformer(f)),typeof f!="undefined"&&p.error(f),p.end()}}e.readFileIntoStream=A;async function I(R,P,p,y,g,v){E(v);const f=await R.open(P,{create:!1});try{E(v);let d=0,S=0,w=g&&typeof g.length=="number"?g.length:void 0,m=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof w=="number"?w:g.bufferSize)),u=g&&typeof g.position=="number"?g.position:0,t=0;do S=await R.read(f,u,m.buffer,t,m.byteLength-t),u+=S,t+=S,d+=S,typeof w=="number"&&(w-=S),t===m.byteLength&&(await p.write(y(m)),m=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof w=="number"?w:g.bufferSize)),t=0);while(S>0&&(typeof w!="number"||w>0)&&E(v)&&C(d,g));if(t>0){let c=t;typeof w=="number"&&(c=Math.min(t,w)),p.write(y(m.slice(0,c)))}}catch(d){throw(0,T.ensureFileSystemProviderError)(d)}finally{await R.close(f)}}function E(R){if(R.isCancellationRequested)throw(0,n.canceled)();return!0}function C(R,P){if(P?.limits){if(typeof P.limits.memory=="number"&&R>P.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&R>P.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[53],re([0,1,78,2,10,4,7,14]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(f){return f.recursive===!0}e.isRecursiveWatchRequest=E;class C extends n.Disposable{constructor(d,S,w,m){super();this.onFileChanges=d,this.onLogMessage=S,this.verboseLogging=w,this.options=m,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new n.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(S=>this.onFileChanges(S))),d.add(this.watcher.onDidLogMessage(S=>this.onLogMessage(S))),d.add(this.watcher.onDidError(S=>this.onError(S)))}onError(d){this.options.restartOnError?this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=C,C.MAX_RESTARTS=5;class R extends C{constructor(d,S,w){super(d,S,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class P extends C{constructor(d,S,w){super(d,S,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function p(f){return f.map(d=>({type:d.type,resource:A.URI.file(d.path)}))}e.toFileChanges=p;function y(f){const d=new v;for(const S of f)d.processEvent(S);return d.coalesce()}e.coalesceEvents=y;function g(f,d){const S=[];for(const w of d){let m=w;typeof m=="string"&&!m.startsWith(D.GLOBSTAR)&&!(0,k.isAbsolute)(m)&&(m={base:f,pattern:m}),S.push((0,D.parse)(m))}return S}e.parseWatcherPatterns=g;class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return T.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const S=this.mapPathToChange.get(this.toKey(d));let w=!1;if(S){const m=S.type,u=d.type;S.path!==d.path&&(d.type===2||d.type===1)?w=!0:m===1&&u===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(S)):m===2&&u===1?S.type=0:m===1&&u===0||(S.type=u)}else w=!0;w&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],S=[];return Array.from(this.coalesced).filter(w=>w.type!==2?(d.push(w),!1):!0).sort((w,m)=>w.path.length-m.path.length).filter(w=>S.some(m=>(0,I.isParent)(w.path,m,!T.isLinux))?!1:(S.push(w.path),!0)).concat(d)}}}),define(ie[168],re([0,1,50,5,25,41,2,75,10,4,118,27,53]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(f,d,S,w){super();this.request=f,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=w,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},m=>this.onDidFilesChange(m)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const f=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await P.Promises.stat(f);this._register(await this.doWatch(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.error(f):this.trace(f)}}async normalizePath(f){let d=f.path;try{d=await P.Promises.realpath(f.path),f.path===d&&(d=await(0,R.realcase)(f.path)??f.path),f.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async doWatch(f,d){if(C.isMacintosh&&(0,T.isEqualOrParent)(f,"/Volumes/",!0))return this.error(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token);let w=new A.DisposableStore;try{const m=(0,E.basename)(f),u=(0,D.watch)(f);w.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${f}'`);const t=new Set;if(d)try{for(const i of await P.Promises.readdir(f))t.add(i)}catch(i){this.error(i)}const c=new Map;w.add((0,A.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),u.on("error",(i,o)=>{this.error(`Failed to watch ${f} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),u.on("change",(i,o)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let a="";if(o&&(a=o.toString(),C.isMacintosh&&(a=(0,I.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){c.get(a)?.dispose();const r=setTimeout(async()=>{if(c.delete(a),a===m&&!await P.Promises.exists(f)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.existsChildStrictCase((0,E.join)(f,a));if(S.token.isCancellationRequested)return;let l;s?t.has(a)?l=0:(l=1,t.add(a)):(t.delete(a),l=2),this.onFileChange({path:(0,E.join)(this.request.path,a),type:l})},y.FILE_DELETE_HANDLER_DELAY);c.set(a,(0,A.toDisposable)(()=>clearTimeout(r)))}else{let r;t.has(a)?r=0:(r=1,t.add(a)),this.onFileChange({path:(0,E.join)(this.request.path,a),type:r})}else if(i==="rename"||a!==m){const r=setTimeout(async()=>{const s=await P.Promises.exists(f);S.token.isCancellationRequested||(s?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(f,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,A.toDisposable)(()=>clearTimeout(r)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(m){await P.Promises.exists(f)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${f} for changes using fs.watch() (${m.toString()})`)}return(0,A.toDisposable)(()=>{S.dispose(!0),w.dispose()})}async onFileChange(f,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!d&&this.excludes.some(S=>S(f.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${f.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(f.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${f.path}`):this.fileChangesBuffer.push(f);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,p.coalesceEvents)(S);if(w.length>0){if(this.verboseLogging)for(const u of w)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(w)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(f){if(C.isLinux)return P.Promises.exists(f);try{const d=(0,E.basename)(f);return(await P.Promises.readdir((0,E.dirname)(f))).some(w=>w===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(f){this.verboseLogging=f}error(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}warn(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}trace(f){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function g(v,f,d,S,w=512){const m=await P.Promises.open(v,"r"),u=Buffer.allocUnsafe(w),t=new k.CancellationTokenSource(S);let c,i=!1;const o={path:v,excludes:[],recursive:!1},a=new y(o,r=>{(async()=>{for(const{type:s}of r)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:l}=await P.Promises.read(m,u,0,w,null);if(!l||t.token.isCancellationRequested)break;f(u.slice(0,l))}}catch(l){c=new Error(l),t.dispose(!0)}finally{i=!1}}})()});return await a.ready,d(),new Promise((r,s)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await P.Promises.close(m)}catch(l){c=new Error(l)}c?s(c):r()})})}e.watchFileContents=g}),define(ie[169],re([0,1,3,78,2,4,168]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const R=this.normalizeRequests(C),P=R.filter(y=>{const g=this.watchers.get(y.path);return g?!(0,n.patternsEquals)(g.request.excludes,y.excludes)||!(0,n.patternsEquals)(g.request.includes,y.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:y})=>!R.find(g=>g.path===y.path&&(0,n.patternsEquals)(g.excludes,y.excludes)&&(0,n.patternsEquals)(g.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.trace(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?y.includes:"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const y of p)this.stopWatching(y);for(const y of P)this.startWatching(y)}startWatching(C){const R=new A.NodeJSFileWatcherLibrary(C,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),P={request:C,instance:R};this.watchers.set(C.path,P)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const R=this.watchers.get(C);R&&(this.watchers.delete(C),R.instance.dispose())}normalizeRequests(C){const R=new Map;for(const P of C){const p=T.isLinux?P.path:P.path.toLowerCase();R.set(p,P)}return Array.from(R.values())}async setVerboseLogging(C){this.verboseLogging=C;for(const[,R]of this.watchers)R.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,R){return R?`[File Watcher (node.js)] ${C} (path: ${R.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=I}),define(ie[170],re([0,1,53,169]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends D.AbstractNonRecursiveWatcherClient{constructor(A,I,E){super(A,I,E);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ie[171],re([0,1,19,36,59,53]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(E,C,R){super(E,C,R);this.init()}createWatcher(E){const C=E.add(new k.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(C.onDidProcessExit(({code:R,signal:P})=>this.onError(`terminated by itself with code ${R}, signal: ${P}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ie[92],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...k){this._entries=new Map;for(let[T,A]of k)this.set(T,A)}set(k,T){const A=this._entries.get(k);return this._entries.set(k,T),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=D}),define(ie[172],re([0,1,5,8,52,162,6,92]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class C extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class R{constructor(g=new I.ServiceCollection,v=!1,f){this._activeInstantiations=new Set,this._services=g,this._strict=v,this._parent=f,this._services.set(A.IInstantiationService,this)}createChild(g){return new R(g,this._strict,this)}invokeFunction(g,...v){let f=p.traceInvocation(g),d=!1;try{return g({get:w=>{if(d)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(w,f);if(!m)throw new Error(`[invokeFunction] unknown service '${w}'`);return m}},...v)}finally{d=!0,f.stop()}}createInstance(g,...v){let f,d;return g instanceof k.SyncDescriptor?(f=p.traceCreation(g.ctor),d=this._createInstance(g.ctor,g.staticArguments.concat(v),f)):(f=p.traceCreation(g),d=this._createInstance(g,v,f)),f.stop(),d}_createInstance(g,v=[],f){let d=A._util.getServiceDependencies(g).sort((m,u)=>m.index-u.index),S=[];for(const m of d){let u=this._getOrCreateServiceInstance(m.id,f);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${m.id}.`,!1),S.push(u)}let w=d.length>0?d[0].index:v.length;if(v.length!==w){console.trace(`[createInstance] First service dependency of ${g.name} at position ${w+1} conflicts with ${v.length} static arguments`);let m=w-v.length;m>0?v=v.concat(new Array(m)):v=v.slice(0,w)}return new g(...[...v,...S])}_setServiceInstance(g,v){if(this._services.get(g)instanceof k.SyncDescriptor)this._services.set(g,v);else if(this._parent)this._parent._setServiceInstance(g,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let v=this._services.get(g);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):v}_getOrCreateServiceInstance(g,v){let f=this._getServiceInstanceOrDescriptor(g);return f instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,f,v.branch(g,!0)):(v.branch(g,!1),f)}_safeCreateAndCacheServiceInstance(g,v,f){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,v,f)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,v,f){const d=new T.Graph(m=>m.id.toString());let S=0;const w=[{id:g,desc:v,_trace:f}];for(;w.length;){const m=w.pop();if(d.lookupOrInsertNode(m),S++>1e3)throw new C(d);for(let u of A._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(t||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),t instanceof k.SyncDescriptor){const c={id:u.id,desc:t,_trace:m._trace.branch(u.id,!0)};d.insertEdge(m,c),w.push(c)}}}for(;;){const m=d.roots();if(m.length===0){if(!d.isEmpty())throw new C(d);break}for(const{data:u}of m){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const c=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,c)}d.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,v,f=[],d,S){if(this._services.get(g)instanceof k.SyncDescriptor)return this._createServiceInstance(v,f,d,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,v,f,d,S);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(g,v=[],f,d){if(f){const S=new D.IdleValue(()=>this._createInstance(g,v,d));return new Proxy(Object.create(null),{get(w,m){if(m in w)return w[m];let u=S.value,t=u[m];return typeof t!="function"||(t=t.bind(u),w[m]=t),t},set(w,m,u){return S.value[m]=u,!0}})}else return this._createInstance(g,v,d)}_throwIfStrict(g,v){if(v&&console.warn(v),this._strict)throw new Error(g)}}e.InstantiationService=R;var P;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(P||(P={}));class p{constructor(g,v){this.type=g,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return E?new p(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(g){return E?new p(0,g.name):p._None}branch(g,v){let f=new p(2,g.toString());return this._dep.push([g,v,f]),f}stop(){let g=Date.now()-this._start;p._totals+=g;let v=!1;function f(S,w){let m=[],u=new Array(S+1).join("	");for(const[t,c,i]of w._dep)if(c&&i){v=!0,m.push(`${u}CREATES -> ${t}`);let o=f(S+1,i);o&&m.push(o)}else m.push(`${u}uses -> ${t}`);return m.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(g>2||v)&&console.log(d.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ie[173],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(k,T){this.server=k,this.router=T}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,T){this.server.registerChannel(k,T)}}e.MessagePortMainProcessService=D}),define(ie[174],re([0,1,36,52,86,6]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,g,v){const f=v.getChannel(y);return I(g)?new g.channelClientCtor(f):D.ProxyChannel.toService(f,g?.proxyOptions)}}function I(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let E=class extends A{constructor(y,g,v){super(y,g,v)}};E=de([Y(2,e.IMainProcessService)],E);function C(p,y,g){(0,k.registerSingleton)(p,new n.SyncDescriptor(E,[y,g],g?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let R=class extends A{constructor(y,g,v){super(y,g,v)}};R=de([Y(2,e.ISharedProcessService)],R);function P(p,y,g){(0,k.registerSingleton)(p,new n.SyncDescriptor(R,[y,g],g?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=P}),define(ie[61],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const T of k.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ie[175],re([0,1,2,61]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([Y(0,n.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(ie[9],re([0,1,37,3,2,4,6]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var E;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function C(c,i,o){switch(i){case E.Trace:c.trace(o);break;case E.Debug:c.debug(o);break;case E.Info:c.info(o);break;case E.Warning:c.warn(o);break;case E.Error:c.error(o);break;case E.Critical:c.critical(o);break;default:throw new Error("Invalid log level")}}e.log=C;function R(c){let i="";for(let o=0;o<c.length;o++){let a=c[o];if(typeof a=="object")try{a=JSON.stringify(a)}catch{}i+=(o>0?" ":"")+a}return i}e.format=R;class P extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class p extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([i,...o]))}debug(i,...o){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([i,...o]))}info(i,...o){this.checkLogLevel(E.Info)&&this.log(E.Info,R([i,...o]))}warn(i,...o){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([i,...o]))}error(i,...o){if(this.checkLogLevel(E.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(E.Error,R(a))}else this.log(E.Error,R([i,...o]))}critical(i,...o){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([i,...o]))}flush(){}}e.AbstractMessageLogger=p;class y extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...o){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...o):console.log(`[main ${I()}]`,i,...o))}debug(i,...o){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...o):console.log(`[main ${I()}]`,i,...o))}info(i,...o){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...o):console.log(`[main ${I()}]`,i,...o))}warn(i,...o){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...o):console.warn(`[main ${I()}]`,i,...o))}error(i,...o){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...o):console.error(`[main ${I()}]`,i,...o))}critical(i,...o){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...o):console.error(`[main ${I()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class g extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=g;class v extends P{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class f extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const a of this.logServices)a.trace(i,...o)}debug(i,...o){for(const a of this.logServices)a.debug(i,...o)}info(i,...o){for(const a of this.logServices)a.info(i,...o)}warn(i,...o){for(const a of this.logServices)a.warn(i,...o)}error(i,...o){for(const a of this.logServices)a.error(i,...o)}critical(i,...o){for(const a of this.logServices)a.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class d extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=d;class S extends k.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,o?.always?E.Trace:this.logLevel,o),this.loggers.set(i.toString(),a),o?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=w;function m(c){if(c.verbose)return E.Trace;if(typeof c.logLevel=="string"){const i=u(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function u(c){switch(c){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=u;function t(c){switch(c){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(ie[176],re([0,1,5,8,2,10,27,13,9]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends k.Disposable{constructor(P,p){super();this.environmentService=P,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const P=(0,T.basename)(this.environmentService.logsPath),p=(0,T.dirname)(this.environmentService.logsPath),v=(await A.Promises.readdir(p)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==P),f=v.slice(0,Math.max(0,v.length-9));f.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(d=>A.Promises.rm((0,T.join)(p,d)))))}catch(P){(0,n.onUnexpectedError)(P)}}};C=de([Y(0,I.IEnvironmentService),Y(1,E.ILogService)],C),e.LogsDataCleaner=C}),define(ie[177],re([0,1,5,8,2,10,27,13,9]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class dt extends k.Disposable{constructor(P,p,y){super();this.backupWorkspacesPath=P,this.environmentService=p,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const P=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(P).emptyWorkspaceInfos.map(v=>v.backupFolder),g=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(g.map(async v=>{v.length===dt.NON_EMPTY_WORKSPACE_ID_LENGTH||v===dt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(v)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${v}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,v)))}))}catch(P){(0,n.onUnexpectedError)(P)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=de([Y(1,I.INativeEnvironmentService),Y(2,E.ILogService)],C),e.StorageDataCleaner=C}),define(ie[178],re([0,1,45,5,37,3,2,19,10,27,13,9]),function(Q,e,D,n,k,T,A,I,E,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(g,v){super();this.environmentService=g,this.logService=v,this.processesLimiter=new n.Limiter(5)}async postUninstall(g){const v=this.parseScript(g,"uninstall");return v&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,g).then(()=>this.logService.info(g.identifier.id,g.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(g.identifier.id,g.manifest.version,`Failed to run post uninstall script: ${f}`)))),C.Promises.rm(this.getExtensionStoragePath(g)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(g,v){const f=`vscode:${v}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[f]=="string"){const d=g.manifest.scripts[f].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${f} should be a node script`),null):{script:(0,E.join)(g.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(g,v,f,d,S){return new Promise((w,m)=>{const u=this.start(g,v,f,S);let t;const c=i=>{t&&(clearTimeout(t),t=null),i?m(i):w(void 0)};u.on("error",i=>{c((0,k.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,o)=>{c(i?`post-${v} process exited with code ${i}`:void 0)}),d&&(t=setTimeout(()=>{t=null,u.kill(),m("timed out")},5e3))})}start(g,v,f,d){const S={silent:!0,execArgv:void 0},w=(0,D.fork)(g,[`--type=extension-post-${v}`,...f],S);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const m=T.Event.fromNodeEventEmitter(w.stdout,"data"),u=T.Event.fromNodeEventEmitter(w.stderr,"data");m(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${v}`,i)),u(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${v}`,i));const t=T.Event.any(T.Event.map(m,i=>({data:`%c${i}`,format:[""]})),T.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}getExtensionStoragePath(g){return(0,E.join)(this.environmentService.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};p=de([Y(0,R.IEnvironmentService),Y(1,P.ILogService)],p),e.ExtensionsLifecycle=p}),define(ie[179],re([0,1,17,5,8,3,2,10,53,9]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends A.Disposable{constructor(p,y){super();this.logService=p,this.options=y,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(p,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,y):this.watchNonRecursive(p,y)}watchUniversal(p,y){const g={path:this.toFilePath(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive},v=(0,D.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,k.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,E.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(y)&&p.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,y){const g={path:this.toFilePath(p),excludes:y.excludes,includes:y.includes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,k.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,E.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,I.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(ie[180],re([0,1,17,5,16,25,3,74,56,2,39,19,181,20,40,142,14,91,9]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends C.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(u,t){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${u}`);const c=new C.DisposableStore;return this.provider.set(u,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:t}),c.add(t.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&c.add(t.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),c.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:u}))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:t}),this.provider.delete(u),(0,C.dispose)(c)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(c){t.push(c)}}),!this.provider.has(u)&&await n.Promises.settled(t)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,t){const c=this.provider.get(u.scheme);return!!(c&&c.capabilities&t)}listCapabilities(){return E.Iterable.map(this.provider,([u,t])=>({scheme:u,capabilities:t.capabilities}))}async withProvider(u){if(!(0,y.isAbsolutePath)(u))throw new f.FileOperationError((0,v.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const t=this.provider.get(u.scheme);if(!t){const c=new Error;throw c.name="ENOPRO",c.message=(0,v.localize)(1,null,u.toString()),c}return t}async withReadProvider(u){const t=await this.withProvider(u);if((0,f.hasOpenReadWriteCloseCapability)(t)||(0,f.hasReadWriteCapability)(t)||(0,f.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const t=await this.withProvider(u);if((0,f.hasOpenReadWriteCloseCapability)(t)||(0,f.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,t){try{return await this.doResolveFile(u,t)}catch(c){throw(0,f.toFileSystemProviderErrorCode)(c)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,v.localize)(2,null,this.resourceForError(u)),1):(0,f.ensureFileSystemProviderError)(c)}}async doResolveFile(u,t){const c=await this.withProvider(u),i=this.isPathCaseSensitive(c),o=t?.resolveTo,a=t?.resolveSingleChildDescendants,r=t?.resolveMetadata,s=await c.stat(u);let l;return this.toFileStat(c,u,s,void 0,!!r,(h,b)=>(l||(l=R.TernarySearchTree.forUris(()=>!i),l.set(u,!0),o&&l.fill(!0,o)),l.get(h.resource)||l.findSuperstr(h.resource.with({query:null,fragment:null}))?!0:h.isDirectory&&a?b===1:!1))}async toFileStat(u,t,c,i,o,a){const{providerExtUri:r}=this.getExtUri(u),s={resource:t,name:r.basename(t),isFile:(c.type&f.FileType.File)!=0,isDirectory:(c.type&f.FileType.Directory)!=0,isSymbolicLink:(c.type&f.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&f.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,f.etag)({mtime:c.mtime,size:c.size}),children:void 0};if(s.isDirectory&&a(s,i)){try{const l=await u.readdir(t),h=await n.Promises.settled(l.map(async([b,_])=>{try{const U=r.joinPath(t,b),N=o?await u.stat(U):{type:_};return await this.toFileStat(u,U,N,l.length,o,a)}catch(U){return this.logService.trace(U),null}}));s.children=(0,D.coalesce)(h)}catch(l){this.logService.trace(l),s.children=[]}return s}return s}async resolveAll(u){return n.Promises.settled(u.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async stat(u){const t=await this.withProvider(u),c=await t.stat(u);return this.toFileStat(t,u,c,void 0,!0,()=>!1)}async exists(u){const t=await this.withProvider(u);try{return!!await t.stat(u)}catch{return!1}}async canCreateFile(u,t){try{await this.doValidateCreateFile(u,t)}catch(c){return c}return!0}async doValidateCreateFile(u,t){if(!t?.overwrite&&await this.exists(u))throw new f.FileOperationError((0,v.localize)(3,null,this.resourceForError(u)),3,t)}async createFile(u,t=k.VSBuffer.fromString(""),c){await this.doValidateCreateFile(u,c);const i=await this.writeFile(u,t);return this._onDidRunOperation.fire(new f.FileOperationEvent(u,0,i)),i}async writeFile(u,t,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,u,c)||await this.mkdirp(i,o.dirname(u));let r;if((0,f.hasReadWriteCapability)(i)&&!(t instanceof k.VSBuffer))if((0,g.isReadableStream)(t)){const s=await(0,g.peekStream)(t,3);s.ended?r=k.VSBuffer.concat(s.buffer):r=s}else r=(0,g.peekReadable)(t,s=>k.VSBuffer.concat(s),3);else r=t;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&r instanceof k.VSBuffer?await this.doWriteUnbuffered(i,u,c,r):await this.doWriteBuffered(i,u,c,r instanceof k.VSBuffer?(0,k.bufferToReadable)(r):r),this._onDidRunOperation.fire(new f.FileOperationEvent(u,4))}catch(a){throw new f.FileOperationError((0,v.localize)(4,null,this.resourceForError(u),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),c)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,t,c){if(!!c?.unlock&&!(u.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(t)));let o;try{o=await u.stat(t)}catch{return}if((o.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,v.localize)(6,null,this.resourceForError(t)),0,c);if(this.throwIfFileIsReadonly(t,o),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==f.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&c.mtime<o.mtime&&c.etag!==(0,f.etag)({mtime:c.mtime,size:o.size}))throw new f.FileOperationError((0,v.localize)(7,null),3,c);return o}async readFile(u,t,c){const i=await this.withReadProvider(u);return t?.atomic?this.doReadFileAtomic(i,u,t,c):this.doReadFile(i,u,t,c)}async doReadFileAtomic(u,t,c,i){return new Promise((o,a)=>{this.writeQueue.queueFor(t,this.getExtUri(u).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(u,t,c,i);o(r)}catch(r){a(r)}})})}async doReadFile(u,t,c,i){const o=await this.doReadFileStream(u,t,{...c,preferUnbuffered:!0},i);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(u,t,c){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,t,c)}async doReadFileStream(u,t,c,i){const o=new T.CancellationTokenSource(i),a=this.validateReadFile(t,c).then(s=>s,s=>{throw o.cancel(),s});let r;try{return typeof c?.etag=="string"&&c.etag!==f.ETAG_DISABLED&&await a,c?.atomic&&(0,f.hasFileAtomicReadCapability)(u)||!((0,f.hasOpenReadWriteCloseCapability)(u)||(0,f.hasFileReadStreamCapability)(u))||(0,f.hasReadWriteCapability)(u)&&c?.preferUnbuffered?r=this.readFileUnbuffered(u,t,c):(0,f.hasFileReadStreamCapability)(u)?r=this.readFileStreamed(u,t,o.token,c):r=this.readFileBuffered(u,t,o.token,c),{...await a,value:r}}catch(s){r&&await(0,g.consumeStream)(r);const l=(0,v.localize)(8,null,this.resourceForError(t),(0,f.ensureFileSystemProviderError)(s).toString());throw s instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(l,s.stat,c):new f.FileOperationError(l,(0,f.toFileOperationResult)(s),c)}}readFileStreamed(u,t,c,i=Object.create(null)){const o=u.readFileStream(t,i,c);return(0,g.transform)(o,{data:a=>a instanceof k.VSBuffer?a:k.VSBuffer.wrap(a),error:a=>new f.FileOperationError((0,v.localize)(9,null,this.resourceForError(t),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),i)},a=>k.VSBuffer.concat(a))}readFileBuffered(u,t,c,i=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,d.readFileIntoStream)(u,t,o,a=>a,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new f.FileOperationError((0,v.localize)(10,null,this.resourceForError(t),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),i)},c),o}readFileUnbuffered(u,t,c){const i=(0,g.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;c?.atomic&&(0,f.hasFileAtomicReadCapability)(u)?o=await u.readFile(t,{atomic:!0}):o=await u.readFile(t),typeof c?.position=="number"&&(o=o.slice(c.position)),typeof c?.length=="number"&&(o=o.slice(0,c.length)),this.validateReadFileLimits(t,o.byteLength,c),i.end(k.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(u,t){const c=await this.resolve(u,{resolveMetadata:!0});if(c.isDirectory)throw new f.FileOperationError((0,v.localize)(11,null,this.resourceForError(u)),0,t);if(typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&t.etag===c.etag)throw new f.NotModifiedSinceFileOperationError((0,v.localize)(12,null),c,t);return this.validateReadFileLimits(u,c.size,t),c}validateReadFileLimits(u,t,c){if(c?.limits){let i;if(typeof c.limits.memory=="number"&&t>c.limits.memory&&(i=9),typeof c.limits.size=="number"&&t>c.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,v.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,t,c){return this.doCanMoveCopy(u,t,"move",c)}async canCopy(u,t,c){return this.doCanMoveCopy(u,t,"copy",c)}async doCanMoveCopy(u,t,c,i){if(u.toString()!==t.toString())try{const o=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(o,u,a,t,c,i)}catch(o){return o}return!0}async move(u,t,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),a=await this.doMoveCopy(i,u,o,t,"move",!!c),r=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,a==="move"?2:3,r)),r}async copy(u,t,c){const i=await this.withReadProvider(u),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),a=await this.doMoveCopy(i,u,o,t,"copy",!!c),r=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,a==="copy"?3:2,r)),r}async doMoveCopy(u,t,c,i,o,a){if(t.toString()===i.toString())return o;const{exists:r,isSameResourceWithDifferentPathCase:s}=await this.doValidateMoveCopy(u,t,c,i,o,a);if(r&&!s&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(i)),o==="copy"){if(u===c&&(0,f.hasFileFolderCopyCapability)(u))await u.copy(t,i,{overwrite:a});else{const l=await this.resolve(t);l.isDirectory?await this.doCopyFolder(u,l,c,i):await this.doCopyFile(u,t,c,i)}return o}else return u===c?(await u.rename(t,i,{overwrite:a}),o):(await this.doMoveCopy(u,t,c,i,"copy",a),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(u,t,c,i){if((0,f.hasOpenReadWriteCloseCapability)(u)&&(0,f.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(u,t,c,i);if((0,f.hasOpenReadWriteCloseCapability)(u)&&(0,f.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(u,t,c,i);if((0,f.hasReadWriteCapability)(u)&&(0,f.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(u,t,c,i);if((0,f.hasReadWriteCapability)(u)&&(0,f.hasReadWriteCapability)(c))return this.doPipeUnbuffered(u,t,c,i)}async doCopyFolder(u,t,c,i){await c.mkdir(i),Array.isArray(t.children)&&await n.Promises.settled(t.children.map(async o=>{const a=this.getExtUri(c).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(u,await this.resolve(o.resource),c,a):this.doCopyFile(u,o.resource,c,a)}))}async doValidateMoveCopy(u,t,c,i,o,a){let r=!1;if(u===c){const{providerExtUri:l,isPathCaseSensitive:h}=this.getExtUri(u);if(h||(r=l.isEqual(t,i)),r&&o==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(t),this.resourceForError(i)));if(!r&&l.isEqualOrParent(i,t))throw new Error((0,v.localize)(15,null,this.resourceForError(t),this.resourceForError(i)))}const s=await this.exists(i);if(s&&!r){if(!a)throw new f.FileOperationError((0,v.localize)(16,null,this.resourceForError(t),this.resourceForError(i)),4);if(u===c){const{providerExtUri:l}=this.getExtUri(u);if(l.isEqualOrParent(t,i))throw new Error((0,v.localize)(17,null,this.resourceForError(t),this.resourceForError(i)))}}return{exists:s,isSameResourceWithDifferentPathCase:r}}getExtUri(u){const t=this.isPathCaseSensitive(u);return{providerExtUri:t?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(t,u);const c=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,0,c)),c}async mkdirp(u,t){const c=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(t,i.dirname(t));)try{if(((await u.stat(t)).type&f.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(t)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;c.push(i.basename(t)),t=i.dirname(t)}for(let o=c.length-1;o>=0;o--){t=i.joinPath(t,c[o]);try{await u.mkdir(t)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(u,t){try{await this.doValidateDelete(u,t)}catch(c){return c}return!0}async doValidateDelete(u,t){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!t?.useTrash&&!(c.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(u)));let o;try{o=await c.stat(u)}catch{}if(o)this.throwIfFileIsReadonly(u,o);else throw new f.FileOperationError((0,v.localize)(20,null,this.resourceForError(u)),1);if(!!!t?.recursive){const r=await this.resolve(u);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(u)))}return c}async del(u,t){const c=await this.doValidateDelete(u,t),i=!!t?.useTrash,o=!!t?.recursive;await c.delete(u,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(u,1))}async cloneFile(u,t){const c=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(c===i&&this.getExtUri(c).providerExtUri.isEqual(u,t))return;if(c===i&&(0,f.hasFileCloneCapability)(c))return c.cloneFile(u,t);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t));const o=this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri);return c===i&&(0,f.hasFileFolderCopyCapability)(c)?o.queue(()=>c.copy(u,t,{overwrite:!0})):o.queue(()=>this.doCopyFile(c,u,i,t))}watch(u,t={recursive:!1,excludes:[]}){const c=new C.DisposableStore;let i=!1,o=()=>{i=!0};return c.add((0,C.toDisposable)(()=>o())),(async()=>{try{const a=await this.doWatch(u,t);i?(0,C.dispose)(a):o=()=>(0,C.dispose)(a)}catch(a){this.logService.error(a)}})(),c}async doWatch(u,t){const c=await this.withProvider(u),i=(0,I.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(u),t]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:c.watch(u,t)},this.activeWatchers.set(i,o)),o.count+=1,(0,C.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,C.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,C.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,t,c,i){return this.writeQueue.queueFor(t,this.getExtUri(u).providerExtUri).queue(async()=>{const o=await u.open(t,{create:!0,unlock:c?.unlock??!1});try{(0,g.isReadableStream)(i)||(0,g.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,o,i):await this.doWriteReadableBufferedQueued(u,o,i)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await u.close(o)}})}async doWriteStreamBufferedQueued(u,t,c){let i=0,o;if((0,g.isReadableBufferedStream)(c)){if(c.buffer.length>0){const a=k.VSBuffer.concat(c.buffer);await this.doWriteBuffer(u,t,a,a.byteLength,i,0),i+=a.byteLength}if(c.ended)return;o=c.stream}else o=c;return new Promise((a,r)=>{(0,g.listenStream)(o,{onData:async s=>{o.pause();try{await this.doWriteBuffer(u,t,s,s.byteLength,i,0)}catch(l){return r(l)}i+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>r(s),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(u,t,c){let i=0,o;for(;(o=c.read())!==null;)await this.doWriteBuffer(u,t,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(u,t,c,i,o,a){let r=0;for(;r<i;)r+=await u.write(t,o+r,c.buffer,a+r,i-r)}async doWriteUnbuffered(u,t,c,i){return this.writeQueue.queueFor(t,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,t,c,i))}async doWriteUnbufferedQueued(u,t,c,i){let o;i instanceof k.VSBuffer?o=i:(0,g.isReadableStream)(i)?o=await(0,k.streamToBuffer)(i):(0,g.isReadableBufferedStream)(i)?o=await(0,k.bufferedStreamToBuffer)(i):o=(0,k.readableToBuffer)(i),await u.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(u,t,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,t,c,i))}async doPipeBufferedQueued(u,t,c,i){let o,a;try{o=await u.open(t,{create:!1}),a=await c.open(i,{create:!0,unlock:!1});const r=k.VSBuffer.alloc(this.BUFFER_SIZE);let s=0,l=0,h=0;do h=await u.read(o,s,r.buffer,l,r.byteLength-l),await this.doWriteBuffer(c,a,r,h,s,l),s+=h,l+=h,l===r.byteLength&&(l=0);while(h>0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await n.Promises.settled([typeof o=="number"?u.close(o):Promise.resolve(),typeof a=="number"?c.close(a):Promise.resolve()])}}async doPipeUnbuffered(u,t,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,t,c,i))}async doPipeUnbufferedQueued(u,t,c,i){return c.writeFile(i,await u.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,t,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,t,c,i))}async doPipeUnbufferedToBufferedQueued(u,t,c,i){const o=await c.open(i,{create:!0,unlock:!1});try{const a=await u.readFile(t);await this.doWriteBuffer(c,o,k.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await c.close(o)}}async doPipeBufferedToUnbuffered(u,t,c,i){const o=await(0,k.streamToBuffer)(this.readFileBuffered(u,t,T.CancellationToken.None));await this.doWriteUnbuffered(c,i,void 0,o)}throwIfFileSystemIsReadonly(u,t){if(u.capabilities&2048)throw new f.FileOperationError((0,v.localize)(22,null,this.resourceForError(t)),6);return u}throwIfFileIsReadonly(u,t){if((t.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,v.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===P.Schemas.file?u.fsPath:u.toString(!0)}};w=de([Y(0,S.ILogService)],w),e.FileService=w}),define(ie[182],re([0,1,50,260,5,39,16,3,41,2,10,4,20,40,27,145,14,91,179,37,171,170]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(c){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(c)}`)}})();class t extends S.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new T.ResourceMap(a=>p.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:a}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async r=>{try{let s;r.isSymbolicLink()?s=(await this.stat((0,p.joinPath)(i,r.name))).type:s=this.toType(r),a.push([r.name,s])}catch(s){this.logService.trace(s)}})),a}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let a;return o?.dangling?a=f.FileType.Unknown:i.isFile()?a=f.FileType.File:i.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,o&&(a|=f.FileType.SymbolicLink),a}async createResourceLock(i){const o=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const r=new k.Barrier;return this.resourceLocks.set(i,r),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,C.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),r.open()})}async readFile(i,o){let a;try{o?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),a=await this.createResourceLock(i));const r=this.toFilePath(i);return await g.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{a?.dispose()}}readFileStream(i,o,a){const r=(0,y.newWriteableStream)(s=>A.VSBuffer.concat(s.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,d.readFileIntoStream)(this,i,r,s=>s.buffer,{...o,bufferSize:256*1024},a),r}async writeFile(i,o,a){let r;try{const s=this.toFilePath(i);if(!a.create||!a.overwrite){if(await g.Promises.exists(s)){if(!a.overwrite)throw(0,f.createFileSystemProviderError)((0,v.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.createFileSystemProviderError)((0,v.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(r,0,o,0,o.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(i,s)}finally{typeof r=="number"&&await this.close(r)}}async open(i,o){const a=this.toFilePath(i);let r;(0,f.isFileOpenForWriteOptions)(o)&&(r=await this.createResourceLock(i));let s;try{if((0,f.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(a);h.mode&128||await g.Promises.chmod(a,h.mode|128)}catch(h){this.logService.trace(h)}let l;if((0,f.isFileOpenForWriteOptions)(o)){if(P.isWindows)try{await g.Promises.truncate(a,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}l||(l="w")}else l="r";s=await g.Promises.open(a,l)}catch(l){throw r?.dispose(),(0,f.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(s,0),(0,f.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(s,i),r){const l=this.mapHandleToLock.get(s);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${a})`),this.mapHandleToLock.set(s,r),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${a})`),l.dispose())}return s}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await g.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,a,r,s){const l=this.normalizePos(i,o);let h=null;try{h=(await g.Promises.read(i,a,r,s,l)).bytesRead}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(i,l,h)}return h}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,a){const r=this.mapHandleToPos.get(i);typeof r=="number"&&(typeof o=="number"||(typeof a=="number"?this.mapHandleToPos.set(i,r+a):this.mapHandleToPos.delete(i)))}async write(i,o,a,r,s){return(0,k.retry)(()=>this.doWrite(i,o,a,r,s),100,3)}async doWrite(i,o,a,r,s){const l=this.normalizePos(i,o);let h=null;try{h=(await g.Promises.write(i,a,r,s,l)).bytesWritten}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),b)}finally{this.updatePos(i,l,h)}return h}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const a=this.toFilePath(i);o.recursive?await g.Promises.rm(a,g.RimRafMode.MOVE):await g.Promises.unlink(a)}catch(a){throw this.toFileSystemProviderError(a)}}async rename(i,o,a){const r=this.toFilePath(i),s=this.toFilePath(o);if(r!==s)try{await this.validateTargetDeleted(i,o,"move",a.overwrite),await g.Promises.move(r,s)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,v.localize)(2,null,(0,R.basename)(r),(0,R.basename)((0,R.dirname)(s)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(i,o,a){const r=this.toFilePath(i),s=this.toFilePath(o);if(r!==s)try{await this.validateTargetDeleted(i,o,"copy",a.overwrite),await g.Promises.copy(r,s,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,v.localize)(3,null,(0,R.basename)(r),(0,R.basename)((0,R.dirname)(s)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(i,o,a,r){const s=this.toFilePath(i),l=this.toFilePath(o);let h=!1;if(!!(this.capabilities&1024)||(h=(0,E.isEqual)(s,l,!0)),h&&a==="copy")throw(0,f.createFileSystemProviderError)((0,v.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!h&&await g.Promises.exists(l)){if(!r)throw(0,f.createFileSystemProviderError)((0,v.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,a){const r=this.toFilePath(i),s=this.toFilePath(o),l=!!(this.capabilities&1024);if((0,E.isEqual)(r,s,!l))return;const h=new C.DisposableStore;try{const[b,_]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);h.add(b),h.add(_),a&&await g.Promises.mkdir((0,R.dirname)(s),{recursive:!0}),await g.Promises.copyFile(r,s)}catch(b){if(b.code==="ENOENT"&&!a)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(b)}finally{h.dispose()}}createUniversalWatcher(i,o,a){return new m.UniversalWatcherClient(r=>i(r),r=>o(r),a)}createNonRecursiveWatcher(i,o,a){return new u.NodeJSWatcherClient(r=>i(r),r=>o(r),a)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=f.FileSystemProviderErrorCode.NoPermissions;break;default:o=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let a=this.toFileSystemProviderError(o);if(i&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.toFilePath(i));r.mode&128||(a=(0,f.createFileSystemProviderError)(o,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return a}}e.DiskFileSystemProvider=t}),define(ie[93],re([0,1,3,7,9]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(p){this.service=p,this.onDidChangeLogLevel=D.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(p,y,g){switch(y){case"setLevel":return this.service.setLevel(g)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=T;class A{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){A.setLevel(this.channel,p)}static setLevel(p,y){return p.call("setLevel",y)}}e.LogLevelChannelClient=A;class I{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,y){throw new Error(`Event not found: ${y}`)}async call(p,y,g){switch(y){case"createLogger":this.createLogger(n.URI.revive(g[0]),g[1]);return;case"log":return this.log(n.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${y}`)}createLogger(p,y){this.loggers.set(p.toString(),this.loggerService.createLogger(p,y))}consoleLog(p,y){let g=console.log;switch(p){case k.LogLevel.Error:g=console.error;break;case k.LogLevel.Warning:g=console.warn;break;case k.LogLevel.Info:g=console.info;break}g.call(console,...y)}log(p,y){const g=this.loggers.get(p.toString());if(!g)throw new Error("Create the logger before logging");for(const[v,f]of y)(0,k.log)(g,v,f)}}e.LoggerChannel=I;class E extends k.AbstractLoggerService{constructor(p,y,g){super(p,y);this.channel=g}createConsoleMainLogger(){return new k.AdapterLogger({log:(p,y)=>{this.channel.call("consoleLog",[p,y])}})}doCreateLogger(p,y,g){return new C(this.channel,p,y,g)}}e.LoggerChannelClient=E;class C extends k.AbstractMessageLogger{constructor(p,y,g,v){super(v?.always);this.channel=p,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,y){const g=[[p,y]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(p){this.channel.call("log",[this.file,p])}}class R extends k.LogService{constructor(p,y){super(y);this.parent=p,this._register(p.onDidChangeLogLevel(g=>y.setLevel(g)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=R}),define(ie[62],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ie[94],re([0,1,19,4,34,20,85]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const E=n.globals.vscode.context.configuration();if(E)I=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const E=(0,T.dirname)(D.FileAccess.asFileUri("",Q));I=Q.__$__nodeRequire((0,T.joinPath)(E,"product.json").fsPath);const C=Q.__$__nodeRequire((0,T.joinPath)(E,"package.json").fsPath);try{const v=(...w)=>w.reduce((m,u)=>(Object.keys(u).forEach(t=>{Array.isArray(m[t])&&Array.isArray(u[t])?m[t]=u[t]:typeof m[t]=="object"&&typeof u[t]=="object"?m[t]=v(m[t],u[t]):m[t]=u[t]}),m),{}),f=(0,A.getUserDataPath)({}),d=n.isWindows?`file:///${f}/product.json`:`file://${f}/product.json`,S=Q.__$__nodeRequire(D.FileAccess.asFileUri(d,Q).fsPath);I=v(I,S)}catch{}k.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`,serverDataFolderName:I.serverDataFolderName?`${I.serverDataFolderName}-dev`:void 0});const{serviceUrl:R,cacheUrl:P,itemUrl:p,controlUrl:y,recommendationsUrl:g}=I.extensionsGallery||{};Object.assign(I,{extensionsGallery:{serviceUrl:k.env.VSCODE_GALLERY_SERVICE_URL||R,cacheUrl:k.env.VSCODE_GALLERY_CACHE_URL||P,itemUrl:k.env.VSCODE_GALLERY_ITEM_URL||p,controlUrl:k.env.VSCODE_GALLERY_CONTROL_URL||y,recommendationsUrl:k.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||g}}),Object.assign(I,{version:C.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=I}),define(ie[23],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[183],re([0,1,5,8,2,10,27,9,23]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends k.Disposable{constructor(P,p,y){super();this.productService=p,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,P&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(P)},30*1e3)).schedule()}async cleanUpCodeCaches(P){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),y=(0,T.dirname)(P),g=(0,T.basename)(P),v=await A.Promises.readdir(y);await Promise.all(v.map(async f=>{if(f===g)return;const d=(0,T.join)(y,f),S=await A.Promises.stat(d);if(S.isDirectory()&&p-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),A.Promises.rm(d)}))}catch(p){(0,n.onUnexpectedError)(p)}}};C=de([Y(1,E.IProductService),Y(2,I.ILogService)],C),e.CodeCacheCleaner=C}),define(ie[184],re([0,1,5,8,2,10,27,13,9,23]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends k.Disposable{constructor(p,y,g){super();this.environmentService=p,this.logService=y,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let S of Object.keys(y)){const w=y[S];p[`${w.hash}.${S}`]=!0}const g=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(g))return;const f=await A.Promises.readdir(g);for(const S of f){if(p[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await A.Promises.rm((0,T.join)(g,S))}const d=Date.now();for(const S of Object.keys(p)){const w=(0,T.join)(g,S),m=await A.Promises.readdir(w);for(const u of m){if(u==="tcf.json")continue;const t=(0,T.join)(w,u),c=await A.Promises.stat(t);c.isDirectory()&&d-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(S,u)}`),await A.Promises.rm(t))}}}catch(p){(0,n.onUnexpectedError)(p)}}};R=de([Y(0,I.INativeEnvironmentService),Y(1,E.ILogService),Y(2,C.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(ie[185],re([0,1,10,6]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(T){function A(I,E="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,D.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(C.callFrame.url))&&(C.callFrame.url=(0,D.join)(E,(0,D.basename)(C.callFrame.url)));return I}T.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(ie[186],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const I=await(await new Promise((C,R)=>{Q(["v8-inspect-profiler"],C,R)})).startProfiling({port:T.port,checkForPaused:!0}),E=(0,D.generateUuid)();return this._sessions.set(E,I),E}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const I=await A.stop();return this._sessions.delete(T),I.profile}}e.InspectProfilingService=n}),define(ie[38],re([0,1,106,15]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,I){D.ok(n.isString(A)),D.ok(n.isObject(I)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ie[95],re([0,1,3,38]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[k(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ie[42],re([0,1,17,3,15,132,18,95,38]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=E.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=this.doRegisterConfigurations(t,c);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const c=this.doDeregisterConfigurations(t);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=[];i.push(...this.doDeregisterConfigurations(c)),i.push(...this.doRegisterConfigurations(t,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(i)})}registerDefaultConfigurations(t){const c=[],i=[];for(const{overrides:o,source:a}of t)for(const r in o)if(c.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const s={...this.configurationDefaultsOverrides.get(r)?.value||{},...o[r]};this.configurationDefaultsOverrides.set(r,{source:a,value:s});const l=(0,A.getLanguageTagSettingPlainKey)(r),h={type:"object",default:s,description:T.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:k.isString(a)?void 0:a};i.push(...v(r)),this.configurationProperties[r]=h,this.defaultLanguageConfigurationOverridesNode.properties[r]=h}else{this.configurationDefaultsOverrides.set(r,{value:o[r],source:a});const s=this.configurationProperties[r];s&&(this.updatePropertyDefaultValue(r,s),this.updateSchema(r,s))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const c=[];for(const{overrides:i,source:o}of t)for(const a in i){const r=this.configurationDefaultsOverrides.get(a),s=k.isString(o)?o:o?.id,l=k.isString(r?.source)?r?.source:r?.source?.id;if(s===l)if(c.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const h=this.configurationProperties[a];h&&(this.updatePropertyDefaultValue(a,h),this.updateSchema(a,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const c of t)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,c){const i=[];return t.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,c,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(t){const c=[],i=o=>{if(o.properties)for(const a in o.properties)c.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,o.properties[a]);o.allOf&&o.allOf.forEach(a=>i(a))};for(const o of t){i(o);const a=this.configurationContributors.indexOf(o);a!==-1&&this.configurationContributors.splice(a,1)}return c}validateAndRegisterProperties(t,c=!0,i,o,a=3){a=k.isUndefinedOrNull(t.scope)?a:t.scope;let r=[],s=t.properties;if(s)for(let h in s){if(c&&w(h)){delete s[h];continue}const b=s[h];if(b.source=i,b.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,b),e.OVERRIDE_PROPERTY_REGEX.test(h)?b.scope=void 0:(b.scope=k.isUndefinedOrNull(b.scope)?a:b.scope,b.restricted=k.isUndefinedOrNull(b.restricted)?!!o?.includes(h):b.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h];!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),r.push(h)}let l=t.allOf;if(l)for(let h of l)r.push(...this.validateAndRegisterProperties(h,c,i,o,a));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const c=i=>{let o=i.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let a=i.allOf;a&&a.forEach(c)};c(t)}updateSchema(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.resourceLanguageSettingsSchema.properties[t]=c;break}}removeFromSchema(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const c=`[${t}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,c){const i=this.configurationDefaultsOverrides.get(t);let o=i?.value,a=i?.source;k.isUndefined(o)&&(o=c.defaultDefaultValue,a=void 0),k.isUndefined(o)&&(o=d(c.type)),c.default=o,c.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",g=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(u){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let c=g.exec(u);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=g.exec(u)}}return(0,D.distinct)(t)}e.overrideIdentifiersFromKey=v;function f(u){return u.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=f;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const S=new p;E.Registry.add(e.Extensions.Configuration,S);function w(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?T.localize(7,null,u):S.getConfigurationProperties()[u]!==void 0?T.localize(8,null,u):null:T.localize(6,null)}e.validateProperty=w;function m(){const u=[],t=S.getConfigurationProperties();for(const c of Object.keys(t))u.push([c,t[c].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=m}),define(ie[96],re([0,1,17,3,33,2,39,28,15,7,18,42,38]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},o=[],a=[]){this._contents=i,this._keys=o,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const a=this.getContentsForOverrideIdentifer(o);return a?i?(0,R.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const a of this.overrides)a.identifiers.includes(i)&&o.push(...a.keys);return D.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return D.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=I.deepClone(this.contents),a=I.deepClone(this.overrides),r=[...this.keys];for(const s of i){this.mergeContents(o,s.contents);for(const l of s.overrides){const[h]=a.filter(b=>D.equals(b.identifiers,l.identifiers));h?(this.mergeContents(h.contents,l.contents),h.keys.push(...l.keys),h.keys=D.distinct(h.keys)):a.push(I.deepClone(l))}for(const l of s.keys)r.indexOf(l)===-1&&r.push(l)}return new y(o,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let a={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r],l=o[r];l&&(typeof s=="object"&&typeof l=="object"?(s=I.deepClone(s),this.mergeContents(s,l)):s=l),a[r]=s}return new y(a,this.keys,this.overrides)}mergeContents(i,o){for(const a of Object.keys(o)){if(a in i&&E.isObject(i[a])&&E.isObject(o[a])){this.mergeContents(i[a],o[a]);continue}i[a]=I.deepClone(o[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,a=null;const r=s=>{s&&(a?this.mergeContents(a,s):a=I.deepClone(s))};for(const s of this.overrides)D.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(o),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,R.addToValueTree)(this.contents,i,o,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let a=0;a<o;a++)i.indexOf(this.keys[a])===0&&(o=a);this.keys.splice(o,1,i)}removeKey(i){let o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=y;class g extends y{constructor(i={}){const o=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(o),r=Object.create(null),s=[];for(const l in o){const h=i[l],b=h!==void 0?h:o[l].default;(0,R.addToValueTree)(r,l,b,_=>console.error(`Conflict in default settings: ${_}`))}for(const l of Object.keys(r))P.OVERRIDE_PROPERTY_REGEX.test(l)&&s.push({identifiers:(0,P.overrideIdentifiersFromKey)(l),keys:Object.keys(r[l]),contents:(0,R.toValuesTree)(r[l],h=>console.error(`Conflict in default settings file: ${h}`))});super(r,a,s)}}e.DefaultConfigurationModel=g;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!E.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:a,keys:r,overrides:s,restricted:l}=this.doParseRaw(i,o);this._configurationModel=new y(a,r,s),this._restrictedConfigurations=l||[]}doParseContent(i){let o={},a=null,r=[],s=[],l=[];function h(_){Array.isArray(r)?r.push(_):a!==null&&(r[a]=_)}let b={onObjectBegin:()=>{let _={};h(_),s.push(r),r=_,a=null},onObjectProperty:_=>{a=_},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{let _=[];h(_),s.push(r),r=_,a=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:h,onError:(_,U,N)=>{l.push({error:_,offset:U,length:N})}};if(i)try{k.visit(i,b),o=r[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return o}doParseRaw(i,o){const a=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,o);i=r.raw;const s=(0,R.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(i),h=this.toOverrides(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:s,keys:l,overrides:h,restricted:r.restricted}}filter(i,o,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const s={},l=[];for(let h in i)if(P.OVERRIDE_PROPERTY_REGEX.test(h)&&a){const b=this.filter(i[h],o,!1,r);s[h]=b.raw,l.push(...b.restricted)}else{const b=o[h],_=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(h),(_===void 0||r.scopes===void 0||r.scopes.includes(_))&&(r.skipRestricted&&b?.restricted||(s[h]=i[h]))}return{raw:s,restricted:l}}toOverrides(i,o){const a=[];for(const r of Object.keys(i))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const l in i[r])s[l]=i[r][l];a.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,o)})}return a}}e.ConfigurationModelParser=v;class f extends T.Disposable{constructor(i,o,a,r){super();this.userSettingsResource=i,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&a.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class d{constructor(i,o,a=new y,r=new y,s=new A.ResourceMap,l=new y,h=new A.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=s,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,o,a){return this.getConsolidateConfigurationModel(o,a).getValue(i)}updateValue(i,o,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new y,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(i):r.setValue(i,o),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,a){const r=this.getConsolidateConfigurationModel(o,a),s=this.getFolderConfigurationModelForResource(o.resource,a),l=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,h=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),N=a?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,L=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,F=o.overrideIdentifier?l.override(o.overrideIdentifier).getValue(i):l.getValue(i),O=r.getValue(i),W=D.distinct(D.flatten(r.overrides.map(H=>H.identifiers))).filter(H=>r.getOverrideValue(i,H)!==void 0);return{defaultValue:h,userValue:b,userLocalValue:_,userRemoteValue:U,workspaceValue:N,workspaceFolderValue:L,memoryValue:F,value:O,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:s?.freeze().getValue(i),override:o.overrideIdentifier?s?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(i),override:o.overrideIdentifier?l.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const a=[];if(!o){const{added:r,updated:s,removed:l}=u(this._defaultConfiguration,i);o=[...r,...s,...l]}for(const r of o)for(const s of(0,P.overrideIdentifiersFromKey)(r)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=i.getKeysForOverrideIdentifier(s),b=[...h.filter(_=>l.indexOf(_)===-1),...l.filter(_=>h.indexOf(_)===-1),...l.filter(_=>!I.equals(this._defaultConfiguration.override(s).getValue(_),i.override(s).getValue(_)))];a.push([s,b])}return this.updateDefaultConfiguration(i),{keys:o,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:a,removed:r,overrides:s}=u(this.localUserConfiguration,i),l=[...o,...a,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:a,removed:r,overrides:s}=u(this.remoteUserConfiguration,i);let l=[...o,...a,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:a,removed:r,overrides:s}=u(this.workspaceConfiguration,i);let l=[...o,...a,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const a=this.folderConfigurations.get(i),{added:r,updated:s,removed:l,overrides:h}=u(a,o);let b=[...r,...s,...l];return(b.length||!a)&&this.updateFolderConfiguration(i,o),{keys:b,overrides:h}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:s,overrides:l}=u(o,void 0);return{keys:[...a,...r,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,o){let a=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},o){let a=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const r=o.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const s=this._memoryConfigurationByResource.get(i);s&&(a=a.merge(s))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(o=a.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=a}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const a=o.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:a,overrides:r,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:a,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>o.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>o.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>o.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),s=i.folders.reduce((l,h)=>(l.set(C.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new A.ResourceMap);return new d(o,a,new y,r,s,new y,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=d;function S(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,o=new Map;for(const r of c)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,l])=>{const h=(0,A.getOrSet)(o,s,new Set);l.forEach(b=>h.add(b))});const a=[];return o.forEach((r,s)=>a.push([s,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=S;class w{constructor(i,o,a,r){this.change=i,this.previous=o,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(h=>s.add(h)),i.overrides.forEach(([,h])=>h.forEach(b=>s.add(b))),this.affectedKeys=[...s.values()];const l=new y;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!I.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let a=(0,R.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=w;class m extends w{constructor(i,o,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,o);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=m;function u(c,i){const{added:o,removed:a,updated:r}=t(i,c),s=[],l=c?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const b=h.filter(_=>!l.includes(_));for(const _ of b)s.push([_,i.getKeysForOverrideIdentifier(_)])}if(c){const b=l.filter(_=>!h.includes(_));for(const _ of b)s.push([_,c.getKeysForOverrideIdentifier(_)])}if(i&&c){for(const b of l)if(h.includes(b)){const _=t({contents:c.getOverrideValue(void 0,b)||{},keys:c.getKeysForOverrideIdentifier(b)},{contents:i.getOverrideValue(void 0,b)||{},keys:i.getKeysForOverrideIdentifier(b)});s.push([b,[..._.added,..._.removed,..._.updated]])}}return{added:o,removed:a,updated:r,overrides:s}}function t(c,i){const o=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],a=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const l=(0,R.getConfigurationValue)(i.contents,s),h=(0,R.getConfigurationValue)(c.contents,s);I.equals(l,h)||r.push(s)}}return{added:o,removed:a,updated:r}}}),define(ie[187],re([0,1,5,3,2,20,18,96,42,38]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends k.Disposable{constructor(p,y){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,y)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:g})=>this.onDidDefaultConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,y){const g=typeof p=="string"?p:void 0,v=(0,A.isConfigurationOverrides)(p)?p:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(g,v,void 0)}updateValue(p,y,g,v){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const y=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(g,y,1)}onDidDefaultConfigurationChange(p){const y=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,p);this.trigger(g,y,6)}trigger(p,y,g){const v=new I.ConfigurationChangeEvent(p,{data:y},this.configuration);v.source=g,v.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(ie[188],re([0,1,8,6]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends D.ErrorNoTelemetry{constructor(I,E=k.Unknown,C){super(I);this._message=I,this._code=E,this._detail=C,this.isHandled=E===k.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(I){return I instanceof T&&I._code===k.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof T&&I._code===k.NoResolverFound}static isHandled(I){return I instanceof T&&I.isHandled}}e.RemoteAuthorityResolverError=T}),define(ie[189],re([0,1,5,16,25,8,3,2,30,80,188]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var p;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function y(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(x){const K=new k.CancellationTokenSource;return setTimeout(()=>K.cancel(),x),K.token}function v(x,K){if(x.isCancellationRequested||K.isCancellationRequested)return k.CancellationToken.Cancelled;const Z=new k.CancellationTokenSource;return x.onCancellationRequested(()=>Z.cancel()),K.onCancellationRequested(()=>Z.cancel()),Z.token}class f{constructor(K){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((Z,X)=>{this._resolvePromise=Z,this._rejectPromise=X}),K.isCancellationRequested?this._timeout():this._disposables.add(K.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(K){this._state==="pending"?this._disposables.add(K):K.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const K=new Error("Time limit reached");return K.code="ETIMEDOUT",K.syscall="connect",K}resolve(K){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(K))}reject(K){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(K))}}function d(x,K){const Z=new f(K);return Z.registerDisposable(x.onControlMessage(X=>{const z=JSON.parse(X.toString()),M=te(z);M?Z.reject(M):Z.resolve(z)})),Z.promise}function S(x,K,Z,X,z,M,j){const B=new f(j);return K.connect(Z,X,z,M,(J,ne)=>{B.didTimeout?(J&&x.error(J),ne?.dispose()):J||!ne?B.reject(J):B.resolve(ne)}),B.promise}function w(x,K){const Z=new f(K);return x.then(X=>{Z.didTimeout||Z.resolve(X)},X=>{Z.didTimeout||Z.reject(X)}),Z.promise}async function m(x,K,Z,X){const z=q(x,K);x.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let M;try{M=await S(x.logService,x.socketFactory,x.host,x.port,`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,`renderer-${y(K)}-${x.reconnectionToken}`,X)}catch(ae){throw x.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),x.logService.error(ae),ae}x.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let j,B;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(M,null),j=x.reconnectionProtocol,B=!1):(j=new C.PersistentProtocol(M,null),B=!0),x.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const J=await w(x.signService.createNewMessage((0,E.generateUuid)()),X),ne={type:"auth",auth:x.connectionToken||"00000000000000000000",data:J.data};j.sendControl(n.VSBuffer.fromString(JSON.stringify(ne)));try{const ae=await d(j,v(X,g(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(x.logService.trace(`${z} 4/6. received SignRequest control message.`),!await w(x.signService.validate(J,ae.signedData),X)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const ve=await w(x.signService.sign(ae.data),X),we={type:"connectionType",commit:x.commit,signedData:ve,desiredConnectionType:K};return Z&&(we.args=Z),x.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),j.sendControl(n.VSBuffer.fromString(JSON.stringify(we))),{protocol:j,ownsProtocol:B}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(x.logService.error(`${z} the handshake timed out. Error:`),x.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${z} received error control message when negotiating connection. Error:`),x.logService.error(ae)),B&&H(j),ae}}async function u(x,K,Z,X){const z=Date.now(),M=q(x,K),{protocol:j,ownsProtocol:B}=await m(x,K,Z,X),J=new f(X);return J.registerDisposable(j.onControlMessage(ne=>{const ae=JSON.parse(ne.toString()),he=te(ae);he?(x.logService.error(`${M} received error control message when negotiating connection. Error:`),x.logService.error(he),B&&H(j),J.reject(he)):(x.reconnectionProtocol&&x.reconnectionProtocol.endAcceptReconnection(),x.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${V(z)}!`),J.resolve({protocol:j,firstMessage:ae}))})),J.promise}async function t(x,K){const{protocol:Z}=await u(x,1,void 0,K);return{protocol:Z}}async function c(x,K,Z){const{protocol:X,firstMessage:z}=await u(x,2,K,Z),M=z&&z.debugPort;return{protocol:X,debugPort:M}}async function i(x,K,Z){const X=Date.now(),z=q(x,3),{protocol:M}=await m(x,3,K,Z);return x.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${V(X)}!`),M}async function o(x,K,Z){const{host:X,port:z,connectionToken:M}=await x.addressProvider.getAddress();return{commit:x.commit,host:X,port:z,connectionToken:M,reconnectionToken:K,reconnectionProtocol:Z,socketFactory:x.socketFactory,signService:x.signService,logService:x.logService}}async function a(x,K,Z){try{const X=(0,E.generateUuid)(),z=await o(x,X,null),{protocol:M}=await t(z,k.CancellationToken.None);return new O(x,K,Z,X,M)}catch(X){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(X),F.triggerPermanentFailure(0,0,R.RemoteAuthorityResolverError.isHandled(X)),X}}e.connectRemoteAgentManagement=a;async function r(x,K){try{const Z=(0,E.generateUuid)(),X=await o(x,Z,null),{protocol:z,debugPort:M}=await c(X,K,k.CancellationToken.None);return new W(x,K,Z,z,M)}catch(Z){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(Z),F.triggerPermanentFailure(0,0,R.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=r;async function s(x,K,Z){const X=await o(x,(0,E.generateUuid)(),null);return await i(X,{host:K,port:Z},k.CancellationToken.None)}e.connectRemoteAgentTunnel=s;function l(x){return(0,D.createCancelablePromise)(K=>new Promise((Z,X)=>{const z=setTimeout(Z,x*1e3);K.onCancellationRequested(()=>{clearTimeout(z),Z()})}))}var h;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(h=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class b{constructor(K,Z){this.reconnectionToken=K,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=b;class _{constructor(K,Z,X,z){this.reconnectionToken=K,this.millisSinceLastIncomingData=Z,this.durationSeconds=X,this.cancellableTimer=z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class U{constructor(K,Z,X){this.reconnectionToken=K,this.millisSinceLastIncomingData=Z,this.attempt=X,this.type=2}}e.ReconnectionRunningEvent=U;class N{constructor(K,Z,X){this.reconnectionToken=K,this.millisSinceLastIncomingData=Z,this.attempt=X,this.type=4}}e.ConnectionGainEvent=N;class L{constructor(K,Z,X,z){this.reconnectionToken=K,this.millisSinceLastIncomingData=Z,this.attempt=X,this.handled=z,this.type=3}}e.ReconnectionPermanentFailureEvent=L;class F extends I.Disposable{constructor(K,Z,X,z,M){super();this._connectionType=K,this._options=Z,this.reconnectionToken=X,this.protocol=z,this._reconnectionFailureIsFatal=M,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(z.onSocketClose(j=>{const B=$(this._connectionType,this.reconnectionToken,!0);j?j.type===0?(this._options.logService.info(`${B} received socket close event (hadError: ${j.hadError}).`),j.error&&this._options.logService.error(j.error)):(this._options.logService.info(`${B} received socket close event (wasClean: ${j.wasClean}, code: ${j.code}, reason: ${j.reason}).`),j.event&&this._options.logService.error(j.event)):this._options.logService.info(`${B} received socket close event.`),this._beginReconnecting()})),this._register(z.onSocketTimeout(()=>{const j=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} received socket timeout event.`),this._beginReconnecting()})),F._instances.push(this),this._register((0,I.toDisposable)(()=>{const j=F._instances.indexOf(this);j>=0&&F._instances.splice(j,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}static triggerPermanentFailure(K,Z,X){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=K,this._permanentFailureAttempt=Z,this._permanentFailureHandled=X,this._instances.forEach(z=>z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(K=>K._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(K=>K._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||F._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const K=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${K} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new b(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const z=X<Z.length?Z[X]:Z[Z.length-1];try{if(z>0){const j=l(z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,j)),this._options.logService.info(`${K} waiting for ${z} seconds before reconnecting...`);try{await j}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${K} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this._options.logService.info(`${K} resolving connection...`);const M=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${K} connecting to ${M.host}:${M.port}...`),await this._reconnect(M,g(P)),this._options.logService.info(`${K} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(M){if(M.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${K} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(M),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this._options.logService.error(`${K} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(M),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(R.RemoteAuthorityResolverError.isTemporarilyNotAvailable(M)){this._options.logService.info(`${K} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(M);continue}if((M.code==="ETIMEDOUT"||M.code==="ENETUNREACH"||M.code==="ECONNREFUSED"||M.code==="ECONNRESET")&&M.syscall==="connect"){this._options.logService.info(`${K} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(M);continue}if((0,T.isCancellationError)(M)){this._options.logService.info(`${K} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(M);continue}if(M instanceof R.RemoteAuthorityResolverError){this._options.logService.error(`${K} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(M),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,R.RemoteAuthorityResolverError.isHandled(M));break}this._options.logService.error(`${K} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(M),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(K,Z,X){this._reconnectionFailureIsFatal?F.triggerPermanentFailure(K,Z,X):this._gotoPermanentFailure(K,Z,X)}_gotoPermanentFailure(K,Z,X){this._onDidStateChange.fire(new L(this.reconnectionToken,K,Z,X)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=F,F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class O extends F{constructor(K,Z,X,z,M){super(1,K,z,M,!0);this.client=this._register(new C.Client(M,{remoteAuthority:Z,clientId:X},K.ipcLogger))}async _reconnect(K,Z){await t(K,Z)}}e.ManagementPersistentConnection=O;class W extends F{constructor(K,Z,X,z,M){super(2,K,X,z,!1);this._startArguments=Z,this.debugPort=M}async _reconnect(K,Z){await c(K,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=W;function H(x){try{x.acceptDisconnect();const K=x.getSocket();x.dispose(),K.dispose()}catch(K){(0,T.onUnexpectedError)(K)}}function te(x){if(x&&x.type==="error"){const K=new Error(`Connection error: ${x.reason}`);return K.code="VSCODE_CONNECTION_ERROR",K}return null}function G(x,K){for(;x.length<K;)x+=" ";return x}function $(x,K,Z){return`[remote-connection][${G(y(x),13)}][${K.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function q(x,K){return`${$(K,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.host}:${x.port}]`}function V(x){return`${Date.now()-x} ms`}}),define(ie[190],re([0,1,19]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(T){return T.scheme===D.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=n;function k(T){if(!T)return;const A=T.indexOf("+");return A<0?T:T.substr(0,A)}e.getRemoteName=k}),define(ie[63],re([0,1,26,6,190]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=T;function A(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var E;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,v){if(typeof g=="undefined"||g===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof g=="string"||typeof v=="string"){let f=typeof g=="string"?g:g.value,d=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(f,d)}return g._lower===v._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function R(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function P(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function p(y,g){if(g){const v=`onResolveRemoteAuthority:${(0,k.getRemoteName)(g)}`;return y.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[31],re([0,1,26,29,63,4,7,8,34]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,D.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{constructor(o,a,r="undefined"){this.version=a,this.targetPlatform=r,this.id=o.id}static create(o){const a=o.manifest?o.manifest.version:o.version,r=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new P(o.identifier,a,r)}static parse(o){const a=R.exec(o);return a&&a[1]&&a[2]?new P({id:a[1]},a[2],a[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof P?C(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=P;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const o=p.exec(i);return o&&o[1]?[v(o[1]),o[2]]:[v(i),void 0]}e.getIdAndVersion=y;function g(i,o){return`${i}.${o}`}e.getExtensionId=g;function v(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function f(i,o){return v(g(i,o))}e.getGalleryExtensionId=f;function d(i,o){const a=[],r=s=>{for(const l of a)if(l.some(h=>C(o(h),o(s))))return l;return null};for(const s of i){const l=r(s);l?l.push(s):a.push([s])}return a}e.groupByExtension=d;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function w(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function m(i){const o=new Set;if(i.malicious)for(const a of i.malicious)o.add(a.id);return o}e.getMaliciousExtensionsSet=m;function u(i,o){const a=[],r=o.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const s=r.shift();if(s&&a.every(l=>!C(l.identifier,{id:s}))){const l=i.filter(h=>C(h.identifier,{id:s}));l.length===1&&(a.push(l[0]),r.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=u;async function t(i,o){if(!T.isLinux)return!1;let a;try{a=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){o.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(s))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function c(i,o){const a=await t(i,o),r=(0,n.getTargetPlatform)(a?"alpine":T.platform,E.arch);return o.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=c}),define(ie[64],re([0,1,17,5,28,16,8,33,128,2,19,10,4,20,51,76,15,7,137,13,31,63,60,14,6,9,23,3,77]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u,t,c,i,o,a,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var l;(function(F){function O(W,H){if(W===H)return!0;let te=Object.keys(W),G=new Set;for(let $ of Object.keys(H))G.add($);if(te.length!==G.size)return!1;for(let $ of te){if(W[$]!==H[$])return!1;G.delete($)}return G.size===0}F.equals=O})(l=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let h=class extends C.Disposable{constructor(O,W,H,te,G,$,q,V){super();this.systemExtensionsLocation=O,this.userExtensionsLocation=W,this.extensionsControlLocation=H,this.cacheLocation=te,this.fileService=G,this.logService=$,this.environmentService=q,this.productService=V,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new U((0,y.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new U((0,y.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new _(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,m.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(O){const[W,H,te]=await Promise.all([this.scanSystemExtensions(O),this.scanUserExtensions(O),this.scanExtensionsUnderDevelopment(O)]);return this.dedupExtensions([...W,...H,...te],await this.getTargetPlatform(),!0)}async scanSystemExtensions(O){const W=[];W.push(this.scanDefaultSystemExtensions(!!O.useCache,O.language)),W.push(this.scanDevSystemExtensions(O.language,!!O.checkControlFile));const[H,te]=await Promise.all(W);return this.applyScanOptions([...H,...te],O,!1)}async scanUserExtensions(O){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!O.includeUninstalled,O.language);let te=await(O.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return te=await this.applyScanOptions(te,O,!0),this.logService.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(O){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const W=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(H=>H.scheme===R.Schemas.file).map(async H=>this.extensionsScanner.scanOneOrMultipleExtensions(await this.createExtensionScannerInput(H,1,!0,O.language))))).flat();return this.applyScanOptions(W,O,!0)}return[]}async scanExistingExtension(O,W,H){const te=await this.createExtensionScannerInput(O,W,!0,H.language),G=await this.extensionsScanner.scanExtension(te);return!G||!H.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(O,W,H){const te=await this.createExtensionScannerInput(O,W,!0,H.language),G=await this.extensionsScanner.scanOneOrMultipleExtensions(te);return this.applyScanOptions(G,H,!0)}async updateMetadata(O,W){const H=(0,y.joinPath)(O,"package.json"),te=(await this.fileService.readFile(H)).value.toString(),G=JSON.parse(te);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,G.__metadata={...G.__metadata,...W},await this.fileService.writeFile((0,y.joinPath)(O,"package.json"),T.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async applyScanOptions(O,W,H){return W.includeAllVersions||(O=this.dedupExtensions(O,await this.getTargetPlatform(),H)),W.includeInvalid||(O=O.filter(te=>te.isValid)),O.sort((te,G)=>{const $=P.basename(te.location.fsPath),q=P.basename(G.location.fsPath);return $<q?-1:$>q?1:0})}dedupExtensions(O,W,H){const te=new Map;for(const G of O){const $=u.ExtensionIdentifier.toKey(G.identifier.id),q=te.get($);if(q){if(q.isValid&&!G.isValid)continue;if(q.isValid===G.isValid){if(H&&g.gt(q.manifest.version,G.manifest.version)){this.logService.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version}.`);continue}if(g.eq(q.manifest.version,G.manifest.version)&&q.targetPlatform===W){this.logService.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`);continue}}q.type===0?this.logService.debug(`Overwriting system extension ${q.location.path} with ${G.location.path}.`):this.logService.warn(`Overwriting user extension ${q.location.path} with ${G.location.path}.`)}te.set($,G)}return[...te.values()]}async scanDefaultSystemExtensions(O,W){this.logService.trace("Started scanning system extensions");const H=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,W),G=await(O&&!H.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(H);return this.logService.trace("Scanned system extensions:",G.length),G}async scanDevSystemExtensions(O,W){const H=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!H?.length)return[];this.logService.trace("Started scanning dev system extensions");const te=W?await this.getBuiltInExtensionControl():{},G=[],$=d.URI.file(P.normalize(P.join(R.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of H){const x=te[V.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":G.push((0,y.joinPath)($,V.name));break;default:G.push(d.URI.file(x));break}}const q=await Promise.all(G.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,0,!0,O))));return this.logService.trace("Scanned dev system extensions:",q.length),(0,D.coalesce)(q)}async getBuiltInExtensionControl(){try{const O=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(O.value.toString())}catch{return{}}}async createExtensionScannerInput(O,W,H,te){const G=await this.getTranslations(te??p.language);let $;try{const q=await this.fileService.stat(O);typeof q.mtime=="number"&&($=q.mtime)}catch{}return new b(O,$,W,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,G)}};h=de([Y(4,c.IFileService),Y(5,o.ILogService),Y(6,w.IEnvironmentService),Y(7,a.IProductService)],h),e.AbstractExtensionsScannerService=h;class b{constructor(O,W,H,te,G,$,q,V,x,K){this.location=O,this.mtime=W,this.type=H,this.excludeObsolete=te,this.productVersion=G,this.productDate=$,this.productCommit=q,this.devMode=V,this.language=x,this.translations=K}static createNlsConfiguration(O){return{language:O.language,pseudo:O.language==="pseudo",devMode:O.devMode,translations:O.translations}}static equals(O,W){return(0,y.isEqual)(O.location,W.location)&&O.mtime===W.mtime&&O.type===W.type&&O.excludeObsolete===W.excludeObsolete&&O.productVersion===W.productVersion&&O.productDate===W.productDate&&O.productCommit===W.productCommit&&O.devMode===W.devMode&&O.language===W.language&&l.equals(O.translations,W.translations)}}class _ extends C.Disposable{constructor(O,W){super();this.fileService=O,this.logService=W}async scanExtensions(O){const W=await this.fileService.resolve(O.location);if(W.children){let H={};if(O.excludeObsolete&&O.type===1)try{const G=(await this.fileService.readFile((0,y.joinPath)(O.location,".obsolete"))).value.toString();H=JSON.parse(G)}catch{}const te=await Promise.all(W.children.map(async G=>{if(!G.isDirectory||O.type===1&&(0,y.basename)(G.resource).indexOf(".")===0)return null;const $=new b(G.resource,O.mtime,O.type,O.excludeObsolete,O.productVersion,O.productDate,O.productCommit,O.devMode,O.language,O.translations),q=await this.scanExtension($);return q&&!H[m.ExtensionKey.create(q).toString()]?q:null}));return(0,D.coalesce)(te)}return[]}async scanOneOrMultipleExtensions(O){try{if(await this.fileService.exists((0,y.joinPath)(O.location,"package.json"))){const W=await this.scanExtension(O);return W?[W]:[]}else return await this.scanExtensions(O)}catch(W){return this.logService.error(`Error scanning extensions at ${O.location.path}:`,(0,A.getErrorMessage)(W)),[]}}async scanExtension(O){try{let W=await this.scanExtensionManifest(O.location);if(W){W.publisher||(W.publisher=u.UNDEFINED_PUBLISHER);const H=W.__metadata;delete W.__metadata;const te=(0,m.getGalleryExtensionId)(W.publisher,W.name),G=H?.id?{id:te,uuid:H.id}:{id:te},$=H?.isSystem?0:O.type,q=$===0||!!H?.isBuiltin,V=(0,t.validateExtensionManifest)(O.productVersion,O.productDate,O.location,W,q);let x=!0;for(const[K,Z]of V)K===v.default.Error&&(x=!1,this.logService.error(this.formatMessage(O.location,Z)));return W=await this.translateManifest(O.location,W,b.createNlsConfiguration(O)),{type:$,identifier:G,manifest:W,location:O.location,isBuiltin:q,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:x,validations:V}}}catch(W){O.type!==0&&this.logService.error(W)}return null}async scanExtensionManifest(O){const W=(0,y.joinPath)(O,"package.json");let H;try{H=(await this.fileService.readFile(W)).value.toString()}catch(G){return(0,c.toFileOperationResult)(G)!==1&&this.logService.error(this.formatMessage(O,(0,S.localize)(0,null,W.path,G.message))),null}let te;try{te=JSON.parse(H)}catch{const $=[];(0,I.parse)(H,$);for(const q of $)this.logService.error(this.formatMessage(O,(0,S.localize)(1,null,W.path,q.offset,q.length,(0,E.getParseErrorMessage)(q.error))));return null}return(0,I.getNodeType)(te)!=="object"?(this.logService.error(this.formatMessage(O,(0,S.localize)(2,null,W.path))),null):te}async translateManifest(O,W,H){const te=await this.getLocalizedMessages(O,W,H);if(te)try{const G=[],$=await this.resolveOriginalMessageBundle(te.default,G);if(G.length>0)return G.forEach(V=>{this.logService.error(this.formatMessage(O,(0,S.localize)(3,null,te.default?.path,(0,E.getParseErrorMessage)(V.error))))}),W;if((0,I.getNodeType)(te)!=="object")return this.logService.error(this.formatMessage(O,(0,S.localize)(4,null,te.default?.path))),W;const q=te.values||Object.create(null);this.replaceNLStrings(H.pseudo,W,q,$,O)}catch{}return W}async getLocalizedMessages(O,W,H){const te=(0,y.joinPath)(O,"package.nls.json"),G=(x,K)=>{K.forEach(Z=>{this.logService.error(this.formatMessage(O,(0,S.localize)(5,null,x?.path,(0,E.getParseErrorMessage)(Z.error))))})},$=x=>{this.logService.error(this.formatMessage(O,(0,S.localize)(6,null,x?.path)))},q=`${W.publisher}.${W.name}`,V=H.translations[q];if(V)try{const x=d.URI.file(V),K=(await this.fileService.readFile(x)).value.toString();let Z=[],X=(0,I.parse)(K,Z);return Z.length>0?(G(x,Z),{values:void 0,default:te}):(0,I.getNodeType)(X)!=="object"?($(x),{values:void 0,default:te}):{values:X.contents?X.contents.package:void 0,default:te}}catch{return{values:void 0,default:te}}else{if(!await this.fileService.exists(te))return;let K;try{K=await this.findMessageBundles(O,H)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const Z=(await this.fileService.readFile(K.localized)).value.toString();let X=[],z=(0,I.parse)(Z,X);return X.length>0?(G(K.localized,X),{values:void 0,default:K.original}):(0,I.getNodeType)(z)!=="object"?($(K.localized),{values:void 0,default:K.original}):{values:z,default:K.original}}catch{return{values:void 0,default:K.original}}}}async resolveOriginalMessageBundle(O,W){if(O)try{const H=(await this.fileService.readFile(O)).value.toString();return(0,I.parse)(H,W)}catch{return null}else return null}findMessageBundles(O,W){return new Promise((H,te)=>{const G=$=>{let q=(0,y.joinPath)(O,`package.nls.${$}.json`);this.fileService.exists(q).then(V=>{V&&H({localized:q,original:(0,y.joinPath)(O,"package.nls.json")});let x=$.lastIndexOf("-");x===-1?H({localized:(0,y.joinPath)(O,"package.nls.json"),original:null}):($=$.substring(0,x),G($))})};if(W.devMode||W.pseudo||!W.language)return H({localized:(0,y.joinPath)(O,"package.nls.json"),original:null});G(W.language)})}replaceNLStrings(O,W,H,te,G){const $=(q,V,x)=>{const K=q[V];if((0,f.isString)(K)){const Z=K,X=Z.length;if(X>1&&Z[0]==="%"&&Z[X-1]==="%"){const z=Z.substr(1,X-2);let M=H[z];M===void 0&&te&&(M=te[z]);let j=typeof M=="string"?M:typeof M?.message=="string"?M.message:void 0;j!==void 0?(O&&(j="\uFF3B"+j.replace(/[aouei]/g,"$&$&")+"\uFF3D"),q[V]=x&&(V==="title"||V==="category")&&te?{value:j,original:te[z]}:j):this.logService.warn(this.formatMessage(G,(0,S.localize)(7,null,z)))}}else if((0,f.isObject)(K))for(let Z in K)K.hasOwnProperty(Z)&&(Z==="commands"?$(K,Z,!0):$(K,Z,x));else if((0,f.isArray)(K))for(let Z=0;Z<K.length;Z++)$(K,Z,x)};for(let q in W)W.hasOwnProperty(q)&&$(W,q)}formatMessage(O,W){return`[${O.path}]: ${W}`}}class U extends _{constructor(O,W,H){super(W,H);this.cacheFile=O,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(O){const W=await this.readExtensionCache();if(this.input=O,W&&W.input&&b.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(te=>(te.location=d.URI.revive(te.location),te));const H=await super.scanExtensions(O);return await this.writeExtensionCache({input:O,result:H}),H}async readExtensionCache(){try{const O=await this.fileService.readFile(this.cacheFile),W=JSON.parse(O.value.toString());return{result:W.result,input:(0,s.revive)(W.input)}}catch(O){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(O))}return null}async writeExtensionCache(O){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(O)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const O=await this.readExtensionCache();if(!O)return;const W=O.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(H,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(te){this.logService.error(te)}}}function N(F,O){const W=(0,m.getExtensionId)(F.manifest.publisher,F.manifest.name);return{id:W,identifier:new u.ExtensionIdentifier(W),isBuiltin:F.type===0,isUserBuiltin:F.type===1&&F.isBuiltin,isUnderDevelopment:O,extensionLocation:F.location,uuid:F.identifier.uuid,targetPlatform:F.targetPlatform,...F.manifest}}e.toExtensionDescription=N;class L extends h{constructor(O,W,H,te,G,$,q,V){super(O,W,(0,y.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(te,u.MANIFEST_CACHE_FOLDER),G,$,q,V);this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const x=await this.fileService.readFile(d.URI.file(p.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(O){return this.translationsPromise}}e.NativeExtensionsScannerService=L}),define(ie[191],re([0,1,25,31]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(T,A,I,E,C){try{const R=await T.getExtensionsControlManifest();if(!R.unsupportedPreReleaseExtensions)return;const P=await T.getInstalled(1);for(const[p,{id:y,migrateStorage:g}]of Object.entries(R.unsupportedPreReleaseExtensions)){const v=P.find(d=>(0,n.areSameExtensions)(d.identifier,{id:p}));if(!v)continue;const f=(await A.getExtensions([{id:y,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!f){C.info(`Skipping migrating '${v.identifier.id}' extension because, the comaptible target '${y}' extension is not found`);continue}try{C.info(`Migrating '${v.identifier.id}' extension to '${y}' extension...`);const d=!E.getDisabledExtensions().some(w=>(0,n.areSameExtensions)(w,v.identifier));await T.uninstall(v),C.info(`Uninstalled the unsupported extension '${v.identifier.id}'`);let S=P.find(w=>(0,n.areSameExtensions)(w.identifier,{id:y}));(!S||!S.isPreReleaseVersion&&d)&&(S=await T.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:v.isMachineScoped,operation:4}),C.info(`Installed the pre-release extension '${S.identifier.id}'`),d||(await E.disableExtension(S.identifier),C.info(`Disabled the pre-release extension '${S.identifier.id}' because the unsupported extension '${v.identifier.id}' is disabled`)),g&&(I.addToMigrationList((0,n.getExtensionId)(v.manifest.publisher,v.manifest.name),(0,n.getExtensionId)(S.manifest.publisher,S.manifest.name)),C.info("Added pre-release extension to the storage migration list"))),C.info(`Migrated '${v.identifier.id}' extension to '${y}' extension.`)}catch(d){C.error(d)}}}catch(R){C.error(R)}}e.migrateUnsupportedExtensions=k}),define(ie[192],re([0,1,5,8,2,4,20,51,7,30,27,13,29,31,14,9]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends k.Disposable{constructor(S,w,m,u){super();this.fileService=w,this.extensionGalleryService=m,this.logService=u,this.extensionsDownloadDir=E.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,w){await this.cleanUpPromise;const m=this.getName(S),u=(0,A.joinPath)(this.extensionsDownloadDir,m);if(!await this.fileService.exists(u)){const t=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(S,t,w);try{await this.rename(t,u,Date.now()+2*60*1e3)}catch(c){try{await this.fileService.del(t)}catch{}if(c.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(c)}. Deleted the vsix from downloaded location`,t.path),c}}return u}async delete(S){await this.cleanUpPromise,await this.fileService.del(S)}async rename(S,w,m){try{await R.Promises.rename(S.fsPath,w.fsPath)}catch(u){if(T.isWindows&&u&&u.code==="EPERM"&&Date.now()<m)return this.logService.info(`Failed renaming ${S} to ${w} with 'EPERM' error. Trying again...`),this.rename(S,w,m);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const w=[],m=[];for(const c of S.children){const i=y.ExtensionKey.parse(c.name);i&&m.push([i,c])}const u=(0,y.groupByExtension)(m,([c])=>c),t=[];for(const c of u)c.sort((i,o)=>I.rcompare(i[0].version,o[0].version)),w.push(...c.slice(1).map(i=>i[1].resource)),t.push(c[0][1]);t.sort((c,i)=>c.mtime-i.mtime),w.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(c=>c.resource)),await D.Promises.settled(w.map(c=>(this.logService.trace("Deleting vsix from cache",c.path),this.fileService.del(c))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?y.ExtensionKey.create(S).toString().toLowerCase():(0,C.generateUuid)()}};f=de([Y(0,P.INativeEnvironmentService),Y(1,g.IFileService),Y(2,p.IExtensionGalleryService),Y(3,v.ILogService)],f),e.ExtensionsDownloader=f}),define(ie[193],re([0,1,2,10,27,63]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(E,C){super();this.environmentService=E,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(C.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtensions(E){E.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ie[194],re([0,1,7,13,64,14,9,23]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends k.NativeExtensionsScannerService{constructor(R,P,p,y){super(D.URI.file(p.builtinExtensionsPath),D.URI.file(p.extensionsPath),p.userHome,D.URI.file(p.userDataPath),R,P,p,y)}};E=de([Y(0,T.IFileService),Y(1,A.ILogService),Y(2,n.INativeEnvironmentService),Y(3,I.IProductService)],E),e.ExtensionsScannerService=E}),define(ie[195],re([0,1,90,17,5,2,19,10,27,13,29,31,61,9]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let g=class extends T.Disposable{constructor(d,S,w){super();this.extensionManagementService=d,this.logService=w,this.cache=this._register(new v(S,w)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const d=await this.cache.getLanguagePacks(),S=["en",...Object.keys(d)];return(0,n.distinct)(S)}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const S=await this.cache.getLanguagePacks();Object.keys(S).some(w=>S[w]&&S[w].extensions.some(m=>(0,P.areSameExtensions)(m.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(S);return!(0,n.equals)(Object.keys(d),Object.keys(w))}};g=de([Y(0,R.IExtensionManagementService),Y(1,C.INativeEnvironmentService),Y(2,y.ILogService)],g),e.LocalizationsService=g;let v=class extends T.Disposable{constructor(d,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(S=>{Object.keys(S).forEach(w=>delete S[w]),this.createLanguagePacksFromExtensions(S,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...S){for(const w of S)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,w);Object.keys(d).forEach(w=>this.updateHash(d[w]))}createLanguagePacksFromExtension(d,S){const w=S.identifier,m=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const u of m)if(S.location.scheme===A.Schemas.file&&(0,p.isValidLocalization)(u)){let t=d[u.languageId];t||(t={hash:"",extensions:[],translations:{}},d[u.languageId]=t);let c=t.extensions.filter(i=>(0,P.areSameExtensions)(i.extensionIdentifier,w))[0];c?c.version=S.manifest.version:t.extensions.push({extensionIdentifier:w,version:S.manifest.version});for(const i of u.translations)t.translations[i.id]=(0,I.join)(S.location.fsPath,i.path)}}updateHash(d){if(d){const S=(0,D.createHash)("md5");for(const w of d.extensions)S.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);d.hash=S.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(S=d(w),w)).then(w=>{for(const u of Object.keys(w))w[u]||delete w[u];this.languagePacks=w,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),E.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>S,w=>this.logService.error(w))})}};v=de([Y(0,C.INativeEnvironmentService),Y(1,y.ILogService)],v)}),define(ie[196],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ie[197],re([0,1,124,18,9]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(I,E){this.configurationService=I,this.logService=E}async request(I,E){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const C=await(0,D.request)(I,E);return this.logService.trace("RequestService#request (browser) - success",I.url),C}catch(C){throw this.logService.error("RequestService#request (browser) - error",I.url,C),C}}async resolveProxy(I){}};T=de([Y(0,n.IConfigurationService),Y(1,k.ILogService)],T),e.RequestService=T}),define(ie[43],re([0,1,16,146,42,6,38]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function I(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=I;function E(v){return v.res.statusCode===204}async function C(v){return E(v)?null:(await(0,D.streamToBuffer)(v.stream)).toString()}e.asText=C;async function R(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);return C(v)}e.asTextOrError=R;async function P(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);if(E(v))return null;const d=(await(0,D.streamToBuffer)(v.stream)).toString();try{return JSON.parse(d)}catch(S){throw S.message+=`:
`+d,S}}e.asJson=P;function p(v){g(v)}e.updateProxyConfigurationsScope=p;let y;function g(v){const f=A.Registry.as(k.Extensions.Configuration),d=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[y],remove:d?[d]:[]})}g(2)}),define(ie[198],re([0,1,25,19,14,43]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(E,C){this.requestService=E,this.fileService=C}async download(E,C,R=D.CancellationToken.None){if(E.scheme===n.Schemas.file||E.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(E,C);return}const P={type:"GET",url:E.toString()},p=await this.requestService.request(P,R);if(p.res.statusCode===200)await this.fileService.writeFile(C,p.stream);else{const y=await(0,T.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${y}`)}}};A=de([Y(0,T.IRequestService),Y(1,k.IFileService)],A),e.DownloadService=A}),define(ie[199],re([0,1,17,25,69,2,20,160,14,9,23,43]),function(Q,e,D,n,k,T,A,I,E,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let p=class extends T.Disposable{constructor(g,v,f,d){super();this.fileService=g,this.productService=v,this.requestService=f,this.logService=d,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:S})=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(g){return this.getValidConfigBasedTips(g)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(g){const v=[];for(const[f,d]of this.allConfigBasedTips)if(!(d.configScheme&&d.configScheme!==g.scheme))try{const S=await this.fileService.readFile((0,A.joinPath)(g,f)),w=new Map;(0,k.forEach)(d.recommendations,({key:u,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const c of t.remotes)w.set(c,{extensionId:u,extensionName:t.name,configName:d.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled});else v.push({extensionId:u,extensionName:t.name,configName:d.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled})});const m=(0,I.getDomainsOfRemotes)(S.value.toString(),[...w.keys()]);for(const u of m){const t=w.get(u);t&&v.push(t)}}catch{}return v}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const g=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(g.res.statusCode!==200)return[];const v=await(0,P.asJson)(g);return v?v.workspaceRecommendations||[]:[]}catch(g){return this.logService.error(g),[]}}};p=de([Y(0,E.IFileService),Y(1,R.IProductService),Y(2,P.IRequestService),Y(3,C.ILogService)],p),e.ExtensionTipsService=p}),define(ie[97],re([0,1,74,6]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ie[200],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ie[201],re([0,1,81,5,25,3,2,19,30,9,97,200]),function(Q,e,D,n,k,T,A,I,E,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(v){this.logService=v,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const f=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${f})`);const d=(0,R.hash)(v);this.processeDisposables.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.doDisposeWorker(v));const S=new k.CancellationTokenSource;let w,m,u;this.processeDisposables.set(d,o=>{S.dispose(!0),w?.terminate(v,k.CancellationToken.None),m?.close(),u?.close(),this.processeDisposables.delete(d);const a=this.processResolvers.get(d);a&&(this.processResolvers.delete(d),a({reason:o}))}),w=await this.getOrCreateWebWorker(v);const t=new Promise(o=>{this.processResolvers.set(d,o)});if(S.token.isCancellationRequested)return t;const{port1:c,port2:i}=new MessageChannel;return m=c,u=i,await w.spawn(v,u,S.token),S.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${f})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[m])),t}getOrCreateWebWorker(v){let f=this.workers.get(v.process.moduleId);if(!f){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const d=new y(v.process.type,this.logService);f=d.init(),d.onDidProcessSelfTerminate(({configuration:S,reason:w})=>{this.doDisposeWorker(S,w)}),this.workers.set(v.process.moduleId,f)}return f}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,f){const d=this.processeDisposables.get((0,R.hash)(v));d&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),d(f))}};p=de([Y(0,C.ILogService)],p),e.SharedProcessWorkerService=p;class y extends A.Disposable{constructor(v,f){super();this.type=v,this.logService=f,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const v=new n.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return f.onerror=d=>{this.logService.error(`SharedProcess: worker error (${this.type})`,d.message)},f.onmessageerror=d=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,d)},f.onmessage=d=>{const{id:S,message:w,configuration:m,nonce:u}=d.data;switch(S){case P.SharedProcessWorkerMessages.Ready:v.complete(f);break;case P.SharedProcessWorkerMessages.Ack:if(u){const t=this.mapMessageNonceToPendingMessageResolve.get(u);t&&(this.mapMessageNonceToPendingMessageResolve.delete(u),t())}break;case P.SharedProcessWorkerMessages.SelfTerminated:m&&w&&this._onDidProcessSelfTerminate.fire({configuration:m,reason:JSON.parse(w)});break;case P.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,w);break;case P.SharedProcessWorkerMessages.Info:w&&this.logService.info(w);break;case P.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,w);break;case P.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,w);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,d)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async send(v,f,d){const S=await this.workerReady;if(!f.isCancellationRequested)return new Promise(w=>{const m=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(m,w);const u={...v,nonce:m};d?S.postMessage(u,[d]):S.postMessage(u),f.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(m)&&w()})})}spawn(v,f,d){const S={id:P.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(S,d,f)}terminate(v,f){const d={id:P.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(d,f)}}}),define(ie[202],re([0,1,55,19,159]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}de([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ie[203],re([0,1,45,10,147,25,37,8,4,30,130,158,5]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let g;async function v(d,S,w){return S["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(w)&&!S["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(w)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=p.Promises.withAsyncBody(async(m,u)=>{const t=new T.CancellationTokenSource,c=setTimeout(()=>{t.dispose(!0),u(new Error((0,k.localize)(0,null)))},y);try{m(await f(d,t.token))}catch(i){!(0,I.isCancellationError)(i)&&!t.token.isCancellationRequested?u(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(i)))):m({})}finally{clearTimeout(c),t.dispose()}})),g)}e.getResolvedShellEnv=v;async function f(d,S){const w=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",w);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",m);const u=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"(.*)"+u),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",c);const i=await(0,R.getSystemShell)(E.OS,c);return d.trace("getUnixShellEnvironment#shell",i),new Promise((o,a)=>{if(S.isCancellationRequested)return a((0,I.canceled)());const r=(0,n.basename)(i);let s,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(s=`& '${process.execPath}' ${h} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,l=["-Login","-Command"]):(s=`'${process.execPath}' ${h} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,r==="tcsh"?l=["-ic"]:l=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),s);const b=(0,D.spawn)(i,[...l,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});S.onCancellationRequested(()=>(b.kill(),a((0,I.canceled)()))),b.on("error",N=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(N)),a(N)});const _=[];b.stdout.on("data",N=>_.push(N));const U=[];b.stderr.on("data",N=>U.push(N)),b.on("close",(N,L)=>{const F=Buffer.concat(_).toString("utf8");d.trace("getUnixShellEnvironment#raw",F);const O=Buffer.concat(U).toString("utf8");if(O.trim()&&d.trace("getUnixShellEnvironment#stderr",O),N||L)return a(new Error((0,k.localize)(2,null,N,L)));const W=t.exec(F),H=W?W[1]:"{}";try{const te=JSON.parse(H);w?te.ELECTRON_RUN_AS_NODE=w:delete te.ELECTRON_RUN_AS_NODE,m?te.ELECTRON_NO_ATTACH_CONSOLE=m:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",te),o(te)}catch(te){d.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(te)),a(te)}})})}}),define(ie[98],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[204],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((k,T)=>Q(["vsda"],k,T))}async createNewMessage(k){try{const T=await this.vsda(),A=new T.validator;if(A){const I=String(D._nextId++);return this.validators.set(I,A),{id:I,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,T){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(k){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=D,D._nextId=1}),define(ie[21],re([0,1,5,3,2,181,15,82,6]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var R;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var p;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));class y extends k.Disposable{constructor(d={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,S){S===C?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:S,target:this.getKeyTargets(d)[S]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,S,w){return this.getStorage(S)?.get(d,w)}getBoolean(d,S,w){return this.getStorage(S)?.getBoolean(d,w)}getNumber(d,S,w){return this.getStorage(S)?.getNumber(d,w)}store(d,S,w,m){if((0,A.isUndefinedOrNull)(S)){this.remove(d,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,w,m),this.getStorage(w)?.set(d,S)})}remove(d,S){this.withPausedEmitters(()=>{this.updateKeyTarget(d,S,void 0),this.getStorage(S)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,S){const w=[],m=this.getKeyTargets(d);for(const u of Object.keys(m))m[u]===S&&w.push(u);return w}updateKeyTarget(d,S,w){const m=this.getKeyTargets(S);typeof w=="number"?m[d]!==w&&(m[d]=w,this.getStorage(S)?.set(C,JSON.stringify(m))):typeof m[d]=="number"&&(delete m[d],this.getStorage(S)?.set(C,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const S=this.get(C,d);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=R.NONE){this._onWillSaveState.fire({reason:d});const S=this.getStorage(0),w=this.getStorage(1);switch(d){case R.NONE:await D.Promises.settled([S?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([S?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve()]);break}}async logStorage(){const d=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return v(d,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class g extends y{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}e.InMemoryStorageService=g;async function v(f,d,S,w){const m=r=>{try{return JSON.parse(r)}catch{return r}},u=new Map,t=new Map;f.forEach((r,s)=>{u.set(s,r),t.set(s,m(r))});const c=new Map,i=new Map;d.forEach((r,s)=>{c.set(s,r),i.set(s,m(r))}),console.group(`Storage: Global (path: ${S})`);let o=[];u.forEach((r,s)=>{o.push({key:s,value:r})}),console.table(o),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${w})`);let a=[];c.forEach((r,s)=>{a.push({key:s,value:r})}),console.table(a),console.groupEnd(),console.log(i)}e.logStorage=v}),define(ie[205],re([0,1,3,2,15,29,31,21]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends n.Disposable{constructor(P,p){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(P)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(p.onDidInstallExtensions(y=>y.forEach(({local:g,operation:v})=>{g&&v===4&&this._removeFromDisabledExtensions(g.identifier)})))}async enableExtension(P,p){return this._removeFromDisabledExtensions(P)?(this._onDidChangeEnablement.fire({extensions:[P],source:p}),!0):!1}async disableExtension(P,p){return this._addToDisabledExtensions(P)?(this._onDidChangeEnablement.fire({extensions:[P],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(P){let p=this.getDisabledExtensions();return p.every(y=>!(0,A.areSameExtensions)(y,P))?(p.push(P),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(P){let p=this.getDisabledExtensions();for(let y=0;y<p.length;y++){const g=p[y];if((0,A.areSameExtensions)(g,P))return p.splice(y,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(P){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,P)}_getExtensions(P){return this.storageManger.get(P,0)}_setExtensions(P,p){this.storageManger.set(P,p,0)}};E=de([Y(0,I.IStorageService),Y(1,T.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class C extends n.Disposable{constructor(P){super();this.storageService=P,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(P.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(P,p){let y;return p===0?((0,k.isUndefinedOrNull)(this.storage[P])&&(this.storage[P]=this._get(P,p)),y=this.storage[P]):y=this._get(P,p),JSON.parse(y)}set(P,p,y){let g=JSON.stringify(p.map(({id:f,uuid:d})=>({id:f,uuid:d})));this._get(P,y)!==g&&(y===0&&(p.length?this.storage[P]=g:delete this.storage[P]),this._set(P,p.length?g:void 0,y))}onDidStorageChange(P){if(P.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[P.key])&&this._get(P.key,P.scope)!==this.storage[P.key]){const y=this.get(P.key,P.scope);delete this.storage[P.key];const g=this.get(P.key,P.scope),v=y.filter(d=>!g.some(S=>(0,A.areSameExtensions)(d,S))),f=g.filter(d=>!y.some(S=>(0,A.areSameExtensions)(S,d)));(v.length||f.length)&&this._onDidChange.fire([...v,...f])}}_get(P,p){return this.storageService.get(P,p,"[]")}_set(P,p,y){p?this.storageService.store(P,p,y,1):this.storageService.remove(P,y)}}e.StorageManager=C}),define(ie[65],re([0,1,6,3,2,21,31,23,17,9,15]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const P=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Je extends k.Disposable{constructor(g,v,f){super();this.storageService=g,this.productService=v,this.logService=f,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(g),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}static toKey(g){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const v=P.exec(g);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(g,v){const f=await g.getInstalled(),d=[];for(const[S,w]of Je.readAllExtensionsWithKeysForSync(v)){const m=f.find(u=>(0,A.areSameExtensions)(u.identifier,{id:S}))?.manifest.version;for(const u of w)m!==u&&d.push(Je.toKey({id:S,version:u}))}for(const S of d)v.remove(S,0)}static readAllExtensionsWithKeysForSync(g){const v=new Map,f=g.keys(0,1);for(const d of f){const S=Je.fromKey(d);if(S){let w=v.get(S.id.toLowerCase());w||v.set(S.id.toLowerCase(),w=[]),w.push(S.version)}}return v}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=Je.fromKey(g.key);if(v){if(this.storageService.get(g.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let f=this.extensionsWithKeysForSync.get(v.id.toLowerCase());f||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),f=[]),f.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(g){if((0,R.isString)(g))return g;const v=g.manifest?g.manifest.publisher:g.publisher,f=g.manifest?g.manifest.name:g.name;return(0,A.getExtensionId)(v,f)}getExtensionState(g,v){const f=this.getExtensionId(g),d=this.storageService.get(f,v?0:1);if(d)try{return JSON.parse(d)}catch(S){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${v}): ${S}`)}}setExtensionState(g,v,f){const d=this.getExtensionId(g);v===void 0?this.storageService.remove(d,f?0:1):this.storageService.store(d,JSON.stringify(v),f?0:1,1)}setKeysForSync(g,v){this.storageService.store(Je.toKey(g),JSON.stringify(v),0,1)}getKeysForSync(g){const v=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],f=this.storageService.get(Je.toKey(g),0),d=f?JSON.parse(f):void 0;return d&&v?(0,E.distinct)([...d,...v]):d||v}addToMigrationList(g,v){if(g!==v){const f=this.migrationList.filter(d=>!d.includes(g)&&!d.includes(v));f.push([g,v]),this.migrationList=f}}getSourceExtensionToMigrate(g){const v=this.migrationList.find(([,f])=>g===f);return v?v[0]:void 0}get migrationList(){const g=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const v=JSON.parse(g);if((0,R.isArray)(v))return v}catch{}return[]}set migrationList(g){g.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(g),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};p=de([Y(0,T.IStorageService),Y(1,I.IProductService),Y(2,C.ILogService)],p),e.ExtensionStorageService=p}),define(ie[206],re([0,1,2,29,65,191,9,21]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let E=class extends D.Disposable{constructor(R,P,p,y,g,v){super();R.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(R,P,p,y,v),k.ExtensionStorageService.removeOutdatedExtensionVersions(R,g)}};E=de([Y(0,n.IExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,k.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,I.IStorageService),Y(5,A.ILogService)],E),e.ExtensionsCleaner=E}),define(ie[207],re([0,1,3,2]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends n.Disposable{constructor(C,R){super();this.channel=C,this.workspace=R}async getItems(){const C={workspace:this.workspace},R=await this.channel.call("getItems",C);return new Map(R)}updateItems(C){const R={workspace:this.workspace};return C.insert&&(R.insert=Array.from(C.insert.entries())),C.delete&&(R.delete=Array.from(C.delete.values())),this.channel.call("updateItems",R)}}class T extends k{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class A extends k{constructor(C,R){super(C,R);this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}class I extends n.Disposable{constructor(C,R){super();this.channel=C,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=I}),define(ie[208],re([0,1,5,2,20,82,21,207]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends A.AbstractStorageService{constructor(R,P,p){super();this.mainProcessService=P,this.environmentService=p,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(R)}createGlobalStorage(){const R=new I.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),P=new T.Storage(R.globalStorage);return this._register(P.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),P}createWorkspaceStorage(R){const P=new I.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),R);if(P.workspaceStorage){const p=new T.Storage(P.workspaceStorage);return this.workspaceStorageDisposable.value=p.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=R?.id,p}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(R){return R===0?this.globalStorage:this.workspaceStorage}getLogDetails(R){return R===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(R){const P=this.workspaceStorage,p=P?.items??new Map;P&&(await P.close(),P.dispose()),this.workspaceStorage=this.createWorkspaceStorage(R),await this.workspaceStorage.init();for(const[y,g]of p)this.workspaceStorage.set(y,g)}}e.NativeStorageService=E}),define(ie[209],re([0,1,4,34,7,30]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(C){if(D.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function I(C,R,P,p,y,g,v,f,d,S){const w=Object.create(null);w["common.machineId"]=v,w.sessionID=(0,T.generateUuid)()+Date.now(),w.commitHash=y,w.version=g,w["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,D.PlatformToString)(D.platform),w["common.nodePlatform"]=n.platform,w["common.nodeArch"]=p,w["common.product"]=S||"desktop";const m=E(f||[]);m&&(w["common.msftInternal"]=m);let u=0;const t=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.isLinuxSnap&&(w["common.snap"]="true");const c=A(P);c&&(w["common.platformDetail"]=c);try{const i=await C.readFile(k.URI.file(d));w["common.source"]=i.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=I;function E(C){const R=n.env.USERDNSDOMAIN;if(!R)return!1;const P=R.toLowerCase();return C.some(p=>P===p)}e.verifyMicrosoftInternalDomain=E}),define(ie[22],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[210],re([0,1,35,56,5,33,19,10,4,7,117,27,120,87,14,23,22]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function S(c,i){const o=`${c}::${i.join(":")}`,a=d.get(o);if(a)return a;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],s=new Map,l=new Map,h=2e4;function b(U,N,L,F){const O=N.substring(U.length+1);return k.Promises.withAsyncBody(async W=>{let H;try{H=await P.Promises.readdir(N,{withFileTypes:!0})}catch{W();return}if(F.count>=h){F.count+=H.length,F.maxReached=!0,W();return}let te=H.length;if(te===0){W();return}let G=H;F.count+H.length>h&&(F.maxReached=!0,te=h-F.count,G=H.slice(0,te)),F.count+=H.length;for(const $ of G)if($.isDirectory()){if(L.includes($.name)||await b(U,(0,I.join)(N,$.name),L,F),--te==0){W();return}}else{const q=$.name.lastIndexOf(".");if(q>=0){const V=$.name.substring(q+1);V&&s.set(V,(s.get(V)??0)+1)}for(const V of r)V.relativePathPattern?.test(O)!==!1&&V.filePattern.test($.name)&&l.set(V.tag,(l.get(V.tag)??0)+1);if(--te==0){W();return}}})}const _=k.Promises.withAsyncBody(async U=>{const N={count:0,maxReached:!1};await b(c,c,i,N);const L=await u(c);U({configFiles:w(l),fileTypes:w(s),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:L})});return d.set(o,_),_}e.collectWorkspaceStats=S;function w(c){return[...n.Iterable.map(c.entries(),([i,o])=>({name:i,count:o}))].sort((i,o)=>o.count-i.count)}function m(){const c={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},i=D.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=m;async function u(c){try{const i=new Map,o=(0,I.join)(c,".vscode","launch.json"),a=await P.Promises.readFile(o),r=[],s=(0,T.parse)(a.toString(),r);if(r.length)return console.log(`Unable to parse ${o}`),[];if((0,T.getNodeType)(s)==="object"&&s.configurations)for(const l of s.configurations){const h=l.type;h&&(i.has(h)?i.set(h,i.get(h)+1):i.set(h,1))}return w(i)}catch{return[]}}e.collectLaunchConfigs=u;let t=class{constructor(i,o){this.telemetryService=i,this.productService=o}formatMachineInfo(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}formatEnvironment(i){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const a=D.cpus();return a&&a.length>0&&o.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),o.push(`Memory (System):  ${(D.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||o.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),o.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,p.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async a=>{let[r,s]=a,l=this.formatProcessList(i,r);return o.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,s+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(i,h.processes)}`),h.workspaceMetadata){s+=`
|  Remote: ${h.hostName}`;for(const b of Object.keys(h.workspaceMetadata)){const _=h.workspaceMetadata[b];let U=`${_.fileCount} files`;_.maxFilesReached&&(U=`more than ${U}`),s+=`|    Folder (${b}): ${U}`,s+=this.formatWorkspaceStats(_)}}}),{processInfo:l,workspaceInfo:s}})}async getSystemInfo(i,o){const{memory:a,vmHint:r,os:s,cpus:l}=m(),h={os:s,memory:a,cpus:l,vmHint:r,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return E.isWindows||(h.load=`${D.loadavg().map(b=>Math.round(b)).join(", ")}`),E.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(i,o){const a=[];return(0,p.listProcesses)(i.mainPID).then(async r=>(a.push(""),a.push(this.formatEnvironment(i)),a.push(""),a.push(this.formatProcessList(i,r)),i.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(i))),o.forEach(s=>{if((0,y.isRemoteDiagnosticError)(s))a.push(`
${s.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${s.hostName}`),a.push(this.formatMachineInfo(s.machineInfo)),s.processes&&a.push(this.formatProcessList(i,s.processes)),s.workspaceMetadata)for(const l of Object.keys(s.workspaceMetadata)){const h=s.workspaceMetadata[l];let b=`${h.fileCount} files`;h.maxFilesReached&&(b=`more than ${b}`),a.push(`Folder (${l}): ${b}`),a.push(this.formatWorkspaceStats(h))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(i){const o=[],a=60;let r=0;const s=(_,U)=>{const N=` ${_}(${U})`;r+N.length>a?(o.push(l),l="|                 ",r=l.length):r+=N.length,l+=N};let l="|      File types:";const h=10;let b=i.fileTypes.length>h?h:i.fileTypes.length;for(let _=0;_<b;_++){const U=i.fileTypes[_];s(U.name,U.count)}if(o.push(l),i.configFiles.length>=0&&(l="|      Conf files:",r=0,i.configFiles.forEach(_=>{s(_.name,_.count)}),o.push(l)),i.launchConfigFiles.length>0){let _="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{_+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),o.push(_)}return o.join(`
`)}expandGPUFeatures(i){const o=Math.max(...Object.keys(i).map(a=>a.length));return Object.keys(i).map(a=>`${a}:  ${" ".repeat(o-a.length)}  ${i[a]}`).join(`
                  `)}formatWorkspaceMetadata(i){const o=[],a=[];return i.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(o.push(`|  Window (${r.title})`),r.folderURIs.forEach(s=>{const l=C.URI.revive(s);if(l.scheme===A.Schemas.file){const h=l.fsPath;a.push(S(h,["node_modules",".git"]).then(b=>{let _=`${b.fileCount} files`;b.maxFilesReached&&(_=`more than ${_}`),o.push(`|    Folder (${(0,I.basename)(h)}): ${_}`),o.push(this.formatWorkspaceStats(b))}).catch(b=>{o.push(`|      Error: Unable to collect workspace stats for folder ${h} (${b.toString()})`)}))}else o.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(r=>o.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(i,o){const a=new Map;i.windows.forEach(s=>a.set(s.pid,s.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(i.mainPID,a,r,o,0),r.join(`
`)}formatProcessItem(i,o,a,r,s){const l=s===0;let h;l?h=r.pid===i?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(s)} ${r.name}`,r.name==="window"&&(h=`${h} (${o.get(r.pid)})`));const b=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);a.push(`${r.load.toFixed(0).padStart(5," ")}	${(b/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(r.children)&&r.children.forEach(_=>this.formatProcessItem(i,o,a,_,s+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:a}of i.folders){const r=C.URI.revive(a);if(r.scheme!==A.Schemas.file)continue;const s=r.fsPath;try{(await S(s,["node_modules",".git"])).fileTypes.forEach(h=>o.add(h.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const a=C.URI.revive(o);if(a.scheme!==A.Schemas.file)continue;const r=a.fsPath;try{const s=await S(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),s.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),s.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),s.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};t=de([Y(0,f.ITelemetryService),Y(1,v.IProductService)],t),e.DiagnosticsService=t}),define(ie[211],re([0,1,17,5,25,8,3,2,4,7,135,29,31,9,23,22]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends I.Disposable{constructor(t,c,i,o){super();this.galleryService=t,this.telemetryService=c,this.logService=i,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(a=>a.cancel()),this.uninstallingExtensions.forEach(a=>a.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const c=await this.getTargetPlatform();return t.allTargetPlatforms.some(i=>(0,P.isTargetPlatformCompatible)(i,t.allTargetPlatforms,c))}async installFromGallery(t,c={}){try{if(!this.galleryService.isEnabled())throw new P.ExtensionManagementError(R.localize(0,null),P.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(t,!c.installGivenVersion,!!c.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,c)}catch(i){throw w(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:i}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(i),S(i)}}async uninstall(t,c={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,c)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const c=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:c,compatible:!0},k.CancellationToken.None);if(!i)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,c,i){if(!C.URI.isUri(c)){let l=this.installingExtensions.get(p.ExtensionKey.create(c).toString());if(l)return this.logService.info("Extensions is already requested to install",c.identifier.id),l.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],a=[],r=this.createInstallExtensionTask(t,c,i);C.URI.isUri(c)||this.installingExtensions.set(p.ExtensionKey.create(c).toString(),r),this._onInstallExtension.fire({identifier:r.identifier,source:c}),this.logService.info("Installing extension:",r.identifier.id),o.push({task:r,manifest:t});let s=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",r.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(r.identifier,t,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:b,manifest:_}of h){s=s||!!_.extensionDependencies?.some(N=>(0,p.areSameExtensions)({id:N},r.identifier));const U=p.ExtensionKey.create(b).toString();if(this.installingExtensions.has(U))this.logService.info("Extension is already requested to install",b.identifier.id);else{const N=this.createInstallExtensionTask(_,b,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(U,N),this._onInstallExtension.fire({identifier:N.identifier,source:b}),this.logService.info("Installing extension:",N.identifier.id),o.push({task:N,manifest:_})}}}catch(h){if(C.URI.isUri(r.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",r.identifier.id,h.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",r.identifier.id,h.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",r.identifier.id),h}const l=o.reduce((h,{task:b,manifest:_})=>(h.set(b.identifier.id.toLowerCase(),{task:b,manifest:_}),h),new Map);for(;l.size;){let h;const b=[...l.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(U=>l.has(U.toLowerCase())));b.length?h=l.size===1?b:b.filter(({task:_})=>!(_===r&&!s)):(this.logService.info("Found extensions with circular dependencies",b.map(({task:_})=>_.identifier.id)),h=[...l.values()]),await this.joinAllSettled(h.map(async({task:_})=>{const U=new Date().getTime();try{const N=await _.run();if(await this.joinAllSettled(this.participants.map(L=>L.postInstall(N,_.source,i,k.CancellationToken.None))),!C.URI.isUri(_.source)){const L=_.operation===3;if(w(this.telemetryService,L?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(_.source),duration:new Date().getTime()-U,durationSinceUpdate:L?void 0:new Date().getTime()-_.source.lastUpdated}),E.isWeb&&_.operation!==3)try{await this.galleryService.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,"install")}catch{}}a.push({local:N,identifier:_.identifier,operation:_.operation,source:_.source})}catch(N){throw C.URI.isUri(_.source)||w(this.telemetryService,_.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(_.source),duration:new Date().getTime()-U,error:N}),this.logService.error("Error while installing the extension:",_.identifier.id),N}finally{l.delete(_.identifier.id.toLowerCase())}}))}return a.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(a),a.filter(({identifier:h})=>(0,p.areSameExtensions)(h,r.identifier))[0].local}catch(l){if(o.forEach(({task:h})=>h.cancel()),a.length)try{const h=await Promise.allSettled(a.map(({local:b})=>this.createUninstallExtensionTask(b,{versionOnly:!0}).run()));for(let b=0;b<h.length;b++){const _=h[b],{identifier:U}=a[b];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,T.getErrorMessage)(_.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(h),a.map(({identifier:b})=>b.id))}throw this._onDidInstallExtensions.fire(o.map(({task:h})=>({identifier:h.identifier,operation:2,source:h.source}))),l}finally{for(const{task:l}of o)if(!C.URI.isUri(l.source)){const h=p.ExtensionKey.create(l.source).toString();this.installingExtensions.delete(h)||this.logService.warn("Installation task is not found in the cache",h)}}}async joinAllSettled(t){const c=[],i=[],o=await Promise.allSettled(t);for(const a of o)a.status==="fulfilled"?c.push(a.value):i.push(a.reason);if(i.length)throw d(i);return c}async getAllDepsAndPackExtensionsToInstall(t,c,i,o){if(!this.galleryService.isEnabled())return[];let a=await this.getInstalled();const r=[t,...a.map(h=>h.identifier)],s=[],l=async(h,b)=>{const _=b.extensionDependencies||[],U=[..._];if(b.extensionPack){const N=i?a.find(L=>(0,p.areSameExtensions)(L.identifier,h)):void 0;for(const L of b.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(F=>(0,p.areSameExtensions)({id:F},{id:L}))||U.every(F=>!(0,p.areSameExtensions)({id:F},{id:L}))&&U.push(L)}if(U.length){const N=[...r,...s.map(F=>F.gallery.identifier)],L=U.filter(F=>N.every(O=>!(0,p.areSameExtensions)(O,{id:F})));if(L.length){const F=await this.galleryService.getExtensions(L.map(O=>({id:O,preRelease:o})),k.CancellationToken.None);for(const O of F){if(N.find(te=>(0,p.areSameExtensions)(te,O.identifier)))continue;const W=_.some(te=>(0,p.areSameExtensions)({id:te},O.identifier));let H;try{H=await this.checkAndGetCompatibleVersion(O,!0,o)}catch(te){if(te instanceof P.ExtensionManagementError&&te.code===P.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",O.identifier.id);continue}else throw te}s.push({gallery:H.extension,manifest:H.manifest}),await l(H.extension.identifier,H.manifest)}}}};return await l(t,c),a=await this.getInstalled(),s.filter(h=>!a.some(b=>(0,p.areSameExtensions)(b.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(t,c,i){const o=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(o).has(t.identifier.id))throw new P.ExtensionManagementError(R.localize(3,null,t.identifier.id),P.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[t.identifier.id])throw new P.ExtensionManagementError(R.localize(4,null,t.identifier.id,o.unsupportedPreReleaseExtensions[t.identifier.id].displayName),P.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(t)){const s=await this.getTargetPlatform();throw new P.ExtensionManagementError(R.localize(5,null,t.identifier.id,this.productService.nameLong,(0,P.TargetPlatformToString)(s)),P.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,c,i);if(a){if(i&&c&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new P.ExtensionManagementError(R.localize(6,null,t.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new P.ExtensionManagementError(R.localize(7,null,t.identifier.id),P.ExtensionManagementErrorCode.ReleaseVersionNotFound):new P.ExtensionManagementError(R.localize(8,null,t.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const r=await this.galleryService.getManifest(a,k.CancellationToken.None);if(r===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,P.ExtensionManagementErrorCode.Invalid);if(r.version!==a.version)throw new P.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,P.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:r}}async getCompatibleVersion(t,c,i){const o=await this.getTargetPlatform();let a=null;return c&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==i&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:i}],{targetPlatform:o,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,i,o)&&(a=t),!a&&c&&(a=await this.galleryService.getCompatibleExtension(t,i,o)),a}async unininstallExtension(t,c){const i=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),i.waitUntilTaskIsFinished();const o=(l,h)=>{const b=this.createUninstallExtensionTask(l,h);return this.uninstallingExtensions.set(b.extension.identifier.id.toLowerCase(),b),this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier),b},a=(l,h)=>{h?this.logService.error("Failed to uninstall extension:",l.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",l.identifier.id),w(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(l),error:h}),this._onDidUninstallExtension.fire({identifier:l.identifier,error:h?.code})},r=[],s=[];try{r.push(o(t,{}));const l=await this.getInstalled(1);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const h=this.getAllPackExtensionsToUninstall(t,l);for(const b of h)this.uninstallingExtensions.has(b.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",b.identifier.id):r.push(o(b,{}))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(r.map(h=>h.extension),l,t),await this.joinAllSettled(r.map(async h=>{try{if(await h.run(),await this.joinAllSettled(this.participants.map(b=>b.postUninstall(h.extension,c,k.CancellationToken.None))),h.extension.identifier.uuid)try{await this.galleryService.reportStatistic(h.extension.manifest.publisher,h.extension.manifest.name,h.extension.manifest.version,"uninstall")}catch{}a(h.extension)}catch(b){const _=b instanceof P.ExtensionManagementError?b:new P.ExtensionManagementError((0,T.getErrorMessage)(b),P.ExtensionManagementErrorCode.Internal);throw a(h.extension,_),_}finally{s.push(h)}}))}catch(l){const h=l instanceof P.ExtensionManagementError?l:new P.ExtensionManagementError((0,T.getErrorMessage)(l),P.ExtensionManagementErrorCode.Internal);for(const b of r){try{b.cancel()}catch{}s.includes(b)||a(b.extension,h)}throw h}finally{for(const l of r)this.uninstallingExtensions.delete(l.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",l.extension.identifier.id)}}checkForDependents(t,c,i){for(const o of t){const a=this.getDependents(o,c);if(a.length){const r=a.filter(s=>!t.some(l=>(0,p.areSameExtensions)(l.identifier,s.identifier)));if(r.length)throw new Error(this.getDependentsErrorMessage(o,r,i))}}}getDependentsErrorMessage(t,c,i){return i===t?c.length===1?R.localize(9,null,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?R.localize(10,null,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):R.localize(11,null,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?R.localize(12,null,i.manifest.displayName||i.manifest.name,t.manifest.displayName||t.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?R.localize(13,null,i.manifest.displayName||i.manifest.name,t.manifest.displayName||t.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):R.localize(14,null,i.manifest.displayName||i.manifest.name,t.manifest.displayName||t.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}getAllPackExtensionsToUninstall(t,c,i=[]){if(i.indexOf(t)!==-1)return[];i.push(t);const o=t.manifest.extensionPack?t.manifest.extensionPack:[];if(o.length){const a=c.filter(s=>!s.isBuiltin&&o.some(l=>(0,p.areSameExtensions)({id:l},s.identifier))),r=[];for(const s of a)r.push(...this.getAllPackExtensionsToUninstall(s,c,i));return[...a,...r]}return[]}getDependents(t,c){return c.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(o=>(0,p.areSameExtensions)({id:o},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=de([Y(0,P.IExtensionGalleryService),Y(1,v.ITelemetryService),Y(2,y.ILogService),Y(3,g.IProductService)],f),e.AbstractExtensionManagementService=f;function d(u){const t=Array.isArray(u)?u:[u];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((c,i)=>new Error(`${c.message}${c.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=d;function S(u){if(u instanceof P.ExtensionManagementError)return u;const t=new P.ExtensionManagementError(u.message,P.ExtensionManagementErrorCode.Internal);return t.stack=u.stack,t}function w(u,t,{extensionData:c,duration:i,error:o,durationSinceUpdate:a}){const r=o?o instanceof P.ExtensionManagementError?o.code:P.ExtensionManagementErrorCode.Internal:void 0;u.publicLog(t,{...c,success:!o,duration:i,errorcode:r,durationSinceUpdate:a})}e.reportTelemetry=w;class m{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((c,i)=>{const o=t.onCancellationRequested(()=>{o.dispose(),i(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=m}),define(ie[212],re([0,1,17,5,69,3,10,4,34,7,138,13,29,31,199,89,14,9,62,23,43,21,22]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const c="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let o=class extends g.ExtensionTipsService{constructor(r,s,l,h,b,_,U,N,L,F){super(U,N,L,F);this.environmentService=r,this.telemetryService=s,this.extensionManagementService=l,this.storageService=h,this.nativeHostService=b,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,N.exeBasedExtensionTips&&(0,k.forEach)(N.exeBasedExtensionTips,({key:O,value:W})=>{const H=[],te=[],G=[];(0,k.forEach)(W.recommendations,({key:$,value:q})=>{q.important?W.important?H.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):te.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):G.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),H.length&&this.highImportanceExecutableTips.set(O,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:H}),te.length&&this.mediumImportanceExecutableTips.set(O,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:te}),G.length&&this.allOtherExecutableTips.set(O,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...r,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(r,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,l)}groupImportantTipsByExe(r,s){const l=new Map;r.forEach(N=>l.set(N.extensionId.toLowerCase(),N));const{installed:h,uninstalled:b}=this.groupByInstalled([...l.keys()],s);for(const N of h){const L=l.get(N);L&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:N,exeName:L.exeName})}for(const N of b){const L=l.get(N);L&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:N,exeName:L.exeName})}const _=this.getPromptedExecutableTips(),U=new Map;for(const N of b){const L=l.get(N);if(L&&(!_[L.exeName]||!_[L.exeName].includes(L.extensionId))){let F=U.get(L.exeName);F||(F=[],U.set(L.exeName,F)),F.push(L)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[r,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(r);break;case"incompatibleWindow":{const h=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const r=this.getLastPromptedMediumExeTime(),s=Date.now()-r,l=7*24*60*60*1e3;if(s<l){const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},l-s));return}const[h,b]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(b).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(b[0].exeName,b);const U=this._register((0,n.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const U=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const U=this._register((0,n.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(r){const s=await this.extensionManagementService.getInstalled(1),l=r.filter(b=>!b.whenNotInstalled||b.whenNotInstalled.every(_=>s.every(U=>!(0,y.areSameExtensions)(U.identifier,{id:_})))).map(({extensionId:b})=>b.toLowerCase()),h=(0,R.localize)(0,null,r[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${r[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let r=this.storageService.getNumber(i,0);return r||(r=Date.now(),this.updateLastPromptedMediumExeTime(r)),r}updateLastPromptedMediumExeTime(r){this.storageService.store(i,r,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(c,0,"{}"))}addToRecommendedExecutables(r,s){const l=this.getPromptedExecutableTips();l[r]=s.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(c,JSON.stringify(l),0,0)}groupByInstalled(r,s){const l=[],h=[],b=s.reduce((_,U)=>(_.add(U.identifier.id.toLowerCase()),_),new Set);return r.forEach(_=>{b.has(_.toLowerCase())?l.push(_):h.push(_)}),{installed:l,uninstalled:h}}async getValidExecutableBasedExtensionTips(r){const s=[],l=new Map;for(const h of r.keys()){const b=r.get(h);if(!b||!(0,D.isNonEmptyArray)(b.recommendations))continue;const _=[];I.isWindows?b.windowsPath&&_.push(b.windowsPath.replace("%USERPROFILE%",E.env.USERPROFILE).replace("%ProgramFiles(x86)%",E.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",E.env.ProgramFiles).replace("%APPDATA%",E.env.APPDATA).replace("%WINDIR%",E.env.WINDIR)):(_.push((0,A.join)("/usr/local/bin",h)),_.push((0,A.join)("/usr/bin",h)),_.push((0,A.join)(this.environmentService.userHome.fsPath,h)));for(const U of _){let N=l.get(U);if(N===void 0&&(N=await this.fileService.exists(C.URI.file(U)),l.set(U,N)),N)for(const{extensionId:L,extensionName:F,isExtensionPack:O,whenNotInstalled:W}of b.recommendations)s.push({extensionId:L,extensionName:F,isExtensionPack:O,exeName:h,exeFriendlyName:b.exeFriendlyName,windowsPath:b.windowsPath,whenNotInstalled:W})}}return s}};o=de([Y(0,P.INativeEnvironmentService),Y(1,t.ITelemetryService),Y(2,p.IExtensionManagementService),Y(3,u.IStorageService),Y(4,S.INativeHostService),Y(5,v.IExtensionRecommendationNotificationService),Y(6,f.IFileService),Y(7,w.IProductService),Y(8,m.IRequestService),Y(9,d.ILogService)],o),e.ExtensionTipsService=o}),define(ie[99],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:I,data:E}){return this.appenders.forEach(C=>C.log(I,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ie[47],re([0,1,28,73,15,18,22]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(w,m){return Promise.resolve(void 0)}publicLog2(w,m){return this.publicLog(w,m)}publicLogError(w,m){return Promise.resolve(void 0)}publicLogError2(w,m){return this.publicLogError(w,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(w,m,u){}async publicLogError(w,m,u){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(S,w){return w.onDidChangeConfiguration(m=>{m.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(m.source),configurationKeys:v(m.sourceConfig)})})}e.configurationTelemetry=C;function R(S,w){return!(w.disableTelemetry||!S.enableTelemetry||w.extensionTestsLocationURI)}e.supportsTelemetry=R;function P(S){const w=S.getValue(A.TELEMETRY_SETTING_ID),m=S.getValue("telemetry.enableCrashReporter");if(S.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function p(S){const w=Object.create(null),m=Object.create(null),u=Object.create(null);g(S,u);for(let t in u){t=t.length>150?t.substr(t.length-149):t;const c=u[t];typeof c=="number"?m[t]=c:typeof c=="boolean"?m[t]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${c.length}`),w[t]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(w[t]=c)}return{properties:w,measurements:m}}e.validateTelemetryData=p;function y(S){if(!S)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{S.indexOf(`${u}+`)===0&&(w=u)}),w}e.cleanRemoteAuthority=y;function g(S,w,m=0,u){if(!!S)for(let t of Object.getOwnPropertyNames(S)){const c=S[t],i=u?u+t:t;Array.isArray(c)?w[i]=(0,D.safeStringify)(c):c instanceof Date?w[i]=c.toISOString():(0,k.isObject)(c)?m<2?g(c,w,m+1,i+"."):w[i]=(0,D.safeStringify)(c):w[i]=c}}function v(S){if(!S)return[];const w=[];return f(w,"",S),w}function f(S,w,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(u=>f(S,w?`${w}.${u}`:u,m[u])):S.push(w)}function d(S){return[S.appRoot,S.extensionsPath,S.userHome.fsPath,S.tmpDir.fsPath,S.userDataPath]}e.getPiiPathsFromEnvironment=d}),define(ie[213],re([0,1,46,47]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,A,I,E,C,R){const P={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},p=await(0,D.getServiceMachineId)(I,C,R);return(0,n.supportsTelemetry)(A,I)&&(0,n.getTelemetryLevel)(E)===3&&(P["X-Market-User-Id"]=p),P}e.resolveMarketplaceHeaders=k}),define(ie[214],re([0,1,17,25,8,28,4,34,15,7,18,13,29,31,60,14,9,23,43,213,21,22]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,p.getTargetPlatform)(A.platform,I.arch);var c;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(c||(c={}));function i(...z){return String(z.reduce((M,j)=>M|j,0))}var o;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class h{constructor(M=l){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,j=this.state.pageSize){return new h({...this.state,pageNumber:M,pageSize:j})}withFilter(M,...j){const B=[...this.state.criteria,...j.length?j.map(J=>({filterType:M,value:J})):[{filterType:M}]];return new h({...this.state,criteria:B})}withSortBy(M){return new h({...this.state,sortBy:M})}withSortOrder(M){return new h({...this.state,sortOrder:M})}withFlags(...M){return new h({...this.state,flags:M.reduce((j,B)=>j|B,0)})}withAssetTypes(...M){return new h({...this.state,assetTypes:M})}withSource(M){return new h({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:j,pageSize:B,sortBy:J,sortOrder:ne,flags:ae,assetTypes:he}=this.state;return{filters:[{criteria:M,pageNumber:j,pageSize:B,sortBy:J,sortOrder:ne}],assetTypes:he,flags:ae}}get searchText(){const M=this.state.criteria.filter(j=>j.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source}}}function b(z,M){const j=(z||[]).filter(B=>B.statisticName===M)[0];return j?j.value:0}function _(z){const M="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(B=>B.assetType.indexOf(M)===0).reduce((B,J)=>{const ne=L(z,J.assetType);return ne&&B.push([J.assetType.substring(M.length),ne]),B},[])}function U(z){if(z.properties){const M=z.properties.filter(J=>J.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=M.filter(J=>j.test(J.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return L(z,a.Repository)}function N(z){return{uri:`${z.fallbackAssetUri}/${a.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${a.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function L(z,M){return z.files.filter(B=>B.assetType===M)[0]?{uri:`${z.assetUri}/${M}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${M}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function F(z,M){const j=z.properties?z.properties.filter(J=>J.key===M):[],B=j.length>0&&j[0].value;return B?B.split(",").map(J=>(0,y.adoptToGalleryExtensionId)(J)):[]}function O(z){const M=z.properties?z.properties.filter(j=>j.key===r.Engine):[];return M.length>0&&M[0].value||""}function W(z){const M=z.properties?z.properties.filter(j=>j.key===r.PreRelease):[];return M.length>0&&M[0].value==="true"}function H(z){const M=z.properties?z.properties.filter(B=>B.key===r.LocalizedLanguages):[],j=M.length>0&&M[0].value||"";return j?j.split(","):[]}function te(z){return z.indexOf("preview")!==-1}function G(z){return z.targetPlatform?(0,p.toTargetPlatform)(z.targetPlatform):"undefined"}function $(z){const M=(0,D.distinct)(z.versions.map(G)),j=!!z.tags?.includes(p.WEB_EXTENSION_TAG),B=M.indexOf("web");return j?B===-1&&M.push("web"):B!==-1&&M.splice(B,1),M}function q(z,M){const j=(0,p.getFallbackTargetPlarforms)(M);for(let B=0;B<z.length;B++){const J=z[B];if(J.version===z[B-1]?.version){let ne=B;const ae=G(J);if(ae===M)for(;ne>0&&z[ne-1].version===J.version;)ne--;else if(j.includes(ae))for(;ne>0&&z[ne-1].version===J.version&&G(z[ne-1])!==M;)ne--;ne!==B&&(z.splice(B,1),z.splice(ne,0,J))}}return z}e.sortExtensionVersions=q;function V(z,M,j){z.telemetryData={index:M,querySource:j}}function x(z,M,j){const B=z.versions[0],J={manifest:L(M,a.Manifest),readme:L(M,a.Details),changelog:L(M,a.Changelog),license:L(M,a.License),repository:U(M),download:N(M),icon:L(M,a.Icon),coreTranslations:_(M)};return{identifier:{id:(0,y.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:M.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:b(z.statistics,"install"),rating:b(z.statistics,"averagerating"),ratingCount:b(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:j,assets:J,properties:{dependencies:F(M,r.Dependency),extensionPack:F(M,r.ExtensionPack),engine:O(M),localizedLanguages:H(M),targetPlatform:G(M),isPreReleaseVersion:W(M)},hasPreReleaseVersion:W(B),hasReleaseVersion:!0,preview:te(z.flags)}}let K=class{constructor(M,j,B,J,ne,ae,he,ve){this.requestService=j,this.logService=B,this.environmentService=J,this.telemetryService=ne,this.fileService=ae,this.productService=he,this.configurationService=ve;const we=he.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=(0,w.resolveMarketplaceHeaders)(he.version,he,this.environmentService,this.configurationService,this.fileService,M)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,j,B){const J=n.CancellationToken.isCancellationToken(j)?{}:j,ne=n.CancellationToken.isCancellationToken(j)?j:B,ae=[],he=[],ve=[],we=[];let ge=!0;for(const Ie of M){Ie.uuid?he.push(Ie.uuid):ae.push(Ie.id);const Re=!!(Ie.version||Ie.preRelease);ve.push({id:Ie.id,uuid:Ie.uuid,includePreRelease:Re}),Ie.version&&we.push({id:Ie.id,uuid:Ie.uuid,version:Ie.version}),ge=ge&&!!Ie.hasPreRelease&&!Re}if(!he.length&&!ae.length)return[];let ye=new h().withPage(1,M.length);he.length&&(ye=ye.withFilter(o.ExtensionId,...he)),ae.length&&(ye=ye.withFilter(o.ExtensionName,...ae)),(J.queryAllVersions||ge)&&(ye=ye.withFlags(ye.flags,c.IncludeVersions)),J.source&&(ye=ye.withSource(J.source));const{extensions:De}=await this.queryGalleryExtensions(ye,{targetPlatform:J.targetPlatform??t,includePreRelease:ve,versions:we,compatible:!!J.compatible},ne);return J.source&&De.forEach((Ie,Re)=>V(Ie,Re,J.source)),De}async getCompatibleExtension(M,j,B){if((0,p.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(M,j,B))return M;const J=new h().withFlags(c.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:ne}=await this.queryGalleryExtensions(J,{targetPlatform:B,compatible:!0,includePreRelease:j},n.CancellationToken.None);return ne[0]||null}async isExtensionCompatible(M,j,B){if(!(0,p.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,B)||!j&&M.properties.isPreReleaseVersion)return!1;let J=M.properties.engine;if(!J){const ne=await this.getManifest(M,n.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");J=ne.engines.vscode}return(0,g.isEngineValid)(J,this.productService.version,this.productService.date)}async isValidVersion(M,j,B,J,ne){if(!(0,p.isTargetPlatformCompatible)(G(M),J,ne)||j!=="any"&&W(M)!==(j==="prerelease"))return!1;if(B){const ae=await this.getEngine(M);if(!(0,g.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}return!0}async query(M,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=M.text||"";const J=(0,T.getOrDefault)(M,ge=>ge.pageSize,50);let ne=new h().withPage(1,J);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,ye,De)=>(ne=ne.withFilter(o.Category,De||ye),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,ye,De)=>(ne=ne.withFilter(o.Tag,De||ye),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(o.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),ne=ne.withFilter(o.SearchText,B)),ne=ne.withSortBy(0)):M.ids?ne=ne.withFilter(o.ExtensionId,...M.ids):M.names?ne=ne.withFilter(o.ExtensionName,...M.names):ne=ne.withSortBy(4),typeof M.sortBy=="number"&&(ne=ne.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(ne=ne.withSortOrder(M.sortOrder)),M.source&&(ne=ne.withSource(M.source));const ae=async(ge,ye)=>{const{extensions:De,total:Ie}=await this.queryGalleryExtensions(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!M.includePreRelease},ye);return De.forEach((Re,qe)=>V(Re,(ge.pageNumber-1)*ge.pageSize+qe,M.source)),{extensions:De,total:Ie}},{extensions:he,total:ve}=await ae(ne,j),we=async(ge,ye)=>{if(ye.isCancellationRequested)throw new k.CancellationError;const{extensions:De}=await ae(ne.withPage(ge+1),ye);return De};return{firstPage:he,total:ve,pageSize:ne.pageSize,getPage:we}}async queryGalleryExtensions(M,j,B){const J=M.flags;!!(M.flags&c.IncludeLatestVersionOnly)&&!!(M.flags&c.IncludeVersions)&&(M=M.withFlags(M.flags&~c.IncludeVersions,c.IncludeLatestVersionOnly)),!(M.flags&c.IncludeLatestVersionOnly)&&!(M.flags&c.IncludeVersions)&&(M=M.withFlags(M.flags,c.IncludeLatestVersionOnly)),j.versions?.length&&(M=M.withFlags(M.flags&~c.IncludeLatestVersionOnly,c.IncludeVersions)),M=M.withFlags(M.flags,c.IncludeAssetUri,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeStatistics,c.IncludeVersionProperties);const{galleryExtensions:ne,total:ae}=await this.queryRawGalleryExtensions(M,B);if(!(M.flags&c.IncludeLatestVersionOnly)){const ge=[];for(const ye of ne){const De=await this.toGalleryExtensionWithCriteria(ye,j);De&&ge.push(De)}return{extensions:ge,total:ae}}const ve=[],we=new Map;for(let ge=0;ge<ne.length;ge++){const ye=ne[ge],De={id:(0,y.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ie=(0,E.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(qe=>(0,y.areSameExtensions)(qe,De))?.includePreRelease;if(j.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)($(ye),j.targetPlatform))continue;const Re=await this.toGalleryExtensionWithCriteria(ye,j);!Re||Re.properties.isPreReleaseVersion&&(!Ie||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==j.targetPlatform&&Re.hasPreReleaseVersion?we.set(ye.extensionId,ge):ve.push([ge,Re])}if(we.size){const ge=new Date().getTime(),ye=new h().withFlags(J&~c.IncludeLatestVersionOnly,c.IncludeVersions).withPage(1,we.size).withFilter(o.ExtensionId,...we.keys()),{extensions:De}=await this.queryGalleryExtensions(ye,j,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:we.size});for(const Ie of De){const Re=we.get(Ie.identifier.uuid);ve.push([Re,Ie])}}return{extensions:ve.sort((ge,ye)=>ge[0]-ye[0]).map(([,ge])=>ge),total:ae}}async toGalleryExtensionWithCriteria(M,j){const B={id:(0,y.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},J=j.versions?.find(ve=>(0,y.areSameExtensions)(ve,B))?.version,ne=(0,E.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(ve=>(0,y.areSameExtensions)(ve,B))?.includePreRelease,ae=$(M),he=q(M.versions,j.targetPlatform);if(j.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(ae,j.targetPlatform))return null;for(let ve=0;ve<he.length;ve++){const we=he[ve];if(!(J&&we.version!==J)){if(await this.isValidVersion(we,ne?"any":"release",j.compatible,ae,j.targetPlatform))return x(M,we,ae);if(J&&we.version===J)return null}}return J||j.compatible?null:x(M,M.versions[0],ae)}async queryRawGalleryExtensions(M,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,c.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,i(c.Unpublished));const B=await this.commonHeadersPromise,J=JSON.stringify(M.raw),ne={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},ae=new Date().getTime();let he,ve,we=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:ne},j),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:we};const ge=await(0,S.asJson)(he);if(ge){const ye=ge.results[0],De=ye.extensions,Ie=ye.resultMetadata&&ye.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return we=Ie&&Ie.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:De,total:we}}return{galleryExtensions:[],total:we}}catch(ge){throw ve=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-ae,success:!!he&&(0,S.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ve?(0,k.isCancellationError)(ve)?"canceled":(0,k.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(M,j,B,J){if(!this.isEnabled())return;const ne=A.isWeb?this.api(`/itemName/${M}.${j}/version/${B}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${j}/${B}/stats?statType=${J}`),ae=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ve={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:ne,headers:ve},n.CancellationToken.None)}catch{}}async download(M,j,B){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const J=(0,y.getGalleryExtensionTelemetryData)(M),ne=new Date().getTime(),ae=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...J,duration:ge}),he=B===2?"install":B===3?"update":"",ve=he?{uri:`${M.assets.download.uri}${C.URI.parse(M.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${M.assets.download.fallbackUri}${C.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:M.assets.download,we=await this.getAsset(ve);await this.fileService.writeFile(j,we.stream),ae(new Date().getTime()-ne)}async getReadme(M,j){if(M.assets.readme){const B=await this.getAsset(M.assets.readme,{},j);return await(0,S.asTextOrError)(B)||""}return""}async getManifest(M,j){if(M.assets.manifest){const B=await this.getAsset(M.assets.manifest,{},j),J=await(0,S.asTextOrError)(B);return J?JSON.parse(J):null}return null}async getManifestFromRawExtensionVersion(M,j){const B=L(M,a.Manifest);if(!B)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},ne=await this.getAsset(B,{headers:J});return await(0,S.asJson)(ne)}async getCoreTranslation(M,j){const B=M.assets.coreTranslations.filter(J=>J[0]===j.toUpperCase())[0];if(B){const J=await this.getAsset(B[1]),ne=await(0,S.asTextOrError)(J);return ne?JSON.parse(ne):null}return null}async getChangelog(M,j){if(M.assets.changelog){const B=await this.getAsset(M.assets.changelog,{},j);return await(0,S.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(M,j,B){let J=new h().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?J=J.withFilter(o.ExtensionId,M.identifier.uuid):J=J.withFilter(o.ExtensionName,M.identifier.id);const{galleryExtensions:ne}=await this.queryRawGalleryExtensions(J,n.CancellationToken.None);if(!ne.length)return[];const ae=$(ne[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(ae,B))return[];const he=[];await Promise.all(ne[0].versions.map(async ge=>{try{await this.isValidVersion(ge,j?"any":"release",!0,ae,B)&&he.push(ge)}catch{}}));const ve=[],we=new Set;for(const ge of q(he,B))we.has(ge.version)||(we.add(ge.version),ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:W(ge)}));return ve}async getAsset(M,j={},B=n.CancellationToken.None){const J=await this.commonHeadersPromise,ne={type:"GET"},ae={...J,...j.headers||{}};j={...j,...ne,headers:ae};const he=M.uri,ve=M.fallbackUri,we={...j,url:he};try{const ge=await this.requestService.request(we,B);if(ge.res.statusCode===200)return ge;const ye=await(0,S.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${ye}`)}catch(ge){if((0,k.isCancellationError)(ge))throw ge;const ye=(0,k.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:he,message:ye});const De={...j,url:ve};return this.requestService.request(De,B)}}async getEngine(M){let j=O(M);if(!j){const B=await this.getManifestFromRawExtensionVersion(M,n.CancellationToken.None);if(!B)throw new Error("Manifest was not found");j=B.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,S.asJson)(M),B=[],J={};if(j){for(const ne of j.malicious)B.push({id:ne});if(j.unsupported)for(const ne of Object.keys(j.unsupported)){const ae=j.unsupported[ne];(0,E.isBoolean)(ae)||(J[ne.toLowerCase()]=ae.preReleaseExtension)}if(j.migrateToPreRelease)for(const[ne,ae]of Object.entries(j.migrateToPreRelease))(!ae.engine||(0,g.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(J[ne.toLowerCase()]=ae)}return{malicious:B,unsupportedPreReleaseExtensions:J}}};K=de([Y(1,S.IRequestService),Y(2,f.ILogService),Y(3,P.IEnvironmentService),Y(4,u.ITelemetryService),Y(5,v.IFileService),Y(6,d.IProductService),Y(7,R.IConfigurationService)],K);let Z=class extends K{constructor(M,j,B,J,ne,ae,he,ve){super(M,j,B,J,ne,ae,he,ve)}};Z=de([Y(0,m.IStorageService),Y(1,S.IRequestService),Y(2,f.ILogService),Y(3,P.IEnvironmentService),Y(4,u.ITelemetryService),Y(5,v.IFileService),Y(6,d.IProductService),Y(7,R.IConfigurationService)],Z),e.ExtensionGalleryService=Z;let X=class extends K{constructor(M,j,B,J,ne,ae,he){super(void 0,M,j,B,J,ne,ae,he)}};X=de([Y(0,S.IRequestService),Y(1,f.ILogService),Y(2,P.IEnvironmentService),Y(3,u.ITelemetryService),Y(4,v.IFileService),Y(5,d.IProductService),Y(6,R.IConfigurationService)],X),e.ExtensionGalleryServiceWithNoStorageService=X}),define(ie[100],re([0,1,2,13,9,47]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(E,C,R=""){super();this.prefix=R;const P=E.getLogger(C.telemetryLogResource);P?this.logger=this._register(P):(this.logger=this._register(E.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,C){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,T.validateTelemetryData)(C))}};A=de([Y(0,k.ILoggerService),Y(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ie[101],re([0,1,2,28,73,4,26,148,18,42,94,23,38,22,47]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(S,w,m){this._configurationService=w,this._productService=m,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,w){this._experimentProperties[S]=w}_updateTelemetryLevel(){let S=(0,g.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const m=w.usage?3:w.error?2:0;S=Math.min(S,m)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties;let w=S.sessionID,m=S["common.machineId"],u=S["common.firstSessionDate"],t=S["common.msftInternal"];return{sessionId:w,machineId:m,firstSessionDate:u,msftInternal:t}}dispose(){this._disposables.dispose()}_log(S,w,m,u){return this.telemetryLevel.value<w?Promise.resolve(void 0):this._commonProperties.then(t=>{m=(0,n.mixin)(m,t),m=(0,n.mixin)(m,this._experimentProperties),m=(0,n.cloneAndChange)(m,c=>{if(typeof c=="string")return this._cleanupInfo(c,u)}),this._appenders.forEach(c=>c.log(S,m))},t=>{console.error(t)})}publicLog(S,w,m){return this._log(S,3,w,m)}publicLog2(S,w,m){return this.publicLog(S,w,m)}publicLogError(S,w){return this._sendErrorTelemetry?this._log(S,2,w,!0):Promise.resolve(void 0)}publicLogError2(S,w){return this.publicLogError(S,w)}_anonymizeFilePaths(S){let w=S;const m=[];for(let i of this._cleanupPatterns)for(;;){const o=i.exec(S);if(!o)break;m.push([o.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,t=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(w="";;){const i=t.exec(S);if(!i)break;!u.test(i[0])&&m.every(([o,a])=>i.index<o||i.index>=a)&&(w+=S.substring(c,i.index)+"<REDACTED: user-file-path>",c=t.lastIndex)}return c<S.length&&(w+=S.substr(c)),w}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const w=S.toLowerCase(),m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of m)if(u.regex.test(w))return`<REDACTED: ${u.label}`;return S}_cleanupInfo(S,w){let m=S;w&&(m=this._anonymizeFilePaths(m));for(let u of this._cleanupPatterns)m=m.replace(u,"");return m=this._removePropertiesWithPossibleUserInfo(m),m}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=de([Y(1,E.IConfigurationService),Y(2,P.IProductService)],v),e.TelemetryService=v;function f(){const d=(0,I.localize)(0,null,R.default.nameLong),S=R.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",R.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=T.isWeb?"":(0,I.localize)(3,null),m=(0,I.localize)(4,null),u=(0,I.localize)(5,null),t=(0,I.localize)(6,null),c=(0,I.localize)(7,null),i=`
|       | ${m} | ${u} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,I.localize)(8,null);return`
${d} ${S} ${w}

&nbsp;

${c}
${i}

&nbsp;

${o}
`}p.Registry.as(C.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:f(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(C.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:R.default.privacyStatementUrl?(0,I.localize)(16,null,R.default.nameLong,R.default.privacyStatementUrl):(0,I.localize)(15,null,R.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[215],re([0,1,8,28,47]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(I){const E=await new Promise((R,P)=>{Q(["applicationinsights"],R,P)});let C;return E.defaultClient?(C=new E.TelemetryClient(I),C.channel.setUseDiskRetryCaching(!0)):(E.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=E.defaultClient),I.indexOf("AIF-")===0&&(C.config.endpointUrl="https://0.0.0.0/collect/v1"),C}class A{constructor(E,C,R){this._eventPrefix=E,this._defaultData=C,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(E){if(!!this._aiClient){if(typeof this._aiClient!="string"){E(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(C=>{E(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(E,C){if(!!this._aiClient){C=(0,n.mixin)(C,this._defaultData),C=(0,k.validateTelemetryData)(C);try{this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+E,properties:C.properties,measurements:C.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(E=>{this._withAIClient(C=>{try{C.flush({callback:()=>{this._aiClient=void 0,E(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(ie[216],re([0,1,19,59,18,13,9,23,22,99,100,101]),function(Q,e,D,n,k,T,A,I,E,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(g,v,f,d,S){this.configurationService=g,this.telemetryService=v,this.loggerService=f,this.environmentService=d,this.productService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(g){if(!this.customTelemetryServices.has(g.id)){const{machineId:v,sessionId:f}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=v,d["common.vscodesessionid"]=f;const S=[g.id,JSON.stringify(d),g.aiKey],m=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:S,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new C.TelemetryAppenderClient(m),new R.TelemetryLogAppender(this.loggerService,this.environmentService,`[${g.id}] `)];this.customTelemetryServices.set(g.id,new P.TelemetryService({appenders:u,sendErrorTelemetry:g.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(g.id)}async publicLog(g,v,f){await(await this.getCustomTelemetryService(g)).publicLog(v,f)}async publicLogError(g,v,f){await(await this.getCustomTelemetryService(g)).publicLogError(v,f)}};p=de([Y(0,k.IConfigurationService),Y(1,E.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService),Y(4,I.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ie[217],re([0,1,5,25,3,2,9]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends T.Disposable{constructor(C,R){super();this._logService=R,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((R,P)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,R),this._onCreateRequest.fire({requestId:p,...C});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>P(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,T.toDisposable)(()=>y.cancel())])})}acceptReply(C,R){const P=this._pendingRequests.get(C);P?(this._pendingRequests.delete(C),(0,T.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),P(R)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};I=de([Y(1,A.ILogService)],I),e.RequestStore=I}),define(ie[102],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",f.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",f.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var C;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(f){f.TerminalView="view",f.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(ie[218],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ie[219],re([0,1,35,19,28,10,4,34,26,15,27]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function P(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let u=0;return m&&m.length===4&&(u=parseInt(m[3])),u}e.getWindowsBuildNumber=P;async function p(m,u,t,c=I.env,i=R.Promises.exists){if(T.isAbsolute(m))return await i(m)?m:void 0;if(u===void 0&&(u=I.cwd()),T.dirname(m)!=="."){const s=T.join(u,m);return await i(s)?s:void 0}const a=(0,k.getCaseInsensitive)(c,"PATH");if(t===void 0&&(0,C.isString)(a)&&(t=a.split(T.delimiter)),t===void 0||t.length===0){const s=T.join(u,m);return await i(s)?s:void 0}for(let s of t){let l;if(T.isAbsolute(s)?l=T.join(s,m):l=T.join(u,s,m),await i(l))return l;if(A.isWindows){let h=l+".com";if(await i(h)||(h=l+".exe",await i(h)))return h}}const r=T.join(u,m);return await i(r)?r:void 0}e.findExecutable=p;function y(m,u,t){if(!u.enabled||!m.executable||m.isFeatureTerminal||m.hideFromUser)return;const c=m.args,i=I.platform==="win32"?T.basename(m.executable).toLowerCase():T.basename(m.executable),o=T.dirname(n.FileAccess.asFileUri("",Q).fsPath);let a;if(A.isWindows){if(i==="pwsh.exe"){if(!c||S(c)?a=e.shellIntegrationArgs.get(g.WindowsPwsh):d(c)&&(a=e.shellIntegrationArgs.get(g.WindowsPwshLogin)),!a)return;if(a){const s=u.showWelcome?"":" -HideWelcome";a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],o,s)}return{newArgs:a}}t.warn(`Shell integration cannot be enabled for executable "${m.executable}" and args`,m.args);return}const r={};switch(i){case"bash":return!c||c.length===0?a=e.shellIntegrationArgs.get(g.Bash):w(c)&&(r.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(g.Bash)),a?(a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],o),u.showWelcome||(r.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:a,envMixin:r}):void 0;case"pwsh":{if(!c||S(c)?a=e.shellIntegrationArgs.get(g.Pwsh):d(c)&&(a=e.shellIntegrationArgs.get(g.PwshLogin)),!a)return;const s=u.showWelcome?"":" -HideWelcome";return a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],o,s),{newArgs:a}}case"zsh":{if(!c||c.length===0?a=e.shellIntegrationArgs.get(g.Zsh):w(c)?a=e.shellIntegrationArgs.get(g.ZshLogin):(c===e.shellIntegrationArgs.get(g.Zsh)||c===e.shellIntegrationArgs.get(g.ZshLogin))&&(a=c),!a)return;a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],o);const s=T.join(D.tmpdir(),"vscode-zsh");r.ZDOTDIR=s;const l=[];return l.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration.zsh"),dest:T.join(s,".zshrc")}),l.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(s,".zprofile")}),l.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(s,".zshenv")}),u.showWelcome||(r.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:a,envMixin:r,filesToCopy:l}}}t.warn(`Shell integration cannot be enabled for executable "${m.executable}" and args`,m.args)}e.getShellIntegrationInjection=y;var g;(function(m){m.WindowsPwsh="windows-pwsh",m.WindowsPwshLogin="windows-pwsh-login",m.Pwsh="pwsh",m.PwshLogin="pwsh-login",m.Zsh="zsh",m.ZshLogin="zsh-login",m.Bash="bash"})(g=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(g.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(g.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(g.Zsh,["-i"]),e.shellIntegrationArgs.set(g.ZshLogin,["-il"]),e.shellIntegrationArgs.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],f=["-nol","-nologo"];function d(m){return typeof m=="string"?v.includes(m.toLowerCase()):m.length===1&&v.includes(m[0].toLowerCase())||m.length===2&&(v.includes(m[0].toLowerCase())||v.includes(m[1].toLowerCase()))&&(f.includes(m[0].toLowerCase())||f.includes(m[1].toLowerCase()))}function S(m){return typeof m=="string"?f.includes(m.toLowerCase()):m.length===0||m?.length===1&&f.includes(m[0].toLowerCase())}function w(m){return m==="string"&&v.includes(m.toLowerCase())||typeof m!="string"&&m.length===1&&v.includes(m[0].toLowerCase())}}),define(ie[220],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var D;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function n(k){return k===D.HIGH_CONTRAST_DARK||k===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=n}),define(ie[103],re([0,1,48,3,2,6,38,220]),function(Q,e,D,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var E;(function(f){function d(S){return S&&typeof S=="object"&&typeof S.id=="string"}f.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function C(f){return{id:f}}e.themeColorFromId=C;var R;(function(f){function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||E.isThemeColor(o.color))}f.isThemeIcon=d;const S=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function w(o){const a=S.exec(o);if(!a)return;let[,r]=a;return{id:r}}f.fromString=w;function m(o){return{id:o}}f.fromId=m;function u(o,a){let r=o.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),a&&(r=`${r}~${a}`),{id:r}}f.modify=u;function t(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}f.getModifier=t;function c(o,a){return o.id===a.id&&o.color?.id===a.color?.id}f.isEqual=c;function i(o,a){return{id:o.id,color:a?C(a):void 0}}f.asThemeIcon=i,f.asClassNameArray=D.CSSIcon.asClassNameArray,f.asClassName=D.CSSIcon.asClassName,f.asCSSSelector=D.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function P(f){switch(f){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(d);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new p;A.Registry.add(e.Extensions.ThemingContribution,y);function g(f){return y.onColorThemeChange(f)}e.registerThemingParticipant=g;class v extends k.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,S){let w=this.theme.getColor(d);return w&&S&&(w=S(w,this.theme)),w?w.toString():null}}e.Themable=v}),define(ie[221],re([0,1,48,7,150,103]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(p,y){const g=[{name:null,description:(0,k.localize)(0,null)}];return g.push(...p.map(v=>({name:v.profileName,description:I(v)}))),y&&g.push(...y.map(v=>({name:v.title,description:E(v)}))),{values:g.map(v=>v.name),markdownDescriptions:g.map(v=>v.description)}}e.createProfileSchemaEnums=A;function I(p){let y=`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?y+=`
- args: "${p.args}"`:y+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(y+=`
- overrideName: ${p.overrideName}`),p.color&&(y+=`
- color: ${p.color}`),p.env&&(y+=`
- env: ${JSON.stringify(p.env)}`),y}function E(p){return`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.title}
- extensionIdenfifier: ${p.extensionIdentifier}`}function C(p,y){if(!p&&!y)return!0;if(typeof p=="string"&&typeof y=="string")return p===y;if(Array.isArray(p)&&Array.isArray(y)){if(p.length!==y.length)return!1;for(let g=0;g<p.length;g++)if(p[g]!==y[g])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function R(p,y){if(!p&&!y)return!0;if(!p||!y)return!1;if(T.ThemeIcon.isThemeIcon(p)&&T.ThemeIcon.isThemeIcon(y))return p.id===y.id&&p.color===y.color;if(typeof p=="object"&&p&&"light"in p&&"dark"in p&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const g=p,v=y;if((n.URI.isUri(g.light)||P(g.light))&&(n.URI.isUri(g.dark)||P(g.dark))&&(n.URI.isUri(v.light)||P(v.light))&&(n.URI.isUri(v.dark)||P(v.dark)))return g.light.path===v.light.path&&g.dark.path===v.dark.path}if(n.URI.isUri(p)&&n.URI.isUri(y)||P(p)||P(y)){const g=p,v=y;return g.path===v.path&&g.scheme===v.scheme}return!1}e.terminalIconsEqual=R;function P(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=P}),define(ie[222],re([0,1,48,149,42,38,221]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const I={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),m=>m.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),m=>`$(${m.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},C={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...I}},R=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),P=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),g=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){T.Registry.as(k.Extensions.Configuration).registerConfiguration(f),w()}e.registerTerminalPlatformConfiguration=d;let S;function w(m,u){const t=T.Registry.as(k.Extensions.Configuration);let c;m&&(c=(0,A.createProfileSchemaEnums)(m?.profiles,u));const i=S;S={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:m?.os===3?c?.values:void 0,markdownEnumDescriptions:m?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:m?.os===2?c?.values:void 0,markdownEnumDescriptions:m?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:m?.os===1?c?.values:void 0,markdownEnumDescriptions:m?.os===1?c?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[S],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(ie[223],re([0,1,45,48,10,4,27,79,219,103]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R,P=!0;function p(c,i,o,a,r=process.env,s,l,h,b){return s=s||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?y(o,s,r,l,a.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:a.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:a.getValue("terminal.integrated.defaultProfile.windows"),b,h):m(s,l,o,c&&typeof c=="object"?{...c}:a.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:a.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),b,h,r)}e.detectAvailableProfiles=p;async function y(c,i,o,a,r,s,l,h,b){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let N=!1;(0,E.getWindowsBuildNumber)()>=16299&&(N=!0),await f(h);const L=new Map;c&&(L.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),L.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),L.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),u(s,L);const F=await g(L.entries(),l,i,o,a,b);if(c||!c&&r)try{const O=await S(`${U}\\${N?"wsl":"bash"}.exe`,l);for(const W of O)(!s||!(W.profileName in s))&&F.push(W)}catch{P&&(a?.info("WSL is not installed, so could not detect WSL profiles"),P=!1)}return F}async function g(c,i,o,a=process.env,r,s){const l=[];for(const[h,b]of c){if(b===null)continue;let _,U,N;if("source"in b){const O=R?.get(b.source);if(!O)continue;_=O.paths,U=b.args||O.args,b.icon?N=v(b.icon):O.icon&&(N=O.icon)}else _=Array.isArray(b.path)?b.path:[b.path],U=T.isWindows||Array.isArray(b.args)?b.args:void 0,N=v(b.icon);const L=await s?.(_)||_.slice(),F=await t(h,i,L,o,a,U,b.env,b.overrideName,b.isAutoDetected,r);F?(F.isAutoDetected=b.isAutoDetected,F.icon=N,F.color=b.color,l.push(F)):r?.trace("profile not validated",h,_)}return l}function v(c){return typeof c=="string"?{id:c}:c}async function f(c){R&&!c||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:c||await d(),icon:C.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function d(){const c=[];for await(const i of(0,I.enumeratePowerShellInstallations)())c.push(i.exePath);return c}async function S(c,i){const o=[],a=await new Promise((l,h)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(b,_)=>{if(b)return h("Problem occurred when getting wsl distros");l(_)})});if(!a)return[];const r=new RegExp(/[\r?\n]/),s=a.split(r).filter(l=>l.trim().length>0&&l!=="");for(const l of s){if(l===""||l.startsWith("docker-desktop"))continue;const h=`${l} (WSL)`,b={profileName:h,path:c,args:["-d",`${l}`],isDefault:h===i,icon:w(l),isAutoDetected:!1};o.push(b)}return o}function w(c){return c.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):c.includes("Debian")?C.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function m(c,i,o,a,r,s,l,h){const b=new Map;if(o){const _=(await c.readFile("/etc/shells")).toString(),U=s||_.split(`
`).filter(L=>L.trim().indexOf("#")!==0&&L.trim().length>0),N=new Map;for(const L of U){let F=(0,k.basename)(L),O=N.get(F)||0;O++,O>1&&(F=`${F} (${O})`),N.set(F,O),b.set(F,{path:L,isAutoDetected:!0})}}return u(a,b),await g(b.entries(),r,c,h,i,l)}function u(c,i){if(!!c)for(const[o,a]of Object.entries(c))a===null||!("path"in a)&&!("source"in a)?i.delete(o):(a.icon=a.icon||i.get(o)?.icon,i.set(o,a))}async function t(c,i,o,a,r,s,l,h,b,_){if(o.length===0)return Promise.resolve(void 0);const U=o.shift();if(U==="")return t(c,i,o,a,r,s,l,h,b);const N={profileName:c,path:U,args:s,env:l,overrideName:h,isAutoDetected:b,isDefault:c===i};if((0,k.basename)(U)===U){const F=r.PATH?r.PATH.split(k.delimiter):void 0,O=await(0,E.findExecutable)(U,void 0,F,void 0,a.existsFile);return O?(N.path=O,N.isFromPath=!0,N):t(c,i,o,a,r,s)}return await a.existsFile((0,k.normalize)(U))?N:t(c,i,o,a,r,s,l,h,b)}}),define(ie[224],re([0,1,3,2,19,4,36,59,18,13,84,203,9,93,217,102,222,223]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var S;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(S||(S={}));let w=0,m=class extends n.Disposable{constructor(t,c,i,o){super();this._reconnectConstants=t,this._configurationService=c,this._environmentService=i,this._logService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new g.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,P.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(t){return this._logService.error("ptyHost was unable to resolve shell environment",t),{}}}_startPtyHost(){const t={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:w,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},c=(0,R.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);c&&(c.break&&c.port?t.debugBrk=c.port:!c.break&&c.port&&(t.debug=c.port));const i=new I.Client(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,t);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(s=>{this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=S.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const a=i.getChannel(v.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const r=A.ProxyChannel.toService(i.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(r.onProcessData(s=>this._onProcessData.fire(s))),this._register(r.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(r.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(r.onDidChangeProperty(s=>this._onDidChangeProperty.fire(s))),this._register(r.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(r.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(r.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[i,r]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(t,c,i,o,a,r,s,l,h,b,_){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(t,c,i,o,a,r,s,l,h,b,_);return clearTimeout(U),w=Math.max(w,N),N}updateTitle(t,c,i){return this._proxy.updateTitle(t,c,i)}updateIcon(t,c,i){return this._proxy.updateIcon(t,c,i)}attachToProcess(t){return this._proxy.attachToProcess(t)}detachFromProcess(t){return this._proxy.detachFromProcess(t)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(t){return this._proxy.start(t)}shutdown(t,c){return this._proxy.shutdown(t,c)}input(t,c){return this._proxy.input(t,c)}processBinary(t,c){return this._proxy.processBinary(t,c)}resize(t,c,i){return this._proxy.resize(t,c,i)}acknowledgeDataEvent(t,c){return this._proxy.acknowledgeDataEvent(t,c)}setUnicodeVersion(t,c){return this._proxy.setUnicodeVersion(t,c)}getInitialCwd(t){return this._proxy.getInitialCwd(t)}getCwd(t){return this._proxy.getCwd(t)}getLatency(t){return this._proxy.getLatency(t)}orphanQuestionReply(t){return this._proxy.orphanQuestionReply(t)}installAutoReply(t,c){return this._proxy.installAutoReply(t,c)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(t){return this._proxy.uninstallAutoReply(t)}getDefaultSystemShell(t){return this._proxy.getDefaultSystemShell(t)}async getProfiles(t,c,i,o=!1){const a=await this._shellEnv;return(0,d.detectAvailableProfiles)(c,i,o,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,t))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(t){return this._proxy.getWslPath(t)}setTerminalLayoutInfo(t){return this._proxy.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this._proxy.getTerminalLayoutInfo(t)}async requestDetachInstance(t,c){return this._proxy.requestDetachInstance(t,c)}async acceptDetachInstanceReply(t,c){return this._proxy.acceptDetachInstanceReply(t,c)}async serializeTerminalState(t){return this._proxy.serializeTerminalState(t)}async reviveTerminalProcesses(t,c){return this._proxy.reviveTerminalProcesses(t,c)}async refreshProperty(t,c){return this._proxy.refreshProperty(t,c)}async updateProperty(t,c,i){return this._proxy.updateProperty(t,c,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(t,c){return this._resolveVariablesRequestStore.createRequest({workspaceId:t,originalText:c})}async acceptPtyHostResolvedVariables(t,c){this._resolveVariablesRequestStore.acceptReply(t,c)}};m=de([Y(1,E.IConfigurationService),Y(2,C.IEnvironmentService),Y(3,p.ILogService)],m),e.PtyHostService=m}),define(ie[66],re([0,1,3,4,6,9]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(g){g.Http="http",g.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=P;function p(g,v){return v?v!==1&&g<1024:!n.isWindows&&g<1024}e.isPortPrivileged=p;let y=class{constructor(v){this.logService=v,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],f=Array.from(this._tunnels.values());for(let d of f){const S=Array.from(d.values());for(let w of S){const m=await w.value;m&&v.push(m)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:f}of v.values())await f.then(d=>d?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,f,d,S,w=!1,m=I.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${S}.`),!v)return;f||(f="localhost");const t=this.retainOrCreateTunnel(v,f,d,S,w,m,u);return t?t.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==f||c.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const f=this._tunnels.get(v.tunnelRemoteHost);if(f){const d=f.get(v.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,d))}}}}async tryDisposeTunnel(v,f,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${f}.`);const S=d.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(f),S}}async closeTunnel(v,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${f} `);const d=this._tunnels.get(v);if(d&&d.has(f)){const S=d.get(f);S.refcount=0,await this.tryDisposeTunnel(v,f,S)}}addTunnelToMap(v,f,d){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(f,{refcount:1,value:d})}async removeEmptyTunnelFromMap(v,f){const d=this._tunnels.get(v);d&&(await d.get(f)||d.delete(f),d.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,f){let d=[v];R(v)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):P(v)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const S=d.map(w=>this._tunnels.get(w));for(const w of S){const m=w?.get(f);if(m)return m}}canTunnel(v){return!!C(v)}createWithProvider(v,f,d,S,w,m,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${S}.`);const c={elevationRequired:w?p(S===void 0?d:S):!1},i={remoteAddress:{host:f,port:d},localAddressPort:S,privacy:m,public:m!==I.Private,protocol:u},o=v.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(f,d,o),o}};y=de([Y(0,T.ILogService)],y),e.AbstractTunnelService=y}),define(ie[225],re([0,1,9,66,2,8,5]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(R){this._address=R,this._addressPromise&&(this._addressPromise.complete(R),this._addressPromise=null)}setTunnel(R){this._register(R)}}let E=class wt extends k.Disposable{constructor(R,P){super();this._tunnelService=R,this._logService=P,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(R=>R.dispose())}async createTunnel(){return{id:String(++wt._lastId)}}async startTunnel(R,P,p,y,g,v){const f=new I,d=await Promise.resolve(this._tunnelService.openTunnel(R,f,p,y,g,v));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${y} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(P))throw this._disposedTunnels.delete(P),f.dispose(),await d.dispose(),(0,T.canceled)();return f.setTunnel(d),this._tunnels.set(P,f),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${P}: ${d.localAddress} (local) to ${p}:${y} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(R,P){const p=this._tunnels.get(R);!p||p.setAddress(P)}async destroyTunnel(R){const P=this._tunnels.get(R);if(P){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${R}.`),this._tunnels.delete(R),await P.dispose();return}this._disposedTunnels.add(R)}};E._lastId=0,E=de([Y(0,n.ISharedTunnelsService),Y(1,D.ILogService)],E),e.SharedProcessTunnelService=E}),define(ie[32],re([0,1,6]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ie[226],re([0,1,3,2,7,13,31,14,9,32]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends n.Disposable{constructor(p,y,g,v,f){super();this.extensionsManagementService=p,this.logService=v,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(S=>{this.installedExtensions=S.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(S=>this.onInstallExtension(S))),this._register(p.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(p.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const d=k.URI.file(g.extensionsPath);this._register(y.watch(d)),this._register(D.Event.filter(y.onDidFilesChange,S=>S.rawChanges.some(w=>this.doesChangeAffects(w,d)))(()=>this.onDidChange()))}doesChangeAffects(p,y){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),y)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const y of p)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),y=p.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,A.areSameExtensions)(f,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),g=this.installedExtensions.filter(v=>this.installingExtensions.some(f=>(0,A.areSameExtensions)(f,v))?!1:p.every(f=>!(0,A.areSameExtensions)(f.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=p.map(v=>v.identifier),(y.length||g.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:g})}}};R=de([Y(1,I.IFileService),Y(2,T.INativeEnvironmentService),Y(3,E.ILogService),Y(4,C.IUriIdentityService)],R),e.ExtensionsWatcher=R}),define(ie[227],re([0,1,32,86,14,20,110,3,2]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(p){this.uri=p,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let R=class{constructor(p){this._fileService=p,this._dispooables=new E.DisposableStore,this._limit=2**16;const y=new Map,g=v=>{let f=y.get(v.scheme);return f===void 0&&(f=p.hasProvider(v)&&!this._fileService.hasCapability(v,1024),y.set(v.scheme,f)),f};this._dispooables.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(v=>{y.delete(v.scheme)})),this.extUri=new T.ExtUri(g),this._canonicalUris=new A.SkipList((v,f)=>this.extUri.compare(v,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,T.normalizePath)(p));let y=this._canonicalUris.get(p);return y?y.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new C(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((g,v)=>g[1].touch<v[1].touch?1:g[1].touch>v[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let g=0;g<y;g++)this._canonicalUris.set(p[g][0],p[g][1].touch())}};R=de([Y(0,k.IFileService)],R),e.UriIdentityService=R,(0,n.registerSingleton)(D.IUriIdentityService,R,!0)}),define(ie[228],re([0,1,3,2,40,39,16]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends n.Disposable{constructor(C,R,P,p){super();this.fileSystemScheme=C,this.fileSystemProvider=R,this.userDataScheme=P,this.logService=p,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(C,R){this.watchResources.set(C,C);const P=this.fileSystemProvider.watch(this.toFileSystemResource(C),R);return(0,n.toDisposable)(()=>{this.watchResources.delete(C),P.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,R,P){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(R),P)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,R,P){const p=(0,k.newWriteableStream)(y=>A.VSBuffer.concat(y.map(g=>A.VSBuffer.wrap(g))).buffer);return(async()=>{try{const y=await this.readFile(C);p.end(y)}catch(y){p.error(y),p.end()}})(),p}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,R,P){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),R,P)}delete(C,R){return this.fileSystemProvider.delete(this.toFileSystemResource(C),R)}handleFileChanges(C){const R=[];for(const P of C){if(P.resource.scheme!==this.fileSystemScheme)continue;const p=this.toUserDataResource(P.resource);this.watchResources.findSubstr(p)&&R.push({resource:p,type:P.type})}R.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(R))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(ie[54],re([0,1,71]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,I,E,C){const R=(0,D.setProperty)(A,I,E,C)[0];return R&&(A=A.substring(0,R.offset)+R.content+A.substring(R.offset+R.length)),A}e.edit=n;function k(A,I,E){let C=E;for(;C>=0;){if(A.charAt(C)===I.charAt(I.length-1)&&I.length===1)return C+1;if(C--,I.length===2&&C>=0&&A.charAt(C)===I.charAt(0))return C+2}return 0}e.getLineStartOffset=k;function T(A,I,E){let C=E;for(;C>=0;)if(A.charAt(C)===I.charAt(I.length-1)&&I.length===1||(C++,I.length===2&&C>=0&&A.charAt(C)===I.charAt(1)))return C;return A.length-1}e.getLineEndOffset=T}),define(ie[229],re([0,1,28,51,15]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(p,y,g,v,f){const d=[],S=[],w=[];if(!y){const U=p.filter(({identifier:N})=>f.every(L=>L.toLowerCase()!==N.id.toLowerCase()));return{local:{added:d,removed:S,updated:w},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}p=p.map(R),y=y.map(R),g=g?g.map(R):null;const m=new Map,u=U=>{U.uuid&&m.set(U.id.toLowerCase(),U.uuid)};p.forEach(({identifier:U})=>u(U)),y.forEach(({identifier:U})=>u(U)),g&&g.forEach(({identifier:U})=>u(U));const t=U=>{const N=U.identifier.uuid||m.get(U.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${U.identifier.id.toLowerCase()}`},c=(U,N)=>(U.set(t(N),N),U),i=p.reduce(c,new Map),o=y.reduce(c,new Map),a=y.reduce((U,N)=>{const L=t(N);N=(0,D.deepClone)(N);const F=i.get(L);return F&&(F.installed&&(N.installed=!0),N.version||(N.version=F.version)),c(U,N)},new Map),r=g?g.reduce(c,new Map):null,s=v.reduce(c,new Map),l=f.reduce((U,N)=>{const L=m.get(N.toLowerCase());return U.add(L?`uuid:${L}`:`id:${N.toLowerCase()}`)},new Set),h=A(i,o,l);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const U=A(r,i,l),N=A(r,o,l),L=(F,O)=>{const W=i.get(F);if(W){const H=o.get(F),te=O?H:W;return{...te,version:H.version&&(!W.installed||n.gt(H.version,W.version))?H.version:W.version,state:I(W,H,r?.get(F)),preRelease:(0,k.isUndefined)(te.preRelease)?W.preRelease:W.installed?te.preRelease:H.preRelease}}};for(const F of N.removed.values()){const O=i.get(F);O&&S.push(O.identifier)}for(const F of N.added.values())if(U.added.has(F)){if(h.updated.has(F)){const O=L(F,!0);O&&(w.push(P(O,F)),a.set(F,O))}}else{const O=o.get(F);O.installed&&d.push(P(O,F))}for(const F of N.updated.values()){const O=L(F,!0);O&&(w.push(P(O,F)),a.set(F,O))}for(const F of U.added.values())N.added.has(F)||a.set(F,i.get(F));for(const F of U.updated.values())if(!N.removed.has(F)&&!N.updated.has(F)){const O=L(F,!1);O&&(a.get(F)?.installed&&(O.installed=!0),a.set(F,O))}for(const F of U.removed.values())!s.has(F)&&!N.updated.has(F)&&r?.get(F)?.installed&&a.delete(F)}const b=[],_=A(o,a,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&a.forEach((U,N)=>b.push(P(U,N))),{local:{added:d,removed:S,updated:w},remote:b.length?{added:[..._.added].map(U=>a.get(U)),updated:[..._.updated].map(U=>a.get(U)),removed:[..._.removed].map(U=>o.get(U)),all:b}:null}}e.merge=T;function A(p,y,g,{checkInstalledProperty:v,checkVersionProperty:f}={checkInstalledProperty:!1,checkVersionProperty:!1}){const d=p?[...p.keys()].filter(t=>!g.has(t)):[],S=[...y.keys()].filter(t=>!g.has(t)),w=S.filter(t=>d.indexOf(t)===-1).reduce((t,c)=>(t.add(c),t),new Set),m=d.filter(t=>S.indexOf(t)===-1).reduce((t,c)=>(t.add(c),t),new Set),u=new Set;for(const t of d){if(m.has(t))continue;const c=p.get(t),i=y.get(t);(!i||c.disabled!==i.disabled||c.installed&&i.installed&&c.preRelease!==i.preRelease||!C(c.state,i.state)||f&&c.version!==i.version||v&&c.installed!==i.installed)&&u.add(t)}return{added:w,removed:m,updated:u}}function I(p,y,g){const v=p.state,f=y.state,d=g?.state;if(!y.version||v&&n.gt(p.version,y.version))return v;if(f&&n.gt(y.version,p.version)||!v)return f;if(!f)return v;const S=(0,D.deepClone)(v),w=d?E(d,f):{added:Object.keys(f).reduce((u,t)=>(u.add(t),u),new Set),removed:new Set,updated:new Set},m=d?E(d,v):{added:Object.keys(v).reduce((u,t)=>(u.add(t),u),new Set),removed:new Set,updated:new Set};for(const u of[...w.added.values(),...w.updated.values()])S[u]=f[u];for(const u of w.removed.values())m.updated.has(u)||delete S[u];return S}function E(p,y){const g=Object.keys(p),v=Object.keys(y),f=v.filter(w=>g.indexOf(w)===-1).reduce((w,m)=>(w.add(m),w),new Set),d=g.filter(w=>v.indexOf(w)===-1).reduce((w,m)=>(w.add(m),w),new Set),S=new Set;for(const w of g){if(d.has(w))continue;const m=p[w],u=y[w];(0,D.equals)(m,u)||S.add(w)}return{added:f,removed:d,updated:S}}function C(p={},y={}){const{added:g,removed:v,updated:f}=E(p,y);return g.size===0&&v.size===0&&f.size===0}function R(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function P(p,y){const g={identifier:{id:p.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!p.preRelease};return p.version&&(g.version=p.version),p.disabled&&(g.disabled=!0),p.installed&&(g.installed=!0),p.state&&(g.state=p.state),g}}),define(ie[104],re([0,1,17,18,6]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,E){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return C=C.filter(R=>R!==I&&R!==`-${I}`),E&&C.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(I,E){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return C=C.filter(R=>R!==I&&R!==`-${I}`),E&&C.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(I){const E=I.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),R=[],P=[];if(Array.isArray(C))for(const p of C)p.startsWith("-")?P.push(p.substring(1)):R.push(p);return(0,D.distinct)([...E,...R].filter(p=>P.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};T=de([Y(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ie[230],re([0,1,17,33,28,164,54]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(m){return(0,n.parse)(m)||[]}e.parseKeybindings=I;async function E(m,u,t,c,i){const o=I(m),a=I(u),r=t?I(t):null,s=[...o,...a,...r||[]].map(H=>H.key),l=await i.resolveUserBindings(s);let h=R(o,a,r,l);if(!h.hasLocalForwarded&&!h.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!h.hasLocalForwarded&&h.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(h.hasLocalForwarded&&!h.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const b=p(o),_=p(a),U=r?p(r):null,N=g(b,_,l),L=U?g(U,b,l):{added:[...b.keys()].reduce((H,te)=>(H.add(te),H),new Set),removed:new Set,updated:new Set},F=U?g(U,_,l):{added:[..._.keys()].reduce((H,te)=>(H.add(te),H),new Set),removed:new Set,updated:new Set},O=C(N,L,F);let W=m;for(const H of O.removed.values())O.conflicts.has(H)||(W=S(W,H,c));for(const H of O.added.values()){if(O.conflicts.has(H))continue;const te=_.get(H);if(te.some(G=>G.command!==`-${H}`&&h.conflicts.has(l[G.key]))){O.conflicts.add(H);continue}W=d(W,te,c)}for(const H of O.updated.values()){if(O.conflicts.has(H))continue;const te=_.get(H);if(te.some(G=>G.command!==`-${H}`&&h.conflicts.has(l[G.key]))){O.conflicts.add(H);continue}W=w(W,H,te,c)}return{mergeContent:W,hasChanges:!0,hasConflicts:O.conflicts.size>0}}e.merge=E;function C(m,u,t){const c=new Set,i=new Set,o=new Set,a=new Set;for(const r of u.removed.values())t.updated.has(r)&&a.add(r);for(const r of t.removed.values())a.has(r)||(u.updated.has(r)?a.add(r):i.add(r));for(const r of u.added.values())a.has(r)||t.added.has(r)&&m.updated.has(r)&&a.add(r);for(const r of t.added.values())a.has(r)||(u.added.has(r)?m.updated.has(r)&&a.add(r):c.add(r));for(const r of u.updated.values())a.has(r)||t.updated.has(r)&&m.updated.has(r)&&a.add(r);for(const r of t.updated.values())a.has(r)||(u.updated.has(r)?m.updated.has(r)&&a.add(r):o.add(r));return{added:c,removed:i,updated:o,conflicts:a}}function R(m,u,t,c){const i=new Set,o=P(m,c),a=P(u,c),r=t?P(t,c):null,s=y(o,a);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const l=r?y(r,o):{added:[...o.keys()].reduce((L,F)=>(L.add(F),L),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const h=r?y(r,a):{added:[...a.keys()].reduce((L,F)=>(L.add(F),L),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:b,removed:_,updated:U,conflicts:N}=C(s,l,h);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:b,removed:_,updated:U,conflicts:N}}function P(m,u){const t=new Map;for(const c of m){const i=u[c.key];let o=t.get(i);o||(o=[],t.set(i,o)),o.push(c)}return t}function p(m){const u=new Map;for(const t of m){const c=t.command[0]==="-"?t.command.substring(1):t.command;let i=u.get(c);i||(i=[],u.set(c,i)),i.push(t)}return u}function y(m,u){const t=[...m.keys()],c=[...u.keys()],i=c.filter(r=>t.indexOf(r)===-1).reduce((r,s)=>(r.add(s),r),new Set),o=t.filter(r=>c.indexOf(r)===-1).reduce((r,s)=>(r.add(s),r),new Set),a=new Set;for(const r of t){if(o.has(r))continue;const s=m.get(r).map(h=>({...h,key:r})),l=u.get(r).map(h=>({...h,key:r}));(0,D.equals)(s,l,(h,b)=>f(h,b))||a.add(r)}return{added:i,removed:o,updated:a}}function g(m,u,t){const c=[...m.keys()],i=[...u.keys()],o=i.filter(s=>c.indexOf(s)===-1).reduce((s,l)=>(s.add(l),s),new Set),a=c.filter(s=>i.indexOf(s)===-1).reduce((s,l)=>(s.add(l),s),new Set),r=new Set;for(const s of c){if(a.has(s))continue;const l=m.get(s).map(b=>({...b,key:t[b.key]})),h=u.get(s).map(b=>({...b,key:t[b.key]}));v(l,h)||r.add(s)}return{added:o,removed:a,updated:r}}function v(m,u){return!(!(0,D.equals)(m.filter(({command:t})=>t[0]!=="-"),u.filter(({command:t})=>t[0]!=="-"),(t,c)=>f(t,c))||!(0,D.equals)(m.filter(({command:t})=>t[0]==="-"),u.filter(({command:t})=>t[0]==="-"),(t,c)=>f(t,c)))}function f(m,u){if(m.command!==u.command||m.key!==u.key)return!1;const t=T.ContextKeyExpr.deserialize(m.when),c=T.ContextKeyExpr.deserialize(u.when);return!(t&&!c||!t&&c||t&&c&&!t.equals(c)||!k.equals(m.args,u.args))}function d(m,u,t){for(const c of u)m=A.edit(m,[-1],c,t);return m}function S(m,u,t){const c=I(m);for(let i=c.length-1;i>=0;i--)(c[i].command===u||c[i].command===`-${u}`)&&(m=A.edit(m,[i],void 0,t));return m}function w(m,u,t,c){const i=I(m),o=i.findIndex(a=>a.command===u||a.command===`-${u}`);for(let a=i.length-1;a>=0;a--)(i[a].command===u||i[a].command===`-${u}`)&&(m=A.edit(m,[a],void 0,c));for(let a=t.length-1;a>=0;a--)m=A.edit(m,[o],t[a],c);return m}}),define(ie[231],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,I){const E={},C={},R=new Set;if(!A)return{local:{added:E,updated:C,removed:[...R.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const P=n(T,A);if(P.added.size===0&&P.removed.size===0&&P.updated.size===0)return{local:{added:E,updated:C,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=n(I,T),y=n(I,A),g={},v={},f=new Set,d=new Set;for(const S of p.removed.values())y.updated.has(S)?E[S]=A[S]:f.add(S);for(const S of y.removed.values())d.has(S)||(p.updated.has(S)?d.add(S):R.add(S));for(const S of p.updated.values())d.has(S)||(y.updated.has(S)?P.updated.has(S)&&d.add(S):v[S]=T[S]);for(const S of y.updated.values())d.has(S)||(p.updated.has(S)?P.updated.has(S)&&d.add(S):T[S]!==void 0&&(C[S]=A[S]));for(const S of p.added.values())d.has(S)||(y.added.has(S)?P.updated.has(S)&&d.add(S):g[S]=T[S]);for(const S of y.added.values())d.has(S)||(p.added.has(S)?P.updated.has(S)&&d.add(S):E[S]=A[S]);return{local:{added:E,removed:[...R.values()],updated:C},remote:{added:g,removed:[...f.values()],updated:v},conflicts:[...d.values()]}}e.merge=D;function n(T,A){const I=T?Object.keys(T):[],E=A?Object.keys(A):[],C=E.filter(p=>I.indexOf(p)===-1).reduce((p,y)=>(p.add(y),p),new Set),R=I.filter(p=>E.indexOf(p)===-1).reduce((p,y)=>(p.add(y),p),new Set),P=new Set;for(const p of I){if(R.has(p))continue;const y=T[p],g=A[p];y!==g&&P.add(p)}return{added:C,removed:R,updated:P}}function k(T,A){const{added:I,removed:E,updated:C}=n(T,A);return I.size===0&&E.size===0&&C.size===0}e.areSame=k}),define(ie[24],re([0,1,17,20,15,155,42,29,6,95,38]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const r=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(s=>!!r[s].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function p(){const r=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(r).filter(b=>!!r[b].ignoreSync),l=Object.keys(r).filter(b=>r[b].scope===2||r[b].scope===6),h=P();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...s,...l,...h])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const r="vscode://schemas/ignoredSettings",s=R.Registry.as(A.Extensions.Configuration);s.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=R.Registry.as(C.Extensions.JSONContribution),h=()=>{const b=P(),_=p().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(A.allSettings.properties).filter(F=>_.indexOf(F)===-1),N=_.filter(F=>b.indexOf(F)===-1),L={items:{type:"string",enum:[...U,...N.map(F=>`-${F}`)]}};l.registerSchema(r,L)};return s.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=y;function g(r){return r&&(0,k.isObject)(r)&&(0,k.isString)(r.id)&&(0,k.isArray)(r.scopes)}e.isAuthenticationProvider=g;var v;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(v=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function f(r,s,l){return l.joinPath(s.userDataSyncHome,r,`lastSync${r}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(r){const s={};return s[e.HEADER_EXECUTION_ID]=r,s}e.createSyncHeaders=d;var S;(function(r){r.Unauthorized="Unauthorized",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.UnresolvedConflicts="UnresolvedConflicts",r.Unknown="Unknown"})(S=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(s,l,h,b){super(s);this.code=l,this.resource=h,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class m extends w{constructor(s,l,h,b,_){super(s,h,void 0,_);this.url=l,this.serverCode=b}}e.UserDataSyncStoreError=m;class u extends w{constructor(s,l){super(s,l)}}e.UserDataAutoSyncError=u,function(r){function s(l){if(l instanceof r)return l;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(h&&h[1]){const b=h[2]==="unknown"?void 0:h[2],_=h[3]==="unknown"?void 0:h[3];return new r(l.message,h[1],b,_)}return new r(l.message,"Unknown")}r.toUserDataSyncError=s}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var c;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var i;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(r){return`sync.enable.${r}`}e.getEnablementKey=o,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(r,s){if(r.scheme!==e.USER_DATA_SYNC_SCHEME)return r=r.with({scheme:s.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,n.isEqualOrParent)(r,(0,n.joinPath)(s.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(ie[44],re([0,1,17,5,16,25,3,33,2,26,15,7,151,18,13,14,9,46,21,22,32,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function t(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&(Object.keys(r).length===2||Object.keys(r).length===3&&r.machineId!==void 0&&typeof r.machineId=="string"))}e.isSyncData=t;let c=class extends E.Disposable{constructor(s,l,h,b,_,U,N,L,F,O,W){super();this.resource=s,this.fileService=l,this.environmentService=h,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=U,this.userDataSyncEnablementService=N,this.telemetryService=L,this.logService=F,this.configurationService=O,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(h.userDataSyncHome,s),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(s,h,this.extUri),this.currentMachineIdPromise=(0,d.getServiceMachineId)(h,l,b)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const s=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(s.remoteUserData,s.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const s=await this.getLastSyncUserData();(s?await this.hasRemoteChanged(s):!0)&&this._onDidChangeLocal.fire()}}setStatus(s){if(this._status!==s){const l=this._status;s==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&s==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=s,this._onDidChangStatus.fire(s)}}async sync(s,l={}){await this._sync(s,!0,this.getUserDataSyncConfiguration(),l)}async preview(s,l,h={}){return this._sync(s,!1,l,h)}async apply(s,l={}){try{this.syncHeaders={...l};const h=await this.doApply(s);return this.setStatus(h),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(s,l,h,b){try{if(this.syncHeaders={...b},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const U=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(s,U);return _=await this.performSync(N,U,l,h),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(s){const l=await this.resolveContent(s);if(!l)return!1;const h=this.parseSyncData(l);if(!h)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,b),U=await this.isRemoteDataFromCurrentMachine(_),N=await this.generateSyncPreview({ref:_.ref,syncData:h},b,U,this.getUserDataSyncConfiguration(),T.CancellationToken.None),L=[];for(const F of N){const O=await this.getAcceptResult(F,F.remoteResource,void 0,T.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,T.CancellationToken.None);L.push([F,{...O,remoteChange:W!==0?W:2}])}await this.applyResult(_,b,L,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(s){const l=await this.currentMachineIdPromise;return!!s.syncData?.machineId&&s.syncData.machineId===l}async getLatestRemoteUserData(s,l){if(l){const h=s&&s.latest?s.latest[this.resource]:void 0;if(l.ref===h||h===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(s,l,h,b){if(s.syncData&&s.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,s.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(s,l,h,b)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(s,l,h,b);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),s=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(s,l,h,b)}throw _}}async doSync(s,l,h,b){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(s,l,h,b,U)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":h?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(s){return await this.updateSyncResourcePreview(s,async l=>{const h=await this.getMergeResult(l,T.CancellationToken.None);await this.fileService.writeFile(l.previewResource,k.VSBuffer.fromString(h?.content||""));const b=h&&!h.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,T.CancellationToken.None):void 0;return l.acceptResult=b,l.mergeState=h.hasConflicts?"conflict":b?"accepted":"preview",l.localChange=b?b.localChange:h.localChange,l.remoteChange=b?b.remoteChange:h.remoteChange,l}),this.syncPreviewPromise}async accept(s,l){return await this.updateSyncResourcePreview(s,async h=>{const b=await this.getAcceptResult(h,s,l,T.CancellationToken.None);return h.acceptResult=b,h.mergeState="accepted",h.localChange=b.localChange,h.remoteChange=b.remoteChange,h}),this.syncPreviewPromise}async discard(s){return await this.updateSyncResourcePreview(s,async l=>{const h=await this.getMergeResult(l,T.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,k.VSBuffer.fromString(h.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=h.localChange,l.remoteChange=h.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(s,l){if(!this.syncPreviewPromise)return;let h=await this.syncPreviewPromise;const b=h.resourcePreviews.findIndex(({localResource:_,remoteResource:U,previewResource:N})=>this.extUri.isEqual(_,s)||this.extUri.isEqual(U,s)||this.extUri.isEqual(N,s));b!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const U=[...h.resourcePreviews];return U[b]=await l(U[b]),{...h,resourcePreviews:U}}),h=await this.syncPreviewPromise,this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(s){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:h})=>h==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:h})=>h!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(h=>[h,h.acceptResult]),s),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(s){const l=s.filter(({mergeState:h})=>h==="conflict");(0,D.equals)(this._conflicts,l,(h,b)=>this.extUri.isEqual(h.previewResource,b.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){const s=await this.getLastSyncUserData();return!!s&&s.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:h})=>({created:l,uri:this.toRemoteBackupResource(h)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:h})=>({created:l,uri:this.toLocalBackupResource(h)}))}toRemoteBackupResource(s){return P.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${s}`})}toLocalBackupResource(s){return P.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${s}`})}async getMachineId({uri:s}){const l=this.extUri.basename(s);if(this.extUri.isEqual(s,this.toRemoteBackupResource(l))){const{content:h}=await this.getUserData(l);if(h)return this.parseSyncData(h)?.machineId}}async resolveContent(s){const l=this.extUri.basename(s);if(this.extUri.isEqual(s,this.toRemoteBackupResource(l))){const{content:h}=await this.getUserData(l);return h}return this.extUri.isEqual(s,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(s){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const h of l.resourcePreviews){if(this.extUri.isEqual(h.acceptedResource,s))return h.acceptResult?h.acceptResult.content:null;if(this.extUri.isEqual(h.remoteResource,s))return h.remoteContent;if(this.extUri.isEqual(h.localResource,s))return h.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(s,l,h,b,_){const U=await this.isRemoteDataFromCurrentMachine(s),N=await this.generateSyncPreview(s,l,U,b,_),L=[];for(const F of N){const O=F.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)L.push({...F,acceptedResource:O,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=h?await this.getMergeResult(F,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,k.VSBuffer.fromString(W?.content||""));const H=W&&!W.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,_):void 0;L.push({...F,acceptResult:H,mergeState:W?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:W?W.localChange:F.localChange,remoteChange:H?H.remoteChange:W?W.remoteChange:F.remoteChange})}}return{remoteUserData:s,lastSyncUserData:l,resourcePreviews:L,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const s=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(s.value.toString()),h=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&h&&l.version!==h,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${h}.`),await this.resetLocal(),null;const b=l;if(b.content===null)return{ref:l.ref,syncData:null};const _=JSON.parse(b.content);if(t(_))return{...l,syncData:_,content:void 0}}catch(s){s instanceof v.FileOperationError&&s.fileOperationResult===1||this.logService.error(s)}return null}async updateLastSyncUserData(s,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const h=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),b={ref:s.ref,content:s.syncData?JSON.stringify(s.syncData):null,version:h,...l};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(b)))}async getRemoteUserData(s){const{ref:l,content:h}=await this.getUserData(s);let b=null;return h!==null&&(b=this.parseSyncData(h)),{ref:l,syncData:b}}parseSyncData(s){try{const l=JSON.parse(s);if(t(l))return l}catch(l){this.logService.error(l)}throw new u.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(s){if((0,R.isString)(s)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,s);return{ref:s,content:l}}else{const l=s?{ref:s.ref,content:s.syncData?JSON.stringify(s.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(s,l){const h=await this.currentMachineIdPromise,b={version:this.version,machineId:h,content:s};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(b),l,this.syncHeaders),{ref:l,syncData:b}}async backupLocal(s){const l={version:this.version,content:s};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=de([Y(1,v.IFileService),Y(2,g.IEnvironmentService),Y(3,S.IStorageService),Y(4,u.IUserDataSyncStoreService),Y(5,u.IUserDataSyncBackupStoreService),Y(6,u.IUserDataSyncEnablementService),Y(7,w.ITelemetryService),Y(8,u.IUserDataSyncLogService),Y(9,y.IConfigurationService),Y(10,m.IUriIdentityService)],c),e.AbstractSynchroniser=c;let i=class extends c{constructor(s,l,h,b,_,U,N,L,F,O,W,H){super(l,h,b,_,U,N,L,F,O,W,H);this.file=s,this._register(this.fileService.watch(this.extUri.dirname(s))),this._register(this.fileService.onDidFilesChange(te=>this.onFileChanges(te)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(s,l,h){try{l?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(s),h?void 0:l):await this.fileService.createFile(this.file,k.VSBuffer.fromString(s),{overwrite:h})}catch(b){throw b instanceof v.FileOperationError&&b.fileOperationResult===1||b instanceof v.FileOperationError&&b.fileOperationResult===3?new u.UserDataSyncError(b.message,"LocalPreconditionFailed"):b}}onFileChanges(s){!s.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,v.IFileService),Y(3,g.IEnvironmentService),Y(4,S.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncEnablementService),Y(8,w.ITelemetryService),Y(9,u.IUserDataSyncLogService),Y(10,y.IConfigurationService),Y(11,m.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let o=class extends i{constructor(s,l,h,b,_,U,N,L,F,O,W,H,te){super(s,l,h,b,_,U,N,L,F,O,H,te);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(s){const l=[];return(0,I.parse)(s,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=de([Y(2,v.IFileService),Y(3,g.IEnvironmentService),Y(4,S.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncEnablementService),Y(8,w.ITelemetryService),Y(9,u.IUserDataSyncLogService),Y(10,u.IUserDataSyncUtilService),Y(11,y.IConfigurationService),Y(12,m.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let a=class{constructor(s,l,h,b,_){this.resource=s,this.environmentService=l,this.logService=h,this.fileService=b,this.extUri=_.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,l,this.extUri)}async initialize({ref:s,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const h=this.parseSyncData(l);if(!!h)try{await this.doInitialize({ref:s,syncData:h})}catch(b){this.logService.error(b)}}parseSyncData(s){try{const l=JSON.parse(s);if(t(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(s,l={}){const h={ref:s.ref,content:s.syncData?JSON.stringify(s.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(h)))}};a=de([Y(1,g.IEnvironmentService),Y(2,f.ILogService),Y(3,v.IFileService),Y(4,m.IUriIdentityService)],a),e.AbstractInitializer=a}),define(ie[232],re([0,1,5,25,8,3,49,26,7,18,13,29,31,65,14,9,21,22,32,44,229,104,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(a,r){const s=JSON.parse(a.content);if(a.version===1||a.version===2){const l=(await r.getInstalled(0)).filter(h=>h.isBuiltin);for(const h of s)a.version===1&&(h.enabled===!1&&(h.disabled=!0),delete h.enabled),a.version===2&&l.every(b=>!(0,p.areSameExtensions)(b.identifier,h.identifier))&&(h.installed=!0)}return s}let i=class ft extends w.AbstractSynchroniser{constructor(r,s,l,h,b,_,U,N,L,F,O,W,H,te,G){super("extensions",s,r,l,h,b,W,H,L,O,G);this.extensionManagementService=_,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=N,this.extensionGalleryService=F,this.extensionStorageService=te,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:q})=>!!q)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(r,s){const l=r.syncData?await c(r.syncData,this.extensionManagementService):null,h=s?.skippedExtensions||[],b=s?.syncData?await c(s.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),U=this.getLocalExtensions(_),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);l?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:L,remote:F}=(0,m.merge)(U,l,b,h,N),O={local:L,remote:F,content:this.getPreviewContent(U,L.added,L.updated,L.removed),localChange:L.added.length>0||L.removed.length>0||L.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:h,localResource:this.localResource,localContent:this.stringify(U,!1),localExtensions:U,remoteResource:this.remoteResource,remoteContent:l?this.stringify(l,!1):null,previewResource:this.previewResource,previewResult:O,localChange:O.localChange,remoteChange:O.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const s=r.syncData?await c(r.syncData,this.extensionManagementService):null,l=await this.extensionManagementService.getInstalled(void 0,!0),h=this.getLocalExtensions(l),b=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),{remote:_}=(0,m.merge)(h,s,s,r.skippedExtensions||[],b);return _!==null}getPreviewContent(r,s,l,h){const b=[...s,...l],_=new Set,U=N=>{_.add(N.id.toLowerCase()),N.uuid&&_.add(N.uuid)};b.forEach(({identifier:N})=>U(N)),h.forEach(U);for(const N of r)_.has(N.identifier.id.toLowerCase())||N.identifier.uuid&&_.has(N.identifier.uuid)||b.push(N);return this.stringify(b,!1)}async getMergeResult(r,s){return{...r.previewResult,hasConflicts:!1}}async getAcceptResult(r,s,l,h){if(this.extUri.isEqual(s,this.localResource))return this.acceptLocal(r);if(this.extUri.isEqual(s,this.remoteResource))return this.acceptRemote(r);if(this.extUri.isEqual(s,this.previewResource))return r.previewResult;throw new Error(`Invalid Resource: ${s.toString()}`)}async acceptLocal(r){const s=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(s),h=(0,m.merge)(r.localExtensions,null,null,r.skippedExtensions,l),{local:b,remote:_}=h;return{content:r.localContent,local:b,remote:_,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(r){const s=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(s),h=r.remoteContent?JSON.parse(r.remoteContent):null;if(h!==null){const b=(0,m.merge)(r.localExtensions,h,r.localExtensions,[],l),{local:_,remote:U}=b;return{content:r.remoteContent,local:_,remote:U,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:r.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(r,s,l,h){let{skippedExtensions:b,localExtensions:_}=l[0][0],{local:U,remote:N,localChange:L,remoteChange:F}=l[0][1];if(L===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),L!==0&&(await this.backupLocal(JSON.stringify(_)),b=await this.updateLocalExtensions(U.added,U.removed,U.updated,b)),N){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const O=JSON.stringify(N.all);r=await this.updateRemoteUserData(O,h?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${N.added.length?` Added: ${JSON.stringify(N.added.map(W=>W.identifier.id))}.`:""}${N.updated.length?` Updated: ${JSON.stringify(N.updated.map(W=>W.identifier.id))}.`:""}${N.removed.length?` Removed: ${JSON.stringify(N.removed.map(W=>W.identifier.id))}.`:""}`)}s?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(r,{skippedExtensions:b}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${b.length?` Skipped: ${JSON.stringify(b.map(O=>O.identifier.id))}.`:""}`))}async getAssociatedResources({uri:r}){return[{resource:this.extUri.joinPath(r,"extensions.json"),comparableResource:ft.EXTENSIONS_DATA_URI}]}async resolveContent(r){if(this.extUri.isEqual(r,ft.EXTENSIONS_DATA_URI)){const l=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),b=this.getLocalExtensions(l).filter(_=>!h.some(U=>(0,p.areSameExtensions)({id:U},_.identifier)));return this.stringify(b,!0)}if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)){const l=await this.resolvePreviewContent(r);return l&&this.stringify(JSON.parse(l),!0)}let s=await super.resolveContent(r);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(r)),s){const l=this.parseSyncData(s);if(l)switch(this.extUri.basename(r)){case"extensions.json":return this.stringify(this.parseExtensions(l),!0)}}return null}stringify(r,s){return r.sort((l,h)=>!l.identifier.uuid&&h.identifier.uuid?-1:l.identifier.uuid&&!h.identifier.uuid?1:(0,I.compare)(l.identifier.id,h.identifier.id)),s?(0,A.toFormattedString)(r,{}):JSON.stringify(r)}async hasLocalData(){try{const r=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(r).some(l=>l.installed||l.disabled))return!0}catch{}return!1}async updateLocalExtensions(r,s,l,h){const b=[],_=[],U=await this.extensionManagementService.getInstalled();if(s.length){const L=U.filter(({identifier:F,isBuiltin:O})=>!O&&s.some(W=>(0,p.areSameExtensions)(F,W)));await D.Promises.settled(L.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),b.push(F.identifier)}))}(r.length||l.length)&&await D.Promises.settled([...r,...l].map(async L=>{const F=U.find(W=>(0,p.areSameExtensions)(W.identifier,L.identifier));if(F&&F.isBuiltin){L.state&&F.manifest.version===L.version&&this.updateExtensionState(L.state,F,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,L.identifier))!==!!L.disabled&&(L.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,L.identifier.id),await this.extensionEnablementService.disableExtension(L.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,L.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,L.identifier.id),await this.extensionEnablementService.enableExtension(L.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,L.identifier.id))),b.push(L.identifier);return}const O=(await this.extensionGalleryService.getExtensions([{...L.identifier,preRelease:L.preRelease}],n.CancellationToken.None))[0];if(L.state&&(F?F.manifest.version===L.version:!!O)&&this.updateExtensionState(L.state,F||O,F?.manifest.version),O)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,L.identifier))!==!!L.disabled&&(L.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,L.identifier.id,O.version),await this.extensionEnablementService.disableExtension(O.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,L.identifier.id,O.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,L.identifier.id,O.version),await this.extensionEnablementService.enableExtension(O.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,L.identifier.id,O.version))),(!F||F.preRelease!==L.preRelease)&&(await this.extensionManagementService.canInstall(O)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,L.identifier.id,O.version),await this.extensionManagementService.installFromGallery(O,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:L.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,L.identifier.id,O.version),b.push(O.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,O.displayName||O.identifier.id),_.push(L)))}catch(W){_.push(L),W instanceof P.ExtensionManagementError&&[P.ExtensionManagementErrorCode.Incompatible,P.ExtensionManagementErrorCode.IncompatiblePreRelease,P.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(W.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,O.displayName||O.identifier.id):(this.logService.error(W),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,O.displayName||O.identifier.id))}else _.push(L),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,L.identifier.id)}));const N=[];for(const L of h)b.some(F=>(0,p.areSameExtensions)(F,L.identifier))||N.push(L);for(const L of _)N.some(F=>(0,p.areSameExtensions)(F.identifier,L.identifier))||N.push(L);return N}updateExtensionState(r,s,l){const h=this.extensionStorageService.getExtensionState(s,!0)||{},b=l?this.extensionStorageService.getKeysForSync({id:s.identifier.id,version:l}):void 0;b?b.forEach(_=>{h[_]=r[_]}):Object.keys(r).forEach(_=>h[_]=r[_]),this.extensionStorageService.setExtensionState(s,h,!0)}parseExtensions(r){return JSON.parse(r.content)}getLocalExtensions(r){const s=this.extensionEnablementService.getDisabledExtensions();return r.map(l=>{const{identifier:h,isBuiltin:b,manifest:_,preRelease:U}=l,N={identifier:h,preRelease:U,version:_.version};s.some(L=>(0,p.areSameExtensions)(L,h))&&(N.disabled=!0),b||(N.installed=!0);try{const L=this.extensionStorageService.getKeysForSync({id:h.id,version:_.version});if(L){const F=this.extensionStorageService.getExtensionState(l,!0)||{};N.state=Object.keys(F).reduce((O,W)=>(L.includes(W)&&(O[W]=F[W]),O),{})}}catch(L){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(L))}return N})}};i.EXTENSIONS_DATA_URI=E.URI.from({scheme:t.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,R.IEnvironmentService),Y(1,g.IFileService),Y(2,f.IStorageService),Y(3,t.IUserDataSyncStoreService),Y(4,t.IUserDataSyncBackupStoreService),Y(5,P.IExtensionManagementService),Y(6,P.IGlobalExtensionEnablementService),Y(7,u.IIgnoredExtensionsManagementService),Y(8,t.IUserDataSyncLogService),Y(9,P.IExtensionGalleryService),Y(10,C.IConfigurationService),Y(11,t.IUserDataSyncEnablementService),Y(12,d.ITelemetryService),Y(13,y.IExtensionStorageService),Y(14,S.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let o=class extends w.AbstractInitializer{constructor(r,s,l,h,b,_){super("extensions",h,b,l,_);this.extensionManagementService=r,this.ignoredExtensionsManagementService=s}async parseExtensions(r){return r.syncData?await c(r.syncData,this.extensionManagementService):null}generatePreview(r,s){const l=[],h=[],b=[];for(const _ of r){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const U=s.find(N=>(0,p.areSameExtensions)(N.identifier,_.identifier));U?(l.push(U),_.disabled&&b.push(_.identifier)):_.installed&&(h.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&b.push(_.identifier))}return{installedExtensions:l,newExtensions:h,disabledExtensions:b,remoteExtensions:r}}};o=de([Y(0,P.IExtensionManagementService),Y(1,u.IIgnoredExtensionsManagementService),Y(2,g.IFileService),Y(3,R.IEnvironmentService),Y(4,v.ILogService),Y(5,S.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ie[233],re([0,1,28,24]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(I,E,C,R,P){if(!E)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const p=T(I,E);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=C?T(C,E):{added:Object.keys(E).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},g=C?T(C,I):{added:Object.keys(I).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},v={added:{},removed:[],updated:{}},f=D.deepClone(E),d=!C;for(const S of g.added.values())S!==n.SYNC_SERVICE_URL_TYPE&&d&&y.added.has(S)||(f[S]=I[S]);for(const S of g.updated.values())f[S]=I[S];for(const S of g.removed.values())R.unregistered.includes(S)||delete f[S];for(const S of y.added.values()){const w=E[S];if(R.machine.includes(S)){P.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(C&&g.added.has(S))continue;const m=I[S];m&&m.value===w.value||S===n.SYNC_SERVICE_URL_TYPE&&d&&g.added.has(S)||(m?v.updated[S]=w:v.added[S]=w)}for(const S of y.updated.values()){const w=E[S];if(R.machine.includes(S)){P.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(S)||g.removed.has(S))continue;const m=I[S];m&&m.value===w.value||(v.updated[S]=w)}for(const S of y.removed.values()){if(R.machine.includes(S)){P.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}g.updated.has(S)||g.removed.has(S)||v.removed.push(S)}return{local:v,remote:A(f,E)?null:f}}e.merge=k;function T(I,E){const C=Object.keys(I),R=Object.keys(E),P=R.filter(g=>C.indexOf(g)===-1).reduce((g,v)=>(g.add(v),g),new Set),p=C.filter(g=>R.indexOf(g)===-1).reduce((g,v)=>(g.add(v),g),new Set),y=new Set;for(const g of C){if(p.has(g))continue;const v=I[g],f=E[g];D.equals(v,f)||y.add(g)}return{added:P,removed:p,updated:y}}function A(I,E){const{added:C,removed:R,updated:P}=T(I,E);return C.size===0&&R.size===0&&P.size===0}}),define(ie[234],re([0,1,16,8,3,33,49,4,7,30,18,13,14,9,46,21,22,32,44,54,233,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",c=["locale"];function i(l,h){const b=l.storage?Object.keys(l.storage).sort():[],_={};return b.forEach(U=>_[U]=l.storage[U]),l.storage=_,h?(0,A.toFormattedString)(l,{}):JSON.stringify(l)}const o=1;let a=class gt extends S.AbstractSynchroniser{constructor(h,b,_,U,N,L,F,O,W,H){super("globalState",h,N,W,b,_,L,F,U,O,H);this.storageService=W,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(h.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(h.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),k.Event.filter(W.onDidChangeValue,te=>te.scope===0&&te.target!==void 0?te.target===0:W.keys(0,0).includes(te.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(h,b,_){const U=h.syncData?JSON.parse(h.syncData.content):null;b=b===null&&_?h:b;const N=b&&b.syncData?JSON.parse(b.syncData.content):null,L=await this.getLocalGlobalState();U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(N),{local:O,remote:W}=(0,m.merge)(L.storage,U?U.storage:null,N?N.storage:null,F,this.logService),H={content:null,local:O,remote:W,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:W!==null?2:0};return[{localResource:this.localResource,localContent:i(L,!1),localUserData:L,remoteResource:this.remoteResource,remoteContent:U?i(U,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async hasRemoteChanged(h){const b=h.syncData?JSON.parse(h.syncData.content):null;if(b===null)return!0;const _=await this.getLocalGlobalState(),U=this.getStorageKeys(b),{remote:N}=(0,m.merge)(_.storage,b.storage,b.storage,U,this.logService);return N!==null}async getMergeResult(h,b){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,b,_,U){if(this.extUri.isEqual(b,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(b,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(b,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async acceptLocal(h){return{content:h.localContent,local:{added:{},removed:[],updated:{}},remote:h.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(h){if(h.remoteContent!==null){const b=JSON.parse(h.remoteContent),{local:_,remote:U}=(0,m.merge)(h.localUserData.storage,b.storage,null,h.storageKeys,this.logService);return{content:h.remoteContent,local:_,remote:U,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:h.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(h,b,_,U){let{localUserData:N}=_[0][0],{local:L,remote:F,localChange:O,remoteChange:W}=_[0][1];if(O===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),O!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(L),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:F});h=await this.updateRemoteUserData(H,U?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}b?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"globalState.json"),comparableResource:gt.GLOBAL_STATE_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,gt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const _=await this.resolvePreviewContent(h);return _&&i(JSON.parse(_),!0)}let b=await super.resolveContent(h);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(h)),b){const _=this.parseSyncData(b);if(_)switch(this.extUri.basename(h)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:h}=await this.getLocalGlobalState();if(Object.keys(h).length>1||h[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const h={},b=await this.getLocalArgvContent(),_=(0,T.parse)(b);for(const U of c)_[U]!==void 0&&(h[`${t}${U}`]={version:1,value:_[U]});for(const U of this.storageService.keys(0,0)){const N=this.storageService.get(U,0);N&&(h[U]={version:1,value:N})}return{storage:h}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const h=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),h.value.toString()}catch(h){this.logService.debug((0,n.getErrorMessage)(h))}return"{}"}async writeLocalGlobalState({added:h,removed:b,updated:_}){const U={},N={},L=(O,W)=>{for(const H of O){if(H.startsWith(t)){U[H.substring(t.length)]=W?W[H].value:void 0;continue}if(W){const te=W[H];te.value!==String(this.storageService.get(H,0))&&(N[H]=te.value)}else this.storageService.get(H,0)!==void 0&&(N[H]=void 0)}};if(L(Object.keys(h),h),L(Object.keys(_),_),L(b),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const O of Object.keys(N))this.storageService.store(O,N[O],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(h){const b=await this.getLocalArgvContent();let _=b;for(const U of Object.keys(h))_=(0,w.edit)(_,[U],h[U],{});b!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(h){const b=this.storageService.keys(0,0),_=this.storageService.keys(0,1),U=[...b,..._],N=h?.storage?Object.keys(h.storage).filter(L=>!L.startsWith(t)&&!U.includes(L)&&this.storageService.get(L,0)!==void 0):[];if(!I.isWeb){const L=[...u.ALL_SYNC_RESOURCES.map(F=>(0,u.getEnablementKey)(F)),u.SYNC_SERVICE_URL_TYPE];N.push(...L),_.push(...L)}return{user:b,machine:_,unregistered:N}}};a.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([Y(0,p.IFileService),Y(1,u.IUserDataSyncStoreService),Y(2,u.IUserDataSyncBackupStoreService),Y(3,u.IUserDataSyncLogService),Y(4,P.IEnvironmentService),Y(5,u.IUserDataSyncEnablementService),Y(6,f.ITelemetryService),Y(7,R.IConfigurationService),Y(8,v.IStorageService),Y(9,d.IUriIdentityService)],a),e.GlobalStateSynchroniser=a;let r=class extends S.AbstractInitializer{constructor(h,b,_,U,N){super("globalState",_,U,b,N);this.storageService=h}async doInitialize(h){const b=h.syncData?JSON.parse(h.syncData.content):null;if(!b){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},U={};for(const N of Object.keys(b.storage))N.startsWith(t)?_[N.substring(t.length)]=b.storage[N].value:this.storageService.get(N,0)===void 0&&(U[N]=b.storage[N].value);if(Object.keys(_).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const L of Object.keys(_))N=(0,w.edit)(N,[L],_[L],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(U).length)for(const N of Object.keys(U))this.storageService.store(N,U[N],0,0)}};r=de([Y(0,v.IStorageService),Y(1,p.IFileService),Y(2,P.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,d.IUriIdentityService)],r),e.GlobalStateInitializer=r;let s=class{constructor(h,b,_,U,N){this.userDataSyncStoreClient=h,this.storageService=b,this.environmentService=_,this.fileService=U,this.logService=N}getSyncStoreType(h){return this.parseGlobalState(h)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(h){const b=(0,u.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(h,b)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(h,b)}throw _}}async doSync(h,b){const _=await this.userDataSyncStoreClient.read("globalState",null,b),U=this.parseGlobalState(_)||{storage:{}};U.storage[u.SYNC_SERVICE_URL_TYPE]={value:h,version:o};const N=await(0,g.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),L={version:o,machineId:N,content:i(U,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(L),_.ref,b)}parseGlobalState({content:h}){if(!h)return null;const b=JSON.parse(h);if((0,S.isSyncData)(b))return b?JSON.parse(b.content):null;throw new Error("Invalid remote data")}};s=de([Y(1,v.IStorageService),Y(2,P.IEnvironmentService),Y(3,p.IFileService),Y(4,y.ILogService)],s),e.UserDataSyncStoreTypeSynchronizer=s}),define(ie[235],re([0,1,17,16,3,33,4,15,152,18,13,14,21,22,32,44,230,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function S(u,t,c){try{const i=JSON.parse(u);if(!t)return(0,I.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,I.isUndefined)(i.mac)?null:i.mac;case 3:return(0,I.isUndefined)(i.linux)?null:i.linux;case 1:return(0,I.isUndefined)(i.windows)?null:i.windows}}catch(i){return c.error(i),null}}e.getKeybindingsContentFromSyncContent=S;let w=class extends v.AbstractJsonFileSynchroniser{constructor(t,c,i,o,a,r,s,l,h,b,_){super(s.keybindingsResource,"keybindings",r,s,l,t,c,a,b,i,h,o,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(t,c,i,o){const a=t.syncData?S(t.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&i?t:c;const r=c?this.getKeybindingsContentFromLastSyncUserData(c):null,s=await this.getLocalFileContent(),l=await this.getFormattingOptions();let h=null,b=!1,_=!1,U=!1;if(a){let L=s?s.value.toString():"[]";if(L=L||"[]",this.hasErrors(L))throw new d.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!r||r!==L||r!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,f.merge)(L,a,r,l,this.userDataSyncUtilService);F.hasChanges&&(h=F.mergeContent,U=F.hasConflicts,b=U||F.mergeContent!==L,_=U||F.mergeContent!==a)}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=s.value.toString(),_=!0);const N={content:h,localChange:b?s?2:1:0,remoteChange:_?2:0,hasConflicts:U};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const c=this.getKeybindingsContentFromLastSyncUserData(t);if(c===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString():"",a=await this.getFormattingOptions(),r=await(0,f.merge)(o||"[]",c,c,a,this.userDataSyncUtilService);return r.hasConflicts||r.mergeContent!==c}async getMergeResult(t,c){return t.previewResult}async getAcceptResult(t,c,i,o){if(this.extUri.isEqual(c,this.localResource))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:t.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(t,c,i,o){const{fileContent:a}=i[0][0];let{content:r,localChange:s,remoteChange:l}=i[0][1];if(s===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),r!==null&&(r=r.trim(),r=r||"[]",this.hasErrors(r)))throw new d.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(r||"[]",a,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const h=this.toSyncContent(r||"[]",t.syncData?.content);t=await this.updateRemoteUserData(h,o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(t,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const c=(0,T.parse)(t.value.toString());if((0,D.isNonEmptyArray)(c))return!0}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"keybindings.json"),comparableResource:c}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let c=await super.resolveContent(t);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(t)),c){const i=this.parseSyncData(c);if(i)switch(this.extUri.basename(t)){case"keybindings.json":return S(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.syncKeybindingsPerPlatform()?null:S(t.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(t,c){let i={};try{i=JSON.parse(c||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=t,A.OS){case 2:i.mac=t;break;case 3:i.linux=t;break;case 1:i.windows=t;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=de([Y(0,d.IUserDataSyncStoreService),Y(1,d.IUserDataSyncBackupStoreService),Y(2,d.IUserDataSyncLogService),Y(3,C.IConfigurationService),Y(4,d.IUserDataSyncEnablementService),Y(5,P.IFileService),Y(6,R.IEnvironmentService),Y(7,p.IStorageService),Y(8,d.IUserDataSyncUtilService),Y(9,y.ITelemetryService),Y(10,g.IUriIdentityService)],w),e.KeybindingsSynchroniser=w;let m=class extends v.AbstractInitializer{constructor(t,c,i,o){super("keybindings",c,i,t,o)}async doInitialize(t){const c=t.syncData?this.getKeybindingsContentFromSyncContent(t.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(c)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,T.parse)(t.value.toString());return!(0,D.isNonEmptyArray)(c)}catch(t){return t.fileOperationResult===1}}getKeybindingsContentFromSyncContent(t){try{return S(t,!0,this.logService)}catch(c){return this.logService.error(c),null}}};m=de([Y(0,P.IFileService),Y(1,R.IEnvironmentService),Y(2,d.IUserDataSyncLogService),Y(3,g.IUriIdentityService)],m),e.KeybindingsInitializer=m}),define(ie[236],re([0,1,17,33,71,49,28,54,24]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function C(s,l,h){let b=[];h?b=P(h):b=R(l);const _=[],U=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const N of b)N.startsWith("-")?U.push(N.substring(1)):_.push(N);return(0,D.distinct)([...s,..._].filter(N=>U.indexOf(N)===-1))}e.getIgnoredSettings=C;function R(s){let l=s.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=s.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:s.getValue("settingsSync.ignoredSettings")||[]}function P(s){const l=(0,n.parse)(s);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function p(s,l){const h=(0,n.parse)(s)||{};let b="{}";for(const _ of Object.keys(h)){const U=(0,k.setProperty)(b,[_],h[_],l);b=(0,k.applyEdits)(b,U)}return b}e.removeComments=p;function y(s,l,h,b){if(h.length){const _=r(l),U=(0,n.parse)(l)||{},N=(0,n.parse)(s);if(!N)return s;const L=[];for(const F of h){const O=U[F],W=N[F];O===void 0?s=I.edit(s,[F],void 0,b):W!==void 0?s=I.edit(s,[F],O,b):L.push(t(F,_))}L.sort((F,O)=>F.startOffset-O.startOffset),L.forEach(F=>s=S(F.setting.key,l,s,b))}return s}e.updateIgnoredSettings=y;function g(s,l,h,b,_,U){const N=y(s,l,b,U),L=h!==N,F=h!==l;if(!L&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(L&&!F)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(F&&!L)return{conflictsSettings:[],localContent:y(l,s,b,U),remoteContent:null,hasConflicts:!1};if(h===null&&f(s)){const B=v(s,l,b)?null:y(l,s,b,U);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let O=s,W=l;const H=(0,n.parse)(s),te=(0,n.parse)(l),G=h?(0,n.parse)(h):null,$=b.reduce((B,J)=>(B.add(J),B),new Set),q=d(H,te,$),V=d(G,H,$),x=d(G,te,$),K=new Map,Z=new Set,X=B=>{Z.add(B);const J=_.filter(({key:ne})=>ne===B)[0];J?(O=I.edit(O,[B],J.value,U),W=I.edit(W,[B],J.value,U)):K.set(B,{key:B,localValue:H[B],remoteValue:te[B]})};for(const B of V.removed.values())x.updated.has(B)?X(B):W=I.edit(W,[B],void 0,U);for(const B of x.removed.values())Z.has(B)||(V.updated.has(B)?X(B):O=I.edit(O,[B],void 0,U));for(const B of V.updated.values())Z.has(B)||(x.updated.has(B)?q.updated.has(B)&&X(B):W=I.edit(W,[B],H[B],U));for(const B of x.updated.values())Z.has(B)||(V.updated.has(B)?q.updated.has(B)&&X(B):O=I.edit(O,[B],te[B],U));for(const B of V.added.values())Z.has(B)||(x.added.has(B)?q.updated.has(B)&&X(B):W=S(B,O,W,U));for(const B of x.added.values())Z.has(B)||(V.added.has(B)?q.updated.has(B)&&X(B):O=S(B,W,O,U));const z=K.size>0||!v(O,W,b),M=z||!v(O,s,[]),j=z||!v(W,l,[]);return{localContent:M?O:null,remoteContent:j?W:null,conflictsSettings:[...K.values()],hasConflicts:z}}e.merge=g;function v(s,l,h){if(s===l)return!0;const b=(0,n.parse)(s),_=(0,n.parse)(l),U=h.reduce((F,O)=>(F.add(O),F),new Set),N=r(s).filter(F=>!(F.setting&&U.has(F.setting.key))),L=r(l).filter(F=>!(F.setting&&U.has(F.setting.key)));if(N.length!==L.length)return!1;for(let F=0;F<N.length;F++){const O=N[F],W=L[F];if(O.setting&&W.setting){if(O.setting.key!==W.setting.key||!A.equals(b[O.setting.key],_[O.setting.key]))return!1}else if(!O.setting&&!W.setting){if(O.value!==W.value)return!1}else return!1}return!0}e.areSame=v;function f(s){return s?r(s).length===0:!0}e.isEmpty=f;function d(s,l,h){const b=s?Object.keys(s).filter(F=>!h.has(F)):[],_=Object.keys(l).filter(F=>!h.has(F)),U=_.filter(F=>b.indexOf(F)===-1).reduce((F,O)=>(F.add(O),F),new Set),N=b.filter(F=>_.indexOf(F)===-1).reduce((F,O)=>(F.add(O),F),new Set),L=new Set;if(s)for(const F of b){if(N.has(F))continue;const O=s[F],W=l[F];A.equals(O,W)||L.add(F)}return{added:U,removed:N,updated:L}}function S(s,l,h,b){const _=(0,n.parse)(l),U=r(l),N=r(h),L=w(s,U,N);return m(h,s,_[s],L,N,b)}e.addSetting=S;function w(s,l,h){const b=l.findIndex(U=>U.setting?.key===s),_=l[b-1];if(_){if(_.setting){const N=t(_.setting.key,h);if(N)return{index:h.indexOf(N),insertAfter:!0}}else{const N=c(b,l);if(N){const L=t(N.setting.key,h);if(L){const F=i(h.indexOf(L),h),O=o(l,N,l[b]);if(F){const W=o(h,L,F),H=a(O,W);return H?{index:h.indexOf(H),insertAfter:!0}:{index:h.indexOf(F),insertAfter:!1}}else{const W=o(h,L,h[h.length-1]),H=a(O,W);return H?{index:h.indexOf(H),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const U=l[b+1];if(U)if(U.setting){const N=t(U.setting.key,h);if(N)return{index:h.indexOf(N),insertAfter:!1}}else{const N=i(b,l);if(N){const L=t(N.setting.key,h);if(L){const F=c(h.indexOf(L),h),O=o(l,l[b],N);if(F){const W=o(h,F,L),H=a(O.reverse(),W.reverse());return H?{index:h.indexOf(H),insertAfter:!1}:{index:h.indexOf(F),insertAfter:!0}}else{const W=o(h,h[0],L),H=a(O.reverse(),W.reverse());return H?{index:h.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function m(s,l,h,b,_,U){let N;return b.index===-1?N=(0,k.setProperty)(s,[l],h,U):N=u(s,l,h,b,_,U).map(L=>(0,k.withFormatting)(s,L,U)[0]),(0,k.applyEdits)(s,N)}function u(s,l,h,b,_,U){const N=`${JSON.stringify(l)}: ${JSON.stringify(h)}`,L=(0,T.getEOL)(U,s),F=_[b.index];if(b.insertAfter){const O=[];if(F.setting)O.push({offset:F.endOffset,length:0,content:","+N});else{const W=i(b.index,_),H=c(b.index,_),te=H?.setting?.commaOffset;H&&te===void 0&&O.push({offset:H.endOffset,length:0,content:","});const G=te!==void 0&&te>F.endOffset;O.push({offset:G?te+1:F.endOffset,length:0,content:W?L+N+",":L+N})}return O}else{if(F.setting)return[{offset:F.startOffset,length:0,content:N+","}];const O=(_[b.index-1]&&!_[b.index-1].setting?L:"")+N+(i(b.index,_)?",":"")+L;return[{offset:F.startOffset,length:0,content:O}]}}function t(s,l){return l.filter(h=>h.setting?.key===s)[0]}function c(s,l){for(let h=s-1;h>=0;h--)if(l[h].setting)return l[h]}function i(s,l){for(let h=s+1;h<l.length;h++)if(l[h].setting)return l[h]}function o(s,l,h){const b=s.indexOf(l),_=s.indexOf(h);return s.filter((U,N)=>b<N&&N<_)}function a(s,l){if(s.length&&l.length){let h=0;for(;h<l.length&&h<s.length;h++)if(s[h].value!==l[h].value)return l[h-1];return l[h-1]}}function r(s){const l=[];let h=-1,b,_;const U={onObjectBegin:N=>{h++},onObjectProperty:(N,L,F)=>{h===0&&(b=L,_=N)},onObjectEnd:(N,L)=>{h--,h===0&&l.push({startOffset:b,endOffset:N+L,value:s.substring(b,N+L),setting:{key:_,commaOffset:void 0}})},onArrayBegin:(N,L)=>{h++},onArrayEnd:(N,L)=>{h--,h===0&&l.push({startOffset:b,endOffset:N+L,value:s.substring(b,N+L),setting:{key:_,commaOffset:void 0}})},onLiteralValue:(N,L,F)=>{h===0&&l.push({startOffset:b,endOffset:L+F,value:s.substring(b,L+F),setting:{key:_,commaOffset:void 0}})},onSeparator:(N,L,F)=>{if(h===0&&N===","){let O=l.length-1;for(;O>=0&&!l[O].setting;O--);const W=l[O];W&&l.splice(O,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:L}})}},onComment:(N,L)=>{h===0&&l.push({startOffset:N,endOffset:N+L,value:s.substring(N,N+L)})}};return(0,n.visit)(s,U),l}}),define(ie[237],re([0,1,16,3,153,18,96,13,29,14,21,22,32,44,54,236,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function S(u){const t=JSON.parse(u);return d(t)?t:{settings:u}}e.parseSettingsSyncContent=S;let w=class extends y.AbstractJsonFileSynchroniser{constructor(t,c,i,o,a,r,s,l,h,b,_,U){super(c.settingsResource,"settings",t,c,i,o,a,h,b,r,s,l,U);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const c=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(t,c),o=this.getSettingsSyncContent(i),a=new A.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&a.parse(o.settings),a.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,c,i){const o=await this.getLocalFileContent(),a=await this.getFormattingOptions(),r=this.getSettingsSyncContent(t);c=c===null&&i?t:c;const s=c?this.getSettingsSyncContent(c):null,l=await this.getIgnoredSettings();let h=null,b=!1,_=!1,U=!1;if(r){let L=o?o.value.toString().trim():"{}";L=L||"{}",this.validateContent(L),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,v.merge)(L,r.settings,s?s.settings:null,l,[],a);h=F.localContent||F.remoteContent,b=F.localContent!==null,_=F.remoteContent!==null,U=F.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),h=o.value.toString(),_=!0);const N={content:h,localChange:b?2:0,remoteChange:_?2:0,hasConflicts:U};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const c=this.getSettingsSyncContent(t);if(c===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString().trim():"",a=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,v.merge)(o||"{}",c.settings,c.settings,a,[],r).remoteContent!==null}async getMergeResult(t,c){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",o,i):null}}async getAcceptResult(t,c,i,o){const a=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",r,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,v.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(t,c,i,o){const{fileContent:a}=i[0][0];let{content:r,localChange:s,remoteChange:l}=i[0][1];if(s===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(r,a,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),l!==0){const h=await this.getFormattingOptions(),b=this.getSettingsSyncContent(t),_=await this.getIgnoredSettings(r);r=(0,v.updateIgnoredSettings)(r,b?b.settings:"{}",_,h),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const c=await this.getFormattingOptions(),i=(0,g.edit)(t.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,v.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:c}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let c=await super.resolveContent(t);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(t)),c){const i=this.parseSyncData(c);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let c=await super.resolvePreviewContent(t);if(c){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();c=(0,v.updateIgnoredSettings)(c,"{}",o,i)}return c}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return S(t)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:a})=>!!a)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(c,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new f.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};w=de([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,R.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncBackupStoreService),Y(5,f.IUserDataSyncLogService),Y(6,f.IUserDataSyncUtilService),Y(7,T.IConfigurationService),Y(8,f.IUserDataSyncEnablementService),Y(9,P.ITelemetryService),Y(10,E.IExtensionManagementService),Y(11,p.IUriIdentityService)],w),e.SettingsSynchroniser=w;let m=class extends y.AbstractInitializer{constructor(t,c,i,o){super("settings",c,i,t,o)}async doInitialize(t){const c=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return S(t)}catch(c){this.logService.error(c)}return null}};m=de([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,f.IUserDataSyncLogService),Y(3,p.IUriIdentityService)],m),e.SettingsInitializer=m}),define(ie[238],re([0,1,16,3,28,18,13,14,21,22,32,44,231,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let g=class extends P.AbstractSynchroniser{constructor(d,S,w,m,u,t,c,i,o,a){super("snippets",S,d,w,m,u,i,o,t,c,a);this.version=1,this.snippetsFolder=d.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(d,S,w){const m=await this.getSnippetsFileContents(),u=this.toSnippetsContents(m),t=d.syncData?this.parseSnippets(d.syncData):null;S=S===null&&w?d:S;const c=S&&S.syncData?this.parseSnippets(S.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,p.merge)(u,t,c);return this.getResourcePreviews(i,m,t||{})}async hasRemoteChanged(d){const S=d.syncData?this.parseSnippets(d.syncData):null;if(S===null)return!0;const w=await this.getSnippetsFileContents(),m=this.toSnippetsContents(w),u=(0,p.merge)(m,S,S);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(d,S){return d.previewResult}async getAcceptResult(d,S,w,m){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return w===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:w,localChange:w===null?d.fileContent!==null?3:0:2,remoteChange:w===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(d,S,w,m){const u=w.map(([t,c])=>({...t,acceptResult:c}));u.every(({localChange:t,remoteChange:c})=>t===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,m)),u.some(({remoteChange:t})=>t!==0)&&(d=await this.updateRemoteSnippets(u,d,m)),S?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of u)try{await this.fileService.del(t)}catch{}}getResourcePreviews(d,S,w){const m=new Map;for(const u of Object.keys(d.local.added)){const t={content:d.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};m.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.local.updated)){const t={content:d.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.remote.added)){const t={content:d.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.remote.updated)){const t={content:d.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.conflicts){const t={content:S[u]?S[u].value.toString():null,hasConflicts:!0,localChange:S[u]?2:1,remoteChange:w[u]?2:1};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(S))if(!m.has(u)){const t={content:S[u]?S[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};m.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...m.values()]}async getAssociatedResources({uri:d}){let S=await super.resolveContent(d);if(S){const w=this.parseSyncData(S);if(w){const m=this.parseSnippets(w),u=[];for(const t of Object.keys(m)){const c=this.extUri.joinPath(d,t),i=this.extUri.joinPath(this.snippetsFolder,t),o=await this.fileService.exists(i);u.push({resource:c,comparableResource:o?i:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(d){if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(d);let S=await super.resolveContent(d);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(d)),S){const w=this.parseSyncData(S);if(w)return this.parseSnippets(w)[this.extUri.basename(d)]||null}return null}async hasLocalData(){try{const d=await this.getSnippetsFileContents();if(Object.keys(d).length)return!0}catch{}return!1}async updateLocalBackup(d){const S={};for(const w of d)w.fileContent&&(S[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(d,S){for(const{fileContent:w,acceptResult:m,localResource:u,remoteResource:t,localChange:c}of d)if(c!==0){const i=t?this.extUri.basename(t):this.extUri.basename(u),o=this.extUri.joinPath(this.snippetsFolder,i);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,D.VSBuffer.fromString(m.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,D.VSBuffer.fromString(m.content),S?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(d,S,w){const m=S.syncData?this.parseSnippets(S.syncData):{},u=(0,k.deepClone)(m);for(const{acceptResult:t,localResource:c,remoteResource:i,remoteChange:o}of d)if(o!==0){const a=c?this.extUri.basename(c):this.extUri.basename(i);o===3?delete u[a]:u[a]=t.content}return(0,p.areSame)(m,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(u),w?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(d){return JSON.parse(d.content)}toSnippetsContents(d){const S={};for(const w of Object.keys(d))S[w]=d[w].value.toString();return S}async getSnippetsFileContents(){const d={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof I.FileOperationError&&w.fileOperationResult===1)return d;throw w}for(const w of S.children||[]){const m=w.resource,u=this.extUri.extname(m);if(u===".json"||u===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,m),c=await this.fileService.readFile(m);d[t]=c}}return d}};g=de([Y(0,A.IEnvironmentService),Y(1,I.IFileService),Y(2,E.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,y.IUserDataSyncEnablementService),Y(8,C.ITelemetryService),Y(9,R.IUriIdentityService)],g),e.SnippetsSynchroniser=g;let v=class extends P.AbstractInitializer{constructor(d,S,w,m){super("snippets",S,w,d,m)}async doInitialize(d){const S=d.syncData?JSON.parse(d.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const m of Object.keys(S)){const u=S[m];if(u){const t=this.extUri.joinPath(this.environmentService.snippetsHome,m);await this.fileService.createFile(t,D.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(d)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};v=de([Y(0,I.IFileService),Y(1,A.IEnvironmentService),Y(2,y.IUserDataSyncLogService),Y(3,R.IUriIdentityService)],v),e.SnippetsInitializer=v}),define(ie[239],re([0,1,16,18,13,14,21,22,32,44,24]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function P(v,f){try{return JSON.parse(v).tasks}catch(d){return f.error(d),null}}e.getTasksContentFromSyncContent=P;let p=class extends C.AbstractFileSynchroniser{constructor(f,d,S,w,m,u,t,c,i,o){super(o.extUri.joinPath(o.extUri.dirname(t.settingsResource),"tasks.json"),"tasks",u,t,c,f,d,m,i,S,w,o);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(f,d,S,w){const m=f.syncData?P(f.syncData.content,this.logService):null;d=d===null&&S?f:d;const u=d?.syncData?P(d.syncData.content,this.logService):null,t=await this.getLocalFileContent();let c=null,i=!1,o=!1,a=!1;if(m){const s=t?t.value.toString():null;if(!u||u!==s||u!==m){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=g(s,m,u);c=l.content,a=l.hasConflicts,i=l.hasLocalChanged,o=l.hasRemoteChanged}}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),c=t.value.toString(),o=!0);const r={content:c,localChange:i?t?2:1:0,remoteChange:o?2:0,hasConflicts:a};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:r.localChange,remoteResource:this.remoteResource,remoteContent:m,remoteChange:r.remoteChange,previewResource:this.previewResource,previewResult:r,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(f){const d=f?.syncData?P(f.syncData.content,this.logService):null;if(d===null)return!0;const S=await this.getLocalFileContent(),w=S?S.value.toString():null,m=g(w,d,d);return m.hasLocalChanged||m.hasRemoteChanged}async getMergeResult(f,d){return f.previewResult}async getAcceptResult(f,d,S,w){if(this.extUri.isEqual(d,this.localResource))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(d,this.remoteResource))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(d,this.previewResource))return S===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:S,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(f,d,S,w){const{fileContent:m}=S[0][0];let{content:u,localChange:t,remoteChange:c}=S[0][1];if(t===0&&c===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),t!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),m&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(m.value.toString()))),await this.updateLocalFileContent(u||"{}",m,w),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),c!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(u||"{}"));f=await this.updateRemoteUserData(i,w?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}d?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:f}){const d=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(f,"tasks.json"),comparableResource:d}]}async resolveContent(f){if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f))return this.resolvePreviewContent(f);let d=await super.resolveContent(f);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(f)),d){const S=this.parseSyncData(d);if(S)switch(this.extUri.basename(f)){case"tasks.json":return P(S.content,this.logService)}}return null}toTasksSyncContent(f){return{tasks:f}}};p=de([Y(0,R.IUserDataSyncStoreService),Y(1,R.IUserDataSyncBackupStoreService),Y(2,R.IUserDataSyncLogService),Y(3,n.IConfigurationService),Y(4,R.IUserDataSyncEnablementService),Y(5,T.IFileService),Y(6,k.IEnvironmentService),Y(7,A.IStorageService),Y(8,I.ITelemetryService),Y(9,E.IUriIdentityService)],p),e.TasksSynchroniser=p;let y=class extends C.AbstractInitializer{constructor(f,d,S,w){super("tasks",d,S,f,w);this.uriIdentityService=w,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(f){const d=f.syncData?P(f.syncData.content,this.logService):null;if(!d){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(d)),await this.updateLastSyncUserData(f)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};y=de([Y(0,T.IFileService),Y(1,k.IEnvironmentService),Y(2,R.IUserDataSyncLogService),Y(3,E.IUriIdentityService)],y),e.TasksInitializer=y;function g(v,f,d){if(v===null&&f===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const S=d!==v,w=d!==f;return!S&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:S&&!w?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!S?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ie[67],re([0,1,3,2,6,24]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(E,C){super();this.userDataSyncStoreService=E,this.logService=C,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};A=de([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ie[240],re([0,1,5,16,58,2,20,18,13,14,24]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let P=class extends T.Disposable{constructor(y,g,v,f){super();this.environmentService=y,this.fileService=g,this.configurationService=v,this.logService=f,R.ALL_SYNC_RESOURCES.forEach(d=>this.cleanUpBackup(d))}async getAllRefs(y){const g=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),v=await this.fileService.resolve(g);return v.children?v.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort().reverse().map(d=>({ref:d.name,created:this.getCreationTime(d)})):[]}async resolveContent(y,g){if(!g){const v=await this.getAllRefs(y);v.length&&(g=v[v.length-1].ref)}if(g){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,g);return(await this.fileService.readFile(v)).value.toString()}return null}async backup(y,g){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),f=(0,A.joinPath)(v,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,n.VSBuffer.fromString(g))}catch(d){this.logService.error(d)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const g=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(g))return}catch{return}const v=await this.fileService.resolve(g);if(v.children){const f=v.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=f.filter(m=>Date.now()-this.getCreationTime(m)>d);const w=f.length-S.length;w<10&&(S=S.slice(10-w)),await D.Promises.settled(S.map(async m=>{this.logService.info("Deleting from backup",m.resource.path),await this.fileService.del(m.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};P=de([Y(0,E.IEnvironmentService),Y(1,C.IFileService),Y(2,I.IConfigurationService),Y(3,R.IUserDataSyncLogService)],P),e.UserDataSyncBackupStoreService=P}),define(ie[241],re([0,1,3,2,4,13,21,22,24]),function(Q,e,D,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let R=class extends n.Disposable{constructor(p,y,g,v){super();this.storageService=p,this.telemetryService=y,this.environmentService=g,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(f=>this.onDidStorageChange(f)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:p}),this.storageService.store(C,p,0,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,E.getEnablementKey)(p),0,!0)}setResourceEnablement(p,y){if(this.isResourceEnabled(p)!==y){const g=(0,E.getEnablementKey)(p);this.storeResourceEnablement(g,y)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,y){this.storageService.store(p,y,0,k.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==0)return;if(C===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=E.ALL_SYNC_RESOURCES.filter(g=>(0,E.getEnablementKey)(g)===p.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};R=de([Y(0,A.IStorageService),Y(1,I.ITelemetryService),Y(2,T.IEnvironmentService),Y(3,E.IUserDataSyncStoreManagementService)],R),e.UserDataSyncEnablementService=R}),define(ie[242],re([0,1,2,7]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(p){this.service=p}listen(p,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(p,y,g){switch(y){case"triggerSync":return this.service.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(g[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class T{constructor(p){this.service=p}listen(p,y){throw new Error(`Event not found: ${y}`)}call(p,y,g){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(g[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=A;class I{constructor(p){this.service=p}listen(p,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(p,y,g){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(g[0],g[1]);case"setEnablements":return this.service.setEnablements(g)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class E{constructor(p){this.service=p}listen(p,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(p,y,g){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class C{constructor(p){this.service=p}listen(p,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(p,y,g){switch(y){case"switch":return this.service.switch(g[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class R extends D.Disposable{constructor(p){super();this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:n.URI.revive(p.url),type:p.type,defaultUrl:n.URI.revive(p.defaultUrl),insidersUrl:n.URI.revive(p.insidersUrl),stableUrl:n.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(ie[243],re([0,1,13,9]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(A,I){super();this.logger=this._register(A.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...I){this.logger.trace(A,...I)}debug(A,...I){this.logger.debug(A,...I)}info(A,...I){this.logger.info(A,...I)}warn(A,...I){this.logger.warn(A,...I)}error(A,...I){this.logger.error(A,...I)}critical(A,...I){this.logger.critical(A,...I)}flush(){this.logger.flush()}};k=de([Y(0,n.ILoggerService),Y(1,D.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ie[68],re([0,1,3,2,4,26,156,13,14,6,23,46,21,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",v="Safari",f="Chrome",d="Edge",S="Firefox",w="Android";function m(c){switch(c){case v:case f:case d:case S:case w:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=m;function u(){return k.isSafari?v:k.isChrome?f:k.isEdge?d:k.isFirefox?S:k.isAndroid?w:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let t=class et extends n.Disposable{constructor(i,o,a,r,s,l){super();this.storageService=a,this.userDataSyncStoreService=r,this.logService=s,this.productService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,P.getServiceMachineId)(i,o,a)}async getMachines(i){const o=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(r=>({...r,isCurrent:r.id===o}))}async addCurrentMachine(i){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(i);a.machines.some(({id:r})=>r===o)||(a.machines.push({id:o,name:this.computeCurrentMachineName(a.machines),platform:u()}),await this.writeMachinesData(a))}async removeCurrentMachine(i){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(i),r=a.machines.filter(({id:s})=>s!==o);r.length!==a.machines.length&&(a.machines=r,await this.writeMachinesData(a))}async renameMachine(i,o,a){const r=await this.readMachinesData(a),s=r.machines.find(({id:l})=>l===i);if(s){s.name=o,await this.writeMachinesData(r);const l=await this.currentMachineIdPromise;i===l&&this.storageService.store(g,o,0,1)}}async setEnablements(i){const o=await this.readMachinesData();for(const[a,r]of i){const s=o.machines.find(l=>l.id===a);s&&(s.disabled=r?void 0:!0)}await this.writeMachinesData(o)}computeCurrentMachineName(i){const o=this.storageService.get(g,0);if(o)return o;const a=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,r=new RegExp(`${(0,T.escapeRegExpCharacters)(a)}\\s#(\\d+)`);let s=0;for(const l of i){const h=r.exec(l.name),b=h?parseInt(h[1]):0;s=b>s?b:s}return`${a} #${s+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const o=this.parse(this.userData);if(o.version!==et.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return o}async writeMachinesData(i){const o=JSON.stringify(i),a=await this.userDataSyncStoreService.write(et.RESOURCE,o,this.userData?.ref||null);this.userData={ref:a,content:o},this._onDidChange.fire()}async readUserData(i){if(this.userData){const o=i&&i.latest?i.latest[et.RESOURCE]:void 0;if(this.userData.ref===o)return this.userData;if(o===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(o){this.logService.error(o)}return{version:et.VERSION,machines:[]}}};t.VERSION=1,t.RESOURCE="machines",t=de([Y(0,I.IEnvironmentService),Y(1,E.IFileService),Y(2,p.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncLogService),Y(5,R.IProductService)],t),e.UserDataSyncMachinesService=t}),define(ie[244],re([0,1,5,58,37,8,3,2,4,20,7,154,23,21,22,24,67,68]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const S="sync.disableMachineEventually",w="sync.sessionId",m="sync.storeUrl",u="sync.productQuality";let t=class extends I.Disposable{constructor(o,a,r,s,l,h,b,_,U,N){super();this.userDataSyncStoreManagementService=a,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=s,this.userDataSyncService=l,this.logService=h,this.userDataSyncAccountService=b,this.telemetryService=_,this.userDataSyncMachinesService=U,this.storageService=N,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=a.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(a.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,a.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=a.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(b.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(L=>this.triggerSync([L],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,L])=>L)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const o=this.storageService.get(m,0);return o?R.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(m,o.toString(),0,1):this.storageService.remove(m,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(o){o?this.storageService.store(u,o,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:o,message:a}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(a&&this.logService.info(a),this.autoSync.clear()):a&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(a))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,a,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(w,0),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(s){if(a)this.logService.error(s),this.updateEnablement(!1);else throw s}}updateEnablement(o){this.userDataSyncEnablementService.isEnabled()!==o&&(this.userDataSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const a=v.UserDataSyncError.toUserDataSyncError(o);a instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:a.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),a.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):a.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):a.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):a.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):a.code==="UpgradeRequired"||a.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):a.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${a.resource} content with newer version than of client. Requires client upgrade.`)):a.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${a.resource} content with older version than of client. Requires server reset.`)):a.code==="ServiceChanged"||a.code==="DefaultServiceChanged"?E.isWeb&&a.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(a),this.successiveFailures++),this._onError.fire(a)}async disableMachineEventually(){this.storageService.store(S,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(S,0,!1)}stopDisableMachineEventually(){this.storageService.remove(S,0)}async triggerSync(o,a,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(a&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};t=de([Y(0,p.IProductService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncEnablementService),Y(4,v.IUserDataSyncService),Y(5,v.IUserDataSyncLogService),Y(6,f.IUserDataSyncAccountService),Y(7,g.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,y.IStorageService)],t),e.UserDataAutoSyncService=t;class c extends I.Disposable{constructor(o,a,r,s,l,h,b,_){super();this.lastSyncUrl=o,this.interval=a,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=s,this.userDataSyncService=l,this.userDataSyncMachinesService=h,this.logService=b,this.storageService=_,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(o,a){const r=(0,D.createCancelablePromise)(async s=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,T.isCancellationError)(l))return}return this.doSync(o,a,s)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),a=this.userDataSyncStoreManagementService.userDataSyncStore;return!!a&&!!o&&(!(0,C.isEqual)(a.defaultUrl,o.defaultUrl)||!(0,C.isEqual)(a.insidersUrl,o.insidersUrl)||!(0,C.isEqual)(a.stableUrl,o.stableUrl))}async doSync(o,a,r){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let s;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,a),r.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,P.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,P.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,P.localize)(2,null),"TurnedOff");const l=this.storageService.get(w,0);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,P.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,P.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,P.localize)(5,null),"SessionExpired");const h=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(r.isCancellationRequested)return;const b=h.find(_=>_.isCurrent);if(b?.disabled)throw new v.UserDataAutoSyncError((0,P.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new v.UserDataAutoSyncError((0,k.toErrorMessage)(_),_ instanceof v.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(w,this.manifest.session,0,1),r.isCancellationRequested)return;b||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),s=l}this._onDidFinishSync.fire(s)}register(o){return super._register(o)}}c.INTERVAL_SYNCING="Interval"}),define(ie[245],re([0,1,17,5,37,3,2,20,15,30,18,29,6,21,22,232,234,235,237,238,239,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let c=class extends A.Disposable{constructor(s,l,h,b,_,U,N,L){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=l,this.instantiationService=h,this.configurationService=b,this.logService=_,this.telemetryService=U,this.storageService=N,this.userDataSyncEnablementService=L,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(t,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,l){this.checkEnablement();const h=(0,C.generateUuid)();try{const L=(0,u.createSyncHeaders)(h);l&&(L["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,L)}catch(L){const F=u.UserDataSyncError.toUserDataSyncError(L);throw this.reportUserDataSyncError(F,h),F}let b=!1;const _=this,U=this.getEnabledSynchronizers();let N;return{manifest:s,async run(){if(b)throw new Error("Can run a task only once");return N=(0,n.createCancelablePromise)(L=>_.sync(U,s,h,L)),N.finally(()=>N=void 0)},async stop(){if(N&&N.cancel(),_.status!=="idle")return _.stop(U)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,C.generateUuid)(),l=(0,u.createSyncHeaders)(s);let h;try{h=await this.userDataSyncStoreService.manifest(null,l)}catch(U){const N=u.UserDataSyncError.toUserDataSyncError(U);throw this.reportUserDataSyncError(N,s),N}await this.resetLocal();const b=this.getEnabledSynchronizers(),_=async()=>{await this.stop(b),await this.resetLocal()};return new i(s,h,l,b,_,this.configurationService,this.logService)}async sync(s,l,h,b){if(b.isCancellationRequested||!s.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const U=(0,u.createSyncHeaders)(h);for(const N of s){if(b.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(N.resource))return;try{await N.sync(l,U)}catch(L){let F=!1;if(L instanceof u.UserDataSyncError)switch(L.code){case"TooLarge":L=new u.UserDataSyncError(L.message,L.code,N.resource),F=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":F=!0;break}const O=u.UserDataSyncError.toUserDataSyncError(L);if(this.reportUserDataSyncError(O,h),F)throw O;this.logService.error(L),this.logService.error(`${N.resource}: ${(0,k.toErrorMessage)(L)}`),this._syncErrors.push([N.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(U){const N=u.UserDataSyncError.toUserDataSyncError(U);throw this.reportUserDataSyncError(N,h),N}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const l of s)try{l.status!=="idle"&&await l.stop()}catch(h){this.logService.error(h)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(s))return!0})}async accept(s,l,h,b){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===s)return await _.accept(l,h),b&&await _.apply(!1,(0,u.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async l=>{const h=await l.resolveContent(s);if(h)return h})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,l){return await this.performSynchronizerAction(async b=>{if(b.resource===s)return b.getAssociatedResources(l)})||[]}async getMachineId(s,l){return await this.performSynchronizerAction(async b=>{if(b.resource===s)return await b.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(t,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(l){this.logService.error(`${s.resource}: ${(0,k.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const l=new A.DisposableStore;try{const h=this.synchronizers.value||l.add(this.instantiationService.createInstance(o,()=>{},()=>{},()=>{})),b=[...h.enabled,...h.disabled.map(_=>l.add(h.createSynchronizer(_)))];for(const _ of b){const U=await s(_);if(!(0,E.isUndefined)(U))return U}return null}finally{l.dispose()}}setStatus(s){const l=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const l=this.computeStatus(s);this.setStatus(l)}updateConflicts(s){const l=this.computeConflicts(s);(0,D.equals)(this._conflicts,l,([h,b],[_,U])=>h===h&&(0,D.equals)(b,U,(N,L)=>(0,I.isEqual)(N.previewResource,L.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(l))}computeConflicts(s){return s.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(a)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(l=>l.status==="hasConflicts")?"hasConflicts":s.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,l){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof u.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof u.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(o,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=de([Y(0,u.IUserDataSyncStoreService),Y(1,u.IUserDataSyncStoreManagementService),Y(2,p.IInstantiationService),Y(3,R.IConfigurationService),Y(4,u.IUserDataSyncLogService),Y(5,g.ITelemetryService),Y(6,y.IStorageService),Y(7,u.IUserDataSyncEnablementService)],c),e.UserDataSyncService=c;class i extends A.Disposable{constructor(s,l,h,b,_,U,N){super();this.id=s,this.manifest=l,this.syncHeaders=h,this.synchronisers=b,this.onStop=_,this.configurationService=U,this.logService=N,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,l){try{return await this.performAction(s,h=>h.accept(s,l))}catch(h){throw this.logService.error(h),h}}async merge(s){try{return s?await this.performAction(s,l=>l.merge(s)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(s){try{return await this.performAction(s,l=>l.discard(s))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,l]of this.previews)for(const h of l.resourcePreviews)h.mergeState==="conflict"&&s.push(h.previewResource);for(const l of s)await this.discard(l);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[l,h]of this.previews){this.synchronizingResources.push([l,h.resourcePreviews.map(U=>U.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const b=this.synchronisers.find(U=>U.resource===l);for(const U of h.resourcePreviews)(U.localChange!==0||U.remoteChange!==0)&&U.mergeState==="preview"&&await b.merge(U.previewResource);const _=await b.apply(!1,this.syncHeaders);_&&s.push(this.toSyncResourcePreview(b.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(U=>U[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,l]of this.previews){this.synchronizingResources.push([s,l.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(b=>b.resource===s);for(const b of l.resourcePreviews)await h.accept(b.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,l]of this.previews){this.synchronizingResources.push([s,l.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(b=>b.resource===s);for(const b of l.resourcePreviews)await h.accept(b.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,W])=>W.resourcePreviews.some(({localResource:H,previewResource:te,remoteResource:G})=>(0,I.isEqual)(s,H)||(0,I.isEqual)(s,te)||(0,I.isEqual)(s,G)));if(h===-1)return this.previews;const[b,_]=this.previews[h],U=_.resourcePreviews.find(({localResource:W,remoteResource:H,previewResource:te})=>(0,I.isEqual)(W,s)||(0,I.isEqual)(H,s)||(0,I.isEqual)(te,s));if(!U)return this.previews;let N=this.synchronizingResources.find(W=>W[0]===b);N||(N=[b,[]],this.synchronizingResources.push(N)),N[1].some(W=>(0,I.isEqual)(W,U.localResource))||(N[1].push(U.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const L=this.synchronisers.find(W=>W.resource===this.previews[h][0]),F=await l(L);F?this.previews.splice(h,1,this.toSyncResourcePreview(L.resource,F)):this.previews.splice(h,1);const O=this.synchronizingResources.findIndex(W=>W[0]===b);return this.synchronizingResources[O][1].splice(N[1].findIndex(W=>(0,I.isEqual)(W,U.localResource)),1),N[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[l,h]of this.previews){this.synchronizingResources.push([l,h.resourcePreviews.map(U=>U.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const b=this.synchronisers.find(U=>U.resource===l);let _=h;for(const U of h.resourcePreviews)(U.localChange!==0||U.remoteChange!==0)&&U.mergeState==="preview"&&(_=await b.merge(U.previewResource));_&&s.push(this.toSyncResourcePreview(b.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(U=>U[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const l=[],h=await this.getUserDataSyncConfiguration();for(const b of this.synchronisers){if(s.isCancellationRequested)return[];const _=await b.preview(this.manifest,h,this.syncHeaders);_&&l.push(this.toSyncResourcePreview(b.resource,_))}return l}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(h=>h instanceof S.SettingsSynchroniser);if(l){const h=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...h}}return s}toSyncResourcePreview(s,l){return[s,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(a)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let o=class extends A.Disposable{constructor(s,l,h,b,_,U,N){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=l,this.onDidChangeLocal=h,this.userDataSyncEnablementService=b,this.instantiationService=_,this.extensionGalleryService=U,this.logService=N,this._enabled=[],this._register(b.onDidChangeResourceEnablement(([L,F])=>this.onDidChangeResourceEnablement(L,F))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,L])=>L.dispose())));for(const L of u.ALL_SYNC_RESOURCES)b.isResourceEnabled(L)&&this.registerSynchronizer(L)}get enabled(){return this._enabled.sort((s,l)=>s[1]-l[1]).map(([s])=>s)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,l){l?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([_])=>_.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,h=l.add(this.createSynchronizer(s));l.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const b=this.getOrder(s);this._enabled.push([h,b,l])}deRegisterSynchronizer(s){const l=this._enabled.findIndex(([h])=>h.resource===s);if(l!==-1){const h=this._enabled.splice(l,1);for(const[b,,_]of h){if(b.status!=="idle"){const U=b.conflicts.length>0;b.stop(),U&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(S.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(w.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(m.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(f.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(v.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};o=de([Y(3,u.IUserDataSyncEnablementService),Y(4,p.IInstantiationService),Y(5,P.IExtensionGalleryService),Y(6,u.IUserDataSyncLogService)],o);function a(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(ie[246],re([0,1,3,2,15,7,24]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class I{constructor(P,p){this.service=P,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(P,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(P,p,y){try{return await this._call(P,p,y)}catch(g){throw this.logService.error(g),g}}async _call(P,p,y){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],T.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:T.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:T.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const g=p.substring("manualSync/".length),v=y[0],f=this.getManualSyncTask(v);switch(y=y.slice(1),g){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(y[0]),y[1]);case"merge":return f.merge(T.URI.revive(y[0]));case"discard":return f.discard(T.URI.revive(y[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(P){const p=this.manualSyncTasks.get(this.createKey(P));if(!p)throw new Error(`Manual sync taks not found: ${P}`);return p.manualSyncTask}async createManualSyncTask(){const P=new n.DisposableStore,p=P.add(await this.service.createManualSyncTask());return P.add(p.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:p.id,data:y}))),this.manualSyncTasks.set(this.createKey(p.id),{manualSyncTask:p,disposables:P}),{id:p.id,manifest:p.manifest,status:p.status}}disposeManualSyncTask(P){P.dispose();const p=this.createKey(P.id);this.manualSyncTasks.get(p)?.disposables.dispose(),this.manualSyncTasks.delete(p)}createKey(P){return`manualSyncTask-${P}`}}e.UserDataSyncChannel=I;class E extends n.Disposable{constructor(P){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,y,g){return P.call(p,y,g).then(null,v=>{throw A.UserDataSyncError.toUserDataSyncError(v)})},listen(p,y){return P.listen(p,y)}},this.channel.call("_getInitialData").then(([p,y,g])=>{this.updateStatus(p),this.updateConflicts(y),g&&this.updateLastSyncTime(g),this._register(this.channel.listen("onDidChangeStatus")(v=>this.updateStatus(v))),this._register(this.channel.listen("onDidChangeLastSyncTime")(v=>this.updateLastSyncTime(v)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(([y,g])=>[y,A.UserDataSyncError.toUserDataSyncError(g)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:P,manifest:p,status:y}=await this.channel.call("createManualSyncTask"),g=this,v=new C(P,p,y,{async call(f,d,S){return g.channel.call(`manualSync/${f}`,[P,...(0,k.isArray)(d)?d:[d]],S)},listen(f,d){return D.Event.map(D.Event.filter(g.channel.listen(`manualSync/${f}`,d),S=>!v.isDiposed()&&S.manualSyncTaskId===P),S=>S.data)}});return v}replace(P){return this.channel.call("replace",[P])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(P,p,y,g){return this.channel.call("accept",[P,p,y,g])}resolveContent(P){return this.channel.call("resolveContent",[P])}async getLocalSyncResourceHandles(P){return(await this.channel.call("getLocalSyncResourceHandles",[P])).map(({created:y,uri:g})=>({created:y,uri:T.URI.revive(g)}))}async getRemoteSyncResourceHandles(P){return(await this.channel.call("getRemoteSyncResourceHandles",[P])).map(({created:y,uri:g})=>({created:y,uri:T.URI.revive(g)}))}async getAssociatedResources(P,p){return(await this.channel.call("getAssociatedResources",[P,p])).map(({resource:g,comparableResource:v})=>({resource:T.URI.revive(g),comparableResource:T.URI.revive(v)}))}async getMachineId(P,p){return this.channel.call("getMachineId",[P,p])}async updateStatus(P){this._status=P,this._onDidChangeStatus.fire(P)}async updateConflicts(P){this._conflicts=P.map(([p,y])=>[p,y.map(g=>({...g,localResource:T.URI.revive(g.localResource),remoteResource:T.URI.revive(g.remoteResource),previewResource:T.URI.revive(g.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(P){this._lastSyncTime!==P&&(this._lastSyncTime=P,this._onDidChangeLastSyncTime.fire(P))}}e.UserDataSyncChannelClient=E;class C extends n.Disposable{constructor(P,p,y,g){super();this.id=P,this.manifest=p,this._disposed=!1,this._status=y;const v=this;this.channel={async call(f,d,S){try{const w=await g.call(f,d,S);return v.isDiposed()||(v._status=await g.call("_getStatus")),w}catch(w){throw A.UserDataSyncError.toUserDataSyncError(w)}},listen(f,d){return g.listen(f,d)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const P=await this.channel.call("preview");return this.deserializePreviews(P)}async accept(P,p){const y=await this.channel.call("accept",[P,p]);return this.deserializePreviews(y)}async merge(P){const p=await this.channel.call("merge",[P]);return this.deserializePreviews(p)}async discard(P){const p=await this.channel.call("discard",[P]);return this.deserializePreviews(p)}async discardConflicts(){const P=await this.channel.call("discardConflicts");return this.deserializePreviews(P)}async apply(){const P=await this.channel.call("apply");return this.deserializePreviews(P)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(P){return P.map(([p,y])=>[p,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(g=>({...g,localResource:T.URI.revive(g.localResource),remoteResource:T.URI.revive(g.remoteResource),previewResource:T.URI.revive(g.previewResource),acceptedResource:T.URI.revive(g.acceptedResource)}))}])}}}),define(ie[247],re([0,1,5,25,8,3,2,109,4,20,15,7,30,18,13,14,23,43,46,21,24]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",t="sync.donot-make-requests-until",c="sync.user-session-id",i="sync.machine-session-id",o=100,a=1e3*60*5;let r=class extends A.Disposable{constructor(U,N,L){super();this.productService=U,this.configurationService=N,this.storageService=L,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(L.onDidChangeValue,F=>F.key===m.SYNC_SERVICE_URL_TYPE&&F.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(m.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(U){this.storageService.store(m.SYNC_SERVICE_URL_TYPE,U,0,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[m.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(m.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,N){U=E.isWeb&&U?.web?{...U,...U.web}:U;const L={...U||{},...N||{}};if(L&&(0,R.isString)(L.url)&&(0,R.isObject)(L.authenticationProviders)&&Object.keys(L.authenticationProviders).every(F=>(0,R.isArray)(L.authenticationProviders[F].scopes))){const F=L,O=!!F.canSwitch&&!N?.url,W=F.url===F.insidersUrl?"insiders":"stable",H=(O?this.userDataSyncStoreType:void 0)||W,te=N?.url||(H==="insiders"?F.insidersUrl:H==="stable"?F.stableUrl:F.url);return{url:P.URI.parse(te),type:H,defaultType:W,defaultUrl:P.URI.parse(F.url),stableUrl:P.URI.parse(F.stableUrl),insidersUrl:P.URI.parse(F.insidersUrl),canSwitch:O,authenticationProviders:Object.keys(F.authenticationProviders).reduce((G,$)=>(G.push({id:$,scopes:F.authenticationProviders[$].scopes}),G),[])}}}};r=de([Y(0,f.IProductService),Y(1,y.IConfigurationService),Y(2,w.IStorageService)],r),e.AbstractUserDataSyncStoreManagementService=r;let s=class extends r{constructor(U,N,L){super(U,N,L);const F=this.storageService.get(u,0);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const O=this.productService[m.CONFIGURATION_SYNC_STORE_KEY];O?this.storageService.store(u,JSON.stringify(O),0,1):this.storageService.remove(u,0)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};s=de([Y(0,f.IProductService),Y(1,y.IConfigurationService),Y(2,w.IStorageService)],s),e.UserDataSyncStoreManagementService=s;let l=class extends A.Disposable{constructor(U,N,L,F,O,W,H){super();this.requestService=L,this.logService=F,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,S.getServiceMachineId)(O,W,H).then(te=>{const G={"X-Client-Name":`${N.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(G["X-Client-Commit"]=N.commit),G}),this.session=new b(o,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,N){this.authToken={token:U,type:N}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,C.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(t,0);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U),L={},F=await this.request(N.toString(),{type:"GET",headers:L},[],n.CancellationToken.None);return(await(0,d.asJson)(F)||[]).map(({url:W,created:H})=>({ref:(0,C.relativePath)(N,N.with({path:W})),created:H*1e3}))}async resolveContent(U,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,N).toString(),F={};F["Cache-Control"]="no-cache";const O=await this.request(L,{type:"GET",headers:F},[],n.CancellationToken.None);return await(0,d.asTextOrError)(O)}async delete(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),L={};await this.request(N,{type:"DELETE",headers:L},[],n.CancellationToken.None)}async read(U,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();L={...L},L["Cache-Control"]="no-cache",N&&(L["If-None-Match"]=N.ref);const O=await this.request(F,{type:"GET",headers:L},[304],n.CancellationToken.None);let W=null;if(O.res.statusCode===304&&(W=N),W===null){const H=O.res.headers.etag;if(!H)throw new m.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",O.res.statusCode,O.res.headers[m.HEADER_OPERATION_ID]);const te=await(0,d.asTextOrError)(O);if(!te&&O.res.statusCode===304)throw new m.UserDataSyncStoreError("Empty response",F,"EmptyResponse",O.res.statusCode,O.res.headers[m.HEADER_OPERATION_ID]);W={ref:H,content:te}}return W}async write(U,N,L,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();F={...F},F["Content-Type"]=I.Mimes.text,L&&(F["If-Match"]=L);const W=await this.request(O,{type:"POST",data:N,headers:F},[],n.CancellationToken.None),H=W.res.headers.etag;if(!H)throw new m.UserDataSyncStoreError("Server did not return the ref",O,"NoRef",W.res.statusCode,W.res.headers[m.HEADER_OPERATION_ID]);return H}async manifest(U,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",U&&(N["If-None-Match"]=U.ref);const F=await this.request(L,{type:"GET",headers:N},[304],n.CancellationToken.None);let O=null;if(F.res.statusCode===304&&(O=U),!O){const H=F.res.headers.etag;if(!H)throw new m.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",F.res.statusCode,F.res.headers[m.HEADER_OPERATION_ID]);const te=await(0,d.asTextOrError)(F);if(!te&&F.res.statusCode===304)throw new m.UserDataSyncStoreError("Empty response",L,"EmptyResponse",F.res.statusCode,F.res.headers[m.HEADER_OPERATION_ID]);te&&(O={...JSON.parse(te),ref:H})}const W=this.storageService.get(c,0);return W&&O&&W!==O.session&&this.clearSession(),O===null&&W&&this.clearSession(),O&&this.storageService.store(c,O.session,0,1),O}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":I.Mimes.text};await this.request(U,{type:"DELETE",headers:N},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(i,0)}async request(U,N,L,F){if(!this.authToken)throw new m.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const O=await this.commonHeadersPromise;N.headers={...N.headers||{},...O,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:U,type:N.type,headers:{...N.headers,authorization:void 0}});let W;try{W=await this.session.request(U,N,F)}catch($){if(!($ instanceof m.UserDataSyncStoreError)){let q="RequestFailed";const V=(0,k.getErrorMessage)($).toLowerCase();V.includes("xhr timeout")?q="RequestTimeout":V.includes("protocol")&&V.includes("not supported")?q="RequestProtocolNotSupported":V.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":V.includes("headers must be an object")?q="RequestHeadersNotObject":(0,k.isCancellationError)($)&&(q="RequestCanceled"),$=new m.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,q,void 0,void 0)}throw this.logService.info("Request failed",U),$}const H=W.res.headers[m.HEADER_OPERATION_ID],te={url:U,status:W.res.statusCode,"execution-id":N.headers[m.HEADER_EXECUTION_ID],"operation-id":H},G=(0,d.isSuccess)(W)||W.res.statusCode&&L.indexOf(W.res.statusCode)!==-1;if(G?this.logService.trace("Request succeeded",te):this.logService.info("Request failed",te),W.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new m.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",W.res.statusCode,H);if(this._onTokenSucceed.fire(),W.res.statusCode===409)throw new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",W.res.statusCode,H);if(W.res.statusCode===410)throw new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",W.res.statusCode,H);if(W.res.statusCode===412)throw new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",W.res.statusCode,H);if(W.res.statusCode===413)throw new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",W.res.statusCode,H);if(W.res.statusCode===426)throw new m.UserDataSyncStoreError(`${N.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",W.res.statusCode,H);if(W.res.statusCode===429){const $=W.res.headers["retry-after"];throw $?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt($)*1e3)),new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",W.res.statusCode,H)):new m.UserDataSyncStoreError(`${N.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",W.res.statusCode,H)}if(!G)throw new m.UserDataSyncStoreError("Server returned "+W.res.statusCode,U,"Unknown",W.res.statusCode,H);return W}addSessionHeaders(U){let N=this.storageService.get(i,0);N===void 0&&(N=(0,p.generateUuid)(),this.storageService.store(i,N,0,1)),U["X-Machine-Session-Id"]=N;const L=this.storageService.get(c,0);L!==void 0&&(U["X-User-Session-Id"]=L)}};l=de([Y(1,f.IProductService),Y(2,d.IRequestService),Y(3,m.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,v.IFileService),Y(6,w.IStorageService)],l),e.UserDataSyncStoreClient=l;let h=class extends l{constructor(U,N,L,F,O,W,H){super(U.userDataSyncStore?.url,N,L,F,O,W,H);this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};h=de([Y(0,m.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,d.IRequestService),Y(3,m.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,v.IFileService),Y(6,w.IStorageService)],h),e.UserDataSyncStoreService=h;class b{constructor(U,N,L,F){this.limit=U,this.interval=N,this.requestService=L,this.logService=F,this.requests=[],this.startTime=void 0}request(U,N,L){if(this.isExpired()&&this.reset(),N.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new m.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(N,L)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(ie[248],re([0,1,3,62,23,21,22,244,24,67,68]),function(Q,e,D,n,k,T,A,I,E,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let P=class extends I.UserDataAutoSyncService{constructor(y,g,v,f,d,S,w,m,u,t,c){super(y,g,v,f,d,w,m,u,t,c);this._register(D.Event.debounce(D.Event.any(D.Event.map(S.onDidFocusWindow,()=>"windowFocus"),D.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(i,o)=>i?[...i,o]:[o],1e3)(i=>this.triggerSync(i,!0,!1)))}};P=de([Y(0,k.IProductService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncEnablementService),Y(4,E.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,E.IUserDataSyncLogService),Y(7,C.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,R.IUserDataSyncMachinesService),Y(10,T.IStorageService)],P),e.UserDataAutoSyncService=P}),define(ie[249],re([0,1,5,3,2]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends k.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:E,getActiveWindowId:C}){super();this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(I,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>C()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ie[105],re([0,1,50,5,10,15,27,131,261,262]),function(Q,e,D,n,k,T,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,c){let i=c.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=c}}e.ExtractError=R;function P(u){const t=u.externalFileAttributes>>16||33188;return[448,56,7].map(c=>t&c).reduce((c,i)=>c+i,t&61440)}function p(u){if(u instanceof R)return u;let t;return/end of central directory record signature not found/.test(u.message)&&(t="CorruptZip"),new R(t,u)}function y(u,t,c,i,o,a){const r=k.dirname(t),s=k.join(i,r);if(!s.startsWith(i))return Promise.reject(new Error(I.localize(0,null,t)));const l=k.join(i,t);let h;return a.onCancellationRequested(()=>{h&&h.destroy()}),Promise.resolve(A.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((b,_)=>{if(!a.isCancellationRequested)try{h=(0,D.createWriteStream)(l,{mode:c}),h.once("close",()=>b()),h.once("error",_),u.once("error",_),u.pipe(h)}catch(U){_(U)}}))}function g(u,t,c,i){let o=(0,n.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{o.cancel(),u.close()}),new Promise((r,s)=>{const l=new n.Sequencer,h=b=>{b.isCancellationRequested||(a++,u.readEntry())};u.once("error",s),u.once("close",()=>o.then(()=>{i.isCancellationRequested||u.entryCount===a?r():s(new R("Incomplete",new Error(I.localize(1,null,a,u.entryCount))))},s)),u.readEntry(),u.on("entry",b=>{if(i.isCancellationRequested)return;if(!c.sourcePathRegex.test(b.fileName)){h(i);return}const _=b.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const L=k.join(t,_);o=(0,n.createCancelablePromise)(F=>A.Promises.mkdir(L,{recursive:!0}).then(()=>h(F)).then(void 0,s));return}const U=f(u,b),N=P(b);o=(0,n.createCancelablePromise)(L=>l.queue(()=>U.then(F=>y(F,_,N,t,c,L).then(()=>h(L)))).then(null,s))})})}function v(u,t=!1){return new Promise((c,i)=>{(0,E.open)(u,t?{lazyEntries:!0}:void 0,(o,a)=>{o?i(p(o)):c((0,T.assertIsDefined)(a))})})}function f(u,t){return new Promise((c,i)=>{u.openReadStream(t,(o,a)=>{o?i(p(o)):c((0,T.assertIsDefined)(a))})})}function d(u,t){return new Promise((c,i)=>{const o=new C.ZipFile;t.forEach(r=>{r.contents?o.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&o.addFile(r.localPath,r.path)}),o.end();const a=(0,D.createWriteStream)(u);o.outputStream.pipe(a),o.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>c(u))})}e.zip=d;function S(u,t,c={},i){const o=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let a=v(u,!0);return c.overwrite&&(a=a.then(r=>A.Promises.rm(t).then(()=>r))),a.then(r=>g(r,t,{sourcePathRegex:o},i))}e.extract=S;function w(u,t){return v(u).then(c=>new Promise((i,o)=>{c.on("entry",a=>{a.fileName===t&&f(c,a).then(r=>i(r),r=>o(r))}),c.once("close",()=>o(new Error(I.localize(2,null,t))))}))}function m(u,t){return w(u,t).then(c=>new Promise((i,o)=>{const a=[];c.once("error",o),c.on("data",r=>a.push(r)),c.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=m}),define(ie[250],re([0,1,105,140]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(ie[251],re([0,1,5,37,8,2,19,10,4,20,51,15,7,30,27,105,139,88,13,211,29,31,64,192,178,250,193,226,60,14,6,9,23,22,32]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u,t,c,i,o,a,r,s,l,h,b,_,U,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let L=class extends w.AbstractExtensionManagementService{constructor($,q,V,x,K,Z,X,z,M){super($,q,V,z);this.environmentService=x,this.downloadService=K,this.fileService=X;const j=this._register(Z.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(Z.createInstance(F,J=>j.postUninstall(J))),this.manifestCache=this._register(new a.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(Z.createInstance(c.ExtensionsDownloader));const B=this._register(new r.ExtensionsWatcher(this,X,x,V,M));this._register(B.onDidChangeExtensionsByAnotherSource(({added:J,removed:ne})=>{J.length&&this._onDidInstallExtensions.fire(J.map(ae=>({identifier:ae.identifier,operation:1,local:ae}))),ne.forEach(ae=>this._onDidUninstallExtension.fire({identifier:ae}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip($){this.logService.trace("ExtensionManagementService#zip",$.identifier.id);const q=await this.collectFiles($),V=await(0,v.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,q);return p.URI.file(V)}async unzip($){return this.logService.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const q=await this.downloadVsix($),V=I.resolve(q.fsPath);return(0,o.getManifest)(V)}getInstalled($=null){return this.extensionsScanner.scanExtensions($)}async install($,q={}){this.logService.trace("ExtensionManagementService#install",$.toString());const V=await this.downloadVsix($),x=await(0,o.getManifest)(I.resolve(V.fsPath));if(x.engines&&x.engines.vscode&&!(0,s.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,u.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,V,q)}async updateMetadata($,q){this.logService.trace("ExtensionManagementService#updateMetadata",$.identifier.id);const V={...q};return q.isPreReleaseVersion&&(V.preRelease=!0),$=await this.extensionsScanner.updateMetadata($,V),this.manifestCache.invalidate(),$}async updateExtensionScope($,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",$.identifier.id),$=await this.extensionsScanner.updateMetadata($,{isMachineScoped:q}),this.manifestCache.invalidate(),$}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix($){if($.scheme===A.Schemas.file)return $;const q=(0,C.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download($,q),q}createInstallExtensionTask($,q,V){return p.URI.isUri(q)?new H($,q,V,this.galleryService,this.extensionsScanner,this.logService):new W(q,V,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask($,q){return new te($,q,this.extensionsScanner)}async collectFiles($){const q=async x=>{let K=await g.Promises.readdir(x);K=K.map(z=>I.join(x,z));const Z=await Promise.all(K.map(z=>g.Promises.stat(z)));let X=Promise.resolve([]);return Z.forEach((z,M)=>{const j=K[M];z.isFile()&&(X=X.then(B=>[...B,j])),z.isDirectory()&&(X=X.then(B=>q(j).then(J=>[...B,...J])))}),X};return(await q($.location.fsPath)).map(x=>({path:`extension/${I.relative($.location.fsPath,x)}`,localPath:x}))}};L=de([Y(0,m.IExtensionGalleryService),Y(1,U.ITelemetryService),Y(2,b.ILogService),Y(3,S.INativeEnvironmentService),Y(4,d.IDownloadService),Y(5,h.IInstantiationService),Y(6,l.IFileService),Y(7,_.IProductService),Y(8,N.IUriIdentityService)],L),e.ExtensionManagementService=L;let F=class extends T.Disposable{constructor($,q,V,x){super();this.beforeRemovingExtension=$,this.fileService=q,this.extensionsScannerService=V,this.logService=x,this.uninstalledPath=(0,C.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions($){const q={includeInvalid:!0};let V=[];return $===null||$===0?V.push(...await this.extensionsScannerService.scanAllExtensions(q)):$===1&&V.push(...await this.extensionsScannerService.scanUserExtensions(q)),V=$!==null?V.filter(x=>x.type===$):V,Promise.all(V.map(x=>this.toLocalExtension(x)))}async scanUserExtensions($){const q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!$,includeInvalid:!0});return Promise.all(q.map(V=>this.toLocalExtension(V)))}async extractUserExtension($,q,V,x){const K=$.toString(),Z=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),X=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,K);try{await g.Promises.rm(X)}catch{throw new m.ExtensionManagementError(f.localize(1,null,X,$.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation($,q,Z,x),await this.extensionsScannerService.updateMetadata(p.URI.file(Z),{...V,installedTimestamp:Date.now()});try{await this.rename($,Z,X,Date.now()+2*60*1e3),this.logService.info("Renamed to",X)}catch(z){try{await g.Promises.rm(Z)}catch{}if(z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",$.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(z)}. Deleted from extracted location`,Z),z}return this.scanLocalExtension(p.URI.file(X),1)}async updateMetadata($,q){return await this.extensionsScannerService.updateMetadata($.location,q),this.scanLocalExtension($.location,$.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...$){const q=$.map(V=>u.ExtensionKey.create(V));await this.withUninstalledExtensions(V=>{q.forEach(x=>V[x.toString()]=!0)})}async setInstalled($){await this.withUninstalledExtensions(x=>delete x[$.toString()]);const V=(await this.scanUserExtensions(!0)).find(x=>u.ExtensionKey.create(x).equals($))||null;return V?this.updateMetadata(V,{installedTimestamp:Date.now()}):null}async removeExtension($,q){this.logService.trace(`Deleting ${q} extension from disk`,$.identifier.id,$.location.fsPath),await g.Promises.rm($.location.fsPath),this.logService.info("Deleted from disk",$.identifier.id,$.location.fsPath)}async removeUninstalledExtension($){await this.removeExtension($,"uninstalled"),await this.withUninstalledExtensions(q=>delete q[u.ExtensionKey.create($).toString()])}async withUninstalledExtensions($){return this.uninstalledFileLimiter.queue(async()=>{let q;try{q=await g.Promises.readFile(this.uninstalledPath,"utf8")}catch(x){if(x.code!=="ENOENT")throw x}let V={};if(q)try{V=JSON.parse(q)}catch{}return $&&($(V),Object.keys(V).length?await g.Promises.writeFile(this.uninstalledPath,JSON.stringify(V)):await g.Promises.rm(this.uninstalledPath)),V})}async extractAtLocation($,q,V,x){this.logService.trace(`Started extracting the extension from ${q} to ${V}`);try{await g.Promises.rm(V)}catch(K){throw new m.ExtensionManagementError(this.joinErrors(K).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(q,V,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${V}:`,$.id)}catch(K){try{await g.Promises.rm(V)}catch{}let Z=m.ExtensionManagementErrorCode.Extract;throw K instanceof v.ExtractError&&(K.type==="CorruptZip"?Z=m.ExtensionManagementErrorCode.CorruptZip:K.type==="Incomplete"&&(Z=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(K.message,Z)}}async rename($,q,V,x){try{await g.Promises.rename(q,V)}catch(K){if(E.isWindows&&K&&K.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${q} to ${V} with 'EPERM' error. Trying again...`,$.id),this.rename($,q,V,x);throw new m.ExtensionManagementError(K.message||f.localize(2,null,q,V),K.code||m.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension($,q){const V=await this.extensionsScannerService.scanExistingExtension($,q,{includeInvalid:!0});if(V)return this.toLocalExtension(V);throw new Error(f.localize(3,null,$.path))}async toLocalExtension($){const q=await this.fileService.resolve($.location);let V,x;return q.children&&(V=q.children.find(({name:K})=>/^readme(\.txt|\.md|)$/i.test(K))?.resource,x=q.children.find(({name:K})=>/^changelog(\.txt|\.md|)$/i.test(K))?.resource),{identifier:$.identifier,type:$.type,isBuiltin:$.isBuiltin||!!$.metadata?.isBuiltin,location:$.location,manifest:$.manifest,targetPlatform:$.targetPlatform,validations:$.validations,isValid:$.isValid,readmeUrl:V,changelogUrl:x,publisherDisplayName:$.metadata?.publisherDisplayName||null,publisherId:$.metadata?.publisherId||null,isMachineScoped:!!$.metadata?.isMachineScoped,isPreReleaseVersion:!!$.metadata?.isPreReleaseVersion,preRelease:!!$.metadata?.preRelease,installedTimestamp:$.metadata?.installedTimestamp,updated:!!$.metadata?.updated}}async removeUninstalledExtensions(){const $=await this.getUninstalledExtensions(),q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),V=new Set;for(const Z of q)$[u.ExtensionKey.create(Z).toString()]||V.add(Z.identifier.id.toLowerCase());const x=(0,u.groupByExtension)(q,Z=>Z.identifier);await D.Promises.settled(x.map(async Z=>{const X=Z.sort((z,M)=>R.rcompare(z.manifest.version,M.manifest.version))[0];V.has(X.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(X))}));const K=q.filter(Z=>$[u.ExtensionKey.create(Z).toString()]);await D.Promises.settled(K.map(Z=>this.removeUninstalledExtension(Z)))}async removeOutdatedExtensions(){const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=[],V=await this.extensionsScannerService.getTargetPlatform(),x=(0,u.groupByExtension)($,K=>K.identifier);q.push(...x.map(K=>K.sort((Z,X)=>{const z=R.rcompare(Z.manifest.version,X.manifest.version);return z!==0?z:Z.targetPlatform===V?-1:1}).slice(1)).flat()),await D.Promises.settled(q.map(K=>this.removeExtension(K,"outdated")))}joinErrors($){const q=Array.isArray($)?$:[$];return q.length===1?q[0]instanceof Error?q[0]:new Error(q[0]):q.reduce((V,x)=>new Error(`${V.message}${V.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}};F=de([Y(1,l.IFileService),Y(2,t.IExtensionsScannerService),Y(3,b.ILogService)],F);class O extends w.AbstractExtensionTask{constructor($,q,V,x,K){super();this.identifier=$,this.source=q,this.options=V,this.extensionsScanner=x,this.logService=K,this._operation=2}get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension($,q){try{const V=await this.unsetUninstalledAndGetLocal($.key);if(V)return $.metadata?this.extensionsScanner.updateMetadata(V,$.metadata):V}catch{throw E.isMacintosh?new m.ExtensionManagementError(f.localize(4,null),m.ExtensionManagementErrorCode.Internal):new m.ExtensionManagementError(f.localize(5,null),m.ExtensionManagementErrorCode.Internal)}return this.extract($,q)}async unsetUninstalledAndGetLocal($){if(!await this.isUninstalled($))return null;this.logService.trace("Removing the extension from uninstalled list:",$.id);const V=await this.extensionsScanner.setInstalled($);return this.logService.info("Removed the extension from uninstalled list:",$.id),V}async isUninstalled($){return!!(await this.extensionsScanner.getUninstalledExtensions())[$.toString()]}async extract({zipPath:$,key:q,metadata:V},x){let K=await this.extensionsScanner.extractUserExtension(q,$,V,x);return this.logService.info("Extracting completed.",q.id),K}}class W extends O{constructor($,q,V,x,K){super($.identifier,$,q,x,K);this.gallery=$,this.extensionsDownloader=V}async doRun($){const V=(await this.extensionsScanner.scanExtensions(null)).find(K=>(0,u.areSameExtensions)(K.identifier,this.gallery.identifier));V&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||V?.isBuiltin,x.metadata.isSystem=V?.type===0?!0:void 0,x.metadata.updated=!!V,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:V?.preRelease);try{const K=await this.installExtension(x,$);return V&&(V.targetPlatform!==K.targetPlatform||R.neq(V.manifest.version,K.manifest.version))&&await this.extensionsScanner.setUninstalled(V),K}catch(K){throw await this.deleteDownloadedVSIX(x.zipPath),K}}async deleteDownloadedVSIX($){try{await this.extensionsDownloader.delete(p.URI.file($))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",$.toString(),(0,k.getErrorMessage)(q))}}async downloadInstallableExtension($,q){const V={id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName,targetPlatform:$.properties.targetPlatform};let x;try{this.logService.trace("Started downloading extension:",$.identifier.id),x=(await this.extensionsDownloader.downloadExtension($,q)).fsPath,this.logService.info("Downloaded extension:",$.identifier.id,x)}catch(K){throw new m.ExtensionManagementError((0,w.joinErrors)(K).message,m.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(x),{zipPath:x,key:u.ExtensionKey.create($),metadata:V}}catch(K){throw await this.deleteDownloadedVSIX(x),new m.ExtensionManagementError((0,w.joinErrors)(K).message,m.ExtensionManagementErrorCode.Invalid)}}}class H extends O{constructor($,q,V,x,K,Z){super({id:(0,u.getGalleryExtensionId)($.publisher,$.name)},q,V,K,Z);this.manifest=$,this.location=q,this.galleryService=x}async doRun($){const q=new u.ExtensionKey(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(Z=>(0,u.areSameExtensions)(this.identifier,Z.identifier)),K=await this.getMetadata(this.identifier.id,this.manifest.version,$);if(K.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,K.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,q.equals(new u.ExtensionKey(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(f.localize(6,null,this.manifest.displayName||this.manifest.name))}else R.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const Z=await this.unsetUninstalledAndGetLocal(q);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),key:q,metadata:K},$)}async getMetadata($,q,V){try{let[x]=await this.galleryService.getExtensions([{id:$,version:q}],V);if(x||([x]=await this.galleryService.getExtensions([{id:$}],V)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class te extends w.AbstractExtensionTask{constructor($,q,V){super();this.extension=$,this.options=q,this.extensionsScanner=V}async doRun($){const q=[],V=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=u.ExtensionKey.create(this.extension);q.push(...V.filter(K=>x.equals(u.ExtensionKey.create(K))))}else q.push(...V.filter(x=>(0,u.areSameExtensions)(x.identifier,this.extension.identifier)));if(!q.length)throw new Error(f.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const x of q)try{$.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(K){throw new Error(f.localize(9,null,(0,n.toErrorMessage)(K)))}}}}),define(ie[252],re([0,1,90,57,35,16,8,3,2,10,4,30,36,80,263]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(b,_=""){this.debugLabel=_,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,A.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(b,_){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(b){const _=U=>{this.traceSocketEvent("read",U),b(T.VSBuffer.wrap(U))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(b){const _=U=>{this.traceSocketEvent("close",{hadError:U}),b({type:0,hadError:U,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(b){const _=()=>{this.traceSocketEvent("nodeEndReceived"),b()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(b){if(!this.socket.destroyed)try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=v;var f;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var d;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(d||(d={}));class S extends E.Disposable{constructor(b,_,U,N){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:U?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new w(this,_,U,N,this._onData,(L,F)=>this._write(L,F))),this._register(this._flowManager.onError(L=>{console.error(L),(0,A.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,_){this.socket.traceSocketEvent(b,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._flowManager.writeMessage(b)}_write(b,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let U=2;b.byteLength<126?U+=0:b.byteLength<2**16?U+=2:U+=8;const N=T.VSBuffer.alloc(U);if(_?N.writeUInt8(194,0):N.writeUInt8(130,0),b.byteLength<126)N.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){N.writeUInt8(126,1);let L=1;N.writeUInt8(b.byteLength>>>8&255,++L),N.writeUInt8(b.byteLength>>>0&255,++L)}else{N.writeUInt8(127,1);let L=1;N.writeUInt8(0,++L),N.writeUInt8(0,++L),N.writeUInt8(0,++L),N.writeUInt8(0,++L),N.writeUInt8(b.byteLength>>>24&255,++L),N.writeUInt8(b.byteLength>>>16&255,++L),N.writeUInt8(b.byteLength>>>8&255,++L),N.writeUInt8(b.byteLength>>>0&255,++L)}this.socket.write(T.VSBuffer.concat([N,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),U=_.readUInt8(0),N=(U&128)>>>7,L=(U&64)>>>6,F=_.readUInt8(1),O=(F&128)>>>7,W=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),U=_.readUInt8(1),N=(U&128)>>>7;let L=U&127,F=1;L===126?L=_.readUInt8(++F)*2**8+_.readUInt8(++F):L===127&&(L=_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*2**24+_.readUInt8(++F)*2**16+_.readUInt8(++F)*2**8+_.readUInt8(++F));let O=0;N&&(O=_.readUInt8(++F)*2**24+_.readUInt8(++F)*2**16+_.readUInt8(++F)*2**8+_.readUInt8(++F)),this._state.state=3,this._state.readLen=L,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),t(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class w extends E.Disposable{constructor(b,_,U,N,L,F){super();this._tracer=b,this._onData=L,this._writeFn=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new m(this._tracer,N,U,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(_,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,_){return new Promise((U,N)=>{b.write(_),b.flush(L=>U(L))})}acceptFrame(b,_,U){this._readQueue.push({data:b,isCompressed:_,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1}}_inflateFrame(b,_,U){return new Promise((N,L)=>{b.write(_),U&&b.write(T.VSBuffer.fromByteArray([0,0,255,255])),b.flush(F=>N(F))})}}class m extends E.Disposable{constructor(b,_,U,N){super();this._tracer=b,this._recordInflateBytes=_,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(N),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(T.VSBuffer.wrap(L))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(_)})}}class u extends E.Disposable{constructor(b,_){super();this._tracer=b,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(T.VSBuffer.wrap(U))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),b(_)})}}function t(h,b){if(b===0)return;let _=h.byteLength>>>2;for(let W=0;W<_;W++){const H=h.readUInt32BE(W*4);h.writeUInt32BE(H^b,W*4)}let U=_*4,N=h.byteLength-U;const L=b>>>24&255,F=b>>>16&255,O=b>>>8&255;N>=1&&h.writeUInt8(h.readUInt8(U)^L,U),N>=2&&h.writeUInt8(h.readUInt8(U+1)^F,U+1),N>=3&&h.writeUInt8(h.readUInt8(U+2)^O,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function i(){const h=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):b=(0,C.join)((0,k.tmpdir)(),`vscode-ipc-${h}.sock`),a(b),b}e.createRandomIPCHandle=i;function o(h,b,_){const U=(0,D.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${_}-${b}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${_}-${b}.sock`):N=(0,C.join)(h,`${_}-${b}.sock`),a(N),N}e.createStaticIPCHandle=o;function a(h){const b=c[R.platform];typeof b=="number"&&h.length>=b&&console.warn(`WARNING: IPC handle "${h}" is longer than ${b} chars, try a shorter --user-data-dir`)}class r extends p.IPCServer{constructor(b){super(r.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const _=I.Event.fromNodeEventEmitter(b,"connection");return I.Event.map(_,U=>({protocol:new y.Protocol(new v(U,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(h){return new Promise((b,_)=>{const U=(0,n.createServer)();U.on("error",_),U.listen(h,()=>{U.removeListener("error",_),b(new r(U))})})}e.serve=s;function l(h,b){return new Promise((_,U)=>{const N=(0,n.createConnection)(h,()=>{N.removeListener("error",U),_(y.Client.fromSocket(new v(N,`ipc-client${b}`),b))});N.once("error",U)})}e.connect=l}),define(ie[253],re([0,1,57,252]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,T,A,I,E){const C=P=>E(P,void 0),R=D.createConnection({host:k,port:T},()=>{R.removeListener("error",C);const P=Buffer.alloc(16);for(let v=0;v<16;v++)P[v]=Math.round(Math.random()*256);const p=P.toString("base64"),y=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];R.write(y.join(`\r
`)+`\r
\r
`);const g=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(R.off("data",g),E(void 0,new n.NodeSocket(R,I)))};R.on("data",g)});R.setNoDelay(!0),R.once("error",C)}}}),define(ie[254],re([0,1,57,119,253,5,2,18,9,23,189,66,98]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(S,w,m,u,t){let c;for(let i=3;i&&(c&&c.dispose(),c=await new g(S,w,m,u,t).waitForReady(),!(t&&n.BROWSER_RESTRICTED_PORTS[t]||!n.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class g extends A.Disposable{constructor(w,m,u,t,c){super();this.defaultTunnelHost=m,this.suggestedLocalPort=c,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(m=>{m()})}async waitForReady(){let w=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),m=null;return this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),m=this._server.address(),m||(w=0,this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),m=this._server.address()),this.tunnelLocalPort=m.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${m.port}`,this}async _onConnection(w){w.pause();const m=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,R.connectRemoteAgentTunnel)(this._options,m,this.tunnelRemotePort),t=u.getSocket().socket,c=u.readEntireBuffer();u.dispose(),c.byteLength>0&&w.write(c.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),t.end()}),w.on("close",()=>t.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),t.destroy()}),t.on("end",()=>w.end()),t.on("close",()=>w.end()),t.on("error",()=>{w.destroy()}),w.pipe(t),t.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),t.end()})}}let v=class extends P.AbstractTunnelService{constructor(w,m,u,t,c){super(m);this.socketFactory=w,this.signService=u,this.productService=t,this.configurationService=c}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(w,m,u,t,c,i,o){const a=this.getTunnelFromMap(m,u);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,m,u,t,c,i,o);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${m}:${u} on local port ${t}.`);const r={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},s=y(r,this.defaultTunnelHost,m,u,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(m,u,s),s}}};v=de([Y(1,E.ILogService),Y(2,p.ISignService),Y(3,C.IProductService),Y(4,I.IConfigurationService)],v),e.BaseTunnelService=v;let f=class extends v{constructor(w,m,u,t){super(k.nodeSocketFactory,w,m,u,t)}};f=de([Y(0,E.ILogService),Y(1,p.ISignService),Y(2,C.IProductService),Y(3,I.IConfigurationService)],f),e.TunnelService=f;let d=class extends A.Disposable{constructor(w,m,u,t){super();this.logService=w,this.productService=m,this.signService=u,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(w,m,u,t,c,i,o,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${t} on local port ${c}.`),!this._tunnelServices.has(w)){const r=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(r),this._tunnelServices.set(w,r),r.onTunnelClosed(async()=>{(await r.tunnels).length===0&&(r.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(m,u,t,c,i,o,a)}};d=de([Y(0,E.ILogService),Y(1,C.IProductService),Y(2,p.ISignService),Y(3,I.IConfigurationService)],d),e.SharedTunnelsService=d}),define(ie[264],re([0,1,81,35,37,8,2,19,20,7,36,122,183,206,184,175,176,177,163,166,18,187,87,210,88,198,13,202,205,214,29,165,212,251,89,161,14,180,182,52,6,172,92,173,174,61,195,9,93,62,94,23,197,43,21,208,209,22,99,100,101,47,215,216,102,218,224,65,104,24,67,240,242,243,68,241,245,246,247,248,249,98,204,66,254,196,225,97,201,32,227,4,228,167,186,185,64,194]),function(Q,e,D,n,k,T,A,I,E,C,R,P,p,y,g,v,f,d,S,w,m,u,t,c,i,o,a,r,s,l,h,b,_,U,N,L,F,O,W,H,te,G,$,q,V,x,K,Z,X,z,M,j,B,J,ne,ae,he,ve,we,ge,ye,De,Ie,Re,qe,Qe,xe,Ve,se,ce,le,Ee,Ce,Ue,Le,Me,Ae,_e,ee,oe,ue,fe,pe,me,be,ke,Te,Pe,Ne,Fe,We,tt,bt,mt,Ct,vt,It,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Rt extends A.Disposable{constructor(Se){super();this.configuration=Se,this.server=this._register(new P.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const Se=()=>this.dispose();process.once("exit",Se),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Oe="vscode:electron-main->shared-process=disposeWorker",$e=(He,ze)=>this.onDisposeWorker(ze);D.ipcRenderer.on(Oe,$e),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,$e)))}onDisposeWorker(Se){this.sharedProcessWorkerService?.disposeWorker(Se)}async open(){const Se=await this.initServices();(0,ce.registerConfiguration)(),Se.invokeFunction(Oe=>{const $e=Oe.get(Z.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(Se.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),Se.createInstance(g.LanguagePackCachedDataCleaner),Se.createInstance(d.StorageDataCleaner,this.configuration.backupWorkspacesPath),Se.createInstance(f.LogsDataCleaner),Se.createInstance(v.LocalizationsUpdater),Se.createInstance(y.ExtensionsCleaner)))}async initServices(){const Se=new $.ServiceCollection,Oe={_serviceBrand:void 0,...M.default};Se.set(j.IProductService,Oe);const $e=new R.StaticRouter(je=>je==="main"),He=new q.MessagePortMainProcessService(this.server,$e);Se.set(V.IMainProcessService,He);const ze=new r.SharedProcessEnvironmentService(this.configuration.args,Oe);Se.set(a.INativeEnvironmentService,ze);const rt=new X.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Xe=new X.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));Se.set(Z.ILoggerService,Xe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,E.joinPath)(C.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new X.FollowerLogService(rt,ot));Se.set(Z.ILogService,Ge),this.sharedProcessWorkerService=new Ne.SharedProcessWorkerService(Ge),Se.set(Pe.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ke=this._register(new O.FileService(Ge));Se.set(F.IFileService,Ke);const at=this._register(new W.DiskFileSystemProvider(Ge));Ke.registerProvider(I.Schemas.file,at);const ct=this._register(new bt.FileUserDataProvider(I.Schemas.file,this._register(new mt.DiskFileSystemProviderClient(He.getChannel(mt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:tt.isLinux})),I.Schemas.vscodeUserData,Ge));Ke.registerProvider(I.Schemas.vscodeUserData,ct);const Ye=this._register(new u.ConfigurationService(ze.settingsResource,Ke));Se.set(m.IConfigurationService,Ye);const nt=new ae.NativeStorageService(void 0,He,ze);Se.set(ne.IStorageService,nt),this._register((0,A.toDisposable)(()=>nt.flush())),await Promise.all([Ye.initialize(),nt.initialize()]),Se.set(Fe.IUriIdentityService,new We.UriIdentityService(Ke)),Se.set(J.IRequestService,new H.SyncDescriptor(B.RequestService)),Se.set(S.IChecksumService,new H.SyncDescriptor(w.ChecksumService)),Se.set(vt.IV8InspectProfilingService,new H.SyncDescriptor(Ct.InspectProfilingService));const st=R.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});Se.set(z.INativeHostService,st),Se.set(i.IDownloadService,new H.SyncDescriptor(o.DownloadService));const lt=this._register(new ue.ActiveWindowManager(st)),ut=new R.StaticRouter(je=>lt.getActiveClientId().then(ht=>je===ht));Se.set(N.IExtensionRecommendationNotificationService,new L.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let Ze;const it=[];if((0,De.supportsTelemetry)(Oe,ze)){const je=new ge.TelemetryLogAppender(Xe,ze);it.push(je);const{installSourcePath:ht}=ze;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const yt=new Ie.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>yt.flush())),it.push(yt)}Ze=new ye.TelemetryService({appenders:it,commonProperties:(0,he.resolveCommonProperties)(Ke,(0,n.release)(),(0,n.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,ht),sendErrorTelemetry:!0,piiPaths:(0,De.getPiiPathsFromEnvironment)(ze)},Ye,Oe)}else{Ze=De.NullTelemetryService;const je=De.NullAppender;it.push(je)}this.server.registerChannel("telemetryAppender",new we.TelemetryAppenderChannel(it)),Se.set(ve.ITelemetryService,Ze);const kt=new Re.CustomEndpointTelemetryService(Ye,Ze,Xe,ze,Oe);Se.set(ve.ICustomEndpointTelemetryService,kt),Se.set(It.IExtensionsScannerService,new H.SyncDescriptor(Pt.ExtensionsScannerService)),Se.set(h.IExtensionManagementService,new H.SyncDescriptor(U.ExtensionManagementService)),Se.set(h.IExtensionGalleryService,new H.SyncDescriptor(l.ExtensionGalleryService)),Se.set(h.IExtensionTipsService,new H.SyncDescriptor(_.ExtensionTipsService)),Se.set(x.ILocalizationsService,new H.SyncDescriptor(K.LocalizationsService)),Se.set(t.IDiagnosticsService,new H.SyncDescriptor(c.DiagnosticsService)),Se.set(le.IUserDataSyncAccountService,new H.SyncDescriptor(le.UserDataSyncAccountService)),Se.set(ce.IUserDataSyncLogService,new H.SyncDescriptor(Ue.UserDataSyncLogService)),Se.set(ce.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),Se.set(h.IGlobalExtensionEnablementService,new H.SyncDescriptor(s.GlobalExtensionEnablementService)),Se.set(se.IIgnoredExtensionsManagementService,new H.SyncDescriptor(se.IgnoredExtensionsManagementService)),Se.set(Ve.IExtensionStorageService,new H.SyncDescriptor(Ve.ExtensionStorageService)),Se.set(ce.IUserDataSyncStoreManagementService,new H.SyncDescriptor(ee.UserDataSyncStoreManagementService)),Se.set(ce.IUserDataSyncStoreService,new H.SyncDescriptor(ee.UserDataSyncStoreService)),Se.set(Le.IUserDataSyncMachinesService,new H.SyncDescriptor(Le.UserDataSyncMachinesService)),Se.set(ce.IUserDataSyncBackupStoreService,new H.SyncDescriptor(Ee.UserDataSyncBackupStoreService)),Se.set(ce.IUserDataSyncEnablementService,new H.SyncDescriptor(Me.UserDataSyncEnablementService)),Se.set(ce.IUserDataSyncService,new H.SyncDescriptor(Ae.UserDataSyncService));const St=new xe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,ze,Ge);return await St.initialize(),Se.set(Qe.ILocalPtyService,this._register(St)),Se.set(fe.ISignService,new H.SyncDescriptor(pe.SignService)),Se.set(me.ISharedTunnelsService,new H.SyncDescriptor(be.SharedTunnelsService)),Se.set(ke.ISharedProcessTunnelService,new H.SyncDescriptor(Te.SharedProcessTunnelService)),new G.InstantiationService(Se)}initChannels(Se){const Oe=new b.ExtensionManagementChannel(Se.get(h.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const $e=R.ProxyChannel.fromService(Se.get(x.ILocalizationsService));this.server.registerChannel("localizations",$e);const He=R.ProxyChannel.fromService(Se.get(t.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const ze=new b.ExtensionTipsChannel(Se.get(h.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=R.ProxyChannel.fromService(Se.get(S.IChecksumService));this.server.registerChannel("checksum",rt);const Xe=R.ProxyChannel.fromService(Se.get(vt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ce.UserDataSyncMachinesServiceChannel(Se.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Ge=R.ProxyChannel.fromService(Se.get(ve.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Ke=new Ce.UserDataSyncAccountServiceChannel(Se.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const at=new Ce.UserDataSyncStoreManagementServiceChannel(Se.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new _e.UserDataSyncChannel(Se.get(ce.IUserDataSyncService),Se.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const Ye=this._register(Se.get(te.IInstantiationService).createInstance(oe.UserDataAutoSyncService)),nt=new Ce.UserDataAutoSyncChannel(Ye);this.server.registerChannel("userDataAutoSync",nt);const st=Se.get(Qe.ILocalPtyService),lt=R.ProxyChannel.fromService(st);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,lt);const ut=R.ProxyChannel.fromService(Se.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const Ze=R.ProxyChannel.fromService(Se.get(Pe.ISharedProcessWorkerService));this.server.registerChannel(Pe.ipcSharedProcessWorkerChannelName,Ze)}registerErrorHandler(Se){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const $e=(0,k.toErrorMessage)(Oe,!0);!$e||Se.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Dt(pt){const Se=new Rt(pt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Dt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c3511e6c69bb39013c4a4b7b9566ec1ca73fc4d5/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
