/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","electron","vs/base/common/errors","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/arrays","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","crypto","net","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],te=function(j){for(var e=[],v=0,t=j.length;v<t;v++)e[v]=ee[j[v]];return e};define(ee[109],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(t,D){if(!t)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(ee[110],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(R){return R?R.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(y,E,b){this.id=y,this.definition=E,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(R,y){const E=["codicon","codicon-"+R];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=D;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(k){if(k instanceof t)return["codicon","codicon-"+k.id];const I=y.exec(k.id);if(!I)return E(t.error);let[,p,g]=I;const h=["codicon","codicon-"+p];return g&&h.push("codicon-modifier-"+g.substr(1)),h}R.asClassNameArray=E;function b(k){return E(k).join(" ")}R.asClassName=b;function P(k){return"."+E(k).join(".")}R.asCSSSelector=P})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ee[48],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(R){return(y,E,b)=>{let P=null,k=null;if(typeof b.value=="function"?(P="value",k=b.value):typeof b.get=="function"&&(P="get",k=b.get),!k)throw new Error("not supported");b[P]=R(k,E)}}e.createDecorator=v;function t(R,y,E){let b=null,P=null;if(typeof E.value=="function"?(b="value",P=E.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",P=E.get),!P)throw new Error("not supported");const k=`$memoize$${y}`;E[b]=function(...I){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,I)}),this[k]}}e.memoize=t;function D(R,y,E){return v((b,P)=>{const k=`$debounce$${P}`,I=`$debounce$result$${P}`;return function(...p){this[I]||(this[I]=E?E():void 0),clearTimeout(this[k]),y&&(this[I]=y(this[I],...p),p=[this[I]]),this[k]=setTimeout(()=>{b.apply(this,p),this[I]=E?E():void 0},R)}})}e.debounce=D;function L(R,y,E){return v((b,P)=>{const k=`$throttle$timer$${P}`,I=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...h){if(this[I]||(this[I]=E?E():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),y&&(this[I]=y(this[I],...h)),this[g])return;const m=this[p]+R;m<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[I]]),this[I]=E?E():void 0):(this[g]=!0,this[k]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),b.apply(this,[this[I]]),this[I]=E?E():void 0},m-Date.now()))}})}e.throttle=L}),define(ee[15],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(l=>{l(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=v,e.errorHandler=new v;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function D(c){E(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function L(c){E(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=L;function R(c){if(c instanceof Error){let{name:r,message:l}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:r,message:l,stack:i}}return c}e.transformErrorForSerialization=R;const y="Canceled";function E(c){return c instanceof b?!0:c instanceof Error&&c.name===y&&c.message===y}e.isCancellationError=E;class b extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=b;function P(){const c=new Error(y);return c.name=c.message,c}e.canceled=P;function k(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=k;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function g(c){const r=new Error(`${c} has been disposed`);return r.name="DISPOSED",r}e.disposed=g;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class m extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=m;class S extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=S;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;class f extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(r){if(r&&r instanceof f)return r;if(r&&r instanceof Error){const l=new f;return l.name=r.name,l.message=r.message,l.stack=r.stack,l}return new f(r)}}e.ErrorNoTelemetry=f;class u extends Error{constructor(r){super(r);Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(ee[26],te([0,1,15]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(W,O=0){return W[W.length-(1+O)]}e.tail=t;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function L(W,O,U=(K,ne)=>K===ne){if(W===O)return!0;if(!W||!O||W.length!==O.length)return!1;for(let K=0,ne=W.length;K<ne;K++)if(!U(W[K],O[K]))return!1;return!0}e.equals=L;function R(W,O,U){let K=0,ne=W.length-1;for(;K<=ne;){const ae=(K+ne)/2|0,le=U(W[ae],O);if(le<0)K=ae+1;else if(le>0)ne=ae-1;else return ae}return-(K+1)}e.binarySearch=R;function y(W,O){let U=0,K=W.length;if(K===0)return 0;for(;U<K;){const ne=Math.floor((U+K)/2);O(W[ne])?K=ne:U=ne+1}return U}e.findFirstInSorted=y;function E(W,O,U){if(W=W|0,W>=O.length)throw new TypeError("invalid index");let K=O[Math.floor(O.length*Math.random())],ne=[],ae=[],le=[];for(let oe of O){const ue=U(oe,K);ue<0?ne.push(oe):ue>0?ae.push(oe):le.push(oe)}return W<ne.length?E(W,ne,U):W<ne.length+le.length?le[0]:E(W-(ne.length+le.length),ae,U)}e.quickSelect=E;function b(W,O){const U=[];let K;for(const ne of W.slice(0).sort(O))!K||O(K[0],ne)!==0?(K=[ne],U.push(K)):K.push(ne);return U}e.groupBy=b;function P(W,O,U){const K=[];function ne(oe,ue,de){if(ue===0&&de.length===0)return;const we=K[K.length-1];we&&we.start+we.deleteCount===oe?(we.deleteCount+=ue,we.toInsert.push(...de)):K.push({start:oe,deleteCount:ue,toInsert:de})}let ae=0,le=0;for(;;){if(ae===W.length){ne(ae,0,O.slice(le));break}if(le===O.length){ne(ae,W.length-ae,[]);break}const oe=W[ae],ue=O[le],de=U(oe,ue);de===0?(ae+=1,le+=1):de<0?(ne(ae,1,[]),ae+=1):de>0&&(ne(ae,0,[ue]),le+=1)}return K}e.sortedDiff=P;function k(W,O,U){const K=P(W,O,U),ne=[],ae=[];for(const le of K)ne.push(...W.slice(le.start,le.start+le.deleteCount)),ae.push(...le.toInsert);return{removed:ne,added:ae}}e.delta=k;function I(W,O,U){if(U===0)return[];const K=W.slice(0,U).sort(O);return g(W,O,K,U,W.length),K}e.top=I;function p(W,O,U,K,ne){return U===0?Promise.resolve([]):new Promise((ae,le)=>{(async()=>{const oe=W.length,ue=W.slice(0,U).sort(O);for(let de=U,we=Math.min(U+K,oe);de<oe;de=we,we=Math.min(we+K,oe)){if(de>U&&await new Promise(Ie=>setTimeout(Ie)),ne&&ne.isCancellationRequested)throw new v.CancellationError;g(W,O,ue,de,we)}return ue})().then(ae,le)})}e.topAsync=p;function g(W,O,U,K,ne){for(const ae=U.length;K<ne;K++){const le=W[K];if(O(le,U[ae-1])<0){U.pop();const oe=y(U,ue=>O(le,ue)<0);U.splice(oe,0,le)}}}function h(W){return W.filter(O=>!!O)}e.coalesce=h;function m(W){let O=0;for(let U=0;U<W.length;U++)W[U]&&(W[O]=W[U],O+=1);W.length=O}e.coalesceInPlace=m;function S(W,O,U){W.splice(U,0,W.splice(O,1)[0])}e.move=S;function C(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=C;function f(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=f;function u(W,O=U=>U){const U=new Set;return W.filter(K=>{const ne=O(K);return U.has(ne)?!1:(U.add(ne),!0)})}e.distinct=u;function c(W){const O=new Set;return U=>{const K=W(U);return O.has(K)?!1:(O.add(K),!0)}}e.uniqueFilter=c;function r(W,O){const U=l(W,O);if(U!==-1)return W[U]}e.findLast=r;function l(W,O){for(let U=W.length-1;U>=0;U--){const K=W[U];if(O(K))return U}return-1}e.lastIndex=l;function i(W,O){return W.length>0?W[0]:O}e.firstOrDefault=i;function n(W,O){return W.length>0?W[W.length-1]:O}e.lastOrDefault=n;function o(W,O,U=(K,ne)=>K===ne){let K=0;for(let ne=0,ae=Math.min(W.length,O.length);ne<ae&&U(W[ne],O[ne]);ne++)K++;return K}e.commonPrefixLength=o;function s(W){return[].concat(...W)}e.flatten=s;function a(W,O){let U=typeof O=="number"?W:0;typeof O=="number"?U=W:(U=0,O=W);const K=[];if(U<=O)for(let ne=U;ne<O;ne++)K.push(ne);else for(let ne=U;ne>O;ne--)K.push(ne);return K}e.range=a;function d(W,O,U){return W.reduce((K,ne)=>(K[O(ne)]=U?U(ne):ne,K),Object.create(null))}e.index=d;function w(W,O){return W.push(O),()=>M(W,O)}e.insert=w;function M(W,O){const U=W.indexOf(O);if(U>-1)return W.splice(U,1),O}e.remove=M;function A(W,O,U){const K=W.slice(0,O),ne=W.slice(O);return K.concat(U,ne)}e.arrayInsert=A;function F(W,O){let U;if(typeof O=="number"){let K=O;U=()=>{const ne=Math.sin(K++)*179426549;return ne-Math.floor(ne)}}else U=Math.random;for(let K=W.length-1;K>0;K-=1){const ne=Math.floor(U()*(K+1)),ae=W[K];W[K]=W[ne],W[ne]=ae}}e.shuffle=F;function H(W,O){const U=W.indexOf(O);U>-1&&(W.splice(U,1),W.unshift(O))}e.pushToStart=H;function Y(W,O){const U=W.indexOf(O);U>-1&&(W.splice(U,1),W.push(O))}e.pushToEnd=Y;function ie(W,O){for(const U of O)W.push(U)}e.pushMany=ie;function X(W,O){return Array.isArray(W)?W.map(O):O(W)}e.mapArrayOrNot=X;function z(W){return Array.isArray(W)?W:[W]}e.asArray=z;function x(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=x;function Z(W,O){for(const U of W){const K=O(U);if(K!==void 0)return K}}e.mapFind=Z;function V(W,O,U){const K=$(W,O),ne=W.length,ae=U.length;W.length=ne+ae;for(let le=ne-1;le>=K;le--)W[le+ae]=W[le];for(let le=0;le<ae;le++)W[le+K]=U[le]}e.insertInto=V;function B(W,O,U,K){const ne=$(W,O),ae=W.splice(ne,U);return V(W,ne,K),ae}e.splice=B;function $(W,O){return O<0?Math.max(O+W.length,0):Math.min(O,W.length)}function Q(W,O){return(U,K)=>O(W(U),W(K))}e.compareBy=Q;const q=(W,O)=>W-O;e.numberComparator=q;function J(W,O){if(W.length===0)return;let U=W[0];for(let K=1;K<W.length;K++){const ne=W[K];O(ne,U)>0&&(U=ne)}return U}e.findMaxBy=J;function _(W,O){if(W.length===0)return;let U=W[0];for(let K=1;K<W.length;K++){const ne=W[K];O(ne,U)>=0&&(U=ne)}return U}e.findLastMaxBy=_;function N(W,O){return J(W,(U,K)=>-O(U,K))}e.findMinBy=N;class T{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let U=this.firstIdx;for(;U<this.items.length&&O(this.items[U]);)U++;const K=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,K}takeFromEndWhile(O){let U=this.lastIdx;for(;U>=0&&O(this.items[U]);)U--;const K=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,K}peek(){return this.items[this.firstIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}takeCount(O){const U=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,U}}e.ArrayQueue=T}),define(ee[44],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const D=this;let L=!1,R;return function(){return L||(L=!0,R=t.apply(D,arguments)),R}}e.once=v}),define(ee[68],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}t.is=D;const L=Object.freeze([]);function R(){return L}t.empty=R;function*y(c){yield c}t.single=y;function E(c){return c||L}t.from=E;function b(c){return!c||c[Symbol.iterator]().next().done===!0}t.isEmpty=b;function P(c){return c[Symbol.iterator]().next().value}t.first=P;function k(c,r){for(const l of c)if(r(l))return!0;return!1}t.some=k;function I(c,r){for(const l of c)if(r(l))return l}t.find=I;function*p(c,r){for(const l of c)r(l)&&(yield l)}t.filter=p;function*g(c,r){let l=0;for(const i of c)yield r(i,l++)}t.map=g;function*h(...c){for(const r of c)for(const l of r)yield l}t.concat=h;function*m(c){for(const r of c)for(const l of r)yield l}t.concatNested=m;function S(c,r,l){let i=l;for(const n of c)i=r(i,n);return i}t.reduce=S;function*C(c,r,l=c.length){for(r<0&&(r+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);r<l;r++)yield c[r]}t.slice=C;function f(c,r=Number.POSITIVE_INFINITY){const l=[];if(r===0)return[l,c];const i=c[Symbol.iterator]();for(let n=0;n<r;n++){const o=i.next();if(o.done)return[l,t.empty()];l.push(o.value)}return[l,{[Symbol.iterator](){return i}}]}t.consume=f;function u(c,r,l=(i,n)=>i===n){const i=c[Symbol.iterator](),n=r[Symbol.iterator]();for(;;){const o=i.next(),s=n.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!l(o.value,s.value))return!1}}t.equals=u})(v=e.Iterable||(e.Iterable={}))}),define(ee[45],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function R(r,l=!1){let i=0,n=r.length,o="",s=0,a=16,d=0;function w(X){let z=0,x=0;for(;z<X;){const Z=r.charCodeAt(i);if(Z>=48&&Z<=57)x=x*16+Z-48;else if(Z>=65&&Z<=70)x=x*16+Z-65+10;else if(Z>=97&&Z<=102)x=x*16+Z-97+10;else break;i++,z++}return z<X&&(x=-1),x}function M(X){i=X,o="",s=0,a=16,d=0}function A(){const X=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&b(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&b(r.charCodeAt(i)))for(i++;i<r.length&&b(r.charCodeAt(i));)i++;else return d=3,r.substring(X,i);let z=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&b(r.charCodeAt(i))){for(i++;i<r.length&&b(r.charCodeAt(i));)i++;z=i}else d=3;return r.substring(X,z)}function F(){let X="",z=i;for(;;){if(i>=n){X+=r.substring(z,i),d=2;break}const x=r.charCodeAt(i);if(x===34){X+=r.substring(z,i),i++;break}if(x===92){if(X+=r.substring(z,i),i++,i>=n){d=2;break}switch(r.charCodeAt(i++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:{const V=w(4);V>=0?X+=String.fromCharCode(V):d=4;break}default:d=5}z=i;continue}if(x>=0&&x<=31)if(E(x)){X+=r.substring(z,i),d=2;break}else d=6;i++}return X}function H(){if(o="",d=0,s=i,i>=n)return s=n,a=17;let X=r.charCodeAt(i);if(y(X)){do i++,o+=String.fromCharCode(X),X=r.charCodeAt(i);while(y(X));return a=15}if(E(X))return i++,o+=String.fromCharCode(X),X===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(X){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=F(),a=10;case 47:{const z=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<n&&!E(r.charCodeAt(i));)i++;return o=r.substring(z,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const x=n-1;let Z=!1;for(;i<x;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,Z=!0;break}i++}return Z||(i++,d=1),o=r.substring(z,i),a=13}return o+=String.fromCharCode(X),i++,a=16}case 45:if(o+=String.fromCharCode(X),i++,i===n||!b(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=A(),a=11;default:for(;i<n&&Y(X);)i++,X=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(X),i++,a=16}}function Y(X){if(y(X)||E(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let X;do X=H();while(X>=12&&X<=15);return X}return{setPosition:M,getPosition:()=>i,scan:l?ie:H,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>d}}e.createScanner=R;function y(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function E(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function k(r,l){const i=[],n=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function d(w,M,A,F){s.value=w,s.offset=M,s.length=A,s.type=F,s.colonOffset=void 0,o=s}try{f(r,{onObjectBegin:(w,M)=>{if(l<=w)throw n;o=void 0,a=l>w,i.push("")},onObjectProperty:(w,M,A)=>{if(l<M||(d(w,M,A,"property"),i[i.length-1]=w,l<=M+A))throw n},onObjectEnd:(w,M)=>{if(l<=w)throw n;o=void 0,i.pop()},onArrayBegin:(w,M)=>{if(l<=w)throw n;o=void 0,i.push(0)},onArrayEnd:(w,M)=>{if(l<=w)throw n;o=void 0,i.pop()},onLiteralValue:(w,M,A)=>{if(l<M||(d(w,M,A,c(w)),l<=M+A))throw n},onSeparator:(w,M,A)=>{if(l<=M)throw n;if(w===":"&&o&&o.type==="property")o.colonOffset=M,a=!1,o=void 0;else if(w===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(w){if(w!==n)throw w}return{path:i,previousNode:o,isAtPropertyKey:a,matches:w=>{let M=0;for(let A=0;M<w.length&&A<i.length;A++)if(w[M]===i[A]||w[M]==="*")M++;else if(w[M]!=="**")return!1;return M===w.length}}}e.getLocation=k;function I(r,l=[],i=L.DEFAULT){let n=null,o=[];const s=[];function a(w){Array.isArray(o)?o.push(w):n!==null&&(o[n]=w)}return f(r,{onObjectBegin:()=>{const w={};a(w),s.push(o),o=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const w=[];a(w),s.push(o),o=w,n=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,onError:(w,M,A)=>{l.push({error:w,offset:M,length:A})}},i),o[0]}e.parse=I;function p(r,l=[],i=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function s(w){return n.children.push(w),w}f(r,{onObjectBegin:w=>{n=s({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,M,A)=>{n=s({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:M,length:A,parent:n})},onObjectEnd:(w,M)=>{n.length=w+M-n.offset,n=n.parent,o(w+M)},onArrayBegin:(w,M)=>{n=s({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,M)=>{n.length=w+M-n.offset,n=n.parent,o(w+M)},onLiteralValue:(w,M,A)=>{s({type:c(w),offset:M,length:A,parent:n,value:w}),o(M+A)},onSeparator:(w,M,A)=>{n.type==="property"&&(w===":"?n.colonOffset=M:w===","&&o(M))},onError:(w,M,A)=>{l.push({error:w,offset:M,length:A})}},i);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=p;function g(r,l){if(!r)return;let i=r;for(let n of l)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=g;function h(r){if(!r.parent||!r.parent.children)return[];const l=h(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;l.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&l.push(i)}return l}e.getNodePath=h;function m(r){switch(r.type){case"array":return r.children.map(m);case"object":{const l=Object.create(null);for(let i of r.children){const n=i.children[1];n&&(l[i.children[0].value]=m(n))}return l}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=m;function S(r,l,i=!1){return l>=r.offset&&l<r.offset+r.length||i&&l===r.offset+r.length}e.contains=S;function C(r,l,i=!1){if(S(r,l,i)){const n=r.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=l;o++){const s=C(n[o],l,i);if(s)return s}return r}}e.findNodeAtOffset=C;function f(r,l,i=L.DEFAULT){const n=R(r,!1);function o(_){return _?()=>_(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(_){return _?N=>_(N,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(l.onObjectBegin),d=s(l.onObjectProperty),w=o(l.onObjectEnd),M=o(l.onArrayBegin),A=o(l.onArrayEnd),F=s(l.onLiteralValue),H=s(l.onSeparator),Y=o(l.onComment),ie=s(l.onError),X=i&&i.disallowComments,z=i&&i.allowTrailingComma;function x(){for(;;){const _=n.scan();switch(n.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:X||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(_){case 12:case 13:X?Z(10):Y();break;case 16:Z(1);break;case 15:case 14:break;default:return _}}}function Z(_,N=[],T=[]){if(ie(_),N.length+T.length>0){let W=n.getToken();for(;W!==17;){if(N.indexOf(W)!==-1){x();break}else if(T.indexOf(W)!==-1)break;W=x()}}}function V(_){const N=n.getTokenValue();return _?F(N):d(N),x(),!0}function B(){switch(n.getToken()){case 11:{let _=0;try{_=JSON.parse(n.getTokenValue()),typeof _!="number"&&(Z(2),_=0)}catch{Z(2)}F(_);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return x(),!0}function $(){return n.getToken()!==10?(Z(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(H(":"),x(),J()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function Q(){a(),x();let _=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(_||Z(4,[],[]),H(","),x(),n.getToken()===2&&z)break}else _&&Z(6,[],[]);$()||Z(4,[],[2,5]),_=!0}return w(),n.getToken()!==2?Z(7,[2],[]):x(),!0}function q(){M(),x();let _=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(_||Z(4,[],[]),H(","),x(),n.getToken()===4&&z)break}else _&&Z(6,[],[]);J()||Z(4,[],[4,5]),_=!0}return A(),n.getToken()!==4?Z(8,[4],[]):x(),!0}function J(){switch(n.getToken()){case 3:return q();case 1:return Q();case 10:return V(!0);default:return B()}}return x(),n.getToken()===17?i.allowEmptyContent?!0:(Z(4,[],[]),!1):J()?(n.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.visit=f;function u(r,l){let i=R(r),n=[],o,s=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==a&&n.push(r.substring(s,a)),l!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,l)),s=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function c(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[111],te([0,1,45]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(b,P,k){let I,p,g,h,m;if(P){for(h=P.offset,m=h+P.length,g=h;g>0&&!E(b,g-1);)g--;let a=m;for(;a<b.length&&!E(b,a);)a++;p=b.substring(g,a),I=R(p,k)}else p=b,I=0,g=0,h=0,m=b.length;const S=y(k,b);let C=!1,f=0,u;k.insertSpaces?u=L(" ",k.tabSize||4):u="	";const c=(0,v.createScanner)(p,!1);let r=!1;function l(){return S+L(u,I+f)}function i(){let a=c.scan();for(C=!1;a===15||a===14;)C=C||a===14,a=c.scan();return r=a===16||c.getTokenError()!==0,a}const n=[];function o(a,d,w){!r&&d<m&&w>h&&b.substring(d,w)!==a&&n.push({offset:d,length:w-d,content:a})}let s=i();if(s!==17){const a=c.getTokenOffset()+g,d=L(u,I);o(d,g,a)}for(;s!==17;){let a=c.getTokenOffset()+c.getTokenLength()+g,d=i(),w="";for(;!C&&(d===12||d===13);){const A=c.getTokenOffset()+g;o(" ",a,A),a=c.getTokenOffset()+c.getTokenLength()+g,w=d===12?l():"",d=i()}if(d===2)s!==1&&(f--,w=l());else if(d===4)s!==3&&(f--,w=l());else{switch(s){case 3:case 1:f++,w=l();break;case 5:case 12:w=l();break;case 13:C?w=l():w=" ";break;case 6:w=" ";break;case 10:if(d===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?w=" ":d!==5&&d!==17&&(r=!0);break;case 16:r=!0;break}C&&(d===12||d===13)&&(w=l())}const M=c.getTokenOffset()+g;o(w,a,M),s=d}return n}e.format=t;function D(b,P){const k=JSON.stringify(b,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?k.replace(/\r\n|\r|\n/g,P.eol):k}e.toFormattedString=D;function L(b,P){let k="";for(let I=0;I<P;I++)k+=b;return k}function R(b,P){let k=0,I=0;const p=P.tabSize||4;for(;k<b.length;){const g=b.charAt(k);if(g===" ")I++;else if(g==="	")I+=p;else break;k++}return Math.floor(I/p)}function y(b,P){for(let k=0;k<P.length;k++){const I=P.charAt(k);if(I==="\r")return k+1<P.length&&P.charAt(k+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=y;function E(b,P){return`\r
`.indexOf(b.charAt(P))!==-1}e.isEOL=E}),define(ee[112],te([0,1,45,111]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,P,k){return L(b,P,void 0,k)}e.removeProperty=D;function L(b,P,k,I,p){const g=P.slice(),h=[],m=(0,v.parseTree)(b,h);let S,C;for(;g.length>0&&(C=g.pop(),S=(0,v.findNodeAtLocation)(m,g),S===void 0&&k!==void 0);)typeof C=="string"?k={[C]:k}:k=[k];if(S)if(S.type==="object"&&typeof C=="string"&&Array.isArray(S.children)){const f=(0,v.findNodeAtLocation)(S,[C]);if(f!==void 0)if(k===void 0){if(!f.parent)throw new Error("Malformed AST");const u=S.children.indexOf(f.parent);let c,r=f.parent.offset+f.parent.length;if(u>0){const l=S.children[u-1];c=l.offset+l.length}else c=S.offset+1,S.children.length>1&&(r=S.children[1].offset);return R(b,{offset:c,length:r-c,content:""},I)}else return R(b,{offset:f.offset,length:f.length,content:JSON.stringify(k)},I);else{if(k===void 0)return[];const u=`${JSON.stringify(C)}: ${JSON.stringify(k)}`,c=p?p(S.children.map(l=>l.children[0].value)):S.children.length;let r;if(c>0){const l=S.children[c-1];r={offset:l.offset+l.length,length:0,content:","+u}}else S.children.length===0?r={offset:S.offset+1,length:0,content:u}:r={offset:S.offset+1,length:0,content:u+","};return R(b,r,I)}}else if(S.type==="array"&&typeof C=="number"&&Array.isArray(S.children))if(k!==void 0){const f=`${JSON.stringify(k)}`;let u;if(S.children.length===0||C===0)u={offset:S.offset+1,length:0,content:S.children.length===0?f:f+","};else{const c=C===-1||C>S.children.length?S.children.length:C,r=S.children[c-1];u={offset:r.offset+r.length,length:0,content:","+f}}return R(b,u,I)}else{const f=C,u=S.children[f];let c;if(S.children.length===1)c={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===f){const r=S.children[f-1],l=r.offset+r.length,i=S.offset+S.length;c={offset:l,length:i-2-l,content:""}}else c={offset:u.offset,length:S.children[f+1].offset-u.offset,content:""};return R(b,c,I)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${S.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return R(b,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(k)},I)}}e.setProperty=L;function R(b,P,k){let I=y(b,P),p=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,t.isEOL)(I,p-1);)p--;for(;g<I.length&&!(0,t.isEOL)(I,g);)g++}const h=(0,t.format)(I,{offset:p,length:g-p},k);for(let S=h.length-1;S>=0;S--){const C=h[S];I=y(I,C),p=Math.min(p,C.offset),g=Math.max(g,C.offset+C.length),g+=C.content.length-C.length}const m=b.length-(I.length-g)-p;return[{offset:p,length:m,content:I.substring(p,g)}]}e.withFormatting=R;function y(b,P){return b.substring(0,P.offset)+P.content+b.substring(P.offset+P.length)}e.applyEdit=y;function E(b,P){let k=P.slice(0).sort((p,g)=>{const h=p.offset-g.offset;return h===0?p.length-g.length:h}),I=b.length;for(let p=k.length-1;p>=0;p--){let g=k[p];if(g.offset+g.length<=I)b=y(b,g);else throw new Error("Overlapping edit");I=g.offset}return b}e.applyEdits=E}),define(ee[113],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(ee[2],te([0,1,44,68]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let L=null;function R(o){L=o}if(e.setDisposableTracker=R,D){const o="__is_disposable_tracked__";R(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==C.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==C.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function y(o){return L?.trackDisposable(o),o}function E(o){L?.markAsDisposed(o)}function b(o,s){L?.setParent(o,s)}function P(o,s){if(!!L)for(const a of o)L.setParent(a,s)}function k(o){return L?.markAsSingleton(o),o}e.markAsSingleton=k;class I extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=I;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function g(o){if(t.Iterable.is(o)){let s=[];for(const a of o)if(a)try{a.dispose()}catch(d){s.push(d)}if(s.length===1)throw s[0];if(s.length>1)throw new I(s);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=g;function h(...o){const s=m(()=>g(o));return P(o,s),s}e.combinedDisposable=h;function m(o){const s=y({dispose:(0,v.once)(()=>{E(s),o()})});return s}e.toDisposable=m;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new S,y(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=f;class u{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,E(this))},this}}e.SafeDisposable=c;class r{constructor(){this.references=new Map}acquire(s,...a){let d=this.references.get(s);d||(d={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,d));const{object:w}=d,M=(0,v.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(s,d.object),this.references.delete(s))});return d.counter++,{object:w,dispose:M}}}e.ReferenceCollection=r;class l{constructor(s){this.referenceCollection=s}async acquire(s,...a){const d=this.referenceCollection.acquire(s,...a);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(w){throw d.dispose(),w}}}e.AsyncReferenceCollection=l;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(o){const s=new S;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(ee[114],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(L){this.element=L,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let L=this._first;for(;L!==v.Undefined;){const R=L.next;L.prev=v.Undefined,L.next=v.Undefined,L=R}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,R){const y=new v(L);if(this._first===v.Undefined)this._first=y,this._last=y;else if(R){const b=this._last;this._last=y,y.prev=b,b.next=y}else{const b=this._first;this._first=y,y.next=b,b.prev=y}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(y))}}shift(){if(this._first!==v.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==v.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==v.Undefined&&L.next!==v.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===v.Undefined&&L.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):L.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):L.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==v.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),function(){function j(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function R(E){L.push(E,Date.now())}function y(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:R,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(D+R.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),define(ee[3],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const v="en";let t=!1,D=!1,L=!1,R=!1,y=!1,E=!1,b=!1,P=!1,k=!1,I,p=v,g,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const S=typeof m?.versions?.electron=="string",C=S&&m?.type==="renderer";if(typeof navigator=="object"&&!C)h=navigator.userAgent,t=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,E=!0,I=navigator.language,p=I;else if(typeof m=="object"){t=m.platform==="win32",D=m.platform==="darwin",L=m.platform==="linux",R=L&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,b=S,k=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=v,p=v;const s=m.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),d=a.availableLanguages["*"];I=a.locale,p=d||v,g=a._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var f;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function u(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let c=0;D?c=1:t?c=3:L&&(c=2),e.isWindows=t,e.isMacintosh=D,e.isLinux=L,e.isLinuxSnap=R,e.isNative=y,e.isElectron=b,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=k,e.platform=c,e.userAgent=h,e.language=p;var r;(function(s){function a(){return e.language}s.value=a;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=d;function w(){return e.language==="en"}s.isDefault=w})(r=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let w=0,M=s.length;w<M;w++){const A=s[w];if(A.id===d.data.vscodeScheduleAsyncWork){s.splice(w,1),A.callback();return}}});let a=0;return d=>{const w=++a;s.push({id:w,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return s=>setTimeout(s)})();var l;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||P?2:t?1:3;let i=!0,n=!1;function o(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[8],te([0,1,36]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,L=90,R=122,y=46,E=47,b=92,P=58,k=63;class I extends Error{constructor(u,c,r){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${l} of type ${c}`;n+=`. Received type ${typeof r}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function p(f,u){if(typeof f!="string")throw new I(u,"string",f)}function g(f){return f===E||f===b}function h(f){return f===E}function m(f){return f>=t&&f<=L||f>=D&&f<=R}function S(f,u,c,r){let l="",i=0,n=-1,o=0,s=0;for(let a=0;a<=f.length;++a){if(a<f.length)s=f.charCodeAt(a);else{if(r(s))break;s=E}if(r(s)){if(!(n===a-1||o===1))if(o===2){if(l.length<2||i!==2||l.charCodeAt(l.length-1)!==y||l.charCodeAt(l.length-2)!==y){if(l.length>2){const d=l.lastIndexOf(c);d===-1?(l="",i=0):(l=l.slice(0,d),i=l.length-1-l.lastIndexOf(c)),n=a,o=0;continue}else if(l.length!==0){l="",i=0,n=a,o=0;continue}}u&&(l+=l.length>0?`${c}..`:"..",i=2)}else l.length>0?l+=`${c}${f.slice(n+1,a)}`:l=f.slice(n+1,a),i=a-n-1;n=a,o=0}else s===y&&o!==-1?++o:o=-1}return l}function C(f,u){if(u===null||typeof u!="object")throw new I("pathObject","Object",u);const c=u.dir||u.root,r=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${r}`:`${c}${f}${r}`:r}e.win32={resolve(...f){let u="",c="",r=!1;for(let l=f.length-1;l>=-1;l--){let i;if(l>=0){if(i=f[l],p(i,"path"),i.length===0)continue}else u.length===0?i=v.cwd():(i=v.env[`=${u}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===b)&&(i=`${u}\\`));const n=i.length;let o=0,s="",a=!1;const d=i.charCodeAt(0);if(n===1)g(d)&&(o=1,a=!0);else if(g(d))if(a=!0,g(i.charCodeAt(1))){let w=2,M=w;for(;w<n&&!g(i.charCodeAt(w));)w++;if(w<n&&w!==M){const A=i.slice(M,w);for(M=w;w<n&&g(i.charCodeAt(w));)w++;if(w<n&&w!==M){for(M=w;w<n&&!g(i.charCodeAt(w));)w++;(w===n||w!==M)&&(s=`\\\\${A}\\${i.slice(M,w)}`,o=w)}}}else o=1;else m(d)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),o=2,n>2&&g(i.charCodeAt(2))&&(a=!0,o=3));if(s.length>0)if(u.length>0){if(s.toLowerCase()!==u.toLowerCase())continue}else u=s;if(r){if(u.length>0)break}else if(c=`${i.slice(o)}\\${c}`,r=a,a&&u.length>0)break}return c=S(c,!r,"\\",g),r?`${u}\\${c}`:`${u}${c}`||"."},normalize(f){p(f,"path");const u=f.length;if(u===0)return".";let c=0,r,l=!1;const i=f.charCodeAt(0);if(u===1)return h(i)?"\\":f;if(g(i))if(l=!0,g(f.charCodeAt(1))){let o=2,s=o;for(;o<u&&!g(f.charCodeAt(o));)o++;if(o<u&&o!==s){const a=f.slice(s,o);for(s=o;o<u&&g(f.charCodeAt(o));)o++;if(o<u&&o!==s){for(s=o;o<u&&!g(f.charCodeAt(o));)o++;if(o===u)return`\\\\${a}\\${f.slice(s)}\\`;o!==s&&(r=`\\\\${a}\\${f.slice(s,o)}`,c=o)}}}else c=1;else m(i)&&f.charCodeAt(1)===P&&(r=f.slice(0,2),c=2,u>2&&g(f.charCodeAt(2))&&(l=!0,c=3));let n=c<u?S(f.slice(c),!l,"\\",g):"";return n.length===0&&!l&&(n="."),n.length>0&&g(f.charCodeAt(u-1))&&(n+="\\"),r===void 0?l?`\\${n}`:n:l?`${r}\\${n}`:`${r}${n}`},isAbsolute(f){p(f,"path");const u=f.length;if(u===0)return!1;const c=f.charCodeAt(0);return g(c)||u>2&&m(c)&&f.charCodeAt(1)===P&&g(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let u,c;for(let i=0;i<f.length;++i){const n=f[i];p(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let r=!0,l=0;if(typeof c=="string"&&g(c.charCodeAt(0))){++l;const i=c.length;i>1&&g(c.charCodeAt(1))&&(++l,i>2&&(g(c.charCodeAt(2))?++l:r=!1))}if(r){for(;l<u.length&&g(u.charCodeAt(l));)l++;l>=2&&(u=`\\${u.slice(l)}`)}return e.win32.normalize(u)},relative(f,u){if(p(f,"from"),p(u,"to"),f===u)return"";const c=e.win32.resolve(f),r=e.win32.resolve(u);if(c===r||(f=c.toLowerCase(),u=r.toLowerCase(),f===u))return"";let l=0;for(;l<f.length&&f.charCodeAt(l)===b;)l++;let i=f.length;for(;i-1>l&&f.charCodeAt(i-1)===b;)i--;const n=i-l;let o=0;for(;o<u.length&&u.charCodeAt(o)===b;)o++;let s=u.length;for(;s-1>o&&u.charCodeAt(s-1)===b;)s--;const a=s-o,d=n<a?n:a;let w=-1,M=0;for(;M<d;M++){const F=f.charCodeAt(l+M);if(F!==u.charCodeAt(o+M))break;F===b&&(w=M)}if(M!==d){if(w===-1)return r}else{if(a>d){if(u.charCodeAt(o+M)===b)return r.slice(o+M+1);if(M===2)return r.slice(o+M)}n>d&&(f.charCodeAt(l+M)===b?w=M:M===2&&(w=3)),w===-1&&(w=0)}let A="";for(M=l+w+1;M<=i;++M)(M===i||f.charCodeAt(M)===b)&&(A+=A.length===0?"..":"\\..");return o+=w,A.length>0?`${A}${r.slice(o,s)}`:(r.charCodeAt(o)===b&&++o,r.slice(o,s))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const u=e.win32.resolve(f);if(u.length<=2)return f;if(u.charCodeAt(0)===b){if(u.charCodeAt(1)===b){const c=u.charCodeAt(2);if(c!==k&&c!==y)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(m(u.charCodeAt(0))&&u.charCodeAt(1)===P&&u.charCodeAt(2)===b)return`\\\\?\\${u}`;return f},dirname(f){p(f,"path");const u=f.length;if(u===0)return".";let c=-1,r=0;const l=f.charCodeAt(0);if(u===1)return g(l)?f:".";if(g(l)){if(c=r=1,g(f.charCodeAt(1))){let o=2,s=o;for(;o<u&&!g(f.charCodeAt(o));)o++;if(o<u&&o!==s){for(s=o;o<u&&g(f.charCodeAt(o));)o++;if(o<u&&o!==s){for(s=o;o<u&&!g(f.charCodeAt(o));)o++;if(o===u)return f;o!==s&&(c=r=o+1)}}}}else m(l)&&f.charCodeAt(1)===P&&(c=u>2&&g(f.charCodeAt(2))?3:2,r=c);let i=-1,n=!0;for(let o=u-1;o>=r;--o)if(g(f.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,u){u!==void 0&&p(u,"ext"),p(f,"path");let c=0,r=-1,l=!0,i;if(f.length>=2&&m(f.charCodeAt(0))&&f.charCodeAt(1)===P&&(c=2),u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,o=-1;for(i=f.length-1;i>=c;--i){const s=f.charCodeAt(i);if(g(s)){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1),n>=0&&(s===u.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=o))}return c===r?r=o:r===-1&&(r=f.length),f.slice(c,r)}for(i=f.length-1;i>=c;--i)if(g(f.charCodeAt(i))){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1);return r===-1?"":f.slice(c,r)},extname(f){p(f,"path");let u=0,c=-1,r=0,l=-1,i=!0,n=0;f.length>=2&&f.charCodeAt(1)===P&&m(f.charCodeAt(0))&&(u=r=2);for(let o=f.length-1;o>=u;--o){const s=f.charCodeAt(o);if(g(s)){if(!i){r=o+1;break}continue}l===-1&&(i=!1,l=o+1),s===y?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||l===-1||n===0||n===1&&c===l-1&&c===r+1?"":f.slice(c,l)},format:C.bind(null,"\\"),parse(f){p(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.length;let r=0,l=f.charCodeAt(0);if(c===1)return g(l)?(u.root=u.dir=f,u):(u.base=u.name=f,u);if(g(l)){if(r=1,g(f.charCodeAt(1))){let w=2,M=w;for(;w<c&&!g(f.charCodeAt(w));)w++;if(w<c&&w!==M){for(M=w;w<c&&g(f.charCodeAt(w));)w++;if(w<c&&w!==M){for(M=w;w<c&&!g(f.charCodeAt(w));)w++;w===c?r=w:w!==M&&(r=w+1)}}}}else if(m(l)&&f.charCodeAt(1)===P){if(c<=2)return u.root=u.dir=f,u;if(r=2,g(f.charCodeAt(2))){if(c===3)return u.root=u.dir=f,u;r=3}}r>0&&(u.root=f.slice(0,r));let i=-1,n=r,o=-1,s=!0,a=f.length-1,d=0;for(;a>=r;--a){if(l=f.charCodeAt(a),g(l)){if(!s){n=a+1;break}continue}o===-1&&(s=!1,o=a+1),l===y?i===-1?i=a:d!==1&&(d=1):i!==-1&&(d=-1)}return o!==-1&&(i===-1||d===0||d===1&&i===o-1&&i===n+1?u.base=u.name=f.slice(n,o):(u.name=f.slice(n,i),u.base=f.slice(n,o),u.ext=f.slice(i,o))),n>0&&n!==r?u.dir=f.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let u="",c=!1;for(let r=f.length-1;r>=-1&&!c;r--){const l=r>=0?f[r]:v.cwd();p(l,"path"),l.length!==0&&(u=`${l}/${u}`,c=l.charCodeAt(0)===E)}return u=S(u,!c,"/",h),c?`/${u}`:u.length>0?u:"."},normalize(f){if(p(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===E,c=f.charCodeAt(f.length-1)===E;return f=S(f,!u,"/",h),f.length===0?u?"/":c?"./":".":(c&&(f+="/"),u?`/${f}`:f)},isAbsolute(f){return p(f,"path"),f.length>0&&f.charCodeAt(0)===E},join(...f){if(f.length===0)return".";let u;for(let c=0;c<f.length;++c){const r=f[c];p(r,"path"),r.length>0&&(u===void 0?u=r:u+=`/${r}`)}return u===void 0?".":e.posix.normalize(u)},relative(f,u){if(p(f,"from"),p(u,"to"),f===u||(f=e.posix.resolve(f),u=e.posix.resolve(u),f===u))return"";const c=1,r=f.length,l=r-c,i=1,n=u.length-i,o=l<n?l:n;let s=-1,a=0;for(;a<o;a++){const w=f.charCodeAt(c+a);if(w!==u.charCodeAt(i+a))break;w===E&&(s=a)}if(a===o)if(n>o){if(u.charCodeAt(i+a)===E)return u.slice(i+a+1);if(a===0)return u.slice(i+a)}else l>o&&(f.charCodeAt(c+a)===E?s=a:a===0&&(s=0));let d="";for(a=c+s+1;a<=r;++a)(a===r||f.charCodeAt(a)===E)&&(d+=d.length===0?"..":"/..");return`${d}${u.slice(i+s)}`},toNamespacedPath(f){return f},dirname(f){if(p(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===E;let c=-1,r=!0;for(let l=f.length-1;l>=1;--l)if(f.charCodeAt(l)===E){if(!r){c=l;break}}else r=!1;return c===-1?u?"/":".":u&&c===1?"//":f.slice(0,c)},basename(f,u){u!==void 0&&p(u,"ext"),p(f,"path");let c=0,r=-1,l=!0,i;if(u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,o=-1;for(i=f.length-1;i>=0;--i){const s=f.charCodeAt(i);if(s===E){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1),n>=0&&(s===u.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=o))}return c===r?r=o:r===-1&&(r=f.length),f.slice(c,r)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===E){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1);return r===-1?"":f.slice(c,r)},extname(f){p(f,"path");let u=-1,c=0,r=-1,l=!0,i=0;for(let n=f.length-1;n>=0;--n){const o=f.charCodeAt(n);if(o===E){if(!l){c=n+1;break}continue}r===-1&&(l=!1,r=n+1),o===y?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||r===-1||i===0||i===1&&u===r-1&&u===c+1?"":f.slice(u,r)},format:C.bind(null,"/"),parse(f){p(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.charCodeAt(0)===E;let r;c?(u.root="/",r=1):r=0;let l=-1,i=0,n=-1,o=!0,s=f.length-1,a=0;for(;s>=r;--s){const d=f.charCodeAt(s);if(d===E){if(!o){i=s+1;break}continue}n===-1&&(o=!1,n=s+1),d===y?l===-1?l=s:a!==1&&(a=1):l!==-1&&(a=-1)}if(n!==-1){const d=i===0&&c?1:i;l===-1||a===0||a===1&&l===n-1&&l===i+1?u.base=u.name=f.slice(d,n):(u.name=f.slice(d,l),u.base=f.slice(d,n),u.ext=f.slice(l,n))}return i>0?u.dir=f.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[69],te([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(y,...E){const b=E.reduce((I,p)=>(I[p]=!0,I),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(I=>!b[I]).forEach(I=>{for(let p=0;p<P.length;p++)if(I.search(P[p])!==-1){delete y[I];break}})}e.sanitizeProcessEnvironment=L;function R(y){!y||(delete y.DEBUG,v.isMacintosh&&delete y.DYLD_LIBRARY_PATH,v.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ee[70],te([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(R){this._highResolution=t&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new D(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ee[4],te([0,1,15,44,2,114,70]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let y=!1,E=!1;var b;(function(s){s.None=()=>D.Disposable.None;function a(N){if(E){const{onListenerDidAdd:T}=N,W=g.create();let O=0;N.onListenerDidAdd=()=>{++O==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),W.print()),T?.()}}}function d(N){return(T,W=null,O)=>{let U=!1,K;return K=N(ne=>{if(!U)return K?K.dispose():U=!0,T.call(W,ne)},null,O),U&&K.dispose(),K}}s.once=d;function w(N,T,W){return ie((O,U=null,K)=>N(ne=>O.call(U,T(ne)),null,K),W)}s.map=w;function M(N,T,W){return ie((O,U=null,K)=>N(ne=>{T(ne),O.call(U,ne)},null,K),W)}s.forEach=M;function A(N,T,W){return ie((O,U=null,K)=>N(ne=>T(ne)&&O.call(U,ne),null,K),W)}s.filter=A;function F(N){return N}s.signal=F;function H(...N){return(T,W=null,O)=>(0,D.combinedDisposable)(...N.map(U=>U(K=>T.call(W,K),null,O)))}s.any=H;function Y(N,T,W,O){let U=W;return w(N,K=>(U=T(U,K),U),O)}s.reduce=Y;function ie(N,T){let W;const O={onFirstListenerAdd(){W=N(U.fire,U)},onLastListenerRemove(){W.dispose()}};T||a(O);const U=new m(O);return T&&T.add(U),U.event}function X(N,T,W=100,O=!1,U,K){let ne,ae,le,oe=0;const ue={leakWarningThreshold:U,onFirstListenerAdd(){ne=N(we=>{oe++,ae=T(ae,we),O&&!le&&(de.fire(ae),ae=void 0),clearTimeout(le),le=setTimeout(()=>{const Ie=ae;ae=void 0,le=void 0,(!O||oe>1)&&de.fire(Ie),oe=0},W)})},onLastListenerRemove(){ne.dispose()}};K||a(ue);const de=new m(ue);return K&&K.add(de),de.event}s.debounce=X;function z(N,T=(O,U)=>O===U,W){let O=!0,U;return A(N,K=>{const ne=O||!T(K,U);return O=!1,U=K,ne},W)}s.latch=z;function x(N,T,W){return[s.filter(N,T,W),s.filter(N,O=>!T(O),W)]}s.split=x;function Z(N,T=!1,W=[]){let O=W.slice(),U=N(ae=>{O?O.push(ae):ne.fire(ae)});const K=()=>{O&&O.forEach(ae=>ne.fire(ae)),O=null},ne=new m({onFirstListenerAdd(){U||(U=N(ae=>ne.fire(ae)))},onFirstListenerDidAdd(){O&&(T?setTimeout(K):K())},onLastListenerRemove(){U&&U.dispose(),U=null}});return ne.event}s.buffer=Z;class V{constructor(T){this.event=T}map(T){return new V(w(this.event,T))}forEach(T){return new V(M(this.event,T))}filter(T){return new V(A(this.event,T))}reduce(T,W){return new V(Y(this.event,T,W))}latch(){return new V(z(this.event))}debounce(T,W=100,O=!1,U){return new V(X(this.event,T,W,O,U))}on(T,W,O){return this.event(T,W,O)}once(T,W,O){return d(this.event)(T,W,O)}}function B(N){return new V(N)}s.chain=B;function $(N,T,W=O=>O){const O=(...ae)=>ne.fire(W(...ae)),U=()=>N.on(T,O),K=()=>N.removeListener(T,O),ne=new m({onFirstListenerAdd:U,onLastListenerRemove:K});return ne.event}s.fromNodeEventEmitter=$;function Q(N,T,W=O=>O){const O=(...ae)=>ne.fire(W(...ae)),U=()=>N.addEventListener(T,O),K=()=>N.removeEventListener(T,O),ne=new m({onFirstListenerAdd:U,onLastListenerRemove:K});return ne.event}s.fromDOMEventEmitter=Q;function q(N){return new Promise(T=>d(N)(T))}s.toPromise=q;function J(N,T){return T(void 0),N(W=>T(W))}s.runAndSubscribe=J;function _(N,T){let W=null;function O(K){W?.dispose(),W=new D.DisposableStore,T(K,W)}O(void 0);const U=N(K=>O(K));return(0,D.toDisposable)(()=>{U.dispose(),W?.dispose()})}s.runAndSubscribeWithStore=_})(b=e.Event||(e.Event={}));class P{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${P._idPool++}`}start(a){this._stopWatch=new R.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let k=-1;function I(s){const a=k;return k=s,{dispose(){k=a}}}e.setGlobalLeakWarningThreshold=I;class p{constructor(a,d=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,d){let w=k;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||d<w)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let A,F=0;for(const[H,Y]of this._stacks)(!A||F<Y)&&(A=H,F=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${F}):`),console.warn(A)}return()=>{const A=this._stacks.get(a.value)||0;this._stacks.set(a.value,A-1)}}}class g{constructor(a){this.value=a}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(a,d,w){this.callback=a,this.callbackThis=d,this.stack=w,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class m{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=k>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const d of a)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,d,w)=>{this._listeners||(this._listeners=new L.LinkedList);const M=this._listeners.isEmpty();M&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let A,F;this._leakageMon&&this._listeners.size>=30&&(F=g.create(),A=this._leakageMon.check(F,this._listeners.size+1)),y&&(F=F??g.create());const H=new h(a,d,F),Y=this._listeners.push(H);M&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,d);const ie=H.subscription.set(()=>{A&&A(),this._disposed||(Y(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return w instanceof D.DisposableStore?w.add(ie):Array.isArray(w)&&w.push(ie),ie}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C);for(let d of this._listeners)this._deliveryQueue.push(this,d,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=m;class S{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(a,d,w){this._queue.push(new f(a,d,w))}clear(a){const d=new L.LinkedList;for(const w of this._queue)w.emitter!==a&&d.push(w);this._queue=d}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(d){(0,v.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=S;class C extends S{clear(a){this._queue.clear()}}class f{constructor(a,d,w){this.emitter=a,this.listener=d,this.event=w}}class u extends m{async fireAsync(a,d,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,a]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[M,A]=this._asyncDeliveryQueue.shift(),F=[],H={...A,token:d,waitUntil:Y=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");w&&(Y=w(Y,M.callback)),F.push(Y)}};try{M.invoke(H)}catch(Y){(0,v.onUnexpectedError)(Y);continue}Object.freeze(F),await Promise.allSettled(F).then(Y=>{for(const ie of Y)ie.status==="rejected"&&(0,v.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=u;class c extends m{constructor(a){super(a);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class r extends c{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=r;class l extends m{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const d={event:a,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const w=()=>{this.hasListeners&&this.unhook(d);const M=this.events.indexOf(d);this.events.splice(M,1)};return(0,D.toDisposable)((0,t.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(d=>this.emitter.fire(d))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(a){return(d,w,M)=>a(A=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>d.call(w,A)):d.call(w,A)},void 0,M)}bufferEvents(a){const d=[];this.buffers.push(d);const w=a();return this.buffers.pop(),d.forEach(M=>M()),w}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ee[23],te([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,E){const b=setTimeout(y.bind(E),0);return{dispose(){clearTimeout(b)}}});var D;(function(y){function E(b){return b===y.None||b===y.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}y.isCancellationToken=E,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=R}),define(ee[115],te([0,1,23]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new v.CancellationTokenSource,E=this.task(y.token);return this.result={promise:E,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class D{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const E=JSON.stringify(y);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=D;class L{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const E=this.fn(y);return this._map.set(y,E),E}}e.CachedFunction=L}),define(ee[85],te([0,1,4,2]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=R=>({onDidChange:v.Event.None,value:R});e.staticObservableValue=D;class L extends t.Disposable{constructor(y){super();this._value=y,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=L}),define(ee[49],te([0,1,15,2]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=D;function L(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function R(u){const c=u;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=R;function y(u,c){return new E(u,c)}e.newWriteableStream=y;class E{constructor(c,r){this.reducer=c,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(r=>r(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(r=>r(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,r){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(c,r){if(this.state.destroyed)return;let l;switch(c){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(r);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(u,c){const r=[];let l;for(;(l=u.read())!==null;)r.push(l);return c(r)}e.consumeReadable=b;function P(u,c,r){const l=[];let i;for(;(i=u.read())!==null&&l.length<r;)l.push(i);return i===null&&l.length>0?c(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=P;function k(u,c){return new Promise((r,l)=>{const i=[];I(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?l(n):r(void 0)},onEnd:()=>{r(c?c(i):void 0)}})})}e.consumeStream=k;function I(u,c){let r=!1;return u.on("error",l=>{r||c.onError(l)}),u.on("end",()=>{r||c.onEnd()}),u.on("data",l=>{r||c.onData(l)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=I;function p(u,c){return new Promise((r,l)=>{const i=new t.DisposableStore,n=[],o=d=>{if(n.push(d),n.length>c)return i.dispose(),u.pause(),r({stream:u,buffer:n,ended:!1})},s=d=>l(d),a=()=>r({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",s))),u.on("error",s),i.add((0,t.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),i.add((0,t.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=p;function g(u,c){const r=y(c);return r.end(u),r}e.toStream=g;function h(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=h;function m(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=m;function S(u,c,r){const l=y(r);return I(u,{onData:i=>l.write(c.data(i)),onError:i=>l.error(c.error?c.error(i):i),onEnd:()=>l.end()}),l}e.transform=S;function C(u,c,r){let l=!1;return{read:()=>{const i=c.read();return l?i:(l=!0,i!==null?r([u,i]):u)}}}e.prefixedReadable=C;function f(u,c,r){let l=!1;const i=y(r);return I(c,{onData:n=>l?i.write(n):(l=!0,i.write(r([u,n]))),onError:n=>i.error(n),onEnd:()=>{l||(l=!0,i.write(u)),i.end()}}),i}e.prefixedStream=f}),define(ee[18],te([0,1,49]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,L;class R{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new R(Buffer.allocUnsafe(d)):new R(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new R(d)}static fromString(d,w){return!(w?.dontUseNodeBuffer||!1)&&t?new R(Buffer.from(d)):(D||(D=new TextEncoder),new R(D.encode(d)))}static fromByteArray(d){const w=R.alloc(d.length);for(let M=0,A=d.length;M<A;M++)w.buffer[M]=d[M];return w}static concat(d,w){if(typeof w=="undefined"){w=0;for(let F=0,H=d.length;F<H;F++)w+=d[F].byteLength}const M=R.alloc(w);let A=0;for(let F=0,H=d.length;F<H;F++){const Y=d[F];M.set(Y,A),A+=Y.byteLength}return M}clone(){const d=R.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(d,w){return new R(this.buffer.subarray(d,w))}set(d,w){if(d instanceof R)this.buffer.set(d.buffer,w);else if(d instanceof Uint8Array)this.buffer.set(d,w);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),w);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return b(this.buffer,d)}writeUInt32BE(d,w){P(this.buffer,d,w)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,w){I(this.buffer,d,w)}readUInt8(d){return p(this.buffer,d)}writeUInt8(d,w){g(this.buffer,d,w)}}e.VSBuffer=R;function y(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0}e.readUInt16LE=y;function E(a,d,w){a[w+0]=d&255,d=d>>>8,a[w+1]=d&255}e.writeUInt16LE=E;function b(a,d){return a[d]*2**24+a[d+1]*2**16+a[d+2]*2**8+a[d+3]}e.readUInt32BE=b;function P(a,d,w){a[w+3]=d,d=d>>>8,a[w+2]=d,d=d>>>8,a[w+1]=d,d=d>>>8,a[w]=d}e.writeUInt32BE=P;function k(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0|a[d+2]<<16>>>0|a[d+3]<<24>>>0}e.readUInt32LE=k;function I(a,d,w){a[w+0]=d&255,d=d>>>8,a[w+1]=d&255,d=d>>>8,a[w+2]=d&255,d=d>>>8,a[w+3]=d&255}e.writeUInt32LE=I;function p(a,d){return a[d]}e.readUInt8=p;function g(a,d,w){a[w]=d}e.writeUInt8=g;function h(a){return v.consumeReadable(a,d=>R.concat(d))}e.readableToBuffer=h;function m(a){return v.toReadable(a)}e.bufferToReadable=m;function S(a){return v.consumeStream(a,d=>R.concat(d))}e.streamToBuffer=S;async function C(a){return a.ended?R.concat(a.buffer):R.concat([...a.buffer,await S(a.stream)])}e.bufferedStreamToBuffer=C;function f(a){return v.toStream(a,d=>R.concat(d))}e.bufferToStream=f;function u(a){return v.transform(a,{data:d=>typeof d=="string"?R.fromString(d):R.wrap(d)},d=>R.concat(d))}e.streamToBufferReadableStream=u;function c(a){return v.newWriteableStream(d=>R.concat(d),a)}e.newWriteableBufferStream=c;function r(a,d){return v.prefixedReadable(a,d,w=>R.concat(w))}e.prefixedBufferReadable=r;function l(a,d){return v.prefixedStream(a,d,w=>R.concat(w))}e.prefixedBufferStream=l;function i(a){let d=0,w=0,M=0;const A=new Uint8Array(Math.floor(a.length/4*3)),F=Y=>{switch(w){case 3:A[M++]=d|Y,w=0;break;case 2:A[M++]=d|Y>>>2,d=Y<<6,w=3;break;case 1:A[M++]=d|Y>>>4,d=Y<<4,w=2;break;default:d=Y<<2,w=1}};for(let Y=0;Y<a.length;Y++){const ie=a.charCodeAt(Y);if(ie>=65&&ie<=90)F(ie-65);else if(ie>=97&&ie<=122)F(ie-97+26);else if(ie>=48&&ie<=57)F(ie-48+52);else if(ie===43||ie===45)F(62);else if(ie===47||ie===95)F(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[Y]}`)}}const H=M;for(;w>0;)F(0);return R.wrap(A).slice(0,H)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},d=!0,w=!1){const M=w?o:n;let A="";const F=a.byteLength%3;let H=0;for(;H<a.byteLength-F;H+=3){const Y=a[H+0],ie=a[H+1],X=a[H+2];A+=M[Y>>>2],A+=M[(Y<<4|ie>>>4)&63],A+=M[(ie<<2|X>>>6)&63],A+=M[X&63]}if(F===1){const Y=a[H+0];A+=M[Y>>>2],A+=M[Y<<4&63],d&&(A+="==")}else if(F===2){const Y=a[H+0],ie=a[H+1];A+=M[Y>>>2],A+=M[(Y<<4|ie>>>4)&63],A+=M[ie<<2&63],d&&(A+="=")}return A}e.encodeBase64=s}),define(ee[28],te([0,1,115,113]),function(j,e,v,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=L;const R=/{(\d+)}/g;function y(G,...se){return se.length===0?G:G.replace(R,function(ce,ge){const ve=parseInt(ge,10);return isNaN(ve)||ve<0||ve>=se.length?ce:se[ve]})}e.format=y;const E=/{([^}]+)}/g;function b(G,se){return G.replace(E,(ce,ge)=>se[ge]??ce)}e.format2=b;function P(G){return G.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function k(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function I(G,se){let ce=0;const ge=se.charCodeAt(0);for(let ve=G.length-1;ve>=0;ve--)G.charCodeAt(ve)===ge&&ce++;return ce}e.count=I;function p(G,se,ce="\u2026"){return G.length<=se?G:`${G.substr(0,se)}${ce}`}e.truncate=p;function g(G,se=" "){const ce=h(G,se);return m(ce,se)}e.trim=g;function h(G,se){if(!G||!se)return G;const ce=se.length;if(ce===0||G.length===0)return G;let ge=0;for(;G.indexOf(se,ge)===ge;)ge=ge+ce;return G.substring(ge)}e.ltrim=h;function m(G,se){if(!G||!se)return G;const ce=se.length,ge=G.length;if(ce===0||ge===0)return G;let ve=ge,Pe=-1;for(;Pe=G.lastIndexOf(se,ve-1),!(Pe===-1||Pe+ce!==ve);){if(Pe===0)return"";ve=Pe}return G.substring(0,ve)}e.rtrim=m;function S(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=S;function C(G){return G.replace(/\*/g,"")}e.stripWildcards=C;function f(G,se,ce={}){if(!G)throw new Error("Cannot create regex from empty string");se||(G=k(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let ge="";return ce.global&&(ge+="g"),ce.matchCase||(ge+="i"),ce.multiline&&(ge+="m"),ce.unicode&&(ge+="u"),new RegExp(G,ge)}e.createRegExp=f;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function r(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=r;function l(G){return G.split(/\r\n|\r|\n/)}e.splitLines=l;function i(G){for(let se=0,ce=G.length;se<ce;se++){const ge=G.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=i;function n(G,se=0,ce=G.length){for(let ge=se;ge<ce;ge++){const ve=G.charCodeAt(ge);if(ve!==32&&ve!==9)return G.substring(se,ge)}return G.substring(se,ce)}e.getLeadingWhitespace=n;function o(G,se=G.length-1){for(let ce=se;ce>=0;ce--){const ge=G.charCodeAt(ce);if(ge!==32&&ge!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function s(G,se,ce){let ge=[],ve=0;for(const Pe of G.matchAll(se)){if(ge.push(G.slice(ve,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");ve=Pe.index+Pe[0].length,ge.push(ce(Pe[0],...Pe.slice(1),Pe.index,G,Pe.groups))}return ge.push(G.slice(ve)),Promise.all(ge).then(Pe=>Pe.join(""))}e.replaceAsync=s;function a(G,se){return G<se?-1:G>se?1:0}e.compare=a;function d(G,se,ce=0,ge=G.length,ve=0,Pe=se.length){for(;ce<ge&&ve<Pe;ce++,ve++){let Ke=G.charCodeAt(ce),Oe=se.charCodeAt(ve);if(Ke<Oe)return-1;if(Ke>Oe)return 1}const Ne=ge-ce,Qe=Pe-ve;return Ne<Qe?-1:Ne>Qe?1:0}e.compareSubstring=d;function w(G,se){return M(G,se,0,G.length,0,se.length)}e.compareIgnoreCase=w;function M(G,se,ce=0,ge=G.length,ve=0,Pe=se.length){for(;ce<ge&&ve<Pe;ce++,ve++){let Ke=G.charCodeAt(ce),Oe=se.charCodeAt(ve);if(Ke===Oe)continue;if(Ke>=128||Oe>=128)return d(G.toLowerCase(),se.toLowerCase(),ce,ge,ve,Pe);A(Ke)&&(Ke-=32),A(Oe)&&(Oe-=32);const He=Ke-Oe;if(He!==0)return He}const Ne=ge-ce,Qe=Pe-ve;return Ne<Qe?-1:Ne>Qe?1:0}e.compareSubstringIgnoreCase=M;function A(G){return G>=97&&G<=122}e.isLowerAsciiLetter=A;function F(G){return G>=65&&G<=90}e.isUpperAsciiLetter=F;function H(G,se){return G.length===se.length&&M(G,se)===0}e.equalsIgnoreCase=H;function Y(G,se){const ce=se.length;return se.length>G.length?!1:M(G,se,0,ce)===0}e.startsWithIgnoreCase=Y;function ie(G,se){let ce,ge=Math.min(G.length,se.length);for(ce=0;ce<ge;ce++)if(G.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return ge}e.commonPrefixLength=ie;function X(G,se){let ce,ge=Math.min(G.length,se.length);const ve=G.length-1,Pe=se.length-1;for(ce=0;ce<ge;ce++)if(G.charCodeAt(ve-ce)!==se.charCodeAt(Pe-ce))return ce;return ge}e.commonSuffixLength=X;function z(G){return 55296<=G&&G<=56319}e.isHighSurrogate=z;function x(G){return 56320<=G&&G<=57343}e.isLowSurrogate=x;function Z(G,se){return(G-55296<<10)+(se-56320)+65536}e.computeCodePoint=Z;function V(G,se,ce){const ge=G.charCodeAt(ce);if(z(ge)&&ce+1<se){const ve=G.charCodeAt(ce+1);if(x(ve))return Z(ge,ve)}return ge}e.getNextCodePoint=V;function B(G,se){const ce=G.charCodeAt(se-1);if(x(ce)&&se>1){const ge=G.charCodeAt(se-2);if(z(ge))return Z(ge,ce)}return ce}class ${constructor(se,ce=0){this._str=se,this._len=se.length,this._offset=ce}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=B(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=V(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class Q{constructor(se,ce=0){this._iterator=new $(se,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=qe.getInstance(),ce=this._iterator,ge=ce.offset;let ve=se.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const Pe=ce.offset,Ne=se.getGraphemeBreakType(ce.nextCodePoint());if(Je(ve,Ne)){ce.setOffset(Pe);break}ve=Ne}return ce.offset-ge}prevGraphemeLength(){const se=qe.getInstance(),ce=this._iterator,ge=ce.offset;let ve=se.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const Pe=ce.offset,Ne=se.getGraphemeBreakType(ce.prevCodePoint());if(Je(Ne,ve)){ce.setOffset(Pe);break}ve=Ne}return ge-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function q(G,se){return new Q(G,se).nextGraphemeLength()}e.nextCharLength=q;function J(G,se){return new Q(G,se).prevGraphemeLength()}e.prevCharLength=J;function _(G,se){se>0&&x(G.charCodeAt(se))&&se--;const ce=se+q(G,se);return[ce-J(G,ce),ce]}e.getCharContainingOffset=_;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(G){return N.test(G)}e.containsRTL=T;const W=/^[\t\n\r\x20-\x7E]*$/;function O(G){return W.test(G)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=U;function K(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=K;function ne(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=ne;function ae(G,se){if(G.length<se)return G;const ce=/\b/g;let ge=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<se);)ge=ce.lastIndex,ce.lastIndex+=1;return G.substring(ge).replace(/^\s/,"")}e.lcut=ae;const le=/\x1B\x5B[12]?K/g,oe=/\x1b\[\d+m/g,ue=/\x1b\[0?m/g;function de(G){return G&&(G=G.replace(le,""),G=G.replace(oe,""),G=G.replace(ue,"")),G}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Ie(G){return we(G)?G.substr(1):G}e.stripUTF8BOM=Ie;function Ae(G,se){if(!G||!se||G.length<se.length)return!1;const ce=se.length,ge=G.toLowerCase();let ve=0,Pe=-1;for(;ve<ce;){const Ne=ge.indexOf(se[ve],Pe+1);if(Ne<0)return!1;Pe=Ne,ve++}return!0}e.fuzzyContains=Ae;function be(G,se=!1){return G?(se&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=be;function Se(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Se;function Ce(G,se=1){if(se===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=Ce;function We(G){const se=90-65+1;return G=G%(2*se),G<se?String.fromCharCode(97+G):String.fromCharCode(65+G-se)}e.singleLetterHash=We;function _e(G){return qe.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=_e;function Je(G,se){return G===0?se!==5&&se!==7:G===2&&se===3?!1:G===4||G===2||G===3||se===4||se===2||se===3?!0:!(G===8&&(se===8||se===9||se===11||se===12)||(G===11||G===9)&&(se===9||se===10)||(G===12||G===10)&&se===10||se===5||se===13||se===7||G===1||G===13&&se===14||G===6&&se===6)}var Ue;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class qe{constructor(){this._data=ot()}static getInstance(){return qe._INSTANCE||(qe._INSTANCE=new qe),qe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,ge=ce.length/3;let ve=1;for(;ve<=ge;)if(se<ce[3*ve])ve=2*ve;else if(se>ce[3*ve+1])ve=2*ve+1;else return ce[3*ve+2];return 0}}qe._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(G,se){if(G===0)return 0;const ce=xe(G,se);if(ce!==void 0)return ce;const ge=new $(se,G);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=Ze;function xe(G,se){const ce=new $(se,G);let ge=ce.prevCodePoint();for(;vt(ge)||ge===65039||ge===8419;){if(ce.offset===0)return;ge=ce.prevCodePoint()}if(!ne(ge))return;let ve=ce.offset;return ve>0&&ce.prevCodePoint()===8205&&(ve=ce.offset),ve}function vt(G){return 127995<=G&&G<=127999}var at;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.noBreakWhitespace="\xA0";class je{constructor(se){this.confusableDictionary=se}static getInstance(se){return je.cache.get(Array.from(se))}static getLocales(){return je._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,D=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new v.LRUCachedFunction(G=>{function se(Oe){const He=new Map;for(let Ve=0;Ve<Oe.length;Ve+=2)He.set(Oe[Ve],Oe[Ve+1]);return He}function ce(Oe,He){const Ve=new Map(Oe);for(const[tt,ct]of He)Ve.set(tt,ct);return Ve}function ge(Oe,He){if(!Oe)return He;const Ve=new Map;for(const[tt,ct]of Oe)He.has(tt)&&Ve.set(tt,ct);return Ve}const ve=D.ambiguousCharacterData.getValue();let Pe=G.filter(Oe=>!Oe.startsWith("_")&&Oe in ve);Pe.length===0&&(Pe=["_default"]);let Ne;for(const Oe of Pe){const He=se(ve[Oe]);Ne=ge(Ne,He)}const Qe=se(ve._common),Ke=ce(Qe,Ne);return new je(Ke)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class et{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(et.getRawData())),this._data}static isInvisibleCharacter(se){return et.getData().has(se)}static get codePoints(){return et.getData()}}e.InvisibleCharacters=et,et._data=void 0}),define(ee[71],te([0,1,28]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(S){return D(S,0)}e.hash=t;function D(S,C){switch(typeof S){case"object":return S===null?L(349,C):Array.isArray(S)?E(S,C):b(S,C);case"string":return y(S,C);case"boolean":return R(S,C);case"number":return L(S,C);case"undefined":return L(937,C);default:return L(617,C)}}e.doHash=D;function L(S,C){return(C<<5)-C+S|0}e.numberHash=L;function R(S,C){return L(S?433:863,C)}function y(S,C){C=L(149417,C);for(let f=0,u=S.length;f<u;f++)C=L(S.charCodeAt(f),C);return C}e.stringHash=y;function E(S,C){return C=L(104579,C),S.reduce((f,u)=>D(u,f),C)}function b(S,C){return C=L(181387,C),Object.keys(S).sort().reduce((f,u)=>(f=y(u,f),D(S[u],f)),C)}class P{constructor(){this._value=0}get value(){return this._value}hash(C){return this._value=D(C,this._value),this._value}}e.Hasher=P;var k;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function I(S,C,f=32){const u=f-C,c=~((1<<u)-1);return(S<<C|(c&S)>>>u)>>>0}function p(S,C=0,f=S.byteLength,u=0){for(let c=0;c<f;c++)S[C+c]=u}function g(S,C,f="0"){for(;S.length<C;)S=f+S;return S}function h(S,C=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(f=>f.toString(16).padStart(2,"0")).join(""):g((S>>>0).toString(16),C/4)}e.toHexString=h;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const f=C.length;if(f===0)return;const u=this._buff;let c=this._buffLen,r=this._leftoverHighSurrogate,l,i;for(r!==0?(l=r,i=-1,r=0):(l=C.charCodeAt(0),i=0);;){let n=l;if(v.isHighSurrogate(l))if(i+1<f){const o=C.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,n=v.computeCodePoint(l,o)):n=65533}else{r=l;break}else v.isLowSurrogate(l)&&(n=65533);if(c=this._push(u,c,n),i++,i<f)l=C.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=r}_push(C,f,u){return u<128?C[f++]=u:u<2048?(C[f++]=192|(u&1984)>>>6,C[f++]=128|(u&63)>>>0):u<65536?(C[f++]=224|(u&61440)>>>12,C[f++]=128|(u&4032)>>>6,C[f++]=128|(u&63)>>>0):(C[f++]=240|(u&1835008)>>>18,C[f++]=128|(u&258048)>>>12,C[f++]=128|(u&4032)>>>6,C[f++]=128|(u&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=m._bigBlock32,f=this._buffDV;for(let a=0;a<64;a+=4)C.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)C.setUint32(a,I(C.getUint32(a-12,!1)^C.getUint32(a-32,!1)^C.getUint32(a-56,!1)^C.getUint32(a-64,!1),1),!1);let u=this._h0,c=this._h1,r=this._h2,l=this._h3,i=this._h4,n,o,s;for(let a=0;a<80;a++)a<20?(n=c&r|~c&l,o=1518500249):a<40?(n=c^r^l,o=1859775393):a<60?(n=c&r|c&l|r&l,o=2400959708):(n=c^r^l,o=3395469782),s=I(u,5)+n+i+o+C.getUint32(a*4,!1)&4294967295,i=l,l=r,r=I(c,30),c=u,u=s;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var Lt=this&&this.__classPrivateFieldSet||function(j,e,v,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(j,v):D?D.value=v:e.set(j,v),v},Xe=this&&this.__classPrivateFieldGet||function(j,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!t:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(j):t?t.value:e.get(j)};define(ee[35],te([0,1,26,28]),function(j,e,v,t){"use strict";var D,L,R,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(o,s,a){let d=o.get(s);return d===void 0&&(d=a,o.set(s,d)),d}e.getOrSet=E;function b(o){const s=[];return o.forEach((a,d)=>{s.push(`${d} => ${a}`)}),`Map(${o.size}) {${s.join(", ")}}`}e.mapToString=b;function P(o){const s=[];return o.forEach(a=>{s.push(a)}),`Set(${o.size}) {${s.join(", ")}}`}e.setToString=P;class k{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const a=s.charCodeAt(0),d=this._value.charCodeAt(this._pos);return a-d}value(){return this._value[this._pos]}}e.StringIterator=k;class I{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class p{constructor(s=!0,a=!0){this._splitOnBackslash=s,this._caseSensitive=a}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let a=s.length-1;a>=0;a--,this._valueLen--){const d=this._value.charCodeAt(a);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var g;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(s,a){this._ignorePathCasing=s,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,t.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(S||(S={}));class C{constructor(s){this._iter=s}static forUris(s=()=>!1,a=()=>!1){return new C(new h(s,a))}static forPaths(s=!1){return new C(new p(void 0,!s))}static forStrings(){return new C(new k)}static forConfigKeys(){return new C(new I)}clear(){this._root=void 0}fill(s,a){if(a){const d=a.slice(0);(0,v.shuffle)(d);for(let w of d)this.set(w,s)}else{const d=s.slice(0);(0,v.shuffle)(d);for(let w of d)this.set(w[0],w[1])}}set(s,a){const d=this._iter.reset(s);let w;this._root||(this._root=new m,this._root.segment=d.value());const M=[];for(w=this._root;;){const F=d.cmp(w.segment);if(F>0)w.left||(w.left=new m,w.left.segment=d.value()),M.push([-1,w]),w=w.left;else if(F<0)w.right||(w.right=new m,w.right.segment=d.value()),M.push([1,w]),w=w.right;else if(d.hasNext())d.next(),w.mid||(w.mid=new m,w.mid.segment=d.value()),M.push([0,w]),w=w.mid;else break}const A=w.value;w.value=a,w.key=s;for(let F=M.length-1;F>=0;F--){const H=M[F][1];H.updateHeight();const Y=H.balanceFactor();if(Y<-1||Y>1){const ie=M[F][0],X=M[F+1][0];if(ie===1&&X===1)M[F][1]=H.rotateLeft();else if(ie===-1&&X===-1)M[F][1]=H.rotateRight();else if(ie===1&&X===-1)H.right=M[F+1][1]=M[F+1][1].rotateRight(),M[F][1]=H.rotateLeft();else if(ie===-1&&X===1)H.left=M[F+1][1]=M[F+1][1].rotateLeft(),M[F][1]=H.rotateRight();else throw new Error;if(F>0)switch(M[F-1][0]){case-1:M[F-1][1].left=M[F][1];break;case 1:M[F-1][1].right=M[F][1];break;case 0:M[F-1][1].mid=M[F][1];break}else this._root=M[0][1]}}return A}get(s){return this._getNode(s)?.value}_getNode(s){const a=this._iter.reset(s);let d=this._root;for(;d;){const w=a.cmp(d.segment);if(w>0)d=d.left;else if(w<0)d=d.right;else if(a.hasNext())a.next(),d=d.mid;else break}return d}has(s){const a=this._getNode(s);return!(a?.value===void 0&&a?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,a){const d=this._iter.reset(s),w=[];let M=this._root;for(;M;){const A=d.cmp(M.segment);if(A>0)w.push([-1,M]),M=M.left;else if(A<0)w.push([1,M]),M=M.right;else if(d.hasNext())d.next(),w.push([0,M]),M=M.mid;else break}if(!!M){if(a?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const A=this._min(M.right),{key:F,value:H,segment:Y}=A;this._delete(A.key,!1),M.key=F,M.value=H,M.segment=Y}else{const A=M.left??M.right;if(w.length>0){const[F,H]=w[w.length-1];switch(F){case-1:H.left=A;break;case 0:H.mid=A;break;case 1:H.right=A;break}}else this._root=A}for(let A=w.length-1;A>=0;A--){const F=w[A][1];F.updateHeight();const H=F.balanceFactor();if(H>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),w[A][1]=F.rotateLeft()):H<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),w[A][1]=F.rotateRight()),A>0)switch(w[A-1][0]){case-1:w[A-1][1].left=w[A][1];break;case 1:w[A-1][1].right=w[A][1];break;case 0:w[A-1][1].mid=w[A][1];break}else this._root=w[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const a=this._iter.reset(s);let d=this._root,w;for(;d;){const M=a.cmp(d.segment);if(M>0)d=d.left;else if(M<0)d=d.right;else if(a.hasNext())a.next(),w=d.value||w,d=d.mid;else break}return d&&d.value||w}findSuperstr(s){const a=this._iter.reset(s);let d=this._root;for(;d;){const w=a.cmp(d.segment);if(w>0)d=d.left;else if(w<0)d=d.right;else if(a.hasNext())a.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(s){for(const[a,d]of this)s(d,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){!s||(s.left&&(yield*this._entries(s.left)),s.value&&(yield[s.key,s.value]),s.mid&&(yield*this._entries(s.mid)),s.right&&(yield*this._entries(s.right)))}_isBalanced(){const s=a=>{if(!a)return!0;const d=a.balanceFactor();return d<-1||d>1?!1:s(a.left)&&s(a.right)};return s(this._root)}}e.TernarySearchTree=C;class f{constructor(s,a){this.uri=s,this.value=a}}class u{constructor(s,a){this[D]="ResourceMap",s instanceof u?(this.map=new Map(s.map),this.toKey=a??u.defaultToKey):(this.map=new Map,this.toKey=s??u.defaultToKey)}set(s,a){return this.map.set(this.toKey(s),new f(s,a)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,a){typeof a!="undefined"&&(s=s.bind(a));for(let[d,w]of this.map)s(w.value,w.uri,this)}*values(){for(let s of this.map.values())yield s.value}*keys(){for(let s of this.map.values())yield s.uri}*entries(){for(let s of this.map.values())yield[s.uri,s.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=u,u.defaultToKey=o=>o.toString();class c{constructor(s,a){this[L]="ResourceSet",!s||typeof s=="function"?this._map=new u(s):(this._map=new u(a),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,a){this._map.forEach((d,w)=>s.call(a,w,w,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var r;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class l{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,a=0){const d=this._map.get(s);if(!!d)return a!==0&&this.touch(d,a),d.value}set(s,a,d=0){let w=this._map.get(s);if(w)w.value=a,d!==0&&this.touch(w,d);else{switch(w={key:s,value:a,next:void 0,previous:void 0},d){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(s,w),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const a=this._map.get(s);if(!!a)return this._map.delete(s),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,a){const d=this._state;let w=this._head;for(;w;){if(a?s.bind(a)(w.value,w.key,this):s(w.value,w.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const s=this,a=this._state;let d=this._head;const w={[Symbol.iterator](){return w},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const M={value:d.key,done:!1};return d=d.next,M}else return{value:void 0,done:!0}}};return w}values(){const s=this,a=this._state;let d=this._head;const w={[Symbol.iterator](){return w},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const M={value:d.value,done:!1};return d=d.next,M}else return{value:void 0,done:!0}}};return w}entries(){const s=this,a=this._state;let d=this._head;const w={[Symbol.iterator](){return w},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const M={value:[d.key,d.value],done:!1};return d=d.next,M}else return{value:void 0,done:!0}}};return w}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let a=this._head,d=this.size;for(;a&&d>s;)this._map.delete(a.key),a=a.next,d--;this._head=a,this._size=d,a&&(a.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const a=s.next,d=s.previous;if(!a||!d)throw new Error("Invalid list");a.previous=d,d.next=a}s.next=void 0,s.previous=void 0,this._state++}touch(s,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(s===this._head)return;const d=s.next,w=s.previous;s===this._tail?(w.next=void 0,this._tail=w):(d.previous=w,w.next=d),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(a===2){if(s===this._tail)return;const d=s.next,w=s.previous;s===this._head?(d.previous=void 0,this._head=d):(d.previous=w,w.next=d),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((a,d)=>{s.push([d,a])}),s}fromJSON(s){this.clear();for(const[a,d]of s)this.set(a,d)}}e.LinkedMap=l;class i extends l{constructor(s,a=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,a=2){return super.get(s,a)}peek(s){return super.get(s,0)}set(s,a){return super.set(s,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class n{constructor(s){y.set(this,void 0),Lt(this,y,s,"f")}get size(){return Xe(this,y,"f").size}forEach(s,a){Xe(this,y,"f").forEach(s,a)}get(s){return Xe(this,y,"f").get(s)}has(s){return Xe(this,y,"f").has(s)}entries(){return Xe(this,y,"f").entries()}keys(){return Xe(this,y,"f").keys()}values(){return Xe(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Xe(this,y,"f").entries()}}e.ReadonlyMapView=n}),define(ee[72],te([0,1,35]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function D(b){return E(b,"NFC",t)}e.normalizeNFC=D;const L=new v.LRUCache(1e4);function R(b){return E(b,"NFD",L)}e.normalizeNFD=R;const y=/[^\u0000-\u0080]/;function E(b,P,k){if(!b)return b;const I=k.get(b);if(I)return I;let p;return y.test(b)?p=b.normalize(P):p=b,k.set(b,p),p}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(P){return R(P).replace(b,"")}}()}),define(ee[11],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(a){return Array.isArray(a)}e.isArray=v;function t(a){return typeof a=="string"}e.isString=t;function D(a){return Array.isArray(a)&&a.every(d=>t(d))}e.isStringArray=D;function L(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=L;function R(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=R;function y(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=y;function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=E;function b(a){return a===!0||a===!1}e.isBoolean=b;function P(a){return typeof a=="undefined"}e.isUndefined=P;function k(a){return!I(a)}e.isDefined=k;function I(a){return P(a)||a===null}e.isUndefinedOrNull=I;function p(a,d){if(!a)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=p;function g(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=g;function h(...a){const d=[];for(let w=0;w<a.length;w++){const M=a[w];if(I(M))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);d.push(M)}return d}e.assertAllDefined=h;const m=Object.prototype.hasOwnProperty;function S(a){if(!L(a))return!1;for(let d in a)if(m.call(a,d))return!1;return!0}e.isEmptyObject=S;function C(a){return typeof a=="function"}e.isFunction=C;function f(...a){return a.length>0&&a.every(C)}e.areFunctions=f;function u(a,d){const w=Math.min(a.length,d.length);for(let M=0;M<w;M++)c(a[M],d[M])}e.validateConstraints=u;function c(a,d){if(t(d)){if(typeof a!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(C(d)){try{if(a instanceof d)return}catch{}if(!I(a)&&a.constructor===d||d.length===1&&d.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function r(a){let d=[],w=Object.getPrototypeOf(a);for(;Object.prototype!==w;)d=d.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return d}e.getAllPropertyNames=r;function l(a){const d=[];for(const w of r(a))typeof a[w]=="function"&&d.push(w);return d}e.getAllMethodNames=l;function i(a,d){const w=A=>function(){const F=Array.prototype.slice.call(arguments,0);return d(A,F)};let M={};for(const A of a)M[A]=w(A);return M}e.createProxyObject=i;function n(a){return a===null?void 0:a}e.withNullAsUndefined=n;function o(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=o;function s(a,d="Unreachable"){throw new Error(d)}e.assertNever=s}),define(ee[29],te([0,1,8,3,28,11]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(o){return o===47||o===92}e.isPathSeparator=R;function y(o){return o.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=y;function E(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function b(o,s=v.posix.sep){if(!o)return"";const a=o.length,d=o.charCodeAt(0);if(R(d)){if(R(o.charCodeAt(1))&&!R(o.charCodeAt(2))){let M=3;const A=M;for(;M<a&&!R(o.charCodeAt(M));M++);if(A!==M&&!R(o.charCodeAt(M+1))){for(M+=1;M<a;M++)if(R(o.charCodeAt(M)))return o.slice(0,M+1).replace(/[\\/]/g,s)}}return s}else if(S(d)&&o.charCodeAt(1)===58)return R(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let w=o.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(R(o.charCodeAt(w)))return o.slice(0,w+1)}return""}e.getRoot=b;function P(o){if(!t.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let a=2;const d=a;for(;a<o.length&&(s=o.charCodeAt(a),s!==92);a++);return!(d===a||(s=o.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=P;const k=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(o,s=t.isWindows){const a=s?k:I;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||s&&p.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=g;function h(o,s,a){const d=o===s;return!a||d?d:!o||!s?!1:(0,D.equalsIgnoreCase)(o,s)}e.isEqual=h;function m(o,s,a,d=v.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let M=s.length;return s.charAt(s.length-1)===d&&M--,o.charAt(M)===d}return s.charAt(s.length-1)!==d&&(s+=d),o.indexOf(s)===0}e.isEqualOrParent=m;function S(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=S;function C(o,s){return t.isWindows&&o.endsWith(":")&&(o+=v.sep),(0,v.isAbsolute)(o)||(o=(0,v.join)(s,o)),o=(0,v.normalize)(o),t.isWindows?(o=(0,D.rtrim)(o,v.sep),o.endsWith(":")&&(o+=v.sep)):(o=(0,D.rtrim)(o,v.sep),o||(o=v.sep)),o}e.sanitizeFilePath=C;function f(o){const s=(0,v.normalize)(o);return t.isWindows?o.length>3?!1:u(s)&&(o.length===2||s.charCodeAt(2)===92):s===v.posix.sep}e.isRootOrDriveLetter=f;function u(o,s=t.isWindows){return s?S(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(o){return u(o)?o[0]:void 0}e.getDriveLetter=c;function r(o,s,a){return s.length>o.length?-1:o===s?0:(a&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function l(o){const s=o.split(":");let a,d,w;for(const M of s){const A=Number(M);(0,L.isNumber)(A)?d===void 0?d=A:w===void 0&&(w=A):a=a?[a,M].join(":"):M}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,s,a=8){let d="";for(let M=0;M<a;M++)d+=i.charAt(Math.floor(Math.random()*i.length));let w;return s?w=`${s}-${d}`:w=d,o?(0,v.join)(o,w):w}e.randomPath=n}),define(ee[50],te([0,1,11]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.keys(h).forEach(S=>{h[S]&&typeof h[S]=="object"?m[S]=t(h[S]):m[S]=h[S]}),m}e.deepClone=t;function D(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const C in S)if(L.call(S,C)){const f=S[C];typeof f=="object"&&!Object.isFrozen(f)&&!(0,v.isTypedArray)(f)&&m.push(f)}}return h}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function R(h,m){return y(h,m,new Set)}e.cloneAndChange=R;function y(h,m,S){if((0,v.isUndefinedOrNull)(h))return h;const C=m(h);if(typeof C!="undefined")return C;if((0,v.isArray)(h)){const f=[];for(const u of h)f.push(y(u,m,S));return f}if((0,v.isObject)(h)){if(S.has(h))throw new Error("Cannot clone recursive data-structure");S.add(h);const f={};for(let u in h)L.call(h,u)&&(f[u]=y(h[u],m,S));return S.delete(h),f}return h}function E(h,m,S=!0){return(0,v.isObject)(h)?((0,v.isObject)(m)&&Object.keys(m).forEach(C=>{C in h?S&&((0,v.isObject)(h[C])&&(0,v.isObject)(m[C])?E(h[C],m[C],S):h[C]=m[C]):h[C]=m[C]}),h):m}e.mixin=E;function b(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let S,C;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(S=0;S<h.length;S++)if(!b(h[S],m[S]))return!1}else{const f=[];for(C in h)f.push(C);f.sort();const u=[];for(C in m)u.push(C);if(u.sort(),!b(f,u))return!1;for(S=0;S<f.length;S++)if(!b(h[f[S]],m[f[S]]))return!1}return!0}e.equals=b;function P(h){const m=new Set;return JSON.stringify(h,(S,C)=>{if((0,v.isObject)(C)||Array.isArray(C)){if(m.has(C))return"[Circular]";m.add(C)}return C})}e.safeStringify=P;function k(h,m,S){const C=m(h);return typeof C=="undefined"?S:C}e.getOrDefault=k;function I(h,m){const S=Object.create(null);return!h||!m||Object.keys(m).forEach(f=>{const u=h[f],c=m[f];b(u,c)||(S[f]=c)}),S}e.distinct=I;function p(h,m){const S=m.toLowerCase(),C=Object.keys(h).find(f=>f.toLowerCase()===S);return C?h[C]:h[m]}e.getCaseInsensitive=p;function g(h,m){const S=Object.create(null);for(const[C,f]of Object.entries(h))m(C,f)&&(S[C]=f);return S}e.filter=g}),define(ee[7],te([0,1,8,3]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function y(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,n){return!i&&!n?"file":i}function b(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const P="",k="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,o,s,a,d,w=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=E(n,w),this.authority=o||P,this.path=b(this.scheme,s||P),this.query=a||P,this.fragment=d||P,y(this,w))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:s,path:a,query:d,fragment:w}=n;return o===void 0?o=this.scheme:o===null&&(o=P),s===void 0?s=this.authority:s===null&&(s=P),a===void 0?a=this.path:a===null&&(a=P),d===void 0?d=this.query:d===null&&(d=P),w===void 0?w=this.fragment:w===null&&(w=P),o===this.scheme&&s===this.authority&&a===this.path&&d===this.query&&w===this.fragment?this:new h(o,s,a,d,w)}static parse(n,o=!1){const s=I.exec(n);return s?new h(s[2]||P,l(s[4]||P),l(s[5]||P),l(s[7]||P),l(s[9]||P),o):new h(P,P,P,P,P)}static file(n){let o=P;if(t.isWindows&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const s=n.indexOf(k,2);s===-1?(o=n.substring(2),n=k):(o=n.substring(2,s),n=n.substring(s)||k)}return new h("file",o,n,P,P)}static from(n){const o=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return y(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&n.scheme==="file"?s=p.file(v.win32.join(f(n,!0),...o)).path:s=v.posix.join(n.path,...o),n.with({path:s})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const o=new h(n);return o._formatted=n.external,o._fsPath=n._sep===g?n.fsPath:null,o}}else return n}}e.URI=p;const g=t.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=g),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(i,n){let o,s=-1;for(let a=0;a<i.length;a++){const d=i.charCodeAt(a);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||n&&d===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o!==void 0&&(o+=i.charAt(a));else{o===void 0&&(o=i.substr(0,a));const w=m[d];w!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,a)),s=-1),o+=w):s===-1&&(s=a)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function C(i){let n;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(n===void 0&&(n=i.substr(0,o)),n+=m[s]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function f(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=f;function u(i,n){const o=n?C:S;let s="",{scheme:a,authority:d,path:w,query:M,fragment:A}=i;if(a&&(s+=a,s+=":"),(d||a==="file")&&(s+=k,s+=k),d){let F=d.indexOf("@");if(F!==-1){const H=d.substr(0,F);d=d.substr(F+1),F=H.indexOf(":"),F===-1?s+=o(H,!1):(s+=o(H.substr(0,F),!1),s+=":",s+=o(H.substr(F+1),!1)),s+="@"}d=d.toLowerCase(),F=d.indexOf(":"),F===-1?s+=o(d,!1):(s+=o(d.substr(0,F),!1),s+=d.substr(F))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const F=w.charCodeAt(1);F>=65&&F<=90&&(w=`/${String.fromCharCode(F+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const F=w.charCodeAt(0);F>=65&&F<=90&&(w=`${String.fromCharCode(F+32)}:${w.substr(2)}`)}s+=o(w,!0)}return M&&(s+="?",s+=o(M,!1)),A&&(s+="#",s+=n?A:S(A,!1)),s}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(r)?i.replace(r,n=>c(n)):i}}),define(ee[116],te([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=t;function D(b){const P=[];let k;try{const I=JSON.parse(b.arguments),p=I[I.length-1];p&&p.__$stack&&(I.pop(),k=p.__$stack),P.push(...I)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:k}}e.parse=D;function L(b){if(typeof b!="string")return L(D(b).stack);const P=b;if(P){const k=R(P),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(I&&I.length===4)return{uri:v.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=L;function R(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function y(b,P){const{args:k,stack:I}=D(b),p=typeof k[0]=="string"&&k.length===1;let g=R(I);g&&(g=`(${g.trim()})`);let h=[];if(typeof k[0]=="string"?g&&p?h=[`%c[${P}] %c${k[0]} %c${g}`,E("blue"),E(""),E("grey")]:h=[`%c[${P}] %c${k[0]}`,E("blue"),E(""),...k.slice(1)]:h=[`%c[${P}]%`,E("blue"),...k],g&&!p&&h.push(g),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,h)}e.log=y;function E(b){return`color: ${b}`}}),define(ee[117],te([0,1,18,28,7]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(b){return JSON.stringify(b,y)}e.stringify=L;function R(b){let P=JSON.parse(b);return P=E(P),P}e.parse=R;function y(b,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,t.regExpFlags)(P)}:P}function E(b,P=0){if(!b||P>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof v.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let k=0;k<b.length;++k)b[k]=E(b[k],P+1);else for(const k in b)Object.hasOwnProperty.call(b,k)&&(b[k]=E(b[k],P+1))}return b}e.revive=E}),define(ee[10],te([0,1,3,7]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,b,P){this._hosts[E]=b,this._ports[E]=P}setConnectionToken(E,b){this._connectionTokens[E]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const b=E.authority;let P=this._hosts[b];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const k=this._ports[b],I=this._connectionTokens[b];let p=`path=${encodeURIComponent(E.path)}`;return typeof I=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${P}:${k}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new L;class R{asBrowserUri(E,b){const P=this.toUri(E,b);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===D.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${D.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?P.with({scheme:D.vscodeFileResource,authority:P.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(E,b){const P=this.toUri(E,b);return P.scheme===D.vscodeFileResource?P.with({scheme:D.file,authority:P.authority!==R.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(E,b){return t.URI.isUri(E)?E:t.URI.parse(b.toUrl(E))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(ee[16],te([0,1,29,10,8,3,28,7]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(p){return(0,y.uriToFsPath)(p,!0)}e.originalFSPath=E;class b{constructor(g){this._ignorePathCasing=g}compare(g,h,m=!1){return g===h?0:(0,R.compare)(this.getComparisonKey(g,m),this.getComparisonKey(h,m))}isEqual(g,h,m=!1){return g===h?!0:!g||!h?!1:this.getComparisonKey(g,m)===this.getComparisonKey(h,m)}getComparisonKey(g,h=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,h,m=!1){if(g.scheme===h.scheme){if(g.scheme===t.Schemas.file)return v.isEqualOrParent(E(g),E(h),this._ignorePathCasing(g))&&g.query===h.query&&(m||g.fragment===h.fragment);if((0,e.isEqualAuthority)(g.authority,h.authority))return v.isEqualOrParent(g.path,h.path,this._ignorePathCasing(g),"/")&&g.query===h.query&&(m||g.fragment===h.fragment)}return!1}joinPath(g,...h){return y.URI.joinPath(g,...h)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return D.posix.basename(g.path)}extname(g){return D.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let h;return g.scheme===t.Schemas.file?h=y.URI.file(D.dirname(E(g))).path:(h=D.posix.dirname(g.path),g.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),h="/")),g.with({path:h})}normalizePath(g){if(!g.path.length)return g;let h;return g.scheme===t.Schemas.file?h=y.URI.file(D.normalize(E(g))).path:h=D.posix.normalize(g.path),g.with({path:h})}relativePath(g,h){if(g.scheme!==h.scheme||!(0,e.isEqualAuthority)(g.authority,h.authority))return;if(g.scheme===t.Schemas.file){const C=D.relative(E(g),E(h));return L.isWindows?v.toSlashes(C):C}let m=g.path||"/",S=h.path||"/";if(this._ignorePathCasing(g)){let C=0;for(const f=Math.min(m.length,S.length);C<f&&!(m.charCodeAt(C)!==S.charCodeAt(C)&&m.charAt(C).toLowerCase()!==S.charAt(C).toLowerCase());C++);m=S.substr(0,C)+m.substr(C)}return D.posix.relative(m,S)}resolvePath(g,h){if(g.scheme===t.Schemas.file){const m=y.URI.file(D.resolve(E(g),h));return g.with({authority:m.authority,path:m.path})}return h=v.toPosixPath(h),g.with({path:D.posix.resolve(g.path,h)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,h){return g===h||g!==void 0&&h!==void 0&&(0,R.equalsIgnoreCase)(g,h)}hasTrailingPathSeparator(g,h=D.sep){if(g.scheme===t.Schemas.file){const m=E(g);return m.length>v.getRoot(m).length&&m[m.length-1]===h}else{const m=g.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,h=D.sep){return(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,h=D.sep){let m=!1;if(g.scheme===t.Schemas.file){const S=E(g);m=S!==void 0&&S.length===v.getRoot(S).length&&S[S.length-1]===h}else{h="/";const S=g.path;m=S.length===1&&S.charCodeAt(S.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path+"/"}):g}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(p=>p.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,g){const h=[];for(let m=0;m<p.length;m++){const S=g(p[m]);p.some((C,f)=>f===m?!1:(0,e.isEqualOrParent)(S,g(C)))||h.push(p[m])}return h}e.distinctParents=P;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(h){const m=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,c]=f.split(":");u&&c&&m.set(u,c)});const C=h.path.substring(0,h.path.indexOf(";"));return C&&m.set(p.META_DATA_MIME,C),m}p.parseMetaData=g})(k=e.DataUri||(e.DataUri={}));function I(p,g,h){if(g){let m=p.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),p.with({scheme:h,authority:g,path:m})}return p.with({scheme:h})}e.toLocalResource=I}),define(ee[9],te([0,1,23,15,4,2,16,3]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(N){return!!N&&typeof N.then=="function"}e.isThenable=E;function b(N){const T=new v.CancellationTokenSource,W=N(T.token),O=new Promise((U,K)=>{const ne=T.token.onCancellationRequested(()=>{ne.dispose(),T.dispose(),K(new t.CancellationError)});Promise.resolve(W).then(ae=>{ne.dispose(),T.dispose(),U(ae)},ae=>{ne.dispose(),T.dispose(),K(ae)})});return new class{cancel(){T.cancel()}then(U,K){return O.then(U,K)}catch(U){return this.then(void 0,U)}finally(U){return O.finally(U)}}}e.createCancelablePromise=b;function P(N,T,W){return new Promise((O,U)=>{const K=T.onCancellationRequested(()=>{K.dispose(),O(W)});N.then(O,U).finally(()=>K.dispose())})}e.raceCancellation=P;function k(N,T){return new Promise((W,O)=>{const U=T.onCancellationRequested(()=>{U.dispose(),O(new t.CancellationError)});N.then(W,O).finally(()=>U.dispose())})}e.raceCancellationError=k;async function I(N){let T=-1;const W=N.map((U,K)=>U.then(ne=>(T=K,ne))),O=await Promise.race(W);return N.forEach((U,K)=>{K!==T&&U.cancel()}),O}e.raceCancellablePromises=I;function p(N,T,W){let O;const U=setTimeout(()=>{O?.(void 0),W?.()},T);return Promise.race([N.finally(()=>clearTimeout(U)),new Promise(K=>O=K)])}e.raceTimeout=p;function g(N){return new Promise((T,W)=>{const O=N();E(O)?O.then(T,W):T(O)})}e.asPromise=g;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(W,W).then(O)})}return new Promise((W,O)=>{this.queuedPromise.then(W,O)})}return this.activePromise=T(),new Promise((W,O)=>{this.activePromise.then(U=>{this.activePromise=null,W(U)},U=>{this.activePromise=null,O(U)})})}}e.Throttler=h;class m{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=m;class S{constructor(){this.promiseMap=new Map}queue(T,W){const U=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(T)===U&&this.promiseMap.delete(T)});return this.promiseMap.set(T,U),U}}e.SequencerByKey=S;const C=(N,T)=>{let W=!0;const O=setTimeout(()=>{W=!1,T()},N);return{isTriggered:()=>W,dispose:()=>{clearTimeout(O),W=!1}}},f=N=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,N())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,W=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,K)=>{this.doResolve=U,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===e.MicrotaskDelay?f(O):C(W,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(T){this.delayer=new u(T),this.throttler=new h}trigger(T,W){return this.delayer.trigger(()=>this.throttler.queue(T),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class r{constructor(){this._isOpen=!1,this._promise=new Promise((T,W)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class l extends r{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(N,T){return T?new Promise((W,O)=>{const U=setTimeout(()=>{K.dispose(),W()},N),K=T.onCancellationRequested(()=>{clearTimeout(U),K.dispose(),O(new t.CancellationError)})}):b(W=>i(N,W))}e.timeout=i;function n(N,T=0){const W=setTimeout(N,T);return(0,L.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=n;function o(N){const T=[];let W=0;const O=N.length;function U(){return W<O?N[W++]():null}function K(ne){ne!=null&&T.push(ne);const ae=U();return ae?ae.then(K):Promise.resolve(T)}return Promise.resolve(null).then(K)}e.sequence=o;function s(N,T=O=>!!O,W=null){let O=0;const U=N.length,K=()=>{if(O>=U)return Promise.resolve(W);const ne=N[O++];return Promise.resolve(ne()).then(le=>T(le)?Promise.resolve(le):K())};return K()}e.first=s;function a(N,T=O=>!!O,W=null){if(N.length===0)return Promise.resolve(W);let O=N.length;const U=()=>{O=-1;for(const K of N)K.cancel?.()};return new Promise((K,ne)=>{for(const ae of N)ae.then(le=>{--O>=0&&T(le)?(U(),K(le)):O===0&&K(W)}).catch(le=>{--O>=0&&(U(),ne(le))})})}e.firstParallel=a;class d{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(T){return this._size++,new Promise((W,O)=>{this.outstandingPromises.push({factory:T,c:W,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const W=T.factory();W.then(T.c,T.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class w extends d{constructor(){super(1)}}e.Queue=w;class M{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const T=new B;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueFor(T,W=R.extUri){const O=W.getComparisonKey(T);let U=this.queues.get(O);return U||(U=new w,D.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(O),this.onDidQueueDrain()}),this.queues.set(O,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=M;class A{constructor(T,W){this._token=-1,typeof T=="function"&&typeof W=="number"&&this.setIfNotSet(T,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},W)}setIfNotSet(T,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},W))}}e.TimeoutTimer=A;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,W){this.cancel(),this._token=setInterval(()=>{T()},W)}}e.IntervalTimer=F;class H{constructor(T,W){this.timeoutToken=-1,this.runner=T,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class Y{constructor(T,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=Y;class ie extends H{constructor(T,W){super(T,W);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ie;class X extends L.Disposable{constructor(T,W){super();this.options=T,this.handler=W,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...T),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,y.setTimeout0)(()=>{if(T)return;const W=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(N,T)=>{const W=requestIdleCallback(N,typeof T=="number"?{timeout:T}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(W))}}}}();class z{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function x(N,T,W){let O;for(let U=0;U<W;U++)try{return await N()}catch(K){O=K,await i(T)}throw O}e.retry=x;class Z{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(T,W,O){return this._pending={taskId:T,cancel:()=>O?.(),promise:W},W.then(()=>this.donePending(T),()=>this.donePending(T)),W}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let W,O;const U=new Promise((K,ne)=>{W=K,O=ne});this._next={run:T,promise:U,promiseResolve:W,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=Z;class V{constructor(T,W=()=>Date.now()){this.interval=T,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,W)=>{this.completeCallback=T,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(W=>{this.completeCallback(T),this.resolved=!0,W()})}error(T){return new Promise(W=>{this.errorCallback(T),this.rejected=!0,W()})}cancel(){new Promise(T=>{this.errorCallback(new t.CancellationError),this.rejected=!0,T()})}}e.DeferredPromise=B;var $;(function(N){async function T(O){let U;const K=await Promise.all(O.map(ne=>ne.then(ae=>ae,ae=>{U||(U=ae)})));if(typeof U!="undefined")throw U;return K}N.settled=T;function W(O){return new Promise(async(U,K)=>{try{await O(U,K)}catch(ne){K(ne)}})}N.withAsyncBody=W})($=e.Promises||(e.Promises={}));var Q;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(Q||(Q={}));class q{constructor(T){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const W={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(T(W)),this.resolve()}catch(O){this.reject(O)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(T){return new q(W=>{W.emitMany(T)})}static fromPromise(T){return new q(async W=>{W.emitMany(await T)})}static fromPromises(T){return new q(async W=>{await Promise.all(T.map(async O=>W.emitOne(await O)))})}static merge(T){return new q(async W=>{await Promise.all(T.map(async O=>{for await(const U of O)W.emitOne(U)}))})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(T,W){return new q(async O=>{for await(const U of T)O.emitOne(W(U))})}map(T){return q.map(this,T)}static filter(T,W){return new q(async O=>{for await(const U of T)W(U)&&O.emitOne(U)})}filter(T){return q.filter(this,T)}static coalesce(T){return q.filter(T,W=>!!W)}coalesce(){return q.coalesce(this)}static async toPromise(T){const W=[];for await(const O of T)W.push(O);return W}toPromise(){return q.toPromise(this)}emitOne(T){this._state===0&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===0&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(T){this._state===0&&(this._state=2,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class J extends q{constructor(T,W){super(W);this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function _(N){const T=new v.CancellationTokenSource,W=N(T.token);return new J(T,async O=>{const U=T.token.onCancellationRequested(()=>{U.dispose(),T.dispose(),O.reject(new t.CancellationError)});try{for await(const K of W){if(T.token.isCancellationRequested)return;O.emitOne(K)}U.dispose(),T.dispose()}catch(K){U.dispose(),T.dispose(),O.reject(K)}})}e.createCancelableAsyncIterable=_}),define(ee[86],te([0,1,26,9,29,35,8,3,28]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",k="[^/\\\\]",I=/\//g;function p(B,$){switch(B){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${$?`|${P}${k}+`:""})*?`}}function g(B,$){if(!B)return[];const Q=[];let q=!1,J=!1,_="";for(const N of B){switch(N){case $:if(!q&&!J){Q.push(_),_="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":J=!0;break;case"]":J=!1;break}_+=N}return _&&Q.push(_),Q}e.splitGlobAware=g;function h(B){if(!B)return"";let $="";const Q=g(B,e.GLOB_SPLIT);if(Q.every(q=>q===e.GLOBSTAR))$=".*";else{let q=!1;Q.forEach((J,_)=>{if(J===e.GLOBSTAR){if(q)return;$+=p(2,_===Q.length-1)}else{let N=!1,T="",W=!1,O="";for(const U of J){if(U!=="}"&&N){T+=U;continue}if(W&&(U!=="]"||!O)){let K;U==="-"?K=U:(U==="^"||U==="!")&&!O?K="^":U===e.GLOB_SPLIT?K="":K=(0,E.escapeRegExpCharacters)(U),O+=K;continue}switch(U){case"{":N=!0;continue;case"[":W=!0;continue;case"}":{$+=`(?:${g(T,",").map(ae=>h(ae)).join("|")})`,N=!1,T="";break}case"]":{$+="["+O+"]",W=!1,O="";break}case"?":$+=k;continue;case"*":$+=p(1);continue;default:$+=(0,E.escapeRegExpCharacters)(U)}}_<Q.length-1&&(Q[_+1]!==e.GLOBSTAR||_+2<Q.length)&&($+=P)}q=J===e.GLOBSTAR})}return $}const m=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),l=function(){return!1},i=function(){return null};function n(B,$){if(!B)return i;let Q;typeof B!="string"?Q=B.pattern:Q=B,Q=Q.trim();const q=`${Q}_${!!$.trimForExclusions}`;let J=r.get(q);if(J)return o(J,B);let _;return m.test(Q)?J=a(Q.substr(4),Q):(_=S.exec(s(Q,$)))?J=d(_[1],Q):($.trimForExclusions?f:C).test(Q)?J=w(Q,$):(_=u.exec(s(Q,$)))?J=M(_[1].substr(1),Q,!0):(_=c.exec(s(Q,$)))?J=M(_[1],Q,!1):J=A(Q),r.set(q,J),o(J,B)}function o(B,$){if(typeof $=="string")return B;const Q=function(q,J){return(0,D.isEqualOrParent)(q,$.base,!y.isLinux)?B(q.substr($.base.length+1),J):null};return Q.allBasenames=B.allBasenames,Q.allPaths=B.allPaths,Q.basenames=B.basenames,Q.patterns=B.patterns,Q}function s(B,$){return $.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function a(B,$){return function(Q,q){return typeof Q=="string"&&Q.endsWith(B)?$:null}}function d(B,$){const Q=`/${B}`,q=`\\${B}`,J=function(N,T){return typeof N!="string"?null:T?T===B?$:null:N===B||N.endsWith(Q)||N.endsWith(q)?$:null},_=[B];return J.basenames=_,J.patterns=[$],J.allBasenames=_,J}function w(B,$){const Q=Z(B.slice(1,-1).split(",").map(T=>n(T,$)).filter(T=>T!==i),B),q=Q.length;if(!q)return i;if(q===1)return Q[0];const J=function(T,W){for(let O=0,U=Q.length;O<U;O++)if(Q[O](T,W))return B;return null},_=Q.find(T=>!!T.allBasenames);_&&(J.allBasenames=_.allBasenames);const N=Q.reduce((T,W)=>W.allPaths?T.concat(W.allPaths):T,[]);return N.length&&(J.allPaths=N),J}function M(B,$,Q){const q=R.sep===R.posix.sep,J=q?B:B.replace(I,R.sep),_=R.sep+J,N=R.posix.sep+B;let T;return Q?T=function(W,O){return typeof W=="string"&&(W===J||W.endsWith(_)||!q&&(W===B||W.endsWith(N)))?$:null}:T=function(W,O){return typeof W=="string"&&(W===J||!q&&W===B)?$:null},T.allPaths=[(Q?"*/":"./")+B],T}function A(B){try{const $=new RegExp(`^${h(B)}$`);return function(Q){return $.lastIndex=0,typeof Q=="string"&&$.test(Q)?B:null}}catch{return i}}function F(B,$,Q){return!B||typeof $!="string"?!1:H(B)($,void 0,Q)}e.match=F;function H(B,$={}){if(!B)return l;if(typeof B=="string"||Y(B)){const Q=n(B,$);if(Q===i)return l;const q=function(J,_){return!!Q(J,_)};return Q.allBasenames&&(q.allBasenames=Q.allBasenames),Q.allPaths&&(q.allPaths=Q.allPaths),q}return z(B,$)}e.parse=H;function Y(B){const $=B;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=Y;function ie(B){return B.allBasenames||[]}e.getBasenameTerms=ie;function X(B){return B.allPaths||[]}e.getPathTerms=X;function z(B,$){const Q=Z(Object.getOwnPropertyNames(B).map(T=>x(T,B[T],$)).filter(T=>T!==i)),q=Q.length;if(!q)return i;if(!Q.some(T=>!!T.requiresSiblings)){if(q===1)return Q[0];const T=function(U,K){let ne;for(let ae=0,le=Q.length;ae<le;ae++){const oe=Q[ae](U,K);if(typeof oe=="string")return oe;(0,t.isThenable)(oe)&&(ne||(ne=[]),ne.push(oe))}return ne?(async()=>{for(const ae of ne){const le=await ae;if(typeof le=="string")return le}return null})():null},W=Q.find(U=>!!U.allBasenames);W&&(T.allBasenames=W.allBasenames);const O=Q.reduce((U,K)=>K.allPaths?U.concat(K.allPaths):U,[]);return O.length&&(T.allPaths=O),T}const J=function(T,W,O){let U,K;for(let ne=0,ae=Q.length;ne<ae;ne++){const le=Q[ne];le.requiresSiblings&&O&&(W||(W=(0,R.basename)(T)),U||(U=W.substr(0,W.length-(0,R.extname)(T).length)));const oe=le(T,W,U,O);if(typeof oe=="string")return oe;(0,t.isThenable)(oe)&&(K||(K=[]),K.push(oe))}return K?(async()=>{for(const ne of K){const ae=await ne;if(typeof ae=="string")return ae}return null})():null},_=Q.find(T=>!!T.allBasenames);_&&(J.allBasenames=_.allBasenames);const N=Q.reduce((T,W)=>W.allPaths?T.concat(W.allPaths):T,[]);return N.length&&(J.allPaths=N),J}function x(B,$,Q){if($===!1)return i;const q=n(B,Q);if(q===i)return i;if(typeof $=="boolean")return q;if($){const J=$.when;if(typeof J=="string"){const _=(N,T,W,O)=>{if(!O||!q(N,T))return null;const U=J.replace("$(basename)",W),K=O(U);return(0,t.isThenable)(K)?K.then(ne=>ne?B:null):K?B:null};return _.requiresSiblings=!0,_}}return q}function Z(B,$){const Q=B.filter(T=>!!T.basenames);if(Q.length<2)return B;const q=Q.reduce((T,W)=>{const O=W.basenames;return O?T.concat(O):T},[]);let J;if($){J=[];for(let T=0,W=q.length;T<W;T++)J.push($)}else J=Q.reduce((T,W)=>{const O=W.patterns;return O?T.concat(O):T},[]);const _=function(T,W){if(typeof T!="string")return null;if(!W){let U;for(U=T.length;U>0;U--){const K=T.charCodeAt(U-1);if(K===47||K===92)break}W=T.substr(U)}const O=q.indexOf(W);return O!==-1?J[O]:null};_.basenames=q,_.patterns=J,_.allBasenames=q;const N=B.filter(T=>!T.basenames);return N.push(_),N}function V(B,$){return(0,v.equals)(B,$,(Q,q)=>typeof Q=="string"&&typeof q=="string"?Q===q:typeof Q!="string"&&typeof q!="string"?Q.base===q.base&&Q.pattern===q.pattern:!1)}e.patternsEquals=V}),define(ee[33],te([0,1,26,29,10,8,3,16,28,7]),function(j,e,v,t,D,L,R,y,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(s,a){const{os:d,tildify:w,relative:M}=a;if(M){const H=k(s,M,d);if(typeof H=="string")return H}let A=s.fsPath;if(d===1&&!R.isWindows?A=A.replace(/\//g,"\\"):d!==1&&R.isWindows&&(A=A.replace(/\\/g,"/")),d!==1&&w?.userHome){let H=w.userHome.fsPath,Y;s.scheme!==w.userHome.scheme&&s.path.startsWith(L.posix.sep)?Y=w.userHome.with({path:s.path}).fsPath:Y=s.fsPath,R.isWindows&&(Y=(0,t.toSlashes)(Y),H=(0,t.toSlashes)(H)),A=h(Y,H,d)}return(d===1?L.win32:L.posix).normalize(p(A,d===1))}e.getPathLabel=P;function k(s,a,d){const w=d===1?L.win32:L.posix,M=d===3?y.extUri:y.extUriIgnorePathCase,A=a.getWorkspace(),F=(0,v.firstOrDefault)(A.folders);if(!F)return;s.scheme!==F.uri.scheme&&s.path.startsWith(L.posix.sep)&&(s=F.uri.with({path:s.path}));const H=a.getWorkspaceFolder(s);if(!H)return;let Y;if(M.isEqual(H.uri,s)?Y="":Y=M.relativePath(H.uri,s)??"",Y&&(Y=w.normalize(Y)),A.folders.length>1&&!a.noPrefix){const ie=H.name?H.name:M.basenameOrAuthority(H.uri);Y=Y?`${ie} \u2022 ${Y}`:ie}return Y}function I(s){if(!s)return;typeof s=="string"&&(s=b.URI.file(s));const a=(0,y.basename)(s)||(s.scheme===D.Schemas.file?s.fsPath:s.path);return R.isWindows&&(0,t.isRootOrDriveLetter)(a)?p(a):a}e.getBaseLabel=I;function p(s,a=R.isWindows){return(0,t.hasDriveLetter)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=p;let g=Object.create(null);function h(s,a,d=R.OS){if(d===1||!s||!a)return s;let w=g.original===a?g.normalized:void 0;return w||(w=`${(0,E.rtrim)(a,L.posix.sep)}${L.posix.sep}`,g={original:a,normalized:w}),(d===3?s.startsWith(w):(0,E.startsWithIgnoreCase)(s,w))&&(s=`~/${s.substr(w.length)}`),s}e.tildify=h;function m(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=m;const S="\u2026",C="\\\\",f="~";function u(s,a=L.sep){const d=new Array(s.length);let w=!1;for(let M=0;M<s.length;M++){let A=s[M];if(A===""){d[M]=`.${a}`;continue}if(!A){d[M]=A;continue}w=!0;let F="";A.indexOf(C)===0?(F=A.substr(0,A.indexOf(C)+C.length),A=A.substr(A.indexOf(C)+C.length)):A.indexOf(a)===0?(F=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length)):A.indexOf(f)===0&&(F=A.substr(0,A.indexOf(f)+f.length),A=A.substr(A.indexOf(f)+f.length));const H=A.split(a);for(let Y=1;w&&Y<=H.length;Y++)for(let ie=H.length-Y;w&&ie>=0;ie--){w=!1;let X=H.slice(ie,ie+Y).join(a);for(let z=0;!w&&z<s.length;z++)if(z!==M&&s[z]&&s[z].indexOf(X)>-1){const x=ie+Y===H.length,Z=ie>0&&s[z].indexOf(a)>-1?a+X:X,V=s[z].endsWith(Z);w=!x||V}if(!w){let z="";(H[0].endsWith(":")||F!=="")&&(ie===1&&(ie=0,Y++,X=H[0]+a+X),ie>0&&(z=H[0]+a),z=F+z),ie>0&&(z=z+S+a),z=z+X,ie+Y<H.length&&(z=z+a+S),d[M]=z}}w&&(d[M]=A)}return d}e.shorten=u;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function r(s,a=Object.create(null)){const d=[];let w=!1,M="";for(const A of s)if(A==="$"||w&&A==="{")M&&d.push({value:M,type:c.TEXT}),M="",w=!0;else if(A==="}"&&w){const F=a[M];if(typeof F=="string")F.length&&d.push({value:F,type:c.VARIABLE});else if(F){const H=d[d.length-1];(!H||H.type!==c.SEPARATOR)&&d.push({value:F.label,type:c.SEPARATOR})}M="",w=!1}else M+=A;return M&&!w&&d.push({value:M,type:c.TEXT}),d.filter((A,F)=>{if(A.type===c.SEPARATOR){const H=d[F-1],Y=d[F+1];return[H,Y].every(ie=>ie&&(ie.type===c.VARIABLE||ie.type===c.TEXT)&&ie.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=r;function l(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function i(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(s){const a=s.indexOf("/")!==-1?L.posix:L.win32,d=a.basename(s),w=a.dirname(s);return d.length?{name:d,parentPath:w}:{name:w,parentPath:""}}e.splitName=o}),define(ee[118],te([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(P){return P.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const I=this._uriTransformer.transformIncoming(k);return I===k?k:t(v.URI.from(I))}transformOutgoing(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:t(v.URI.from(I))}transformOutgoingURI(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:v.URI.from(I)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function L(P,k,I){if(!P||I>200)return null;if(typeof P=="object"){if(P instanceof v.URI)return k.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const g=L(P[p],k,I+1);g!==null&&(P[p]=g)}}return null}function R(P,k){const I=L(P,k,0);return I===null?P:I}e.transformOutgoingURIs=R;function y(P,k,I,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return I?v.URI.revive(k.transformIncoming(P)):k.transformIncoming(P);for(let g in P)if(Object.hasOwnProperty.call(P,g)){const h=y(P[g],k,I,p+1);h!==null&&(P[g]=h)}}return null}function E(P,k){const I=y(P,k,!1,0);return I===null?P:I}e.transformIncomingURIs=E;function b(P,k){const I=y(P,k,!0,0);return I===null?P:I}e.transformAndReviveIncomingURIs=b}),define(ee[31],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(E){return v.test(E)}e.isUUID=t;const D=new Uint8Array(16),L=[];for(let E=0;E<256;E++)L.push(E.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(E){for(let b=0;b<E.length;b++)E[b]=Math.floor(Math.random()*256);return E};function y(){R(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let E=0,b="";return b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b}e.generateUuid=y}),define(ee[119],te([0,1,15,4,2,3,11,28]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const E="$initialize";let b=!1;function P(i){!L.isWeb||(b||(b=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(i.message))}e.logOnceWebWorkerWarning=P;var k;(function(i){i[i.Request=0]="Request",i[i.Reply=1]="Reply",i[i.SubscribeEvent=2]="SubscribeEvent",i[i.Event=3]="Event",i[i.UnsubscribeEvent=4]="UnsubscribeEvent"})(k||(k={}));class I{constructor(n,o,s,a){this.vsWorker=n,this.req=o,this.method=s,this.args=a,this.type=0}}class p{constructor(n,o,s,a){this.vsWorker=n,this.seq=o,this.res=s,this.err=a,this.type=1}}class g{constructor(n,o,s,a){this.vsWorker=n,this.req=o,this.eventName=s,this.arg=a,this.type=2}}class h{constructor(n,o,s){this.vsWorker=n,this.req=o,this.event=s,this.type=3}}class m{constructor(n,o){this.vsWorker=n,this.req=o,this.type=4}}class S{constructor(n){this._workerId=-1,this._handler=n,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(n){this._workerId=n}sendMessage(n,o){const s=String(++this._lastSentReq);return new Promise((a,d)=>{this._pendingReplies[s]={resolve:a,reject:d},this._send(new I(this._workerId,s,n,o))})}listen(n,o){let s=null;const a=new t.Emitter({onFirstListenerAdd:()=>{s=String(++this._lastSentReq),this._pendingEmitters.set(s,a),this._send(new g(this._workerId,s,n,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(s),this._send(new m(this._workerId,s)),s=null}});return a.event}handleMessage(n){!n||!n.vsWorker||this._workerId!==-1&&n.vsWorker!==this._workerId||this._handleMessage(n)}_handleMessage(n){switch(n.type){case 1:return this._handleReplyMessage(n);case 0:return this._handleRequestMessage(n);case 2:return this._handleSubscribeEventMessage(n);case 3:return this._handleEventMessage(n);case 4:return this._handleUnsubscribeEventMessage(n)}}_handleReplyMessage(n){if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let s=n.err;n.err.$isError&&(s=new Error,s.name=n.err.name,s.message=n.err.message,s.stack=n.err.stack),o.reject(s);return}o.resolve(n.res)}_handleRequestMessage(n){let o=n.req;this._handler.handleMessage(n.method,n.args).then(a=>{this._send(new p(this._workerId,o,a,void 0))},a=>{a.detail instanceof Error&&(a.detail=(0,v.transformErrorForSerialization)(a.detail)),this._send(new p(this._workerId,o,void 0,(0,v.transformErrorForSerialization)(a)))})}_handleSubscribeEventMessage(n){const o=n.req,s=this._handler.handleEvent(n.eventName,n.arg)(a=>{this._send(new h(this._workerId,o,a))});this._pendingEvents.set(o,s)}_handleEventMessage(n){if(!this._pendingEmitters.has(n.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(n.req).fire(n.event)}_handleUnsubscribeEventMessage(n){if(!this._pendingEvents.has(n.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(n.req).dispose(),this._pendingEvents.delete(n.req)}_send(n){let o=[];if(n.type===0)for(let s=0;s<n.args.length;s++)n.args[s]instanceof ArrayBuffer&&o.push(n.args[s]);else n.type===1&&n.res instanceof ArrayBuffer&&o.push(n.res);this._handler.sendMessage(n,o)}}class C extends D.Disposable{constructor(n,o,s){super();let a=null;this._worker=this._register(n.create("vs/base/common/worker/simpleWorker",F=>{this._protocol.handleMessage(F)},F=>{a&&a(F)})),this._protocol=new S({sendMessage:(F,H)=>{this._worker.postMessage(F,H)},handleMessage:(F,H)=>{if(typeof s[F]!="function")return Promise.reject(new Error("Missing method "+F+" on main thread host."));try{return Promise.resolve(s[F].apply(s,H))}catch(Y){return Promise.reject(Y)}},handleEvent:(F,H)=>{if(u(F)){const Y=s[F].call(s,H);if(typeof Y!="function")throw new Error(`Missing dynamic event ${F} on main thread host.`);return Y}if(f(F)){const Y=s[F];if(typeof Y!="function")throw new Error(`Missing event ${F} on main thread host.`);return Y}throw new Error(`Malformed event name ${F}`)}}),this._protocol.setWorkerId(this._worker.getId());let d=null;typeof L.globals.require!="undefined"&&typeof L.globals.require.getConfig=="function"?d=L.globals.require.getConfig():typeof L.globals.requirejs!="undefined"&&(d=L.globals.requirejs.s.contexts._.config);const w=R.getAllMethodNames(s);this._onModuleLoaded=this._protocol.sendMessage(E,[this._worker.getId(),JSON.parse(JSON.stringify(d)),o,w]);const M=(F,H)=>this._request(F,H),A=(F,H)=>this._protocol.listen(F,H);this._lazyProxy=new Promise((F,H)=>{a=H,this._onModuleLoaded.then(Y=>{F(c(Y,M,A))},Y=>{H(Y),this._onError("Worker failed to load "+o,Y)})})}getProxyObject(){return this._lazyProxy}_request(n,o){return new Promise((s,a)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(n,o).then(s,a)},a)})}_onError(n,o){console.error(n),console.info(o)}}e.SimpleWorkerClient=C;function f(i){return i[0]==="o"&&i[1]==="n"&&y.isUpperAsciiLetter(i.charCodeAt(2))}function u(i){return/^onDynamic/.test(i)&&y.isUpperAsciiLetter(i.charCodeAt(9))}function c(i,n,o){const s=w=>function(){const M=Array.prototype.slice.call(arguments,0);return n(w,M)},a=w=>function(M){return o(w,M)};let d={};for(const w of i){if(u(w)){d[w]=a(w);continue}if(f(w)){d[w]=o(w,void 0);continue}d[w]=s(w)}return d}class r{constructor(n,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new S({sendMessage:(s,a)=>{n(s,a)},handleMessage:(s,a)=>this._handleMessage(s,a),handleEvent:(s,a)=>this._handleEvent(s,a)})}onmessage(n){this._protocol.handleMessage(n)}_handleMessage(n,o){if(n===E)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._requestHandler[n].apply(this._requestHandler,o))}catch(s){return Promise.reject(s)}}_handleEvent(n,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(u(n)){const s=this._requestHandler[n].call(this._requestHandler,o);if(typeof s!="function")throw new Error(`Missing dynamic event ${n} on request handler.`);return s}if(f(n)){const s=this._requestHandler[n];if(typeof s!="function")throw new Error(`Missing event ${n} on request handler.`);return s}throw new Error(`Malformed event name ${n}`)}initialize(n,o,s,a){this._protocol.setWorkerId(n);const M=c(a,(A,F)=>this._protocol.sendMessage(A,F),(A,F)=>this._protocol.listen(A,F));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(M),Promise.resolve(R.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,L.globals.require.config(o)),new Promise((A,F)=>{(L.globals.require||j)([s],Y=>{if(this._requestHandler=Y.create(M),!this._requestHandler){F(new Error("No RequestHandler!"));return}A(R.getAllMethodNames(this._requestHandler))},F)}))}}e.SimpleWorkerServer=r;function l(i){return new r(i,null)}e.create=l}),define(ee[120],te([0,1,60,30,44]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function L(R,y){if(await new Promise((P,k)=>{const I=t.createReadStream(R),p=v.createHash("sha1");I.pipe(p);const g=(0,D.once)((h,m)=>{I.removeAllListeners(),p.removeAllListeners(),h?k(h):P(m)});I.once("error",g),I.once("end",g),p.once("error",g),p.once("data",h=>g(void 0,h.toString("hex")))})!==y)throw new Error("Hash mismatch")}e.checksum=L}),define(ee[121],te([0,1,240]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(L="utf8"){this.stringDecoder=new v.StringDecoder(L),this.remaining=null}write(L){const R=[],y=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(y.length<1)return R;let E=0,b,P=E;for(;P<y.length;)if(b=y.charCodeAt(P),b===13||b===10){if(R.push(y.substring(E,P)),P++,P<y.length){const k=b;b=y.charCodeAt(P),(k===13&&b===10||k===10&&b===13)&&P++}E=P}else P++;return this.remaining=E<y.length?y.substr(E):null,R}end(){return this.remaining}}e.LineDecoder=t}),define(ee[122],te([0,1,27]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(R){const y=R.replace(/\-/g,":").toLowerCase();return!t.has(y)}function L(){const R=(0,v.networkInterfaces)();for(let y in R){const E=R[y];if(E){for(const{mac:b}of E)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ee[73],te([0,1,27,15,35,31,122]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,k=0;const I=(0,v.networkInterfaces)();for(let p in I){const g=I[p];if(g)for(const{mac:h,internal:m}of g)m||(k+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(P+=1))}this._value=k>0?P/k:0}return this._value}};let y;async function E(){return y||(y=(async()=>await b()||L.generateUuid())()),y}e.getMachineId=E;async function b(){try{const P=await new Promise((I,p)=>{j(["crypto"],I,p)}),k=(0,R.getMac)();return P.createHash("sha256").update(k,"utf8").digest("hex")}catch(P){t.onUnexpectedError(P);return}}}),define(ee[20],te([0,1,30,27,123,9,29,72,8,3,16,7]),function(j,e,v,t,D,L,R,y,E,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function p(X,z=I.UNLINK){if((0,R.isRootOrDriveLetter)(X))throw new Error("rimraf - will refuse to recursively delete root");return z===I.UNLINK?h(X):g(X)}async function g(X){try{const z=(0,R.randomPath)((0,t.tmpdir)());try{await v.promises.rename(X,z)}catch{return h(X)}h(z).catch(x=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function h(X){return(0,D.promisify)(v.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function m(X){if((0,R.isRootOrDriveLetter)(X))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function S(X,z){return u(await(z?C(X):(0,D.promisify)(v.readdir)(X)))}async function C(X){try{return await(0,D.promisify)(v.readdir)(X,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const z=[],x=await S(X);for(const Z of x){let V=!1,B=!1,$=!1;try{const Q=await e.Promises.lstat((0,E.join)(X,Z));V=Q.isFile(),B=Q.isDirectory(),$=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}z.push({name:Z,isFile:()=>V,isDirectory:()=>B,isSymbolicLink:()=>$})}return z}function f(X){return u(v.readdirSync(X))}e.readdirSync=f;function u(X){return X.map(z=>typeof z=="string"?b.isMacintosh?(0,y.normalizeNFC)(z):z:(z.name=b.isMacintosh?(0,y.normalizeNFC)(z.name):z.name,z))}async function c(X){const z=await S(X),x=[];for(const Z of z)await l.existsDirectory((0,E.join)(X,Z))&&x.push(Z);return x}function r(X,z=1e3){return new Promise(x=>{let Z=!1;const V=setInterval(()=>{Z||(Z=!0,v.access(X,B=>{Z=!1,B&&(clearInterval(V),x(void 0))}))},z)})}e.whenDeleted=r;var l;(function(X){async function z(V){let B;try{if(B=await e.Promises.lstat(V),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(b.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw Q}throw $}}X.stat=z;async function x(V){try{const{stat:B,symbolicLink:$}=await X.stat(V);return B.isFile()&&$?.dangling!==!0}catch{}return!1}X.existsFile=x;async function Z(V){try{const{stat:B,symbolicLink:$}=await X.stat(V);return B.isDirectory()&&$?.dangling!==!0}catch{}return!1}X.existsDirectory=Z})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function n(X,z,x){return i.queueFor(k.URI.file(X),P.extUriBiasedIgnorePathCase).queue(()=>{const Z=d(x);return new Promise((V,B)=>s(X,z,Z,$=>$?B($):V()))})}let o=!0;function s(X,z,x,Z){if(!o)return v.writeFile(X,z,{mode:x.mode,flag:x.flag},Z);v.open(X,x.flag,x.mode,(V,B)=>{if(V)return Z(V);v.writeFile(B,z,$=>{if($)return v.close(B,()=>Z($));v.fdatasync(B,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),o=!1),v.close(B,q=>Z(q))))})})}function a(X,z,x){const Z=d(x);if(!o)return v.writeFileSync(X,z,{mode:Z.mode,flag:Z.flag});const V=v.openSync(X,Z.flag,Z.mode);try{v.writeFileSync(V,z);try{v.fdatasyncSync(V)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o=!1}}finally{v.closeSync(V)}}e.writeFileSync=a;function d(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function w(X,z){if(X!==z)try{await e.Promises.rename(X,z)}catch(x){if(X.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||X.endsWith("."))await M(X,z,{preserveSymlinks:!1}),await p(X,I.MOVE);else throw x}}async function M(X,z,x){return F(X,z,{root:{source:X,target:z},options:x,handledSourcePaths:new Set})}const A=511;async function F(X,z,x){if(x.handledSourcePaths.has(X))return;x.handledSourcePaths.add(X);const{stat:Z,symbolicLink:V}=await l.stat(X);if(V){if(x.options.preserveSymlinks)try{return await ie(X,z,x)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(V.dangling)return}return Z.isDirectory()?H(X,z,Z.mode&A,x):Y(X,z,Z.mode&A)}async function H(X,z,x,Z){await e.Promises.mkdir(z,{recursive:!0,mode:x});const V=await S(X);for(const B of V)await F((0,E.join)(X,B),(0,E.join)(z,B),Z)}async function Y(X,z,x){await e.Promises.copyFile(X,z),await e.Promises.chmod(z,x)}async function ie(X,z,x){let Z=await e.Promises.readlink(X);(0,R.isEqualOrParent)(Z,x.root.source,!b.isLinux)&&(Z=(0,E.join)(x.root.target,Z.substr(x.root.source.length+1))),await e.Promises.symlink(Z,z)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(X,z,x,Z,V)=>new Promise((B,$)=>{v.read(X,z,x,Z,V,(Q,q,J)=>Q?$(Q):B({bytesRead:q,buffer:J}))})}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(X,z,x,Z,V)=>new Promise((B,$)=>{v.write(X,z,x,Z,V,(Q,q,J)=>Q?$(Q):B({bytesWritten:q,buffer:J}))})}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return S}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return p}get move(){return w}get copy(){return M}}}),define(ee[87],te([0,1,30,8,3,28,20]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(I){if(D.isLinux)return I;const p=(0,t.dirname)(I);if(I===p)return I;const g=((0,t.basename)(I)||I).toLowerCase();try{const m=(0,R.readdirSync)(p).filter(S=>S.toLowerCase()===g);if(m.length===1){const S=y(p);if(S)return(0,t.join)(S,m[0])}else if(m.length>1){const S=m.indexOf(g);if(S>=0){const C=y(p);if(C)return(0,t.join)(C,m[S])}}}catch{}return null}e.realcaseSync=y;async function E(I){if(D.isLinux)return I;const p=(0,t.dirname)(I);if(I===p)return I;const g=((0,t.basename)(I)||I).toLowerCase();try{const m=(await R.Promises.readdir(p)).filter(S=>S.toLowerCase()===g);if(m.length===1){const S=await E(p);if(S)return(0,t.join)(S,m[0])}else if(m.length>1){const S=m.indexOf(g);if(S>=0){const C=await E(p);if(C)return(0,t.join)(C,m[S])}}}catch{}return null}e.realcase=E;async function b(I){try{return await R.Promises.realpath(I)}catch{const g=k(I);return await R.Promises.access(g,v.constants.R_OK),g}}e.realpath=b;function P(I){try{return v.realpathSync(I)}catch{const g=k(I);return v.accessSync(g,v.constants.R_OK),g}}e.realpathSync=P;function k(I){return(0,L.rtrim)((0,t.normalize)(I),t.sep)}}),define(ee[88],te([0,1,61]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(y,E,b,P=1){let k=!1;return new Promise(I=>{const p=setTimeout(()=>{if(!k)return k=!0,I(0)},b);D(y,E,P,g=>{if(!k)return k=!0,clearTimeout(p),I(g)})})}e.findFreePort=t;function D(y,E,b,P){if(E===0)return P(0);const k=new v.Socket;k.once("connect",()=>(R(k),D(y+b,E-1,b,P))),k.once("data",()=>{}),k.once("error",I=>(R(k),I.code!=="ECONNREFUSED"?D(y+b,E-1,b,P):P(y))),k.connect(y,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(y,E,b){let P=!1,k,I=1;const p=v.createServer({pauseOnConnect:!0});function g(h,m){P||(P=!0,p.removeAllListeners(),p.close(),k&&clearTimeout(k),m(h))}return new Promise(h=>{k=setTimeout(()=>{g(0,h)},b),p.on("listening",()=>{g(y,h)}),p.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&I<E?(y++,I++,p.listen(y,"127.0.0.1")):g(0,h)}),p.on("close",()=>{g(0,h)}),p.listen(y,"127.0.0.1")})}e.findFreePortFaster=L;function R(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(E){console.error(E)}}}),define(ee[124],te([0,1,27,8,20]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,R=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var E;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class k{constructor(c,r,l){this.exePath=c,this.displayName=r,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:u=!1}={}){return u?b===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:u=!1,findPreview:c=!1}={}){const r=I({useAlternateBitness:u});if(!r)return null;const l=t.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(l))return null;let i=-1,n=null;for(const a of await D.Promises.readdir(l)){let d=-1;if(c){const M=a.indexOf("-");if(M<0)continue;const A=a.substring(0,M);if(!L.test(A)||a.substring(M+1)!=="preview")continue;d=parseInt(A,10)}else{if(!L.test(a))continue;d=parseInt(a,10)}if(d<=i)continue;const w=t.join(l,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(n=w,i=d)}if(!n)return null;const o=r.includes("x86")?" (x86)":"",s=c?" Preview":"";return new k(n,`PowerShell${s}${o}`,!0)}async function g({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:r,pwshMsixName:l}=u?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(c))if(r.test(i)){const n=t.join(c,i,"pwsh.exe");return new k(n,l)}return null}function h(){const u=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function m(){const u=t.join(process.env.windir,b===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}async function*S(){let u=await p();u&&(yield u),u=await p({useAlternateBitness:!0}),u&&(yield u),u=await g(),u&&(yield u),u=h(),u&&(yield u),u=await p({findPreview:!0}),u&&(yield u),u=await g({findPreview:!0}),u&&(yield u),u=await p({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=m(),u&&(yield u)}async function*C(){for await(const u of S())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=C;async function f(){for await(const u of C())return u;return null}e.getFirstAvailablePowerShellInstallation=f}),define(ee[89],te([0,1,46,10]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(R){return new Promise((y,E)=>{let b;const P=new Map;function k(p,g,h,m,S){const C=P.get(g);if(p===R||C){const f={name:I(h),cmd:h,pid:p,ppid:g,load:m,mem:S};P.set(p,f),p===R&&(b=f),C&&(C.children||(C.children=[]),C.children.push(f),C.children.length>1&&(C.children=C.children.sort((u,c)=>u.pid-c.pid)))}}function I(p){const g=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,S=/--utility-sub-type=network/,C=/--crashes-directory/,f=/\\pipe\\winpty-control/,u=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(C.exec(p))return"electron-crash-reporter";if(f.exec(p))return"winpty-process";if(u.exec(p))return"console-window-host (Windows internal process)";let r=c.exec(p);if(r&&r.length===2)return r[1]==="renderer"?g.exec(p)?"shared-process":h.exec(p)?"issue-reporter":m.exec(p)?"process-explorer":"window":r[1]==="utility"&&S.exec(p)?"utility-network-service":r[1];const l=/[a-zA-Z-]+\.js/g;let i="";do r=l.exec(p),r&&(i+=r+" ");while(r);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,h)=>{j(["windows-process-tree"],g,h)}).then(g=>{g.getProcessList(R,h=>{if(!h){E(new Error(`Root process ${R} not found`));return}g.getProcessCpuUsage(h,m=>{const S=new Map;m.forEach(C=>{const f=p(C.commandLine||"");S.set(C.pid,{name:I(f),cmd:f,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),b=S.get(R),b?(S.forEach(C=>{const f=S.get(C.ppid);f&&(f.children||(f.children=[]),f.children.push(C))}),S.forEach(C=>{C.children&&(C.children=C.children.sort((f,u)=>f.pid-u.pid))}),y(b)):E(new Error(`Root process ${R} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let p=function(){let g=[b];const h=[];for(;g.length;){const S=g.shift();S&&(h.push(S.pid),S.children&&(g=g.concat(S.children)))}let m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);m+=" "+h.join(" "),(0,v.exec)(m,{},(S,C,f)=>{if(S||f)E(S||new Error(f.toString()));else{const u=C.toString().split(`
`);for(let c=0;c<h.length;c++){const r=P.get(h[c]);r.load=parseFloat(u[c])}if(!b){E(new Error(`Root process ${R} not found`));return}y(b)}})};(0,v.exec)("which ps",{},(g,h,m)=>{if(g||m)if(process.platform!=="linux")E(g||new Error(m.toString()));else{const S=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,v.exec)(S,{},(C,f,u)=>{C||u?E(C||new Error(u.toString())):(L(f,k),p())})}else{const S=h.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${S} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,u,c)=>{f||c&&!c.includes("screen size is bogus")?E(f||new Error(c.toString())):(L(u,k),process.platform==="linux"?p():b?y(b):E(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=D;function L(R,y){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=R.toString().split(`
`);for(const P of b){const k=E.exec(P.trim());k&&k.length===6&&y(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(ee[125],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"});var he=this&&this.__decorate||function(j,e,v,t){var D=arguments.length,L=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(j,e,v,t);else for(var y=j.length-1;y>=0;y--)(R=j[y])&&(L=(D<3?R(L):D>3?R(e,v,L):R(e,v))||L);return D>3&&L&&Object.defineProperty(e,v,L),L};define(ee[38],te([0,1,26,9,18,23,48,15,4,2,117,28,11]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function g(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function m(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(S||(S={}));class C{constructor($){this.buffer=$,this.pos=0}read($){const Q=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Q.byteLength,Q}}class f{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var u;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(u||(u={}));function c(B){const $=D.VSBuffer.alloc(4);return $.writeUInt32BE(B,0),$}function r(B){return B.read(4).readUInt32BE(0)}function l(B){const $=D.VSBuffer.alloc(1);return $.writeUInt8(B,0),$}const i={Undefined:l(u.Undefined),String:l(u.String),Buffer:l(u.Buffer),VSBuffer:l(u.VSBuffer),Array:l(u.Array),Object:l(u.Object)},n=typeof Buffer!="undefined";function o(B,$){if(typeof $=="undefined")B.write(i.Undefined);else if(typeof $=="string"){const Q=D.VSBuffer.fromString($);B.write(i.String),B.write(c(Q.byteLength)),B.write(Q)}else if(n&&Buffer.isBuffer($)){const Q=D.VSBuffer.wrap($);B.write(i.Buffer),B.write(c(Q.byteLength)),B.write(Q)}else if($ instanceof D.VSBuffer)B.write(i.VSBuffer),B.write(c($.byteLength)),B.write($);else if(Array.isArray($)){B.write(i.Array),B.write(c($.length));for(const Q of $)o(B,Q)}else{const Q=D.VSBuffer.fromString(JSON.stringify($));B.write(i.Object),B.write(c(Q.byteLength)),B.write(Q)}}function s(B){switch(B.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return B.read(r(B)).toString();case u.Buffer:return B.read(r(B)).buffer;case u.VSBuffer:return B.read(r(B));case u.Array:{const Q=r(B),q=[];for(let J=0;J<Q;J++)q.push(s(B));return q}case u.Object:return JSON.parse(B.read(r(B)).toString())}}class a{constructor($,Q,q=null,J=1e3){this.protocol=$,this.ctx=Q,this.logger=q,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel($,Q){this.channels.set($,Q),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Q=this.send([$.type]);this.logger?.logOutgoing(Q,0,1,m($.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(Q,$.id,1,m($.type),$.data);return}}}send($,Q=void 0){const q=new f;return o(q,$),o(q,Q),this.sendBuffer(q.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Q=new C($),q=s(Q),J=s(Q),_=q[0];switch(_){case 100:return this.logger?.logIncoming($.byteLength,q[1],1,`${g(_)}: ${q[2]}.${q[3]}`,J),this.onPromise({type:_,id:q[1],channelName:q[2],name:q[3],arg:J});case 102:return this.logger?.logIncoming($.byteLength,q[1],1,`${g(_)}: ${q[2]}.${q[3]}`,J),this.onEventListen({type:_,id:q[1],channelName:q[2],name:q[3],arg:J});case 101:return this.logger?.logIncoming($.byteLength,q[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:q[1]});case 103:return this.logger?.logIncoming($.byteLength,q[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:q[1]})}}onPromise($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const q=new L.CancellationTokenSource;let J;try{J=Q.call(this.ctx,$.name,$.arg,q.token)}catch(T){J=Promise.reject(T)}const _=$.id;J.then(T=>{this.sendResponse({id:_,data:T,type:201}),this.activeRequests.delete($.id)},T=>{T instanceof Error?this.sendResponse({id:_,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:_,data:T,type:203}),this.activeRequests.delete($.id)});const N=(0,b.toDisposable)(()=>q.cancel());this.activeRequests.set($.id,N)}onEventListen($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const q=$.id,_=Q.listen(this.ctx,$.name,$.arg)(N=>this.sendResponse({id:q,data:N,type:204}));this.activeRequests.set($.id,_)}disposeActiveRequest($){const Q=this.activeRequests.get($.id);Q&&(Q.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Q=this.pendingRequests.get($.channelName);Q||(Q=[],this.pendingRequests.set($.channelName,Q));const q=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:$,timeoutTimer:q})}flushPendingRequests($){const Q=this.pendingRequests.get($);if(Q){for(const q of Q)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var d;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor($,Q=null){this.protocol=$,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=Q}getChannel($){const Q=this;return{call(q,J,_){return Q.isDisposed?Promise.reject(y.canceled()):Q.requestPromise($,q,J,_)},listen(q,J){return Q.isDisposed?E.Event.None:Q.requestEvent($,q,J)}}}requestPromise($,Q,q,J=L.CancellationToken.None){const _=this.lastRequestId++,T={id:_,type:100,channelName:$,name:Q,arg:q};if(J.isCancellationRequested)return Promise.reject(y.canceled());let W;return new Promise((U,K)=>{if(J.isCancellationRequested)return K(y.canceled());const ne=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(_),U(de.data);break;case 202:{this.handlers.delete(_);const we=new Error(de.data.message);we.stack=de.data.stack,we.name=de.data.name,K(we);break}case 203:this.handlers.delete(_),K(de.data);break}};this.handlers.set(_,ue),this.sendRequest(T)};let ae=null;this.state===S.Idle?ne():(ae=(0,t.createCancelablePromise)(ue=>this.whenInitialized()),ae.then(()=>{ae=null,ne()}));const le=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:_,type:101}),K(y.canceled())},oe=J.onCancellationRequested(le);W=(0,b.combinedDisposable)((0,b.toDisposable)(le),oe),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent($,Q,q){const J=this.lastRequestId++,N={id:J,type:102,channelName:$,name:Q,arg:q};let T=null;const W=new E.Emitter({onFirstListenerAdd:()=>{T=(0,t.createCancelablePromise)(U=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(W),this.sendRequest(N)})},onLastListenerRemove:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(W),this.sendRequest({id:J,type:103}))}}),O=U=>W.fire(U.data);return this.handlers.set(J,O),W.event}sendRequest($){switch($.type){case 100:case 102:{const Q=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(Q,$.id,0,`${g($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Q=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(Q,$.id,0,g($.type));return}}}send($,Q=void 0){const q=new f;return o(q,$),o(q,Q),this.sendBuffer(q.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Q=new C($),q=s(Q),J=s(Q),_=q[0];switch(_){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,m(_)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,q[1],0,m(_),J),this.onResponse({type:q[0],id:q[1],data:J})}}onResponse($){if($.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get($.id);Q&&Q($)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([R.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class M{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:Q,onDidClientDisconnect:q})=>{E.Event.once(Q.onMessage)(_=>{const N=new C(_),T=s(N),W=new a(Q,T),O=new w(Q);this.channels.forEach((K,ne)=>W.registerChannel(ne,K));const U={channelServer:W,channelClient:O,ctx:T};this._connections.add(U),this._onDidAddConnection.fire(U),q(()=>{W.dispose(),O.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const $=[];return this._connections.forEach(Q=>$.push(Q)),$}getChannel($,Q){const q=this;return{call(J,_,N){let T;if((0,I.isFunction)(Q)){let O=(0,v.getRandomElement)(q.connections.filter(Q));T=O?Promise.resolve(O):E.Event.toPromise(E.Event.filter(q.onDidAddConnection,Q))}else T=Q.routeCall(q,J,_);const W=T.then(O=>O.channelClient.getChannel($));return F(W).call(J,_,N)},listen(J,_){if((0,I.isFunction)(Q))return q.getMulticastEvent($,Q,J,_);const N=Q.routeEvent(q,J,_).then(T=>T.channelClient.getChannel($));return F(N).listen(J,_)}}}getMulticastEvent($,Q,q,J){const _=this;let N=new b.DisposableStore;const T=new E.Emitter({onFirstListenerAdd:()=>{N=new b.DisposableStore;const W=new E.EventMultiplexer,O=new Map,U=ne=>{const le=ne.channelClient.getChannel($).listen(q,J),oe=W.add(le);O.set(ne,oe)},K=ne=>{const ae=O.get(ne);!ae||(ae.dispose(),O.delete(ne))};_.connections.filter(Q).forEach(U),E.Event.filter(_.onDidAddConnection,Q)(U,void 0,N),_.onDidRemoveConnection(K,void 0,N),W.event(T.fire,T,N),N.add(W)},onLastListenerRemove:()=>{N.dispose()}});return T.event}registerChannel($,Q){this.channels.set($,Q),this._connections.forEach(q=>{q.channelServer.registerChannel($,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=M;class A{constructor($,Q,q=null){const J=new f;o(J,Q),$.send(J.buffer),this.channelClient=new w($,q),this.channelServer=new a($,Q,q)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Q){this.channelServer.registerChannel($,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function F(B){return{call($,Q,q){return B.then(J=>J.call($,Q,q))},listen($,Q){const q=new E.Relay;return B.then(J=>q.input=J.listen($,Q)),q.event}}}e.getDelayedChannel=F;function H(B){let $=!1;return{call(Q,q,J){return $?B.call(Q,q,J):(0,t.timeout)(0).then(()=>$=!0).then(()=>B.call(Q,q,J))},listen(Q,q){if($)return B.listen(Q,q);const J=new E.Relay;return(0,t.timeout)(0).then(()=>$=!0).then(()=>J.input=B.listen(Q,q)),J.event}}}e.getNextTickChannel=H;class Y{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Q of $.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await E.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=Y;var ie;(function(B){function $(_,N){const T=_,W=N&&N.disableMarshalling,O=new Map;for(const U in T)q(U)&&O.set(U,E.Event.buffer(T[U],!0));return new class{listen(U,K,ne){const ae=O.get(K);if(ae)return ae;if(J(K)){const le=T[K];if(typeof le=="function")return le.call(T,ne)}throw new Error(`Event not found: ${K}`)}call(U,K,ne){const ae=T[K];if(typeof ae=="function"){if(!W&&Array.isArray(ne))for(let le=0;le<ne.length;le++)ne[le]=(0,P.revive)(ne[le]);return ae.apply(T,ne)}throw new Error(`Method not found: ${K}`)}}}B.fromService=$;function Q(_,N){const T=N&&N.disableMarshalling;return new Proxy({},{get(W,O){if(typeof O=="string")return N?.properties?.has(O)?N.properties.get(O):J(O)?function(U){return _.listen(O,U)}:q(O)?_.listen(O):async function(...U){let K;N&&!(0,I.isUndefinedOrNull)(N.context)?K=[N.context,...U]:K=U;const ne=await _.call(O,K);return T?ne:(0,P.revive)(ne)};throw new Error(`Property not found: ${String(O)}`)}})}B.toService=Q;function q(_){return _[0]==="o"&&_[1]==="n"&&k.isUpperAsciiLetter(_.charCodeAt(2))}function J(_){return/^onDynamic/.test(_)&&k.isUpperAsciiLetter(_.charCodeAt(9))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let $=B.toString();if($!=="[object Object]")return $}return B}function x(B){return Array.isArray(B)?B.map(z):z(B)}function Z(B,$,Q,q,J,_,N){N=x(N);const T=X[J],W=T[q%T.length];let O=[`%c[${B}]%c[${String($).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(_)?(O=O.concat(N),O.push(")")):O.push(N),console.log.apply(console,O)}e.logWithColors=Z;class V{constructor($,Q){this._outgoingPrefix=$,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Q,q,J,_){this._totalOutgoing+=$,Z(this._outgoingPrefix,this._totalOutgoing,$,Q,q,J,_)}logIncoming($,Q,q,J,_){this._totalIncoming+=$,Z(this._incomingPrefix,this._totalIncoming,$,Q,q,J,_)}}e.IPCLogger=V}),define(ee[126],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,L){this.sender=D,this.onMessage=L}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(ee[127],te([0,1,18,4,38]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",b=>v.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class R extends D.IPCClient{constructor(E,b){const P=new L(E);super(P,b);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=R}),define(ee[90],te([0,1,18,4,2,38]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let s=0;function a(w,M){if(!o.has(w)){const A=String(++s);o.set(w,A)}return o.get(w)}function d(w,M,A,F){if(!n.enableDiagnostics)return;const H=a(w,M);if(F instanceof v.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const Y=v.VSBuffer.alloc(F.byteLength);Y.set(F),n.records.push({timestamp:Date.now(),id:H,label:M,type:A,buff:Y})}else n.records.push({timestamp:Date.now(),id:H,label:M,type:A,data:F})}n.traceSocketEvent=d})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function P(){return b||(b=v.VSBuffer.alloc(0)),b}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return P();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const M=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),M}if(this._chunks[0].byteLength>o){const M=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),M}let a=v.VSBuffer.alloc(o),d=0,w=0;for(;o>0;){const M=this._chunks[w];if(M.byteLength>o){const A=M.slice(0,o);a.set(A,d),d+=o,s&&(this._chunks[w]=M.slice(o),this._totalLength-=o),o-=o}else a.set(M,d),d+=M.byteLength,s?(this._chunks.shift(),this._totalLength-=M.byteLength):w++,o-=M.byteLength}return a}}e.ChunkStream=k;var I;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(I||(I={}));function p(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,s,a,d){this.type=o,this.id=s,this.ack=a,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,d=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new h(a,d,w,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=v.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const a=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,a}_bufferTake(){const o=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class C extends D.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=C;class f extends L.IPCClient{constructor(o,s,a=null){super(o,s,a);this.protocol=o}static fromSocket(o,s){return new f(new C(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=f;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,a=this._first;for(;a;)o[s++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new c(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class l{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<l._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=l._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const o=Date.now(),s=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let d=0;d<l._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=s&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class i{constructor(o,s=null,a=l.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,P());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new h(7,0,0,P());this._socketWriter.write(o)}sendResume(){const o=new h(8,0,0,P());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,P());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let a=0,d=s.length;a<d;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,d=s.length;a<d;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const s=new h(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const w=Math.max(2e4-s,2e4-a,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,P());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(ee[37],te([0,1,14,15]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class D{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,y){const E=(b,...P)=>{this.validateEvent(R,b)&&y(b,...P)};return this.mapListenerToWrapper.set(y,E),v.ipcMain.on(R,E),this}once(R,y){return v.ipcMain.once(R,(E,...b)=>{this.validateEvent(R,E)&&y(E,...b)}),this}handle(R,y){return v.ipcMain.handle(R,(E,...b)=>this.validateEvent(R,E)?y(E,...b):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return v.ipcMain.removeHandler(R),this}removeListener(R,y){const E=this.mapListenerToWrapper.get(y);return E&&(v.ipcMain.removeListener(R,E),this.mapListenerToWrapper.delete(y)),this}validateEvent(R,y){if(!R||!R.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const E=y.senderFrame,b=E.url;if(!b)return!0;let P="unknown";try{P=new URL(b).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${b}'.`),!1}return P!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${P}'.`),!1):E.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${P}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new D}),define(ee[128],te([0,1,14,37,11,125]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){t.validatedIpcMain.on(L.CONTEXT_MENU_CHANNEL,(E,b,P,k,I)=>{const p=y(E,k,P);p.popup({window:(0,D.withNullAsUndefined)(v.BrowserWindow.fromWebContents(E.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{p&&E.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,b)}})})}e.registerContextMenuListener=R;function y(E,b,P){const k=new v.Menu;return P.forEach(I=>{let p;I.type==="separator"?p=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?p=new v.MenuItem({submenu:y(E,b,I.submenu),label:I.label}):p=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(g,h,m)=>E.sender.send(b,I.id,m)}),k.append(p)}),k}}),define(ee[129],te([0,1,37,18,4,2,38,126]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function E(P,k){const I=D.Event.fromNodeEventEmitter(v.validatedIpcMain,k,(g,h)=>({event:g,message:h})),p=D.Event.filter(I,({event:g})=>g.sender.id===P);return D.Event.map(p,({message:g})=>g&&t.VSBuffer.wrap(g))}class b extends R.IPCServer{constructor(){super(b.getOnDidClientConnect())}static getOnDidClientConnect(){const k=D.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:I})=>I);return D.Event.map(k,I=>{const p=I.id,g=b.Clients.get(p);g&&g.dispose();const h=new D.Emitter;b.Clients.set(p,(0,L.toDisposable)(()=>h.fire()));const m=E(p,"vscode:message"),S=D.Event.any(D.Event.signal(E(p,"vscode:disconnect")),h.event);return{protocol:new y.Protocol(I,m),onDidClientDisconnect:S}})}}e.Server=b,b.Clients=new Map}),define(ee[91],te([0,1,37,4,31,127]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends L.Client{constructor(b,P){super({addEventListener:(k,I)=>b.addListener(k,I),removeEventListener:(k,I)=>b.removeListener(k,I),postMessage:k=>b.postMessage(k),start:()=>b.start(),close:()=>b.close()},P)}}e.Client=R;async function y(E){if(E.isDestroyed()||E.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const b=(0,D.generateUuid)();E.webContents.send("vscode:createMessageChannel",b);const P=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(I,p)=>({nonce:p,port:I.ports[0]})),{port:k}=await t.Event.toPromise(t.Event.once(t.Event.filter(P,I=>I.nonce===b)));return k}e.connect=y}),define(ee[92],te([0,1,9,4,2,11]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=e.StorageHint||(e.StorageHint={}));function y(k){const I=k;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var E;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(I,p=Object.create(null)){super();this.database=I,this.options=p,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((p,g)=>this.accept(g,p)),I.deleted?.forEach(p=>this.accept(p,void 0))}accept(I,p){if(this.state===E.Closed)return;let g=!1;(0,L.isUndefinedOrNull)(p)?g=this.cache.delete(I):this.cache.get(I)!==p&&(this.cache.set(I,p),g=!0),g&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,p){const g=this.cache.get(I);return(0,L.isUndefinedOrNull)(g)?p:g}getBoolean(I,p){const g=this.get(I);return(0,L.isUndefinedOrNull)(g)?p:g==="true"}getNumber(I,p){const g=this.get(I);return(0,L.isUndefinedOrNull)(g)?p:parseInt(g,10)}async set(I,p){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(p))return this.delete(I);const g=String(p);if(this.cache.get(I)!==g)return this.cache.set(I,g),this.pendingInserts.set(I,g),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===E.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((p,g)=>this.items.set(g,p)),I.delete&&I.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(ee[130],te([0,1,9,4,35,8,20]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(P,k=Object.create(null)){this.path=P,this.options=k,this.name=(0,L.basename)(this.path),this.logger=new E(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const P=await this.whenConnected,k=new Map;return(await this.all(P,"SELECT * FROM ItemTable")).forEach(p=>k.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(P){const k=await this.whenConnected;return this.doUpdateItems(k,P)}doUpdateItems(P,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,D.mapToString)(k.insert):"0"}), delete(${k.delete?(0,D.setToString)(k.delete):"0"})`),this.transaction(P,()=>{const I=k.insert,p=k.delete;if(I&&I.size>0){const g=[];g.push([]);let h=0;I.forEach((m,S)=>{let C=g[h];C.length>y.MAX_HOST_PARAMETERS&&(h++,C=[],g.push(C)),C.push(S,m)}),g.forEach(m=>{this.prepare(P,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,S=>S.run(m),()=>{const S=[];let C=0;return I.forEach((f,u)=>{S.push(u),C+=f.length}),`Keys: ${S.join(", ")} Length: ${C}`})})}if(p&&p.size){const g=[];g.push([]);let h=0;p.forEach(m=>{let S=g[h];S.length>y.MAX_HOST_PARAMETERS&&(h++,S=[],g.push(S)),S.push(m)}),g.forEach(m=>{this.prepare(P,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,S=>S.run(m),()=>{const S=[];return p.forEach(C=>{S.push(C)}),`Keys: ${S.join(", ")}`})})}})}async close(P){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,P)}doClose(P,k){return new Promise((I,p)=>{P.db.close(g=>(g&&this.handleSQLiteError(P,`[storage ${this.name}] close(): ${g}`),this.path===y.IN_MEMORY_PATH?I():!P.isErroneous&&!P.isInMemory?this.backup().then(I,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),I())):typeof k=="function"?R.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const m=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:k()}).then(()=>m(),S=>(m(),Promise.reject(S)))})).then(I,p):p(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const P=this.toBackupPath(this.path);return R.Promises.copy(this.path,P,{preserveSymlinks:!1})}toBackupPath(P){return`${P}.backup`}async checkIntegrity(P){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${P})`);const k=await this.whenConnected,I=await this.get(k,P?"PRAGMA integrity_check":"PRAGMA quick_check"),p=P?I.integrity_check:I.quick_check;return k.isErroneous?`${p} (last error: ${k.lastError})`:k.isInMemory?`${p} (in-memory!)`:p}async connect(P,k=!0){this.logger.trace(`[storage ${this.name}] open(${P}, retryOnBusy: ${k})`);try{return await this.doConnect(P)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&k)return await(0,v.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(P,!1);try{await R.Promises.unlink(P);try{await R.Promises.rename(this.toBackupPath(P),P)}catch{}return await this.doConnect(P)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(P,k){P.isErroneous=!0,P.lastError=k,this.logger.error(k)}doConnect(P){return new Promise((k,I)=>{new Promise((p,g)=>{j(["@vscode/sqlite3"],p,g)}).then(p=>{const g={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(P,h=>h?g.db?g.db.close(()=>I(h)):I(h):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(g),m=>g.db.close(()=>I(m)))),isInMemory:P===y.IN_MEMORY_PATH};g.db.on("error",h=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&g.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},I)})}exec(P,k){return new Promise((I,p)=>{P.db.exec(k,g=>g?(this.handleSQLiteError(P,`[storage ${this.name}] exec(): ${g}`),p(g)):I())})}get(P,k){return new Promise((I,p)=>{P.db.get(k,(g,h)=>g?(this.handleSQLiteError(P,`[storage ${this.name}] get(): ${g}`),p(g)):I(h))})}all(P,k){return new Promise((I,p)=>{P.db.all(k,(g,h)=>g?(this.handleSQLiteError(P,`[storage ${this.name}] all(): ${g}`),p(g)):I(h))})}transaction(P,k){return new Promise((I,p)=>{P.db.serialize(()=>{P.db.run("BEGIN TRANSACTION"),k(),P.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(P,`[storage ${this.name}] transaction(): ${g}`),p(g)):I())})})}prepare(P,k,I,p){const g=P.db.prepare(k),h=m=>{this.handleSQLiteError(P,`[storage ${this.name}] prepare(): ${m} (${k}). Details: ${p()}`)};g.on("error",h),I(g),g.finalize(m=>{m&&h(m),g.removeListener("error",h)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class E{constructor(P){P&&typeof P.logTrace=="function"&&process.env[E.VSCODE_TRACE_STORAGE]&&(this.logTrace=P.logTrace),P&&typeof P.logError=="function"&&(this.logError=P.logError)}get isTracing(){return!!this.logTrace}trace(P){this.logTrace&&this.logTrace(P)}error(P){this.logError&&this.logError(P)}}E.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[131],te([13,12]),function(j,e){return j.create("vs/base/common/date",e)}),define(ee[132],te([0,1,131]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,L=D*24,R=L*7,y=L*30,E=L*365;function b(k,I,p){typeof k!="number"&&(k=k.getTime());const g=Math.round((new Date().getTime()-k)/1e3);if(g<-30)return(0,v.localize)(0,null,b(new Date().getTime()+g*1e3,!1));if(g<30)return(0,v.localize)(1,null);let h;return g<t?(h=g,I?h===1?p?(0,v.localize)(2,null,h):(0,v.localize)(3,null,h):p?(0,v.localize)(4,null,h):(0,v.localize)(5,null,h):h===1?p?(0,v.localize)(6,null,h):(0,v.localize)(7,null,h):p?(0,v.localize)(8,null,h):(0,v.localize)(9,null,h)):g<D?(h=Math.floor(g/t),I?h===1?p?(0,v.localize)(10,null,h):(0,v.localize)(11,null,h):p?(0,v.localize)(12,null,h):(0,v.localize)(13,null,h):h===1?p?(0,v.localize)(14,null,h):(0,v.localize)(15,null,h):p?(0,v.localize)(16,null,h):(0,v.localize)(17,null,h)):g<L?(h=Math.floor(g/D),I?h===1?p?(0,v.localize)(18,null,h):(0,v.localize)(19,null,h):p?(0,v.localize)(20,null,h):(0,v.localize)(21,null,h):h===1?p?(0,v.localize)(22,null,h):(0,v.localize)(23,null,h):p?(0,v.localize)(24,null,h):(0,v.localize)(25,null,h)):g<R?(h=Math.floor(g/L),I?h===1?(0,v.localize)(26,null,h):(0,v.localize)(27,null,h):h===1?(0,v.localize)(28,null,h):(0,v.localize)(29,null,h)):g<y?(h=Math.floor(g/R),I?h===1?p?(0,v.localize)(30,null,h):(0,v.localize)(31,null,h):p?(0,v.localize)(32,null,h):(0,v.localize)(33,null,h):h===1?p?(0,v.localize)(34,null,h):(0,v.localize)(35,null,h):p?(0,v.localize)(36,null,h):(0,v.localize)(37,null,h)):g<E?(h=Math.floor(g/y),I?h===1?p?(0,v.localize)(38,null,h):(0,v.localize)(39,null,h):p?(0,v.localize)(40,null,h):(0,v.localize)(41,null,h):h===1?p?(0,v.localize)(42,null,h):(0,v.localize)(43,null,h):p?(0,v.localize)(44,null,h):(0,v.localize)(45,null,h)):(h=Math.floor(g/E),I?h===1?p?(0,v.localize)(46,null,h):(0,v.localize)(47,null,h):p?(0,v.localize)(48,null,h):(0,v.localize)(49,null,h):h===1?p?(0,v.localize)(50,null,h):(0,v.localize)(51,null,h):p?(0,v.localize)(52,null,h):(0,v.localize)(53,null,h))}e.fromNow=b;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ee[133],te([13,12]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(ee[39],te([0,1,26,11,133]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(k,I){return I&&(k.stack||k.stacktrace)?D.localize(0,null,y(k),R(k.stack)||R(k.stacktrace)):y(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function E(k=null,I=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const p=v.coalesce(k),g=E(p[0],I);return p.length>1?D.localize(4,null,g,p.length):g}if(t.isString(k))return k;if(k.detail){const p=k.detail;if(p.error)return L(p.error,I);if(p.exception)return L(p.exception,I)}return k.stack?L(k,I):k.message?k.message:D.localize(5,null)}e.toErrorMessage=E;function b(k){const I=k;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=b;function P(k,I){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=I,p}e.createErrorWithActions=P}),define(ee[134],te([13,12]),function(j,e){return j.create("vs/base/node/processes",e)}),define(ee[74],te([0,1,46,29,10,50,8,3,36,69,11,121,20,134]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function g(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(c,r){if(y.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};r&&(l.cwd=r);const i=v.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],l);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,s)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?g(l.status):1})}else if(y.isLinux||y.isMacintosh)try{const l=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{v.execFile(l,[c.pid.toString()],{encoding:"utf8",shell:!0},(n,o,s)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function m(c=E.env){return c.comspec||"cmd.exe"}e.getWindowsShell=m;class S{constructor(r,l,i,n){if(l!==void 0&&i!==void 0&&n!==void 0)this.cmd=r,this.args=l,this.shell=i,this.options=n;else{const o=r;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(s=>{o[s]=E.env[s]}),Object.keys(this.options.env).forEach(s=>{o[s]=this.options.env[s]}),this.options.env=o}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const l=r.lastIndexOf(R.sep);return l!==-1&&(r=r.substring(l+1)),S.WellKnowCommands[r]?r:"other"}start(r){return y.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(E.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(l=>{let i,n;const o=new Promise((s,a)=>{i=s,n=a});if(l){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=v.exec(s,this.options,(a,d,w)=>{this.childProcess=null;const M=a;M&&M.killed?n({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(i,r,a,d,w)})}else{let s=null;const a=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,i,r,n);const w={terminated:this.terminateRequested};P.isNumber(d)&&(w.cmdCode=d),i(w)};if(this.shell&&y.isWindows){const d=L.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,M=!1;const A=[];let F=this.ensureQuotes(this.cmd);A.push(F.value),w=F.quoted,this.args&&this.args.forEach(Y=>{F=this.ensureQuotes(Y),A.push(F.value),M=M&&F.quoted});const H=["/s","/c"];w?M?H.push('"'+A.join(" ")+'"'):A.length>1?H.push('"'+A[0]+'" '+A.slice(1).join(" ")):H.push('"'+A[0]+'"'):H.push(A.join(" ")),s=v.spawn(m(),H,d)}else this.cmd&&(s=v.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(P.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",d=>{this.childProcess=null,n({terminated:this.terminateRequested,error:d})}),s.pid&&(this.childProcess.on("close",a),this.handleSpawn(s,i,r,n,!0)))}return o})}handleClose(r,l,i,n){}ensureQuotes(r){return S.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,h(r,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!y.isWindows)return r(!1);const l=v.spawn(m(),["/s","/c"]);l.on("error",i=>r(!0)),l.on("exit",i=>r(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class C extends S{constructor(r,l,i,n){super(r,l,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,l,i,n,o){[n,o].forEach((s,a)=>{const d=new k.LineDecoder;d.write(s).forEach(A=>{l({line:A,source:a===0?0:1})});const M=d.end();M&&l({line:M,source:a===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,l,i,n,o){const s=new k.LineDecoder,a=new k.LineDecoder;r.stdout.on("data",d=>{s.write(d).forEach(M=>i({line:M,source:0}))}),r.stderr.on("data",d=>{a.write(d).forEach(M=>i({line:M,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=a}handleClose(r,l,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}}e.LineProcess=C;function f(c){let r=[],l=!1;const i=function(n){if(l){r.push(n);return}(!c.send(n,s=>{if(s&&console.error(s),l=!1,r.length>0){const a=r.slice(0);r=[],a.forEach(d=>i(d))}})||y.isWindows)&&(l=!0)};return{send:i}}e.createQueuedSender=f;var u;(function(c){async function r(l,i,n){if(R.isAbsolute(l))return l;if(i===void 0&&(i=E.cwd()),R.dirname(l)!=="."||(n===void 0&&P.isString(E.env.PATH)&&(n=E.env.PATH.split(R.delimiter)),n===void 0||n.length===0))return R.join(i,l);async function s(a){if(await I.Promises.exists(a)){let d;try{d=await I.Promises.stat(a)}catch(w){w.message.startsWith("EACCES")&&(d=await I.Promises.lstat(a))}return d?!d.isDirectory():!1}return!1}for(let a of n){let d;if(R.isAbsolute(a)?d=R.join(a,l):d=R.join(i,a,l),await s(d))return d;let w=d+".com";if(await s(w)||(w=d+".exe",await s(w)))return w}return R.join(i,l)}c.findExecutable=r})(u=e.win32||(e.win32={}))}),define(ee[135],te([0,1,27,3,124,74]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function R(p,g){return p===1?t.isWindows?k():L.getWindowsShell(g):b(p,g)}e.getSystemShell=R;function y(p,g){return p===1?t.isWindows?I(g):L.getWindowsShell(g):b(p,g)}e.getSystemShellSync=y;let E=null;function b(p,g){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!E){let h;if(t.isWindows)h="/bin/bash";else{if(h=g.SHELL,!h)try{h=(0,v.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}E=h}return E}let P=null;async function k(){return P||(P=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),P}function I(p){if(P)return P;const g=t.isWindows&&parseFloat((0,v.release)())>=10,h=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${p.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?m:L.getWindowsShell(p)}}),define(ee[136],te([0,1,46,9,18,23,116,15,4,2,50,74,69,38]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends p.ChannelServer{constructor(S){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",C=>D.VSBuffer.wrap(Buffer.from(C,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=g;class h{constructor(S,C){this.modulePath=S,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(S){const C=this;return{call(f,u,c){return C.requestPromise(S,f,u,c)},listen(f,u){return C.requestEvent(S,f,u)}}}requestPromise(S,C,f,u=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(S),r=(0,t.createCancelablePromise)(n=>c.call(C,f,n)),l=u.onCancellationRequested(()=>r.cancel()),i=(0,b.toDisposable)(()=>r.cancel());return this.activeRequests.add(i),r.finally(()=>{l.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(S,C,f){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let u;const c=new E.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(S).listen(C,f)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,I.removeDangerousEnvVariables)(C.env),this.child=(0,v.fork)(this.modulePath,S,C);const f=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,R.isRemoteConsoleLog)(o)){(0,R.log)(o,`IPC Library: ${this.options.serverName}`);return}f.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),l=f.event,i={send:r,onMessage:l};this._client=new p.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,b.dispose)(a)),this.activeRequests.clear(),o!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:s})})}return this._client}getCachedChannel(S){let C=this.channels.get(S);return C||(C=this.client.getChannel(S),this.channels.set(S,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ee[137],te([13,12]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(ee[138],te([13,12]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[139],te([13,12]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[140],te([13,12]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(ee[141],te([13,12]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(ee[142],te([13,12]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[143],te([13,12]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(ee[144],te([13,12]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(ee[145],te([13,12]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(ee[146],te([13,12]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[147],te([13,12]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[148],te([13,12]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[149],te([13,12]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[150],te([13,12]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[151],te([13,12]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(ee[152],te([13,12]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(ee[153],te([13,12]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[154],te([13,12]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[155],te([13,12]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(ee[156],te([13,12]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[157],te([13,12]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(ee[158],te([13,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[159],te([13,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[160],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(D){return D&&D.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(D){return D&&D.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[161],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(ee[162],te([0,1,4,2]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(y,E,b){switch(E){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(y,E,b){switch(E){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class L extends t.Disposable{constructor(y){super();this.channel=y}reload(y){this.channel.call("reload",[y])}get onReload(){return this.channel.listen("reload")}close(y){this.channel.call("close",[y])}get onClose(){return this.channel.listen("close")}attachSession(y,E,b){this.channel.call("attach",[y,E,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(y,E){this.channel.call("terminate",[y,E])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(y,E){return this.channel.call("openExtensionDevelopmentHostWindow",[y,E])}}e.ExtensionHostDebugChannelClient=L}),define(ee[163],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(D){this.machineId=D}encryption(){return new Promise((D,L)=>j(["vscode-encrypt"],D,L))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=v}),define(ee[164],te([0,1,132,48,10,8,36,16,7]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(h,m,S){this._args=h,this.paths=m,this.productService=S}get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,y.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=R.env.VSCODE_PORTABLE;return h?E.URI.file((0,L.join)(h,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,y.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.resolve)(h):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,L.resolve)(h):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.resolve)(h);const m=R.env.VSCODE_EXTENSIONS;if(m)return m;const S=R.env.VSCODE_PORTABLE;return S?(0,L.join)(S,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?E.URI.parse(m):E.URI.file((0,L.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?E.URI.parse(h):E.URI.file((0,L.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([t.memoize],b.prototype,"appRoot",null),he([t.memoize],b.prototype,"userHome",null),he([t.memoize],b.prototype,"userDataPath",null),he([t.memoize],b.prototype,"appSettingsHome",null),he([t.memoize],b.prototype,"tmpDir",null),he([t.memoize],b.prototype,"cacheHome",null),he([t.memoize],b.prototype,"userRoamingDataHome",null),he([t.memoize],b.prototype,"settingsResource",null),he([t.memoize],b.prototype,"userDataSyncHome",null),he([t.memoize],b.prototype,"userDataSyncLogResource",null),he([t.memoize],b.prototype,"sync",null),he([t.memoize],b.prototype,"machineSettingsResource",null),he([t.memoize],b.prototype,"globalStorageHome",null),he([t.memoize],b.prototype,"workspaceStorageHome",null),he([t.memoize],b.prototype,"localHistoryHome",null),he([t.memoize],b.prototype,"keybindingsResource",null),he([t.memoize],b.prototype,"keyboardLayoutResource",null),he([t.memoize],b.prototype,"argvResource",null),he([t.memoize],b.prototype,"snippetsHome",null),he([t.memoize],b.prototype,"isExtensionDevelopment",null),he([t.memoize],b.prototype,"untitledWorkspacesHome",null),he([t.memoize],b.prototype,"installSourcePath",null),he([t.memoize],b.prototype,"builtinExtensionsPath",null),he([t.memoize],b.prototype,"extensionsPath",null),he([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([t.memoize],b.prototype,"extensionDevelopmentKind",null),he([t.memoize],b.prototype,"extensionTestsLocationURI",null),he([t.memoize],b.prototype,"debugExtensionHost",null),he([t.memoize],b.prototype,"serviceMachineIdResource",null),he([t.memoize],b.prototype,"telemetryLogResource",null),he([t.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function P(g,h){return p(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=P;function k(g,h){return p(g["inspect-search"],g["inspect-brk-search"],5876,h,g.extensionEnvironment)}e.parseSearchPort=k;function I(g,h){return p(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,h,g.extensionEnvironment)}e.parsePtyHostPort=I;function p(g,h,m,S,C,f){const c=Number(h||g)||(S?null:m),r=c?Boolean(!!h):!1;let l;if(f)try{l=JSON.parse(f)}catch{}return{port:c,break:r,debugId:C,env:l}}}),define(ee[93],te([0,1,241,3,140]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function y(g,h,m=R){const S={},C=["_"],f=[];for(let l in h){const i=h[l];i.alias&&(S[l]=i.alias),i.type==="string"||i.type==="string[]"?(C.push(l),i.deprecates&&C.push(...i.deprecates)):i.type==="boolean"&&(f.push(l),i.deprecates&&f.push(...i.deprecates))}const u=v(g,{string:C,boolean:f,alias:S}),c={},r=u;c._=u._.map(l=>String(l)).filter(l=>l.length>0),delete r._;for(let l in h){const i=h[l];i.alias&&delete r[i.alias];let n=r[l];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(n||(n=r[o],n&&m.onDeprecatedOption(o,i.deprecationMessage||(0,D.localize)(33,null,l))),delete r[o]);typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),m.onMultipleValues(l,n)),c[l]=n,i.deprecationMessage&&m.onDeprecatedOption(l,i.deprecationMessage)),delete r[l]}for(let l in r)m.onUnknownOption(l);return c}e.parseArgs=y;function E(g,h){let m="";return h.args&&(Array.isArray(h.args)?m=` <${h.args.join("> <")}>`:m=` <${h.args}>`),h.alias?`-${h.alias} --${g}${m}`:`--${g}${m}`}function b(g,h){let m=0,S=[];for(const c in g){const r=g[c],l=E(c,r);m=Math.max(m,l.length),S.push([l,r.description])}let C=m+2+1;if(h-C<25)return S.reduce((c,r)=>c.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let f=h-C-1,u=[];for(const c of S){let r=c[0],l=k(c[1],f),i=P(C-r.length-2);u.push("  "+r+i+l[0]);for(let n=1;n<l.length;n++)u.push(P(C)+l[n])}return u}e.formatOptions=b;function P(g){return" ".repeat(g)}function k(g,h){let m=[];for(;g.length;){let S=g.length<h?g.length:g.lastIndexOf(" ",h),C=g.slice(0,S).trim();g=g.slice(S),m.push(C)}return m}function I(g,h,m,S,C){const f=process.stdout.isTTY&&process.stdout.columns||80,u=C?.noInputFiles!==!0?`[${(0,D.localize)(34,null)}...]`:"",c=[`${g} ${m}`];c.push(""),c.push(`${(0,D.localize)(35,null)}: ${h} [${(0,D.localize)(36,null)}]${u}`),c.push(""),C?.noPipe!==!0&&(t.isWindows?c.push((0,D.localize)(37,null,h)):c.push((0,D.localize)(38,null,h)),c.push(""));const r={};for(const l in S){const i=S[l];if(i.description&&i.cat){let n=r[i.cat];n||(r[i.cat]=n={}),n[l]=i}}for(let l in r){const i=l;let n=r[i];n&&(c.push(L[i]),c.push(...b(n,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=I;function p(g,h){return`${g||(0,D.localize)(39,null)}
${h||(0,D.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(ee[165],te([0,1,61,162,93]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends t.ExtensionHostDebugBroadcastChannel{constructor(y){super();this.windowsMainService=y}call(y,E,b){return E==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(b[0],b[1]):super.call(y,E,b)}async openExtensionDevelopmentHostWindow(y,E){const b=(0,D.parseArgs)(y,D.OPTIONS);b.debugRenderer=E;const P=b.extensionDevelopmentPath;if(!P)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:b});if(!E)return{success:!0};const I=k.win;if(!I)return{success:!0};const p=I.webContents.debugger;let g=p.isAttached()?1/0:0;const h=(0,v.createServer)(m=>{g++==0&&p.attach();let S=!1;const C=c=>{S||m.write(JSON.stringify(c)+"\0")},f=(c,r,l,i)=>C({method:r,params:l,sessionId:i});I.on("close",()=>{p.removeListener("message",f),m.end(),S=!0}),p.addListener("message",f);let u=Buffer.alloc(0);m.on("data",c=>{u=Buffer.concat([u,c]);for(let r=u.indexOf(0);r!==-1;r=u.indexOf(0)){let l;try{const i=u.slice(0,r).toString("utf8");u=u.slice(r+1),l=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}p.sendCommand(l.method,l.params,l.sessionId).then(i=>C({id:l.id,sessionId:l.sessionId,result:i})).catch(i=>C({id:l.id,sessionId:l.sessionId,error:{code:0,message:i.message}}))}}),m.on("error",c=>{console.error("error on cdp pipe:",c)}),m.on("close",()=>{S=!0,--g==0&&p.detach()})});return await new Promise(m=>h.listen(0,m)),I.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(ee[51],te([0,1,242,141,93]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function R(I,p){const g={onUnknownOption:m=>{console.warn((0,t.localize)(0,null,m))},onMultipleValues:(m,S)=>{console.warn((0,t.localize)(1,null,m,S))},onDeprecatedOption:(m,S)=>{console.warn((0,t.localize)(2,null,m,S))}},h=(0,D.parseArgs)(I,D.OPTIONS,p?g:void 0);return h.goto&&h._.forEach(m=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,t.localize)(3,null))),h["max-memory"]&&v(parseInt(h["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),h}function y(I){const p=I.findIndex(g=>!/^-/.test(g));if(p>-1)return[...I.slice(0,p),...I.slice(p+1)]}function E(I){let[,...p]=I;process.env.VSCODE_DEV&&(p=y(p)||[]);const g=!k(process.env);return R(p,g)}e.parseMainProcessArgv=E;function b(I){const[,,...p]=I;return R(p,!0)}e.parseCLIProcessArgv=b;function P(I,...p){const g=I.indexOf("--");return g===-1?I.push(...p):I.splice(g,0,...p),I}e.addArg=P;function k(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function j(e,v,t,D){function L(y){const E=R(y),b=[E];return e.isAbsolute(E)||b.unshift(D),e.resolve(...b)}function R(y){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,t);const P=y["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(k,"AppData","Roaming")}break;case"darwin":b=e.join(v.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,t)}return{getUserDataPath:L}}if(typeof define=="function")define(ee[94],te([0,243,27,10,16,36]),function(e,v,t,D,L,R){const y=L.dirname(D.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(L.joinPath(y,"package.json").fsPath);return j(v,t,E.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=j(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[166],te([0,1,27,164,94]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(y,E){super(y,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(y)},E)}}e.NativeEnvironmentService=L}),define(ee[167],te([0,1,30,27,29]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function L(R){const y=(0,D.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(y,""),R&&console.log(`Marker file for --wait created: ${y}`),y}catch(E){R&&console.error(`Failed to create marker file for --wait: ${E}`);return}}e.createWaitMarkerFile=L}),define(ee[168],te([0,1,18,31]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,R,y){let E=y&&y.get("storage.serviceMachineId",0)||null;if(E)return E;try{const P=(await R.readFile(L.serviceMachineIdResource)).value.toString();E=(0,t.isUUID)(P)?P:null}catch{E=null}if(!E){E=(0,t.generateUuid)();try{await R.writeFile(L.serviceMachineIdResource,v.VSBuffer.fromString(E))}catch{}}return y&&y.store("storage.serviceMachineId",E,0,1),E}e.getServiceMachineId=D}),define(ee[75],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,L=[],R=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=v}),define(ee[169],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=v;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let R of this._nodes.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const y=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);y.outgoing.set(this._hashFn(R),E),E.incoming.set(this._hashFn(L),y)}removeNode(L){const R=this._hashFn(L);this._nodes.delete(R);for(let y of this._nodes.values())y.outgoing.delete(R),y.incoming.delete(R)}lookupOrInsertNode(L){const R=this._hashFn(L);let y=this._nodes.get(R);return y||(y=new v(L),this._nodes.set(R,y)),y}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[R,y]of this._nodes)L.push(`${R}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,R]of this._nodes){const y=new Set([L]),E=this._findCycle(R,y);if(E)return E}}_findCycle(L,R){for(let[y,E]of L.outgoing){if(R.has(y))return[...R,y].join(" -> ");R.add(y);const b=this._findCycle(E,R);if(b)return b;R.delete(y)}}}e.Graph=t}),define(ee[5],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function y(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(R,y,E){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:R,index:E}):(y[v.DI_DEPENDENCIES]=[{id:R,index:E}],y[v.DI_TARGET]=y)}function D(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const y=function(E,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,E,P)};return y.toString=()=>R,v.serviceIds.set(R,y),y}e.createDecorator=D;function L(R){return R}e.refineServiceDecorator=L}),define(ee[52],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(ee[17],te([0,1,11,7,5]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(S){return S&&typeof S=="object"&&(!S.overrideIdentifier||typeof S.overrideIdentifier=="string")&&(!S.resource||S.resource instanceof t.URI)}e.isConfigurationOverrides=L;function R(S){return S&&typeof S=="object"&&(!S.overrideIdentifiers||v.isArray(S.overrideIdentifiers))&&!S.overrideIdentifier&&(!S.resource||S.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=R;var y;(function(S){S[S.USER=1]="USER",S[S.USER_LOCAL=2]="USER_LOCAL",S[S.USER_REMOTE=3]="USER_REMOTE",S[S.WORKSPACE=4]="WORKSPACE",S[S.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",S[S.DEFAULT=6]="DEFAULT",S[S.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(S){switch(S){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(S,C){const f=Object.create(null);for(let u in S)P(f,u,S[u],C);return f}e.toValuesTree=b;function P(S,C,f,u){const c=C.split("."),r=c.pop();let l=S;for(let i=0;i<c.length;i++){let n=c[i],o=l[n];switch(typeof o){case"undefined":o=l[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${C} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}l=o}if(typeof l=="object"&&l!==null)try{l[r]=f}catch{u(`Ignoring ${C} as ${c.join(".")} is ${JSON.stringify(l)}`)}else u(`Ignoring ${C} as ${c.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=P;function k(S,C){const f=C.split(".");I(S,f)}e.removeFromValueTree=k;function I(S,C){const f=C.shift();if(C.length===0){delete S[f];return}if(Object.keys(S).indexOf(f)!==-1){const u=S[f];typeof u=="object"&&!Array.isArray(u)&&(I(u,C),Object.keys(u).length===0&&delete S[f])}}function p(S,C,f){function u(l,i){let n=l;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const c=C.split("."),r=u(S,c);return typeof r=="undefined"?f:r}e.getConfigurationValue=p;function g(S,C,f){Object.keys(C).forEach(u=>{u!=="__proto__"&&(u in S?v.isObject(S[u])&&v.isObject(C[u])?g(S[u],C[u],f):f&&(S[u]=C[u]):S[u]=C[u])})}e.merge=g;function h(S,C,f){const u=S.inspect(C),c=S.inspect(f);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=h;function m(S){return S.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(ee[62],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(L,R){return this.secretVault[L]?.[R]??null}async setPassword(L,R,y){this.secretVault[L]=this.secretVault[L]??{},this.secretVault[L][R]=y}async deletePassword(L,R){return this.secretVault[L]?.[R]?(delete this.secretVault[L][R],Object.keys(this.secretVault[L]).length===0&&delete this.secretVault[L],!0):!1}async findPassword(L){return JSON.stringify(this.secretVault[L])??null}async findCredentials(L){const R=[];for(const y of Object.keys(this.secretVault[L]||{}))R.push({account:y,password:this.secretVault[L][y]});return R}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ee[76],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(R,y){return{}}async getSystemInfo(R,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,y){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=D}),define(ee[95],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(ee[53],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[170],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(ee[171],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[96],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(ee[172],te([0,1,46,10,8,3,69,20,74,142,96]),function(j,e,v,t,D,L,R,y,E,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=b.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends I{openTerminal(u,c){return this.spawnTerminal(v,u,E.getWindowsShell(),c)}spawnTerminal(u,c,r,l){const i=c.windowsExec||p.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const n=D.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((s,a)=>{const d=m(process),w=u.spawn(r,o,{cwd:l,env:d});w.on("error",a),w.on("exit",()=>s())})}runInTerminal(u,c,r,l,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:p.getDefaultTerminalWindows();return new Promise((o,s)=>{const a=`"${c} - ${k}"`,d=`""${r.join('" "')}" & pause"`,w=["/c","start",a,"/wait",n,"/c",d],M=Object.assign({},m(process),l);Object.keys(M).filter(H=>M[H]===null).forEach(H=>delete M[H]);const A={cwd:c,env:M,windowsVerbatimArguments:!0};v.spawn(p.CMD,w,A).on("error",H=>{s(S(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class g extends I{openTerminal(u,c){return this.spawnTerminal(v,u,c)}runInTerminal(u,c,r,l,i){const n=i.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((o,s)=>{if(n===P.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const a=n===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,j).fsPath,"-t",u||k,"-w",c];for(let F of r)w.push("-a"),w.push(F);if(l){const F=Object.assign({},m(process),l);for(let H in F){const Y=F[H];Y===null?(w.push("-u"),w.push(H)):(w.push("-e"),w.push(`${H}=${Y}`))}}let M="";const A=v.spawn(g.OSASCRIPT,w);A.on("error",F=>{s(S(F))}),A.stderr.on("data",F=>{M+=F.toString()}),A.on("exit",F=>{if(F===0)o(void 0);else if(M){const H=M.split(`
`,1);s(new Error(H[0]))}else s(new Error(b.localize(1,null,a,F)))})}else s(new Error(b.localize(2,null,n)))})}spawnTerminal(u,c,r){const l=c.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",l];r&&o.push(r);const s=m(process),a=u.spawn("/usr/bin/open",o,{cwd:r,env:s});a.on("error",n),a.on("exit",()=>i())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class h extends I{openTerminal(u,c){return this.spawnTerminal(v,u,c)}runInTerminal(u,c,r,l,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((o,s)=>{let a=[];n.then(d=>{d.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const w=`${C(r)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;a.push(`''${w}''`);const M=Object.assign({},m(process),l);Object.keys(M).filter(Y=>M[Y]===null).forEach(Y=>delete M[Y]);const A={cwd:c,env:M};let F="";const H=v.spawn(d,a,A);H.on("error",Y=>{s(S(Y))}),H.stderr.on("data",Y=>{F+=Y.toString()}),H.on("exit",Y=>{if(Y===0)o(void 0);else if(F){const ie=F.split(`
`,1);s(new Error(ie[0]))}else s(new Error(b.localize(4,null,d,Y)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await y.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,r){const l=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{l.then(o=>{const s=m(process),a=u.spawn(o,[],{cwd:r,env:s});a.on("error",n),a.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=b.localize(3,null);function m(f){const u={...f.env};return(0,R.sanitizeProcessEnvironment)(u),u}function S(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(b.localize(5,null,f.path)):f}function C(f){let u="";for(let c of f)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(ee[21],te([0,1,15,35,8,28,11,7,144,5]),function(j,e,v,t,D,L,R,y,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function P(V){return V.create===!0}e.isFileOpenForWriteOptions=P;var k;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var I;(function(V){V[V.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var p;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=g;function h(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=h;function m(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=m;function S(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function C(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=C;function f(V){return g(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var u;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(B,$){super(B);this.code=$}}e.FileSystemProviderError=c;function r(V,B){const $=new c(V.toString(),B);return i($,B),$}e.createFileSystemProviderError=r;function l(V){return V||r((0,E.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=l;function i(V,B){return V.name=B?`${B} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=i;function n(V){if(!V)return u.Unknown;if(V instanceof c)return V.code;const B=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!B)return u.Unknown;switch(B[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function o(V){if(V instanceof A)return V.fileOperationResult;switch(n(V)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(B,$,Q){this.resource=B,this.operation=$,this.target=Q}isOperation(B){return this.operation===B}}e.FileOperationEvent=a;var d;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class w{constructor(B,$){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const Q=new Map;for(const q of B){const J=Q.get(q.type);switch(J?J.push([q.resource,q]):Q.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,J]of Q)switch(q){case 1:this.added=t.TernarySearchTree.forUris(()=>$),this.added.fill(J);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>$),this.updated.fill(J);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>$),this.deleted.fill(J);break}}contains(B,...$){return this.doContains(B,{includeChildren:!1},...$)}affects(B,...$){return this.doContains(B,{includeChildren:!0},...$)}doContains(B,$,...Q){if(!B)return!1;const q=Q.length>0;return!!((!q||Q.includes(1))&&(this.added?.get(B)||$.includeChildren&&this.added?.findSuperstr(B))||(!q||Q.includes(0))&&(this.updated?.get(B)||$.includeChildren&&this.updated?.findSuperstr(B))||(!q||Q.includes(2))&&(this.deleted?.findSubstr(B)||$.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=w;function M(V,B,$){return!V||!B||V===B||B.length>V.length?!1:(B.charAt(B.length-1)!==D.sep&&(B+=D.sep),$?(0,L.startsWithIgnoreCase)(V,B):V.indexOf(B)===0)}e.isParent=M;class A extends v.ErrorNoTelemetry{constructor(B,$,Q){super(B);this.fileOperationResult=$,this.options=Q}}e.FileOperationError=A;class F extends A{constructor(B,$,Q){super(B,2,Q);this.stat=$}}e.NotModifiedSinceFileOperationError=F;var H;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(H=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Y;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ie(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=ie;async function X(V,B){if(!B.hasProvider(y.URI.from({scheme:V.scheme})))return new Promise($=>{const Q=B.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===V.scheme&&q.added&&(Q.dispose(),$())})})}e.whenProviderRegistered=X,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(B){return(0,R.isNumber)(B)||(B=0),B<z.KB?(0,E.localize)(1,null,B.toFixed(0)):B<z.MB?(0,E.localize)(2,null,(B/z.KB).toFixed(2)):B<z.GB?(0,E.localize)(3,null,(B/z.MB).toFixed(2)):B<z.TB?(0,E.localize)(4,null,(B/z.GB).toFixed(2)):(0,E.localize)(5,null,(B/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var x;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function Z(V){return{maxFileSize:V===0?300*z.MB:16*z.GB,maxHeapSize:V===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=Z}),define(ee[173],te([0,1,18,39,15,4,2,49,7,31,21]),function(j,e,v,t,D,L,R,y,E,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends R.Disposable{constructor(p,g){super();this.channel=p,this.extraCapabilities=g,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,g){const{buffer:h}=await this.channel.call("readFile",[p,g]);return h}readFileStream(p,g,h){const m=(0,y.newWriteableStream)(C=>v.VSBuffer.concat(C.map(f=>v.VSBuffer.wrap(f))).buffer),S=this.channel.listen("readFileStream",[p,g])(C=>{if(C instanceof v.VSBuffer)m.write(C.buffer);else{if(C==="end")m.end();else{let f=C;f instanceof Error||(f=(0,P.createFileSystemProviderError)((0,t.toErrorMessage)(f),P.FileSystemProviderErrorCode.Unknown)),m.error(f),m.end()}S.dispose()}});return h.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),S.dispose()}),m}writeFile(p,g,h){return this.channel.call("writeFile",[p,v.VSBuffer.wrap(g),h])}open(p,g){return this.channel.call("open",[p,g])}close(p){return this.channel.call("close",[p])}async read(p,g,h,m,S){const[C,f]=await this.channel.call("read",[p,g,S]);return h.set(C.buffer.slice(0,f),m),f}write(p,g,h,m,S){return this.channel.call("write",[p,g,v.VSBuffer.wrap(h),m,S])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,g){return this.channel.call("delete",[p,g])}rename(p,g,h){return this.channel.call("rename",[p,g,h])}copy(p,g,h){return this.channel.call("copy",[p,g,h])}cloneFile(p,g){return this.channel.call("cloneFile",[p,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const g=p;this._onDidChange.fire(g.map(h=>({resource:E.URI.revive(h.resource),type:h.type})))}else{const g=p;this._onDidWatchError.fire(g)}}))}watch(p,g){const h=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,h,p,g]),(0,R.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=k}),define(ee[97],te([0,1,18,15,145,21]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(P,k,I,p,g,h){let m;try{await y(P,k,I,p,g,h)}catch(S){m=S}finally{m&&g.errorTransformer&&(m=g.errorTransformer(m)),typeof m!="undefined"&&I.error(m),I.end()}}e.readFileIntoStream=R;async function y(P,k,I,p,g,h){E(h);const m=await P.open(k,{create:!1});try{E(h);let S=0,C=0,f=g&&typeof g.length=="number"?g.length:void 0,u=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof f=="number"?f:g.bufferSize)),c=g&&typeof g.position=="number"?g.position:0,r=0;do C=await P.read(m,c,u.buffer,r,u.byteLength-r),c+=C,r+=C,S+=C,typeof f=="number"&&(f-=C),r===u.byteLength&&(await I.write(p(u)),u=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof f=="number"?f:g.bufferSize)),r=0);while(C>0&&(typeof f!="number"||f>0)&&E(h)&&b(S,g));if(r>0){let l=r;typeof f=="number"&&(l=Math.min(r,f)),I.write(p(u.slice(0,l)))}}catch(S){throw(0,L.ensureFileSystemProviderError)(S)}finally{await P.close(m)}}function E(P){if(P.isCancellationRequested)throw(0,t.canceled)();return!0}function b(P,k){if(k?.limits){if(typeof k.limits.memory=="number"&&P>k.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&P>k.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[63],te([0,1,86,2,8,3,7,21]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(m){return m.recursive===!0}e.isRecursiveWatchRequest=E;class b extends t.Disposable{constructor(S,C,f,u){super();this.onFileChanges=S,this.onLogMessage=C,this.verboseLogging=f,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(C=>this.onFileChanges(C))),S.add(this.watcher.onDidLogMessage(C=>this.onLogMessage(C))),S.add(this.watcher.onDidError(C=>this.onError(C)))}onError(S){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class P extends b{constructor(S,C,f){super(S,C,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class k extends b{constructor(S,C,f){super(S,C,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function I(m){return m.map(S=>({type:S.type,resource:R.URI.file(S.path)}))}e.toFileChanges=I;function p(m){const S=new h;for(const C of m)S.processEvent(C);return S.coalesce()}e.coalesceEvents=p;function g(m,S){const C=[];for(const f of S){let u=f;typeof u=="string"&&!u.startsWith(v.GLOBSTAR)&&!(0,D.isAbsolute)(u)&&(u={base:m,pattern:u}),C.push((0,v.parse)(u))}return C}e.parseWatcherPatterns=g;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return L.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const C=this.mapPathToChange.get(this.toKey(S));let f=!1;if(C){const u=C.type,c=S.type;C.path!==S.path&&(S.type===2||S.type===1)?f=!0:u===1&&c===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(C)):u===2&&c===1?C.type=0:u===1&&c===0||(C.type=c)}else f=!0;f&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],C=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(S.push(f),!1):!0).sort((f,u)=>f.path.length-u.path.length).filter(f=>C.some(u=>(0,y.isParent)(f.path,u,!L.isLinux))?!1:(C.push(f.path),!0)).concat(S)}}}),define(ee[174],te([0,1,30,9,23,29,2,72,8,3,87,20,63]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends R.Disposable{constructor(m,S,C,f){super();this.request=m,this.onDidFilesChange=S,this.onLogMessage=C,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(p.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,I.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,I.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const S=await k.Promises.stat(m);this._register(await this.doWatch(m,S.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let S=m.path;try{S=await k.Promises.realpath(m.path),m.path===S&&(S=await(0,P.realcase)(m.path)??m.path),m.path!==S&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${S})`)}catch{}return S}async doWatch(m,S){if(b.isMacintosh&&(0,L.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const C=new D.CancellationTokenSource(this.cts.token);let f=new R.DisposableStore;try{const u=(0,E.basename)(m),c=(0,v.watch)(m);f.add((0,R.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${m}'`);const r=new Set;if(S)try{for(const i of await k.Promises.readdir(m))r.add(i)}catch(i){this.error(i)}const l=new Map;f.add((0,R.toDisposable)(()=>{for(const[,i]of l)i.dispose();l.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(C.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),b.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(S)if(i==="rename"){l.get(o)?.dispose();const s=setTimeout(async()=>{if(l.delete(o),o===u&&!await k.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,E.join)(m,o));if(C.token.isCancellationRequested)return;let d;a?r.has(o)?d=0:(d=1,r.add(o)):(r.delete(o),d=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:d})},p.FILE_DELETE_HANDLER_DELAY);l.set(o,(0,R.toDisposable)(()=>clearTimeout(s)))}else{let s;r.has(o)?s=0:(s=1,r.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:s})}else if(i==="rename"||o!==u){const s=setTimeout(async()=>{const a=await k.Promises.exists(m);C.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},p.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,R.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await k.Promises.exists(m)&&!C.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${u.toString()})`)}return(0,R.toDisposable)(()=>{C.dispose(!0),f.dispose()})}async onFileChange(m,S=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!S&&this.excludes.some(C=>C(m.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${m.path}`):!S&&this.includes&&this.includes.length>0&&!this.includes.some(C=>C(m.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const C=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,I.coalesceEvents)(C);if(f.length>0){if(this.verboseLogging)for(const c of f)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(b.isLinux)return k.Promises.exists(m);try{const S=(0,E.basename)(m);return(await k.Promises.readdir((0,E.dirname)(m))).some(f=>f===S)}catch(S){return this.trace(S),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.FILE_DELETE_HANDLER_DELAY=100,p.FILE_CHANGES_HANDLER_DELAY=50;async function g(h,m,S,C,f=512){const u=await k.Promises.open(h,"r"),c=Buffer.allocUnsafe(f),r=new D.CancellationTokenSource(C);let l,i=!1;const n={path:h,excludes:[],recursive:!1},o=new p(n,s=>{(async()=>{for(const{type:a}of s)if(a===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:d}=await k.Promises.read(u,c,0,f,null);if(!d||r.token.isCancellationRequested)break;m(c.slice(0,d))}}catch(d){l=new Error(d),r.dispose(!0)}finally{i=!1}}})()});return await o.ready,S(),new Promise((s,a)=>{r.token.onCancellationRequested(async()=>{o.dispose();try{await k.Promises.close(u)}catch(d){l=new Error(d)}l?a(l):s()})})}e.watchFileContents=g}),define(ee[175],te([0,1,4,86,2,3,174]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const P=this.normalizeRequests(b),k=P.filter(p=>{const g=this.watchers.get(p.path);return g?!(0,t.patternsEquals)(g.request.excludes,p.excludes)||!(0,t.patternsEquals)(g.request.includes,p.includes):!0}),I=Array.from(this.watchers.values()).filter(({request:p})=>!P.find(g=>g.path===p.path&&(0,t.patternsEquals)(g.excludes,p.excludes)&&(0,t.patternsEquals)(g.includes,p.includes))).map(({request:p})=>p.path);k.length&&this.trace(`Request to start watching: ${k.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?p.includes:"<all>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const p of I)this.stopWatching(p);for(const p of k)this.startWatching(p)}startWatching(b){const P=new R.NodeJSFileWatcherLibrary(b,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),k={request:b,instance:P};this.watchers.set(b.path,k)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const P=this.watchers.get(b);P&&(this.watchers.delete(b),P.instance.dispose())}normalizeRequests(b){const P=new Map;for(const k of b){const I=L.isLinux?k.path:k.path.toLowerCase();P.set(I,k)}return Array.from(P.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,P]of this.watchers)P.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,P){return P?`[File Watcher (node.js)] ${b} (path: ${P.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=y}),define(ee[176],te([0,1,63,175]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends v.AbstractNonRecursiveWatcherClient{constructor(R,y,E){super(R,y,E);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ee[177],te([0,1,10,38,136,63]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends L.AbstractUniversalWatcherClient{constructor(E,b,P){super(E,b,P);this.init()}createWatcher(E){const b=E.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:P,signal:k})=>this.onError(`terminated by itself with code ${P}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ee[77],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[L,R]of D)this.set(L,R)}set(D,L){const R=this._entries.get(D);return this._entries.set(D,L),R}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(ee[178],te([0,1,9,15,75,169,5,77]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class P{constructor(g=new y.ServiceCollection,h=!1,m){this._activeInstantiations=new Set,this._services=g,this._strict=h,this._parent=m,this._services.set(R.IInstantiationService,this)}createChild(g){return new P(g,this._strict,this)}invokeFunction(g,...h){let m=I.traceInvocation(g),S=!1;try{return g({get:f=>{if(S)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(f,m);if(!u)throw new Error(`[invokeFunction] unknown service '${f}'`);return u}},...h)}finally{S=!0,m.stop()}}createInstance(g,...h){let m,S;return g instanceof D.SyncDescriptor?(m=I.traceCreation(g.ctor),S=this._createInstance(g.ctor,g.staticArguments.concat(h),m)):(m=I.traceCreation(g),S=this._createInstance(g,h,m)),m.stop(),S}_createInstance(g,h=[],m){let S=R._util.getServiceDependencies(g).sort((u,c)=>u.index-c.index),C=[];for(const u of S){let c=this._getOrCreateServiceInstance(u.id,m);c||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${u.id}.`,!1),C.push(c)}let f=S.length>0?S[0].index:h.length;if(h.length!==f){console.trace(`[createInstance] First service dependency of ${g.name} at position ${f+1} conflicts with ${h.length} static arguments`);let u=f-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,f)}return new g(...[...h,...C])}_setServiceInstance(g,h){if(this._services.get(g)instanceof D.SyncDescriptor)this._services.set(g,h);else if(this._parent)this._parent._setServiceInstance(g,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let h=this._services.get(g);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):h}_getOrCreateServiceInstance(g,h){let m=this._getServiceInstanceOrDescriptor(g);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,m,h.branch(g,!0)):(h.branch(g,!1),m)}_safeCreateAndCacheServiceInstance(g,h,m){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,h,m)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,h,m){const S=new L.Graph(u=>u.id.toString());let C=0;const f=[{id:g,desc:h,_trace:m}];for(;f.length;){const u=f.pop();if(S.lookupOrInsertNode(u),C++>1e3)throw new b(S);for(let c of R._util.getServiceDependencies(u.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(c.id);if(r||this._throwIfStrict(`[createInstance] ${g} depends on ${c.id} which is NOT registered.`,!0),r instanceof D.SyncDescriptor){const l={id:c.id,desc:r,_trace:u._trace.branch(c.id,!0)};S.insertEdge(u,l),f.push(l)}}}for(;;){const u=S.roots();if(u.length===0){if(!S.isEmpty())throw new b(S);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}S.removeNode(c)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,h,m=[],S,C){if(this._services.get(g)instanceof D.SyncDescriptor)return this._createServiceInstance(h,m,S,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,h,m,S,C);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(g,h=[],m,S){if(m){const C=new v.IdleValue(()=>this._createInstance(g,h,S));return new Proxy(Object.create(null),{get(f,u){if(u in f)return f[u];let c=C.value,r=c[u];return typeof r!="function"||(r=r.bind(c),f[u]=r),r},set(f,u,c){return C.value[u]=c,!0}})}else return this._createInstance(g,h,S)}_throwIfStrict(g,h){if(h&&console.warn(h),this._strict)throw new Error(g)}}e.InstantiationService=P;var k;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(k||(k={}));class I{constructor(g,h){this.type=g,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return E?new I(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(g){return E?new I(0,g.name):I._None}branch(g,h){let m=new I(2,g.toString());return this._dep.push([g,h,m]),m}stop(){let g=Date.now()-this._start;I._totals+=g;let h=!1;function m(C,f){let u=[],c=new Array(C+1).join("	");for(const[r,l,i]of f._dep)if(l&&i){h=!0,u.push(`${c}CREATES -> ${r}`);let n=m(C+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${r}`);return u.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(g>2||h)&&console.log(S.join(`
`))}}e.Trace=I,I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(ee[6],te([0,1,39,4,2,3,5]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function y(){return new Date().toISOString()}var E;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(l,i,n){switch(i){case E.Trace:l.trace(n);break;case E.Debug:l.debug(n);break;case E.Info:l.info(n);break;case E.Warning:l.warn(n);break;case E.Error:l.error(n);break;case E.Critical:l.critical(n);break;default:throw new Error("Invalid log level")}}e.log=b;function P(l){let i="";for(let n=0;n<l.length;n++){let o=l[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=P;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class I extends k{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,P([i,...n]))}debug(i,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,P([i,...n]))}info(i,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,P([i,...n]))}warn(i,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,P([i,...n]))}error(i,...n){if(this.checkLogLevel(E.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(E.Error,P(o))}else this.log(E.Error,P([i,...n]))}critical(i,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,P([i,...n]))}flush(){}}e.AbstractMessageLogger=I;class p extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}debug(i,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}info(i,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}warn(i,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...n):console.warn(`[main ${y()}]`,i,...n))}error(i,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}critical(i,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class g extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=g;class h extends k{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class m extends k{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=m;class S extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=S;class C extends D.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?E.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=f;function u(l){if(l.verbose)return E.Trace;if(typeof l.logLevel=="string"){const i=c(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(l){switch(l){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=c;function r(l){switch(l){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=r});var re=this&&this.__param||function(j,e){return function(v,t){e(v,t,j)}};define(ee[179],te([0,1,62,4,2,6,3]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class wt extends D.Disposable{constructor(b){super();this.logService=b,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(b,P){let k;try{k=await this.withKeytar()}catch{return null}const I=await k.getPassword(b,P);if(I)try{let{content:p,hasNextChunk:g}=JSON.parse(I);if(!p||!g)return I;let h=1;for(;g;){const m=await k.getPassword(b,`${P}-${h}`),S=JSON.parse(m);p+=S.content,g=S.hasNextChunk,h++}return p}catch{return I}return I}async setPassword(b,P,k){let I;try{I=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}const p=3,g=async(h,m,S)=>{let C=0,f;for(;C<p;)try{await I.setPassword(h,m,S);return}catch(u){f=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),C++,await new Promise(c=>setTimeout(c,200))}throw f};if(R.isWindows&&k.length>wt.MAX_PASSWORD_LENGTH){let h=0,m=0,S=!0;for(;S;){const C=k.substring(h,h+wt.PASSWORD_CHUNK_SIZE);h+=wt.PASSWORD_CHUNK_SIZE,S=k.length-h>0;const f={content:C,hasNextChunk:S};await g(b,m?`${P}-${m}`:P,JSON.stringify(f)),m++}}else await g(b,P,k);this._onDidChangePassword.fire({service:b,account:P})}async deletePassword(b,P){let k;try{k=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}const I=await k.getPassword(b,P);if(!I)return!1;const p=await k.deletePassword(b,P);let{content:g,hasNextChunk:h}=JSON.parse(I);if(g&&h){let m=1;for(;h;){const S=`${P}-${m}`,C=await k.getPassword(b,S);await k.deletePassword(b,S),h=JSON.parse(C).hasNextChunk,m++}}return p&&this._onDidChangePassword.fire({service:b,account:P}),p}async findPassword(b){let P;try{P=await this.withKeytar()}catch{return null}return P.findPassword(b)}async findCredentials(b){let P;try{P=await this.withKeytar()}catch{return[]}return P.findCredentials(b)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=he([re(0,L.ILogService)],y),e.BaseCredentialsMainService=y}),define(ee[180],te([0,1,26,9,15,4,2,8,63,6]),function(j,e,v,t,D,L,R,y,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends R.Disposable{constructor(I,p){super();this.logService=I,this.options=p,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(I,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,p):this.watchNonRecursive(I,p)}watchUniversal(I,p){const g={path:this.toFilePath(I),excludes:p.excludes,includes:p.includes,recursive:p.recursive},h=(0,v.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,D.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,E.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const p of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const p of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(p)&&I.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,p){const g={path:this.toFilePath(I),excludes:p.excludes,includes:p.includes,recursive:!1},h=(0,v.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,D.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,E.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,y.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ee[181],te([0,1,26,9,18,23,4,71,68,2,35,10,64,16,49,143,21,97,6]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends b.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,r){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`);const l=new b.DisposableStore;return this.provider.set(c,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:r}),l.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new m.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&l.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),l.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:c}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:r}),this.provider.delete(c),(0,b.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){r.push(l)}}),!this.provider.has(c)&&await t.Promises.settled(r)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,r){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&r)}listCapabilities(){return E.Iterable.map(this.provider,([c,r])=>({scheme:c,capabilities:r.capabilities}))}async withProvider(c){if(!(0,p.isAbsolutePath)(c))throw new m.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const r=this.provider.get(c.scheme);if(!r){const l=new Error;throw l.name="ENOPRO",l.message=(0,h.localize)(1,null,c.toString()),l}return r}async withReadProvider(c){const r=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r)||(0,m.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const r=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,r){try{return await this.doResolveFile(c,r)}catch(l){throw(0,m.toFileSystemProviderErrorCode)(l)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(l)}}async doResolveFile(c,r){const l=await this.withProvider(c),i=this.isPathCaseSensitive(l),n=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,a=await l.stat(c);let d;return this.toFileStat(l,c,a,void 0,!!s,(w,M)=>(d||(d=P.TernarySearchTree.forUris(()=>!i),d.set(c,!0),n&&d.fill(!0,n)),d.get(w.resource)||d.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&o?M===1:!1))}async toFileStat(c,r,l,i,n,o){const{providerExtUri:s}=this.getExtUri(c),a={resource:r,name:s.basename(r),isFile:(l.type&m.FileType.File)!=0,isDirectory:(l.type&m.FileType.Directory)!=0,isSymbolicLink:(l.type&m.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const d=await c.readdir(r),w=await t.Promises.settled(d.map(async([M,A])=>{try{const F=s.joinPath(r,M),H=n?await c.stat(F):{type:A};return await this.toFileStat(c,F,H,d.length,n,o)}catch(F){return this.logService.trace(F),null}}));a.children=(0,v.coalesce)(w)}catch(d){this.logService.trace(d),a.children=[]}return a}return a}async resolveAll(c){return t.Promises.settled(c.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(c){const r=await this.withProvider(c),l=await r.stat(c);return this.toFileStat(r,c,l,void 0,!0,()=>!1)}async exists(c){const r=await this.withProvider(c);try{return!!await r.stat(c)}catch{return!1}}async canCreateFile(c,r){try{await this.doValidateCreateFile(c,r)}catch(l){return l}return!0}async doValidateCreateFile(c,r){if(!r?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,r)}async createFile(c,r=D.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const i=await this.writeFile(c,r);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,i)),i}async writeFile(c,r,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,l)||await this.mkdirp(i,n.dirname(c));let s;if((0,m.hasReadWriteCapability)(i)&&!(r instanceof D.VSBuffer))if((0,g.isReadableStream)(r)){const a=await(0,g.peekStream)(r,3);a.ended?s=D.VSBuffer.concat(a.buffer):s=a}else s=(0,g.peekReadable)(r,a=>D.VSBuffer.concat(a),3);else s=r;!(0,m.hasOpenReadWriteCloseCapability)(i)||(0,m.hasReadWriteCapability)(i)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(i,c,l,s):await this.doWriteBuffered(i,c,l,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s),this._onDidRunOperation.fire(new m.FileOperationEvent(c,4))}catch(o){throw new m.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,r,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(r)));let n;try{n=await c.stat(r)}catch{return}if((n.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,h.localize)(6,null,this.resourceForError(r)),0,l);if(this.throwIfFileIsReadonly(r,n),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==m.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&l.mtime<n.mtime&&l.etag!==(0,m.etag)({mtime:l.mtime,size:n.size}))throw new m.FileOperationError((0,h.localize)(7,null),3,l);return n}async readFile(c,r,l){const i=await this.withReadProvider(c);return r?.atomic?this.doReadFileAtomic(i,c,r,l):this.doReadFile(i,c,r,l)}async doReadFileAtomic(c,r,l,i){return new Promise((n,o)=>{this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,r,l,i);n(s)}catch(s){o(s)}})})}async doReadFile(c,r,l,i){const n=await this.doReadFileStream(c,r,{...l,preferUnbuffered:!0},i);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(c,r,l){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,r,l)}async doReadFileStream(c,r,l,i){const n=new L.CancellationTokenSource(i),o=this.validateReadFile(r,l).then(a=>a,a=>{throw n.cancel(),a});let s;try{return typeof l?.etag=="string"&&l.etag!==m.ETAG_DISABLED&&await o,l?.atomic&&(0,m.hasFileAtomicReadCapability)(c)||!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&l?.preferUnbuffered?s=this.readFileUnbuffered(c,r,l):(0,m.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,r,n.token,l):s=this.readFileBuffered(c,r,n.token,l),{...await o,value:s}}catch(a){s&&await(0,g.consumeStream)(s);const d=(0,h.localize)(8,null,this.resourceForError(r),(0,m.ensureFileSystemProviderError)(a).toString());throw a instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(d,a.stat,l):new m.FileOperationError(d,(0,m.toFileOperationResult)(a),l)}}readFileStreamed(c,r,l,i=Object.create(null)){const n=c.readFileStream(r,i,l);return(0,g.transform)(n,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new m.FileOperationError((0,h.localize)(9,null,this.resourceForError(r),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),i)},o=>D.VSBuffer.concat(o))}readFileBuffered(c,r,l,i=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,S.readFileIntoStream)(c,r,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new m.FileOperationError((0,h.localize)(10,null,this.resourceForError(r),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),i)},l),n}readFileUnbuffered(c,r,l){const i=(0,g.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n;l?.atomic&&(0,m.hasFileAtomicReadCapability)(c)?n=await c.readFile(r,{atomic:!0}):n=await c.readFile(r),typeof l?.position=="number"&&(n=n.slice(l.position)),typeof l?.length=="number"&&(n=n.slice(0,l.length)),this.validateReadFileLimits(r,n.byteLength,l),i.end(D.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,r){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new m.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,r);if(typeof r?.etag=="string"&&r.etag!==m.ETAG_DISABLED&&r.etag===l.etag)throw new m.NotModifiedSinceFileOperationError((0,h.localize)(12,null),l,r);return this.validateReadFileLimits(c,l.size,r),l}validateReadFileLimits(c,r,l){if(l?.limits){let i;if(typeof l.limits.memory=="number"&&r>l.limits.memory&&(i=9),typeof l.limits.size=="number"&&r>l.limits.size&&(i=7),typeof i=="number")throw new m.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,r,l){return this.doCanMoveCopy(c,r,"move",l)}async canCopy(c,r,l){return this.doCanMoveCopy(c,r,"copy",l)}async doCanMoveCopy(c,r,l,i){if(c.toString()!==r.toString())try{const n=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,c,o,r,l,i)}catch(n){return n}return!0}async move(c,r,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,c,n,r,"move",!!l),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,o==="move"?2:3,s)),s}async copy(c,r,l){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,c,n,r,"copy",!!l),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,o==="copy"?3:2,s)),s}async doMoveCopy(c,r,l,i,n,o){if(r.toString()===i.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,r,l,i,n,o);if(s&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(i)),n==="copy"){if(c===l&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(r,i,{overwrite:o});else{const d=await this.resolve(r);d.isDirectory?await this.doCopyFolder(c,d,l,i):await this.doCopyFile(c,r,l,i)}return n}else return c===l?(await c.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(c,r,l,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(c,r,l,i){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,r,l,i);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,r,l,i);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,r,l,i);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,r,l,i)}async doCopyFolder(c,r,l,i){await l.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(l).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),l,o):this.doCopyFile(c,n.resource,l,o)}))}async doValidateMoveCopy(c,r,l,i,n,o){let s=!1;if(c===l){const{providerExtUri:d,isPathCaseSensitive:w}=this.getExtUri(c);if(w||(s=d.isEqual(r,i)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&d.isEqualOrParent(i,r))throw new Error((0,h.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!o)throw new m.FileOperationError((0,h.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(c===l){const{providerExtUri:d}=this.getExtUri(c);if(d.isEqualOrParent(r,i))throw new Error((0,h.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const r=this.isPathCaseSensitive(c);return{providerExtUri:r?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(r,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,l)),l}async mkdirp(c,r){const l=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(r,i.dirname(r));)try{if(((await c.stat(r)).type&m.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,m.toFileSystemProviderErrorCode)(n)!==m.FileSystemProviderErrorCode.FileNotFound)throw n;l.push(i.basename(r)),r=i.dirname(r)}for(let n=l.length-1;n>=0;n--){r=i.joinPath(r,l[n]);try{await c.mkdir(r)}catch(o){if((0,m.toFileSystemProviderErrorCode)(o)!==m.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,r){try{await this.doValidateDelete(c,r)}catch(l){return l}return!0}async doValidateDelete(c,r){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!r?.useTrash&&!(l.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await l.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new m.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!r?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return l}async del(c,r){const l=await this.doValidateDelete(c,r),i=!!r?.useTrash,n=!!r?.recursive;await l.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}async cloneFile(c,r){const l=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(l===i&&this.getExtUri(l).providerExtUri.isEqual(c,r))return;if(l===i&&(0,m.hasFileCloneCapability)(l))return l.cloneFile(c,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const n=this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri);return l===i&&(0,m.hasFileFolderCopyCapability)(l)?n.queue(()=>l.copy(c,r,{overwrite:!0})):n.queue(()=>this.doCopyFile(l,c,i,r))}watch(c,r={recursive:!1,excludes:[]}){const l=new b.DisposableStore;let i=!1,n=()=>{i=!0};return l.add((0,b.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(c,r);i?(0,b.dispose)(o):n=()=>(0,b.dispose)(o)}catch(o){this.logService.error(o)}})(),l}async doWatch(c,r){const l=await this.withProvider(c),i=(0,y.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),r]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:l.watch(c,r)},this.activeWatchers.set(i,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,b.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,r,l,i){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(r,{create:!0,unlock:l?.unlock??!1});try{(0,g.isReadableStream)(i)||(0,g.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,r,l){let i=0,n;if((0,g.isReadableBufferedStream)(l)){if(l.buffer.length>0){const o=D.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,r,o,o.byteLength,i,0),i+=o.byteLength}if(l.ended)return;n=l.stream}else n=l;return new Promise((o,s)=>{(0,g.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(c,r,a,a.byteLength,i,0)}catch(d){return s(d)}i+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>s(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,r,l){let i=0,n;for(;(n=l.read())!==null;)await this.doWriteBuffer(c,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,r,l,i,n,o){let s=0;for(;s<i;)s+=await c.write(r,n+s,l.buffer,o+s,i-s)}async doWriteUnbuffered(c,r,l,i){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,r,l,i))}async doWriteUnbufferedQueued(c,r,l,i){let n;i instanceof D.VSBuffer?n=i:(0,g.isReadableStream)(i)?n=await(0,D.streamToBuffer)(i):(0,g.isReadableBufferedStream)(i)?n=await(0,D.bufferedStreamToBuffer)(i):n=(0,D.readableToBuffer)(i),await c.writeFile(r,n.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,r,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,r,l,i))}async doPipeBufferedQueued(c,r,l,i){let n,o;try{n=await c.open(r,{create:!1}),o=await l.open(i,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,d=0,w=0;do w=await c.read(n,a,s.buffer,d,s.byteLength-d),await this.doWriteBuffer(l,o,s,w,a,d),a+=w,d+=w,d===s.byteLength&&(d=0);while(w>0)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?l.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,r,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,r,l,i))}async doPipeUnbufferedQueued(c,r,l,i){return l.writeFile(i,await c.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,r,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,r,l,i))}async doPipeUnbufferedToBufferedQueued(c,r,l,i){const n=await l.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(r);await this.doWriteBuffer(l,n,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await l.close(n)}}async doPipeBufferedToUnbuffered(c,r,l,i){const n=await(0,D.streamToBuffer)(this.readFileBuffered(c,r,L.CancellationToken.None));await this.doWriteUnbuffered(l,i,void 0,n)}throwIfFileSystemIsReadonly(c,r){if(c.capabilities&2048)throw new m.FileOperationError((0,h.localize)(22,null,this.resourceForError(r)),6);return c}throwIfFileIsReadonly(c,r){if((r.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===k.Schemas.file?c.fsPath:c.toString(!0)}};f=he([re(0,C.ILogService)],f),e.FileService=f}),define(ee[78],te([0,1,30,244,9,35,18,4,29,2,8,3,16,49,20,147,21,97,180,39,177,176]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(l){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(l)}`)}})();class r extends C.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new L.ResourceMap(o=>I.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,I.joinPath)(i,s.name))).type:a=this.toType(s),o.push([s.name,a])}catch(a){this.logService.trace(a)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=m.FileType.Unknown:i.isFile()?o=m.FileType.File:i.isDirectory()?o=m.FileType.Directory:o=m.FileType.Unknown,n&&(o|=m.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const s=new D.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),s.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await g.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,n,o){const s=(0,p.newWriteableStream)(a=>R.VSBuffer.concat(a.map(d=>R.VSBuffer.wrap(d))).buffer);return(0,S.readFileIntoStream)(this,i,s,a=>a.buffer,{...n,bufferSize:256*1024},o),s}async writeFile(i,n,o){let s;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await g.Promises.exists(a)){if(!o.overwrite)throw(0,m.createFileSystemProviderError)((0,h.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,m.createFileSystemProviderError)((0,h.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,n){const o=this.toFilePath(i);let s;(0,m.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(i));let a;try{if((0,m.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await g.SymlinkSupport.stat(o);w.mode&128||await g.Promises.chmod(o,w.mode|128)}catch(w){this.logService.trace(w)}let d;if((0,m.isFileOpenForWriteOptions)(n)){if(k.isWindows)try{await g.Promises.truncate(o,0),d="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}d||(d="w")}else d="r";a=await g.Promises.open(o,d)}catch(d){throw s?.dispose(),(0,m.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(a,0),(0,m.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,i),s){const d=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,s),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),d.dispose())}return a}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await g.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await g.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,s,a){const d=this.normalizePos(i,n);let w=null;try{w=(await g.Promises.read(i,o,s,a,d)).bytesRead}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(i,d,w)}return w}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,s,a){return(0,D.retry)(()=>this.doWrite(i,n,o,s,a),100,3)}async doWrite(i,n,o,s,a){const d=this.normalizePos(i,n);let w=null;try{w=(await g.Promises.write(i,o,s,a,d)).bytesWritten}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),M)}finally{this.updatePos(i,d,w)}return w}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await g.Promises.rm(o,g.RimRafMode.MOVE):await g.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const s=this.toFilePath(i),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await g.Promises.move(s,a)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,h.localize)(2,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(i,n,o){const s=this.toFilePath(i),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await g.Promises.copy(s,a,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,h.localize)(3,null,(0,P.basename)(s),(0,P.basename)((0,P.dirname)(a)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(i,n,o,s){const a=this.toFilePath(i),d=this.toFilePath(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,E.isEqual)(a,d,!0)),w&&o==="copy")throw(0,m.createFileSystemProviderError)((0,h.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!w&&await g.Promises.exists(d)){if(!s)throw(0,m.createFileSystemProviderError)((0,h.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const s=this.toFilePath(i),a=this.toFilePath(n),d=!!(this.capabilities&1024);if((0,E.isEqual)(s,a,!d))return;const w=new b.DisposableStore;try{const[M,A]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);w.add(M),w.add(A),o&&await g.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await g.Promises.copyFile(s,a)}catch(M){if(M.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(M)}finally{w.dispose()}}createUniversalWatcher(i,n,o){return new u.UniversalWatcherClient(s=>i(s),s=>n(s),o)}createNonRecursiveWatcher(i,n,o){return new c.NodeJSWatcherClient(s=>i(s),s=>n(s),o)}toFileSystemProviderError(i){if(i instanceof m.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await g.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,m.createFileSystemProviderError)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(ee[182],te([0,1,4,78,2,18,49,23]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class E extends D.Disposable{constructor(k,I){super();this.provider=k,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,I,p){const g=this.getUriTransformer(k);switch(I){case"stat":return this.stat(g,p[0]);case"readdir":return this.readdir(g,p[0]);case"open":return this.open(g,p[0],p[1]);case"close":return this.close(p[0]);case"read":return this.read(p[0],p[1],p[2]);case"readFile":return this.readFile(g,p[0],p[1]);case"write":return this.write(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.writeFile(g,p[0],p[1],p[2]);case"rename":return this.rename(g,p[0],p[1],p[2]);case"copy":return this.copy(g,p[0],p[1],p[2]);case"cloneFile":return this.cloneFile(g,p[0],p[1]);case"mkdir":return this.mkdir(g,p[0]);case"delete":return this.delete(g,p[0],p[1]);case"watch":return this.watch(g,p[0],p[1],p[2],p[3]);case"unwatch":return this.unwatch(p[0],p[1])}throw new Error(`IPC Command ${I} not found`)}listen(k,I,p){const g=this.getUriTransformer(k);switch(I){case"fileChange":return this.onFileChange(g,p[0]);case"readFileStream":return this.onReadFileStream(g,p[0],p[1])}throw new Error(`Unknown event ${I}`)}stat(k,I){const p=this.transformIncoming(k,I,!0);return this.provider.stat(p)}readdir(k,I){const p=this.transformIncoming(k,I);return this.provider.readdir(p)}async readFile(k,I,p){const g=this.transformIncoming(k,I,!0),h=await this.provider.readFile(g,p);return L.VSBuffer.wrap(h)}onReadFileStream(k,I,p){const g=this.transformIncoming(k,I,!0),h=new y.CancellationTokenSource,m=new v.Emitter({onLastListenerRemove:()=>{h.cancel()}}),S=this.provider.readFileStream(g,p,h.token);return(0,R.listenStream)(S,{onData:C=>m.fire(L.VSBuffer.wrap(C)),onError:C=>m.fire(C),onEnd:()=>{m.fire("end"),m.dispose(),h.dispose()}}),m.event}writeFile(k,I,p,g){const h=this.transformIncoming(k,I);return this.provider.writeFile(h,p.buffer,g)}open(k,I,p){const g=this.transformIncoming(k,I,!0);return this.provider.open(g,p)}close(k){return this.provider.close(k)}async read(k,I,p){const g=L.VSBuffer.alloc(p),h=0,m=await this.provider.read(k,I,g.buffer,h,p);return[g,m]}write(k,I,p,g,h){return this.provider.write(k,I,p.buffer,g,h)}mkdir(k,I){const p=this.transformIncoming(k,I);return this.provider.mkdir(p)}delete(k,I,p){const g=this.transformIncoming(k,I);return this.provider.delete(g,p)}rename(k,I,p,g){const h=this.transformIncoming(k,I),m=this.transformIncoming(k,p);return this.provider.rename(h,m,g)}copy(k,I,p,g){const h=this.transformIncoming(k,I),m=this.transformIncoming(k,p);return this.provider.copy(h,m,g)}cloneFile(k,I,p){const g=this.transformIncoming(k,I),h=this.transformIncoming(k,p);return this.provider.cloneFile(g,h)}onFileChange(k,I){const p=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(k,p))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return p.event}async watch(k,I,p,g,h){const m=this.sessionToWatcher.get(I);if(m){const S=this.transformIncoming(k,g),C=m.watch(p,S,h);this.watchRequests.set(I+p,C)}}async unwatch(k,I){const p=k+I,g=this.watchRequests.get(p);g&&((0,D.dispose)(g),this.watchRequests.delete(p))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=E;class b extends D.Disposable{constructor(k,I,p,g){super();this.uriTransformer=k,this.logService=p,this.environmentService=g,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(k){const I=this._register(new v.Emitter);this._register(I.event(p=>{k.fire(p.map(g=>({resource:this.uriTransformer.transformOutgoingURI(g.resource),type:g.type})))})),this._register(this.fileWatcher.onDidChangeFile(p=>I.fire(p))),this._register(this.fileWatcher.onDidWatchError(p=>k.fire(p)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,I,p){const g=this.getExtraExcludes(this.environmentService);return Array.isArray(g)&&(p.excludes=[...p.excludes,...g]),this.watcherRequests.set(k,this.fileWatcher.watch(I,p)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(ee[183],te([0,1,14,146,3,7,21,8,182,118]),function(j,e,v,t,D,L,R,y,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class P extends E.AbstractDiskFileSystemProviderChannel{constructor(p,g,h){super(p,g);this.environmentService=h}getUriTransformer(p){return b.DefaultURITransformer}transformIncoming(p,g){return L.URI.revive(g)}async delete(p,g,h){if(!h.useTrash)return super.delete(p,g,h);const m=this.transformIncoming(p,g),S=(0,y.normalize)(m.fsPath);try{await v.shell.trashItem(S)}catch{throw(0,R.createFileSystemProviderError)(D.isWindows?(0,t.localize)(0,null,(0,y.basename)(S)):(0,t.localize)(1,null,(0,y.basename)(S)),R.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,g){return new k(p,g,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=P;class k extends E.AbstractSessionFileWatcher{watch(p,g,h){if(h.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(p,g,h)}}}),define(ee[98],te([0,1,6]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(L,R){switch(R){case v.LogLevel.Trace:return L.trace;case v.LogLevel.Debug:return L.debug;case v.LogLevel.Info:return L.info;case v.LogLevel.Warning:return L.warn;case v.LogLevel.Error:return L.error;case v.LogLevel.Critical:return L.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(R=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(R),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}set logger(R){this._logger=R;for(const{level:y,args:E}of this.buffer)t(R,y).apply(R,E);this.buffer=[]}_log(R,...y){this._logger?t(this._logger,R).apply(this._logger,y):this.getLevel()<=R&&this.buffer.push({level:R,args:y})}trace(R,...y){this._log(v.LogLevel.Trace,R,...y)}debug(R,...y){this._log(v.LogLevel.Debug,R,...y)}info(R,...y){this._log(v.LogLevel.Info,R,...y)}warn(R,...y){this._log(v.LogLevel.Warning,R,...y)}error(R,...y){this._log(v.LogLevel.Error,R,...y)}critical(R,...y){this._log(v.LogLevel.Critical,R,...y)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(ee[184],te([0,1,9,18,16,21,5,98,6]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const b=5*L.ByteSize.MB;let P=class extends E.AbstractLogger{constructor(p,g,h,m,S){super();this.name=p,this.resource=g,this.donotUseFormatters=m,this.fileService=S,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=E.LogLevel.Trace&&this._log(E.LogLevel.Trace,(0,E.format)(arguments))}debug(){this.getLevel()<=E.LogLevel.Debug&&this._log(E.LogLevel.Debug,(0,E.format)(arguments))}info(){this.getLevel()<=E.LogLevel.Info&&this._log(E.LogLevel.Info,(0,E.format)(arguments))}warn(){this.getLevel()<=E.LogLevel.Warning&&this._log(E.LogLevel.Warning,(0,E.format)(arguments))}error(){if(this.getLevel()<=E.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=p.stack,this._log(E.LogLevel.Error,(0,E.format)(g))}else this._log(E.LogLevel.Error,(0,E.format)(arguments))}}critical(){this.getLevel()<=E.LogLevel.Critical&&this._log(E.LogLevel.Critical,(0,E.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,g){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>b&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=g:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${g}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(h))})}getCurrentTimestamp(){const p=m=>m<10?`0${m}`:m,g=m=>m<10?`00${m}`:m<100?`0${m}`:m,h=new Date;return`${h.getFullYear()}-${p(h.getMonth()+1)}-${p(h.getDate())} ${p(h.getHours())}:${p(h.getMinutes())}:${p(h.getSeconds())}.${g(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(p){switch(p){case E.LogLevel.Critical:return"critical";case E.LogLevel.Debug:return"debug";case E.LogLevel.Error:return"error";case E.LogLevel.Info:return"info";case E.LogLevel.Trace:return"trace";case E.LogLevel.Warning:return"warning"}return""}};P=he([re(4,L.IFileService)],P),e.FileLogger=P;let k=class extends E.AbstractLoggerService{constructor(p,g,h){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=g,this.fileService=h}doCreateLogger(p,g,h){const m=new y.BufferLogService(g);return(0,L.whenProviderRegistered)(p,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(P,h?.name||(0,D.basename)(p),p,m.getLevel(),!!h?.donotUseFormatters)),m}};k=he([re(0,E.ILogService),re(1,R.IInstantiationService),re(2,L.IFileService)],k),e.FileLoggerService=k}),define(ee[185],te([0,1,4,7,6]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(I){this.service=I,this.onDidChangeLogLevel=v.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(I,p,g){switch(p){case"setLevel":return this.service.setLevel(g)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=L;class R{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){R.setLevel(this.channel,I)}static setLevel(I,p){return I.call("setLevel",p)}}e.LogLevelChannelClient=R;class y{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,p){throw new Error(`Event not found: ${p}`)}async call(I,p,g){switch(p){case"createLogger":this.createLogger(t.URI.revive(g[0]),g[1]);return;case"log":return this.log(t.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${p}`)}createLogger(I,p){this.loggers.set(I.toString(),this.loggerService.createLogger(I,p))}consoleLog(I,p){let g=console.log;switch(I){case D.LogLevel.Error:g=console.error;break;case D.LogLevel.Warning:g=console.warn;break;case D.LogLevel.Info:g=console.info;break}g.call(console,...p)}log(I,p){const g=this.loggers.get(I.toString());if(!g)throw new Error("Create the logger before logging");for(const[h,m]of p)(0,D.log)(g,h,m)}}e.LoggerChannel=y;class E extends D.AbstractLoggerService{constructor(I,p,g){super(I,p);this.channel=g}createConsoleMainLogger(){return new D.AdapterLogger({log:(I,p)=>{this.channel.call("consoleLog",[I,p])}})}doCreateLogger(I,p,g){return new b(this.channel,I,p,g)}}e.LoggerChannelClient=E;class b extends D.AbstractMessageLogger{constructor(I,p,g,h){super(h?.always);this.channel=I,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[p,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,p){const g=[[I,p]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(I){this.channel.call("log",[this.file,I])}}class P extends D.LogService{constructor(I,p){super(p);this.parent=I,this._register(I.onDidChangeLogLevel(g=>p.setLevel(g)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=P}),define(ee[99],te([0,1,21,6]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(y,E,b,P,k){try{const I=await new Promise((g,h)=>{j(["spdlog"],g,h)});I.setFlushOn(t.LogLevel.Trace);const p=await I.createAsyncRotatingLogger(y,E,b,P);return k&&p.clearFormatters(),p}catch(I){console.error(I)}return null}function L(y,E,b){switch(E){case t.LogLevel.Trace:y.trace(b);break;case t.LogLevel.Debug:y.debug(b);break;case t.LogLevel.Info:y.info(b);break;case t.LogLevel.Warning:y.warn(b);break;case t.LogLevel.Error:y.error(b);break;case t.LogLevel.Critical:y.critical(b);break;default:throw new Error("Invalid log level")}}class R extends t.AbstractMessageLogger{constructor(E,b,P,k,I){super();this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(E,b,P,k),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(E,b,P,k){const I=P?6:1,p=30/I*v.ByteSize.MB,g=await D(E,b,p,I,k);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:h,message:m}of this.buffer)L(this._logger,h,m);this.buffer=[]}}log(E,b){this._logger?L(this._logger,E,b):this.getLevel()<=E&&this.buffer.push({level:E,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=R}),define(ee[186],te([0,1,10,16,31,21,184,6,99]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let b=class extends y.AbstractLoggerService{constructor(k,I){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=I}doCreateLogger(k,I,p){return k.scheme===v.Schemas.file?new E.SpdLogLogger(p?.name||(0,D.generateUuid)(),k.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,I):new R.FileLogger(p?.name??(0,t.basename)(k),k,I,!!p?.donotUseFormatters,this.fileService)}};b=he([re(0,y.ILogService),re(1,L.IFileService)],b),e.LoggerService=b}),define(ee[187],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function D(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function L(R){return!v(R)&&!t(R)&&!D(R)}e.isMenubarMenuItemAction=L}),define(ee[54],te([0,1,10,3,36,16,94]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const E=t.globals.vscode.context.configuration();if(E)y=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const E=(0,L.dirname)(v.FileAccess.asFileUri("",j));y=j.__$__nodeRequire((0,L.joinPath)(E,"product.json").fsPath);const b=j.__$__nodeRequire((0,L.joinPath)(E,"package.json").fsPath);try{const h=(...f)=>f.reduce((u,c)=>(Object.keys(c).forEach(r=>{Array.isArray(u[r])&&Array.isArray(c[r])?u[r]=c[r]:typeof u[r]=="object"&&typeof c[r]=="object"?u[r]=h(u[r],c[r]):u[r]=c[r]}),u),{}),m=(0,R.getUserDataPath)({}),S=t.isWindows?`file:///${m}/product.json`:`file://${m}/product.json`,C=j.__$__nodeRequire(v.FileAccess.asFileUri(S,j).fsPath);y=h(y,C)}catch{}D.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0});const{serviceUrl:P,cacheUrl:k,itemUrl:I,controlUrl:p,recommendationsUrl:g}=y.extensionsGallery||{};Object.assign(y,{extensionsGallery:{serviceUrl:D.env.VSCODE_GALLERY_SERVICE_URL||P,cacheUrl:D.env.VSCODE_GALLERY_CACHE_URL||k,itemUrl:D.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:D.env.VSCODE_GALLERY_CONTROL_URL||p,recommendationsUrl:D.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||g}}),Object.assign(y,{version:b.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(ee[19],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[188],te([0,1,60,6,19]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let L=class{constructor(y,E){this.productService=y,this.logService=E,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(y,E){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const b=/^(.*)#([^#]+)$/.exec(E);if(!b)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",E),!1;const[,P,k]=b;let I=this.trustedExtensionUrlPublicKeys.get(y);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[y],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",y),!1;this.trustedExtensionUrlPublicKeys.set(y,[...I])}const p=Buffer.from(decodeURIComponent(k),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",E),!1;const g=p.slice(0,6),h=p.readUIntBE(0,6),m=Date.now()-h;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",E),!1;const S=p.slice(6),C=v.createVerify("SHA256");C.write(g),C.write(Buffer.from(P)),C.end();for(let f=0;f<I.length;f++){let u=I[f];if(u!==null){if(typeof u=="string")try{u=v.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),I[f]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${y}:`,c),I[f]=null;continue}if(C.verify(u,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",E),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",E),!1}};L=he([re(0,D.IProductService),re(1,t.ILogService)],L),e.ExtensionUrlTrustService=L}),define(ee[55],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(ee[189],te([0,1,14,37,2,35,10,8,3,7,31,53,6]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends D.Disposable{constructor(h,m){super();this.logService=m,this.validRoots=L.TernarySearchTree.forPaths(!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(h.appRoot),this.addValidFileRoot(h.extensionsPath),this.addValidFileRoot(h.globalStorageHome.fsPath),this.addValidFileRoot(h.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=v.session;h.protocol.registerFileProtocol(R.Schemas.vscodeFileResource,(m,S)=>this.handleResourceRequest(m,S)),h.protocol.interceptFileProtocol(R.Schemas.file,(m,S)=>this.handleFileRequest(m,S)),this._register((0,D.toDisposable)(()=>{h.protocol.unregisterProtocol(R.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(R.Schemas.file)}))}addValidFileRoot(h){const m=(0,y.normalize)(h);return this.validRoots.get(m)?D.Disposable.None:(this.validRoots.set(m,!0),(0,D.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(h,m){const S=b.URI.parse(h.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${R.Schemas.file}: protocol (original URL: ${h.url})`),m({error:-3})}handleResourceRequest(h,m){const S=this.requestToNormalizedFilePath(h);return this.validRoots.findSubstr(S)?m({path:S}):this.validExtensions.has((0,y.extname)(S))?m({path:S}):(this.logService.error(`${R.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${R.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),m({error:-3}))}requestToNormalizedFilePath(h){const m=b.URI.parse(h.url),S=R.FileAccess.asFileUri(m);return(0,y.normalize)(S.fsPath)}createIPCObjectUrl(){let h;const m=b.URI.from({scheme:"vscode",path:(0,P.generateUuid)()}),S=m.toString(),C=async()=>h;return t.validatedIpcMain.handle(S,C),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:m,update:f=>h=f,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),t.validatedIpcMain.removeHandler(S)}}}};p=he([re(0,k.INativeEnvironmentService),re(1,I.ILogService)],p),e.ProtocolMainService=p}),define(ee[40],te([0,1,109,11]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(R,y){v.ok(t.isString(R)),v.ok(t.isObject(y)),v.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,y)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new D}),define(ee[190],te([0,1,4,40]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class L{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[D(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new L;t.Registry.add(e.Extensions.JSONContribution,R)}),define(ee[56],te([0,1,26,4,11,138,17,190,40]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=E.Registry.as(y.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,l=!0){this.registerConfigurations([r],l)}registerConfigurations(r,l=!0){const i=this.doRegisterConfigurations(r,l);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const l=this.doDeregisterConfigurations(r);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:r,remove:l}){const i=[];i.push(...this.doDeregisterConfigurations(l)),i.push(...this.doRegisterConfigurations(r,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(r){const l=[],i=[];for(const{overrides:n,source:o}of r)for(const s in n)if(l.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const a={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:o,value:a});const d=(0,R.getLanguageTagSettingPlainKey)(s),w={type:"object",default:a,description:L.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:D.isString(o)?void 0:o};i.push(...h(s)),this.configurationProperties[s]=w,this.defaultLanguageConfigurationOverridesNode.properties[s]=w}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:o});const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const l=[];for(const{overrides:i,source:n}of r)for(const o in i){const s=this.configurationDefaultsOverrides.get(o),a=D.isString(n)?n:n?.id,d=D.isString(s?.source)?s?.source:s?.source?.id;if(a===d)if(l.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const w=this.configurationProperties[o];w&&(this.updatePropertyDefaultValue(o,w),this.updateSchema(o,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const l of r)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,l){const i=[];return r.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,l,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(r){const l=[],i=n=>{if(n.properties)for(const o in n.properties)l.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o]);n.allOf&&n.allOf.forEach(o=>i(o))};for(const n of r){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return l}validateAndRegisterProperties(r,l=!0,i,n,o=3){o=D.isUndefinedOrNull(r.scope)?o:r.scope;let s=[],a=r.properties;if(a)for(let w in a){if(l&&f(w)){delete a[w];continue}const M=a[w];if(M.source=i,M.defaultDefaultValue=a[w].default,this.updatePropertyDefaultValue(w,M),e.OVERRIDE_PROPERTY_REGEX.test(w)?M.scope=void 0:(M.scope=D.isUndefinedOrNull(M.scope)?o:M.scope,M.restricted=D.isUndefinedOrNull(M.restricted)?!!n?.includes(w):M.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.excludedConfigurationProperties[w]=a[w],delete a[w];continue}else this.configurationProperties[w]=a[w];!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),s.push(w)}let d=r.allOf;if(d)for(let w of d)s.push(...this.validateAndRegisterProperties(w,l,i,n,o));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const l=i=>{let n=i.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let o=i.allOf;o&&o.forEach(l)};l(r)}updateSchema(r,l){switch(e.allSettings.properties[r]=l,l.scope){case 1:e.applicationSettings.properties[r]=l;break;case 2:e.machineSettings.properties[r]=l;break;case 6:e.machineOverridableSettings.properties[r]=l;break;case 3:e.windowSettings.properties[r]=l;break;case 4:e.resourceSettings.properties[r]=l;break;case 5:e.resourceSettings.properties[r]=l,this.resourceLanguageSettingsSchema.properties[r]=l;break}}removeFromSchema(r,l){switch(delete e.allSettings.properties[r],l.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const l=`[${r}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,l){const i=this.configurationDefaultsOverrides.get(r);let n=i?.value,o=i?.source;D.isUndefined(n)&&(n=l.defaultDefaultValue,o=void 0),D.isUndefined(n)&&(n=S(l.type)),l.default=n,l.defaultValueSource=o}}const p="\\[([^\\]]+)\\]",g=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let l=g.exec(c);for(;l?.length;){const i=l[1].trim();i&&r.push(i),l=g.exec(c)}}return(0,v.distinct)(r)}e.overrideIdentifiersFromKey=h;function m(c){return c.reduce((r,l)=>`${r}[${l}]`,"")}e.keyFromOverrideIdentifiers=m;function S(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=S;const C=new I;E.Registry.add(e.Extensions.Configuration,C);function f(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?L.localize(7,null,c):C.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):null:L.localize(6,null)}e.validateProperty=f;function u(){const c=[],r=C.getConfigurationProperties();for(const l of Object.keys(r))c.push([l,r[l].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(ee[191],te([0,1,26,4,45,2,35,50,11,7,17,56,40]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},n=[],o=[]){this._contents=i,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,P.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return v.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return v.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=y.deepClone(this.contents),o=y.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(n,a.contents);for(const d of a.overrides){const[w]=o.filter(M=>v.equals(M.identifiers,d.identifiers));w?(this.mergeContents(w.contents,d.contents),w.keys.push(...d.keys),w.keys=v.distinct(w.keys)):o.push(y.deepClone(d))}for(const d of a.keys)s.indexOf(d)===-1&&s.push(d)}return new p(n,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const s of v.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s],d=n[s];d&&(typeof a=="object"&&typeof d=="object"?(a=y.deepClone(a),this.mergeContents(a,d)):a=d),o[s]=a}return new p(o,this.keys,this.overrides)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&E.isObject(i[o])&&E.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=y.deepClone(n[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?y.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,o=null;const s=a=>{a&&(o?this.mergeContents(o,a):o=y.deepClone(a))};for(const a of this.overrides)v.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,P.addToValueTree)(this.contents,i,n,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let o=0;o<n;o++)i.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class g extends p{constructor(i={}){const n=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),s=Object.create(null),a=[];for(const d in n){const w=i[d],M=w!==void 0?w:n[d].default;(0,P.addToValueTree)(s,d,M,A=>console.error(`Conflict in default settings: ${A}`))}for(const d of Object.keys(s))k.OVERRIDE_PROPERTY_REGEX.test(d)&&a.push({identifiers:(0,k.overrideIdentifiersFromKey)(d),keys:Object.keys(s[d]),contents:(0,P.toValuesTree)(s[d],w=>console.error(`Conflict in default settings file: ${w}`))});super(s,o,a)}}e.DefaultConfigurationModel=g;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!E.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:s,overrides:a,restricted:d}=this.doParseRaw(i,n);this._configurationModel=new p(o,s,a),this._restrictedConfigurations=d||[]}doParseContent(i){let n={},o=null,s=[],a=[],d=[];function w(A){Array.isArray(s)?s.push(A):o!==null&&(s[o]=A)}let M={onObjectBegin:()=>{let A={};w(A),a.push(s),s=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let A=[];w(A),a.push(s),s=A,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:w,onError:(A,F,H)=>{d.push({error:A,offset:F,length:H})}};if(i)try{D.visit(i,M),n=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(i,n){const o=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,n);i=s.raw;const a=(0,P.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),d=Object.keys(i),w=this.toOverrides(i,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:d,overrides:w,restricted:s.restricted}}filter(i,n,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},d=[];for(let w in i)if(k.OVERRIDE_PROPERTY_REGEX.test(w)&&o){const M=this.filter(i[w],n,!1,s);a[w]=M.raw,d.push(...M.restricted)}else{const M=n[w],A=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&d.push(w),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&M?.restricted||(a[w]=i[w]))}return{raw:a,restricted:d}}toOverrides(i,n){const o=[];for(const s of Object.keys(i))if(k.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const d in i[s])a[d]=i[s][d];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=h;class m extends L.Disposable{constructor(i,n,o,s){super();this.userSettingsResource=i,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class S{constructor(i,n,o=new p,s=new p,a=new R.ResourceMap,d=new p,w=new R.ResourceMap,M=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=d,this._memoryConfigurationByResource=w,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(i)}updateValue(i,n,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new p,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(i):s.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const s=this.getConsolidateConfigurationModel(n,o),a=this.getFolderConfigurationModelForResource(n.resource,o),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,w=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),M=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),F=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),H=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,Y=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,ie=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(i):d.getValue(i),X=s.getValue(i),z=v.distinct(v.flatten(s.overrides.map(x=>x.identifiers))).filter(x=>s.getOverrideValue(i,x)!==void 0);return{defaultValue:w,userValue:M,userLocalValue:A,userRemoteValue:F,workspaceValue:H,workspaceFolderValue:Y,memoryValue:ie,value:X,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:Y!==void 0?{value:a?.freeze().getValue(i),override:n.overrideIdentifier?a?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:d.getValue(i),override:n.overrideIdentifier?d.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:s,updated:a,removed:d}=c(this._defaultConfiguration,i);n=[...s,...a,...d]}for(const s of n)for(const a of(0,k.overrideIdentifiersFromKey)(s)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=i.getKeysForOverrideIdentifier(a),M=[...w.filter(A=>d.indexOf(A)===-1),...d.filter(A=>w.indexOf(A)===-1),...d.filter(A=>!y.equals(this._defaultConfiguration.override(a).getValue(A),i.override(a).getValue(A)))];o.push([a,M])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:s,overrides:a}=c(this.localUserConfiguration,i),d=[...n,...o,...s];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:s,overrides:a}=c(this.remoteUserConfiguration,i);let d=[...n,...o,...s];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:s,overrides:a}=c(this.workspaceConfiguration,i);let d=[...n,...o,...s];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:s,updated:a,removed:d,overrides:w}=c(o,n);let M=[...s,...a,...d];return(M.length||!o)&&this.updateFolderConfiguration(i,n),{keys:M,overrides:w}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:a,overrides:d}=c(n,void 0);return{keys:[...o,...s,...a],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const s=n.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const a=this._memoryConfigurationByResource.get(i);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(n=o.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:s,keys:a}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((d,w)=>(d.set(b.URI.revive(w[0]),this.parseConfigurationModel(w[1])),d),new R.ResourceMap);return new S(n,o,new p,s,a,new p,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function C(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,n=new Map;for(const s of l)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,d])=>{const w=(0,R.getOrSet)(n,a,new Set);d.forEach(M=>w.add(M))});const o=[];return n.forEach((s,a)=>o.push([a,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=C;class f{constructor(i,n,o,s){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(w=>a.add(w)),i.overrides.forEach(([,w])=>w.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const d=new p;this.affectedKeys.forEach(w=>d.setValue(w,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!y.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let o=(0,P.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=f;class u extends f{constructor(i,n,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=u;function c(l,i){const{added:n,removed:o,updated:s}=r(i,l),a=[],d=l?.getAllOverrideIdentifiers()||[],w=i?.getAllOverrideIdentifiers()||[];if(i){const M=w.filter(A=>!d.includes(A));for(const A of M)a.push([A,i.getKeysForOverrideIdentifier(A)])}if(l){const M=d.filter(A=>!w.includes(A));for(const A of M)a.push([A,l.getKeysForOverrideIdentifier(A)])}if(i&&l){for(const M of d)if(w.includes(M)){const A=r({contents:l.getOverrideValue(void 0,M)||{},keys:l.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});a.push([M,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:o,updated:s,overrides:a}}function r(l,i){const n=l?i?l.keys.filter(a=>i.keys.indexOf(a)===-1):[...l.keys]:[],o=i?l?i.keys.filter(a=>l.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(l&&i){for(const a of i.keys)if(l.keys.indexOf(a)!==-1){const d=(0,P.getConfigurationValue)(i.contents,a),w=(0,P.getConfigurationValue)(l.contents,a);y.equals(d,w)||s.push(a)}}return{added:n,removed:o,updated:s}}}),define(ee[192],te([0,1,9,4,2,16,17,191,56,40]),function(j,e,v,t,D,L,R,y,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends D.Disposable{constructor(I,p){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,p)),this.configuration=new y.Configuration(new y.DefaultConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:g})=>this.onDidDefaultConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new y.Configuration(new y.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,p){const g=typeof I=="string"?I:void 0,h=(0,R.isConfigurationOverrides)(I)?I:(0,R.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(g,h,void 0)}updateValue(I,p,g,h){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(g,p,1)}onDidDefaultConfigurationChange(I){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(new y.DefaultConfigurationModel,I);this.trigger(g,p,6)}trigger(I,p,g){const h=new y.ConfigurationChangeEvent(I,{data:p},this.configuration);h.source=g,h.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ee[193],te([0,1,15,5]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends v.ErrorNoTelemetry{constructor(y,E=D.Unknown,b){super(y);this._message=y,this._code=E,this._detail=b,this.isHandled=E===D.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(y){return y instanceof L&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof L&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof L&&y.isHandled}}e.RemoteAuthorityResolverError=L}),define(ee[194],te([0,1,9,18,23,15,4,2,31,90,193]),function(j,e,v,t,D,L,R,y,E,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const k=30*1e3;var I;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function p(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(q){const J=new D.CancellationTokenSource;return setTimeout(()=>J.cancel(),q),J.token}function h(q,J){if(q.isCancellationRequested||J.isCancellationRequested)return D.CancellationToken.Cancelled;const _=new D.CancellationTokenSource;return q.onCancellationRequested(()=>_.cancel()),J.onCancellationRequested(()=>_.cancel()),_.token}class m{constructor(J){this._state="pending",this._disposables=new y.DisposableStore,this.promise=new Promise((_,N)=>{this._resolvePromise=_,this._rejectPromise=N}),J.isCancellationRequested?this._timeout():this._disposables.add(J.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(J){this._state==="pending"?this._disposables.add(J):J.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(J))}reject(J){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(J))}}function S(q,J){const _=new m(J);return _.registerDisposable(q.onControlMessage(N=>{const T=JSON.parse(N.toString()),W=Z(T);W?_.reject(W):_.resolve(T)})),_.promise}function C(q,J,_,N,T,W,O){const U=new m(O);return J.connect(_,N,T,W,(K,ne)=>{U.didTimeout?(K&&q.error(K),ne?.dispose()):K||!ne?U.reject(K):U.resolve(ne)}),U.promise}function f(q,J){const _=new m(J);return q.then(N=>{_.didTimeout||_.resolve(N)},N=>{_.didTimeout||_.reject(N)}),_.promise}async function u(q,J,_,N){const T=$(q,J);q.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let W;try{W=await C(q.logService,q.socketFactory,q.host,q.port,`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${p(J)}-${q.reconnectionToken}`,N)}catch(ae){throw q.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ae),ae}q.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let O,U;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(W,null),O=q.reconnectionProtocol,U=!1):(O=new b.PersistentProtocol(W,null),U=!0),q.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const K=await f(q.signService.createNewMessage((0,E.generateUuid)()),N),ne={type:"auth",auth:q.connectionToken||"00000000000000000000",data:K.data};O.sendControl(t.VSBuffer.fromString(JSON.stringify(ne)));try{const ae=await S(O,h(N,g(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}if(q.logService.trace(`${T} 4/6. received SignRequest control message.`),!await f(q.signService.validate(K,ae.signedData),N)){const de=new Error("Refused to connect to unsupported server");throw de.code="VSCODE_CONNECTION_ERROR",de}const oe=await f(q.signService.sign(ae.data),N),ue={type:"connectionType",commit:q.commit,signedData:oe,desiredConnectionType:J};return _&&(ue.args=_),q.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(t.VSBuffer.fromString(JSON.stringify(ue))),{protocol:O,ownsProtocol:U}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(q.logService.error(`${T} the handshake timed out. Error:`),q.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${T} received error control message when negotiating connection. Error:`),q.logService.error(ae)),U&&x(O),ae}}async function c(q,J,_,N){const T=Date.now(),W=$(q,J),{protocol:O,ownsProtocol:U}=await u(q,J,_,N),K=new m(N);return K.registerDisposable(O.onControlMessage(ne=>{const ae=JSON.parse(ne.toString()),le=Z(ae);le?(q.logService.error(`${W} received error control message when negotiating connection. Error:`),q.logService.error(le),U&&x(O),K.reject(le)):(q.reconnectionProtocol&&q.reconnectionProtocol.endAcceptReconnection(),q.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${Q(T)}!`),K.resolve({protocol:O,firstMessage:ae}))})),K.promise}async function r(q,J){const{protocol:_}=await c(q,1,void 0,J);return{protocol:_}}async function l(q,J,_){const{protocol:N,firstMessage:T}=await c(q,2,J,_),W=T&&T.debugPort;return{protocol:N,debugPort:W}}async function i(q,J,_){const N=Date.now(),T=$(q,3),{protocol:W}=await u(q,3,J,_);return q.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${Q(N)}!`),W}async function n(q,J,_){const{host:N,port:T,connectionToken:W}=await q.addressProvider.getAddress();return{commit:q.commit,host:N,port:T,connectionToken:W,reconnectionToken:J,reconnectionProtocol:_,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function o(q,J,_){try{const N=(0,E.generateUuid)(),T=await n(q,N,null),{protocol:W}=await r(T,D.CancellationToken.None);return new X(q,J,_,N,W)}catch(N){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(N),ie.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentManagement=o;async function s(q,J){try{const _=(0,E.generateUuid)(),N=await n(q,_,null),{protocol:T,debugPort:W}=await l(N,J,D.CancellationToken.None);return new z(q,J,_,T,W)}catch(_){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(_),ie.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=s;async function a(q,J,_){const N=await n(q,(0,E.generateUuid)(),null);return await i(N,{host:J,port:_},D.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function d(q){return(0,v.createCancelablePromise)(J=>new Promise((_,N)=>{const T=setTimeout(_,q*1e3);J.onCancellationRequested(()=>{clearTimeout(T),_()})}))}var w;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(w=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(J,_){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=M;class A{constructor(J,_,N,T){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.durationSeconds=N,this.cancellableTimer=T,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=A;class F{constructor(J,_,N){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=F;class H{constructor(J,_,N){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.attempt=N,this.type=4}}e.ConnectionGainEvent=H;class Y{constructor(J,_,N,T){this.reconnectionToken=J,this.millisSinceLastIncomingData=_,this.attempt=N,this.handled=T,this.type=3}}e.ReconnectionPermanentFailureEvent=Y;class ie extends y.Disposable{constructor(J,_,N,T,W){super();this._connectionType=J,this._options=_,this.reconnectionToken=N,this.protocol=T,this._reconnectionFailureIsFatal=W,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new H(this.reconnectionToken,0,0)),this._register(T.onSocketClose(O=>{const U=B(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${U} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${U} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${U} received socket close event.`),this._beginReconnecting()})),this._register(T.onSocketTimeout(()=>{const O=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),ie._instances.push(this),this._register((0,y.toDisposable)(()=>{const O=ie._instances.indexOf(this);O>=0&&ie._instances.splice(O,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ie._permanentFailureMillisSinceLastIncomingData,ie._permanentFailureAttempt,ie._permanentFailureHandled)}static triggerPermanentFailure(J,_,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=J,this._permanentFailureAttempt=_,this._permanentFailureHandled=N,this._instances.forEach(T=>T._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(J=>J._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(J=>J._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ie._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const J=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const T=N<_.length?_[N]:_[_.length-1];try{if(T>0){const O=d(T);this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,O)),this._options.logService.info(`${J} waiting for ${T} seconds before reconnecting...`);try{await O}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${J} resolving connection...`);const W=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${J} connecting to ${W.host}:${W.port}...`),await this._reconnect(W,g(k)),this._options.logService.info(`${J} reconnected!`),this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(W)){this._options.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this._options.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(W);continue}if((0,L.isCancellationError)(W)){this._options.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(W);continue}if(W instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,P.RemoteAuthorityResolverError.isHandled(W));break}this._options.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(W),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(J,_,N){this._reconnectionFailureIsFatal?ie.triggerPermanentFailure(J,_,N):this._gotoPermanentFailure(J,_,N)}_gotoPermanentFailure(J,_,N){this._onDidStateChange.fire(new Y(this.reconnectionToken,J,_,N)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie._permanentFailureMillisSinceLastIncomingData=0,ie._permanentFailureAttempt=0,ie._permanentFailureHandled=!1,ie._instances=[];class X extends ie{constructor(J,_,N,T,W){super(1,J,T,W,!0);this.client=this._register(new b.Client(W,{remoteAuthority:_,clientId:N},J.ipcLogger))}async _reconnect(J,_){await r(J,_)}}e.ManagementPersistentConnection=X;class z extends ie{constructor(J,_,N,T,W){super(2,J,N,T,!1);this._startArguments=_,this.debugPort=W}async _reconnect(J,_){await l(J,this._startArguments,_)}}e.ExtensionHostPersistentConnection=z;function x(q){try{q.acceptDisconnect();const J=q.getSocket();q.dispose(),J.dispose()}catch(J){(0,L.onUnexpectedError)(J)}}function Z(q){if(q&&q.type==="error"){const J=new Error(`Connection error: ${q.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function V(q,J){for(;q.length<J;)q+=" ";return q}function B(q,J,_){return`[remote-connection][${V(p(q),13)}][${J.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function $(q,J){return`${B(J,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function Q(q){return`${Date.now()-q} ms`}}),define(ee[79],te([0,1,10]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(L){return L.scheme===v.Schemas.vscodeRemote?L.authority:void 0}e.getRemoteAuthority=t;function D(L){if(!L)return;const R=L.indexOf("+");return R<0?L:L.substr(0,R)}e.getRemoteName=D}),define(ee[57],te([0,1,18,151,56,5,40]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function y(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=y;function E(h){return h.res.statusCode===204}async function b(h){return E(h)?null:(await(0,v.streamToBuffer)(h.stream)).toString()}e.asText=b;async function P(h){if(!y(h))throw new Error("Server returned "+h.res.statusCode);return b(h)}e.asTextOrError=P;async function k(h){if(!y(h))throw new Error("Server returned "+h.res.statusCode);if(E(h))return null;const S=(await(0,v.streamToBuffer)(h.stream)).toString();try{return JSON.parse(S)}catch(C){throw C.message+=`:
`+S,C}}e.asJson=k;function I(h){g(h)}e.updateProxyConfigurationsScope=I;let p;function g(h){const m=R.Registry.as(D.Extensions.Configuration),S=p;p={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[p],remove:S?[S]:[]})}g(2)}),define(ee[195],te([0,1,196,11]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(R,y){return R.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:R.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function L(R,y,E={}){const b=(0,v.parse)(R),P=E.proxyUrl||D(b,y);if(!P)return null;const k=(0,v.parse)(P);if(!/^https?:$/.test(k.protocol||""))return null;const I={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(E.strictSSL)?E.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((p,g)=>{j(["http-proxy-agent"],p,g)}))(I):new(await new Promise((p,g)=>{j(["https-proxy-agent"],p,g)}))(I)}e.getProxyAgent=L}),define(ee[100],te([0,1,46,8,152,23,39,15,3,31,135,51,9]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let g;async function h(S,C,f){return C["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(f)&&!C["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(f)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=I.Promises.withAsyncBody(async(u,c)=>{const r=new L.CancellationTokenSource,l=setTimeout(()=>{r.dispose(!0),c(new Error((0,D.localize)(0,null)))},p);try{u(await m(S,r.token))}catch(i){!(0,y.isCancellationError)(i)&&!r.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,R.toErrorMessage)(i)))):u({})}finally{clearTimeout(l),r.dispose()}})),g)}e.getResolvedShellEnv=h;async function m(S,C){const f=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",f);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",u);const c=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};S.trace("getUnixShellEnvironment#env",l);const i=await(0,P.getSystemShell)(E.OS,l);return S.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(C.isCancellationRequested)return o((0,y.canceled)());const s=(0,t.basename)(i);let a,d;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${w} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,d=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s==="tcsh"?d=["-ic"]:d=["-ilc"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),a);const M=(0,v.spawn)(i,[...d,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});C.onCancellationRequested(()=>(M.kill(),o((0,y.canceled)()))),M.on("error",H=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(H)),o(H)});const A=[];M.stdout.on("data",H=>A.push(H));const F=[];M.stderr.on("data",H=>F.push(H)),M.on("close",(H,Y)=>{const ie=Buffer.concat(A).toString("utf8");S.trace("getUnixShellEnvironment#raw",ie);const X=Buffer.concat(F).toString("utf8");if(X.trim()&&S.trace("getUnixShellEnvironment#stderr",X),H||Y)return o(new Error((0,D.localize)(2,null,H,Y)));const z=r.exec(ie),x=z?z[1]:"{}";try{const Z=JSON.parse(x);f?Z.ELECTRON_RUN_AS_NODE=f:delete Z.ELECTRON_RUN_AS_NODE,u?Z.ELECTRON_NO_ATTACH_CONSOLE=u:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",Z),n(Z)}catch(Z){S.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(Z)),o(Z)}})})}}),define(ee[80],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[197],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((D,L)=>j(["vsda"],D,L))}async createNewMessage(D){try{const L=await this.vsda(),R=new L.validator;if(R){const y=String(v._nextId++);return this.validators.set(y,R),{id:y,data:R.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const R=this.validators.get(D.id);if(!R)return!1;this.validators.delete(D.id);try{return R.validate(L)==="ok"}catch{return!1}}async sign(D){try{const L=await this.vsda(),R=new L.signer;if(R)return R.sign(D)}catch{}return D}}e.SignService=v,v._nextId=1}),define(ee[41],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(ee[22],te([0,1,14,37,9,4,2,3,36,11,5,6,41]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var p;(function(m){m[m.QUIT=1]="QUIT",m[m.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var g;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class pt extends R.Disposable{constructor(S,C){super();this.logService=S,this.stateMainService=C,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(pt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(pt.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",S);const C=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",C),v.app.once("will-quit",f=>{this.logService.trace("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",S),v.app.removeListener("window-all-closed",C),v.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const C=[];return this._onWillShutdown.fire({reason:S,join(f){C.push(f)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(C)}catch(f){this.logService.error(f)}try{await this.stateMainService.close()}catch(f){this.logService.error(f)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.logService.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const C=this.phaseWhen.get(this._phase);C&&(C.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let C=this.phaseWhen.get(S);C||(C=new D.Barrier,this.phaseWhen.set(S,C)),await C.wait()}registerWindow(S){const C=new R.DisposableStore;this.windowCounter++,C.add(S.onWillLoad(u=>this._onWillLoadWindow.fire({window:S,workspace:u.workspace,reason:u.reason})));const f=(0,b.assertIsDefined)(S.win);f.on("close",u=>{const c=S.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),u.preventDefault(),this.unload(S,1).then(r=>{if(r){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(S),S.close()})}),f.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,C.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,C){await this.unload(S,3)||S.reload(C)}unload(S,C){const f=this.mapWindowIdToPendingUnload.get(S.id);if(f)return f;const u=this.doUnload(S,C).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,u),u}async doUnload(S,C){if(!S.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${S.id}`);const f=this._quitRequested?2:C;let u=await this.onBeforeUnloadWindowInRenderer(S,f);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(u)):(await this.onWillUnloadWindowInRenderer(S,f),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,C){return new Promise(f=>{const u=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${u}`,r=`vscode:cancel${u}`;t.validatedIpcMain.once(c,()=>{f(!1)}),t.validatedIpcMain.once(r,()=>{f(!0)}),S.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:r,reason:C})})}onWillUnloadWindowInRenderer(S,C){return new Promise(f=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(c,()=>f()),S.send("vscode:onWillUnload",{replyChannel:c,reason:C})})}quit(S){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${S}`),S&&this.stateMainService.setItem(pt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(C=>{this.pendingQuitPromiseResolve=C,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(S){this.logService.trace("Lifecycle#relaunch()");const C=process.argv.slice(1);if(S?.addArgs&&C.push(...S.addArgs),S?.removeArgs)for(const c of S.removeArgs){const r=C.indexOf(c);r>=0&&C.splice(r,1)}const f=()=>{try{if(y.isWindows){const c=(0,E.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:C})};v.app.once("quit",f),await this.quit(!0)&&v.app.removeListener("quit",f)}async kill(S){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const C of v.BrowserWindow.getAllWindows())if(C&&!C.isDestroyed()){let f;C.webContents&&!C.webContents.isDestroyed()?f=new Promise(u=>C.once("closed",u)):f=Promise.resolve(),C.destroy(),await f}})()]),v.app.exit(S)}};h.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",h=he([re(0,k.ILogService),re(1,I.IStateMainService)],h),e.LifecycleMainService=h}),define(ee[198],te([0,1,4,2,5,22]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let R=class extends t.Disposable{constructor(b){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,b.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const b=await new Promise((P,k)=>{j(["native-keymap"],P,k)});this._keyboardLayoutData=y(b),b.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=y(b),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};R=he([re(0,L.ILifecycleMainService)],R),e.KeyboardLayoutMainService=R;function y(E){const b=E.getKeyMap(),P=E.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:P}}}),define(ee[101],te([0,1,9,4,2,64,11,92,5]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var P;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var I;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class p extends D.Disposable{constructor(S={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,C){C===b?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:C,target:this.getKeyTargets(S)[C]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,C,f){return this.getStorage(C)?.get(S,f)}getBoolean(S,C,f){return this.getStorage(C)?.getBoolean(S,f)}getNumber(S,C,f){return this.getStorage(C)?.getNumber(S,f)}store(S,C,f,u){if((0,R.isUndefinedOrNull)(C)){this.remove(S,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,f,u),this.getStorage(f)?.set(S,C)})}remove(S,C){this.withPausedEmitters(()=>{this.updateKeyTarget(S,C,void 0),this.getStorage(C)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,C){const f=[],u=this.getKeyTargets(S);for(const c of Object.keys(u))u[c]===C&&f.push(c);return f}updateKeyTarget(S,C,f){const u=this.getKeyTargets(C);typeof f=="number"?u[S]!==f&&(u[S]=f,this.getStorage(C)?.set(b,JSON.stringify(u))):typeof u[S]=="number"&&(delete u[S],this.getStorage(C)?.set(b,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const C=this.get(b,S);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=P.NONE){this._onWillSaveState.fire({reason:S});const C=this.getStorage(0),f=this.getStorage(1);switch(S){case P.NONE:await v.Promises.settled([C?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await v.Promises.settled([C?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const S=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return h(S,C,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class g extends p{constructor(){super();this.globalStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=g;async function h(m,S,C,f){const u=s=>{try{return JSON.parse(s)}catch{return s}},c=new Map,r=new Map;m.forEach((s,a)=>{c.set(a,s),r.set(a,u(s))});const l=new Map,i=new Map;S.forEach((s,a)=>{l.set(a,s),i.set(a,u(s))}),console.group(`Storage: Global (path: ${C})`);let n=[];c.forEach((s,a)=>{n.push({key:a,value:s})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${f})`);let o=[];l.forEach((s,a)=>{o.push({key:a,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=h}),define(ee[199],te([0,1,3,36,7,31]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(b){if(v.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function y(b,P,k,I,p,g,h,m,S,C){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,L.generateUuid)()+Date.now(),f.commitHash=p,f.version=g,f["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,v.PlatformToString)(v.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=I,f["common.product"]=C||"desktop";const u=E(m||[]);u&&(f["common.msftInternal"]=u);let c=0;const r=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(f["common.snap"]="true");const l=R(k);l&&(f["common.platformDetail"]=l);try{const i=await b.readFile(D.URI.file(S));f["common.source"]=i.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=y;function E(b){const P=t.env.USERDNSDOMAIN;if(!P)return!1;const k=P.toLowerCase();return b.some(I=>k===I)}e.verifyMicrosoftInternalDomain=E}),define(ee[32],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[200],te([0,1,27,68,9,45,10,8,3,7,73,20,89,76,21,19,32]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const S=new Map;async function C(l,i){const n=`${l}::${i.join(":")}`,o=S.get(n);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,d=new Map,w=2e4;function M(F,H,Y,ie){const X=H.substring(F.length+1);return D.Promises.withAsyncBody(async z=>{let x;try{x=await k.Promises.readdir(H,{withFileTypes:!0})}catch{z();return}if(ie.count>=w){ie.count+=x.length,ie.maxReached=!0,z();return}let Z=x.length;if(Z===0){z();return}let V=x;ie.count+x.length>w&&(ie.maxReached=!0,Z=w-ie.count,V=x.slice(0,Z)),ie.count+=x.length;for(const B of V)if(B.isDirectory()){if(Y.includes(B.name)||await M(F,(0,y.join)(H,B.name),Y,ie),--Z==0){z();return}}else{const $=B.name.lastIndexOf(".");if($>=0){const Q=B.name.substring($+1);Q&&a.set(Q,(a.get(Q)??0)+1)}for(const Q of s)Q.relativePathPattern?.test(X)!==!1&&Q.filePattern.test(B.name)&&d.set(Q.tag,(d.get(Q.tag)??0)+1);if(--Z==0){z();return}}})}const A=D.Promises.withAsyncBody(async F=>{const H={count:0,maxReached:!1};await M(l,l,i,H);const Y=await c(l);F({configFiles:f(d),fileTypes:f(a),fileCount:H.count,maxFilesReached:H.maxReached,launchConfigFiles:Y})});return S.set(n,A),A}e.collectWorkspaceStats=C;function f(l){return[...t.Iterable.map(l.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const l={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=u;async function c(l){try{const i=new Map,n=(0,y.join)(l,".vscode","launch.json"),o=await k.Promises.readFile(n),s=[],a=(0,L.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const d of a.configurations){const w=d.type;w&&(i.has(w)?i.set(w,i.get(w)+1):i.set(w,1))}return f(i)}catch{return[]}}e.collectLaunchConfigs=c;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const o=v.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(v.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||n.push(`Load (avg):       ${v.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,I.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[s,a]=o,d=this.formatProcessList(i,s);return n.forEach(w=>{if((0,p.isRemoteDiagnosticError)(w))d+=`
${w.errorMessage}`,a+=`
${w.errorMessage}`;else if(d+=`

Remote: ${w.hostName}`,w.processes&&(d+=`
${this.formatProcessList(i,w.processes)}`),w.workspaceMetadata){a+=`
|  Remote: ${w.hostName}`;for(const M of Object.keys(w.workspaceMetadata)){const A=w.workspaceMetadata[M];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),a+=`|    Folder (${M}): ${F}`,a+=this.formatWorkspaceStats(A)}}}),{processInfo:d,workspaceInfo:a}})}async getSystemInfo(i,n){const{memory:o,vmHint:s,os:a,cpus:d}=u(),w={os:a,memory:o,cpus:d,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return E.isWindows||(w.load=`${v.loadavg().map(M=>Math.round(M)).join(", ")}`),E.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(i,n){const o=[];return(0,I.listProcesses)(i.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,s)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const d of Object.keys(a.workspaceMetadata)){const w=a.workspaceMetadata[d];let M=`${w.fileCount} files`;w.maxFilesReached&&(M=`more than ${M}`),o.push(`Folder (${d}): ${M}`),o.push(this.formatWorkspaceStats(w))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let s=0;const a=(A,F)=>{const H=` ${A}(${F})`;s+H.length>o?(n.push(d),d="|                 ",s=d.length):s+=H.length,d+=H};let d="|      File types:";const w=10;let M=i.fileTypes.length>w?w:i.fileTypes.length;for(let A=0;A<M;A++){const F=i.fileTypes[A];a(F.name,F.count)}if(n.push(d),i.configFiles.length>=0&&(d="|      Conf files:",s=0,i.configFiles.forEach(A=>{a(A.name,A.count)}),n.push(d)),i.launchConfigFiles.length>0){let A="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),n.push(A)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const d=b.URI.revive(a);if(d.scheme===R.Schemas.file){const w=d.fsPath;o.push(C(w,["node_modules",".git"]).then(M=>{let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),n.push(`|    Folder (${(0,y.basename)(w)}): ${A}`),n.push(this.formatWorkspaceStats(M))}).catch(M=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${M.toString()})`)}))}else n.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(a=>o.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,s,n,0),s.join(`
`)}formatProcessItem(i,n,o,s,a){const d=a===0;let w;d?w=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(w=`${w} (${n.get(s.pid)})`));const M=process.platform==="win32"?s.mem:v.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(M/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(s.children)&&s.children.forEach(A=>this.formatProcessItem(i,n,o,A,a+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const s=b.URI.revive(o);if(s.scheme!==R.Schemas.file)continue;const a=s.fsPath;try{(await C(a,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=b.URI.revive(n);if(o.scheme!==R.Schemas.file)continue;const s=o.fsPath;try{const a=await C(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:d.name,count:d.count})}),a.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:d.name,count:d.count})}),a.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};r=he([re(0,m.ITelemetryService),re(1,h.IProductService)],r),e.DiagnosticsService=r}),define(ee[201],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(L){this.appenders=L}listen(L,R){throw new Error(`Event not found: ${R}`)}call(L,R,{eventName:y,data:E}){return this.appenders.forEach(b=>b.log(y,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(L){this.channel=L}log(L,R){return this.channel.call("log",{eventName:L,data:R}).then(void 0,y=>`Failed to log telemetry: ${console.warn(y)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[65],te([0,1,50,85,11,17,32]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(f,u){return Promise.resolve(void 0)}publicLog2(f,u){return this.publicLog(f,u)}publicLogError(f,u){return Promise.resolve(void 0)}publicLogError2(f,u){return this.publicLogError(f,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class E{async publicLog(f,u,c){}async publicLogError(f,u,c){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(C,f){return f.onDidChangeConfiguration(u=>{u.source!==6&&C.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(u.source),configurationKeys:h(u.sourceConfig)})})}e.configurationTelemetry=b;function P(C,f){return!(f.disableTelemetry||!C.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=P;function k(C){const f=C.getValue(R.TELEMETRY_SETTING_ID),u=C.getValue("telemetry.enableCrashReporter");if(C.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=k;function I(C){const f=Object.create(null),u=Object.create(null),c=Object.create(null);g(C,c);for(let r in c){r=r.length>150?r.substr(r.length-149):r;const l=c[r];typeof l=="number"?u[r]=l:typeof l=="boolean"?u[r]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${l.length}`),f[r]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(f[r]=l)}return{properties:f,measurements:u}}e.validateTelemetryData=I;function p(C){if(!C)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{C.indexOf(`${c}+`)===0&&(f=c)}),f}e.cleanRemoteAuthority=p;function g(C,f,u=0,c){if(!!C)for(let r of Object.getOwnPropertyNames(C)){const l=C[r],i=c?c+r:r;Array.isArray(l)?f[i]=(0,v.safeStringify)(l):l instanceof Date?f[i]=l.toISOString():(0,D.isObject)(l)?u<2?g(l,f,u+1,i+"."):f[i]=(0,v.safeStringify)(l):f[i]=l}}function h(C){if(!C)return[];const f=[];return m(f,"",C),f}function m(C,f,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(c=>m(C,f?`${f}.${c}`:c,u[c])):C.push(f)}function S(C){return[C.appRoot,C.extensionsPath,C.userHome.fsPath,C.tmpDir.fsPath,C.userDataPath]}e.getPiiPathsFromEnvironment=S}),define(ee[202],te([0,1,168,65]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(L,R,y,E,b,P){const k={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${R.nameShort})`},I=await(0,v.getServiceMachineId)(y,b,P);return(0,t.supportsTelemetry)(R,y)&&(0,t.getTelemetryLevel)(E)===3&&(k["X-Market-User-Id"]=I),k}e.resolveMarketplaceHeaders=D}),define(ee[203],te([0,1,2,50,85,3,28,153,17,56,54,19,40,32,65]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(C,f,u){this._configurationService=f,this._productService=u,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=C.appenders,this._commonProperties=C.commonProperties||Promise.resolve({}),this._piiPaths=C.piiPaths||[],this._sendErrorTelemetry=!!C.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(C,f){this._experimentProperties[C]=f}_updateTelemetryLevel(){let C=(0,g.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;C=Math.min(C,u)}this.telemetryLevel.value=C}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const C=await this._commonProperties;let f=C.sessionID,u=C["common.machineId"],c=C["common.firstSessionDate"],r=C["common.msftInternal"];return{sessionId:f,machineId:u,firstSessionDate:c,msftInternal:r}}dispose(){this._disposables.dispose()}_log(C,f,u,c){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(r=>{u=(0,t.mixin)(u,r),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(C,u))},r=>{console.error(r)})}publicLog(C,f,u){return this._log(C,3,f,u)}publicLog2(C,f,u){return this.publicLog(C,f,u)}publicLogError(C,f){return this._sendErrorTelemetry?this._log(C,2,f,!0):Promise.resolve(void 0)}publicLogError2(C,f){return this.publicLogError(C,f)}_anonymizeFilePaths(C){let f=C;const u=[];for(let i of this._cleanupPatterns)for(;;){const n=i.exec(C);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(f="";;){const i=r.exec(C);if(!i)break;!c.test(i[0])&&u.every(([n,o])=>i.index<n||i.index>=o)&&(f+=C.substring(l,i.index)+"<REDACTED: user-file-path>",l=r.lastIndex)}return l<C.length&&(f+=C.substr(l)),f}_removePropertiesWithPossibleUserInfo(C){if(!C)return C;const f=C.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(f))return`<REDACTED: ${c.label}`;return C}_cleanupInfo(C,f){let u=C;f&&(u=this._anonymizeFilePaths(u));for(let c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=he([re(1,E.IConfigurationService),re(2,k.IProductService)],h),e.TelemetryService=h;function m(){const S=(0,y.localize)(0,null,P.default.nameLong),C=P.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",P.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=L.isWeb?"":(0,y.localize)(3,null),u=(0,y.localize)(4,null),c=(0,y.localize)(5,null),r=(0,y.localize)(6,null),l=(0,y.localize)(7,null),i=`
|       | ${u} | ${c} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,y.localize)(8,null);return`
${S} ${C} ${f}

&nbsp;

${l}
${i}

&nbsp;

${n}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:m(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:P.default.privacyStatementUrl?(0,y.localize)(16,null,P.default.nameLong,P.default.privacyStatementUrl):(0,y.localize)(15,null,P.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[204],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var v;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST_DARK="hcDark",D.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(D){return D===v.HIGH_CONTRAST_DARK||D===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t}),define(ee[205],te([0,1,110,4,2,5,40,204]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(m){function S(C){return C&&typeof C=="object"&&typeof C.id=="string"}m.isThemeColor=S})(E=e.ThemeColor||(e.ThemeColor={}));function b(m){return{id:m}}e.themeColorFromId=b;var P;(function(m){function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||E.isThemeColor(n.color))}m.isThemeIcon=S;const C=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const o=C.exec(n);if(!o)return;let[,s]=o;return{id:s}}m.fromString=f;function u(n){return{id:n}}m.fromId=u;function c(n,o){let s=n.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),o&&(s=`${s}~${o}`),{id:s}}m.modify=c;function r(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}m.getModifier=r;function l(n,o){return n.id===o.id&&n.color?.id===o.color?.id}m.isEqual=l;function i(n,o){return{id:n.id,color:o?b(o):void 0}}m.asThemeIcon=i,m.asClassNameArray=v.CSSIcon.asClassNameArray,m.asClassName=v.CSSIcon.asClassName,m.asCSSSelector=v.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function k(m){switch(m){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,D.toDisposable)(()=>{const C=this.themingParticipants.indexOf(S);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new I;R.Registry.add(e.Extensions.ThemingContribution,p);function g(m){return p.onColorThemeChange(m)}e.registerThemingParticipant=g;class h extends D.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,C){let f=this.theme.getColor(S);return f&&C&&(f=C(f,this.theme)),f?f.toString():null}}e.Themable=h}),define(ee[58],te([0,1,14,4,2,3,17,5,41]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const b="#FFFFFF",P="#1E1E1E",k="#000000",I="#FFFFFF",p="theme",g="themeBackground",h="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let m=class extends D.Disposable{constructor(C,f){super();this.stateMainService=C,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(L.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors!==v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const C=this.getColorScheme();if(C.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return C.dark?k:I;let f=this.stateMainService.getItem(g,null);if(!f)switch(this.stateMainService.getItem(p,"vs-dark").split(" ")[0]){case"vs":f=b;break;case"hc-black":f=k;break;case"hc-light":f=I;break;default:f=P}return L.isMacintosh&&f.toUpperCase()===P&&(f="#171717"),f}saveWindowSplash(C,f){this.stateMainService.setItems([{key:p,data:f.baseTheme},{key:g,data:f.colorInfo.background},{key:h,data:f}]),typeof C=="number"&&this.updateBackgroundColor(C,f)}updateBackgroundColor(C,f){for(const u of v.BrowserWindow.getAllWindows())if(u.id===C){u.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(h)}};m=he([re(0,E.IStateMainService),re(1,R.IConfigurationService)],m),e.ThemeMainService=m}),define(ee[102],te([0,1,4,3,5,6]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var R;(function(g){g.Http="http",g.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=k;function I(g,h){return h?h!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=I;let p=class{constructor(h){this.logService=h,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],m=Array.from(this._tunnels.values());for(let S of m){const C=Array.from(S.values());for(let f of C){const u=await f.value;u&&h.push(u)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:m}of h.values())await m.then(S=>S?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,m,S,C,f=!1,u=y.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${S} on local port ${C}.`),!h)return;m||(m="localhost");const r=this.retainOrCreateTunnel(h,m,S,C,f,u,c);return r?r.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(l);return(l.tunnelRemoteHost!==m||l.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const m=this._tunnels.get(h.tunnelRemoteHost);if(m){const S=m.get(h.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,S))}}}}async tryDisposeTunnel(h,m,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${m}.`);const C=S.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(m),C}}async closeTunnel(h,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${m} `);const S=this._tunnels.get(h);if(S&&S.has(m)){const C=S.get(m);C.refcount=0,await this.tryDisposeTunnel(h,m,C)}}addTunnelToMap(h,m,S){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(m,{refcount:1,value:S})}async removeEmptyTunnelFromMap(h,m){const S=this._tunnels.get(h);S&&(await S.get(m)||S.delete(m),S.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,m){let S=[h];P(h)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):k(h)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const C=S.map(f=>this._tunnels.get(f));for(const f of C){const u=f?.get(m);if(u)return u}}canTunnel(h){return!!b(h)}createWithProvider(h,m,S,C,f,u,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${S} on local port ${C}.`);const l={elevationRequired:f?I(C===void 0?S:C):!1},i={remoteAddress:{host:m,port:S},localAddressPort:C,privacy:u,public:u!==y.Private,protocol:c},n=h.forwardPort(i,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(m,S,n),n}};p=he([re(0,L.ILogService)],p),e.AbstractTunnelService=p}),define(ee[42],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(t=e.StateType||(e.StateType={}));var D;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(L,R)=>({type:"idle",updateType:L,error:R}),CheckingForUpdates:L=>({type:"checking for updates",explicit:L}),AvailableForDownload:L=>({type:"available for download",update:L}),Downloading:L=>({type:"downloading",update:L}),Downloaded:L=>({type:"downloaded",update:L}),Updating:L=>({type:"updating",update:L}),Ready:L=>({type:"ready",update:L})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(ee[206],te([0,1,3,154,56,40]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[207],te([0,1,4,42]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(y){this.service=y}listen(y,E){switch(E){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${E}`)}call(y,E,b){switch(E){case"checkForUpdates":return this.service.checkForUpdates(b);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${E}`)}}e.UpdateChannel=D;class L{constructor(y){this.channel=y,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(E=>this.state=E),this.channel.call("_getInitialState").then(E=>this.state=E)}get state(){return this._state}set state(y){this._state=y,this._onStateChange.fire(y)}checkForUpdates(y){return this.channel.call("checkForUpdates",y)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=L}),define(ee[103],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(ee[208],te([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(y){this.handler=y}listen(y,E){throw new Error(`Event not found: ${E}`)}call(y,E,b){switch(E){case"handleURL":return this.handler.handleURL(v.URI.revive(b[0]),b[1])}throw new Error(`Call not found: ${E}`)}}e.URLHandlerChannel=t;class D{constructor(y){this.channel=y}handleURL(y,E){return this.channel.call("handleURL",[y.toJSON(),E])}}e.URLHandlerChannelClient=D;class L{constructor(y){this.next=y}async routeCall(y,E,b,P){if(E!=="handleURL")throw new Error(`Call not found: ${E}`);if(b){const k=v.URI.revive(b);if(k&&k.query){const I=/\bwindowId=(\d+)/.exec(k.query);if(I){const p=I[1],g=new RegExp(`window:${p}`),h=y.connections.find(m=>g.test(m.ctx));if(h)return h}}}return this.next.routeCall(y,E,b,P)}routeEvent(y,E){throw new Error(`Event not found: ${E}`)}}e.URLHandlerRouter=L}),define(ee[209],te([0,1,9,2,7,19]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(b,P){const k=[...this.handlers.values()];return(0,v.first)(k.map(I=>()=>I.handleURL(b,P)),void 0,!1).then(I=>I||!1)}registerHandler(b){return this.handlers.add(b),(0,t.toDisposable)(()=>this.handlers.delete(b))}}e.AbstractURLService=R;let y=class extends R{constructor(b){super();this.productService=b}create(b){let{authority:P,path:k,query:I,fragment:p}=b||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return P&&k&&k.indexOf("/")!==0&&(k=`/${k}`),D.URI.from({scheme:this.productService.urlProtocol,authority:P,path:k,query:I,fragment:p})}};y=he([re(0,L.IProductService)],y),e.NativeURLService=y}),define(ee[210],te([0,1,14,9,4,2,3,7]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function E(P){try{return y.URI.parse(P)}catch{return null}}class b{constructor(k,I,p,g,h){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=L.Disposable.None,this.disposables=new L.DisposableStore,this.uris=k,R.isWindows){const C=g.isBuilt?[]:[`"${g.appRoot}"`];C.push("--open-url","--"),v.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,C)}const m=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(C,f)=>({event:C,url:f})),({event:C,url:f})=>(C.preventDefault(),f));this.disposables.add(m(C=>{const f=E(C);!f||this.urlService.open(f,{originalUrl:C})})),p.getWindows().filter(C=>C.isReady).length>0?this.flush():D.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||k.push(I);k.length!==0&&(this.uris=k,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=b}),define(ee[211],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(ee[212],te([0,1,14,2,10,7]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends t.Disposable{constructor(){super();const E=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,E)}handleWebviewRequest(E,b){try{const P=L.URI.parse(E.url),k=R.validWebviewFilePaths.get(P.path);if(typeof k=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${k}`,p=D.FileAccess.asFileUri(I,j);return b(decodeURIComponent(p.fsPath))}else return b({error:-10})}catch{}return b({error:-2})}}e.WebviewProtocolProvider=R,R.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(ee[66],te([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function D(b){return!!b.folderUri}e.isFolderToOpen=D;function L(b){return!!b.fileUri}e.isFileToOpen=L;function R(b){const P=y(b),k=b.getValue("window.menuBarVisibility");return k==="default"||P==="native"&&k==="compact"||v.isMacintosh&&v.isNative?"classic":k}e.getMenuBarVisibility=R;function y(b){if(v.isWeb)return"custom";const P=b.getValue("window");if(P){if(v.isMacintosh&&P.nativeTabs===!0||v.isMacintosh&&P.nativeFullScreen===!1)return"native";const p=b.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const g=P.titleBarStyle;if(g==="native"||g==="custom")return g}return v.isLinux?"native":"custom"}e.getTitleBarStyle=y;function E(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=E}),define(ee[104],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const D=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=D;var L;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(L=e.WindowMode||(e.WindowMode={}));var R;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(R=e.WindowError||(e.WindowError={}))}),define(ee[34],te([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(D){D[D.CLI=0]="CLI",D[D.DOCK=1]="DOCK",D[D.MENU=2]="MENU",D[D.DIALOG=3]="DIALOG",D[D.DESKTOP=4]="DESKTOP",D[D.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[213],te([0,1,14,23,4,71,2,31,62,95,6,19,34]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let g=class extends R.Disposable{constructor(m,S,C,f,u){super();this.logService=m,this.windowsMainService=S,this.credentialsService=C,this.encryptionMainService=f,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(v.app,"login",(S,C,f,u,c)=>({event:S,webContents:C,req:f,authInfo:u,callback:c}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:S,req:C,callback:f}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&C.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(u?.username,u?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(m);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const S=String((0,L.hash)({scheme:m.scheme,host:m.host,port:m.port}));let C,f;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(l){const i=JSON.parse(await this.encryptionMainService.decrypt(l));C=i.username,f=i.password}}catch(l){this.logService.error(l)}if(this.state!==p.StoredCredentialsUsed&&typeof C=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:C,password:f};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:m,username:this.sessionCredentials?.username??C,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,y.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=p.LoginDialogShown;const r=await new Promise(l=>{const i=async(n,o,s)=>{if(o===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),s){const a={username:s.username,password:s.password};try{if(s.remember){const d=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,S,d)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(d){this.logService.error(d)}l({username:a.username,password:a.password})}else l(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=r,r}};g=he([re(0,P.ILogService),re(1,I.IWindowsMainService),re(2,E.ICredentialsMainService),re(3,b.IEncryptionMainService),re(4,k.IProductService)],g),e.ProxyAuthHandler=g}),define(ee[214],te([0,1,62,6,53,19,34,179]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let E=class extends y.BaseCredentialsMainService{constructor(P,k,I,p){super(P);this.environmentMainService=k,this.productService=I,this.windowsMainService=p,this.surfaceKeytarLoadError=g=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",g.message??g)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const P=await new Promise((k,I)=>{j(["keytar"],k,I)});return await P.findCredentials("test-keytar-loads"),this._keytarCache=P,this._keytarCache}};E=he([re(0,t.ILogService),re(1,D.INativeEnvironmentService),re(2,L.IProductService),re(3,R.IWindowsMainService)],E),e.CredentialsNativeMainService=E}),define(ee[215],te([0,1,14,4,2,212,34]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let y=class extends D.Disposable{constructor(b){super();this.windowsMainService=b,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new L.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(b,P){let k;if(typeof b.windowId=="number"){const{windowId:I}=b,p=this.windowsMainService.getWindowById(I);if(!p?.win)throw new Error(`Invalid windowId: ${I}`);k=p.win.webContents}else{const{webContentsId:I}=b;if(k=v.webContents.fromId(I),!k)throw new Error(`Invalid webContentsId: ${I}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(P)}async findInFrame(b,P,k,I){const g=this.getFrameByName(b,P);if(typeof g.findInFrame=="function"){g.findInFrame(k,{findNext:I.findNext,forward:I.forward});const h=(m,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),g.removeListener("found-in-frame",h))};g.on("found-in-frame",h)}}async stopFindInFrame(b,P,k){const p=this.getFrameByName(b,P);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(b,P){const k=this.windowsMainService.getWindowById(b.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${b}`);const I=k.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===P);if(!I)throw new Error(`Unknown frame: ${P}`);return I}};y=he([re(0,R.IWindowsMainService)],y),e.WebviewMainService=y}),define(ee[216],te([0,1,9,4,2]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends D.Disposable{constructor({onDidOpenWindow:y,onDidFocusWindow:E,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),t.Event.latch(t.Event.any(y,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>b()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(y){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=y}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ee[25],te([0,1,157,8,35,16,7,5,10]),function(j,e,v,t,D,L,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function b(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=b;function P(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=P;function k(i){const n=i;return typeof n?.id=="string"&&R.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=k;function I(i){const n=i;if(n?.uri)return{id:n.id,uri:R.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:R.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=I;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=g;function h(i){const n=i;return!!(n&&typeof n=="object"&&R.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class m{constructor(n,o,s,a,d){this._id=n,this._transient=s,this._configuration=a,this._ignorePathCasing=d,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n.with({scheme:n.scheme,authority:n.authority,path:n.path}))||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class S{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function C(i){return new S({uri:i,index:0,name:(0,L.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return L.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return R.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=c;function r(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=r;function l(i){return(typeof i=="string"?(0,t.extname)(i):(0,L.extname)(i))===f}e.hasWorkspaceFileExtension=l}),define(ee[47],te([0,1,14,9,71,33,2,72,8,3,11,20,139,5,6,41,25]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let S=class It{constructor(f,u){this.stateMainService=f,this.logService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(f,u){return this.doPick({...f,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},u)}pickFolder(f,u){return this.doPick({...f,pickFolders:!0,title:(0,I.localize)(1,null)},u)}pickFile(f,u){return this.doPick({...f,pickFiles:!0,title:(0,I.localize)(2,null)},u)}pickWorkspace(f,u){const c=(0,I.localize)(3,null),r=(0,L.mnemonicButtonLabel)((0,I.localize)(4,null)),l=m.WORKSPACE_FILTER;return this.doPick({...f,pickFiles:!0,title:c,filters:l,buttonLabel:r},u)}async doPick(f,u){const c={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters};c.defaultPath=f.defaultPath||this.stateMainService.getItem(It.workingDirPickerStorageKey),(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(c.properties=void 0,f.pickFiles&&f.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),b.isMacintosh&&c.properties.push("treatPackageAsDirectory");const r=u||v.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(c,(0,P.withNullAsUndefined)(r));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(It.workingDirPickerStorageKey,(0,E.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(f){if(f){let u=this.windowDialogQueues.get(f.id);return u||(u=new t.Queue,this.windowDialogQueues.set(f.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(f,u){return this.getWindowDialogQueue(u).queue(async()=>u?v.dialog.showMessageBox(u,f):v.dialog.showMessageBox(f))}async showSaveDialog(f,u){const c=this.acquireFileDialogLock(f,u);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(u).queue(async()=>{let r;return u?r=await v.dialog.showSaveDialog(u,f):r=await v.dialog.showSaveDialog(f),r.filePath=this.normalizePath(r.filePath),r})}finally{(0,R.dispose)(c)}}normalizePath(f){return f&&b.isMacintosh&&(f=(0,y.normalizeNFC)(f)),f}normalizePaths(f){return f.map(u=>this.normalizePath(u))}async showOpenDialog(f,u){f.defaultPath&&(await k.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const c=this.acquireFileDialogLock(f,u);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(u).queue(async()=>{let r;return u?r=await v.dialog.showOpenDialog(u,f):r=await v.dialog.showOpenDialog(f),r.filePaths=this.normalizePaths(r.filePaths),r})}finally{(0,R.dispose)(c)}}acquireFileDialogLock(f,u){if(!u)return R.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",f);let c=this.windowFileDialogLocks.get(u.id);c||(c=new Set,this.windowFileDialogLocks.set(u.id,c));const r=(0,D.hash)(f);if(!c.has(r))return this.logService.trace("[DialogMainService]: new file dialog lock created",f),c.add(r),(0,R.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",f),c?.delete(r),c?.size===0&&this.windowFileDialogLocks.delete(u.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=he([re(0,h.IStateMainService),re(1,g.ILogService)],S),e.DialogMainService=S}),define(ee[217],te([0,1,4,2,25]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class L extends t.Disposable{constructor(y,E){super();this.logService=y,this.storageMainService=E,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(y,E)=>(y?y.push(E):y=[E],y),L.STORAGE_CHANGE_DEBOUNCE_TIME)(y=>{y.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(y))}))}serializeGlobalStorageEvents(y){const E=new Map,b=new Set;return y.forEach(P=>{const k=this.storageMainService.globalStorage.get(P.key);typeof k=="string"?E.set(P.key,k):b.add(P.key)}),{changed:Array.from(E.entries()),deleted:Array.from(b.values())}}listen(y,E){switch(E){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${E}`)}async call(y,E,b){const P=(0,D.reviveIdentifier)(b.workspace),k=await this.withStorageInitialized(P);switch(E){case"getItems":return Array.from(k.items.entries());case"updateItems":{const I=b;if(I.insert)for(const[p,g]of I.insert)k.set(p,g);I.delete&&I.delete.forEach(p=>k.delete(p));break}default:throw new Error(`Call not found: ${E}`)}}async withStorageInitialized(y){const E=y?this.storageMainService.workspaceStorage(y):this.storageMainService.globalStorage;try{await E.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${y?"workspace":"global"} storage due to ${b}`)}return E}}e.StorageDatabaseChannel=L,L.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[218],te([0,1,26,9,4,2,8,70,7,20,92,130,6,101,32,25]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends L.Disposable{constructor(c,r,l){super();this.logService=c,this.fileService=r,this.telemetryService=l,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new P.Storage(new P.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=P.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===P.StorageState.None)try{const c=await this.doCreate();this._storage.dispose(),this._storage=c,this._register(c.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(c);const r=c.getBoolean(p.IS_NEW_KEY);r===void 0?c.set(p.IS_NEW_KEY,!0):r&&c.set(p.IS_NEW_KEY,!1)}catch(c){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.state=P.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===I.LogLevel.Trace?c=>this.logService.trace(c):void 0,logError:c=>this.logService.error(c)}}doInit(c){return c.init()}get items(){return this._storage.items}get(c,r){return this._storage.get(c,r)}set(c,r){return this._storage.set(c,r)}delete(c){return this._storage.delete(c)}async close(){const c=new y.StopWatch(!1);await this.doClose(),c.stop(),c.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(c),this._onDidCloseStorage.fire()}async logSlowClose(c){if(!!this.path)try{const r=(0,v.top)(Array.from(this._storage.items.entries()).map(([i,n])=>({key:i,length:n.length})),(i,n)=>n.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),l=(await this.fileService.stat(E.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${l}b, Large Keys: ${r}`),this.telemetryService.publicLog2("storageSlowClose",{duration:c.elapsed(),size:l,largestEntries:r})}catch(r){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=P.StorageState.Closed,await this._storage.close()}}m.LOG_SLOW_CLOSE_THRESHOLD=300;class S extends m{constructor(c,r,l,i,n){super(r,i,n);this.options=c,this.environmentService=l}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.globalStorageHome.fsPath,S.STORAGE_NAME)}async doCreate(){return new P.Storage(new k.SQLiteStorageDatabase(this.path??k.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}async doInit(c){await super.doInit(c),this.updateTelemetryState(c)}updateTelemetryState(c){c.get(g.firstSessionDateStorageKey,void 0)===void 0&&c.set(g.firstSessionDateStorageKey,new Date().toUTCString());const l=c.get(g.currentSessionDateStorageKey,void 0),i=new Date().toUTCString();c.set(g.lastSessionDateStorageKey,typeof l=="undefined"?null:l),c.set(g.currentSessionDateStorageKey,i)}}e.GlobalStorageMain=S,S.STORAGE_NAME="state.vscdb";class C extends m{constructor(c,r,l,i,n,o){super(l,n,o);this.workspace=c,this.options=r,this.environmentService=i}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,C.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:c,wasCreated:r}=await this.prepareWorkspaceStorageFolder();return new P.Storage(new k.SQLiteStorageDatabase(c,{logging:this.createLoggingOptions()}),{hint:r?P.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:k.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,R.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),r=(0,R.join)(c,C.WORKSPACE_STORAGE_NAME);return await b.Promises.exists(c)?{storageFilePath:r,wasCreated:!1}:(await b.Promises.mkdir(c,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(c),{storageFilePath:r,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(c){let r;if((0,h.isSingleFolderWorkspaceIdentifier)(this.workspace)?r={folder:this.workspace.uri.toString()}:(0,h.isWorkspaceIdentifier)(this.workspace)&&(r={workspace:this.workspace.configPath.toString()}),r)try{const l=(0,R.join)(c,C.WORKSPACE_META_NAME);await b.Promises.exists(l)||await b.Promises.writeFile(l,JSON.stringify(r,void 0,2))}catch(l){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=C,C.WORKSPACE_STORAGE_NAME="state.vscdb",C.WORKSPACE_META_NAME="workspace.json";class f extends m{get path(){}async doCreate(){return new P.Storage(new P.InMemoryStorageDatabase)}}e.InMemoryStorageMain=f}),define(ee[105],te([0,1,16,7,25]),function(j,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function L(E,b,P){for(const I of E){const p=I.openedWorkspace;if((0,D.isWorkspaceIdentifier)(p)){const g=P(p);if(g){if(g.folders.some(h=>v.extUriBiasedIgnorePathCase.isEqualOrParent(b,h.uri)))return I}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(b,p.configPath))return I}}const k=E.filter(I=>(0,D.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(b,I.openedWorkspace.uri));if(k.length)return k.sort((I,p)=>-(I.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=L;function R(E,b){for(const P of E)if((0,D.isWorkspaceIdentifier)(P.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.configPath,b)||(0,D.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.uri,b))return P}e.findWindowOnWorkspaceOrFolder=R;function y(E,b){const P=k=>b.some(I=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(I),t.URI.file(k)));for(const k of E)if(k.config?.extensionDevelopmentPath?.some(I=>P(I)))return k}e.findWindowOnExtensionDevelopmentPath=y}),define(ee[219],te([0,1,14,2,3,16,7,17,22,6,41,34,104,25]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let g=class kt extends t.Disposable{constructor(u,c,r,l,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=r,this.logService=l,this.configurationService=i,this._state=h(this.stateMainService.getItem(kt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let l=this.windowsMainService.getLastActiveWindow();(!l||l.isExtensionDevelopmentHost)&&(l=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),l&&(u.lastActiveWindow=this.toWindowState(l))}const c=this.windowsMainService.getWindows().find(l=>l.isExtensionDevelopmentHost&&!l.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(l=>!l.isExtensionDevelopmentHost).map(l=>this.toWindowState(l)));const r=S(u);this.stateMainService.setItem(kt.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(r=>{const l=(0,p.isWorkspaceIdentifier)(u.openedWorkspace)&&r.workspace?.id===u.openedWorkspace.id,i=(0,p.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&r.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(r.folderUri,u.openedWorkspace.uri);(l||i)&&(r.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,p.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,p.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),r=this.configurationService.getValue("window");let l;return c.hasDefaultState?l=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):(l=!!(this.lifecycleMainService.wasRestarted||r?.restoreFullscreen),l&&D.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(l=!1)),c.mode===3&&!l&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const s=u.workspace;if((0,p.isWorkspaceIdentifier)(s)){const d=this.state.openedWindows.filter(w=>w.workspace&&w.workspace.id===s.id).map(w=>w.uiState);if(d.length)return d[0]}if((0,p.isSingleFolderWorkspaceIdentifier)(s)){const d=this.state.openedWindows.filter(w=>w.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(w.folderUri,s.uri)).map(w=>w.uiState);if(d.length)return d[0]}else if(u.backupPath){const d=this.state.openedWindows.filter(w=>w.backupPath===u.backupPath).map(w=>w.uiState);if(d.length)return d[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!c&&a)return a.uiState}let r;const l=v.screen.getAllDisplays();if(l.length===1)r=l[0];else{if(D.isMacintosh){const s=v.screen.getCursorScreenPoint();r=v.screen.getDisplayNearestPoint(s)}!r&&c&&(r=v.screen.getDisplayMatching(c.getBounds())),r||(r=v.screen.getPrimaryDisplay()||l[0])}let i=(0,I.defaultWindowState)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const s=c.serializeWindowState();s.mode===3?i.mode=3:i=s,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(r=>r.getBounds());for(;c.some(r=>r.x===u.x||r.y===u.y);)u.x+=30,u.y+=30;return u}};g.windowsStateStorageKey="windowsState",g=he([re(0,k.IWindowsMainService),re(1,P.IStateMainService),re(2,E.ILifecycleMainService),re(3,b.ILogService),re(4,y.IConfigurationService)],g),e.WindowsStateHandler=g;function h(f){const u={openedWindows:[]},c=f||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=m(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(r=>m(r))),u}e.restoreWindowsState=h;function m(f){const u={uiState:f.uiState};return f.backupPath&&(u.backupPath=f.backupPath),f.remoteAuthority&&(u.remoteAuthority=f.remoteAuthority),f.folder&&(u.folderUri=R.URI.parse(f.folder)),f.workspaceIdentifier&&(u.workspace={id:f.workspaceIdentifier.id,configPath:R.URI.parse(f.workspaceIdentifier.configURIPath)}),u}function S(f){return{lastActiveWindow:f.lastActiveWindow&&C(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&C(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(u=>C(u))}}e.getWindowsStateStoreData=S;function C(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(ee[81],te([0,1,29,45,112,33,10,8,3,16,7,5,79,25]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function g(w){return w.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function h(w){return w.hasOwnProperty("folderUri")}e.isRecentFolder=h;function m(w){return w.hasOwnProperty("fileUri")}e.isRecentFile=m;function S(w){return C(w)||f(w)}e.isStoredWorkspaceFolder=S;function C(w){const M=w;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function f(w){const M=w;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function u(w,M,A,F,H=!E.isWindows,Y){if(w.scheme!==F.scheme)return{name:A,uri:w.toString(!0)};let ie=M?void 0:Y.relativePath(F,w);if(ie!==void 0)ie.length===0?ie=".":E.isWindows&&w.scheme===R.Schemas.file&&!H&&(ie=ie.replace(/\//g,"\\"));else if(w.scheme===R.Schemas.file)ie=w.fsPath,E.isWindows&&(ie=(0,L.normalizeDriveLetter)(ie),H&&(ie=(0,v.toSlashes)(ie)));else{if(!Y.isEqualAuthority(w.authority,F.authority))return{name:A,uri:w.toString(!0)};ie=w.path}return{name:A,path:ie}}e.getStoredWorkspaceFolder=u;function c(w,M,A){let F=[],H=new Set;const Y=A.dirname(M);for(let ie of w){let X;if(C(ie))ie.path&&(X=A.resolvePath(Y,ie.path));else if(f(ie))try{X=P.URI.parse(ie.uri),X.path[0]!=="/"&&(X=X.with({path:"/"+X.path}))}catch(z){console.warn(z)}if(X){let z=A.getComparisonKey(X);if(!H.has(z)){H.add(z);const x=ie.name||A.basenameOrAuthority(X);F.push(new p.WorkspaceFolder({uri:X,name:x,index:F.length},ie))}}}return F}e.toWorkspaceFolders=c;function r(w,M,A,F,H){let Y=l(M,w);const ie=H.dirname(M),X=H.dirname(F),z=[],x=i(Y.folders);for(const $ of Y.folders){const Q=C($)?H.resolvePath(ie,$.path):P.URI.parse($.uri);let q;A?q=!1:q=!C($)||(0,y.isAbsolute)($.path),z.push(u(Q,q,$.name,X,x,H))}const Z={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},V=D.setProperty(w,["folders"],z,Z);let B=D.applyEdits(w,V);return(0,b.isEqualAuthority)(Y.remoteAuthority,(0,I.getRemoteAuthority)(F))&&(B=D.applyEdits(B,D.removeProperty(B,["remoteAuthority"],Z))),B}e.rewriteWorkspaceFileForNewLocation=r;function l(w,M){let A=t.parse(M);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(F=>S(F));else throw new Error(`${w} looks like an invalid workspace file.`);return A}function i(w){return E.isWindows?w.some(M=>C(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=i;function n(w){return w.workspace&&typeof w.workspace=="object"&&typeof w.workspace.id=="string"&&typeof w.workspace.configPath=="string"}function o(w){return typeof w.folderUri=="string"}function s(w){return typeof w.fileUri=="string"}function a(w,M){const A={workspaces:[],files:[]};if(w){const F=function(Y,ie){for(let X=0;X<Y.length;X++)try{ie(Y[X],X)}catch(z){M.warn(`Error restoring recent entry ${JSON.stringify(Y[X])}: ${z.toString()}. Skip entry.`)}},H=w;Array.isArray(H.entries)&&F(H.entries,Y=>{const ie=Y.label,X=Y.remoteAuthority;n(Y)?A.workspaces.push({label:ie,remoteAuthority:X,workspace:{id:Y.workspace.id,configPath:P.URI.parse(Y.workspace.configPath)}}):o(Y)?A.workspaces.push({label:ie,remoteAuthority:X,folderUri:P.URI.parse(Y.folderUri)}):s(Y)&&A.files.push({label:ie,remoteAuthority:X,fileUri:P.URI.parse(Y.fileUri)})})}return A}e.restoreRecentlyOpened=a;function d(w){const M={entries:[]};for(const A of w.workspaces)h(A)?M.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):M.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of w.files)M.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return M}e.toStoreData=d}),define(ee[106],te([0,1,60,30,10,3,16]),function(j,e,v,t,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function y(b){function P(){let k=b.scheme===D.Schemas.file?(0,R.originalFSPath)(b):b.toString();return L.isLinux||(k=k.toLowerCase()),(0,v.createHash)("md5").update(k).digest("hex")}return{id:P(),configPath:b}}e.getWorkspaceIdentifier=y;function E(b,P){function k(){if(b.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(b.toString()).digest("hex");if(!P)try{P=(0,t.statSync)(b.fsPath)}catch{return}let p;return L.isLinux?p=P.ino:L.isMacintosh?p=P.birthtime.getTime():L.isWindows&&(typeof P.birthtimeMs=="number"?p=Math.floor(P.birthtimeMs):p=P.birthtime.getTime()),(0,v.createHash)("md5").update(b.fsPath).update(p?String(p):"").digest("hex")}const I=k();if(typeof I=="string")return{id:I,uri:b}}e.getSingleFolderWorkspaceIdentifier=E}),define(ee[220],te([0,1,15,4,10,6,245,119,22,70]),function(j,e,v,t,D,L,R,y,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class P{constructor(g,h){this._worker=new R.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",g),this._worker.on("error",h),this.onError=t.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=t.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=t.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(g,h){this._worker.postMessage(g,h)}dispose(){this._worker.terminate()}}let k=class{constructor(g){this._logService=g}async logInfo(g){this._logService.info(g)}};k=he([re(0,L.ILogService)],k);let I=class{constructor(g,h){this._logService=g,this._shutdown=!1,this._proxy=null;const m={create:(S,C,f)=>{const u=new P(C,f);return u.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),u.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),u.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),u.postMessage(S,[]),u}};this._worker=new y.SimpleWorkerClient(m,"vs/platform/extensions/node/extensionHostStarterWorker",new k(this._logService)),this._initialize(),h.onWillShutdown(S=>{this._shutdown=!0,this._proxy&&S.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(g){return this._proxy.onDynamicStdout(g)}onDynamicStderr(g){return this._proxy.onDynamicStderr(g)}onDynamicMessage(g){return this._proxy.onDynamicMessage(g)}onDynamicError(g){return this._proxy.onDynamicError(g)}onDynamicExit(g){return this._proxy.onDynamicExit(g)}async createExtensionHost(){const g=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return g.createExtensionHost()}async start(g,h){const m=b.StopWatch.create(!1),S=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();const C=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),f=await S.start(g,h),u=m.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${u} ms.`),clearTimeout(C),f}async enableInspectPort(g){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return h.enableInspectPort(g)}async kill(g){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return h.kill(g)}};I=he([re(0,L.ILogService),re(1,E.ILifecycleMainService)],I),e.WorkerMainProcessExtensionHostStarter=I}),define(ee[82],te([0,1,60,61,27,18,15,4,2,8,3,31,38,90,221]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(M,A=""){this.debugLabel=A,this.socket=M,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,R.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}traceSocketEvent(M,A){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,M,A)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(M){const A=F=>{this.traceSocketEvent("read",F),M(L.VSBuffer.wrap(F))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(M){const A=F=>{this.traceSocketEvent("close",{hadError:F}),M({type:0,hadError:F,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(M){const A=()=>{this.traceSocketEvent("nodeEndReceived"),M()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(M){if(!this.socket.destroyed)try{this.traceSocketEvent("write",M),this.socket.write(M.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((M,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),M();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),M()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=h;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var S;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(S||(S={}));class C extends E.Disposable{constructor(M,A,F,H){super();this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=M,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:F?.byteLength||0,recordInflateBytes:H}),this._flowManager=this._register(new f(this,A,F,H,this._onData,(Y,ie)=>this._write(Y,ie))),this._register(this._flowManager.onError(Y=>{console.error(Y),(0,R.onUnexpectedError)(Y),this._onClose.fire({type:0,hadError:!0,error:Y})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(Y=>this._acceptChunk(Y))),this._register(this.socket.onClose(Y=>this._onClose.fire(Y)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(M,A){this.socket.traceSocketEvent(M,A)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(M){return this._onData.event(M)}onClose(M){return this._onClose.event(M)}onEnd(M){return this.socket.onEnd(M)}write(M){this._flowManager.writeMessage(M)}_write(M,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",M);let F=2;M.byteLength<126?F+=0:M.byteLength<2**16?F+=2:F+=8;const H=L.VSBuffer.alloc(F);if(A?H.writeUInt8(194,0):H.writeUInt8(130,0),M.byteLength<126)H.writeUInt8(M.byteLength,1);else if(M.byteLength<2**16){H.writeUInt8(126,1);let Y=1;H.writeUInt8(M.byteLength>>>8&255,++Y),H.writeUInt8(M.byteLength>>>0&255,++Y)}else{H.writeUInt8(127,1);let Y=1;H.writeUInt8(0,++Y),H.writeUInt8(0,++Y),H.writeUInt8(0,++Y),H.writeUInt8(0,++Y),H.writeUInt8(M.byteLength>>>24&255,++Y),H.writeUInt8(M.byteLength>>>16&255,++Y),H.writeUInt8(M.byteLength>>>8&255,++Y),H.writeUInt8(M.byteLength>>>0&255,++Y)}this.socket.write(L.VSBuffer.concat([H,M]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(M){if(M.byteLength!==0){for(this._incomingData.acceptChunk(M);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),F=A.readUInt8(0),H=(F&128)>>>7,Y=(F&64)>>>6,ie=A.readUInt8(1),X=(ie&128)>>>7,z=ie&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=H,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(Y)),this._state.firstFrameOfMessage=Boolean(H),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),F=A.readUInt8(1),H=(F&128)>>>7;let Y=F&127,ie=1;Y===126?Y=A.readUInt8(++ie)*2**8+A.readUInt8(++ie):Y===127&&(Y=A.readUInt8(++ie)*0+A.readUInt8(++ie)*0+A.readUInt8(++ie)*0+A.readUInt8(++ie)*0+A.readUInt8(++ie)*2**24+A.readUInt8(++ie)*2**16+A.readUInt8(++ie)*2**8+A.readUInt8(++ie));let X=0;H&&(X=A.readUInt8(++ie)*2**24+A.readUInt8(++ie)*2**16+A.readUInt8(++ie)*2**8+A.readUInt8(++ie)),this._state.state=3,this._state.readLen=Y,this._state.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),r(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class f extends E.Disposable{constructor(M,A,F,H,Y,ie){super();this._tracer=M,this._onData=Y,this._writeFn=ie,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new u(this._tracer,H,F,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(X=>this._onError.fire(X))),this._register(this._zlibDeflateStream.onError(X=>this._onError.fire(X)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(M){this._writeQueue.push(M),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const M=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,M);this._writeFn(A,!0)}else this._writeFn(M,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(M,A){return new Promise((F,H)=>{M.write(A),M.flush(Y=>F(Y))})}acceptFrame(M,A,F){this._readQueue.push({data:M,isCompressed:A,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const M=this._readQueue.shift();if(this._zlibInflateStream&&M.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,M.data,M.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(M.data)}this._isProcessingReadQueue=!1}}_inflateFrame(M,A,F){return new Promise((H,Y)=>{M.write(A),F&&M.write(L.VSBuffer.fromByteArray([0,0,255,255])),M.flush(ie=>H(ie))})}}class u extends E.Disposable{constructor(M,A,F,H){super();this._tracer=M,this._recordInflateBytes=A,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(H),this._zlibInflate.on("error",Y=>{this._tracer.traceSocketEvent("zlibInflateError",{message:Y?.message,code:Y?.code}),this._onError.fire(Y)}),this._zlibInflate.on("data",Y=>{this._tracer.traceSocketEvent("zlibInflateData",Y),this._pendingInflateData.push(L.VSBuffer.wrap(Y))}),F&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(M){this._recordInflateBytes&&this._recordedInflateBytes.push(M.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",M),this._zlibInflate.write(M.buffer)}flush(M){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,M(A)})}}class c extends E.Disposable{constructor(M,A){super();this._tracer=M,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent("zlibDeflateData",F),this._pendingDeflateData.push(L.VSBuffer.wrap(F))})}write(M){this._tracer.traceSocketEvent("zlibDeflateWrite",M.buffer),this._zlibDeflate.write(M.buffer)}flush(M){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),M(A)})}}function r(w,M){if(M===0)return;let A=w.byteLength>>>2;for(let z=0;z<A;z++){const x=w.readUInt32BE(z*4);w.writeUInt32BE(x^M,z*4)}let F=A*4,H=w.byteLength-F;const Y=M>>>24&255,ie=M>>>16&255,X=M>>>8&255;H>=1&&w.writeUInt8(w.readUInt8(F)^Y,F),H>=2&&w.writeUInt8(w.readUInt8(F+1)^ie,F+1),H>=3&&w.writeUInt8(w.readUInt8(F+2)^X,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function i(){const w=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let M;return e.XDG_RUNTIME_DIR?M=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):M=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${w}.sock`),o(M),M}e.createRandomIPCHandle=i;function n(w,M,A){const F=(0,v.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${M}-sock`;let H;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?H=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${A}-${M}.sock`):H=(0,b.join)(w,`${A}-${M}.sock`),o(H),H}e.createStaticIPCHandle=n;function o(w){const M=l[P.platform];typeof M=="number"&&w.length>=M&&console.warn(`WARNING: IPC handle "${w}" is longer than ${M} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(M){super(s.toClientConnectionEvent(M));this.server=M}static toClientConnectionEvent(M){const A=y.Event.fromNodeEventEmitter(M,"connection");return y.Event.map(A,F=>({protocol:new p.Protocol(new h(F,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(w){return new Promise((M,A)=>{const F=(0,t.createServer)();F.on("error",A),F.listen(w,()=>{F.removeListener("error",A),M(new s(F))})})}e.serve=a;function d(w,M){return new Promise((A,F)=>{const H=(0,t.createConnection)(w,()=>{H.removeListener("error",F),A(p.Client.fromSocket(new h(H,`ipc-client${M}`),M))});H.once("error",F)})}e.connect=d}),define(ee[24],te([0,1,48,8,82,53,166,5]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(L.IEnvironmentService);class E extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],E.prototype,"cachedLanguagesPath",null),he([v.memoize],E.prototype,"backupHome",null),he([v.memoize],E.prototype,"backupWorkspacesPath",null),he([v.memoize],E.prototype,"mainIPCHandle",null),he([v.memoize],E.prototype,"mainLockfile",null),he([v.memoize],E.prototype,"sandbox",null),he([v.memoize],E.prototype,"disableUpdates",null),he([v.memoize],E.prototype,"disableKeytar",null),he([v.memoize],E.prototype,"codeCachePath",null),he([v.memoize],E.prototype,"useCodeCache",null),e.EnvironmentMainService=E}),define(ee[222],te([0,1,60,30,29,10,8,3,16,7,20,161,17,24,21,6,160,25]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let C=class{constructor(u,c,r){this.configurationService=c,this.logService=r,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=E.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(l,i)=>(0,D.isEqual)(l,i,!y.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await P.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(l=>({workspace:{id:l.id,configPath:b.URI.parse(l.configURIPath)},remoteAuthority:l.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let r=[];try{Array.isArray(u.folderWorkspaceInfos)?r=u.folderWorkspaceInfos.map(l=>({folderUri:b.URI.parse(l.folderUri),remoteAuthority:l.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(r=u.folderURIWorkspaces.map(l=>({folderUri:b.URI.parse(l),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(r),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==g.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(l=>u.workspace.id===l.workspace.id)||(this.workspaces.push(u),this.saveSync());const r=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(r,c),r}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(r){this.logService.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,r=this.workspaces.findIndex(l=>l.workspace.id===c);r!==-1&&(this.workspaces.splice(r,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(r=>this.backupUriComparer.isEqual(u,r.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const r=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,r))||(this.emptyWindows.push({backupFolder:r,remoteAuthority:c}),this.saveSync()),this.getBackupPath(r)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,R.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,r=[];for(let l of u){const i=l.workspace;if(!(0,S.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==L.Schemas.file||await P.Promises.exists(i.configPath.fsPath)?r.push(l):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return r}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],r=new Set;for(let l of u){const i=l.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!r.has(n)){r.add(n);const o=this.getBackupPath(this.getFolderHash(l));await this.doHasBackups(o)?i.scheme!==L.Schemas.file||await P.Promises.exists(i.fsPath)?c.push(l):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],r=new Set;for(let l of u){const i=l.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(l):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await P.Promises.exists(u)&&await P.Promises.rm(u,P.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));)c=this.getRandomEmptyWindowId();const r=this.getBackupPath(c);try{await P.Promises.rename(u,r)}catch(l){return this.logService.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));)c=this.getRandomEmptyWindowId();const r=this.getBackupPath(c);try{t.renameSync(u,r)}catch(l){return this.logService.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,k.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,m.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await P.Promises.readdir(u);for(const r of c)try{if((await P.Promises.readdir((0,R.join)(u,r))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await P.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let r;return c.scheme===L.Schemas.file?r=y.isLinux?c.fsPath:c.fsPath.toLowerCase():r=c.toString().toLowerCase(),(0,v.createHash)("md5").update(r).digest("hex")}};C=he([re(0,p.IEnvironmentMainService),re(1,I.IConfigurationService),re(2,h.ILogService)],C),e.BackupMainService=C}),define(ee[223],te([0,1,61,82]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,L,R,y,E){const b=k=>E(k,void 0),P=v.createConnection({host:D,port:L},()=>{P.removeListener("error",b);const k=Buffer.alloc(16);for(let h=0;h<16;h++)k[h]=Math.round(Math.random()*256);const I=k.toString("base64"),p=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${L}/?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];P.write(p.join(`\r
`)+`\r
\r
`);const g=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",g),E(void 0,new t.NodeSocket(P,y)))};P.on("data",g)});P.setNoDelay(!0),P.once("error",b)}}}),define(ee[224],te([0,1,196,9,18,15,2,11,17,53,100,6,195,221]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let g=class extends R.Disposable{constructor(m,S,C){super();this.environmentService=S,this.logService=C,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,S){this.logService.trace("RequestService#request (node) - begin",m.url);const{proxyUrl:C,strictSSL:f}=this;let u;try{u=await(0,P.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",l))}const c={...process.env,...u},r=m.agent?m.agent:await(0,I.getProxyAgent)(m.url||"",c,{proxyUrl:C,strictSSL:f});m.agent=r,m.strictSSL=f,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization});try{const l=await this._request(m,S);return this.logService.trace("RequestService#request (node) - success",m.url),l}catch(l){throw this.logService.trace("RequestService#request (node) - error",m.url,l),l}}async getNodeRequest(m){return((0,v.parse)(m.url).protocol==="https:"?await new Promise((f,u)=>{j(["https"],f,u)}):await new Promise((f,u)=>{j(["http"],f,u)})).request}_request(m,S){return t.Promises.withAsyncBody(async(C,f)=>{let u;const c=(0,v.parse)(m.url),r=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,y.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password),u=r(l,i=>{const n=(0,y.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...m,url:i.headers.location,followRedirects:n-1},S).then(C,f);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,p.createGunzip)())),C({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}}),u.on("error",f),m.timeout&&u.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&u.write(m.data),u.end(),S.onCancellationRequested(()=>{u.abort(),f((0,L.canceled)())})})}async resolveProxy(m){}};g=he([re(0,E.IConfigurationService),re(1,b.INativeEnvironmentService),re(2,k.ILogService)],g),e.RequestService=g}),define(ee[225],te([0,1,14,224]),function(j,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(R){return v.net.request}class L extends t.RequestService{request(y,E){return super.request({...y||{},getRawRequest:D},E)}}e.RequestMainService=L}),define(ee[226],te([0,1,14,37,9,4,2,10,11,91,24,22,6,54,55,58,39]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let S=class extends R.Disposable{constructor(f,u,c,r,l,i,n){super();this.machineId=f,this.userEnv=u,this.environmentMainService=c,this.lifecycleMainService=r,this.logService=l,this.themeMainService=i,this.protocolMainService=n,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(f,u)=>this.onWindowConnection(f,u)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(f,u)=>this.onWorkerConnection(f,u)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(f,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(f.sender.isDestroyed())return c.close();f.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[c])}onWorkerConnection(f,u){this.logService.trace("SharedProcess: onWorkerConnection",u);const c=new R.DisposableStore,r=i=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${i}')`,u),c.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",u))},l=v.BrowserWindow.fromId(u.reply.windowId);if(!l||l.isDestroyed()||l.webContents.isDestroyed()||!u.reply.channel){r("unavailable");return}c.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,i=>i.window.win===l)(()=>r("load"))),c.add(L.Event.fromNodeEventEmitter(l,"closed")(()=>r("closed"))),l.webContents.postMessage(u.reply.channel,u.reply.nonce,f.ports)}onWillShutdown(){const f=this.window;!f||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(f.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{f.close()}catch{}this.window=void 0},0))}send(f,...u){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${f}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(f,...u)}catch(c){this.logService.warn(`Error sending IPC message to channel '${f}' of shared process: ${(0,m.toErrorMessage)(c)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(f=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),f()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(f=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),f()}))})()),this._whenIpcReady}createWindow(){const f=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${f.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),f.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:p.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=f=>{this.logService.trace("SharedProcess#close prevented"),f.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(f,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(f,u,c)=>this._onDidError.fire({type:3,details:{reason:c,exitCode:u}})))}async connect(){await this.whenIpcReady;const f=(0,E.assertIsDefined)(this.window);return(0,b.connect)(f)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const f=this.window;return f?!f.isDestroyed()&&!f.webContents.isDestroyed():!1}};S=he([re(2,P.IEnvironmentMainService),re(3,k.ILifecycleMainService),re(4,I.ILogService),re(5,h.IThemeMainService),re(6,g.IProtocolMainService)],S),e.SharedProcess=S}),define(ee[227],te([0,1,9,18,8,16,11,7,20,24,21,6]),function(j,e,v,t,D,L,R,y,E,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class I{constructor(h,m,S){this.storagePath=h,this.logService=m,this.fileService=S,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(h){h.fileOperationResult!==1&&this.logService.error(h)}}getItem(h,m){const S=this.storage[h];return(0,R.isUndefinedOrNull)(S)?m:S}setItem(h,m){this.setItems([{key:h,data:m}])}setItems(h){let m=!1;for(const{key:S,data:C}of h)this.storage[S]!==C&&((0,R.isUndefinedOrNull)(C)?(0,R.isUndefined)(this.storage[S])||(this.storage[S]=void 0,m=!0):(this.storage[S]=C,m=!0));m&&this.save()}removeItem(h){(0,R.isUndefined)(this.storage[h])||(this.storage[h]=void 0,this.save())}async save(h){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),h)}async doSave(){if(!this.initializing)return;await this.initializing;const h=JSON.stringify(this.storage,null,4);if(h!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(h)),this.lastSavedStorageContents=h}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=I;let p=class Pt{constructor(h,m,S){this.environmentMainService=h,this.logService=m,this.legacyStateFilePath=y.URI.file((0,D.join)(this.environmentMainService.userDataPath,Pt.STATE_FILE)),this.stateFilePath=(0,L.joinPath)(this.environmentMainService.globalStorageHome,Pt.STATE_FILE),this.fileStorage=new I(this.stateFilePath,m,S)}async init(){try{await E.Promises.move(this.legacyStateFilePath.fsPath,this.stateFilePath.fsPath)}catch(h){h.code!=="ENOENT"&&this.logService.error(h)}return this.fileStorage.init()}getItem(h,m){return this.fileStorage.getItem(h,m)}setItem(h,m){this.fileStorage.setItem(h,m)}setItems(h){this.fileStorage.setItems(h)}removeItem(h){this.fileStorage.removeItem(h)}close(){return this.fileStorage.close()}};p.STATE_FILE="storage.json",p=he([re(0,b.IEnvironmentMainService),re(1,k.ILogService),re(2,P.IFileService)],p),e.StateMainService=p}),define(ee[83],te([0,1,44,2,53,24,21,5,22,6,101,218,32]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,y.createDecorator)("storageMainService");let p=class extends t.Disposable{constructor(m,S,C,f,u){super();this.logService=m,this.environmentService=S,this.lifecycleMainService=C,this.fileService=f,this.telemetryService=u,this.shutdownReason=void 0,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(m=>{m.workspace&&this.workspaceStorage(m.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(m=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=m.reason,m.join(this.globalStorage.close());for(const[,S]of this.mapWorkspaceToStorage)m.join(S.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const m=new k.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService,this.fileService,this.telemetryService);return(0,v.once)(m.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),m}workspaceStorage(m){let S=this.mapWorkspaceToStorage.get(m.id);return S||(this.logService.trace(`StorageMainService: creating workspace storage (${m.id})`),S=this.createWorkspaceStorage(m),this.mapWorkspaceToStorage.set(m.id,S),(0,v.once)(S.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${m.id})`),this.mapWorkspaceToStorage.delete(m.id)})),S}createWorkspaceStorage(m){return this.shutdownReason===2?new k.InMemoryStorageMain(this.logService,this.fileService,this.telemetryService):new k.WorkspaceStorageMain(m,this.getStorageOptions(),this.logService,this.environmentService,this.fileService,this.telemetryService)}};p=he([re(0,b.ILogService),re(1,D.IEnvironmentService),re(2,E.ILifecycleMainService),re(3,R.IFileService),re(4,I.ITelemetryService)],p),e.StorageMainService=p,e.IGlobalStorageMainService=(0,y.createDecorator)("globalStorageMainService");let g=class extends P.AbstractStorageService{constructor(m,S){super();this.environmentMainService=m,this.storageMainService=S,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(m){switch(m){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(m){return m===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};g=he([re(0,L.IEnvironmentMainService),re(1,e.IStorageMainService)],g),e.GlobalStorageMainService=g}),define(ee[228],te([0,1,61,88,223,9,2,17,6,19,194,102,80]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(C,f,u,c,r){let l;for(let i=3;i&&(l&&l.dispose(),l=await new g(C,f,u,c,r).waitForReady(),!(r&&t.BROWSER_RESTRICTED_PORTS[r]||!t.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));i--);return l}class g extends R.Disposable{constructor(f,u,c,r,l){super();this.defaultTunnelHost=u,this.suggestedLocalPort=l,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=v.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(f){f.pause();const u=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,P.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),r=c.getSocket().socket,l=c.readEntireBuffer();c.dispose(),l.byteLength>0&&f.write(l.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),r.end()}),f.on("close",()=>r.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),r.destroy()}),r.on("end",()=>f.end()),r.on("close",()=>f.end()),r.on("error",()=>{f.destroy()}),f.pipe(r),r.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),r.end()})}}let h=class extends k.AbstractTunnelService{constructor(f,u,c,r,l){super(u);this.socketFactory=f,this.signService=c,this.productService=r,this.configurationService=l}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,u,c,r,l,i,n){const o=this.getTunnelFromMap(u,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,r,l,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},a=p(s,this.defaultTunnelHost,u,c,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,a),a}}};h=he([re(1,E.ILogService),re(2,I.ISignService),re(3,b.IProductService),re(4,y.IConfigurationService)],h),e.BaseTunnelService=h;let m=class extends h{constructor(f,u,c,r){super(D.nodeSocketFactory,f,u,c,r)}};m=he([re(0,E.ILogService),re(1,I.ISignService),re(2,b.IProductService),re(3,y.IConfigurationService)],m),e.TunnelService=m;let S=class extends R.Disposable{constructor(f,u,c,r){super();this.logService=f,this.productService=u,this.signService=c,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(f,u,c,r,l,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${r} on local port ${l}.`),!this._tunnelServices.has(f)){const s=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(f,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(u,c,r,l,i,n,o)}};S=he([re(0,E.ILogService),re(1,b.IProductService),re(2,I.ISignService),re(3,y.IConfigurationService)],S),e.SharedTunnelsService=S}),define(ee[84],te([0,1,9,23,4,17,24,22,6,19,57,42]),function(j,e,v,t,D,L,R,y,E,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(g,h,m){return`${m.updateUrl}/api/update/${g}/${h}/${m.commit}`}e.createUpdateURL=I;let p=class{constructor(h,m,S,C,f,u){this.lifecycleMainService=h,this.configurationService=m,this.environmentMainService=S,this.requestService=C,this.logService=f,this.productService=u,this._state=k.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=await this.getUpdateMode(),m=this.getProductQuality(h);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}async getUpdateMode(){return(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,v.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([re(0,y.ILifecycleMainService),re(1,L.IConfigurationService),re(2,R.IEnvironmentMainService),re(3,P.IRequestService),re(4,E.ILogService),re(5,b.IProductService)],p),e.AbstractUpdateService=p}),define(ee[229],te([0,1,14,48,4,2,17,24,22,6,19,57,32,42,84]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends g.AbstractUpdateService{constructor(S,C,f,u,c,r,l){super(S,C,u,c,r,l);this.telemetryService=f,this.disposables=new L.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(S,C)=>C)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(S,C,f)=>({url:C,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(S,C,f,u)=>({releaseNotes:C,version:f,productVersion:f,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(p.State.Idle(1,f))}buildUpdateFeedUrl(S){let C;this.productService.darwinUniversalAssetId?C=this.productService.darwinUniversalAssetId:C=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,g.createUpdateURL)(C,S,this.productService);try{v.autoUpdater.setFeedURL({url:f})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return f}doCheckForUpdates(S){this.setState(p.State.CheckingForUpdates(S)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(p.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([t.memoize],h.prototype,"onRawError",null),he([t.memoize],h.prototype,"onRawUpdateNotAvailable",null),he([t.memoize],h.prototype,"onRawUpdateAvailable",null),he([t.memoize],h.prototype,"onRawUpdateDownloaded",null),h=he([re(0,E.ILifecycleMainService),re(1,R.IConfigurationService),re(2,I.ITelemetryService),re(3,y.IEnvironmentMainService),re(4,k.IRequestService),re(5,b.ILogService),re(6,P.IProductService)],h),e.DarwinUpdateService=h}),define(ee[230],te([0,1,46,30,9,4,8,24,22,6,32,42]),function(j,e,v,t,D,L,R,y,E,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(h,m,S){if(this.lifecycleMainService=h,this.logService=S,this._state=k.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,C=>this.logService.error(C))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,D.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=he([re(0,E.ILifecycleMainService),re(1,y.IEnvironmentMainService),re(2,b.ILogService)],I);let p=class extends I{constructor(h,m,S,C,f,u){super(S,C,f);this.snap=h,this.snapRevision=m,this.telemetryService=u;const c=(0,t.watch)(R.dirname(this.snap)),r=L.Event.fromNodeEventEmitter(c,"change",(o,s)=>s),l=L.Event.filter(r,o=>o==="current"),n=L.Event.debounce(l,(o,s)=>s,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((S,C)=>(0,t.realpath)(`${R.dirname(this.snap)}/current`,(f,u)=>f?C(f):S(u))),m=R.basename(h);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([re(2,E.ILifecycleMainService),re(3,y.IEnvironmentMainService),re(4,b.ILogService),re(5,P.ITelemetryService)],p),e.SnapUpdateService=p}),define(ee[43],te([0,1,14,30,4,45,33,2,10,8,3,16,11,20,159,52,47,24,5,6,19,105,25,81,106]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let n=class extends y.Disposable{constructor(s,a,d,w,M){super();this.environmentMainService=s,this.logService=a,this.backupMainService=d,this.dialogMainService=w,this.productService=M,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(s){return this.doResolveLocalWorkspace(s,a=>(0,t.readFileSync)(a,"utf8"))}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,a=>p.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(s,a){if(!!this.isWorkspacePath(s)&&s.scheme===E.Schemas.file)try{const d=a(s.fsPath);return d instanceof Promise?d.then(w=>this.doResolveWorkspace(s,w),w=>{}):this.doResolveWorkspace(s,d)}catch{return}}isWorkspacePath(s){return(0,r.isUntitledWorkspace)(s,this.environmentMainService)||(0,r.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,a){try{const d=this.doParseStoredWorkspace(s,a),w=(0,i.getWorkspaceIdentifier)(s);return{id:w.id,configPath:w.configPath,folders:(0,l.toWorkspaceFolders)(d.folders,w.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:d.remoteAuthority,transient:d.transient}}catch(d){this.logService.warn(d.toString())}}doParseStoredWorkspace(s,a){const d=(0,L.parse)(a);if(d&&Array.isArray(d.folders))d.folders=d.folders.filter(w=>(0,l.isStoredWorkspaceFolder)(w));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return d}async createUntitledWorkspace(s,a){const{workspace:d,storedWorkspace:w}=this.newUntitledWorkspace(s,a),M=d.configPath.fsPath;return await p.Promises.mkdir((0,b.dirname)(M),{recursive:!0}),await p.Promises.writeFile(M,JSON.stringify(w,null,"	")),d}createUntitledWorkspaceSync(s,a){const{workspace:d,storedWorkspace:w}=this.newUntitledWorkspace(s,a),M=d.configPath.fsPath;return(0,t.mkdirSync)((0,b.dirname)(M),{recursive:!0}),(0,p.writeFileSync)(M,JSON.stringify(w,null,"	")),d}newUntitledWorkspace(s=[],a){const d=(Date.now()+Math.round(Math.random()*1e3)).toString(),w=(0,k.joinPath)(this.untitledWorkspacesHome,d),M=(0,k.joinPath)(w,r.UNTITLED_WORKSPACE_NAME),A=[];for(const F of s)A.push((0,l.getStoredWorkspaceFolder)(F.uri,!0,F.name,w,!P.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(M),storedWorkspace:{folders:A,remoteAuthority:a}}}async getWorkspaceIdentifier(s){return(0,i.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,r.isUntitledWorkspace)(s.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(s){!this.isUntitledWorkspace(s)||(this.doDeleteUntitledWorkspaceSync(s),this._onDidDeleteUntitledWorkspace.fire(s))}async deleteUntitledWorkspace(s){this.deleteUntitledWorkspaceSync(s)}doDeleteUntitledWorkspaceSync(s){const a=(0,k.originalFSPath)(s.configPath);try{(0,p.rimrafSync)((0,b.dirname)(a));const d=(0,b.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);(0,t.existsSync)(d)&&(0,p.writeFileSync)((0,b.join)(d,"obsolete"),"")}catch(d){this.logService.warn(`Unable to delete untitled workspace ${a} (${d}).`)}}getUntitledWorkspacesSync(){const s=[];try{const a=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(d=>(0,k.joinPath)(this.untitledWorkspacesHome,d,r.UNTITLED_WORKSPACE_NAME));for(const d of a){const w=(0,i.getWorkspaceIdentifier)(d),M=this.resolveLocalWorkspaceSync(d);M?s.push({workspace:w,remoteAuthority:M.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(w)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}return s}async enterWorkspace(s,a,d){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,a,d))return;const M=this.doEnterWorkspace(s,(0,i.getWorkspaceIdentifier)(d));if(!!M)return this._onDidEnterWorkspace.fire({window:s,workspace:M.workspace}),M}async isValidTargetWorkspacePath(s,a,d){if(!d)return!0;if((0,r.isWorkspaceIdentifier)(s.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,d))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(a,d)){const w={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,k.basename)(d)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(w,(0,I.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(s,a){if(!s.config)return;s.focus();let d;return s.config.extensionDevelopmentPath||(d=this.backupMainService.registerWorkspaceBackupSync({workspace:a,remoteAuthority:s.remoteAuthority},s.config.backupPath)),(0,r.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&this.deleteUntitledWorkspaceSync(s.openedWorkspace),s.config.workspace=a,s.config.backupPath=d,{workspace:a,backupPath:d}}};n=he([re(0,S.IEnvironmentMainService),re(1,f.ILogService),re(2,h.IBackupMainService),re(3,m.IDialogMainService),re(4,u.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ee[107],te([0,1,37,23,5,34,25,43]),function(j,e,v,t,D,L,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let E=class{constructor(P,k){this.windowsMainService=P,this.workspacesManagementMainService=k}async getRemoteDiagnostics(P){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(p=>new Promise(g=>{const h=p.remoteAuthority;if(h){const m=`vscode:getDiagnosticInfoResponse${p.id}`,S={includeProcesses:P.includeProcesses,folders:P.includeWorkspaceMetadata?this.getFolderURIs(p):void 0};p.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:m,args:S}),v.validatedIpcMain.once(m,(C,f)=>{f||g({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),g(f)}),setTimeout(()=>{g({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else g(void 0)})))).filter(p=>!!p)}getFolderURIs(P){const k=[],I=P.openedWorkspace;if((0,R.isSingleFolderWorkspaceIdentifier)(I))k.push(I.uri);else if((0,R.isWorkspaceIdentifier)(I)){const p=this.workspacesManagementMainService.resolveLocalWorkspaceSync(I.configPath);p&&p.folders.forEach(h=>{k.push(h.uri)})}return k}};E=he([re(0,L.IWindowsMainService),re(1,y.IWorkspacesManagementMainService)],E),e.DiagnosticsMainService=E}),define(ee[108],te([0,1,14,26,3,11,7,20,17,51,5,6,103,34,25,43]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let m=class{constructor(C,f,u,c,r){this.logService=C,this.windowsMainService=f,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=r}async start(C,f){this.logService.trace("Received data from other instance: ",C,f),D.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(C);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:r,url:l}of u)this.urlService.open(r,{originalUrl:l})})}else return this.startOpenWindow(C,f)}parseOpenUrl(C){return C["open-url"]&&C._urls&&C._urls.length>0?(0,t.coalesce)(C._urls.map(f=>{try{return{uri:R.URI.parse(f),url:f}}catch{return null}})):[]}async startOpenWindow(C,f){const u=(0,b.isLaunchedFromCli)(f)?0:4;let c=[];const r=C.wait&&C.waitMarkerFilePath?R.URI.file(C.waitMarkerFilePath):void 0,l=C.remote||void 0,i={context:u,cli:C,userEnv:f,waitMarkerFileURI:r,remoteAuthority:l};if(C.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(C.extensionDevelopmentPath,i);else if(!C._.length&&!C["folder-uri"]&&!C["file-uri"]){let n=!1;if(C["new-window"]||C["unity-launch"])n=!0;else if(C["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!D.isMacintosh}if(n)c=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),c=[o]):c=this.windowsMainService.open({...i,forceEmpty:!0})}}else c=this.windowsMainService.open({...i,forceNewWindow:C["new-window"],preferNewWindow:!C["reuse-window"]&&!C.wait,forceReuseWindow:C["reuse-window"],diffMode:C.diff,addMode:C.add,noRecentEntry:!!C["skip-add-to-recently-opened"],gotoLineMode:C.goto});if(r&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,y.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const C=[];return v.BrowserWindow.getAllWindows().forEach(f=>{const u=this.windowsMainService.getWindowById(f.id);u?C.push(this.codeWindowToInfo(u)):C.push(this.browserWindowToInfo(f))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:C,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}getFolderURIs(C){const f=[],u=C.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))f.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(l=>{f.push(l.uri)})}return f}codeWindowToInfo(C){const f=this.getFolderURIs(C),u=(0,L.assertIsDefined)(C.win);return this.browserWindowToInfo(u,f,C.remoteAuthority)}browserWindowToInfo(C,f=[],u){return{pid:C.webContents.getOSProcessId(),title:C.getTitle(),folderURIs:f,remoteAuthority:u}}};m=he([re(0,k.ILogService),re(1,p.IWindowsMainService),re(2,I.IURLService),re(3,h.IWorkspacesManagementMainService),re(4,E.IConfigurationService)],m),e.LaunchMainService=m}),define(ee[59],te([0,1,46,14,27,123,48,4,33,2,10,8,3,7,87,73,20,88,150,47,24,5,22,6,19,58,34,25,43]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l,i,n,o,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let d=class extends b.Disposable{constructor(M,A,F,H,Y,ie,X,z,x){super();this.sharedProcess=M,this.windowsMainService=A,this.dialogMainService=F,this.lifecycleMainService=H,this.environmentMainService=Y,this.logService=ie,this.productService=X,this.themeMainService=z,this.workspacesManagementMainService=x,this.onDidOpenWindow=y.Event.map(this.windowsMainService.onDidOpenWindow,Z=>Z.id),this.onDidMaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(Z,V)=>V.id),Z=>!!this.windowsMainService.getWindowById(Z)),this.onDidUnmaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(Z,V)=>V.id),Z=>!!this.windowsMainService.getWindowById(Z)),this.onDidBlurWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(Z,V)=>V.id),Z=>!!this.windowsMainService.getWindowById(Z)),this.onDidFocusWindow=y.Event.any(y.Event.map(y.Event.filter(y.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Z=>!!Z),Z=>Z.id),y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(Z,V)=>V.id),Z=>!!this.windowsMainService.getWindowById(Z))),this.onDidResumeOS=y.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new y.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=y.Event.debounce(y.Event.any(y.Event.filter(y.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(Z,V,B)=>B),Z=>!(Array.isArray(Z)&&Z.length===1&&Z[0]==="workArea")),y.Event.fromNodeEventEmitter(t.screen,"display-added"),y.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(A=>({id:A.id,workspace:A.openedWorkspace,title:A.win?.getTitle()??"",filename:A.getRepresentedFilename(),dirty:A.isDocumentEdited()}))}async getWindowCount(M){return this.windowsMainService.getWindowCount()}async getActiveWindowId(M){const A=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(A)return A.id}openWindow(M,A,F){return Array.isArray(A)?this.doOpenWindow(M,A,F):this.doOpenEmptyWindow(M,A)}async doOpenWindow(M,A,F=Object.create(null)){A.length>0&&this.windowsMainService.open({context:5,contextWindowId:M,urisToOpen:A,cli:this.environmentMainService.args,forceNewWindow:F.forceNewWindow,forceReuseWindow:F.forceReuseWindow,preferNewWindow:F.preferNewWindow,diffMode:F.diffMode,addMode:F.addMode,gotoLineMode:F.gotoLineMode,noRecentEntry:F.noRecentEntry,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:F.remoteAuthority||void 0})}async doOpenEmptyWindow(M,A){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:M},A)}async toggleFullScreen(M){const A=this.windowById(M);A&&A.toggleFullScreen()}async handleTitleDoubleClick(M){const A=this.windowById(M);A&&A.handleTitleDoubleClick()}async isMaximized(M){const A=this.windowById(M);return A?.win?A.win.isMaximized():!1}async maximizeWindow(M){const A=this.windowById(M);A?.win&&A.win.maximize()}async unmaximizeWindow(M){const A=this.windowById(M);A?.win&&A.win.unmaximize()}async minimizeWindow(M){const A=this.windowById(M);A?.win&&A.win.minimize()}async focusWindow(M,A){A&&typeof A.windowId=="number"&&(M=A.windowId);const F=this.windowById(M);F&&F.focus({force:A?.force??!1})}async setMinimumSize(M,A,F){const H=this.windowById(M);if(H?.win){const[Y,ie]=H.win.getSize(),[X,z]=H.win.getMinimumSize(),[x,Z]=[A??X,F??z],[V,B]=[Math.max(Y,x),Math.max(ie,Z)];(X!==x||z!==Z)&&H.win.setMinimumSize(x,Z),(Y!==V||ie!==B)&&H.win.setSize(V,B)}}async saveWindowSplash(M,A){this.themeMainService.saveWindowSplash(M,A)}async installShellCommand(M){const{source:A,target:F}=await this.getShellCommandLink();try{const{symbolicLink:H}=await m.SymlinkSupport.stat(A);if(H&&!H.dangling){const Y=await(0,g.realpath)(A);if(F===Y)return}await m.Promises.unlink(A)}catch(H){if(H.code!=="ENOENT")throw H}try{await m.Promises.symlink(F,A)}catch(H){if(H.code!=="EACCES"&&H.code!=="ENOENT")throw H;const{response:Y}=await this.showMessageBox(M,{title:this.productService.nameLong,type:"info",message:(0,C.localize)(0,null,this.productService.nameShort),buttons:[(0,E.mnemonicButtonLabel)((0,C.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,C.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(Y===0)try{const ie=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${F}' '${A}'\\" with administrator privileges"`;await(0,L.promisify)(v.exec)(ie)}catch{throw new Error((0,C.localize)(3,null,A))}}}async uninstallShellCommand(M){const{source:A}=await this.getShellCommandLink();try{await m.Promises.unlink(A)}catch(F){switch(F.code){case"EACCES":{const{response:H}=await this.showMessageBox(M,{title:this.productService.nameLong,type:"info",message:(0,C.localize)(4,null,this.productService.nameShort),buttons:[(0,E.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,E.mnemonicButtonLabel)((0,C.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(H===0)try{const Y=`osascript -e "do shell script \\"rm '${A}'\\" with administrator privileges"`;await(0,L.promisify)(v.exec)(Y)}catch{throw new Error((0,C.localize)(7,null,A))}break}case"ENOENT":break;default:throw F}}}async getShellCommandLink(){const M=(0,k.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),A=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(M))throw new Error((0,C.localize)(8,null,M));return{source:A,target:M}}async showMessageBox(M,A){return this.dialogMainService.showMessageBox(A,this.toBrowserWindow(M))}async showSaveDialog(M,A){return this.dialogMainService.showSaveDialog(A,this.toBrowserWindow(M))}async showOpenDialog(M,A){return this.dialogMainService.showOpenDialog(A,this.toBrowserWindow(M))}toBrowserWindow(M){const A=this.windowById(M);if(A?.win)return A.win}async pickFileFolderAndOpen(M,A){const F=await this.dialogMainService.pickFileFolder(A);F&&this.doOpenPicked(await Promise.all(F.map(async H=>await m.SymlinkSupport.existsDirectory(H)?{folderUri:p.URI.file(H)}:{fileUri:p.URI.file(H)})),A,M)}async pickFolderAndOpen(M,A){const F=await this.dialogMainService.pickFolder(A);F&&this.doOpenPicked(F.map(H=>({folderUri:p.URI.file(H)})),A,M)}async pickFileAndOpen(M,A){const F=await this.dialogMainService.pickFile(A);F&&this.doOpenPicked(F.map(H=>({fileUri:p.URI.file(H)})),A,M)}async pickWorkspaceAndOpen(M,A){const F=await this.dialogMainService.pickWorkspace(A);F&&this.doOpenPicked(F.map(H=>({workspaceUri:p.URI.file(H)})),A,M)}doOpenPicked(M,A,F){this.windowsMainService.open({context:3,contextWindowId:F,cli:this.environmentMainService.args,urisToOpen:M,forceNewWindow:A.forceNewWindow})}async showItemInFolder(M,A){t.shell.showItemInFolder(A)}async setRepresentedFilename(M,A){const F=this.windowById(M);F&&F.setRepresentedFilename(A)}async setDocumentEdited(M,A){const F=this.windowById(M);F&&F.setDocumentEdited(A)}async openExternal(M,A){return I.isLinuxSnap?this.safeSnapOpenExternal(A):t.shell.openExternal(A),!0}safeSnapOpenExternal(M){const A=process.env.GDK_PIXBUF_MODULE_FILE,F=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(M),process.env.GDK_PIXBUF_MODULE_FILE=A,process.env.GDK_PIXBUF_MODULEDIR=F}moveItemToTrash(M,A){return t.shell.trashItem(A)}async isAdmin(){let M;return I.isWindows?M=(await new Promise((A,F)=>{j(["native-is-elevated"],A,F)}))():M=process.getuid()===0,M}async writeElevated(M,A,F,H){const Y=await new Promise((ie,X)=>{j(["@vscode/sudo-prompt"],ie,X)});return new Promise((ie,X)=>{const z=[`"${this.cliPath}"`];H?.unlock&&z.push("--file-chmod"),z.push("--file-write",`"${A.fsPath}"`,`"${F.fsPath}"`);const x={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};Y.exec(z.join(" "),x,(Z,V,B)=>{V&&this.logService.trace(`[sudo-prompt] received stdout: ${V}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),Z?X(Z):ie(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(M,A,F){process.kill(A,F)}async readClipboardText(M,A){return t.clipboard.readText(A)}async writeClipboardText(M,A,F){return t.clipboard.writeText(A,F)}async readClipboardFindText(M){return t.clipboard.readFindText()}async writeClipboardFindText(M,A){return t.clipboard.writeFindText(A)}async writeClipboardBuffer(M,A,F,H){return t.clipboard.writeBuffer(A,Buffer.from(F),H)}async readClipboardBuffer(M,A){return t.clipboard.readBuffer(A)}async hasClipboard(M,A,F){return t.clipboard.has(A,F)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(M,A){const F=this.windowById(M);F&&F.updateTouchBar(A)}async notifyReady(M){const A=this.windowById(M);A&&A.setReady()}async relaunch(M,A){return this.lifecycleMainService.relaunch(A)}async reload(M,A){const F=this.windowById(M);if(F){if((0,s.isWorkspaceIdentifier)(F.openedWorkspace)){const H=F.openedWorkspace.configPath;if(H.scheme===P.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(H))?.transient)return this.openWindow(F.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(F,A?.disableExtensions!==void 0?{_:[],"disable-extensions":A.disableExtensions}:void 0)}}async closeWindow(M){this.closeWindowById(M,M)}async closeWindowById(M,A){const F=this.windowById(A);if(F?.win)return F.win.close()}async quit(M){const A=this.windowsMainService.getLastActiveWindow();A?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&A.win?A.win.close():this.lifecycleMainService.quit()}async exit(M,A){await this.lifecycleMainService.kill(A)}async resolveProxy(M,A){const H=this.windowById(M)?.win?.webContents?.session;if(H)return H.resolveProxy(A)}findFreePort(M,A,F,H,Y=1){return(0,S.findFreePort)(A,F,H,Y)}async openDevTools(M,A){const F=this.windowById(M);F?.win&&F.win.webContents.openDevTools(A)}async toggleDevTools(M){const A=this.windowById(M);A?.win&&A.win.webContents.toggleDevTools()}async sendInputEvent(M,A){const F=this.windowById(M);F?.win&&(A.type==="mouseDown"||A.type==="mouseUp")&&F.win.webContents.sendInputEvent(A)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(M,A,F,H){if(!I.isWindows)return;const Y=await new Promise((ie,X)=>{j(["@vscode/windows-registry"],ie,X)});try{return Y.GetStringRegKey(A,F,H)}catch{return}}windowById(M){if(typeof M=="number")return this.windowsMainService.getWindowById(M)}};he([R.memoize],d.prototype,"cliPath",null),d=he([re(1,o.IWindowsMainService),re(2,f.IDialogMainService),re(3,r.ILifecycleMainService),re(4,u.IEnvironmentMainService),re(5,l.ILogService),re(6,i.IProductService),re(7,n.IThemeMainService),re(8,a.IWorkspacesManagementMainService)],d),e.NativeHostMainService=d}),define(ee[231],te([0,1,14,37,27,33,2,10,3,89,148,76,107,47,24,5,108,6,59,54,19,55,66]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,h.createDecorator)("issueMainService");let l=class Rt{constructor(n,o,s,a,d,w,M,A,F,H){this.userEnv=n,this.environmentMainService=o,this.launchMainService=s,this.logService=a,this.diagnosticsService=d,this.diagnosticsMainService=w,this.dialogMainService=M,this.nativeHostMainService=A,this.protocolMainService=F,this.productService=H,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[o,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(o,s);this.safeSend(n,"vscode:issueSystemInfoResponse",a)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const o=[];try{const s=await this.launchMainService.getMainProcessId();o.push({name:(0,P.localize)(0,null),rootProcess:await(0,b.listProcesses)(s)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(d=>{(0,k.isRemoteDiagnosticError)(d)?o.push({name:d.hostName,rootProcess:d}):d.processes&&o.push({name:d.hostName,rootProcess:d.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(n,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const o={title:this.productService.nameLong,message:(0,P.localize)(1,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,P.localize)(2,null)),(0,L.mnemonicButtonLabel)((0,P.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",s.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const o=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,P.localize)(4,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,P.localize)(5,null)),(0,L.mnemonicButtonLabel)((0,P.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,o)=>{const{id:s,from:a,args:d}=o;let w;switch(a){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}w&&w.webContents.send("vscode:runAction",{id:s,from:a,args:d})}),t.validatedIpcMain.on("vscode:openExternal",(n,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",o.windows)})}safeSend(n,o,...s){n.sender.isDestroyed()||n.sender.send(o,...s)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new R.DisposableStore,s=o.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:n.styles.backgroundColor,title:(0,P.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:f.default}),this.issueReporterWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new R.DisposableStore,s=o.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:n.styles.backgroundColor,title:(0,P.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:f.default}),this.processExplorerWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,o,s,a){const d=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:s.title,backgroundColor:s.backgroundColor||Rt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,r.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop,experimentalDarkMode:!0});return d.setMenuBarVisibility(!1),d}async getSystemStatus(){const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,o)}getWindowPosition(n,o,s){let a;const d=v.screen.getAllDisplays();if(d.length===1)a=d[0];else{if(E.isMacintosh){const A=v.screen.getCursorScreenPoint();a=v.screen.getDisplayNearestPoint(A)}!a&&n&&(a=v.screen.getDisplayMatching(n.getBounds())),a||(a=v.screen.getPrimaryDisplay()||d[0])}const w={width:o,height:s},M=a.bounds;return w.x=M.x+M.width/2-w.width/2,w.y=M.y+M.height/2-w.height/2,M.width>0&&M.height>0&&(w.x<M.x&&(w.x=M.x),w.y<M.y&&(w.y=M.y),w.x>M.x+M.width&&(w.x=M.x),w.y>M.y+M.height&&(w.y=M.y),w.width>M.width&&(w.width=M.width),w.height>M.height&&(w.height=M.height)),w}async getPerformanceInfo(){try{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,o)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([re(1,g.IEnvironmentMainService),re(2,m.ILaunchMainService),re(3,S.ILogService),re(4,k.IDiagnosticsService),re(5,I.IDiagnosticsMainService),re(6,p.IDialogMainService),re(7,C.INativeHostMainService),re(8,c.IProtocolMainService),re(9,u.IProductService)],l),e.IssueMainService=l}),define(ee[232],te([0,1,23,17,24,22,6,59,19,57,32,42,84]),function(j,e,v,t,D,L,R,y,E,b,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends I.AbstractUpdateService{constructor(h,m,S,C,f,u,c,r){super(h,m,C,f,u,r);this.telemetryService=S,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,I.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(k.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},v.CancellationToken.None).then(b.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const S=h?m.message||m:void 0;this.setState(k.State.Idle(1,S))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(k.State.Idle(1))}};p=he([re(0,L.ILifecycleMainService),re(1,t.IConfigurationService),re(2,P.ITelemetryService),re(3,D.IEnvironmentMainService),re(4,b.IRequestService),re(5,R.ILogService),re(6,y.INativeHostMainService),re(7,E.IProductService)],p),e.LinuxUpdateService=p}),define(ee[233],te([0,1,46,30,27,9,23,48,8,7,120,20,17,24,21,22,6,59,19,57,32,42,84]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(a,d=1e3){for(;!a();)await(0,L.timeout)(d)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(E.join(E.dirname(process.execPath),"unins000.exe"))?0:1),i}function o(a){if(a==="none"||a==="manual"||a==="start"||a==="default")return a}let s=class extends r.AbstractUpdateService{constructor(d,w,M,A,F,H,Y,ie,X){super(d,w,A,F,H,X);this.telemetryService=M,this.fileService=Y,this.nativeHostMainService=ie}get cachePath(){const d=E.join((0,D.tmpdir)(),`${this.productService.applicationName}-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(d,{recursive:!0}).then(()=>d)}async getUpdateMode(){if(this.productService.win32RegValueName){const d=`Software\\Policies\\Microsoft\\${this.productService.win32RegValueName}`,[w,M]=await Promise.all([this.nativeHostMainService.windowsGetStringRegKey(void 0,"HKEY_LOCAL_MACHINE",d,"UpdateMode").then(o),this.nativeHostMainService.windowsGetStringRegKey(void 0,"HKEY_CURRENT_USER",d,"UpdateMode").then(o)]);if(w)return this.logService.info(`update#getUpdateMode: 'UpdateMode' policy defined in 'HKLM\\${d}':`,w),w;if(M)return this.logService.info(`update#getUpdateMode: 'UpdateMode' policy defined in 'HKCU\\${d}':`,M),M}return await super.getUpdateMode()}buildUpdateFeedUrl(d){let w="win32";return process.arch!=="ia32"&&(w+=`-${process.arch}`),n()===1?w+="-archive":this.productService.target==="user"&&(w+="-user"),(0,r.createUpdateURL)(w,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(c.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},R.CancellationToken.None).then(f.asJson).then(w=>{const M=n();return!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(w)),Promise.resolve(null)):(this.setState(c.State.Downloading(w)),this.cleanup(w.version).then(()=>this.getUpdatePackagePath(w.version).then(A=>k.Promises.exists(A).then(F=>{if(F)return Promise.resolve(A);const H=w.url,Y=w.hash,ie=`${A}.tmp`;return this.requestService.request({url:H},R.CancellationToken.None).then(X=>this.fileService.writeFile(b.URI.file(ie),X.stream)).then(Y?()=>(0,P.checksum)(ie,w.hash):()=>{}).then(()=>k.Promises.rename(ie,A)).then(()=>A)})).then(A=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},F&&w.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(w)):this.setState(c.State.Ready(w))})))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const M=d?w.message||w:void 0;this.setState(c.State.Idle(n(),M))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(d){const w=await this.cachePath;return E.join(w,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const w=d?H=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(H):()=>!0,M=await this.cachePath,F=(await k.Promises.readdir(M)).filter(w).map(async H=>{try{await k.Promises.unlink(E.join(M,H))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(c.State.Updating(d));const w=await this.cachePath;this.availableUpdate.updateFilePath=E.join(w,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const A=`${this.productService.win32MutexName}-ready`,F=await new Promise((H,Y)=>{j(["windows-mutex"],H,Y)});l(()=>F.isActive(A)).then(()=>this.setState(c.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}};he([y.memoize],s.prototype,"cachePath",null),s=he([re(0,h.ILifecycleMainService),re(1,I.IConfigurationService),re(2,u.ITelemetryService),re(3,p.IEnvironmentMainService),re(4,f.IRequestService),re(5,m.ILogService),re(6,g.IFileService),re(7,S.INativeHostMainService),re(8,C.IProductService)],s),e.Win32UpdateService=s}),define(ee[234],te([0,1,14,9,23,39,4,33,2,10,8,64,3,7,155,52,17,47,24,51,21,22,6,19,55,202,83,32,205,58,66,34,25,43,104]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l,i,n,o,s,a,d,w,M,A,F,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(X){X[X.NONE=0]="NONE",X[X.NAVIGATING=1]="NAVIGATING",X[X.READY=2]="READY"})(Y||(Y={}));let ie=class extends E.Disposable{constructor(z,x,Z,V,B,$,Q,q,J,_,N,T,W,O,U,K){super();this.logService=x,this.environmentMainService=Z,this.fileService=V,this.globalStorageMainService=B,this.storageMainService=$,this.configurationService=Q,this.themeMainService=q,this.workspacesManagementMainService=J,this.backupMainService=_,this.telemetryService=N,this.dialogMainService=T,this.lifecycleMainService=W,this.productService=O,this.protocolMainService=U,this.windowsMainService=K,this._onWillLoad=this._register(new R.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new R.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new R.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new R.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ne,ae]=this.restoreWindowState(z.state);this.windowState=ne,this.logService.trace("window#ctor: using window state",ne);const le=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:w.WindowMinimumSize.WIDTH,minHeight:w.WindowMinimumSize.HEIGHT,show:!le,title:this.productService.nameLong,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,w.zoomLevelToZoomFactor)(oe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?ue.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(ue.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(ue.fullscreenable=!1),I.isMacintosh&&(ue.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(ue.acceptFirstMouse=!1));const de=I.isMacintosh&&oe?.nativeTabs===!0;de&&(ue.tabbingIdentifier=this.productService.nameShort);const we=(0,w.getTitleBarStyle)(this.configurationService)==="custom";if(we&&(ue.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(ue.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(ue),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&we&&this._win.setSheetOffset(22),I.isMacintosh&&ae&&(!de||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Ie=>typeof Ie=="number")){const Ie=this.windowState;this._win.setBounds({width:Ie.width,height:Ie.height,x:Ie.x,y:Ie.y})}le&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(z){I.isMacintosh?this._win.setRepresentedFilename(z):this.representedFilename=z}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(z){I.isMacintosh&&this._win.setDocumentEdited(z),this.documentEdited=z}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(z){I.isMacintosh&&z?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(z=>{if(this.isReady)return z(this);this.whenReadyCallbacks.push(z)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(z=>{function x(){Z.dispose(),V.dispose(),z()}const Z=this.onDidClose(()=>x()),V=this.onWillLoad(()=>x())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(x,Z)=>this.onWindowError(2,Z)),this._win.webContents.on("did-fail-load",(x,Z,V)=>this.onWindowError(3,{reason:V,exitCode:Z})),this._win.webContents.on("will-prevent-unload",x=>{x.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",x=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",x,this._win)}),this._win.on("unmaximize",x=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",x,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(x=>this.onDidDeleteUntitledWorkspace(x)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(x,Z)=>{const V=await this.getMarketplaceHeaders();Z({cancel:!1,requestHeaders:Object.assign(x.requestHeaders,V)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(z,x){switch(z){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:z,reason:x?.reason,code:x?.exitCode}),z){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(z===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const Z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,g.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,y.mnemonicButtonLabel)((0,g.localize)(2,null))],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,g.localize)(5,null):void 0},this._win);if(Z.response!==1){const V=Z.response===0;this.destroyWindow(V,Z.checkboxChecked)}}else if(z===2){let Z;x?Z=(0,g.localize)(7,null,x.reason,x.exitCode??"<unknown>"):Z=(0,g.localize)(6,null);const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,g.localize)(8,null)),(0,y.mnemonicButtonLabel)((0,g.localize)(9,null))],message:Z,detail:(0,g.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,g.localize)(11,null):void 0},this._win),B=V.response===0;this.destroyWindow(B,V.checkboxChecked)}break}}async destroyWindow(z,x){const Z=this._config?.workspace;if(x&&Z)try{const V=this.storageMainService.workspaceStorage(Z);await V.init(),V.delete("memento/workbench.parts.editor"),await V.close()}catch(V){this.logService.error(V)}if(this._onDidDestroy.fire(),this._win?.destroy(),z&&this._config){let V,B;(0,A.isSingleFolderWorkspaceIdentifier)(Z)?V={folderUri:Z.uri}:(0,A.isWorkspaceIdentifier)(Z)?V={workspaceUri:Z.configPath}:B=!0;const[$]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:V?[V]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(z){this._config?.workspace?.id===z.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(){const z=this.getMenuBarVisibility();z!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=z,this.setMenuBarVisibility(z));let x=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;x?.endsWith("/")&&(x=x.substr(0,x.length-1));const Z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((x||"").indexOf("@")===-1&&(x!==this.currentHttpProxy||Z!==this.currentNoProxy)){this.currentHttpProxy=x,this.currentNoProxy=Z;const V=x||"",B=Z?`${Z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${B}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:B,pacScript:""})}}addTabbedWindow(z){I.isMacintosh&&z.win&&this._win.addTabbedWindow(z.win)}load(z,x=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!x.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),x.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(z,x),this.readyState===0?this._config=z:this.pendingLoadConfig=z,this.readyState=1,this._win.loadURL(b.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const Z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:z.workspace,reason:x.isReload?3:Z?2:1})}updateConfiguration(z,x){const Z=(this._config??this.pendingLoadConfig)?.userEnv;if(Z){const V=(0,f.isLaunchedFromCli)(Z)&&!(0,f.isLaunchedFromCli)(z.userEnv),B=this.isExtensionDevelopmentHost;(V||B)&&(z.userEnv={...Z,...z.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(z.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),x.disableExtensions!==void 0&&(z["disable-extensions"]=x.disableExtensions),z.fullscreen=this.isFullScreen,z.maximized=this._win.isMaximized(),z.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),z.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(z)}async reload(z){const x=Object.assign({},this._config);x.workspace=await this.validateWorkspaceBeforeReload(x),delete x.filesToOpenOrCreate,delete x.filesToDiff,delete x.filesToWait,this.isExtensionDevelopmentHost&&z&&(x.verbose=z.verbose,x.debugId=z.debugId,x.extensionEnvironment=z.extensionEnvironment,x["inspect-extensions"]=z["inspect-extensions"],x["inspect-brk-extensions"]=z["inspect-brk-extensions"],x["extensions-dir"]=z["extensions-dir"]),x.isInitialStartup=!1,this.load(x,{isReload:!0,disableExtensions:z?.["disable-extensions"]})}async validateWorkspaceBeforeReload(z){if((0,A.isWorkspaceIdentifier)(z.workspace)){const x=z.workspace.configPath;if(x.scheme===b.Schemas.file&&!await this.fileService.exists(x))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(z.workspace)){const x=z.workspace.uri;if(x.scheme===b.Schemas.file&&!await this.fileService.exists(x))return}return z.workspace}serializeWindowState(){if(!this._win)return(0,H.defaultWindowState)();if(this.isFullScreen){let Z;try{Z=v.screen.getDisplayMatching(this.getBounds())}catch{}const V=(0,H.defaultWindowState)();return{mode:3,display:Z?Z.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const z=Object.create(null);let x;if(!I.isMacintosh&&this._win.isMaximized()?x=0:x=1,x===0?z.mode=0:z.mode=1,x===1||x===0){let Z;x===1?Z=this.getBounds():Z=this._win.getNormalBounds(),z.x=Z.x,z.y=Z.y,z.width=Z.width,z.height=Z.height}return z}restoreWindowState(z){(0,k.mark)("code/willRestoreCodeWindowState");let x=!1;if(z)try{const Z=v.screen.getAllDisplays();x=Z.length>1,z=this.validateWindowState(z,Z)}catch(Z){this.logService.warn(`Unexpected error validating window state: ${Z}
${Z.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[z||(0,H.defaultWindowState)(),x]}validateWindowState(z,x){if(this.logService.trace(`window#validateWindowState: validating window state on ${x.length} display(s)`,z),typeof z.x!="number"||typeof z.y!="number"||typeof z.width!="number"||typeof z.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(z.width<=0||z.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(x.length===1){const B=this.getWorkingArea(x[0]);if(B){let $=function(){!z||typeof z.x!="number"||typeof z.y!="number"||!B||(z.x<B.x&&(z.x=B.x),z.y<B.y&&(z.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),z.width>B.width&&(z.width=B.width),z.height>B.height&&(z.height=B.height),z.x>B.x+B.width-128&&(z.x=B.x+B.width-z.width),z.y>B.y+B.height-128&&(z.y=B.y+B.height-z.height),$()}return z}if(z.display&&z.mode===3){const B=x.find($=>$.id===z.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,H.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let Z,V;try{Z=v.screen.getDisplayMatching({x:z.x,y:z.y,width:z.width,height:z.height}),V=this.getWorkingArea(Z)}catch{}if(Z&&V&&z.x+z.width>V.x&&z.y+z.height>V.y&&z.x<V.x+V.width&&z.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),z}getWorkingArea(z){if(z.workArea.width>0&&z.workArea.height>0)return z.workArea;if(z.bounds.width>0&&z.bounds.height>0)return z.bounds}getBounds(){const[z,x]=this._win.getPosition(),[Z,V]=this._win.getSize();return{x:z,y:x,width:Z,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(z){this.useNativeFullScreen()?this.setNativeFullScreen(z):this.setSimpleFullScreen(z),this.sendWhenReady(z?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(z){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(z)}setSimpleFullScreen(z){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(z),this._win.webContents.focus()}useNativeFullScreen(){const z=this.configurationService.getValue("window");return!z||typeof z.nativeFullScreen!="boolean"||z.nativeTabs?!0:z.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let z=(0,w.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(z)<0&&(z="classic"),z}setMenuBarVisibility(z,x=!0){I.isMacintosh||(z==="toggle"&&x&&this.send("vscode:showInfoMessage",(0,g.localize)(12,null)),z==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(z)}):this.doSetMenuBarVisibility(z))}doSetMenuBarVisibility(z){const x=this.isFullScreen;switch(z){case"classic":this._win.setMenuBarVisibility(!x),this._win.autoHideMenuBar=x;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(z,x,...Z){this.isReady?this.send(z,...Z):this.ready().then(()=>{x.isCancellationRequested||this.send(z,...Z)})}send(z,...x){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${z}' for window that is destroyed`);return}try{this._win.webContents.send(z,...x)}catch(Z){this.logService.warn(`Error sending IPC message to channel '${z}' of window ${this._id}: ${(0,L.toErrorMessage)(Z)}`)}}}updateTouchBar(z){!I.isMacintosh||this.touchBarGroups.forEach((x,Z)=>{const V=z[Z];x.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!I.isMacintosh){for(let z=0;z<10;z++){const x=this.createTouchBarGroup();this.touchBarGroups.push(x)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(z=[]){const x=this.createTouchBarGroupSegments(z),Z=new v.TouchBar.TouchBarSegmentedControl({segments:x,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:Z.segments[V].id,from:"touchbar"})}});return Z}createTouchBarGroupSegments(z=[]){return z.map(Z=>{let V;Z.icon&&!a.ThemeIcon.isThemeIcon(Z.icon)&&Z.icon?.dark?.scheme===b.Schemas.file&&(V=v.nativeImage.createFromPath(p.URI.revive(Z.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let B;return typeof Z.title=="string"?B=Z.title:B=Z.title.value,{id:Z.id,label:V?void 0:B,icon:V}})}dispose(){super.dispose(),this._win=null}};ie=he([re(1,r.ILogService),re(2,C.IEnvironmentMainService),re(3,u.IFileService),re(4,o.IGlobalStorageMainService),re(5,o.IStorageMainService),re(6,m.IConfigurationService),re(7,d.IThemeMainService),re(8,F.IWorkspacesManagementMainService),re(9,h.IBackupMainService),re(10,s.ITelemetryService),re(11,S.IDialogMainService),re(12,c.ILifecycleMainService),re(13,l.IProductService),re(14,i.IProtocolMainService),re(15,M.IWindowsMainService)],ie),e.CodeWindow=ie}),define(ee[67],te([0,1,14,26,9,4,33,2,10,3,16,7,20,158,5,22,6,83,81,25,43]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,g.createDecorator)("workspacesHistoryMainService");let c=class Ge extends y.Disposable{constructor(l,i,n,o){super();this.logService=l,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.globalStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new L.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){const i=[],n=[];for(let o of l)if((0,C.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,C.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const s=this.indexOfFile(n,o.fileUri)>=0,a=o.fileUri.scheme===E.Schemas.file&&Ge.COMMON_FILES_FILTER.indexOf((0,P.basename)(o.fileUri))>=0;!s&&!a&&(n.push(o),b.isWindows&&o.fileUri.scheme===E.Schemas.file&&v.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>Ge.MAX_TOTAL_RECENT_ENTRIES&&(i.length=Ge.MAX_TOTAL_RECENT_ENTRIES),n.length>Ge.MAX_TOTAL_RECENT_ENTRIES&&(n.length=Ge.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),b.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(l){const i=a=>{const d=this.location(a);for(const w of l)if(P.extUriBiasedIgnorePathCase.isEqual(w,d))return!1;return!0},n=await this.getRecentlyOpened(),o=n.workspaces.filter(i),s=n.files.filter(i);(o.length!==n.workspaces.length||s.length!==n.files.length)&&(await this.saveRecentlyOpened({files:s,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),b.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(l){const i=[],n=[];if(l){const s=l.config?.workspace;(0,f.isWorkspaceIdentifier)(s)&&!this.workspacesManagementMainService.isUntitledWorkspace(s)?i.push({workspace:s,remoteAuthority:l.remoteAuthority}):(0,f.isSingleFolderWorkspaceIdentifier)(s)&&i.push({folderUri:s.uri,remoteAuthority:l.remoteAuthority})}const o=l?.config?.filesToOpenOrCreate;if(o)for(let s of o){const a=s.fileUri;a&&this.indexOfFile(n,a)===-1&&n.push({fileUri:a})}return await this.addEntriesFromStorage(i,n),{workspaces:i,files:n}}async addEntriesFromStorage(l,i){let n=await this.getRecentlyOpenedFromStorage();for(let o of n.workspaces){let s=(0,C.isRecentFolder)(o)?this.indexOfFolder(l,o.folderUri):this.indexOfWorkspace(l,o.workspace);s>=0?l[s].label=l[s].label||o.label:l.push(o)}for(let o of n.files){let s=this.indexOfFile(i,o.fileUri);s>=0?i[s].label=i[s].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let l;const i=this.globalStorageMainService.get(Ge.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{l=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,C.restoreRecentlyOpened)(l,this.logService)}async saveRecentlyOpened(l){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(Ge.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,C.toStoreData)(l)),0,1)}location(l){return(0,C.isRecentFolder)(l)?l.folderUri:(0,C.isRecentFile)(l)?l.fileUri:l.workspace.configPath}indexOfWorkspace(l,i){return l.findIndex(n=>(0,C.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(l,i){return l.findIndex(n=>(0,C.isRecentFolder)(n)&&P.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(l,i){return l.findIndex(n=>P.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!b.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!b.isWindows)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let s of v.app.getJumpListSettings().removedItems){const a=s.args;if(a){const d=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(a);d&&i.push(k.URI.parse(d[2]))}}await this.removeRecentlyOpened(i);let n=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,Ge.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(s=>{const a=(0,C.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:d,description:w}=this.getWindowsJumpListLabel(a,s.label);let M;return k.URI.isUri(a)?M=`--folder-uri "${a.toString()}"`:(n=!0,M=`--file-uri "${a.configPath.toString()}"`),{type:"task",title:d.substr(0,255),description:w.substr(0,255),program:process.execPath,args:M,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&l.push({type:"custom",name:n?(0,p.localize)(2,null):(0,p.localize)(3,null),items:o})}l.push({type:"recent"});try{v.app.setJumpList(l)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(l,i){if(i)return{title:(0,R.splitName)(i).name,description:i};if(k.URI.isUri(l))return{title:(0,P.basename)(l),description:this.renderJumpListPathDescription(l)};if(this.workspacesManagementMainService.isUntitledWorkspace(l))return{title:(0,p.localize)(4,null),description:""};let n=(0,P.basename)(l.configPath);return n.endsWith(f.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,n),description:this.renderJumpListPathDescription(l.configPath)}}renderJumpListPathDescription(l){return l.scheme==="file"?(0,R.normalizeDriveLetter)(l.fsPath):l.toString()}async updateMacOSRecentDocuments(){if(!b.isMacintosh)return;v.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),i=[];let n=0;for(let s=0;s<l.workspaces.length&&n<Ge.MAX_MACOS_DOCK_RECENT_WORKSPACES;s++){const a=this.location(l.workspaces[s]);if(a.scheme===E.Schemas.file){const d=(0,P.originalFSPath)(a);await I.Promises.exists(d)&&(i.push(d),n++)}}const o=[];for(let s=0;s<l.files.length&&n<Ge.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;s++){const a=this.location(l.files[s]);if(a.scheme===E.Schemas.file){const d=(0,P.originalFSPath)(a);if(Ge.COMMON_FILES_FILTER.includes((0,P.basename)(a))||i.includes(d))continue;await I.Promises.exists(d)&&(o.push(d),n++)}}o.reverse().forEach(s=>v.app.addRecentDocument(s)),i.reverse().forEach(s=>v.app.addRecentDocument(s))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=he([re(0,m.ILogService),re(1,u.IWorkspacesManagementMainService),re(2,h.ILifecycleMainService),re(3,S.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(ee[235],te([0,1,14,9,23,33,3,11,7,149,17,47,24,22,6,187,59,19,41,32,42,66,34,67]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let n=class Mt{constructor(a,d,w,M,A,F,H,Y,ie,X,z,x){this.updateService=a,this.configurationService=d,this.windowsMainService=w,this.environmentMainService=M,this.telemetryService=A,this.workspacesHistoryMainService=F,this.stateMainService=H,this.lifecycleMainService=Y,this.logService=ie,this.nativeHostMainService=X,this.productService=z,this.dialogMainService=x,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateMainService.getItem(Mt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(F,H,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(F,H,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(F,H,Y)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(F,H,Y)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(F,H,Y)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const d=this.productService.requestFeatureUrl;d&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(d,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const F=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${F}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,d){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateMainService.setItem(Mt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!R.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=v.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(R.isMacintosh?new v.Menu:null);return}const d=new v.Menu;let w;if(R.isMacintosh){const A=new v.Menu;w=new v.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),d.append(w)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new v.Menu;A.append(new v.MenuItem({label:this.mnemonicLabel(b.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(1,null)),submenu:A});this.setMenuById(A,"File"),d.append(F)}if(this.shouldDrawMenu("Edit")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),d.append(F)}if(this.shouldDrawMenu("Selection")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),d.append(F)}if(this.shouldDrawMenu("View")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(4,null)),submenu:A});this.setMenuById(A,"View"),d.append(F)}if(this.shouldDrawMenu("Go")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),d.append(F)}if(this.shouldDrawMenu("Run")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),d.append(F)}if(this.shouldDrawMenu("Terminal")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),d.append(F)}let M;if(this.shouldDrawMenu("Window")){const A=new v.Menu;M=new v.MenuItem({label:this.mnemonicLabel(b.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(M&&d.append(M),this.shouldDrawMenu("Help")){const A=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(b.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),d.append(F)}d.items&&d.items.length>0?v.Menu.setApplicationMenu(d):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const d=this.createMenuItem(b.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const x=new v.Menu;this.setMenuById(x,"Preferences"),M=new v.MenuItem({label:this.mnemonicLabel(b.localize(11,null)),submenu:x})}const A=new v.Menu,F=new v.MenuItem({label:b.localize(12,null),role:"services",submenu:A}),H=new v.MenuItem({label:b.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Y=new v.MenuItem({label:b.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ie=new v.MenuItem({label:b.localize(15,null),role:"unhide"}),X=new v.MenuItem(this.likeAction("workbench.action.quit",{label:b.localize(16,null,this.productService.nameLong),click:async(x,Z,V)=>{const B=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||B?.isMinimized())&&await this.confirmBeforeQuit(V)&&this.nativeHostMainService.quit(void 0)}})),z=[d];z.push(...w),M&&z.push(o(),M),z.push(o(),F,o(),H,Y,ie,o(),X),z.forEach(x=>a.append(x))}async confirmBeforeQuit(a){if(this.windowsMainService.getWindowCount()===0)return!0;const d=this.configurationService.getValue("window.confirmBeforeClose");if(d==="always"||d==="keyboardOnly"&&this.isKeyboardEvent(a)){const w={title:this.productService.nameLong,type:"question",buttons:[(0,L.mnemonicButtonLabel)(b.localize(17,null)),(0,L.mnemonicButtonLabel)(b.localize(18,null))],message:b.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:M}=await this.dialogMainService.showMessageBox(w,(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()));return M===0}return!0}shouldDrawMenu(a){if(!R.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,d){d.forEach(w=>{if((0,h.isMenubarMenuItemSeparator)(w))a.append(o());else if((0,h.isMenubarMenuItemSubmenu)(w)){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(w.label),submenu:M});this.setMenu(M,w.submenu.items),a.append(A)}else(0,h.isMenubarMenuItemRecentAction)(w)?a.append(this.createOpenRecentMenuItem(w)):(0,h.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?a.append(new v.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):a.append(this.createMenuItem(w.label,w.id,!1,w.checked)):a.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):a.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(a,d){this.menubarMenus&&this.menubarMenus[d]&&this.setMenu(a,this.menubarMenus[d].items)}insertCheckForUpdatesItems(a){const d=this.getUpdateMenuItems();d.length&&(d.forEach(w=>a.append(w)),a.append(o()))}createOpenRecentMenuItem(a){const d=E.URI.revive(a.uri),w=a.id,M=w==="openRecentFile"?{fileUri:d}:w==="openRecentWorkspace"?{workspaceUri:d}:{folderUri:d};return new v.MenuItem(this.likeAction(w,{label:a.label,click:(A,F,H)=>{const Y=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:a.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([d])}},!1))}isOptionClick(a){return!!(a&&(!R.isMacintosh&&(a.ctrlKey||a.shiftKey)||R.isMacintosh&&(a.metaKey||a.altKey)))}isKeyboardEvent(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}createRoleMenuItem(a,d,w){const M={label:this.mnemonicLabel(a),role:w,enabled:!0};return new v.MenuItem(this.withKeybinding(d,M))}setMacWindowMenu(a){const d=new v.MenuItem({label:b.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new v.MenuItem({label:b.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new v.MenuItem({label:b.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(b.localize(23,null),"workbench.action.switchWindow"),F=[];this.currentEnableNativeTabs&&(F.push(o()),F.push(this.createMenuItem(b.localize(24,null),"workbench.action.newWindowTab")),F.push(this.createRoleMenuItem(b.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.createRoleMenuItem(b.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.createRoleMenuItem(b.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.createRoleMenuItem(b.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[d,w,o(),A,...F,o(),M].forEach(H=>a.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(b.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:b.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(b.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:b.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(b.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:b.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(b.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,d,w,M){const A=this.mnemonicLabel(a),F=typeof d=="function"?d:(z,x,Z)=>{const V=z?z.userSettingsLabel:null;let B=d;Array.isArray(d)&&(B=this.isOptionClick(Z)?d[1]:d[0]),V&&Z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:B})},H=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,Y=typeof M=="boolean"?M:!1,ie={label:A,click:F,enabled:H};Y&&(ie.type="checkbox",ie.checked=Y);let X;return typeof d=="string"?X=d:Array.isArray(d)&&(X=d[0]),R.isMacintosh&&(X==="editor.action.clipboardCutAction"?ie.role="cut":X==="editor.action.clipboardCopyAction"?ie.role="copy":X==="editor.action.clipboardPasteAction"&&(ie.role="paste"),X==="undo"?ie.click=this.makeContextAwareClickHandler(F,{inDevTools:z=>z.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?ie.click=this.makeContextAwareClickHandler(F,{inDevTools:z=>z.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(ie.click=this.makeContextAwareClickHandler(F,{inDevTools:z=>z.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(X,ie))}makeContextAwareClickHandler(a,d){return(w,M,A)=>{const F=v.BrowserWindow.getFocusedWindow();if(!F)return d.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return d.inDevTools(F.webContents.devToolsWebContents);a(w,M||F,A)}}runActionInRenderer(a){let d=v.BrowserWindow.getFocusedWindow();if(!d){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(d=M.win)}const w=d?this.windowsMainService.getWindowById(d.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",a),R.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const M={id:a.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",D.CancellationToken.None,M)}else{const M={userSettingsLabel:a.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,d){const w=typeof a=="string"?this.keybindings[a]:void 0;if(w?.label){if(w.isNative!==!1)d.accelerator=w.label,d.userSettingsLabel=w.userSettingsLabel;else if(typeof d.label=="string"){const M=d.label.indexOf("[");M>=0?d.label=`${d.label.substr(0,M)} [${w.label}]`:d.label=`${d.label} [${w.label}]`}}else d.accelerator=void 0;return d}likeAction(a,d,w=!d.accelerator){w&&(d=this.withKeybinding(a,d));const M=d.click;return d.click=(A,F,H)=>{this.reportMenuActionTelemetry(a),M&&M(A,F,H)},d}openUrl(a,d){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(d)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:i})}mnemonicLabel(a){return(0,L.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};n.lastKnownMenubarStorageKey="lastKnownMenubarData",n=he([re(0,u.IUpdateService),re(1,P.IConfigurationService),re(2,r.IWindowsMainService),re(3,I.IEnvironmentMainService),re(4,f.ITelemetryService),re(5,l.IWorkspacesHistoryMainService),re(6,C.IStateMainService),re(7,p.ILifecycleMainService),re(8,g.ILogService),re(9,m.INativeHostMainService),re(10,S.IProductService),re(11,k.IDialogMainService)],n),e.Menubar=n;function o(){return new v.MenuItem({type:"separator"})}}),define(ee[236],te([0,1,5,22,6,235]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let R=class{constructor(E,b,P){this.instantiationService=E,this.lifecycleMainService=b,this.logService=P,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(L.Menubar)}async updateMenubar(E,b){this.logService.trace("menubarService#updateMenubar",E),(await this.menubar).updateMenu(b,E)}};R=he([re(0,v.IInstantiationService),re(1,t.ILifecycleMainService),re(2,D.ILogService)],R),e.MenubarMainService=R}),define(ee[237],te([0,1,14,30,27,26,23,4,29,44,33,2,10,8,64,3,36,16,11,7,156,52,17,47,24,21,5,22,6,54,19,55,79,41,66,234,105,219,25,106,67,43,58]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l,i,n,o,s,a,d,w,M,A,F,H,Y,ie,X,z,x,Z,V,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(J){return(0,z.isWorkspaceIdentifier)(J?.workspace)}function Q(J){return(0,z.isSingleFolderWorkspaceIdentifier)(J?.workspace)}let q=class st extends k.Disposable{constructor(_,N,T,W,O,U,K,ne,ae,le,oe,ue,de,we,Ie,Ae){super();this.machineId=_,this.initialUserEnv=N,this.logService=T,this.stateMainService=W,this.environmentMainService=O,this.lifecycleMainService=U,this.backupMainService=K,this.configurationService=ne,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=le,this.instantiationService=oe,this.dialogMainService=ue,this.fileService=de,this.productService=we,this.protocolMainService=Ie,this.themeMainService=Ae,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new X.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(_=>this._onDidSignalReadyWindow.fire(_.window))),this._register(this.onDidSignalReadyWindow(_=>{if(_.config?.extensionDevelopmentPath||_.config?.extensionTestsPath){const N=new k.DisposableStore;if(N.add(y.Event.any(_.onDidClose,_.onDidDestroy)(()=>N.dispose())),_.config.extensionDevelopmentPath)for(const T of _.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(T));_.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(_.config.extensionTestsPath))}}))}openEmptyWindow(_,N){let T=this.environmentMainService.args;const W=N?.remoteAuthority||void 0,O=!0,U=N?.forceReuseWindow,K=!U;return this.open({..._,cli:T,forceEmpty:O,forceNewWindow:K,forceReuseWindow:U,remoteAuthority:W})}openExistingWindow(_,N){_.focus(),this.handleWaitMarkerFile(N,[_])}open(_){this.logService.trace("windowsManager#open"),_.addMode&&(_.initialStartup||!this.getLastActiveWindow())&&(_.addMode=!1);const N=[],T=[],W=[],O=[],U=[];let K,ne=0;const ae=this.getPathsToOpen(_);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const de of ae)Q(de)?_.addMode?N.push(de):T.push(de):$(de)?W.push(de):de.fileUri?(K||(K={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:de.remoteAuthority}),K.filesToOpenOrCreate.push(de)):de.backupPath?U.push({backupFolder:(0,p.basename)(de.backupPath),remoteAuthority:de.remoteAuthority}):ne++;_.diffMode&&K&&K.filesToOpenOrCreate.length>=2&&(K.filesToDiff=K.filesToOpenOrCreate.slice(0,2),K.filesToOpenOrCreate=[]),K&&_.waitMarkerFileURI&&(K.filesToWait={paths:[...K.filesToDiff,...K.filesToOpenOrCreate],waitMarkerFileUri:_.waitMarkerFileURI}),_.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),W.push(...O),U.push(...this.backupMainService.getEmptyWindowBackupPaths())):U.length=0;const{windows:le,filesOpenedInWindow:oe}=this.doOpen(_,W,T,U,ne,K,N);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${W.length}, foldersToOpen: ${T.length}, emptyToRestore: ${U.length}, emptyToOpen: ${ne})`),le.length>1)if(oe)oe.focus();else{const de=this.windowsStateHandler.state.lastActiveWindow&&!_.forceEmpty&&!_.cli._.length&&!_.cli["file-uri"]&&!_.cli["folder-uri"]&&!(_.urisToOpen&&_.urisToOpen.length);let we=!0,Ie=!0;if(de){const Ae=le.filter(be=>this.windowsStateHandler.state.lastActiveWindow&&be.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ae.length&&(Ae[0].focus(),we=!1,Ie=!1)}if(we)for(let Ae=le.length-1;Ae>=0;Ae--){const be=le[Ae];if(!(be.openedWorkspace&&O.some(Se=>be.openedWorkspace&&Se.workspace.id===be.openedWorkspace.id)||be.backupPath&&U.some(Se=>be.backupPath&&Se.backupFolder===(0,p.basename)(be.backupPath)))){be.focus(),Ie=!1;break}}Ie&&le[le.length-1].focus()}const ue=K&&K.filesToDiff.length>0;if(!le.some(de=>de.isExtensionDevelopmentHost)&&!ue&&!_.noRecentEntry){const de=[];for(const we of ae)$(we)&&!we.transient?de.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):Q(we)?de.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&de.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(de)}return this.handleWaitMarkerFile(_,le),le}handleWaitMarkerFile(_,N){const T=_.waitMarkerFileURI;_.context===0&&T&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}doOpen(_,N,T,W,O,U,K){const ne=[];let ae;function le(be,Se){ne.push(be),Se&&(ae=be,U=void 0)}let{openFolderInNewWindow:oe,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(_);if(!_.initialStartup&&K.length>0){const be=K[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(be);Se&&le(this.doAddFoldersToExistingWindow(Se,K.map(Ce=>Ce.workspace.uri)))}const de=T.length+N.length+W.length;if(U&&de===0){const be=U.filesToOpenOrCreate[0]||U.filesToDiff[0],Se=this.getWindows().filter(We=>U&&(0,S.isEqualAuthority)(We.remoteAuthority,U.remoteAuthority));let Ce;be?.fileUri&&!ue&&((_.context===4||_.context===0||_.context===1)&&(Ce=(0,ie.findWindowOnFile)(Se,be.fileUri,We=>We.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(We.configPath):void 0)),Ce||(Ce=this.doGetLastActiveWindow(Se))),Ce?(0,z.isWorkspaceIdentifier)(Ce.openedWorkspace)?N.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):(0,z.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)?T.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):le(this.doOpenFilesInExistingWindow(_,Ce,U),!0):le(this.openInBrowserWindow({userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:_.forceNewTabbedWindow}),!0)}const we=(0,L.distinct)(N,be=>be.workspace.id);if(we.length>0){const be=(0,L.coalesce)(we.map(Se=>(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(be.length>0){const Se=be[0],Ce=(0,S.isEqualAuthority)(U?.remoteAuthority,Se.remoteAuthority)?U:void 0;le(this.doOpenFilesInExistingWindow(_,Se,Ce),!!Ce),oe=!0}we.forEach(Se=>{if(be.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===Se.workspace.id))return;const Ce=Se.remoteAuthority,We=(0,S.isEqualAuthority)(U?.remoteAuthority,Ce)?U:void 0;le(this.doOpenFolderOrWorkspace(_,Se,oe,We),!!We),oe=!0})}const Ie=(0,L.distinct)(T,be=>S.extUriBiasedIgnorePathCase.getComparisonKey(be.workspace.uri));if(Ie.length>0){const be=(0,L.coalesce)(Ie.map(Se=>(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(be.length>0){const Se=be[0],Ce=(0,S.isEqualAuthority)(U?.remoteAuthority,Se.remoteAuthority)?U:void 0;le(this.doOpenFilesInExistingWindow(_,Se,Ce),!!Ce),oe=!0}Ie.forEach(Se=>{if(be.some(_e=>(0,z.isSingleFolderWorkspaceIdentifier)(_e.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,Se.workspace.uri)))return;const Ce=Se.remoteAuthority,We=(0,S.isEqualAuthority)(U?.remoteAuthority,Ce)?U:void 0;le(this.doOpenFolderOrWorkspace(_,Se,oe,We),!!We),oe=!0})}const Ae=(0,L.distinct)(W,be=>be.backupFolder);if(Ae.length>0&&Ae.forEach(be=>{const Se=be.remoteAuthority,Ce=(0,S.isEqualAuthority)(U?.remoteAuthority,Se)?U:void 0;le(this.doOpenEmpty(_,!0,Se,Ce,be),!!Ce),oe=!0}),ne.length===0||U){U&&!O&&O++;const be=U?U.remoteAuthority:_.remoteAuthority;for(let Se=0;Se<O;Se++)le(this.doOpenEmpty(_,oe,be,U),!!U),oe=!0}return{windows:(0,L.distinct)(ne),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(_,N,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),N.focus();const W={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToWait:T?.filesToWait,termProgram:_?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",R.CancellationToken.None,W),N}doAddFoldersToExistingWindow(_,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),_.focus();const T={foldersToAdd:N};return _.sendWhenReady("vscode:addFolders",R.CancellationToken.None,T),_}doOpenEmpty(_,N,T,W,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:T,filesToOpen:W,forceNewWindow:N});let U;return!N&&typeof _.contextWindowId=="number"&&(U=this.getWindowById(_.contextWindowId)),this.openInBrowserWindow({userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,remoteAuthority:T,forceNewWindow:N,forceNewTabbedWindow:_.forceNewTabbedWindow,filesToOpen:W,windowToUse:U,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(_,N,T,W,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:W}),!T&&!O&&typeof _.contextWindowId=="number"&&(O=this.getWindowById(_.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:_.forceNewTabbedWindow,filesToOpen:W,windowToUse:O})}getPathsToOpen(_){let N,T=!1,W=!1;if(_.urisToOpen&&_.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(_),T=!0):_.forceEmpty?N=[Object.create(null)]:_.cli._.length||_.cli["folder-uri"]||_.cli["file-uri"]?(N=this.doExtractPathsFromCLI(_.cli),N.length===0&&N.push(Object.create(null)),T=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),W=!0),!_.addMode&&T){const O=N.filter(U=>Q(U));if(O.length>1){const U=O[0].remoteAuthority;if(O.every(K=>(0,S.isEqualAuthority)(K.remoteAuthority,U))){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ne=>({uri:ne.workspace.uri})));N.push({workspace:K,remoteAuthority:U}),N=N.filter(ne=>!Q(ne))}}}return _.initialStartup&&!W&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(O=>$(O)||Q(O)||O.backupPath)),N}doExtractPathsFromAPI(_){const N=[],T={gotoLineMode:_.gotoLineMode,remoteAuthority:_.remoteAuthority};for(const W of(0,L.coalesce)(_.urisToOpen||[])){const O=this.resolveOpenable(W,T);if(O)O.label=W.label,N.push(O);else{const U=this.resourceFromOpenable(W),K={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:U.scheme===I.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:U.scheme===I.Schemas.file?(0,u.localize)(3,null,(0,P.getPathLabel)(U,{os:h.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,U.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(K,(0,C.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return N}doExtractPathsFromCLI(_){const N=[],T={ignoreFileNotFound:!0,gotoLineMode:_.goto,remoteAuthority:_.remote||void 0,forceOpenWorkspaceAsFile:!1},W=_["folder-uri"];if(W)for(const K of W){const ne=this.cliArgToUri(K);if(ne){const ae=this.resolveOpenable({folderUri:ne},T);ae&&N.push(ae)}}const O=_["file-uri"];if(O)for(const K of O){const ne=this.cliArgToUri(K);if(ne){const ae=this.resolveOpenable((0,z.hasWorkspaceFileExtension)(K)?{workspaceUri:ne}:{fileUri:ne},T);ae&&N.push(ae)}}const U=_._;for(const K of U){const ne=T.remoteAuthority?this.doResolvePathRemote(K,T):this.doResolveFilePath(K,T);ne&&N.push(ne)}return N}cliArgToUri(_){try{const N=f.URI.parse(_);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${_}`);return}return N}catch(N){this.logService.error(`Invalid URI input string: ${_}, ${N.message}`)}}doGetPathsFromLastSession(){const _=this.getRestoreWindowsSetting();switch(_){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];_!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const T=[];for(const W of N)if(W.workspace){const O=this.resolveOpenable({workspaceUri:W.workspace.configPath},{remoteAuthority:W.remoteAuthority,rejectTransientWorkspaces:!0});$(O)&&T.push(O)}else if(W.folderUri){const O=this.resolveOpenable({folderUri:W.folderUri},{remoteAuthority:W.remoteAuthority});Q(O)&&T.push(O)}else _!=="folders"&&W.backupPath&&T.push({backupPath:W.backupPath,remoteAuthority:W.remoteAuthority});return T}}}getRestoreWindowsSetting(){let _;return this.lifecycleMainService.wasRestarted?_="all":(_=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(_)||(_="all")),_}resolveOpenable(_,N=Object.create(null)){let T=this.resourceFromOpenable(_);return T.scheme===I.Schemas.file?((0,H.isFileToOpen)(_)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,N)):this.doResolveRemoteOpenable(_,N)}doResolveRemoteOpenable(_,N){let T=this.resourceFromOpenable(_);const W=(0,A.getRemoteAuthority)(T)||N.remoteAuthority;if(T=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(T)),(0,H.isFileToOpen)(_)){if(N.gotoLineMode){const{path:O,line:U,column:K}=(0,E.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:O}),options:{selection:U?{startLineNumber:U,startColumn:K||1}:void 0},remoteAuthority:W}}return{fileUri:T,remoteAuthority:W}}else if((0,H.isWorkspaceToOpen)(_))return{workspace:(0,x.getWorkspaceIdentifier)(T),remoteAuthority:W};return{workspace:(0,x.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:W}}resourceFromOpenable(_){return(0,H.isWorkspaceToOpen)(_)?_.workspaceUri:(0,H.isFolderToOpen)(_)?_.folderUri:_.fileUri}doResolveFilePath(_,N){let T,W;N.gotoLineMode&&({path:_,line:T,column:W}=(0,E.parseLineAndColumnAware)(_)),_=(0,E.sanitizeFilePath)((0,p.normalize)(_),(0,m.cwd)());try{const O=(0,t.statSync)(_);if(O.isFile()){if(!N.forceOpenWorkspaceAsFile){const U=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.URI.file(_));if(U)return U.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:n.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:f.URI.file(_),type:n.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:W||1}:void 0}}}else{if(O.isDirectory())return{workspace:(0,x.getSingleFolderWorkspaceIdentifier)(f.URI.file(_),O),type:n.FileType.Directory,exists:!0};if(!h.isWindows&&_==="/dev/null")return{fileUri:f.URI.file(_),type:n.FileType.File,exists:!0}}}catch{const U=f.URI.file(_);if(this.workspacesHistoryMainService.removeRecentlyOpened([U]),N.ignoreFileNotFound)return{fileUri:U,type:n.FileType.File,exists:!1}}}doResolvePathRemote(_,N){const T=_.charCodeAt(0),W=N.remoteAuthority;let O,U;N.gotoLineMode&&({path:_,line:O,column:U}=(0,E.parseLineAndColumnAware)(_)),T!==47&&((0,E.isWindowsDriveLetter)(T)&&_.charCodeAt(_.charCodeAt(1))===58&&(_=(0,E.toSlashes)(_)),_=`/${_}`);const K=f.URI.from({scheme:I.Schemas.vscodeRemote,authority:W,path:_});if(_.charCodeAt(_.length-1)!==47){if((0,z.hasWorkspaceFileExtension)(_))return N.forceOpenWorkspaceAsFile?{fileUri:K,options:{selection:O?{startLineNumber:O,startColumn:U||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,x.getWorkspaceIdentifier)(K),remoteAuthority:W};if(N.gotoLineMode||p.posix.basename(_).indexOf(".")!==-1)return{fileUri:K,options:{selection:O?{startLineNumber:O,startColumn:U||1}:void 0},remoteAuthority:W}}return{workspace:(0,x.getSingleFolderWorkspaceIdentifier)(K),remoteAuthority:W}}shouldOpenNewWindow(_){const N=this.configurationService.getValue("window"),T=N?.openFoldersInNewWindow||"default",W=N?.openFilesInNewWindow||"off";let O=(_.preferNewWindow||_.forceNewWindow)&&!_.forceReuseWindow;!_.forceNewWindow&&!_.forceReuseWindow&&(T==="on"||T==="off")&&(O=T==="on");let U=!1;return _.forceNewWindow||_.forceReuseWindow?U=!!_.forceNewWindow&&!_.forceReuseWindow:(h.isMacintosh?_.context===1&&(U=!0):_.context!==3&&_.context!==2&&!(_.userEnv&&_.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!_.cli.extensionDevelopmentPath&&(W==="on"||W==="off")&&(U=W==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:U}}openExtensionDevelopmentHostWindow(_,N){const T=(0,ie.findWindowOnExtensionDevelopmentPath)(this.getWindows(),_);if(T)return this.lifecycleMainService.reload(T,N.cli),T.focus(),[T];let W=N.cli["folder-uri"]||[],O=N.cli["file-uri"]||[],U=N.cli._;if(!U.length&&!W.length&&!O.length&&!N.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,oe=le&&(le.workspace||le.folderUri);oe&&(f.URI.isUri(oe)?oe.scheme===I.Schemas.file?U=[oe.fsPath]:W=[oe.toString()]:oe.configPath.scheme===I.Schemas.file?U=[(0,S.originalFSPath)(oe.configPath)]:O=[oe.configPath.toString()])}let K=N.remoteAuthority;for(const le of _)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=f.URI.parse(le),ue=(0,A.getRemoteAuthority)(oe);ue&&(K?(0,S.isEqualAuthority)(ue,K)||this.logService.error("more than one extension development path authority"):K=ue)}U=U.filter(le=>{const oe=f.URI.file(le);return(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,S.isEqualAuthority)((0,A.getRemoteAuthority)(oe),K)}),W=W.filter(le=>{const oe=this.cliArgToUri(le);return oe&&!!(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,S.isEqualAuthority)((0,A.getRemoteAuthority)(oe),K):!1}),O=O.filter(le=>{const oe=this.cliArgToUri(le);return oe&&!!(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,S.isEqualAuthority)((0,A.getRemoteAuthority)(oe),K):!1}),N.cli._=U,N.cli["folder-uri"]=W,N.cli["file-uri"]=O;const ne=!U.length&&!W.length&&!O.length,ae={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:K};return this.open(ae)}openInBrowserWindow(_){const N=this.configurationService.getValue("window"),T={...this.environmentMainService.args,..._.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:_.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,_.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:_.remoteAuthority,workspace:_.workspace,userEnv:{...this.initialUserEnv,..._.userEnv},filesToOpenOrCreate:_.filesToOpen?.filesToOpenOrCreate,filesToDiff:_.filesToOpen?.filesToDiff,filesToWait:_.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:d.default,isInitialStartup:_.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme()};let W;if(!_.forceNewWindow&&!_.forceNewTabbedWindow&&(W=_.windowToUse||this.getLastActiveWindow(),W&&W.focus()),W){const O=W.config;!T.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(T.extensionDevelopmentPath=O.extensionDevelopmentPath,T.verbose=O.verbose,T["inspect-brk-extensions"]=O["inspect-brk-extensions"],T.debugId=O.debugId,T.extensionEnvironment=O.extensionEnvironment,T["inspect-extensions"]=O["inspect-extensions"],T["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(T);(0,g.mark)("code/willCreateCodeWindow");const U=W=this.instantiationService.createInstance(Y.CodeWindow,{state:O,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});if((0,g.mark)("code/didCreateCodeWindow"),_.forceNewTabbedWindow){const ne=this.getLastActiveWindow();ne&&ne.addTabbedWindow(U)}st.WINDOWS.push(U),this._onDidOpenWindow.fire(U),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,b.once)(U.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(U)),(0,b.once)(U.onDidClose)(()=>this.onWindowClosed(U)),(0,b.once)(U.onDidDestroy)(()=>this._onDidDestroyWindow.fire(U));const K=(0,C.assertIsDefined)(U.win?.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(U)),this.lifecycleMainService.registerWindow(U)}return T.windowId=W.id,W.isReady?this.lifecycleMainService.unload(W,4).then(O=>{O||this.doOpenInBrowserWindow(W,T,_)}):this.doOpenInBrowserWindow(W,T,_),W}doOpenInBrowserWindow(_,N,T){if(!N.extensionDevelopmentPath)if((0,z.isWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:N.workspace,remoteAuthority:N.remoteAuthority});else if((0,z.isSingleFolderWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority});else{const W=T.emptyWindowBackupInfo&&T.emptyWindowBackupInfo.backupFolder;N.backupPath=this.backupMainService.registerEmptyWindowBackupSync(W,N.remoteAuthority)}_.load(N)}onWindowClosed(_){const N=st.WINDOWS.indexOf(_);st.WINDOWS.splice(N,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const _=v.BrowserWindow.getFocusedWindow();if(_)return this.getWindowById(_.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(_){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,S.isEqualAuthority)(N.remoteAuthority,_)))}doGetLastActiveWindow(_){const N=Math.max.apply(Math,_.map(T=>T.lastFocusTime));return _.find(T=>T.lastFocusTime===N)}sendToFocused(_,...N){const T=this.getFocusedWindow()||this.getLastActiveWindow();T&&T.sendWhenReady(_,R.CancellationToken.None,...N)}sendToAll(_,N,T){for(const W of this.getWindows())T&&T.indexOf(W.id)>=0||W.sendWhenReady(_,R.CancellationToken.None,N)}getWindows(){return st.WINDOWS}getWindowCount(){return st.WINDOWS.length}getWindowById(_){const N=this.getWindows().filter(T=>T.id===_);return(0,L.firstOrDefault)(N)}getWindowByWebContents(_){const N=v.BrowserWindow.fromWebContents(_);if(!!N)return this.getWindowById(N.id)}};q.WINDOWS=[],q=he([re(2,a.ILogService),re(3,F.IStateMainService),re(4,i.IEnvironmentMainService),re(5,s.ILifecycleMainService),re(6,c.IBackupMainService),re(7,r.IConfigurationService),re(8,Z.IWorkspacesHistoryMainService),re(9,V.IWorkspacesManagementMainService),re(10,o.IInstantiationService),re(11,l.IDialogMainService),re(12,n.IFileService),re(13,w.IProductService),re(14,M.IProtocolMainService),re(15,B.IThemeMainService)],q),e.WindowsMainService=q}),define(ee[238],te([0,1,52,34,67,43]),function(j,e,v,t,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=class{constructor(E,b,P,k){this.workspacesManagementMainService=E,this.windowsMainService=b,this.workspacesHistoryMainService=P,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(E,b){const P=this.windowsMainService.getWindowById(E);if(P)return this.workspacesManagementMainService.enterWorkspace(P,this.windowsMainService.getWindows(),b)}createUntitledWorkspace(E,b,P){return this.workspacesManagementMainService.createUntitledWorkspace(b,P)}deleteUntitledWorkspace(E,b){return this.workspacesManagementMainService.deleteUntitledWorkspace(b)}getWorkspaceIdentifier(E,b){return this.workspacesManagementMainService.getWorkspaceIdentifier(b)}getRecentlyOpened(E){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(E))}addRecentlyOpened(E,b){return this.workspacesHistoryMainService.addRecentlyOpened(b)}removeRecentlyOpened(E,b){return this.workspacesHistoryMainService.removeRecentlyOpened(b)}clearRecentlyOpened(E){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};R=he([re(0,L.IWorkspacesManagementMainService),re(1,t.IWindowsMainService),re(2,D.IWorkspacesHistoryMainService),re(3,v.IBackupMainService)],R),e.WorkspacesMainService=R}),define(ee[239],te([0,1,14,37,30,27,18,39,15,29,44,45,33,2,10,8,3,11,7,31,73,128,38,129,91,213,137,52,222,17,62,165,76,107,47,95,163,24,51,100,170,188,171,220,96,172,173,21,183,78,75,5,77,231,198,108,22,6,185,236,59,19,79,226,80,41,217,83,199,32,201,203,65,42,207,229,232,230,233,103,208,209,210,211,215,34,237,216,25,81,67,238,43,214]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l,i,n,o,s,a,d,w,M,A,F,H,Y,ie,X,z,x,Z,V,B,$,Q,q,J,_,N,T,W,O,U,K,ne,ae,le,oe,ue,de,we,Ie,Ae,be,Se,Ce,We,_e,Je,Ue,qe,ot,Ze,xe,vt,at,je,et,G,se,ce,ge,ve,Pe,Ne,Qe,Ke,Oe,He,Ve,tt,ct,Dt,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let St=class extends p.Disposable{constructor(fe,pe,ye,me,ke,Le,Me,De,Ee,Re){super();this.mainProcessNodeIpcServer=fe,this.userEnv=pe,this.mainInstantiationService=ye,this.logService=me,this.environmentMainService=ke,this.lifecycleMainService=Le,this.configurationService=Me,this.stateMainService=De,this.fileService=Ee,this.productService=Re,this.configureSession(),this.registerListeners()}configureSession(){const fe=Ee=>Ee?.startsWith(`${g.Schemas.vscodeWebview}://`),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((Ee,Re,Te,Be)=>fe(Be.requestingUrl)?Te(pe.has(Re)):Te(!1)),v.session.defaultSession.setPermissionCheckHandler((Ee,Re,Te,Be)=>fe(Be.requestingUrl)?pe.has(Re):!1);const ye=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),me=Ee=>{for(let Re=Ee;Re;Re=Re.parent)if(Re.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},ke=Ee=>Ee.resourceType==="xhr"||me(Ee.frame),Le=Ee=>{const Re=Ee.frame;if(!Re||!this.windowsMainService)return!1;const Te=v.BrowserWindow.getAllWindows();for(const Be of Te)if(Re.processId===Be.webContents.mainFrame.processId)return!0;return!1},Me=(Ee,Re)=>{if(Ee.path!=="/index.html")return!0;const Te=Re.frame;if(!Te||!this.windowsMainService)return!1;for(const Be of this.windowsMainService.getWindows())if(Be.win&&Te.processId===Be.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((Ee,Re)=>{const Te=C.URI.parse(Ee.url);return Te.scheme===g.Schemas.vscodeWebview&&!Me(Te,Ee)?(this.logService.error("Blocked vscode-webview request",Ee.url),Re({cancel:!0})):Te.scheme===g.Schemas.vscodeFileResource&&!Le(Ee)?(this.logService.error("Blocked vscode-file request",Ee.url),Re({cancel:!0})):Te.path.endsWith(".svg")&&!ye.has(Te.scheme)?Re({cancel:!ke(Ee)}):Re({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((Ee,Re)=>{const Te=Ee.responseHeaders,Be=Te["content-type"]||Te["Content-Type"];if(Be&&Array.isArray(Be)){const Ye=C.URI.parse(Ee.url);if(Ye.path.endsWith(".svg")&&ye.has(Ye.scheme))return Te["Content-Type"]=["image/svg+xml"],Re({cancel:!1,responseHeaders:Te});if(!Ye.path.includes(g.Schemas.vscodeRemoteResource)&&Be.some(it=>it.toLowerCase().includes("image/svg")))return Re({cancel:!ke(Ee)})}return Re({cancel:!1})});const De=v.session.defaultSession;typeof De.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&De.setCodeCachePath((0,h.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,E.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,E.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(ye,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),v.app.on("activate",(ye,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(ye,me)=>{me.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),me.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let fe=[],pe;v.app.on("open-file",(ye,me)=>{this.logService.trace("app#open-file: ",me),ye.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(me)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],pe=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const me=this.windowsMainService?.getWindowByWebContents(ye.sender);let ke,Le;return me?.config?(ke=me.config,Le={...process.env,...me.config.userEnv}):(ke=this.environmentMainService.args,Le=process.env),this.resolveShellEnvironment(ke,Le,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(ye,me,ke)=>{const Le=this.validateNlsPath([me]);if(!Le||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,R.VSBuffer.fromString(ke))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...me)=>{const ke=this.validateNlsPath(me);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(fe){let pe;for(const ye of fe)typeof ye=="string"&&(typeof pe!="string"?pe=ye:pe=(0,h.join)(pe,ye));if(!(typeof pe!="string"||!(0,h.isAbsolute)(pe)||!(0,b.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return C.URI.file(pe)}onUnexpectedError(fe){if(fe){const pe={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(pe))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;m.isWindows&&fe&&v.app.setAppUserModelId(fe);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ee){this.logService.error(Ee)}const pe=new l.Server;this.lifecycleMainService.onWillShutdown(Ee=>{Ee.reason===2&&pe.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:me,sharedProcessReady:ke,sharedProcessClient:Le}=this.setupSharedProcess(ye),Me=await this.initServices(ye,me,ke);this._register(Me.createInstance(n.ProxyAuthHandler)),Me.invokeFunction(Ee=>this.initChannels(Ee,pe,Le));const De=Me.invokeFunction(Ee=>this.openFirstWindow(Ee,pe));Me.invokeFunction(Ee=>this.afterWindowOpen(Ee,me)),this.environmentMainService.args.trace&&Me.invokeFunction(Ee=>this.stopTracingEventually(Ee,De))}async resolveMachineId(){let fe=this.stateMainService.getItem(Ue.machineIdKey);return(!fe||m.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,u.getMachineId)(),this.stateMainService.setItem(Ue.machineIdKey,fe)),fe}setupSharedProcess(fe){const pe=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,fe,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(ke,"main")})(),me=(async()=>(await pe.whenReady(),ye))();return{sharedProcess:pe,sharedProcessReady:me,sharedProcessClient:ye}}async initServices(fe,pe,ye){const me=new U.ServiceCollection;switch(process.platform){case"win32":me.set(xe.IUpdateService,new W.SyncDescriptor(G.Win32UpdateService));break;case"linux":m.isLinuxSnap?me.set(xe.IUpdateService,new W.SyncDescriptor(et.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(xe.IUpdateService,new W.SyncDescriptor(je.LinuxUpdateService));break;case"darwin":me.set(xe.IUpdateService,new W.SyncDescriptor(at.DarwinUpdateService));break}me.set(Qe.IWindowsMainService,new W.SyncDescriptor(Ke.WindowsMainService,[fe,this.userEnv])),me.set(H.IDialogMainService,new W.SyncDescriptor(H.DialogMainService)),me.set(ae.ILaunchMainService,new W.SyncDescriptor(ae.LaunchMainService)),me.set(F.IDiagnosticsMainService,new W.SyncDescriptor(F.DiagnosticsMainService)),me.set(A.IDiagnosticsService,r.ProxyChannel.toService((0,r.getDelayedChannel)(ye.then(Le=>Le.getChannel("diagnostics"))))),me.set(K.IIssueMainService,new W.SyncDescriptor(K.IssueMainService,[this.userEnv])),me.set(Y.IEncryptionMainService,new W.SyncDescriptor(ie.EncryptionMainService,[fe])),me.set(ne.IKeyboardLayoutMainService,new W.SyncDescriptor(ne.KeyboardLayoutMainService)),me.set(we.INativeHostMainService,new W.SyncDescriptor(we.NativeHostMainService,[pe])),me.set(w.ICredentialsMainService,new W.SyncDescriptor(At.CredentialsNativeMainService)),me.set(Pe.IWebviewManagerService,new W.SyncDescriptor(Ne.WebviewMainService)),me.set(Ve.IWorkspacesService,new W.SyncDescriptor(ct.WorkspacesMainService)),me.set(Dt.IWorkspacesManagementMainService,new W.SyncDescriptor(Dt.WorkspacesManagementMainService)),me.set(tt.IWorkspacesHistoryMainService,new W.SyncDescriptor(tt.WorkspacesHistoryMainService)),me.set(de.IMenubarMainService,new W.SyncDescriptor(de.MenubarMainService)),me.set(Z.IExtensionUrlTrustService,new W.SyncDescriptor(V.ExtensionUrlTrustService)),me.set(B.IExtensionHostStarter,new W.SyncDescriptor($.WorkerMainProcessExtensionHostStarter)),me.set(_e.IStorageMainService,new W.SyncDescriptor(_e.StorageMainService)),me.set(_e.IGlobalStorageMainService,new W.SyncDescriptor(_e.GlobalStorageMainService)),m.isWindows?me.set(Q.IExternalTerminalMainService,new W.SyncDescriptor(q.WindowsExternalTerminalService)):m.isMacintosh?me.set(Q.IExternalTerminalMainService,new W.SyncDescriptor(q.MacExternalTerminalService)):m.isLinux&&me.set(Q.IExternalTerminalMainService,new W.SyncDescriptor(q.LinuxExternalTerminalService));const ke=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(s.IBackupMainService,ke),me.set(se.IURLService,new W.SyncDescriptor(ge.NativeURLService)),(0,Ze.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,r.getDelayedChannel)(ye.then(Te=>Te.getChannel("telemetryAppender"))),Me=new qe.TelemetryAppenderClient(Le),De=(0,Je.resolveCommonProperties)(this.fileService,(0,L.release)(),(0,L.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ee=(0,Ze.getPiiPathsFromEnvironment)(this.environmentMainService),Re={appenders:[Me],commonProperties:De,piiPaths:Ee,sendErrorTelemetry:!0};me.set(Ue.ITelemetryService,new W.SyncDescriptor(ot.TelemetryService,[Re]))}else me.set(Ue.ITelemetryService,Ze.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(me)}initChannels(fe,pe,ye){const me=r.ProxyChannel.fromService(fe.get(ae.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me);const ke=r.ProxyChannel.fromService(fe.get(F.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const Le=this.fileService.getProvider(g.Schemas.file);(0,S.assertType)(Le instanceof T.DiskFileSystemProvider);const Me=new N.DiskFileSystemProviderChannel(Le,this.logService,this.environmentMainService);pe.registerChannel(J.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ye.then($e=>$e.registerChannel(J.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const De=new vt.UpdateChannel(fe.get(xe.IUpdateService));pe.registerChannel("update",De);const Ee=r.ProxyChannel.fromService(fe.get(K.IIssueMainService));pe.registerChannel("issue",Ee);const Re=r.ProxyChannel.fromService(fe.get(Y.IEncryptionMainService));pe.registerChannel("encryption",Re);const Te=r.ProxyChannel.fromService(fe.get(w.ICredentialsMainService));pe.registerChannel("credentials",Te);const Be=r.ProxyChannel.fromService(fe.get(Se.ISignService));pe.registerChannel("sign",Be);const Ye=r.ProxyChannel.fromService(fe.get(ne.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Ye),this.nativeHostMainService=fe.get(we.INativeHostMainService);const it=r.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",it),ye.then($e=>$e.registerChannel("nativeHost",it));const yt=r.ProxyChannel.fromService(fe.get(Ve.IWorkspacesService));pe.registerChannel("workspaces",yt);const ze=r.ProxyChannel.fromService(fe.get(de.IMenubarMainService));pe.registerChannel("menubar",ze);const ft=r.ProxyChannel.fromService(fe.get(se.IURLService));pe.registerChannel("url",ft);const lt=r.ProxyChannel.fromService(fe.get(Z.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",lt);const ut=r.ProxyChannel.fromService(fe.get(Pe.IWebviewManagerService));pe.registerChannel("webview",ut);const dt=this._register(new We.StorageDatabaseChannel(this.logService,fe.get(_e.IStorageMainService)));pe.registerChannel("storage",dt),ye.then($e=>$e.registerChannel("storage",dt));const gt=r.ProxyChannel.fromService(fe.get(Q.IExternalTerminalMainService));pe.registerChannel("externalTerminal",gt);const nt=new ue.LogLevelChannel(fe.get(oe.ILogService));pe.registerChannel("logLevel",nt),ye.then($e=>$e.registerChannel("logLevel",nt));const rt=new ue.LoggerChannel(fe.get(oe.ILoggerService));pe.registerChannel("logger",rt),ye.then($e=>$e.registerChannel("logger",rt));const mt=new M.ElectronExtensionHostDebugBroadcastChannel(fe.get(Qe.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",mt);const Fe=r.ProxyChannel.fromService(fe.get(B.IExtensionHostStarter));pe.registerChannel(B.ipcExtensionHostStarterChannelName,Fe)}openFirstWindow(fe,pe){const ye=this.windowsMainService=fe.get(Qe.IWindowsMainService),me=fe.get(se.IURLService),ke=fe.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Fe=>{try{return{uri:C.URI.parse(Fe),url:Fe}}catch{return}}).filter(Fe=>{if(!Fe||this.shouldBlockURI(Fe.uri))return!1;const $e=this.getWindowOpenableFromProtocolLink(Fe.uri);return $e?(Le.push($e),!1):!0}),De=this,Ee=this.environmentMainService,Re=this.productService,Te=this.logService;me.registerHandler({async handleURL(Fe,$e){if(Te.trace("app#handleURL: ",Fe.toString(!0),$e),Fe.scheme===Re.urlProtocol&&Fe.path==="workspace"&&(Fe=Fe.with({authority:"file",path:C.URI.parse(Fe.query).path,query:""})),De.shouldBlockURI(Fe))return!0;let ht=!1;const bt=new URLSearchParams(Fe.query);bt.get("windowId")==="_blank"&&(bt.delete("windowId"),Fe=Fe.with({query:bt.toString()}),ht=!0),ht||(ht=m.isMacintosh&&ye.getWindowCount()===0);const Et=De.getWindowOpenableFromProtocolLink(Fe);if(Te.trace("app#handleURL: windowOpenableFromProtocolLink = ",Et),Et){const[Ct]=ye.open({context:5,cli:{...Ee.args},urisToOpen:[Et],forceNewWindow:ht,gotoLineMode:!0});return Ct.focus(),!0}if(ht){const[Ct]=ye.open({context:5,cli:{...Ee.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ae.getRemoteAuthority)(Fe)});return await Ct.ready(),me.open(Fe,$e)}return!1}});const Be=this._register(new Oe.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ye=new r.StaticRouter(Fe=>Be.getActiveClientId().then($e=>Fe===$e)),it=new ce.URLHandlerRouter(Ye),yt=pe.getChannel("urlHandler",it);me.registerHandler(new ce.URLHandlerChannelClient(yt)),this._register(new ve.ElectronURLListener(Me,me,ye,this.environmentMainService,this.productService));const ze=this.environmentMainService.args,ft=global.macOpenFiles,lt=(0,z.isLaunchedFromCli)(process.env)?0:4,ut=ze._.length,dt=!!ze["folder-uri"],gt=!!ze["file-uri"],nt=ze["skip-add-to-recently-opened"]===!0,rt=ze.wait&&ze.waitMarkerFilePath?C.URI.file(ze.waitMarkerFilePath):void 0,mt=ze.remote||void 0;return Le.length>0?ye.open({context:lt,cli:ze,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):ze["new-window"]&&!ut&&!dt&&!gt?ye.open({context:lt,cli:ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0,remoteAuthority:mt}):ft.length&&!ut&&!dt&&!gt?ye.open({context:1,cli:ze,urisToOpen:ft.map(Fe=>this.getWindowOpenableFromPathSync(Fe)),noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0}):ye.open({context:lt,cli:ze,forceNewWindow:ze["new-window"]||!ut&&ze["unity-launch"],diffMode:ze.diff,noRecentEntry:nt,waitMarkerFileURI:rt,gotoLineMode:ze.goto,initialStartup:!0,remoteAuthority:mt})}shouldBlockURI(fe){return!!(fe.authority===g.Schemas.file&&m.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,I.getPathLabel)(fe,{os:m.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===g.Schemas.file){const pe=C.URI.file(fe.fsPath);return(0,He.hasWorkspaceFileExtension)(pe)?{workspaceUri:pe}:{fileUri:pe}}else if(fe.authority===g.Schemas.vscodeRemote){const pe=fe.path.indexOf(h.posix.sep,1);if(pe!==-1){const ye=fe.path.substring(1,pe),me=fe.path.substring(pe),ke=C.URI.from({scheme:g.Schemas.vscodeRemote,authority:ye,path:me,query:fe.query,fragment:fe.fragment});return(0,He.hasWorkspaceFileExtension)(me)?{workspaceUri:ke}:/:[\d]+$/.test(me)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(fe){try{if((0,D.statSync)(fe).isDirectory())return{folderUri:C.URI.file(fe)};if((0,He.hasWorkspaceFileExtension)(fe))return{workspaceUri:C.URI.file(fe)}}catch{}return{fileUri:C.URI.file(fe)}}async afterWindowOpen(fe,pe){this.lifecycleMainService.phase=3;let ye=!1;(0,P.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const me=fe.get(Ue.ITelemetryService);this._register(pe.onDidError(({type:Me,details:De})=>{let Ee;switch(Me){case 1:Ee="SharedProcess: detected unresponsive window";break;case 2:Ee=`SharedProcess: crashed (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break;case 3:Ee=`SharedProcess: failed to load (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Ee)),me.publicLog2("sharedprocesserror",{type:Me,reason:De?.reason,code:De?.exitCode,visible:pe.isVisible(),shuttingdown:ye})}));const ke=this.productService.win32MutexName;if(m.isWindows&&ke)try{const Me=j.__$__nodeRequire("windows-mutex").Mutex,De=new Me(ke);(0,P.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(Me,De)=>{De({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const Le=fe.get(xe.IUpdateService);(Le instanceof G.Win32UpdateService||Le instanceof je.LinuxUpdateService||Le instanceof at.DarwinUpdateService)&&await Le.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const De=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,k.stripComments)(De))["enable-crash-reporter"]===void 0){const Te=(0,Ze.getTelemetryLevel)(this.configurationService)>=1,Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Te},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],Ye=De.substring(0,De.length-2).concat(`,
`,Be.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ye))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(fe,pe,ye){try{return await(0,x.getResolvedShellEnv)(this.logService,fe,pe)}catch(me){const ke=(0,y.toErrorMessage)(me);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(fe,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ye=fe.get(H.IDialogMainService);let me=!1;const ke=async Me=>{if(me)return;me=!0;const De=await v.contentTracing.stopRecording(`${(0,b.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,De),buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>ke(!0),3e4);Promise.all(pe.map(Me=>Me.ready())).then(()=>{clearTimeout(Le),ke(!1)})}};St=he([re(2,O.IInstantiationService),re(3,oe.ILogService),re(4,X.IEnvironmentMainService),re(5,le.ILifecycleMainService),re(6,d.IConfigurationService),re(7,Ce.IStateMainService),re(8,_.IFileService),re(9,Ie.IProductService)],St),e.CodeApplication=St}),define(ee[246],te([0,1,14,30,7,26,9,39,15,29,44,33,10,8,64,3,36,28,20,38,82,239,12,17,192,200,24,51,167,21,181,78,75,178,77,22,98,6,186,99,54,19,55,189,102,228,57,225,80,197,41,227,65,58,206]),function(j,e,v,t,D,L,R,y,E,b,P,k,I,p,g,h,m,S,C,f,u,c,r,l,i,n,o,s,a,d,w,M,A,F,H,Y,ie,X,z,x,Z,V,B,$,Q,q,J,_,N,T,W,O,U,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(oe){console.error(oe.message),v.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(Se=>console.error(Se));const[oe,ue,de,we,Ie,Ae,be]=this.createServices();try{try{await this.initServices(de,we,Ie)}catch(Se){throw this.handleStartupDataDirError(de,be.nameLong,Se),Se}await oe.invokeFunction(async Se=>{const Ce=Se.get(X.ILogService),We=Se.get(Y.ILifecycleMainService),_e=Se.get(d.IFileService),Je=await this.claimInstance(Ce,de,We,oe,be,!0);return C.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(Ue=>{Ce.warn(`Error writing main lockfile: ${Ue.stack}`)}),Ae.logger=new x.SpdLogLogger("main",(0,p.join)(de.logsPath,"main.log"),!0,!1,Ae.getLevel()),(0,P.once)(We.onWillShutdown)(Ue=>{_e.dispose(),we.dispose(),Ue.join(C.Promises.unlink(de.mainLockfile).catch(()=>{}))}),oe.createInstance(c.CodeApplication,Je,ue).startup()})}catch(Se){oe.invokeFunction(this.quit,Se)}}createServices(){const oe=new H.ServiceCollection,ue={_serviceBrand:void 0,...Z.default};oe.set(V.IProductService,ue);const de=new o.EnvironmentMainService(this.resolveArgs(),ue),we=this.patchEnvironment(de);oe.set(o.IEnvironmentMainService,de);const Ie=new ie.BufferLogService,Ae=new X.MultiplexLogService([new X.ConsoleMainLogger((0,X.getLogLevel)(de)),Ie]);process.once("exit",()=>Ae.dispose()),oe.set(X.ILogService,Ae);const be=new w.FileService(Ae);oe.set(d.IFileService,be);const Se=new M.DiskFileSystemProvider(Ae);be.registerProvider(I.Schemas.file,Se),oe.set(X.ILoggerService,new z.LoggerService(Ae,be));const Ce=new i.ConfigurationService(de.settingsResource,be);oe.set(l.IConfigurationService,Ce),oe.set(Y.ILifecycleMainService,new A.SyncDescriptor(Y.LifecycleMainService));const We=new O.StateMainService(de,Ae,be);return oe.set(W.IStateMainService,We),oe.set(J.IRequestService,new A.SyncDescriptor(_.RequestMainService)),oe.set(K.IThemeMainService,new A.SyncDescriptor(K.ThemeMainService)),oe.set(N.ISignService,new A.SyncDescriptor(T.SignService)),oe.set(Q.ITunnelService,new A.SyncDescriptor(q.TunnelService)),oe.set(B.IProtocolMainService,new A.SyncDescriptor($.ProtocolMainService)),[new F.InstantiationService(oe,!0),we,de,Ce,We,Ie,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const we=process.env[de];typeof we=="string"&&(ue[de]=we)}),Object.assign(process.env,ue),ue}initServices(oe,ue,de){return R.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.localHistoryHome.fsPath,oe.backupHome].map(we=>we?C.Promises.mkdir(we,{recursive:!0}):void 0)),ue.initialize(),de.init()])}async claimInstance(oe,ue,de,we,Ie,Ae){let be;try{(0,g.mark)("code/willStartMainServer"),be=await(0,u.serve)(ue.mainIPCHandle),(0,g.mark)("code/didStartMainServer"),(0,P.once)(de.onWillShutdown)(()=>be.dispose())}catch(Se){if(Se.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,Ie.nameLong,Se),Se;let Ce;try{Ce=await(0,u.connect)(ue.mainIPCHandle,"main")}catch(Ue){if(!Ae||h.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,r.localize)(0,null,Ie.nameShort),(0,r.localize)(1,null),Ie.nameLong),Ue;try{(0,t.unlinkSync)(ue.mainIPCHandle)}catch(qe){throw oe.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(oe,ue,de,we,Ie,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ue),Ce.dispose(),new Error(Ue)}let We;!ue.args.wait&&!ue.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,r.localize)(2,null,Ie.nameShort),(0,r.localize)(3,null),Ie.nameLong)},1e4));const _e=f.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),Je=f.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(ue.args.status)return we.invokeFunction(async()=>{const Ue=new n.DiagnosticsService(U.NullTelemetryService,Ie),qe=await _e.getMainProcessInfo(),ot=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ze=await Ue.getDiagnostics(qe,ot);throw console.log(Ze),new E.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(_e,oe),oe.trace("Sending env to running instance..."),await _e.start(ue.args,process.env),Ce.dispose(),We&&clearTimeout(We),new E.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),be}handleStartupDataDirError(oe,ue,de){if(de.code==="EACCES"||de.code==="EPERM"){const we=(0,L.coalesce)([oe.userDataPath,oe.extensionsPath,u.XDG_RUNTIME_DIR]).map(Ie=>(0,k.getPathLabel)(D.URI.file(Ie),{os:h.OS,tildify:oe}));this.showStartupWarningDialog((0,r.localize)(4,null),(0,r.localize)(5,null,(0,y.toErrorMessage)(de),we.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,de){v.dialog.showMessageBoxSync({title:de,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,r.localize)(6,null))],message:oe,detail:ue,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(h.isWindows){const de=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",de);try{(await new Promise((we,Ie)=>{j(["windows-foreground-love"],we,Ie)})).allowSetForegroundWindow(de)}catch(we){ue.error(we)}}}quit(oe,ue){const de=oe.get(X.ILogService),we=oe.get(Y.ILifecycleMainService);let Ie=0;ue&&(ue.isExpected?ue.message&&de.trace(ue.message):(Ie=1,ue.stack?de.error(ue.stack):de.error(`Startup error: ${ue.toString()}`))),we.kill(Ie)}resolveArgs(){const oe=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=(0,a.createWaitMarkerFile)(oe.verbose);ue&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const de=(0,m.cwd)(),we=oe.map(be=>{let Se=String(be),Ce;ue&&(Ce=(0,b.parseLineAndColumnAware)(Se),Se=Ce.path),Se&&(Se=this.preparePath(de,Se));const We=(0,b.sanitizeFilePath)(Se,de),_e=(0,p.basename)(We);return _e&&!(0,b.isValidBasename)(_e)?null:ue&&Ce?(Ce.path=We,this.toPath(Ce)):We}),Ie=h.isWindows||h.isMacintosh,Ae=(0,L.distinct)(we,be=>be&&Ie?be.toLowerCase():be||"");return(0,L.coalesce)(Ae)}preparePath(oe,ue){return h.isWindows&&(ue=(0,S.rtrim)(ue,'"')),ue=(0,S.trim)((0,S.trim)(ue," "),"	"),h.isWindows&&(ue=(0,p.resolve)(oe,ue),ue=(0,S.rtrim)(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c3511e6c69bb39013c4a4b7b9566ec1ca73fc4d5/core/vs/code/electron-main/main.js.map
