/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/platform","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/base/node/pfs","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/base/common/process","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","os","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/userDataPath","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],te=function(_){for(var i=[],R=0,I=_.length;R<I;R++)i[R]=ee[_[R]];return i};define(ee[61],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function R(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=R}),define(ee[45],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function R(k){return(S,l,m)=>{let L=null,T=null;if(typeof m.value=="function"?(L="value",T=m.value):typeof m.get=="function"&&(L="get",T=m.get),!T)throw new Error("not supported");m[L]=k(T,l)}}i.createDecorator=R;function I(k,S,l){let m=null,L=null;if(typeof l.value=="function"?(m="value",L=l.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",L=l.get),!L)throw new Error("not supported");const T=`$memoize$${S}`;l[m]=function(...v){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[T]}}i.memoize=I;function b(k,S,l){return R((m,L)=>{const T=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...w){this[v]||(this[v]=l?l():void 0),clearTimeout(this[T]),S&&(this[v]=S(this[v],...w),w=[this[v]]),this[T]=setTimeout(()=>{m.apply(this,w),this[v]=l?l():void 0},k)}})}i.debounce=b;function D(k,S,l){return R((m,L)=>{const T=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,w=`$throttle$lastRun$${L}`,P=`$throttle$pending$${L}`;return function(...g){if(this[v]||(this[v]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[v]=S(this[v],...g)),this[P])return;const y=this[w]+k;y<=Date.now()?(this[w]=Date.now(),m.apply(this,[this[v]]),this[v]=l?l():void 0):(this[P]=!0,this[T]=setTimeout(()=>{this[P]=!1,this[w]=Date.now(),m.apply(this,[this[v]]),this[v]=l?l():void 0},y-Date.now()))}})}i.throttle=D}),define(ee[46],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var R;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(R=i.ScanError||(i.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D=i.ParseOptions||(i.ParseOptions={}));function k(e,r=!1){let t=0,n=e.length,o="",c=0,f=16,d=0;function E(U){let W=0,J=0;for(;W<U;){const G=e.charCodeAt(t);if(G>=48&&G<=57)J=J*16+G-48;else if(G>=65&&G<=70)J=J*16+G-65+10;else if(G>=97&&G<=102)J=J*16+G-97+10;else break;t++,W++}return W<U&&(J=-1),J}function A(U){t=U,o="",c=0,f=16,d=0}function z(){const U=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&m(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&m(e.charCodeAt(t)))for(t++;t<e.length&&m(e.charCodeAt(t));)t++;else return d=3,e.substring(U,t);let W=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&m(e.charCodeAt(t))){for(t++;t<e.length&&m(e.charCodeAt(t));)t++;W=t}else d=3;return e.substring(U,W)}function Z(){let U="",W=t;for(;;){if(t>=n){U+=e.substring(W,t),d=2;break}const J=e.charCodeAt(t);if(J===34){U+=e.substring(W,t),t++;break}if(J===92){if(U+=e.substring(W,t),t++,t>=n){d=2;break}switch(e.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ne=E(4);ne>=0?U+=String.fromCharCode(ne):d=4;break}default:d=5}W=t;continue}if(J>=0&&J<=31)if(l(J)){U+=e.substring(W,t),d=2;break}else d=6;t++}return U}function Q(){if(o="",d=0,c=t,t>=n)return c=n,f=17;let U=e.charCodeAt(t);if(S(U)){do t++,o+=String.fromCharCode(U),U=e.charCodeAt(t);while(S(U));return f=15}if(l(U))return t++,o+=String.fromCharCode(U),U===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),f=14;switch(U){case 123:return t++,f=1;case 125:return t++,f=2;case 91:return t++,f=3;case 93:return t++,f=4;case 58:return t++,f=6;case 44:return t++,f=5;case 34:return t++,o=Z(),f=10;case 47:{const W=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<n&&!l(e.charCodeAt(t));)t++;return o=e.substring(W,t),f=12}if(e.charCodeAt(t+1)===42){t+=2;const J=n-1;let G=!1;for(;t<J;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,G=!0;break}t++}return G||(t++,d=1),o=e.substring(W,t),f=13}return o+=String.fromCharCode(U),t++,f=16}case 45:if(o+=String.fromCharCode(U),t++,t===n||!m(e.charCodeAt(t)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=z(),f=11;default:for(;t<n&&ie(U);)t++,U=e.charCodeAt(t);if(c!==t){switch(o=e.substring(c,t),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(U),t++,f=16}}function ie(U){if(S(U)||l(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let U;do U=Q();while(U>=12&&U<=15);return U}return{setPosition:A,getPosition:()=>t,scan:r?re:Q,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>d}}i.createScanner=k;function S(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function m(e){return e>=48&&e<=57}var L;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(L||(L={}));function T(e,r){const t=[],n=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function d(E,A,z,Z){c.value=E,c.offset=A,c.length=z,c.type=Z,c.colonOffset=void 0,o=c}try{p(e,{onObjectBegin:(E,A)=>{if(r<=E)throw n;o=void 0,f=r>E,t.push("")},onObjectProperty:(E,A,z)=>{if(r<A||(d(E,A,z,"property"),t[t.length-1]=E,r<=A+z))throw n},onObjectEnd:(E,A)=>{if(r<=E)throw n;o=void 0,t.pop()},onArrayBegin:(E,A)=>{if(r<=E)throw n;o=void 0,t.push(0)},onArrayEnd:(E,A)=>{if(r<=E)throw n;o=void 0,t.pop()},onLiteralValue:(E,A,z)=>{if(r<A||(d(E,A,z,s(E)),r<=A+z))throw n},onSeparator:(E,A,z)=>{if(r<=A)throw n;if(E===":"&&o&&o.type==="property")o.colonOffset=A,f=!1,o=void 0;else if(E===","){const Z=t[t.length-1];typeof Z=="number"?t[t.length-1]=Z+1:(f=!0,t[t.length-1]=""),o=void 0}}})}catch(E){if(E!==n)throw E}return{path:t,previousNode:o,isAtPropertyKey:f,matches:E=>{let A=0;for(let z=0;A<E.length&&z<t.length;z++)if(E[A]===t[z]||E[A]==="*")A++;else if(E[A]!=="**")return!1;return A===E.length}}}i.getLocation=T;function v(e,r=[],t=D.DEFAULT){let n=null,o=[];const c=[];function f(E){Array.isArray(o)?o.push(E):n!==null&&(o[n]=E)}return p(e,{onObjectBegin:()=>{const E={};f(E),c.push(o),o=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const E=[];f(E),c.push(o),o=E,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:f,onError:(E,A,z)=>{r.push({error:E,offset:A,length:z})}},t),o[0]}i.parse=v;function w(e,r=[],t=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function c(E){return n.children.push(E),E}p(e,{onObjectBegin:E=>{n=c({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,A,z)=>{n=c({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:A,length:z,parent:n})},onObjectEnd:(E,A)=>{n.length=E+A-n.offset,n=n.parent,o(E+A)},onArrayBegin:(E,A)=>{n=c({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,A)=>{n.length=E+A-n.offset,n=n.parent,o(E+A)},onLiteralValue:(E,A,z)=>{c({type:s(E),offset:A,length:z,parent:n,value:E}),o(A+z)},onSeparator:(E,A,z)=>{n.type==="property"&&(E===":"?n.colonOffset=A:E===","&&o(A))},onError:(E,A,z)=>{r.push({error:E,offset:A,length:z})}},t);const d=n.children[0];return d&&delete d.parent,d}i.parseTree=w;function P(e,r){if(!e)return;let t=e;for(let n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===n){t=c.children[1],o=!0;break}if(!o)return}else{const o=n;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=P;function g(e){if(!e.parent||!e.parent.children)return[];const r=g(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;r.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&r.push(t)}return r}i.getNodePath=g;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":{const r=Object.create(null);for(let t of e.children){const n=t.children[1];n&&(r[t.children[0].value]=y(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=y;function a(e,r,t=!1){return r>=e.offset&&r<e.offset+e.length||t&&r===e.offset+e.length}i.contains=a;function u(e,r,t=!1){if(a(e,r,t)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const c=u(n[o],r,t);if(c)return c}return e}}i.findNodeAtOffset=u;function p(e,r,t=D.DEFAULT){const n=k(e,!1);function o($){return $?()=>$(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c($){return $?se=>$(se,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=o(r.onObjectBegin),d=c(r.onObjectProperty),E=o(r.onObjectEnd),A=o(r.onArrayBegin),z=o(r.onArrayEnd),Z=c(r.onLiteralValue),Q=c(r.onSeparator),ie=o(r.onComment),re=c(r.onError),U=t&&t.disallowComments,W=t&&t.allowTrailingComma;function J(){for(;;){const $=n.scan();switch(n.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:U||G(11);break;case 2:G(12);break;case 6:G(16);break}switch($){case 12:case 13:U?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return $}}}function G($,se=[],N=[]){if(re($),se.length+N.length>0){let M=n.getToken();for(;M!==17;){if(se.indexOf(M)!==-1){J();break}else if(N.indexOf(M)!==-1)break;M=J()}}}function ne($){const se=n.getTokenValue();return $?Z(se):d(se),J(),!0}function O(){switch(n.getToken()){case 11:{let $=0;try{$=JSON.parse(n.getTokenValue()),typeof $!="number"&&(G(2),$=0)}catch{G(2)}Z($);break}case 7:Z(null);break;case 8:Z(!0);break;case 9:Z(!1);break;default:return!1}return J(),!0}function C(){return n.getToken()!==10?(G(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(Q(":"),J(),q()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function F(){f(),J();let $=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if($||G(4,[],[]),Q(","),J(),n.getToken()===2&&W)break}else $&&G(6,[],[]);C()||G(4,[],[2,5]),$=!0}return E(),n.getToken()!==2?G(7,[2],[]):J(),!0}function x(){A(),J();let $=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if($||G(4,[],[]),Q(","),J(),n.getToken()===4&&W)break}else $&&G(6,[],[]);q()||G(4,[],[4,5]),$=!0}return z(),n.getToken()!==4?G(8,[4],[]):J(),!0}function q(){switch(n.getToken()){case 3:return x();case 1:return F();case 10:return ne(!0);default:return O()}}return J(),n.getToken()===17?t.allowEmptyContent?!0:(G(4,[],[]),!1):q()?(n.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}i.visit=p;function h(e,r){let t=k(e),n=[],o,c=0,f;do switch(f=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==f&&n.push(e.substring(c,f)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(o!==17);return n.join("")}i.stripComments=h;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function _(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function k(l){D.push(l,Date.now())}function S(){const l=[];for(let m=0;m<D.length;m+=2)l.push({name:D[m],startTime:D[m+1]});return l}return{mark:k,getMarks:S}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(b+k.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function R(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=R(I))}(),define(ee[47],te([0,1,10]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var I;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(I=i.Source||(i.Source={}));var b;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(b=i.TerminateResponseCode||(i.TerminateResponseCode={}));function D(S,...l){const m=l.reduce((v,w)=>(v[w]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(v=>!m[v]).forEach(v=>{for(let w=0;w<L.length;w++)if(v.search(L[w])!==-1){delete S[v];break}})}i.sanitizeProcessEnvironment=D;function k(S){!S||(delete S.DEBUG,R.isMacintosh&&delete S.DYLD_LIBRARY_PATH,R.isLinux&&delete S.LD_PRELOAD)}i.removeDangerousEnvVariables=k}),function(_,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var R=i();for(var I in R)(typeof exports=="object"?exports:_)[I]=R[I]}}(typeof self!="undefined"?self:this,function(){return function(_){var i={};function R(I){if(i[I])return i[I].exports;var b=i[I]={i:I,l:!1,exports:{}};return _[I].call(b.exports,b,b.exports,R),b.l=!0,b.exports}return R.m=_,R.c=i,R.d=function(I,b,D){R.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:D})},R.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},R.t=function(I,b){if(1&b&&(I=R(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var D=Object.create(null);if(R.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var k in I)R.d(D,k,function(S){return I[S]}.bind(null,k));return D},R.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return R.d(b,"a",b),b},R.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},R.p="",R(R.s=0)}([function(_,i,R){(function(I){var b;i=_.exports=N,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var D=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,S=i.re=[],l=i.src=[],m=0,L=m++;l[L]="0|[1-9]\\d*";var T=m++;l[T]="[0-9]+";var v=m++;l[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=m++;l[w]="("+l[L]+")\\.("+l[L]+")\\.("+l[L]+")";var P=m++;l[P]="("+l[T]+")\\.("+l[T]+")\\.("+l[T]+")";var g=m++;l[g]="(?:"+l[L]+"|"+l[v]+")";var y=m++;l[y]="(?:"+l[T]+"|"+l[v]+")";var a=m++;l[a]="(?:-("+l[g]+"(?:\\."+l[g]+")*))";var u=m++;l[u]="(?:-?("+l[y]+"(?:\\."+l[y]+")*))";var p=m++;l[p]="[0-9A-Za-z-]+";var h=m++;l[h]="(?:\\+("+l[p]+"(?:\\."+l[p]+")*))";var s=m++,e="v?"+l[w]+l[a]+"?"+l[h]+"?";l[s]="^"+e+"$";var r="[v=\\s]*"+l[P]+l[u]+"?"+l[h]+"?",t=m++;l[t]="^"+r+"$";var n=m++;l[n]="((?:<|>)?=?)";var o=m++;l[o]=l[T]+"|x|X|\\*";var c=m++;l[c]=l[L]+"|x|X|\\*";var f=m++;l[f]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[a]+")?"+l[h]+"?)?)?";var d=m++;l[d]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[u]+")?"+l[h]+"?)?)?";var E=m++;l[E]="^"+l[n]+"\\s*"+l[f]+"$";var A=m++;l[A]="^"+l[n]+"\\s*"+l[d]+"$";var z=m++;l[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Z=m++;l[Z]="(?:~>?)";var Q=m++;l[Q]="(\\s*)"+l[Z]+"\\s+",S[Q]=new RegExp(l[Q],"g");var ie=m++;l[ie]="^"+l[Z]+l[f]+"$";var re=m++;l[re]="^"+l[Z]+l[d]+"$";var U=m++;l[U]="(?:\\^)";var W=m++;l[W]="(\\s*)"+l[U]+"\\s+",S[W]=new RegExp(l[W],"g");var J=m++;l[J]="^"+l[U]+l[f]+"$";var G=m++;l[G]="^"+l[U]+l[d]+"$";var ne=m++;l[ne]="^"+l[n]+"\\s*("+r+")$|^$";var O=m++;l[O]="^"+l[n]+"\\s*("+e+")$|^$";var C=m++;l[C]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[f]+")",S[C]=new RegExp(l[C],"g");var F=m++;l[F]="^\\s*("+l[f]+")\\s+-\\s+("+l[f]+")\\s*$";var x=m++;l[x]="^\\s*("+l[d]+")\\s+-\\s+("+l[d]+")\\s*$";var q=m++;l[q]="(<|>)?=?\\s*\\*";for(var $=0;$<35;$++)b($,l[$]),S[$]||(S[$]=new RegExp(l[$]));function se(V,H){if(V instanceof N)return V;if(typeof V!="string"||V.length>D||!(H?S[t]:S[s]).test(V))return null;try{return new N(V,H)}catch{return null}}function N(V,H){if(V instanceof N){if(V.loose===H)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof N))return new N(V,H);b("SemVer",V,H),this.loose=H;var X=V.trim().match(H?S[t]:S[s]);if(!X)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<k)return me}return fe}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}i.parse=se,i.valid=function(V,H){var X=se(V,H);return X?X.version:null},i.clean=function(V,H){var X=se(V.trim().replace(/^[=v]+/,""),H);return X?X.version:null},i.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(V){return b("SemVer.compare",this.version,this.loose,V),V instanceof N||(V=new N(V,this.loose)),this.compareMain(V)||this.comparePre(V)},N.prototype.compareMain=function(V){return V instanceof N||(V=new N(V,this.loose)),j(this.major,V.major)||j(this.minor,V.minor)||j(this.patch,V.patch)},N.prototype.comparePre=function(V){if(V instanceof N||(V=new N(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],fe=V.prerelease[H];if(b("prerelease compare",H,X,fe),X===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(X===void 0)return-1;if(X!==fe)return j(X,fe)}while(++H)},N.prototype.inc=function(V,H){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},i.inc=function(V,H,X,fe){typeof X=="string"&&(fe=X,X=void 0);try{return new N(V,X).inc(H,fe).version}catch{return null}},i.diff=function(V,H){if(oe(V,H))return null;var X=se(V),fe=se(H);if(X.prerelease.length||fe.prerelease.length){for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==fe[me])return me},i.compareIdentifiers=j;var M=/^[0-9]+$/;function j(V,H){var X=M.test(V),fe=M.test(H);return X&&fe&&(V=+V,H=+H),X&&!fe?-1:fe&&!X?1:V<H?-1:V>H?1:0}function B(V,H,X){return new N(V,X).compare(new N(H,X))}function K(V,H,X){return B(V,H,X)>0}function Y(V,H,X){return B(V,H,X)<0}function oe(V,H,X){return B(V,H,X)===0}function ce(V,H,X){return B(V,H,X)!==0}function de(V,H,X){return B(V,H,X)>=0}function ve(V,H,X){return B(V,H,X)<=0}function le(V,H,X,fe){var me;switch(H){case"===":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),me=V===X;break;case"!==":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),me=V!==X;break;case"":case"=":case"==":me=oe(V,X,fe);break;case"!=":me=ce(V,X,fe);break;case">":me=K(V,X,fe);break;case">=":me=de(V,X,fe);break;case"<":me=Y(V,X,fe);break;case"<=":me=ve(V,X,fe);break;default:throw new TypeError("Invalid operator: "+H)}return me}function ue(V,H){if(V instanceof ue){if(V.loose===H)return V;V=V.value}if(!(this instanceof ue))return new ue(V,H);b("comparator",V,H),this.loose=H,this.parse(V),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(V,H){return j(H,V)},i.major=function(V,H){return new N(V,H).major},i.minor=function(V,H){return new N(V,H).minor},i.patch=function(V,H){return new N(V,H).patch},i.compare=B,i.compareLoose=function(V,H){return B(V,H,!0)},i.rcompare=function(V,H,X){return B(H,V,X)},i.sort=function(V,H){return V.sort(function(X,fe){return i.compare(X,fe,H)})},i.rsort=function(V,H){return V.sort(function(X,fe){return i.rcompare(X,fe,H)})},i.gt=K,i.lt=Y,i.eq=oe,i.neq=ce,i.gte=de,i.lte=ve,i.cmp=le,i.Comparator=ue;var ye={};function ge(V,H){if(V instanceof ge)return V.loose===H?V:new ge(V.raw,H);if(V instanceof ue)return new ge(V.value,H);if(!(this instanceof ge))return new ge(V,H);if(this.loose=H,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Ee(V){return!V||V.toLowerCase()==="x"||V==="*"}function Fe(V,H,X,fe,me,De,we,Oe,Ie,Te,Ne,Re,Ce){return((H=Ee(X)?"":Ee(fe)?">="+X+".0.0":Ee(me)?">="+X+"."+fe+".0":">="+H)+" "+(Oe=Ee(Ie)?"":Ee(Te)?"<"+(+Ie+1)+".0.0":Ee(Ne)?"<"+Ie+"."+(+Te+1)+".0":Re?"<="+Ie+"."+Te+"."+Ne+"-"+Re:"<="+Oe)).trim()}function je(V,H){for(var X=0;X<V.length;X++)if(!V[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<V.length;X++)if(b(V[X].semver),V[X].semver!==ye&&V[X].semver.prerelease.length>0){var fe=V[X].semver;if(fe.major===H.major&&fe.minor===H.minor&&fe.patch===H.patch)return!0}return!1}return!0}function ze(V,H,X){try{H=new ge(H,X)}catch{return!1}return H.test(V)}function xe(V,H,X,fe){var me,De,we,Oe,Ie;switch(V=new N(V,fe),H=new ge(H,fe),X){case">":me=K,De=ve,we=Y,Oe=">",Ie=">=";break;case"<":me=Y,De=de,we=K,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(V,H,fe))return!1;for(var Te=0;Te<H.set.length;++Te){var Ne=H.set[Te],Re=null,Ce=null;if(Ne.forEach(function(ke){ke.semver===ye&&(ke=new ue(">=0.0.0")),Re=Re||ke,Ce=Ce||ke,me(ke.semver,Re.semver,fe)?Re=ke:we(ke.semver,Ce.semver,fe)&&(Ce=ke)}),Re.operator===Oe||Re.operator===Ie||(!Ce.operator||Ce.operator===Oe)&&De(V,Ce.semver)||Ce.operator===Ie&&we(V,Ce.semver))return!1}return!0}ue.prototype.parse=function(V){var H=this.loose?S[ne]:S[O],X=V.match(H);if(!X)throw new TypeError("Invalid comparator: "+V);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new N(X[2],this.loose):this.semver=ye},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(V){return b("Comparator.test",V,this.loose),this.semver===ye||(typeof V=="string"&&(V=new N(V,this.loose)),le(V,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(V,H){if(!(V instanceof ue))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ge(V.value,H),ze(this.value,X,H);if(V.operator==="")return X=new ge(this.value,H),ze(V.semver,X,H);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Oe=le(this.semver,"<",V.semver,H)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=le(this.semver,">",V.semver,H)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||me||De&&we||Oe||Ie},i.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(V){var H=this.loose;V=V.trim(),b("range",V,H);var X=H?S[x]:S[F];V=V.replace(X,Fe),b("hyphen replace",V),V=V.replace(S[C],"$1$2$3"),b("comparator trim",V,S[C]),V=(V=(V=V.replace(S[Q],"$1~")).replace(S[W],"$1^")).split(/\s+/).join(" ");var fe=H?S[ne]:S[O],me=V.split(" ").map(function(De){return function(we,Oe){return b("comp",we),we=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Ne){return function(Re,Ce){b("caret",Re,Ce);var ke=Ce?S[G]:S[J];return Re.replace(ke,function(Ae,pe,Se,be,Pe){var Le;return b("caret",Re,Ae,pe,Se,be,Pe),Ee(pe)?Le="":Ee(Se)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(be)?Le=pe==="0"?">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0":">="+pe+"."+Se+".0 <"+(+pe+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=pe==="0"?Se==="0"?">="+pe+"."+Se+"."+be+Pe+" <"+pe+"."+Se+"."+(+be+1):">="+pe+"."+Se+"."+be+Pe+" <"+pe+"."+(+Se+1)+".0":">="+pe+"."+Se+"."+be+Pe+" <"+(+pe+1)+".0.0"):(b("no pr"),Le=pe==="0"?Se==="0"?">="+pe+"."+Se+"."+be+" <"+pe+"."+Se+"."+(+be+1):">="+pe+"."+Se+"."+be+" <"+pe+"."+(+Se+1)+".0":">="+pe+"."+Se+"."+be+" <"+(+pe+1)+".0.0"),b("caret return",Le),Le})}(Ne,Te)}).join(" ")}(we,Oe),b("caret",we),we=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Ne){return function(Re,Ce){var ke=Ce?S[re]:S[ie];return Re.replace(ke,function(Ae,pe,Se,be,Pe){var Le;return b("tilde",Re,Ae,pe,Se,be,Pe),Ee(pe)?Le="":Ee(Se)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(be)?Le=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+pe+"."+Se+"."+be+Pe+" <"+pe+"."+(+Se+1)+".0"):Le=">="+pe+"."+Se+"."+be+" <"+pe+"."+(+Se+1)+".0",b("tilde return",Le),Le})}(Ne,Te)}).join(" ")}(we,Oe),b("tildes",we),we=function(Ie,Te){return b("replaceXRanges",Ie,Te),Ie.split(/\s+/).map(function(Ne){return function(Re,Ce){Re=Re.trim();var ke=Ce?S[A]:S[E];return Re.replace(ke,function(Ae,pe,Se,be,Pe,Le){b("xRange",Re,Ae,pe,Se,be,Pe,Le);var Ve=Ee(Se),Me=Ve||Ee(be),Ue=Me||Ee(Pe);return pe==="="&&Ue&&(pe=""),Ve?Ae=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Ue?(Me&&(be=0),Ue&&(Pe=0),pe===">"?(pe=">=",Me?(Se=+Se+1,be=0,Pe=0):Ue&&(be=+be+1,Pe=0)):pe==="<="&&(pe="<",Me?Se=+Se+1:be=+be+1),Ae=pe+Se+"."+be+"."+Pe):Me?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ue&&(Ae=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),b("xRange return",Ae),Ae})}(Ne,Te)}).join(" ")}(we,Oe),b("xrange",we),we=function(Ie,Te){return b("replaceStars",Ie,Te),Ie.trim().replace(S[q],"")}(we,Oe),b("stars",we),we}(De,H)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(fe)})),me=me.map(function(De){return new ue(De,H)})},ge.prototype.intersects=function(V,H){if(!(V instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(fe){return V.set.some(function(me){return me.every(function(De){return fe.intersects(De,H)})})})})},i.toComparators=function(V,H){return new ge(V,H).set.map(function(X){return X.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new N(V,this.loose));for(var H=0;H<this.set.length;H++)if(je(this.set[H],V))return!0;return!1},i.satisfies=ze,i.maxSatisfying=function(V,H,X){var fe=null,me=null;try{var De=new ge(H,X)}catch{return null}return V.forEach(function(we){De.test(we)&&(fe&&me.compare(we)!==-1||(me=new N(fe=we,X)))}),fe},i.minSatisfying=function(V,H,X){var fe=null,me=null;try{var De=new ge(H,X)}catch{return null}return V.forEach(function(we){De.test(we)&&(fe&&me.compare(we)!==1||(me=new N(fe=we,X)))}),fe},i.validRange=function(V,H){try{return new ge(V,H).range||"*"}catch{return null}},i.ltr=function(V,H,X){return xe(V,H,"<",X)},i.gtr=function(V,H,X){return xe(V,H,">",X)},i.outside=xe,i.prerelease=function(V,H){var X=se(V,H);return X&&X.prerelease.length?X.prerelease:null},i.intersects=function(V,H,X){return V=new ge(V,X),H=new ge(H,X),V.intersects(H)},i.coerce=function(V){if(V instanceof N)return V;if(typeof V!="string")return null;var H=V.match(S[z]);return H==null?null:se((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,R(1))},function(_,i){var R,I,b=_.exports={};function D(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function S(y){if(R===setTimeout)return setTimeout(y,0);if((R===D||!R)&&setTimeout)return R=setTimeout,setTimeout(y,0);try{return R(y,0)}catch{try{return R.call(null,y,0)}catch{return R.call(this,y,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:D}catch{R=D}try{I=typeof clearTimeout=="function"?clearTimeout:k}catch{I=k}})();var l,m=[],L=!1,T=-1;function v(){L&&l&&(L=!1,l.length?m=l.concat(m):T=-1,m.length&&w())}function w(){if(!L){var y=S(v);L=!0;for(var a=m.length;a;){for(l=m,m=[];++T<a;)l&&l[T].run();T=-1,a=m.length}l=null,L=!1,function(u){if(I===clearTimeout)return clearTimeout(u);if((I===k||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(u);try{I(u)}catch{try{return I.call(null,u)}catch{return I.call(this,u)}}}(y)}}function P(y,a){this.fun=y,this.array=a}function g(){}b.nextTick=function(y){var a=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)a[u-1]=arguments[u];m.push(new P(y,a)),m.length!==1||L||S(w)},P.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(y){return[]},b.binding=function(y){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(y){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(ee[62],te([0,1]),function(_,i){"use strict";var R;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(S,l,m){this.level=S,this.key=l,this.value=m,this.forward=[]}}const b=void 0;class D{constructor(S,l=2**16){this.comparator=S,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(S){return Boolean(D._search(this,S,this.comparator))}get(S){return D._search(this,S,this.comparator)?.value}set(S,l){return D._insert(this,S,l,this.comparator)&&(this._size+=1),this}delete(S){const l=D._delete(this,S,this.comparator);return l&&(this._size-=1),l}forEach(S,l){let m=this._header.forward[0];for(;m;)S.call(l,m.value,m.key,this),m=m.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",l=this._header.forward[0];for(;l;)S+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return S}static _search(S,l,m){let L=S._header;for(let T=S._level-1;T>=0;T--)for(;L.forward[T]&&m(L.forward[T].key,l)<0;)L=L.forward[T];if(L=L.forward[0],L&&m(L.key,l)===0)return L}static _insert(S,l,m,L){let T=[],v=S._header;for(let w=S._level-1;w>=0;w--){for(;v.forward[w]&&L(v.forward[w].key,l)<0;)v=v.forward[w];T[w]=v}if(v=v.forward[0],v&&L(v.key,l)===0)return v.value=m,!1;{let w=D._randomLevel(S);if(w>S._level){for(let P=S._level;P<w;P++)T[P]=S._header;S._level=w}v=new I(w,l,m);for(let P=0;P<w;P++)v.forward[P]=T[P].forward[P],T[P].forward[P]=v;return!0}}static _randomLevel(S,l=.5){let m=1;for(;Math.random()<l&&m<S._maxLevel;)m+=1;return m}static _delete(S,l,m){let L=[],T=S._header;for(let v=S._level-1;v>=0;v--){for(;T.forward[v]&&m(T.forward[v].key,l)<0;)T=T.forward[v];L[v]=T}if(T=T.forward[0],!T||m(T.key,l)!==0)return!1;for(let v=0;v<S._level&&L[v].forward[v]===T;v++)L[v].forward[v]=T.forward[v];for(;S._level>0&&S._header.forward[S._level-1]===b;)S._level-=1;return!0}}i.SkipList=D}),define(ee[48],te([0,1,3,2]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const b=k=>({onDidChange:R.Event.None,value:k});i.staticObservableValue=b;class D extends I.Disposable{constructor(S){super();this._value=S,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(S){S!==this._value&&(this._value=S,this.changeEmitter.fire(S))}}i.MutableObservableValue=D}),define(ee[38],te([0,1,7,2]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function b(h){const s=h;return s?typeof s.read=="function":!1}i.isReadable=b;function D(h){const s=h;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=D;function k(h){const s=h;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=k;function S(h,s){return new l(h,s)}i.newWriteableStream=S;class l{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,R.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(e);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(h,s){const e=[];let r;for(;(r=h.read())!==null;)e.push(r);return s(e)}i.consumeReadable=m;function L(h,s,e){const r=[];let t;for(;(t=h.read())!==null&&r.length<e;)r.push(t);return t===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t!="undefined"){const n=t;return t=void 0,n}return h.read()}}}i.peekReadable=L;function T(h,s){return new Promise((e,r)=>{const t=[];v(h,{onData:n=>{s&&t.push(n)},onError:n=>{s?r(n):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=T;function v(h,s){let e=!1;return h.on("error",r=>{e||s.onError(r)}),h.on("end",()=>{e||s.onEnd()}),h.on("data",r=>{e||s.onData(r)}),(0,I.toDisposable)(()=>e=!0)}i.listenStream=v;function w(h,s){return new Promise((e,r)=>{const t=new I.DisposableStore,n=[],o=d=>{if(n.push(d),n.length>s)return t.dispose(),h.pause(),e({stream:h,buffer:n,ended:!1})},c=d=>r(d),f=()=>e({stream:h,buffer:n,ended:!0});t.add((0,I.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),t.add((0,I.toDisposable)(()=>h.removeListener("end",f))),h.on("end",f),t.add((0,I.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}i.peekStream=w;function P(h,s){const e=S(s);return e.end(h),e}i.toStream=P;function g(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}i.emptyStream=g;function y(h){let s=!1;return{read:()=>s?null:(s=!0,h)}}i.toReadable=y;function a(h,s,e){const r=S(e);return v(h,{onData:t=>r.write(s.data(t)),onError:t=>r.error(s.error?s.error(t):t),onEnd:()=>r.end()}),r}i.transform=a;function u(h,s,e){let r=!1;return{read:()=>{const t=s.read();return r?t:(r=!0,t!==null?e([h,t]):h)}}}i.prefixedReadable=u;function p(h,s,e){let r=!1;const t=S(e);return v(s,{onData:n=>r?t.write(n):(r=!0,t.write(e([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}i.prefixedStream=p}),define(ee[16],te([0,1,38]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,D;class k{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return I?new k(Buffer.allocUnsafe(d)):new k(new Uint8Array(d))}static wrap(d){return I&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new k(d)}static fromString(d,E){return!(E?.dontUseNodeBuffer||!1)&&I?new k(Buffer.from(d)):(b||(b=new TextEncoder),new k(b.encode(d)))}static fromByteArray(d){const E=k.alloc(d.length);for(let A=0,z=d.length;A<z;A++)E.buffer[A]=d[A];return E}static concat(d,E){if(typeof E=="undefined"){E=0;for(let Z=0,Q=d.length;Z<Q;Z++)E+=d[Z].byteLength}const A=k.alloc(E);let z=0;for(let Z=0,Q=d.length;Z<Q;Z++){const ie=d[Z];A.set(ie,z),z+=ie.byteLength}return A}clone(){const d=k.alloc(this.byteLength);return d.set(this),d}toString(){return I?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(d,E){return new k(this.buffer.subarray(d,E))}set(d,E){if(d instanceof k)this.buffer.set(d.buffer,E);else if(d instanceof Uint8Array)this.buffer.set(d,E);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),E);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return m(this.buffer,d)}writeUInt32BE(d,E){L(this.buffer,d,E)}readUInt32LE(d){return T(this.buffer,d)}writeUInt32LE(d,E){v(this.buffer,d,E)}readUInt8(d){return w(this.buffer,d)}writeUInt8(d,E){P(this.buffer,d,E)}}i.VSBuffer=k;function S(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0}i.readUInt16LE=S;function l(f,d,E){f[E+0]=d&255,d=d>>>8,f[E+1]=d&255}i.writeUInt16LE=l;function m(f,d){return f[d]*2**24+f[d+1]*2**16+f[d+2]*2**8+f[d+3]}i.readUInt32BE=m;function L(f,d,E){f[E+3]=d,d=d>>>8,f[E+2]=d,d=d>>>8,f[E+1]=d,d=d>>>8,f[E]=d}i.writeUInt32BE=L;function T(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0|f[d+2]<<16>>>0|f[d+3]<<24>>>0}i.readUInt32LE=T;function v(f,d,E){f[E+0]=d&255,d=d>>>8,f[E+1]=d&255,d=d>>>8,f[E+2]=d&255,d=d>>>8,f[E+3]=d&255}i.writeUInt32LE=v;function w(f,d){return f[d]}i.readUInt8=w;function P(f,d,E){f[E]=d}i.writeUInt8=P;function g(f){return R.consumeReadable(f,d=>k.concat(d))}i.readableToBuffer=g;function y(f){return R.toReadable(f)}i.bufferToReadable=y;function a(f){return R.consumeStream(f,d=>k.concat(d))}i.streamToBuffer=a;async function u(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await a(f.stream)])}i.bufferedStreamToBuffer=u;function p(f){return R.toStream(f,d=>k.concat(d))}i.bufferToStream=p;function h(f){return R.transform(f,{data:d=>typeof d=="string"?k.fromString(d):k.wrap(d)},d=>k.concat(d))}i.streamToBufferReadableStream=h;function s(f){return R.newWriteableStream(d=>k.concat(d),f)}i.newWriteableBufferStream=s;function e(f,d){return R.prefixedReadable(f,d,E=>k.concat(E))}i.prefixedBufferReadable=e;function r(f,d){return R.prefixedStream(f,d,E=>k.concat(E))}i.prefixedBufferStream=r;function t(f){let d=0,E=0,A=0;const z=new Uint8Array(Math.floor(f.length/4*3)),Z=ie=>{switch(E){case 3:z[A++]=d|ie,E=0;break;case 2:z[A++]=d|ie>>>2,d=ie<<6,E=3;break;case 1:z[A++]=d|ie>>>4,d=ie<<4,E=2;break;default:d=ie<<2,E=1}};for(let ie=0;ie<f.length;ie++){const re=f.charCodeAt(ie);if(re>=65&&re<=90)Z(re-65);else if(re>=97&&re<=122)Z(re-97+26);else if(re>=48&&re<=57)Z(re-48+52);else if(re===43||re===45)Z(62);else if(re===47||re===95)Z(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${f[ie]}`)}}const Q=A;for(;E>0;)Z(0);return k.wrap(z).slice(0,Q)}i.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:f},d=!0,E=!1){const A=E?o:n;let z="";const Z=f.byteLength%3;let Q=0;for(;Q<f.byteLength-Z;Q+=3){const ie=f[Q+0],re=f[Q+1],U=f[Q+2];z+=A[ie>>>2],z+=A[(ie<<4|re>>>4)&63],z+=A[(re<<2|U>>>6)&63],z+=A[U&63]}if(Z===1){const ie=f[Q+0];z+=A[ie>>>2],z+=A[ie<<4&63],d&&(z+="==")}else if(Z===2){const ie=f[Q+0],re=f[Q+1];z+=A[ie>>>2],z+=A[(ie<<4|re>>>4)&63],z+=A[re<<2&63],d&&(z+="=")}return z}i.encodeBase64=c}),define(ee[63],te([0,1,25]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function I(a){return b(a,0)}i.hash=I;function b(a,u){switch(typeof a){case"object":return a===null?D(349,u):Array.isArray(a)?l(a,u):m(a,u);case"string":return S(a,u);case"boolean":return k(a,u);case"number":return D(a,u);case"undefined":return D(937,u);default:return D(617,u)}}i.doHash=b;function D(a,u){return(u<<5)-u+a|0}i.numberHash=D;function k(a,u){return D(a?433:863,u)}function S(a,u){u=D(149417,u);for(let p=0,h=a.length;p<h;p++)u=D(a.charCodeAt(p),u);return u}i.stringHash=S;function l(a,u){return u=D(104579,u),a.reduce((p,h)=>b(h,p),u)}function m(a,u){return u=D(181387,u),Object.keys(a).sort().reduce((p,h)=>(p=S(h,p),b(a[h],p)),u)}class L{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=b(u,this._value),this._value}}i.Hasher=L;var T;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function v(a,u,p=32){const h=p-u,s=~((1<<h)-1);return(a<<u|(s&a)>>>h)>>>0}function w(a,u=0,p=a.byteLength,h=0){for(let s=0;s<p;s++)a[u+s]=h}function P(a,u,p="0"){for(;a.length<u;)a=p+a;return a}function g(a,u=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(p=>p.toString(16).padStart(2,"0")).join(""):P((a>>>0).toString(16),u/4)}i.toHexString=g;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const p=u.length;if(p===0)return;const h=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,r,t;for(e!==0?(r=e,t=-1,e=0):(r=u.charCodeAt(0),t=0);;){let n=r;if(R.isHighSurrogate(r))if(t+1<p){const o=u.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,n=R.computeCodePoint(r,o)):n=65533}else{e=r;break}else R.isLowSurrogate(r)&&(n=65533);if(s=this._push(h,s,n),t++,t<p)r=u.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(u,p,h){return h<128?u[p++]=h:h<2048?(u[p++]=192|(h&1984)>>>6,u[p++]=128|(h&63)>>>0):h<65536?(u[p++]=224|(h&61440)>>>12,u[p++]=128|(h&4032)>>>6,u[p++]=128|(h&63)>>>0):(u[p++]=240|(h&1835008)>>>18,u[p++]=128|(h&258048)>>>12,u[p++]=128|(h&4032)>>>6,u[p++]=128|(h&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=y._bigBlock32,p=this._buffDV;for(let f=0;f<64;f+=4)u.setUint32(f,p.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)u.setUint32(f,v(u.getUint32(f-12,!1)^u.getUint32(f-32,!1)^u.getUint32(f-56,!1)^u.getUint32(f-64,!1),1),!1);let h=this._h0,s=this._h1,e=this._h2,r=this._h3,t=this._h4,n,o,c;for(let f=0;f<80;f++)f<20?(n=s&e|~s&r,o=1518500249):f<40?(n=s^e^r,o=1859775393):f<60?(n=s&e|s&r|e&r,o=2400959708):(n=s^e^r,o=3395469782),c=v(h,5)+n+t+o+u.getUint32(f*4,!1)&4294967295,t=r,r=e,e=v(s,30),s=h,h=c;this._h0=this._h0+h&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[49],te([0,1,25]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var I;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(I||(I={})),function(b){const D="error",k="warning",S="warn",l="info",m="ignore";function L(v){return v?R.equalsIgnoreCase(D,v)?b.Error:R.equalsIgnoreCase(k,v)||R.equalsIgnoreCase(S,v)?b.Warning:R.equalsIgnoreCase(l,v)?b.Info:b.Ignore:b.Ignore}b.fromValue=L;function T(v){switch(v){case b.Error:return D;case b.Warning:return k;case b.Info:return l;default:return m}}b.toString=T}(I||(I={})),i.default=I}),define(ee[21],te([0,1,8]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const y=Array.isArray(g)?[]:{};return Object.keys(g).forEach(a=>{g[a]&&typeof g[a]=="object"?y[a]=I(g[a]):y[a]=g[a]}),y}i.deepClone=I;function b(g){if(!g||typeof g!="object")return g;const y=[g];for(;y.length>0;){const a=y.shift();Object.freeze(a);for(const u in a)if(D.call(a,u)){const p=a[u];typeof p=="object"&&!Object.isFrozen(p)&&!(0,R.isTypedArray)(p)&&y.push(p)}}return g}i.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function k(g,y){return S(g,y,new Set)}i.cloneAndChange=k;function S(g,y,a){if((0,R.isUndefinedOrNull)(g))return g;const u=y(g);if(typeof u!="undefined")return u;if((0,R.isArray)(g)){const p=[];for(const h of g)p.push(S(h,y,a));return p}if((0,R.isObject)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const p={};for(let h in g)D.call(g,h)&&(p[h]=S(g[h],y,a));return a.delete(g),p}return g}function l(g,y,a=!0){return(0,R.isObject)(g)?((0,R.isObject)(y)&&Object.keys(y).forEach(u=>{u in g?a&&((0,R.isObject)(g[u])&&(0,R.isObject)(y[u])?l(g[u],y[u],a):g[u]=y[u]):g[u]=y[u]}),g):y}i.mixin=l;function m(g,y){if(g===y)return!0;if(g==null||y===null||y===void 0||typeof g!=typeof y||typeof g!="object"||Array.isArray(g)!==Array.isArray(y))return!1;let a,u;if(Array.isArray(g)){if(g.length!==y.length)return!1;for(a=0;a<g.length;a++)if(!m(g[a],y[a]))return!1}else{const p=[];for(u in g)p.push(u);p.sort();const h=[];for(u in y)h.push(u);if(h.sort(),!m(p,h))return!1;for(a=0;a<p.length;a++)if(!m(g[p[a]],y[p[a]]))return!1}return!0}i.equals=m;function L(g){const y=new Set;return JSON.stringify(g,(a,u)=>{if((0,R.isObject)(u)||Array.isArray(u)){if(y.has(u))return"[Circular]";y.add(u)}return u})}i.safeStringify=L;function T(g,y,a){const u=y(g);return typeof u=="undefined"?a:u}i.getOrDefault=T;function v(g,y){const a=Object.create(null);return!g||!y||Object.keys(y).forEach(p=>{const h=g[p],s=y[p];m(h,s)||(a[p]=s)}),a}i.distinct=v;function w(g,y){const a=y.toLowerCase(),u=Object.keys(g).find(p=>p.toLowerCase()===a);return u?g[u]:g[y]}i.getCaseInsensitive=w;function P(g,y){const a=Object.create(null);for(const[u,p]of Object.entries(g))y(u,p)&&(a[u]=p);return a}i.filter=P}),define(ee[64],te([0,1,9]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(m){const L=m;return L&&typeof L.type=="string"&&typeof L.severity=="string"}i.isRemoteConsoleLog=I;function b(m){const L=[];let T;try{const v=JSON.parse(m.arguments),w=v[v.length-1];w&&w.__$stack&&(v.pop(),T=w.__$stack),L.push(...v)}catch{L.push("Unable to log remote console arguments",m.arguments)}return{args:L,stack:T}}i.parse=b;function D(m){if(typeof m!="string")return D(b(m).stack);const L=m;if(L){const T=k(L),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(v&&v.length===4)return{uri:R.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}i.getFirstFrame=D;function k(m){if(!m)return m;const L=m.indexOf(`
`);return L===-1?m:m.substring(0,L)}function S(m,L){const{args:T,stack:v}=b(m),w=typeof T[0]=="string"&&T.length===1;let P=k(v);P&&(P=`(${P.trim()})`);let g=[];if(typeof T[0]=="string"?P&&w?g=[`%c[${L}] %c${T[0]} %c${P}`,l("blue"),l(""),l("grey")]:g=[`%c[${L}] %c${T[0]}`,l("blue"),l(""),...T.slice(1)]:g=[`%c[${L}]%`,l("blue"),...T],P&&!w&&g.push(P),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}i.log=S;function l(m){return`color: ${m}`}}),define(ee[50],te([0,1,16,25,9]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function D(m){return JSON.stringify(m,S)}i.stringify=D;function k(m){let L=JSON.parse(m);return L=l(L),L}i.parse=k;function S(m,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,I.regExpFlags)(L)}:L}function l(m,L=0){if(!m||L>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return b.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof R.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=l(m[T],L+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=l(m[T],L+1))}return m}i.revive=l}),define(ee[65],te([0,1,17,51,14,11,10,18,25,9]),function(_,i,R,I,b,D,k,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function L(c,f){const{os:d,tildify:E,relative:A}=f;if(A){const Q=T(c,A,d);if(typeof Q=="string")return Q}let z=c.fsPath;if(d===1&&!k.isWindows?z=z.replace(/\//g,"\\"):d!==1&&k.isWindows&&(z=z.replace(/\\/g,"/")),d!==1&&E?.userHome){let Q=E.userHome.fsPath,ie;c.scheme!==E.userHome.scheme&&c.path.startsWith(D.posix.sep)?ie=E.userHome.with({path:c.path}).fsPath:ie=c.fsPath,k.isWindows&&(ie=(0,I.toSlashes)(ie),Q=(0,I.toSlashes)(Q)),z=g(ie,Q,d)}return(d===1?D.win32:D.posix).normalize(w(z,d===1))}i.getPathLabel=L;function T(c,f,d){const E=d===1?D.win32:D.posix,A=d===3?S.extUri:S.extUriIgnorePathCase,z=f.getWorkspace(),Z=(0,R.firstOrDefault)(z.folders);if(!Z)return;c.scheme!==Z.uri.scheme&&c.path.startsWith(D.posix.sep)&&(c=Z.uri.with({path:c.path}));const Q=f.getWorkspaceFolder(c);if(!Q)return;let ie;if(A.isEqual(Q.uri,c)?ie="":ie=A.relativePath(Q.uri,c)??"",ie&&(ie=E.normalize(ie)),z.folders.length>1&&!f.noPrefix){const re=Q.name?Q.name:A.basenameOrAuthority(Q.uri);ie=ie?`${re} \u2022 ${ie}`:re}return ie}function v(c){if(!c)return;typeof c=="string"&&(c=m.URI.file(c));const f=(0,S.basename)(c)||(c.scheme===b.Schemas.file?c.fsPath:c.path);return k.isWindows&&(0,I.isRootOrDriveLetter)(f)?w(f):f}i.getBaseLabel=v;function w(c,f=k.isWindows){return(0,I.hasDriveLetter)(c,f)?c.charAt(0).toUpperCase()+c.slice(1):c}i.normalizeDriveLetter=w;let P=Object.create(null);function g(c,f,d=k.OS){if(d===1||!c||!f)return c;let E=P.original===f?P.normalized:void 0;return E||(E=`${(0,l.rtrim)(f,D.posix.sep)}${D.posix.sep}`,P={original:f,normalized:E}),(d===3?c.startsWith(E):(0,l.startsWithIgnoreCase)(c,E))&&(c=`~/${c.substr(E.length)}`),c}i.tildify=g;function y(c,f){return c.replace(/^~($|\/|\\)/,`${f}$1`)}i.untildify=y;const a="\u2026",u="\\\\",p="~";function h(c,f=D.sep){const d=new Array(c.length);let E=!1;for(let A=0;A<c.length;A++){let z=c[A];if(z===""){d[A]=`.${f}`;continue}if(!z){d[A]=z;continue}E=!0;let Z="";z.indexOf(u)===0?(Z=z.substr(0,z.indexOf(u)+u.length),z=z.substr(z.indexOf(u)+u.length)):z.indexOf(f)===0?(Z=z.substr(0,z.indexOf(f)+f.length),z=z.substr(z.indexOf(f)+f.length)):z.indexOf(p)===0&&(Z=z.substr(0,z.indexOf(p)+p.length),z=z.substr(z.indexOf(p)+p.length));const Q=z.split(f);for(let ie=1;E&&ie<=Q.length;ie++)for(let re=Q.length-ie;E&&re>=0;re--){E=!1;let U=Q.slice(re,re+ie).join(f);for(let W=0;!E&&W<c.length;W++)if(W!==A&&c[W]&&c[W].indexOf(U)>-1){const J=re+ie===Q.length,G=re>0&&c[W].indexOf(f)>-1?f+U:U,ne=c[W].endsWith(G);E=!J||ne}if(!E){let W="";(Q[0].endsWith(":")||Z!=="")&&(re===1&&(re=0,ie++,U=Q[0]+f+U),re>0&&(W=Q[0]+f),W=Z+W),re>0&&(W=W+a+f),W=W+U,re+ie<Q.length&&(W=W+f+a),d[A]=W}}E&&(d[A]=z)}return d}i.shorten=h;var s;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function e(c,f=Object.create(null)){const d=[];let E=!1,A="";for(const z of c)if(z==="$"||E&&z==="{")A&&d.push({value:A,type:s.TEXT}),A="",E=!0;else if(z==="}"&&E){const Z=f[A];if(typeof Z=="string")Z.length&&d.push({value:Z,type:s.VARIABLE});else if(Z){const Q=d[d.length-1];(!Q||Q.type!==s.SEPARATOR)&&d.push({value:Z.label,type:s.SEPARATOR})}A="",E=!1}else A+=z;return A&&!E&&d.push({value:A,type:s.TEXT}),d.filter((z,Z)=>{if(z.type===s.SEPARATOR){const Q=d[Z-1],ie=d[Z+1];return[Q,ie].every(re=>re&&(re.type===s.VARIABLE||re.type===s.TEXT)&&re.value.length>0)}return!0}).map(z=>z.value).join("")}i.template=e;function r(c,f){return k.isMacintosh||f?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):c.replace(/&&|&/g,d=>d==="&"?"&&":"&")}i.mnemonicMenuLabel=r;function t(c,f){return k.isMacintosh||f?c.replace(/\(&&\w\)|&&/g,""):k.isWindows?c.replace(/&&|&/g,d=>d==="&"?"&&":"&"):c.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function n(c){return c.replace(/&/g,"&&")}i.unmnemonicLabel=n;function o(c){const f=c.indexOf("/")!==-1?D.posix:D.win32,d=f.basename(c),E=f.dirname(c);return d.length?{name:d,parentPath:E}:{name:E,parentPath:""}}i.splitName=o}),define(ee[31],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(l){return R.test(l)}i.isUUID=I;const b=new Uint8Array(16),D=[];for(let l=0;l<256;l++)D.push(l.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(l){for(let m=0;m<l.length;m++)l[m]=Math.floor(Math.random()*256);return l};function S(){k(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let l=0,m="";return m+=D[b[l++]],m+=D[b[l++]],m+=D[b[l++]],m+=D[b[l++]],m+="-",m+=D[b[l++]],m+=D[b[l++]],m+="-",m+=D[b[l++]],m+=D[b[l++]],m+="-",m+=D[b[l++]],m+=D[b[l++]],m+="-",m+=D[b[l++]],m+=D[b[l++]],m+=D[b[l++]],m+=D[b[l++]],m+=D[b[l++]],m+=D[b[l++]],m}i.generateUuid=S}),define(ee[66],te([0,1,135]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(D="utf8"){this.stringDecoder=new R.StringDecoder(D),this.remaining=null}write(D){const k=[],S=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(S.length<1)return k;let l=0,m,L=l;for(;L<S.length;)if(m=S.charCodeAt(L),m===13||m===10){if(k.push(S.substring(l,L)),L++,L<S.length){const T=m;m=S.charCodeAt(L),(T===13&&m===10||T===10&&m===13)&&L++}l=L}else L++;return this.remaining=l<S.length?S.substr(l):null,k}end(){return this.remaining}}i.LineDecoder=I}),define(ee[67],te([0,1,39,11,19]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var l;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=1:L=0;class T{constructor(s,e,r){this.exePath=s,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:h=!1}={}){return h?m===0?process.env["ProgramFiles(x86)"]||null:L===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:h=!1,findPreview:s=!1}={}){const e=v({useAlternateBitness:h});if(!e)return null;const r=I.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const f of await b.Promises.readdir(r)){let d=-1;if(s){const A=f.indexOf("-");if(A<0)continue;const z=f.substring(0,A);if(!D.test(z)||f.substring(A+1)!=="preview")continue;d=parseInt(z,10)}else{if(!D.test(f))continue;d=parseInt(f,10)}if(d<=t)continue;const E=I.join(r,f,"pwsh.exe");!await b.SymlinkSupport.existsFile(E)||(n=E,t=d)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",c=s?" Preview":"";return new T(n,`PowerShell${c}${o}`,!0)}async function P({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const t of await b.Promises.readdir(s))if(e.test(t)){const n=I.join(s,t,"pwsh.exe");return new T(n,r)}return null}function g(){const h=I.join(R.homedir(),".dotnet","tools","pwsh.exe");return new T(h,".NET Core PowerShell Global Tool")}function y(){const h=I.join(process.env.windir,m===1&&L!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(h,"Windows PowerShell",!0)}async function*a(){let h=await w();h&&(yield h),h=await w({useAlternateBitness:!0}),h&&(yield h),h=await P(),h&&(yield h),h=g(),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await P({findPreview:!0}),h&&(yield h),h=await w({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=y(),h&&(yield h)}async function*u(){for await(const h of a())await h.exists()&&(yield h)}i.enumeratePowerShellInstallations=u;async function p(){for await(const h of u())return h;return null}i.getFirstAvailablePowerShellInstallation=p});var he=this&&this.__decorate||function(_,i,R,I){var b=arguments.length,D=b<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,R):I,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(_,i,R,I);else for(var S=_.length-1;S>=0;S--)(k=_[S])&&(D=(b<3?k(D):b>3?k(i,R,D):k(i,R))||D);return b>3&&D&&Object.defineProperty(i,R,D),D};define(ee[52],te([0,1,17,4,16,26,45,7,3,2,50,25,8]),function(_,i,R,I,b,D,k,S,l,m,L,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var w;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(w=i.RequestType||(i.RequestType={}));function P(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function y(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(a||(a={}));class u{constructor(C){this.buffer=C,this.pos=0}read(C){const F=this.buffer.slice(this.pos,this.pos+C);return this.pos+=F.byteLength,F}}class p{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(C){this.buffers.push(C)}}var h;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(h||(h={}));function s(O){const C=b.VSBuffer.alloc(4);return C.writeUInt32BE(O,0),C}function e(O){return O.read(4).readUInt32BE(0)}function r(O){const C=b.VSBuffer.alloc(1);return C.writeUInt8(O,0),C}const t={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},n=typeof Buffer!="undefined";function o(O,C){if(typeof C=="undefined")O.write(t.Undefined);else if(typeof C=="string"){const F=b.VSBuffer.fromString(C);O.write(t.String),O.write(s(F.byteLength)),O.write(F)}else if(n&&Buffer.isBuffer(C)){const F=b.VSBuffer.wrap(C);O.write(t.Buffer),O.write(s(F.byteLength)),O.write(F)}else if(C instanceof b.VSBuffer)O.write(t.VSBuffer),O.write(s(C.byteLength)),O.write(C);else if(Array.isArray(C)){O.write(t.Array),O.write(s(C.length));for(const F of C)o(O,F)}else{const F=b.VSBuffer.fromString(JSON.stringify(C));O.write(t.Object),O.write(s(F.byteLength)),O.write(F)}}function c(O){switch(O.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return O.read(e(O)).toString();case h.Buffer:return O.read(e(O)).buffer;case h.VSBuffer:return O.read(e(O));case h.Array:{const F=e(O),x=[];for(let q=0;q<F;q++)x.push(c(O));return x}case h.Object:return JSON.parse(O.read(e(O)).toString())}}class f{constructor(C,F,x=null,q=1e3){this.protocol=C,this.ctx=F,this.logger=x,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(C,F){this.channels.set(C,F),setTimeout(()=>this.flushPendingRequests(C),0)}sendResponse(C){switch(C.type){case 200:{const F=this.send([C.type]);this.logger?.logOutgoing(F,0,1,y(C.type));return}case 201:case 202:case 204:case 203:{const F=this.send([C.type,C.id],C.data);this.logger?.logOutgoing(F,C.id,1,y(C.type),C.data);return}}}send(C,F=void 0){const x=new p;return o(x,C),o(x,F),this.sendBuffer(x.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch{return 0}}onRawMessage(C){const F=new u(C),x=c(F),q=c(F),$=x[0];switch($){case 100:return this.logger?.logIncoming(C.byteLength,x[1],1,`${P($)}: ${x[2]}.${x[3]}`,q),this.onPromise({type:$,id:x[1],channelName:x[2],name:x[3],arg:q});case 102:return this.logger?.logIncoming(C.byteLength,x[1],1,`${P($)}: ${x[2]}.${x[3]}`,q),this.onEventListen({type:$,id:x[1],channelName:x[2],name:x[3],arg:q});case 101:return this.logger?.logIncoming(C.byteLength,x[1],1,`${P($)}`),this.disposeActiveRequest({type:$,id:x[1]});case 103:return this.logger?.logIncoming(C.byteLength,x[1],1,`${P($)}`),this.disposeActiveRequest({type:$,id:x[1]})}}onPromise(C){const F=this.channels.get(C.channelName);if(!F){this.collectPendingRequest(C);return}const x=new D.CancellationTokenSource;let q;try{q=F.call(this.ctx,C.name,C.arg,x.token)}catch(N){q=Promise.reject(N)}const $=C.id;q.then(N=>{this.sendResponse({id:$,data:N,type:201}),this.activeRequests.delete(C.id)},N=>{N instanceof Error?this.sendResponse({id:$,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:$,data:N,type:203}),this.activeRequests.delete(C.id)});const se=(0,m.toDisposable)(()=>x.cancel());this.activeRequests.set(C.id,se)}onEventListen(C){const F=this.channels.get(C.channelName);if(!F){this.collectPendingRequest(C);return}const x=C.id,$=F.listen(this.ctx,C.name,C.arg)(se=>this.sendResponse({id:x,data:se,type:204}));this.activeRequests.set(C.id,$)}disposeActiveRequest(C){const F=this.activeRequests.get(C.id);F&&(F.dispose(),this.activeRequests.delete(C.id))}collectPendingRequest(C){let F=this.pendingRequests.get(C.channelName);F||(F=[],this.pendingRequests.set(C.channelName,F));const x=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.sendResponse({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:C,timeoutTimer:x})}flushPendingRequests(C){const F=this.pendingRequests.get(C);if(F){for(const x of F)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(C)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=f;var d;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(d=i.RequestInitiator||(i.RequestInitiator={}));class E{constructor(C,F=null){this.protocol=C,this.isDisposed=!1,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=F}getChannel(C){const F=this;return{call(x,q,$){return F.isDisposed?Promise.reject(S.canceled()):F.requestPromise(C,x,q,$)},listen(x,q){return F.isDisposed?l.Event.None:F.requestEvent(C,x,q)}}}requestPromise(C,F,x,q=D.CancellationToken.None){const $=this.lastRequestId++,N={id:$,type:100,channelName:C,name:F,arg:x};if(q.isCancellationRequested)return Promise.reject(S.canceled());let M;return new Promise((B,K)=>{if(q.isCancellationRequested)return K(S.canceled());const Y=()=>{const ve=le=>{switch(le.type){case 201:this.handlers.delete($),B(le.data);break;case 202:{this.handlers.delete($);const ue=new Error(le.data.message);ue.stack=le.data.stack,ue.name=le.data.name,K(ue);break}case 203:this.handlers.delete($),K(le.data);break}};this.handlers.set($,ve),this.sendRequest(N)};let oe=null;this.state===a.Idle?Y():(oe=(0,I.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,Y()}));const ce=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:$,type:101}),K(S.canceled())},de=q.onCancellationRequested(ce);M=(0,m.combinedDisposable)((0,m.toDisposable)(ce),de),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(C,F,x){const q=this.lastRequestId++,se={id:q,type:102,channelName:C,name:F,arg:x};let N=null;const M=new l.Emitter({onFirstListenerAdd:()=>{N=(0,I.createCancelablePromise)(B=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(M),this.sendRequest(se)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(M),this.sendRequest({id:q,type:103}))}}),j=B=>M.fire(B.data);return this.handlers.set(q,j),M.event}sendRequest(C){switch(C.type){case 100:case 102:{const F=this.send([C.type,C.id,C.channelName,C.name],C.arg);this.logger&&this.logger.logOutgoing(F,C.id,0,`${P(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const F=this.send([C.type,C.id]);this.logger&&this.logger.logOutgoing(F,C.id,0,P(C.type));return}}}send(C,F=void 0){const x=new p;return o(x,C),o(x,F),this.sendBuffer(x.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch{return 0}}onBuffer(C){const F=new u(C),x=c(F),q=c(F),$=x[0];switch($){case 200:return this.logger&&this.logger.logIncoming(C.byteLength,0,0,y($)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(C.byteLength,x[1],0,y($),q),this.onResponse({type:x[0],id:x[1],data:q})}}onResponse(C){if(C.type===200){this.state=a.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(C.id);F&&F(C)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([k.memoize],E.prototype,"onDidInitializePromise",null),i.ChannelClient=E;class A{constructor(C){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,C(({protocol:F,onDidClientDisconnect:x})=>{l.Event.once(F.onMessage)($=>{const se=new u($),N=c(se),M=new f(F,N),j=new E(F);this.channels.forEach((K,Y)=>M.registerChannel(Y,K));const B={channelServer:M,channelClient:j,ctx:N};this._connections.add(B),this._onDidAddConnection.fire(B),x(()=>{M.dispose(),j.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const C=[];return this._connections.forEach(F=>C.push(F)),C}getChannel(C,F){const x=this;return{call(q,$,se){let N;if((0,v.isFunction)(F)){let j=(0,R.getRandomElement)(x.connections.filter(F));N=j?Promise.resolve(j):l.Event.toPromise(l.Event.filter(x.onDidAddConnection,F))}else N=F.routeCall(x,q,$);const M=N.then(j=>j.channelClient.getChannel(C));return Z(M).call(q,$,se)},listen(q,$){if((0,v.isFunction)(F))return x.getMulticastEvent(C,F,q,$);const se=F.routeEvent(x,q,$).then(N=>N.channelClient.getChannel(C));return Z(se).listen(q,$)}}}getMulticastEvent(C,F,x,q){const $=this;let se=new m.DisposableStore;const N=new l.Emitter({onFirstListenerAdd:()=>{se=new m.DisposableStore;const M=new l.EventMultiplexer,j=new Map,B=Y=>{const ce=Y.channelClient.getChannel(C).listen(x,q),de=M.add(ce);j.set(Y,de)},K=Y=>{const oe=j.get(Y);!oe||(oe.dispose(),j.delete(Y))};$.connections.filter(F).forEach(B),l.Event.filter($.onDidAddConnection,F)(B,void 0,se),$.onDidRemoveConnection(K,void 0,se),M.event(N.fire,N,se),se.add(M)},onLastListenerRemove:()=>{se.dispose()}});return N.event}registerChannel(C,F){this.channels.set(C,F),this._connections.forEach(x=>{x.channelServer.registerChannel(C,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=A;class z{constructor(C,F,x=null){const q=new p;o(q,F),C.send(q.buffer),this.channelClient=new E(C,x),this.channelServer=new f(C,F,x)}getChannel(C){return this.channelClient.getChannel(C)}registerChannel(C,F){this.channelServer.registerChannel(C,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=z;function Z(O){return{call(C,F,x){return O.then(q=>q.call(C,F,x))},listen(C,F){const x=new l.Relay;return O.then(q=>x.input=q.listen(C,F)),x.event}}}i.getDelayedChannel=Z;function Q(O){let C=!1;return{call(F,x,q){return C?O.call(F,x,q):(0,I.timeout)(0).then(()=>C=!0).then(()=>O.call(F,x,q))},listen(F,x){if(C)return O.listen(F,x);const q=new l.Relay;return(0,I.timeout)(0).then(()=>C=!0).then(()=>q.input=O.listen(F,x)),q.event}}}i.getNextTickChannel=Q;class ie{constructor(C){this.fn=C}routeCall(C){return this.route(C)}routeEvent(C){return this.route(C)}async route(C){for(const F of C.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await l.Event.toPromise(C.onDidAddConnection),await this.route(C)}}i.StaticRouter=ie;var re;(function(O){function C($,se){const N=$,M=se&&se.disableMarshalling,j=new Map;for(const B in N)x(B)&&j.set(B,l.Event.buffer(N[B],!0));return new class{listen(B,K,Y){const oe=j.get(K);if(oe)return oe;if(q(K)){const ce=N[K];if(typeof ce=="function")return ce.call(N,Y)}throw new Error(`Event not found: ${K}`)}call(B,K,Y){const oe=N[K];if(typeof oe=="function"){if(!M&&Array.isArray(Y))for(let ce=0;ce<Y.length;ce++)Y[ce]=(0,L.revive)(Y[ce]);return oe.apply(N,Y)}throw new Error(`Method not found: ${K}`)}}}O.fromService=C;function F($,se){const N=se&&se.disableMarshalling;return new Proxy({},{get(M,j){if(typeof j=="string")return se?.properties?.has(j)?se.properties.get(j):q(j)?function(B){return $.listen(j,B)}:x(j)?$.listen(j):async function(...B){let K;se&&!(0,v.isUndefinedOrNull)(se.context)?K=[se.context,...B]:K=B;const Y=await $.call(j,K);return N?Y:(0,L.revive)(Y)};throw new Error(`Property not found: ${String(j)}`)}})}O.toService=F;function x($){return $[0]==="o"&&$[1]==="n"&&T.isUpperAsciiLetter($.charCodeAt(2))}function q($){return/^onDynamic/.test($)&&T.isUpperAsciiLetter($.charCodeAt(9))}})(re=i.ProxyChannel||(i.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let C=O.toString();if(C!=="[object Object]")return C}return O}function J(O){return Array.isArray(O)?O.map(W):W(O)}function G(O,C,F,x,q,$,se){se=J(se);const N=U[q],M=N[x%N.length];let j=[`%c[${O}]%c[${String(C).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test($)?(j=j.concat(se),j.push(")")):j.push(se),console.log.apply(console,j)}i.logWithColors=G;class ne{constructor(C,F){this._outgoingPrefix=C,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(C,F,x,q,$){this._totalOutgoing+=C,G(this._outgoingPrefix,this._totalOutgoing,C,F,x,q,$)}logIncoming(C,F,x,q,$){this._totalIncoming+=C,G(this._incomingPrefix,this._totalIncoming,C,F,x,q,$)}}i.IPCLogger=ne}),define(ee[68],te([0,1,4,3,2,8]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var k;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=i.StorageHint||(i.StorageHint={}));function S(T){const v=T;return v?.changed instanceof Map||v?.deleted instanceof Set}i.isStorageItemsChangeEvent=S;var l;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(l=i.StorageState||(i.StorageState={}));class m extends b.Disposable{constructor(v,w=Object.create(null)){super();this.database=v,this.options=w,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((w,P)=>this.accept(P,w)),v.deleted?.forEach(w=>this.accept(w,void 0))}accept(v,w){if(this.state===l.Closed)return;let P=!1;(0,D.isUndefinedOrNull)(w)?P=this.cache.delete(v):this.cache.get(v)!==w&&(this.cache.set(v,w),P=!0),P&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,w){const P=this.cache.get(v);return(0,D.isUndefinedOrNull)(P)?w:P}getBoolean(v,w){const P=this.get(v);return(0,D.isUndefinedOrNull)(P)?w:P==="true"}getNumber(v,w){const P=this.get(v);return(0,D.isUndefinedOrNull)(P)?w:parseInt(P,10)}async set(v,w){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(w))return this.delete(v);const P=String(w);if(this.cache.get(v)!==P)return this.cache.set(v,P),this.pendingInserts.set(v,P),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===l.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class L{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((w,P)=>this.items.set(P,w)),v.delete&&v.delete.forEach(w=>this.items.delete(w))}async close(){}}i.InMemoryStorageDatabase=L}),define(ee[69],te([5,6]),function(_,i){return _.create("vs/base/common/date",i)}),define(ee[70],te([0,1,69]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,b=I*60,D=b*24,k=D*7,S=D*30,l=D*365;function m(T,v,w){typeof T!="number"&&(T=T.getTime());const P=Math.round((new Date().getTime()-T)/1e3);if(P<-30)return(0,R.localize)(0,null,m(new Date().getTime()+P*1e3,!1));if(P<30)return(0,R.localize)(1,null);let g;return P<I?(g=P,v?g===1?w?(0,R.localize)(2,null,g):(0,R.localize)(3,null,g):w?(0,R.localize)(4,null,g):(0,R.localize)(5,null,g):g===1?w?(0,R.localize)(6,null,g):(0,R.localize)(7,null,g):w?(0,R.localize)(8,null,g):(0,R.localize)(9,null,g)):P<b?(g=Math.floor(P/I),v?g===1?w?(0,R.localize)(10,null,g):(0,R.localize)(11,null,g):w?(0,R.localize)(12,null,g):(0,R.localize)(13,null,g):g===1?w?(0,R.localize)(14,null,g):(0,R.localize)(15,null,g):w?(0,R.localize)(16,null,g):(0,R.localize)(17,null,g)):P<D?(g=Math.floor(P/b),v?g===1?w?(0,R.localize)(18,null,g):(0,R.localize)(19,null,g):w?(0,R.localize)(20,null,g):(0,R.localize)(21,null,g):g===1?w?(0,R.localize)(22,null,g):(0,R.localize)(23,null,g):w?(0,R.localize)(24,null,g):(0,R.localize)(25,null,g)):P<k?(g=Math.floor(P/D),v?g===1?(0,R.localize)(26,null,g):(0,R.localize)(27,null,g):g===1?(0,R.localize)(28,null,g):(0,R.localize)(29,null,g)):P<S?(g=Math.floor(P/k),v?g===1?w?(0,R.localize)(30,null,g):(0,R.localize)(31,null,g):w?(0,R.localize)(32,null,g):(0,R.localize)(33,null,g):g===1?w?(0,R.localize)(34,null,g):(0,R.localize)(35,null,g):w?(0,R.localize)(36,null,g):(0,R.localize)(37,null,g)):P<l?(g=Math.floor(P/S),v?g===1?w?(0,R.localize)(38,null,g):(0,R.localize)(39,null,g):w?(0,R.localize)(40,null,g):(0,R.localize)(41,null,g):g===1?w?(0,R.localize)(42,null,g):(0,R.localize)(43,null,g):w?(0,R.localize)(44,null,g):(0,R.localize)(45,null,g)):(g=Math.floor(P/l),v?g===1?w?(0,R.localize)(46,null,g):(0,R.localize)(47,null,g):w?(0,R.localize)(48,null,g):(0,R.localize)(49,null,g):g===1?w?(0,R.localize)(50,null,g):(0,R.localize)(51,null,g):w?(0,R.localize)(52,null,g):(0,R.localize)(53,null,g))}i.fromNow=m;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=L}),define(ee[71],te([5,6]),function(_,i){return _.create("vs/base/common/errorMessage",i)}),define(ee[28],te([0,1,17,8,71]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function D(T,v){return v&&(T.stack||T.stacktrace)?b.localize(0,null,S(T),k(T.stack)||k(T.stacktrace)):S(T)}function k(T){return Array.isArray(T)?T.join(`
`):T}function S(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?b.localize(1,null,T.message):T.message||b.localize(2,null)}function l(T=null,v=!1){if(!T)return b.localize(3,null);if(Array.isArray(T)){const w=R.coalesce(T),P=l(w[0],v);return w.length>1?b.localize(4,null,P,w.length):P}if(I.isString(T))return T;if(T.detail){const w=T.detail;if(w.error)return D(w.error,v);if(w.exception)return D(w.exception,v)}return T.stack?D(T,v):T.message?T.message:b.localize(5,null)}i.toErrorMessage=l;function m(T){const v=T;return v instanceof Error&&Array.isArray(v.actions)}i.isErrorWithActions=m;function L(T,v){let w;return typeof T=="string"?w=new Error(T):w=T,w.actions=v,w}i.createErrorWithActions=L}),define(ee[72],te([5,6]),function(_,i){return _.create("vs/base/common/jsonErrorMessages",i)}),define(ee[73],te([0,1,72]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function I(b){switch(b){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}i.getParseErrorMessage=I}),define(ee[74],te([5,6]),function(_,i){return _.create("vs/base/node/processes",i)}),define(ee[53],te([0,1,40,51,14,21,11,10,32,47,8,66,19,74]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return m.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return m.TerminateResponseCode}});function P(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(s,e){if(S.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};e&&(r.cwd=e);const t=R.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(n=>{t.once("error",o=>{n({success:!1,error:o})}),t.once("exit",(o,c)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?P(r.status):1})}else if(S.isLinux||S.isMacintosh)try{const r=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(t=>{R.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(n,o,c)=>{t(n?{success:!1,error:n}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function y(s=l.env){return s.comspec||"cmd.exe"}i.getWindowsShell=y;class a{constructor(e,r,t,n){if(r!==void 0&&t!==void 0&&n!==void 0)this.cmd=e,this.args=r,this.shell=t,this.options=n;else{const o=e;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(l.env).forEach(c=>{o[c]=l.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const r=e.lastIndexOf(k.sep);return r!==-1&&(e=e.substring(r+1)),a.WellKnowCommands[e]?e:"other"}start(e){return S.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(r=>{let t,n;const o=new Promise((c,f)=>{t=c,n=f});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=R.exec(c,this.options,(f,d,E)=>{this.childProcess=null;const A=f;A&&A.killed?n({killed:this.terminateRequested,stdout:d.toString(),stderr:E.toString()}):this.handleExec(t,e,f,d,E)})}else{let c=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,t,e,n);const E={terminated:this.terminateRequested};L.isNumber(d)&&(E.cmdCode=d),t(E)};if(this.shell&&S.isWindows){const d=D.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let E=!1,A=!1;const z=[];let Z=this.ensureQuotes(this.cmd);z.push(Z.value),E=Z.quoted,this.args&&this.args.forEach(ie=>{Z=this.ensureQuotes(ie),z.push(Z.value),A=A&&Z.quoted});const Q=["/s","/c"];E?A?Q.push('"'+z.join(" ")+'"'):z.length>1?Q.push('"'+z[0]+'" '+z.slice(1).join(" ")):Q.push('"'+z[0]+'"'):Q.push(z.join(" ")),c=R.spawn(y(),Q,d)}else this.cmd&&(c=R.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(L.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",d=>{this.childProcess=null,n({terminated:this.terminateRequested,error:d})}),c.pid&&(this.childProcess.on("close",f),this.handleSpawn(c,t,e,n,!0)))}return o})}handleClose(e,r,t,n){}ensureQuotes(e){return a.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,g(e,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!S.isWindows)return e(!1);const r=R.spawn(y(),["/s","/c"]);r.on("error",t=>e(!0)),r.on("exit",t=>e(!1))})}}i.AbstractProcess=a,a.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},a.regexp=/^[^"].* .*[^"]/;class u extends a{constructor(e,r,t,n){super(e,r,t,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,r,t,n,o){[n,o].forEach((c,f)=>{const d=new T.LineDecoder;d.write(c).forEach(z=>{r({line:z,source:f===0?0:1})});const A=d.end();A&&r({line:A,source:f===0?0:1})}),e({terminated:this.terminateRequested,error:t})}handleSpawn(e,r,t,n,o){const c=new T.LineDecoder,f=new T.LineDecoder;e.stdout.on("data",d=>{c.write(d).forEach(A=>t({line:A,source:0}))}),e.stderr.on("data",d=>{f.write(d).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=f}handleClose(e,r,t,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}i.LineProcess=u;function p(s){let e=[],r=!1;const t=function(n){if(r){e.push(n);return}(!s.send(n,c=>{if(c&&console.error(c),r=!1,e.length>0){const f=e.slice(0);e=[],f.forEach(d=>t(d))}})||S.isWindows)&&(r=!0)};return{send:t}}i.createQueuedSender=p;var h;(function(s){async function e(r,t,n){if(k.isAbsolute(r))return r;if(t===void 0&&(t=l.cwd()),k.dirname(r)!=="."||(n===void 0&&L.isString(l.env.PATH)&&(n=l.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(t,r);async function c(f){if(await v.Promises.exists(f)){let d;try{d=await v.Promises.stat(f)}catch(E){E.message.startsWith("EACCES")&&(d=await v.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(let f of n){let d;if(k.isAbsolute(f)?d=k.join(f,r):d=k.join(t,f,r),await c(d))return d;let E=d+".com";if(await c(E)||(E=d+".exe",await c(E)))return E}return k.join(t,r)}s.findExecutable=e})(h=i.win32||(i.win32={}))}),define(ee[75],te([0,1,39,10,67,53]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function k(w,P){return w===1?I.isWindows?T():D.getWindowsShell(P):m(w,P)}i.getSystemShell=k;function S(w,P){return w===1?I.isWindows?v(P):D.getWindowsShell(P):m(w,P)}i.getSystemShellSync=S;let l=null;function m(w,P){if(I.isLinux&&w===2||I.isMacintosh&&w===3)return"/bin/bash";if(!l){let g;if(I.isWindows)g="/bin/bash";else{if(g=P.SHELL,!g)try{g=(0,R.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}l=g}return l}let L=null;async function T(){return L||(L=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),L}function v(w){if(L)return L;const P=I.isWindows&&parseFloat((0,R.release)())>=10,g=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${w.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return P?y:D.getWindowsShell(w)}}),define(ee[76],te([0,1,40,4,16,26,64,7,3,2,21,53,47,52]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class P extends w.ChannelServer{constructor(a){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",u=>b.VSBuffer.wrap(Buffer.from(u,"base64")))},a);process.once("disconnect",()=>this.dispose())}}i.Server=P;class g{constructor(a,u){this.modulePath=a,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new I.Delayer(p),this.child=null,this._client=null}getChannel(a){const u=this;return{call(p,h,s){return u.requestPromise(a,p,h,s)},listen(p,h){return u.requestEvent(a,p,h)}}}requestPromise(a,u,p,h=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(a),e=(0,I.createCancelablePromise)(n=>s.call(u,p,n)),r=h.onCancellationRequested(()=>e.cancel()),t=(0,m.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(a,u,p){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let h;const s=new l.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(a).listen(u,p)(s.fire,s),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,L.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,v.removeDangerousEnvVariables)(u.env),this.child=(0,R.fork)(this.modulePath,a,u);const p=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}p.fire(b.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=p.event,t={send:e,onMessage:r};this._client=new w.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(f=>(0,m.dispose)(f)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(a){let u=this.channels.get(a);return u||(u=this.client.getChannel(a),this.channels.set(a,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=g}),define(ee[77],te([5,6]),function(_,i){return _.create("vs/base/node/zip",i)}),define(ee[78],te([5,6]),function(_,i){return _.create("vs/platform/configuration/common/configurationRegistry",i)}),define(ee[79],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(ee[80],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(ee[81],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(ee[82],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(ee[83],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(ee[84],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(ee[85],te([5,6]),function(_,i){return _.create("vs/platform/extensions/common/extensionValidator",i)}),define(ee[86],te([5,6]),function(_,i){return _.create("vs/platform/files/common/fileService",i)}),define(ee[87],te([5,6]),function(_,i){return _.create("vs/platform/files/common/io",i)}),define(ee[88],te([5,6]),function(_,i){return _.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(ee[89],te([5,6]),function(_,i){return _.create("vs/platform/request/common/request",i)}),define(ee[90],te([5,6]),function(_,i){return _.create("vs/platform/shell/node/shellEnv",i)}),define(ee[91],te([5,6]),function(_,i){return _.create("vs/platform/telemetry/common/telemetryService",i)}),define(ee[92],te([0,1,70,45,14,11,32,18,9]),function(_,i,R,I,b,D,k,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class m{constructor(g,y,a){this._args=g,this.paths=y,this.productService=a}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",_).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?l.URI.file((0,D.join)(g,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,D.resolve)(g):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,D.resolve)(g):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,D.resolve)(g);const y=k.env.VSCODE_EXTENSIONS;if(y)return y;const a=k.env.VSCODE_PORTABLE;return a?(0,D.join)(a,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(y=>/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,D.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,D.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([I.memoize],m.prototype,"appRoot",null),he([I.memoize],m.prototype,"userHome",null),he([I.memoize],m.prototype,"userDataPath",null),he([I.memoize],m.prototype,"appSettingsHome",null),he([I.memoize],m.prototype,"tmpDir",null),he([I.memoize],m.prototype,"cacheHome",null),he([I.memoize],m.prototype,"userRoamingDataHome",null),he([I.memoize],m.prototype,"settingsResource",null),he([I.memoize],m.prototype,"userDataSyncHome",null),he([I.memoize],m.prototype,"userDataSyncLogResource",null),he([I.memoize],m.prototype,"sync",null),he([I.memoize],m.prototype,"machineSettingsResource",null),he([I.memoize],m.prototype,"globalStorageHome",null),he([I.memoize],m.prototype,"workspaceStorageHome",null),he([I.memoize],m.prototype,"localHistoryHome",null),he([I.memoize],m.prototype,"keybindingsResource",null),he([I.memoize],m.prototype,"keyboardLayoutResource",null),he([I.memoize],m.prototype,"argvResource",null),he([I.memoize],m.prototype,"snippetsHome",null),he([I.memoize],m.prototype,"isExtensionDevelopment",null),he([I.memoize],m.prototype,"untitledWorkspacesHome",null),he([I.memoize],m.prototype,"installSourcePath",null),he([I.memoize],m.prototype,"builtinExtensionsPath",null),he([I.memoize],m.prototype,"extensionsPath",null),he([I.memoize],m.prototype,"extensionDevelopmentLocationURI",null),he([I.memoize],m.prototype,"extensionDevelopmentKind",null),he([I.memoize],m.prototype,"extensionTestsLocationURI",null),he([I.memoize],m.prototype,"debugExtensionHost",null),he([I.memoize],m.prototype,"serviceMachineIdResource",null),he([I.memoize],m.prototype,"telemetryLogResource",null),he([I.memoize],m.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=m;function L(P,g){return w(P["inspect-extensions"],P["inspect-brk-extensions"],5870,g,P.debugId,P.extensionEnvironment)}i.parseExtensionHostPort=L;function T(P,g){return w(P["inspect-search"],P["inspect-brk-search"],5876,g,P.extensionEnvironment)}i.parseSearchPort=T;function v(P,g){return w(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,g,P.extensionEnvironment)}i.parsePtyHostPort=v;function w(P,g,y,a,u,p){const s=Number(g||P)||(a?null:y),e=s?Boolean(!!g):!1;let r;if(p)try{r=JSON.parse(p)}catch{}return{port:s,break:e,debugId:u,env:r}}}),define(ee[93],te([0,1,39,92,136]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class D extends I.AbstractNativeEnvironmentService{constructor(S,l){super(S,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,b.getUserDataPath)(S)},l)}}i.NativeEnvironmentService=D}),define(ee[41],te([0,1,18,49,85,33]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function l(a){return a=a.trim(),a==="*"||k.test(a)}i.isValidVersionStr=l;function m(a){if(!l(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=a.match(k);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}i.parseVersion=m;function L(a){if(!a)return null;let u=a.majorBase,p=a.majorMustEqual,h=a.minorBase,s=a.minorMustEqual,e=a.patchBase,r=a.patchMustEqual;a.hasCaret&&(u===0||(s=!1),r=!1);let t=0;if(a.preRelease){const n=S.exec(a.preRelease);if(n){const[,o,c,f]=n;t=Date.UTC(Number(o),Number(c)-1,Number(f))}}return{majorBase:u,majorMustEqual:p,minorBase:h,minorMustEqual:s,patchBase:e,patchMustEqual:r,isMinimum:a.hasGreaterEquals,notBefore:t}}i.normalizeVersion=L;function T(a,u,p){let h;typeof a=="string"?h=L(m(a)):h=a;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let e;if(typeof p=="string"?e=L(m(p)):e=p,!h||!e)return!1;let r=h.majorBase,t=h.minorBase,n=h.patchBase,o=e.majorBase,c=e.minorBase,f=e.patchBase,d=e.notBefore,E=e.majorMustEqual,A=e.minorMustEqual,z=e.patchMustEqual;return e.isMinimum?r>o?!0:r<o?!1:t>c?!0:t<c||s&&s<d?!1:n>=f:(r===1&&o===0&&(!E||!A||!z)&&(o=1,c=0,f=0,E=!0,A=!1,z=!1),r<o?!1:r>o?!E:t<c?!1:t>c?!A:n<f?!1:n>f?!z:!(s&&s<d))}i.isValidVersion=T;function v(a,u,p,h,s){const e=[];if(typeof h.publisher!="undefined"&&typeof h.publisher!="string")return e.push([I.default.Error,b.localize(0,null)]),e;if(typeof h.name!="string")return e.push([I.default.Error,b.localize(1,null,"name")]),e;if(typeof h.version!="string")return e.push([I.default.Error,b.localize(2,null,"version")]),e;if(!h.engines)return e.push([I.default.Error,b.localize(3,null,"engines")]),e;if(typeof h.engines.vscode!="string")return e.push([I.default.Error,b.localize(4,null,"engines.vscode")]),e;if(typeof h.extensionDependencies!="undefined"&&!y(h.extensionDependencies))return e.push([I.default.Error,b.localize(5,null,"extensionDependencies")]),e;if(typeof h.activationEvents!="undefined"){if(!y(h.activationEvents))return e.push([I.default.Error,b.localize(6,null,"activationEvents")]),e;if(typeof h.main=="undefined"&&typeof h.browser=="undefined")return e.push([I.default.Error,b.localize(7,null,"activationEvents","main")]),e}if(typeof h.extensionKind!="undefined"&&typeof h.main=="undefined"&&e.push([I.default.Warning,b.localize(8,null,"extensionKind")]),typeof h.main!="undefined"){if(typeof h.main!="string")return e.push([I.default.Error,b.localize(9,null,"main")]),e;{const n=(0,R.joinPath)(p,h.main);(0,R.isEqualOrParent)(n,p)||e.push([I.default.Warning,b.localize(10,null,n.path,p.path)])}if(typeof h.activationEvents=="undefined")return e.push([I.default.Error,b.localize(11,null,"activationEvents","main")]),e}if(typeof h.browser!="undefined"){if(typeof h.browser!="string")return e.push([I.default.Error,b.localize(12,null,"browser")]),e;{const n=(0,R.joinPath)(p,h.browser);(0,R.isEqualOrParent)(n,p)||e.push([I.default.Warning,b.localize(13,null,n.path,p.path)])}if(typeof h.activationEvents=="undefined")return e.push([I.default.Error,b.localize(14,null,"activationEvents","browser")]),e}if(!D.valid(h.version))return e.push([I.default.Error,b.localize(15,null)]),e;const r=[];if(!w(a,u,h,s,r))for(const n of r)e.push([I.default.Error,n]);return e}i.validateExtensionManifest=v;function w(a,u,p,h,s){return h||typeof p.main=="undefined"&&typeof p.browser=="undefined"?!0:g(a,u,p.engines.vscode,s)}i.isValidExtensionVersion=w;function P(a,u,p){return a==="*"||g(u,p,a)}i.isEngineValid=P;function g(a,u,p,h=[]){let s=L(m(p));if(!s)return h.push(b.localize(16,null,p)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return h.push(b.localize(17,null,p)),!1}else if(!s.majorMustEqual)return h.push(b.localize(18,null,p)),!1;return T(a,u,s)?!0:(h.push(b.localize(19,null,a,p)),!1)}function y(a){if(!Array.isArray(a))return!1;for(let u=0,p=a.length;u<p;u++)if(typeof a[u]!="string")return!1;return!0}}),define(ee[94],te([0,1,16,31]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(D,k,S){let l=S&&S.get("storage.serviceMachineId",0)||null;if(l)return l;try{const L=(await k.readFile(D.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(L)?L:null}catch{l=null}if(!l){l=(0,I.generateUuid)();try{await k.writeFile(D.serviceMachineIdResource,R.VSBuffer.fromString(l))}catch{}}return S&&S.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(ee[42],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class R{constructor(b,D=[],k=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=k}}i.SyncDescriptor=R}),define(ee[95],te([0,1,42]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function b(k,S,l){S instanceof R.SyncDescriptor||(S=new R.SyncDescriptor(S,[],l)),I.push([k,S])}i.registerSingleton=b;function D(){return I}i.getSingletonServiceDescriptors=D}),define(ee[96],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class R{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}i.Node=R;class I{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let k of this._nodes.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const S=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(k);S.outgoing.set(this._hashFn(k),l),l.incoming.set(this._hashFn(D),S)}removeNode(D){const k=this._hashFn(D);this._nodes.delete(k);for(let S of this._nodes.values())S.outgoing.delete(k),S.incoming.delete(k)}lookupOrInsertNode(D){const k=this._hashFn(D);let S=this._nodes.get(k);return S||(S=new R(D),this._nodes.set(k,S)),S}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[k,S]of this._nodes)D.push(`${k}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,k]of this._nodes){const S=new Set([D]),l=this._findCycle(k,S);if(l)return l}}_findCycle(D,k){for(let[S,l]of D.outgoing){if(k.has(S))return[...k,S].join(" -> ");k.add(S);const m=this._findCycle(l,k);if(m)return m;k.delete(S)}}}i.Graph=I}),define(ee[22],te([0,1,8,9,12]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof I.URI)}i.isConfigurationOverrides=D;function k(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||R.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=k;var S;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(S=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function m(a,u){const p=Object.create(null);for(let h in a)L(p,h,a[h],u);return p}i.toValuesTree=m;function L(a,u,p,h){const s=u.split("."),e=s.pop();let r=a;for(let t=0;t<s.length;t++){let n=s[t],o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${u} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[e]=p}catch{h(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}i.addToValueTree=L;function T(a,u){const p=u.split(".");v(a,p)}i.removeFromValueTree=T;function v(a,u){const p=u.shift();if(u.length===0){delete a[p];return}if(Object.keys(a).indexOf(p)!==-1){const h=a[p];typeof h=="object"&&!Array.isArray(h)&&(v(h,u),Object.keys(h).length===0&&delete a[p])}}function w(a,u,p){function h(r,t){let n=r;for(const o of t){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=u.split("."),e=h(a,s);return typeof e=="undefined"?p:e}i.getConfigurationValue=w;function P(a,u,p){Object.keys(u).forEach(h=>{h!=="__proto__"&&(h in a?R.isObject(a[h])&&R.isObject(u[h])?P(a[h],u[h],p):p&&(a[h]=u[h]):a[h]=u[h])})}i.merge=P;function g(a,u,p){const h=a.inspect(u),s=a.inspect(p);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:h.defaultValue}i.getMigratedSettingValue=g;function y(a){return a.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=y}),define(ee[54],te([0,1,12]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ee[20],te([0,1,12]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,R.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,R.refineServiceDecorator)(i.IEnvironmentService)}),define(ee[23],te([0,1,80,12]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function b(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=b;function D(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=D;function k(a,u){switch(a){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=k;function S(a,u){return u==="web"&&!a.includes("web")}i.isNotWebExtensionInWebTargetPlatform=S;function l(a,u,p){return S(u,p)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===p?!0:m(p).includes(a)}i.isTargetPlatformCompatible=l;function m(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=m;function L(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}i.isIExtensionIdentifier=L;var T;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(T=i.SortBy||(i.SortBy={}));var v;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(v=i.SortOrder||(i.SortOrder={}));var w;(function(a){a.Install="install",a.Uninstall="uninstall"})(w=i.StatisticType||(i.StatisticType={}));var P;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(P=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var g;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(g=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class y extends Error{constructor(u,p){super(u);this.code=p,this.name=p}}i.ExtensionManagementError=y,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,R.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,R.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ee[55],te([0,1,16,7,87,15]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function k(L,T,v,w,P,g){let y;try{await S(L,T,v,w,P,g)}catch(a){y=a}finally{y&&P.errorTransformer&&(y=P.errorTransformer(y)),typeof y!="undefined"&&v.error(y),v.end()}}i.readFileIntoStream=k;async function S(L,T,v,w,P,g){l(g);const y=await L.open(T,{create:!1});try{l(g);let a=0,u=0,p=P&&typeof P.length=="number"?P.length:void 0,h=R.VSBuffer.alloc(Math.min(P.bufferSize,typeof p=="number"?p:P.bufferSize)),s=P&&typeof P.position=="number"?P.position:0,e=0;do u=await L.read(y,s,h.buffer,e,h.byteLength-e),s+=u,e+=u,a+=u,typeof p=="number"&&(p-=u),e===h.byteLength&&(await v.write(w(h)),h=R.VSBuffer.alloc(Math.min(P.bufferSize,typeof p=="number"?p:P.bufferSize)),e=0);while(u>0&&(typeof p!="number"||p>0)&&l(g)&&m(a,P));if(e>0){let r=e;typeof p=="number"&&(r=Math.min(e,p)),v.write(w(h.slice(0,r)))}}catch(a){throw(0,D.ensureFileSystemProviderError)(a)}finally{await L.close(y)}}function l(L){if(L.isCancellationRequested)throw(0,I.canceled)();return!0}function m(L,T){if(T?.limits){if(typeof T.limits.memory=="number"&&L>T.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&L>T.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[97],te([0,1,3,137,2,10,138]),function(_,i,R,I,b,D,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class S extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const L=this.normalizeRequests(m),T=L.filter(w=>{const P=this.watchers.get(w.path);return P?!(0,I.patternsEquals)(P.request.excludes,w.excludes)||!(0,I.patternsEquals)(P.request.includes,w.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:w})=>!L.find(P=>P.path===w.path&&(0,I.patternsEquals)(P.excludes,w.excludes)&&(0,I.patternsEquals)(P.includes,w.includes))).map(({request:w})=>w.path);T.length&&this.trace(`Request to start watching: ${T.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?w.includes:"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const w of v)this.stopWatching(w);for(const w of T)this.startWatching(w)}startWatching(m){const L=new k.NodeJSFileWatcherLibrary(m,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),T={request:m,instance:L};this.watchers.set(m.path,T)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const L=this.watchers.get(m);L&&(this.watchers.delete(m),L.instance.dispose())}normalizeRequests(m){const L=new Map;for(const T of m){const v=D.isLinux?T.path:T.path.toLowerCase();L.set(v,T)}return Array.from(L.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,L]of this.watchers)L.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,L){return L?`[File Watcher (node.js)] ${m} (path: ${L.request.path})`:`[File Watcher (node.js)] ${m}`}}i.NodeJSWatcher=S}),define(ee[98],te([0,1,56,97]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class b extends R.AbstractNonRecursiveWatcherClient{constructor(k,S,l){super(k,S,l);this.init()}createWatcher(){return new I.NodeJSWatcher}}i.NodeJSWatcherClient=b}),define(ee[99],te([0,1,14,52,76,56]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(l,m,L){super(l,m,L);this.init()}createWatcher(l){const m=l.add(new b.Client(R.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:L,signal:T})=>this.onError(`terminated by itself with code ${L}, signal: ${T}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(m.getChannel("watcher")))}}i.UniversalWatcherClient=k}),define(ee[57],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class R{constructor(...b){this._entries=new Map;for(let[D,k]of b)this.set(D,k)}set(b,D){const k=this._entries.get(b);return this._entries.set(b,D),k}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=R}),define(ee[100],te([0,1,4,7,42,96,12,57]),function(_,i,R,I,b,D,k,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const l=!1;class m extends Error{constructor(P){super("cyclic dependency between services");this.message=P.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${P.toString()}`}}class L{constructor(P=new S.ServiceCollection,g=!1,y){this._activeInstantiations=new Set,this._services=P,this._strict=g,this._parent=y,this._services.set(k.IInstantiationService,this)}createChild(P){return new L(P,this._strict,this)}invokeFunction(P,...g){let y=v.traceInvocation(P),a=!1;try{return P({get:p=>{if(a)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(p,y);if(!h)throw new Error(`[invokeFunction] unknown service '${p}'`);return h}},...g)}finally{a=!0,y.stop()}}createInstance(P,...g){let y,a;return P instanceof b.SyncDescriptor?(y=v.traceCreation(P.ctor),a=this._createInstance(P.ctor,P.staticArguments.concat(g),y)):(y=v.traceCreation(P),a=this._createInstance(P,g,y)),y.stop(),a}_createInstance(P,g=[],y){let a=k._util.getServiceDependencies(P).sort((h,s)=>h.index-s.index),u=[];for(const h of a){let s=this._getOrCreateServiceInstance(h.id,y);s||this._throwIfStrict(`[createInstance] ${P.name} depends on UNKNOWN service ${h.id}.`,!1),u.push(s)}let p=a.length>0?a[0].index:g.length;if(g.length!==p){console.trace(`[createInstance] First service dependency of ${P.name} at position ${p+1} conflicts with ${g.length} static arguments`);let h=p-g.length;h>0?g=g.concat(new Array(h)):g=g.slice(0,p)}return new P(...[...g,...u])}_setServiceInstance(P,g){if(this._services.get(P)instanceof b.SyncDescriptor)this._services.set(P,g);else if(this._parent)this._parent._setServiceInstance(P,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(P){let g=this._services.get(P);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(P):g}_getOrCreateServiceInstance(P,g){let y=this._getServiceInstanceOrDescriptor(P);return y instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(P,y,g.branch(P,!0)):(g.branch(P,!1),y)}_safeCreateAndCacheServiceInstance(P,g,y){if(this._activeInstantiations.has(P))throw new Error(`illegal state - RECURSIVELY instantiating service '${P}'`);this._activeInstantiations.add(P);try{return this._createAndCacheServiceInstance(P,g,y)}finally{this._activeInstantiations.delete(P)}}_createAndCacheServiceInstance(P,g,y){const a=new D.Graph(h=>h.id.toString());let u=0;const p=[{id:P,desc:g,_trace:y}];for(;p.length;){const h=p.pop();if(a.lookupOrInsertNode(h),u++>1e3)throw new m(a);for(let s of k._util.getServiceDependencies(h.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${P} depends on ${s.id} which is NOT registered.`,!0),e instanceof b.SyncDescriptor){const r={id:s.id,desc:e,_trace:h._trace.branch(s.id,!0)};a.insertEdge(h,r),p.push(r)}}}for(;;){const h=a.roots();if(h.length===0){if(!a.isEmpty())throw new m(a);break}for(const{data:s}of h){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}a.removeNode(s)}}return this._getServiceInstanceOrDescriptor(P)}_createServiceInstanceWithOwner(P,g,y=[],a,u){if(this._services.get(P)instanceof b.SyncDescriptor)return this._createServiceInstance(g,y,a,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(P,g,y,a,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(P,g=[],y,a){if(y){const u=new R.IdleValue(()=>this._createInstance(P,g,a));return new Proxy(Object.create(null),{get(p,h){if(h in p)return p[h];let s=u.value,e=s[h];return typeof e!="function"||(e=e.bind(s),p[h]=e),e},set(p,h,s){return u.value[h]=s,!0}})}else return this._createInstance(P,g,a)}_throwIfStrict(P,g){if(g&&console.warn(g),this._strict)throw new Error(P)}}i.InstantiationService=L;var T;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(T||(T={}));class v{constructor(P,g){this.type=P,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(P){return l?new v(1,P.name||P.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(P){return l?new v(0,P.name):v._None}branch(P,g){let y=new v(2,P.toString());return this._dep.push([P,g,y]),y}stop(){let P=Date.now()-this._start;v._totals+=P;let g=!1;function y(u,p){let h=[],s=new Array(u+1).join("	");for(const[e,r,t]of p._dep)if(r&&t){g=!0,h.push(`${s}CREATES -> ${e}`);let n=y(u+1,t);n&&h.push(n)}else h.push(`${s}uses -> ${e}`);return h.join(`
`)}let a=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${P.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(P>2||g)&&console.log(a.join(`
`))}}i.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(ee[58],te([0,1,12]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,R.createDecorator)("localizationsService");function I(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=I}),define(ee[13],te([0,1,28,3,2,10,12]),function(_,i,R,I,b,D,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,k.createDecorator)("logService"),i.ILoggerService=(0,k.createDecorator)("loggerService");function S(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function m(r,t,n){switch(t){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=m;function L(r){let t="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(n>0?" ":"")+o}return t}i.format=L;class T extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=T;class v extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,L([t,...n]))}debug(t,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,L([t,...n]))}info(t,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,L([t,...n]))}warn(t,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,L([t,...n]))}error(t,...n){if(this.checkLogLevel(l.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(l.Error,L(o))}else this.log(l.Error,L([t,...n]))}critical(t,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,L([t,...n]))}flush(){}}i.AbstractMessageLogger=v;class w extends T{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...n):console.log(`[main ${S()}]`,t,...n))}debug(t,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...n):console.log(`[main ${S()}]`,t,...n))}info(t,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...n):console.log(`[main ${S()}]`,t,...n))}warn(t,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...n):console.warn(`[main ${S()}]`,t,...n))}error(t,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...n):console.error(`[main ${S()}]`,t,...n))}critical(t,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...n):console.error(`[main ${S()}]`,t,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=w;class P extends T{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}i.ConsoleLogger=P;class g extends T{constructor(t,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class y extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=y;class a extends b.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}i.LogService=a;class u extends b.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,n?.always?l.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=u;class p{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return l.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}i.NullLogService=p;function h(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const t=s(r.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=h;function s(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=s;function e(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=e});var ae=this&&this.__param||function(_,i){return function(R,I){i(R,I,_)}};define(ee[101],te([0,1,40,4,28,3,2,14,11,19,20,13]),function(_,i,R,I,b,D,k,S,l,m,L,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let v=class extends k.Disposable{constructor(P,g){super();this.environmentService=P,this.logService=g,this.processesLimiter=new I.Limiter(5)}async postUninstall(P){const g=this.parseScript(P,"uninstall");return g&&(this.logService.info(P.identifier.id,P.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,P).then(()=>this.logService.info(P.identifier.id,P.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(P.identifier.id,P.manifest.version,`Failed to run post uninstall script: ${y}`)))),m.Promises.rm(this.getExtensionStoragePath(P)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(P,g){const y=`vscode:${g}`;if(P.location.scheme===S.Schemas.file&&P.manifest&&P.manifest.scripts&&typeof P.manifest.scripts[y]=="string"){const a=P.manifest.scripts[y].split(" ");return a.length<2||a[0]!=="node"||!a[1]?(this.logService.warn(P.identifier.id,P.manifest.version,`${y} should be a node script`),null):{script:(0,l.join)(P.location.fsPath,a[1]),args:a.slice(2)||[]}}return null}runLifecycleHook(P,g,y,a,u){return new Promise((p,h)=>{const s=this.start(P,g,y,u);let e;const r=t=>{e&&(clearTimeout(e),e=null),t?h(t):p(void 0)};s.on("error",t=>{r((0,b.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,n)=>{r(t?`post-${g} process exited with code ${t}`:void 0)}),a&&(e=setTimeout(()=>{e=null,s.kill(),h("timed out")},5e3))})}start(P,g,y,a){const u={silent:!0,execArgv:void 0},p=(0,R.fork)(P,[`--type=extension-post-${g}`,...y],u);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const h=D.Event.fromNodeEventEmitter(p.stdout,"data"),s=D.Event.fromNodeEventEmitter(p.stderr,"data");h(t=>this.logService.info(a.identifier.id,a.manifest.version,`post-${g}`,t)),s(t=>this.logService.error(a.identifier.id,a.manifest.version,`post-${g}`,t));const e=D.Event.any(D.Event.map(h,t=>({data:`%c${t}`,format:[""]})),D.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return D.Event.debounce(e,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(a.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}getExtensionStoragePath(P){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,P.identifier.id.toLowerCase())}};v=he([ae(0,L.IEnvironmentService),ae(1,T.ILogService)],v),i.ExtensionsLifecycle=v}),define(ee[102],te([0,1,17,4,7,3,2,11,56,13]),function(_,i,R,I,b,D,k,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class L extends k.Disposable{constructor(v,w){super();this.logService=v,this.options=w,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(v,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,w):this.watchNonRecursive(v,w)}watchUniversal(v,w){const P={path:this.toFilePath(v),excludes:w.excludes,includes:w.includes,recursive:w.recursive},g=(0,R.insert)(this.universalPathsToWatch,P);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,b.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,l.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const w of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const w of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(w)&&v.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,w){const P={path:this.toFilePath(v),excludes:w.excludes,includes:w.includes,recursive:!1},g=(0,R.insert)(this.nonRecursivePathsToWatch,P);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,b.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,l.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,S.normalize)(v.fsPath)}}i.AbstractDiskFileSystemProvider=L}),define(ee[103],te([0,1,17,4,16,26,3,63,139,2,59,14,104,18,38,86,15,55,13]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g,y,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let p=class extends m.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${s}`);const r=new m.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),r.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new y.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,m.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){e.push(r)}}),!this.provider.has(s)&&await I.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return l.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,w.isAbsolutePath)(s))throw new y.FileOperationError((0,g.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,s.toString()),r}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e)||(0,y.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,g.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(s,e){const r=await this.withProvider(s),t=this.isPathCaseSensitive(r),n=e?.resolveTo,o=e?.resolveSingleChildDescendants,c=e?.resolveMetadata,f=await r.stat(s);let d;return this.toFileStat(r,s,f,void 0,!!c,(E,A)=>(d||(d=L.TernarySearchTree.forUris(()=>!t),d.set(s,!0),n&&d.fill(!0,n)),d.get(E.resource)||d.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?A===1:!1))}async toFileStat(s,e,r,t,n,o){const{providerExtUri:c}=this.getExtUri(s),f={resource:e,name:c.basename(e),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(f.isDirectory&&o(f,t)){try{const d=await s.readdir(e),E=await I.Promises.settled(d.map(async([A,z])=>{try{const Z=c.joinPath(e,A),Q=n?await s.stat(Z):{type:z};return await this.toFileStat(s,Z,Q,d.length,n,o)}catch(Z){return this.logService.trace(Z),null}}));f.children=(0,R.coalesce)(E)}catch(d){this.logService.trace(d),f.children=[]}return f}return f}async resolveAll(s){return I.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),r=await e.stat(s);return this.toFileStat(e,s,r,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(r){return r}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,g.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=b.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,t)),t}async writeFile(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,s,r)||await this.mkdirp(t,n.dirname(s));let c;if((0,y.hasReadWriteCapability)(t)&&!(e instanceof b.VSBuffer))if((0,P.isReadableStream)(e)){const f=await(0,P.peekStream)(e,3);f.ended?c=b.VSBuffer.concat(f.buffer):c=f}else c=(0,P.peekReadable)(e,f=>b.VSBuffer.concat(f),3);else c=e;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&c instanceof b.VSBuffer?await this.doWriteUnbuffered(t,s,r,c):await this.doWriteBuffered(t,s,r,c instanceof b.VSBuffer?(0,b.bufferToReadable)(c):c),this._onDidRunOperation.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,g.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(e)));let n;try{n=await s.stat(e)}catch{return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,g.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:n.size}))throw new y.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(s,e,r){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,r):this.doReadFile(t,s,e,r)}async doReadFileAtomic(s,e,r,t){return new Promise((n,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(s,e,r,t);n(c)}catch(c){o(c)}})})}async doReadFile(s,e,r,t){const n=await this.doReadFileStream(s,e,{...r,preferUnbuffered:!0},t);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(s,e,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,r)}async doReadFileStream(s,e,r,t){const n=new D.CancellationTokenSource(t),o=this.validateReadFile(e,r).then(f=>f,f=>{throw n.cancel(),f});let c;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await o,r?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&r?.preferUnbuffered?c=this.readFileUnbuffered(s,e,r):(0,y.hasFileReadStreamCapability)(s)?c=this.readFileStreamed(s,e,n.token,r):c=this.readFileBuffered(s,e,n.token,r),{...await o,value:c}}catch(f){c&&await(0,P.consumeStream)(c);const d=(0,g.localize)(8,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(f).toString());throw f instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(d,f.stat,r):new y.FileOperationError(d,(0,y.toFileOperationResult)(f),r)}}readFileStreamed(s,e,r,t=Object.create(null)){const n=s.readFileStream(e,t,r);return(0,P.transform)(n,{data:o=>o instanceof b.VSBuffer?o:b.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,g.localize)(9,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},o=>b.VSBuffer.concat(o))}readFileBuffered(s,e,r,t=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,a.readFileIntoStream)(s,e,n,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new y.FileOperationError((0,g.localize)(10,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},r),n}readFileUnbuffered(s,e,r){const t=(0,P.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?n=await s.readFile(e,{atomic:!0}):n=await s.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),t.end(b.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(s,e){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,g.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==y.ETAG_DISABLED&&e.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,e);return this.validateReadFileLimits(s,r.size,e),r}validateReadFileLimits(s,e,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&e>r.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,g.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,r){return this.doCanMoveCopy(s,e,"move",r)}async canCopy(s,e,r){return this.doCanMoveCopy(s,e,"copy",r)}async doCanMoveCopy(s,e,r,t){if(s.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,s,o,e,r,t)}catch(n){return n}return!0}async move(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"move",!!r),c=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,e,r){const t=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"copy",!!r),c=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="copy"?3:2,c)),c}async doMoveCopy(s,e,r,t,n,o){if(e.toString()===t.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(s,e,r,t,n,o);if(c&&!f&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n==="copy"){if(s===r&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const d=await this.resolve(e);d.isDirectory?await this.doCopyFolder(s,d,r,t):await this.doCopyFile(s,e,r,t)}return n}else return s===r?(await s.rename(e,t,{overwrite:o}),n):(await this.doMoveCopy(s,e,r,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,r,t){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,e,r,t);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,e,r,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,e,r,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,e,r,t)}async doCopyFolder(s,e,r,t){await r.mkdir(t),Array.isArray(e.children)&&await I.Promises.settled(e.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,e,r,t,n,o){let c=!1;if(s===r){const{providerExtUri:d,isPathCaseSensitive:E}=this.getExtUri(s);if(E||(c=d.isEqual(e,t)),c&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!c&&d.isEqualOrParent(t,e))throw new Error((0,g.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const f=await this.exists(t);if(f&&!c){if(!o)throw new y.FileOperationError((0,g.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===r){const{providerExtUri:d}=this.getExtUri(s);if(d.isEqualOrParent(e,t))throw new Error((0,g.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:f,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,r)),r}async mkdirp(s,e){const r=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&y.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(t.basename(e)),e=t.dirname(e)}for(let n=r.length-1;n>=0;n--){e=t.joinPath(e,r[n]);try{await s.mkdir(e)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(r){return r}return!0}async doValidateDelete(s,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new y.FileOperationError((0,g.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(s)))}return r}async del(s,e){const r=await this.doValidateDelete(s,e),t=!!e?.useTrash,n=!!e?.recursive;await r.delete(s,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,e){const r=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(s,e))return;if(r===t&&(0,y.hasFileCloneCapability)(r))return r.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===t&&(0,y.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,e,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const r=new m.DisposableStore;let t=!1,n=()=>{t=!0};return r.add((0,m.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,m.dispose)(o):n=()=>(0,m.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,e){const r=await this.withProvider(s),t=(0,S.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),e]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:r.watch(s,e)},this.activeWatchers.set(t,n)),n.count+=1,(0,m.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,m.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,P.isReadableStream)(t)||(0,P.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,n,t):await this.doWriteReadableBufferedQueued(s,n,t)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,e,r){let t=0,n;if((0,P.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=b.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,c)=>{(0,P.listenStream)(n,{onData:async f=>{n.pause();try{await this.doWriteBuffer(s,e,f,f.byteLength,t,0)}catch(d){return c(d)}t+=f.byteLength,setTimeout(()=>n.resume())},onError:f=>c(f),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,r){let t=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,e,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(s,e,r,t,n,o){let c=0;for(;c<t;)c+=await s.write(e,n+c,r.buffer,o+c,t-c)}async doWriteUnbuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,r,t))}async doWriteUnbufferedQueued(s,e,r,t){let n;t instanceof b.VSBuffer?n=t:(0,P.isReadableStream)(t)?n=await(0,b.streamToBuffer)(t):(0,P.isReadableBufferedStream)(t)?n=await(0,b.bufferedStreamToBuffer)(t):n=(0,b.readableToBuffer)(t),await s.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,r,t))}async doPipeBufferedQueued(s,e,r,t){let n,o;try{n=await s.open(e,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const c=b.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,d=0,E=0;do E=await s.read(n,f,c.buffer,d,c.byteLength-d),await this.doWriteBuffer(r,o,c,E,f,d),f+=E,d+=E,d===c.byteLength&&(d=0);while(E>0)}catch(c){throw(0,y.ensureFileSystemProviderError)(c)}finally{await I.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,r,t))}async doPipeUnbufferedQueued(s,e,r,t){return r.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,r,t))}async doPipeUnbufferedToBufferedQueued(s,e,r,t){const n=await r.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(r,n,b.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,e,r,t){const n=await(0,b.streamToBuffer)(this.readFileBuffered(s,e,D.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,n)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new y.FileOperationError((0,g.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,g.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===T.Schemas.file?s.fsPath:s.toString(!0)}};p=he([ae(0,u.ILogService)],p),i.FileService=p}),define(ee[105],te([0,1,106,140,4,59,16,3,51,2,11,10,18,38,19,88,15,55,102,28,99,98]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g,y,a,u,p,h,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(r)}`)}})();class e extends u.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new D.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:o}=await P.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await P.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async c=>{try{let f;c.isSymbolicLink()?f=(await this.stat((0,v.joinPath)(t,c.name))).type:f=this.toType(c),o.push([c.name,f])}catch(f){this.logService.trace(f)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let o;return n?.dangling?o=y.FileType.Unknown:t.isFile()?o=y.FileType.File:t.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,n&&(o|=y.FileType.SymbolicLink),o}async createResourceLock(t){const n=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const c=new b.Barrier;return this.resourceLocks.set(t,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(t,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const c=this.toFilePath(t);return await P.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}readFileStream(t,n,o){const c=(0,w.newWriteableStream)(f=>k.VSBuffer.concat(f.map(d=>k.VSBuffer.wrap(d))).buffer);return(0,a.readFileIntoStream)(this,t,c,f=>f.buffer,{...n,bufferSize:256*1024},o),c}async writeFile(t,n,o){let c;try{const f=this.toFilePath(t);if(!o.create||!o.overwrite){if(await P.Promises.exists(f)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,g.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,g.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(t,f)}finally{typeof c=="number"&&await this.close(c)}}async open(t,n){const o=this.toFilePath(t);let c;(0,y.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(t));let f;try{if((0,y.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:E}=await P.SymlinkSupport.stat(o);E.mode&128||await P.Promises.chmod(o,E.mode|128)}catch(E){this.logService.trace(E)}let d;if((0,y.isFileOpenForWriteOptions)(n)){if(T.isWindows)try{await P.Promises.truncate(o,0),d="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}d||(d="w")}else d="r";f=await P.Promises.open(o,d)}catch(d){throw c?.dispose(),(0,y.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(f,0),(0,y.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(f,t),c){const d=this.mapHandleToLock.get(f);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${f} (${o})`),this.mapHandleToLock.set(f,c),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${f} (${o})`),d.dispose())}return f}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&this.canFlush)try{await P.Promises.fdatasync(t)}catch(o){this.canFlush=!1,this.logService.error(o)}return await P.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,o,c,f){const d=this.normalizePos(t,n);let E=null;try{E=(await P.Promises.read(t,o,c,f,d)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,d,E)}return E}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,o){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,c+o):this.mapHandleToPos.delete(t)))}async write(t,n,o,c,f){return(0,b.retry)(()=>this.doWrite(t,n,o,c,f),100,3)}async doWrite(t,n,o,c,f){const d=this.normalizePos(t,n);let E=null;try{E=(await P.Promises.write(t,o,c,f,d)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,d,E)}return E}async mkdir(t){try{await P.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const o=this.toFilePath(t);n.recursive?await P.Promises.rm(o,P.RimRafMode.MOVE):await P.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,n,o){const c=this.toFilePath(t),f=this.toFilePath(n);if(c!==f)try{await this.validateTargetDeleted(t,n,"move",o.overwrite),await P.Promises.move(c,f)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(2,null,(0,L.basename)(c),(0,L.basename)((0,L.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(t,n,o){const c=this.toFilePath(t),f=this.toFilePath(n);if(c!==f)try{await this.validateTargetDeleted(t,n,"copy",o.overwrite),await P.Promises.copy(c,f,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(3,null,(0,L.basename)(c),(0,L.basename)((0,L.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(t,n,o,c){const f=this.toFilePath(t),d=this.toFilePath(n);let E=!1;if(!!(this.capabilities&1024)||(E=(0,l.isEqual)(f,d,!0)),E&&o==="copy")throw(0,y.createFileSystemProviderError)((0,g.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!E&&await P.Promises.exists(d)){if(!c)throw(0,y.createFileSystemProviderError)((0,g.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,o){const c=this.toFilePath(t),f=this.toFilePath(n),d=!!(this.capabilities&1024);if((0,l.isEqual)(c,f,!d))return;const E=new m.DisposableStore;try{const[A,z]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);E.add(A),E.add(z),o&&await P.Promises.mkdir((0,L.dirname)(f),{recursive:!0}),await P.Promises.copyFile(c,f)}catch(A){if(A.code==="ENOENT"&&!o)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(A)}finally{E.dispose()}}createUniversalWatcher(t,n,o){return new h.UniversalWatcherClient(c=>t(c),c=>n(c),o)}createNonRecursiveWatcher(t,n,o){return new s.NodeJSWatcherClient(c=>t(c),c=>n(c),o)}toFileSystemProviderError(t){if(t instanceof y.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=y.FileSystemProviderErrorCode.NoPermissions;break;default:n=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let o=this.toFileSystemProviderError(n);if(t&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await P.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(o=(0,y.createFileSystemProviderError)(n,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}i.DiskFileSystemProvider=e}),define(ee[107],te([0,1,15,13]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(S,l,m,L,T){try{const v=await new Promise((P,g)=>{_(["spdlog"],P,g)});v.setFlushOn(I.LogLevel.Trace);const w=await v.createAsyncRotatingLogger(S,l,m,L);return T&&w.clearFormatters(),w}catch(v){console.error(v)}return null}function D(S,l,m){switch(l){case I.LogLevel.Trace:S.trace(m);break;case I.LogLevel.Debug:S.debug(m);break;case I.LogLevel.Info:S.info(m);break;case I.LogLevel.Warning:S.warn(m);break;case I.LogLevel.Error:S.error(m);break;case I.LogLevel.Critical:S.critical(m);break;default:throw new Error("Invalid log level")}}class k extends I.AbstractMessageLogger{constructor(l,m,L,T,v){super();this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(l,m,L,T),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(l,m,L,T){const v=L?6:1,w=30/v*R.ByteSize.MB,P=await b(l,m,w,v,T);if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:g,message:y}of this.buffer)D(this._logger,g,y);this.buffer=[]}}log(l,m){this._logger?D(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=k}),define(ee[27],te([0,1,12]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,R.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(ee[29],te([0,1,61,8]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(k,S){R.ok(I.isString(k)),R.ok(I.isObject(S)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,S)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}i.Registry=new b}),define(ee[108],te([0,1,3,29]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[b(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new D;I.Registry.add(i.Extensions.JSONContribution,k)}),define(ee[34],te([0,1,17,3,8,78,22,108,29]),function(_,i,R,I,b,D,k,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var m;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(m=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var L;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=l.Registry.as(S.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,r=!0){this.registerConfigurations([e],r)}registerConfigurations(e,r=!0){const t=this.doRegisterConfigurations(e,r);T.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const r=this.doDeregisterConfigurations(e);T.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:e,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(e,!1)),T.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(e){const r=[],t=[];for(const{overrides:n,source:o}of e)for(const c in n)if(r.push(c),i.OVERRIDE_PROPERTY_REGEX.test(c)){const f={...this.configurationDefaultsOverrides.get(c)?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:f});const d=(0,k.getLanguageTagSettingPlainKey)(c),E={type:"object",default:f,description:D.localize(1,null,d),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:b.isString(o)?void 0:o};t.push(...g(c)),this.configurationProperties[c]=E,this.defaultLanguageConfigurationOverridesNode.properties[c]=E}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:o});const f=this.configurationProperties[c];f&&(this.updatePropertyDefaultValue(c,f),this.updateSchema(c,f))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const r=[];for(const{overrides:t,source:n}of e)for(const o in t){const c=this.configurationDefaultsOverrides.get(o),f=b.isString(n)?n:n?.id,d=b.isString(c?.source)?c?.source:c?.source?.id;if(f===d)if(r.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const E=this.configurationProperties[o];E&&(this.updatePropertyDefaultValue(o,E),this.updateSchema(o,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const r of e)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,r){const t=[];return e.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(e){const r=[],t=n=>{if(n.properties)for(const o in n.properties)r.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o]);n.allOf&&n.allOf.forEach(o=>t(o))};for(const n of e){t(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(e,r=!0,t,n,o=3){o=b.isUndefinedOrNull(e.scope)?o:e.scope;let c=[],f=e.properties;if(f)for(let E in f){if(r&&p(E)){delete f[E];continue}const A=f[E];if(A.source=t,A.defaultDefaultValue=f[E].default,this.updatePropertyDefaultValue(E,A),i.OVERRIDE_PROPERTY_REGEX.test(E)?A.scope=void 0:(A.scope=b.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=b.isUndefinedOrNull(A.restricted)?!!n?.includes(E):A.restricted),f[E].hasOwnProperty("included")&&!f[E].included){this.excludedConfigurationProperties[E]=f[E],delete f[E];continue}else this.configurationProperties[E]=f[E];!f[E].deprecationMessage&&f[E].markdownDeprecationMessage&&(f[E].deprecationMessage=f[E].markdownDeprecationMessage),c.push(E)}let d=e.allOf;if(d)for(let E of d)c.push(...this.validateAndRegisterProperties(E,r,t,n,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const r=t=>{let n=t.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);let o=t.allOf;o&&o.forEach(r)};r(e)}updateSchema(e,r){switch(i.allSettings.properties[e]=r,r.scope){case 1:i.applicationSettings.properties[e]=r;break;case 2:i.machineSettings.properties[e]=r;break;case 6:i.machineOverridableSettings.properties[e]=r;break;case 3:i.windowSettings.properties[e]=r;break;case 4:i.resourceSettings.properties[e]=r;break;case 5:i.resourceSettings.properties[e]=r,this.resourceLanguageSettingsSchema.properties[e]=r;break}}removeFromSchema(e,r){switch(delete i.allSettings.properties[e],r.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,t={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),i.allSettings.properties[r]=t,i.applicationSettings.properties[r]=t,i.machineSettings.properties[r]=t,i.machineOverridableSettings.properties[r]=t,i.windowSettings.properties[r]=t,i.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,r){const t=this.configurationDefaultsOverrides.get(e);let n=t?.value,o=t?.source;b.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),b.isUndefined(n)&&(n=a(r.type)),r.default=n,r.defaultValueSource=o}}const w="\\[([^\\]]+)\\]",P=new RegExp(w,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function g(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let r=P.exec(s);for(;r?.length;){const t=r[1].trim();t&&e.push(t),r=P.exec(s)}}return(0,R.distinct)(e)}i.overrideIdentifiersFromKey=g;function y(s){return s.reduce((e,r)=>`${e}[${r}]`,"")}i.keyFromOverrideIdentifiers=y;function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const u=new v;l.Registry.add(i.Extensions.Configuration,u);function p(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?D.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?D.localize(8,null,s):null:D.localize(6,null)}i.validateProperty=p;function h(){const s=[],e=u.getConfigurationProperties();for(const r of Object.keys(e))s.push([r,e[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=h}),define(ee[109],te([0,1,17,3,46,2,59,21,8,9,22,34,29]),function(_,i,R,I,b,D,k,S,l,m,L,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class w{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,L.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,L.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const o of this.overrides)o.identifiers.includes(t)&&n.push(...o.keys);return R.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return R.distinct(t)}override(t){let n=this.overrideConfigurations.get(t);return n||(n=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,n)),n}merge(...t){const n=S.deepClone(this.contents),o=S.deepClone(this.overrides),c=[...this.keys];for(const f of t){this.mergeContents(n,f.contents);for(const d of f.overrides){const[E]=o.filter(A=>R.equals(A.identifiers,d.identifiers));E?(this.mergeContents(E.contents,d.contents),E.keys.push(...d.keys),E.keys=R.distinct(E.keys)):o.push(S.deepClone(d))}for(const d of f.keys)c.indexOf(d)===-1&&c.push(d)}return new w(n,c,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const c of R.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[c],d=n[c];d&&(typeof f=="object"&&typeof d=="object"?(f=S.deepClone(f),this.mergeContents(f,d)):f=d),o[c]=f}return new w(o,this.keys,this.overrides)}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&l.isObject(t[o])&&l.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=S.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let n=null,o=null;const c=f=>{f&&(o?this.mergeContents(o,f):o=S.deepClone(f))};for(const f of this.overrides)R.equals(f.identifiers,[t])?n=f.contents:f.identifiers.includes(t)&&c(f.contents);return c(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,L.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,L.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=w;class P extends w{constructor(t={}){const n=v.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),c=Object.create(null),f=[];for(const d in n){const E=t[d],A=E!==void 0?E:n[d].default;(0,L.addToValueTree)(c,d,A,z=>console.error(`Conflict in default settings: ${z}`))}for(const d of Object.keys(c))T.OVERRIDE_PROPERTY_REGEX.test(d)&&f.push({identifiers:(0,T.overrideIdentifiersFromKey)(d),keys:Object.keys(c[d]),contents:(0,L.toValuesTree)(c[d],E=>console.error(`Conflict in default settings file: ${E}`))});super(c,o,f)}}i.DefaultConfigurationModel=P;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!l.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:o,keys:c,overrides:f,restricted:d}=this.doParseRaw(t,n);this._configurationModel=new w(o,c,f),this._restrictedConfigurations=d||[]}doParseContent(t){let n={},o=null,c=[],f=[],d=[];function E(z){Array.isArray(c)?c.push(z):o!==null&&(c[o]=z)}let A={onObjectBegin:()=>{let z={};E(z),f.push(c),c=z,o=null},onObjectProperty:z=>{o=z},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{let z=[];E(z),f.push(c),c=z,o=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:E,onError:(z,Z,Q)=>{d.push({error:z,offset:Z,length:Q})}};if(t)try{b.visit(t,A),n=c[0]||{}}catch(z){console.error(`Error while parsing settings file ${this._name}: ${z}`),this._parseErrors=[z]}return n}doParseRaw(t,n){const o=v.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),c=this.filter(t,o,!0,n);t=c.raw;const f=(0,L.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),d=Object.keys(t),E=this.toOverrides(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:f,keys:d,overrides:E,restricted:c.restricted}}filter(t,n,o,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:t,restricted:[]};const f={},d=[];for(let E in t)if(T.OVERRIDE_PROPERTY_REGEX.test(E)&&o){const A=this.filter(t[E],n,!1,c);f[E]=A.raw,d.push(...A.restricted)}else{const A=n[E],z=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&d.push(E),(z===void 0||c.scopes===void 0||c.scopes.includes(z))&&(c.skipRestricted&&A?.restricted||(f[E]=t[E]))}return{raw:f,restricted:d}}toOverrides(t,n){const o=[];for(const c of Object.keys(t))if(T.OVERRIDE_PROPERTY_REGEX.test(c)){const f={};for(const d in t[c])f[d]=t[c][d];o.push({identifiers:(0,T.overrideIdentifiersFromKey)(c),keys:Object.keys(f),contents:(0,L.toValuesTree)(f,n)})}return o}}i.ConfigurationModelParser=g;class y extends D.Disposable{constructor(t,n,o,c){super();this.userSettingsResource=t,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&o.isEqual(f.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=y;class a{constructor(t,n,o=new w,c=new w,f=new k.ResourceMap,d=new w,E=new k.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=c,this._folderConfigurations=f,this._memoryConfiguration=d,this._memoryConfigurationByResource=E,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let c;o.resource?(c=this._memoryConfigurationByResource.get(o.resource),c||(c=new w,this._memoryConfigurationByResource.set(o.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(t):c.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const c=this.getConsolidateConfigurationModel(n,o),f=this.getFolderConfigurationModelForResource(n.resource,o),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,E=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),z=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),Z=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),Q=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,ie=f?n.overrideIdentifier?f.freeze().override(n.overrideIdentifier).getValue(t):f.freeze().getValue(t):void 0,re=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(t):d.getValue(t),U=c.getValue(t),W=R.distinct(R.flatten(c.overrides.map(J=>J.identifiers))).filter(J=>c.getOverrideValue(t,J)!==void 0);return{defaultValue:E,userValue:A,userLocalValue:z,userRemoteValue:Z,workspaceValue:Q,workspaceFolderValue:ie,memoryValue:re,value:U,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:z!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:Z!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:ie!==void 0?{value:f?.freeze().getValue(t),override:n.overrideIdentifier?f?.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:d.getValue(t),override:n.overrideIdentifier?d.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=[];if(!n){const{added:c,updated:f,removed:d}=s(this._defaultConfiguration,t);n=[...c,...f,...d]}for(const c of n)for(const f of(0,T.overrideIdentifiersFromKey)(c)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(f),E=t.getKeysForOverrideIdentifier(f),A=[...E.filter(z=>d.indexOf(z)===-1),...d.filter(z=>E.indexOf(z)===-1),...d.filter(z=>!S.equals(this._defaultConfiguration.override(f).getValue(z),t.override(f).getValue(z)))];o.push([f,A])}return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:c,overrides:f}=s(this.localUserConfiguration,t),d=[...n,...o,...c];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:f}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:c,overrides:f}=s(this.remoteUserConfiguration,t);let d=[...n,...o,...c];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:f}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:c,overrides:f}=s(this.workspaceConfiguration,t);let d=[...n,...o,...c];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:f}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:c,updated:f,removed:d,overrides:E}=s(o,n);let A=[...c,...f,...d];return(A.length||!o)&&this.updateFolderConfiguration(t,n),{keys:A,overrides:E}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:c,removed:f,overrides:d}=s(n,void 0);return{keys:[...o,...c,...f],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const c=n.getFolder(t);c&&(o=this.getFolderConsolidatedConfiguration(c.uri)||o);const f=this._memoryConfigurationByResource.get(t);f&&(o=o.merge(f))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(n=o.merge(c),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:c,keys:f}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:c,keys:f}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(c=>n.add(c))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),f=t.folders.reduce((d,E)=>(d.set(m.URI.revive(E[0]),this.parseConfigurationModel(E[1])),d),new k.ResourceMap);return new a(n,o,new w,c,f,new w,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new w(t.contents,t.keys,t.overrides).freeze()}}i.Configuration=a;function u(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const c of r)c.keys.forEach(f=>t.add(f)),c.overrides.forEach(([f,d])=>{const E=(0,k.getOrSet)(n,f,new Set);d.forEach(A=>E.add(A))});const o=[];return n.forEach((c,f)=>o.push([f,[...c.values()]])),{keys:[...t.values()],overrides:o}}i.mergeChanges=u;class p{constructor(t,n,o,c){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=c,this._previousConfiguration=void 0;const f=new Set;t.keys.forEach(E=>f.add(E)),t.overrides.forEach(([,E])=>E.forEach(A=>f.add(A))),this.affectedKeys=[...f.values()];const d=new w;this.affectedKeys.forEach(E=>d.setValue(E,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!S.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,L.toValuesTree)({[n]:!0},()=>{}),c;for(;typeof o=="object"&&(c=Object.keys(o)[0]);){if(t=t[c],!t)return!1;o=o[c]}return!0}}i.ConfigurationChangeEvent=p;class h extends p{constructor(t,n,o,c){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=c}}i.AllKeysConfigurationChangeEvent=h;function s(r,t){const{added:n,removed:o,updated:c}=e(t,r),f=[],d=r?.getAllOverrideIdentifiers()||[],E=t?.getAllOverrideIdentifiers()||[];if(t){const A=E.filter(z=>!d.includes(z));for(const z of A)f.push([z,t.getKeysForOverrideIdentifier(z)])}if(r){const A=d.filter(z=>!E.includes(z));for(const z of A)f.push([z,r.getKeysForOverrideIdentifier(z)])}if(t&&r){for(const A of d)if(E.includes(A)){const z=e({contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});f.push([A,[...z.added,...z.removed,...z.updated]])}}return{added:n,removed:o,updated:c,overrides:f}}function e(r,t){const n=r?t?r.keys.filter(f=>t.keys.indexOf(f)===-1):[...r.keys]:[],o=t?r?t.keys.filter(f=>r.keys.indexOf(f)===-1):[...t.keys]:[],c=[];if(r&&t){for(const f of t.keys)if(r.keys.indexOf(f)!==-1){const d=(0,L.getConfigurationValue)(t.contents,f),E=(0,L.getConfigurationValue)(r.contents,f);S.equals(d,E)||c.push(f)}}return{added:n,removed:o,updated:c}}}),define(ee[110],te([0,1,4,3,2,18,22,109,34,29]),function(_,i,R,I,b,D,k,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class L extends b.Disposable{constructor(v,w){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,w)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:P})=>this.onDidDefaultConfigurationChange(P))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,w){const P=typeof v=="string"?v:void 0,g=(0,k.isConfigurationOverrides)(v)?v:(0,k.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(P,g,void 0)}updateValue(v,w,P,g){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const w=this.configuration.toData(),P=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(P,w,1)}onDidDefaultConfigurationChange(v){const w=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,v);this.trigger(P,w,6)}trigger(v,w,P){const g=new S.ConfigurationChangeEvent(v,{data:w},this.configuration);g.source=P,g.sourceConfig=this.getTargetConfiguration(P),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=L}),define(ee[111],te([0,1,14]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteName=i.getRemoteAuthority=void 0;function I(D){return D.scheme===R.Schemas.vscodeRemote?D.authority:void 0}i.getRemoteAuthority=I;function b(D){if(!D)return;const k=D.indexOf("+");return k<0?D:D.substr(0,k)}i.getRemoteName=b}),define(ee[35],te([0,1,25,12,111]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}i.getWorkspaceSupportTypeMessage=D;function k(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}i.isIExtensionIdentifier=k,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(S=i.ExtensionType||(i.ExtensionType={}));var l;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(l=i.TargetPlatform||(i.TargetPlatform={}));class m{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,g){if(typeof P=="undefined"||P===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof P=="string"||typeof g=="string"){let y=typeof P=="string"?P:P.value,a=typeof g=="string"?g:g.value;return R.equalsIgnoreCase(y,a)}return P._lower===g._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}i.ExtensionIdentifier=m;function L(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}i.isLanguagePackExtension=L;function T(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=T;function v(w,P){if(P){const g=`onResolveRemoteAuthority:${(0,b.getRemoteName)(P)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}i.isResolverExtension=v,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[24],te([0,1,25,23,35,10,9,7,32]),function(_,i,R,I,b,D,k,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function m(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,R.compareIgnoreCase)(t.id,n.id)===0}i.areSameExtensions=m;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class T{constructor(n,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=n.id}static create(n){const o=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new T(n.identifier,o,c)}static parse(n){const o=L.exec(n);return o&&o[1]&&o[2]?new T({id:o[1]},o[2],o[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof T?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}i.ExtensionKey=T;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=v.exec(t);return n&&n[1]?[g(n[1]),n[2]]:[g(t),void 0]}i.getIdAndVersion=w;function P(t,n){return`${t}.${n}`}i.getExtensionId=P;function g(t){return t.toLocaleLowerCase()}i.adoptToGalleryExtensionId=g;function y(t,n){return g(P(t,n))}i.getGalleryExtensionId=y;function a(t,n){const o=[],c=f=>{for(const d of o)if(d.some(E=>m(n(E),n(f))))return d;return null};for(const f of t){const d=c(f);d?d.push(f):o.push([f])}return o}i.groupByExtension=a;function u(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=u;function p(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}i.getGalleryExtensionTelemetryData=p,i.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function h(t){const n=new Set;if(t.malicious)for(const o of t.malicious)n.add(o.id);return n}i.getMaliciousExtensionsSet=h;function s(t,n){const o=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const f=c.shift();if(f&&o.every(d=>!m(d.identifier,{id:f}))){const d=t.filter(E=>m(E.identifier,{id:f}));d.length===1&&(o.push(d[0]),c.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}i.getExtensionDependencies=s;async function e(t,n){if(!D.isLinux)return!1;let o;try{o=(await t.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await t.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(f))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=e;async function r(t,n){const o=await e(t,n),c=(0,I.getTargetPlatform)(o?"alpine":D.platform,l.arch);return n.debug("ComputeTargetPlatform:",c),c}i.computeTargetPlatform=r}),define(ee[112],te([0,1,26,7,65,14,33,9,81,23,24,35]),function(_,i,R,I,b,D,k,S,l,m,L,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const v=y=>(0,l.localize)(0,null,y),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");function P(y,a){return a?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let g=class{constructor(a,u){this.extensionManagementService=a,this.extensionGalleryService=u}get location(){}async listExtensions(a,u,p=console){let h=await this.extensionManagementService.getInstalled(1);const s=T.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(u&&u!==""){if(s.indexOf(u.toLowerCase())<0){p.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}h=h.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){p.log("Possible Categories: "),s.forEach(r=>{p.log(r)});return}this.location&&p.log((0,l.localize)(2,null,this.location)),h=h.sort((r,t)=>r.identifier.id.localeCompare(t.identifier.id));let e;for(let r of h)e!==r.identifier.id&&(e=r.identifier.id,p.log(P(r.manifest,a)))}async installExtensions(a,u,p,h,s=console){const e=[],r=[];a.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1),n=(d,E)=>{const A=t.find(z=>(0,L.areSameExtensions)(z.identifier,{id:d}));if(A){if(!h&&(!E||E==="prerelease"&&A.preRelease))return s.log((0,l.localize)(5,null,d,A.manifest.version,d)),!1;if(E&&A.manifest.version===E)return s.log((0,l.localize)(6,null,`${d}@${E}`)),!1}return!0},o=(d,E,A)=>{f.push({id:d,version:E!=="prerelease"?E:void 0,installOptions:{...p,isBuiltin:A,installPreReleaseVersion:E==="prerelease"||p.installPreReleaseVersion}})},c=[],f=[];for(const d of a)if(d instanceof S.URI)c.push(d);else{const[E,A]=(0,L.getIdAndVersion)(d);n(E,A)&&o(E,A,!1)}for(const d of u){const[E,A]=(0,L.getIdAndVersion)(d);n(E,A)&&o(E,A,!0)}if(c.length&&await Promise.all(c.map(async d=>{try{const E=await this.installVSIX(d,{...p,isBuiltin:!1},h,s);E&&r.push(E)}catch(E){s.error(E.message||E.stack||E),e.push(d.toString())}})),f.length){const d=await this.getGalleryExtensions(f);await Promise.all(f.map(async E=>{const A=d.get(E.id.toLowerCase());if(A)try{const z=await this.installFromGallery(E,A,t,h,s);z&&r.push(z)}catch(z){s.error(z.message||z.stack||z),e.push(E.id)}else s.error(`${v(E.version?`${E.id}@${E.version}`:E.id)}
${w}`),e.push(E.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(a,u,p,h){const s=await this.extensionManagementService.getManifest(a);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,p,h))try{return await this.extensionManagementService.install(a,u),h.log((0,l.localize)(8,null,(0,b.getBaseLabel)(a))),s}catch(r){if((0,I.isCancellationError)(r))return h.log((0,l.localize)(9,null,(0,b.getBaseLabel)(a))),null;throw r}return null}async getGalleryExtensions(a){const u=new Map,p=a.some(s=>s.installOptions.installPreReleaseVersion),h=await this.extensionGalleryService.getExtensions(a.map(s=>({...s,preRelease:p})),R.CancellationToken.None);for(const s of h)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:a,version:u,installOptions:p},h,s,e,r){const t=await this.extensionGalleryService.getManifest(h,R.CancellationToken.None);if(t&&!this.validateExtensionKind(t,r))return null;const n=s.find(o=>(0,L.areSameExtensions)(o.identifier,h.identifier));if(n){if(h.version===n.manifest.version)return r.log((0,l.localize)(10,null,u?`${a}@${u}`:a)),null;r.log((0,l.localize)(11,null,a,h.version))}try{return p.isBuiltin?r.log(u?(0,l.localize)(12,null,a,u):(0,l.localize)(13,null,a)):r.log(u?(0,l.localize)(14,null,a,u):(0,l.localize)(15,null,a)),await this.extensionManagementService.installFromGallery(h,{...p,installGivenVersion:!!u}),r.log((0,l.localize)(16,null,a,h.version)),t}catch(o){if((0,I.isCancellationError)(o))return r.log((0,l.localize)(17,null,a)),null;throw o}}validateExtensionKind(a,u){return!0}async validateVSIX(a,u,p){const h={id:(0,L.getGalleryExtensionId)(a.publisher,a.name)},e=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,L.areSameExtensions)(h,r.identifier)&&(0,k.gt)(r.manifest.version,a.version));return e&&!u?(p.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,a.version)),!1):this.validateExtensionKind(a,p)}async uninstallExtensions(a,u,p=console){const h=async e=>{if(e instanceof S.URI){const r=await this.extensionManagementService.getManifest(e);return P(r)}return e},s=[];for(const e of a){const r=await h(e),n=(await this.extensionManagementService.getInstalled()).filter(o=>(0,L.areSameExtensions)(o.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${w}`);if(n.some(o=>o.type===0)){p.log((0,l.localize)(19,null,r));return}if(!u&&n.some(o=>o.isBuiltin)){p.log((0,l.localize)(20,null,r));return}p.log((0,l.localize)(21,null,r));for(const o of n)await this.extensionManagementService.uninstall(o),s.push(o);this.location?p.log((0,l.localize)(22,null,r,this.location)):p.log((0,l.localize)(23,null,r))}}async locateExtension(a,u=console){const p=await this.extensionManagementService.getInstalled();a.forEach(h=>{p.forEach(s=>{if(s.identifier.id===h&&s.location.scheme===D.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(a){return this.location?(0,l.localize)(24,null,a,this.location):(0,l.localize)(25,null,a)}};g=he([ae(0,m.IExtensionManagementService),ae(1,m.IExtensionGalleryService)],g),i.ExtensionManagementCLIService=g}),define(ee[43],te([0,1,17,4,21,16,7,46,73,2,14,11,10,18,33,49,8,9,82,20,24,35,41,15,12,13,27,3,50]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g,y,a,u,p,h,s,e,r,t,n,o,c,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var d;(function(re){function U(W,J){if(W===J)return!0;let G=Object.keys(W),ne=new Set;for(let O of Object.keys(J))ne.add(O);if(G.length!==ne.size)return!1;for(let O of G){if(W[O]!==J[O])return!1;ne.delete(O)}return ne.size===0}re.equals=U})(d=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let E=class extends m.Disposable{constructor(U,W,J,G,ne,O,C,F){super();this.systemExtensionsLocation=U,this.userExtensionsLocation=W,this.extensionsControlLocation=J,this.cacheLocation=G,this.fileService=ne,this.logService=O,this.environmentService=C,this.productService=F,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new Z((0,w.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new Z((0,w.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new z(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(U){const[W,J,G]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(U),this.scanExtensionsUnderDevelopment(U)]);return this.dedupExtensions([...W,...J,...G],await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const W=[];W.push(this.scanDefaultSystemExtensions(!!U.useCache,U.language)),W.push(this.scanDevSystemExtensions(U.language,!!U.checkControlFile));const[J,G]=await Promise.all(W);return this.applyScanOptions([...J,...G],U,!1)}async scanUserExtensions(U){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!U.includeUninstalled,U.language);let G=await(U.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return G=await this.applyScanOptions(G,U,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(U){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const W=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(J=>J.scheme===L.Schemas.file).map(async J=>this.extensionsScanner.scanOneOrMultipleExtensions(await this.createExtensionScannerInput(J,1,!0,U.language))))).flat();return this.applyScanOptions(W,U,!0)}return[]}async scanExistingExtension(U,W,J){const G=await this.createExtensionScannerInput(U,W,!0,J.language),ne=await this.extensionsScanner.scanExtension(G);return!ne||!J.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(U,W,J){const G=await this.createExtensionScannerInput(U,W,!0,J.language),ne=await this.extensionsScanner.scanOneOrMultipleExtensions(G);return this.applyScanOptions(ne,J,!0)}async updateMetadata(U,W){const J=(0,w.joinPath)(U,"package.json"),G=(await this.fileService.readFile(J)).value.toString(),ne=JSON.parse(G);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,ne.__metadata={...ne.__metadata,...W},await this.fileService.writeFile((0,w.joinPath)(U,"package.json"),D.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async applyScanOptions(U,W,J){return W.includeAllVersions||(U=this.dedupExtensions(U,await this.getTargetPlatform(),J)),W.includeInvalid||(U=U.filter(G=>G.isValid)),U.sort((G,ne)=>{const O=T.basename(G.location.fsPath),C=T.basename(ne.location.fsPath);return O<C?-1:O>C?1:0})}dedupExtensions(U,W,J){const G=new Map;for(const ne of U){const O=s.ExtensionIdentifier.toKey(ne.identifier.id),C=G.get(O);if(C){if(C.isValid&&!ne.isValid)continue;if(C.isValid===ne.isValid){if(J&&P.gt(C.manifest.version,ne.manifest.version)){this.logService.debug(`Skipping extension ${ne.location.path} with lower version ${ne.manifest.version}.`);continue}if(P.eq(C.manifest.version,ne.manifest.version)&&C.targetPlatform===W){this.logService.debug(`Skipping extension ${ne.location.path} from different target platform ${ne.targetPlatform}`);continue}}C.type===0?this.logService.debug(`Overwriting system extension ${C.location.path} with ${ne.location.path}.`):this.logService.warn(`Overwriting user extension ${C.location.path} with ${ne.location.path}.`)}G.set(O,ne)}return[...G.values()]}async scanDefaultSystemExtensions(U,W){this.logService.trace("Started scanning system extensions");const J=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,W),ne=await(U&&!J.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(J);return this.logService.trace("Scanned system extensions:",ne.length),ne}async scanDevSystemExtensions(U,W){const J=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!J?.length)return[];this.logService.trace("Started scanning dev system extensions");const G=W?await this.getBuiltInExtensionControl():{},ne=[],O=a.URI.file(T.normalize(T.join(L.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions")));for(const F of J){const x=G[F.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ne.push((0,w.joinPath)(O,F.name));break;default:ne.push(a.URI.file(x));break}}const C=await Promise.all(ne.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,0,!0,U))));return this.logService.trace("Scanned dev system extensions:",C.length),(0,R.coalesce)(C)}async getBuiltInExtensionControl(){try{const U=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(U.value.toString())}catch{return{}}}async createExtensionScannerInput(U,W,J,G){const ne=await this.getTranslations(G??v.language);let O;try{const C=await this.fileService.stat(U);typeof C.mtime=="number"&&(O=C.mtime)}catch{}return new A(U,O,W,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,G,ne)}};E=he([ae(4,r.IFileService),ae(5,n.ILogService),ae(6,p.IEnvironmentService),ae(7,o.IProductService)],E),i.AbstractExtensionsScannerService=E;class A{constructor(U,W,J,G,ne,O,C,F,x,q){this.location=U,this.mtime=W,this.type=J,this.excludeObsolete=G,this.productVersion=ne,this.productDate=O,this.productCommit=C,this.devMode=F,this.language=x,this.translations=q}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,W){return(0,w.isEqual)(U.location,W.location)&&U.mtime===W.mtime&&U.type===W.type&&U.excludeObsolete===W.excludeObsolete&&U.productVersion===W.productVersion&&U.productDate===W.productDate&&U.productCommit===W.productCommit&&U.devMode===W.devMode&&U.language===W.language&&d.equals(U.translations,W.translations)}}class z extends m.Disposable{constructor(U,W){super();this.fileService=U,this.logService=W}async scanExtensions(U){const W=await this.fileService.resolve(U.location);if(W.children){let J={};if(U.excludeObsolete&&U.type===1)try{const ne=(await this.fileService.readFile((0,w.joinPath)(U.location,".obsolete"))).value.toString();J=JSON.parse(ne)}catch{}const G=await Promise.all(W.children.map(async ne=>{if(!ne.isDirectory||U.type===1&&(0,w.basename)(ne.resource).indexOf(".")===0)return null;const O=new A(ne.resource,U.mtime,U.type,U.excludeObsolete,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations),C=await this.scanExtension(O);return C&&!J[h.ExtensionKey.create(C).toString()]?C:null}));return(0,R.coalesce)(G)}return[]}async scanOneOrMultipleExtensions(U){try{if(await this.fileService.exists((0,w.joinPath)(U.location,"package.json"))){const W=await this.scanExtension(U);return W?[W]:[]}else return await this.scanExtensions(U)}catch(W){return this.logService.error(`Error scanning extensions at ${U.location.path}:`,(0,k.getErrorMessage)(W)),[]}}async scanExtension(U){try{let W=await this.scanExtensionManifest(U.location);if(W){W.publisher||(W.publisher=s.UNDEFINED_PUBLISHER);const J=W.__metadata;delete W.__metadata;const G=(0,h.getGalleryExtensionId)(W.publisher,W.name),ne=J?.id?{id:G,uuid:J.id}:{id:G},O=J?.isSystem?0:U.type,C=O===0||!!J?.isBuiltin,F=(0,e.validateExtensionManifest)(U.productVersion,U.productDate,U.location,W,C);let x=!0;for(const[q,$]of F)q===g.default.Error&&(x=!1,this.logService.error(this.formatMessage(U.location,$)));return W=await this.translateManifest(U.location,W,A.createNlsConfiguration(U)),{type:O,identifier:ne,manifest:W,location:U.location,isBuiltin:C,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:x,validations:F}}}catch(W){U.type!==0&&this.logService.error(W)}return null}async scanExtensionManifest(U){const W=(0,w.joinPath)(U,"package.json");let J;try{J=(await this.fileService.readFile(W)).value.toString()}catch(ne){return(0,r.toFileOperationResult)(ne)!==1&&this.logService.error(this.formatMessage(U,(0,u.localize)(0,null,W.path,ne.message))),null}let G;try{G=JSON.parse(J)}catch{const O=[];(0,S.parse)(J,O);for(const C of O)this.logService.error(this.formatMessage(U,(0,u.localize)(1,null,W.path,C.offset,C.length,(0,l.getParseErrorMessage)(C.error))));return null}return(0,S.getNodeType)(G)!=="object"?(this.logService.error(this.formatMessage(U,(0,u.localize)(2,null,W.path))),null):G}async translateManifest(U,W,J){const G=await this.getLocalizedMessages(U,W,J);if(G)try{const ne=[],O=await this.resolveOriginalMessageBundle(G.default,ne);if(ne.length>0)return ne.forEach(F=>{this.logService.error(this.formatMessage(U,(0,u.localize)(3,null,G.default?.path,(0,l.getParseErrorMessage)(F.error))))}),W;if((0,S.getNodeType)(G)!=="object")return this.logService.error(this.formatMessage(U,(0,u.localize)(4,null,G.default?.path))),W;const C=G.values||Object.create(null);this.replaceNLStrings(J.pseudo,W,C,O,U)}catch{}return W}async getLocalizedMessages(U,W,J){const G=(0,w.joinPath)(U,"package.nls.json"),ne=(x,q)=>{q.forEach($=>{this.logService.error(this.formatMessage(U,(0,u.localize)(5,null,x?.path,(0,l.getParseErrorMessage)($.error))))})},O=x=>{this.logService.error(this.formatMessage(U,(0,u.localize)(6,null,x?.path)))},C=`${W.publisher}.${W.name}`,F=J.translations[C];if(F)try{const x=a.URI.file(F),q=(await this.fileService.readFile(x)).value.toString();let $=[],se=(0,S.parse)(q,$);return $.length>0?(ne(x,$),{values:void 0,default:G}):(0,S.getNodeType)(se)!=="object"?(O(x),{values:void 0,default:G}):{values:se.contents?se.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.fileService.exists(G))return;let q;try{q=await this.findMessageBundles(U,J)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const $=(await this.fileService.readFile(q.localized)).value.toString();let se=[],N=(0,S.parse)($,se);return se.length>0?(ne(q.localized,se),{values:void 0,default:q.original}):(0,S.getNodeType)(N)!=="object"?(O(q.localized),{values:void 0,default:q.original}):{values:N,default:q.original}}catch{return{values:void 0,default:q.original}}}}async resolveOriginalMessageBundle(U,W){if(U)try{const J=(await this.fileService.readFile(U)).value.toString();return(0,S.parse)(J,W)}catch{return null}else return null}findMessageBundles(U,W){return new Promise((J,G)=>{const ne=O=>{let C=(0,w.joinPath)(U,`package.nls.${O}.json`);this.fileService.exists(C).then(F=>{F&&J({localized:C,original:(0,w.joinPath)(U,"package.nls.json")});let x=O.lastIndexOf("-");x===-1?J({localized:(0,w.joinPath)(U,"package.nls.json"),original:null}):(O=O.substring(0,x),ne(O))})};if(W.devMode||W.pseudo||!W.language)return J({localized:(0,w.joinPath)(U,"package.nls.json"),original:null});ne(W.language)})}replaceNLStrings(U,W,J,G,ne){const O=(C,F,x)=>{const q=C[F];if((0,y.isString)(q)){const $=q,se=$.length;if(se>1&&$[0]==="%"&&$[se-1]==="%"){const N=$.substr(1,se-2);let M=J[N];M===void 0&&G&&(M=G[N]);let j=typeof M=="string"?M:typeof M?.message=="string"?M.message:void 0;j!==void 0?(U&&(j="\uFF3B"+j.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C[F]=x&&(F==="title"||F==="category")&&G?{value:j,original:G[N]}:j):this.logService.warn(this.formatMessage(ne,(0,u.localize)(7,null,N)))}}else if((0,y.isObject)(q))for(let $ in q)q.hasOwnProperty($)&&($==="commands"?O(q,$,!0):O(q,$,x));else if((0,y.isArray)(q))for(let $=0;$<q.length;$++)O(q,$,x)};for(let C in W)W.hasOwnProperty(C)&&O(W,C)}formatMessage(U,W){return`[${U.path}]: ${W}`}}class Z extends z{constructor(U,W,J){super(W,J);this.cacheFile=U,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(U){const W=await this.readExtensionCache();if(this.input=U,W&&W.input&&A.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(G=>(G.location=a.URI.revive(G.location),G));const J=await super.scanExtensions(U);return await this.writeExtensionCache({input:U,result:J}),J}async readExtensionCache(){try{const U=await this.fileService.readFile(this.cacheFile),W=JSON.parse(U.value.toString());return{result:W.result,input:(0,f.revive)(W.input)}}catch(U){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(U))}return null}async writeExtensionCache(U){try{await this.fileService.writeFile(this.cacheFile,D.VSBuffer.fromString(JSON.stringify(U)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const U=await this.readExtensionCache();if(!U)return;const W=U.result,J=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(J,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(G){this.logService.error(G)}}}function Q(re,U){const W=(0,h.getExtensionId)(re.manifest.publisher,re.manifest.name);return{id:W,identifier:new s.ExtensionIdentifier(W),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:U,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}i.toExtensionDescription=Q;class ie extends E{constructor(U,W,J,G,ne,O,C,F){super(U,W,(0,w.joinPath)(J,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)(G,s.MANIFEST_CACHE_FOLDER),ne,O,C,F);this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const x=await this.fileService.readFile(a.URI.file(v.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(U){return this.translationsPromise}}i.NativeExtensionsScannerService=ie}),define(ee[113],te([0,1,4,7,2,10,18,33,9,31,19,20,23,24,15,13]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let y=class extends b.Disposable{constructor(u,p,h,s){super();this.fileService=p,this.extensionGalleryService=h,this.logService=s,this.extensionsDownloadDir=l.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,p){await this.cleanUpPromise;const h=this.getName(u),s=(0,k.joinPath)(this.extensionsDownloadDir,h);if(!await this.fileService.exists(s)){const e=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(u,e,p);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(e)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,e.path),r}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,p,h){try{await L.Promises.rename(u.fsPath,p.fsPath)}catch(s){if(D.isWindows&&s&&s.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${u} to ${p} with 'EPERM' error. Trying again...`),this.rename(u,p,h);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const p=[],h=[];for(const r of u.children){const t=w.ExtensionKey.parse(r.name);t&&h.push([t,r])}const s=(0,w.groupByExtension)(h,([r])=>r),e=[];for(const r of s)r.sort((t,n)=>S.rcompare(t[0].version,n[0].version)),p.push(...r.slice(1).map(t=>t[1].resource)),e.push(r[0][1]);e.sort((r,t)=>r.mtime-t.mtime),p.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(r=>r.resource)),await R.Promises.settled(p.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?w.ExtensionKey.create(u).toString().toLowerCase():(0,m.generateUuid)()}};y=he([ae(0,T.INativeEnvironmentService),ae(1,P.IFileService),ae(2,v.IExtensionGalleryService),ae(3,g.ILogService)],y),i.ExtensionsDownloader=y}),define(ee[114],te([0,1,2,11,19,35]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class k extends R.Disposable{constructor(l,m){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtensions(L=>this.onDidInstallExtensions(L))),this._register(m.onDidUninstallExtension(L=>this.onDidUnInstallExtension(L)))}onDidInstallExtensions(l){l.some(m=>!!m.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=k}),define(ee[115],te([0,1,9,20,43,15,13,27]),function(_,i,R,I,b,D,k,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let l=class extends b.NativeExtensionsScannerService{constructor(L,T,v,w){super(R.URI.file(v.builtinExtensionsPath),R.URI.file(v.extensionsPath),v.userHome,R.URI.file(v.userDataPath),L,T,v,w)}};l=he([ae(0,D.IFileService),ae(1,k.ILogService),ae(2,I.INativeEnvironmentService),ae(3,S.IProductService)],l),i.ExtensionsScannerService=l}),define(ee[116],te([0,1,141,17,4,2,14,11,19,20,23,24,58,13]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let P=class extends D.Disposable{constructor(a,u,p){super();this.extensionManagementService=a,this.logService=p,this.cache=this._register(new g(u,p)),this.extensionManagementService.registerParticipant({postInstall:async h=>this.postInstallExtension(h),postUninstall:async h=>this.postUninstallExtension(h)})}async getLanguageIds(){const a=await this.cache.getLanguagePacks(),u=["en",...Object.keys(a)];return(0,I.distinct)(u)}async postInstallExtension(a){a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",a.identifier.id),await this.update())}async postUninstallExtension(a){const u=await this.cache.getLanguagePacks();Object.keys(u).some(p=>u[p]&&u[p].extensions.some(h=>(0,T.areSameExtensions)(h.extensionIdentifier,a.identifier)))&&(this.logService.info("Removing language packs from the extension",a.identifier.id),await this.update())}async update(){const[a,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),p=await this.cache.update(u);return!(0,I.equals)(Object.keys(a),Object.keys(p))}};P=he([ae(0,L.IExtensionManagementService),ae(1,m.INativeEnvironmentService),ae(2,w.ILogService)],P),i.LocalizationsService=P;let g=class extends D.Disposable{constructor(a,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(a.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(a){return this.withLanguagePacks(u=>{Object.keys(u).forEach(p=>delete u[p]),this.createLanguagePacksFromExtensions(u,...a)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(a,...u){for(const p of u)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(a,p);Object.keys(a).forEach(p=>this.updateHash(a[p]))}createLanguagePacksFromExtension(a,u){const p=u.identifier,h=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of h)if(u.location.scheme===k.Schemas.file&&(0,v.isValidLocalization)(s)){let e=a[s.languageId];e||(e={hash:"",extensions:[],translations:{}},a[s.languageId]=e);let r=e.extensions.filter(t=>(0,T.areSameExtensions)(t.extensionIdentifier,p))[0];r?r.version=u.manifest.version:e.extensions.push({extensionIdentifier:p,version:u.manifest.version});for(const t of s.translations)e.translations[t.id]=(0,S.join)(u.location.fsPath,t.path)}}updateHash(a){if(a){const u=(0,R.createHash)("md5");for(const p of a.extensions)u.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);a.hash=u.digest("hex")}}withLanguagePacks(a=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(u=a(p),p)).then(p=>{for(const s of Object.keys(p))p[s]||delete p[s];this.languagePacks=p,this.initializedCache=!0;const h=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",h),l.Promises.writeFile(this.languagePacksFilePath,h)}).then(()=>u,p=>this.logService.error(p))})}};g=he([ae(0,m.INativeEnvironmentService),ae(1,w.ILogService)],g)}),define(ee[44],te([0,1,16,89,34,12,29]),function(_,i,R,I,b,D,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,D.createDecorator)("requestService");function S(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}i.isSuccess=S;function l(g){return g.res.statusCode===204}async function m(g){return l(g)?null:(await(0,R.streamToBuffer)(g.stream)).toString()}i.asText=m;async function L(g){if(!S(g))throw new Error("Server returned "+g.res.statusCode);return m(g)}i.asTextOrError=L;async function T(g){if(!S(g))throw new Error("Server returned "+g.res.statusCode);if(l(g))return null;const a=(await(0,R.streamToBuffer)(g.stream)).toString();try{return JSON.parse(a)}catch(u){throw u.message+=`:
`+a,u}}i.asJson=T;function v(g){P(g)}i.updateProxyConfigurationsScope=v;let w;function P(g){const y=k.Registry.as(b.Extensions.Configuration),a=w;w={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[w],remove:a?[a]:[]})}P(2)}),define(ee[117],te([0,1,26,14,15,44]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let k=class{constructor(l,m){this.requestService=l,this.fileService=m}async download(l,m,L=R.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,m);return}const T={type:"GET",url:l.toString()},v=await this.requestService.request(T,L);if(v.res.statusCode===200)await this.fileService.writeFile(m,v.stream);else{const w=await(0,D.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${w}`)}}};k=he([ae(0,D.IRequestService),ae(1,b.IFileService)],k),i.DownloadService=k}),define(ee[118],te([0,1,119,8]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(k,S){return k.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:k.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(k,S,l={}){const m=(0,R.parse)(k),L=l.proxyUrl||b(m,S);if(!L)return null;const T=(0,R.parse)(L);if(!/^https?:$/.test(T.protocol||""))return null;const v={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((w,P)=>{_(["http-proxy-agent"],w,P)}))(v):new(await new Promise((w,P)=>{_(["https-proxy-agent"],w,P)}))(v)}i.getProxyAgent=D}),define(ee[120],te([0,1,40,11,90,26,28,7,10,31,75,142,4]),function(_,i,R,I,b,D,k,S,l,m,L,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const w=1e4;let P;async function g(a,u,p){return u["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(p)&&!u["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(p)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),P||(P=v.Promises.withAsyncBody(async(h,s)=>{const e=new D.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),s(new Error((0,b.localize)(0,null)))},w);try{h(await y(a,e.token))}catch(t){!(0,S.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,b.localize)(1,null,(0,k.toErrorMessage)(t)))):h({})}finally{clearTimeout(r),e.dispose()}})),P)}i.getResolvedShellEnv=g;async function y(a,u){const p=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",p);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",h);const s=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",r);const t=await(0,L.getSystemShell)(l.OS,r);return a.trace("getUnixShellEnvironment#shell",t),new Promise((n,o)=>{if(u.isCancellationRequested)return o((0,S.canceled)());const c=(0,I.basename)(t);let f,d;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(f=`& '${process.execPath}' ${E} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,d=["-Login","-Command"]):(f=`'${process.execPath}' ${E} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?d=["-ic"]:d=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),f);const A=(0,R.spawn)(t,[...d,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(A.kill(),o((0,S.canceled)()))),A.on("error",Q=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),o(Q)});const z=[];A.stdout.on("data",Q=>z.push(Q));const Z=[];A.stderr.on("data",Q=>Z.push(Q)),A.on("close",(Q,ie)=>{const re=Buffer.concat(z).toString("utf8");a.trace("getUnixShellEnvironment#raw",re);const U=Buffer.concat(Z).toString("utf8");if(U.trim()&&a.trace("getUnixShellEnvironment#stderr",U),Q||ie)return o(new Error((0,b.localize)(2,null,Q,ie)));const W=e.exec(re),J=W?W[1]:"{}";try{const G=JSON.parse(J);p?G.ELECTRON_RUN_AS_NODE=p:delete G.ELECTRON_RUN_AS_NODE,h?G.ELECTRON_NO_ATTACH_CONSOLE=h:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",G),n(G)}catch(G){a.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(G)),o(G)}})})}}),define(ee[121],te([0,1,4,3,2,104,8,68,12]),function(_,i,R,I,b,D,k,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var L;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(L=i.WillSaveStateReason||(i.WillSaveStateReason={}));var T;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(T=i.StorageScope||(i.StorageScope={}));var v;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(v=i.StorageTarget||(i.StorageTarget={}));class w extends b.Disposable{constructor(a={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=a,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,u){u===m?(a===0?this._globalKeyTargets=void 0:a===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:a})):this._onDidChangeValue.fire({scope:a,key:u,target:this.getKeyTargets(a)[u]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,u,p){return this.getStorage(u)?.get(a,p)}getBoolean(a,u,p){return this.getStorage(u)?.getBoolean(a,p)}getNumber(a,u,p){return this.getStorage(u)?.getNumber(a,p)}store(a,u,p,h){if((0,k.isUndefinedOrNull)(u)){this.remove(a,p);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,p,h),this.getStorage(p)?.set(a,u)})}remove(a,u){this.withPausedEmitters(()=>{this.updateKeyTarget(a,u,void 0),this.getStorage(u)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,u){const p=[],h=this.getKeyTargets(a);for(const s of Object.keys(h))h[s]===u&&p.push(s);return p}updateKeyTarget(a,u,p){const h=this.getKeyTargets(u);typeof p=="number"?h[a]!==p&&(h[a]=p,this.getStorage(u)?.set(m,JSON.stringify(h))):typeof h[a]=="number"&&(delete h[a],this.getStorage(u)?.set(m,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(a){return a===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(a){const u=this.get(m,a);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(a){return this.getBoolean(i.IS_NEW_KEY,a)===!0}async flush(a=L.NONE){this._onWillSaveState.fire({reason:a});const u=this.getStorage(0),p=this.getStorage(1);switch(a){case L.NONE:await R.Promises.settled([u?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await R.Promises.settled([u?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve()]);break}}async logStorage(){const a=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return g(a,u,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class P extends w{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.globalStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a)))}getStorage(a){return a===0?this.globalStorage:this.workspaceStorage}getLogDetails(a){return a===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(a){}}i.InMemoryStorageService=P;async function g(y,a,u,p){const h=c=>{try{return JSON.parse(c)}catch{return c}},s=new Map,e=new Map;y.forEach((c,f)=>{s.set(f,c),e.set(f,h(c))});const r=new Map,t=new Map;a.forEach((c,f)=>{r.set(f,c),t.set(f,h(c))}),console.group(`Storage: Global (path: ${u})`);let n=[];s.forEach((c,f)=>{n.push({key:f,value:c})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${p})`);let o=[];r.forEach((c,f)=>{o.push({key:f,value:c})}),console.table(o),console.groupEnd(),console.log(t)}i.logStorage=g}),define(ee[122],te([0,1,10,32,9,31]),function(_,i,R,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function k(m){if(R.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function S(m,L,T,v,w,P,g,y,a,u){const p=Object.create(null);p["common.machineId"]=g,p.sessionID=(0,D.generateUuid)()+Date.now(),p.commitHash=w,p.version=P,p["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,R.PlatformToString)(R.platform),p["common.nodePlatform"]=I.platform,p["common.nodeArch"]=v,p["common.product"]=u||"desktop";const h=l(y||[]);h&&(p["common.msftInternal"]=h);let s=0;const e=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),R.isLinuxSnap&&(p["common.snap"]="true");const r=k(T);r&&(p["common.platformDetail"]=r);try{const t=await m.readFile(b.URI.file(a));p["common.source"]=t.value.toString().slice(0,30)}catch{}return p}i.resolveCommonProperties=S;function l(m){const L=I.env.USERDNSDOMAIN;if(!L)return!1;const T=L.toLowerCase();return m.some(v=>T===v)}i.verifyMicrosoftInternalDomain=l}),define(ee[30],te([0,1,12]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,R.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(ee[123],te([0,1,17,4,26,7,3,2,10,9,79,23,24,13,27,30]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let y=class extends S.Disposable{constructor(e,r,t,n){super();this.galleryService=e,this.telemetryService=r,this.logService=t,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,S.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const r=await this.getTargetPlatform();return e.allTargetPlatforms.some(t=>(0,T.isTargetPlatformCompatible)(t,e.allTargetPlatforms,r))}async installFromGallery(e,r={}){try{if(!this.galleryService.isEnabled())throw new T.ExtensionManagementError(L.localize(0,null),T.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(e,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,r)}catch(t){throw p(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(e),error:t}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(t),u(t)}}async uninstall(e,r={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.unininstallExtension(e,r)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(L.localize(1,null));const r=await this.getTargetPlatform(),[t]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:r,compatible:!0},b.CancellationToken.None);if(!t)throw new Error(L.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,r,t){if(!m.URI.isUri(r)){let d=this.installingExtensions.get(v.ExtensionKey.create(r).toString());if(d)return this.logService.info("Extensions is already requested to install",r.identifier.id),d.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],o=[],c=this.createInstallExtensionTask(e,r,t);m.URI.isUri(r)||this.installingExtensions.set(v.ExtensionKey.create(r).toString(),c),this._onInstallExtension.fire({identifier:c.identifier,source:r}),this.logService.info("Installing extension:",c.identifier.id),n.push({task:c,manifest:e});let f=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const E=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,e,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:A,manifest:z}of E){f=f||!!z.extensionDependencies?.some(Q=>(0,v.areSameExtensions)({id:Q},c.identifier));const Z=v.ExtensionKey.create(A).toString();if(this.installingExtensions.has(Z))this.logService.info("Extension is already requested to install",A.identifier.id);else{const Q=this.createInstallExtensionTask(z,A,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(Z,Q),this._onInstallExtension.fire({identifier:Q.identifier,source:A}),this.logService.info("Installing extension:",Q.identifier.id),n.push({task:Q,manifest:z})}}}catch(E){if(m.URI.isUri(c.source))(0,R.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,E.message),(0,R.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,E.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),E}const d=n.reduce((E,{task:A,manifest:z})=>(E.set(A.identifier.id.toLowerCase(),{task:A,manifest:z}),E),new Map);for(;d.size;){let E;const A=[...d.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(Z=>d.has(Z.toLowerCase())));A.length?E=d.size===1?A:A.filter(({task:z})=>!(z===c&&!f)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:z})=>z.identifier.id)),E=[...d.values()]),await this.joinAllSettled(E.map(async({task:z})=>{const Z=new Date().getTime();try{const Q=await z.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(Q,z.source,t,b.CancellationToken.None))),!m.URI.isUri(z.source)){const ie=z.operation===3;if(p(this.telemetryService,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(z.source),duration:new Date().getTime()-Z,durationSinceUpdate:ie?void 0:new Date().getTime()-z.source.lastUpdated}),l.isWeb&&z.operation!==3)try{await this.galleryService.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}o.push({local:Q,identifier:z.identifier,operation:z.operation,source:z.source})}catch(Q){throw m.URI.isUri(z.source)||p(this.telemetryService,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(z.source),duration:new Date().getTime()-Z,error:Q}),this.logService.error("Error while installing the extension:",z.identifier.id),Q}finally{d.delete(z.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:E})=>this.logService.info("Extension installed successfully:",E.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:E})=>(0,v.areSameExtensions)(E,c.identifier))[0].local}catch(d){if(n.forEach(({task:E})=>E.cancel()),o.length)try{const E=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<E.length;A++){const z=E[A],{identifier:Z}=o[A];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Z.id):this.logService.warn("Rollback: Error while uninstalling extension",Z.id,(0,D.getErrorMessage)(z.reason))}}catch(E){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(E),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(n.map(({task:E})=>({identifier:E.identifier,operation:2,source:E.source}))),d}finally{for(const{task:d}of n)if(!m.URI.isUri(d.source)){const E=v.ExtensionKey.create(d.source).toString();this.installingExtensions.delete(E)||this.logService.warn("Installation task is not found in the cache",E)}}}async joinAllSettled(e){const r=[],t=[],n=await Promise.allSettled(e);for(const o of n)o.status==="fulfilled"?r.push(o.value):t.push(o.reason);if(t.length)throw a(t);return r}async getAllDepsAndPackExtensionsToInstall(e,r,t,n){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[e,...o.map(E=>E.identifier)],f=[],d=async(E,A)=>{const z=A.extensionDependencies||[],Z=[...z];if(A.extensionPack){const Q=t?o.find(ie=>(0,v.areSameExtensions)(ie.identifier,E)):void 0;for(const ie of A.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(re=>(0,v.areSameExtensions)({id:re},{id:ie}))||Z.every(re=>!(0,v.areSameExtensions)({id:re},{id:ie}))&&Z.push(ie)}if(Z.length){const Q=[...c,...f.map(re=>re.gallery.identifier)],ie=Z.filter(re=>Q.every(U=>!(0,v.areSameExtensions)(U,{id:re})));if(ie.length){const re=await this.galleryService.getExtensions(ie.map(U=>({id:U,preRelease:n})),b.CancellationToken.None);for(const U of re){if(Q.find(G=>(0,v.areSameExtensions)(G,U.identifier)))continue;const W=z.some(G=>(0,v.areSameExtensions)({id:G},U.identifier));let J;try{J=await this.checkAndGetCompatibleVersion(U,!0,n)}catch(G){if(G instanceof T.ExtensionManagementError&&G.code===T.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",U.identifier.id);continue}else throw G}f.push({gallery:J.extension,manifest:J.manifest}),await d(J.extension.identifier,J.manifest)}}}};return await d(e,r),o=await this.getInstalled(),f.filter(E=>!o.some(A=>(0,v.areSameExtensions)(A.identifier,E.gallery.identifier)))}async checkAndGetCompatibleVersion(e,r,t){const n=await this.getExtensionsControlManifest();if((0,v.getMaliciousExtensionsSet)(n).has(e.identifier.id))throw new T.ExtensionManagementError(L.localize(3,null,e.identifier.id),T.ExtensionManagementErrorCode.Malicious);if(!!n.unsupportedPreReleaseExtensions&&!!n.unsupportedPreReleaseExtensions[e.identifier.id])throw new T.ExtensionManagementError(L.localize(4,null,e.identifier.id,n.unsupportedPreReleaseExtensions[e.identifier.id].displayName),T.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(e)){const f=await this.getTargetPlatform();throw new T.ExtensionManagementError(L.localize(5,null,e.identifier.id,this.productService.nameLong,(0,T.TargetPlatformToString)(f)),T.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(e,r,t);if(o){if(t&&r&&e.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new T.ExtensionManagementError(L.localize(6,null,e.identifier.id,this.productService.nameLong,this.productService.version),T.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],b.CancellationToken.None))[0]?new T.ExtensionManagementError(L.localize(7,null,e.identifier.id),T.ExtensionManagementErrorCode.ReleaseVersionNotFound):new T.ExtensionManagementError(L.localize(8,null,e.identifier.id,this.productService.nameLong,this.productService.version),T.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,b.CancellationToken.None);if(c===null)throw new T.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,T.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new T.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,T.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(e,r,t){const n=await this.getTargetPlatform();let o=null;return r&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==t&&(o=(await this.galleryService.getExtensions([{...e.identifier,preRelease:t}],{targetPlatform:n,compatible:!0},b.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(e,t,n)&&(o=e),!o&&r&&(o=await this.galleryService.getCompatibleExtension(e,t,n)),o}async unininstallExtension(e,r){const t=this.uninstallingExtensions.get(e.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),t.waitUntilTaskIsFinished();const n=(d,E)=>{const A=this.createUninstallExtensionTask(d,E);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",d.identifier.id),this._onUninstallExtension.fire(d.identifier),A},o=(d,E)=>{E?this.logService.error("Failed to uninstall extension:",d.identifier.id,E.message):this.logService.info("Successfully uninstalled extension:",d.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(d),error:E}),this._onDidUninstallExtension.fire({identifier:d.identifier,error:E?.code})},c=[],f=[];try{c.push(n(e,{}));const d=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",e.identifier.id);else{const E=this.getAllPackExtensionsToUninstall(e,d);for(const A of E)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):c.push(n(A,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",e.identifier.id):this.checkForDependents(c.map(E=>E.extension),d,e),await this.joinAllSettled(c.map(async E=>{try{if(await E.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(E.extension,r,b.CancellationToken.None))),E.extension.identifier.uuid)try{await this.galleryService.reportStatistic(E.extension.manifest.publisher,E.extension.manifest.name,E.extension.manifest.version,"uninstall")}catch{}o(E.extension)}catch(A){const z=A instanceof T.ExtensionManagementError?A:new T.ExtensionManagementError((0,D.getErrorMessage)(A),T.ExtensionManagementErrorCode.Internal);throw o(E.extension,z),z}finally{f.push(E)}}))}catch(d){const E=d instanceof T.ExtensionManagementError?d:new T.ExtensionManagementError((0,D.getErrorMessage)(d),T.ExtensionManagementErrorCode.Internal);for(const A of c){try{A.cancel()}catch{}f.includes(A)||o(A.extension,E)}throw E}finally{for(const d of c)this.uninstallingExtensions.delete(d.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",d.extension.identifier.id)}}checkForDependents(e,r,t){for(const n of e){const o=this.getDependents(n,r);if(o.length){const c=o.filter(f=>!e.some(d=>(0,v.areSameExtensions)(d.identifier,f.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(n,c,t))}}}getDependentsErrorMessage(e,r,t){return t===e?r.length===1?L.localize(9,null,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?L.localize(10,null,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):L.localize(11,null,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?L.localize(12,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?L.localize(13,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):L.localize(14,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(e,r,t=[]){if(t.indexOf(e)!==-1)return[];t.push(e);const n=e.manifest.extensionPack?e.manifest.extensionPack:[];if(n.length){const o=r.filter(f=>!f.isBuiltin&&n.some(d=>(0,v.areSameExtensions)({id:d},f.identifier))),c=[];for(const f of o)c.push(...this.getAllPackExtensionsToUninstall(f,r,t));return[...o,...c]}return[]}getDependents(e,r){return r.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(n=>(0,v.areSameExtensions)({id:n},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};y=he([ae(0,T.IExtensionGalleryService),ae(1,g.ITelemetryService),ae(2,w.ILogService),ae(3,P.IProductService)],y),i.AbstractExtensionManagementService=y;function a(s){const e=Array.isArray(s)?s:[s];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((r,t)=>new Error(`${r.message}${r.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=a;function u(s){if(s instanceof T.ExtensionManagementError)return s;const e=new T.ExtensionManagementError(s.message,T.ExtensionManagementErrorCode.Internal);return e.stack=s.stack,e}function p(s,e,{extensionData:r,duration:t,error:n,durationSinceUpdate:o}){const c=n?n instanceof T.ExtensionManagementError?n.code:T.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(e,{...r,success:!n,duration:t,errorcode:c,durationSinceUpdate:o})}i.reportTelemetry=p;class h{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>new Promise((r,t)=>{const n=e.onCancellationRequested(()=>{n.dispose(),t(new D.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=h}),define(ee[36],te([0,1,21,48,8,22,30]),function(_,i,R,I,b,D,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(p,h){return Promise.resolve(void 0)}publicLog2(p,h){return this.publicLog(p,h)}publicLogError(p,h){return Promise.resolve(void 0)}publicLogError2(p,h){return this.publicLogError(p,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=S,i.NullTelemetryService=new S;class l{async publicLog(p,h,s){}async publicLogError(p,h,s){}}i.NullEndpointTelemetryService=l,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,p){return p.onDidChangeConfiguration(h=>{h.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(h.source),configurationKeys:g(h.sourceConfig)})})}i.configurationTelemetry=m;function L(u,p){return!(p.disableTelemetry||!u.enableTelemetry||p.extensionTestsLocationURI)}i.supportsTelemetry=L;function T(u){const p=u.getValue(k.TELEMETRY_SETTING_ID),h=u.getValue("telemetry.enableCrashReporter");if(u.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=T;function v(u){const p=Object.create(null),h=Object.create(null),s=Object.create(null);P(u,s);for(let e in s){e=e.length>150?e.substr(e.length-149):e;const r=s[e];typeof r=="number"?h[e]=r:typeof r=="boolean"?h[e]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${e} has been trimmed to 8192, the original length is ${r.length}`),p[e]=r.substring(0,8191)):typeof r!="undefined"&&r!==null&&(p[e]=r)}return{properties:p,measurements:h}}i.validateTelemetryData=v;function w(u){if(!u)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(s=>{u.indexOf(`${s}+`)===0&&(p=s)}),p}i.cleanRemoteAuthority=w;function P(u,p,h=0,s){if(!!u)for(let e of Object.getOwnPropertyNames(u)){const r=u[e],t=s?s+e:e;Array.isArray(r)?p[t]=(0,R.safeStringify)(r):r instanceof Date?p[t]=r.toISOString():(0,b.isObject)(r)?h<2?P(r,p,h+1,t+"."):p[t]=(0,R.safeStringify)(r):p[t]=r}}function g(u){if(!u)return[];const p=[];return y(p,"",u),p}function y(u,p,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(s=>y(u,p?`${p}.${s}`:s,h[s])):u.push(p)}function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}i.getPiiPathsFromEnvironment=a}),define(ee[124],te([0,1,94,36]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function b(D,k,S,l,m,L){const T={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${k.nameShort})`},v=await(0,R.getServiceMachineId)(S,m,L);return(0,I.supportsTelemetry)(k,S)&&(0,I.getTelemetryLevel)(l)===3&&(T["X-Market-User-Id"]=v),T}i.resolveMarketplaceHeaders=b}),define(ee[125],te([0,1,17,26,7,21,10,32,8,9,22,20,23,24,41,15,13,27,44,124,121,30]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g,y,a,u,p,h,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const e=k.isWeb?"web":(0,v.getTargetPlatform)(k.platform,S.arch);var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...N){return String(N.reduce((M,j)=>M|j,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class E{constructor(M=d){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,j=this.state.pageSize){return new E({...this.state,pageNumber:M,pageSize:j})}withFilter(M,...j){const B=[...this.state.criteria,...j.length?j.map(K=>({filterType:M,value:K})):[{filterType:M}]];return new E({...this.state,criteria:B})}withSortBy(M){return new E({...this.state,sortBy:M})}withSortOrder(M){return new E({...this.state,sortOrder:M})}withFlags(...M){return new E({...this.state,flags:M.reduce((j,B)=>j|B,0)})}withAssetTypes(...M){return new E({...this.state,assetTypes:M})}withSource(M){return new E({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:j,pageSize:B,sortBy:K,sortOrder:Y,flags:oe,assetTypes:ce}=this.state;return{filters:[{criteria:M,pageNumber:j,pageSize:B,sortBy:K,sortOrder:Y}],assetTypes:ce,flags:oe}}get searchText(){const M=this.state.criteria.filter(j=>j.filterType===n.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source}}}function A(N,M){const j=(N||[]).filter(B=>B.statisticName===M)[0];return j?j.value:0}function z(N){const M="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(B=>B.assetType.indexOf(M)===0).reduce((B,K)=>{const Y=ie(N,K.assetType);return Y&&B.push([K.assetType.substring(M.length),Y]),B},[])}function Z(N){if(N.properties){const M=N.properties.filter(K=>K.key===o.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=M.filter(K=>j.test(K.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return ie(N,o.Repository)}function Q(N){return{uri:`${N.fallbackAssetUri}/${o.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${o.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ie(N,M){return N.files.filter(B=>B.assetType===M)[0]?{uri:`${N.assetUri}/${M}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${M}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function re(N,M){const j=N.properties?N.properties.filter(K=>K.key===M):[],B=j.length>0&&j[0].value;return B?B.split(",").map(K=>(0,w.adoptToGalleryExtensionId)(K)):[]}function U(N){const M=N.properties?N.properties.filter(j=>j.key===c.Engine):[];return M.length>0&&M[0].value||""}function W(N){const M=N.properties?N.properties.filter(j=>j.key===c.PreRelease):[];return M.length>0&&M[0].value==="true"}function J(N){const M=N.properties?N.properties.filter(B=>B.key===c.LocalizedLanguages):[],j=M.length>0&&M[0].value||"";return j?j.split(","):[]}function G(N){return N.indexOf("preview")!==-1}function ne(N){return N.targetPlatform?(0,v.toTargetPlatform)(N.targetPlatform):"undefined"}function O(N){const M=(0,R.distinct)(N.versions.map(ne)),j=!!N.tags?.includes(v.WEB_EXTENSION_TAG),B=M.indexOf("web");return j?B===-1&&M.push("web"):B!==-1&&M.splice(B,1),M}function C(N,M){const j=(0,v.getFallbackTargetPlarforms)(M);for(let B=0;B<N.length;B++){const K=N[B];if(K.version===N[B-1]?.version){let Y=B;const oe=ne(K);if(oe===M)for(;Y>0&&N[Y-1].version===K.version;)Y--;else if(j.includes(oe))for(;Y>0&&N[Y-1].version===K.version&&ne(N[Y-1])!==M;)Y--;Y!==B&&(N.splice(B,1),N.splice(Y,0,K))}}return N}i.sortExtensionVersions=C;function F(N,M,j){N.telemetryData={index:M,querySource:j}}function x(N,M,j){const B=N.versions[0],K={manifest:ie(M,o.Manifest),readme:ie(M,o.Details),changelog:ie(M,o.Changelog),license:ie(M,o.License),repository:Z(M),download:Q(M),icon:ie(M,o.Icon),coreTranslations:z(M)};return{identifier:{id:(0,w.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:M.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:A(N.statistics,"install"),rating:A(N.statistics,"averagerating"),ratingCount:A(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:j,assets:K,properties:{dependencies:re(M,c.Dependency),extensionPack:re(M,c.ExtensionPack),engine:U(M),localizedLanguages:J(M),targetPlatform:ne(M),isPreReleaseVersion:W(M)},hasPreReleaseVersion:W(B),hasReleaseVersion:!0,preview:G(N.flags)}}let q=class{constructor(M,j,B,K,Y,oe,ce,de){this.requestService=j,this.logService=B,this.environmentService=K,this.telemetryService=Y,this.fileService=oe,this.productService=ce,this.configurationService=de;const ve=ce.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,M)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,j,B){const K=I.CancellationToken.isCancellationToken(j)?{}:j,Y=I.CancellationToken.isCancellationToken(j)?j:B,oe=[],ce=[],de=[],ve=[];let le=!0;for(const ge of M){ge.uuid?ce.push(ge.uuid):oe.push(ge.id);const Ee=!!(ge.version||ge.preRelease);de.push({id:ge.id,uuid:ge.uuid,includePreRelease:Ee}),ge.version&&ve.push({id:ge.id,uuid:ge.uuid,version:ge.version}),le=le&&!!ge.hasPreRelease&&!Ee}if(!ce.length&&!oe.length)return[];let ue=new E().withPage(1,M.length);ce.length&&(ue=ue.withFilter(n.ExtensionId,...ce)),oe.length&&(ue=ue.withFilter(n.ExtensionName,...oe)),(K.queryAllVersions||le)&&(ue=ue.withFlags(ue.flags,r.IncludeVersions)),K.source&&(ue=ue.withSource(K.source));const{extensions:ye}=await this.queryGalleryExtensions(ue,{targetPlatform:K.targetPlatform??e,includePreRelease:de,versions:ve,compatible:!!K.compatible},Y);return K.source&&ye.forEach((ge,Ee)=>F(ge,Ee,K.source)),ye}async getCompatibleExtension(M,j,B){if((0,v.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(M,j,B))return M;const K=new E().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,M.identifier.uuid),{extensions:Y}=await this.queryGalleryExtensions(K,{targetPlatform:B,compatible:!0,includePreRelease:j},I.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(M,j,B){if(!(0,v.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,B)||!j&&M.properties.isPreReleaseVersion)return!1;let K=M.properties.engine;if(!K){const Y=await this.getManifest(M,I.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");K=Y.engines.vscode}return(0,P.isEngineValid)(K,this.productService.version,this.productService.date)}async isValidVersion(M,j,B,K,Y){if(!(0,v.isTargetPlatformCompatible)(ne(M),K,Y)||j!=="any"&&W(M)!==(j==="prerelease"))return!1;if(B){const oe=await this.getEngine(M);if(!(0,P.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}return!0}async query(M,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=M.text||"";const K=(0,D.getOrDefault)(M,le=>le.pageSize,50);let Y=new E().withPage(1,K);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ue,ye)=>(Y=Y.withFilter(n.Category,ye||ue),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ue,ye)=>(Y=Y.withFilter(n.Tag,ye||ue),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),Y=Y.withFilter(n.SearchText,B)),Y=Y.withSortBy(0)):M.ids?Y=Y.withFilter(n.ExtensionId,...M.ids):M.names?Y=Y.withFilter(n.ExtensionName,...M.names):Y=Y.withSortBy(4),typeof M.sortBy=="number"&&(Y=Y.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(Y=Y.withSortOrder(M.sortOrder)),M.source&&(Y=Y.withSource(M.source));const oe=async(le,ue)=>{const{extensions:ye,total:ge}=await this.queryGalleryExtensions(le,{targetPlatform:e,compatible:!1,includePreRelease:!!M.includePreRelease},ue);return ye.forEach((Ee,Fe)=>F(Ee,(le.pageNumber-1)*le.pageSize+Fe,M.source)),{extensions:ye,total:ge}},{extensions:ce,total:de}=await oe(Y,j),ve=async(le,ue)=>{if(ue.isCancellationRequested)throw new b.CancellationError;const{extensions:ye}=await oe(Y.withPage(le+1),ue);return ye};return{firstPage:ce,total:de,pageSize:Y.pageSize,getPage:ve}}async queryGalleryExtensions(M,j,B){const K=M.flags;!!(M.flags&r.IncludeLatestVersionOnly)&&!!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(M.flags&r.IncludeLatestVersionOnly)&&!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags,r.IncludeLatestVersionOnly)),j.versions?.length&&(M=M.withFlags(M.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),M=M.withFlags(M.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:Y,total:oe}=await this.queryRawGalleryExtensions(M,B);if(!(M.flags&r.IncludeLatestVersionOnly)){const le=[];for(const ue of Y){const ye=await this.toGalleryExtensionWithCriteria(ue,j);ye&&le.push(ye)}return{extensions:le,total:oe}}const de=[],ve=new Map;for(let le=0;le<Y.length;le++){const ue=Y[le],ye={id:(0,w.getGalleryExtensionId)(ue.publisher.publisherName,ue.extensionName),uuid:ue.extensionId},ge=(0,l.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Fe=>(0,w.areSameExtensions)(Fe,ye))?.includePreRelease;if(j.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(O(ue),j.targetPlatform))continue;const Ee=await this.toGalleryExtensionWithCriteria(ue,j);!Ee||Ee.properties.isPreReleaseVersion&&(!ge||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==j.targetPlatform&&Ee.hasPreReleaseVersion?ve.set(ue.extensionId,le):de.push([le,Ee])}if(ve.size){const le=new Date().getTime(),ue=new E().withFlags(K&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,ve.size).withFilter(n.ExtensionId,...ve.keys()),{extensions:ye}=await this.queryGalleryExtensions(ue,j,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const ge of ye){const Ee=ve.get(ge.identifier.uuid);de.push([Ee,ge])}}return{extensions:de.sort((le,ue)=>le[0]-ue[0]).map(([,le])=>le),total:oe}}async toGalleryExtensionWithCriteria(M,j){const B={id:(0,w.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},K=j.versions?.find(de=>(0,w.areSameExtensions)(de,B))?.version,Y=(0,l.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(de=>(0,w.areSameExtensions)(de,B))?.includePreRelease,oe=O(M),ce=C(M.versions,j.targetPlatform);if(j.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(oe,j.targetPlatform))return null;for(let de=0;de<ce.length;de++){const ve=ce[de];if(!(K&&ve.version!==K)){if(await this.isValidVersion(ve,Y?"any":"release",j.compatible,oe,j.targetPlatform))return x(M,ve,oe);if(K&&ve.version===K)return null}}return K||j.compatible?null:x(M,M.versions[0],oe)}async queryRawGalleryExtensions(M,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,t(r.Unpublished));const B=await this.commonHeadersPromise,K=JSON.stringify(M.raw),Y={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},oe=new Date().getTime();let ce,de,ve=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:K,headers:Y},j),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,u.asJson)(ce);if(le){const ue=le.results[0],ye=ue.extensions,ge=ue.resultMetadata&&ue.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ve=ge&&ge.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw de=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(K.length),duration:new Date().getTime()-oe,success:!!ce&&(0,u.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:de?(0,b.isCancellationError)(de)?"canceled":(0,b.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(M,j,B,K){if(!this.isEnabled())return;const Y=k.isWeb?this.api(`/itemName/${M}.${j}/version/${B}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${j}/${B}/stats?statType=${K}`),oe=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:Y,headers:de},I.CancellationToken.None)}catch{}}async download(M,j,B){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const K=(0,w.getGalleryExtensionTelemetryData)(M),Y=new Date().getTime(),oe=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:le}),ce=B===2?"install":B===3?"update":"",de=ce?{uri:`${M.assets.download.uri}${m.URI.parse(M.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${M.assets.download.fallbackUri}${m.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:M.assets.download,ve=await this.getAsset(de);await this.fileService.writeFile(j,ve.stream),oe(new Date().getTime()-Y)}async getReadme(M,j){if(M.assets.readme){const B=await this.getAsset(M.assets.readme,{},j);return await(0,u.asTextOrError)(B)||""}return""}async getManifest(M,j){if(M.assets.manifest){const B=await this.getAsset(M.assets.manifest,{},j),K=await(0,u.asTextOrError)(B);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(M,j){const B=ie(M,o.Manifest);if(!B)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Y=await this.getAsset(B,{headers:K});return await(0,u.asJson)(Y)}async getCoreTranslation(M,j){const B=M.assets.coreTranslations.filter(K=>K[0]===j.toUpperCase())[0];if(B){const K=await this.getAsset(B[1]),Y=await(0,u.asTextOrError)(K);return Y?JSON.parse(Y):null}return null}async getChangelog(M,j){if(M.assets.changelog){const B=await this.getAsset(M.assets.changelog,{},j);return await(0,u.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(M,j,B){let K=new E().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?K=K.withFilter(n.ExtensionId,M.identifier.uuid):K=K.withFilter(n.ExtensionName,M.identifier.id);const{galleryExtensions:Y}=await this.queryRawGalleryExtensions(K,I.CancellationToken.None);if(!Y.length)return[];const oe=O(Y[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(oe,B))return[];const ce=[];await Promise.all(Y[0].versions.map(async le=>{try{await this.isValidVersion(le,j?"any":"release",!0,oe,B)&&ce.push(le)}catch{}}));const de=[],ve=new Set;for(const le of C(ce,B))ve.has(le.version)||(ve.add(le.version),de.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:W(le)}));return de}async getAsset(M,j={},B=I.CancellationToken.None){const K=await this.commonHeadersPromise,Y={type:"GET"},oe={...K,...j.headers||{}};j={...j,...Y,headers:oe};const ce=M.uri,de=M.fallbackUri,ve={...j,url:ce};try{const le=await this.requestService.request(ve,B);if(le.res.statusCode===200)return le;const ue=await(0,u.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ue}`)}catch(le){if((0,b.isCancellationError)(le))throw le;const ue=(0,b.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:ue});const ye={...j,url:de};return this.requestService.request(ye,B)}}async getEngine(M){let j=U(M);if(!j){const B=await this.getManifestFromRawExtensionVersion(M,I.CancellationToken.None);if(!B)throw new Error("Manifest was not found");j=B.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,u.asJson)(M),B=[],K={};if(j){for(const Y of j.malicious)B.push({id:Y});if(j.unsupported)for(const Y of Object.keys(j.unsupported)){const oe=j.unsupported[Y];(0,l.isBoolean)(oe)||(K[Y.toLowerCase()]=oe.preReleaseExtension)}if(j.migrateToPreRelease)for(const[Y,oe]of Object.entries(j.migrateToPreRelease))(!oe.engine||(0,P.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(K[Y.toLowerCase()]=oe)}return{malicious:B,unsupportedPreReleaseExtensions:K}}};q=he([ae(1,u.IRequestService),ae(2,y.ILogService),ae(3,T.IEnvironmentService),ae(4,s.ITelemetryService),ae(5,g.IFileService),ae(6,a.IProductService),ae(7,L.IConfigurationService)],q);let $=class extends q{constructor(M,j,B,K,Y,oe,ce,de){super(M,j,B,K,Y,oe,ce,de)}};$=he([ae(0,h.IStorageService),ae(1,u.IRequestService),ae(2,y.ILogService),ae(3,T.IEnvironmentService),ae(4,s.ITelemetryService),ae(5,g.IFileService),ae(6,a.IProductService),ae(7,L.IConfigurationService)],$),i.ExtensionGalleryService=$;let se=class extends q{constructor(M,j,B,K,Y,oe,ce){super(void 0,M,j,B,K,Y,oe,ce)}};se=he([ae(0,u.IRequestService),ae(1,y.ILogService),ae(2,T.IEnvironmentService),ae(3,s.ITelemetryService),ae(4,g.IFileService),ae(5,a.IProductService),ae(6,L.IConfigurationService)],se),i.ExtensionGalleryServiceWithNoStorageService=se}),define(ee[126],te([0,1,2,21,48,10,25,91,22,34,127,27,29,30,36]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let g=class{constructor(u,p,h){this._configurationService=p,this._productService=h,this._experimentProperties={},this.telemetryLevel=new b.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,p){this._experimentProperties[u]=p}_updateTelemetryLevel(){let u=(0,P.getTelemetryLevel)(this._configurationService);const p=this._productService.enabledTelemetryLevels;if(p){this._sendErrorTelemetry=this.sendErrorTelemetry?p.error:!1;const h=p.usage?3:p.error?2:0;u=Math.min(u,h)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties;let p=u.sessionID,h=u["common.machineId"],s=u["common.firstSessionDate"],e=u["common.msftInternal"];return{sessionId:p,machineId:h,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(u,p,h,s){return this.telemetryLevel.value<p?Promise.resolve(void 0):this._commonProperties.then(e=>{h=(0,I.mixin)(h,e),h=(0,I.mixin)(h,this._experimentProperties),h=(0,I.cloneAndChange)(h,r=>{if(typeof r=="string")return this._cleanupInfo(r,s)}),this._appenders.forEach(r=>r.log(u,h))},e=>{console.error(e)})}publicLog(u,p,h){return this._log(u,3,p,h)}publicLog2(u,p,h){return this.publicLog(u,p,h)}publicLogError(u,p){return this._sendErrorTelemetry?this._log(u,2,p,!0):Promise.resolve(void 0)}publicLogError2(u,p){return this.publicLogError(u,p)}_anonymizeFilePaths(u){let p=u;const h=[];for(let t of this._cleanupPatterns)for(;;){const n=t.exec(u);if(!n)break;h.push([n.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(p="";;){const t=e.exec(u);if(!t)break;!s.test(t[0])&&h.every(([n,o])=>t.index<n||t.index>=o)&&(p+=u.substring(r,t.index)+"<REDACTED: user-file-path>",r=e.lastIndex)}return r<u.length&&(p+=u.substr(r)),p}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const p=u.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of h)if(s.regex.test(p))return`<REDACTED: ${s.label}`;return u}_cleanupInfo(u,p){let h=u;p&&(h=this._anonymizeFilePaths(h));for(let s of this._cleanupPatterns)h=h.replace(s,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=he([ae(1,l.IConfigurationService),ae(2,T.IProductService)],g),i.TelemetryService=g;function y(){const a=(0,S.localize)(0,null,L.default.nameLong),u=L.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",L.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=D.isWeb?"":(0,S.localize)(3,null),h=(0,S.localize)(4,null),s=(0,S.localize)(5,null),e=(0,S.localize)(6,null),r=(0,S.localize)(7,null),t=`
|       | ${h} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,S.localize)(8,null);return`
${a} ${u} ${p}

&nbsp;

${r}
${t}

&nbsp;

${n}
`}v.Registry.as(m.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(m.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:L.default.privacyStatementUrl?(0,S.localize)(16,null,L.default.nameLong,L.default.privacyStatementUrl):(0,S.localize)(15,null,L.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[128],te([0,1,7,21,36]),function(_,i,R,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function D(S){const l=await new Promise((L,T)=>{_(["applicationinsights"],L,T)});let m;return l.defaultClient?(m=new l.TelemetryClient(S),m.channel.setUseDiskRetryCaching(!0)):(l.setup(S).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),m=l.defaultClient),S.indexOf("AIF-")===0&&(m.config.endpointUrl="https://0.0.0.0/collect/v1"),m}class k{constructor(l,m,L){this._eventPrefix=l,this._defaultData=m,this._defaultData||(this._defaultData=Object.create(null)),typeof L=="function"?this._aiClient=L():this._aiClient=L,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient)),this._asyncAIClient.then(m=>{l(m)},m=>{(0,R.onUnexpectedError)(m),console.error(m)})}}log(l,m){if(!!this._aiClient){m=(0,I.mixin)(m,this._defaultData),m=(0,b.validateTelemetryData)(m);try{this._withAIClient(L=>L.trackEvent({name:this._eventPrefix+"/"+l,properties:m.properties,measurements:m.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(m=>{try{m.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=k}),define(ee[129],te([0,1,11,19]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(D,k){const S=Object.create(null),l=(L,T)=>{const v=JSON.parse(L);S[T]=v};if(k){const L=[],T=await I.Promises.readdir(k);for(const w of T)try{(await I.Promises.stat((0,R.join)(k,w))).isDirectory()&&L.push(w)}catch{}const v=[];for(const w of L)(await I.Promises.readdir((0,R.join)(k,w))).filter(g=>g==="telemetry.json").length===1&&v.push(w);for(const w of v){const P=(await I.Promises.readFile((0,R.join)(k,w,"telemetry.json"))).toString();l(P,w)}}let m=(await I.Promises.readFile((0,R.join)(D,"telemetry-core.json"))).toString();return l(m,"vscode-core"),m=(await I.Promises.readFile((0,R.join)(D,"telemetry-extensions.json"))).toString(),l(m,"vscode-extensions"),JSON.stringify(S,null,4)}i.buildTelemetryMessage=b}),define(ee[37],te([0,1,12]),function(_,i,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ee[130],te([0,1,3,2,9,20,24,15,13,37]),function(_,i,R,I,b,D,k,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let L=class extends I.Disposable{constructor(v,w,P,g,y){super();this.extensionsManagementService=v,this.logService=g,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(u=>this.onInstallExtension(u))),this._register(v.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(v.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const a=b.URI.file(P.extensionsPath);this._register(w.watch(a)),this._register(R.Event.filter(w.onDidFilesChange,u=>u.rawChanges.some(p=>this.doesChangeAffects(p,a)))(()=>this.onDidChange()))}doesChangeAffects(v,w){return v.type!==1&&v.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),w)?!1:this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(v.resource).startsWith(".")}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const w of v)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(w=>!(0,k.areSameExtensions)(w,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,k.areSameExtensions)(w,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),w=v.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,k.areSameExtensions)(y,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),P=this.installedExtensions.filter(g=>this.installingExtensions.some(y=>(0,k.areSameExtensions)(y,g))?!1:v.every(y=>!(0,k.areSameExtensions)(y.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=v.map(g=>g.identifier),(w.length||P.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:P})}}};L=he([ae(1,S.IFileService),ae(2,D.INativeEnvironmentService),ae(3,l.ILogService),ae(4,m.IUriIdentityService)],L),i.ExtensionsWatcher=L}),define(ee[131],te([0,1,37,95,15,18,62,3,2]),function(_,i,R,I,b,D,k,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class m{constructor(v){this.uri=v,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let L=class{constructor(v){this._fileService=v,this._dispooables=new l.DisposableStore,this._limit=2**16;const w=new Map,P=g=>{let y=w.get(g.scheme);return y===void 0&&(y=v.hasProvider(g)&&!this._fileService.hasCapability(g,1024),w.set(g.scheme,y)),y};this._dispooables.add(S.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new D.ExtUri(P),this._canonicalUris=new k.SkipList((g,y)=>this.extUri.compare(g,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,D.normalizePath)(v));let w=this._canonicalUris.get(v);return w?w.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new m(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((P,g)=>P[1].touch<g[1].touch?1:P[1].touch>g[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let P=0;P<w;P++)this._canonicalUris.set(v[P][0],v[P][1].touch())}};L=he([ae(0,b.IFileService)],L),i.UriIdentityService=L,(0,I.registerSingleton)(R.IUriIdentityService,L,!0)}),define(ee[60],te([0,1,106,4,11,8,19,77,143,144]),function(_,i,R,I,b,D,k,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class L extends Error{constructor(e,r){let t=r.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=e,this.cause=r}}i.ExtractError=L;function T(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,t)=>r+t,e&61440)}function v(s){if(s instanceof L)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new L(e,s)}function w(s,e,r,t,n,o){const c=b.dirname(e),f=b.join(t,c);if(!f.startsWith(t))return Promise.reject(new Error(S.localize(0,null,e)));const d=b.join(t,e);let E;return o.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(k.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((A,z)=>{if(!o.isCancellationRequested)try{E=(0,R.createWriteStream)(d,{mode:r}),E.once("close",()=>A()),E.once("error",z),s.once("error",z),s.pipe(E)}catch(Z){z(Z)}}))}function P(s,e,r,t){let n=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((c,f)=>{const d=new I.Sequencer,E=A=>{A.isCancellationRequested||(o++,s.readEntry())};s.once("error",f),s.once("close",()=>n.then(()=>{t.isCancellationRequested||s.entryCount===o?c():f(new L("Incomplete",new Error(S.localize(1,null,o,s.entryCount))))},f)),s.readEntry(),s.on("entry",A=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){E(t);return}const z=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(z)){const ie=b.join(e,z);n=(0,I.createCancelablePromise)(re=>k.Promises.mkdir(ie,{recursive:!0}).then(()=>E(re)).then(void 0,f));return}const Z=y(s,A),Q=T(A);n=(0,I.createCancelablePromise)(ie=>d.queue(()=>Z.then(re=>w(re,z,Q,e,r,ie).then(()=>E(ie)))).then(null,f))})})}function g(s,e=!1){return new Promise((r,t)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(n,o)=>{n?t(v(n)):r((0,D.assertIsDefined)(o))})})}function y(s,e){return new Promise((r,t)=>{s.openReadStream(e,(n,o)=>{n?t(v(n)):r((0,D.assertIsDefined)(o))})})}function a(s,e){return new Promise((r,t)=>{const n=new m.ZipFile;e.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const o=(0,R.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(s))})}i.zip=a;function u(s,e,r={},t){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=g(s,!0);return r.overwrite&&(o=o.then(c=>k.Promises.rm(e).then(()=>c))),o.then(c=>P(c,e,{sourcePathRegex:n},t))}i.extract=u;function p(s,e){return g(s).then(r=>new Promise((t,n)=>{r.on("entry",o=>{o.fileName===e&&y(r,o).then(c=>t(c),c=>n(c))}),r.once("close",()=>n(new Error(S.localize(2,null,e))))}))}function h(s,e){return p(s,e).then(r=>new Promise((t,n)=>{const o=[];r.once("error",n),r.on("data",c=>o.push(c)),r.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=h}),define(ee[132],te([0,1,60,84]),function(_,i,R,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(D){return(0,R.buffer)(D,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}i.getManifest=b}),define(ee[133],te([0,1,4,28,7,2,14,11,10,18,33,8,9,31,19,60,83,54,20,123,23,24,43,113,101,132,114,130,41,15,12,13,27,30,37]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g,y,a,u,p,h,s,e,r,t,n,o,c,f,d,E,A,z,Z,Q){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let ie=class extends p.AbstractExtensionManagementService{constructor(O,C,F,x,q,$,se,N,M){super(O,C,F,N);this.environmentService=x,this.downloadService=q,this.fileService=se;const j=this._register($.createInstance(t.ExtensionsLifecycle));this.extensionsScanner=this._register($.createInstance(re,K=>j.postUninstall(K))),this.manifestCache=this._register(new o.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register($.createInstance(r.ExtensionsDownloader));const B=this._register(new c.ExtensionsWatcher(this,se,x,F,M));this._register(B.onDidChangeExtensionsByAnotherSource(({added:K,removed:Y})=>{K.length&&this._onDidInstallExtensions.fire(K.map(oe=>({identifier:oe.identifier,operation:1,local:oe}))),Y.forEach(oe=>this._onDidUninstallExtension.fire({identifier:oe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(O){this.logService.trace("ExtensionManagementService#zip",O.identifier.id);const C=await this.collectFiles(O),F=await(0,g.zip)((0,m.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)()).fsPath,C);return v.URI.file(F)}async unzip(O){return this.logService.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const C=await this.downloadVsix(O),F=S.resolve(C.fsPath);return(0,n.getManifest)(F)}getInstalled(O=null){return this.extensionsScanner.scanExtensions(O)}async install(O,C={}){this.logService.trace("ExtensionManagementService#install",O.toString());const F=await this.downloadVsix(O),x=await(0,n.getManifest)(S.resolve(F.fsPath));if(x.engines&&x.engines.vscode&&!(0,f.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,s.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,F,C)}async updateMetadata(O,C){this.logService.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const F={...C};return C.isPreReleaseVersion&&(F.preRelease=!0),O=await this.extensionsScanner.updateMetadata(O,F),this.manifestCache.invalidate(),O}async updateExtensionScope(O,C){return this.logService.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.extensionsScanner.updateMetadata(O,{isMachineScoped:C}),this.manifestCache.invalidate(),O}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(O){if(O.scheme===k.Schemas.file)return O;const C=(0,m.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)());return await this.downloadService.download(O,C),C}createInstallExtensionTask(O,C,F){return v.URI.isUri(C)?new J(O,C,F,this.galleryService,this.extensionsScanner,this.logService):new W(C,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(O,C){return new G(O,C,this.extensionsScanner)}async collectFiles(O){const C=async x=>{let q=await P.Promises.readdir(x);q=q.map(N=>S.join(x,N));const $=await Promise.all(q.map(N=>P.Promises.stat(N)));let se=Promise.resolve([]);return $.forEach((N,M)=>{const j=q[M];N.isFile()&&(se=se.then(B=>[...B,j])),N.isDirectory()&&(se=se.then(B=>C(j).then(K=>[...B,...K])))}),se};return(await C(O.location.fsPath)).map(x=>({path:`extension/${S.relative(O.location.fsPath,x)}`,localPath:x}))}};ie=he([ae(0,h.IExtensionGalleryService),ae(1,Z.ITelemetryService),ae(2,A.ILogService),ae(3,u.INativeEnvironmentService),ae(4,a.IDownloadService),ae(5,E.IInstantiationService),ae(6,d.IFileService),ae(7,z.IProductService),ae(8,Q.IUriIdentityService)],ie),i.ExtensionManagementService=ie;let re=class extends D.Disposable{constructor(O,C,F,x){super();this.beforeRemovingExtension=O,this.fileService=C,this.extensionsScannerService=F,this.logService=x,this.uninstalledPath=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(O){const C={includeInvalid:!0};let F=[];return O===null||O===0?F.push(...await this.extensionsScannerService.scanAllExtensions(C)):O===1&&F.push(...await this.extensionsScannerService.scanUserExtensions(C)),F=O!==null?F.filter(x=>x.type===O):F,Promise.all(F.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(O){const C=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(C.map(F=>this.toLocalExtension(F)))}async extractUserExtension(O,C,F,x){const q=O.toString(),$=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),se=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await P.Promises.rm(se)}catch{throw new h.ExtensionManagementError(y.localize(1,null,se,O.id),h.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(O,C,$,x),await this.extensionsScannerService.updateMetadata(v.URI.file($),{...F,installedTimestamp:Date.now()});try{await this.rename(O,$,se,Date.now()+2*60*1e3),this.logService.info("Renamed to",se)}catch(N){try{await P.Promises.rm($)}catch{}if(N.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(N)}. Deleted from extracted location`,$),N}return this.scanLocalExtension(v.URI.file(se),1)}async updateMetadata(O,C){return await this.extensionsScannerService.updateMetadata(O.location,C),this.scanLocalExtension(O.location,O.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...O){const C=O.map(F=>s.ExtensionKey.create(F));await this.withUninstalledExtensions(F=>{C.forEach(x=>F[x.toString()]=!0)})}async setInstalled(O){await this.withUninstalledExtensions(x=>delete x[O.toString()]);const F=(await this.scanUserExtensions(!0)).find(x=>s.ExtensionKey.create(x).equals(O))||null;return F?this.updateMetadata(F,{installedTimestamp:Date.now()}):null}async removeExtension(O,C){this.logService.trace(`Deleting ${C} extension from disk`,O.identifier.id,O.location.fsPath),await P.Promises.rm(O.location.fsPath),this.logService.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[s.ExtensionKey.create(O).toString()])}async withUninstalledExtensions(O){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await P.Promises.readFile(this.uninstalledPath,"utf8")}catch(x){if(x.code!=="ENOENT")throw x}let F={};if(C)try{F=JSON.parse(C)}catch{}return O&&(O(F),Object.keys(F).length?await P.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await P.Promises.rm(this.uninstalledPath)),F})}async extractAtLocation(O,C,F,x){this.logService.trace(`Started extracting the extension from ${C} to ${F}`);try{await P.Promises.rm(F)}catch(q){throw new h.ExtensionManagementError(this.joinErrors(q).message,h.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(C,F,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${F}:`,O.id)}catch(q){try{await P.Promises.rm(F)}catch{}let $=h.ExtensionManagementErrorCode.Extract;throw q instanceof g.ExtractError&&(q.type==="CorruptZip"?$=h.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&($=h.ExtensionManagementErrorCode.IncompleteZip)),new h.ExtensionManagementError(q.message,$)}}async rename(O,C,F,x){try{await P.Promises.rename(C,F)}catch(q){if(l.isWindows&&q&&q.code==="EPERM"&&Date.now()<x)return this.logService.info(`Failed renaming ${C} to ${F} with 'EPERM' error. Trying again...`,O.id),this.rename(O,C,F,x);throw new h.ExtensionManagementError(q.message||y.localize(2,null,C,F),q.code||h.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(O,C){const F=await this.extensionsScannerService.scanExistingExtension(O,C,{includeInvalid:!0});if(F)return this.toLocalExtension(F);throw new Error(y.localize(3,null,O.path))}async toLocalExtension(O){const C=await this.fileService.resolve(O.location);let F,x;return C.children&&(F=C.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,x=C.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:F,changelogUrl:x,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async removeUninstalledExtensions(){const O=await this.getUninstalledExtensions(),C=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const $ of C)O[s.ExtensionKey.create($).toString()]||F.add($.identifier.id.toLowerCase());const x=(0,s.groupByExtension)(C,$=>$.identifier);await R.Promises.settled(x.map(async $=>{const se=$.sort((N,M)=>L.rcompare(N.manifest.version,M.manifest.version))[0];F.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(se))}));const q=C.filter($=>O[s.ExtensionKey.create($).toString()]);await R.Promises.settled(q.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const O=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=[],F=await this.extensionsScannerService.getTargetPlatform(),x=(0,s.groupByExtension)(O,q=>q.identifier);C.push(...x.map(q=>q.sort(($,se)=>{const N=L.rcompare($.manifest.version,se.manifest.version);return N!==0?N:$.targetPlatform===F?-1:1}).slice(1)).flat()),await R.Promises.settled(C.map(q=>this.removeExtension(q,"outdated")))}joinErrors(O){const C=Array.isArray(O)?O:[O];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((F,x)=>new Error(`${F.message}${F.message?",":""}${x instanceof Error?x.message:x}`),new Error(""))}};re=he([ae(1,d.IFileService),ae(2,e.IExtensionsScannerService),ae(3,A.ILogService)],re);class U extends p.AbstractExtensionTask{constructor(O,C,F,x,q){super();this.identifier=O,this.source=C,this.options=F,this.extensionsScanner=x,this.logService=q,this._operation=2}get operation(){return(0,T.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(O,C){try{const F=await this.unsetUninstalledAndGetLocal(O.key);if(F)return O.metadata?this.extensionsScanner.updateMetadata(F,O.metadata):F}catch{throw l.isMacintosh?new h.ExtensionManagementError(y.localize(4,null),h.ExtensionManagementErrorCode.Internal):new h.ExtensionManagementError(y.localize(5,null),h.ExtensionManagementErrorCode.Internal)}return this.extract(O,C)}async unsetUninstalledAndGetLocal(O){if(!await this.isUninstalled(O))return null;this.logService.trace("Removing the extension from uninstalled list:",O.id);const F=await this.extensionsScanner.setInstalled(O);return this.logService.info("Removed the extension from uninstalled list:",O.id),F}async isUninstalled(O){return!!(await this.extensionsScanner.getUninstalledExtensions())[O.toString()]}async extract({zipPath:O,key:C,metadata:F},x){let q=await this.extensionsScanner.extractUserExtension(C,O,F,x);return this.logService.info("Extracting completed.",C.id),q}}class W extends U{constructor(O,C,F,x,q){super(O.identifier,O,C,x,q);this.gallery=O,this.extensionsDownloader=F}async doRun(O){const F=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,s.areSameExtensions)(q.identifier,this.gallery.identifier));F&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin,x.metadata.isSystem=F?.type===0?!0:void 0,x.metadata.updated=!!F,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,T.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:F?.preRelease);try{const q=await this.installExtension(x,O);return F&&(F.targetPlatform!==q.targetPlatform||L.neq(F.manifest.version,q.manifest.version))&&await this.extensionsScanner.setUninstalled(F),q}catch(q){throw await this.deleteDownloadedVSIX(x.zipPath),q}}async deleteDownloadedVSIX(O){try{await this.extensionsDownloader.delete(v.URI.file(O))}catch(C){this.logService.warn("Error while deleting the downloaded vsix",O.toString(),(0,b.getErrorMessage)(C))}}async downloadInstallableExtension(O,C){const F={id:O.identifier.uuid,publisherId:O.publisherId,publisherDisplayName:O.publisherDisplayName,targetPlatform:O.properties.targetPlatform};let x;try{this.logService.trace("Started downloading extension:",O.identifier.id),x=(await this.extensionsDownloader.downloadExtension(O,C)).fsPath,this.logService.info("Downloaded extension:",O.identifier.id,x)}catch(q){throw new h.ExtensionManagementError((0,p.joinErrors)(q).message,h.ExtensionManagementErrorCode.Download)}try{return await(0,n.getManifest)(x),{zipPath:x,key:s.ExtensionKey.create(O),metadata:F}}catch(q){throw await this.deleteDownloadedVSIX(x),new h.ExtensionManagementError((0,p.joinErrors)(q).message,h.ExtensionManagementErrorCode.Invalid)}}}class J extends U{constructor(O,C,F,x,q,$){super({id:(0,s.getGalleryExtensionId)(O.publisher,O.name)},C,F,q,$);this.manifest=O,this.location=C,this.galleryService=x}async doRun(O){const C=new s.ExtensionKey(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find($=>(0,s.areSameExtensions)(this.identifier,$.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,O);if(q.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,C.equals(new s.ExtensionKey(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else L.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const $=await this.unsetUninstalledAndGetLocal(C);if($)try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),key:C,metadata:q},O)}async getMetadata(O,C,F){try{let[x]=await this.galleryService.getExtensions([{id:O,version:C}],F);if(x||([x]=await this.galleryService.getExtensions([{id:O}],F)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class G extends p.AbstractExtensionTask{constructor(O,C,F){super();this.extension=O,this.options=C,this.extensionsScanner=F}async doRun(O){const C=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=s.ExtensionKey.create(this.extension);C.push(...F.filter(q=>x.equals(s.ExtensionKey.create(q))))}else C.push(...F.filter(x=>(0,s.areSameExtensions)(x.identifier,this.extension.identifier)));if(!C.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...C),this.options.remove)for(const x of C)try{O.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(q){throw new Error(y.localize(9,null,(0,I.toErrorMessage)(q)))}}}}),define(ee[134],te([0,1,119,4,16,7,2,8,22,20,120,13,118,145]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let P=class extends k.Disposable{constructor(y,a,u){super();this.environmentService=a,this.logService=u,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,a){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:u,strictSSL:p}=this;let h;try{h=await(0,L.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...h},e=y.agent?y.agent:await(0,v.getProxyAgent)(y.url||"",s,{proxyUrl:u,strictSSL:p});y.agent=e,y.strictSSL=p,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(y,a);return this.logService.trace("RequestService#request (node) - success",y.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",y.url,r),r}}async getNodeRequest(y){return((0,R.parse)(y.url).protocol==="https:"?await new Promise((p,h)=>{_(["https"],p,h)}):await new Promise((p,h)=>{_(["http"],p,h)})).request}_request(y,a){return I.Promises.withAsyncBody(async(u,p)=>{let h;const s=(0,R.parse)(y.url),e=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),r={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,S.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(r.auth=y.user+":"+y.password),h=e(r,t=>{const n=(0,S.isNumber)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)this._request({...y,url:t.headers.location,followRedirects:n-1},a).then(u,p);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,w.createGunzip)())),u({res:t,stream:(0,b.streamToBufferReadableStream)(o)})}}),h.on("error",p),y.timeout&&h.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&h.write(y.data),h.end(),a.onCancellationRequested(()=>{h.abort(),p((0,D.canceled)())})})}async resolveProxy(y){}};P=he([ae(0,l.IConfigurationService),ae(1,m.INativeEnvironmentService),ae(2,T.ILogService)],P),i.RequestService=P}),define(ee[146],te([0,1,39,4,16,28,7,2,14,11,32,18,9,19,22,110,54,117,20,93,125,23,112,43,133,115,15,103,105,42,100,57,58,116,13,107,127,27,44,134,122,30,126,36,128,129,37,131]),function(_,i,R,I,b,D,k,S,l,m,L,T,v,w,P,g,y,a,u,p,h,s,e,r,t,n,o,c,f,d,E,A,z,Z,Q,ie,re,U,W,J,G,ne,O,C,F,x,q,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class se extends S.Disposable{constructor(j){super();this.argv=j,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[j,B]=await this.initServices();return j.invokeFunction(async K=>{const Y=K.get(Q.ILogService),oe=K.get(o.IFileService),ce=K.get(u.INativeEnvironmentService),de=K.get(s.IExtensionManagementCLIService);Y.info("CLI main",this.argv),this.registerErrorHandler(Y),await this.doRun(ce,de,oe),await Promise.all(B.map(ve=>{(0,I.raceTimeout)(ve.flush(),1e3)}))})}async initServices(){const j=new A.ServiceCollection,B={_serviceBrand:void 0,...re.default};j.set(U.IProductService,B);const K=new p.NativeEnvironmentService(this.argv,B);j.set(u.INativeEnvironmentService,K),await Promise.all([K.appSettingsHome.fsPath,K.extensionsPath].map(ye=>ye?w.Promises.mkdir(ye,{recursive:!0}):void 0));const Y=(0,Q.getLogLevel)(K),oe=[];oe.push(new ie.SpdLogLogger("cli",(0,m.join)(K.logsPath,"cli.log"),!0,!1,Y)),Y===Q.LogLevel.Trace&&oe.push(new Q.ConsoleLogger(Y));const ce=this._register(new Q.MultiplexLogService(oe));j.set(Q.ILogService,ce);const de=this._register(new c.FileService(ce));j.set(o.IFileService,de);const ve=this._register(new f.DiskFileSystemProvider(ce));de.registerProvider(l.Schemas.file,ve);const le=this._register(new g.ConfigurationService(K.settingsResource,de));j.set(P.IConfigurationService,le),await le.initialize(),j.set(q.IUriIdentityService,new $.UriIdentityService(de)),j.set(W.IRequestService,new d.SyncDescriptor(J.RequestService)),j.set(y.IDownloadService,new d.SyncDescriptor(a.DownloadService)),j.set(r.IExtensionsScannerService,new d.SyncDescriptor(n.ExtensionsScannerService)),j.set(s.IExtensionManagementService,new d.SyncDescriptor(t.ExtensionManagementService)),j.set(s.IExtensionGalleryService,new d.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService)),j.set(s.IExtensionManagementCLIService,new d.SyncDescriptor(e.ExtensionManagementCLIService)),j.set(z.ILocalizationsService,new d.SyncDescriptor(Z.LocalizationsService));const ue=[];if((0,C.supportsTelemetry)(B,K)){B.aiConfig&&B.aiConfig.asimovKey&&ue.push(new F.AppInsightsAppender("monacoworkbench",null,B.aiConfig.asimovKey));const{installSourcePath:ye}=K,ge={appenders:ue,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ee;try{const Fe=await w.Promises.readFile((0,T.joinPath)(K.globalStorageHome,"storage.json").fsPath);Ee=JSON.parse(Fe.toString())[ne.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&ce.error(Fe)}return(0,G.resolveCommonProperties)(de,(0,R.release)(),(0,R.hostname)(),process.arch,B.commit,B.version,Ee,B.msftInternalDomains,ye)})(),piiPaths:(0,C.getPiiPathsFromEnvironment)(K)};j.set(ne.ITelemetryService,new d.SyncDescriptor(O.TelemetryService,[ge]))}else j.set(ne.ITelemetryService,C.NullTelemetryService);return[new E.InstantiationService(j),ue]}registerErrorHandler(j){(0,k.setUnexpectedErrorHandler)(B=>{const K=(0,D.toErrorMessage)(B,!0);!K||j.error(`[uncaught exception in CLI]: ${K}`)}),process.on("uncaughtException",B=>(0,k.onUnexpectedError)(B)),process.on("unhandledRejection",B=>(0,k.onUnexpectedError)(B))}async doRun(j,B,K){if(this.argv["install-source"])return this.setInstallSource(j,K,this.argv["install-source"]);if(this.argv["list-extensions"])return B.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Y={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return B.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],Y,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return B.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return B.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(j.appRoot,j.extensionsPath))}}asExtensionIdOrVSIX(j){return j.map(B=>/\.vsix$/i.test(B)?v.URI.file((0,m.isAbsolute)(B)?B:(0,m.join)((0,L.cwd)(),B)):B)}async setInstallSource(j,B,K){await B.writeFile(v.URI.file(j.installSourcePath),b.VSBuffer.fromString(K.slice(0,30)))}}async function N(M){const j=new se(M);try{await j.run()}finally{j.dispose()}}i.main=N})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c3511e6c69bb39013c4a4b7b9566ec1ca73fc4d5/core/vs/code/node/cliProcessMain.js.map
