/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/glob","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","child_process","vs/platform/files/common/files","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/shared/dataTransfer","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/environment/node/userDataPath","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookProxyKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","path","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(Y){for(var e=[],d=0,i=Y.length;d<i;d++)e[d]=ye[Y[d]];return e};define(ye[56],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(i,_){if(!i)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=d}),define(ye[76],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function d(k){return k?k.replace(/\$\((.*?)\)/g,(y,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=d;class i{constructor(y,w,P){this.id=y,this.definition=w,this.description=P,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function _(k,y){const w=["codicon","codicon-"+k];return y&&w.push("codicon-modifier-"+y),w}e.getClassNamesArray=_;var A;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function w(I){if(I instanceof i)return["codicon","codicon-"+I.id];const D=y.exec(I.id);if(!D)return w(i.error);let[,T,C]=D;const m=["codicon","codicon-"+T];return C&&m.push("codicon-modifier-"+C.substr(1)),m}k.asClassNameArray=w;function P(I){return w(I).join(" ")}k.asClassName=P;function L(I){return"."+w(I).join(".")}k.asCSSSelector=L})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ye[57],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function i(L){const I=[];for(let D in L)d.call(L,D)&&I.push(L[D]);return I}e.values=i;function _(L,I){for(let D in L)if(d.call(L,D)&&I({key:D,value:L[D]},function(){delete L[D]})===!1)return}e.forEach=_;function A(L,I){const D=Object.create(null);for(const T of L){const C=I(T);let m=D[C];m||(m=D[C]=[]),m.push(T)}return D}e.groupBy=A;function k(L){const I=Object.create(null);return L&&L.forEach((D,T)=>{I[T]=D}),I}e.fromMap=k;function y(L,I){const D=[],T=[];for(let C of L)I.has(C)||D.push(C);for(let C of I)L.has(C)||T.push(C);return{removed:D,added:T}}e.diffSets=y;function w(L,I){const D=[],T=[];for(let[C,m]of L)I.has(C)||D.push(m);for(let[C,m]of I)L.has(C)||T.push(m);return{removed:D,added:T}}e.diffMaps=w;class P{constructor(){this.map=new Map}add(I,D){let T=this.map.get(I);T||(T=new Set,this.map.set(I,T)),T.add(D)}delete(I,D){const T=this.map.get(I);!T||(T.delete(D),T.size===0&&this.map.delete(I))}forEach(I,D){const T=this.map.get(I);!T||T.forEach(D)}}e.SetMap=P}),define(ye[58],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(k){return(y,w,P)=>{let L=null,I=null;if(typeof P.value=="function"?(L="value",I=P.value):typeof P.get=="function"&&(L="get",I=P.get),!I)throw new Error("not supported");P[L]=k(I,w)}}e.createDecorator=d;function i(k,y,w){let P=null,L=null;if(typeof w.value=="function"?(P="value",L=w.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(P="get",L=w.get),!L)throw new Error("not supported");const I=`$memoize$${y}`;w[P]=function(...D){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,D)}),this[I]}}e.memoize=i;function _(k,y,w){return d((P,L)=>{const I=`$debounce$${L}`,D=`$debounce$result$${L}`;return function(...T){this[D]||(this[D]=w?w():void 0),clearTimeout(this[I]),y&&(this[D]=y(this[D],...T),T=[this[D]]),this[I]=setTimeout(()=>{P.apply(this,T),this[D]=w?w():void 0},k)}})}e.debounce=_;function A(k,y,w){return d((P,L)=>{const I=`$throttle$timer$${L}`,D=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...m){if(this[D]||(this[D]=w?w():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),y&&(this[D]=y(this[D],...m)),this[C])return;const v=this[T]+k;v<=Date.now()?(this[T]=Date.now(),P.apply(this,[this[D]]),this[D]=w?w():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[T]=Date.now(),P.apply(this,[this[D]]),this[D]=w?w():void 0},v-Date.now()))}})}e.throttle=A}),define(ye[11],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class d{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(E=>{E(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=d,e.errorHandler=new d;function i(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=i;function _(h){w(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=_;function A(h){w(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=A;function k(h){if(h instanceof Error){let{name:o,message:E}=h;const r=h.stacktrace||h.stack;return{$isError:!0,name:o,message:E,stack:r}}return h}e.transformErrorForSerialization=k;const y="Canceled";function w(h){return h instanceof P?!0:h instanceof Error&&h.name===y&&h.message===y}e.isCancellationError=w;class P extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=P;function L(){const h=new Error(y);return h.name=h.message,h}e.canceled=L;function I(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=I;function D(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=D;function T(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function C(h){const o=new Error(`${h} has been disposed`);return o.name="DISPOSED",o}e.disposed=C;function m(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=m;class v extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=v;class g extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=g;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;class f extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(o){if(o&&o instanceof f)return o;if(o&&o instanceof Error){const E=new f;return E.name=o.name,E.message=o.message,E.stack=o.stack,E}return new f(o)}}e.ErrorNoTelemetry=f;class l extends Error{constructor(o){super(o);Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(ye[16],De([0,1,11]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(X,ce=0){return X[X.length-(1+ce)]}e.tail=i;function _(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=_;function A(X,ce,pe=(Ie,Re)=>Ie===Re){if(X===ce)return!0;if(!X||!ce||X.length!==ce.length)return!1;for(let Ie=0,Re=X.length;Ie<Re;Ie++)if(!pe(X[Ie],ce[Ie]))return!1;return!0}e.equals=A;function k(X,ce,pe){let Ie=0,Re=X.length-1;for(;Ie<=Re;){const Ce=(Ie+Re)/2|0,ke=pe(X[Ce],ce);if(ke<0)Ie=Ce+1;else if(ke>0)Re=Ce-1;else return Ce}return-(Ie+1)}e.binarySearch=k;function y(X,ce){let pe=0,Ie=X.length;if(Ie===0)return 0;for(;pe<Ie;){const Re=Math.floor((pe+Ie)/2);ce(X[Re])?Ie=Re:pe=Re+1}return pe}e.findFirstInSorted=y;function w(X,ce,pe){if(X=X|0,X>=ce.length)throw new TypeError("invalid index");let Ie=ce[Math.floor(ce.length*Math.random())],Re=[],Ce=[],ke=[];for(let Ae of ce){const ue=pe(Ae,Ie);ue<0?Re.push(Ae):ue>0?Ce.push(Ae):ke.push(Ae)}return X<Re.length?w(X,Re,pe):X<Re.length+ke.length?ke[0]:w(X-(Re.length+ke.length),Ce,pe)}e.quickSelect=w;function P(X,ce){const pe=[];let Ie;for(const Re of X.slice(0).sort(ce))!Ie||ce(Ie[0],Re)!==0?(Ie=[Re],pe.push(Ie)):Ie.push(Re);return pe}e.groupBy=P;function L(X,ce,pe){const Ie=[];function Re(Ae,ue,ve){if(ue===0&&ve.length===0)return;const ie=Ie[Ie.length-1];ie&&ie.start+ie.deleteCount===Ae?(ie.deleteCount+=ue,ie.toInsert.push(...ve)):Ie.push({start:Ae,deleteCount:ue,toInsert:ve})}let Ce=0,ke=0;for(;;){if(Ce===X.length){Re(Ce,0,ce.slice(ke));break}if(ke===ce.length){Re(Ce,X.length-Ce,[]);break}const Ae=X[Ce],ue=ce[ke],ve=pe(Ae,ue);ve===0?(Ce+=1,ke+=1):ve<0?(Re(Ce,1,[]),Ce+=1):ve>0&&(Re(Ce,0,[ue]),ke+=1)}return Ie}e.sortedDiff=L;function I(X,ce,pe){const Ie=L(X,ce,pe),Re=[],Ce=[];for(const ke of Ie)Re.push(...X.slice(ke.start,ke.start+ke.deleteCount)),Ce.push(...ke.toInsert);return{removed:Re,added:Ce}}e.delta=I;function D(X,ce,pe){if(pe===0)return[];const Ie=X.slice(0,pe).sort(ce);return C(X,ce,Ie,pe,X.length),Ie}e.top=D;function T(X,ce,pe,Ie,Re){return pe===0?Promise.resolve([]):new Promise((Ce,ke)=>{(async()=>{const Ae=X.length,ue=X.slice(0,pe).sort(ce);for(let ve=pe,ie=Math.min(pe+Ie,Ae);ve<Ae;ve=ie,ie=Math.min(ie+Ie,Ae)){if(ve>pe&&await new Promise(oe=>setTimeout(oe)),Re&&Re.isCancellationRequested)throw new d.CancellationError;C(X,ce,ue,ve,ie)}return ue})().then(Ce,ke)})}e.topAsync=T;function C(X,ce,pe,Ie,Re){for(const Ce=pe.length;Ie<Re;Ie++){const ke=X[Ie];if(ce(ke,pe[Ce-1])<0){pe.pop();const Ae=y(pe,ue=>ce(ke,ue)<0);pe.splice(Ae,0,ke)}}}function m(X){return X.filter(ce=>!!ce)}e.coalesce=m;function v(X){let ce=0;for(let pe=0;pe<X.length;pe++)X[pe]&&(X[ce]=X[pe],ce+=1);X.length=ce}e.coalesceInPlace=v;function g(X,ce,pe){X.splice(pe,0,X.splice(ce,1)[0])}e.move=g;function b(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=b;function f(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=f;function l(X,ce=pe=>pe){const pe=new Set;return X.filter(Ie=>{const Re=ce(Ie);return pe.has(Re)?!1:(pe.add(Re),!0)})}e.distinct=l;function h(X){const ce=new Set;return pe=>{const Ie=X(pe);return ce.has(Ie)?!1:(ce.add(Ie),!0)}}e.uniqueFilter=h;function o(X,ce){const pe=E(X,ce);if(pe!==-1)return X[pe]}e.findLast=o;function E(X,ce){for(let pe=X.length-1;pe>=0;pe--){const Ie=X[pe];if(ce(Ie))return pe}return-1}e.lastIndex=E;function r(X,ce){return X.length>0?X[0]:ce}e.firstOrDefault=r;function s(X,ce){return X.length>0?X[X.length-1]:ce}e.lastOrDefault=s;function n(X,ce,pe=(Ie,Re)=>Ie===Re){let Ie=0;for(let Re=0,Ce=Math.min(X.length,ce.length);Re<Ce&&pe(X[Re],ce[Re]);Re++)Ie++;return Ie}e.commonPrefixLength=n;function t(X){return[].concat(...X)}e.flatten=t;function a(X,ce){let pe=typeof ce=="number"?X:0;typeof ce=="number"?pe=X:(pe=0,ce=X);const Ie=[];if(pe<=ce)for(let Re=pe;Re<ce;Re++)Ie.push(Re);else for(let Re=pe;Re>ce;Re--)Ie.push(Re);return Ie}e.range=a;function c(X,ce,pe){return X.reduce((Ie,Re)=>(Ie[ce(Re)]=pe?pe(Re):Re,Ie),Object.create(null))}e.index=c;function u(X,ce){return X.push(ce),()=>S(X,ce)}e.insert=u;function S(X,ce){const pe=X.indexOf(ce);if(pe>-1)return X.splice(pe,1),ce}e.remove=S;function R(X,ce,pe){const Ie=X.slice(0,ce),Re=X.slice(ce);return Ie.concat(pe,Re)}e.arrayInsert=R;function O(X,ce){let pe;if(typeof ce=="number"){let Ie=ce;pe=()=>{const Re=Math.sin(Ie++)*179426549;return Re-Math.floor(Re)}}else pe=Math.random;for(let Ie=X.length-1;Ie>0;Ie-=1){const Re=Math.floor(pe()*(Ie+1)),Ce=X[Ie];X[Ie]=X[Re],X[Re]=Ce}}e.shuffle=O;function N(X,ce){const pe=X.indexOf(ce);pe>-1&&(X.splice(pe,1),X.unshift(ce))}e.pushToStart=N;function p(X,ce){const pe=X.indexOf(ce);pe>-1&&(X.splice(pe,1),X.push(ce))}e.pushToEnd=p;function M(X,ce){for(const pe of ce)X.push(pe)}e.pushMany=M;function U(X,ce){return Array.isArray(X)?X.map(ce):ce(X)}e.mapArrayOrNot=U;function z(X){return Array.isArray(X)?X:[X]}e.asArray=z;function re(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=re;function H(X,ce){for(const pe of X){const Ie=ce(pe);if(Ie!==void 0)return Ie}}e.mapFind=H;function F(X,ce,pe){const Ie=x(X,ce),Re=X.length,Ce=pe.length;X.length=Re+Ce;for(let ke=Re-1;ke>=Ie;ke--)X[ke+Ce]=X[ke];for(let ke=0;ke<Ce;ke++)X[ke+Ie]=pe[ke]}e.insertInto=F;function j(X,ce,pe,Ie){const Re=x(X,ce),Ce=X.splice(Re,pe);return F(X,Re,Ie),Ce}e.splice=j;function x(X,ce){return ce<0?Math.max(ce+X.length,0):Math.min(ce,X.length)}function V(X,ce){return(pe,Ie)=>ce(X(pe),X(Ie))}e.compareBy=V;const ne=(X,ce)=>X-ce;e.numberComparator=ne;function Q(X,ce){if(X.length===0)return;let pe=X[0];for(let Ie=1;Ie<X.length;Ie++){const Re=X[Ie];ce(Re,pe)>0&&(pe=Re)}return pe}e.findMaxBy=Q;function he(X,ce){if(X.length===0)return;let pe=X[0];for(let Ie=1;Ie<X.length;Ie++){const Re=X[Ie];ce(Re,pe)>=0&&(pe=Re)}return pe}e.findLastMaxBy=he;function fe(X,ce){return Q(X,(pe,Ie)=>-ce(pe,Ie))}e.findMinBy=fe;class G{constructor(ce){this.items=ce,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ce){let pe=this.firstIdx;for(;pe<this.items.length&&ce(this.items[pe]);)pe++;const Ie=pe===this.firstIdx?null:this.items.slice(this.firstIdx,pe);return this.firstIdx=pe,Ie}takeFromEndWhile(ce){let pe=this.lastIdx;for(;pe>=0&&ce(this.items[pe]);)pe--;const Ie=pe===this.lastIdx?null:this.items.slice(pe+1,this.lastIdx+1);return this.lastIdx=pe,Ie}peek(){return this.items[this.firstIdx]}dequeue(){const ce=this.items[this.firstIdx];return this.firstIdx++,ce}takeCount(ce){const pe=this.items.slice(this.firstIdx,this.firstIdx+ce);return this.firstIdx+=ce,pe}}e.ArrayQueue=G}),define(ye[77],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function d(i){const _=this;let A=!1,k;return function(){return A||(A=!0,k=i.apply(_,arguments)),k}}e.once=d}),define(ye[78],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(ye[79],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(i){function _(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=_;const A=Object.freeze([]);function k(){return A}i.empty=k;function*y(h){yield h}i.single=y;function w(h){return h||A}i.from=w;function P(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=P;function L(h){return h[Symbol.iterator]().next().value}i.first=L;function I(h,o){for(const E of h)if(o(E))return!0;return!1}i.some=I;function D(h,o){for(const E of h)if(o(E))return E}i.find=D;function*T(h,o){for(const E of h)o(E)&&(yield E)}i.filter=T;function*C(h,o){let E=0;for(const r of h)yield o(r,E++)}i.map=C;function*m(...h){for(const o of h)for(const E of o)yield E}i.concat=m;function*v(h){for(const o of h)for(const E of o)yield E}i.concatNested=v;function g(h,o,E){let r=E;for(const s of h)r=o(r,s);return r}i.reduce=g;function*b(h,o,E=h.length){for(o<0&&(o+=h.length),E<0?E+=h.length:E>h.length&&(E=h.length);o<E;o++)yield h[o]}i.slice=b;function f(h,o=Number.POSITIVE_INFINITY){const E=[];if(o===0)return[E,h];const r=h[Symbol.iterator]();for(let s=0;s<o;s++){const n=r.next();if(n.done)return[E,i.empty()];E.push(n.value)}return[E,{[Symbol.iterator](){return r}}]}i.consume=f;function l(h,o,E=(r,s)=>r===s){const r=h[Symbol.iterator](),s=o[Symbol.iterator]();for(;;){const n=r.next(),t=s.next();if(n.done!==t.done)return!1;if(n.done)return!0;if(!E(n.value,t.value))return!1}}i.equals=l})(d=e.Iterable||(e.Iterable={}))}),define(ye[144],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var i;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function k(o,E=!1){let r=0,s=o.length,n="",t=0,a=16,c=0;function u(U){let z=0,re=0;for(;z<U;){const H=o.charCodeAt(r);if(H>=48&&H<=57)re=re*16+H-48;else if(H>=65&&H<=70)re=re*16+H-65+10;else if(H>=97&&H<=102)re=re*16+H-97+10;else break;r++,z++}return z<U&&(re=-1),re}function S(U){r=U,n="",t=0,a=16,c=0}function R(){const U=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&P(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&P(o.charCodeAt(r)))for(r++;r<o.length&&P(o.charCodeAt(r));)r++;else return c=3,o.substring(U,r);let z=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&P(o.charCodeAt(r))){for(r++;r<o.length&&P(o.charCodeAt(r));)r++;z=r}else c=3;return o.substring(U,z)}function O(){let U="",z=r;for(;;){if(r>=s){U+=o.substring(z,r),c=2;break}const re=o.charCodeAt(r);if(re===34){U+=o.substring(z,r),r++;break}if(re===92){if(U+=o.substring(z,r),r++,r>=s){c=2;break}switch(o.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const F=u(4);F>=0?U+=String.fromCharCode(F):c=4;break}default:c=5}z=r;continue}if(re>=0&&re<=31)if(w(re)){U+=o.substring(z,r),c=2;break}else c=6;r++}return U}function N(){if(n="",c=0,t=r,r>=s)return t=s,a=17;let U=o.charCodeAt(r);if(y(U)){do r++,n+=String.fromCharCode(U),U=o.charCodeAt(r);while(y(U));return a=15}if(w(U))return r++,n+=String.fromCharCode(U),U===13&&o.charCodeAt(r)===10&&(r++,n+=`
`),a=14;switch(U){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,n=O(),a=10;case 47:{const z=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<s&&!w(o.charCodeAt(r));)r++;return n=o.substring(z,r),a=12}if(o.charCodeAt(r+1)===42){r+=2;const re=s-1;let H=!1;for(;r<re;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,c=1),n=o.substring(z,r),a=13}return n+=String.fromCharCode(U),r++,a=16}case 45:if(n+=String.fromCharCode(U),r++,r===s||!P(o.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),a=11;default:for(;r<s&&p(U);)r++,U=o.charCodeAt(r);if(t!==r){switch(n=o.substring(t,r),n){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return n+=String.fromCharCode(U),r++,a=16}}function p(U){if(y(U)||w(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:S,getPosition:()=>r,scan:E?M:N,getToken:()=>a,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>c}}e.createScanner=k;function y(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function w(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var L;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(L||(L={}));function I(o,E){const r=[],s=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function c(u,S,R,O){t.value=u,t.offset=S,t.length=R,t.type=O,t.colonOffset=void 0,n=t}try{f(o,{onObjectBegin:(u,S)=>{if(E<=u)throw s;n=void 0,a=E>u,r.push("")},onObjectProperty:(u,S,R)=>{if(E<S||(c(u,S,R,"property"),r[r.length-1]=u,E<=S+R))throw s},onObjectEnd:(u,S)=>{if(E<=u)throw s;n=void 0,r.pop()},onArrayBegin:(u,S)=>{if(E<=u)throw s;n=void 0,r.push(0)},onArrayEnd:(u,S)=>{if(E<=u)throw s;n=void 0,r.pop()},onLiteralValue:(u,S,R)=>{if(E<S||(c(u,S,R,h(u)),E<=S+R))throw s},onSeparator:(u,S,R)=>{if(E<=S)throw s;if(u===":"&&n&&n.type==="property")n.colonOffset=S,a=!1,n=void 0;else if(u===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(a=!0,r[r.length-1]=""),n=void 0}}})}catch(u){if(u!==s)throw u}return{path:r,previousNode:n,isAtPropertyKey:a,matches:u=>{let S=0;for(let R=0;S<u.length&&R<r.length;R++)if(u[S]===r[R]||u[S]==="*")S++;else if(u[S]!=="**")return!1;return S===u.length}}}e.getLocation=I;function D(o,E=[],r=A.DEFAULT){let s=null,n=[];const t=[];function a(u){Array.isArray(n)?n.push(u):s!==null&&(n[s]=u)}return f(o,{onObjectBegin:()=>{const u={};a(u),t.push(n),n=u,s=null},onObjectProperty:u=>{s=u},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const u=[];a(u),t.push(n),n=u,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:a,onError:(u,S,R)=>{E.push({error:u,offset:S,length:R})}},r),n[0]}e.parse=D;function T(o,E=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(u){s.type==="property"&&(s.length=u-s.offset,s=s.parent)}function t(u){return s.children.push(u),u}f(o,{onObjectBegin:u=>{s=t({type:"object",offset:u,length:-1,parent:s,children:[]})},onObjectProperty:(u,S,R)=>{s=t({type:"property",offset:S,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:u,offset:S,length:R,parent:s})},onObjectEnd:(u,S)=>{s.length=u+S-s.offset,s=s.parent,n(u+S)},onArrayBegin:(u,S)=>{s=t({type:"array",offset:u,length:-1,parent:s,children:[]})},onArrayEnd:(u,S)=>{s.length=u+S-s.offset,s=s.parent,n(u+S)},onLiteralValue:(u,S,R)=>{t({type:h(u),offset:S,length:R,parent:s,value:u}),n(S+R)},onSeparator:(u,S,R)=>{s.type==="property"&&(u===":"?s.colonOffset=S:u===","&&n(S))},onError:(u,S,R)=>{E.push({error:u,offset:S,length:R})}},r);const c=s.children[0];return c&&delete c.parent,c}e.parseTree=T;function C(o,E){if(!o)return;let r=o;for(let s of E)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===s){r=t.children[1],n=!0;break}if(!n)return}else{const n=s;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=C;function m(o){if(!o.parent||!o.parent.children)return[];const E=m(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;E.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&E.push(r)}return E}e.getNodePath=m;function v(o){switch(o.type){case"array":return o.children.map(v);case"object":{const E=Object.create(null);for(let r of o.children){const s=r.children[1];s&&(E[r.children[0].value]=v(s))}return E}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=v;function g(o,E,r=!1){return E>=o.offset&&E<o.offset+o.length||r&&E===o.offset+o.length}e.contains=g;function b(o,E,r=!1){if(g(o,E,r)){const s=o.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=E;n++){const t=b(s[n],E,r);if(t)return t}return o}}e.findNodeAtOffset=b;function f(o,E,r=A.DEFAULT){const s=k(o,!1);function n(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(he){return he?fe=>he(fe,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=n(E.onObjectBegin),c=t(E.onObjectProperty),u=n(E.onObjectEnd),S=n(E.onArrayBegin),R=n(E.onArrayEnd),O=t(E.onLiteralValue),N=t(E.onSeparator),p=n(E.onComment),M=t(E.onError),U=r&&r.disallowComments,z=r&&r.allowTrailingComma;function re(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:U||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(he){case 12:case 13:U?H(10):p();break;case 16:H(1);break;case 15:case 14:break;default:return he}}}function H(he,fe=[],G=[]){if(M(he),fe.length+G.length>0){let X=s.getToken();for(;X!==17;){if(fe.indexOf(X)!==-1){re();break}else if(G.indexOf(X)!==-1)break;X=re()}}}function F(he){const fe=s.getTokenValue();return he?O(fe):c(fe),re(),!0}function j(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(H(2),he=0)}catch{H(2)}O(he);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return re(),!0}function x(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(F(!1),s.getToken()===6?(N(":"),re(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function V(){a(),re();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||H(4,[],[]),N(","),re(),s.getToken()===2&&z)break}else he&&H(6,[],[]);x()||H(4,[],[2,5]),he=!0}return u(),s.getToken()!==2?H(7,[2],[]):re(),!0}function ne(){S(),re();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||H(4,[],[]),N(","),re(),s.getToken()===4&&z)break}else he&&H(6,[],[]);Q()||H(4,[],[4,5]),he=!0}return R(),s.getToken()!==4?H(8,[4],[]):re(),!0}function Q(){switch(s.getToken()){case 3:return ne();case 1:return V();case 10:return F(!0);default:return j()}}return re(),s.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=f;function l(o,E){let r=k(o),s=[],n,t=0,a;do switch(a=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:t!==a&&s.push(o.substring(t,a)),E!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,E)),t=r.getPosition();break}while(n!==17);return s.join("")}e.stripComments=l;function h(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(ye[80],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(_){this.executor=_,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(_){return new d(()=>_(this.getValue()))}}e.Lazy=d}),define(ye[6],De([0,1,77,79]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const _=!1;let A=null;function k(n){A=n}if(e.setDisposableTracker=k,_){const n="__is_disposable_tracked__";k(new class{trackDisposable(t){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[n]||console.log(a)},3e3)}setParent(t,a){if(t&&t!==b.None)try{t[n]=!0}catch{}}markAsDisposed(t){if(t&&t!==b.None)try{t[n]=!0}catch{}}markAsSingleton(t){}})}function y(n){return A?.trackDisposable(n),n}function w(n){A?.markAsDisposed(n)}function P(n,t){A?.setParent(n,t)}function L(n,t){if(!!A)for(const a of n)A.setParent(a,t)}function I(n){return A?.markAsSingleton(n),n}e.markAsSingleton=I;class D extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=D;function T(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=T;function C(n){if(i.Iterable.is(n)){let t=[];for(const a of n)if(a)try{a.dispose()}catch(c){t.push(c)}if(t.length===1)throw t[0];if(t.length>1)throw new D(t);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=C;function m(...n){const t=v(()=>C(n));return L(n,t),t}e.combinedDisposable=m;function v(n){const t=y({dispose:(0,d.once)(()=>{w(t),n()})});return t}e.toDisposable=v;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return P(t,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new g,y(this),P(this._store,this)}dispose(){w(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&P(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&P(t,null),t}}e.MutableDisposable=f;class l{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(t){let a=t;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,w(this))},this}}e.SafeDisposable=h;class o{constructor(){this.references=new Map}acquire(t,...a){let c=this.references.get(t);c||(c={counter:0,object:this.createReferencedObject(t,...a)},this.references.set(t,c));const{object:u}=c,S=(0,d.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(t,c.object),this.references.delete(t))});return c.counter++,{object:u,dispose:S}}}e.ReferenceCollection=o;class E{constructor(t){this.referenceCollection=t}async acquire(t,...a){const c=this.referenceCollection.acquire(t,...a);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(u){throw c.dispose(),u}}}e.AsyncReferenceCollection=E;class r{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=r;function s(n){const t=new g;try{n(t)}finally{t.dispose()}}e.disposeOnReturn=s}),define(ye[92],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class d{constructor(A){this.element=A,this.next=d.Undefined,this.prev=d.Undefined}}d.Undefined=new d(void 0);class i{constructor(){this._first=d.Undefined,this._last=d.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===d.Undefined}clear(){let A=this._first;for(;A!==d.Undefined;){const k=A.next;A.prev=d.Undefined,A.next=d.Undefined,A=k}this._first=d.Undefined,this._last=d.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,k){const y=new d(A);if(this._first===d.Undefined)this._first=y,this._last=y;else if(k){const P=this._last;this._last=y,y.prev=P,P.next=y}else{const P=this._first;this._first=y,y.next=P,P.prev=y}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(y))}}shift(){if(this._first!==d.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==d.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==d.Undefined&&A.next!==d.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===d.Undefined&&A.next===d.Undefined?(this._first=d.Undefined,this._last=d.Undefined):A.next===d.Undefined?(this._last=this._last.prev,this._last.next=d.Undefined):A.prev===d.Undefined&&(this._first=this._first.next,this._first.prev=d.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==d.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ye[145],De([1]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(Ce,ke){for(var Ae=0;Ae<ke.length;Ae++){var ue=ke[Ae];ue.enumerable=ue.enumerable||!1,ue.configurable=!0,"value"in ue&&(ue.writable=!0),Object.defineProperty(Ce,ue.key,ue)}}function d(Ce,ke,Ae){return ke&&e(Ce.prototype,ke),Ae&&e(Ce,Ae),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function i(Ce,ke){if(!!Ce){if(typeof Ce=="string")return _(Ce,ke);var Ae=Object.prototype.toString.call(Ce).slice(8,-1);if(Ae==="Object"&&Ce.constructor&&(Ae=Ce.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(Ce);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return _(Ce,ke)}}function _(Ce,ke){(ke==null||ke>Ce.length)&&(ke=Ce.length);for(var Ae=0,ue=new Array(ke);Ae<ke;Ae++)ue[Ae]=Ce[Ae];return ue}function A(Ce,ke){var Ae=typeof Symbol!="undefined"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(Ae)return(Ae=Ae.call(Ce)).next.bind(Ae);if(Array.isArray(Ce)||(Ae=i(Ce))||ke&&Ce&&typeof Ce.length=="number"){Ae&&(Ce=Ae);var ue=0;return function(){return ue>=Ce.length?{done:!0}:{done:!1,value:Ce[ue++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=k();function y(Ce){Y.defaults=Ce}var w=/[&<>"']/,P=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,D={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ke){return D[ke]};function C(Ce,ke){if(ke){if(w.test(Ce))return Ce.replace(P,T)}else if(L.test(Ce))return Ce.replace(I,T);return Ce}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ce){return Ce.replace(m,function(ke,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var g=/(^|[^\[])\^/g;function b(Ce,ke){Ce=Ce.source||Ce,ke=ke||"";var Ae={replace:function(ve,ie){return ie=ie.source||ie,ie=ie.replace(g,"$1"),Ce=Ce.replace(ve,ie),Ae},getRegex:function(){return new RegExp(Ce,ke)}};return Ae}var f=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ke,Ae){if(Ce){var ue;try{ue=decodeURIComponent(v(Ae)).replace(f,"").toLowerCase()}catch{return null}if(ue.indexOf("javascript:")===0||ue.indexOf("vbscript:")===0||ue.indexOf("data:")===0)return null}ke&&!l.test(Ae)&&(Ae=n(ke,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch{return null}return Ae}var o={},E=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ce,ke){o[" "+Ce]||(E.test(Ce)?o[" "+Ce]=Ce+"/":o[" "+Ce]=u(Ce,"/",!0)),Ce=o[" "+Ce];var Ae=Ce.indexOf(":")===-1;return ke.substring(0,2)==="//"?Ae?ke:Ce.replace(r,"$1")+ke:ke.charAt(0)==="/"?Ae?ke:Ce.replace(s,"$1")+ke:Ce+ke}var t={exec:function(){}};function a(Ce){for(var ke=1,Ae,ue;ke<arguments.length;ke++){Ae=arguments[ke];for(ue in Ae)Object.prototype.hasOwnProperty.call(Ae,ue)&&(Ce[ue]=Ae[ue])}return Ce}function c(Ce,ke){var Ae=Ce.replace(/\|/g,function(ie,oe,we){for(var Te=!1,B=oe;--B>=0&&we[B]==="\\";)Te=!Te;return Te?"|":" |"}),ue=Ae.split(/ \|/),ve=0;if(ue[0].trim()||ue.shift(),ue[ue.length-1].trim()||ue.pop(),ue.length>ke)ue.splice(ke);else for(;ue.length<ke;)ue.push("");for(;ve<ue.length;ve++)ue[ve]=ue[ve].trim().replace(/\\\|/g,"|");return ue}function u(Ce,ke,Ae){var ue=Ce.length;if(ue===0)return"";for(var ve=0;ve<ue;){var ie=Ce.charAt(ue-ve-1);if(ie===ke&&!Ae)ve++;else if(ie!==ke&&Ae)ve++;else break}return Ce.substr(0,ue-ve)}function S(Ce,ke){if(Ce.indexOf(ke[1])===-1)return-1;for(var Ae=Ce.length,ue=0,ve=0;ve<Ae;ve++)if(Ce[ve]==="\\")ve++;else if(Ce[ve]===ke[0])ue++;else if(Ce[ve]===ke[1]&&(ue--,ue<0))return ve;return-1}function R(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(Ce,ke){if(ke<1)return"";for(var Ae="";ke>1;)ke&1&&(Ae+=Ce),ke>>=1,Ce+=Ce;return Ae+Ce}function N(Ce,ke,Ae,ue){var ve=ke.href,ie=ke.title?C(ke.title):null,oe=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){ue.state.inLink=!0;var we={type:"link",raw:Ae,href:ve,title:ie,text:oe,tokens:ue.inlineTokens(oe,[])};return ue.state.inLink=!1,we}else return{type:"image",raw:Ae,href:ve,title:ie,text:C(oe)}}function p(Ce,ke){var Ae=Ce.match(/^(\s+)(?:```)/);if(Ae===null)return ke;var ue=Ae[1];return ke.split(`
`).map(function(ve){var ie=ve.match(/^\s+/);if(ie===null)return ve;var oe=ie[0];return oe.length>=ue.length?ve.slice(ue.length):ve}).join(`
`)}var M=function(){function Ce(Ae){this.options=Ae||Y.defaults}var ke=Ce.prototype;return ke.space=function(ue){var ve=this.rules.block.newline.exec(ue);if(ve&&ve[0].length>0)return{type:"space",raw:ve[0]}},ke.code=function(ue){var ve=this.rules.block.code.exec(ue);if(ve){var ie=ve[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ve[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:u(ie,`
`)}}},ke.fences=function(ue){var ve=this.rules.block.fences.exec(ue);if(ve){var ie=ve[0],oe=p(ie,ve[3]||"");return{type:"code",raw:ie,lang:ve[2]?ve[2].trim():ve[2],text:oe}}},ke.heading=function(ue){var ve=this.rules.block.heading.exec(ue);if(ve){var ie=ve[2].trim();if(/#$/.test(ie)){var oe=u(ie,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(ie=oe.trim())}var we={type:"heading",raw:ve[0],depth:ve[1].length,text:ie,tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},ke.hr=function(ue){var ve=this.rules.block.hr.exec(ue);if(ve)return{type:"hr",raw:ve[0]}},ke.blockquote=function(ue){var ve=this.rules.block.blockquote.exec(ue);if(ve){var ie=ve[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ve[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ke.list=function(ue){var ve=this.rules.block.list.exec(ue);if(ve){var ie,oe,we,Te,B,q,J,te,K,ae,de,Be,$e=ve[1].trim(),Ne=$e.length>1,Xe={type:"list",raw:"",ordered:Ne,start:Ne?+$e.slice(0,-1):"",loose:!1,items:[]};$e=Ne?"\\d{1,9}\\"+$e.slice(-1):"\\"+$e,this.options.pedantic&&($e=Ne?$e:"[*+-]");for(var ee=new RegExp("^( {0,3}"+$e+")((?: [^\\n]*)?(?:\\n|$))");ue&&(Be=!1,!(!(ve=ee.exec(ue))||this.rules.block.hr.test(ue)));){if(ie=ve[0],ue=ue.substring(ie.length),te=ve[2].split(`
`,1)[0],K=ue.split(`
`,1)[0],this.options.pedantic?(Te=2,de=te.trimLeft()):(Te=ve[2].search(/[^ ]/),Te=Te>4?1:Te,de=te.slice(Te),Te+=ve[1].length),q=!1,!te&&/^ *$/.test(K)&&(ie+=K+`
`,ue=ue.substring(K.length+1),Be=!0),!Be)for(var se=new RegExp("^ {0,"+Math.min(3,Te-1)+"}(?:[*+-]|\\d{1,9}[.)])");ue&&(ae=ue.split(`
`,1)[0],te=ae,this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!se.test(te));){if(te.search(/[^ ]/)>=Te||!te.trim())de+=`
`+te.slice(Te);else if(!q)de+=`
`+te;else break;!q&&!te.trim()&&(q=!0),ie+=ae+`
`,ue=ue.substring(ae.length+1)}Xe.loose||(J?Xe.loose=!0:/\n *\n *$/.test(ie)&&(J=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(de),oe&&(we=oe[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:ie,task:!!oe,checked:we,loose:!1,text:de}),Xe.raw+=ie}Xe.items[Xe.items.length-1].raw=ie.trimRight(),Xe.items[Xe.items.length-1].text=de.trimRight(),Xe.raw=Xe.raw.trimRight();var be=Xe.items.length;for(B=0;B<be;B++){this.lexer.state.top=!1,Xe.items[B].tokens=this.lexer.blockTokens(Xe.items[B].text,[]);var le=Xe.items[B].tokens.filter(function(Fe){return Fe.type==="space"}),_e=le.every(function(Fe){for(var He=Fe.raw.split(""),qe=0,Ge=A(He),Ze;!(Ze=Ge()).done;){var Qe=Ze.value;if(Qe===`
`&&(qe+=1),qe>1)return!0}return!1});!Xe.loose&&le.length&&_e&&(Xe.loose=!0,Xe.items[B].loose=!0)}return Xe}},ke.html=function(ue){var ve=this.rules.block.html.exec(ue);if(ve){var ie={type:"html",raw:ve[0],pre:!this.options.sanitizer&&(ve[1]==="pre"||ve[1]==="script"||ve[1]==="style"),text:ve[0]};return this.options.sanitize&&(ie.type="paragraph",ie.text=this.options.sanitizer?this.options.sanitizer(ve[0]):C(ve[0]),ie.tokens=[],this.lexer.inline(ie.text,ie.tokens)),ie}},ke.def=function(ue){var ve=this.rules.block.def.exec(ue);if(ve){ve[3]&&(ve[3]=ve[3].substring(1,ve[3].length-1));var ie=ve[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ve[0],href:ve[2],title:ve[3]}}},ke.table=function(ue){var ve=this.rules.block.table.exec(ue);if(ve){var ie={type:"table",header:c(ve[1]).map(function(J){return{text:J}}),align:ve[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ve[3]?ve[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ve[0];var oe=ie.align.length,we,Te,B,q;for(we=0;we<oe;we++)/^ *-+: *$/.test(ie.align[we])?ie.align[we]="right":/^ *:-+: *$/.test(ie.align[we])?ie.align[we]="center":/^ *:-+ *$/.test(ie.align[we])?ie.align[we]="left":ie.align[we]=null;for(oe=ie.rows.length,we=0;we<oe;we++)ie.rows[we]=c(ie.rows[we],ie.header.length).map(function(J){return{text:J}});for(oe=ie.header.length,Te=0;Te<oe;Te++)ie.header[Te].tokens=[],this.lexer.inlineTokens(ie.header[Te].text,ie.header[Te].tokens);for(oe=ie.rows.length,Te=0;Te<oe;Te++)for(q=ie.rows[Te],B=0;B<q.length;B++)q[B].tokens=[],this.lexer.inlineTokens(q[B].text,q[B].tokens);return ie}}},ke.lheading=function(ue){var ve=this.rules.block.lheading.exec(ue);if(ve){var ie={type:"heading",raw:ve[0],depth:ve[2].charAt(0)==="="?1:2,text:ve[1],tokens:[]};return this.lexer.inline(ie.text,ie.tokens),ie}},ke.paragraph=function(ue){var ve=this.rules.block.paragraph.exec(ue);if(ve){var ie={type:"paragraph",raw:ve[0],text:ve[1].charAt(ve[1].length-1)===`
`?ve[1].slice(0,-1):ve[1],tokens:[]};return this.lexer.inline(ie.text,ie.tokens),ie}},ke.text=function(ue){var ve=this.rules.block.text.exec(ue);if(ve){var ie={type:"text",raw:ve[0],text:ve[0],tokens:[]};return this.lexer.inline(ie.text,ie.tokens),ie}},ke.escape=function(ue){var ve=this.rules.inline.escape.exec(ue);if(ve)return{type:"escape",raw:ve[0],text:C(ve[1])}},ke.tag=function(ue){var ve=this.rules.inline.tag.exec(ue);if(ve)return!this.lexer.state.inLink&&/^<a /i.test(ve[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ve[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):C(ve[0]):ve[0]}},ke.link=function(ue){var ve=this.rules.inline.link.exec(ue);if(ve){var ie=ve[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var oe=u(ie.slice(0,-1),"\\");if((ie.length-oe.length)%2==0)return}else{var we=S(ve[2],"()");if(we>-1){var Te=ve[0].indexOf("!")===0?5:4,B=Te+ve[1].length+we;ve[2]=ve[2].substring(0,we),ve[0]=ve[0].substring(0,B).trim(),ve[3]=""}}var q=ve[2],J="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);te&&(q=te[1],J=te[3])}else J=ve[3]?ve[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ie)?q=q.slice(1):q=q.slice(1,-1)),N(ve,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:J&&J.replace(this.rules.inline._escapes,"$1")},ve[0],this.lexer)}},ke.reflink=function(ue,ve){var ie;if((ie=this.rules.inline.reflink.exec(ue))||(ie=this.rules.inline.nolink.exec(ue))){var oe=(ie[2]||ie[1]).replace(/\s+/g," ");if(oe=ve[oe.toLowerCase()],!oe||!oe.href){var we=ie[0].charAt(0);return{type:"text",raw:we,text:we}}return N(ie,oe,ie[0],this.lexer)}},ke.emStrong=function(ue,ve,ie){ie===void 0&&(ie="");var oe=this.rules.inline.emStrong.lDelim.exec(ue);if(!!oe&&!(oe[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=oe[1]||oe[2]||"";if(!we||we&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Te=oe[0].length-1,B,q,J=Te,te=0,K=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,ve=ve.slice(-1*ue.length+Te);(oe=K.exec(ve))!=null;)if(B=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!B){if(q=B.length,oe[3]||oe[4]){J+=q;continue}else if((oe[5]||oe[6])&&Te%3&&!((Te+q)%3)){te+=q;continue}if(J-=q,!(J>0)){if(q=Math.min(q,q+J+te),Math.min(Te,q)%2){var ae=ue.slice(1,Te+oe.index+q);return{type:"em",raw:ue.slice(0,Te+oe.index+q+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}var de=ue.slice(2,Te+oe.index+q-1);return{type:"strong",raw:ue.slice(0,Te+oe.index+q+1),text:de,tokens:this.lexer.inlineTokens(de,[])}}}}}},ke.codespan=function(ue){var ve=this.rules.inline.code.exec(ue);if(ve){var ie=ve[2].replace(/\n/g," "),oe=/[^ ]/.test(ie),we=/^ /.test(ie)&&/ $/.test(ie);return oe&&we&&(ie=ie.substring(1,ie.length-1)),ie=C(ie,!0),{type:"codespan",raw:ve[0],text:ie}}},ke.br=function(ue){var ve=this.rules.inline.br.exec(ue);if(ve)return{type:"br",raw:ve[0]}},ke.del=function(ue){var ve=this.rules.inline.del.exec(ue);if(ve)return{type:"del",raw:ve[0],text:ve[2],tokens:this.lexer.inlineTokens(ve[2],[])}},ke.autolink=function(ue,ve){var ie=this.rules.inline.autolink.exec(ue);if(ie){var oe,we;return ie[2]==="@"?(oe=C(this.options.mangle?ve(ie[1]):ie[1]),we="mailto:"+oe):(oe=C(ie[1]),we=oe),{type:"link",raw:ie[0],text:oe,href:we,tokens:[{type:"text",raw:oe,text:oe}]}}},ke.url=function(ue,ve){var ie;if(ie=this.rules.inline.url.exec(ue)){var oe,we;if(ie[2]==="@")oe=C(this.options.mangle?ve(ie[0]):ie[0]),we="mailto:"+oe;else{var Te;do Te=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Te!==ie[0]);oe=C(ie[0]),ie[1]==="www."?we="http://"+oe:we=oe}return{type:"link",raw:ie[0],text:oe,href:we,tokens:[{type:"text",raw:oe,text:oe}]}}},ke.inlineText=function(ue,ve){var ie=this.rules.inline.text.exec(ue);if(ie){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):C(ie[0]):ie[0]:oe=C(this.options.smartypants?ve(ie[0]):ie[0]),{type:"text",raw:ie[0],text:oe}}},Ce}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=b(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=b(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=b(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=b(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=b(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=a({},U),U.gfm=a({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=b(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=a({},U.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:b(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=b(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=b(U._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=b(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=b(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=b(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=b(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=b(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=b(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=b(z.reflink).replace("label",z._label).replace("ref",U._label).getRegex(),z.nolink=b(z.nolink).replace("ref",U._label).getRegex(),z.reflinkSearch=b(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=a({},z),z.pedantic=a({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=a({},z.normal,{escape:b(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=b(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=a({},z.gfm,{br:b(z.br).replace("{2,}","*").getRegex(),text:b(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function re(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ce){var ke="",Ae,ue,ve=Ce.length;for(Ae=0;Ae<ve;Ae++)ue=Ce.charCodeAt(Ae),Math.random()>.5&&(ue="x"+ue.toString(16)),ke+="&#"+ue+";";return ke}var F=function(){function Ce(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||Y.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ue={block:U.normal,inline:z.normal};this.options.pedantic?(ue.block=U.pedantic,ue.inline=z.pedantic):this.options.gfm&&(ue.block=U.gfm,this.options.breaks?ue.inline=z.breaks:ue.inline=z.gfm),this.tokenizer.rules=ue}Ce.lex=function(ue,ve){var ie=new Ce(ve);return ie.lex(ue)},Ce.lexInline=function(ue,ve){var ie=new Ce(ve);return ie.inlineTokens(ue)};var ke=Ce.prototype;return ke.lex=function(ue){ue=ue.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ue,this.tokens);for(var ve;ve=this.inlineQueue.shift();)this.inlineTokens(ve.src,ve.tokens);return this.tokens},ke.blockTokens=function(ue,ve){var ie=this;ve===void 0&&(ve=[]),this.options.pedantic&&(ue=ue.replace(/^ +$/gm,""));for(var oe,we,Te,B;ue;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(J){return(oe=J.call({lexer:ie},ue,ve))?(ue=ue.substring(oe.raw.length),ve.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ue)){ue=ue.substring(oe.raw.length),oe.raw.length===1&&ve.length>0?ve[ve.length-1].raw+=`
`:ve.push(oe);continue}if(oe=this.tokenizer.code(ue)){ue=ue.substring(oe.raw.length),we=ve[ve.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+oe.raw,we.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):ve.push(oe);continue}if(oe=this.tokenizer.fences(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.heading(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.hr(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.blockquote(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.list(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.html(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.def(ue)){ue=ue.substring(oe.raw.length),we=ve[ve.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+oe.raw,we.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.lheading(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(Te=ue,this.options.extensions&&this.options.extensions.startBlock&&function(){var J=1/0,te=ue.slice(1),K=void 0;ie.options.extensions.startBlock.forEach(function(ae){K=ae.call({lexer:this},te),typeof K=="number"&&K>=0&&(J=Math.min(J,K))}),J<1/0&&J>=0&&(Te=ue.substring(0,J+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Te))){we=ve[ve.length-1],B&&we.type==="paragraph"?(we.raw+=`
`+oe.raw,we.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ve.push(oe),B=Te.length!==ue.length,ue=ue.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ue)){ue=ue.substring(oe.raw.length),we=ve[ve.length-1],we&&we.type==="text"?(we.raw+=`
`+oe.raw,we.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ve.push(oe);continue}if(ue){var q="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,ve},ke.inline=function(ue,ve){this.inlineQueue.push({src:ue,tokens:ve})},ke.inlineTokens=function(ue,ve){var ie=this;ve===void 0&&(ve=[]);var oe,we,Te,B=ue,q,J,te;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)K.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,q.index)+"["+O("a",q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,q.index)+"["+O("a",q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ue;)if(J||(te=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(oe=de.call({lexer:ie},ue,ve))?(ue=ue.substring(oe.raw.length),ve.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.tag(ue)){ue=ue.substring(oe.raw.length),we=ve[ve.length-1],we&&oe.type==="text"&&we.type==="text"?(we.raw+=oe.raw,we.text+=oe.text):ve.push(oe);continue}if(oe=this.tokenizer.link(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.reflink(ue,this.tokens.links)){ue=ue.substring(oe.raw.length),we=ve[ve.length-1],we&&oe.type==="text"&&we.type==="text"?(we.raw+=oe.raw,we.text+=oe.text):ve.push(oe);continue}if(oe=this.tokenizer.emStrong(ue,B,te)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.codespan(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.br(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.del(ue)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(oe=this.tokenizer.autolink(ue,H)){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ue,H))){ue=ue.substring(oe.raw.length),ve.push(oe);continue}if(Te=ue,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Be=ue.slice(1),$e=void 0;ie.options.extensions.startInline.forEach(function(Ne){$e=Ne.call({lexer:this},Be),typeof $e=="number"&&$e>=0&&(de=Math.min(de,$e))}),de<1/0&&de>=0&&(Te=ue.substring(0,de+1))}(),oe=this.tokenizer.inlineText(Te,re)){ue=ue.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(te=oe.raw.slice(-1)),J=!0,we=ve[ve.length-1],we&&we.type==="text"?(we.raw+=oe.raw,we.text+=oe.text):ve.push(oe);continue}if(ue){var ae="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return ve},d(Ce,null,[{key:"rules",get:function(){return{block:U,inline:z}}}]),Ce}(),j=function(){function Ce(Ae){this.options=Ae||Y.defaults}var ke=Ce.prototype;return ke.code=function(ue,ve,ie){var oe=(ve||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(ue,oe);we!=null&&we!==ue&&(ie=!0,ue=we)}return ue=ue.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+C(oe,!0)+'">'+(ie?ue:C(ue,!0))+`</code></pre>
`:"<pre><code>"+(ie?ue:C(ue,!0))+`</code></pre>
`},ke.blockquote=function(ue){return`<blockquote>
`+ue+`</blockquote>
`},ke.html=function(ue){return ue},ke.heading=function(ue,ve,ie,oe){return this.options.headerIds?"<h"+ve+' id="'+this.options.headerPrefix+oe.slug(ie)+'">'+ue+"</h"+ve+`>
`:"<h"+ve+">"+ue+"</h"+ve+`>
`},ke.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ke.list=function(ue,ve,ie){var oe=ve?"ol":"ul",we=ve&&ie!==1?' start="'+ie+'"':"";return"<"+oe+we+`>
`+ue+"</"+oe+`>
`},ke.listitem=function(ue){return"<li>"+ue+`</li>
`},ke.checkbox=function(ue){return"<input "+(ue?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ke.paragraph=function(ue){return"<p>"+ue+`</p>
`},ke.table=function(ue,ve){return ve&&(ve="<tbody>"+ve+"</tbody>"),`<table>
<thead>
`+ue+`</thead>
`+ve+`</table>
`},ke.tablerow=function(ue){return`<tr>
`+ue+`</tr>
`},ke.tablecell=function(ue,ve){var ie=ve.header?"th":"td",oe=ve.align?"<"+ie+' align="'+ve.align+'">':"<"+ie+">";return oe+ue+"</"+ie+`>
`},ke.strong=function(ue){return"<strong>"+ue+"</strong>"},ke.em=function(ue){return"<em>"+ue+"</em>"},ke.codespan=function(ue){return"<code>"+ue+"</code>"},ke.br=function(){return this.options.xhtml?"<br/>":"<br>"},ke.del=function(ue){return"<del>"+ue+"</del>"},ke.link=function(ue,ve,ie){if(ue=h(this.options.sanitize,this.options.baseUrl,ue),ue===null)return ie;var oe='<a href="'+C(ue)+'"';return ve&&(oe+=' title="'+ve+'"'),oe+=">"+ie+"</a>",oe},ke.image=function(ue,ve,ie){if(ue=h(this.options.sanitize,this.options.baseUrl,ue),ue===null)return ie;var oe='<img src="'+ue+'" alt="'+ie+'"';return ve&&(oe+=' title="'+ve+'"'),oe+=this.options.xhtml?"/>":">",oe},ke.text=function(ue){return ue},Ce}(),x=function(){function Ce(){}var ke=Ce.prototype;return ke.strong=function(ue){return ue},ke.em=function(ue){return ue},ke.codespan=function(ue){return ue},ke.del=function(ue){return ue},ke.html=function(ue){return ue},ke.text=function(ue){return ue},ke.link=function(ue,ve,ie){return""+ie},ke.image=function(ue,ve,ie){return""+ie},ke.br=function(){return""},Ce}(),V=function(){function Ce(){this.seen={}}var ke=Ce.prototype;return ke.serialize=function(ue){return ue.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ke.getNextSafeSlug=function(ue,ve){var ie=ue,oe=0;if(this.seen.hasOwnProperty(ie)){oe=this.seen[ue];do oe++,ie=ue+"-"+oe;while(this.seen.hasOwnProperty(ie))}return ve||(this.seen[ue]=oe,this.seen[ie]=0),ie},ke.slug=function(ue,ve){ve===void 0&&(ve={});var ie=this.serialize(ue);return this.getNextSafeSlug(ie,ve.dryrun)},Ce}(),ne=function(){function Ce(Ae){this.options=Ae||Y.defaults,this.options.renderer=this.options.renderer||new j,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new V}Ce.parse=function(ue,ve){var ie=new Ce(ve);return ie.parse(ue)},Ce.parseInline=function(ue,ve){var ie=new Ce(ve);return ie.parseInline(ue)};var ke=Ce.prototype;return ke.parse=function(ue,ve){ve===void 0&&(ve=!0);var ie="",oe,we,Te,B,q,J,te,K,ae,de,Be,$e,Ne,Xe,ee,se,be,le,_e,Fe=ue.length;for(oe=0;oe<Fe;oe++){if(de=ue[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(_e=this.options.extensions.renderers[de.type].call({parser:this},de),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){ie+=_e||"";continue}switch(de.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(de.tokens),de.depth,v(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(K="",te="",B=de.header.length,we=0;we<B;we++)te+=this.renderer.tablecell(this.parseInline(de.header[we].tokens),{header:!0,align:de.align[we]});for(K+=this.renderer.tablerow(te),ae="",B=de.rows.length,we=0;we<B;we++){for(J=de.rows[we],te="",q=J.length,Te=0;Te<q;Te++)te+=this.renderer.tablecell(this.parseInline(J[Te].tokens),{header:!1,align:de.align[Te]});ae+=this.renderer.tablerow(te)}ie+=this.renderer.table(K,ae);continue}case"blockquote":{ae=this.parse(de.tokens),ie+=this.renderer.blockquote(ae);continue}case"list":{for(Be=de.ordered,$e=de.start,Ne=de.loose,B=de.items.length,ae="",we=0;we<B;we++)ee=de.items[we],se=ee.checked,be=ee.task,Xe="",ee.task&&(le=this.renderer.checkbox(se),Ne?ee.tokens.length>0&&ee.tokens[0].type==="paragraph"?(ee.tokens[0].text=le+" "+ee.tokens[0].text,ee.tokens[0].tokens&&ee.tokens[0].tokens.length>0&&ee.tokens[0].tokens[0].type==="text"&&(ee.tokens[0].tokens[0].text=le+" "+ee.tokens[0].tokens[0].text)):ee.tokens.unshift({type:"text",text:le}):Xe+=le),Xe+=this.parse(ee.tokens,Ne),ae+=this.renderer.listitem(Xe,be,se);ie+=this.renderer.list(ae,Be,$e);continue}case"html":{ie+=this.renderer.html(de.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ae=de.tokens?this.parseInline(de.tokens):de.text;oe+1<Fe&&ue[oe+1].type==="text";)de=ue[++oe],ae+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);ie+=ve?this.renderer.paragraph(ae):ae;continue}default:{var He='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return ie},ke.parseInline=function(ue,ve){ve=ve||this.renderer;var ie="",oe,we,Te,B=ue.length;for(oe=0;oe<B;oe++){if(we=ue[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Te=this.options.extensions.renderers[we.type].call({parser:this},we),Te!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){ie+=Te||"";continue}switch(we.type){case"escape":{ie+=ve.text(we.text);break}case"html":{ie+=ve.html(we.text);break}case"link":{ie+=ve.link(we.href,we.title,this.parseInline(we.tokens,ve));break}case"image":{ie+=ve.image(we.href,we.title,we.text);break}case"strong":{ie+=ve.strong(this.parseInline(we.tokens,ve));break}case"em":{ie+=ve.em(this.parseInline(we.tokens,ve));break}case"codespan":{ie+=ve.codespan(we.text);break}case"br":{ie+=ve.br();break}case"del":{ie+=ve.del(this.parseInline(we.tokens,ve));break}case"text":{ie+=ve.text(we.text);break}default:{var q='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ie},Ce}();function Q(Ce,ke,Ae){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ke=="function"&&(Ae=ke,ke=null),ke=a({},Q.defaults,ke||{}),R(ke),Ae){var ue=ke.highlight,ve;try{ve=F.lex(Ce,ke)}catch(Te){return Ae(Te)}var ie=function(B){var q;if(!B)try{ke.walkTokens&&Q.walkTokens(ve,ke.walkTokens),q=ne.parse(ve,ke)}catch(J){B=J}return ke.highlight=ue,B?Ae(B):Ae(null,q)};if(!ue||ue.length<3||(delete ke.highlight,!ve.length))return ie();var oe=0;Q.walkTokens(ve,function(Te){Te.type==="code"&&(oe++,setTimeout(function(){ue(Te.text,Te.lang,function(B,q){if(B)return ie(B);q!=null&&q!==Te.text&&(Te.text=q,Te.escaped=!0),oe--,oe===0&&ie()})},0))}),oe===0&&ie();return}try{var we=F.lex(Ce,ke);return ke.walkTokens&&Q.walkTokens(we,ke.walkTokens),ne.parse(we,ke)}catch(Te){if(Te.message+=`
Please report this to https://github.com/markedjs/marked.`,ke.silent)return"<p>An error occurred:</p><pre>"+C(Te.message+"",!0)+"</pre>";throw Te}}Q.options=Q.setOptions=function(Ce){return a(Q.defaults,Ce),y(Q.defaults),Q},Q.getDefaults=k,Q.defaults=Y.defaults,Q.use=function(){for(var Ce=arguments.length,ke=new Array(Ce),Ae=0;Ae<Ce;Ae++)ke[Ae]=arguments[Ae];var ue=a.apply(void 0,[{}].concat(ke)),ve=Q.defaults.extensions||{renderers:{},childTokens:{}},ie;ke.forEach(function(oe){if(oe.extensions&&(ie=!0,oe.extensions.forEach(function(Te){if(!Te.name)throw new Error("extension name required");if(Te.renderer){var B=ve.renderers?ve.renderers[Te.name]:null;B?ve.renderers[Te.name]=function(){for(var q=arguments.length,J=new Array(q),te=0;te<q;te++)J[te]=arguments[te];var K=Te.renderer.apply(this,J);return K===!1&&(K=B.apply(this,J)),K}:ve.renderers[Te.name]=Te.renderer}if(Te.tokenizer){if(!Te.level||Te.level!=="block"&&Te.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ve[Te.level]?ve[Te.level].unshift(Te.tokenizer):ve[Te.level]=[Te.tokenizer],Te.start&&(Te.level==="block"?ve.startBlock?ve.startBlock.push(Te.start):ve.startBlock=[Te.start]:Te.level==="inline"&&(ve.startInline?ve.startInline.push(Te.start):ve.startInline=[Te.start]))}Te.childTokens&&(ve.childTokens[Te.name]=Te.childTokens)})),oe.renderer&&function(){var Te=Q.defaults.renderer||new j,B=function(te){var K=Te[te];Te[te]=function(){for(var ae=arguments.length,de=new Array(ae),Be=0;Be<ae;Be++)de[Be]=arguments[Be];var $e=oe.renderer[te].apply(Te,de);return $e===!1&&($e=K.apply(Te,de)),$e}};for(var q in oe.renderer)B(q);ue.renderer=Te}(),oe.tokenizer&&function(){var Te=Q.defaults.tokenizer||new M,B=function(te){var K=Te[te];Te[te]=function(){for(var ae=arguments.length,de=new Array(ae),Be=0;Be<ae;Be++)de[Be]=arguments[Be];var $e=oe.tokenizer[te].apply(Te,de);return $e===!1&&($e=K.apply(Te,de)),$e}};for(var q in oe.tokenizer)B(q);ue.tokenizer=Te}(),oe.walkTokens){var we=Q.defaults.walkTokens;ue.walkTokens=function(Te){oe.walkTokens.call(this,Te),we&&we.call(this,Te)}}ie&&(ue.extensions=ve),Q.setOptions(ue)})},Q.walkTokens=function(Ce,ke){for(var Ae=function(){var oe=ve.value;switch(ke.call(Q,oe),oe.type){case"table":{for(var we=A(oe.header),Te;!(Te=we()).done;){var B=Te.value;Q.walkTokens(B.tokens,ke)}for(var q=A(oe.rows),J;!(J=q()).done;)for(var te=J.value,K=A(te),ae;!(ae=K()).done;){var de=ae.value;Q.walkTokens(de.tokens,ke)}break}case"list":{Q.walkTokens(oe.items,ke);break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[oe.type]?Q.defaults.extensions.childTokens[oe.type].forEach(function(Be){Q.walkTokens(oe[Be],ke)}):oe.tokens&&Q.walkTokens(oe.tokens,ke)}},ue=A(Ce),ve;!(ve=ue()).done;)Ae()},Q.parseInline=function(Ce,ke){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ke=a({},Q.defaults,ke||{}),R(ke);try{var Ae=F.lexInline(Ce,ke);return ke.walkTokens&&Q.walkTokens(Ae,ke.walkTokens),ne.parseInline(Ae,ke)}catch(ue){if(ue.message+=`
Please report this to https://github.com/markedjs/marked.`,ke.silent)return"<p>An error occurred:</p><pre>"+C(ue.message+"",!0)+"</pre>";throw ue}},Q.Parser=ne,Q.parser=ne.parse,Q.Renderer=j,Q.TextRenderer=x,Q.Lexer=F,Q.lexer=F.lex,Q.Tokenizer=M,Q.Slugger=V,Q.parse=Q;var he=Q.options,fe=Q.setOptions,G=Q.use,X=Q.walkTokens,ce=Q.parseInline,pe=Q,Ie=ne.parse,Re=F.lex;Y.Lexer=F,Y.Parser=ne,Y.Renderer=j,Y.Slugger=V,Y.TextRenderer=x,Y.Tokenizer=M,Y.getDefaults=k,Y.lexer=Re,Y.marked=Q,Y.options=he,Y.parse=pe,Y.parseInline=ce,Y.parser=Ie,Y.setOptions=fe,Y.use=G,Y.walkTokens=X,Object.defineProperty(Y,"__esModule",{value:!0})}),define(ye[93],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(y,w,P){return Math.min(Math.max(y,w),P)}e.clamp=d;function i(y,w){return(w+y%w)%w}e.rot=i;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class k{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const P=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=k}),function(){function Y(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function k(w){A.push(w,Date.now())}function y(){const w=[];for(let P=0;P<A.length;P+=2)w.push({name:A[P],startTime:A[P+1]});return w}return{mark:k,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(_+k.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function d(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=d(i))}(),define(ye[12],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const d="en";let i=!1,_=!1,A=!1,k=!1,y=!1,w=!1,P=!1,L=!1,I=!1,D,T=d,C,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const g=typeof v?.versions?.electron=="string",b=g&&v?.type==="renderer";if(typeof navigator=="object"&&!b)m=navigator.userAgent,i=m.indexOf("Windows")>=0,_=m.indexOf("Macintosh")>=0,L=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,w=!0,D=navigator.language,T=D;else if(typeof v=="object"){i=v.platform==="win32",_=v.platform==="darwin",A=v.platform==="linux",k=A&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,P=g,I=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=d,T=d;const t=v.env.VSCODE_NLS_CONFIG;if(t)try{const a=JSON.parse(t),c=a.availableLanguages["*"];D=a.locale,T=c||d,C=a._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var f;(function(t){t[t.Web=0]="Web",t[t.Mac=1]="Mac",t[t.Linux=2]="Linux",t[t.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function l(t){switch(t){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let h=0;_?h=1:i?h=3:A&&(h=2),e.isWindows=i,e.isMacintosh=_,e.isLinux=A,e.isLinuxSnap=k,e.isNative=y,e.isElectron=P,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isCI=I,e.platform=h,e.userAgent=m,e.language=T;var o;(function(t){function a(){return e.language}t.value=a;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}t.isDefaultVariant=c;function u(){return e.language==="en"}t.isDefault=u})(o=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=C,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let t=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let u=0,S=t.length;u<S;u++){const R=t[u];if(R.id===c.data.vscodeScheduleAsyncWork){t.splice(u,1),R.callback();return}}});let a=0;return c=>{const u=++a;t.push({id:u,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return t=>setTimeout(t)})();var E;(function(t){t[t.Windows=1]="Windows",t[t.Macintosh=2]="Macintosh",t[t.Linux=3]="Linux"})(E=e.OperatingSystem||(e.OperatingSystem={})),e.OS=_||L?2:i?1:3;let r=!0,s=!1;function n(){if(!s){s=!0;const t=new Uint8Array(2);t[0]=1,t[1]=2,r=new Uint16Array(t.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[34],De([0,1,12]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof d.globals.vscode!="undefined"&&typeof d.globals.vscode.process!="undefined"){const _=d.globals.vscode.process;i={get platform(){return _.platform},get arch(){return _.arch},get env(){return _.env},cwd(){return _.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return d.isWindows?"win32":d.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ye[9],De([0,1,34]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,_=97,A=90,k=122,y=46,w=47,P=92,L=58,I=63;class D extends Error{constructor(l,h,o){let E;typeof h=="string"&&h.indexOf("not ")===0?(E="must not be",h=h.replace(/^not /,"")):E="must be";const r=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${r} ${E} of type ${h}`;s+=`. Received type ${typeof o}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function T(f,l){if(typeof f!="string")throw new D(l,"string",f)}function C(f){return f===w||f===P}function m(f){return f===w}function v(f){return f>=i&&f<=A||f>=_&&f<=k}function g(f,l,h,o){let E="",r=0,s=-1,n=0,t=0;for(let a=0;a<=f.length;++a){if(a<f.length)t=f.charCodeAt(a);else{if(o(t))break;t=w}if(o(t)){if(!(s===a-1||n===1))if(n===2){if(E.length<2||r!==2||E.charCodeAt(E.length-1)!==y||E.charCodeAt(E.length-2)!==y){if(E.length>2){const c=E.lastIndexOf(h);c===-1?(E="",r=0):(E=E.slice(0,c),r=E.length-1-E.lastIndexOf(h)),s=a,n=0;continue}else if(E.length!==0){E="",r=0,s=a,n=0;continue}}l&&(E+=E.length>0?`${h}..`:"..",r=2)}else E.length>0?E+=`${h}${f.slice(s+1,a)}`:E=f.slice(s+1,a),r=a-s-1;s=a,n=0}else t===y&&n!==-1?++n:n=-1}return E}function b(f,l){if(l===null||typeof l!="object")throw new D("pathObject","Object",l);const h=l.dir||l.root,o=l.base||`${l.name||""}${l.ext||""}`;return h?h===l.root?`${h}${o}`:`${h}${f}${o}`:o}e.win32={resolve(...f){let l="",h="",o=!1;for(let E=f.length-1;E>=-1;E--){let r;if(E>=0){if(r=f[E],T(r,"path"),r.length===0)continue}else l.length===0?r=d.cwd():(r=d.env[`=${l}`]||d.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${l}\\`));const s=r.length;let n=0,t="",a=!1;const c=r.charCodeAt(0);if(s===1)C(c)&&(n=1,a=!0);else if(C(c))if(a=!0,C(r.charCodeAt(1))){let u=2,S=u;for(;u<s&&!C(r.charCodeAt(u));)u++;if(u<s&&u!==S){const R=r.slice(S,u);for(S=u;u<s&&C(r.charCodeAt(u));)u++;if(u<s&&u!==S){for(S=u;u<s&&!C(r.charCodeAt(u));)u++;(u===s||u!==S)&&(t=`\\\\${R}\\${r.slice(S,u)}`,n=u)}}}else n=1;else v(c)&&r.charCodeAt(1)===L&&(t=r.slice(0,2),n=2,s>2&&C(r.charCodeAt(2))&&(a=!0,n=3));if(t.length>0)if(l.length>0){if(t.toLowerCase()!==l.toLowerCase())continue}else l=t;if(o){if(l.length>0)break}else if(h=`${r.slice(n)}\\${h}`,o=a,a&&l.length>0)break}return h=g(h,!o,"\\",C),o?`${l}\\${h}`:`${l}${h}`||"."},normalize(f){T(f,"path");const l=f.length;if(l===0)return".";let h=0,o,E=!1;const r=f.charCodeAt(0);if(l===1)return m(r)?"\\":f;if(C(r))if(E=!0,C(f.charCodeAt(1))){let n=2,t=n;for(;n<l&&!C(f.charCodeAt(n));)n++;if(n<l&&n!==t){const a=f.slice(t,n);for(t=n;n<l&&C(f.charCodeAt(n));)n++;if(n<l&&n!==t){for(t=n;n<l&&!C(f.charCodeAt(n));)n++;if(n===l)return`\\\\${a}\\${f.slice(t)}\\`;n!==t&&(o=`\\\\${a}\\${f.slice(t,n)}`,h=n)}}}else h=1;else v(r)&&f.charCodeAt(1)===L&&(o=f.slice(0,2),h=2,l>2&&C(f.charCodeAt(2))&&(E=!0,h=3));let s=h<l?g(f.slice(h),!E,"\\",C):"";return s.length===0&&!E&&(s="."),s.length>0&&C(f.charCodeAt(l-1))&&(s+="\\"),o===void 0?E?`\\${s}`:s:E?`${o}\\${s}`:`${o}${s}`},isAbsolute(f){T(f,"path");const l=f.length;if(l===0)return!1;const h=f.charCodeAt(0);return C(h)||l>2&&v(h)&&f.charCodeAt(1)===L&&C(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let l,h;for(let r=0;r<f.length;++r){const s=f[r];T(s,"path"),s.length>0&&(l===void 0?l=h=s:l+=`\\${s}`)}if(l===void 0)return".";let o=!0,E=0;if(typeof h=="string"&&C(h.charCodeAt(0))){++E;const r=h.length;r>1&&C(h.charCodeAt(1))&&(++E,r>2&&(C(h.charCodeAt(2))?++E:o=!1))}if(o){for(;E<l.length&&C(l.charCodeAt(E));)E++;E>=2&&(l=`\\${l.slice(E)}`)}return e.win32.normalize(l)},relative(f,l){if(T(f,"from"),T(l,"to"),f===l)return"";const h=e.win32.resolve(f),o=e.win32.resolve(l);if(h===o||(f=h.toLowerCase(),l=o.toLowerCase(),f===l))return"";let E=0;for(;E<f.length&&f.charCodeAt(E)===P;)E++;let r=f.length;for(;r-1>E&&f.charCodeAt(r-1)===P;)r--;const s=r-E;let n=0;for(;n<l.length&&l.charCodeAt(n)===P;)n++;let t=l.length;for(;t-1>n&&l.charCodeAt(t-1)===P;)t--;const a=t-n,c=s<a?s:a;let u=-1,S=0;for(;S<c;S++){const O=f.charCodeAt(E+S);if(O!==l.charCodeAt(n+S))break;O===P&&(u=S)}if(S!==c){if(u===-1)return o}else{if(a>c){if(l.charCodeAt(n+S)===P)return o.slice(n+S+1);if(S===2)return o.slice(n+S)}s>c&&(f.charCodeAt(E+S)===P?u=S:S===2&&(u=3)),u===-1&&(u=0)}let R="";for(S=E+u+1;S<=r;++S)(S===r||f.charCodeAt(S)===P)&&(R+=R.length===0?"..":"\\..");return n+=u,R.length>0?`${R}${o.slice(n,t)}`:(o.charCodeAt(n)===P&&++n,o.slice(n,t))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const l=e.win32.resolve(f);if(l.length<=2)return f;if(l.charCodeAt(0)===P){if(l.charCodeAt(1)===P){const h=l.charCodeAt(2);if(h!==I&&h!==y)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===P)return`\\\\?\\${l}`;return f},dirname(f){T(f,"path");const l=f.length;if(l===0)return".";let h=-1,o=0;const E=f.charCodeAt(0);if(l===1)return C(E)?f:".";if(C(E)){if(h=o=1,C(f.charCodeAt(1))){let n=2,t=n;for(;n<l&&!C(f.charCodeAt(n));)n++;if(n<l&&n!==t){for(t=n;n<l&&C(f.charCodeAt(n));)n++;if(n<l&&n!==t){for(t=n;n<l&&!C(f.charCodeAt(n));)n++;if(n===l)return f;n!==t&&(h=o=n+1)}}}}else v(E)&&f.charCodeAt(1)===L&&(h=l>2&&C(f.charCodeAt(2))?3:2,o=h);let r=-1,s=!0;for(let n=l-1;n>=o;--n)if(C(f.charCodeAt(n))){if(!s){r=n;break}}else s=!1;if(r===-1){if(h===-1)return".";r=h}return f.slice(0,r)},basename(f,l){l!==void 0&&T(l,"ext"),T(f,"path");let h=0,o=-1,E=!0,r;if(f.length>=2&&v(f.charCodeAt(0))&&f.charCodeAt(1)===L&&(h=2),l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let s=l.length-1,n=-1;for(r=f.length-1;r>=h;--r){const t=f.charCodeAt(r);if(C(t)){if(!E){h=r+1;break}}else n===-1&&(E=!1,n=r+1),s>=0&&(t===l.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return h===o?o=n:o===-1&&(o=f.length),f.slice(h,o)}for(r=f.length-1;r>=h;--r)if(C(f.charCodeAt(r))){if(!E){h=r+1;break}}else o===-1&&(E=!1,o=r+1);return o===-1?"":f.slice(h,o)},extname(f){T(f,"path");let l=0,h=-1,o=0,E=-1,r=!0,s=0;f.length>=2&&f.charCodeAt(1)===L&&v(f.charCodeAt(0))&&(l=o=2);for(let n=f.length-1;n>=l;--n){const t=f.charCodeAt(n);if(C(t)){if(!r){o=n+1;break}continue}E===-1&&(r=!1,E=n+1),t===y?h===-1?h=n:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||E===-1||s===0||s===1&&h===E-1&&h===o+1?"":f.slice(h,E)},format:b.bind(null,"\\"),parse(f){T(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const h=f.length;let o=0,E=f.charCodeAt(0);if(h===1)return C(E)?(l.root=l.dir=f,l):(l.base=l.name=f,l);if(C(E)){if(o=1,C(f.charCodeAt(1))){let u=2,S=u;for(;u<h&&!C(f.charCodeAt(u));)u++;if(u<h&&u!==S){for(S=u;u<h&&C(f.charCodeAt(u));)u++;if(u<h&&u!==S){for(S=u;u<h&&!C(f.charCodeAt(u));)u++;u===h?o=u:u!==S&&(o=u+1)}}}}else if(v(E)&&f.charCodeAt(1)===L){if(h<=2)return l.root=l.dir=f,l;if(o=2,C(f.charCodeAt(2))){if(h===3)return l.root=l.dir=f,l;o=3}}o>0&&(l.root=f.slice(0,o));let r=-1,s=o,n=-1,t=!0,a=f.length-1,c=0;for(;a>=o;--a){if(E=f.charCodeAt(a),C(E)){if(!t){s=a+1;break}continue}n===-1&&(t=!1,n=a+1),E===y?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}return n!==-1&&(r===-1||c===0||c===1&&r===n-1&&r===s+1?l.base=l.name=f.slice(s,n):(l.name=f.slice(s,r),l.base=f.slice(s,n),l.ext=f.slice(r,n))),s>0&&s!==o?l.dir=f.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let l="",h=!1;for(let o=f.length-1;o>=-1&&!h;o--){const E=o>=0?f[o]:d.cwd();T(E,"path"),E.length!==0&&(l=`${E}/${l}`,h=E.charCodeAt(0)===w)}return l=g(l,!h,"/",m),h?`/${l}`:l.length>0?l:"."},normalize(f){if(T(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===w,h=f.charCodeAt(f.length-1)===w;return f=g(f,!l,"/",m),f.length===0?l?"/":h?"./":".":(h&&(f+="/"),l?`/${f}`:f)},isAbsolute(f){return T(f,"path"),f.length>0&&f.charCodeAt(0)===w},join(...f){if(f.length===0)return".";let l;for(let h=0;h<f.length;++h){const o=f[h];T(o,"path"),o.length>0&&(l===void 0?l=o:l+=`/${o}`)}return l===void 0?".":e.posix.normalize(l)},relative(f,l){if(T(f,"from"),T(l,"to"),f===l||(f=e.posix.resolve(f),l=e.posix.resolve(l),f===l))return"";const h=1,o=f.length,E=o-h,r=1,s=l.length-r,n=E<s?E:s;let t=-1,a=0;for(;a<n;a++){const u=f.charCodeAt(h+a);if(u!==l.charCodeAt(r+a))break;u===w&&(t=a)}if(a===n)if(s>n){if(l.charCodeAt(r+a)===w)return l.slice(r+a+1);if(a===0)return l.slice(r+a)}else E>n&&(f.charCodeAt(h+a)===w?t=a:a===0&&(t=0));let c="";for(a=h+t+1;a<=o;++a)(a===o||f.charCodeAt(a)===w)&&(c+=c.length===0?"..":"/..");return`${c}${l.slice(r+t)}`},toNamespacedPath(f){return f},dirname(f){if(T(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===w;let h=-1,o=!0;for(let E=f.length-1;E>=1;--E)if(f.charCodeAt(E)===w){if(!o){h=E;break}}else o=!1;return h===-1?l?"/":".":l&&h===1?"//":f.slice(0,h)},basename(f,l){l!==void 0&&T(l,"ext"),T(f,"path");let h=0,o=-1,E=!0,r;if(l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let s=l.length-1,n=-1;for(r=f.length-1;r>=0;--r){const t=f.charCodeAt(r);if(t===w){if(!E){h=r+1;break}}else n===-1&&(E=!1,n=r+1),s>=0&&(t===l.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return h===o?o=n:o===-1&&(o=f.length),f.slice(h,o)}for(r=f.length-1;r>=0;--r)if(f.charCodeAt(r)===w){if(!E){h=r+1;break}}else o===-1&&(E=!1,o=r+1);return o===-1?"":f.slice(h,o)},extname(f){T(f,"path");let l=-1,h=0,o=-1,E=!0,r=0;for(let s=f.length-1;s>=0;--s){const n=f.charCodeAt(s);if(n===w){if(!E){h=s+1;break}continue}o===-1&&(E=!1,o=s+1),n===y?l===-1?l=s:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||o===-1||r===0||r===1&&l===o-1&&l===h+1?"":f.slice(l,o)},format:b.bind(null,"/"),parse(f){T(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const h=f.charCodeAt(0)===w;let o;h?(l.root="/",o=1):o=0;let E=-1,r=0,s=-1,n=!0,t=f.length-1,a=0;for(;t>=o;--t){const c=f.charCodeAt(t);if(c===w){if(!n){r=t+1;break}continue}s===-1&&(n=!1,s=t+1),c===y?E===-1?E=t:a!==1&&(a=1):E!==-1&&(a=-1)}if(s!==-1){const c=r===0&&h?1:r;E===-1||a===0||a===1&&E===s-1&&E===r+1?l.base=l.name=f.slice(c,s):(l.name=f.slice(c,E),l.base=f.slice(c,s),l.ext=f.slice(E,s))}return r>0?l.dir=f.slice(0,r-1):h&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=d.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d.platform==="win32"?e.win32.join:e.posix.join,e.resolve=d.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=d.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=d.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=d.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=d.platform==="win32"?e.win32.extname:e.posix.extname,e.format=d.platform==="win32"?e.win32.format:e.posix.format,e.parse=d.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=d.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=d.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ye[94],De([0,1,9]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(I){I.text="text/plain",I.binary="application/octet-stream",I.unknown="application/unknown",I.markdown="text/markdown",I.latex="text/latex",I.uriList="text/uri-list"})(i=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(I){const D=(0,d.extname)(I),T=_[D.toLowerCase()];return T!==void 0?T:y(I)}e.getMediaOrTextMime=k;function y(I){const D=(0,d.extname)(I);return A[D.toLowerCase()]}e.getMediaMime=y;function w(I){for(const D in A)if(A[D]===I)return D}e.getExtensionForMimeType=w;const P=/^(.+)\/(.+?)(;.+)?$/;function L(I,D){const T=P.exec(I);return T?`${T[1].toLowerCase()}/${T[2].toLowerCase()}${T[3]??""}`:D?void 0:I}e.normalizeMimeType=L}),define(ye[95],De([0,1,12]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var _;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(_=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(y,...w){const P=w.reduce((D,T)=>(D[T]=!0,D),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(D=>!P[D]).forEach(D=>{for(let T=0;T<L.length;T++)if(D.search(L[T])!==-1){delete y[D];break}})}e.sanitizeProcessEnvironment=A;function k(y){!y||(delete y.DEBUG,d.isMacintosh&&delete y.DYLD_LIBRARY_PATH,d.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var d=e();for(var i in d)(typeof exports=="object"?exports:Y)[i]=d[i]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function d(i){if(e[i])return e[i].exports;var _=e[i]={i,l:!1,exports:{}};return Y[i].call(_.exports,_,_.exports,d),_.l=!0,_.exports}return d.m=Y,d.c=e,d.d=function(i,_,A){d.o(i,_)||Object.defineProperty(i,_,{enumerable:!0,get:A})},d.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},d.t=function(i,_){if(1&_&&(i=d(i)),8&_||4&_&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(d.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&_&&typeof i!="string")for(var k in i)d.d(A,k,function(y){return i[y]}.bind(null,k));return A},d.n=function(i){var _=i&&i.__esModule?function(){return i.default}:function(){return i};return d.d(_,"a",_),_},d.o=function(i,_){return Object.prototype.hasOwnProperty.call(i,_)},d.p="",d(d.s=0)}([function(Y,e,d){(function(i){var _;e=Y.exports=G,_=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],w=e.src=[],P=0,L=P++;w[L]="0|[1-9]\\d*";var I=P++;w[I]="[0-9]+";var D=P++;w[D]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=P++;w[T]="("+w[L]+")\\.("+w[L]+")\\.("+w[L]+")";var C=P++;w[C]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var m=P++;w[m]="(?:"+w[L]+"|"+w[D]+")";var v=P++;w[v]="(?:"+w[I]+"|"+w[D]+")";var g=P++;w[g]="(?:-("+w[m]+"(?:\\."+w[m]+")*))";var b=P++;w[b]="(?:-?("+w[v]+"(?:\\."+w[v]+")*))";var f=P++;w[f]="[0-9A-Za-z-]+";var l=P++;w[l]="(?:\\+("+w[f]+"(?:\\."+w[f]+")*))";var h=P++,o="v?"+w[T]+w[g]+"?"+w[l]+"?";w[h]="^"+o+"$";var E="[v=\\s]*"+w[C]+w[b]+"?"+w[l]+"?",r=P++;w[r]="^"+E+"$";var s=P++;w[s]="((?:<|>)?=?)";var n=P++;w[n]=w[I]+"|x|X|\\*";var t=P++;w[t]=w[L]+"|x|X|\\*";var a=P++;w[a]="[v=\\s]*("+w[t]+")(?:\\.("+w[t]+")(?:\\.("+w[t]+")(?:"+w[g]+")?"+w[l]+"?)?)?";var c=P++;w[c]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[b]+")?"+w[l]+"?)?)?";var u=P++;w[u]="^"+w[s]+"\\s*"+w[a]+"$";var S=P++;w[S]="^"+w[s]+"\\s*"+w[c]+"$";var R=P++;w[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=P++;w[O]="(?:~>?)";var N=P++;w[N]="(\\s*)"+w[O]+"\\s+",y[N]=new RegExp(w[N],"g");var p=P++;w[p]="^"+w[O]+w[a]+"$";var M=P++;w[M]="^"+w[O]+w[c]+"$";var U=P++;w[U]="(?:\\^)";var z=P++;w[z]="(\\s*)"+w[U]+"\\s+",y[z]=new RegExp(w[z],"g");var re=P++;w[re]="^"+w[U]+w[a]+"$";var H=P++;w[H]="^"+w[U]+w[c]+"$";var F=P++;w[F]="^"+w[s]+"\\s*("+E+")$|^$";var j=P++;w[j]="^"+w[s]+"\\s*("+o+")$|^$";var x=P++;w[x]="(\\s*)"+w[s]+"\\s*("+E+"|"+w[a]+")",y[x]=new RegExp(w[x],"g");var V=P++;w[V]="^\\s*("+w[a]+")\\s+-\\s+("+w[a]+")\\s*$";var ne=P++;w[ne]="^\\s*("+w[c]+")\\s+-\\s+("+w[c]+")\\s*$";var Q=P++;w[Q]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)_(he,w[he]),y[he]||(y[he]=new RegExp(w[he]));function fe(K,ae){if(K instanceof G)return K;if(typeof K!="string"||K.length>A||!(ae?y[r]:y[h]).test(K))return null;try{return new G(K,ae)}catch{return null}}function G(K,ae){if(K instanceof G){if(K.loose===ae)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof G))return new G(K,ae);_("SemVer",K,ae),this.loose=ae;var de=K.trim().match(ae?y[r]:y[h]);if(!de)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var $e=+Be;if($e>=0&&$e<k)return $e}return Be}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=fe,e.valid=function(K,ae){var de=fe(K,ae);return de?de.version:null},e.clean=function(K,ae){var de=fe(K.trim().replace(/^[=v]+/,""),ae);return de?de.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(K){return _("SemVer.compare",this.version,this.loose,K),K instanceof G||(K=new G(K,this.loose)),this.compareMain(K)||this.comparePre(K)},G.prototype.compareMain=function(K){return K instanceof G||(K=new G(K,this.loose)),ce(this.major,K.major)||ce(this.minor,K.minor)||ce(this.patch,K.patch)},G.prototype.comparePre=function(K){if(K instanceof G||(K=new G(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var ae=0;do{var de=this.prerelease[ae],Be=K.prerelease[ae];if(_("prerelease compare",ae,de,Be),de===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(de===void 0)return-1;if(de!==Be)return ce(de,Be)}while(++ae)},G.prototype.inc=function(K,ae){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,ae,de,Be){typeof de=="string"&&(Be=de,de=void 0);try{return new G(K,de).inc(ae,Be).version}catch{return null}},e.diff=function(K,ae){if(Ce(K,ae))return null;var de=fe(K),Be=fe(ae);if(de.prerelease.length||Be.prerelease.length){for(var $e in de)if(($e==="major"||$e==="minor"||$e==="patch")&&de[$e]!==Be[$e])return"pre"+$e;return"prerelease"}for(var $e in de)if(($e==="major"||$e==="minor"||$e==="patch")&&de[$e]!==Be[$e])return $e},e.compareIdentifiers=ce;var X=/^[0-9]+$/;function ce(K,ae){var de=X.test(K),Be=X.test(ae);return de&&Be&&(K=+K,ae=+ae),de&&!Be?-1:Be&&!de?1:K<ae?-1:K>ae?1:0}function pe(K,ae,de){return new G(K,de).compare(new G(ae,de))}function Ie(K,ae,de){return pe(K,ae,de)>0}function Re(K,ae,de){return pe(K,ae,de)<0}function Ce(K,ae,de){return pe(K,ae,de)===0}function ke(K,ae,de){return pe(K,ae,de)!==0}function Ae(K,ae,de){return pe(K,ae,de)>=0}function ue(K,ae,de){return pe(K,ae,de)<=0}function ve(K,ae,de,Be){var $e;switch(ae){case"===":typeof K=="object"&&(K=K.version),typeof de=="object"&&(de=de.version),$e=K===de;break;case"!==":typeof K=="object"&&(K=K.version),typeof de=="object"&&(de=de.version),$e=K!==de;break;case"":case"=":case"==":$e=Ce(K,de,Be);break;case"!=":$e=ke(K,de,Be);break;case">":$e=Ie(K,de,Be);break;case">=":$e=Ae(K,de,Be);break;case"<":$e=Re(K,de,Be);break;case"<=":$e=ue(K,de,Be);break;default:throw new TypeError("Invalid operator: "+ae)}return $e}function ie(K,ae){if(K instanceof ie){if(K.loose===ae)return K;K=K.value}if(!(this instanceof ie))return new ie(K,ae);_("comparator",K,ae),this.loose=ae,this.parse(K),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,_("comp",this)}e.rcompareIdentifiers=function(K,ae){return ce(ae,K)},e.major=function(K,ae){return new G(K,ae).major},e.minor=function(K,ae){return new G(K,ae).minor},e.patch=function(K,ae){return new G(K,ae).patch},e.compare=pe,e.compareLoose=function(K,ae){return pe(K,ae,!0)},e.rcompare=function(K,ae,de){return pe(ae,K,de)},e.sort=function(K,ae){return K.sort(function(de,Be){return e.compare(de,Be,ae)})},e.rsort=function(K,ae){return K.sort(function(de,Be){return e.rcompare(de,Be,ae)})},e.gt=Ie,e.lt=Re,e.eq=Ce,e.neq=ke,e.gte=Ae,e.lte=ue,e.cmp=ve,e.Comparator=ie;var oe={};function we(K,ae){if(K instanceof we)return K.loose===ae?K:new we(K.raw,ae);if(K instanceof ie)return new we(K.value,ae);if(!(this instanceof we))return new we(K,ae);if(this.loose=ae,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Te(K){return!K||K.toLowerCase()==="x"||K==="*"}function B(K,ae,de,Be,$e,Ne,Xe,ee,se,be,le,_e,Fe){return((ae=Te(de)?"":Te(Be)?">="+de+".0.0":Te($e)?">="+de+"."+Be+".0":">="+ae)+" "+(ee=Te(se)?"":Te(be)?"<"+(+se+1)+".0.0":Te(le)?"<"+se+"."+(+be+1)+".0":_e?"<="+se+"."+be+"."+le+"-"+_e:"<="+ee)).trim()}function q(K,ae){for(var de=0;de<K.length;de++)if(!K[de].test(ae))return!1;if(ae.prerelease.length){for(de=0;de<K.length;de++)if(_(K[de].semver),K[de].semver!==oe&&K[de].semver.prerelease.length>0){var Be=K[de].semver;if(Be.major===ae.major&&Be.minor===ae.minor&&Be.patch===ae.patch)return!0}return!1}return!0}function J(K,ae,de){try{ae=new we(ae,de)}catch{return!1}return ae.test(K)}function te(K,ae,de,Be){var $e,Ne,Xe,ee,se;switch(K=new G(K,Be),ae=new we(ae,Be),de){case">":$e=Ie,Ne=ue,Xe=Re,ee=">",se=">=";break;case"<":$e=Re,Ne=Ae,Xe=Ie,ee="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(J(K,ae,Be))return!1;for(var be=0;be<ae.set.length;++be){var le=ae.set[be],_e=null,Fe=null;if(le.forEach(function(He){He.semver===oe&&(He=new ie(">=0.0.0")),_e=_e||He,Fe=Fe||He,$e(He.semver,_e.semver,Be)?_e=He:Xe(He.semver,Fe.semver,Be)&&(Fe=He)}),_e.operator===ee||_e.operator===se||(!Fe.operator||Fe.operator===ee)&&Ne(K,Fe.semver)||Fe.operator===se&&Xe(K,Fe.semver))return!1}return!0}ie.prototype.parse=function(K){var ae=this.loose?y[F]:y[j],de=K.match(ae);if(!de)throw new TypeError("Invalid comparator: "+K);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new G(de[2],this.loose):this.semver=oe},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(K){return _("Comparator.test",K,this.loose),this.semver===oe||(typeof K=="string"&&(K=new G(K,this.loose)),ve(K,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(K,ae){if(!(K instanceof ie))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new we(K.value,ae),J(this.value,de,ae);if(K.operator==="")return de=new we(this.value,ae),J(K.semver,de,ae);var Be=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),$e=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Ne=this.semver.version===K.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),ee=ve(this.semver,"<",K.semver,ae)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),se=ve(this.semver,">",K.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return Be||$e||Ne&&Xe||ee||se},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(K){var ae=this.loose;K=K.trim(),_("range",K,ae);var de=ae?y[ne]:y[V];K=K.replace(de,B),_("hyphen replace",K),K=K.replace(y[x],"$1$2$3"),_("comparator trim",K,y[x]),K=(K=(K=K.replace(y[N],"$1~")).replace(y[z],"$1^")).split(/\s+/).join(" ");var Be=ae?y[F]:y[j],$e=K.split(" ").map(function(Ne){return function(Xe,ee){return _("comp",Xe),Xe=function(se,be){return se.trim().split(/\s+/).map(function(le){return function(_e,Fe){_("caret",_e,Fe);var He=Fe?y[H]:y[re];return _e.replace(He,function(qe,Ge,Ze,Qe,rt){var tt;return _("caret",_e,qe,Ge,Ze,Qe,rt),Te(Ge)?tt="":Te(Ze)?tt=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":Te(Qe)?tt=Ge==="0"?">="+Ge+"."+Ze+".0 <"+Ge+"."+(+Ze+1)+".0":">="+Ge+"."+Ze+".0 <"+(+Ge+1)+".0.0":rt?(_("replaceCaret pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),tt=Ge==="0"?Ze==="0"?">="+Ge+"."+Ze+"."+Qe+rt+" <"+Ge+"."+Ze+"."+(+Qe+1):">="+Ge+"."+Ze+"."+Qe+rt+" <"+Ge+"."+(+Ze+1)+".0":">="+Ge+"."+Ze+"."+Qe+rt+" <"+(+Ge+1)+".0.0"):(_("no pr"),tt=Ge==="0"?Ze==="0"?">="+Ge+"."+Ze+"."+Qe+" <"+Ge+"."+Ze+"."+(+Qe+1):">="+Ge+"."+Ze+"."+Qe+" <"+Ge+"."+(+Ze+1)+".0":">="+Ge+"."+Ze+"."+Qe+" <"+(+Ge+1)+".0.0"),_("caret return",tt),tt})}(le,be)}).join(" ")}(Xe,ee),_("caret",Xe),Xe=function(se,be){return se.trim().split(/\s+/).map(function(le){return function(_e,Fe){var He=Fe?y[M]:y[p];return _e.replace(He,function(qe,Ge,Ze,Qe,rt){var tt;return _("tilde",_e,qe,Ge,Ze,Qe,rt),Te(Ge)?tt="":Te(Ze)?tt=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":Te(Qe)?tt=">="+Ge+"."+Ze+".0 <"+Ge+"."+(+Ze+1)+".0":rt?(_("replaceTilde pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),tt=">="+Ge+"."+Ze+"."+Qe+rt+" <"+Ge+"."+(+Ze+1)+".0"):tt=">="+Ge+"."+Ze+"."+Qe+" <"+Ge+"."+(+Ze+1)+".0",_("tilde return",tt),tt})}(le,be)}).join(" ")}(Xe,ee),_("tildes",Xe),Xe=function(se,be){return _("replaceXRanges",se,be),se.split(/\s+/).map(function(le){return function(_e,Fe){_e=_e.trim();var He=Fe?y[S]:y[u];return _e.replace(He,function(qe,Ge,Ze,Qe,rt,tt){_("xRange",_e,qe,Ge,Ze,Qe,rt,tt);var pt=Te(Ze),nt=pt||Te(Qe),ut=nt||Te(rt);return Ge==="="&&ut&&(Ge=""),pt?qe=Ge===">"||Ge==="<"?"<0.0.0":"*":Ge&&ut?(nt&&(Qe=0),ut&&(rt=0),Ge===">"?(Ge=">=",nt?(Ze=+Ze+1,Qe=0,rt=0):ut&&(Qe=+Qe+1,rt=0)):Ge==="<="&&(Ge="<",nt?Ze=+Ze+1:Qe=+Qe+1),qe=Ge+Ze+"."+Qe+"."+rt):nt?qe=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":ut&&(qe=">="+Ze+"."+Qe+".0 <"+Ze+"."+(+Qe+1)+".0"),_("xRange return",qe),qe})}(le,be)}).join(" ")}(Xe,ee),_("xrange",Xe),Xe=function(se,be){return _("replaceStars",se,be),se.trim().replace(y[Q],"")}(Xe,ee),_("stars",Xe),Xe}(Ne,ae)}).join(" ").split(/\s+/);return this.loose&&($e=$e.filter(function(Ne){return!!Ne.match(Be)})),$e=$e.map(function(Ne){return new ie(Ne,ae)})},we.prototype.intersects=function(K,ae){if(!(K instanceof we))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Be){return K.set.some(function($e){return $e.every(function(Ne){return Be.intersects(Ne,ae)})})})})},e.toComparators=function(K,ae){return new we(K,ae).set.map(function(de){return de.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new G(K,this.loose));for(var ae=0;ae<this.set.length;ae++)if(q(this.set[ae],K))return!0;return!1},e.satisfies=J,e.maxSatisfying=function(K,ae,de){var Be=null,$e=null;try{var Ne=new we(ae,de)}catch{return null}return K.forEach(function(Xe){Ne.test(Xe)&&(Be&&$e.compare(Xe)!==-1||($e=new G(Be=Xe,de)))}),Be},e.minSatisfying=function(K,ae,de){var Be=null,$e=null;try{var Ne=new we(ae,de)}catch{return null}return K.forEach(function(Xe){Ne.test(Xe)&&(Be&&$e.compare(Xe)!==1||($e=new G(Be=Xe,de)))}),Be},e.validRange=function(K,ae){try{return new we(K,ae).range||"*"}catch{return null}},e.ltr=function(K,ae,de){return te(K,ae,"<",de)},e.gtr=function(K,ae,de){return te(K,ae,">",de)},e.outside=te,e.prerelease=function(K,ae){var de=fe(K,ae);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(K,ae,de){return K=new we(K,de),ae=new we(ae,de),K.intersects(ae)},e.coerce=function(K){if(K instanceof G)return K;if(typeof K!="string")return null;var ae=K.match(y[R]);return ae==null?null:fe((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,d(1))},function(Y,e){var d,i,_=Y.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function y(v){if(d===setTimeout)return setTimeout(v,0);if((d===A||!d)&&setTimeout)return d=setTimeout,setTimeout(v,0);try{return d(v,0)}catch{try{return d.call(null,v,0)}catch{return d.call(this,v,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:A}catch{d=A}try{i=typeof clearTimeout=="function"?clearTimeout:k}catch{i=k}})();var w,P=[],L=!1,I=-1;function D(){L&&w&&(L=!1,w.length?P=w.concat(P):I=-1,P.length&&T())}function T(){if(!L){var v=y(D);L=!0;for(var g=P.length;g;){for(w=P,P=[];++I<g;)w&&w[I].run();I=-1,g=P.length}w=null,L=!1,function(b){if(i===clearTimeout)return clearTimeout(b);if((i===k||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(b);try{i(b)}catch{try{return i.call(null,b)}catch{return i.call(this,b)}}}(v)}}function C(v,g){this.fun=v,this.array=g}function m(){}_.nextTick=function(v){var g=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)g[b-1]=arguments[b];P.push(new C(v,g)),P.length!==1||L||y(T)},C.prototype.run=function(){this.fun.apply(null,this.array)},_.title="browser",_.browser=!0,_.env={},_.argv=[],_.version="",_.versions={},_.on=m,_.addListener=m,_.once=m,_.off=m,_.removeListener=m,_.removeAllListeners=m,_.emit=m,_.prependListener=m,_.prependOnceListener=m,_.listeners=function(v){return[]},_.binding=function(v){throw new Error("process.binding is not supported")},_.cwd=function(){return"/"},_.chdir=function(v){throw new Error("process.chdir is not supported")},_.umask=function(){return 0}}])}),define(ye[48],De([0,1,12]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=d.globals.performance&&typeof d.globals.performance.now=="function";class _{constructor(k){this._highResolution=i&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new _(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?d.globals.performance.now():Date.now()}}e.StopWatch=_}),define(ye[3],De([0,1,11,77,6,92,48]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let y=!1,w=!1;var P;(function(t){t.None=()=>_.Disposable.None;function a(fe){if(w){const{onListenerDidAdd:G}=fe,X=C.create();let ce=0;fe.onListenerDidAdd=()=>{++ce==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),G?.()}}}function c(fe){return(G,X=null,ce)=>{let pe=!1,Ie;return Ie=fe(Re=>{if(!pe)return Ie?Ie.dispose():pe=!0,G.call(X,Re)},null,ce),pe&&Ie.dispose(),Ie}}t.once=c;function u(fe,G,X){return M((ce,pe=null,Ie)=>fe(Re=>ce.call(pe,G(Re)),null,Ie),X)}t.map=u;function S(fe,G,X){return M((ce,pe=null,Ie)=>fe(Re=>{G(Re),ce.call(pe,Re)},null,Ie),X)}t.forEach=S;function R(fe,G,X){return M((ce,pe=null,Ie)=>fe(Re=>G(Re)&&ce.call(pe,Re),null,Ie),X)}t.filter=R;function O(fe){return fe}t.signal=O;function N(...fe){return(G,X=null,ce)=>(0,_.combinedDisposable)(...fe.map(pe=>pe(Ie=>G.call(X,Ie),null,ce)))}t.any=N;function p(fe,G,X,ce){let pe=X;return u(fe,Ie=>(pe=G(pe,Ie),pe),ce)}t.reduce=p;function M(fe,G){let X;const ce={onFirstListenerAdd(){X=fe(pe.fire,pe)},onLastListenerRemove(){X.dispose()}};G||a(ce);const pe=new v(ce);return G&&G.add(pe),pe.event}function U(fe,G,X=100,ce=!1,pe,Ie){let Re,Ce,ke,Ae=0;const ue={leakWarningThreshold:pe,onFirstListenerAdd(){Re=fe(ie=>{Ae++,Ce=G(Ce,ie),ce&&!ke&&(ve.fire(Ce),Ce=void 0),clearTimeout(ke),ke=setTimeout(()=>{const oe=Ce;Ce=void 0,ke=void 0,(!ce||Ae>1)&&ve.fire(oe),Ae=0},X)})},onLastListenerRemove(){Re.dispose()}};Ie||a(ue);const ve=new v(ue);return Ie&&Ie.add(ve),ve.event}t.debounce=U;function z(fe,G=(ce,pe)=>ce===pe,X){let ce=!0,pe;return R(fe,Ie=>{const Re=ce||!G(Ie,pe);return ce=!1,pe=Ie,Re},X)}t.latch=z;function re(fe,G,X){return[t.filter(fe,G,X),t.filter(fe,ce=>!G(ce),X)]}t.split=re;function H(fe,G=!1,X=[]){let ce=X.slice(),pe=fe(Ce=>{ce?ce.push(Ce):Re.fire(Ce)});const Ie=()=>{ce&&ce.forEach(Ce=>Re.fire(Ce)),ce=null},Re=new v({onFirstListenerAdd(){pe||(pe=fe(Ce=>Re.fire(Ce)))},onFirstListenerDidAdd(){ce&&(G?setTimeout(Ie):Ie())},onLastListenerRemove(){pe&&pe.dispose(),pe=null}});return Re.event}t.buffer=H;class F{constructor(G){this.event=G}map(G){return new F(u(this.event,G))}forEach(G){return new F(S(this.event,G))}filter(G){return new F(R(this.event,G))}reduce(G,X){return new F(p(this.event,G,X))}latch(){return new F(z(this.event))}debounce(G,X=100,ce=!1,pe){return new F(U(this.event,G,X,ce,pe))}on(G,X,ce){return this.event(G,X,ce)}once(G,X,ce){return c(this.event)(G,X,ce)}}function j(fe){return new F(fe)}t.chain=j;function x(fe,G,X=ce=>ce){const ce=(...Ce)=>Re.fire(X(...Ce)),pe=()=>fe.on(G,ce),Ie=()=>fe.removeListener(G,ce),Re=new v({onFirstListenerAdd:pe,onLastListenerRemove:Ie});return Re.event}t.fromNodeEventEmitter=x;function V(fe,G,X=ce=>ce){const ce=(...Ce)=>Re.fire(X(...Ce)),pe=()=>fe.addEventListener(G,ce),Ie=()=>fe.removeEventListener(G,ce),Re=new v({onFirstListenerAdd:pe,onLastListenerRemove:Ie});return Re.event}t.fromDOMEventEmitter=V;function ne(fe){return new Promise(G=>c(fe)(G))}t.toPromise=ne;function Q(fe,G){return G(void 0),fe(X=>G(X))}t.runAndSubscribe=Q;function he(fe,G){let X=null;function ce(Ie){X?.dispose(),X=new _.DisposableStore,G(Ie,X)}ce(void 0);const pe=fe(Ie=>ce(Ie));return(0,_.toDisposable)(()=>{pe.dispose(),X?.dispose()})}t.runAndSubscribeWithStore=he})(P=e.Event||(e.Event={}));class L{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${L._idPool++}`}start(a){this._stopWatch=new k.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}L._idPool=0;let I=-1;function D(t){const a=I;return I=t,{dispose(){I=a}}}e.setGlobalLeakWarningThreshold=D;class T{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,c){let u=I;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||c<u)return;this._stacks||(this._stacks=new Map);const S=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,S+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let R,O=0;for(const[N,p]of this._stacks)(!R||O<p)&&(R=N,O=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${O}):`),console.warn(R)}return()=>{const R=this._stacks.get(a.value)||0;this._stacks.set(a.value,R-1)}}}class C{constructor(a){this.value=a}static create(){return new C(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(a,c,u){this.callback=a,this.callbackThis=c,this.stack=u,this.subscription=new _.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class v{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=I>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const c of a)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,c,u)=>{this._listeners||(this._listeners=new A.LinkedList);const S=this._listeners.isEmpty();S&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,O;this._leakageMon&&this._listeners.size>=30&&(O=C.create(),R=this._leakageMon.check(O,this._listeners.size+1)),y&&(O=O??C.create());const N=new m(a,c,O),p=this._listeners.push(N);S&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const M=N.subscription.set(()=>{R&&R(),this._disposed||(p(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof _.DisposableStore?u.add(M):Array.isArray(u)&&u.push(M),M}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b);for(let c of this._listeners)this._deliveryQueue.push(this,c,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class g{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(a,c,u){this._queue.push(new f(a,c,u))}clear(a){const c=new A.LinkedList;for(const u of this._queue)u.emitter!==a&&c.push(u);this._queue=c}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(c){(0,d.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=g;class b extends g{clear(a){this._queue.clear()}}class f{constructor(a,c,u){this.emitter=a,this.listener=c,this.event=u}}class l extends v{async fireAsync(a,c,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const S of this._listeners)this._asyncDeliveryQueue.push([S,a]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[S,R]=this._asyncDeliveryQueue.shift(),O=[],N={...R,token:c,waitUntil:p=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");u&&(p=u(p,S.callback)),O.push(p)}};try{S.invoke(N)}catch(p){(0,d.onUnexpectedError)(p);continue}Object.freeze(O),await Promise.allSettled(O).then(p=>{for(const M of p)M.status==="rejected"&&(0,d.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=l;class h extends v{constructor(a){super(a);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class o extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=o;class E extends v{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const u=()=>{this.hasListeners&&this.unhook(c);const S=this.events.indexOf(c);this.events.splice(S,1)};return(0,_.toDisposable)((0,i.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(a){return(c,u,S)=>a(R=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>c.call(u,R)):c.call(u,R)},void 0,S)}bufferEvents(a){const c=[];this.buffers.push(c);const u=a();return this.buffers.pop(),c.forEach(S=>S()),u}}e.EventBufferer=s;class n{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=_.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=n}),define(ye[21],De([0,1,3]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(y,w){const P=setTimeout(y.bind(w),0);return{dispose(){clearTimeout(P)}}});var _;(function(y){function w(P){return P===y.None||P===y.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}y.isCancellationToken=w,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(_=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new d.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=_.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=_.None}}e.CancellationTokenSource=k}),define(ye[146],De([0,1,21]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new d.CancellationTokenSource,w=this.task(y.token);return this.result={promise:w,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=i;class _{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const w=JSON.stringify(y);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=_;class A{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const w=this.fn(y);return this._map.set(y,w),w}}e.CachedFunction=A}),define(ye[96],De([0,1,11,6]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function _(l){const h=l;return h?typeof h.read=="function":!1}e.isReadable=_;function A(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function k(l){const h=l;return h?A(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=k;function y(l,h){return new w(l,h)}e.newWriteableStream=y;class w{constructor(h,o){this.reducer=h,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(o=>o(h))}emitError(h){this.listeners.error.length===0?(0,d.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(o=>o(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,o){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(h,o){if(this.state.destroyed)return;let E;switch(h){case"data":E=this.listeners.data;break;case"end":E=this.listeners.end;break;case"error":E=this.listeners.error;break}if(E){const r=E.indexOf(o);r>=0&&E.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(E=>E())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(l,h){const o=[];let E;for(;(E=l.read())!==null;)o.push(E);return h(o)}e.consumeReadable=P;function L(l,h,o){const E=[];let r;for(;(r=l.read())!==null&&E.length<o;)E.push(r);return r===null&&E.length>0?h(E):{read:()=>{if(E.length>0)return E.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return l.read()}}}e.peekReadable=L;function I(l,h){return new Promise((o,E)=>{const r=[];D(l,{onData:s=>{h&&r.push(s)},onError:s=>{h?E(s):o(void 0)},onEnd:()=>{o(h?h(r):void 0)}})})}e.consumeStream=I;function D(l,h){let o=!1;return l.on("error",E=>{o||h.onError(E)}),l.on("end",()=>{o||h.onEnd()}),l.on("data",E=>{o||h.onData(E)}),(0,i.toDisposable)(()=>o=!0)}e.listenStream=D;function T(l,h){return new Promise((o,E)=>{const r=new i.DisposableStore,s=[],n=c=>{if(s.push(c),s.length>h)return r.dispose(),l.pause(),o({stream:l,buffer:s,ended:!1})},t=c=>E(c),a=()=>o({stream:l,buffer:s,ended:!0});r.add((0,i.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),r.add((0,i.toDisposable)(()=>l.removeListener("end",a))),l.on("end",a),r.add((0,i.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=T;function C(l,h){const o=y(h);return o.end(l),o}e.toStream=C;function m(){const l=y(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=m;function v(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=v;function g(l,h,o){const E=y(o);return D(l,{onData:r=>E.write(h.data(r)),onError:r=>E.error(h.error?h.error(r):r),onEnd:()=>E.end()}),E}e.transform=g;function b(l,h,o){let E=!1;return{read:()=>{const r=h.read();return E?r:(E=!0,r!==null?o([l,r]):l)}}}e.prefixedReadable=b;function f(l,h,o){let E=!1;const r=y(o);return D(h,{onData:s=>E?r.write(s):(E=!0,r.write(o([l,s]))),onError:s=>r.error(s),onEnd:()=>{E||(E=!0,r.write(l)),r.end()}}),r}e.prefixedStream=f}),define(ye[23],De([0,1,96]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let _,A;class k{constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}static alloc(c){return i?new k(Buffer.allocUnsafe(c)):new k(new Uint8Array(c))}static wrap(c){return i&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new k(c)}static fromString(c,u){return!(u?.dontUseNodeBuffer||!1)&&i?new k(Buffer.from(c)):(_||(_=new TextEncoder),new k(_.encode(c)))}static fromByteArray(c){const u=k.alloc(c.length);for(let S=0,R=c.length;S<R;S++)u.buffer[S]=c[S];return u}static concat(c,u){if(typeof u=="undefined"){u=0;for(let O=0,N=c.length;O<N;O++)u+=c[O].byteLength}const S=k.alloc(u);let R=0;for(let O=0,N=c.length;O<N;O++){const p=c[O];S.set(p,R),R+=p.byteLength}return S}clone(){const c=k.alloc(this.byteLength);return c.set(this),c}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(c,u){return new k(this.buffer.subarray(c,u))}set(c,u){if(c instanceof k)this.buffer.set(c.buffer,u);else if(c instanceof Uint8Array)this.buffer.set(c,u);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),u);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return P(this.buffer,c)}writeUInt32BE(c,u){L(this.buffer,c,u)}readUInt32LE(c){return I(this.buffer,c)}writeUInt32LE(c,u){D(this.buffer,c,u)}readUInt8(c){return T(this.buffer,c)}writeUInt8(c,u){C(this.buffer,c,u)}}e.VSBuffer=k;function y(a,c){return a[c+0]<<0>>>0|a[c+1]<<8>>>0}e.readUInt16LE=y;function w(a,c,u){a[u+0]=c&255,c=c>>>8,a[u+1]=c&255}e.writeUInt16LE=w;function P(a,c){return a[c]*2**24+a[c+1]*2**16+a[c+2]*2**8+a[c+3]}e.readUInt32BE=P;function L(a,c,u){a[u+3]=c,c=c>>>8,a[u+2]=c,c=c>>>8,a[u+1]=c,c=c>>>8,a[u]=c}e.writeUInt32BE=L;function I(a,c){return a[c+0]<<0>>>0|a[c+1]<<8>>>0|a[c+2]<<16>>>0|a[c+3]<<24>>>0}e.readUInt32LE=I;function D(a,c,u){a[u+0]=c&255,c=c>>>8,a[u+1]=c&255,c=c>>>8,a[u+2]=c&255,c=c>>>8,a[u+3]=c&255}e.writeUInt32LE=D;function T(a,c){return a[c]}e.readUInt8=T;function C(a,c,u){a[u]=c}e.writeUInt8=C;function m(a){return d.consumeReadable(a,c=>k.concat(c))}e.readableToBuffer=m;function v(a){return d.toReadable(a)}e.bufferToReadable=v;function g(a){return d.consumeStream(a,c=>k.concat(c))}e.streamToBuffer=g;async function b(a){return a.ended?k.concat(a.buffer):k.concat([...a.buffer,await g(a.stream)])}e.bufferedStreamToBuffer=b;function f(a){return d.toStream(a,c=>k.concat(c))}e.bufferToStream=f;function l(a){return d.transform(a,{data:c=>typeof c=="string"?k.fromString(c):k.wrap(c)},c=>k.concat(c))}e.streamToBufferReadableStream=l;function h(a){return d.newWriteableStream(c=>k.concat(c),a)}e.newWriteableBufferStream=h;function o(a,c){return d.prefixedReadable(a,c,u=>k.concat(u))}e.prefixedBufferReadable=o;function E(a,c){return d.prefixedStream(a,c,u=>k.concat(u))}e.prefixedBufferStream=E;function r(a){let c=0,u=0,S=0;const R=new Uint8Array(Math.floor(a.length/4*3)),O=p=>{switch(u){case 3:R[S++]=c|p,u=0;break;case 2:R[S++]=c|p>>>2,c=p<<6,u=3;break;case 1:R[S++]=c|p>>>4,c=p<<4,u=2;break;default:c=p<<2,u=1}};for(let p=0;p<a.length;p++){const M=a.charCodeAt(p);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${a[p]}`)}}const N=S;for(;u>0;)O(0);return k.wrap(R).slice(0,N)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:a},c=!0,u=!1){const S=u?n:s;let R="";const O=a.byteLength%3;let N=0;for(;N<a.byteLength-O;N+=3){const p=a[N+0],M=a[N+1],U=a[N+2];R+=S[p>>>2],R+=S[(p<<4|M>>>4)&63],R+=S[(M<<2|U>>>6)&63],R+=S[U&63]}if(O===1){const p=a[N+0];R+=S[p>>>2],R+=S[p<<4&63],c&&(R+="==")}else if(O===2){const p=a[N+0],M=a[N+1];R+=S[p>>>2],R+=S[(p<<4|M>>>4)&63],R+=S[M<<2&63],c&&(R+="=")}return R}e.encodeBase64=t}),define(ye[8],De([0,1,146,80]),function(Y,e,d,i){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=A;const k=/{(\d+)}/g;function y(le,..._e){return _e.length===0?le:le.replace(k,function(Fe,He){const qe=parseInt(He,10);return isNaN(qe)||qe<0||qe>=_e.length?Fe:_e[qe]})}e.format=y;const w=/{([^}]+)}/g;function P(le,_e){return le.replace(w,(Fe,He)=>_e[He]??Fe)}e.format2=P;function L(le){return le.replace(/[<>&]/g,function(_e){switch(_e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _e}})}e.escape=L;function I(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function D(le,_e){let Fe=0;const He=_e.charCodeAt(0);for(let qe=le.length-1;qe>=0;qe--)le.charCodeAt(qe)===He&&Fe++;return Fe}e.count=D;function T(le,_e,Fe="\u2026"){return le.length<=_e?le:`${le.substr(0,_e)}${Fe}`}e.truncate=T;function C(le,_e=" "){const Fe=m(le,_e);return v(Fe,_e)}e.trim=C;function m(le,_e){if(!le||!_e)return le;const Fe=_e.length;if(Fe===0||le.length===0)return le;let He=0;for(;le.indexOf(_e,He)===He;)He=He+Fe;return le.substring(He)}e.ltrim=m;function v(le,_e){if(!le||!_e)return le;const Fe=_e.length,He=le.length;if(Fe===0||He===0)return le;let qe=He,Ge=-1;for(;Ge=le.lastIndexOf(_e,qe-1),!(Ge===-1||Ge+Fe!==qe);){if(Ge===0)return"";qe=Ge}return le.substring(0,qe)}e.rtrim=v;function g(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function b(le){return le.replace(/\*/g,"")}e.stripWildcards=b;function f(le,_e,Fe={}){if(!le)throw new Error("Cannot create regex from empty string");_e||(le=I(le)),Fe.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let He="";return Fe.global&&(He+="g"),Fe.matchCase||(He+="i"),Fe.multiline&&(He+="m"),Fe.unicode&&(He+="u"),new RegExp(le,He)}e.createRegExp=f;function l(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function h(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function o(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=o;function E(le){return le.split(/\r\n|\r|\n/)}e.splitLines=E;function r(le){for(let _e=0,Fe=le.length;_e<Fe;_e++){const He=le.charCodeAt(_e);if(He!==32&&He!==9)return _e}return-1}e.firstNonWhitespaceIndex=r;function s(le,_e=0,Fe=le.length){for(let He=_e;He<Fe;He++){const qe=le.charCodeAt(He);if(qe!==32&&qe!==9)return le.substring(_e,He)}return le.substring(_e,Fe)}e.getLeadingWhitespace=s;function n(le,_e=le.length-1){for(let Fe=_e;Fe>=0;Fe--){const He=le.charCodeAt(Fe);if(He!==32&&He!==9)return Fe}return-1}e.lastNonWhitespaceIndex=n;function t(le,_e,Fe){let He=[],qe=0;for(const Ge of le.matchAll(_e)){if(He.push(le.slice(qe,Ge.index)),Ge.index===void 0)throw new Error("match.index should be defined");qe=Ge.index+Ge[0].length,He.push(Fe(Ge[0],...Ge.slice(1),Ge.index,le,Ge.groups))}return He.push(le.slice(qe)),Promise.all(He).then(Ge=>Ge.join(""))}e.replaceAsync=t;function a(le,_e){return le<_e?-1:le>_e?1:0}e.compare=a;function c(le,_e,Fe=0,He=le.length,qe=0,Ge=_e.length){for(;Fe<He&&qe<Ge;Fe++,qe++){let rt=le.charCodeAt(Fe),tt=_e.charCodeAt(qe);if(rt<tt)return-1;if(rt>tt)return 1}const Ze=He-Fe,Qe=Ge-qe;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=c;function u(le,_e){return S(le,_e,0,le.length,0,_e.length)}e.compareIgnoreCase=u;function S(le,_e,Fe=0,He=le.length,qe=0,Ge=_e.length){for(;Fe<He&&qe<Ge;Fe++,qe++){let rt=le.charCodeAt(Fe),tt=_e.charCodeAt(qe);if(rt===tt)continue;if(rt>=128||tt>=128)return c(le.toLowerCase(),_e.toLowerCase(),Fe,He,qe,Ge);R(rt)&&(rt-=32),R(tt)&&(tt-=32);const pt=rt-tt;if(pt!==0)return pt}const Ze=He-Fe,Qe=Ge-qe;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=S;function R(le){return le>=97&&le<=122}e.isLowerAsciiLetter=R;function O(le){return le>=65&&le<=90}e.isUpperAsciiLetter=O;function N(le,_e){return le.length===_e.length&&S(le,_e)===0}e.equalsIgnoreCase=N;function p(le,_e){const Fe=_e.length;return _e.length>le.length?!1:S(le,_e,0,Fe)===0}e.startsWithIgnoreCase=p;function M(le,_e){let Fe,He=Math.min(le.length,_e.length);for(Fe=0;Fe<He;Fe++)if(le.charCodeAt(Fe)!==_e.charCodeAt(Fe))return Fe;return He}e.commonPrefixLength=M;function U(le,_e){let Fe,He=Math.min(le.length,_e.length);const qe=le.length-1,Ge=_e.length-1;for(Fe=0;Fe<He;Fe++)if(le.charCodeAt(qe-Fe)!==_e.charCodeAt(Ge-Fe))return Fe;return He}e.commonSuffixLength=U;function z(le){return 55296<=le&&le<=56319}e.isHighSurrogate=z;function re(le){return 56320<=le&&le<=57343}e.isLowSurrogate=re;function H(le,_e){return(le-55296<<10)+(_e-56320)+65536}e.computeCodePoint=H;function F(le,_e,Fe){const He=le.charCodeAt(Fe);if(z(He)&&Fe+1<_e){const qe=le.charCodeAt(Fe+1);if(re(qe))return H(He,qe)}return He}e.getNextCodePoint=F;function j(le,_e){const Fe=le.charCodeAt(_e-1);if(re(Fe)&&_e>1){const He=le.charCodeAt(_e-2);if(z(He))return H(He,Fe)}return Fe}class x{constructor(_e,Fe=0){this._str=_e,this._len=_e.length,this._offset=Fe}get offset(){return this._offset}setOffset(_e){this._offset=_e}prevCodePoint(){const _e=j(this._str,this._offset);return this._offset-=_e>=65536?2:1,_e}nextCodePoint(){const _e=F(this._str,this._len,this._offset);return this._offset+=_e>=65536?2:1,_e}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class V{constructor(_e,Fe=0){this._iterator=new x(_e,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const _e=de.getInstance(),Fe=this._iterator,He=Fe.offset;let qe=_e.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const Ge=Fe.offset,Ze=_e.getGraphemeBreakType(Fe.nextCodePoint());if(K(qe,Ze)){Fe.setOffset(Ge);break}qe=Ze}return Fe.offset-He}prevGraphemeLength(){const _e=de.getInstance(),Fe=this._iterator,He=Fe.offset;let qe=_e.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const Ge=Fe.offset,Ze=_e.getGraphemeBreakType(Fe.prevCodePoint());if(K(Ze,qe)){Fe.setOffset(Ge);break}qe=Ze}return He-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function ne(le,_e){return new V(le,_e).nextGraphemeLength()}e.nextCharLength=ne;function Q(le,_e){return new V(le,_e).prevGraphemeLength()}e.prevCharLength=Q;function he(le,_e){_e>0&&re(le.charCodeAt(_e))&&_e--;const Fe=_e+ne(le,_e);return[Fe-Q(le,Fe),Fe]}e.getCharContainingOffset=he;const fe=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(le){return fe.test(le)}e.containsRTL=G;const X=/^[\t\n\r\x20-\x7E]*$/;function ce(le){return X.test(le)}e.isBasicASCII=ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function pe(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=pe;function Ie(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Ie;function Re(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129008||le>=129280&&le<=129535||le>=129648&&le<=129782}e.isEmojiImprecise=Re;function Ce(le,_e){if(le.length<_e)return le;const Fe=/\b/g;let He=0;for(;Fe.test(le)&&!(le.length-Fe.lastIndex<_e);)He=Fe.lastIndex,Fe.lastIndex+=1;return le.substring(He).replace(/^\s/,"")}e.lcut=Ce;const ke=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,ue=/\x1b\[0?m/g;function ve(le){return le&&(le=le.replace(ke,""),le=le.replace(Ae,""),le=le.replace(ue,"")),le}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ie(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ie;function oe(le){return ie(le)?le.substr(1):le}e.stripUTF8BOM=oe;function we(le,_e){if(!le||!_e||le.length<_e.length)return!1;const Fe=_e.length,He=le.toLowerCase();let qe=0,Ge=-1;for(;qe<Fe;){const Ze=He.indexOf(_e[qe],Ge+1);if(Ze<0)return!1;Ge=Ze,qe++}return!0}e.fuzzyContains=we;function Te(le,_e=!1){return le?(_e&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=Te;function B(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=B;function q(le,_e=1){if(_e===0)return"";let Fe=-1;do Fe=le.indexOf(`
`,Fe+1),_e--;while(_e>0&&Fe>=0);return Fe===-1?le:(le[Fe-1]==="\r"&&Fe--,le.substr(0,Fe))}e.getNLines=q;function J(le){const _e=90-65+1;return le=le%(2*_e),le<_e?String.fromCharCode(97+le):String.fromCharCode(65+le-_e)}e.singleLetterHash=J;function te(le){return de.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=te;function K(le,_e){return le===0?_e!==5&&_e!==7:le===2&&_e===3?!1:le===4||le===2||le===3||_e===4||_e===2||_e===3?!0:!(le===8&&(_e===8||_e===9||_e===11||_e===12)||(le===11||le===9)&&(_e===9||_e===10)||(le===12||le===10)&&_e===10||_e===5||_e===13||_e===7||le===1||le===13&&_e===14||le===6&&_e===6)}var ae;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class de{constructor(){this._data=Be()}static getInstance(){return de._INSTANCE||(de._INSTANCE=new de),de._INSTANCE}getGraphemeBreakType(_e){if(_e<32)return _e===10?3:_e===13?2:4;if(_e<127)return 0;const Fe=this._data,He=Fe.length/3;let qe=1;for(;qe<=He;)if(_e<Fe[3*qe])qe=2*qe;else if(_e>Fe[3*qe+1])qe=2*qe+1;else return Fe[3*qe+2];return 0}}de._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(le,_e){if(le===0)return 0;const Fe=Ne(le,_e);if(Fe!==void 0)return Fe;const He=new x(_e,le);return He.prevCodePoint(),He.offset}e.getLeftDeleteOffset=$e;function Ne(le,_e){const Fe=new x(_e,le);let He=Fe.prevCodePoint();for(;Xe(He)||He===65039||He===8419;){if(Fe.offset===0)return;He=Fe.prevCodePoint()}if(!Re(He))return;let qe=Fe.offset;return qe>0&&Fe.prevCodePoint()===8205&&(qe=Fe.offset),qe}function Xe(le){return 127995<=le&&le<=127999}var ee;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class se{constructor(_e){this.confusableDictionary=_e}static getInstance(_e){return se.cache.get(Array.from(_e))}static getLocales(){return se._locales.getValue()}isAmbiguous(_e){return this.confusableDictionary.has(_e)}getPrimaryConfusable(_e){return this.confusableDictionary.get(_e)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,_=se,se.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new d.LRUCachedFunction(le=>{function _e(tt){const pt=new Map;for(let nt=0;nt<tt.length;nt+=2)pt.set(tt[nt],tt[nt+1]);return pt}function Fe(tt,pt){const nt=new Map(tt);for(const[ut,Pt]of pt)nt.set(ut,Pt);return nt}function He(tt,pt){if(!tt)return pt;const nt=new Map;for(const[ut,Pt]of tt)pt.has(ut)&&nt.set(ut,Pt);return nt}const qe=_.ambiguousCharacterData.getValue();let Ge=le.filter(tt=>!tt.startsWith("_")&&tt in qe);Ge.length===0&&(Ge=["_default"]);let Ze;for(const tt of Ge){const pt=_e(qe[tt]);Ze=He(Ze,pt)}const Qe=_e(qe._common),rt=Fe(Qe,Ze);return new se(rt)}),se._locales=new i.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(le=>!le.startsWith("_")));class be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(be.getRawData())),this._data}static isInvisibleCharacter(_e){return be.getData().has(_e)}static get codePoints(){return be.getData()}}e.InvisibleCharacters=be,be._data=void 0}),define(ye[59],De([0,1,8]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(g){return _(g,0)}e.hash=i;function _(g,b){switch(typeof g){case"object":return g===null?A(349,b):Array.isArray(g)?w(g,b):P(g,b);case"string":return y(g,b);case"boolean":return k(g,b);case"number":return A(g,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=_;function A(g,b){return(b<<5)-b+g|0}e.numberHash=A;function k(g,b){return A(g?433:863,b)}function y(g,b){b=A(149417,b);for(let f=0,l=g.length;f<l;f++)b=A(g.charCodeAt(f),b);return b}e.stringHash=y;function w(g,b){return b=A(104579,b),g.reduce((f,l)=>_(l,f),b)}function P(g,b){return b=A(181387,b),Object.keys(g).sort().reduce((f,l)=>(f=y(l,f),_(g[l],f)),b)}class L{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=_(b,this._value),this._value}}e.Hasher=L;var I;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function D(g,b,f=32){const l=f-b,h=~((1<<l)-1);return(g<<b|(h&g)>>>l)>>>0}function T(g,b=0,f=g.byteLength,l=0){for(let h=0;h<f;h++)g[b+h]=l}function C(g,b,f="0"){for(;g.length<b;)g=f+g;return g}function m(g,b=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):C((g>>>0).toString(16),b/4)}e.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const f=b.length;if(f===0)return;const l=this._buff;let h=this._buffLen,o=this._leftoverHighSurrogate,E,r;for(o!==0?(E=o,r=-1,o=0):(E=b.charCodeAt(0),r=0);;){let s=E;if(d.isHighSurrogate(E))if(r+1<f){const n=b.charCodeAt(r+1);d.isLowSurrogate(n)?(r++,s=d.computeCodePoint(E,n)):s=65533}else{o=E;break}else d.isLowSurrogate(E)&&(s=65533);if(h=this._push(l,h,s),r++,r<f)E=b.charCodeAt(r);else break}this._buffLen=h,this._leftoverHighSurrogate=o}_push(b,f,l){return l<128?b[f++]=l:l<2048?(b[f++]=192|(l&1984)>>>6,b[f++]=128|(l&63)>>>0):l<65536?(b[f++]=224|(l&61440)>>>12,b[f++]=128|(l&4032)>>>6,b[f++]=128|(l&63)>>>0):(b[f++]=240|(l&1835008)>>>18,b[f++]=128|(l&258048)>>>12,b[f++]=128|(l&4032)>>>6,b[f++]=128|(l&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,f=this._buffDV;for(let a=0;a<64;a+=4)b.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)b.setUint32(a,D(b.getUint32(a-12,!1)^b.getUint32(a-32,!1)^b.getUint32(a-56,!1)^b.getUint32(a-64,!1),1),!1);let l=this._h0,h=this._h1,o=this._h2,E=this._h3,r=this._h4,s,n,t;for(let a=0;a<80;a++)a<20?(s=h&o|~h&E,n=1518500249):a<40?(s=h^o^E,n=1859775393):a<60?(s=h&o|h&E|o&E,n=2400959708):(s=h^o^E,n=3395469782),t=D(l,5)+s+r+n+b.getUint32(a*4,!1)&4294967295,r=E,E=o,o=D(h,30),h=l,l=t;this._h0=this._h0+l&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[24],De([0,1,16,8]),function(Y,e,d,i){"use strict";var _,A,k,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function w(n,t,a){let c=n.get(t);return c===void 0&&(c=a,n.set(t,c)),c}e.getOrSet=w;function P(n){const t=[];return n.forEach((a,c)=>{t.push(`${c} => ${a}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=P;function L(n){const t=[];return n.forEach(a=>{t.push(a)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=L;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const a=t.charCodeAt(0),c=this._value.charCodeAt(this._pos);return a-c}value(){return this._value[this._pos]}}e.StringIterator=I;class D{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class T{constructor(t=!0,a=!0){this._splitOnBackslash=t,this._caseSensitive=a}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let a=t.length-1;a>=0;a--,this._valueLen--){const c=this._value.charCodeAt(a);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var C;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(C||(C={}));class m{constructor(t,a){this._ignorePathCasing=t,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(g||(g={}));class b{constructor(t){this._iter=t}static forUris(t=()=>!1,a=()=>!1){return new b(new m(t,a))}static forPaths(t=!1){return new b(new T(void 0,!t))}static forStrings(){return new b(new I)}static forConfigKeys(){return new b(new D)}clear(){this._root=void 0}fill(t,a){if(a){const c=a.slice(0);(0,d.shuffle)(c);for(let u of c)this.set(u,t)}else{const c=t.slice(0);(0,d.shuffle)(c);for(let u of c)this.set(u[0],u[1])}}set(t,a){const c=this._iter.reset(t);let u;this._root||(this._root=new v,this._root.segment=c.value());const S=[];for(u=this._root;;){const O=c.cmp(u.segment);if(O>0)u.left||(u.left=new v,u.left.segment=c.value()),S.push([-1,u]),u=u.left;else if(O<0)u.right||(u.right=new v,u.right.segment=c.value()),S.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new v,u.mid.segment=c.value()),S.push([0,u]),u=u.mid;else break}const R=u.value;u.value=a,u.key=t;for(let O=S.length-1;O>=0;O--){const N=S[O][1];N.updateHeight();const p=N.balanceFactor();if(p<-1||p>1){const M=S[O][0],U=S[O+1][0];if(M===1&&U===1)S[O][1]=N.rotateLeft();else if(M===-1&&U===-1)S[O][1]=N.rotateRight();else if(M===1&&U===-1)N.right=S[O+1][1]=S[O+1][1].rotateRight(),S[O][1]=N.rotateLeft();else if(M===-1&&U===1)N.left=S[O+1][1]=S[O+1][1].rotateLeft(),S[O][1]=N.rotateRight();else throw new Error;if(O>0)switch(S[O-1][0]){case-1:S[O-1][1].left=S[O][1];break;case 1:S[O-1][1].right=S[O][1];break;case 0:S[O-1][1].mid=S[O][1];break}else this._root=S[0][1]}}return R}get(t){return this._getNode(t)?.value}_getNode(t){const a=this._iter.reset(t);let c=this._root;for(;c;){const u=a.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(a.hasNext())a.next(),c=c.mid;else break}return c}has(t){const a=this._getNode(t);return!(a?.value===void 0&&a?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,a){const c=this._iter.reset(t),u=[];let S=this._root;for(;S;){const R=c.cmp(S.segment);if(R>0)u.push([-1,S]),S=S.left;else if(R<0)u.push([1,S]),S=S.right;else if(c.hasNext())c.next(),u.push([0,S]),S=S.mid;else break}if(!!S){if(a?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const R=this._min(S.right),{key:O,value:N,segment:p}=R;this._delete(R.key,!1),S.key=O,S.value=N,S.segment=p}else{const R=S.left??S.right;if(u.length>0){const[O,N]=u[u.length-1];switch(O){case-1:N.left=R;break;case 0:N.mid=R;break;case 1:N.right=R;break}}else this._root=R}for(let R=u.length-1;R>=0;R--){const O=u[R][1];O.updateHeight();const N=O.balanceFactor();if(N>1?(O.right.balanceFactor()>=0||(O.right=O.right.rotateRight()),u[R][1]=O.rotateLeft()):N<-1&&(O.left.balanceFactor()<=0||(O.left=O.left.rotateLeft()),u[R][1]=O.rotateRight()),R>0)switch(u[R-1][0]){case-1:u[R-1][1].left=u[R][1];break;case 1:u[R-1][1].right=u[R][1];break;case 0:u[R-1][1].mid=u[R][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const a=this._iter.reset(t);let c=this._root,u;for(;c;){const S=a.cmp(c.segment);if(S>0)c=c.left;else if(S<0)c=c.right;else if(a.hasNext())a.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(t){const a=this._iter.reset(t);let c=this._root;for(;c;){const u=a.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(a.hasNext())a.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(t){for(const[a,c]of this)t(c,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=a=>{if(!a)return!0;const c=a.balanceFactor();return c<-1||c>1?!1:t(a.left)&&t(a.right)};return t(this._root)}}e.TernarySearchTree=b;class f{constructor(t,a){this.uri=t,this.value=a}}class l{constructor(t,a){this[_]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=a??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,a){return this.map.set(this.toKey(t),new f(t,a)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,a){typeof a!="undefined"&&(t=t.bind(a));for(let[c,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=l,l.defaultToKey=n=>n.toString();class h{constructor(t,a){this[A]="ResourceSet",!t||typeof t=="function"?this._map=new l(t):(this._map=new l(a),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,a){this._map.forEach((c,u)=>t.call(a,u,u,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var o;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class E{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,a=0){const c=this._map.get(t);if(!!c)return a!==0&&this.touch(c,a),c.value}set(t,a,c=0){let u=this._map.get(t);if(u)u.value=a,c!==0&&this.touch(u,c);else{switch(u={key:t,value:a,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this._map.get(t);if(!!a)return this._map.delete(t),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,a){const c=this._state;let u=this._head;for(;u;){if(a?t.bind(a)(u.value,u.key,this):t(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,a=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return u}values(){const t=this,a=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return u}entries(){const t=this,a=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this._head,c=this.size;for(;a&&c>t;)this._map.delete(a.key),a=a.next,c--;this._head=a,this._size=c,a&&(a.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const a=t.next,c=t.previous;if(!a||!c)throw new Error("Invalid list");a.previous=c,c.next=a}t.next=void 0,t.previous=void 0,this._state++}touch(t,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this._head)return;const c=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(a===2){if(t===this._tail)return;const c=t.next,u=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((a,c)=>{t.push([c,a])}),t}fromJSON(t){this.clear();for(const[a,c]of t)this.set(a,c)}}e.LinkedMap=E;class r extends E{constructor(t,a=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{constructor(t){y.set(this,void 0),et(this,y,t,"f")}get size(){return Ue(this,y,"f").size}forEach(t,a){Ue(this,y,"f").forEach(t,a)}get(t){return Ue(this,y,"f").get(t)}has(t){return Ue(this,y,"f").has(t)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=s}),define(ye[97],De([0,1,24,8]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...ie){return function(oe,we){for(let Te=0,B=ie.length;Te<B;Te++){const q=ie[Te](oe,we);if(q)return q}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ie,oe,we){if(!we||we.length<oe.length)return null;let Te;return ie?Te=i.startsWithIgnoreCase(we,oe):Te=we.indexOf(oe)===0,Te?oe.length>0?[{start:0,end:oe.length}]:[]:null}function k(ie,oe){const we=oe.toLowerCase().indexOf(ie.toLowerCase());return we===-1?null:[{start:we,end:we+ie.length}]}e.matchesContiguousSubString=k;function y(ie,oe){return w(ie.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=y;function w(ie,oe,we,Te){if(we===ie.length)return[];if(Te===oe.length)return null;if(ie[we]===oe[Te]){let B=null;return(B=w(ie,oe,we+1,Te+1))?g({start:Te,end:Te+1},B):null}return w(ie,oe,we,Te+1)}function P(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function I(ie){return 48<=ie&&ie<=57}function D(ie){return ie===32||ie===9||ie===10||ie===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>T.add(ie.charCodeAt(0)));function C(ie){return D(ie)||T.has(ie)}function m(ie,oe){return ie===oe||C(ie)&&C(oe)}function v(ie){return P(ie)||L(ie)||I(ie)}function g(ie,oe){return oe.length===0?oe=[ie]:ie.end===oe[0].start?oe[0].start=ie.start:oe.unshift(ie),oe}function b(ie,oe){for(let we=oe;we<ie.length;we++){const Te=ie.charCodeAt(we);if(L(Te)||I(Te)||we>0&&!v(ie.charCodeAt(we-1)))return we}return ie.length}function f(ie,oe,we,Te){if(we===ie.length)return[];if(Te===oe.length)return null;if(ie[we]!==oe[Te].toLowerCase())return null;{let B=null,q=Te+1;for(B=f(ie,oe,we+1,Te+1);!B&&(q=b(oe,q))<oe.length;)B=f(ie,oe,we+1,q),q++;return B===null?null:g({start:Te,end:Te+1},B)}}function l(ie){let oe=0,we=0,Te=0,B=0,q=0;for(let de=0;de<ie.length;de++)q=ie.charCodeAt(de),L(q)&&oe++,P(q)&&we++,v(q)&&Te++,I(q)&&B++;const J=oe/ie.length,te=we/ie.length,K=Te/ie.length,ae=B/ie.length;return{upperPercent:J,lowerPercent:te,alphaPercent:K,numericPercent:ae}}function h(ie){const{upperPercent:oe,lowerPercent:we}=ie;return we===0&&oe>.6}function o(ie){const{upperPercent:oe,lowerPercent:we,alphaPercent:Te,numericPercent:B}=ie;return we>.2&&oe<.8&&Te>.6&&B<.2}function E(ie){let oe=0,we=0,Te=0,B=0;for(let q=0;q<ie.length;q++)Te=ie.charCodeAt(q),L(Te)&&oe++,P(Te)&&we++,D(Te)&&B++;return(oe===0||we===0)&&B===0?ie.length<=30:oe<=5}function r(ie,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!E(ie)||oe.length>60)return null;const we=l(oe);if(!o(we)){if(!h(we))return null;oe=oe.toLowerCase()}let Te=null,B=0;for(ie=ie.toLowerCase();B<oe.length&&(Te=f(ie,oe,0,B))===null;)B=b(oe,B+1);return Te}e.matchesCamelCase=r;function s(ie,oe,we=!1){if(!oe||oe.length===0)return null;let Te=null,B=0;for(ie=ie.toLowerCase(),oe=oe.toLowerCase();B<oe.length&&(Te=n(ie,oe,0,B,we))===null;)B=t(oe,B+1);return Te}e.matchesWords=s;function n(ie,oe,we,Te,B){if(we===ie.length)return[];if(Te===oe.length)return null;if(m(ie.charCodeAt(we),oe.charCodeAt(Te))){let q=null,J=Te+1;if(q=n(ie,oe,we+1,Te+1,B),!B)for(;!q&&(J=t(oe,J))<oe.length;)q=n(ie,oe,we+1,J,B),J++;return q===null?null:g({start:Te,end:Te+1},q)}else return null}function t(ie,oe){for(let we=oe;we<ie.length;we++)if(C(ie.charCodeAt(we))||we>0&&C(ie.charCodeAt(we-1)))return we;return ie.length}const a=_(e.matchesPrefix,r,k),c=_(e.matchesPrefix,r,y),u=new d.LRUCache(1e4);function S(ie,oe,we=!1){if(typeof ie!="string"||typeof oe!="string")return null;let Te=u.get(ie);Te||(Te=new RegExp(i.convertSimple2RegExpPattern(ie),"i"),u.set(ie,Te));const B=Te.exec(oe);return B?[{start:B.index,end:B.index+B[0].length}]:we?c(ie,oe):a(ie,oe)}e.matchesFuzzy=S;function R(ie,oe){const we=Ie(ie,ie.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?N(we):null}e.matchesFuzzy2=R;function O(ie,oe,we,Te,B,q){const J=Math.min(13,ie.length);for(;we<J;we++){const te=Ie(ie,oe,we,Te,B,q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(te)return te}return[0,q]}e.anyScore=O;function N(ie){if(typeof ie=="undefined")return[];const oe=[],we=ie[1];for(let Te=ie.length-1;Te>1;Te--){const B=ie[Te]+we,q=oe[oe.length-1];q&&q.end===B?q.end=B+1:oe.push({start:B,end:B+1})}return oe}e.createMatches=N;const p=128;function M(){const ie=[],oe=[];for(let we=0;we<=p;we++)oe[we]=0;for(let we=0;we<=p;we++)ie.push(oe.slice(0));return ie}function U(ie){const oe=[];for(let we=0;we<=ie;we++)oe[we]=0;return oe}const z=U(2*p),re=U(2*p),H=M(),F=M(),j=M(),x=!1;function V(ie,oe,we,Te,B){function q(te,K,ae=" "){for(;te.length<K;)te=ae+te;return te}let J=` |   |${Te.split("").map(te=>q(te,3)).join("|")}
`;for(let te=0;te<=we;te++)te===0?J+=" |":J+=`${oe[te-1]}|`,J+=ie[te].slice(0,B+1).map(K=>q(K.toString(),3)).join("|")+`
`;return J}function ne(ie,oe,we,Te){ie=ie.substr(oe),we=we.substr(Te),console.log(V(F,ie,ie.length,we,we.length)),console.log(V(j,ie,ie.length,we,we.length)),console.log(V(H,ie,ie.length,we,we.length))}function Q(ie,oe){if(oe<0||oe>=ie.length)return!1;const we=ie.codePointAt(oe);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(we)}}function he(ie,oe){if(oe<0||oe>=ie.length)return!1;switch(ie.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function fe(ie,oe,we){return oe[ie]!==we[ie]}function G(ie,oe,we,Te,B,q,J=!1){for(;oe<we&&B<q;)ie[oe]===Te[B]&&(J&&(z[oe]=B),oe+=1),B+=1;return oe===we}e.isPatternInWord=G;var X;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(X||(X={}));var ce;(function(ie){ie.Default=[-100,0];function oe(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}ie.isDefault=oe})(ce=e.FuzzyScore||(e.FuzzyScore={}));class pe{constructor(oe,we){this.firstMatchCanBeWeak=oe,this.boostFullMatch=we}}e.FuzzyScoreOptions=pe,pe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ie(ie,oe,we,Te,B,q,J=pe.default){const te=ie.length>p?p:ie.length,K=Te.length>p?p:Te.length;if(we>=te||q>=K||te-we>K-q||!G(oe,we,te,B,q,K,!0))return;Re(te,K,we,q,oe,B);let ae=1,de=1,Be=we,$e=q;const Ne=[!1];for(ae=1,Be=we;Be<te;ae++,Be++){const le=z[Be],_e=re[Be],Fe=Be+1<te?re[Be+1]:K;for(de=le-q+1,$e=le;$e<Fe;de++,$e++){let He=Number.MIN_SAFE_INTEGER,qe=!1;$e<=_e&&(He=Ce(ie,oe,Be,we,Te,B,$e,K,q,H[ae-1][de-1]===0,Ne));let Ge=0;He!==Number.MAX_SAFE_INTEGER&&(qe=!0,Ge=He+F[ae-1][de-1]);const Ze=$e>le,Qe=Ze?F[ae][de-1]+(H[ae][de-1]>0?-5:0):0,rt=$e>le+1&&H[ae][de-1]>0,tt=rt?F[ae][de-2]+(H[ae][de-2]>0?-5:0):0;if(rt&&(!Ze||tt>=Qe)&&(!qe||tt>=Ge))F[ae][de]=tt,j[ae][de]=3,H[ae][de]=0;else if(Ze&&(!qe||Qe>=Ge))F[ae][de]=Qe,j[ae][de]=2,H[ae][de]=0;else if(qe)F[ae][de]=Ge,j[ae][de]=1,H[ae][de]=H[ae-1][de-1]+1;else throw new Error("not possible")}}if(x&&ne(ie,we,Te,q),!Ne[0]&&!J.firstMatchCanBeWeak)return;ae--,de--;const Xe=[F[ae][de],q];let ee=0,se=0;for(;ae>=1;){let le=de;do{const _e=j[ae][le];if(_e===3)le=le-2;else if(_e===2)le=le-1;else break}while(le>=1);ee>1&&oe[we+ae-1]===B[q+de-1]&&!fe(le+q-1,Te,B)&&ee+1>H[ae][le]&&(le=de),le===de?ee++:ee=1,se||(se=le),ae--,de=le-1,Xe.push(de)}K===te&&J.boostFullMatch&&(Xe[0]+=2);const be=se-te;return Xe[0]-=be,Xe}e.fuzzyScore=Ie;function Re(ie,oe,we,Te,B,q){let J=ie-1,te=oe-1;for(;J>=we&&te>=Te;)B[J]===q[te]&&(re[J]=te,J--),te--}function Ce(ie,oe,we,Te,B,q,J,te,K,ae,de){if(oe[we]!==q[J])return Number.MIN_SAFE_INTEGER;let Be=1,$e=!1;return J===we-Te?Be=ie[we]===B[J]?7:5:fe(J,B,q)&&(J===0||!fe(J-1,B,q))?(Be=ie[we]===B[J]?7:5,$e=!0):Q(q,J)&&(J===0||!Q(q,J-1))?Be=5:(Q(q,J-1)||he(q,J-1))&&(Be=5,$e=!0),Be>1&&we===Te&&(de[0]=!0),$e||($e=fe(J,B,q)||Q(q,J-1)||he(q,J-1)),we===Te?J>K&&(Be-=$e?3:5):ae?Be+=$e?2:0:Be+=$e?0:1,J+1===te&&(Be-=$e?3:5),Be}function ke(ie,oe,we,Te,B,q,J){return ue(ie,oe,we,Te,B,q,!0,J)}e.fuzzyScoreGracefulAggressive=ke;function Ae(ie,oe,we,Te,B,q,J){return ue(ie,oe,we,Te,B,q,!1,J)}e.fuzzyScoreGraceful=Ae;function ue(ie,oe,we,Te,B,q,J,te){let K=Ie(ie,oe,we,Te,B,q,te);if(K&&!J)return K;if(ie.length>=3){const ae=Math.min(7,ie.length-1);for(let de=we+1;de<ae;de++){const Be=ve(ie,de);if(Be){const $e=Ie(Be,Be.toLowerCase(),we,Te,B,q,te);$e&&($e[0]-=3,(!K||$e[0]>K[0])&&(K=$e))}}}return K}function ve(ie,oe){if(oe+1>=ie.length)return;const we=ie[oe],Te=ie[oe+1];if(we!==Te)return ie.slice(0,oe)+Te+we+ie.slice(oe+2)}}),define(ye[147],De([0,1,76,97,8]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(d.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${A.source}`,"g");function w(v){return v.replace(y,(g,b)=>b?g:`\\${g}`)}e.escapeIcons=w;const P=new RegExp(`\\\\${A.source}`,"g");function L(v){return v.replace(P,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function D(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(I,(g,b,f,l)=>f?g:b||l||"")}e.stripIcons=D;function T(v){const g=v.indexOf(e.iconStartMarker);return g===-1?{text:v}:C(v,g)}e.parseLabelWithIcons=T;function C(v,g){const b=[];let f="";function l(a){if(a){f+=a;for(const c of a)b.push(E)}}let h=-1,o="",E=0,r,s,n=g;const t=v.length;for(l(v.substr(0,g));n<t;)r=v[n],s=v[n+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=n,l(o),o=e.iconStartMarker,n++):r===")"&&h!==-1?(E+=n-h+1,h=-1,o=""):h!==-1?k.test(r)?o+=r:(l(o),h=-1,o=""):l(r),n++;return l(o),{text:f,iconOffsets:b}}function m(v,g,b=!1){const{text:f,iconOffsets:l}=g;if(!l||l.length===0)return(0,i.matchesFuzzy)(v,f,b);const h=(0,_.ltrim)(f," "),o=f.length-h.length,E=(0,i.matchesFuzzy)(v,h,b);if(E)for(const r of E){const s=l[r.start+o]+o;r.start+=s,r.end+=s}return E}e.matchesFuzzyIconAware=m}),define(ye[81],De([0,1,24]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new d.LRUCache(1e4);function _(P){return w(P,"NFC",i)}e.normalizeNFC=_;const A=new d.LRUCache(1e4);function k(P){return w(P,"NFD",A)}e.normalizeNFD=k;const y=/[^\u0000-\u0080]/;function w(P,L,I){if(!P)return P;const D=I.get(P);if(D)return D;let T;return y.test(P)?T=P.normalize(L):T=P,I.set(P,T),T}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(L){return k(L).replace(P,"")}}()}),define(ye[43],De([0,1,8]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(i||(i={})),function(_){const A="error",k="warning",y="warn",w="info",P="ignore";function L(D){return D?d.equalsIgnoreCase(A,D)?_.Error:d.equalsIgnoreCase(k,D)||d.equalsIgnoreCase(y,D)?_.Warning:d.equalsIgnoreCase(w,D)?_.Info:_.Ignore:_.Ignore}_.fromValue=L;function I(D){switch(D){case _.Error:return A;case _.Warning:return k;case _.Info:return w;default:return P}}_.toString=I}(i||(i={})),e.default=i}),define(ye[14],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function d(a){return Array.isArray(a)}e.isArray=d;function i(a){return typeof a=="string"}e.isString=i;function _(a){return Array.isArray(a)&&a.every(c=>i(c))}e.isStringArray=_;function A(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=A;function k(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=k;function y(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=y;function w(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=w;function P(a){return a===!0||a===!1}e.isBoolean=P;function L(a){return typeof a=="undefined"}e.isUndefined=L;function I(a){return!D(a)}e.isDefined=I;function D(a){return L(a)||a===null}e.isUndefinedOrNull=D;function T(a,c){if(!a)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=T;function C(a){if(D(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=C;function m(...a){const c=[];for(let u=0;u<a.length;u++){const S=a[u];if(D(S))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);c.push(S)}return c}e.assertAllDefined=m;const v=Object.prototype.hasOwnProperty;function g(a){if(!A(a))return!1;for(let c in a)if(v.call(a,c))return!1;return!0}e.isEmptyObject=g;function b(a){return typeof a=="function"}e.isFunction=b;function f(...a){return a.length>0&&a.every(b)}e.areFunctions=f;function l(a,c){const u=Math.min(a.length,c.length);for(let S=0;S<u;S++)h(a[S],c[S])}e.validateConstraints=l;function h(a,c){if(i(c)){if(typeof a!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(b(c)){try{if(a instanceof c)return}catch{}if(!D(a)&&a.constructor===c||c.length===1&&c.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function o(a){let c=[],u=Object.getPrototypeOf(a);for(;Object.prototype!==u;)c=c.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return c}e.getAllPropertyNames=o;function E(a){const c=[];for(const u of o(a))typeof a[u]=="function"&&c.push(u);return c}e.getAllMethodNames=E;function r(a,c){const u=R=>function(){const O=Array.prototype.slice.call(arguments,0);return c(R,O)};let S={};for(const R of a)S[R]=u(R);return S}e.createProxyObject=r;function s(a){return a===null?void 0:a}e.withNullAsUndefined=s;function n(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=n;function t(a,c="Unreachable"){throw new Error(c)}e.assertNever=t}),define(ye[30],De([0,1,9,12,8,14]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function y(n){return n.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=y;function w(n){return n.indexOf("/")===-1&&(n=y(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=w;function P(n,t=d.posix.sep){if(!n)return"";const a=n.length,c=n.charCodeAt(0);if(k(c)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let S=3;const R=S;for(;S<a&&!k(n.charCodeAt(S));S++);if(R!==S&&!k(n.charCodeAt(S+1))){for(S+=1;S<a;S++)if(k(n.charCodeAt(S)))return n.slice(0,S+1).replace(/[\\/]/g,t)}}return t}else if(g(c)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let u=n.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(k(n.charCodeAt(u)))return n.slice(0,u+1)}return""}e.getRoot=P;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let a=2;const c=a;for(;a<n.length&&(t=n.charCodeAt(a),t!==92);a++);return!(c===a||(t=n.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=L;const I=/[\\/:\*\?"<>\|]/g,D=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(n,t=i.isWindows){const a=t?I:D;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||t&&T.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=C;function m(n,t,a){const c=n===t;return!a||c?c:!n||!t?!1:(0,_.equalsIgnoreCase)(n,t)}e.isEqual=m;function v(n,t,a,c=d.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(a){if(!(0,_.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let S=t.length;return t.charAt(t.length-1)===c&&S--,n.charAt(S)===c}return t.charAt(t.length-1)!==c&&(t+=c),n.indexOf(t)===0}e.isEqualOrParent=v;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function b(n,t){return i.isWindows&&n.endsWith(":")&&(n+=d.sep),(0,d.isAbsolute)(n)||(n=(0,d.join)(t,n)),n=(0,d.normalize)(n),i.isWindows?(n=(0,_.rtrim)(n,d.sep),n.endsWith(":")&&(n+=d.sep)):(n=(0,_.rtrim)(n,d.sep),n||(n=d.sep)),n}e.sanitizeFilePath=b;function f(n){const t=(0,d.normalize)(n);return i.isWindows?n.length>3?!1:l(t)&&(n.length===2||t.charCodeAt(2)===92):t===d.posix.sep}e.isRootOrDriveLetter=f;function l(n,t=i.isWindows){return t?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function h(n){return l(n)?n[0]:void 0}e.getDriveLetter=h;function o(n,t,a){return t.length>n.length?-1:n===t?0:(a&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=o;function E(n){const t=n.split(":");let a,c,u;for(const S of t){const R=Number(S);(0,A.isNumber)(R)?c===void 0?c=R:u===void 0&&(u=R):a=a?[a,S].join(":"):S}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:c!==void 0?c:void 0,column:u!==void 0?u:c!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,t,a=8){let c="";for(let S=0;S<a;S++)c+=r.charAt(Math.floor(Math.random()*r.length));let u;return t?u=`${t}-${c}`:u=c,n?(0,d.join)(n,u):u}e.randomPath=s}),define(ye[26],De([0,1,14]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(g=>{m[g]&&typeof m[g]=="object"?v[g]=i(m[g]):v[g]=m[g]}),v}e.deepClone=i;function _(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const b in g)if(A.call(g,b)){const f=g[b];typeof f=="object"&&!Object.isFrozen(f)&&!(0,d.isTypedArray)(f)&&v.push(f)}}return m}e.deepFreeze=_;const A=Object.prototype.hasOwnProperty;function k(m,v){return y(m,v,new Set)}e.cloneAndChange=k;function y(m,v,g){if((0,d.isUndefinedOrNull)(m))return m;const b=v(m);if(typeof b!="undefined")return b;if((0,d.isArray)(m)){const f=[];for(const l of m)f.push(y(l,v,g));return f}if((0,d.isObject)(m)){if(g.has(m))throw new Error("Cannot clone recursive data-structure");g.add(m);const f={};for(let l in m)A.call(m,l)&&(f[l]=y(m[l],v,g));return g.delete(m),f}return m}function w(m,v,g=!0){return(0,d.isObject)(m)?((0,d.isObject)(v)&&Object.keys(v).forEach(b=>{b in m?g&&((0,d.isObject)(m[b])&&(0,d.isObject)(v[b])?w(m[b],v[b],g):m[b]=v[b]):m[b]=v[b]}),m):v}e.mixin=w;function P(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let g,b;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(g=0;g<m.length;g++)if(!P(m[g],v[g]))return!1}else{const f=[];for(b in m)f.push(b);f.sort();const l=[];for(b in v)l.push(b);if(l.sort(),!P(f,l))return!1;for(g=0;g<f.length;g++)if(!P(m[f[g]],v[f[g]]))return!1}return!0}e.equals=P;function L(m){const v=new Set;return JSON.stringify(m,(g,b)=>{if((0,d.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=L;function I(m,v,g){const b=v(m);return typeof b=="undefined"?g:b}e.getOrDefault=I;function D(m,v){const g=Object.create(null);return!m||!v||Object.keys(v).forEach(f=>{const l=m[f],h=v[f];P(l,h)||(g[f]=h)}),g}e.distinct=D;function T(m,v){const g=v.toLowerCase(),b=Object.keys(m).find(f=>f.toLowerCase()===g);return b?m[b]:m[v]}e.getCaseInsensitive=T;function C(m,v){const g=Object.create(null);for(const[b,f]of Object.entries(m))v(b,f)&&(g[b]=f);return g}e.filter=C}),define(ye[98],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var d;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d=e.Constants||(e.Constants={}));function i(A){return A<0?0:A>255?255:A|0}e.toUint8=i;function _(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=_}),define(ye[2],De([0,1,9,12]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const _=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function y(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!_.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,s){return!r&&!s?"file":r}function P(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const L="",I="/",D=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(s,n,t,a,c,u=!1){typeof s=="object"?(this.scheme=s.scheme||L,this.authority=s.authority||L,this.path=s.path||L,this.query=s.query||L,this.fragment=s.fragment||L):(this.scheme=w(s,u),this.authority=n||L,this.path=P(this.scheme,t||L),this.query=a||L,this.fragment=c||L,y(this,u))}static isUri(s){return s instanceof T?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:n,authority:t,path:a,query:c,fragment:u}=s;return n===void 0?n=this.scheme:n===null&&(n=L),t===void 0?t=this.authority:t===null&&(t=L),a===void 0?a=this.path:a===null&&(a=L),c===void 0?c=this.query:c===null&&(c=L),u===void 0?u=this.fragment:u===null&&(u=L),n===this.scheme&&t===this.authority&&a===this.path&&c===this.query&&u===this.fragment?this:new m(n,t,a,c,u)}static parse(s,n=!1){const t=D.exec(s);return t?new m(t[2]||L,E(t[4]||L),E(t[5]||L),E(t[7]||L),E(t[9]||L),n):new m(L,L,L,L,L)}static file(s){let n=L;if(i.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const t=s.indexOf(I,2);t===-1?(n=s.substring(2),s=I):(n=s.substring(2,t),s=s.substring(t)||I)}return new m("file",n,s,L,L)}static from(s){const n=new m(s.scheme,s.authority,s.path,s.query,s.fragment);return y(n,!0),n}static joinPath(s,...n){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return i.isWindows&&s.scheme==="file"?t=T.file(d.win32.join(f(s,!0),...n)).path:t=d.posix.join(s.path,...n),s.with({path:t})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof T)return s;{const n=new m(s);return n._formatted=s.external,n._fsPath=s._sep===C?s.fsPath:null,n}}else return s}}e.URI=T;const C=i.isWindows?1:void 0;class m extends T{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=C),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(r,s){let n,t=-1;for(let a=0;a<r.length;a++){const c=r.charCodeAt(a);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||s&&c===47)t!==-1&&(n+=encodeURIComponent(r.substring(t,a)),t=-1),n!==void 0&&(n+=r.charAt(a));else{n===void 0&&(n=r.substr(0,a));const u=v[c];u!==void 0?(t!==-1&&(n+=encodeURIComponent(r.substring(t,a)),t=-1),n+=u):t===-1&&(t=a)}}return t!==-1&&(n+=encodeURIComponent(r.substring(t))),n!==void 0?n:r}function b(r){let s;for(let n=0;n<r.length;n++){const t=r.charCodeAt(n);t===35||t===63?(s===void 0&&(s=r.substr(0,n)),s+=v[t]):s!==void 0&&(s+=r[n])}return s!==void 0?s:r}function f(r,s){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=f;function l(r,s){const n=s?b:g;let t="",{scheme:a,authority:c,path:u,query:S,fragment:R}=r;if(a&&(t+=a,t+=":"),(c||a==="file")&&(t+=I,t+=I),c){let O=c.indexOf("@");if(O!==-1){const N=c.substr(0,O);c=c.substr(O+1),O=N.indexOf(":"),O===-1?t+=n(N,!1):(t+=n(N.substr(0,O),!1),t+=":",t+=n(N.substr(O+1),!1)),t+="@"}c=c.toLowerCase(),O=c.indexOf(":"),O===-1?t+=n(c,!1):(t+=n(c.substr(0,O),!1),t+=c.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}t+=n(u,!0)}return S&&(t+="?",t+=n(S,!1)),R&&(t+="#",t+=s?R:g(R,!1)),t}function h(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+h(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(r){return r.match(o)?r.replace(o,s=>h(s)):r}}),define(ye[60],De([0,1,23,8,2]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,y)}e.stringify=A;function k(P){let L=JSON.parse(P);return L=w(L),L}e.parse=k;function y(P,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,i.regExpFlags)(L)}:L}function w(P,L=0){if(!P||L>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return _.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof d.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=w(P[I],L+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=w(P[I],L+1))}return P}e.revive=w}),define(ye[10],De([0,1,12,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls"})(_=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,P,L){this._hosts[w]=P,this._ports[w]=L}setConnectionToken(w,P){this._connectionTokens[w]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const P=w.authority;let L=this._hosts[P];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const I=this._ports[P],D=this._connectionTokens[P];let T=`path=${encodeURIComponent(w.path)}`;return typeof D=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),i.URI.from({scheme:d.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${L}:${I}`,path:"/vscode-remote-resource",query:T})}}e.RemoteAuthorities=new A;class k{asBrowserUri(w,P){const L=this.toUri(w,P);return L.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===_.file&&(d.isNative||d.isWebWorker&&d.globals.origin===`${_.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?L.with({scheme:_.vscodeFileResource,authority:L.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(w,P){const L=this.toUri(w,P);return L.scheme===_.vscodeFileResource?L.with({scheme:_.file,authority:L.authority!==k.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(w,P){return i.URI.isUri(w)?w:i.URI.parse(P.toUrl(w))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ye[22],De([0,1,30,10,9,12,8,2]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(T){return(0,y.uriToFsPath)(T,!0)}e.originalFSPath=w;class P{constructor(C){this._ignorePathCasing=C}compare(C,m,v=!1){return C===m?0:(0,k.compare)(this.getComparisonKey(C,v),this.getComparisonKey(m,v))}isEqual(C,m,v=!1){return C===m?!0:!C||!m?!1:this.getComparisonKey(C,v)===this.getComparisonKey(m,v)}getComparisonKey(C,m=!1){return C.with({path:this._ignorePathCasing(C)?C.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(C){return this._ignorePathCasing(C)}isEqualOrParent(C,m,v=!1){if(C.scheme===m.scheme){if(C.scheme===i.Schemas.file)return d.isEqualOrParent(w(C),w(m),this._ignorePathCasing(C))&&C.query===m.query&&(v||C.fragment===m.fragment);if((0,e.isEqualAuthority)(C.authority,m.authority))return d.isEqualOrParent(C.path,m.path,this._ignorePathCasing(C),"/")&&C.query===m.query&&(v||C.fragment===m.fragment)}return!1}joinPath(C,...m){return y.URI.joinPath(C,...m)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return _.posix.basename(C.path)}extname(C){return _.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let m;return C.scheme===i.Schemas.file?m=y.URI.file(_.dirname(w(C))).path:(m=_.posix.dirname(C.path),C.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),m="/")),C.with({path:m})}normalizePath(C){if(!C.path.length)return C;let m;return C.scheme===i.Schemas.file?m=y.URI.file(_.normalize(w(C))).path:m=_.posix.normalize(C.path),C.with({path:m})}relativePath(C,m){if(C.scheme!==m.scheme||!(0,e.isEqualAuthority)(C.authority,m.authority))return;if(C.scheme===i.Schemas.file){const b=_.relative(w(C),w(m));return A.isWindows?d.toSlashes(b):b}let v=C.path||"/",g=m.path||"/";if(this._ignorePathCasing(C)){let b=0;for(const f=Math.min(v.length,g.length);b<f&&!(v.charCodeAt(b)!==g.charCodeAt(b)&&v.charAt(b).toLowerCase()!==g.charAt(b).toLowerCase());b++);v=g.substr(0,b)+v.substr(b)}return _.posix.relative(v,g)}resolvePath(C,m){if(C.scheme===i.Schemas.file){const v=y.URI.file(_.resolve(w(C),m));return C.with({authority:v.authority,path:v.path})}return m=d.toPosixPath(m),C.with({path:_.posix.resolve(C.path,m)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,m){return C===m||C!==void 0&&m!==void 0&&(0,k.equalsIgnoreCase)(C,m)}hasTrailingPathSeparator(C,m=_.sep){if(C.scheme===i.Schemas.file){const v=w(C);return v.length>d.getRoot(v).length&&v[v.length-1]===m}else{const v=C.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,m=_.sep){return(0,e.hasTrailingPathSeparator)(C,m)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,m=_.sep){let v=!1;if(C.scheme===i.Schemas.file){const g=w(C);v=g!==void 0&&g.length===d.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=C.path;v=g.length===1&&g.charCodeAt(g.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(C,m)?C.with({path:C.path+"/"}):C}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(T=>T.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,C){const m=[];for(let v=0;v<T.length;v++){const g=C(T[v]);T.some((b,f)=>f===v?!1:(0,e.isEqualOrParent)(g,C(b)))||m.push(T[v])}return m}e.distinctParents=L;var I;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function C(m){const v=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(f=>{const[l,h]=f.split(":");l&&h&&v.set(l,h)});const b=m.path.substring(0,m.path.indexOf(";"));return b&&v.set(T.META_DATA_MIME,b),v}T.parseMetaData=C})(I=e.DataUri||(e.DataUri={}));function D(T,C,m){if(C){let v=T.path;return v&&v[0]!==_.posix.sep&&(v=_.posix.sep+v),T.with({scheme:m,authority:C,path:v})}return T.with({scheme:m})}e.toLocalResource=D}),define(ye[17],De([0,1,21,11,3,6,22,12]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=w;function P(fe){const G=new d.CancellationTokenSource,X=fe(G.token),ce=new Promise((pe,Ie)=>{const Re=G.token.onCancellationRequested(()=>{Re.dispose(),G.dispose(),Ie(new i.CancellationError)});Promise.resolve(X).then(Ce=>{Re.dispose(),G.dispose(),pe(Ce)},Ce=>{Re.dispose(),G.dispose(),Ie(Ce)})});return new class{cancel(){G.cancel()}then(pe,Ie){return ce.then(pe,Ie)}catch(pe){return this.then(void 0,pe)}finally(pe){return ce.finally(pe)}}}e.createCancelablePromise=P;function L(fe,G,X){return new Promise((ce,pe)=>{const Ie=G.onCancellationRequested(()=>{Ie.dispose(),ce(X)});fe.then(ce,pe).finally(()=>Ie.dispose())})}e.raceCancellation=L;function I(fe,G){return new Promise((X,ce)=>{const pe=G.onCancellationRequested(()=>{pe.dispose(),ce(new i.CancellationError)});fe.then(X,ce).finally(()=>pe.dispose())})}e.raceCancellationError=I;async function D(fe){let G=-1;const X=fe.map((pe,Ie)=>pe.then(Re=>(G=Ie,Re))),ce=await Promise.race(X);return fe.forEach((pe,Ie)=>{Ie!==G&&pe.cancel()}),ce}e.raceCancellablePromises=D;function T(fe,G,X){let ce;const pe=setTimeout(()=>{ce?.(void 0),X?.()},G);return Promise.race([fe.finally(()=>clearTimeout(pe)),new Promise(Ie=>ce=Ie)])}e.raceTimeout=T;function C(fe){return new Promise((G,X)=>{const ce=fe();w(ce)?ce.then(G,X):G(ce)})}e.asPromise=C;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const X=()=>{this.queuedPromise=null;const ce=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ce};this.queuedPromise=new Promise(ce=>{this.activePromise.then(X,X).then(ce)})}return new Promise((X,ce)=>{this.queuedPromise.then(X,ce)})}return this.activePromise=G(),new Promise((X,ce)=>{this.activePromise.then(pe=>{this.activePromise=null,X(pe)},pe=>{this.activePromise=null,ce(pe)})})}}e.Throttler=m;class v{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=v;class g{constructor(){this.promiseMap=new Map}queue(G,X){const pe=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.promiseMap.get(G)===pe&&this.promiseMap.delete(G)});return this.promiseMap.set(G,pe),pe}}e.SequencerByKey=g;const b=(fe,G)=>{let X=!0;const ce=setTimeout(()=>{X=!1,G()},fe);return{isTriggered:()=>X,dispose:()=>{clearTimeout(ce),X=!1}}},f=fe=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,fe())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(G){this.defaultDelay=G,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,X=this.defaultDelay){this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,Ie)=>{this.doResolve=pe,this.doReject=Ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const ce=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=X===e.MicrotaskDelay?f(ce):b(X,ce),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class h{constructor(G){this.delayer=new l(G),this.throttler=new m}trigger(G,X){return this.delayer.trigger(()=>this.throttler.queue(G),X)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class o{constructor(){this._isOpen=!1,this._promise=new Promise((G,X)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class E extends o{constructor(G){super();this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function r(fe,G){return G?new Promise((X,ce)=>{const pe=setTimeout(()=>{Ie.dispose(),X()},fe),Ie=G.onCancellationRequested(()=>{clearTimeout(pe),Ie.dispose(),ce(new i.CancellationError)})}):P(X=>r(fe,X))}e.timeout=r;function s(fe,G=0){const X=setTimeout(fe,G);return(0,A.toDisposable)(()=>clearTimeout(X))}e.disposableTimeout=s;function n(fe){const G=[];let X=0;const ce=fe.length;function pe(){return X<ce?fe[X++]():null}function Ie(Re){Re!=null&&G.push(Re);const Ce=pe();return Ce?Ce.then(Ie):Promise.resolve(G)}return Promise.resolve(null).then(Ie)}e.sequence=n;function t(fe,G=ce=>!!ce,X=null){let ce=0;const pe=fe.length,Ie=()=>{if(ce>=pe)return Promise.resolve(X);const Re=fe[ce++];return Promise.resolve(Re()).then(ke=>G(ke)?Promise.resolve(ke):Ie())};return Ie()}e.first=t;function a(fe,G=ce=>!!ce,X=null){if(fe.length===0)return Promise.resolve(X);let ce=fe.length;const pe=()=>{ce=-1;for(const Ie of fe)Ie.cancel?.()};return new Promise((Ie,Re)=>{for(const Ce of fe)Ce.then(ke=>{--ce>=0&&G(ke)?(pe(),Ie(ke)):ce===0&&Ie(X)}).catch(ke=>{--ce>=0&&(pe(),Re(ke))})})}e.firstParallel=a;class c{constructor(G){this._size=0,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new _.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(G){return this._size++,new Promise((X,ce)=>{this.outstandingPromises.push({factory:G,c:X,e:ce}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const X=G.factory();X.then(G.c,G.e),X.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class u extends c{constructor(){super(1)}}e.Queue=u;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const G=new j;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueFor(G,X=k.extUri){const ce=X.getComparisonKey(G);let pe=this.queues.get(ce);return pe||(pe=new u,_.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(ce),this.onDidQueueDrain()}),this.queues.set(ce,pe)),pe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class R{constructor(G,X){this._token=-1,typeof G=="function"&&typeof X=="number"&&this.setIfNotSet(G,X)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,X){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},X)}setIfNotSet(G,X){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},X))}}e.TimeoutTimer=R;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(G,X){this.cancel(),this._token=setInterval(()=>{G()},X)}}e.IntervalTimer=O;class N{constructor(G,X){this.timeoutToken=-1,this.runner=G,this.timeout=X,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class p{constructor(G,X){X%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=X,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class M extends N{constructor(G,X){super(G,X);this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner&&this.runner(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class U extends A.Disposable{constructor(G,X){super();this.options=G,this.handler=X,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.options.maxBufferedWork)return!1}else if(this.pending+G.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...G),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,y.setTimeout0)(()=>{if(G)return;const X=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(fe,G)=>{const X=requestIdleCallback(fe,typeof G=="number"?{timeout:G}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,cancelIdleCallback(X))}}}}();class z{constructor(G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(X){this._error=X}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function re(fe,G,X){let ce;for(let pe=0;pe<X;pe++)try{return await fe()}catch(Ie){ce=Ie,await r(G)}throw ce}e.retry=re;class H{hasPending(G){return this._pending?typeof G=="number"?this._pending.taskId===G:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(G,X,ce){return this._pending={taskId:G,cancel:()=>ce?.(),promise:X},X.then(()=>this.donePending(G),()=>this.donePending(G)),X}donePending(G){this._pending&&G===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const G=this._next;this._next=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this._next)this._next.run=G;else{let X,ce;const pe=new Promise((Ie,Re)=>{X=Ie,ce=Re});this._next={run:G,promise:pe,promiseResolve:X,promiseReject:ce}}return this._next.promise}}e.TaskSequentializer=H;class F{constructor(G,X=()=>Date.now()){this.interval=G,this.nowFn=X,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((G,X)=>{this.completeCallback=G,this.errorCallback=X})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(G){return new Promise(X=>{this.completeCallback(G),this.resolved=!0,X()})}error(G){return new Promise(X=>{this.errorCallback(G),this.rejected=!0,X()})}cancel(){new Promise(G=>{this.errorCallback(new i.CancellationError),this.rejected=!0,G()})}}e.DeferredPromise=j;var x;(function(fe){async function G(ce){let pe;const Ie=await Promise.all(ce.map(Re=>Re.then(Ce=>Ce,Ce=>{pe||(pe=Ce)})));if(typeof pe!="undefined")throw pe;return Ie}fe.settled=G;function X(ce){return new Promise(async(pe,Ie)=>{try{await ce(pe,Ie)}catch(Re){Ie(Re)}})}fe.withAsyncBody=X})(x=e.Promises||(e.Promises={}));var V;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(V||(V={}));class ne{constructor(G){this._state=0,this._results=[],this._error=null,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const X={emitOne:ce=>this.emitOne(ce),emitMany:ce=>this.emitMany(ce),reject:ce=>this.reject(ce)};try{await Promise.resolve(G(X)),this.resolve()}catch(ce){this.reject(ce)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}static fromArray(G){return new ne(X=>{X.emitMany(G)})}static fromPromise(G){return new ne(async X=>{X.emitMany(await G)})}static fromPromises(G){return new ne(async X=>{await Promise.all(G.map(async ce=>X.emitOne(await ce)))})}static merge(G){return new ne(async X=>{await Promise.all(G.map(async ce=>{for await(const pe of ce)X.emitOne(pe)}))})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===1)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(G,X){return new ne(async ce=>{for await(const pe of G)ce.emitOne(X(pe))})}map(G){return ne.map(this,G)}static filter(G,X){return new ne(async ce=>{for await(const pe of G)X(pe)&&ce.emitOne(pe)})}filter(G){return ne.filter(this,G)}static coalesce(G){return ne.filter(G,X=>!!X)}coalesce(){return ne.coalesce(this)}static async toPromise(G){const X=[];for await(const ce of G)X.push(ce);return X}toPromise(){return ne.toPromise(this)}emitOne(G){this._state===0&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===0&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(G){this._state===0&&(this._state=2,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class Q extends ne{constructor(G,X){super(X);this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function he(fe){const G=new d.CancellationTokenSource,X=fe(G.token);return new Q(G,async ce=>{const pe=G.token.onCancellationRequested(()=>{pe.dispose(),G.dispose(),ce.reject(new i.CancellationError)});try{for await(const Ie of X){if(G.token.isCancellationRequested)return;ce.emitOne(Ie)}pe.dispose(),G.dispose()}catch(Ie){pe.dispose(),G.dispose(),ce.reject(Ie)}})}e.createCancelableAsyncIterable=he}),define(ye[99],De([0,1,17,9]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new d.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(u,S,R=!1){const O=u||"",N=S||"",p=_.value.collator.compare(O,N);return _.value.collatorIsNumeric&&p===0&&O!==N?O<N?-1:1:p}e.compareFileNames=y;function w(u,S){const R=A.value.collator;return u=u||"",S=S||"",h(R,u,S)}e.compareFileNamesDefault=w;function P(u,S){const R=A.value.collator;return u=u||"",S=S||"",s(u,S)||h(R,u,S)}e.compareFileNamesUpper=P;function L(u,S){const R=A.value.collator;return u=u||"",S=S||"",r(u,S)||h(R,u,S)}e.compareFileNamesLower=L;function I(u,S){return u=u||"",S=S||"",u===S?0:u<S?-1:1}e.compareFileNamesUnicode=I;function D(u,S,R=!1){R||(u=u&&u.toLowerCase(),S=S&&S.toLowerCase());const[O,N]=f(u),[p,M]=f(S);return O!==p?O<p?-1:1:N===M?0:N<M?-1:1}e.noIntlCompareFileNames=D;function T(u,S){const[R,O]=f(u),[N,p]=f(S);let M=_.value.collator.compare(O,p);if(M===0){if(_.value.collatorIsNumeric&&O!==p)return O<p?-1:1;if(M=_.value.collator.compare(R,N),_.value.collatorIsNumeric&&M===0&&R!==N)return R<N?-1:1}return M}e.compareFileExtensions=T;function C(u,S){u=u||"",S=S||"";const R=l(u),O=l(S),N=A.value.collator,p=k.value.collator;return h(p,R,O)||h(N,u,S)}e.compareFileExtensionsDefault=C;function m(u,S){u=u||"",S=S||"";const R=l(u),O=l(S),N=A.value.collator,p=k.value.collator;return h(p,R,O)||s(u,S)||h(N,u,S)}e.compareFileExtensionsUpper=m;function v(u,S){u=u||"",S=S||"";const R=l(u),O=l(S),N=A.value.collator,p=k.value.collator;return h(p,R,O)||r(u,S)||h(N,u,S)}e.compareFileExtensionsLower=v;function g(u,S){u=u||"",S=S||"";const R=l(u).toLowerCase(),O=l(S).toLowerCase();return R!==O?R<O?-1:1:u!==S?u<S?-1:1:0}e.compareFileExtensionsUnicode=g;const b=/^(.*?)(\.([^.]*))?$/;function f(u,S=!1){const R=u?b.exec(u):[];let O=[R&&R[1]||"",R&&R[3]||""];return S&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function l(u){const S=u?b.exec(u):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function h(u,S,R){let O=u.compare(S,R);return O!==0?O:S.length!==R.length?S.length<R.length?-1:1:0}function o(u){const S=u.charAt(0);return S.toLocaleUpperCase()!==S}function E(u){const S=u.charAt(0);return S.toLocaleLowerCase()!==S}function r(u,S){return o(u)&&E(S)?-1:E(u)&&o(S)?1:0}function s(u,S){return E(u)&&o(S)?-1:o(u)&&E(S)?1:0}function n(u,S,R=!1){return R||(u=u&&u.toLowerCase(),S=S&&S.toLowerCase()),u===S?0:u<S?-1:1}function t(u,S,R=!1){const O=u.split(i.sep),N=S.split(i.sep),p=O.length-1,M=N.length-1;let U,z;for(let re=0;;re++){if(U=p===re,z=M===re,U&&z)return y(O[re],N[re],R);if(U)return-1;if(z)return 1;const H=n(O[re],N[re],R);if(H!==0)return H}}e.comparePaths=t;function a(u,S,R){const O=u.toLowerCase(),N=S.toLowerCase(),p=c(u,S,R);if(p)return p;const M=O.endsWith(R),U=N.endsWith(R);if(M!==U)return M?-1:1;const z=y(O,N);return z!==0?z:O.localeCompare(N)}e.compareAnything=a;function c(u,S,R){const O=u.toLowerCase(),N=S.toLowerCase(),p=O.startsWith(R),M=N.startsWith(R);if(p!==M)return p?-1:1;if(p&&M){if(O.length<N.length)return-1;if(O.length>N.length)return 1}return 0}e.compareByPrefix=c}),define(ye[100],De([0,1,99,97,59,9,12,8]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const w=0,P=[w,[]];function L(H,F,j,x){if(!H||!F)return P;const V=H.length,ne=F.length;if(V<ne)return P;const Q=H.toLowerCase();return I(F,j,ne,H,Q,V,x)}e.scoreFuzzy=L;function I(H,F,j,x,V,ne,Q){const he=[],fe=[];for(let pe=0;pe<j;pe++){const Ie=pe*ne,Re=Ie-ne,Ce=pe>0,ke=H[pe],Ae=F[pe];for(let ue=0;ue<ne;ue++){const ve=ue>0,ie=Ie+ue,oe=ie-1,we=Re+ue-1,Te=ve?he[oe]:0,B=Ce&&ve?he[we]:0,q=Ce&&ve?fe[we]:0;let J;!B&&Ce?J=0:J=D(ke,Ae,x,V,ue,q),J&&B+J>=Te&&(Q||Ce||V.startsWith(F,ue))?(fe[ie]=q+1,he[ie]=B+J):(fe[ie]=w,he[ie]=Te)}}const G=[];let X=j-1,ce=ne-1;for(;X>=0&&ce>=0;){const pe=X*ne+ce;fe[pe]===w||(G.push(ce),X--),ce--}return[he[j*ne-1],G.reverse()]}function D(H,F,j,x,V,ne){let Q=0;if(!T(F,x[V]))return Q;if(Q+=1,ne>0&&(Q+=ne*5),H===j[V]&&(Q+=1),V===0)Q+=8;else{const he=C(j.charCodeAt(V-1));he?Q+=he:(0,i.isUpper)(j.charCodeAt(V))&&ne===0&&(Q+=2)}return Q}function T(H,F){return H===F?!0:H==="/"||H==="\\"?F==="/"||F==="\\":!1}function C(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function v(H,F,j=0,x=0){const V=F;return V.values&&V.values.length>1?g(H,V.values,j,x):b(H,F,j,x)}e.scoreFuzzy2=v;function g(H,F,j,x){let V=0;const ne=[];for(const Q of F){const[he,fe]=b(H,Q,j,x);if(typeof he!="number")return m;V+=he,ne.push(...fe)}return[V,c(ne)]}function b(H,F,j,x){const V=(0,i.fuzzyScore)(F.original,F.originalLowercase,j,H,H.toLowerCase(),x);return V?[V[0],(0,i.createMatches)(V)]:m}const f=Object.freeze({score:0}),l=1<<18,h=1<<17,o=1<<16;function E(H,F,j,x){const V=x.values?x.values:[x];return(0,_.hash)({[x.normalized]:{values:V.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:H,description:F,allowNonContiguousMatches:j}})}function r(H,F,j,x,V){if(!H||!F.normalized)return f;const ne=x.getItemLabel(H);if(!ne)return f;const Q=x.getItemDescription(H),he=E(ne,Q,j,F),fe=V[he];if(fe)return fe;const G=s(ne,Q,x.getItemPath(H),F,j);return V[he]=G,G}e.scoreItemFuzzy=r;function s(H,F,j,x,V){const ne=!j||!x.containsPathSeparator;return j&&(k.isLinux?x.pathNormalized===j:(0,y.equalsIgnoreCase)(x.pathNormalized,j))?{score:l,labelMatch:[{start:0,end:H.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:x.values&&x.values.length>1?n(H,F,j,x.values,ne,V):t(H,F,j,x,ne,V)}function n(H,F,j,x,V,ne){let Q=0;const he=[],fe=[];for(const G of x){const{score:X,labelMatch:ce,descriptionMatch:pe}=t(H,F,j,G,V,ne);if(X===w)return f;Q+=X,ce&&he.push(...ce),pe&&fe.push(...pe)}return{score:Q,labelMatch:c(he),descriptionMatch:c(fe)}}function t(H,F,j,x,V,ne){if(V||!F){const[Q,he]=L(H,x.normalized,x.normalizedLowercase,ne&&!x.expectContiguousMatch);if(Q){const fe=(0,i.matchesPrefix)(x.normalized,H);let G;return fe?(G=h,G+=Math.round(x.normalized.length/H.length*100)):G=o,{score:G+Q,labelMatch:fe||a(he)}}}if(F){let Q=F;j&&(Q=`${F}${A.sep}`);const he=Q.length,fe=`${Q}${H}`,[G,X]=L(fe,x.normalized,x.normalizedLowercase,ne&&!x.expectContiguousMatch);if(G){const ce=a(X),pe=[],Ie=[];return ce.forEach(Re=>{Re.start<he&&Re.end>he?(pe.push({start:0,end:Re.end-he}),Ie.push({start:Re.start,end:he})):Re.start>=he?pe.push({start:Re.start-he,end:Re.end-he}):Ie.push(Re)}),{score:G,labelMatch:pe,descriptionMatch:Ie}}}return f}function a(H){const F=[];if(!H)return F;let j;for(const x of H)j&&j.end===x?j.end+=1:(j={start:x,end:x+1},F.push(j));return F}function c(H){const F=H.sort((V,ne)=>V.start-ne.start),j=[];let x;for(const V of F)!x||!u(x,V)?(x=V,j.push(V)):(x.start=Math.min(x.start,V.start),x.end=Math.max(x.end,V.end));return j}function u(H,F){return!(H.end<F.start||F.end<H.start)}function S(H,F,j,x,V,ne){const Q=r(H,j,x,V,ne),he=r(F,j,x,V,ne),fe=Q.score,G=he.score;if((fe===l||G===l)&&fe!==G)return fe===l?-1:1;if(fe>o||G>o){if(fe!==G)return fe>G?-1:1;if(fe<h&&G<h){const ke=O(Q.labelMatch,he.labelMatch);if(ke!==0)return ke}const Re=V.getItemLabel(H)||"",Ce=V.getItemLabel(F)||"";if(Re.length!==Ce.length)return Re.length-Ce.length}if(fe!==G)return fe>G?-1:1;const X=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,ce=Array.isArray(he.labelMatch)&&he.labelMatch.length>0;if(X&&!ce)return-1;if(ce&&!X)return 1;const pe=R(H,Q,V),Ie=R(F,he,V);return pe&&Ie&&pe!==Ie?Ie>pe?-1:1:N(H,F,j,V)}e.compareItemsByFuzzyScore=S;function R(H,F,j){let x=-1,V=-1;if(F.descriptionMatch&&F.descriptionMatch.length?x=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&(x=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if(V=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const ne=j.getItemDescription(H);ne&&(V+=ne.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&(V=F.descriptionMatch[F.descriptionMatch.length-1].end);return V-x}function O(H,F){if(!H&&!F||(!H||!H.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!H||!H.length)return 1;const j=H[0].start,V=H[H.length-1].end-j,ne=F[0].start,he=F[F.length-1].end-ne;return V===he?0:he<V?1:-1}function N(H,F,j,x){const V=x.getItemLabel(H)||"",ne=x.getItemLabel(F)||"",Q=x.getItemDescription(H),he=x.getItemDescription(F),fe=V.length+(Q?Q.length:0),G=ne.length+(he?he.length:0);if(fe!==G)return fe-G;const X=x.getItemPath(H),ce=x.getItemPath(F);return X&&ce&&X.length!==ce.length?X.length-ce.length:V!==ne?(0,d.compareAnything)(V,ne,j.normalized):Q&&he&&Q!==he?(0,d.compareAnything)(Q,he,j.normalized):X&&ce&&X!==ce?(0,d.compareAnything)(X,ce,j.normalized):0}function p(H){return H.startsWith('"')&&H.endsWith('"')}const M=" ";function U(H){typeof H!="string"&&(H="");const F=H.toLowerCase(),{pathNormalized:j,normalized:x,normalizedLowercase:V}=z(H),ne=j.indexOf(A.sep)>=0,Q=p(H);let he;const fe=H.split(M);if(fe.length>1)for(const G of fe){const X=p(G),{pathNormalized:ce,normalized:pe,normalizedLowercase:Ie}=z(G);pe&&(he||(he=[]),he.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:ce,normalized:pe,normalizedLowercase:Ie,expectContiguousMatch:X}))}return{original:H,originalLowercase:F,pathNormalized:j,normalized:x,normalizedLowercase:V,values:he,containsPathSeparator:ne,expectContiguousMatch:Q}}e.prepareQuery=U;function z(H){let F;k.isWindows?F=H.replace(/\//g,A.sep):F=H.replace(/\\/g,A.sep);const j=(0,y.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:j,normalizedLowercase:j.toLowerCase()}}function re(H){return Array.isArray(H)?U(H.map(F=>F.original).join(M)):U(H.original)}e.pieceToQuery=re}),define(ye[35],De([0,1,16,17,30,24,9,12,8]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",I="[^/\\\\]",D=/\//g;function T(j,x){switch(j){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${x?`|${L}${I}+`:""})*?`}}function C(j,x){if(!j)return[];const V=[];let ne=!1,Q=!1,he="";for(const fe of j){switch(fe){case x:if(!ne&&!Q){V.push(he),he="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}he+=fe}return he&&V.push(he),V}e.splitGlobAware=C;function m(j){if(!j)return"";let x="";const V=C(j,e.GLOB_SPLIT);if(V.every(ne=>ne===e.GLOBSTAR))x=".*";else{let ne=!1;V.forEach((Q,he)=>{if(Q===e.GLOBSTAR){if(ne)return;x+=T(2,he===V.length-1)}else{let fe=!1,G="",X=!1,ce="";for(const pe of Q){if(pe!=="}"&&fe){G+=pe;continue}if(X&&(pe!=="]"||!ce)){let Ie;pe==="-"?Ie=pe:(pe==="^"||pe==="!")&&!ce?Ie="^":pe===e.GLOB_SPLIT?Ie="":Ie=(0,w.escapeRegExpCharacters)(pe),ce+=Ie;continue}switch(pe){case"{":fe=!0;continue;case"[":X=!0;continue;case"}":{x+=`(?:${C(G,",").map(Ce=>m(Ce)).join("|")})`,fe=!1,G="";break}case"]":{x+="["+ce+"]",X=!1,ce="";break}case"?":x+=I;continue;case"*":x+=T(1);continue;default:x+=(0,w.escapeRegExpCharacters)(pe)}}he<V.length-1&&(V[he+1]!==e.GLOBSTAR||he+2<V.length)&&(x+=L)}ne=Q===e.GLOBSTAR})}return x}const v=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.LRUCache(1e4),E=function(){return!1},r=function(){return null};function s(j,x){if(!j)return r;let V;typeof j!="string"?V=j.pattern:V=j,V=V.trim();const ne=`${V}_${!!x.trimForExclusions}`;let Q=o.get(ne);if(Q)return n(Q,j);let he;return v.test(V)?Q=a(V.substr(4),V):(he=g.exec(t(V,x)))?Q=c(he[1],V):(x.trimForExclusions?f:b).test(V)?Q=u(V,x):(he=l.exec(t(V,x)))?Q=S(he[1].substr(1),V,!0):(he=h.exec(t(V,x)))?Q=S(he[1],V,!1):Q=R(V),o.set(ne,Q),n(Q,j)}function n(j,x){if(typeof x=="string")return j;const V=function(ne,Q){return(0,_.isEqualOrParent)(ne,x.base,!y.isLinux)?j(ne.substr(x.base.length+1),Q):null};return V.allBasenames=j.allBasenames,V.allPaths=j.allPaths,V.basenames=j.basenames,V.patterns=j.patterns,V}function t(j,x){return x.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function a(j,x){return function(V,ne){return typeof V=="string"&&V.endsWith(j)?x:null}}function c(j,x){const V=`/${j}`,ne=`\\${j}`,Q=function(fe,G){return typeof fe!="string"?null:G?G===j?x:null:fe===j||fe.endsWith(V)||fe.endsWith(ne)?x:null},he=[j];return Q.basenames=he,Q.patterns=[x],Q.allBasenames=he,Q}function u(j,x){const V=H(j.slice(1,-1).split(",").map(G=>s(G,x)).filter(G=>G!==r),j),ne=V.length;if(!ne)return r;if(ne===1)return V[0];const Q=function(G,X){for(let ce=0,pe=V.length;ce<pe;ce++)if(V[ce](G,X))return j;return null},he=V.find(G=>!!G.allBasenames);he&&(Q.allBasenames=he.allBasenames);const fe=V.reduce((G,X)=>X.allPaths?G.concat(X.allPaths):G,[]);return fe.length&&(Q.allPaths=fe),Q}function S(j,x,V){const ne=k.sep===k.posix.sep,Q=ne?j:j.replace(D,k.sep),he=k.sep+Q,fe=k.posix.sep+j;let G;return V?G=function(X,ce){return typeof X=="string"&&(X===Q||X.endsWith(he)||!ne&&(X===j||X.endsWith(fe)))?x:null}:G=function(X,ce){return typeof X=="string"&&(X===Q||!ne&&X===j)?x:null},G.allPaths=[(V?"*/":"./")+j],G}function R(j){try{const x=new RegExp(`^${m(j)}$`);return function(V){return x.lastIndex=0,typeof V=="string"&&x.test(V)?j:null}}catch{return r}}function O(j,x,V){return!j||typeof x!="string"?!1:N(j)(x,void 0,V)}e.match=O;function N(j,x={}){if(!j)return E;if(typeof j=="string"||p(j)){const V=s(j,x);if(V===r)return E;const ne=function(Q,he){return!!V(Q,he)};return V.allBasenames&&(ne.allBasenames=V.allBasenames),V.allPaths&&(ne.allPaths=V.allPaths),ne}return z(j,x)}e.parse=N;function p(j){const x=j;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=p;function M(j){return j.allBasenames||[]}e.getBasenameTerms=M;function U(j){return j.allPaths||[]}e.getPathTerms=U;function z(j,x){const V=H(Object.getOwnPropertyNames(j).map(G=>re(G,j[G],x)).filter(G=>G!==r)),ne=V.length;if(!ne)return r;if(!V.some(G=>!!G.requiresSiblings)){if(ne===1)return V[0];const G=function(pe,Ie){let Re;for(let Ce=0,ke=V.length;Ce<ke;Ce++){const Ae=V[Ce](pe,Ie);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(Re||(Re=[]),Re.push(Ae))}return Re?(async()=>{for(const Ce of Re){const ke=await Ce;if(typeof ke=="string")return ke}return null})():null},X=V.find(pe=>!!pe.allBasenames);X&&(G.allBasenames=X.allBasenames);const ce=V.reduce((pe,Ie)=>Ie.allPaths?pe.concat(Ie.allPaths):pe,[]);return ce.length&&(G.allPaths=ce),G}const Q=function(G,X,ce){let pe,Ie;for(let Re=0,Ce=V.length;Re<Ce;Re++){const ke=V[Re];ke.requiresSiblings&&ce&&(X||(X=(0,k.basename)(G)),pe||(pe=X.substr(0,X.length-(0,k.extname)(G).length)));const Ae=ke(G,X,pe,ce);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(Ie||(Ie=[]),Ie.push(Ae))}return Ie?(async()=>{for(const Re of Ie){const Ce=await Re;if(typeof Ce=="string")return Ce}return null})():null},he=V.find(G=>!!G.allBasenames);he&&(Q.allBasenames=he.allBasenames);const fe=V.reduce((G,X)=>X.allPaths?G.concat(X.allPaths):G,[]);return fe.length&&(Q.allPaths=fe),Q}function re(j,x,V){if(x===!1)return r;const ne=s(j,V);if(ne===r)return r;if(typeof x=="boolean")return ne;if(x){const Q=x.when;if(typeof Q=="string"){const he=(fe,G,X,ce)=>{if(!ce||!ne(fe,G))return null;const pe=Q.replace("$(basename)",X),Ie=ce(pe);return(0,i.isThenable)(Ie)?Ie.then(Re=>Re?j:null):Ie?j:null};return he.requiresSiblings=!0,he}}return ne}function H(j,x){const V=j.filter(G=>!!G.basenames);if(V.length<2)return j;const ne=V.reduce((G,X)=>{const ce=X.basenames;return ce?G.concat(ce):G},[]);let Q;if(x){Q=[];for(let G=0,X=ne.length;G<X;G++)Q.push(x)}else Q=V.reduce((G,X)=>{const ce=X.patterns;return ce?G.concat(ce):G},[]);const he=function(G,X){if(typeof G!="string")return null;if(!X){let pe;for(pe=G.length;pe>0;pe--){const Ie=G.charCodeAt(pe-1);if(Ie===47||Ie===92)break}X=G.substr(pe)}const ce=ne.indexOf(X);return ce!==-1?Q[ce]:null};he.basenames=ne,he.patterns=Q,he.allBasenames=ne;const fe=j.filter(G=>!G.basenames);return fe.push(he),fe}function F(j,x){return(0,d.equals)(j,x,(V,ne)=>typeof V=="string"&&typeof ne=="string"?V===ne:typeof V!="string"&&typeof ne!="string"?V.base===ne.base&&V.pattern===ne.pattern:!1)}e.patternsEquals=F}),define(ye[101],De([0,1,11,147,22,8,2]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(v="",g=!1){if(this.value=v,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(v,g=0){return this.value+=D(this.supportThemeIcons?(0,i.escapeIcons)(v):v).replace(/([ \t]+)/g,(b,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,g){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(v,g,b){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(v),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(v,g){const b=new RegExp((0,A.escapeRegExpCharacters)(g),"g");return v.replace(b,(f,l)=>v.charAt(l-1)!=="\\"?`\\${f}`:f)}}e.MarkdownString=w;function P(m){return L(m)?!m.value:Array.isArray(m)?m.every(P):!0}e.isEmptyMarkdownString=P;function L(m){return m instanceof w?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function I(m,v){return m===v?!0:!m||!v?!1:m.value===v.value&&m.isTrusted===v.isTrusted&&m.supportThemeIcons===v.supportThemeIcons&&m.supportHtml===v.supportHtml&&(m.baseUri===v.baseUri||!!m.baseUri&&!!v.baseUri&&(0,_.isEqual)(k.URI.from(m.baseUri),k.URI.from(v.baseUri)))}e.markdownStringEqual=I;function D(m){return m.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function T(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function C(m){const v=[],g=m.split("|").map(f=>f.trim());m=g[0];const b=g[1];if(b){const f=/height=(\d+)/.exec(b),l=/width=(\d+)/.exec(b),h=f?f[1]:"",o=l?l[1]:"",E=isFinite(parseInt(o)),r=isFinite(parseInt(h));E&&v.push(`width="${o}"`),r&&v.push(`height="${h}"`)}return{href:m,dimensions:v}}e.parseHrefAndDimensions=C}),define(ye[102],De([0,1,16,30,10,9,12,22,8,2]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(t,a){const{os:c,tildify:u,relative:S}=a;if(S){const N=I(t,S,c);if(typeof N=="string")return N}let R=t.fsPath;if(c===1&&!k.isWindows?R=R.replace(/\//g,"\\"):c!==1&&k.isWindows&&(R=R.replace(/\\/g,"/")),c!==1&&u?.userHome){let N=u.userHome.fsPath,p;t.scheme!==u.userHome.scheme&&t.path.startsWith(A.posix.sep)?p=u.userHome.with({path:t.path}).fsPath:p=t.fsPath,k.isWindows&&(p=(0,i.toSlashes)(p),N=(0,i.toSlashes)(N)),R=m(p,N,c)}return(c===1?A.win32:A.posix).normalize(T(R,c===1))}e.getPathLabel=L;function I(t,a,c){const u=c===1?A.win32:A.posix,S=c===3?y.extUri:y.extUriIgnorePathCase,R=a.getWorkspace(),O=(0,d.firstOrDefault)(R.folders);if(!O)return;t.scheme!==O.uri.scheme&&t.path.startsWith(A.posix.sep)&&(t=O.uri.with({path:t.path}));const N=a.getWorkspaceFolder(t);if(!N)return;let p;if(S.isEqual(N.uri,t)?p="":p=S.relativePath(N.uri,t)??"",p&&(p=u.normalize(p)),R.folders.length>1&&!a.noPrefix){const M=N.name?N.name:S.basenameOrAuthority(N.uri);p=p?`${M} \u2022 ${p}`:M}return p}function D(t){if(!t)return;typeof t=="string"&&(t=P.URI.file(t));const a=(0,y.basename)(t)||(t.scheme===_.Schemas.file?t.fsPath:t.path);return k.isWindows&&(0,i.isRootOrDriveLetter)(a)?T(a):a}e.getBaseLabel=D;function T(t,a=k.isWindows){return(0,i.hasDriveLetter)(t,a)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=T;let C=Object.create(null);function m(t,a,c=k.OS){if(c===1||!t||!a)return t;let u=C.original===a?C.normalized:void 0;return u||(u=`${(0,w.rtrim)(a,A.posix.sep)}${A.posix.sep}`,C={original:a,normalized:u}),(c===3?t.startsWith(u):(0,w.startsWithIgnoreCase)(t,u))&&(t=`~/${t.substr(u.length)}`),t}e.tildify=m;function v(t,a){return t.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=v;const g="\u2026",b="\\\\",f="~";function l(t,a=A.sep){const c=new Array(t.length);let u=!1;for(let S=0;S<t.length;S++){let R=t[S];if(R===""){c[S]=`.${a}`;continue}if(!R){c[S]=R;continue}u=!0;let O="";R.indexOf(b)===0?(O=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(a)===0?(O=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(f)===0&&(O=R.substr(0,R.indexOf(f)+f.length),R=R.substr(R.indexOf(f)+f.length));const N=R.split(a);for(let p=1;u&&p<=N.length;p++)for(let M=N.length-p;u&&M>=0;M--){u=!1;let U=N.slice(M,M+p).join(a);for(let z=0;!u&&z<t.length;z++)if(z!==S&&t[z]&&t[z].indexOf(U)>-1){const re=M+p===N.length,H=M>0&&t[z].indexOf(a)>-1?a+U:U,F=t[z].endsWith(H);u=!re||F}if(!u){let z="";(N[0].endsWith(":")||O!=="")&&(M===1&&(M=0,p++,U=N[0]+a+U),M>0&&(z=N[0]+a),z=O+z),M>0&&(z=z+g+a),z=z+U,M+p<N.length&&(z=z+a+g),c[S]=z}}u&&(c[S]=R)}return c}e.shorten=l;var h;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(t,a=Object.create(null)){const c=[];let u=!1,S="";for(const R of t)if(R==="$"||u&&R==="{")S&&c.push({value:S,type:h.TEXT}),S="",u=!0;else if(R==="}"&&u){const O=a[S];if(typeof O=="string")O.length&&c.push({value:O,type:h.VARIABLE});else if(O){const N=c[c.length-1];(!N||N.type!==h.SEPARATOR)&&c.push({value:O.label,type:h.SEPARATOR})}S="",u=!1}else S+=R;return S&&!u&&c.push({value:S,type:h.TEXT}),c.filter((R,O)=>{if(R.type===h.SEPARATOR){const N=c[O-1],p=c[O+1];return[N,p].every(M=>M&&(M.type===h.VARIABLE||M.type===h.TEXT)&&M.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function E(t,a){return k.isMacintosh||a?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function r(t,a){return k.isMacintosh||a?t.replace(/\(&&\w\)|&&/g,""):k.isWindows?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function s(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=s;function n(t){const a=t.indexOf("/")!==-1?A.posix:A.win32,c=a.basename(t),u=a.dirname(t);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=n}),define(ye[103],De([0,1,2]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class _{constructor(I){this._uriTransformer=I}transformIncoming(I){const D=this._uriTransformer.transformIncoming(I);return D===I?I:i(d.URI.from(D))}transformOutgoing(I){const D=this._uriTransformer.transformOutgoing(I);return D===I?I:i(d.URI.from(D))}transformOutgoingURI(I){const D=this._uriTransformer.transformOutgoing(I);return D===I?I:d.URI.from(D)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function A(L,I,D){if(!L||D>200)return null;if(typeof L=="object"){if(L instanceof d.URI)return I.transformOutgoing(L);for(let T in L)if(Object.hasOwnProperty.call(L,T)){const C=A(L[T],I,D+1);C!==null&&(L[T]=C)}}return null}function k(L,I){const D=A(L,I,0);return D===null?L:D}e.transformOutgoingURIs=k;function y(L,I,D,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return D?d.URI.revive(I.transformIncoming(L)):I.transformIncoming(L);for(let C in L)if(Object.hasOwnProperty.call(L,C)){const m=y(L[C],I,D,T+1);m!==null&&(L[C]=m)}}return null}function w(L,I){const D=y(L,I,!1,0);return D===null?L:D}e.transformIncomingURIs=w;function P(L,I){const D=y(L,I,!0,0);return D===null?L:D}e.transformAndReviveIncomingURIs=P}),define(ye[36],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(w){return d.test(w)}e.isUUID=i;const _=new Uint8Array(16),A=[];for(let w=0;w<256;w++)A.push(w.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(w){for(let P=0;P<w.length;P++)w[P]=Math.floor(Math.random()*256);return w};function y(){k(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let w=0,P="";return P+=A[_[w++]],P+=A[_[w++]],P+=A[_[w++]],P+=A[_[w++]],P+="-",P+=A[_[w++]],P+=A[_[w++]],P+="-",P+=A[_[w++]],P+=A[_[w++]],P+="-",P+=A[_[w++]],P+=A[_[w++]],P+="-",P+=A[_[w++]],P+=A[_[w++]],P+=A[_[w++]],P+=A[_[w++]],P+=A[_[w++]],P+=A[_[w++]],P}e.generateUuid=y}),define(ye[148],De([0,1,104]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(A="utf8"){this.stringDecoder=new d.StringDecoder(A),this.remaining=null}write(A){const k=[],y=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(y.length<1)return k;let w=0,P,L=w;for(;L<y.length;)if(P=y.charCodeAt(L),P===13||P===10){if(k.push(y.substring(w,L)),L++,L<y.length){const I=P;P=y.charCodeAt(L),(I===13&&P===10||I===10&&P===13)&&L++}w=L}else L++;return this.remaining=w<y.length?y.substr(w):null,k}end(){return this.remaining}}e.LineDecoder=i}),define(ye[29],De([0,1,61,49,295,17,30,81,9,12,22,2]),function(Y,e,d,i,_,A,k,y,w,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var D;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(D=e.RimRafMode||(e.RimRafMode={}));async function T(U,z=D.UNLINK){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===D.UNLINK?m(U):C(U)}async function C(U){try{const z=(0,k.randomPath)((0,i.tmpdir)());try{await d.promises.rename(U,z)}catch{return m(U)}m(z).catch(re=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function m(U){return(0,_.promisify)(d.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function v(U){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function g(U,z){return l(await(z?b(U):(0,_.promisify)(d.readdir)(U)))}async function b(U){try{return await(0,_.promisify)(d.readdir)(U,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const z=[],re=await g(U);for(const H of re){let F=!1,j=!1,x=!1;try{const V=await e.Promises.lstat((0,w.join)(U,H));F=V.isFile(),j=V.isDirectory(),x=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}z.push({name:H,isFile:()=>F,isDirectory:()=>j,isSymbolicLink:()=>x})}return z}function f(U){return l(d.readdirSync(U))}e.readdirSync=f;function l(U){return U.map(z=>typeof z=="string"?P.isMacintosh?(0,y.normalizeNFC)(z):z:(z.name=P.isMacintosh?(0,y.normalizeNFC)(z.name):z.name,z))}async function h(U){const z=await g(U),re=[];for(const H of z)await E.existsDirectory((0,w.join)(U,H))&&re.push(H);return re}function o(U,z=1e3){return new Promise(re=>{let H=!1;const F=setInterval(()=>{H||(H=!0,d.access(U,j=>{H=!1,j&&(clearInterval(F),re(void 0))}))},z)})}e.whenDeleted=o;var E;(function(U){async function z(F){let j;try{if(j=await e.Promises.lstat(F),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(P.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw V}throw x}}U.stat=z;async function re(F){try{const{stat:j,symbolicLink:x}=await U.stat(F);return j.isFile()&&x?.dangling!==!0}catch{}return!1}U.existsFile=re;async function H(F){try{const{stat:j,symbolicLink:x}=await U.stat(F);return j.isDirectory()&&x?.dangling!==!0}catch{}return!1}U.existsDirectory=H})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function s(U,z,re){return r.queueFor(I.URI.file(U),L.extUriBiasedIgnorePathCase).queue(()=>{const H=c(re);return new Promise((F,j)=>t(U,z,H,x=>x?j(x):F()))})}let n=!0;function t(U,z,re,H){if(!n)return d.writeFile(U,z,{mode:re.mode,flag:re.flag},H);d.open(U,re.flag,re.mode,(F,j)=>{if(F)return H(F);d.writeFile(j,z,x=>{if(x)return d.close(j,()=>H(x));d.fdatasync(j,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),n=!1),d.close(j,ne=>H(ne))))})})}function a(U,z,re){const H=c(re);if(!n)return d.writeFileSync(U,z,{mode:H.mode,flag:H.flag});const F=d.openSync(U,H.flag,H.mode);try{d.writeFileSync(F,z);try{d.fdatasyncSync(F)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),n=!1}}finally{d.closeSync(F)}}e.writeFileSync=a;function c(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function u(U,z){if(U!==z)try{await e.Promises.rename(U,z)}catch(re){if(U.toLowerCase()!==z.toLowerCase()&&re.code==="EXDEV"||U.endsWith("."))await S(U,z,{preserveSymlinks:!1}),await T(U,D.MOVE);else throw re}}async function S(U,z,re){return O(U,z,{root:{source:U,target:z},options:re,handledSourcePaths:new Set})}const R=511;async function O(U,z,re){if(re.handledSourcePaths.has(U))return;re.handledSourcePaths.add(U);const{stat:H,symbolicLink:F}=await E.stat(U);if(F){if(re.options.preserveSymlinks)try{return await M(U,z,re)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(F.dangling)return}return H.isDirectory()?N(U,z,H.mode&R,re):p(U,z,H.mode&R)}async function N(U,z,re,H){await e.Promises.mkdir(z,{recursive:!0,mode:re});const F=await g(U);for(const j of F)await O((0,w.join)(U,j),(0,w.join)(z,j),H)}async function p(U,z,re){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,re)}async function M(U,z,re){let H=await e.Promises.readlink(U);(0,k.isEqualOrParent)(H,re.root.source,!P.isLinux)&&(H=(0,w.join)(re.root.target,H.substr(re.root.source.length+1))),await e.Promises.symlink(H,z)}e.Promises=new class{get access(){return(0,_.promisify)(d.access)}get stat(){return(0,_.promisify)(d.stat)}get lstat(){return(0,_.promisify)(d.lstat)}get utimes(){return(0,_.promisify)(d.utimes)}get read(){return(U,z,re,H,F)=>new Promise((j,x)=>{d.read(U,z,re,H,F,(V,ne,Q)=>V?x(V):j({bytesRead:ne,buffer:Q}))})}get readFile(){return(0,_.promisify)(d.readFile)}get write(){return(U,z,re,H,F)=>new Promise((j,x)=>{d.write(U,z,re,H,F,(V,ne,Q)=>V?x(V):j({bytesWritten:ne,buffer:Q}))})}get appendFile(){return(0,_.promisify)(d.appendFile)}get fdatasync(){return(0,_.promisify)(d.fdatasync)}get truncate(){return(0,_.promisify)(d.truncate)}get rename(){return(0,_.promisify)(d.rename)}get copyFile(){return(0,_.promisify)(d.copyFile)}get open(){return(0,_.promisify)(d.open)}get close(){return(0,_.promisify)(d.close)}get symlink(){return(0,_.promisify)(d.symlink)}get readlink(){return(0,_.promisify)(d.readlink)}get chmod(){return(0,_.promisify)(d.chmod)}get mkdir(){return(0,_.promisify)(d.mkdir)}get unlink(){return(0,_.promisify)(d.unlink)}get rmdir(){return(0,_.promisify)(d.rmdir)}get realpath(){return(0,_.promisify)(d.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return h}get writeFile(){return s}get rm(){return T}get move(){return u}get copy(){return S}}}),define(ye[105],De([0,1,61,9,12,8,29]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(D){if(_.isLinux)return D;const T=(0,i.dirname)(D);if(D===T)return D;const C=((0,i.basename)(D)||D).toLowerCase();try{const v=(0,k.readdirSync)(T).filter(g=>g.toLowerCase()===C);if(v.length===1){const g=y(T);if(g)return(0,i.join)(g,v[0])}else if(v.length>1){const g=v.indexOf(C);if(g>=0){const b=y(T);if(b)return(0,i.join)(b,v[g])}}}catch{}return null}e.realcaseSync=y;async function w(D){if(_.isLinux)return D;const T=(0,i.dirname)(D);if(D===T)return D;const C=((0,i.basename)(D)||D).toLowerCase();try{const v=(await k.Promises.readdir(T)).filter(g=>g.toLowerCase()===C);if(v.length===1){const g=await w(T);if(g)return(0,i.join)(g,v[0])}else if(v.length>1){const g=v.indexOf(C);if(g>=0){const b=await w(T);if(b)return(0,i.join)(b,v[g])}}}catch{}return null}e.realcase=w;async function P(D){try{return await k.Promises.realpath(D)}catch{const C=I(D);return await k.Promises.access(C,d.constants.R_OK),C}}e.realpath=P;function L(D){try{return d.realpathSync(D)}catch{const C=I(D);return d.accessSync(C,d.constants.R_OK),C}}e.realpathSync=L;function I(D){return(0,A.rtrim)((0,i.normalize)(D),i.sep)}});var je=this&&this.__decorate||function(Y,e,d,i){var _=arguments.length,A=_<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,d):i,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,d,i);else for(var y=Y.length-1;y>=0;y--)(k=Y[y])&&(A=(_<3?k(A):_>3?k(e,d,A):k(e,d))||A);return _>3&&A&&Object.defineProperty(e,d,A),A};define(ye[106],De([0,1,16,17,23,21,58,11,3,6,60,8,14]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function C(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function v(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(g||(g={}));class b{constructor(x){this.buffer=x,this.pos=0}read(x){const V=this.buffer.slice(this.pos,this.pos+x);return this.pos+=V.byteLength,V}}class f{constructor(){this.buffers=[]}get buffer(){return _.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var l;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(l||(l={}));function h(j){const x=_.VSBuffer.alloc(4);return x.writeUInt32BE(j,0),x}function o(j){return j.read(4).readUInt32BE(0)}function E(j){const x=_.VSBuffer.alloc(1);return x.writeUInt8(j,0),x}const r={Undefined:E(l.Undefined),String:E(l.String),Buffer:E(l.Buffer),VSBuffer:E(l.VSBuffer),Array:E(l.Array),Object:E(l.Object)},s=typeof Buffer!="undefined";function n(j,x){if(typeof x=="undefined")j.write(r.Undefined);else if(typeof x=="string"){const V=_.VSBuffer.fromString(x);j.write(r.String),j.write(h(V.byteLength)),j.write(V)}else if(s&&Buffer.isBuffer(x)){const V=_.VSBuffer.wrap(x);j.write(r.Buffer),j.write(h(V.byteLength)),j.write(V)}else if(x instanceof _.VSBuffer)j.write(r.VSBuffer),j.write(h(x.byteLength)),j.write(x);else if(Array.isArray(x)){j.write(r.Array),j.write(h(x.length));for(const V of x)n(j,V)}else{const V=_.VSBuffer.fromString(JSON.stringify(x));j.write(r.Object),j.write(h(V.byteLength)),j.write(V)}}function t(j){switch(j.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return j.read(o(j)).toString();case l.Buffer:return j.read(o(j)).buffer;case l.VSBuffer:return j.read(o(j));case l.Array:{const V=o(j),ne=[];for(let Q=0;Q<V;Q++)ne.push(t(j));return ne}case l.Object:return JSON.parse(j.read(o(j)).toString())}}class a{constructor(x,V,ne=null,Q=1e3){this.protocol=x,this.ctx=V,this.logger=ne,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(he=>this.onRawMessage(he)),this.sendResponse({type:200})}registerChannel(x,V){this.channels.set(x,V),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const V=this.send([x.type]);this.logger?.logOutgoing(V,0,1,v(x.type));return}case 201:case 202:case 204:case 203:{const V=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(V,x.id,1,v(x.type),x.data);return}}}send(x,V=void 0){const ne=new f;return n(ne,x),n(ne,V),this.sendBuffer(ne.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const V=new b(x),ne=t(V),Q=t(V),he=ne[0];switch(he){case 100:return this.logger?.logIncoming(x.byteLength,ne[1],1,`${C(he)}: ${ne[2]}.${ne[3]}`,Q),this.onPromise({type:he,id:ne[1],channelName:ne[2],name:ne[3],arg:Q});case 102:return this.logger?.logIncoming(x.byteLength,ne[1],1,`${C(he)}: ${ne[2]}.${ne[3]}`,Q),this.onEventListen({type:he,id:ne[1],channelName:ne[2],name:ne[3],arg:Q});case 101:return this.logger?.logIncoming(x.byteLength,ne[1],1,`${C(he)}`),this.disposeActiveRequest({type:he,id:ne[1]});case 103:return this.logger?.logIncoming(x.byteLength,ne[1],1,`${C(he)}`),this.disposeActiveRequest({type:he,id:ne[1]})}}onPromise(x){const V=this.channels.get(x.channelName);if(!V){this.collectPendingRequest(x);return}const ne=new A.CancellationTokenSource;let Q;try{Q=V.call(this.ctx,x.name,x.arg,ne.token)}catch(G){Q=Promise.reject(G)}const he=x.id;Q.then(G=>{this.sendResponse({id:he,data:G,type:201}),this.activeRequests.delete(x.id)},G=>{G instanceof Error?this.sendResponse({id:he,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:he,data:G,type:203}),this.activeRequests.delete(x.id)});const fe=(0,P.toDisposable)(()=>ne.cancel());this.activeRequests.set(x.id,fe)}onEventListen(x){const V=this.channels.get(x.channelName);if(!V){this.collectPendingRequest(x);return}const ne=x.id,he=V.listen(this.ctx,x.name,x.arg)(fe=>this.sendResponse({id:ne,data:fe,type:204}));this.activeRequests.set(x.id,he)}disposeActiveRequest(x){const V=this.activeRequests.get(x.id);V&&(V.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let V=this.pendingRequests.get(x.channelName);V||(V=[],this.pendingRequests.set(x.channelName,V));const ne=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:x,timeoutTimer:ne})}flushPendingRequests(x){const V=this.pendingRequests.get(x);if(V){for(const ne of V)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var c;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(x,V=null){this.protocol=x,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=V}getChannel(x){const V=this;return{call(ne,Q,he){return V.isDisposed?Promise.reject(y.canceled()):V.requestPromise(x,ne,Q,he)},listen(ne,Q){return V.isDisposed?w.Event.None:V.requestEvent(x,ne,Q)}}}requestPromise(x,V,ne,Q=A.CancellationToken.None){const he=this.lastRequestId++,G={id:he,type:100,channelName:x,name:V,arg:ne};if(Q.isCancellationRequested)return Promise.reject(y.canceled());let X;return new Promise((pe,Ie)=>{if(Q.isCancellationRequested)return Ie(y.canceled());const Re=()=>{const ue=ve=>{switch(ve.type){case 201:this.handlers.delete(he),pe(ve.data);break;case 202:{this.handlers.delete(he);const ie=new Error(ve.data.message);ie.stack=ve.data.stack,ie.name=ve.data.name,Ie(ie);break}case 203:this.handlers.delete(he),Ie(ve.data);break}};this.handlers.set(he,ue),this.sendRequest(G)};let Ce=null;this.state===g.Idle?Re():(Ce=(0,i.createCancelablePromise)(ue=>this.whenInitialized()),Ce.then(()=>{Ce=null,Re()}));const ke=()=>{Ce?(Ce.cancel(),Ce=null):this.sendRequest({id:he,type:101}),Ie(y.canceled())},Ae=Q.onCancellationRequested(ke);X=(0,P.combinedDisposable)((0,P.toDisposable)(ke),Ae),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(x,V,ne){const Q=this.lastRequestId++,fe={id:Q,type:102,channelName:x,name:V,arg:ne};let G=null;const X=new w.Emitter({onFirstListenerAdd:()=>{G=(0,i.createCancelablePromise)(pe=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(X),this.sendRequest(fe)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(X),this.sendRequest({id:Q,type:103}))}}),ce=pe=>X.fire(pe.data);return this.handlers.set(Q,ce),X.event}sendRequest(x){switch(x.type){case 100:case 102:{const V=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(V,x.id,0,`${C(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const V=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(V,x.id,0,C(x.type));return}}}send(x,V=void 0){const ne=new f;return n(ne,x),n(ne,V),this.sendBuffer(ne.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const V=new b(x),ne=t(V),Q=t(V),he=ne[0];switch(he){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,v(he)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,ne[1],0,v(he),Q),this.onResponse({type:ne[0],id:ne[1],data:Q})}}onResponse(x){if(x.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(x.id);V&&V(x)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([k.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class S{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:V,onDidClientDisconnect:ne})=>{w.Event.once(V.onMessage)(he=>{const fe=new b(he),G=t(fe),X=new a(V,G),ce=new u(V);this.channels.forEach((Ie,Re)=>X.registerChannel(Re,Ie));const pe={channelServer:X,channelClient:ce,ctx:G};this._connections.add(pe),this._onDidAddConnection.fire(pe),ne(()=>{X.dispose(),ce.dispose(),this._connections.delete(pe),this._onDidRemoveConnection.fire(pe)})})})}get connections(){const x=[];return this._connections.forEach(V=>x.push(V)),x}getChannel(x,V){const ne=this;return{call(Q,he,fe){let G;if((0,D.isFunction)(V)){let ce=(0,d.getRandomElement)(ne.connections.filter(V));G=ce?Promise.resolve(ce):w.Event.toPromise(w.Event.filter(ne.onDidAddConnection,V))}else G=V.routeCall(ne,Q,he);const X=G.then(ce=>ce.channelClient.getChannel(x));return O(X).call(Q,he,fe)},listen(Q,he){if((0,D.isFunction)(V))return ne.getMulticastEvent(x,V,Q,he);const fe=V.routeEvent(ne,Q,he).then(G=>G.channelClient.getChannel(x));return O(fe).listen(Q,he)}}}getMulticastEvent(x,V,ne,Q){const he=this;let fe=new P.DisposableStore;const G=new w.Emitter({onFirstListenerAdd:()=>{fe=new P.DisposableStore;const X=new w.EventMultiplexer,ce=new Map,pe=Re=>{const ke=Re.channelClient.getChannel(x).listen(ne,Q),Ae=X.add(ke);ce.set(Re,Ae)},Ie=Re=>{const Ce=ce.get(Re);!Ce||(Ce.dispose(),ce.delete(Re))};he.connections.filter(V).forEach(pe),w.Event.filter(he.onDidAddConnection,V)(pe,void 0,fe),he.onDidRemoveConnection(Ie,void 0,fe),X.event(G.fire,G,fe),fe.add(X)},onLastListenerRemove:()=>{fe.dispose()}});return G.event}registerChannel(x,V){this.channels.set(x,V),this._connections.forEach(ne=>{ne.channelServer.registerChannel(x,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class R{constructor(x,V,ne=null){const Q=new f;n(Q,V),x.send(Q.buffer),this.channelClient=new u(x,ne),this.channelServer=new a(x,V,ne)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,V){this.channelServer.registerChannel(x,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(j){return{call(x,V,ne){return j.then(Q=>Q.call(x,V,ne))},listen(x,V){const ne=new w.Relay;return j.then(Q=>ne.input=Q.listen(x,V)),ne.event}}}e.getDelayedChannel=O;function N(j){let x=!1;return{call(V,ne,Q){return x?j.call(V,ne,Q):(0,i.timeout)(0).then(()=>x=!0).then(()=>j.call(V,ne,Q))},listen(V,ne){if(x)return j.listen(V,ne);const Q=new w.Relay;return(0,i.timeout)(0).then(()=>x=!0).then(()=>Q.input=j.listen(V,ne)),Q.event}}}e.getNextTickChannel=N;class p{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const V of x.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await w.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=p;var M;(function(j){function x(he,fe){const G=he,X=fe&&fe.disableMarshalling,ce=new Map;for(const pe in G)ne(pe)&&ce.set(pe,w.Event.buffer(G[pe],!0));return new class{listen(pe,Ie,Re){const Ce=ce.get(Ie);if(Ce)return Ce;if(Q(Ie)){const ke=G[Ie];if(typeof ke=="function")return ke.call(G,Re)}throw new Error(`Event not found: ${Ie}`)}call(pe,Ie,Re){const Ce=G[Ie];if(typeof Ce=="function"){if(!X&&Array.isArray(Re))for(let ke=0;ke<Re.length;ke++)Re[ke]=(0,L.revive)(Re[ke]);return Ce.apply(G,Re)}throw new Error(`Method not found: ${Ie}`)}}}j.fromService=x;function V(he,fe){const G=fe&&fe.disableMarshalling;return new Proxy({},{get(X,ce){if(typeof ce=="string")return fe?.properties?.has(ce)?fe.properties.get(ce):Q(ce)?function(pe){return he.listen(ce,pe)}:ne(ce)?he.listen(ce):async function(...pe){let Ie;fe&&!(0,D.isUndefinedOrNull)(fe.context)?Ie=[fe.context,...pe]:Ie=pe;const Re=await he.call(ce,Ie);return G?Re:(0,L.revive)(Re)};throw new Error(`Property not found: ${String(ce)}`)}})}j.toService=V;function ne(he){return he[0]==="o"&&he[1]==="n"&&I.isUpperAsciiLetter(he.charCodeAt(2))}function Q(he){return/^onDynamic/.test(he)&&I.isUpperAsciiLetter(he.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let x=j.toString();if(x!=="[object Object]")return x}return j}function re(j){return Array.isArray(j)?j.map(z):z(j)}function H(j,x,V,ne,Q,he,fe){fe=re(fe);const G=U[Q],X=G[ne%G.length];let ce=[`%c[${j}]%c[${String(x).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${he}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(he)?(ce=ce.concat(fe),ce.push(")")):ce.push(fe),console.log.apply(console,ce)}e.logWithColors=H;class F{constructor(x,V){this._outgoingPrefix=x,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,V,ne,Q,he){this._totalOutgoing+=x,H(this._outgoingPrefix,this._totalOutgoing,x,V,ne,Q,he)}logIncoming(x,V,ne,Q,he){this._totalIncoming+=x,H(this._incomingPrefix,this._totalIncoming,x,V,ne,Q,he)}}e.IPCLogger=F}),define(ye[107],De([0,1,23,3,6,106]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(s){s.enableDiagnostics=!1,s.records=[];const n=new WeakMap;let t=0;function a(u,S){if(!n.has(u)){const R=String(++t);n.set(u,R)}return n.get(u)}function c(u,S,R,O){if(!s.enableDiagnostics)return;const N=a(u,S);if(O instanceof d.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const p=d.VSBuffer.alloc(O.byteLength);p.set(O),s.records.push({timestamp:Date.now(),id:N,label:S,type:R,buff:p})}else s.records.push({timestamp:Date.now(),id:N,label:S,type:R,data:O})}s.traceSocketEvent=c})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function L(){return P||(P=d.VSBuffer.alloc(0)),P}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,t){if(n===0)return L();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const S=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=n),S}if(this._chunks[0].byteLength>n){const S=this._chunks[0].slice(0,n);return t&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),S}let a=d.VSBuffer.alloc(n),c=0,u=0;for(;n>0;){const S=this._chunks[u];if(S.byteLength>n){const R=S.slice(0,n);a.set(R,c),c+=n,t&&(this._chunks[u]=S.slice(n),this._totalLength-=n),n-=n}else a.set(S,c),c+=S.byteLength,t?(this._chunks.shift(),this._totalLength-=S.byteLength):u++,n-=S.byteLength}return a}}e.ChunkStream=I;var D;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(D||(D={}));function T(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var C;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(C=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(n,t,a,c){this.type=n,this.id=t,this.ack=a,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends _.Disposable{constructor(n){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,c=this._state.id,u=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new m(a,c,u,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=d.VSBuffer.alloc(13);t.writeUInt8(n.type,0),t.writeUInt32BE(n.id,1),t.writeUInt32BE(n.ack,5),t.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(t,n.data)}_bufferAdd(n,t){const a=this._totalLength===0;return this._data.push(n,t),this._totalLength+=n.byteLength+t.byteLength,a}_bufferTake(){const n=d.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,t){this._bufferAdd(n,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class b extends _.Disposable{constructor(n){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new m(1,0,0,n))}}e.Protocol=b;class f extends A.IPCClient{constructor(n,t,a=null){super(n,t,a);this.protocol=n}static fromSocket(n,t){return new f(new b(n),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=f;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class h{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],t=0,a=this._first;for(;a;)n[t++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const t=new h(n);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class E{constructor(){this.lastRuns=[];const n=Date.now();for(let t=0;t<E._HISTORY_LENGTH;t++)this.lastRuns[t]=n-1e3*t;setInterval(()=>{for(let t=E._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const n=Date.now(),t=(1+E._HISTORY_LENGTH)*1e3;let a=0;for(let c=0;c<E._HISTORY_LENGTH;c++)n-this.lastRuns[c]<=t&&a++;return 1-a/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class r{constructor(n,t=null,a=E.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,_.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new m(5,0,0,L());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new m(7,0,0,L());this._socketWriter.write(n)}sendResume(){const n=new m(8,0,0,L());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,t){this._isReconnecting=!0,this._socketDisposables=(0,_.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new m(3,0,this._incomingAckId,L());this._socketWriter.write(n);const t=this._outgoingUnackMsg.toArray();for(let a=0,c=t.length;a<c;a++)this._socketWriter.write(t[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new m(6,0,0,L())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let a=0,c=t.length;a<c;a++)this._socketWriter.write(t[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,t,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const t=new m(2,0,0,n);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),t=Date.now()-n.writtenTime,a=Date.now()-this._socketReader.lastReadTime,c=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&a>=2e4&&c>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const u=Math.max(2e4-t,2e4-a,2e4-c,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},u)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new m(3,0,this._incomingAckId,L());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(ye[108],De([0,1,98]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(y){const w=(0,d.toUint8)(y);this._defaultValue=w,this._asciiMap=i._createAsciiMap(w),this._map=new Map}static _createAsciiMap(y){const w=new Uint8Array(256);for(let P=0;P<256;P++)w[P]=y;return w}set(y,w){const P=(0,d.toUint8)(w);y>=0&&y<256?this._asciiMap[y]=P:this._map.set(y,P)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=i;var _;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(_||(_={}));class A{constructor(){this._actual=new i(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=A}),define(ye[50],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class d{constructor(_,A){this.lineNumber=_,this.column=A}with(_=this.lineNumber,A=this.column){return _===this.lineNumber&&A===this.column?this:new d(_,A)}delta(_=0,A=0){return this.with(this.lineNumber+_,this.column+A)}equals(_){return d.equals(this,_)}static equals(_,A){return!_&&!A?!0:!!_&&!!A&&_.lineNumber===A.lineNumber&&_.column===A.column}isBefore(_){return d.isBefore(this,_)}static isBefore(_,A){return _.lineNumber<A.lineNumber?!0:A.lineNumber<_.lineNumber?!1:_.column<A.column}isBeforeOrEqual(_){return d.isBeforeOrEqual(this,_)}static isBeforeOrEqual(_,A){return _.lineNumber<A.lineNumber?!0:A.lineNumber<_.lineNumber?!1:_.column<=A.column}static compare(_,A){const k=_.lineNumber|0,y=A.lineNumber|0;if(k===y){const w=_.column|0,P=A.column|0;return w-P}return k-y}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(_){return new d(_.lineNumber,_.column)}static isIPosition(_){return _&&typeof _.lineNumber=="number"&&typeof _.column=="number"}}e.Position=d}),define(ye[37],De([0,1,50]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(A,k,y,w){A>y||A===y&&k>w?(this.startLineNumber=y,this.startColumn=w,this.endLineNumber=A,this.endColumn=k):(this.startLineNumber=A,this.startColumn=k,this.endLineNumber=y,this.endColumn=w)}isEmpty(){return i.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return i.containsPosition(this,A)}static containsPosition(A,k){return!(k.lineNumber<A.startLineNumber||k.lineNumber>A.endLineNumber||k.lineNumber===A.startLineNumber&&k.column<A.startColumn||k.lineNumber===A.endLineNumber&&k.column>A.endColumn)}static strictContainsPosition(A,k){return!(k.lineNumber<A.startLineNumber||k.lineNumber>A.endLineNumber||k.lineNumber===A.startLineNumber&&k.column<=A.startColumn||k.lineNumber===A.endLineNumber&&k.column>=A.endColumn)}containsRange(A){return i.containsRange(this,A)}static containsRange(A,k){return!(k.startLineNumber<A.startLineNumber||k.endLineNumber<A.startLineNumber||k.startLineNumber>A.endLineNumber||k.endLineNumber>A.endLineNumber||k.startLineNumber===A.startLineNumber&&k.startColumn<A.startColumn||k.endLineNumber===A.endLineNumber&&k.endColumn>A.endColumn)}strictContainsRange(A){return i.strictContainsRange(this,A)}static strictContainsRange(A,k){return!(k.startLineNumber<A.startLineNumber||k.endLineNumber<A.startLineNumber||k.startLineNumber>A.endLineNumber||k.endLineNumber>A.endLineNumber||k.startLineNumber===A.startLineNumber&&k.startColumn<=A.startColumn||k.endLineNumber===A.endLineNumber&&k.endColumn>=A.endColumn)}plusRange(A){return i.plusRange(this,A)}static plusRange(A,k){let y,w,P,L;return k.startLineNumber<A.startLineNumber?(y=k.startLineNumber,w=k.startColumn):k.startLineNumber===A.startLineNumber?(y=k.startLineNumber,w=Math.min(k.startColumn,A.startColumn)):(y=A.startLineNumber,w=A.startColumn),k.endLineNumber>A.endLineNumber?(P=k.endLineNumber,L=k.endColumn):k.endLineNumber===A.endLineNumber?(P=k.endLineNumber,L=Math.max(k.endColumn,A.endColumn)):(P=A.endLineNumber,L=A.endColumn),new i(y,w,P,L)}intersectRanges(A){return i.intersectRanges(this,A)}static intersectRanges(A,k){let y=A.startLineNumber,w=A.startColumn,P=A.endLineNumber,L=A.endColumn,I=k.startLineNumber,D=k.startColumn,T=k.endLineNumber,C=k.endColumn;return y<I?(y=I,w=D):y===I&&(w=Math.max(w,D)),P>T?(P=T,L=C):P===T&&(L=Math.min(L,C)),y>P||y===P&&w>L?null:new i(y,w,P,L)}equalsRange(A){return i.equalsRange(this,A)}static equalsRange(A,k){return!!A&&!!k&&A.startLineNumber===k.startLineNumber&&A.startColumn===k.startColumn&&A.endLineNumber===k.endLineNumber&&A.endColumn===k.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(A){return new d.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(A){return new d.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,k){return new i(this.startLineNumber,this.startColumn,A,k)}setStartPosition(A,k){return new i(A,k,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(A){return new i(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,k=A){return new i(A.lineNumber,A.column,k.lineNumber,k.column)}static lift(A){return A?new i(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,k){return!(A.endLineNumber<k.startLineNumber||A.endLineNumber===k.startLineNumber&&A.endColumn<k.startColumn||k.endLineNumber<A.startLineNumber||k.endLineNumber===A.startLineNumber&&k.endColumn<A.startColumn)}static areIntersecting(A,k){return!(A.endLineNumber<k.startLineNumber||A.endLineNumber===k.startLineNumber&&A.endColumn<=k.startColumn||k.endLineNumber<A.startLineNumber||k.endLineNumber===A.startLineNumber&&k.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,k){if(A&&k){const P=A.startLineNumber|0,L=k.startLineNumber|0;if(P===L){const I=A.startColumn|0,D=k.startColumn|0;if(I===D){const T=A.endLineNumber|0,C=k.endLineNumber|0;if(T===C){const m=A.endColumn|0,v=k.endColumn|0;return m-v}return T-C}return I-D}return P-L}return(A?1:0)-(k?1:0)}static compareRangesUsingEnds(A,k){return A.endLineNumber===k.endLineNumber?A.endColumn===k.endColumn?A.startLineNumber===k.startLineNumber?A.startColumn-k.startColumn:A.startLineNumber-k.startLineNumber:A.endColumn-k.endColumn:A.endLineNumber-k.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=i}),define(ye[149],De([0,1,50,37]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var _;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(_=e.SelectionDirection||(e.SelectionDirection={}));class A extends i.Range{constructor(y,w,P,L){super(y,w,P,L);this.selectionStartLineNumber=y,this.selectionStartColumn=w,this.positionLineNumber=P,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return A.selectionsEqual(this,y)}static selectionsEqual(y,w){return y.selectionStartLineNumber===w.selectionStartLineNumber&&y.selectionStartColumn===w.selectionStartColumn&&y.positionLineNumber===w.positionLineNumber&&y.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,w){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,y,w):new A(y,w,this.startLineNumber,this.startColumn)}getPosition(){return new d.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(y,w){return this.getDirection()===0?new A(y,w,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,y,w)}static fromPositions(y,w=y){return new A(y.lineNumber,y.column,w.lineNumber,w.column)}static fromRange(y,w){return w===0?new A(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):new A(y.endLineNumber,y.endColumn,y.startLineNumber,y.startColumn)}static liftSelection(y){return new A(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,w){if(y&&!w||!y&&w)return!1;if(!y&&!w)return!0;if(y.length!==w.length)return!1;for(let P=0,L=y.length;P<L;P++)if(!this.selectionsEqual(y[P],w[P]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,w,P,L,I){return I===0?new A(y,w,P,L):new A(P,L,y,w)}}e.Selection=A}),define(ye[150],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],De([0,1,108]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class _ extends d.CharacterClassifier{constructor(y){super(0);for(let w=0,P=y.length;w<P;w++)this.set(y.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=_;function A(k){const y={};return w=>(y.hasOwnProperty(w)||(y[w]=k(w)),y[w])}e.getMapForWordSeparators=A(k=>new _(k))}),define(ye[109],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function d(y=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)y.indexOf(P)>=0||(w+="\\"+P);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=d();function i(y){let w=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)w=y;else{let P="g";y.ignoreCase&&(P+="i"),y.multiline&&(P+="m"),y.unicode&&(P+="u"),w=new RegExp(y.source,P)}return w.lastIndex=0,w}e.ensureValidWordDefinition=i;const _={maxLen:1e3,windowSize:15,timeBudget:150};function A(y,w,P,L,I=_){if(P.length>I.maxLen){let v=y-I.maxLen/2;return v<0?v=0:L+=v,P=P.substring(v,y+I.maxLen/2),A(y,w,P,L,I)}const D=Date.now(),T=y-1-L;let C=-1,m=null;for(let v=1;!(Date.now()-D>=I.timeBudget);v++){const g=T-I.windowSize*v;w.lastIndex=Math.max(0,g);const b=k(w,P,T,C);if(!b&&m||(m=b,g<=0))break;C=g}if(m){const v={word:m[0],startColumn:L+1+m.index,endColumn:L+1+m.index+m[0].length};return w.lastIndex=0,v}return null}e.getWordAtText=A;function k(y,w,P,L){let I;for(;I=y.exec(w);){const D=I.index||0;if(D<=P&&y.lastIndex>=P)return I;if(L>0&&D>L)return null}return null}}),define(ye[152],De([0,1,35,9]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,k,y,w,P){if(Array.isArray(A)){let L=0;for(const I of A){const D=_(I,k,y,w,P);if(D===10)return D;D>L&&(L=D)}return L}else{if(typeof A=="string")return w?A==="*"?5:A===y?10:0:0;if(A){const{language:L,pattern:I,scheme:D,hasAccessToAllModels:T,notebookType:C}=A;if(!w&&!T)return 0;let m=0;if(D)if(D===k.scheme)m=10;else if(D==="*")m=5;else return 0;if(L)if(L===y)m=10;else if(L==="*")m=Math.max(m,5);else return 0;if(C)if(C===P)m=10;else if(C==="*"&&P!==void 0)m=Math.max(m,5);else return 0;if(I){let v;if(typeof I=="string"?v=I:v={...I,base:(0,i.normalize)(I.base)},v===k.fsPath||(0,d.match)(v,k.fsPath))m=10;else return 0}return m}else return 0}}e.score=_}),define(ye[153],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class i{constructor(y){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=y.open,this.close=y.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(y.notIn))for(let w=0,P=y.notIn.length;w<P;w++)switch(y.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(y){switch(y){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(y,w){if(y.getTokenCount()===0)return!0;const P=y.findTokenIndexAtOffset(w-2),L=y.getStandardTokenType(P);return this.isOK(L)}_findNeutralCharacterInRange(y,w){for(let P=y;P<=w;P++){const L=String.fromCharCode(P);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class _{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of y)A(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),A(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),A(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),A(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&A(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=_;function A(k,y,w){k.has(y)?k.get(y).push(w):k.set(y,[w])}}),define(ye[154],De([0,1,108]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class _{constructor(C,m,v){const g=new Uint8Array(C*m);for(let b=0,f=C*m;b<f;b++)g[b]=v;this._data=g,this.rows=C,this.cols=m}get(C,m){return this._data[C*this.cols+m]}set(C,m,v){this._data[C*this.cols+m]=v}}e.Uint8Matrix=_;class A{constructor(C){let m=0,v=0;for(let b=0,f=C.length;b<f;b++){const[l,h,o]=C[b];h>m&&(m=h),l>v&&(v=l),o>v&&(v=o)}m++,v++;const g=new _(v,m,0);for(let b=0,f=C.length;b<f;b++){const[l,h,o]=C[b];g.set(l,h,o)}this._states=g,this._maxCharCode=m}nextState(C,m){return m<0||m>=this._maxCharCode?0:this._states.get(C,m)}}e.StateMachine=A;let k=null;function y(){return k===null&&(k=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var w;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let P=null;function L(){if(P===null){P=new d.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<T.length;m++)P.set(T.charCodeAt(m),1);const C=".,;";for(let m=0;m<C.length;m++)P.set(C.charCodeAt(m),2)}return P}class I{static _createLink(C,m,v,g,b){let f=b-1;do{const l=m.charCodeAt(f);if(C.get(l)!==2)break;f--}while(f>g);if(g>0){const l=m.charCodeAt(g-1),h=m.charCodeAt(f);(l===40&&h===41||l===91&&h===93||l===123&&h===125)&&f--}return{range:{startLineNumber:v,startColumn:g+1,endLineNumber:v,endColumn:f+2},url:m.substring(g,f+1)}}static computeLinks(C,m=y()){const v=L(),g=[];for(let b=1,f=C.getLineCount();b<=f;b++){const l=C.getLineContent(b),h=l.length;let o=0,E=0,r=0,s=1,n=!1,t=!1,a=!1,c=!1;for(;o<h;){let u=!1;const S=l.charCodeAt(o);if(s===13){let R;switch(S){case 40:n=!0,R=0;break;case 41:R=n?0:1;break;case 91:a=!0,t=!0,R=0;break;case 93:a=!1,R=t?0:1;break;case 123:c=!0,R=0;break;case 125:R=c?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=a?0:1;break;default:R=v.get(S)}R===1&&(g.push(I._createLink(v,l,b,E,o)),u=!0)}else if(s===12){let R;S===91?(t=!0,R=0):R=v.get(S),R===1?u=!0:s=13}else s=m.nextState(s,S),s===0&&(u=!0);u&&(s=1,n=!1,t=!1,c=!1,E=o+1,r=S),o++}s===13&&g.push(I._createLink(v,l,b,E,h))}return g}}e.LinkComputer=I;function D(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:I.computeLinks(T)}e.computeLinks=D}),define(ye[110],De([0,1,26]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var _;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(_=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var k;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var w;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(w=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace),this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class L{constructor(f,l){this._findMatchBrand=void 0,this.range=f,this.matches=l}}e.FindMatch=L;var I;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var D;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(D=e.PositionAffinity||(e.PositionAffinity={}));var T;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class C{constructor(f,l,h,o,E,r){this.identifier=f,this.range=l,this.text=h,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=E,this._isTracked=r}}e.ValidAnnotatedEditOperation=C;class m{constructor(f,l,h){this.regex=f,this.wordSeparators=l,this.simpleSearch=h}}e.SearchData=m;class v{constructor(f,l,h){this.reverseEdits=f,this.changes=l,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=v;function g(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(ye[155],De([0,1,16,98]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class _{constructor(w){this.values=w,this.prefixSum=new Uint32Array(w.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(w,P){w=(0,i.toUint32)(w);const L=this.values,I=this.prefixSum,D=P.length;return D===0?!1:(this.values=new Uint32Array(L.length+D),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w),w+D),this.values.set(P,w),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(w,P){return w=(0,i.toUint32)(w),P=(0,i.toUint32)(P),this.values[w]===P?!1:(this.values[w]=P,w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),!0)}removeValues(w,P){w=(0,i.toUint32)(w),P=(0,i.toUint32)(P);const L=this.values,I=this.prefixSum;if(w>=L.length)return!1;const D=L.length-w;return P>=D&&(P=D),P===0?!1:(this.values=new Uint32Array(L.length-P),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w+P),w),this.prefixSum=new Uint32Array(this.values.length),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(w){return w<0?0:(w=(0,i.toUint32)(w),this._getPrefixSum(w))}_getPrefixSum(w){if(w<=this.prefixSumValidIndex[0])return this.prefixSum[w];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),w>=this.values.length&&(w=this.values.length-1);for(let L=P;L<=w;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],w),this.prefixSum[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let P=0,L=this.values.length-1,I=0,D=0,T=0;for(;P<=L;)if(I=P+(L-P)/2|0,D=this.prefixSum[I],T=D-this.values[I],w<T)L=I-1;else if(w>=D)P=I+1;else break;return new k(I,w-T)}}e.PrefixSumComputer=_;class A{constructor(w){this._values=w,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(w){return this._ensureValid(),w===0?0:this._prefixSum[w-1]}getIndexOf(w){this._ensureValid();const P=this._indexBySum[w],L=P>0?this._prefixSum[P-1]:0;return new k(P,w-L)}removeValues(w,P){this._values.splice(w,P),this._invalidate(w)}insertValues(w,P){this._values=(0,d.arrayInsert)(this._values,w,P),this._invalidate(w)}_invalidate(w){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,w-1)}_ensureValid(){if(!this._isValid){for(let w=this._validEndIndex+1,P=this._values.length;w<P;w++){const L=this._values[w],I=w>0?this._prefixSum[w-1]:0;this._prefixSum[w]=I+L;for(let D=0;D<L;D++)this._indexBySum[I+D]=w}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(w,P){this._values[w]!==P&&(this._values[w]=P,this._invalidate(w))}}e.ConstantTimePrefixSumComputer=A;class k{constructor(w,P){this.index=w,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=P}}e.PrefixSumIndexOfResult=k}),define(ye[156],De([0,1,8,50,155]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(y,w,P,L){this._uri=y,this._lines=w,this._eol=P,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const w=y.changes;for(const P of w)this._acceptDeleteRange(P.range),this._acceptInsertText(new i.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,w=this._lines.length,P=new Uint32Array(w);for(let L=0;L<w;L++)P[L]=this._lines[L].length+y;this._lineStarts=new _.PrefixSumComputer(P)}}_setLineText(y,w){this._lines[y]=w,this._lineStarts&&this._lineStarts.setValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,w){if(w.length===0)return;const P=(0,d.splitLines)(w);if(P.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+P[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}P[P.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+P[0]);const L=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(y.lineNumber+I-1,0,P[I]),L[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,L)}}e.MirrorTextModel=A}),define(ye[157],De([0,1,8,151,50,37,110]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class w{constructor(b,f,l,h){this.searchString=b,this.isRegex=f,this.matchCase=l,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=P(this.searchString):b=this.searchString.indexOf(`
`)>=0;let f=null;try{f=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!f)return null;let l=!this.isRegex&&!b;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new k.SearchData(f,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}e.SearchParams=w;function P(g){if(!g||g.length===0)return!1;for(let b=0,f=g.length;b<f;b++)if(g.charCodeAt(b)===92){if(b++,b>=f)break;const h=g.charCodeAt(b);if(h===110||h===114||h===87)return!0}return!1}e.isMultilineRegexSource=P;function L(g,b,f){if(!f)return new k.FindMatch(g,null);const l=[];for(let h=0,o=b.length;h<o;h++)l[h]=b[h];return new k.FindMatch(g,l)}e.createFindMatch=L;class I{constructor(b){const f=[];let l=0;for(let h=0,o=b.length;h<o;h++)b.charCodeAt(h)===10&&(f[l++]=h);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(b){const f=this._lineFeedsOffsets;let l=0,h=f.length-1;if(h===-1||b<=f[0])return 0;for(;l<h;){const o=l+((h-l)/2>>0);f[o]>=b?h=o-1:f[o+1]>=b?(l=o,h=o):l=o+1}return l+1}}class D{static findMatches(b,f,l,h,o){const E=f.parseSearchRequest();return E?E.regex.multiline?this._doFindMatchesMultiline(b,l,new v(E.wordSeparators,E.regex),h,o):this._doFindMatchesLineByLine(b,l,E,h,o):[]}static _getMultilineMatchRange(b,f,l,h,o,E){let r,s=0;h?(s=h.findLineFeedCountBeforeOffset(o),r=f+o+s):r=f+o;let n;if(h){const u=h.findLineFeedCountBeforeOffset(o+E.length)-s;n=r+E.length+u}else n=r+E.length;const t=b.getPositionAt(r),a=b.getPositionAt(n);return new A.Range(t.lineNumber,t.column,a.lineNumber,a.column)}static _doFindMatchesMultiline(b,f,l,h,o){const E=b.getOffsetAt(f.getStartPosition()),r=b.getValueInRange(f,1),s=b.getEOL()===`\r
`?new I(r):null,n=[];let t=0,a;for(l.reset(0);a=l.next(r);)if(n[t++]=L(this._getMultilineMatchRange(b,E,r,s,a.index,a[0]),a,h),t>=o)return n;return n}static _doFindMatchesLineByLine(b,f,l,h,o){const E=[];let r=0;if(f.startLineNumber===f.endLineNumber){const n=b.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(l,n,f.startLineNumber,f.startColumn-1,r,E,h,o),E}const s=b.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(l,s,f.startLineNumber,f.startColumn-1,r,E,h,o);for(let n=f.startLineNumber+1;n<f.endLineNumber&&r<o;n++)r=this._findMatchesInLine(l,b.getLineContent(n),n,0,r,E,h,o);if(r<o){const n=b.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(l,n,f.endLineNumber,0,r,E,h,o)}return E}static _findMatchesInLine(b,f,l,h,o,E,r,s){const n=b.wordSeparators;if(!r&&b.simpleSearch){const c=b.simpleSearch,u=c.length,S=f.length;let R=-u;for(;(R=f.indexOf(c,R+u))!==-1;)if((!n||m(n,f,S,R,u))&&(E[o++]=new k.FindMatch(new A.Range(l,R+1+h,l,R+1+u+h),null),o>=s))return o;return o}const t=new v(b.wordSeparators,b.regex);let a;t.reset(0);do if(a=t.next(f),a&&(E[o++]=L(new A.Range(l,a.index+1+h,l,a.index+1+a[0].length+h),a,r),o>=s))return o;while(a);return o}static findNextMatch(b,f,l,h){const o=f.parseSearchRequest();if(!o)return null;const E=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(b,l,E,h):this._doFindNextMatchLineByLine(b,l,E,h)}static _doFindNextMatchMultiline(b,f,l,h){const o=new _.Position(f.lineNumber,1),E=b.getOffsetAt(o),r=b.getLineCount(),s=b.getValueInRange(new A.Range(o.lineNumber,o.column,r,b.getLineMaxColumn(r)),1),n=b.getEOL()===`\r
`?new I(s):null;l.reset(f.column-1);let t=l.next(s);return t?L(this._getMultilineMatchRange(b,E,s,n,t.index,t[0]),t,h):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(b,new _.Position(1,1),l,h):null}static _doFindNextMatchLineByLine(b,f,l,h){const o=b.getLineCount(),E=f.lineNumber,r=b.getLineContent(E),s=this._findFirstMatchInLine(l,r,E,f.column,h);if(s)return s;for(let n=1;n<=o;n++){const t=(E+n-1)%o,a=b.getLineContent(t+1),c=this._findFirstMatchInLine(l,a,t+1,1,h);if(c)return c}return null}static _findFirstMatchInLine(b,f,l,h,o){b.reset(h-1);const E=b.next(f);return E?L(new A.Range(l,E.index+1,l,E.index+1+E[0].length),E,o):null}static findPreviousMatch(b,f,l,h){const o=f.parseSearchRequest();if(!o)return null;const E=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(b,l,E,h):this._doFindPreviousMatchLineByLine(b,l,E,h)}static _doFindPreviousMatchMultiline(b,f,l,h){const o=this._doFindMatchesMultiline(b,new A.Range(1,1,f.lineNumber,f.column),l,h,10*y);if(o.length>0)return o[o.length-1];const E=b.getLineCount();return f.lineNumber!==E||f.column!==b.getLineMaxColumn(E)?this._doFindPreviousMatchMultiline(b,new _.Position(E,b.getLineMaxColumn(E)),l,h):null}static _doFindPreviousMatchLineByLine(b,f,l,h){const o=b.getLineCount(),E=f.lineNumber,r=b.getLineContent(E).substring(0,f.column-1),s=this._findLastMatchInLine(l,r,E,h);if(s)return s;for(let n=1;n<=o;n++){const t=(o+E-n-1)%o,a=b.getLineContent(t+1),c=this._findLastMatchInLine(l,a,t+1,h);if(c)return c}return null}static _findLastMatchInLine(b,f,l,h){let o=null,E;for(b.reset(0);E=b.next(f);)o=L(new A.Range(l,E.index+1,l,E.index+1+E[0].length),E,h);return o}}e.TextModelSearch=D;function T(g,b,f,l,h){if(l===0)return!0;const o=b.charCodeAt(l-1);if(g.get(o)!==0||o===13||o===10)return!0;if(h>0){const E=b.charCodeAt(l);if(g.get(E)!==0)return!0}return!1}function C(g,b,f,l,h){if(l+h===f)return!0;const o=b.charCodeAt(l+h);if(g.get(o)!==0||o===13||o===10)return!0;if(h>0){const E=b.charCodeAt(l+h-1);if(g.get(E)!==0)return!0}return!1}function m(g,b,f,l,h){return T(g,b,f,l,h)&&C(g,b,f,l,h)}e.isValidMatch=m;class v{constructor(b,f){this._wordSeparators=b,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const f=b.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(l=this._searchRegex.exec(b),!l))return null;const h=l.index,o=l[0].length;if(h===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){d.getNextCodePoint(b,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=h,this._prevMatchLength=o,!this._wordSeparators||m(this._wordSeparators,b,f,h,o))return l}while(l);return null}}e.Searcher=v}),define(ye[111],De([0,1,23,12]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(_||(_={}));function A(I){for(let D=0,T=I.length;D<T;D+=4){const C=I[D+0],m=I[D+1],v=I[D+2],g=I[D+3];I[D+0]=g,I[D+1]=v,I[D+2]=m,I[D+3]=C}}function k(I){const D=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return i.isLittleEndian()||A(D),d.VSBuffer.wrap(D)}function y(I){const D=I.buffer;if(i.isLittleEndian()||A(D),D.byteOffset%4==0)return new Uint32Array(D.buffer,D.byteOffset,D.length/4);{const T=new Uint8Array(D.byteLength);return T.set(D),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function w(I){const D=new Uint32Array(P(I));let T=0;if(D[T++]=I.id,I.type==="full")D[T++]=1,D[T++]=I.data.length,D.set(I.data,T),T+=I.data.length;else{D[T++]=2,D[T++]=I.deltas.length;for(const C of I.deltas)D[T++]=C.start,D[T++]=C.deleteCount,C.data?(D[T++]=C.data.length,D.set(C.data,T),T+=C.data.length):D[T++]=0}return k(D)}e.encodeSemanticTokensDto=w;function P(I){let D=0;if(D+=1+1,I.type==="full")D+=1+I.data.length;else{D+=1,D+=(1+1+1)*I.deltas.length;for(const T of I.deltas)T.data&&(D+=T.data.length)}return D}function L(I){const D=y(I);let T=0;const C=D[T++];if(D[T++]===1){const b=D[T++],f=D.subarray(T,T+b);return T+=b,{id:C,type:"full",data:f}}const v=D[T++],g=[];for(let b=0;b<v;b++){const f=D[T++],l=D[T++],h=D[T++];let o;h>0&&(o=D.subarray(T,T+h),T+=h),g[b]={start:f,deleteCount:l,data:o}}return{id:C,type:"delta",deltas:g}}e.decodeSemanticTokensDto=L}),define(ye[158],De([0,1,3,6]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class _{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,w){return this._map.set(y,w),this.fire([y]),(0,i.toDisposable)(()=>{this._map.get(y)===w&&(this._map.delete(y),this.fire([y]))})}registerFactory(y,w){this._factories.get(y)?.dispose();const P=new A(this,y,w);return this._factories.set(y,P),(0,i.toDisposable)(()=>{const L=this._factories.get(y);!L||L!==P||(this._factories.delete(y),L.dispose())})}async getOrCreate(y){const w=this.get(y);if(w)return w;const P=this._factories.get(y);return!P||P.isResolved?null:(await P.resolve(),this.get(y))}get(y){return this._map.get(y)||null}isResolved(y){if(this.get(y))return!0;const P=this._factories.get(y);return!!(!P||P.isResolved)}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=_;class A extends i.Disposable{constructor(y,w,P){super();this._registry=y,this._languageId=w,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const y=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,y&&!this._isDisposed&&this._register(this._registry.register(this._languageId,y))}}}),define(ye[62],De([0,1,2,37,158,76]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var y;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var w;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(w=e.ColorId||(e.ColorId={}));var P;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var L;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L=e.MetadataConsts||(e.MetadataConsts={}));class I{static getLanguageId(M){return(M&255)>>>0}static getTokenType(M){return(M&768)>>>8}static containsBalancedBrackets(M){return(M&1024)!=0}static getFontStyle(M){return(M&30720)>>>11}static getForeground(M){return(M&16744448)>>>15}static getBackground(M){return(M&4278190080)>>>24}static getClassNameFromMetadata(M){const U=this.getForeground(M);let z="mtk"+U;const re=this.getFontStyle(M);return re&1&&(z+=" mtki"),re&2&&(z+=" mtkb"),re&4&&(z+=" mtku"),re&8&&(z+=" mtks"),z}static getInlineStyleFromMetadata(M,U){const z=this.getForeground(M),re=this.getFontStyle(M);let H=`color: ${U[z]};`;re&1&&(H+="font-style: italic;"),re&2&&(H+="font-weight: bold;");let F="";return re&4&&(F+=" underline"),re&8&&(F+=" line-through"),F&&(H+=`text-decoration:${F};`),H}static getPresentationFromMetadata(M){const U=this.getForeground(M),z=this.getFontStyle(M);return{foreground:U,italic:Boolean(z&1),bold:Boolean(z&2),underline:Boolean(z&4),strikethrough:Boolean(z&8)}}}e.TokenMetadata=I;class D{constructor(M,U,z){this._tokenBrand=void 0,this.offset=M,this.type=U,this.language=z}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class T{constructor(M,U){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=U}}e.TokenizationResult=T;class C{constructor(M,U){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=U}}e.EncodedTokenizationResult=C;var m;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(p){const M=new Map;M.set(0,A.Codicon.symbolMethod),M.set(1,A.Codicon.symbolFunction),M.set(2,A.Codicon.symbolConstructor),M.set(3,A.Codicon.symbolField),M.set(4,A.Codicon.symbolVariable),M.set(5,A.Codicon.symbolClass),M.set(6,A.Codicon.symbolStruct),M.set(7,A.Codicon.symbolInterface),M.set(8,A.Codicon.symbolModule),M.set(9,A.Codicon.symbolProperty),M.set(10,A.Codicon.symbolEvent),M.set(11,A.Codicon.symbolOperator),M.set(12,A.Codicon.symbolUnit),M.set(13,A.Codicon.symbolValue),M.set(15,A.Codicon.symbolEnum),M.set(14,A.Codicon.symbolConstant),M.set(15,A.Codicon.symbolEnum),M.set(16,A.Codicon.symbolEnumMember),M.set(17,A.Codicon.symbolKeyword),M.set(27,A.Codicon.symbolSnippet),M.set(18,A.Codicon.symbolText),M.set(19,A.Codicon.symbolColor),M.set(20,A.Codicon.symbolFile),M.set(21,A.Codicon.symbolReference),M.set(22,A.Codicon.symbolCustomColor),M.set(23,A.Codicon.symbolFolder),M.set(24,A.Codicon.symbolTypeParameter),M.set(25,A.Codicon.account),M.set(26,A.Codicon.issues);function U(H){let F=M.get(H);return F||(console.info("No codicon found for CompletionItemKind "+H),F=A.Codicon.symbolProperty),F}p.toIcon=U;const z=new Map;z.set("method",0),z.set("function",1),z.set("constructor",2),z.set("field",3),z.set("variable",4),z.set("class",5),z.set("struct",6),z.set("interface",7),z.set("module",8),z.set("property",9),z.set("event",10),z.set("operator",11),z.set("unit",12),z.set("value",13),z.set("constant",14),z.set("enum",15),z.set("enum-member",16),z.set("enumMember",16),z.set("keyword",17),z.set("snippet",27),z.set("text",18),z.set("color",19),z.set("file",20),z.set("reference",21),z.set("customcolor",22),z.set("folder",23),z.set("type-parameter",24),z.set("typeParameter",24),z.set("account",25),z.set("issue",26);function re(H,F){let j=z.get(H);return typeof j=="undefined"&&!F&&(j=9),j}p.fromString=re})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(p){p[p.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var f;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var l;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(l=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var E;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(E=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function r(p){return p&&d.URI.isUri(p.uri)&&i.Range.isIRange(p.range)&&(i.Range.isIRange(p.originSelectionRange)||i.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=r;var s;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var n;(function(p){p[p.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var t;(function(p){const M=new Map;M.set(0,A.Codicon.symbolFile),M.set(1,A.Codicon.symbolModule),M.set(2,A.Codicon.symbolNamespace),M.set(3,A.Codicon.symbolPackage),M.set(4,A.Codicon.symbolClass),M.set(5,A.Codicon.symbolMethod),M.set(6,A.Codicon.symbolProperty),M.set(7,A.Codicon.symbolField),M.set(8,A.Codicon.symbolConstructor),M.set(9,A.Codicon.symbolEnum),M.set(10,A.Codicon.symbolInterface),M.set(11,A.Codicon.symbolFunction),M.set(12,A.Codicon.symbolVariable),M.set(13,A.Codicon.symbolConstant),M.set(14,A.Codicon.symbolString),M.set(15,A.Codicon.symbolNumber),M.set(16,A.Codicon.symbolBoolean),M.set(17,A.Codicon.symbolArray),M.set(18,A.Codicon.symbolObject),M.set(19,A.Codicon.symbolKey),M.set(20,A.Codicon.symbolNull),M.set(21,A.Codicon.symbolEnumMember),M.set(22,A.Codicon.symbolStruct),M.set(23,A.Codicon.symbolEvent),M.set(24,A.Codicon.symbolOperator),M.set(25,A.Codicon.symbolTypeParameter);function U(z){let re=M.get(z);return re||(console.info("No codicon found for SymbolKind "+z),re=A.Codicon.symbolProperty),re}p.toIcon=U})(t=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(M){this.value=M}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var c;(function(p){function M(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}p.is=M})(c=e.Command||(e.Command={}));var u;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var S;(function(p){p[p.Unresolved=0]="Unresolved",p[p.Resolved=1]="Resolved"})(S=e.CommentThreadState||(e.CommentThreadState={}));var R;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(R=e.CommentMode||(e.CommentMode={}));var O;(function(p){p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(O=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new _.TokenizationRegistry;var N;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(N=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[159],De([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ye[160],De([0,1,159]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,_=i*60,A=_*24,k=A*7,y=A*30,w=A*365;function P(I,D,T){typeof I!="number"&&(I=I.getTime());const C=Math.round((new Date().getTime()-I)/1e3);if(C<-30)return(0,d.localize)(0,null,P(new Date().getTime()+C*1e3,!1));if(C<30)return(0,d.localize)(1,null);let m;return C<i?(m=C,D?m===1?T?(0,d.localize)(2,null,m):(0,d.localize)(3,null,m):T?(0,d.localize)(4,null,m):(0,d.localize)(5,null,m):m===1?T?(0,d.localize)(6,null,m):(0,d.localize)(7,null,m):T?(0,d.localize)(8,null,m):(0,d.localize)(9,null,m)):C<_?(m=Math.floor(C/i),D?m===1?T?(0,d.localize)(10,null,m):(0,d.localize)(11,null,m):T?(0,d.localize)(12,null,m):(0,d.localize)(13,null,m):m===1?T?(0,d.localize)(14,null,m):(0,d.localize)(15,null,m):T?(0,d.localize)(16,null,m):(0,d.localize)(17,null,m)):C<A?(m=Math.floor(C/_),D?m===1?T?(0,d.localize)(18,null,m):(0,d.localize)(19,null,m):T?(0,d.localize)(20,null,m):(0,d.localize)(21,null,m):m===1?T?(0,d.localize)(22,null,m):(0,d.localize)(23,null,m):T?(0,d.localize)(24,null,m):(0,d.localize)(25,null,m)):C<k?(m=Math.floor(C/A),D?m===1?(0,d.localize)(26,null,m):(0,d.localize)(27,null,m):m===1?(0,d.localize)(28,null,m):(0,d.localize)(29,null,m)):C<y?(m=Math.floor(C/k),D?m===1?T?(0,d.localize)(30,null,m):(0,d.localize)(31,null,m):T?(0,d.localize)(32,null,m):(0,d.localize)(33,null,m):m===1?T?(0,d.localize)(34,null,m):(0,d.localize)(35,null,m):T?(0,d.localize)(36,null,m):(0,d.localize)(37,null,m)):C<w?(m=Math.floor(C/y),D?m===1?T?(0,d.localize)(38,null,m):(0,d.localize)(39,null,m):T?(0,d.localize)(40,null,m):(0,d.localize)(41,null,m):m===1?T?(0,d.localize)(42,null,m):(0,d.localize)(43,null,m):T?(0,d.localize)(44,null,m):(0,d.localize)(45,null,m)):(m=Math.floor(C/w),D?m===1?T?(0,d.localize)(46,null,m):(0,d.localize)(47,null,m):T?(0,d.localize)(48,null,m):(0,d.localize)(49,null,m):m===1?T?(0,d.localize)(50,null,m):(0,d.localize)(51,null,m):T?(0,d.localize)(52,null,m):(0,d.localize)(53,null,m))}e.fromNow=P;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[161],De([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ye[51],De([0,1,16,14,161]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,D){return D&&(I.stack||I.stacktrace)?_.localize(0,null,y(I),k(I.stack)||k(I.stacktrace)):y(I)}function k(I){return Array.isArray(I)?I.join(`
`):I}function y(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?_.localize(1,null,I.message):I.message||_.localize(2,null)}function w(I=null,D=!1){if(!I)return _.localize(3,null);if(Array.isArray(I)){const T=d.coalesce(I),C=w(T[0],D);return T.length>1?_.localize(4,null,C,T.length):C}if(i.isString(I))return I;if(I.detail){const T=I.detail;if(T.error)return A(T.error,D);if(T.exception)return A(T.exception,D)}return I.stack?A(I,D):I.message?I.message:_.localize(5,null)}e.toErrorMessage=w;function P(I){const D=I;return D instanceof Error&&Array.isArray(D.actions)}e.isErrorWithActions=P;function L(I,D){let T;return typeof I=="string"?T=new Error(I):T=I,T.actions=D,T}e.createErrorWithActions=L}),define(ye[162],De([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ye[112],De([0,1,41,30,10,26,9,12,34,95,14,148,29,162]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function C(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(h,o){if(y.isWindows)try{const E={stdio:["pipe","pipe","ignore"]};o&&(E.cwd=o);const r=d.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],E);return new Promise(s=>{r.once("error",n=>{s({success:!1,error:n})}),r.once("exit",(n,t)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(E){return Promise.resolve({success:!1,error:E,code:E.status?C(E.status):1})}else if(y.isLinux||y.isMacintosh)try{const E=_.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{d.execFile(E,[h.pid.toString()],{encoding:"utf8",shell:!0},(s,n,t)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(E){return Promise.resolve({success:!1,error:E})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function v(h=w.env){return h.comspec||"cmd.exe"}e.getWindowsShell=v;class g{constructor(o,E,r,s){if(E!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=E,this.shell=r,this.options=s;else{const n=o;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(w.env).forEach(t=>{n[t]=w.env[t]}),Object.keys(this.options.env).forEach(t=>{n[t]=this.options.env[t]}),this.options.env=n}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const E=o.lastIndexOf(k.sep);return E!==-1&&(o=o.substring(E+1)),g.WellKnowCommands[o]?o:"other"}start(o){return y.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(w.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(E=>{let r,s;const n=new Promise((t,a)=>{r=t,s=a});if(E){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=d.exec(t,this.options,(a,c,u)=>{this.childProcess=null;const S=a;S&&S.killed?s({killed:this.terminateRequested,stdout:c.toString(),stderr:u.toString()}):this.handleExec(r,o,a,c,u)})}else{let t=null;const a=c=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(c,r,o,s);const u={terminated:this.terminateRequested};L.isNumber(c)&&(u.cmdCode=c),r(u)};if(this.shell&&y.isWindows){const c=A.deepClone(this.options);c.windowsVerbatimArguments=!0,c.detached=!1;let u=!1,S=!1;const R=[];let O=this.ensureQuotes(this.cmd);R.push(O.value),u=O.quoted,this.args&&this.args.forEach(p=>{O=this.ensureQuotes(p),R.push(O.value),S=S&&O.quoted});const N=["/s","/c"];u?S?N.push('"'+R.join(" ")+'"'):R.length>1?N.push('"'+R[0]+'" '+R.slice(1).join(" ")):N.push('"'+R[0]+'"'):N.push(R.join(" ")),t=d.spawn(v(),N,c)}else this.cmd&&(t=d.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(L.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",c=>{this.childProcess=null,s({terminated:this.terminateRequested,error:c})}),t.pid&&(this.childProcess.on("close",a),this.handleSpawn(t,r,o,s,!0)))}return n})}handleClose(o,E,r,s){}ensureQuotes(o){return g.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,m(o,this.options.cwd).then(E=>(E.success&&(this.childProcess=null),E))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!y.isWindows)return o(!1);const E=d.spawn(v(),["/s","/c"]);E.on("error",r=>o(!0)),E.on("exit",r=>o(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class b extends g{constructor(o,E,r,s){super(o,E,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,E,r,s,n){[s,n].forEach((t,a)=>{const c=new I.LineDecoder;c.write(t).forEach(R=>{E({line:R,source:a===0?0:1})});const S=c.end();S&&E({line:S,source:a===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,E,r,s,n){const t=new I.LineDecoder,a=new I.LineDecoder;o.stdout.on("data",c=>{t.write(c).forEach(S=>r({line:S,source:0}))}),o.stderr.on("data",c=>{a.write(c).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=a}handleClose(o,E,r,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&r({line:t,source:1})}}e.LineProcess=b;function f(h){let o=[],E=!1;const r=function(s){if(E){o.push(s);return}(!h.send(s,t=>{if(t&&console.error(t),E=!1,o.length>0){const a=o.slice(0);o=[],a.forEach(c=>r(c))}})||y.isWindows)&&(E=!0)};return{send:r}}e.createQueuedSender=f;var l;(function(h){async function o(E,r,s){if(k.isAbsolute(E))return E;if(r===void 0&&(r=w.cwd()),k.dirname(E)!=="."||(s===void 0&&L.isString(w.env.PATH)&&(s=w.env.PATH.split(k.delimiter)),s===void 0||s.length===0))return k.join(r,E);async function t(a){if(await D.Promises.exists(a)){let c;try{c=await D.Promises.stat(a)}catch(u){u.message.startsWith("EACCES")&&(c=await D.Promises.lstat(a))}return c?!c.isDirectory():!1}return!1}for(let a of s){let c;if(k.isAbsolute(a)?c=k.join(a,E):c=k.join(r,a,E),await t(c))return c;let u=c+".com";if(await t(u)||(u=c+".exe",await t(u)))return u}return k.join(r,E)}h.findExecutable=o})(l=e.win32||(e.win32={}))}),define(ye[163],De([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ye[113],De([0,1,163,12,109,16,26,150]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=P;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(se,be,le,_e){this.id=se,this.name=be,this.defaultValue=le,this.schema=_e}applyUpdate(se,be){return T(se,be)}compute(se,be,le){return le}}class D{constructor(se,be){this.newValue=se,this.didChange=be}}e.ApplyUpdateResult=D;function T(ee,se){if(typeof ee!="object"||typeof se!="object"||!ee||!se)return new D(se,ee!==se);if(Array.isArray(ee)||Array.isArray(se)){const le=Array.isArray(ee)&&Array.isArray(se)&&A.equals(ee,se);return new D(se,le)}let be=!1;for(const le in se)if(se.hasOwnProperty(le)){const _e=T(ee[le],se[le]);_e.didChange&&(ee[le]=_e.newValue,be=!0)}return new D(ee,be)}class C{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,be){return T(se,be)}validate(se){return this.defaultValue}}class m{constructor(se,be,le,_e){this.id=se,this.name=be,this.defaultValue=le,this.schema=_e}applyUpdate(se,be){return T(se,be)}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,be,le){return le}}function v(ee,se){return typeof ee=="undefined"?se:ee==="false"?!1:Boolean(ee)}e.boolean=v;class g extends m{constructor(se,be,le,_e=void 0){typeof _e!="undefined"&&(_e.type="boolean",_e.default=le);super(se,be,le,_e)}validate(se){return v(se,this.defaultValue)}}function b(ee,se,be,le){if(typeof ee=="undefined")return se;let _e=parseInt(ee,10);return isNaN(_e)?se:(_e=Math.max(be,_e),_e=Math.min(le,_e),_e|0)}e.clampedInt=b;class f extends m{constructor(se,be,le,_e,Fe,He=void 0){typeof He!="undefined"&&(He.type="integer",He.default=le,He.minimum=_e,He.maximum=Fe);super(se,be,le,He);this.minimum=_e,this.maximum=Fe}static clampedInt(se,be,le,_e){return b(se,be,le,_e)}validate(se){return f.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class l extends m{constructor(se,be,le,_e,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=le);super(se,be,le,Fe);this.validationFn=_e}static clamp(se,be,le){return se<be?be:se>le?le:se}static float(se,be){if(typeof se=="number")return se;if(typeof se=="undefined")return be;const le=parseFloat(se);return isNaN(le)?be:le}validate(se){return this.validationFn(l.float(se,this.defaultValue))}}class h extends m{static string(se,be){return typeof se!="string"?be:se}constructor(se,be,le,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.default=le);super(se,be,le,_e)}validate(se){return h.string(se,this.defaultValue)}}function o(ee,se,be){return typeof ee!="string"||be.indexOf(ee)===-1?se:ee}e.stringSet=o;class E extends m{constructor(se,be,le,_e,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=_e,Fe.default=le);super(se,be,le,Fe);this._allowedValues=_e}validate(se){return o(se,this.defaultValue,this._allowedValues)}}class r extends I{constructor(se,be,le,_e,Fe,He,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.enum=Fe,qe.default=_e);super(se,be,le,qe);this._allowedValues=Fe,this._convert=He}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function s(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,be,le){return le===0?se.accessibilitySupport:le}}class t extends I{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:d.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{insertSpace:v(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(ee){switch(ee){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function R(ee){switch(ee){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class O extends C{constructor(){super(128)}compute(se,be,le){const _e=["monaco-editor"];return be.get(33)&&_e.push(be.get(33)),se.extraEditorClassName&&_e.push(se.extraEditorClassName),be.get(66)==="default"?_e.push("mouse-default"):be.get(66)==="copy"&&_e.push("mouse-copy"),be.get(100)&&_e.push("showUnused"),be.get(126)&&_e.push("showDeprecated"),_e.join(" ")}}class N extends g{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(se,be,le){return le&&se.emptySelectionClipboard}}class p extends I{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:d.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:d.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{cursorMoveOnType:v(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":o(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":o(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(be.loop,this.defaultValue.loop)}}}class M extends I{constructor(){super(45,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.ON:se:Boolean(se)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class U extends C{constructor(){super(44)}compute(se,be,le){return se.fontInfo}}class z extends m{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(se){const be=l.float(se,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(be,6,100)}compute(se,be,le){return se.fontInfo.fontSize}}class re extends I{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.MINIMUM_VALUE,maximum:re.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(f.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,re.MINIMUM_VALUE,re.MAXIMUM_VALUE))}}re.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],re.MINIMUM_VALUE=1,re.MAXIMUM_VALUE=1e3;class H extends I{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...be},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...be},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...be},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:le,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:le,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:le,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:le,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:le,description:d.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{multiple:o(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??o(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??o(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??o(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??o(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??o(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:h.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:h.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:h.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:h.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:h.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends I{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:d.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{enabled:v(be.enabled,this.defaultValue.enabled),delay:f.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:v(be.sticky,this.defaultValue.sticky),above:v(be.above,this.defaultValue.above)}}}var j;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class x extends C{constructor(){super(131)}compute(se,be,le){return x.computeLayout(be,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const be=se.height/se.lineHeight,le=se.scrollBeyondLastLine?be-1:0,_e=(se.viewLineCount+le)/(se.pixelRatio*se.height),Fe=Math.floor(se.viewLineCount/_e);return{typicalViewportLineCount:be,extraLinesBeyondLastLine:le,desiredRatio:_e,minimapLineCount:Fe}}static _computeMinimapLayout(se,be){const le=se.outerWidth,_e=se.outerHeight,Fe=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const He=be.stableMinimapLayoutInput,qe=He&&se.outerHeight===He.outerHeight&&se.lineHeight===He.lineHeight&&se.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&se.pixelRatio===He.pixelRatio&&se.scrollBeyondLastLine===He.scrollBeyondLastLine&&se.minimap.enabled===He.minimap.enabled&&se.minimap.side===He.minimap.side&&se.minimap.size===He.minimap.size&&se.minimap.showSlider===He.minimap.showSlider&&se.minimap.renderCharacters===He.minimap.renderCharacters&&se.minimap.maxColumn===He.minimap.maxColumn&&se.minimap.scale===He.minimap.scale&&se.verticalScrollbarWidth===He.verticalScrollbarWidth&&se.isViewportWrapping===He.isViewportWrapping,Ge=se.lineHeight,Ze=se.typicalHalfwidthCharacterWidth,Qe=se.scrollBeyondLastLine,rt=se.minimap.renderCharacters;let tt=Fe>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const pt=se.minimap.maxColumn,nt=se.minimap.size,ut=se.minimap.side,Pt=se.verticalScrollbarWidth,Nt=se.viewLineCount,yt=se.remainingWidth,ft=se.isViewportWrapping,Dt=rt?2:3;let At=Math.floor(Fe*_e);const Ft=At/Fe;let Ke=!1,zt=!1,Rt=Dt*tt,Mt=tt/Fe,Pe=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Ye,extraLinesBeyondLastLine:lt,desiredRatio:dt,minimapLineCount:vt}=x.computeContainedMinimapLineCount({viewLineCount:Nt,scrollBeyondLastLine:Qe,height:_e,lineHeight:Ge,pixelRatio:Fe});if(Nt/vt>1)Ke=!0,zt=!0,tt=1,Rt=1,Mt=tt/Fe;else{let mt=!1,wt=tt+1;if(nt==="fit"){const Lt=Math.ceil((Nt+lt)*Rt);ft&&qe&&yt<=be.stableFitRemainingWidth?(mt=!0,wt=be.stableFitMaxMinimapScale):mt=Lt>At}if(nt==="fill"||mt){Ke=!0;const Lt=tt;Rt=Math.min(Ge*Fe,Math.max(1,Math.floor(1/dt))),ft&&qe&&yt<=be.stableFitRemainingWidth&&(wt=be.stableFitMaxMinimapScale),tt=Math.min(wt,Math.max(1,Math.floor(Rt/Dt))),tt>Lt&&(Pe=Math.min(2,tt/Lt)),Mt=tt/Fe/Pe,At=Math.ceil(Math.max(Ye,Nt+lt)*Rt),ft?(be.stableMinimapLayoutInput=se,be.stableFitRemainingWidth=yt,be.stableFitMaxMinimapScale=tt):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const Le=Math.floor(pt*Mt),Ee=Math.min(Le,Math.max(0,Math.floor((yt-Pt-2)*Mt/(Ze+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Z=Math.floor(Fe*Ee);const Me=Z/Fe;Z=Math.floor(Z*Pe);const Ve=rt?1:2,st=ut==="left"?0:le-Ee-Pt;return{renderMinimap:Ve,minimapLeft:st,minimapWidth:Ee,minimapHeightIsEditorHeight:Ke,minimapIsSampling:zt,minimapScale:tt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Z,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ft}}static computeLayout(se,be){const le=be.outerWidth|0,_e=be.outerHeight|0,Fe=be.lineHeight|0,He=be.lineNumbersDigitCount|0,qe=be.typicalHalfwidthCharacterWidth,Ge=be.maxDigitWidth,Ze=be.pixelRatio,Qe=be.viewLineCount,rt=se.get(123),tt=rt==="inherit"?se.get(122):rt,pt=tt==="inherit"?se.get(118):tt,nt=se.get(121),ut=se.get(2),Pt=be.isDominatedByLongLines,Nt=se.get(50),yt=se.get(60).renderType!==0,ft=se.get(61),Dt=se.get(94),At=se.get(65),Ft=se.get(92),Ke=Ft.verticalScrollbarSize,zt=Ft.verticalHasArrows,Rt=Ft.arrowSize,Mt=Ft.horizontalScrollbarSize,Pe=se.get(58),Le=se.get(37);let Ee;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const Qt=parseFloat(Pe.substr(0,Pe.length-2));Ee=f.clampedInt(Qt*qe,0,0,1e3)}else Ee=f.clampedInt(Pe,0,0,1e3);Le&&(Ee+=16);let Z=0;if(yt){const Qt=Math.max(He,ft);Z=Math.round(Qt*Ge)}let Me=0;Nt&&(Me=Fe);let Ve=0,st=Ve+Me,Ye=st+Z,lt=Ye+Ee;const dt=le-Me-Z-Ee;let vt=!1,_t=!1,mt=-1;ut!==2&&(tt==="inherit"&&Pt?(vt=!0,_t=!0):pt==="on"||pt==="bounded"?_t=!0:pt==="wordWrapColumn"&&(mt=nt));const wt=x._computeMinimapLayout({outerWidth:le,outerHeight:_e,lineHeight:Fe,typicalHalfwidthCharacterWidth:qe,pixelRatio:Ze,scrollBeyondLastLine:Dt,minimap:At,verticalScrollbarWidth:Ke,viewLineCount:Qe,remainingWidth:dt,isViewportWrapping:_t},be.memory||new L);wt.renderMinimap!==0&&wt.minimapLeft===0&&(Ve+=wt.minimapWidth,st+=wt.minimapWidth,Ye+=wt.minimapWidth,lt+=wt.minimapWidth);const Lt=dt-wt.minimapWidth,bt=Math.max(1,Math.floor((Lt-Ke-2)/qe)),Kt=zt?Rt:0;return _t&&(mt=Math.max(1,bt),pt==="bounded"&&(mt=Math.min(mt,nt))),{width:le,height:_e,glyphMarginLeft:Ve,glyphMarginWidth:Me,lineNumbersLeft:st,lineNumbersWidth:Z,decorationsLeft:Ye,decorationsWidth:Ee,contentLeft:lt,contentWidth:Lt,minimap:wt,viewportColumn:bt,isWordWrapMinified:vt,isViewportWrapping:_t,wrappingColumn:mt,verticalScrollbarWidth:Ke,horizontalScrollbarHeight:Mt,overviewRuler:{top:Kt,width:Ke,height:_e-2*Kt,right:0}}}}e.EditorLayoutInfoComputer=x;class V extends I{constructor(){const se={enabled:!0};super(57,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:d.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}class ne extends I{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",displayStyle:"compact"};super(127,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:d.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(45,null),d.localize(46,null),d.localize(47,null),d.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:d.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:d.localize(50,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return typeof be.enabled=="boolean"&&(be.enabled=be.enabled?"on":"off"),{enabled:o(be.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:h.string(be.fontFamily,this.defaultValue.fontFamily),displayStyle:o(be.displayStyle,this.defaultValue.displayStyle,["standard","compact"])}}}class Q extends l{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>l.clamp(se,0,150),{markdownDescription:d.localize(51,null)})}compute(se,be,le){return se.fontInfo.lineHeight}}class he extends I{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:d.localize(52,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(53,null),d.localize(54,null),d.localize(55,null)],default:se.size,description:d.localize(56,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:d.localize(57,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:d.localize(58,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(59,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:d.localize(60,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:d.localize(61,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{enabled:v(be.enabled,this.defaultValue.enabled),size:o(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(be.side,this.defaultValue.side,["right","left"]),showSlider:o(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(be.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(be.scale,1,1,3),maxColumn:f.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(ee){return ee==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends I{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(62,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(63,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{top:f.clampedInt(be.top,0,0,1e3),bottom:f.clampedInt(be.bottom,0,0,1e3)}}}class X extends I{constructor(){const se={enabled:!0,cycle:!1};super(76,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:d.localize(64,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:d.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{enabled:v(be.enabled,this.defaultValue.enabled),cycle:v(be.cycle,this.defaultValue.cycle)}}}class ce extends C{constructor(){super(129)}compute(se,be,le){return se.pixelRatio}}class pe extends I{constructor(){const se={other:"on",comments:"off",strings:"off"},be=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null)]}];super(79,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{anyOf:be,default:se.strings,description:d.localize(69,null)},comments:{anyOf:be,default:se.comments,description:d.localize(70,null)},other:{anyOf:be,default:se.other,description:d.localize(71,null)}}}],default:se,markdownDescription:d.localize(72,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Ze=se?"on":"off";return{comments:Ze,strings:Ze,other:Ze}}if(!se||typeof se!="object")return this.defaultValue;const{other:be,comments:le,strings:_e}=se,Fe=["on","inline","off"];let He,qe,Ge;return typeof be=="boolean"?He=be?"on":"off":He=o(be,this.defaultValue.other,Fe),typeof le=="boolean"?qe=le?"on":"off":qe=o(le,this.defaultValue.comments,Fe),typeof _e=="boolean"?Ge=_e?"on":"off":Ge=o(_e,this.defaultValue.strings,Fe),{other:He,comments:qe,strings:Ge}}}var Ie;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends I{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"on",description:d.localize(77,null)})}validate(se){let be=this.defaultValue.renderType,le=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(be=4,le=se):se==="interval"?be=3:se==="relative"?be=2:se==="on"?be=1:be=0),{renderType:be,renderFn:le}}}function Ce(ee){const se=ee.get(87);return se==="editable"?ee.get(81):se!=="on"}e.filterValidationDecorations=Ce;class ke extends I{constructor(){const se=[],be={type:"number",description:d.localize(78,null)};super(91,"rulers",se,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:d.localize(79,null),format:"color-hex"}}}]},default:se,description:d.localize(80,null)})}validate(se){if(Array.isArray(se)){const be=[];for(let le of se)if(typeof le=="number")be.push({column:f.clampedInt(le,0,0,1e4),color:null});else if(le&&typeof le=="object"){const _e=le;be.push({column:f.clampedInt(_e.column,0,0,1e4),color:_e.color})}return be.sort((le,_e)=>le.column-_e.column),be}return this.defaultValue}}function Ae(ee,se){if(typeof ee!="string")return se;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends I{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(81,null),d.localize(82,null),d.localize(83,null)],default:"auto",description:d.localize(84,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null)],default:"auto",description:d.localize(88,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:d.localize(89,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:d.localize(90,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:d.localize(91,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se,le=f.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=f.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(be.vertical,this.defaultValue.vertical),horizontal:Ae(be.horizontal,this.defaultValue.horizontal),useShadows:v(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:le,horizontalSliderSize:f.clampedInt(be.horizontalSliderSize,le,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:f.clampedInt(be.verticalSliderSize,_e,0,1e3),scrollByPage:v(be.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ve extends I{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:d.localize(92,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:d.localize(93,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:d.localize(94,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:d.localize(95,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:d.localize(96,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:d.localize(97,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:d.localize(98,null)}})}applyUpdate(se,be){let le=!1;be.allowedCharacters&&(k.equals(se.allowedCharacters,be.allowedCharacters)||(se={...se,allowedCharacters:be.allowedCharacters},le=!0)),be.allowedLocales&&(k.equals(se.allowedLocales,be.allowedLocales)||(se={...se,allowedLocales:be.allowedLocales},le=!0));const _e=super.applyUpdate(se,be);return le?new D(_e.newValue,!0):_e}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{nonBasicASCII:Te(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Te(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Te(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,be){if(typeof se!="object"||!se)return be;const le={};for(const[_e,Fe]of Object.entries(se))Fe===!0&&(le[_e]=!0);return le}}class ie extends I{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:d.localize(99,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{enabled:v(be.enabled,this.defaultValue.enabled),mode:o(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class oe extends I{constructor(){const se={enabled:y.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:y.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:d.localize(100,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:d.localize(101,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{enabled:v(be.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(be.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends I{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(102,null),d.localize(103,null),d.localize(104,null)],default:se.bracketPairs,description:d.localize(105,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(106,null),d.localize(107,null),d.localize(108,null)],default:se.bracketPairsHorizontal,description:d.localize(109,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:d.localize(110,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:d.localize(111,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(112,null),d.localize(113,null),d.localize(114,null)],default:se.highlightActiveIndentation,description:d.localize(115,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{bracketPairs:Te(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Te(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:Te(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Te(ee,se,be){const le=be.indexOf(ee);return le===-1?se:be[le]}class B extends I{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(116,null),d.localize(117,null)],default:se.insertMode,description:d.localize(118,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:d.localize(119,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:d.localize(120,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:d.localize(121,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:d.localize(122,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:d.localize(123,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:d.localize(124,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:d.localize(125,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:d.localize(126,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(127,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(128,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(140,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(141,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(142,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(143,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(144,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(145,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(146,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(147,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(148,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(149,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(150,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(151,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(152,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(153,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(154,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(155,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(156,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(157,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const be=se;return{insertMode:o(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(be.showIcons,this.defaultValue.showIcons),showStatusBar:v(be.showStatusBar,this.defaultValue.showStatusBar),preview:v(be.preview,this.defaultValue.preview),previewMode:o(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(be.showMethods,this.defaultValue.showMethods),showFunctions:v(be.showFunctions,this.defaultValue.showFunctions),showConstructors:v(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(be.showDeprecated,this.defaultValue.showDeprecated),showFields:v(be.showFields,this.defaultValue.showFields),showVariables:v(be.showVariables,this.defaultValue.showVariables),showClasses:v(be.showClasses,this.defaultValue.showClasses),showStructs:v(be.showStructs,this.defaultValue.showStructs),showInterfaces:v(be.showInterfaces,this.defaultValue.showInterfaces),showModules:v(be.showModules,this.defaultValue.showModules),showProperties:v(be.showProperties,this.defaultValue.showProperties),showEvents:v(be.showEvents,this.defaultValue.showEvents),showOperators:v(be.showOperators,this.defaultValue.showOperators),showUnits:v(be.showUnits,this.defaultValue.showUnits),showValues:v(be.showValues,this.defaultValue.showValues),showConstants:v(be.showConstants,this.defaultValue.showConstants),showEnums:v(be.showEnums,this.defaultValue.showEnums),showEnumMembers:v(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(be.showKeywords,this.defaultValue.showKeywords),showWords:v(be.showWords,this.defaultValue.showWords),showColors:v(be.showColors,this.defaultValue.showColors),showFiles:v(be.showFiles,this.defaultValue.showFiles),showReferences:v(be.showReferences,this.defaultValue.showReferences),showFolders:v(be.showFolders,this.defaultValue.showFolders),showTypeParameters:v(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(be.showSnippets,this.defaultValue.showSnippets),showUsers:v(be.showUsers,this.defaultValue.showUsers),showIssues:v(be.showIssues,this.defaultValue.showIssues)}}}class q extends I{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(158,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends C{constructor(){super(130)}compute(se,be,le){return be.get(81)?!0:se.tabFocusMode}}var te;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(te=e.WrappingIndent||(e.WrappingIndent={}));function K(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ae extends C{constructor(){super(132)}compute(se,be,le){const _e=be.get(131);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}const de="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?Be:i.isLinux?$e:de,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Xe;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=41]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=43]="fontFamily",ee[ee.fontInfo=44]="fontInfo",ee[ee.fontLigatures=45]="fontLigatures",ee[ee.fontSize=46]="fontSize",ee[ee.fontWeight=47]="fontWeight",ee[ee.formatOnPaste=48]="formatOnPaste",ee[ee.formatOnType=49]="formatOnType",ee[ee.glyphMargin=50]="glyphMargin",ee[ee.gotoLocation=51]="gotoLocation",ee[ee.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ee[ee.hover=53]="hover",ee[ee.inDiffEditor=54]="inDiffEditor",ee[ee.inlineSuggest=55]="inlineSuggest",ee[ee.letterSpacing=56]="letterSpacing",ee[ee.lightbulb=57]="lightbulb",ee[ee.lineDecorationsWidth=58]="lineDecorationsWidth",ee[ee.lineHeight=59]="lineHeight",ee[ee.lineNumbers=60]="lineNumbers",ee[ee.lineNumbersMinChars=61]="lineNumbersMinChars",ee[ee.linkedEditing=62]="linkedEditing",ee[ee.links=63]="links",ee[ee.matchBrackets=64]="matchBrackets",ee[ee.minimap=65]="minimap",ee[ee.mouseStyle=66]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=68]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=70]="multiCursorModifier",ee[ee.multiCursorPaste=71]="multiCursorPaste",ee[ee.occurrencesHighlight=72]="occurrencesHighlight",ee[ee.overviewRulerBorder=73]="overviewRulerBorder",ee[ee.overviewRulerLanes=74]="overviewRulerLanes",ee[ee.padding=75]="padding",ee[ee.parameterHints=76]="parameterHints",ee[ee.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=79]="quickSuggestions",ee[ee.quickSuggestionsDelay=80]="quickSuggestionsDelay",ee[ee.readOnly=81]="readOnly",ee[ee.renameOnType=82]="renameOnType",ee[ee.renderControlCharacters=83]="renderControlCharacters",ee[ee.renderFinalNewline=84]="renderFinalNewline",ee[ee.renderLineHighlight=85]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=87]="renderValidationDecorations",ee[ee.renderWhitespace=88]="renderWhitespace",ee[ee.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ee[ee.roundedSelection=90]="roundedSelection",ee[ee.rulers=91]="rulers",ee[ee.scrollbar=92]="scrollbar",ee[ee.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=94]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=95]="scrollPredominantAxis",ee[ee.selectionClipboard=96]="selectionClipboard",ee[ee.selectionHighlight=97]="selectionHighlight",ee[ee.selectOnLineNumbers=98]="selectOnLineNumbers",ee[ee.showFoldingControls=99]="showFoldingControls",ee[ee.showUnused=100]="showUnused",ee[ee.snippetSuggestions=101]="snippetSuggestions",ee[ee.smartSelect=102]="smartSelect",ee[ee.smoothScrolling=103]="smoothScrolling",ee[ee.stickyTabStops=104]="stickyTabStops",ee[ee.stopRenderingLineAfter=105]="stopRenderingLineAfter",ee[ee.suggest=106]="suggest",ee[ee.suggestFontSize=107]="suggestFontSize",ee[ee.suggestLineHeight=108]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ee[ee.suggestSelection=110]="suggestSelection",ee[ee.tabCompletion=111]="tabCompletion",ee[ee.tabIndex=112]="tabIndex",ee[ee.unicodeHighlighting=113]="unicodeHighlighting",ee[ee.unusualLineTerminators=114]="unusualLineTerminators",ee[ee.useShadowDOM=115]="useShadowDOM",ee[ee.useTabStops=116]="useTabStops",ee[ee.wordSeparators=117]="wordSeparators",ee[ee.wordWrap=118]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=121]="wordWrapColumn",ee[ee.wordWrapOverride1=122]="wordWrapOverride1",ee[ee.wordWrapOverride2=123]="wordWrapOverride2",ee[ee.wrappingIndent=124]="wrappingIndent",ee[ee.wrappingStrategy=125]="wrappingStrategy",ee[ee.showDeprecated=126]="showDeprecated",ee[ee.inlayHints=127]="inlayHints",ee[ee.editorClassName=128]="editorClassName",ee[ee.pixelRatio=129]="pixelRatio",ee[ee.tabFocusMode=130]="tabFocusMode",ee[ee.layoutInfo=131]="layoutInfo",ee[ee.wrappingInfo=132]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(159,null)})),acceptSuggestionOnEnter:Ne(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(160,null),""],markdownDescription:d.localize(161,null)})),accessibilitySupport:Ne(new n),accessibilityPageSize:Ne(new f(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(162,null)})),ariaLabel:Ne(new h(4,"ariaLabel",d.localize(163,null))),autoClosingBrackets:Ne(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(164,null),d.localize(165,null),""],description:d.localize(166,null)})),autoClosingDelete:Ne(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(167,null),""],description:d.localize(168,null)})),autoClosingOvertype:Ne(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(169,null),""],description:d.localize(170,null)})),autoClosingQuotes:Ne(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(171,null),d.localize(172,null),""],description:d.localize(173,null)})),autoIndent:Ne(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[d.localize(174,null),d.localize(175,null),d.localize(176,null),d.localize(177,null),d.localize(178,null)],description:d.localize(179,null)})),automaticLayout:Ne(new g(10,"automaticLayout",!1)),autoSurround:Ne(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(180,null),d.localize(181,null),d.localize(182,null),""],description:d.localize(183,null)})),bracketPairColorization:Ne(new oe),bracketPairGuides:Ne(new we),stickyTabStops:Ne(new g(104,"stickyTabStops",!1,{description:d.localize(184,null)})),codeLens:Ne(new g(14,"codeLens",!0,{description:d.localize(185,null)})),codeLensFontFamily:Ne(new h(15,"codeLensFontFamily","",{description:d.localize(186,null)})),codeLensFontSize:Ne(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(187,null)})),colorDecorators:Ne(new g(17,"colorDecorators",!0,{description:d.localize(188,null)})),columnSelection:Ne(new g(18,"columnSelection",!1,{description:d.localize(189,null)})),comments:Ne(new t),contextmenu:Ne(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new g(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(190,null)})),cursorBlinking:Ne(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:d.localize(191,null)})),cursorSmoothCaretAnimation:Ne(new g(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(192,null)})),cursorStyle:Ne(new r(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:d.localize(193,null)})),cursorSurroundingLines:Ne(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(194,null)})),cursorSurroundingLinesStyle:Ne(new E(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(195,null),d.localize(196,null)],description:d.localize(197,null)})),cursorWidth:Ne(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(198,null)})),disableLayerHinting:Ne(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new g(30,"domReadOnly",!1)),dragAndDrop:Ne(new g(31,"dragAndDrop",!0,{description:d.localize(199,null)})),emptySelectionClipboard:Ne(new N),extraEditorClassName:Ne(new h(33,"extraEditorClassName","")),fastScrollSensitivity:Ne(new l(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:d.localize(200,null)})),find:Ne(new p),fixedOverflowWidgets:Ne(new g(36,"fixedOverflowWidgets",!1)),folding:Ne(new g(37,"folding",!0,{description:d.localize(201,null)})),foldingStrategy:Ne(new E(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(202,null),d.localize(203,null)],description:d.localize(204,null)})),foldingHighlight:Ne(new g(39,"foldingHighlight",!0,{description:d.localize(205,null)})),foldingImportsByDefault:Ne(new g(40,"foldingImportsByDefault",!1,{description:d.localize(206,null)})),foldingMaximumRegions:Ne(new f(41,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(207,null)})),unfoldOnClickAfterEndOfLine:Ne(new g(42,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(208,null)})),fontFamily:Ne(new h(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(209,null)})),fontInfo:Ne(new U),fontLigatures2:Ne(new M),fontSize:Ne(new z),fontWeight:Ne(new re),formatOnPaste:Ne(new g(48,"formatOnPaste",!1,{description:d.localize(210,null)})),formatOnType:Ne(new g(49,"formatOnType",!1,{description:d.localize(211,null)})),glyphMargin:Ne(new g(50,"glyphMargin",!0,{description:d.localize(212,null)})),gotoLocation:Ne(new H),hideCursorInOverviewRuler:Ne(new g(52,"hideCursorInOverviewRuler",!1,{description:d.localize(213,null)})),hover:Ne(new F),inDiffEditor:Ne(new g(54,"inDiffEditor",!1)),letterSpacing:Ne(new l(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>l.clamp(ee,-5,20),{description:d.localize(214,null)})),lightbulb:Ne(new V),lineDecorationsWidth:Ne(new m(58,"lineDecorationsWidth",10)),lineHeight:Ne(new Q),lineNumbers:Ne(new Re),lineNumbersMinChars:Ne(new f(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new g(62,"linkedEditing",!1,{description:d.localize(215,null)})),links:Ne(new g(63,"links",!0,{description:d.localize(216,null)})),matchBrackets:Ne(new E(64,"matchBrackets","always",["always","near","never"],{description:d.localize(217,null)})),minimap:Ne(new he),mouseStyle:Ne(new E(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new l(67,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:d.localize(218,null)})),mouseWheelZoom:Ne(new g(68,"mouseWheelZoom",!1,{markdownDescription:d.localize(219,null)})),multiCursorMergeOverlapping:Ne(new g(69,"multiCursorMergeOverlapping",!0,{description:d.localize(220,null)})),multiCursorModifier:Ne(new r(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[d.localize(221,null),d.localize(222,null)],markdownDescription:d.localize(223,null)})),multiCursorPaste:Ne(new E(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(224,null),d.localize(225,null)],markdownDescription:d.localize(226,null)})),occurrencesHighlight:Ne(new g(72,"occurrencesHighlight",!0,{description:d.localize(227,null)})),overviewRulerBorder:Ne(new g(73,"overviewRulerBorder",!0,{description:d.localize(228,null)})),overviewRulerLanes:Ne(new f(74,"overviewRulerLanes",3,0,3)),padding:Ne(new G),parameterHints:Ne(new X),peekWidgetDefaultFocus:Ne(new E(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(229,null),d.localize(230,null)],description:d.localize(231,null)})),definitionLinkOpensInPeek:Ne(new g(78,"definitionLinkOpensInPeek",!1,{description:d.localize(232,null)})),quickSuggestions:Ne(new pe),quickSuggestionsDelay:Ne(new f(80,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(233,null)})),readOnly:Ne(new g(81,"readOnly",!1)),renameOnType:Ne(new g(82,"renameOnType",!1,{description:d.localize(234,null),markdownDeprecationMessage:d.localize(235,null)})),renderControlCharacters:Ne(new g(83,"renderControlCharacters",!0,{description:d.localize(236,null),restricted:!0})),renderFinalNewline:Ne(new g(84,"renderFinalNewline",!0,{description:d.localize(237,null)})),renderLineHighlight:Ne(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(238,null)],description:d.localize(239,null)})),renderLineHighlightOnlyWhenFocus:Ne(new g(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(240,null)})),renderValidationDecorations:Ne(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(241,null),d.localize(242,null),d.localize(243,null),""],description:d.localize(244,null)})),revealHorizontalRightPadding:Ne(new f(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ne(new g(90,"roundedSelection",!0,{description:d.localize(245,null)})),rulers:Ne(new ke),scrollbar:Ne(new ue),scrollBeyondLastColumn:Ne(new f(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(246,null)})),scrollBeyondLastLine:Ne(new g(94,"scrollBeyondLastLine",!0,{description:d.localize(247,null)})),scrollPredominantAxis:Ne(new g(95,"scrollPredominantAxis",!0,{description:d.localize(248,null)})),selectionClipboard:Ne(new g(96,"selectionClipboard",!0,{description:d.localize(249,null),included:i.isLinux})),selectionHighlight:Ne(new g(97,"selectionHighlight",!0,{description:d.localize(250,null)})),selectOnLineNumbers:Ne(new g(98,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(251,null),d.localize(252,null)],description:d.localize(253,null)})),showUnused:Ne(new g(100,"showUnused",!0,{description:d.localize(254,null)})),showDeprecated:Ne(new g(126,"showDeprecated",!0,{description:d.localize(255,null)})),inlayHints:Ne(new ne),snippetSuggestions:Ne(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(256,null),d.localize(257,null),d.localize(258,null),d.localize(259,null)],description:d.localize(260,null)})),smartSelect:Ne(new q),smoothScrolling:Ne(new g(103,"smoothScrolling",!1,{description:d.localize(261,null)})),stopRenderingLineAfter:Ne(new f(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new B),inlineSuggest:Ne(new ie),suggestFontSize:Ne(new f(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(262,null)})),suggestLineHeight:Ne(new f(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(263,null)})),suggestOnTriggerCharacters:Ne(new g(109,"suggestOnTriggerCharacters",!0,{description:d.localize(264,null)})),suggestSelection:Ne(new E(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(265,null),d.localize(266,null),d.localize(267,null)],description:d.localize(268,null)})),tabCompletion:Ne(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(269,null),d.localize(270,null),d.localize(271,null)],description:d.localize(272,null)})),tabIndex:Ne(new f(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new ve),unusualLineTerminators:Ne(new E(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(273,null),d.localize(274,null),d.localize(275,null)],description:d.localize(276,null)})),useShadowDOM:Ne(new g(115,"useShadowDOM",!0)),useTabStops:Ne(new g(116,"useTabStops",!0,{description:d.localize(277,null)})),wordSeparators:Ne(new h(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:d.localize(278,null)})),wordWrap:Ne(new E(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(279,null),d.localize(280,null),d.localize(281,null),d.localize(282,null)],description:d.localize(283,null)})),wordWrapBreakAfterCharacters:Ne(new h(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new h(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new f(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(284,null)})),wordWrapOverride1:Ne(new E(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new E(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new r(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],K,{enumDescriptions:[d.localize(285,null),d.localize(286,null),d.localize(287,null),d.localize(288,null)],description:d.localize(289,null)})),wrappingStrategy:Ne(new E(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(290,null),d.localize(291,null)],description:d.localize(292,null)})),editorClassName:Ne(new O),pixelRatio:Ne(new ce),tabFocusMode:Ne(new J),layoutInfo:Ne(new x),wrappingInfo:Ne(new ae)}}),define(ye[164],De([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[165],De([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[166],De([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[167],De([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[168],De([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ye[169],De([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ye[170],De([19,20]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(ye[171],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[172],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[173],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[174],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[175],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[176],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[177],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[178],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[179],De([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[180],De([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(ye[181],De([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[182],De([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[183],De([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[184],De([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[185],De([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[186],De([19,20]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[187],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var d;(function(y){y[y.ACTIVATE=1]="ACTIVATE",y[y.RESTORE=2]="RESTORE",y[y.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var i;(function(y){y[y.PICK=0]="PICK",y[y.DISABLED=1]="DISABLED",y[y.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var _;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(_=e.EditorOpenSource||(e.EditorOpenSource={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var k;(function(y){y.PROGRAMMATIC="api",y.NAVIGATION="code.navigation",y.JUMP="code.jump"})(k=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),function(){"use strict";function Y(e,d,i,_){function A(y){const w=k(y),P=[w];return e.isAbsolute(w)||P.unshift(_),e.resolve(...P)}function k(y){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,i);const L=y["user-data-dir"];if(L)return L;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(I,"AppData","Roaming")}break;case"darwin":P=e.join(d.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(d.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,i)}return{getUserDataPath:A}}if(typeof define=="function")define(ye[188],De([0,296,49,10,22,34]),function(e,d,i,_,A,k){const y=A.dirname(_.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(A.joinPath(y,"package.json").fsPath);return Y(d,i,w.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),d=require("path"),i=require("os");module.exports=Y(d,i,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ye[189],De([0,1,22,43,166,297]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function w(g){return g=g.trim(),g==="*"||k.test(g)}e.isValidVersionStr=w;function P(g){if(!w(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=g.match(k);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=P;function L(g){if(!g)return null;let b=g.majorBase,f=g.majorMustEqual,l=g.minorBase,h=g.minorMustEqual,o=g.patchBase,E=g.patchMustEqual;g.hasCaret&&(b===0||(h=!1),E=!1);let r=0;if(g.preRelease){const s=y.exec(g.preRelease);if(s){const[,n,t,a]=s;r=Date.UTC(Number(n),Number(t)-1,Number(a))}}return{majorBase:b,majorMustEqual:f,minorBase:l,minorMustEqual:h,patchBase:o,patchMustEqual:E,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function I(g,b,f){let l;typeof g=="string"?l=L(P(g)):l=g;let h;b instanceof Date?h=b.getTime():typeof b=="string"&&(h=new Date(b).getTime());let o;if(typeof f=="string"?o=L(P(f)):o=f,!l||!o)return!1;let E=l.majorBase,r=l.minorBase,s=l.patchBase,n=o.majorBase,t=o.minorBase,a=o.patchBase,c=o.notBefore,u=o.majorMustEqual,S=o.minorMustEqual,R=o.patchMustEqual;return o.isMinimum?E>n?!0:E<n?!1:r>t?!0:r<t||h&&h<c?!1:s>=a:(E===1&&n===0&&(!u||!S||!R)&&(n=1,t=0,a=0,u=!0,S=!1,R=!1),E<n?!1:E>n?!u:r<t?!1:r>t?!S:s<a?!1:s>a?!R:!(h&&h<c))}e.isValidVersion=I;function D(g,b,f,l,h){const o=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return o.push([i.default.Error,_.localize(0,null)]),o;if(typeof l.name!="string")return o.push([i.default.Error,_.localize(1,null,"name")]),o;if(typeof l.version!="string")return o.push([i.default.Error,_.localize(2,null,"version")]),o;if(!l.engines)return o.push([i.default.Error,_.localize(3,null,"engines")]),o;if(typeof l.engines.vscode!="string")return o.push([i.default.Error,_.localize(4,null,"engines.vscode")]),o;if(typeof l.extensionDependencies!="undefined"&&!v(l.extensionDependencies))return o.push([i.default.Error,_.localize(5,null,"extensionDependencies")]),o;if(typeof l.activationEvents!="undefined"){if(!v(l.activationEvents))return o.push([i.default.Error,_.localize(6,null,"activationEvents")]),o;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return o.push([i.default.Error,_.localize(7,null,"activationEvents","main")]),o}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&o.push([i.default.Warning,_.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return o.push([i.default.Error,_.localize(9,null,"main")]),o;{const s=(0,d.joinPath)(f,l.main);(0,d.isEqualOrParent)(s,f)||o.push([i.default.Warning,_.localize(10,null,s.path,f.path)])}if(typeof l.activationEvents=="undefined")return o.push([i.default.Error,_.localize(11,null,"activationEvents","main")]),o}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return o.push([i.default.Error,_.localize(12,null,"browser")]),o;{const s=(0,d.joinPath)(f,l.browser);(0,d.isEqualOrParent)(s,f)||o.push([i.default.Warning,_.localize(13,null,s.path,f.path)])}if(typeof l.activationEvents=="undefined")return o.push([i.default.Error,_.localize(14,null,"activationEvents","browser")]),o}if(!A.valid(l.version))return o.push([i.default.Error,_.localize(15,null)]),o;const E=[];if(!T(g,b,l,h,E))for(const s of E)o.push([i.default.Error,s]);return o}e.validateExtensionManifest=D;function T(g,b,f,l,h){return l||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:m(g,b,f.engines.vscode,h)}e.isValidExtensionVersion=T;function C(g,b,f){return g==="*"||m(b,f,g)}e.isEngineValid=C;function m(g,b,f,l=[]){let h=L(P(f));if(!h)return l.push(_.localize(16,null,f)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return l.push(_.localize(17,null,f)),!1}else if(!h.majorMustEqual)return l.push(_.localize(18,null,f)),!1;return I(g,b,h)?!0:(l.push(_.localize(19,null,g,f)),!1)}function v(g){if(!Array.isArray(g))return!1;for(let b=0,f=g.length;b<f;b++)if(typeof g[b]!="string")return!1;return!0}}),define(ye[114],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(_,A=[],k=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=d}),define(ye[82],De([0,1,114]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function _(k,y,w){y instanceof d.SyncDescriptor||(y=new d.SyncDescriptor(y,[],w)),i.push([k,y])}e.registerSingleton=_;function A(){return i}e.getSingletonServiceDescriptors=A}),define(ye[190],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class i{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let k of this._nodes.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const y=this.lookupOrInsertNode(A),w=this.lookupOrInsertNode(k);y.outgoing.set(this._hashFn(k),w),w.incoming.set(this._hashFn(A),y)}removeNode(A){const k=this._hashFn(A);this._nodes.delete(k);for(let y of this._nodes.values())y.outgoing.delete(k),y.incoming.delete(k)}lookupOrInsertNode(A){const k=this._hashFn(A);let y=this._nodes.get(k);return y||(y=new d(A),this._nodes.set(k,y)),y}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[k,y]of this._nodes)A.push(`${k}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,k]of this._nodes){const y=new Set([A]),w=this._findCycle(k,y);if(w)return w}}_findCycle(A,k){for(let[y,w]of A.outgoing){if(k.has(y))return[...k,y].join(" -> ");k.add(y);const P=this._findCycle(w,k);if(P)return P;k.delete(y)}}}e.Graph=i}),define(ye[4],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function y(w){return w[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=y})(d=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function i(k,y,w){y[d.DI_TARGET]===y?y[d.DI_DEPENDENCIES].push({id:k,index:w}):(y[d.DI_DEPENDENCIES]=[{id:k,index:w}],y[d.DI_TARGET]=y)}function _(k){if(d.serviceIds.has(k))return d.serviceIds.get(k);const y=function(w,P,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(y,w,L)};return y.toString=()=>k,d.serviceIds.set(k,y),y}e.createDecorator=_;function A(k){return k}e.refineServiceDecorator=A}),define(ye[83],De([0,1,14,2,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationOverrides=A;function k(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||d.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=k;var y;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=w;function P(g,b){const f=Object.create(null);for(let l in g)L(f,l,g[l],b);return f}e.toValuesTree=P;function L(g,b,f,l){const h=b.split("."),o=h.pop();let E=g;for(let r=0;r<h.length;r++){let s=h[r],n=E[s];switch(typeof n){case"undefined":n=E[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${b} as ${h.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}E=n}if(typeof E=="object"&&E!==null)try{E[o]=f}catch{l(`Ignoring ${b} as ${h.join(".")} is ${JSON.stringify(E)}`)}else l(`Ignoring ${b} as ${h.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=L;function I(g,b){const f=b.split(".");D(g,f)}e.removeFromValueTree=I;function D(g,b){const f=b.shift();if(b.length===0){delete g[f];return}if(Object.keys(g).indexOf(f)!==-1){const l=g[f];typeof l=="object"&&!Array.isArray(l)&&(D(l,b),Object.keys(l).length===0&&delete g[f])}}function T(g,b,f){function l(E,r){let s=E;for(const n of r){if(typeof s!="object"||s===null)return;s=s[n]}return s}const h=b.split("."),o=l(g,h);return typeof o=="undefined"?f:o}e.getConfigurationValue=T;function C(g,b,f){Object.keys(b).forEach(l=>{l!=="__proto__"&&(l in g?d.isObject(g[l])&&d.isObject(b[l])?C(g[l],b[l],f):f&&(g[l]=b[l]):g[l]=b[l])})}e.merge=C;function m(g,b,f){const l=g.inspect(b),h=g.inspect(f);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:l.defaultValue}e.getMigratedSettingValue=m;function v(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(ye[63],De([0,1,12,8,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",d.isMacintosh),A.set("isLinux",d.isLinux),A.set("isWindows",d.isWindows),A.set("isWeb",d.isWeb),A.set("isMacNative",d.isMacintosh&&!d.isWeb),A.set("isEdge",d.isEdge),A.set("isFirefox",d.isFirefox),A.set("isChrome",d.isChrome),A.set("isSafari",d.isSafari);const k=Object.prototype.hasOwnProperty;var y;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(p){return T.create(p)}static equals(p,M){return C.create(p,M)}static notEquals(p,M){return g.create(p,M)}static regex(p,M){return r.create(p,M)}static in(p,M){return m.create(p,M)}static not(p){return b.create(p)}static and(...p){return t.create(p,null)}static or(...p){return a.create(p,null,!0)}static greater(p,M){return l.create(p,M)}static greaterEquals(p,M){return h.create(p,M)}static smaller(p,M){return o.create(p,M)}static smallerEquals(p,M){return E.create(p,M)}static deserialize(p,M=!1){if(!!p)return this._deserializeOrExpression(p,M)}static _deserializeOrExpression(p,M){let U=p.split("||");return a.create(U.map(z=>this._deserializeAndExpression(z,M)),null,!0)}static _deserializeAndExpression(p,M){let U=p.split("&&");return t.create(U.map(z=>this._deserializeOne(z,M)),null)}static _deserializeOne(p,M){if(p=p.trim(),p.indexOf("!=")>=0){let U=p.split("!=");return g.create(U[0].trim(),this._deserializeValue(U[1],M))}if(p.indexOf("==")>=0){let U=p.split("==");return C.create(U[0].trim(),this._deserializeValue(U[1],M))}if(p.indexOf("=~")>=0){let U=p.split("=~");return r.create(U[0].trim(),this._deserializeRegexValue(U[1],M))}if(p.indexOf(" in ")>=0){let U=p.split(" in ");return m.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const U=p.split(">=");return h.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const U=p.split(">");return l.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const U=p.split("<=");return E.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const U=p.split("<");return o.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(p)?b.create(p.substr(1).trim()):T.create(p)}static _deserializeValue(p,M){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let U=/^'([^']*)'$/.exec(p);return U?U[1].trim():p}static _deserializeRegexValue(p,M){if((0,i.isFalsyOrWhitespace)(p)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=p.indexOf("/"),z=p.lastIndexOf("/");if(U===z||U<0){if(M)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let re=p.slice(U+1,z),H=p[z+1]==="i"?"i":"";try{return new RegExp(re,H)}catch(F){if(M)throw new Error(`bad regexp-value '${p}', parse error: ${F}`);return console.warn(`bad regexp-value '${p}', parse error: ${F}`),null}}}e.ContextKeyExpr=w;function P(N,p){const M=N?N.substituteConstants():void 0,U=p?p.substituteConstants():void 0;return!M&&!U?!0:!M||!U?!1:M.equals(U)}e.expressionsAreEqualWithConstantSubstitution=P;function L(N,p){return N.cmp(p)}class I{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class D{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=D,D.INSTANCE=new D;class T{constructor(p,M){this.key=p,this.negated=M,this.type=2}static create(p,M=null){const U=A.get(p);return typeof U=="boolean"?U?D.INSTANCE:I.INSTANCE:new T(p,M)}cmp(p){return p.type!==this.type?this.type-p.type:u(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=A.get(this.key);return typeof p=="boolean"?p?D.INSTANCE:I.INSTANCE:this}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class C{constructor(p,M,U){this.key=p,this.value=M,this.negated=U,this.type=4}static create(p,M,U=null){if(typeof M=="boolean")return M?T.create(p,U):b.create(p,U);const z=A.get(p);return typeof z=="boolean"?M===(z?"true":"false")?D.INSTANCE:I.INSTANCE:new C(p,M,U)}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=A.get(this.key);if(typeof p=="boolean"){const M=p?"true":"false";return this.value===M?D.INSTANCE:I.INSTANCE}return this}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class m{constructor(p,M){this.key=p,this.valueKey=M,this.type=10,this.negated=null}static create(p,M){return new m(p,M)}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}substituteConstants(){return this}evaluate(p){const M=p.getValue(this.valueKey),U=p.getValue(this.key);return Array.isArray(M)?M.indexOf(U)>=0:typeof U=="string"&&typeof M=="object"&&M!==null?k.call(M,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=m;class v{constructor(p){this._actual=p,this.type=11}static create(p){return new v(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new v(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class g{constructor(p,M,U){this.key=p,this.value=M,this.negated=U,this.type=5}static create(p,M,U=null){if(typeof M=="boolean")return M?b.create(p,U):T.create(p,U);const z=A.get(p);return typeof z=="boolean"?M===(z?"true":"false")?I.INSTANCE:D.INSTANCE:new g(p,M,U)}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=A.get(this.key);if(typeof p=="boolean"){const M=p?"true":"false";return this.value===M?I.INSTANCE:D.INSTANCE}return this}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class b{constructor(p,M){this.key=p,this.negated=M,this.type=3}static create(p,M=null){const U=A.get(p);return typeof U=="boolean"?U?I.INSTANCE:D.INSTANCE:new b(p,M)}cmp(p){return p.type!==this.type?this.type-p.type:u(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=A.get(this.key);return typeof p=="boolean"?p?I.INSTANCE:D.INSTANCE:this}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function f(N,p){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?p(N):I.INSTANCE}class l{constructor(p,M,U){this.key=p,this.value=M,this.negated=U,this.type=12}static create(p,M,U=null){return f(M,z=>new l(p,z,U))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class h{constructor(p,M,U){this.key=p,this.value=M,this.negated=U,this.type=13}static create(p,M,U=null){return f(M,z=>new h(p,z,U))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class o{constructor(p,M,U){this.key=p,this.value=M,this.negated=U,this.type=14}static create(p,M,U=null){return f(M,z=>new o(p,z,U))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class E{constructor(p,M,U){this.key=p,this.value=M,this.negated=U,this.type=15}static create(p,M,U=null){return f(M,z=>new E(p,z,U))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=E;class r{constructor(p,M){this.key=p,this.regexp=M,this.type=7,this.negated=null}static create(p,M){return new r(p,M)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const M=this.regexp?this.regexp.source:"",U=p.regexp?p.regexp.source:"";return M<U?-1:M>U?1:0}equals(p){if(p.type===this.type){const M=this.regexp?this.regexp.source:"",U=p.regexp?p.regexp.source:"";return this.key===p.key&&M===U}return!1}substituteConstants(){return this}evaluate(p){let M=p.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(p){this._actual=p,this.type=8}static create(p){return new s(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new s(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function n(N){let p=null;for(let M=0,U=N.length;M<U;M++){const z=N[M].substituteConstants();if(N[M]!==z&&p===null){p=[];for(let re=0;re<M;re++)p[re]=N[re]}p!==null&&(p[M]=z)}return p===null?N:p}class t{constructor(p,M){this.expr=p,this.negated=M,this.type=6}static create(p,M){return t._normalizeArr(p,M)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const z=L(this.expr[M],p.expr[M]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(p.expr[M]))return!1;return!0}return!1}substituteConstants(){const p=n(this.expr);return p===this.expr?this:t.create(p,this.negated)}evaluate(p){for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].evaluate(p))return!1;return!0}static _normalizeArr(p,M){const U=[];let z=!1;for(const re of p)if(!!re){if(re.type===1){z=!0;continue}if(re.type===0)return I.INSTANCE;if(re.type===6){U.push(...re.expr);continue}U.push(re)}if(U.length===0&&z)return D.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let re=1;re<U.length;re++)U[re-1].equals(U[re])&&(U.splice(re,1),re--);if(U.length===1)return U[0];for(;U.length>1;){const re=U[U.length-1];if(re.type!==9)break;U.pop();const H=U.pop(),F=U.length===0,j=a.create(re.expr.map(x=>t.create([x,H],null)),null,F);j&&(U.push(j),U.sort(L))}return U.length===1?U[0]:new t(U,M)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let M of this.expr)p.push(...M.keys());return p}map(p){return new t(this.expr.map(M=>M.map(p)),null)}negate(){if(!this.negated){const p=[];for(let M of this.expr)p.push(M.negate());this.negated=a.create(p,this,!0)}return this.negated}}class a{constructor(p,M){this.expr=p,this.negated=M,this.type=9}static create(p,M,U){return a._normalizeArr(p,M,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const z=L(this.expr[M],p.expr[M]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(p.expr[M]))return!1;return!0}return!1}substituteConstants(){const p=n(this.expr);return p===this.expr?this:a.create(p,this.negated,!1)}evaluate(p){for(let M=0,U=this.expr.length;M<U;M++)if(this.expr[M].evaluate(p))return!0;return!1}static _normalizeArr(p,M,U){let z=[],re=!1;if(p){for(let H=0,F=p.length;H<F;H++){const j=p[H];if(!!j){if(j.type===0){re=!0;continue}if(j.type===1)return D.INSTANCE;if(j.type===9){z=z.concat(j.expr);continue}z.push(j)}}if(z.length===0&&re)return I.INSTANCE;z.sort(L)}if(z.length!==0){if(z.length===1)return z[0];for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];if(U){for(let H=0;H<z.length;H++)for(let F=H+1;F<z.length;F++)R(z[H],z[F])&&(z.splice(F,1),F--);if(z.length===1)return z[0]}return new a(z,M)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let M of this.expr)p.push(...M.keys());return p}map(p){return new a(this.expr.map(M=>M.map(p)),null)}negate(){if(!this.negated){let p=[];for(let M of this.expr)p.push(M.negate());for(;p.length>1;){const M=p.shift(),U=p.shift(),z=[];for(const H of O(M))for(const F of O(U))z.push(t.create([H,F],null));const re=p.length===0;p.unshift(a.create(z,null,re))}this.negated=p[0]}return this.negated}}class c extends T{constructor(p,M,U){super(p,null);this._defaultValue=M,typeof U=="object"?c._info.push({...U,key:p}):U!==!0&&c._info.push({key:p,description:U,type:M!=null?typeof M:void 0})}static all(){return c._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return C.create(this.key,p)}notEqualsTo(p){return g.create(this.key,p)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(N,p){return N<p?-1:N>p?1:0}function S(N,p,M,U){return N<M?-1:N>M?1:p<U?-1:p>U?1:0}function R(N,p){if(p.type===6&&N.type!==9&&N.type!==6){for(const z of p.expr)if(N.equals(z))return!0}const M=N.negate(),U=O(M).concat(O(p));U.sort(L);for(let z=0;z<U.length;z++){const H=U[z].negate();for(let F=z+1;F<U.length;F++){const j=U[F];if(H.equals(j))return!0}}return!1}e.implies=R;function O(N){return N.type===9?N.expr:[N]}}),define(ye[191],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[115],De([0,1,165,4]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function _(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=_;function A(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function k(g,b){switch(g){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function y(g,b){return b==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function w(g,b,f){return y(b,f)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===f?!0:P(f).includes(g)}e.isTargetPlatformCompatible=w;function P(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=L;var I;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var D;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var T;(function(g){g.Install="install",g.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var C;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(b,f){super(b);this.code=f,this.name=f}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,d.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,d.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,i.createDecorator)("IExtensionManagementCLIService")}),define(ye[192],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,d.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,d.createDecorator)("externalTerminal")}),define(ye[193],De([0,1,41,10,9,12,95,29,112,167,192]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=P.localize(0,null);class D{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends D{openTerminal(l,h){return this.spawnTerminal(d,l,w.getWindowsShell(),h)}spawnTerminal(l,h,o,E){const r=h.windowsExec||T.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const s=_.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return l.spawn(r,E?[E]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(s==="wt"||s==="wt.exe")&&n.push("-d ."),new Promise((t,a)=>{const c=v(process),u=l.spawn(o,n,{cwd:E,env:c});u.on("error",a),u.on("exit",()=>t())})}runInTerminal(l,h,o,E,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:T.getDefaultTerminalWindows();return new Promise((n,t)=>{const a=`"${h} - ${I}"`,c=`""${o.join('" "')}" & pause"`,u=["/c","start",a,"/wait",s,"/c",c],S=Object.assign({},v(process),E);Object.keys(S).filter(N=>S[N]===null).forEach(N=>delete S[N]);const R={cwd:h,env:S,windowsVerbatimArguments:!0};d.spawn(T.CMD,u,R).on("error",N=>{t(g(N))}),n(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class C extends D{openTerminal(l,h){return this.spawnTerminal(d,l,h)}runInTerminal(l,h,o,E,r){const s=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{if(s===L.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const a=s===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Y).fsPath,"-t",l||I,"-w",h];for(let O of o)u.push("-a"),u.push(O);if(E){const O=Object.assign({},v(process),E);for(let N in O){const p=O[N];p===null?(u.push("-u"),u.push(N)):(u.push("-e"),u.push(`${N}=${p}`))}}let S="";const R=d.spawn(C.OSASCRIPT,u);R.on("error",O=>{t(g(O))}),R.stderr.on("data",O=>{S+=O.toString()}),R.on("exit",O=>{if(O===0)n(void 0);else if(S){const N=S.split(`
`,1);t(new Error(N[0]))}else t(new Error(P.localize(1,null,a,O)))})}else t(new Error(P.localize(2,null,s)))})}spawnTerminal(l,h,o){const E=h.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const n=["-a",E];o&&n.push(o);const t=v(process),a=l.spawn("/usr/bin/open",n,{cwd:o,env:t});a.on("error",s),a.on("exit",()=>r())})}}e.MacExternalTerminalService=C,C.OSASCRIPT="/usr/bin/osascript";class m extends D{openTerminal(l,h){return this.spawnTerminal(d,l,h)}runInTerminal(l,h,o,E,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{let a=[];s.then(c=>{c.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const u=`${b(o)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;a.push(`''${u}''`);const S=Object.assign({},v(process),E);Object.keys(S).filter(p=>S[p]===null).forEach(p=>delete S[p]);const R={cwd:h,env:S};let O="";const N=d.spawn(c,a,R);N.on("error",p=>{t(g(p))}),N.stderr.on("data",p=>{O+=p.toString()}),N.on("exit",p=>{if(p===0)n(void 0);else if(O){const M=O.split(`
`,1);t(new Error(M[0]))}else t(new Error(P.localize(4,null,c,p)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const l=await y.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(h=>{l?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,h,o){const E=h.linuxExec?Promise.resolve(h.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{E.then(n=>{const t=v(process),a=l.spawn(n,[],{cwd:o,env:t});a.on("error",s),a.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=P.localize(3,null);function v(f){const l={...f.env};return(0,k.sanitizeProcessEnvironment)(l),l}function g(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(P.localize(5,null,f.path)):f}function b(f){let l="";for(let h of f)h.indexOf(" ")>=0?l+='"'+h+'"':l+=h,l+=" ";return l}}),define(ye[42],De([0,1,11,24,9,8,14,2,168,4]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function L(F){return F.create===!0}e.isFileOpenForWriteOptions=L;var I;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var D;(function(F){F[F.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var T;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(T=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=C;function m(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=m;function v(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=v;function g(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=b;function f(F){return C(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var l;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(j,x){super(j);this.code=x}}e.FileSystemProviderError=h;function o(F,j){const x=new h(F.toString(),j);return r(x,j),x}e.createFileSystemProviderError=o;function E(F){return F||o((0,w.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=E;function r(F,j){return F.name=j?`${j} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=r;function s(F){if(!F)return l.Unknown;if(F instanceof h)return F.code;const j=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!j)return l.Unknown;switch(j[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=s;function n(F){if(F instanceof R)return F.fileOperationResult;switch(s(F)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class a{constructor(j,x,V){this.resource=j,this.operation=x,this.target=V}isOperation(j){return this.operation===j}}e.FileOperationEvent=a;var c;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class u{constructor(j,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const V=new Map;for(const ne of j){const Q=V.get(ne.type);switch(Q?Q.push([ne.resource,ne]):V.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,Q]of V)switch(ne){case 1:this.added=i.TernarySearchTree.forUris(()=>x),this.added.fill(Q);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>x),this.updated.fill(Q);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>x),this.deleted.fill(Q);break}}contains(j,...x){return this.doContains(j,{includeChildren:!1},...x)}affects(j,...x){return this.doContains(j,{includeChildren:!0},...x)}doContains(j,x,...V){if(!j)return!1;const ne=V.length>0;return!!((!ne||V.includes(1))&&(this.added?.get(j)||x.includeChildren&&this.added?.findSuperstr(j))||(!ne||V.includes(0))&&(this.updated?.get(j)||x.includeChildren&&this.updated?.findSuperstr(j))||(!ne||V.includes(2))&&(this.deleted?.findSubstr(j)||x.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function S(F,j,x){return!F||!j||F===j||j.length>F.length?!1:(j.charAt(j.length-1)!==_.sep&&(j+=_.sep),x?(0,A.startsWithIgnoreCase)(F,j):F.indexOf(j)===0)}e.isParent=S;class R extends d.ErrorNoTelemetry{constructor(j,x,V){super(j);this.fileOperationResult=x,this.options=V}}e.FileOperationError=R;class O extends R{constructor(j,x,V){super(j,2,V);this.stat=x}}e.NotModifiedSinceFileOperationError=O;var N;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=M;async function U(F,j){if(!j.hasProvider(y.URI.from({scheme:F.scheme})))return new Promise(x=>{const V=j.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===F.scheme&&ne.added&&(V.dispose(),x())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(j){return(0,k.isNumber)(j)||(j=0),j<z.KB?(0,w.localize)(1,null,j.toFixed(0)):j<z.MB?(0,w.localize)(2,null,(j/z.KB).toFixed(2)):j<z.GB?(0,w.localize)(3,null,(j/z.MB).toFixed(2)):j<z.TB?(0,w.localize)(4,null,(j/z.GB).toFixed(2)):(0,w.localize)(5,null,(j/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var re;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function H(F){return{maxFileSize:F===0?300*z.MB:16*z.GB,maxHeapSize:F===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=H}),define(ye[84],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(..._){this._entries=new Map;for(let[A,k]of _)this.set(A,k)}set(_,A){const k=this._entries.get(_);return this._entries.set(_,A),k}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=d}),define(ye[194],De([0,1,17,11,114,190,4,84]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class P extends Error{constructor(C){super("cyclic dependency between services");this.message=C.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${C.toString()}`}}class L{constructor(C=new y.ServiceCollection,m=!1,v){this._activeInstantiations=new Set,this._services=C,this._strict=m,this._parent=v,this._services.set(k.IInstantiationService,this)}createChild(C){return new L(C,this._strict,this)}invokeFunction(C,...m){let v=D.traceInvocation(C),g=!1;try{return C({get:f=>{if(g)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(f,v);if(!l)throw new Error(`[invokeFunction] unknown service '${f}'`);return l}},...m)}finally{g=!0,v.stop()}}createInstance(C,...m){let v,g;return C instanceof _.SyncDescriptor?(v=D.traceCreation(C.ctor),g=this._createInstance(C.ctor,C.staticArguments.concat(m),v)):(v=D.traceCreation(C),g=this._createInstance(C,m,v)),v.stop(),g}_createInstance(C,m=[],v){let g=k._util.getServiceDependencies(C).sort((l,h)=>l.index-h.index),b=[];for(const l of g){let h=this._getOrCreateServiceInstance(l.id,v);h||this._throwIfStrict(`[createInstance] ${C.name} depends on UNKNOWN service ${l.id}.`,!1),b.push(h)}let f=g.length>0?g[0].index:m.length;if(m.length!==f){console.trace(`[createInstance] First service dependency of ${C.name} at position ${f+1} conflicts with ${m.length} static arguments`);let l=f-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,f)}return new C(...[...m,...b])}_setServiceInstance(C,m){if(this._services.get(C)instanceof _.SyncDescriptor)this._services.set(C,m);else if(this._parent)this._parent._setServiceInstance(C,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(C){let m=this._services.get(C);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(C):m}_getOrCreateServiceInstance(C,m){let v=this._getServiceInstanceOrDescriptor(C);return v instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(C,v,m.branch(C,!0)):(m.branch(C,!1),v)}_safeCreateAndCacheServiceInstance(C,m,v){if(this._activeInstantiations.has(C))throw new Error(`illegal state - RECURSIVELY instantiating service '${C}'`);this._activeInstantiations.add(C);try{return this._createAndCacheServiceInstance(C,m,v)}finally{this._activeInstantiations.delete(C)}}_createAndCacheServiceInstance(C,m,v){const g=new A.Graph(l=>l.id.toString());let b=0;const f=[{id:C,desc:m,_trace:v}];for(;f.length;){const l=f.pop();if(g.lookupOrInsertNode(l),b++>1e3)throw new P(g);for(let h of k._util.getServiceDependencies(l.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(h.id);if(o||this._throwIfStrict(`[createInstance] ${C} depends on ${h.id} which is NOT registered.`,!0),o instanceof _.SyncDescriptor){const E={id:h.id,desc:o,_trace:l._trace.branch(h.id,!0)};g.insertEdge(l,E),f.push(E)}}}for(;;){const l=g.roots();if(l.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:h}of l){if(this._getServiceInstanceOrDescriptor(h.id)instanceof _.SyncDescriptor){const E=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,E)}g.removeNode(h)}}return this._getServiceInstanceOrDescriptor(C)}_createServiceInstanceWithOwner(C,m,v=[],g,b){if(this._services.get(C)instanceof _.SyncDescriptor)return this._createServiceInstance(m,v,g,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(C,m,v,g,b);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(C,m=[],v,g){if(v){const b=new d.IdleValue(()=>this._createInstance(C,m,g));return new Proxy(Object.create(null),{get(f,l){if(l in f)return f[l];let h=b.value,o=h[l];return typeof o!="function"||(o=o.bind(h),f[l]=o),o},set(f,l,h){return b.value[l]=h,!0}})}else return this._createInstance(C,m,g)}_throwIfStrict(C,m){if(m&&console.warn(m),this._strict)throw new Error(C)}}e.InstantiationService=L;var I;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(I||(I={}));class D{constructor(C,m){this.type=C,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(C){return w?new D(1,C.name||C.toString().substring(0,42).replace(/\n/g,"")):D._None}static traceCreation(C){return w?new D(0,C.name):D._None}branch(C,m){let v=new D(2,C.toString());return this._dep.push([C,m,v]),v}stop(){let C=Date.now()-this._start;D._totals+=C;let m=!1;function v(b,f){let l=[],h=new Array(b+1).join("	");for(const[o,E,r]of f._dep)if(E&&r){m=!0,l.push(`${h}CREATES -> ${o}`);let s=v(b+1,r);s&&l.push(s)}else l.push(`${h}uses -> ${o}`);return l.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${C.toFixed(2)}ms (grand total ${D._totals.toFixed(2)}ms)`];(C>2||m)&&console.log(g.join(`
`))}}e.Trace=D,D._None=new class extends D{constructor(){super(-1,null)}stop(){}branch(){return this}},D._totals=0}),define(ye[13],De([0,1,51,3,6,12,4]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function y(){return new Date().toISOString()}var w;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function P(E,r,s){switch(r){case w.Trace:E.trace(s);break;case w.Debug:E.debug(s);break;case w.Info:E.info(s);break;case w.Warning:E.warn(s);break;case w.Error:E.error(s);break;case w.Critical:E.critical(s);break;default:throw new Error("Invalid log level")}}e.log=P;function L(E){let r="";for(let s=0;s<E.length;s++){let n=E[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(s>0?" ":"")+n}return r}e.format=L;class I extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class D extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,L([r,...s]))}debug(r,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,L([r,...s]))}info(r,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,L([r,...s]))}warn(r,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,L([r,...s]))}error(r,...s){if(this.checkLogLevel(w.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(w.Error,L(n))}else this.log(w.Error,L([r,...s]))}critical(r,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,L([r,...s]))}flush(){}}e.AbstractMessageLogger=D;class T extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!A.isWindows}trace(r,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,r,...s):console.log(`[main ${y()}]`,r,...s))}debug(r,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,r,...s):console.log(`[main ${y()}]`,r,...s))}info(r,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,r,...s):console.log(`[main ${y()}]`,r,...s))}warn(r,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,r,...s):console.warn(`[main ${y()}]`,r,...s))}error(r,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,r,...s):console.error(`[main ${y()}]`,r,...s))}critical(r,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,r,...s):console.error(`[main ${y()}]`,r,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class C extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",r,...s)}debug(r,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...s)}info(r,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",r,...s)}warn(r,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",r,...s)}error(r,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",r,...s)}critical(r,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...s)}dispose(){}flush(){}}e.ConsoleLogger=C;class m extends I{constructor(r,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(s)}trace(r,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(r),...s])}debug(r,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(r),...s])}info(r,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(r),...s])}warn(r,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(r),...s])}error(r,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(r),...s])}critical(r,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(r),...s])}extractMessage(r){return typeof r=="string"?r:(0,d.toErrorMessage)(r,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class v extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const s of this.logServices)s.setLevel(r);super.setLevel(r)}trace(r,...s){for(const n of this.logServices)n.trace(r,...s)}debug(r,...s){for(const n of this.logServices)n.debug(r,...s)}info(r,...s){for(const n of this.logServices)n.info(r,...s)}warn(r,...s){for(const n of this.logServices)n.warn(r,...s)}error(r,...s){for(const n of this.logServices)n.error(r,...s)}critical(r,...s){for(const n of this.logServices)n.critical(r,...s)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class g extends _.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...s){this.logger.trace(r,...s)}debug(r,...s){this.logger.debug(r,...s)}info(r,...s){this.logger.info(r,...s)}warn(r,...s){this.logger.warn(r,...s)}error(r,...s){this.logger.error(r,...s)}critical(r,...s){this.logger.critical(r,...s)}flush(){this.logger.flush()}}e.LogService=g;class b extends _.Disposable{constructor(r,s){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,s){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,s?.always?w.Trace:this.logLevel,s),this.loggers.set(r.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return w.Info}trace(r,...s){}debug(r,...s){}info(r,...s){}warn(r,...s){}error(r,...s){}critical(r,...s){}dispose(){}flush(){}}e.NullLogService=f;function l(E){if(E.verbose)return w.Trace;if(typeof E.logLevel=="string"){const r=h(E.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function h(E){switch(E){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=h;function o(E){switch(E){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=o}),define(ye[195],De([0,1,42,13]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function _(y,w,P,L,I){try{const D=await new Promise((C,m)=>{Y(["spdlog"],C,m)});D.setFlushOn(i.LogLevel.Trace);const T=await D.createAsyncRotatingLogger(y,w,P,L);return I&&T.clearFormatters(),T}catch(D){console.error(D)}return null}function A(y,w,P){switch(w){case i.LogLevel.Trace:y.trace(P);break;case i.LogLevel.Debug:y.debug(P);break;case i.LogLevel.Info:y.info(P);break;case i.LogLevel.Warning:y.warn(P);break;case i.LogLevel.Error:y.error(P);break;case i.LogLevel.Critical:y.critical(P);break;default:throw new Error("Invalid log level")}}class k extends i.AbstractMessageLogger{constructor(w,P,L,I,D){super();this.buffer=[],this.setLevel(D),this._loggerCreationPromise=this._createSpdLogLogger(w,P,L,I),this._register(this.onDidChangeLogLevel(T=>{this._logger&&this._logger.setLevel(T)}))}async _createSpdLogLogger(w,P,L,I){const D=L?6:1,T=30/D*d.ByteSize.MB,C=await _(w,P,T,D,I);if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:m,message:v}of this.buffer)A(this._logger,m,v);this.buffer=[]}}log(w,P){this._logger?A(this._logger,w,P):this.getLevel()<=w&&this.buffer.push({level:w,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ye[116],De([0,1,43,169,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var k;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function P(C,m){return m-C}w.compare=P;const L=Object.create(null);L[w.Error]=(0,i.localize)(0,null),L[w.Warning]=(0,i.localize)(1,null),L[w.Info]=(0,i.localize)(2,null);function I(C){return L[C]||""}w.toString=I;function D(C){switch(C){case d.default.Error:return w.Error;case d.default.Warning:return w.Warning;case d.default.Info:return w.Info;case d.default.Ignore:return w.Hint}}w.fromSeverity=D;function T(C){switch(C){case w.Error:return d.default.Error;case w.Warning:return d.default.Warning;case w.Info:return d.default.Info;case w.Hint:return d.default.Ignore}}w.toSeverity=T}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(w){const P="";function L(D){return I(D,!0)}w.makeKey=L;function I(D,T){let C=[P];return D.source?C.push(D.source.replace("\xA6","\\\xA6")):C.push(P),D.code?typeof D.code=="string"?C.push(D.code.replace("\xA6","\\\xA6")):C.push(D.code.value.replace("\xA6","\\\xA6")):C.push(P),D.severity!==void 0&&D.severity!==null?C.push(k.toString(D.severity)):C.push(P),D.message&&T?C.push(D.message.replace("\xA6","\\\xA6")):C.push(P),D.startLineNumber!==void 0&&D.startLineNumber!==null?C.push(D.startLineNumber.toString()):C.push(P),D.startColumn!==void 0&&D.startColumn!==null?C.push(D.startColumn.toString()):C.push(P),D.endLineNumber!==void 0&&D.endLineNumber!==null?C.push(D.endLineNumber.toString()):C.push(P),D.endColumn!==void 0&&D.endColumn!==null?C.push(D.endColumn.toString()):C.push(P),C.push(P),C.join("\xA6")}w.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ye[196],De([0,1,3,43,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new w,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=y;class w{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=w}),define(ye[117],De([0,1,6,8,2,4]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function k(L,I){return _.URI.isUri(L)?(0,i.equalsIgnoreCase)(L.scheme,I):(0,i.startsWithIgnoreCase)(L,I+":")}e.matchesScheme=k;function y(L,...I){return I.some(D=>k(L,D))}e.matchesSomeScheme=y;function w(L,I){return L.with({fragment:`${I.startLineNumber},${I.startColumn}${I.endLineNumber?`-${I.endLineNumber}${I.endColumn?`,${I.endColumn}`:""}`:""}`})}e.withSelection=w;function P(L){let I;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return D&&(I={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},L=L.with({fragment:""})),{selection:I,uri:L}}e.extractSelection=P}),define(ye[197],De([0,1,10,12,34,22,188]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const w=i.globals.vscode.context.configuration();if(w)y=w.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const w=(0,A.dirname)(d.FileAccess.asFileUri("",Y));y=Y.__$__nodeRequire((0,A.joinPath)(w,"product.json").fsPath);const P=Y.__$__nodeRequire((0,A.joinPath)(w,"package.json").fsPath);try{const m=(...f)=>f.reduce((l,h)=>(Object.keys(h).forEach(o=>{Array.isArray(l[o])&&Array.isArray(h[o])?l[o]=h[o]:typeof l[o]=="object"&&typeof h[o]=="object"?l[o]=m(l[o],h[o]):l[o]=h[o]}),l),{}),v=(0,k.getUserDataPath)({}),g=i.isWindows?`file:///${v}/product.json`:`file://${v}/product.json`,b=Y.__$__nodeRequire(d.FileAccess.asFileUri(g,Y).fsPath);y=m(y,b)}catch{}_.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0});const{serviceUrl:L,cacheUrl:I,itemUrl:D,controlUrl:T,recommendationsUrl:C}=y.extensionsGallery||{};Object.assign(y,{extensionsGallery:{serviceUrl:_.env.VSCODE_GALLERY_SERVICE_URL||L,cacheUrl:_.env.VSCODE_GALLERY_CACHE_URL||I,itemUrl:_.env.VSCODE_GALLERY_ITEM_URL||D,controlUrl:_.env.VSCODE_GALLERY_CONTROL_URL||T,recommendationsUrl:_.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||C}}),Object.assign(y,{version:P.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y});var xe=this&&this.__param||function(Y,e){return function(d,i){e(d,i,Y)}};define(ye[118],De([0,1,17,21,6,4]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var k;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let w=class extends _.Disposable{constructor(I,D){super();this.deferred=new d.DeferredPromise,D.withProgress(I,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};w=je([xe(1,e.IProgressService)],w),e.UnmanagedProgress=w;class P extends _.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(I){this.stop();const D=++this.currentOperationId,T=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{D===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:D,token:T.token,stop:()=>this.doStop(D),isCurrent:()=>this.currentOperationId===D}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ye[44],De([0,1,56,14]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(k,y){d.ok(i.isString(k)),d.ok(i.isObject(y)),d.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,y)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new _}),define(ye[198],De([0,1,3,44]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,P){this.schemasById[_(w)]=P,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new A;i.Registry.add(e.Extensions.JSONContribution,k)}),define(ye[119],De([0,1,16,3,14,164,83,198,44]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=w.Registry.as(y.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,E=!0){this.registerConfigurations([o],E)}registerConfigurations(o,E=!0){const r=this.doRegisterConfigurations(o,E);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const E=this.doDeregisterConfigurations(o);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}updateConfigurations({add:o,remove:E}){const r=[];r.push(...this.doDeregisterConfigurations(E)),r.push(...this.doRegisterConfigurations(o,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,d.distinct)(r)})}registerDefaultConfigurations(o){const E=[],r=[];for(const{overrides:s,source:n}of o)for(const t in s)if(E.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const a={...this.configurationDefaultsOverrides.get(t)?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:a});const c=(0,k.getLanguageTagSettingPlainKey)(t),u={type:"object",default:a,description:A.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:_.isString(n)?void 0:n};r.push(...m(t)),this.configurationProperties[t]=u,this.defaultLanguageConfigurationOverridesNode.properties[t]=u}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:n});const a=this.configurationProperties[t];a&&(this.updatePropertyDefaultValue(t,a),this.updateSchema(t,a))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const E=[];for(const{overrides:r,source:s}of o)for(const n in r){const t=this.configurationDefaultsOverrides.get(n),a=_.isString(s)?s:s?.id,c=_.isString(t?.source)?t?.source:t?.source?.id;if(a===c)if(E.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const E of o)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,E){const r=[];return o.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,E,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),r}doDeregisterConfigurations(o){const E=[],r=s=>{if(s.properties)for(const n in s.properties)E.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n]);s.allOf&&s.allOf.forEach(n=>r(n))};for(const s of o){r(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return E}validateAndRegisterProperties(o,E=!0,r,s,n=3){n=_.isUndefinedOrNull(o.scope)?n:o.scope;let t=[],a=o.properties;if(a)for(let u in a){if(E&&f(u)){delete a[u];continue}const S=a[u];if(S.source=r,S.defaultDefaultValue=a[u].default,this.updatePropertyDefaultValue(u,S),e.OVERRIDE_PROPERTY_REGEX.test(u)?S.scope=void 0:(S.scope=_.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=_.isUndefinedOrNull(S.restricted)?!!s?.includes(u):S.restricted),a[u].hasOwnProperty("included")&&!a[u].included){this.excludedConfigurationProperties[u]=a[u],delete a[u];continue}else this.configurationProperties[u]=a[u];!a[u].deprecationMessage&&a[u].markdownDeprecationMessage&&(a[u].deprecationMessage=a[u].markdownDeprecationMessage),t.push(u)}let c=o.allOf;if(c)for(let u of c)t.push(...this.validateAndRegisterProperties(u,E,r,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const E=r=>{let s=r.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let n=r.allOf;n&&n.forEach(E)};E(o)}updateSchema(o,E){switch(e.allSettings.properties[o]=E,E.scope){case 1:e.applicationSettings.properties[o]=E;break;case 2:e.machineSettings.properties[o]=E;break;case 6:e.machineOverridableSettings.properties[o]=E;break;case 3:e.windowSettings.properties[o]=E;break;case 4:e.resourceSettings.properties[o]=E;break;case 5:e.resourceSettings.properties[o]=E,this.resourceLanguageSettingsSchema.properties[o]=E;break}}removeFromSchema(o,E){switch(delete e.allSettings.properties[o],E.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const E=`[${o}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,r),e.allSettings.properties[E]=r,e.applicationSettings.properties[E]=r,e.machineSettings.properties[E]=r,e.machineOverridableSettings.properties[E]=r,e.windowSettings.properties[E]=r,e.resourceSettings.properties[E]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,E){const r=this.configurationDefaultsOverrides.get(o);let s=r?.value,n=r?.source;_.isUndefined(s)&&(s=E.defaultDefaultValue,n=void 0),_.isUndefined(s)&&(s=g(E.type)),E.default=s,E.defaultValueSource=n}}const T="\\[([^\\]]+)\\]",C=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(h){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let E=C.exec(h);for(;E?.length;){const r=E[1].trim();r&&o.push(r),E=C.exec(h)}}return(0,d.distinct)(o)}e.overrideIdentifiersFromKey=m;function v(h){return h.reduce((o,E)=>`${o}[${E}]`,"")}e.keyFromOverrideIdentifiers=v;function g(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const b=new D;w.Registry.add(e.Extensions.Configuration,b);function f(h){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?A.localize(7,null,h):b.getConfigurationProperties()[h]!==void 0?A.localize(8,null,h):null:A.localize(6,null)}e.validateProperty=f;function l(){const h=[],o=b.getConfigurationProperties();for(const E of Object.keys(o))h.push([E,o[E].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=l}),define(ye[199],De([0,1,16,3,144,6,24,26,14,2,83,119,44]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class T{constructor(r={},s=[],n=[]){this._contents=r,this._keys=s,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,s){const n=this.getContentsForOverrideIdentifer(s);return n?r?(0,L.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const n of this.overrides)n.identifiers.includes(r)&&s.push(...n.keys);return d.distinct(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return d.distinct(r)}override(r){let s=this.overrideConfigurations.get(r);return s||(s=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,s)),s}merge(...r){const s=y.deepClone(this.contents),n=y.deepClone(this.overrides),t=[...this.keys];for(const a of r){this.mergeContents(s,a.contents);for(const c of a.overrides){const[u]=n.filter(S=>d.equals(S.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=d.distinct(u.keys)):n.push(y.deepClone(c))}for(const c of a.keys)t.indexOf(c)===-1&&t.push(c)}return new T(s,t,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const s=this.getContentsForOverrideIdentifer(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const t of d.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[t],c=s[t];c&&(typeof a=="object"&&typeof c=="object"?(a=y.deepClone(a),this.mergeContents(a,c)):a=c),n[t]=a}return new T(n,this.keys,this.overrides)}mergeContents(r,s){for(const n of Object.keys(s)){if(n in r&&w.isObject(r[n])&&w.isObject(s[n])){this.mergeContents(r[n],s[n]);continue}r[n]=y.deepClone(s[n])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?y.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let s=null,n=null;const t=a=>{a&&(n?this.mergeContents(n,a):n=y.deepClone(a))};for(const a of this.overrides)d.equals(a.identifiers,[r])?s=a.contents:a.identifiers.includes(r)&&t(a.contents);return t(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,s){this.addKey(r),(0,L.addToValueTree)(this.contents,r,s,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,L.removeFromValueTree)(this.contents,r)}addKey(r){let s=this.keys.length;for(let n=0;n<s;n++)r.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,r)}removeKey(r){let s=this.keys.indexOf(r);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=T;class C extends T{constructor(r={}){const s=D.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(s),t=Object.create(null),a=[];for(const c in s){const u=r[c],S=u!==void 0?u:s[c].default;(0,L.addToValueTree)(t,c,S,R=>console.error(`Conflict in default settings: ${R}`))}for(const c of Object.keys(t))I.OVERRIDE_PROPERTY_REGEX.test(c)&&a.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(t[c]),contents:(0,L.toValuesTree)(t[c],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,a)}}e.DefaultConfigurationModel=C;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,s){if(!w.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,s)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,s){this._raw=r;const{contents:n,keys:t,overrides:a,restricted:c}=this.doParseRaw(r,s);this._configurationModel=new T(n,t,a),this._restrictedConfigurations=c||[]}doParseContent(r){let s={},n=null,t=[],a=[],c=[];function u(R){Array.isArray(t)?t.push(R):n!==null&&(t[n]=R)}let S={onObjectBegin:()=>{let R={};u(R),a.push(t),t=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let R=[];u(R),a.push(t),t=R,n=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:u,onError:(R,O,N)=>{c.push({error:R,offset:O,length:N})}};if(r)try{_.visit(r,S),s=t[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(r,s){const n=D.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(r,n,!0,s);r=t.raw;const a=(0,L.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),c=Object.keys(r),u=this.toOverrides(r,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:a,keys:c,overrides:u,restricted:t.restricted}}filter(r,s,n,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:r,restricted:[]};const a={},c=[];for(let u in r)if(I.OVERRIDE_PROPERTY_REGEX.test(u)&&n){const S=this.filter(r[u],s,!1,t);a[u]=S.raw,c.push(...S.restricted)}else{const S=s[u],R=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&c.push(u),(R===void 0||t.scopes===void 0||t.scopes.includes(R))&&(t.skipRestricted&&S?.restricted||(a[u]=r[u]))}return{raw:a,restricted:c}}toOverrides(r,s){const n=[];for(const t of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(t)){const a={};for(const c in r[t])a[c]=r[t][c];n.push({identifiers:(0,I.overrideIdentifiersFromKey)(t),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,s)})}return n}}e.ConfigurationModelParser=m;class v extends A.Disposable{constructor(r,s,n,t){super();this.userSettingsResource=r,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class g{constructor(r,s,n=new T,t=new T,a=new k.ResourceMap,c=new T,u=new k.ResourceMap,S=!0){this._defaultConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=c,this._memoryConfigurationByResource=u,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(r)}updateValue(r,s,n={}){let t;n.resource?(t=this._memoryConfigurationByResource.get(n.resource),t||(t=new T,this._memoryConfigurationByResource.set(n.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(r):t.setValue(r,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,s,n){const t=this.getConsolidateConfigurationModel(s,n),a=this.getFolderConfigurationModelForResource(s.resource,n),c=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),S=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,p=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,M=s.overrideIdentifier?c.override(s.overrideIdentifier).getValue(r):c.getValue(r),U=t.getValue(r),z=d.distinct(d.flatten(t.overrides.map(re=>re.identifiers))).filter(re=>t.getOverrideValue(r,re)!==void 0);return{defaultValue:u,userValue:S,userLocalValue:R,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:p,memoryValue:M,value:U,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:a?.freeze().getValue(r),override:s.overrideIdentifier?a?.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:c.getValue(r),override:s.overrideIdentifier?c.getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const s=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,s){this._folderConfigurations.set(r,s),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const n=[];if(!s){const{added:t,updated:a,removed:c}=h(this._defaultConfiguration,r);s=[...t,...a,...c]}for(const t of s)for(const a of(0,I.overrideIdentifiersFromKey)(t)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=r.getKeysForOverrideIdentifier(a),S=[...u.filter(R=>c.indexOf(R)===-1),...c.filter(R=>u.indexOf(R)===-1),...c.filter(R=>!y.equals(this._defaultConfiguration.override(a).getValue(R),r.override(a).getValue(R)))];n.push([a,S])}return this.updateDefaultConfiguration(r),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:n,removed:t,overrides:a}=h(this.localUserConfiguration,r),c=[...s,...n,...t];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:n,removed:t,overrides:a}=h(this.remoteUserConfiguration,r);let c=[...s,...n,...t];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:n,removed:t,overrides:a}=h(this.workspaceConfiguration,r);let c=[...s,...n,...t];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(r,s){const n=this.folderConfigurations.get(r),{added:t,updated:a,removed:c,overrides:u}=h(n,s);let S=[...t,...a,...c];return(S.length||!n)&&this.updateFolderConfiguration(r,s),{keys:S,overrides:u}}compareAndDeleteFolderConfiguration(r){const s=this.folderConfigurations.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:t,removed:a,overrides:c}=h(s,void 0);return{keys:[...n,...t,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,s){let n=this.getConsolidatedConfigurationModelForResource(r,s);return r.overrideIdentifier?n.override(r.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:r},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&r){const t=s.getFolder(r);t&&(n=this.getFolderConsolidatedConfiguration(t.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let s=this._foldersConsolidatedConfigurations.get(r);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(r);t?(s=n.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(r,s)):s=n}return s}getFolderConfigurationModelForResource(r,s){if(s&&r){const n=s.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,s)=>{const{contents:n,overrides:t,keys:a}=this._folderConfigurations.get(s);return r.push([s,{contents:n,overrides:t,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>r.add(s)),this.userConfiguration.freeze().keys.forEach(s=>r.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(t=>s.add(t))),[...s.values()]}static parse(r){const s=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((c,u)=>(c.set(P.URI.revive(u[0]),this.parseConfigurationModel(u[1])),c),new k.ResourceMap);return new g(s,n,new T,t,a,new T,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new T(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=g;function b(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const r=new Set,s=new Map;for(const t of E)t.keys.forEach(a=>r.add(a)),t.overrides.forEach(([a,c])=>{const u=(0,k.getOrSet)(s,a,new Set);c.forEach(S=>u.add(S))});const n=[];return s.forEach((t,a)=>n.push([a,[...t.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=b;class f{constructor(r,s,n,t){this.change=r,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(u=>a.add(u)),r.overrides.forEach(([,u])=>u.forEach(S=>a.add(S))),this.affectedKeys=[...a.values()];const c=new T;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(r,s,this.currentWorkspace);return!y.equals(n,t)}return!0}return!1}doesAffectedKeysTreeContains(r,s){let n=(0,L.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof n=="object"&&(t=Object.keys(n)[0]);){if(r=r[t],!r)return!1;n=n[t]}return!0}}e.ConfigurationChangeEvent=f;class l extends f{constructor(r,s,n,t){super({keys:r.allKeys(),overrides:[]},void 0,r,s);this.source=n,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=l;function h(E,r){const{added:s,removed:n,updated:t}=o(r,E),a=[],c=E?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const S=u.filter(R=>!c.includes(R));for(const R of S)a.push([R,r.getKeysForOverrideIdentifier(R)])}if(E){const S=c.filter(R=>!u.includes(R));for(const R of S)a.push([R,E.getKeysForOverrideIdentifier(R)])}if(r&&E){for(const S of c)if(u.includes(S)){const R=o({contents:E.getOverrideValue(void 0,S)||{},keys:E.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});a.push([S,[...R.added,...R.removed,...R.updated]])}}return{added:s,removed:n,updated:t,overrides:a}}function o(E,r){const s=E?r?E.keys.filter(a=>r.keys.indexOf(a)===-1):[...E.keys]:[],n=r?E?r.keys.filter(a=>E.keys.indexOf(a)===-1):[...r.keys]:[],t=[];if(E&&r){for(const a of r.keys)if(E.keys.indexOf(a)!==-1){const c=(0,L.getConfigurationValue)(r.contents,a),u=(0,L.getConfigurationValue)(E.contents,a);y.equals(c,u)||t.push(a)}}return{added:s,removed:n,updated:t}}}),define(ye[120],De([0,1,11,4]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var _;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(_=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends d.ErrorNoTelemetry{constructor(y,w=_.Unknown,P){super(y);this._message=y,this._code=w,this._detail=P,this.isHandled=w===_.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(y){return y instanceof A&&y._code===_.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof A&&y._code===_.NoResolverFound}static isHandled(y){return y instanceof A&&y.isHandled}}e.RemoteAuthorityResolverError=A}),define(ye[121],De([0,1,10]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function i(A){return A.scheme===d.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=i;function _(A){if(!A)return;const k=A.indexOf("+");return k<0?A:A.substr(0,k)}e.getRemoteName=_}),define(ye[28],De([0,1,8,4,121]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(T){if(typeof T=="object"&&T!==null&&T.supported!==!0)return T.description}e.getWorkspaceSupportTypeMessage=A;function k(T){return T&&typeof T=="object"&&typeof T.id=="string"&&(!T.uuid||typeof T.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(T){T[T.System=0]="System",T[T.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var w;(function(T){T.WIN32_X64="win32-x64",T.WIN32_IA32="win32-ia32",T.WIN32_ARM64="win32-arm64",T.LINUX_X64="linux-x64",T.LINUX_ARM64="linux-arm64",T.LINUX_ARMHF="linux-armhf",T.ALPINE_X64="alpine-x64",T.ALPINE_ARM64="alpine-arm64",T.DARWIN_X64="darwin-x64",T.DARWIN_ARM64="darwin-arm64",T.WEB="web",T.UNIVERSAL="universal",T.UNKNOWN="unknown",T.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,m){if(typeof C=="undefined"||C===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof C=="string"||typeof m=="string"){let v=typeof C=="string"?C:C.value,g=typeof m=="string"?m:m.value;return d.equalsIgnoreCase(v,g)}return C._lower===m._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function L(T){return T.contributes&&T.contributes.localizations?T.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function I(T){return T.contributes&&T.contributes.authentication?T.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function D(T,C){if(C){const m=`onResolveRemoteAuthority:${(0,_.getRemoteName)(C)}`;return T.activationEvents?.indexOf(m)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[200],De([0,1,8,115,28,12,2,11,34]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,d.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=P;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(s,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=s.id}static create(s){const n=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new I(s.identifier,n,t)}static parse(s){const n=L.exec(s);return n&&n[1]&&n[2]?new I({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof I?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=I;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(r){const s=D.exec(r);return s&&s[1]?[m(s[1]),s[2]]:[m(r),void 0]}e.getIdAndVersion=T;function C(r,s){return`${r}.${s}`}e.getExtensionId=C;function m(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=m;function v(r,s){return m(C(r,s))}e.getGalleryExtensionId=v;function g(r,s){const n=[],t=a=>{for(const c of n)if(c.some(u=>P(s(u),s(a))))return c;return null};for(const a of r){const c=t(a);c?c.push(a):n.push([a])}return n}e.groupByExtension=g;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function l(r){const s=new Set;if(r.malicious)for(const n of r.malicious)s.add(n.id);return s}e.getMaliciousExtensionsSet=l;function h(r,s){const n=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const a=t.shift();if(a&&n.every(c=>!P(c.identifier,{id:a}))){const c=r.filter(u=>P(u.identifier,{id:a}));c.length===1&&(n.push(c[0]),t.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=h;async function o(r,s){if(!A.isLinux)return!1;let n;try{n=(await r.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function E(r,s){const n=await o(r,s),t=(0,i.getTargetPlatform)(n?"alpine":A.platform,w.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=E}),define(ye[201],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d{constructor(){this.validators=new Map}vsda(){return new Promise((_,A)=>Y(["vsda"],_,A))}async createNewMessage(_){try{const A=await this.vsda(),k=new A.validator;if(k){const y=String(d._nextId++);return this.validators.set(y,k),{id:y,data:k.createNewMessage(_)}}}catch{}return{id:"",data:_}}async validate(_,A){if(!_.id)return!0;const k=this.validators.get(_.id);if(!k)return!1;this.validators.delete(_.id);try{return k.validate(A)==="ok"}catch{return!1}}async sign(_){try{const A=await this.vsda(),k=new A.signer;if(k)return k.sign(_)}catch{}return _}}e.SignService=d,d._nextId=1}),define(ye[202],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,k=5){let y;return y=A(w=>{const P=typeof w=="string"?w:w.data;let L=this._terminalBufferMap.get(_);if(L){L.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(_),k);L={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(_),y.dispose()}},this._terminalBufferMap.set(_,L)}),y}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=d}),define(ye[203],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var d;(function(_){_.DARK="dark",_.LIGHT="light",_.HIGH_CONTRAST_DARK="hcDark",_.HIGH_CONTRAST_LIGHT="hcLight"})(d=e.ColorScheme||(e.ColorScheme={}));function i(_){return _===d.HIGH_CONTRAST_DARK||_===d.HIGH_CONTRAST_LIGHT}e.isHighContrast=i}),define(ye[85],De([0,1,76,3,6,4,44,203]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var w;(function(v){function g(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=g})(w=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var L;(function(v){function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}v.isThemeIcon=g;const b=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const n=b.exec(s);if(!n)return;let[,t]=n;return{id:t}}v.fromString=f;function l(s){return{id:s}}v.fromId=l;function h(s,n){let t=s.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),n&&(t=`${t}~${n}`),{id:t}}v.modify=h;function o(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}v.getModifier=o;function E(s,n){return s.id===n.id&&s.color?.id===n.color?.id}v.isEqual=E;function r(s,n){return{id:s.id,color:n?P(n):void 0}}v.asThemeIcon=r,v.asClassNameArray=d.CSSIcon.asClassNameArray,v.asClassName=d.CSSIcon.asClassName,v.asCSSSelector=d.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function I(v){switch(v){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class D{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,_.toDisposable)(()=>{const b=this.themingParticipants.indexOf(g);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let T=new D;k.Registry.add(e.Extensions.ThemingContribution,T);function C(v){return T.onColorThemeChange(v)}e.registerThemingParticipant=C;class m extends _.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,b){let f=this.theme.getColor(g);return f&&b&&(f=b(f,this.theme)),f?f.toString():null}}e.Themable=m}),define(ye[122],De([0,1,3,12,4,13]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var k;(function(C){C.Http="http",C.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(C){C.ConstantPrivate="constantPrivate",C.Private="private",C.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(C){C[C.Notify=1]="Notify",C[C.OpenBrowser=2]="OpenBrowser",C[C.OpenPreview=3]="OpenPreview",C[C.Silent=4]="Silent",C[C.Ignore=5]="Ignore",C[C.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(C){if(C.scheme!=="http"&&C.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(C.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(C){return e.LOCALHOST_ADDRESSES.indexOf(C)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(C){return e.ALL_INTERFACES_ADDRESSES.indexOf(C)>=0}e.isAllInterfaces=I;function D(C,m){return m?m!==1&&C<1024:!i.isWindows&&C<1024}e.isPortPrivileged=D;let T=class{constructor(m){this.logService=m,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],v=Array.from(this._tunnels.values());for(let g of v){const b=Array.from(g.values());for(let f of b){const l=await f.value;l&&m.push(l)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:v}of m.values())await v.then(g=>g?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,v,g,b,f=!1,l=y.Private,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${g} on local port ${b}.`),!m)return;v||(v="localhost");const o=this.retainOrCreateTunnel(m,v,g,b,f,l,h);return o?o.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(E);return(E.tunnelRemoteHost!==v||E.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const v=this._tunnels.get(m.tunnelRemoteHost);if(v){const g=v.get(m.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,g))}}}}async tryDisposeTunnel(m,v,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${v}.`);const b=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(v),b}}async closeTunnel(m,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${v} `);const g=this._tunnels.get(m);if(g&&g.has(v)){const b=g.get(v);b.refcount=0,await this.tryDisposeTunnel(m,v,b)}}addTunnelToMap(m,v,g){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(v,{refcount:1,value:g})}async removeEmptyTunnelFromMap(m,v){const g=this._tunnels.get(m);g&&(await g.get(v)||g.delete(v),g.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,v){let g=[m];L(m)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):I(m)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const b=g.map(f=>this._tunnels.get(f));for(const f of b){const l=f?.get(v);if(l)return l}}canTunnel(m){return!!P(m)}createWithProvider(m,v,g,b,f,l,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${g} on local port ${b}.`);const E={elevationRequired:f?D(b===void 0?g:b):!1},r={remoteAddress:{host:v,port:g},localAddressPort:b,privacy:l,public:l!==y.Private,protocol:h},s=m.forwardPort(r,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,g,s),s}};T=je([xe(0,A.ILogService)],T),e.AbstractTunnelService=T}),define(ye[204],De([0,1,10]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function i(w){return w.scheme!==d.Schemas.file&&w.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=i;function _(w){if(w.folders.length)return w.folders.every(P=>i(P.uri))?w.folders[0].uri:void 0;if(w.configuration&&i(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=_;function A(w){return _(w)?.scheme}e.getVirtualWorkspaceScheme=A;function k(w){return _(w)?.authority}e.getVirtualWorkspaceAuthority=k;function y(w){return _(w)!==void 0}e.isVirtualWorkspace=y}),define(ye[45],De([0,1,170,9,24,22,2,4,10]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function P(r){const s=r;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=P;function L(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=L;function I(r){const s=r;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=I;function D(r){const s=r;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:k.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=D;var T;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function C(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=C;function m(r){const s=r;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=m;class v{constructor(s,n,t,a,c){this._id=s,this._transient=t,this._configuration=a,this._ignorePathCasing=c,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class g{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function b(r){return new g({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,d.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(r,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,s.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function h(r){let s;return k.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=h;function o(r,s){return!l(r,s)&&!h(r)}e.isSavedWorkspace=o;function E(r){return(typeof r=="string"?(0,i.extname)(r):(0,A.extname)(r))===f}e.hasWorkspaceFileExtension=E}),define(ye[86],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(ye[46],De([0,1,10,22,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(y=>{const w=this._providerInfo.get(y.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(y,w){w===null?this._providerInfo.delete(y.scheme):this._providerInfo.set(y.scheme,w)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(ye[27],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(ye[205],De([0,1,17]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(k,y,w){this._deferredPromises=new Map,this._id=k,this._shared=y,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of P.values())L.complete()}catch(L){for(const I of P.values())I.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,y){let w=this._value[k];return typeof w=="undefined"&&(w=y),w}update(k,y){this._value[k]=y;let w=this._deferredPromises.get(k);if(w!==void 0)return w.p;const P=new d.DeferredPromise;return this._deferredPromises.set(k,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class _ extends i{constructor(k,y){super(k.identifier.value,!0,y);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=_}),define(ye[206],De([0,1,3,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class _{constructor(k){this._notebooksAndEditors=k,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new d.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(k,y,w,P){const I=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptModelChanged(y.value,w,P);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(k,y){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptDirty(y)}$acceptModelSaved(k){const y=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}}e.ExtHostNotebookDocuments=_}),define(ye[18],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class i{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=i});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[207],De([0,1,28,3]),function(Y,e,d,i){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(y,w){_.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(y.identifier),et(this,_,w,"f"),Ue(this,_,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(y){return Ue(this,_,"f").get(this._id,y)}store(y,w){return Ue(this,_,"f").store(this._id,y,w)}delete(y){return Ue(this,_,"f").delete(this._id,y)}}e.ExtensionSecrets=A,_=new WeakMap}),define(ye[123],De([0,1,4,3]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new i.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(k,y){this._level=k,this._productConfig=y||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(k){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=k,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(ye[52],De([0,1,4,122,3,18]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var k;(function(w){function P(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:I.protocol}}w.fromApiTunnel=P;function L(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==i.TunnelPrivacyId.ConstantPrivate&&I.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}w.fromServiceTunnel=L})(k=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let y=class{constructor(P){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,L){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,L){return{dispose:()=>{}}}async $providePortAttributes(P,L,I,D,T){return[]}async $forwardPort(P,L){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([xe(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[7],De([0,1,16,11,101,24,94,8,14,2,36,42,120]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";var T,C,m,v,g,b,f,l,h,o,E,r,s,n,t,a,c,u,S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O($){function W(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(W,$),Object.setPrototypeOf(W.prototype,$.prototype),W}let N=g=class{constructor(W){T.set(this,void 0),et(this,T,W,"f")}static from(...W){let ge=W;return new g(function(){if(ge){for(const Oe of ge)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();ge=void 0}})}dispose(){typeof Ue(this,T,"f")=="function"&&(Ue(this,T,"f").call(this),et(this,T,void 0,"f"))}};T=new WeakMap,N=g=je([O],N),e.Disposable=N;let p=b=class{constructor(W,ge){if(W<0)throw(0,i.illegalArgument)("line must be non-negative");if(ge<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=W,this._character=ge}static Min(...W){if(W.length===0)throw new TypeError;let ge=W[0];for(let Oe=1;Oe<W.length;Oe++){const Je=W[Oe];Je.isBefore(ge)&&(ge=Je)}return ge}static Max(...W){if(W.length===0)throw new TypeError;let ge=W[0];for(let Oe=1;Oe<W.length;Oe++){const Je=W[Oe];Je.isAfter(ge)&&(ge=Je)}return ge}static isPosition(W){if(!W)return!1;if(W instanceof b)return!0;let{line:ge,character:Oe}=W;return typeof ge=="number"&&typeof Oe=="number"}static of(W){if(W instanceof b)return W;if(this.isPosition(W))return new b(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ge=0){if(W===null||ge===null)throw(0,i.illegalArgument)();let Oe;return typeof W=="undefined"?Oe=0:typeof W=="number"?Oe=W:(Oe=typeof W.lineDelta=="number"?W.lineDelta:0,ge=typeof W.characterDelta=="number"?W.characterDelta:0),Oe===0&&ge===0?this:new b(this.line+Oe,this.character+ge)}with(W,ge=this.character){if(W===null||ge===null)throw(0,i.illegalArgument)();let Oe;return typeof W=="undefined"?Oe=this.line:typeof W=="number"?Oe=W:(Oe=typeof W.line=="number"?W.line:this.line,ge=typeof W.character=="number"?W.character:this.character),Oe===this.line&&ge===this.character?this:new b(Oe,ge)}toJSON(){return{line:this.line,character:this.character}}};p=b=je([O],p),e.Position=p;let M=f=class{constructor(W,ge,Oe,Je){let it,at;if(typeof W=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Je=="number"?(it=new p(W,ge),at=new p(Oe,Je)):p.isPosition(W)&&p.isPosition(ge)&&(it=p.of(W),at=p.of(ge)),!it||!at)throw new Error("Invalid arguments");it.isBefore(at)?(this._start=it,this._end=at):(this._start=at,this._end=it)}static isRange(W){return W instanceof f?!0:W?p.isPosition(W.start)&&p.isPosition(W.end):!1}static of(W){if(W instanceof f)return W;if(this.isRange(W))return new f(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return f.isRange(W)?this.contains(W.start)&&this.contains(W.end):p.isPosition(W)?!(p.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ge=p.Max(W.start,this._start),Oe=p.Min(W.end,this._end);if(!ge.isAfter(Oe))return new f(ge,Oe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ge=p.Min(W.start,this._start),Oe=p.Max(W.end,this.end);return new f(ge,Oe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ge=this.end){if(W===null||ge===null)throw(0,i.illegalArgument)();let Oe;return W?p.isPosition(W)?Oe=W:(Oe=W.start||this.start,ge=W.end||this.end):Oe=this.start,Oe.isEqual(this._start)&&ge.isEqual(this.end)?this:new f(Oe,ge)}toJSON(){return[this.start,this.end]}};M=f=je([O],M),e.Range=M;let U=l=class extends M{constructor(W,ge,Oe,Je){let it,at;if(typeof W=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Je=="number"?(it=new p(W,ge),at=new p(Oe,Je)):p.isPosition(W)&&p.isPosition(ge)&&(it=p.of(W),at=p.of(ge)),!it||!at)throw new Error("Invalid arguments");super(it,at);this._anchor=it,this._active=at}static isSelection(W){return W instanceof l?!0:W?M.isRange(W)&&p.isPosition(W.anchor)&&p.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=l=je([O],U),e.Selection=U;class z{constructor(W,ge,Oe){if(typeof W!="string"||W.length===0)throw(0,i.illegalArgument)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,i.illegalArgument)("port");if(typeof Oe!="undefined"&&(typeof Oe!="string"||Oe.length===0||!/^[0-9A-Za-z\-]+$/.test(Oe)))throw(0,i.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ge),this.connectionToken=Oe}}e.ResolvedAuthority=z;class re extends Error{constructor(W,ge=D.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(W);this._message=W,this._code=ge,this._detail=Oe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(W,ge){return new re(W,D.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(W){return new re(W,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var H;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var F;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=h=class{constructor(W,ge){this._range=W,this._newText=ge}static isTextEdit(W){return W instanceof h?!0:W?M.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ge){return new h(W,ge)}static insert(W,ge){return h.replace(new M(W,W),ge)}static delete(W){return h.replace(W,"")}static setEndOfLine(W){const ge=new h(new M(new p(0,0),new p(0,0)),"");return ge.newEol=W,ge}get range(){return this._range}set range(W){if(W&&!M.isRange(W))throw(0,i.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,i.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,i.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=h=je([O],j),e.TextEdit=j;class x{constructor(W,ge){this.range=W,this.snippet=ge}}e.SnippetTextEdit=x;var V;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let ne=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ge,Oe,Je){this._edits.push({_type:1,from:W,to:ge,options:Oe,metadata:Je})}createFile(W,ge,Oe){this._edits.push({_type:1,from:void 0,to:W,options:ge,metadata:Oe})}deleteFile(W,ge,Oe){this._edits.push({_type:1,from:W,to:void 0,options:ge,metadata:Oe})}replaceNotebookMetadata(W,ge,Oe){this._edits.push({_type:3,metadata:Oe,uri:W,edit:{editType:5,metadata:ge},notebookMetadata:ge})}replaceNotebookCells(W,ge,Oe,Je,it){let at,ct,Ct=[],Tt;if(gt.isNotebookRange(ge)&&jt.isNotebookCellDataArray(Oe)&&!jt.isNotebookCellDataArray(Je)?(at=ge.start,ct=ge.end,Ct=Oe,Tt=Je):typeof ge=="number"&&typeof Oe=="number"&&jt.isNotebookCellDataArray(Je)&&(at=ge,ct=Oe,Ct=Je,Tt=it),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:W,index:at,count:ct-at,cells:Ct,metadata:Tt})}replaceNotebookCellMetadata(W,ge,Oe,Je){this._edits.push({_type:3,metadata:Je,uri:W,edit:{editType:8,index:ge,metadata:Oe}})}replace(W,ge,Oe,Je){this._edits.push({_type:2,uri:W,edit:new j(ge,Oe),metadata:Je})}insert(W,ge,Oe,Je){this.replace(W,new M(ge,ge),Oe,Je)}delete(W,ge,Oe){this.replace(W,ge,"",Oe)}has(W){return this._edits.some(ge=>ge._type===2&&ge.uri.toString()===W.toString())}set(W,ge){if(ge)for(const Oe of ge)Oe&&this._edits.push({_type:2,uri:W,edit:Oe});else{for(let Oe=0;Oe<this._edits.length;Oe++){const Je=this._edits[Oe];Je._type===2&&Je.uri.toString()===W.toString()&&(this._edits[Oe]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(W){const ge=[];for(let Oe of this._edits)Oe._type===2&&Oe.uri.toString()===W.toString()&&ge.push(Oe.edit);return ge}entries(){const W=new A.ResourceMap;for(let ge of this._edits)if(ge._type===2){let Oe=W.get(ge.uri);Oe||(Oe=[ge.uri,[]],W.set(ge.uri,Oe)),Oe[1].push(ge.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ne=je([O],ne),e.WorkspaceEdit=ne;let Q=o=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=o._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ge=this._tabstop++){if(typeof W=="function"){const Oe=new o;Oe._tabstop=this._tabstop,W(Oe),this._tabstop=Oe._tabstop,W=Oe.value}else W=o._escape(W);return this.value+="${",this.value+=ge,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ge=this._tabstop++){const Oe=W.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(W,ge){if(typeof ge=="function"){const Oe=new o;Oe._tabstop=this._tabstop,ge(Oe),this._tabstop=Oe._tabstop,ge=Oe.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};Q=o=je([O],Q),e.SnippetString=Q;var he;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(he=e.DiagnosticTag||(e.DiagnosticTag={}));var fe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(fe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=E=class{constructor(W,ge){if(this.uri=W,ge)if(M.isRange(ge))this.range=M.of(ge);else if(p.isPosition(ge))this.range=new M(ge,ge);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof E?!0:W?M.isRange(W.range)&&P.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=E=je([O],G),e.Location=G;let X=class{constructor(W,ge){this.location=W,this.message=ge}static is(W){return W?typeof W.message=="string"&&W.location&&M.isRange(W.location.range)&&P.URI.isUri(W.location.uri):!1}static isEqual(W,ge){return W===ge?!0:!W||!ge?!1:W.message===ge.message&&W.location.range.isEqual(ge.location.range)&&W.location.uri.toString()===ge.location.uri.toString()}};X=je([O],X),e.DiagnosticRelatedInformation=X;let ce=class{constructor(W,ge,Oe=fe.Error){if(!M.isRange(W))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=W,this.message=ge,this.severity=Oe}toJSON(){return{severity:fe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ge){return W===ge?!0:!W||!ge?!1:W.message===ge.message&&W.severity===ge.severity&&W.code===ge.code&&W.severity===ge.severity&&W.source===ge.source&&W.range.isEqual(ge.range)&&(0,d.equals)(W.tags,ge.tags)&&(0,d.equals)(W.relatedInformation,ge.relatedInformation,X.isEqual)}};ce=je([O],ce),e.Diagnostic=ce;let pe=class{constructor(W,ge){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ge}};pe=je([O],pe),e.Hover=pe;var Ie;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(W,ge=Ie.Text){this.range=W,this.kind=ge}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Re=je([O],Re),e.DocumentHighlight=Re;var Ce;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Ce=e.SymbolKind||(e.SymbolKind={}));var ke;(function($){$[$.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Ae=r=class{constructor(W,ge,Oe,Je,it){this.name=W,this.kind=ge,this.containerName=it,typeof Oe=="string"&&(this.containerName=Oe),Je instanceof G?this.location=Je:Oe instanceof M&&(this.location=new G(Je,Oe)),r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};Ae=r=je([O],Ae),e.SymbolInformation=Ae;let ue=s=class{constructor(W,ge,Oe,Je,it){this.name=W,this.detail=ge,this.kind=Oe,this.range=Je,this.selectionRange=it,this.children=[],s.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(s.validate)}};ue=s=je([O],ue),e.DocumentSymbol=ue;var ve;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(W,ge){this.title=W,this.kind=ge}};ie=je([O],ie),e.CodeAction=ie;let oe=n=class{constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.sep)}};oe.sep=".",oe=n=je([O],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let we=class{constructor(W,ge){if(this.range=W,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=je([O],we),e.SelectionRange=we;class Te{constructor(W,ge,Oe,Je,it,at){this.kind=W,this.name=ge,this.detail=Oe,this.uri=Je,this.range=it,this.selectionRange=at}}e.CallHierarchyItem=Te;class B{constructor(W,ge){this.fromRanges=ge,this.from=W}}e.CallHierarchyIncomingCall=B;class q{constructor(W,ge){this.fromRanges=ge,this.to=W}}e.CallHierarchyOutgoingCall=q;var J;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(J=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let te=class{constructor(W,ge){this.range=W,this.command=ge}get isResolved(){return!!this.command}};te=je([O],te),e.CodeLens=te;let K=t=class{constructor(W,ge=!1){C.set(this,void 0),et(this,C,new _.MarkdownString(W,{supportThemeIcons:ge}),"f")}static isMarkdownString(W){return W instanceof t?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Ue(this,C,"f").value}set value(W){Ue(this,C,"f").value=W}get isTrusted(){return Ue(this,C,"f").isTrusted}set isTrusted(W){Ue(this,C,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,C,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,C,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,C,"f").supportHtml}set supportHtml(W){Ue(this,C,"f").supportHtml=W}get baseUri(){return Ue(this,C,"f").baseUri}set baseUri(W){Ue(this,C,"f").baseUri=W}appendText(W){return Ue(this,C,"f").appendText(W),this}appendMarkdown(W){return Ue(this,C,"f").appendMarkdown(W),this}appendCodeblock(W,ge){return Ue(this,C,"f").appendCodeblock(ge??"",W),this}};C=new WeakMap,K=t=je([O],K),e.MarkdownString=K;let ae=class{constructor(W,ge){this.label=W,this.documentation=ge}};ae=je([O],ae),e.ParameterInformation=ae;let de=class{constructor(W,ge){this.label=W,this.documentation=ge,this.parameters=[]}};de=je([O],de),e.SignatureInformation=de;let Be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Be=je([O],Be),e.SignatureHelp=Be;var $e;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})($e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let Xe=class{constructor(W){this.value=W}};Xe=je([O],Xe),e.InlayHintLabelPart=Xe;let ee=class{constructor(W,ge,Oe){this.position=W,this.label=ge,this.kind=Oe}};ee=je([O],ee),e.InlayHint=ee;var se;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var be;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(be=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function($){$[$.Deprecated=1]="Deprecated"})(le=e.CompletionItemTag||(e.CompletionItemTag={}));let _e=class{constructor(W,ge){this.label=W,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};_e=je([O],_e),e.CompletionItem=_e;let Fe=class{constructor(W=[],ge=!1){this.items=W,this.isIncomplete=ge}};Fe=je([O],Fe),e.CompletionList=Fe;let He=class{constructor(W,ge,Oe){this.insertText=W,this.range=ge,this.command=Oe}};He=je([O],He),e.InlineSuggestion=He;let qe=class{constructor(W){this.items=W}};qe=je([O],qe),e.InlineSuggestions=qe;let Ge=class{constructor(W,ge,Oe){this.insertText=W,this.range=ge,this.command=Oe}};Ge=je([O],Ge),e.InlineSuggestionNew=Ge;let Ze=class{constructor(W,ge){this.items=W,this.commands=ge}};Ze=je([O],Ze),e.InlineSuggestionsNew=Ze;var Qe;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var rt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var tt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ut;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Pt;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(Pt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Nt;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function W(ge){switch(ge){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=W}(ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let yt=class{constructor(W,ge){if(ge&&!P.URI.isUri(ge))throw(0,i.illegalArgument)("target");if(!M.isRange(W)||W.isEmpty)throw(0,i.illegalArgument)("range");this.range=W,this.target=ge}};yt=je([O],yt),e.DocumentLink=yt;let ft=class{constructor(W,ge,Oe,Je){this.red=W,this.green=ge,this.blue=Oe,this.alpha=Je}};ft=je([O],ft),e.Color=ft;let Dt=class{constructor(W,ge){if(ge&&!(ge instanceof ft))throw(0,i.illegalArgument)("color");if(!M.isRange(W)||W.isEmpty)throw(0,i.illegalArgument)("range");this.range=W,this.color=ge}};Dt=je([O],Dt),e.ColorInformation=Dt;let At=class{constructor(W){if(!W||typeof W!="string")throw(0,i.illegalArgument)("label");this.label=W}};At=je([O],At),e.ColorPresentation=At;var Ft;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Ft=e.ColorFormat||(e.ColorFormat={}));var Ke;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Ke=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class zt{constructor(W,ge,Oe){if(this.startIndex=W,this.length=ge,this.tooltip=Oe,typeof W!="number"||W<0)throw(0,i.illegalArgument)("startIndex");if(typeof ge!="number"||ge<1)throw(0,i.illegalArgument)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=zt;var Rt;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Rt=e.TerminalLocation||(e.TerminalLocation={}));class Mt{constructor(W){if(this.options=W,typeof W!="object")throw(0,i.illegalArgument)("options")}}e.TerminalProfile=Mt;var Pe;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Le;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(Le=e.TaskPanelKind||(e.TaskPanelKind={}));let Ee=a=class{constructor(W,ge){if(this.label=ge,typeof W!="string"||typeof ge!="string")throw(0,i.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};Ee.Clean=new a("clean","Clean"),Ee.Build=new a("build","Build"),Ee.Rebuild=new a("rebuild","Rebuild"),Ee.Test=new a("test","Test"),Ee=a=je([O],Ee),e.TaskGroup=Ee;function Z($){let W="";for(let ge=0;ge<$.length;ge++)W+=$[ge].replace(/,/g,",,")+",";return W}let Me=class{constructor(W,ge,Oe){if(typeof W!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=W,ge!==void 0&&(Array.isArray(ge)?(this._args=ge,this._options=Oe):this._options=ge)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,i.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let ge of this._args)W.push(ge);return Z(W)}};Me=je([O],Me),e.ProcessExecution=Me;let Ve=class{constructor(W,ge,Oe){if(this._args=[],Array.isArray(ge)){if(!W)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,i.illegalArgument)("command");this._command=W,this._args=ge,this._options=Oe}else{if(typeof W!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=W,this._options=ge}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,i.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ge of this._args)W.push(typeof ge=="string"?ge:ge.value);return Z(W)}};Ve=je([O],Ve),e.ShellExecution=Ve;var st;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(st=e.ShellQuoting||(e.ShellQuoting={}));var Ye;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Ye=e.TaskScope||(e.TaskScope={}));class lt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=lt;let dt=c=class{constructor(W,ge,Oe,Je,it,at){this.__deprecated=!1,this._definition=this.definition=W;let ct;typeof ge=="string"?(this._name=this.name=ge,this._source=this.source=Oe,this.execution=Je,ct=it,this.__deprecated=!0):ge===Ye.Global||ge===Ye.Workspace?(this.target=ge,this._name=this.name=Oe,this._source=this.source=Je,this.execution=it,ct=at):(this.target=ge,this._name=this.name=Oe,this._source=this.source=Je,this.execution=it,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Me?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ve?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ge=this._definition.type;(c.EmptyType===ge||c.ProcessType===ge||c.ShellType===ge||c.ExtensionCallbackType===ge)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=c=je([O],dt),e.Task=dt;var vt;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(W,ge=mt.None){this.collapsibleState=ge,P.URI.isUri(W)?this.resourceUri=W:this.label=W}};_t=je([O],_t),e.TreeItem=_t;var mt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(W){this.value=W}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};wt=je([O],wt),e.DataTransferItem=wt;let Lt=class{constructor(){this._items=new Map}get(W){return this._items.get(W)}set(W,ge){this._items.set(W,ge)}forEach(W){this._items.forEach(W)}};Lt=je([O],Lt),e.DataTransfer=Lt;let bt=class{constructor(W,ge){this.id=W,this.color=ge}};bt=je([O],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Kt=class{constructor(W){this.id=W}};Kt=je([O],Kt),e.ThemeColor=Kt;var Qt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Et=class{constructor(W,ge){if(typeof W!="string"&&(!W||!P.URI.isUri(W)&&!P.URI.isUri(W.uri)))throw(0,i.illegalArgument)("base");if(typeof ge!="string")throw(0,i.illegalArgument)("pattern");typeof W=="string"?this.baseUri=P.URI.file(W):P.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ge}get base(){return this._base}set base(W){this._base=W,this._baseUri=P.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Et=je([O],Et),e.RelativePattern=Et;let $t=class{constructor(W,ge,Oe,Je){this.enabled=typeof W=="boolean"?W:!0,typeof ge=="string"&&(this.condition=ge),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};$t=je([O],$t),e.Breakpoint=$t;let Yt=class extends $t{constructor(W,ge,Oe,Je,it){super(ge,Oe,Je,it);if(W===null)throw(0,i.illegalArgument)("location");this.location=W}};Yt=je([O],Yt),e.SourceBreakpoint=Yt;let Jt=class extends $t{constructor(W,ge,Oe,Je,it){super(ge,Oe,Je,it);this.functionName=W}};Jt=je([O],Jt),e.FunctionBreakpoint=Jt;let ci=class extends $t{constructor(W,ge,Oe,Je,it,at,ct){super(Je,it,at,ct);if(!ge)throw(0,i.illegalArgument)("dataId");this.label=W,this.dataId=ge,this.canPersist=Oe}};ci=je([O],ci),e.DataBreakpoint=ci;let ui=class{constructor(W,ge,Oe){this.command=W,this.args=ge||[],this.options=Oe}};ui=je([O],ui),e.DebugAdapterExecutable=ui;let kt=class{constructor(W,ge){this.port=W,this.host=ge}};kt=je([O],kt),e.DebugAdapterServer=kt;let Zt=class{constructor(W){this.path=W}};Zt=je([O],Zt),e.DebugAdapterNamedPipeServer=Zt;let di=class{constructor(W){this.implementation=W}};di=je([O],di),e.DebugAdapterInlineImplementation=di;let Xt=class{constructor(W,ge){this.range=W,this.expression=ge}};Xt=je([O],Xt),e.EvaluatableExpression=Xt;var ei;(function($){$[$.Automatic=0]="Automatic",$[$.Explicit=1]="Explicit"})(ei=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var ht;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(ht=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let hi=class{constructor(W,ge){this.range=W,this.text=ge}};hi=je([O],hi),e.InlineValueText=hi;let Bt=class{constructor(W,ge,Oe=!0){this.range=W,this.variableName=ge,this.caseSensitiveLookup=Oe}};Bt=je([O],Bt),e.InlineValueVariableLookup=Bt;let xt=class{constructor(W,ge){this.range=W,this.expression=ge}};xt=je([O],xt),e.InlineValueEvaluatableExpression=xt;let ti=class{constructor(W,ge){this.frameId=W,this.stoppedLocation=ge}};ti=je([O],ti),e.InlineValueContext=ti;var Ti;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ti=e.FileChangeType||(e.FileChangeType={}));let ii=u=class extends Error{constructor(W,ge=I.FileSystemProviderErrorCode.Unknown,Oe){super(P.URI.isUri(W)?W.toString(!0):W);this.code=Oe?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ge),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}static FileExists(W){return new u(W,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(W){return new u(W,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(W){return new u(W,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(W){return new u(W,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(W){return new u(W,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(W){return new u(W,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};ii=u=je([O],ii),e.FileSystemError=ii;let fi=class{constructor(W,ge,Oe){this.start=W,this.end=ge,this.kind=Oe}};fi=je([O],fi),e.FoldingRange=fi;var Si;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ni;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pi;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Pi=e.CommentMode||(e.CommentMode={}));var mi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class gi{constructor(W,ge=[]){this.tokenTypes=W,this.tokenModifiers=ge}}e.SemanticTokensLegend=gi;function Ai($){return typeof $=="undefined"||(0,w.isStringArray)($)}class pi{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ge=0,Oe=W.tokenTypes.length;ge<Oe;ge++)this._tokenTypeStrToInt.set(W.tokenTypes[ge],ge);for(let ge=0,Oe=W.tokenModifiers.length;ge<Oe;ge++)this._tokenModifierStrToInt.set(W.tokenModifiers[ge],ge)}}push(W,ge,Oe,Je,it){if(typeof W=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Je=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(W,ge,Oe,Je,it);if(M.isRange(W)&&typeof ge=="string"&&Ai(Oe))return this._push(W,ge,Oe);throw(0,i.illegalArgument)()}_push(W,ge,Oe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ge))throw new Error("`tokenType` is not in the provided legend");const Je=W.start.line,it=W.start.character,at=W.end.character-W.start.character,ct=this._tokenTypeStrToInt.get(ge);let Ct=0;if(Oe)for(const Tt of Oe){if(!this._tokenModifierStrToInt.has(Tt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Tt);Ct|=1<<Wt>>>0}this._pushEncoded(Je,it,at,ct,Ct)}_pushEncoded(W,ge,Oe,Je,it){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ge<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Tt=0,Wt=0;for(let Ht=0;Ht<Ct;Ht++){let qt=this._data[5*Ht],bi=this._data[5*Ht+1];qt===0?(qt=Tt,bi+=Wt):qt+=Tt,this._data[5*Ht]=qt,this._data[5*Ht+1]=bi,Tt=qt,Wt=bi}}let at=W,ct=ge;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Oe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=it,this._prevLine=W,this._prevChar=ge}static _sortAndDeltaEncode(W){let ge=[];const Oe=W.length/5|0;for(let ct=0;ct<Oe;ct++)ge[ct]=ct;ge.sort((ct,Ct)=>{const Tt=W[5*ct],Wt=W[5*Ct];if(Tt===Wt){const Ht=W[5*ct+1],qt=W[5*Ct+1];return Ht-qt}return Tt-Wt});const Je=new Uint32Array(W.length);let it=0,at=0;for(let ct=0;ct<Oe;ct++){const Ct=5*ge[ct],Tt=W[Ct+0],Wt=W[Ct+1],Ht=W[Ct+2],qt=W[Ct+3],bi=W[Ct+4],Xi=Tt-it,dn=Xi===0?Wt-at:Wt,Ei=5*ct;Je[Ei+0]=Xi,Je[Ei+1]=dn,Je[Ei+2]=Ht,Je[Ei+3]=qt,Je[Ei+4]=bi,it=Tt,at=Wt}return Je}build(W){return this._dataIsSortedAndDeltaEncoded?new Vt(new Uint32Array(this._data),W):new Vt(pi._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=pi;class Vt{constructor(W,ge){this.resultId=ge,this.data=W}}e.SemanticTokens=Vt;class Ri{constructor(W,ge,Oe){this.start=W,this.deleteCount=ge,this.data=Oe}}e.SemanticTokensEdit=Ri;class Li{constructor(W,ge){this.resultId=ge,this.edits=W}}e.SemanticTokensEdits=Li;var Oi;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Oi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ri=class{constructor(){}};ri.Back={iconPath:new bt("arrow-left")},ri=je([O],ri),e.QuickInputButtons=ri;var vi;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(vi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var _i;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(_i=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ci;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Ci=e.ExtensionKind||(e.ExtensionKind={}));class ze{constructor(W,ge,Oe){this.badge=W,this.tooltip=ge,this.color=Oe}static validate(W){if(W.badge){let ge=(0,y.nextCharLength)(W.badge,0);if(ge<W.badge.length&&(ge+=(0,y.nextCharLength)(W.badge,ge)),W.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ze;let Ut=class{constructor(W){this.kind=W}};Ut=je([O],Ut),e.ColorTheme=Ut;var yi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(yi=e.ColorThemeKind||(e.ColorThemeKind={}));class gt{constructor(W,ge){if(W<0)throw(0,i.illegalArgument)("start must be positive");if(ge<0)throw(0,i.illegalArgument)("end must be positive");W<=ge?(this._start=W,this._end=ge):(this._start=ge,this._end=W)}static isNotebookRange(W){return W instanceof gt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let ge=this._start,Oe=this._end;return W.start!==void 0&&(ge=W.start),W.end!==void 0&&(Oe=W.end),ge===this._start&&Oe===this._end?this:new gt(ge,Oe)}}e.NotebookRange=gt;class jt{constructor(W,ge,Oe,Je,it,at,ct){this.kind=W,this.value=ge,this.languageId=Oe,this.mime=Je,this.outputs=it??[],this.metadata=at,this.executionSummary=ct,jt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ge=>jt.isNotebookCellData(ge))}static isNotebookCellData(W){return!0}}e.NotebookCellData=jt;class Ni{constructor(W){this.cells=W}}e.NotebookData=Ni;class Ot{constructor(W,ge){this.data=W,this.mime=ge;const Oe=(0,k.normalizeMimeType)(ge,!0);if(!Oe)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}static isNotebookCellOutputItem(W){return W instanceof Ot?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ge={name:W.name,message:W.message,stack:W.stack};return Ot.json(ge,"application/vnd.code.notebook.error")}static stdout(W){return Ot.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Ot.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ge="application/octet-stream"){return new Ot(W,ge)}static text(W,ge=k.Mimes.text){const Oe=Ue(Ot,m,"f",v).encode(String(W));return new Ot(Oe,ge)}static json(W,ge="text/x-json"){const Oe=JSON.stringify(W,void 0,"	");return Ot.text(Oe,ge)}}e.NotebookCellOutputItem=Ot,m=Ot,v={value:new TextEncoder};class si{constructor(W,ge,Oe){this.items=si.ensureUniqueMimeTypes(W,!0),typeof ge=="string"?(this.id=ge,this.metadata=Oe):(this.id=(0,L.generateUuid)(),this.metadata=ge??Oe)}static isNotebookCellOutput(W){return W instanceof si?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,w.isArray)(W.items)}static ensureUniqueMimeTypes(W,ge=!1){const Oe=new Set,Je=new Set;for(let it=0;it<W.length;it++){const at=W[it],ct=(0,k.normalizeMimeType)(at.mime);if(!Oe.has(ct)){Oe.add(ct);continue}Je.add(it),ge&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Je.size===0?W:W.filter((it,at)=>!Je.has(at))}}e.NotebookCellOutput=si;var oi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(oi=e.NotebookCellKind||(e.NotebookCellKind={}));var Fi;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Fi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Mi;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ui;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Ui=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Di{constructor(W,ge){this.text=W,this.alignment=ge}}e.NotebookCellStatusBarItem=Di;var Bi;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Bi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Wi{constructor(W,ge=[]){this.uri=W,this.provides=(0,d.asArray)(ge)}}e.NotebookRendererScript=Wi;let wi=class{constructor(W,ge){this.label=W,this.timestamp=ge}};wi=je([O],wi),e.TimelineItem=wi;var zi;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(zi=e.ExtensionMode||(e.ExtensionMode={}));var Hi;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(Hi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var me;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(me=e.StandardTokenType||(e.StandardTokenType={}));class Se{constructor(W,ge){this.ranges=W,this.wordPattern=ge}}e.LinkedEditingRanges=Se;class We{constructor(W,ge){this._port=W,this._autoForwardAction=ge}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=We;var ot;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(ot=e.TestResultState||(e.TestResultState={}));var St;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(St=e.TestRunProfileKind||(e.TestRunProfileKind={}));let It=class{constructor(W=void 0,ge=void 0,Oe=void 0){this.include=W,this.exclude=ge,this.profile=Oe}};It=je([O],It),e.TestRunRequest=It;let $i=S=class{constructor(W){this.message=W}static diff(W,ge,Oe){const Je=new S(W);return Je.expectedOutput=ge,Je.actualOutput=Oe,Je}};$i=S=je([O],$i),e.TestMessage=$i;let xi=class{constructor(W){this.id=W}};xi=je([O],xi),e.TestTag=xi;let ai=class{constructor(W,ge){this.covered=W,this.total=ge}};ai=je([O],ai),e.CoveredCount=ai;let Vi=R=class{constructor(W,ge,Oe,Je){this.uri=W,this.statementCoverage=ge,this.branchCoverage=Oe,this.functionCoverage=Je}static fromDetails(W,ge){const Oe=new ai(0,0),Je=new ai(0,0),it=new ai(0,0);for(const ct of ge)if("branches"in ct){Oe.total+=1,Oe.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)Je.total+=1,Je.covered+=Ct.executionCount>0?1:0}else it.total+=1,it.covered+=ct.executionCount>0?1:0;const at=new R(W,Oe,Je.total>0?Je:void 0,it.total>0?it:void 0);return at.detailedCoverage=ge,at}};Vi=R=je([O],Vi),e.FileCoverage=Vi;let ji=class{constructor(W,ge,Oe=[]){this.executionCount=W,this.location=ge,this.branches=Oe}};ji=je([O],ji),e.StatementCoverage=ji;let qi=class{constructor(W,ge){this.executionCount=W,this.location=ge}};qi=je([O],qi),e.BranchCoverage=qi;let Gi=class{constructor(W,ge){this.executionCount=W,this.location=ge}};Gi=je([O],Gi),e.FunctionCoverage=Gi;var Zi;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(Zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var en;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(en=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var tn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(tn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class nn{constructor(W,ge,Oe,Je,it,at){this.kind=W,this.name=ge,this.detail=Oe,this.uri=Je,this.range=it,this.selectionRange=at}}e.TypeHierarchyItem=nn;class rn{constructor(W){this.uri=W}}e.TextTabInput=rn;class sn{constructor(W,ge){this.original=W,this.modified=ge}}e.TextDiffTabInput=sn;class on{constructor(W,ge){this.uri=W,this.viewType=ge}}e.CustomEditorTabInput=on;class an{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=an;class ln{constructor(W,ge){this.uri=W,this.notebookType=ge}}e.NotebookEditorTabInput=ln;class cn{constructor(W,ge,Oe){this.original=W,this.modified=ge,this.notebookType=Oe}}e.NotebookDiffEditorTabInput=cn;class un{constructor(){}}e.TerminalEditorTabInput=un}),define(ye[124],De([0,1,56,10,8,156,109,7,16]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function L(C,m){m?P.set(C,m):P.delete(C)}e.setWordDefinitionFor=L;function I(C){return P.get(C)}e.getWordDefinitionFor=I;class D extends A.MirrorTextModel{constructor(m,v,g,b,f,l,h,o){super(v,g,b,f);this._proxy=m,this._languageId=l,this._isDirty=h,this._notebook=o,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,w.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===i.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(v){return v?m._getTextInRange(v):m.getText()},get eol(){return m._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(v){return m._lineAt(v)},offsetAt(v){return m._offsetAt(v)},positionAt(v){return m._positionAt(v)},validateRange(v){return m._validateRange(v)},validatePosition(v){return m._validatePosition(v)},getWordRangeAtPosition(v,g){return m._getWordRangeAtPosition(v,g)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,d.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,d.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const v=this._validateRange(m);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const g=this._eol,b=v.start.line,f=v.end.line,l=[];l.push(this._lines[b].substring(v.start.character));for(let h=b+1;h<f;h++)l.push(this._lines[h]);return l.push(this._lines[f].substring(0,v.end.character)),l.join(g)}_lineAt(m){let v;if(m instanceof y.Position?v=m.line:typeof m=="number"&&(v=m),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new T(v,this._lines[v],v===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getPrefixSum(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(m),g=this._lines[v.index].length;return new y.Position(v.index,Math.min(v.remainder,g))}_validateRange(m){if(!(m instanceof y.Range))throw new Error("Invalid argument");const v=this._validatePosition(m.start),g=this._validatePosition(m.end);return v===m.start&&g===m.end?m:new y.Range(v.line,v.character,g.line,g.character)}_validatePosition(m){if(!(m instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:v,character:g}=m,b=!1;if(v<0)v=0,g=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,g=this._lines[v].length,b=!0;else{const f=this._lines[v].length;g<0?(g=0,b=!0):g>f&&(g=f,b=!0)}return b?new y.Position(v,g):m}_getWordRangeAtPosition(m,v){const g=this._validatePosition(m);if(!v)v=I(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,k.getWordAtText)(g.character+1,(0,k.ensureValidWordDefinition)(v),this._lines[g.line],0);if(b)return new y.Range(g.line,b.startColumn-1,g.line,b.endColumn-1)}}e.ExtHostDocumentData=D;class T{constructor(m,v,g){this._line=m,this._text=v,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(ye[208],De([0,1,7,18,3]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(y){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let w;switch(y){case"light":w=d.ColorThemeKind.Light;break;case"hcDark":w=d.ColorThemeKind.HighContrast;break;case"hcLight":w=d.ColorThemeKind.HighContrastLight;break;default:w=d.ColorThemeKind.Dark}this._actual=new d.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([xe(0,i.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ye[64],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class i{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=i}),define(ye[209],De([0,1,23]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(w){let P=this.buffers.indexOf(w);return P<0&&(P=this.buffers.length,this.buffers.push(w)),P}}function _(y,w){if(w.serializeBuffersForPostMessage){const P=new i,L=(T,C)=>{if(C instanceof ArrayBuffer){const m=P.add(C);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(C)){const m=A(C);if(m){const v=P.add(C.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:m,byteLength:C.byteLength,byteOffset:C.byteOffset}}}}return C},I=JSON.stringify(y,L),D=P.buffers.map(T=>{const C=new Uint8Array(T);return d.VSBuffer.wrap(C)});return{message:I,buffers:D}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=_;function A(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(y,w){const P=w.map(D=>{const T=new ArrayBuffer(D.byteLength);return new Uint8Array(T).set(D.buffer),T}),L=w.length?(D,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const C=T,{index:m}=C,v=P[m];if(C.view)switch(C.view.type){case 1:return new Int8Array(v,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return T}:void 0;return{message:JSON.parse(y,L),arrayBuffers:P}}e.deserializeWebviewMessage=k}),define(ye[125],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransferConverter=void 0;var d;(function(i){function _(k){const y=new Map;return k.types.forEach((w,P)=>{y.set(w,{asString:async()=>k.items[P].asString,value:void 0})}),y}i.toDataTransfer=_;async function A(k){const y={types:[],items:[]},w=Array.from(k.entries());for(const P of w)y.types.push(P[0]),y.items.push({asString:await P[1].asString()});return y}i.toDataTransferDTO=A})(d=e.DataTransferConverter||(e.DataTransferConverter={}))}),define(ye[210],De([0,1,103]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function i(A){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:A,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function _(A){return new d.URITransformer(i(A))}e.createURITransformer=_}),define(ye[211],De([0,1,180,14,2,6,4,44,42,16,10]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(H){const F=H;return!!F&&typeof F.getSelection=="function"&&!!F.onDidChangeSelection}e.isEditorPaneWithSelection=T;function C(H,F,j){for(const x of j.visibleEditorPanes)if(x.group.id===F&&H.matches(x.input))return x.getViewState()}e.findViewStateForEditor=C;function m(H){if(r(H))return!1;const F=H;return _.URI.isUri(F?.resource)}e.isResourceEditorInput=m;function v(H){if(r(H))return!1;const F=H;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=v;function g(H){if(r(H)||v(H))return!1;const F=H;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function b(H){if(r(H))return!1;const F=H;return F?F.resource===void 0||F.resource.scheme===L.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=b;var f;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var l;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class h{constructor(){this.mapIdToSaveSource=new Map}registerSource(F,j){let x=this.mapIdToSaveSource.get(F);return x||(x={source:F,label:j},this.mapIdToSaveSource.set(F,x)),x.source}getSourceLabel(F){return this.mapIdToSaveSource.get(F)?.label??F}}e.SaveSourceRegistry=new h;var o;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends A.Disposable{}e.AbstractEditorInput=E;function r(H){return H instanceof E}e.isEditorInput=r;function s(H){const F=H;return _.URI.isUri(F?.preferredResource)}function n(H){const F=H;return r(F?.primary)&&r(F?.secondary)}e.isSideBySideEditorInput=n;function t(H){const F=H;return r(F?.modified)&&r(F?.original)}e.isDiffEditorInput=t;function a(H){return r(H?.editor)}e.isEditorInputWithOptions=a;function c(H){const F=H;return a(H)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=c;function u(H){const F=H;return typeof F?.groupId=="number"&&r(F.editor)}e.isEditorIdentifier=u;var S;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(S=e.EditorCloseContext||(e.EditorCloseContext={}));var R;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(R=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var O;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(O=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(F,j){if(!F)return;if(j?.supportSideBySide){const{primary:V,secondary:ne}=this.getSideEditors(F);if(V&&ne){if(j?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===O.ANY)return this.getOriginalUri(V,{filterByScheme:j.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:j.filterByScheme});F=j.supportSideBySide===O.PRIMARY?V:ne}}if(v(F)||g(F))return;const x=s(F)?F.preferredResource:F.resource;return!x||!j||!j.filterByScheme?x:this.filterUri(x,j.filterByScheme)}getSideEditors(F){return n(F)||g(F)?{primary:F.primary,secondary:F.secondary}:t(F)||v(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,j){if(!F)return;if(j?.supportSideBySide){const{primary:V,secondary:ne}=this.getSideEditors(F);if(V&&ne){if(j?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===O.ANY)return this.getCanonicalUri(V,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:j.filterByScheme});F=j.supportSideBySide===O.PRIMARY?V:ne}}if(v(F)||g(F))return;const x=F.resource;return!x||!j||!j.filterByScheme?x:this.filterUri(x,j.filterByScheme)}filterUri(F,j){if(Array.isArray(j)){if(j.some(x=>F.scheme===x))return F}else if(j===F.scheme)return F}}e.EditorResourceAccessor=new N;var p;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class M{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const j=this.instantiationService=F.get(k.IInstantiationService);for(const[x,V]of this.editorSerializerConstructors)this.createEditorSerializer(x,V,j);this.editorSerializerConstructors.clear()}createEditorSerializer(F,j,x){const V=x.createInstance(j);this.editorSerializerInstances.set(F,V)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,j){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,j,this.instantiationService):this.editorSerializerConstructors.set(F,j),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new M);async function U(H,F){if(!H||!H.length)return[];const j=await Promise.all(H.map(async x=>{const V=_.URI.revive(x.fileUri);if(!V||!await F.canHandleResource(V))return;let Q=x.exists,he=x.type;if(typeof Q!="boolean"||typeof he!="number")try{he=(await F.stat(V)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Q=!0}catch{Q=!1}if(!Q&&x.openOnlyIfExists||he===w.FileType.Directory)return;const fe={...x.options,pinned:!0};let G;return Q?G={resource:V,options:fe}:G={resource:V,options:fe,forceUntitled:!0},G}));return(0,P.coalesce)(j)}e.pathsToEditors=U;var z;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function re(H){const F=H;if(!F)return!1;const j=F;if(j.modified)return re(j.modified);const x=F;return!!(x.contributionsState&&x.viewState&&Array.isArray(x.cursorState))}e.isTextEditorViewState=re}),define(ye[87],De([0,1,10,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function _(y,w){return y.scheme===d.Schemas.http||y.scheme===d.Schemas.https?y:(w&&w.authority&&w.isRemote&&y.scheme===d.Schemas.file&&(y=i.URI.from({scheme:d.Schemas.vscodeRemote,authority:w.authority,path:y.path})),i.URI.from({scheme:d.Schemas.https,authority:`${y.scheme}+${A(y.authority)}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=_;function A(y){return y.replace(/./g,w=>{const P=w.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?w:"-"+P.toString(16).padStart(4,"0")})}function k(y){return y.replace(/-([0-9a-f]{4})/g,(w,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=k}),define(ye[212],De([0,1,3,6,87]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(y,w,P){this._proxy=y,this._editors=w,this._remoteInfo=P,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const L=w.getVisibleTextEditors();for(const I of this._insets.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,w,P,L,I){let D;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===y){D=f;break}if(!D)throw new Error("not a visible editor");const T=this,C=this._handlePool++,m=new d.Emitter,v=new d.Emitter,g=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,_.asWebviewUri)(f,T._remoteInfo)}get cspSource(){return _.webviewGenericCspSource}set options(f){this._options=f,T._proxy.$setOptions(C,f)}get options(){return this._options}set html(f){this._html=f,T._proxy.$setHtml(C,f)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(f){return T._proxy.$postMessage(C,f)}},b=new class{constructor(){this.editor=y,this.line=w,this.height=P,this.webview=g,this.onDidDispose=v.event}dispose(){T._insets.has(C)&&(T._insets.delete(C),T._proxy.$disposeEditorInset(C),v.fire(),v.dispose(),m.dispose())}};return this._proxy.$createEditorInset(C,D.id,D.value.document.uri,w+1,P,L||{},I.identifier,I.extensionLocation),this._insets.set(C,{editor:y,inset:b,onDidReceiveMessage:m}),b}$onDidDispose(y){const w=this._insets.get(y);w&&w.inset.dispose()}$onDidReceiveMessage(y,w){const P=this._insets.get(y);P&&P.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=A}),define(ye[126],De([0,1,3,17,181]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,w,P,L){const I={command:y};if(w&&Object.keys(w).length>0&&(I.arguments=w),this.internalSend("request",I),typeof L=="number"){const D=setTimeout(()=>{clearTimeout(D);const T=this.pendingRequests.get(I.seq);if(T){this.pendingRequests.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:(0,_.localize)(0,null,L,y)};T(C)}},L)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,w){return y.type!=="event"||w.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,i.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":{const w=y,P=this.pendingRequests.get(w.request_seq);P&&(this.pendingRequests.delete(w.request_seq),P(w));break}}}}internalSend(y,w){w.type=y,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((w,P)=>y.set(P,w)),await(0,i.timeout)(500),y.forEach((w,P)=>{w({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ye[213],De([0,1,182,63,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new i.RawContextKey("debugType",void 0,{type:"string",description:d.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new i.RawContextKey("debugConfigurationType",void 0,{type:"string",description:d.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new i.RawContextKey("debugState","inactive",{type:"string",description:d.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new i.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:d.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new i.RawContextKey("inDebugMode",!1,{type:"boolean",description:d.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new i.RawContextKey("inDebugRepl",!1,{type:"boolean",description:d.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new i.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:d.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new i.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:d.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new i.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:d.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new i.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:d.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new i.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:d.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new i.RawContextKey("variablesFocused",!0,{type:"boolean",description:d.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new i.RawContextKey("expressionSelected",!1,{type:"boolean",description:d.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new i.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:d.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new i.RawContextKey("callStackItemType",void 0,{type:"string",description:d.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new i.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:d.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new i.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:d.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new i.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:d.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new i.RawContextKey("watchItemType",void 0,{type:"string",description:d.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new i.RawContextKey("canViewMemory",void 0,{type:"boolean",description:d.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new i.RawContextKey("breakpointItemType",void 0,{type:"string",description:d.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new i.RawContextKey("breakpointAccessType",void 0,{type:"string",description:d.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new i.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:d.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new i.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:d.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new i.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:d.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new i.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:d.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new i.RawContextKey("stepBackSupported",!1,{type:"boolean",description:d.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new i.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:d.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new i.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:d.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new i.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:d.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new i.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:d.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new i.RawContextKey("breakpointsExist",!1,{type:"boolean",description:d.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new i.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:d.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new i.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:d.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new i.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:d.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new i.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:d.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new i.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:d.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new i.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:d.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new i.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:d.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new i.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:d.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new i.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:d.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new i.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:d.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new i.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:d.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new i.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:d.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new i.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:d.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new i.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:d.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new i.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:d.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new i.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:d.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new i.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:d.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new i.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:d.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new i.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:d.localize(50,null)});const A=I=>d.localize(51,null,I);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:d.localize(52,null)};var k;(function(I){I[I.Inactive=0]="Inactive",I[I.Initializing=1]="Initializing",I[I.Stopped=2]="Stopped",I[I.Running=3]="Running"})(k=e.State||(e.State={}));function y(I){switch(I){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=y;var w;(function(I){I[I.Valid=0]="Valid",I[I.Unreadable=1]="Unreadable",I[I.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(I){I[I.Initial=1]="Initial",I[I.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,_.createDecorator)(e.DEBUG_SERVICE_ID);var L;(function(I){I[I.CONDITION=0]="CONDITION",I[I.HIT_COUNT=1]="HIT_COUNT",I[I.LOG_MESSAGE=2]="LOG_MESSAGE"})(L=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[214],De([0,1,8,2,9,26,10]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function w(r,s,n){return r.replace(y,function(t,a){return s&&a.length>0&&a[0]!=="_"?t:n&&n.hasOwnProperty(a)?n[a]:t})}e.formatPII=w;function P(r){const s={};for(const n of Object.keys(r))n.startsWith("!")||(s[n]=r[n]);return s}e.filterExceptionsFromTelemetry=P;function L(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(s,"extensionhost")||(0,d.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function D(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=D;function T(r,s,n){let t,a=0;const c=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let u=null;for(;u=c.exec(r);){const S=u.index+1,R=S+u[0].length;if(S<=s&&R>=n){t=u[0],a=S;break}}if(t){const S=/\w+/g;let R=null;for(;(R=S.exec(t))&&!(R.index+1+a+R[0].length>=n););R&&(t=t.substring(0,S.lastIndex))}return t?{start:a,end:a+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const C=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(C))}e.isUri=m;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return i.URI.parse(r.path);if((0,_.isAbsolute)(r.path))return i.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=i.URI.revive(r.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return r.path}function b(r,s){const n=s?v:g,t=(0,A.deepClone)(r);return l(t,(a,c)=>{a&&c&&(c.path=n(c))}),t}e.convertToDAPaths=b;function f(r,s){const n=s?v:g,t=(0,A.deepClone)(r);return l(t,(a,c)=>{!a&&c&&(c.path=n(c))}),t}e.convertToVSCPaths=f;function l(r,s){switch(r.type){case"event":{const n=r;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>s(!1,t));break;case"scopes":n.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(a=>s(!1,a.location))}break;default:break}break}}}function h(r){return r.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):o(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=h;function o(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function E(r,s){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(n!=="none"&&(await s.saveAll(),n==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===k.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ye[215],De([0,1,29,41,183,127,9,8,26,12,115,126]),function(Y,e,d,i,_,A,k,y,w,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class D extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",l=>this.handleData(l))}sendMessage(b){if(this.outputStream){const f=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${D.TWO_CRLF}${f}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+f))}continue}}else{const f=this.rawData.indexOf(D.TWO_CRLF);if(f!==-1){const h=this.rawData.toString("utf8",0,f).split(D.HEADER_LINESEPARATOR);for(const o of h){const E=o.split(D.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(f+D.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=D,D.TWO_CRLF=`\r
\r
`,D.HEADER_LINESEPARATOR=/\r?\n/,D.HEADER_FIELDSEPARATOR=/: */;class T extends D{startSession(){return new Promise((b,f)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",h=>{l?this._onError.fire(h):f(h)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class C extends T{constructor(b){super();this.adapterServer=b}createConnection(b){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=C;class m extends T{constructor(b){super();this.adapterServer=b}createConnection(b){return A.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=m;class v extends D{constructor(b,f,l){super();this.adapterExecutable=b,this.debugType=f,this.outputService=l}async startSession(){const b=this.adapterExecutable.command,f=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(b)if(k.isAbsolute(b)){if(!await d.Promises.exists(b))throw new Error(_.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(_.localize(1,null,this.debugType));let h=process.env;if(l.env&&Object.keys(l.env).length>0&&(h=w.mixin(w.deepClone(process.env),l.env)),b==="node")if(Array.isArray(f)&&f.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:h,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(r.cwd=l.cwd);const s=i.fork(f[0],f.slice(1),r);if(!s.pid)throw new Error(_.localize(2,null,f[0]));this.serverProcess=s}else throw new Error(_.localize(3,null));else{const E={env:h};l.cwd&&(E.cwd=l.cwd),this.serverProcess=i.spawn(b,f,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,r)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const o=this.outputService;if(o){const E=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const s=o.getChannel(L.ExtensionsChannelId);s&&s.append(E(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(h){this._onError.fire(h)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((b,f)=>{const l=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(h,o,E){if(h)return f(h)});l.on("exit",b),l.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,f){if(!b)return;const l=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?l.runtime=k.join(f,b.runtime):l.runtime=b.runtime),b.runtimeArgs&&(l.runtimeArgs=b.runtimeArgs),b.program&&(k.isAbsolute(b.program)?l.program=b.program:l.program=k.join(f,b.program)),b.args&&(l.args=b.args);const h=b;return h.win&&(l.win=v.extract(h.win,f)),h.winx86&&(l.winx86=v.extract(h.winx86,f)),h.windows&&(l.windows=v.extract(h.windows,f)),h.osx&&(l.osx=v.extract(h.osx,f)),h.linux&&(l.linux=v.extract(h.linux,f)),l}static platformAdapterExecutable(b,f){let l=Object.create(null);f=f.toLowerCase();for(const n of b)if(n.contributes){const t=n.contributes.debuggers;t&&t.length>0&&t.filter(a=>typeof a.type=="string"&&y.equalsIgnoreCase(a.type,f)).forEach(a=>{const c=v.extract(a,n.extensionLocation.fsPath);l=w.mixin(l,c,n.isBuiltin)})}let h;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=l.winx86||l.win||l.windows:P.isWindows?h=l.win||l.windows:P.isMacintosh?h=l.osx:P.isLinux&&(h=l.linux),h=h||l;const o=h.program||l.program,E=h.args||l.args,r=h.runtime||l.runtime,s=h.runtimeArgs||l.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(E||[])};if(o)return{type:"executable",command:o,args:E||[]}}}e.ExecutableDebugAdapter=v}),define(ye[216],De([0,1,41,30,12]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(P,L){return new Promise((I,D)=>{let T="";const C=d.spawn(P,L);C.pid&&C.stdout.on("data",m=>{T+=m.toString()}),C.on("error",m=>{D(m)}),C.on("close",m=>{I(T)})})}async function k(P){if(P)if(_.isWindows){const L=await new Promise((I,D)=>{Y(["windows-process-tree"],I,D)});return new Promise(I=>{L.getProcessTree(P,D=>{I(!!D&&D.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(P)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=k;var y;(function(P){P[P.cmd=0]="cmd",P[P.powershell=1]="powershell",P[P.bash=2]="bash"})(y||(y={}));function w(P,L,I,D){P=P.trim().toLowerCase();let T;P.indexOf("powershell")>=0||P.indexOf("pwsh")>=0?T=1:P.indexOf("cmd.exe")>=0?T=0:P.indexOf("bash")>=0?T=2:_.isWindows?T=0:T=2;let C,m=" ";switch(T){case 1:if(C=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),I){const v=(0,i.getDriveLetter)(I);v&&(m+=`${v}:; `),m+=`cd ${C(I)}; `}if(D)for(const v in D){const g=D[v];g===null?m+=`Remove-Item env:${v}; `:m+=`\${env:${v}}='${g}'; `}if(L.length>0){const v=C(L.shift());m+=v[0]==="'"?`& ${v} `:`${v} `;for(const g of L)m+=g==="<"||g===">"?g:C(g),m+=" "}break;case 0:if(C=v=>(v=v.replace(/\"/g,'""'),v=v.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>v.includes(g))||v.length===0?`"${v}"`:v),I){const v=(0,i.getDriveLetter)(I);v&&(m+=`${v}: && `),m+=`cd ${C(I)} && `}if(D){m+='cmd /C "';for(const v in D){let g=D[v];g===null?m+=`set "${v}=" && `:(g=g.replace(/[&^|<>]/g,b=>`^${b}`),m+=`set "${v}=${g}" && `)}}for(const v of L)m+=v==="<"||v===">"?v:C(v),m+=" ";D&&(m+='"');break;case 2:{C=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;])/g,"\\$1"),g.length===0?'""':g);const v=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(I&&(m+=`cd ${C(I)} ; `),D){m+="/usr/bin/env";for(const g in D){const b=D[g];b===null?m+=` -u ${v(g)}`:m+=` ${v(`${g}=${b}`)}`}m+=" "}for(const g of L)m+=g==="<"||g===">"?g:C(g),m+=" ";break}}return m}e.prepareCommand=w}),define(ye[128],De([0,1,35,79,94,10,9,12,63]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var D;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(D=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var T;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(T=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var C;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var g;(function(n){n.scheme=A.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function a(N,p){return N.with({scheme:n.scheme,fragment:`ch${p.toString().padStart(7,"0")}${N.scheme!==A.Schemas.file?N.scheme:""}`})}n.generate=a;function c(N){if(N.scheme!==n.scheme)return;const p=t.exec(N.fragment);return p?{handle:Number(p[1]),notebook:N.with({scheme:N.fragment.substring(p[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parse=c;function u(N,p){return N.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${p??""},${N.scheme!==A.Schemas.file?N.scheme:""}`})}n.generateCellOutputUri=u;function S(N){if(N.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const p=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!p)return;const M=p[1]&&p[1]!==""?p[1]:void 0,U=p[2];return{outputId:M,notebook:N.with({scheme:U||A.Schemas.file,fragment:null})}}n.parseCellOutputUri=S;function R(N,p,M){return N.with({scheme:M,fragment:`ch${p.toString().padStart(7,"0")}${N.scheme!==A.Schemas.file?N.scheme:""}`})}n.generateCellUri=R;function O(N,p){if(N.scheme!==p)return;const M=t.exec(N.fragment);return M?{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substring(M[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parseCellUri=O})(g=e.CellUri||(e.CellUri={}));const b=n=>y.isWindows?n.replace(/\//g,"\\"):n;class f{constructor(t=[],a=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=a,this.order=[...new Set(t)].map(c=>({pattern:c,matches:d.parse(b(c))}))}sort(t){const a=new Map(i.Iterable.map(t,u=>[u,b(u)]));let c=[];for(const{matches:u}of this.order)for(const[S,R]of a)if(u(R)){c.push(S),a.delete(S);break}return a.size&&(c=c.concat([...a.keys()].sort((u,S)=>this.defaultOrder.indexOf(u)-this.defaultOrder.indexOf(S)))),c}prioritize(t,a){const c=this.findIndex(t);if(c===-1){this.order.unshift({pattern:t,matches:d.parse(b(t))});return}const u=new Set(a.map(R=>this.findIndex(R,c)));u.delete(-1);const S=Array.from(u).sort();this.order.splice(c+1,0,...S.map(R=>this.order[R]));for(let R=S.length-1;R>=0;R--)this.order.splice(S[R],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,a=this.order.length){const c=b(t);for(let u=0;u<a;u++)if(this.order[u].matches(c))return u;return-1}}e.MimeTypeDisplayOrder=f;function l(n,t,a,c=(u,S)=>u===S){const u=[];function S(N,p,M){if(p===0&&M.length===0)return;const U=u[u.length-1];U&&U.start+U.deleteCount===N?(U.deleteCount+=p,U.toInsert.push(...M)):u.push({start:N,deleteCount:p,toInsert:M})}let R=0,O=0;for(;;){if(R===n.length){S(R,0,t.slice(O));break}if(O===t.length){S(R,n.length-R,[]);break}const N=n[R],p=t[O];if(c(N,p)){R+=1,O+=1;continue}a(p)?(S(R,1,[]),R+=1):(S(R,0,[p]),O+=1)}return u}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtBoundary","none");var h;(function(n){n.default="default",n.option="option"})(h=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(n){const t=n;return!!((typeof t.include=="string"||d.isRelativePattern(t.include))&&(typeof t.exclude=="string"||d.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=o;function E(n,t,a){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const c=o(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,u=o(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(d.match(c,(0,k.basename)(a.fsPath).toLowerCase()))return!(u&&d.match(u,(0,k.basename)(a.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=E,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(ye[217],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(ye[218],De([0,1,184,4,63]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[219],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=d;function i(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=i}),define(ye[65],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class _{constructor(k,y=k.length){if(this.path=k,this.viewEnd=y,k.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,y,w=k.parent){if(k.id===y)return new _([y]);let P=[k.id];for(let L=w;L&&L.id!==y;L=L.parent)P.push(L.id);return P.push(y),new _(P.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const y=k.indexOf("\0");return y===-1?k:k.slice(0,y)}static fromString(k){return new _(k.split("\0"))}static join(k,y){return new _([...k.path,y])}static joinToString(k,y){return k.toString()+"\0"+y}static compare(k,y){return k===y?0:y.startsWith(k+"\0")?2:k.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new _(this.path,k)}compare(k){if(typeof k=="string")return _.compare(this.toString(),k);for(let y=0;y<k.viewEnd&&y<this.viewEnd;y++)if(k.path[y]!==this.path[y])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=_}),define(ye[66],De([0,1,2,37]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var _;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(_=e.TestResultState||(e.TestResultState={}));var A;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:i.Range.lift(t.range),uri:d.URI.revive(t.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var y;(function(n){n[n.Error=0]="Error",n[n.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var w;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&k.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&k.deserialize(t.location)})})(w=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&k.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&k.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(n){n.serialize=t=>t.type===0?w.serialize(t):P.serialize(t),n.deserialize=t=>t.type===0?w.deserialize(t):P.deserialize(t)})(L=e.ITestMessage||(e.ITestMessage={}));var I;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const D="\0",T=(n,t)=>n+D+t;e.namespaceTestTag=T;const C=n=>{const t=n.indexOf(D);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=C;var m;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?d.URI.revive(t.uri):void 0,range:t.range?i.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(m=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:m.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:m.deserialize(t.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(n){n.serialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.uri!==void 0&&(a.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(a.range=t.item.range?.toJSON()),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}},n.deserialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.range!==void 0&&(a.range=t.item.range?i.Range.lift(t.item.range):null),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=f;var l;(function(n){n.serialize=(t,a)=>({...g.serialize(t),children:a,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(I.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var h;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(h=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var E;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:g.deserialize(t.item)}:t.op===1?{op:t.op,item:b.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:g.serialize(t.item)}:t.op===1?{op:t.op,item:b.serialize(t.item)}:t})(E=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,a){}complete(){}}e.IncrementalChangeCollector=r;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const a=this.createChangeCollector();for(const c of t)switch(c.op){case 0:{const u=g.deserialize(c.item);if(u.parent){if(this.items.has(u.parent)){const S=this.items.get(u.parent);S.children.add(u.item.extId);const R=this.createItem(u,S);this.items.set(u.item.extId,R),a.add(R)}}else{const S=this.createItem(u);this.roots.add(S),this.items.set(u.item.extId,S),a.add(S)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=b.deserialize(c.item),S=this.items.get(u.extId);if(!S)break;u.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,u),a.update(S);break}case 2:{const u=this.items.get(c.itemId);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const S=[[c.itemId]];for(;S.length;)for(const R of S.pop()){const O=this.items.get(R);O&&(S.push(O.children),this.items.delete(R),a.remove(O,O!==u),O.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c.itemId);break;case 3:this.updatePendingRoots(c.amount);break;case 5:this._tags.set(c.tag.id,c.tag);break;case 6:this._tags.delete(c.id);break}a.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=s}),define(ye[88],De([0,1,17,3,6,14,66,65]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(g,b)=>g===b,L={range:(g,b)=>g===b?!0:!g||!b?!1:g.equalsRange(b),busy:P,label:P,description:P,error:P,tags:(g,b)=>!(g.length!==b.length||g.some(f=>!b.includes(f)))},I=(g,b)=>{let f;for(const[l,h]of Object.entries(L))h(g[l],b[l])||(f?f[l]=b[l]:f={[l]:b[l]});return f};class D extends _.Disposable{constructor(b){super();this.options=b,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(b){this._resolveHandler=b;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){const f=this.diff[this.diff.length-1];if(f&&b.op===1){if(f.op===1&&f.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(f.item,b.item);return}if(f.op===0&&f.item.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(f.item,b.item);return}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,f){const l=this.tree.get(b);if(!!l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const h=this.resolveChildren(l);return h.isOpen()?this.expandChildren(l,f-1):h.wait().then(()=>this.expandChildren(l,f-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,f-1)):this.expandChildren(l,f-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,f){switch(f.op){case 3:this.removeItem(y.TestId.joinToString(b.fullId,f.id));break;case 0:this.upsertItem(f.item,b);break;case 5:for(const l of f.ops)this.onTestItemEvent(b,l);break;case 1:this.diffTagRefs(f.new,f.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:f.update}});break;default:(0,A.assertNever)(f)}}upsertItem(b,f){const l=y.TestId.fromExtHostTestItem(b,this.root.id,f?.actual),h=this.options.getApiFor(b);h.parent&&h.parent!==f?.actual&&this.options.getChildren(h.parent).delete(b.id);let o=this.tree.get(l.toString());if(!o){o={fullId:l,actual:b,parent:f?l.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(b,f),this.pushDiff({op:0,item:{parent:o.parent&&o.parent.toString(),controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,o,f);return}if(o.actual===b){this.connectItem(b,o,f);return}const E=this.options.getChildren(o.actual),r=o.actual,s=I(this.options.toITestItem(r),this.options.toITestItem(b));this.options.getApiFor(r).listener=void 0,o.actual=b,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,r.tags,l.toString()),delete s.tags),this.onTestItemEvent(o,{op:4,update:s})),this.connectItemAndChildren(b,o,f);for(const n of E)this.options.getChildren(b).get(n.id)||this.removeItem(y.TestId.joinToString(l,n.id))}diffTagRefs(b,f,l){const h=new Set(f.map(o=>o.id));for(const o of b)h.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:l,item:{tags:b.map(o=>(0,k.namespaceTestTag)(this.options.controllerId,o.id))}}}),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const f=this.tags.get(b.id);f?f.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const f=this.tags.get(b);f&&!--f.refCount&&(this.tags.delete(b),this.pushDiff({op:6,id:(0,k.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,f){this.options.getApiFor(b).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(b,f,l){this.setItemParent(b,l);const h=this.options.getApiFor(b);h.parent=l?.actual,h.listener=o=>this.onTestItemEvent(f,o),this.updateExpandability(f)}connectItemAndChildren(b,f,l){this.connectItem(b,f,l);for(const h of this.options.getChildren(b))this.upsertItem(h,f)}updateExpandability(b){let f;this._resolveHandler?b.resolveBarrier?f=b.resolveBarrier.isOpen()?3:2:f=b.actual.canResolveChildren?1:0:f=0,f!==b.expand&&(b.expand=f,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:f}}),f===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,f){if(f<0)return;const l=[];for(const h of this.options.getChildren(b.actual)){const o=this.expand(y.TestId.joinToString(b.fullId,h.id),f);(0,d.isThenable)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const o=new d.Barrier;return o.open(),o}b.expand=2,this.pushExpandStateUpdate(b);const f=b.resolveBarrier=new d.Barrier,l=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let h;try{h=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(o){l(o)}return(0,d.isThenable)(h)?h.catch(l).then(()=>{f.open(),this.updateExpandability(b)}):(f.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const f=this.tree.get(b);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:b});const l=[f];for(;l.length;){const h=l.pop();if(!!h){this.options.getApiFor(h.actual).listener=void 0;for(const o of h.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(h.fullId.toString());for(const o of this.options.getChildren(h.actual))l.push(this.tree.get(y.TestId.joinToString(h.fullId,o.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=D;class T extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=T;class C extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=C;class m extends Error{constructor(b,f,l){super(`TestItem with ID "${b}" is from controller "${f}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=m;const v=(g,b,f)=>{let l=new Map;return{get size(){return l.size},forEach(h,o){for(const E of l.values())h.call(o,E,this)},replace(h){const o=new Map,E=new Set(l.keys()),r={op:5,ops:[]};for(const s of h){if(!(s instanceof f))throw new C(s.id);const n=b(s).controllerId;if(n!==g.controllerId)throw new m(s.id,n,g.controllerId);if(o.has(s.id))throw new T(s.id);o.set(s.id,s),E.delete(s.id),r.ops.push({op:0,item:s})}for(const s of E.keys())r.ops.push({op:3,id:s});g.listener?.(r),l=o},add(h){if(!(h instanceof f))throw new C(h.id);l.set(h.id,h),g.listener?.({op:0,item:h})},delete(h){l.delete(h)&&g.listener?.({op:3,id:h})},get(h){return l.get(h)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};e.createTestItemChildren=v}),define(ye[129],De([0,1,88]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const i=new WeakMap,_=(k,y)=>{const w={controllerId:y};return i.set(k,w),w};e.createPrivateApiFor=_;const A=k=>{const y=i.get(k);if(!y)throw new d.InvalidTestItemError(k?.id||"<unknown>");return y};e.getPrivateApiFor=A}),define(ye[220],De([0,1,9,34,14,26,12,102,185,8]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(D,T,C,m){this._contributedVariables=new Map,this._context=D,this._labelService=T,this._userHomePromise=C,m&&(this._envVariablesPromise=m.then(v=>this.prepareEnv(v)))}prepareEnv(D){if(k.isWindows){const T=Object.create(null);return Object.keys(D).forEach(C=>{T[C.toLowerCase()]=D[C]}),T}return D}resolveWithEnvironment(D,T,C){return this.recursiveResolve({env:this.prepareEnv(D),userHome:void 0},T?T.uri:void 0,C)}async resolveAsync(D,T){const C={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(C,D?D.uri:void 0,T)}async resolveAnyBase(D,T,C,m){const v=A.deepClone(T);k.isWindows&&v.windows?Object.keys(v.windows).forEach(b=>v[b]=v.windows[b]):k.isMacintosh&&v.osx?Object.keys(v.osx).forEach(b=>v[b]=v.osx[b]):k.isLinux&&v.linux&&Object.keys(v.linux).forEach(b=>v[b]=v.linux[b]),delete v.windows,delete v.osx,delete v.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,D?D.uri:void 0,v,C,m)}async resolveAnyAsync(D,T,C){return this.resolveAnyBase(D,T,C)}async resolveAnyMap(D,T,C){const m=new Map;return{newConfig:await this.resolveAnyBase(D,T,C,m),resolvedVariables:m}}resolveWithInteractionReplace(D,T,C,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,T,C,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,T){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,T)}async recursiveResolve(D,T,C,m,v){if(_.isString(C))return this.resolveString(D,T,C,m,v);if(_.isArray(C))return Promise.all(C.map(g=>this.recursiveResolve(D,T,g,m,v)));if(_.isObject(C)){let g=Object.create(null);const b=await Promise.all(Object.keys(C).map(async f=>[await this.resolveString(D,T,f,m,v),await this.recursiveResolve(D,T,C[f],m,v)]));for(const[f,l]of b)g[f]=l;return g}return C}resolveString(D,T,C,m,v){return(0,P.replaceAsync)(C,L.VARIABLE_REGEXP,async(g,b)=>{if(b.includes(L.VARIABLE_LHS))return g;let f=await this.evaluateSingleVariable(D,g,b,T,m);return v&&v.set(b,f),f!==g&&_.isString(f)&&f.match(L.VARIABLE_REGEXP)&&(f=await this.resolveString(D,T,f,m,v)),f})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}async evaluateSingleVariable(D,T,C,m,v){let g;const b=C.split(":");b.length>1&&(C=b[0],g=b[1]);const f=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error((0,w.localize)(0,null,T))},l=()=>{const o=f();if(this._context.getWorkspaceFolderPathForFile){const E=this._context.getWorkspaceFolderPathForFile();if(E)return E}throw new Error((0,w.localize)(1,null,T,d.basename(o)))},h=()=>{if(g){const o=this._context.getFolderUri(g);if(o)return o;throw new Error((0,w.localize)(2,null,T,g))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new Error((0,w.localize)(3,null,T)):new Error((0,w.localize)(4,null,T))};switch(C){case"env":if(g){if(D.env){const o=D.env[k.isWindows?g.toLowerCase():g];if(_.isString(o))return o}return""}throw new Error((0,w.localize)(5,null,T));case"config":if(g){const o=this._context.getConfigurationValue(m,g);if(_.isUndefinedOrNull(o))throw new Error((0,w.localize)(6,null,T,g));if(_.isObject(o))throw new Error((0,w.localize)(7,null,T,g));return o}throw new Error((0,w.localize)(8,null,T));case"command":return this.resolveFromMap(T,g,v,"command");case"input":return this.resolveFromMap(T,g,v,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new Error((0,w.localize)(9,null,T,g));return this.fsPath(o.extensionLocation)}throw new Error((0,w.localize)(10,null,T));default:switch(C){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return m||g?(0,y.normalizeDriveLetter)(this.fsPath(h())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(h()));case"userHome":{if(D.userHome)return D.userHome;throw new Error((0,w.localize)(11,null,T))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new Error((0,w.localize)(12,null,T))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new Error((0,w.localize)(13,null,T))}case"file":return f();case"fileWorkspaceFolder":return l();case"relativeFile":return m||g?d.relative(this.fsPath(h()),f()):f();case"relativeFileDirname":{const o=d.dirname(f());if(m||g){const E=d.relative(this.fsPath(h()),o);return E.length===0?".":E}return o}case"fileDirname":return d.dirname(f());case"fileExtname":return d.extname(f());case"fileBasename":return d.basename(f());case"fileBasenameNoExtension":{const o=d.basename(f());return o.slice(0,o.length-d.extname(o).length)}case"fileDirnameBasename":return d.basename(d.dirname(f()));case"execPath":{const o=this._context.getExecPath();return o||T}case"execInstallFolder":{const o=this._context.getAppRoot();return o||T}case"pathSeparator":return d.sep;default:try{const o=g?`${C}:${g}`:C;return this.resolveFromMap(T,o,v,void 0)}catch{return T}}}}resolveFromMap(D,T,C,m){if(T&&C){const v=m===void 0?C[T]:C[m+":"+T];if(typeof v=="string")return v;throw new Error((0,w.localize)(14,null,D))}return D}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[130],De([0,1,4,211]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var _;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var y;(function(C){C[C.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function P(C){const m=C;return(0,i.isEditorInput)(m?.editor)&&(0,i.isEditorInput)(m?.replacement)}e.isEditorReplacement=P;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function D(C){const m=C;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=D;function T(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(ye[221],De([0,1,4,130]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const k=A;return typeof A=="number"||(0,i.isEditorGroup)(k)}e.isPreferredGroup=_}),define(ye[15],De([0,1,16,23,101,24,145,60,26,14,2,37,62,187,116,129,128,65,66,221,7]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Pe){function Le(Z){const{selectionStartLineNumber:Me,selectionStartColumn:Ve,positionLineNumber:st,positionColumn:Ye}=Z,lt=new l.Position(Me-1,Ve-1),dt=new l.Position(st-1,Ye-1);return new l.Selection(lt,dt)}Pe.to=Le;function Ee(Z){const{anchor:Me,active:Ve}=Z;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Pe.from=Ee})(h=e.Selection||(e.Selection={}));var o;(function(Pe){function Le(Z){if(!Z)return;const{start:Me,end:Ve}=Z;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Pe.from=Le;function Ee(Z){if(!Z)return;const{startLineNumber:Me,startColumn:Ve,endLineNumber:st,endColumn:Ye}=Z;return new l.Range(Me-1,Ve-1,st-1,Ye-1)}Pe.to=Ee})(o=e.Range||(e.Range={}));var E;(function(Pe){function Le(Ee){switch(Ee){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Pe.to=Le})(E=e.TokenType||(e.TokenType={}));var r;(function(Pe){function Le(Z){return new l.Position(Z.lineNumber-1,Z.column-1)}Pe.to=Le;function Ee(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Pe.from=Ee})(r=e.Position||(e.Position={}));var s;(function(Pe){function Le(Me,Ve){return(0,d.coalesce)((0,d.asArray)(Me).map(st=>Ee(st,Ve)))}Pe.from=Le;function Ee(Me,Ve){if(typeof Me=="string")return{$serialized:!0,language:Me};if(Me)return{$serialized:!0,language:Me.language,scheme:Z(Me.scheme,Ve),pattern:_e.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType}}function Z(Me,Ve){return Ve&&typeof Me=="string"?Ve.transformOutgoingScheme(Me):Me}})(s=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Pe){function Le(Z){switch(Z){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function Ee(Z){switch(Z){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Pe.to=Ee})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(Pe){function Le(Z){let Me;return Z.code&&((0,P.isString)(Z.code)||(0,P.isNumber)(Z.code)?Me=String(Z.code):Me={value:String(Z.code.value),target:Z.code.target}),{...o.from(Z.range),message:Z.message,source:Z.source,code:Me,severity:c.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(a.from),tags:Array.isArray(Z.tags)?(0,d.coalesce)(Z.tags.map(n.from)):void 0}}Pe.from=Le;function Ee(Z){const Me=new l.Diagnostic(o.to(Z),Z.message,c.to(Z.severity));return Me.source=Z.source,Me.code=(0,P.isString)(Z.code)?Z.code:Z.code?.value,Me.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(a.to),Me.tags=Z.tags&&(0,d.coalesce)(Z.tags.map(n.to)),Me}Pe.to=Ee})(t=e.Diagnostic||(e.Diagnostic={}));var a;(function(Pe){function Le(Z){return{...o.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Pe.from=Le;function Ee(Z){return new l.DiagnosticRelatedInformation(new l.Location(Z.resource,o.to(Z)),Z.message)}Pe.to=Ee})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(Pe){function Le(Z){switch(Z){case l.DiagnosticSeverity.Error:return C.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return C.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return C.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return C.MarkerSeverity.Hint}return C.MarkerSeverity.Error}Pe.from=Le;function Ee(Z){switch(Z){case C.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case C.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case C.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case C.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Pe.to=Ee})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(Pe){function Le(Z){return typeof Z=="number"&&Z>=l.ViewColumn.One?Z-1:Z===l.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Pe.from=Le;function Ee(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=Ee})(u=e.ViewColumn||(e.ViewColumn={}));function S(Pe){return typeof Pe.range!="undefined"}function R(Pe){return Pe.length===0?!0:!!S(Pe[0])}e.isDecorationOptionsArr=R;var O;(function(Pe){function Le(Ye){return Ye.map(Pe.from)}Pe.fromMany=Le;function Ee(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function Z(Ye){let lt;if(Ee(Ye)){const{language:mt,value:wt}=Ye;lt={value:"```"+mt+`
`+wt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ye)?lt={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?lt={value:Ye}:lt={value:""};const dt=Object.create(null);lt.uris=dt;const vt=mt=>{try{let wt=L.URI.parse(mt,!0);wt=wt.with({query:Me(wt.query,dt)}),dt[mt]=wt}catch{}return""},_t=new k.marked.Renderer;return _t.link=vt,_t.image=mt=>typeof mt=="string"?vt(_.parseHrefAndDimensions(mt).href):"",(0,k.marked)(lt.value,{renderer:_t}),lt}Pe.from=Z;function Me(Ye,lt){if(!Ye)return Ye;let dt;try{dt=(0,y.parse)(Ye)}catch{}if(!dt)return Ye;let vt=!1;return dt=(0,w.cloneAndChange)(dt,_t=>{if(L.URI.isUri(_t)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[mt]=_t,vt=!0,mt}else return}),vt?JSON.stringify(dt):Ye}function Ve(Ye){const lt=new l.MarkdownString(Ye.value,Ye.supportThemeIcons);return lt.isTrusted=Ye.isTrusted,lt.supportHtml=Ye.supportHtml,lt.baseUri=Ye.baseUri?L.URI.from(Ye.baseUri):void 0,lt}Pe.to=Ve;function st(Ye){if(!!Ye)return typeof Ye=="string"?Ye:Pe.from(Ye)}Pe.fromStrict=st})(O=e.MarkdownString||(e.MarkdownString={}));function N(Pe){return R(Pe)?Pe.map(Le=>({range:o.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?O.fromMany(Le.hoverMessage):Le.hoverMessage?O.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:o.from(Le)}))}e.fromRangeOrRangeWithMessage=N;function p(Pe){return typeof Pe=="undefined"?Pe:typeof Pe=="string"?L.URI.file(Pe):Pe}e.pathOrURIToURI=p;var M;(function(Pe){function Le(Ee){return typeof Ee=="undefined"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?p(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Pe.from=Le})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Pe){function Le(Ee){return typeof Ee=="undefined"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?p(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?M.from(Ee.before):void 0,after:Ee.after?M.from(Ee.after):void 0}}Pe.from=Le})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Pe){function Le(Ee){if(typeof Ee=="undefined")return Ee;switch(Ee){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var re;(function(Pe){function Le(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?z.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?U.from(Ee.light):void 0,dark:Ee.dark?U.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?p(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?M.from(Ee.before):void 0,after:Ee.after?M.from(Ee.after):void 0}}Pe.from=Le})(re=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(Pe){function Le(Z){return{text:Z.newText,eol:Z.newEol&&Xe.from(Z.newEol),range:o.from(Z.range)}}Pe.from=Le;function Ee(Z){const Me=new l.TextEdit(o.to(Z.range),Z.text);return Me.newEol=typeof Z.eol=="undefined"?void 0:Xe.to(Z.eol),Me}Pe.to=Ee})(H=e.TextEdit||(e.TextEdit={}));var F;(function(Pe){function Le(Ee){return{range:o.from(Ee.range),snippet:Ee.snippet.value}}Pe.from=Le})(F=e.SnippetTextEdit||(e.SnippetTextEdit={}));var j;(function(Pe){function Le(Z,Me){const Ve={edits:[]};if(Z instanceof l.WorkspaceEdit){const st=new A.ResourceSet;for(const Ye of Z._allEntries())Ye._type===1&&L.URI.isUri(Ye.to)&&Ye.from===void 0&&st.add(Ye.to);for(const Ye of Z._allEntries())Ye._type===1?Ve.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata}):Ye._type===2?Ve.edits.push({_type:2,resource:Ye.uri,edit:H.from(Ye.edit),modelVersionId:st.has(Ye.uri)?void 0:Me?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===3?Ve.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ye.uri)}):Ye._type===5&&Ve.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ye.uri),edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(rt.from)}})}return Ve}Pe.from=Le;function Ee(Z){const Me=new l.WorkspaceEdit;for(const Ve of Z.edits)Ve.edit?Me.replace(L.URI.revive(Ve.resource),o.to(Ve.edit.range),Ve.edit.text):Me.renameFile(L.URI.revive(Ve.oldUri),L.URI.revive(Ve.newUri),Ve.options);return Me}Pe.to=Ee})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(Pe){const Le=Object.create(null);Le[l.SymbolKind.File]=0,Le[l.SymbolKind.Module]=1,Le[l.SymbolKind.Namespace]=2,Le[l.SymbolKind.Package]=3,Le[l.SymbolKind.Class]=4,Le[l.SymbolKind.Method]=5,Le[l.SymbolKind.Property]=6,Le[l.SymbolKind.Field]=7,Le[l.SymbolKind.Constructor]=8,Le[l.SymbolKind.Enum]=9,Le[l.SymbolKind.Interface]=10,Le[l.SymbolKind.Function]=11,Le[l.SymbolKind.Variable]=12,Le[l.SymbolKind.Constant]=13,Le[l.SymbolKind.String]=14,Le[l.SymbolKind.Number]=15,Le[l.SymbolKind.Boolean]=16,Le[l.SymbolKind.Array]=17,Le[l.SymbolKind.Object]=18,Le[l.SymbolKind.Key]=19,Le[l.SymbolKind.Null]=20,Le[l.SymbolKind.EnumMember]=21,Le[l.SymbolKind.Struct]=22,Le[l.SymbolKind.Event]=23,Le[l.SymbolKind.Operator]=24,Le[l.SymbolKind.TypeParameter]=25;function Ee(Me){return typeof Le[Me]=="number"?Le[Me]:6}Pe.from=Ee;function Z(Me){for(const Ve in Le)if(Le[Ve]===Me)return Number(Ve);return l.SymbolKind.Property}Pe.to=Z})(x=e.SymbolKind||(e.SymbolKind={}));var V;(function(Pe){function Le(Z){switch(Z){case l.SymbolTag.Deprecated:return 1}}Pe.from=Le;function Ee(Z){switch(Z){case 1:return l.SymbolTag.Deprecated}}Pe.to=Ee})(V=e.SymbolTag||(e.SymbolTag={}));var ne;(function(Pe){function Le(Z){return{name:Z.name,kind:x.from(Z.kind),tags:Z.tags&&Z.tags.map(V.from),containerName:Z.containerName,location:X.from(Z.location)}}Pe.from=Le;function Ee(Z){const Me=new l.SymbolInformation(Z.name,x.to(Z.kind),Z.containerName,X.to(Z.location));return Me.tags=Z.tags&&Z.tags.map(V.to),Me}Pe.to=Ee})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Pe){function Le(Z){const Me={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:o.from(Z.range),selectionRange:o.from(Z.selectionRange),kind:x.from(Z.kind),tags:Z.tags?.map(V.from)??[]};return Z.children&&(Me.children=Z.children.map(Le)),Me}Pe.from=Le;function Ee(Z){const Me=new l.DocumentSymbol(Z.name,Z.detail,x.to(Z.kind),o.to(Z.range),o.to(Z.selectionRange));return(0,d.isNonEmptyArray)(Z.tags)&&(Me.tags=Z.tags.map(V.to)),Z.children&&(Me.children=Z.children.map(Ee)),Me}Pe.to=Ee})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var he;(function(Pe){function Le(Z){const Me=new l.CallHierarchyItem(x.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),o.to(Z.range),o.to(Z.selectionRange));return Me._sessionId=Z._sessionId,Me._itemId=Z._itemId,Me}Pe.to=Le;function Ee(Z,Me,Ve){if(Me=Me??Z._sessionId,Ve=Ve??Z._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,name:Z.name,detail:Z.detail,kind:x.from(Z.kind),uri:Z.uri,range:o.from(Z.range),selectionRange:o.from(Z.selectionRange),tags:Z.tags?.map(V.from)}}Pe.from=Ee})(he=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(Pe){function Le(Ee){return new l.CallHierarchyIncomingCall(he.to(Ee.from),Ee.fromRanges.map(Z=>o.to(Z)))}Pe.to=Le})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(Pe){function Le(Ee){return new l.CallHierarchyOutgoingCall(he.to(Ee.to),Ee.fromRanges.map(Z=>o.to(Z)))}Pe.to=Le})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var X;(function(Pe){function Le(Z){return{range:Z.range&&o.from(Z.range),uri:Z.uri}}Pe.from=Le;function Ee(Z){return new l.Location(L.URI.revive(Z.uri),o.to(Z.range))}Pe.to=Ee})(X=e.location||(e.location={}));var ce;(function(Pe){function Le(Z){const Me=Z,Ve=Z;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ve.uri,range:o.from(Me.targetRange?Me.targetRange:Ve.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Pe.from=Le;function Ee(Z){return{targetUri:L.URI.revive(Z.uri),targetRange:o.to(Z.range),targetSelectionRange:Z.targetSelectionRange?o.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?o.to(Z.originSelectionRange):void 0}}Pe.to=Ee})(ce=e.DefinitionLink||(e.DefinitionLink={}));var pe;(function(Pe){function Le(Z){return{range:o.from(Z.range),contents:O.fromMany(Z.contents)}}Pe.from=Le;function Ee(Z){return new l.Hover(Z.contents.map(O.to),o.to(Z.range))}Pe.to=Ee})(pe=e.Hover||(e.Hover={}));var Ie;(function(Pe){function Le(Z){return{range:o.from(Z.range),expression:Z.expression}}Pe.from=Le;function Ee(Z){return new l.EvaluatableExpression(o.to(Z.range),Z.expression)}Pe.to=Ee})(Ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(Pe){function Le(Z){if(Z instanceof l.InlineValueText)return{type:"text",range:o.from(Z.range),text:Z.text};if(Z instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function Ee(Z){switch(Z.type){case"text":return{range:o.to(Z.range),text:Z.text};case"variable":return{range:o.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:o.to(Z.range),expression:Z.expression}}}Pe.to=Ee})(Re=e.InlineValue||(e.InlineValue={}));var Ce;(function(Pe){function Le(Z){return{frameId:Z.frameId,stoppedLocation:o.from(Z.stoppedLocation)}}Pe.from=Le;function Ee(Z){return new l.InlineValueContext(Z.frameId,o.to(Z.stoppedLocation))}Pe.to=Ee})(Ce=e.InlineValueContext||(e.InlineValueContext={}));var ke;(function(Pe){function Le(Z){return{range:o.from(Z.range),kind:Z.kind}}Pe.from=Le;function Ee(Z){return new l.DocumentHighlight(o.to(Z.range),Z.kind)}Pe.to=Ee})(ke=e.DocumentHighlight||(e.DocumentHighlight={}));var Ae;(function(Pe){function Le(Ee){switch(Ee){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Pe.to=Le})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ue;(function(Pe){function Le(Ee){return{triggerKind:Ae.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Pe.to=Le})(ue=e.CompletionContext||(e.CompletionContext={}));var ve;(function(Pe){function Le(Z){switch(Z){case l.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function Ee(Z){switch(Z){case 1:return l.CompletionItemTag.Deprecated}}Pe.to=Ee})(ve=e.CompletionItemTag||(e.CompletionItemTag={}));var ie;(function(Pe){const Le=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function Ee(Ve){return Le.get(Ve)??9}Pe.from=Ee;const Z=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Me(Ve){return Z.get(Ve)??l.CompletionItemKind.Property}Pe.to=Me})(ie=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(Pe){function Le(Ee,Z){const Me=new l.CompletionItem(Ee.label);return Me.insertText=Ee.insertText,Me.kind=ie.to(Ee.kind),Me.tags=Ee.tags?.map(ve.to),Me.detail=Ee.detail,Me.documentation=_.isMarkdownString(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Me.sortText=Ee.sortText,Me.filterText=Ee.filterText,Me.preselect=Ee.preselect,Me.commitCharacters=Ee.commitCharacters,I.Range.isIRange(Ee.range)?Me.range=o.to(Ee.range):typeof Ee.range=="object"&&(Me.range={inserting:o.to(Ee.range.insert),replacing:o.to(Ee.range.replace)}),Me.keepWhitespace=typeof Ee.insertTextRules=="undefined"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules!="undefined"&&Ee.insertTextRules&4?Me.insertText=new l.SnippetString(Ee.insertText):(Me.insertText=Ee.insertText,Me.textEdit=Me.range instanceof l.Range?new l.TextEdit(Me.range,Me.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Me.additionalTextEdits=Ee.additionalTextEdits.map(Ve=>H.to(Ve))),Me.command=Z&&Ee.command?Z.fromInternal(Ee.command):void 0,Me}Pe.to=Le})(oe=e.CompletionItem||(e.CompletionItem={}));var we;(function(Pe){function Le(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation)}}Pe.from=Le;function Ee(Z){return{label:Z.label,documentation:_.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation}}Pe.to=Ee})(we=e.ParameterInformation||(e.ParameterInformation={}));var Te;(function(Pe){function Le(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(we.from):[],activeParameter:Z.activeParameter}}Pe.from=Le;function Ee(Z){return{label:Z.label,documentation:_.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(we.to):[],activeParameter:Z.activeParameter}}Pe.to=Ee})(Te=e.SignatureInformation||(e.SignatureInformation={}));var B;(function(Pe){function Le(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(Te.from):[]}}Pe.from=Le;function Ee(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(Te.to):[]}}Pe.to=Ee})(B=e.SignatureHelp||(e.SignatureHelp={}));var q;(function(Pe){function Le(Ee,Z){const Me=new l.InlayHint(r.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(J.to.bind(void 0,Ee)),Z.kind&&te.to(Z.kind));return Me.textEdits=Z.textEdits&&Z.textEdits.map(H.to),Me.tooltip=_.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,Me.paddingLeft=Z.paddingLeft,Me.paddingRight=Z.paddingRight,Me}Pe.to=Le})(q=e.InlayHint||(e.InlayHint={}));var J;(function(Pe){function Le(Ee,Z){const Me=new l.InlayHintLabelPart(Z.label);return Me.tooltip=_.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,D.Command.is(Z.command)&&(Me.command=Ee.fromInternal(Z.command)),Z.location&&(Me.location=X.to(Z.location)),Me}Pe.to=Le})(J=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var te;(function(Pe){function Le(Z){return Z}Pe.from=Le;function Ee(Z){return Z}Pe.to=Ee})(te=e.InlayHintKind||(e.InlayHintKind={}));var K;(function(Pe){function Le(Z){return{range:o.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Pe.from=Le;function Ee(Z){let Me;if(Z.url)try{Me=typeof Z.url=="string"?L.URI.parse(Z.url,!0):L.URI.revive(Z.url)}catch{}return new l.DocumentLink(o.to(Z.range),Me)}Pe.to=Ee})(K=e.DocumentLink||(e.DocumentLink={}));var ae;(function(Pe){function Le(Z){const Me=new l.ColorPresentation(Z.label);return Z.textEdit&&(Me.textEdit=H.to(Z.textEdit)),Z.additionalTextEdits&&(Me.additionalTextEdits=Z.additionalTextEdits.map(Ve=>H.to(Ve))),Me}Pe.to=Le;function Ee(Z){return{label:Z.label,textEdit:Z.textEdit?H.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Me=>H.from(Me)):void 0}}Pe.from=Ee})(ae=e.ColorPresentation||(e.ColorPresentation={}));var de;(function(Pe){function Le(Z){return new l.Color(Z[0],Z[1],Z[2],Z[3])}Pe.to=Le;function Ee(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Pe.from=Ee})(de=e.Color||(e.Color={}));var Be;(function(Pe){function Le(Z){return{range:o.from(Z.range)}}Pe.from=Le;function Ee(Z){return new l.SelectionRange(o.to(Z.range))}Pe.to=Ee})(Be=e.SelectionRange||(e.SelectionRange={}));var $e;(function(Pe){function Le(Ee){switch(Ee){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Pe.to=Le})($e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(Pe){function Le(Z){switch(Z){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function Ee(Z){switch(Z){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Pe.to=Ee})(Ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Pe){function Le(Z){if(Z===l.EndOfLine.CRLF)return 1;if(Z===l.EndOfLine.LF)return 0}Pe.from=Le;function Ee(Z){if(Z===1)return l.EndOfLine.CRLF;if(Z===0)return l.EndOfLine.LF}Pe.to=Ee})(Xe=e.EndOfLine||(e.EndOfLine={}));var ee;(function(Pe){function Le(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(ee=e.ProgressLocation||(e.ProgressLocation={}));var se;(function(Pe){function Le(Ee){const Z={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(Z.kind=be.from(Ee.kind)),Z}Pe.from=Le})(se=e.FoldingRange||(e.FoldingRange={}));var be;(function(Pe){function Le(Ee){if(Ee)switch(Ee){case l.FoldingRangeKind.Comment:return D.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return D.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return D.FoldingRangeKind.Region}}Pe.from=Le})(be=e.FoldingRangeKind||(e.FoldingRangeKind={}));var le;(function(Pe){function Le(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?o.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?T.EditorResolution.DISABLED:void 0}}Pe.from=Le})(le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var _e;(function(Pe){function Le(Ve){return Ve instanceof l.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:Ee(Ve)||Z(Ve)?new l.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Pe.from=Le;function Ee(Ve){const st=Ve;return st?L.URI.isUri(st.baseUri)&&typeof st.pattern=="string":!1}function Z(Ve){const st=Ve;return st?typeof st.base=="string"&&typeof st.pattern=="string":!1}function Me(Ve){return typeof Ve=="string"?Ve:new l.RelativePattern(L.URI.revive(Ve.baseUri),Ve.pattern)}Pe.to=Me})(_e=e.GlobPattern||(e.GlobPattern={}));var Fe;(function(Pe){function Le(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Le);if(typeof Ee=="string")return Ee;{const Z=Ee;return{language:Z.language,scheme:Z.scheme,pattern:_e.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}Pe.from=Le})(Fe=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(Pe){function Le(Z){return{start:Z.start,end:Z.end}}Pe.from=Le;function Ee(Z){return new l.NotebookRange(Z.start,Z.end)}Pe.to=Ee})(He=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Pe){function Le(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Pe.to=Le;function Ee(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Pe.from=Ee})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ge;(function(Pe){function Le(Ee){if(Ee===v.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(Ee===v.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(Ee===v.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${Ee}`)}Pe.to=Le})(Ge=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(Pe){function Le(Z){switch(Z){case l.NotebookCellKind.Markup:return v.CellKind.Markup;case l.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Le;function Ee(Z){switch(Z){case v.CellKind.Markup:return l.NotebookCellKind.Markup;case v.CellKind.Code:default:return l.NotebookCellKind.Code}}Pe.to=Ee})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Qe;(function(Pe){function Le(Z){const Me={metadata:Z.metadata??Object.create(null),cells:[]};for(let Ve of Z.cells)l.NotebookCellData.validate(Ve),Me.cells.push(rt.from(Ve));return Me}Pe.from=Le;function Ee(Z){const Me=new l.NotebookData(Z.cells.map(rt.to));return(0,P.isEmptyObject)(Z.metadata)||(Me.metadata=Z.metadata),Me}Pe.to=Ee})(Qe=e.NotebookData||(e.NotebookData={}));var rt;(function(Pe){function Le(Z){return{cellKind:Ze.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:qe.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(pt.from):[]}}Pe.from=Le;function Ee(Z){return new l.NotebookCellData(Ze.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(pt.to):void 0,Z.metadata,Z.internalMetadata?qe.to(Z.internalMetadata):void 0)}Pe.to=Ee})(rt=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(Pe){function Le(Z){return{mime:Z.mime,valueBytes:i.VSBuffer.wrap(Z.data)}}Pe.from=Le;function Ee(Z){return new l.NotebookCellOutputItem(Z.valueBytes.buffer,Z.mime)}Pe.to=Ee})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var pt;(function(Pe){function Le(Z){return{outputId:Z.id,items:Z.items.map(tt.from),metadata:Z.metadata}}Pe.from=Le;function Ee(Z){const Me=Z.items.map(tt.to);return new l.NotebookCellOutput(Me,Z.outputId,Z.metadata)}Pe.to=Ee})(pt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var nt;(function(Pe){function Le(Me){return Z(Me)?{include:(0,P.withNullAsUndefined)(_e.from(Me.include)),exclude:(0,P.withNullAsUndefined)(_e.from(Me.exclude))}:(0,P.withNullAsUndefined)(_e.from(Me))}Pe.from=Le;function Ee(Me){return Z(Me)?{include:_e.to(Me.include),exclude:_e.to(Me.exclude)}:_e.to(Me)}Pe.to=Ee;function Z(Me){const Ve=Me;return Ve?!(0,P.isUndefinedOrNull)(Ve.include)&&!(0,P.isUndefinedOrNull)(Ve.exclude):!1}})(nt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Pe){function Le(Ee){return{backgroundColor:Ee.backgroundColor,borderColor:Ee.borderColor,top:Ee.top?M.from(Ee.top):void 0}}Pe.from=Le})(ut=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Pt;(function(Pe){function Le(Ee,Z,Me){const Ve=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Ve,Me),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Pe.from=Le})(Pt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Nt;(function(Pe){function Le(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{}}}Pe.from=Le})(Nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(Pe){function Le(Z){return{uri:Z.uri,provides:Z.provides}}Pe.from=Le;function Ee(Z){return new l.NotebookRendererScript(L.URI.revive(Z.uri),Z.provides)}Pe.to=Ee})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Le(Z){return{message:O.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,location:Z.location&&{range:o.from(Z.location.range),uri:Z.location.uri}}}Pe.from=Le;function Ee(Z){const Me=new l.TestMessage(typeof Z.message=="string"?Z.message:O.to(Z.message));return Me.actualOutput=Z.actual,Me.expectedOutput=Z.expected,Me.location=Z.location?X.to(Z.location):void 0,Me}Pe.to=Ee})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(Pe){Pe.namespace=b.namespaceTestTag,Pe.denamespace=b.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var At;(function(Pe){function Le(Z){const Me=(0,m.getPrivateApiFor)(Z).controllerId;return{extId:g.TestId.fromExtHostTestItem(Z,Me).toString(),label:Z.label,uri:L.URI.revive(Z.uri),busy:!1,tags:Z.tags.map(Ve=>Dt.namespace(Me,Ve.id)),range:I.Range.lift(o.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&O.fromStrict(Z.error)||null}}Pe.from=Le;function Ee(Z){return{parent:void 0,error:void 0,id:g.TestId.fromString(Z.extId).localId,label:Z.label,uri:L.URI.revive(Z.uri),tags:(Z.tags||[]).map(Me=>{const{tagId:Ve}=Dt.denamespace(Me);return new l.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:o.to(Z.range||void 0),canResolveChildren:!1,busy:!1,description:Z.description||void 0,sortText:Z.sortText||void 0}}Pe.toPlain=Ee})(At=e.TestItem||(e.TestItem={})),function(Pe){function Le(Z){return{id:Z.id}}Pe.from=Le;function Ee(Z){return new l.TestTag(Z.id)}Pe.to=Ee}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Pe){const Le=(Z,Me)=>{const Ve={...At.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(st=>({state:st.state,duration:st.duration,messages:st.messages.filter(Ye=>Ye.type===0).map(ft.to)})),children:Z.children.map(st=>Me.get(st)).filter(P.isDefined).map(st=>Le(st,Me))};for(const st of Ve.children)st.parent=Ve;return Ve};function Ee(Z){const Me=[],Ve=new Map;for(const st of Z.items)Ve.set(st.item.extId,st),Z.request.targets.some(Ye=>Ye.controllerId===st.controllerId&&Ye.testIds.includes(st.item.extId))&&Me.push(st);return{completedAt:Z.completedAt,results:Me.map(st=>Le(st,Ve))}}Pe.to=Ee})(Ft=e.TestResults||(e.TestResults={}));var Ke;(function(Pe){function Le(Ve){return{covered:Ve.covered,total:Ve.covered}}function Ee(Ve){return"line"in Ve?r.from(Ve):o.from(Ve)}function Z(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ee(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(st=>({count:st.executionCount,location:st.location&&Ee(st.location)})):void 0}:{type:0,count:Ve.executionCount,location:Ee(Ve.location)}}Pe.fromDetailed=Z;function Me(Ve){return{uri:Ve.uri,statement:Le(Ve.statementCoverage),branch:Ve.branchCoverage&&Le(Ve.branchCoverage),function:Ve.functionCoverage&&Le(Ve.functionCoverage),details:Ve.detailedCoverage?.map(Z)}}Pe.fromFile=Me})(Ke=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Pe){function Le(Ee){switch(Ee){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Pe.to=Le})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Rt;(function(Pe){function Le(Z){const Me=new l.TypeHierarchyItem(x.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),o.to(Z.range),o.to(Z.selectionRange));return Me._sessionId=Z._sessionId,Me._itemId=Z._itemId,Me}Pe.to=Le;function Ee(Z,Me,Ve){if(Me=Me??Z._sessionId,Ve=Ve??Z._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,kind:x.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:o.from(Z.range),selectionRange:o.from(Z.selectionRange),tags:Z.tags?.map(V.from)}}Pe.from=Ee})(Rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(Pe){function Le(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Pe.from=Le})(Mt=e.ViewBadge||(e.ViewBadge={}))}),define(ye[222],De([0,1,2,11,7,15,92]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(P,L,I,D={timeout:1500,errors:3}){this._logService=P,this._documents=L,this._mainThreadBulkEdits=I,this._thresholds=D,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(L,I,D)=>{const C={dispose:this._callbacks.push([L,I,P])};return Array.isArray(D)&&D.push(C),C}}async $participateInSave(P,L){const I=d.URI.revive(P);let D=!1;const T=setTimeout(()=>D=!0,this._thresholds.timeout),C=[];try{for(let m of[...this._callbacks]){if(D)break;const v=this._documents.getDocument(I),g=await this._deliverEventAsyncAndBlameBadListeners(m,{document:v,reason:A.TextDocumentSaveReason.to(L)});C.push(g)}}finally{clearTimeout(T)}return C}_deliverEventAsyncAndBlameBadListeners([P,L,I],D){const T=this._badListeners.get(P);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,L,D).then(()=>!0,C=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const m=this._badListeners.get(P);this._badListeners.set(P,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,L,I,D){const T=[],C=Date.now(),{document:m,reason:v}=D,{version:g}=m,b=Object.freeze({document:m,reason:v,waitUntil(f){if(Object.isFrozen(T))throw(0,i.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(f))}});try{L.apply(I,[b])}catch(f){return Promise.reject(f)}return Object.freeze(T),new Promise((f,l)=>{const h=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(h),f(o)}).catch(o=>{clearTimeout(h),l(o)})}).then(f=>{const l={edits:[]};for(const h of f)if(Array.isArray(h)&&h.every(o=>o instanceof _.TextEdit))for(const{newText:o,newEol:E,range:r}of h)l.edits.push({_type:2,resource:m.uri,edit:{range:r&&A.Range.from(r),text:o,eol:E&&A.EndOfLine.from(E)}});if(l.edits.length!==0)return g===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(ye[223],De([0,1,10,2,15,7,128]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(I,D,T,C){this.start=I,this.deletedCount=D,this.deletedItems=T,this.items=C}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class w{constructor(I,D,T){this.notebook=I,this._extHostDocument=D,this._cellData=T,this.handle=T.handle,this.uri=i.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(I,D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1,notebook:I}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,D=this._extHostDocument.getDocument(this.uri);if(!D)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:D.document,get mime(){return I._mime},set mime(C){I._mime=C},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(I){this._outputs=I.map(_.NotebookCellOutput.to)}setOutputItems(I,D,T){const C=T.map(_.NotebookCellOutputItem.to),m=this._outputs.find(v=>v.id===I);m&&(D||(m.items.length=0),m.items.push(...C))}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=w;class P{constructor(I,D,T,C,m){this._proxy=I,this._textDocumentsAndEditors=D,this._textDocuments=T,this.uri=C,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=m.viewType,this._metadata=Object.freeze(m.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,m.cells]],!0,void 0),this._versionId=m.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,D={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===d.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(T){return T=I._validateIndex(T),I._cells[T].apiCell},getCells(T){return(T?I._getCells(T):I._cells).map(m=>m.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(D)}return this._notebook}updateBackup(I){this._backup?.delete(),this._backup=I}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,D,T){this._versionId=I.versionId,this._isDirty=D,this.acceptDocumentPropertiesChanged({metadata:T});const C={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},m=[];for(const g of I.rawEvents)g.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1,C.contentChanges):g.kind===k.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx,C.contentChanges):g.kind===k.NotebookCellsChangeType.Output?(this._setCellOutputs(g.index,g.outputs),m.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===k.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems),m.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===k.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(g.index,g.language),m.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document})):g.kind===k.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document}):g.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===k.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(g.index,g.metadata),m.push({cell:this._cells[g.index].apiCell,metadata:this._cells[g.index].apiCell.metadata})):g.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(g.index,g.internalMetadata),m.push({cell:this._cells[g.index].apiCell,executionSummary:this._cells[g.index].apiCell.executionSummary}));const v=new Map;for(let g=0;g<m.length;g++){const b=m[g],f=v.get(b.cell);if(f===void 0){const l=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});v.set(b.cell,l-1)}else C.cellChanges[f]={...C.cellChanges[f],...b}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let D=I.start|0,T=I.end|0;return D<0&&(D=0),T>this._cells.length&&(T=this._cells.length),I.with({start:D,end:T})}_getCells(I){I=this._validateRange(I);const D=[];for(let T=I.start;T<I.end;T++)D.push(this._cells[T]);return D}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,D,T){if(this._disposed)return;const C=[],m=[],v=[];if(I.reverse().forEach(g=>{const f=g[2].map(o=>{const E=new w(this,this._textDocumentsAndEditors,o);return D||m.push(w.asModelAddData(this.apiNotebook,o)),E}),l=new y(g[0],g[1],[],f),h=this._cells.splice(g[0],g[1],...f);for(const o of h)v.push(o.uri),l.deletedItems.push(o.apiCell);C.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:v}),T)for(let g of C)T.push(g.asApiEvent())}_moveCell(I,D,T){const C=this._cells.splice(I,1);this._cells.splice(D,0,...C);const m=[new y(I,1,C.map(v=>v.apiCell),[]),new y(D,0,[],C)];for(const v of m)T.push(v.asApiEvent())}_setCellOutputs(I,D){this._cells[I].setOutputs(D)}_setCellOutputItems(I,D,T,C){this._cells[I].setOutputItems(D,T,C)}_changeCellLanguage(I,D){const T=this._cells[I];T.apiCell.document.languageId!==D&&this._textDocuments.$acceptModelLanguageChanged(T.uri,D)}_changeCellMime(I,D){const T=this._cells[I];T.apiCell.mime=D}_changeCellMetadata(I,D){this._cells[I].setMetadata(D)}_changeCellInternalMetadata(I,D){this._cells[I].setInternalMetadata(D)}getCellFromApiCell(I){return this._cells.find(D=>D.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(D=>D.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(ye[131],De([0,1,7,15,11]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(w){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=w}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(w){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:w})}replaceCellMetadata(w,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:w,metadata:P})}replaceCells(w,P,L){this._throwIfFinalized(),!(w===P&&L.length===0)&&this._collectedEdits.push({editType:1,index:w,count:P-w,cells:L.map(i.NotebookCellData.from)})}}class k{constructor(w,P,L,I,D,T){this.id=w,this._proxy=P,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._visibleRanges=I,this._viewColumn=T}get apiEditor(){if(!this._editor){const w=this;this._editor={get document(){return w.notebookData.apiNotebook},get selections(){return w._selections},set selections(P){if(!Array.isArray(P)||!P.every(d.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");w._selections=P,w._trySetSelections(P)},get visibleRanges(){return w._visibleRanges},revealRange(P,L){w._proxy.$tryRevealRange(w.id,i.NotebookRange.from(P),L??d.NotebookEditorRevealType.Default)},get viewColumn(){return w._viewColumn},edit(P){const L=new A(this.document.version);return P(L),w._applyEdit(L.finalize())},setDecorations(P,L){return w.setDecorations(P,L)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(w){this._visible=w}_acceptVisibleRanges(w){this._visibleRanges=w}_acceptSelections(w){this._selections=w}_trySetSelections(w){this._proxy.$trySetSelections(this.id,w.map(i.NotebookRange.from))}_acceptViewColumn(w){this._viewColumn=w}_applyEdit(w){if(w.cellEdits.length===0)return Promise.resolve(!0);const P=[];let L=-1;for(let I=0;I<w.cellEdits.length;I++){if(L<0){P.push(w.cellEdits[I]),L++;continue}const T=P[L],C=w.cellEdits[I];if(T.editType===1&&C.editType===1&&T.index===C.index){T.cells.push(...w.cellEdits[I].cells),T.count+=w.cellEdits[I].count;continue}P.push(w.cellEdits[I]),L++}return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,P)}setDecorations(w,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(w.key)))return P.isEmpty?this._hasDecorationsForKey.delete(w.key):this._hasDecorationsForKey.add(w.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(P),w.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(ye[224],De([0,1,15,118,173,21,58,11]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(D){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=D}async withProgress(D,T,C){const m=this._handles++,{title:v,location:g,cancellable:b}=T,f={label:(0,_.localize)(0,null,D.displayName||D.name),id:D.identifier.value};return this._proxy.$startProgress(m,{location:d.ProgressLocation.from(g),title:v,source:f,cancellable:b},D.isUnderDevelopment?void 0:D.identifier.value).catch(y.onUnexpectedExternalError),this._withProgress(m,C,!!b)}_withProgress(D,T,C){let m;C&&(m=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(D,m));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),m&&m.dispose()};let g;try{g=T(new L(this._proxy,D),C&&m?m.token:A.CancellationToken.None)}catch(b){throw v(D),b}return g.then(b=>v(D),b=>v(D)),g}$acceptProgressCanceled(D){const T=this._mapHandleToCancellationSource.get(D);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(D))}}e.ExtHostProgress=w;function P(I,D){return I.message=D.message,typeof D.increment=="number"&&(typeof I.increment=="number"?I.increment+=D.increment:I.increment=D.increment),I}class L extends i.Progress{constructor(D,T){super(C=>this.throttledReport(C));this._proxy=D,this._handle=T}throttledReport(D){this._proxy.$progressReport(this._handle,D)}}je([(0,k.throttle)(100,(I,D)=>P(I,D),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[132],De([0,1,37,129,65,88,66,15,2]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(f,l,h,o)=>{let E=l;return{enumerable:!0,configurable:!1,get(){return E},set(r){if(!h(E,r)){const s=E;E=r,f.listener?.(o(r,s))}}}},L=(f,l)=>f===l,I={range:(f,l)=>f===l?!0:!f||!l?!1:f.isEqual(l),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(f,l)=>!(f.length!==l.length||f.some(h=>!l.find(o=>h.id===o.id)))},D=f=>l=>({op:4,update:f(l)}),T=(f,l)=>({range:P(f,void 0,I.range,D(h=>({range:d.Range.lift(y.Range.from(h))}))),label:P(f,l,I.label,D(h=>({label:h}))),description:P(f,void 0,I.description,D(h=>({description:h}))),sortText:P(f,void 0,I.sortText,D(h=>({sortText:h}))),canResolveChildren:P(f,!1,I.canResolveChildren,h=>({op:2,state:h})),busy:P(f,!1,I.busy,D(h=>({busy:h}))),error:P(f,void 0,I.error,D(h=>({error:y.MarkdownString.fromStrict(h)||null}))),tags:P(f,[],I.tags,(h,o)=>({op:1,new:h.map(y.TestTag.from),old:o.map(y.TestTag.from)}))}),C=f=>{const l=_.TestId.fromString(f.extId),h=new v(l.controllerId,l.localId,f.label,w.URI.revive(f.uri)||void 0);return h.range=y.Range.to(f.range||void 0),h.description=f.description||void 0,h.sortText=f.sortText||void 0,h.tags=f.tags.map(o=>y.TestTag.to({id:(0,k.denamespaceTestTag)(o).tagId})),h},m=f=>{let l;for(const h of f.tests){const o=C(h.item);(0,i.getPrivateApiFor)(o).parent=l,l=o}return l};e.toItemFromContext=m;class v{constructor(l,h,o,E){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,i.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:E,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof g?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,i.getPrivateApiFor,v),enumerable:!0,writable:!1},...T(r,o)})}}e.TestItemImpl=v;class g extends v{constructor(l,h){super(l,l,h,void 0)}}e.TestItemRootImpl=g;class b extends A.TestItemCollection{constructor(l,h){super({controllerId:l,getApiFor:i.getPrivateApiFor,getChildren:o=>o.children,root:new g(l,h),toITestItem:y.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(ye[133],De([0,1,56,11,78,15,7]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(D,T,C){const m=y._Keys.nextId();D.$registerTextEditorDecorationType(T.identifier,m,A.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:m,dispose(){D.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=y,y._Keys=new _.IdGenerator("TextEditorDecorationType");class w{constructor(D,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=D,this._documentVersionId=D.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(D,T){this._throwIfFinalized();let C=null;if(D instanceof k.Position)C=new k.Range(D,D);else if(D instanceof k.Range)C=D;else throw new Error("Unrecognized location");this._pushEdit(C,T,!1)}insert(D,T){this._throwIfFinalized(),this._pushEdit(new k.Range(D,D),T,!0)}delete(D){this._throwIfFinalized();let T=null;if(D instanceof k.Range)T=D;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(D,T,C){const m=this._document.validateRange(D);this._collectedEdits.push({range:m,text:T,forceMoveMarkers:C})}setEndOfLine(D){if(this._throwIfFinalized(),D!==k.EndOfLine.LF&&D!==k.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=D}}e.TextEditorEdit=w;class P{constructor(D,T,C,m){this._proxy=D,this._id=T,this._accept(C),this._logService=m;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(g){v._setTabSize(g)},get insertSpaces(){return v._insertSpaces},set insertSpaces(g){v._setInsertSpaces(g)},get cursorStyle(){return v._cursorStyle},set cursorStyle(g){v._setCursorStyle(g)},get lineNumbers(){return v._lineNumbers},set lineNumbers(g){v._setLineNumbers(g)}}}_accept(D){this._tabSize=D.tabSize,this._insertSpaces=D.insertSpaces,this._cursorStyle=D.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(D.lineNumbers)}_validateTabSize(D){if(D==="auto")return"auto";if(typeof D=="number"){const T=Math.floor(D);return T>0?T:null}if(typeof D=="string"){const T=parseInt(D,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(D){const T=this._validateTabSize(D);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(D){return D==="auto"?"auto":D==="false"?!1:Boolean(D)}_setInsertSpaces(D){const T=this._validateInsertSpaces(D);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(D){this._cursorStyle!==D&&(this._cursorStyle=D,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:D})))}_setLineNumbers(D){this._lineNumbers!==D&&(this._lineNumbers=D,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(D)})))}assign(D){const T={};let C=!1;if(typeof D.tabSize!="undefined"){const m=this._validateTabSize(D.tabSize);m==="auto"?(C=!0,T.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,C=!0,T.tabSize=m)}if(typeof D.insertSpaces!="undefined"){const m=this._validateInsertSpaces(D.insertSpaces);m==="auto"?(C=!0,T.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,C=!0,T.insertSpaces=m)}typeof D.cursorStyle!="undefined"&&this._cursorStyle!==D.cursorStyle&&(this._cursorStyle=D.cursorStyle,C=!0,T.cursorStyle=D.cursorStyle),typeof D.lineNumbers!="undefined"&&this._lineNumbers!==D.lineNumbers&&(this._lineNumbers=D.lineNumbers,C=!0,T.lineNumbers=A.TextEditorLineNumbersStyle.from(D.lineNumbers)),C&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(D,T){T.catch(C=>{this._logService.warn(`ExtHostTextEditorOptions '${D}' failed:'`),this._logService.warn(C)})}}e.ExtHostTextEditorOptions=P;class L{constructor(D,T,C,m,v,g,b,f){this.id=D,this._proxy=T,this._logService=C,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,g,C),this._visibleRanges=b,this._viewColumn=f;const l=this;this.value=Object.freeze({get document(){return m.getValue()},set document(h){throw(0,i.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(h){if(!(h instanceof k.Selection))throw(0,i.illegalArgument)("selection");l._selections=[h],l._trySetSelection()},get selections(){return l._selections},set selections(h){if(!Array.isArray(h)||h.some(o=>!(o instanceof k.Selection)))throw(0,i.illegalArgument)("selections");l._selections=h,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(h){throw(0,i.readonly)("visibleRanges")},get options(){return l._options.value},set options(h){l._disposed||l._options.assign(h)},get viewColumn(){return l._viewColumn},set viewColumn(h){throw(0,i.readonly)("viewColumn")},edit(h,o={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new w(m.getValue(),o);return h(E),l._applyEdit(E)},insertSnippet(h,o,E={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=l._selections.map(s=>A.Range.from(s));else if(o instanceof k.Position){const{lineNumber:s,column:n}=A.Position.from(o);r=[{startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n}]}else if(o instanceof k.Range)r=[A.Range.from(o)];else{r=[];for(const s of o)if(s instanceof k.Range)r.push(A.Range.from(s));else{const{lineNumber:n,column:t}=A.Position.from(s);r.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return T.$tryInsertSnippet(D,m.getValue().version,h.value,r,E)},setDecorations(h,o){const E=o.length===0;E&&!l._hasDecorationsForKey.has(h.key)||(E?l._hasDecorationsForKey.delete(h.key):l._hasDecorationsForKey.add(h.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(o))return T.$trySetDecorations(D,h.key,A.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let s=0,n=o.length;s<n;s++){const t=o[s];r[4*s]=t.start.line+1,r[4*s+1]=t.start.character+1,r[4*s+2]=t.end.line+1,r[4*s+3]=t.end.character+1}return T.$trySetDecorationsFast(D,h.key,r)}}))},revealRange(h,o){l._runOnProxy(()=>T.$tryRevealRange(D,A.Range.from(h),o||k.TextEditorRevealType.Default))},show(h){T.$tryShowEditor(D,A.ViewColumn.from(h))},hide(){T.$tryHideEditor(D)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(D){(0,d.ok)(!this._disposed),this._options._accept(D)}_acceptVisibleRanges(D){(0,d.ok)(!this._disposed),this._visibleRanges=D}_acceptViewColumn(D){(0,d.ok)(!this._disposed),this._viewColumn=D}_acceptSelections(D){(0,d.ok)(!this._disposed),this._selections=D}async _trySetSelection(){const D=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,D)),this.value}_applyEdit(D){const T=D.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const C=T.edits.map(v=>v.range);C.sort((v,g)=>v.end.line===g.end.line?v.end.character===g.end.character?v.start.line===g.start.line?v.start.character-g.start.character:v.start.line-g.start.line:v.end.character-g.end.character:v.end.line-g.end.line);for(let v=0,g=C.length-1;v<g;v++){const b=C[v].end;if(C[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=T.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,m,{setEndOfLine:typeof T.setEndOfLine=="number"?A.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(D){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):D().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(ye[225],De([0,1,4,191]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(i.IEnvironmentService)}),define(ye[226],De([0,1,28,3,9]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=A;class k{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let I of L.activationEvents)I==="onUri"&&(I=`onUri:${d.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(L)}}set(L){this._extensionDescriptions=L,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,I){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const D=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(D.map(T=>T.identifier)),I.length>0){const T=new Set;I.forEach(C=>T.add(d.ExtensionIdentifier.toKey(C))),this._extensionDescriptions=this._extensionDescriptions.filter(C=>!T.has(d.ExtensionIdentifier.toKey(C.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(D)}static _findLoopingExtensions(L){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,g){this.addNode(v),this.addNode(g),this._arcs.has(v)?this._arcs.get(v).push(g):this._arcs.set(v,[g])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,g){const b=I.getArcs(v);for(let f=0;f<b.length;f++)if(!g.has(b[f]))return!1;return!0}getNodes(){return this._nodesArr}};let D=new Map;for(let v of L){const g=d.ExtensionIdentifier.toKey(v.identifier);if(D.set(g,v),v.extensionDependencies)for(let b of v.extensionDependencies){const f=d.ExtensionIdentifier.toKey(b);I.addArc(g,f)}}let T=new Set;I.getNodes().filter(v=>I.getArcs(v).length===0).forEach(v=>T.add(v));let C=I.getNodes().filter(v=>!T.has(v)),m;do{m=!1;for(let v=0;v<C.length;v++){const g=C[v];I.hasOnlyGoodArcs(g,T)&&(C.splice(v,1),v--,T.add(g),m=!0)}}while(m);return C.map(v=>D.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const I=this._activationMap.get(L);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const I=this._extensionsMap.get(d.ExtensionIdentifier.toKey(L));return I||void 0}}e.ExtensionDescriptionRegistry=k;var y;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(y||(y={}));function w(P,L){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,D=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(I!==D)return I-D;const T=_.posix.basename(P.extensionLocation.path),C=_.posix.basename(L.extensionLocation.path);return T<C?-1:T>C?1:0}}),define(ye[134],De([0,1,23]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var i;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(i=e.UIKind||(e.UIKind={}));var _;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(_=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function k(w){const P=d.VSBuffer.alloc(1);switch(w){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=k;function y(w,P){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=y}),define(ye[25],De([0,1,3,2,4,28,200]),function(Y,e,d,i,_,A,k){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");class w{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class L{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class I{constructor(t){this.dependency=t}}e.MissingExtensionDependency=I;var D;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class C{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,a){const c=[],u=[],S=[],R=[],O=g(this._allExtensions),N=g(t),p=(re,H)=>re.extensionLocation.toString()===H.extensionLocation.toString()||re.isBuiltin===H.isBuiltin||re.isUserBuiltin===H.isUserBuiltin||re.isUnderDevelopment===H.isUnderDevelopment;for(const re of this._allExtensions){const H=N.get(A.ExtensionIdentifier.toKey(re.identifier));if(!H){c.push(re.identifier),O.delete(A.ExtensionIdentifier.toKey(re.identifier));continue}if(!p(re,H)){c.push(re.identifier),O.delete(A.ExtensionIdentifier.toKey(re.identifier));continue}}for(const re of t){const H=O.get(A.ExtensionIdentifier.toKey(re.identifier));if(!H){u.push(re);continue}if(!p(H,re)){c.push(H.identifier),O.delete(A.ExtensionIdentifier.toKey(H.identifier));continue}}const M=v(this._myExtensions),U=v(a);for(const re of this._myExtensions)U.has(A.ExtensionIdentifier.toKey(re))||S.push(re);for(const re of a)M.has(A.ExtensionIdentifier.toKey(re))||R.push(re);const z={toRemove:c,toAdd:u,myToRemove:S,myToAdd:R};return this.delta(z),z}delta(t){const{toRemove:a,toAdd:c,myToRemove:u,myToAdd:S}=t,R=v(a),O=v(u);for(let N=0;N<this._allExtensions.length;N++)R.has(A.ExtensionIdentifier.toKey(this._allExtensions[N].identifier))&&(this._allExtensions.splice(N,1),N--);for(let N=0;N<this._myExtensions.length;N++)O.has(A.ExtensionIdentifier.toKey(this._myExtensions[N]))&&(this._myExtensions.splice(N,1),N--);for(const N of c)this._allExtensions.push(N);for(const N of S)this._myExtensions.push(N)}containsExtension(t){for(const a of this._myExtensions)if(A.ExtensionIdentifier.equals(a,t))return!0;return!1}}e.ExtensionHostExtensions=C;class m{constructor(t){if(this[y]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,t)for(const a of t)this.add(a)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,a){this._map.forEach(c=>t.call(a,c,c,this))}*entries(){for(let[t,a]of this._map)yield[a,a]}keys(){return this._map.values()}values(){return this._map.values()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=m;function v(n){const t=new Set;for(const a of n)t.add(A.ExtensionIdentifier.toKey(a));return t}e.extensionIdentifiersArrayToSet=v;function g(n){const t=new Map;for(const a of n)t.set(A.ExtensionIdentifier.toKey(a.identifier),a);return t}function b(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=b;function f(n,t){if(!b(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=f;class l{constructor(t,a,c,u){this.codeLoadingTime=t,this.activateCallTime=a,this.activateResolvedTime=c,this.activationReason=u}}e.ActivationTimes=l;class h{constructor(t,a){this.description=t,this.value=a}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost";var o;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function E(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=E;function r(n,t){return{identifier:new A.ExtensionIdentifier((0,k.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=r;class s{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,a){return Promise.resolve(0)}getInspectPorts(t,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,a){return Promise.resolve()}}e.NullExtensionService=s}),define(ye[227],De([0,1,11,28,25,13,17]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(v,g,b,f){this.startup=v,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=f}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class w{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,g){return v===-1||g===-1?-1:g-v}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class P{constructor(v,g,b,f,l,h){this.activationFailed=v,this.activationFailedError=g,this.activationTimes=b,this.module=f,this.exports=l,this.subscriptions=h}}e.ActivatedExtension=P;class L extends P{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class I extends P{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class D extends P{constructor(v){super(!0,v,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=D;let T=class{constructor(v,g,b,f,l){this._logService=l,this._registry=v,this._resolvedExtensionsSet=new Set,g.forEach(h=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(h))),this._externalExtensionsMap=new Map,b.forEach(h=>this._externalExtensionsMap.set(i.ExtensionIdentifier.toKey(h),h)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,g]of this._operations)g.dispose()}isActivated(v){const g=this._operations.get(i.ExtensionIdentifier.toKey(v));return Boolean(g&&g.value)}getActivatedExtension(v){const g=this._operations.get(i.ExtensionIdentifier.toKey(v));if(!g||!g.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return g.value}async activateByEvent(v,g){if(this._alreadyActivatedEvents[v])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(b.map(f=>({id:f.identifier,reason:{startup:g,extensionId:f.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,g){const b=this._registry.getExtensionDescription(v);if(!b)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:b.identifier,reason:g}])}async _activateExtensions(v){const g=v.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(g.map(b=>b.wait()))}_handleActivationRequest(v){if(this._operations.has(i.ExtensionIdentifier.toKey(v.id)))return this._operations.get(i.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const g=this._registry.getExtensionDescription(v.id);if(!g){const l=new Error(`Cannot activate unknown extension '${v.id.value}'`),h=this._createAndSaveOperation(v,null,[],new D(l));return this._host.onExtensionActivationError(v.id,l,new _.MissingExtensionDependency(v.id.value)),h}const b=[],f=typeof g.extensionDependencies=="undefined"?[]:g.extensionDependencies;for(const l of f){if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(l)))continue;const h=this._operations.get(i.ExtensionIdentifier.toKey(l));if(h){b.push(h);continue}if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(l))){b.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(i.ExtensionIdentifier.toKey(l)),reason:v.reason}));continue}const o=this._registry.getExtensionDescription(l);if(o){if(!o.main&&!o.browser)continue;b.push(this._handleActivationRequest({id:o.identifier,reason:v.reason}));continue}const E=g.displayName||g.identifier.value,r=new Error(`Cannot activate the '${E}' extension because it depends on unknown extension '${l}'`),s=this._createAndSaveOperation(v,g.displayName,[],new D(r));return this._host.onExtensionActivationError(g.identifier,r,new _.MissingExtensionDependency(l)),s}return this._createAndSaveOperation(v,g.displayName,b,null)}_createAndSaveOperation(v,g,b,f){const l=new C(v.id,g,v.reason,b,f,this._host,this._logService);return this._operations.set(i.ExtensionIdentifier.toKey(v.id),l),l}};T=je([xe(4,A.ILogService)],T),e.ExtensionsActivator=T;let C=class{constructor(v,g,b,f,l,h,o){this._id=v,this._displayName=g,this._reason=b,this._deps=f,this._value=l,this._host=h,this._logService=o,this._barrier=new k.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const g=this._deps[v];if(g.value&&!g.value.activationFailed){this._deps.splice(v,1),v--;continue}if(g.value&&g.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);b.detail=g.value.activationFailedError,this._value=new D(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const g=new Error;if(v&&v.name&&(g.name=v.name),v&&v.message?g.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(g.stack=v.stack),this._value=new D(g),this._isDisposed&&d.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};C=je([xe(6,A.ILogService)],C)}),define(ye[228],De([0,1,13,27,25]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends d.LogService{constructor(y,w){super(y.createLogger(w.logFile,{name:_.ExtensionHostLogFileName}))}};A=je([xe(0,d.ILoggerService),xe(1,i.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ye[229],De([0,1,11]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,k)=>{this._actualOk=A,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,k){return this._ensureActual().then(A,k)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=i}),define(ye[53],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const i=[];function _(y){const w=new d(y);return i[w.nid]=w,w}e.createProxyIdentifier=_;function A(y){return i[y].sid}e.getStringIdentifierForProxy=A;class k{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=k}),define(ye[5],De([0,1,60,2,53]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.NotebookInput=3]="NotebookInput",f[f.NotebookDiffInput=4]="NotebookDiffInput",f[f.CustomEditorInput=5]="CustomEditorInput",f[f.WebviewEditorInput=6]="WebviewEditorInput",f[f.TerminalEditorInput=7]="TerminalEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var y;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(y=e.TabModelOperationKind||(e.TabModelOperationKind={}));var w;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(w=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var D;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(D=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(l){return l._id=T._n++,l}}e.IdObject=T,T._n=0;var C;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(C=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(f){if(f&&f.edits)for(const l of f.edits)typeof l.resource=="object"?l.resource=i.URI.revive(l.resource):(l.newUri=i.URI.revive(l.newUri),l.oldUri=i.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,d.revive)(l.metadata));return f}e.reviveWorkspaceEditDto=g;var b;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookProxyKernels:(0,_.createProxyIdentifier)("MainThreadNotebookProxyKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookProxyKernels:(0,_.createProxyIdentifier)("ExtHostNotebookProxyKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry")}}),define(ye[89],De([0,1,5,3,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(y){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,w){return this._proxy.$getPassword(y,w)}store(y,w,P){return this._proxy.$setPassword(y,w,P)}delete(y,w){return this._proxy.$deletePassword(y,w)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(ye[67],De([0,1,4,13,5,18]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(w,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(_.MainContext.MainThreadTelemetry)}report(w,P,L){const I=this.getUsageKey(w,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:w}))}getUsageKey(w,P){return`${w}-${P.identifier.value}`}};k=je([xe(0,A.IExtHostRpcService),xe(1,i.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(y,w,P){}})}),define(ye[230],De([0,1,3,5,7,28]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,P,L,I={}){const D=A.ExtensionIdentifier.toKey(w.identifier),T=this._inFlightRequests.get(D)||[],C=[...L].sort().join(" ");let m=T.find(v=>v.scopes===C);if(m)return m.result;{const v=this._getSession(w,D,P,L,I);m={scopes:C,result:v},T.push(m),this._inFlightRequests.set(D,T);try{await v}finally{const g=T.findIndex(b=>b.scopes===C);g>-1&&(T.splice(g),this._inFlightRequests.set(D,T))}return v}}async _getSession(w,P,L,I,D={}){await this._proxy.$ensureProvider(L);const T=w.displayName||w.name;return this._proxy.$getSession(L,I,P,T,D)}async removeSession(w,P){const L=this._authenticationProviders.get(w);return L?L.provider.removeSession(P):this._proxy.$removeSession(w,P)}registerAuthenticationProvider(w,P,L,I){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:P,provider:L,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===w)||this._providers.push({id:w,label:P});const D=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(w,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,P,I?.supportsMultipleAccounts??!1),new _.Disposable(()=>{D.dispose(),this._authenticationProviders.delete(w);const T=this._providers.findIndex(C=>C.id===w);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,P){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,P){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,P){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,P){return this._onDidChangeSessions.fire({provider:{id:w,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ye[231],De([0,1,5,18,15]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(y,w){this._proxy=y.getProxy(d.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>w.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(y){const w=_.WorkspaceEdit.from(y,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(w)}};A=je([xe(0,i.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ye[232],De([0,1,5]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(A){const k=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(y){return k.$writeText(y)}})}}e.ExtHostClipboard=i});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[38],De([0,1,14,7,15,26,5,16,13,60,37,50,2,6,4,18,132,23,53,51]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f){"use strict";var l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(a,c){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,h.set(this,void 0),et(this,l,a.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=c,et(this,h,a.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new E(this,u=>{const S=this._apiCommands.get(u);return S?.result===s.Void?S:void 0},c),this._argumentProcessors=[{processArgument(u){return(0,P.revive)(u)}},{processArgument(u){return(0,A.cloneAndChange)(u,function(S){if(L.Range.isIRange(S))return _.Range.to(S);if(I.Position.isIPosition(S))return _.Position.to(S);if(L.Range.isIRange(S.range)&&D.URI.isUri(S.uri))return _.location.to(S);if(S instanceof g.VSBuffer)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(a){this._argumentProcessors.push(a)}registerApiCommand(a){const c=this.registerCommand(!1,a.id,async(...u)=>{const S=a.args.map((O,N)=>{if(!O.validate(u[N]))throw new Error(`Invalid argument '${O.name}' when running '${a.id}', received: ${u[N]}`);return O.convert(u[N])}),R=await this.executeCommand(a.internalId,...S);return a.result.convert(R,u,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this._apiCommands.set(a.id,a),new i.Disposable(()=>{c.dispose(),this._apiCommands.delete(a.id)})}registerCommand(a,c,u,S,R,O){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:u,thisArg:S,description:R,extension:O}),a&&Ue(this,l,"f").$registerCommand(c),new i.Disposable(()=>{this._commands.delete(c)&&a&&Ue(this,l,"f").$unregisterCommand(c)})}executeCommand(a,...c){return this._logService.trace("ExtHostCommands#executeCommand",a),this._doExecuteCommand(a,c,!0)}async _doExecuteCommand(a,c,u){if(this._commands.has(a))return this._executeContributedCommand(a,c,!1);{let S=!1;const R=(0,A.cloneAndChange)(c,function(O){if(O instanceof i.Position)return _.Position.from(O);if(O instanceof i.Range)return _.Range.from(O);if(O instanceof i.Location)return _.location.from(O);if(i.NotebookRange.isNotebookRange(O))return _.NotebookRange.from(O);if(O instanceof ArrayBuffer)return S=!0,g.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return S=!0,g.VSBuffer.wrap(O);if(O instanceof g.VSBuffer)return S=!0,O;if(!Array.isArray(O))return O});try{const O=await Ue(this,l,"f").$executeCommand(a,S?new b.SerializableObjectWithBuffers(R):R,u);return(0,P.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(a,c,!1);throw O}}}async _executeContributedCommand(a,c,u){const S=this._commands.get(a);if(!S)throw new Error("Unknown command");this._reportTelemetry(S,a);let{callback:R,thisArg:O,description:N}=S;if(N)for(let p=0;p<N.args.length;p++)try{(0,d.validateConstraint)(c[p],N.args[p].constraint)}catch{throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${N.args[p].name}' - ${N.args[p].description}`)}try{return await R.apply(O,c)}catch(p){if(a===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...c);M&&(a=M.command)}throw this._logService.error(p,a,S.extension?.identifier),u?new class extends Error{constructor(){super((0,f.toErrorMessage)(p));this.id=a,this.source=S.extension?.displayName??S.extension?.name}}:p}}_reportTelemetry(a,c){!a.extension||a.extension.isBuiltin||Ue(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:a.extension.identifier.value,id:c})}$executeContributedCommand(a,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",a),this._commands.has(a)?(c=c.map(u=>this._argumentProcessors.reduce((S,R)=>R.processArgument(S),u)),this._executeContributedCommand(a,c,!0)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this._logService.trace("ExtHostCommands#getCommands",a),Ue(this,l,"f").$getCommands().then(c=>(a&&(c=c.filter(u=>u[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(let[c,u]of this._commands){let{description:S}=u;S&&(a[c]=S)}return Promise.resolve(a)}};l=new WeakMap,h=new WeakMap,o=je([xe(0,m.IExtHostRpcService),xe(1,w.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class E{constructor(a,c,u){this._commands=a,this._lookupApiCommand=c,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(a,c){if(!a)return;const u={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return u;const S=this._lookupApiCommand(a.command);if(S)u.id=S.internalId,u.arguments=S.args.map((R,O)=>R.convert(a.arguments&&a.arguments[O]));else if((0,y.isNonEmptyArray)(a.arguments)){const R=++this._cachIdPool;this._cache.set(R,a),c.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),u.$ident=R,u.id=this.delegatingCommandId,u.arguments=[R],this._logService.trace("CommandsConverter#CREATE",a.command,R)}return u}fromInternal(a){return typeof a.$ident=="number"?this._cache.get(a.$ident):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this._cache.get(a[0])}_executeConvertedCommand(...a){const c=this.getActualCommand(...a);return this._logService.trace("CommandsConverter#EXECUTE",a[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class r{constructor(a,c,u,S){this.name=a,this.description=c,this.validate=u,this.convert=S}optional(){return new r(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,c){return new r(a??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>D.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>i.Position.isPosition(t),_.Position.from),r.Range=new r("range","A range in a text document",t=>i.Range.isRange(t),_.Range.from),r.Selection=new r("selection","A selection in a text document",t=>i.Selection.isSelection(t),_.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,_.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,_.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,_.TestItem.from);class s{constructor(a,c){this.description=a,this.convert=c}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class n{constructor(a,c,u,S,R){this.id=a,this.internalId=c,this.description=u,this.args=S,this.result=R}}e.ApiCommand=n}),define(ye[233],De([0,1,2,15,7,62,38,16,111,117,10]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(i.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,v)=>{if((0,y.isFalsyOrEmpty)(m))return;class g extends _.SymbolInformation{static to(f){const l=new g(f.name,i.SymbolKind.to(f.kind),f.containerName||"",new _.Location(v[0],i.Range.to(f.range)));return l.detail=f.detail,l.range=l.location.range,l.selectionRange=i.Range.to(f.selectionRange),l.children=f.children?f.children.map(g.to):[],l}}return m.map(g.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(i.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(i.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new k.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(i.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(i.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(i.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(v=>_.Position.isPosition(v)),m=>m.map(i.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(v=>{let g;for(const b of v.reverse())g=new _.SelectionRange(i.Range.to(b),g);return g}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(i.WorkspaceSymbol.to))),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A CallHierarchyItem or undefined",m=>m.map(i.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",m=>m.map(i.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",m=>m.map(i.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:i.Range.to(m.range),placeholder:m.text}})),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return i.WorkspaceEdit.to(m)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(i.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new _.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const v=(0,w.decodeSemanticTokensDto)(m);if(v.type==="full")return new _.SemanticTokens(v.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range.optional()],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new _.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const v=(0,w.decodeSemanticTokensDto)(m);if(v.type==="full")return new _.SemanticTokens(v.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,v,g)=>{if(!m)return new _.CompletionList([]);const b=m.suggestions.map(f=>i.CompletionItem.to(f,g));return new _.CompletionList(b,m.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return i.SignatureHelp.to(m)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,v,g)=>T(b=>new _.CodeLens(i.Range.to(b.range),b.command&&g.fromInternal(b.command)))(m))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>_.Range.isRange(m),m=>_.Selection.isSelection(m)?i.Selection.from(m):i.Range.from(m)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,v,g)=>T(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(b.command)}else{const f=new _.CodeAction(b.title,b.kind?new _.CodeActionKind(b.kind):void 0);return b.edit&&(f.edit=i.WorkspaceEdit.to(b.edit)),b.command&&(f.command=g.fromInternal(b.command)),f.isPreferred=b.isPreferred,f}})(m))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(v=>new _.ColorInformation(i.Range.to(v.range),i.Color.to(v.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",m=>m instanceof _.Color,i.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:i.Range.from(m.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(i.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,v,g)=>m.map(i.InlayHint.to.bind(void 0,g)))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(v=>i.NotebookExclusiveDocumentPattern.to(v))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(i.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new k.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>d.URI.isUri(m)||typeof m=="string"&&(0,P.matchesSomeScheme)(m,L.Schemas.http,L.Schemas.https),m=>m),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[i.ViewColumn.from(m),void 0]:[i.ViewColumn.from(m.viewColumn),i.TextEditorOpenOptions.from(m)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[i.ViewColumn.from(m),void 0]:[i.ViewColumn.from(m.viewColumn),i.TextEditorOpenOptions.from(m)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[i.ViewColumn.from(m.viewColumn),i.TextEditorOpenOptions.from(m)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A TypeHierarchyItem or undefined",m=>m.map(i.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",m=>m.map(i.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",m=>m.map(i.TypeHierarchyItem.to))),new k.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[k.ApiCommandArgument.TestItem],k.ApiCommandResult.Void)];class D{static register(v){I.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=D;function T(m){return v=>{if(Array.isArray(v))return v.map(m)}}function C(m){if(!Array.isArray(m))return;const v=[];for(const g of m)A.isLocationLink(g)?v.push(i.DefinitionLink.to(g)):v.push(i.location.to(g));return v}}),define(ye[234],De([0,1,17,58,3,6,2,62,28,15,7,25,5]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(C,m,v){const g=C.getProxy(D.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,m.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const a=this._commentControllers.get(t.handle);return a?a.value:t}else if(t&&t.$mid===7){const a=this._commentControllers.get(t.commentControlHandle);if(!a)return t;const c=a.getCommentThread(t.commentThreadHandle);return c?c.value:t}else if(t&&t.$mid===8){const a=this._commentControllers.get(t.thread.commentControlHandle);if(!a)return t;const c=a.getCommentThread(t.thread.commentThreadHandle);return c?{thread:c.value,text:t.text}:t}else if(t&&t.$mid===9){const a=this._commentControllers.get(t.thread.commentControlHandle);if(!a)return t;const c=a.getCommentThread(t.thread.commentThreadHandle);if(!c)return t;let u=t.commentUniqueId,S=c.getCommentByUniqueId(u);return S||t}else if(t&&t.$mid===10){const a=this._commentControllers.get(t.thread.commentControlHandle);if(!a)return t;const c=a.getCommentThread(t.thread.commentThreadHandle);if(!c)return t;let u=t.text,S=t.commentUniqueId,R=c.getCommentByUniqueId(S);return R?(R.body=u,R):t}return t}})}createCommentController(t,a,c){const u=b.handlePool++,S=new l(t,u,a,c);this._commentControllers.set(S.handle,S);const R=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(S),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(t.identifier),R),S.value}$createCommentThreadTemplate(t,a,c){const u=this._commentControllers.get(t);!u||u.$createCommentThreadTemplate(a,c)}async $updateCommentThreadTemplate(t,a,c){const u=this._commentControllers.get(t);!u||u.$updateCommentThreadTemplate(a,c)}$deleteCommentThread(t,a){const c=this._commentControllers.get(t);c&&c.$deleteCommentThread(a)}$provideCommentingRanges(t,a,c){const u=this._commentControllers.get(t);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const S=v.getDocument(k.URI.revive(a));return(0,d.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(S,c)).then(R=>R?R.map(O=>P.Range.from(O)):void 0)}$toggleReaction(t,a,c,u,S){const R=this._commentControllers.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const O=R.getCommentThread(a);if(O){const N=O.getCommentByUniqueId(u.uniqueIdInThread);if(R!==void 0&&N&&R.reactionHandler)return R.reactionHandler(N,E(S))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class f{constructor(t,a,c,u,S,R,O){this._commentControllerHandle=a,this._id=c,this._uri=u,this._range=S,this._comments=R,this.extensionDescription=O,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),g.$createCommentThread(a,this.handle,this._id,this._uri,P.Range.from(this._range),O.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(a,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(p){N.range=p},get comments(){return N.comments},set comments(p){N.comments=p},get collapsibleState(){return N.collapsibleState},set collapsibleState(p){N.collapsibleState=p},get canReply(){return N.canReply},set canReply(p){N.canReply=p},get contextValue(){return N.contextValue},set contextValue(p){N.contextValue=p},get label(){return N.label},set label(p){N.label=p},get state(){return N.state},set state(p){N.state=p},dispose:()=>{N.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const t=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),a={};t("range")&&(a.range=P.Range.from(this._range)),t("label")&&(a.label=this.label),t("contextValue")&&(a.contextValue=this.contextValue??null),t("comments")&&(a.comments=this._comments.map(c=>h(this,c,this._commentsMap))),t("collapsibleState")&&(a.collapseState=r(this._collapseState)),t("canReply")&&(a.canReply=this.canReply),t("state")&&(a.state=s(this._state)),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(t){for(let a of this._commentsMap){let c=a[0],u=a[1];if(t===u)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}f._handlePool=0,je([(0,i.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,a,c,u){this._extension=t,this._handle=a,this._id=c,this._label=u,this._threads=new Map,g.$registerCommentController(this.handle,c,u);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(R){S.options=R},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(R){S.commentingRangeProvider=R},get reactionHandler(){return S.reactionHandler},set reactionHandler(R){S.reactionHandler=R},createCommentThread(R,O,N){return S.createCommentThread(R,O,N).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,a,c,u){if(typeof t=="string"){const S=new f(this.id,this.handle,t,a,c,u,this._extension);return this._threads.set(S.handle,S),S}else{const S=new f(this.id,this.handle,void 0,t,a,c,this._extension);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(t,a){const c=new f(this.id,this.handle,void 0,k.URI.revive(t),P.Range.to(a),[],this._extension);return c.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(t,a){let c=this._threads.get(t);c&&(c.range=P.Range.to(a))}$deleteCommentThread(t){let a=this._threads.get(t);a&&a.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function h(n,t,a){let c=a.get(t);c||(c=++n.commentHandle,a.set(t,c));const u=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:c,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:u,label:t.label,commentReactions:t.reactions?t.reactions.map(S=>o(S)):void 0,timestamp:t.timestamp?.toJSON()}}function o(n){return{label:n.label,iconPath:n.iconPath?P.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function E(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?k.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function r(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}function s(n){if(n!==void 0)switch(n){case L.CommentThreadState.Unresolved:return y.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return y.CommentThreadState.Resolved}return y.CommentThreadState.Unresolved}return new b}e.createExtHostComments=T}),define(ye[135],De([0,1,2,5,7,4,18,13,16,8,9]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Ii{constructor(T,C){this._logService=C,this._provider=new Map,this._proxy=T.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,C){const m=Ii._handlePool++;this._provider.set(m,{provider:T,extensionId:C}),this._proxy.$registerDecorationProvider(m,C.value);const v=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(m,null);return}let b=(0,w.asArray)(g);if(b.length<=Ii._maxEventSize){this._proxy.$onDidChange(m,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",C.value,b.length);const f=b.map(o=>({uri:o,rank:(0,P.count)(o.path,"/")})),l=(0,w.groupBy)(f,(o,E)=>o.rank-E.rank||(0,P.compare)(o.uri.path,E.uri.path));let h=[];e:for(let o of l){let E;for(let r of o){let s=(0,L.dirname)(r.uri.path);if(E!==s&&(E=s,h.push(r.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(m,h)});return new _.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(T,C,m){if(!this._provider.has(T))return Object.create(null);const v=Object.create(null),{provider:g,extensionId:b}=this._provider.get(T);return await Promise.all(C.map(async f=>{try{const{uri:l,id:h}=f,o=await Promise.resolve(g.provideFileDecoration(d.URI.revive(l),m));if(!o)return;try{_.FileDecoration.validate(o),v[h]=[o.propagate,o.tooltip,o.badge,o.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${b.value}': ${E}`)}}catch(l){this._logService.error(l)}})),v}};I._handlePool=0,I._maxEventSize=250,I=je([xe(0,k.IExtHostRpcService),xe(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[235],De([0,1,171,116,2,5,7,15,3,13,24,46]),function(Y,e,d,i,_,A,k,y,w,P,L,I){"use strict";var D,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(b,f,l,h,o,E){this._name=b,this._owner=f,this._maxDiagnosticsPerFile=l,D.set(this,void 0),T.set(this,void 0),C.set(this,void 0),this._isDisposed=!1,et(this,C,new L.ResourceMap(r=>h.getComparisonKey(r)),"f"),et(this,D,o,"f"),et(this,T,E,"f")}dispose(){this._isDisposed||(Ue(this,T,"f").fire([...Ue(this,C,"f").keys()]),Ue(this,D,"f")&&Ue(this,D,"f").$clear(this._owner),Ue(this,C,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,f){if(!b){this.clear();return}this._checkDisposed();let l=[];if(_.URI.isUri(b)){if(!f){this.delete(b);return}Ue(this,C,"f").set(b,f.slice()),l=[b]}else if(Array.isArray(b)){l=[];let o;b=[...b].sort(m._compareIndexedTuplesByUri);for(const E of b){const[r,s]=E;if((!o||r.toString()!==o.toString())&&(o&&Ue(this,C,"f").get(o).length===0&&Ue(this,C,"f").delete(o),o=r,l.push(r),Ue(this,C,"f").set(r,[])),s){const n=Ue(this,C,"f").get(r);n&&n.push(...s)}else{const n=Ue(this,C,"f").get(r);n&&(n.length=0)}}}if(Ue(this,T,"f").fire(l),!Ue(this,D,"f"))return;const h=[];for(let o of l){let E=[];const r=Ue(this,C,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){E=[];const s=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let t of r)if(t.severity===s[n]&&E.push(y.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;E.push({severity:i.MarkerSeverity.Info,message:(0,d.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=r.map(s=>y.Diagnostic.from(s));h.push([o,E])}Ue(this,D,"f").$changeMany(this._owner,h)}delete(b){this._checkDisposed(),Ue(this,T,"f").fire([b]),Ue(this,C,"f").delete(b),Ue(this,D,"f")&&Ue(this,D,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ue(this,T,"f").fire([...Ue(this,C,"f").keys()]),Ue(this,C,"f").clear(),Ue(this,D,"f")&&Ue(this,D,"f").$clear(this._owner)}forEach(b,f){this._checkDisposed();for(let l of Ue(this,C,"f").keys())b.apply(f,[l,this.get(l),this])}get(b){this._checkDisposed();const f=Ue(this,C,"f").get(b);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ue(this,C,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,f){return b[0].toString()<f[0].toString()?-1:b[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=m,D=new WeakMap,T=new WeakMap,C=new WeakMap;let v=class li{constructor(b,f,l){this._logService=f,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:h=>h.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=b.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(b){const f=new L.ResourceMap;for(const l of b)f.set(l,l);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(b,f){const{_collections:l,_proxy:h,_onDidChangeDiagnostics:o,_logService:E,_fileSystemInfoService:r}=this,s=new class{$changeMany(a,c){h.$changeMany(a,c),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,a,c.length===0?"CLEARING":c)}$clear(a){h.$clear(a),E.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,a)}dispose(){h.dispose()}};let n;if(!f)f="_generated_diagnostic_collection_name_#"+li._idPool++,n=f;else if(!l.has(f))n=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do n=f+li._idPool++;while(l.has(n))}return new class extends m{constructor(){super(f,n,li._maxDiagnosticsPerFile,r.extUri,s,o);l.set(n,this)}dispose(){super.dispose(),l.delete(n)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const f=new Map,l=[];for(const h of this._collections.values())h.forEach((o,E)=>{let r=f.get(o.toString());typeof r=="undefined"&&(r=l.length,f.set(o.toString(),r),l.push([o,[]])),l[r][1]=l[r][1].concat(...E)});return l}}_getDiagnostics(b){let f=[];for(let l of this._collections.values())l.has(b)&&(f=f.concat(l.get(b)));return f}$acceptMarkersChange(b){if(!this._mirrorCollection){const f="_generated_mirror",l=new m(f,f,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,l),this._mirrorCollection=l}for(const[f,l]of b)this._mirrorCollection.set(_.URI.revive(f),l.map(y.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([xe(1,P.ILogService),xe(2,I.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(ye[236],De([0,1,2,5]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(k){this._proxy=k.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(y=>y?y.map(w=>d.URI.revive(w)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(y=>y?d.URI.revive(y):void 0)}}e.ExtHostDialogs=_}),define(ye[237],De([0,1,11,2,7,5,10,21,8]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,D,T){this._documentsAndEditors=D,this._logService=T,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,D){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const T=P._handlePool++;this._documentContentProviders.set(T,D),this._proxy.$registerTextContentProvider(T,I);let C;return typeof D.onDidChange=="function"&&(C=D.onDidChange(m=>{if(m.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(T,m).then(v=>{if(!v&&typeof v!="string")return;const g=this._documentsAndEditors.getDocument(m);if(!g)return;const b=(0,w.splitLines)(v);if(!g.equalLines(b))return this._proxy.$onVirtualDocumentChange(m,v)},d.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,D){const T=this._documentContentProviders.get(I);return T?Promise.resolve(T.provideTextDocumentContent(i.URI.revive(D),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${D.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ye[238],De([0,1,3,6,2,5,124,15,14,26,7]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(T,C){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=C,this._documentsAndEditors.onDidRemoveDocuments(m=>{for(const v of m)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(m=>{for(const v of m)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const C=this._documentsAndEditors.getDocument(T);if(C)return C}getDocument(T){const C=this.getDocumentData(T);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return C.document}ensureDocumentData(T){const C=this._documentsAndEditors.getDocument(T);if(C)return Promise.resolve(C);let m=this._documentLoader.get(T.toString());return m||(m=this._proxy.$tryOpenDocument(T).then(v=>{this._documentLoader.delete(T.toString());const g=_.URI.revive(v);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(g))},v=>(this._documentLoader.delete(T.toString()),Promise.reject(v))),this._documentLoader.set(T.toString(),m)),m}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(C=>_.URI.revive(C))}$acceptModelLanguageChanged(T,C){const m=_.URI.revive(T),v=this._documentsAndEditors.getDocument(m);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(C),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(T){const C=_.URI.revive(T),m=this._documentsAndEditors.getDocument(C);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(m.document)}$acceptDirtyStateChanged(T,C){const m=_.URI.revive(T),v=this._documentsAndEditors.getDocument(m);if(!v)throw new Error("unknown document");v._acceptIsDirty(C),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,C,m){const v=_.URI.revive(T),g=this._documentsAndEditors.getDocument(v);if(!g)throw new Error("unknown document");g._acceptIsDirty(m),g.onEvents(C);let b;C.isUndoing?b=L.TextDocumentChangeReason.Undo:C.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:g.document,contentChanges:C.changes.map(f=>({range:y.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:b}))}setWordDefinitionFor(T,C){(0,k.setWordDefinitionFor)(T,C)}}e.ExtHostDocuments=I}),define(ye[54],De([0,1,56,3,6,2,4,5,124,18,133,15,13,24,10,79,80]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(l,h){this._extHostRpc=l,this._logService=h,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const h=[],o=[],E=[];if(l.removedDocuments)for(const r of l.removedDocuments){const s=A.URI.revive(r),n=this._documents.get(s);n?.unref()&&(this._documents.delete(s),h.push(n.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const s=A.URI.revive(r.uri);let n=this._documents.get(s);if(n&&s.scheme!==C.Schemas.vscodeNotebookCell&&s.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);n||(n=new g(new w.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,n),o.push(n.value)),n.ref()}if(l.removedEditors)for(const r of l.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&E.push(s)}if(l.addedEditors)for(const r of l.addedEditors){const s=A.URI.revive(r.documentUri);d.ok(this._documents.has(s),`document '${s}' does not exist`),d.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(s).value,t=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>n.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(a=>I.Range.to(a)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}l.newActiveEditor!==void 0&&(d.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,_.dispose)(h),(0,_.dispose)(E),l.removedDocuments&&this._onDidRemoveDocuments.fire(h),l.addedDocuments&&this._onDidAddDocuments.fire(o),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return m.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const h=this._editors.get(this._activeEditorId);return l?h:h?.value}allEditors(){return[...this._editors.values()]}};b=je([xe(0,P.IExtHostRpcService),xe(1,D.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[55],De([0,1,15,5,2,3,4,7,18,14,57]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class I{constructor(v,g,b){this._activeTabIdGetter=b,this._parentGroup=g,this.acceptDtoUpdate(v)}get apiObject(){if(!this._apiObject){const v=this,g={get isActive(){return v._dto.id===v._activeTabIdGetter()},get label(){return v._dto.label},get input(){return v._input},get isDirty(){return v._dto.isDirty},get isPinned(){return v._dto.isPinned},get isPreview(){return v._dto.isPreview},get group(){return v._parentGroup.apiObject}};this._apiObject=Object.freeze(g)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(v){this._dto=v,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new y.TextTabInput(_.URI.revive(this._dto.input.uri));case 2:return new y.TextDiffTabInput(_.URI.revive(this._dto.input.original),_.URI.revive(this._dto.input.modified));case 5:return new y.CustomEditorTabInput(_.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new y.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new y.NotebookEditorTabInput(_.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new y.NotebookDiffEditorTabInput(_.URI.revive(this._dto.input.original),_.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new y.TerminalEditorTabInput;default:return}}}class D{constructor(v,g,b){this._tabs=[],this._activeTabId="",this._dto=v,this._activeGroupIdGetter=b;for(const f of v.tabs)f.isActive&&(this._activeTabId=f.id),this._tabs.push(new I(f,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const v=this,g={get isActive(){return v._dto.groupId===v._activeGroupIdGetter()},get viewColumn(){return d.ViewColumn.to(v._dto.viewColumn)},get activeTab(){return v._tabs.find(b=>b.tabId===v._activeTabId)?.apiObject},get tabs(){return Object.freeze(v._tabs.map(b=>b.apiObject))}};this._apiObject=Object.freeze(g)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(v){this._dto=v}acceptTabOperation(v){if(v.kind===0){const b=new I(v.tabDto,this,()=>this.activeTabId());return this._tabs.splice(v.index,0,b),v.tabDto.isActive&&(this._activeTabId=b.tabId),b}else if(v.kind===1){const b=this._tabs.splice(v.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${v.index} which does not exist`);return b.tabId===this._activeTabId&&(this._activeTabId=""),b}else if(v.kind===3){if(v.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this._tabs.splice(v.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${v.oldIndex} which does not exist`);return this._tabs.splice(v.index,0,b),b}const g=this._tabs.find(b=>b.tabId===v.tabDto.id);if(!g)throw new Error("INVALID tab");return v.tabDto.isActive?this._activeTabId=v.tabDto.id:this._activeTabId===v.tabDto.id&&!v.tabDto.isActive&&(this._activeTabId=""),g.acceptDtoUpdate(v.tabDto),g}activeTabId(){return this._activeTabId}}let T=class{constructor(v){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=v.getProxy(i.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const v=this,g={onDidChangeTabGroups:v._onDidChangeTabGroups.event,onDidChangeTabs:v._onDidChangeTabs.event,get all(){return Object.freeze(v._extHostTabGroups.map(b=>b.apiObject))},get activeTabGroup(){const b=v._activeGroupId;return(0,P.assertIsDefined)(v._extHostTabGroups.find(l=>l.groupId===b)?.apiObject)},close:async(b,f)=>{const l=Array.isArray(b)?b:[b];return l.length?C(l[0])?this._closeGroups(l,f):this._closeTabs(l,f):!0}};this._apiObject=Object.freeze(g)}return this._apiObject}$acceptEditorTabModel(v){const g=new Set(this._extHostTabGroups.map(r=>r.groupId)),b=new Set(v.map(r=>r.groupId)),f=(0,L.diffSets)(g,b),l=this._extHostTabGroups.filter(r=>f.removed.includes(r.groupId)).map(r=>r.apiObject),h=[],o=[];this._extHostTabGroups=v.map(r=>{const s=new D(r,this._proxy,()=>this._activeGroupId);return f.added.includes(s.groupId)?h.push(s.apiObject):o.push(s.apiObject),s});const E=(0,P.assertIsDefined)(v.find(r=>r.isActive===!0)?.groupId);E!==void 0&&this._activeGroupId!==E&&(this._activeGroupId=E),this._onDidChangeTabGroups.fire(Object.freeze({opened:h,closed:l,changed:o}))}$acceptTabGroupUpdate(v){const g=this._extHostTabGroups.find(b=>b.groupId===v.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(v),v.isActive&&(this._activeGroupId=v.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(v){const g=this._extHostTabGroups.find(f=>f.groupId===v.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const b=g.acceptTabOperation(v);switch(v.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}_findExtHostTabFromApi(v){for(const g of this._extHostTabGroups)for(const b of g.tabs)if(b.apiObject===v)return b}_findExtHostTabGroupFromApi(v){return this._extHostTabGroups.find(g=>g.apiObject===v)}async _closeTabs(v,g){const b=[];for(const f of v){const l=this._findExtHostTabFromApi(f);if(!l)throw new Error("Tab close: Invalid tab not found!");b.push(l.tabId)}return this._proxy.$closeTab(b,g)}async _closeGroups(v,g){const b=[];for(const f of v){const l=this._findExtHostTabGroupFromApi(f);if(!l)throw new Error("Group close: Invalid group not found!");b.push(l.groupId)}return this._proxy.$closeGroup(b,g)}};T=je([xe(0,w.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function C(m){return m.tabs!==void 0}}),define(ye[239],De([0,1,2,5,6,7,15,154,8,23,25]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(C){this._stateMachine=void 0,this._schemes.push(C)}delete(C){const m=this._schemes.indexOf(C);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const C=this._schemes.sort(),m=[];let v,g,b=14,f=14;for(const l of C){let h=v?(0,w.commonPrefixLength)(v,l):0;for(h===0?g=1:g=f;h<l.length;h++)h+1===l.length?(b=f,f=9):f+=1,m.push([g,l.toUpperCase().charCodeAt(h),f]),m.push([g,l.toLowerCase().charCodeAt(h),f]),g=f;v=l,f=b}m.push([9,58,10]),m.push([10,47,12]),this._stateMachine=new y.StateMachine(m)}}provideDocumentLinks(C){this._initStateMachine();const m=[],v=y.LinkComputer.computeLinks({getLineContent(g){return C.lineAt(g-1).text},getLineCount(){return C.lineCount}},this._stateMachine);for(const g of v){const b=k.DocumentLink.to(g);b.target&&m.push(b)}return m}}class D{constructor(C,m){this._extHostLanguageFeatures=m,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=C.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(C,m,v,g={}){if(this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(C,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(b,v);let f=2;g.isCaseSensitive&&(f+=1024),g.isReadonly&&(f+=2048),typeof v.copy=="function"&&(f+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(C,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(b,m,f).catch(h=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${m}`),console.error(h)});const l=v.onDidChangeFile(h=>{const o=[];for(const E of h){let{uri:r,type:s}=E;if(r.scheme!==m)continue;let n;switch(s){case A.FileChangeType.Changed:n=0;break;case A.FileChangeType.Created:n=1;break;case A.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:n})}this._proxy.$onFileSystemChange(b,o)});return(0,_.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(C){const{type:m,ctime:v,mtime:g,size:b,permissions:f}=C;return{type:m,ctime:v,mtime:g,size:b,permissions:f}}$stat(C,m){return Promise.resolve(this._getFsProvider(C).stat(d.URI.revive(m))).then(v=>D._asIStat(v))}$readdir(C,m){return Promise.resolve(this._getFsProvider(C).readDirectory(d.URI.revive(m)))}$readFile(C,m){return Promise.resolve(this._getFsProvider(C).readFile(d.URI.revive(m))).then(v=>P.VSBuffer.wrap(v))}$writeFile(C,m,v,g){return Promise.resolve(this._getFsProvider(C).writeFile(d.URI.revive(m),v.buffer,g))}$delete(C,m,v){return Promise.resolve(this._getFsProvider(C).delete(d.URI.revive(m),v))}$rename(C,m,v,g){return Promise.resolve(this._getFsProvider(C).rename(d.URI.revive(m),d.URI.revive(v),g))}$copy(C,m,v,g){const b=this._getFsProvider(C);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(d.URI.revive(m),d.URI.revive(v),g))}$mkdir(C,m){return Promise.resolve(this._getFsProvider(C).createDirectory(d.URI.revive(m)))}$watch(C,m,v,g){const b=this._getFsProvider(C).watch(d.URI.revive(v),g);this._watches.set(m,b)}$unwatch(C,m){const v=this._watches.get(m);v&&(v.dispose(),this._watches.delete(m))}$open(C,m,v){const g=this._getFsProvider(C);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(d.URI.revive(m),v))}$close(C,m){const v=this._getFsProvider(C);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(m))}$read(C,m,v,g){const b=this._getFsProvider(C);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const f=P.VSBuffer.alloc(g);return Promise.resolve(b.read(m,v,f.buffer,0,g)).then(l=>f.slice(0,l))}$write(C,m,v,g){const b=this._getFsProvider(C);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(m,v,g.buffer,0,g.byteLength))}_getFsProvider(C){const m=this._fsProvider.get(C);if(!m){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return m}}e.ExtHostFileSystem=D}),define(ye[68],De([0,1,5,42,7,23,4,18,46,6]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Gt{constructor(D,T){this._fileSystemProvider=new Map,this._proxy=D.getProxy(d.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(m){try{const v=C._fileSystemProvider.get(m.scheme);if(!v)return await C._proxy.$stat(m);await C._proxy.$ensureActivation(m.scheme);const g=await v.stat(m);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions}}catch(v){Gt._handleError(v)}},async readDirectory(m){try{const v=C._fileSystemProvider.get(m.scheme);return v?(await C._proxy.$ensureActivation(m.scheme),(await v.readDirectory(m)).slice()):await C._proxy.$readdir(m)}catch(v){return Gt._handleError(v)}},async createDirectory(m){try{return await C._proxy.$mkdir(m)}catch(v){return Gt._handleError(v)}},async readFile(m){try{const v=C._fileSystemProvider.get(m.scheme);return v?(await C._proxy.$ensureActivation(m.scheme),(await v.readFile(m)).slice()):(await C._proxy.$readFile(m)).buffer}catch(v){return Gt._handleError(v)}},async writeFile(m,v){try{return await C._proxy.$writeFile(m,A.VSBuffer.wrap(v))}catch(g){return Gt._handleError(g)}},async delete(m,v){try{const g=C._fileSystemProvider.get(m.scheme);return g?(await C._proxy.$ensureActivation(m.scheme),await g.delete(m,{recursive:!1,...v})):await C._proxy.$delete(m,{recursive:!1,useTrash:!1,...v})}catch(g){return Gt._handleError(g)}},async rename(m,v,g){try{return await C._proxy.$rename(m,v,{overwrite:!1,...g})}catch(b){return Gt._handleError(b)}},async copy(m,v,g){try{return await C._proxy.$copy(m,v,{overwrite:!1,...g})}catch(b){return Gt._handleError(b)}},isWritableFileSystem(m){const v=T.getCapabilities(m);if(typeof v=="number")return!(v&2048)}})}static _handleError(D){if(D instanceof _.FileSystemError)throw D;if(!(D instanceof Error))throw new _.FileSystemError(String(D));if(D.name==="ENOPRO")throw _.FileSystemError.Unavailable(D.message);switch(D.name){case i.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(D.message);case i.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(D.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(D.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(D.message);case i.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(D.message);case i.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(D.message);default:throw new _.FileSystemError(D.message,D.name)}}addFileSystemProvider(D,T){return this._fileSystemProvider.set(D,T),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(D))}};L=je([xe(0,y.IExtHostRpcService),xe(1,w.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[240],De([0,1,3,35,2,5,15,7]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{constructor(I,D,T,C,m,v,g,b){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter;const f=this.ensureWatching(I,T,m);this._config=0,v&&(this._config+=1),g&&(this._config+=2),b&&(this._config+=4);const l=(0,i.parse)(m),h=typeof m=="string",o=C(E=>{if(!v)for(let r of E.created){const s=_.URI.revive(r);l(s.fsPath)&&(!h||D.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(let r of E.changed){const s=_.URI.revive(r);l(s.fsPath)&&(!h||D.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!b)for(let r of E.deleted){const s=_.URI.revive(r);l(s.fsPath)&&(!h||D.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=y.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(I,D,T){let C=y.Disposable.from();if(typeof T=="string")return C;const m=I.getProxy(A.MainContext.MainThreadFileSystem);let v=!1;(T.pattern.includes(i.GLOBSTAR)||T.pattern.includes(i.GLOB_SPLIT))&&(v=!0);const g=Math.random();return m.$watch(D.identifier.value,g,T.baseUri,{recursive:v,excludes:[]}),y.Disposable.from({dispose:()=>m.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(I,D,T){this._mainContext=I,this._logService=D,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,D,T,C,m,v){return new w(this._mainContext,I,D,this._onFileSystemEvent.event,k.GlobPattern.from(T),C,m,v)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,D){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:D.map(T=>({oldUri:_.URI.revive(T.source),newUri:_.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:D.map(T=>_.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:D.map(T=>_.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,D){return(T,C,m)=>{const v=function(b){T.call(C,b)};return v.extension=I,D.event(v,void 0,m)}}async $onWillRunFileOperation(I,D,T,C){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:D.map(m=>({oldUri:_.URI.revive(m.source),newUri:_.URI.revive(m.target)}))},T,C);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:D.map(m=>_.URI.revive(m.target))},T,C);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:D.map(m=>_.URI.revive(m.target))},T,C)}}async _fireWillEvent(I,D,T,C){const m=new Set,v=[];if(await I.fireAsync(D,C,async(b,f)=>{const l=Date.now(),h=await Promise.resolve(b);h instanceof y.WorkspaceEdit&&(v.push(h),m.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-l>T&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),C.isCancellationRequested||v.length===0)return;const g={edits:[]};for(let b of v){let{edits:f}=k.WorkspaceEdit.from(b,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});g.edits=g.edits.concat(f)}return{edit:g,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=P}),define(ye[241],De([0,1,2,38]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(k,y,w,P){this._extHostNotebooks=y,this._textDocumentsAndEditors=w,this._commands=P;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new i.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new i.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new i.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new i.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const D=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:d.URI.revive(I.notebookUri),inputUri:d.URI.revive(I.inputUri),notebookEditor:D.apiEditor}}return{notebookUri:d.URI.revive(I.notebookUri),inputUri:d.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(k,y,w,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],languageId:w,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=_}),define(ye[242],De([0,1,6,5]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(k){this._handlePool=0,this._proxy=k.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,k),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=_}),define(ye[243],De([0,1,2,26,15,7,62,5,8,37,16,14,149,21,6,111,78,86,48,11,3,17,25,125]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l,h,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class r{constructor(B,q){this._documents=B,this._provider=q}async provideDocumentSymbols(B,q){const J=this._documents.getDocument(B),te=await this._provider.provideDocumentSymbols(J,q);if(!(0,L.isFalsyOrEmpty)(te))return te[0]instanceof A.DocumentSymbol?te.map(_.DocumentSymbol.from):r._asDocumentSymbolTree(te)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((te,K)=>{let ae=te.location.range.start.compareTo(K.location.range.start);return ae===0&&(ae=K.location.range.end.compareTo(te.location.range.end)),ae});const q=[],J=[];for(const te of B){const K={name:te.name||"!!MISSING: name!!",kind:_.SymbolKind.from(te.kind),tags:te.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:te.containerName,range:_.Range.from(te.location.range),selectionRange:_.Range.from(te.location.range),children:[]};for(;;){if(J.length===0){J.push(K),q.push(K);break}const ae=J[J.length-1];if(P.Range.containsRange(ae.range,K.range)&&!P.Range.equalsRange(ae.range,K.range)){ae.children&&ae.children.push(K),J.push(K);break}J.pop()}}return q}}class s{constructor(B,q,J){this._documents=B,this._commands=q,this._provider=J,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,q){const J=this._documents.getDocument(B),te=await this._provider.provideCodeLenses(J,q);if(!te||q.isCancellationRequested)return;const K=this._cache.add(te),ae=new C.DisposableStore;this._disposables.set(K,ae);const de={cacheId:K,lenses:[]};for(let Be=0;Be<te.length;Be++)de.lenses.push({cacheId:[K,Be],range:_.Range.from(te[Be].range),command:this._commands.toInternal(te[Be].command,ae)});return de}async resolveCodeLens(B,q){const J=B.cacheId&&this._cache.get(...B.cacheId);if(!J)return;let te;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?te=J:te=await this._provider.resolveCodeLens(J,q),te||(te=J),q.isCancellationRequested)return;const K=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!K)return B.command=this._commands.toInternal(te.command??s._badCmd,K),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(Te){return Array.isArray(Te)?Te.map(_.DefinitionLink.from):Te?[_.DefinitionLink.from(Te)]:[]}class t{constructor(B,q){this._documents=B,this._provider=q}async provideDefinition(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideDefinition(te,K,J);return n(ae)}}class a{constructor(B,q){this._documents=B,this._provider=q}async provideDeclaration(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideDeclaration(te,K,J);return n(ae)}}class c{constructor(B,q){this._documents=B,this._provider=q}async provideImplementation(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideImplementation(te,K,J);return n(ae)}}class u{constructor(B,q){this._documents=B,this._provider=q}async provideTypeDefinition(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideTypeDefinition(te,K,J);return n(ae)}}class S{constructor(B,q){this._documents=B,this._provider=q}async provideHover(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideHover(te,K,J);if(!(!ae||(0,L.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=te.getWordRangeAtPosition(K)),ae.range||(ae.range=new A.Range(K,K)),_.Hover.from(ae)}}class R{constructor(B,q){this._documents=B,this._provider=q}async provideEvaluatableExpression(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideEvaluatableExpression(te,K,J);if(ae)return _.EvaluatableExpression.from(ae)}}class O{constructor(B,q){this._documents=B,this._provider=q}async provideInlineValues(B,q,J,te){const K=this._documents.getDocument(B),ae=await this._provider.provideInlineValues(K,_.Range.to(q),_.InlineValueContext.to(J),te);if(Array.isArray(ae))return ae.map(de=>_.InlineValue.from(de))}}class N{constructor(B,q){this._documents=B,this._provider=q}async provideDocumentHighlights(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideDocumentHighlights(te,K,J);if(Array.isArray(ae))return ae.map(_.DocumentHighlight.from)}}class p{constructor(B,q){this._documents=B,this._provider=q}async provideLinkedEditingRanges(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.provideLinkedEditingRanges(te,K,J);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,L.coalesce)(ae.ranges.map(_.Range.from)),wordPattern:ae.wordPattern}}}class M{constructor(B,q){this._documents=B,this._provider=q}async provideReferences(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q),de=await this._provider.provideReferences(K,ae,J,te);if(Array.isArray(de))return de.map(_.location.from)}}class U{constructor(B,q,J,te,K,ae,de){this._documents=B,this._commands=q,this._diagnostics=J,this._provider=te,this._logService=K,this._extension=ae,this._apiDeprecation=de,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,q,J,te){const K=this._documents.getDocument(B),ae=D.Selection.isISelection(q)?_.Selection.to(q):_.Range.to(q),de=[];for(const se of this._diagnostics.getDiagnostics(B))if(ae.intersection(se.range)&&de.push(se)>U._maxCodeActionsPerFile)break;const Be={diagnostics:de,only:J.only?new A.CodeActionKind(J.only):void 0,triggerKind:_.CodeActionTriggerKind.to(J.trigger)},$e=await this._provider.provideCodeActions(K,ae,Be,te);if(!(0,L.isNonEmptyArray)($e)||te.isCancellationRequested)return;const Ne=this._cache.add($e),Xe=new C.DisposableStore;this._disposables.set(Ne,Xe);const ee=[];for(let se=0;se<$e.length;se++){const be=$e[se];!be||(U._isCommand(be)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ee.push({_isSynthetic:!0,title:be.title,command:this._commands.toInternal(be,Xe)})):(Be.only&&(be.kind?Be.only.contains(be.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${be.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ee.push({cacheId:[Ne,se],title:be.title,command:be.command&&this._commands.toInternal(be.command,Xe),diagnostics:be.diagnostics&&be.diagnostics.map(_.Diagnostic.from),edit:be.edit&&_.WorkspaceEdit.from(be.edit),kind:be.kind&&be.kind.value,isPreferred:be.isPreferred,disabled:be.disabled?.reason})))}return{cacheId:Ne,actions:ee}}async resolveCodeAction(B,q){const[J,te]=B,K=this._cache.get(J,te);if(!K||U._isCommand(K)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(K,q)??K;return ae?.edit?_.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}U._maxCodeActionsPerFile=1e3;class z{constructor(B,q){this._documents=B,this._provider=q}async provideDocumentFormattingEdits(B,q,J){const te=this._documents.getDocument(B),K=await this._provider.provideDocumentFormattingEdits(te,q,J);if(Array.isArray(K))return K.map(_.TextEdit.from)}}class re{constructor(B,q){this._documents=B,this._provider=q}async provideDocumentRangeFormattingEdits(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Range.to(q),de=await this._provider.provideDocumentRangeFormattingEdits(K,ae,J,te);if(Array.isArray(de))return de.map(_.TextEdit.from)}}class H{constructor(B,q){this._documents=B,this._provider=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,q,J,te,K){const ae=this._documents.getDocument(B),de=_.Position.to(q),Be=await this._provider.provideOnTypeFormattingEdits(ae,de,J,te,K);if(Array.isArray(Be))return Be.map(_.TextEdit.from)}}class F{constructor(B,q){this._provider=B,this._logService=q,this._cache=new g.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,q){const J=await this._provider.provideWorkspaceSymbols(B,q);if(!(0,L.isNonEmptyArray)(J))return{symbols:[]};const te=this._cache.add(J),K={cacheId:te,symbols:[]};for(let ae=0;ae<J.length;ae++){const de=J[ae];if(!de||!de.name){this._logService.warn("INVALID SymbolInformation",de);continue}K.symbols.push({..._.WorkspaceSymbol.from(de),cacheId:[te,ae]})}return K}async resolveWorkspaceSymbol(B,q){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const J=this._cache.get(...B.cacheId);if(J){const te=await this._provider.resolveWorkspaceSymbol(J,q);return te&&(0,i.mixin)(B,_.WorkspaceSymbol.from(te),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class j{constructor(B,q,J){this._documents=B,this._provider=q,this._logService=J}static supportsResolving(B){return typeof B.prepareRename=="function"}async provideRenameEdits(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q);try{const de=await this._provider.provideRenameEdits(K,ae,J,te);return de?_.WorkspaceEdit.from(de):void 0}catch(de){const Be=j._asMessage(de);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(B,q,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const te=this._documents.getDocument(B),K=_.Position.to(q);try{const ae=await this._provider.prepareRename(te,K,J);let de,Be;if(A.Range.isRange(ae)?(de=ae,Be=te.getText(ae)):(0,I.isObject)(ae)&&(de=ae.range,Be=ae.placeholder),!de||!Be)return;if(de.start.line>K.line||de.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(de),text:Be}}catch(ae){const de=j._asMessage(ae);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class x{constructor(B,q){this.resultId=B,this.tokens=q}}class V{constructor(B,q){this._documents=B,this._provider=q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,q,J){const te=this._documents.getDocument(B),K=q!==0?this._previousResults.get(q):null;let ae=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(te,K.resultId,J):await this._provider.provideDocumentSemanticTokens(te,J);return K&&this._previousResults.delete(q),ae?(ae=V._fixProvidedSemanticTokens(ae),this._send(V._convertToEdits(K,ae),ae)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return V._isSemanticTokens(B)?V._isCorrectSemanticTokens(B)?B:new A.SemanticTokens(new Uint32Array(B.data),B.resultId):V._isSemanticTokensEdits(B)?V._isCorrectSemanticTokensEdits(B)?B:new A.SemanticTokensEdits(B.edits.map(q=>new A.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const q of B.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,q){if(!V._isSemanticTokens(q)||!B||!B.tokens)return q;const J=B.tokens,te=J.length,K=q.data,ae=K.length;let de=0;const Be=Math.min(te,ae);for(;de<Be&&J[de]===K[de];)de++;if(de===te&&de===ae)return new A.SemanticTokensEdits([],q.resultId);let $e=0;const Ne=Be-de;for(;$e<Ne&&J[te-$e-1]===K[ae-$e-1];)$e++;return new A.SemanticTokensEdits([{start:de,deleteCount:te-de-$e,data:K.subarray(de,ae-$e)}],q.resultId)}_send(B,q){if(V._isSemanticTokens(B)){const J=this._nextResultId++;return this._previousResults.set(J,new x(B.resultId,B.data)),(0,m.encodeSemanticTokensDto)({id:J,type:"full",data:B.data})}if(V._isSemanticTokensEdits(B)){const J=this._nextResultId++;return V._isSemanticTokens(q)?this._previousResults.set(J,new x(q.resultId,q.data)):this._previousResults.set(J,new x(B.resultId)),(0,m.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(B.edits||[]).map(te=>({start:te.start,deleteCount:te.deleteCount,data:te.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class ne{constructor(B,q){this._documents=B,this._provider=q}async provideDocumentRangeSemanticTokens(B,q,J){const te=this._documents.getDocument(B),K=await this._provider.provideDocumentRangeSemanticTokens(te,_.Range.to(q),J);return K?this._send(K):null}_send(B){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=ne;class Q{constructor(B,q,J,te,K){this._documents=B,this._commands=q,this._provider=J,this._apiDeprecation=te,this._extension=K,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q),de=K.getWordRangeAtPosition(ae)||new A.Range(ae,ae),Be=de.with({end:ae}),$e=new b.StopWatch(!0),Ne=await this._provider.provideCompletionItems(K,ae,te,_.CompletionContext.to(J));if(!Ne||te.isCancellationRequested)return;const Xe=Array.isArray(Ne)?new A.CompletionList(Ne):Ne,ee=Q.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),se=new C.DisposableStore;this._disposables.set(ee,se);const be=[],le={x:ee,b:be,a:{replace:_.Range.from(de),insert:_.Range.from(Be)},c:Xe.isIncomplete||void 0,d:$e.elapsed()};for(let _e=0;_e<Xe.items.length;_e++){const Fe=Xe.items[_e],He=this._convertCompletionItem(Fe,[ee,_e],Be,de);be.push(He)}return le}async resolveCompletionItem(B,q){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...B);if(!J)return;const te=await this._provider.resolveCompletionItem(J,q);if(!!te)return this._convertCompletionItem(te,B)}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,q,J,te){const K=this._disposables.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const ae={x:q,a:B.label,b:B.kind!==void 0?_.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(_.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(B.command,K)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=B.textEdit.newText):typeof B.insertText=="string"?ae.h=B.insertText:B.insertText instanceof A.SnippetString&&(ae.h=B.insertText.value,ae.i|=4);let de;return B.textEdit?de=B.textEdit.range:B.range&&(de=B.range),A.Range.isRange(de)?ae.j=_.Range.from(de):de&&(!J?.isEqual(de.inserting)||!te?.isEqual(de.replacing))&&(ae.j={insert:_.Range.from(de.inserting),replace:_.Range.from(de.replacing)}),ae}}class he{async provideInlineCompletions(B,q,J,te){}disposeCompletions(B){}handleDidShowCompletionItem(B,q){}}class fe extends he{constructor(B,q,J){super();this._documents=B,this._provider=q,this._commands=J,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q),de=await this._provider.provideInlineCompletionItems(K,ae,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:_.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text,isSnippetText:J.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to(J.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:J.triggerKind},te);if(!de||te.isCancellationRequested)return;const Be=(0,I.isArray)(de)?de:de.items,$e=this._cache.add(Be);let Ne;return{pid:$e,items:Be.map((Xe,ee)=>{let se;Xe.command&&(Ne||(Ne=new C.DisposableStore,this._disposables.set($e,Ne)),se=this._commands.toInternal(Xe.command,Ne));const be=Xe.insertText??Xe.text;if(be===void 0)throw new Error("text or insertText must be defined");return{insertText:typeof be=="string"?be:{snippet:be.value},range:Xe.range?_.Range.from(Xe.range):void 0,command:se,idx:ee,completeBracketPairs:Xe.completeBracketPairs}})}}disposeCompletions(B){this._cache.delete(B);const q=this._disposables.get(B);q&&q.clear(),this._disposables.delete(B)}handleDidShowCompletionItem(B,q){const J=this._cache.get(B,q);J&&ce.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class G extends he{constructor(B,q,J,te){super();this.extension=B,this._documents=q,this._provider=J,this._commands=te,this._references=new X,this.isAdditionProposedApiEnabled=(0,o.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[k.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKindNew.Automatic,[k.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q),de=await this._provider.provideInlineCompletionItems(K,ae,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:_.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[J.triggerKind]},te);if(!de||te.isCancellationRequested)return;const Be=(0,I.isArray)(de)?de:de.items,$e=(0,I.isArray)(de)?[]:de.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:Be}),items:Be.map((ee,se)=>{let be;ee.command&&(Ne||(Ne=new C.DisposableStore),be=this._commands.toInternal(ee.command,Ne));const le=ee.insertText;return{insertText:typeof le=="string"?le:{snippet:le.value},filterText:ee.filterText,range:ee.range?_.Range.from(ee.range):void 0,command:be,idx:se,completeBracketPairs:this.isAdditionProposedApiEnabled?ee.completeBracketPairs:!1}}),commands:$e.map(ee=>(Ne||(Ne=new C.DisposableStore),this._commands.toInternal(ee,Ne)))}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,q){const J=this._references.get(B)?.items[q];J&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(J)}}class X{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const q=this._idPool++;return this._references.set(q,B),q}disposeReferenceId(B){const q=this._references.get(B);return this._references.delete(B),q}get(B){return this._references.get(B)}}class ce{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(B){let q=ce.map.get(B);return q||(q=new ce,ce.map.set(B,q)),q}fireOnDidShowCompletionItem(B){this._onDidShowCompletionItemEmitter.fire(B)}}e.InlineCompletionController=ce,ce.map=new WeakMap;class pe{constructor(B,q){this._documents=B,this._provider=q,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q),de=this.reviveContext(J),Be=await this._provider.provideSignatureHelp(K,ae,te,de);if(Be){const $e=this._cache.add([Be]);return{..._.SignatureHelp.from(Be),id:$e}}}reviveContext(B){let q;if(B.activeSignatureHelp){const J=_.SignatureHelp.to(B.activeSignatureHelp),te=this._cache.get(B.activeSignatureHelp.id,0);te?(q=te,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...B,activeSignatureHelp:q}}releaseSignatureHelp(B){this._cache.delete(B)}}class Ie{constructor(B,q,J,te,K){this._documents=B,this._commands=q,this._provider=J,this._logService=te,this._extension=K,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,q,J){const te=this._documents.getDocument(B),K=_.Range.to(q),ae=await this._provider.provideInlayHints(te,K,J);if(!Array.isArray(ae)||ae.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${q}`);return}if(J.isCancellationRequested)return;const de=this._cache.add(ae);this._disposables.set(de,new C.DisposableStore);const Be={hints:[],cacheId:de};for(let $e=0;$e<ae.length;$e++)this._isValidInlayHint(ae[$e],K)&&Be.hints.push(this._convertInlayHint(ae[$e],[de,$e]));return this._logService.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this._extension.identifier.value}' for ${q}`),Be}async resolveInlayHint(B,q){if(typeof this._provider.resolveInlayHint!="function")return;const J=this._cache.get(...B);if(!J)return;const te=await this._provider.resolveInlayHint(J,q);if(!!te&&!!this._isValidInlayHint(te))return this._convertInlayHint(te,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(q&&!q.contains(B.position))}_convertInlayHint(B,q){const J=this._disposables.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const te={label:"",cacheId:q,tooltip:_.MarkdownString.fromStrict(B.tooltip),position:_.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(_.TextEdit.from),kind:B.kind&&_.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?te.label=B.label:te.label=B.label.map(K=>{let ae={label:K.value};return ae.tooltip=_.MarkdownString.fromStrict(K.tooltip),A.Location.isLocation(K.location)&&(ae.location=_.location.from(K.location)),K.command&&(ae.command=this._commands.toInternal(K.command,J)),ae}),te}}class Re{constructor(B,q){this._documents=B,this._provider=q,this._cache=new g.Cache("DocumentLink")}async provideLinks(B,q){const J=this._documents.getDocument(B),te=await this._provider.provideDocumentLinks(J,q);if(!(!Array.isArray(te)||te.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:te.filter(Re._validateLink).map(_.DocumentLink.from)};{const K=this._cache.add(te),ae={links:[],cacheId:K};for(let de=0;de<te.length;de++){if(!Re._validateLink(te[de]))continue;const Be=_.DocumentLink.from(te[de]);Be.cacheId=[K,de],ae.links.push(Be)}return ae}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,q){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...B);if(!J)return;const te=await this._provider.resolveDocumentLink(J,q);if(!(!te||!Re._validateLink(te)))return _.DocumentLink.from(te)}releaseLinks(B){this._cache.delete(B)}}class Ce{constructor(B,q){this._documents=B,this._provider=q}async provideColors(B,q){const J=this._documents.getDocument(B),te=await this._provider.provideDocumentColors(J,q);return Array.isArray(te)?te.map(ae=>({color:_.Color.from(ae.color),range:_.Range.from(ae.range)})):[]}async provideColorPresentations(B,q,J){const te=this._documents.getDocument(B),K=_.Range.to(q.range),ae=_.Color.to(q.color),de=await this._provider.provideColorPresentations(ae,{document:te,range:K},J);if(!!Array.isArray(de))return de.map(_.ColorPresentation.from)}}class ke{constructor(B,q){this._documents=B,this._provider=q}async provideFoldingRanges(B,q,J){const te=this._documents.getDocument(B),K=await this._provider.provideFoldingRanges(te,q,J);if(!!Array.isArray(K))return K.map(_.FoldingRange.from)}}class Ae{constructor(B,q,J){this._documents=B,this._provider=q,this._logService=J}async provideSelectionRanges(B,q,J){const te=this._documents.getDocument(B),K=q.map(_.Position.to),ae=await this._provider.provideSelectionRanges(te,K,J);if(!(0,L.isNonEmptyArray)(ae))return[];if(ae.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Be=0;Be<K.length;Be++){const $e=[];de.push($e);let Ne=K[Be],Xe=ae[Be];for(;;){if(!Xe.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if($e.push(_.SelectionRange.from(Xe)),!Xe.parent)break;Ne=Xe.range,Xe=Xe.parent}}return de}}class ue{constructor(B,q){this._documents=B,this._provider=q,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.prepareCallHierarchy(te,K,J);if(!ae)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ae)?ae.map(Be=>this._cacheAndConvertItem(de,Be)):[this._cacheAndConvertItem(de,ae)]}async provideCallsTo(B,q,J){const te=this._itemFromCache(B,q);if(!te)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(te,J);if(!!K)return K.map(ae=>({from:this._cacheAndConvertItem(B,ae.from),fromRanges:ae.fromRanges.map(de=>_.Range.from(de))}))}async provideCallsFrom(B,q,J){const te=this._itemFromCache(B,q);if(!te)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(te,J);if(!!K)return K.map(ae=>({to:this._cacheAndConvertItem(B,ae.to),fromRanges:ae.fromRanges.map(de=>_.Range.from(de))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,q){const J=this._cache.get(B),te=_.CallHierarchyItem.from(q,B,J.size.toString(36));return J.set(te._itemId,q),te}_itemFromCache(B,q){return this._cache.get(B)?.get(q)}}class ve{constructor(B,q){this._documents=B,this._provider=q,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(B,q,J){const te=this._documents.getDocument(B),K=_.Position.to(q),ae=await this._provider.prepareTypeHierarchy(te,K,J);if(!ae)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ae)?ae.map(Be=>this._cacheAndConvertItem(de,Be)):[this._cacheAndConvertItem(de,ae)]}async provideSupertypes(B,q,J){const te=this._itemFromCache(B,q);if(!te)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes(te,J);if(!!K)return K.map(ae=>this._cacheAndConvertItem(B,ae))}async provideSubtypes(B,q,J){const te=this._itemFromCache(B,q);if(!te)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes(te,J);if(!!K)return K.map(ae=>this._cacheAndConvertItem(B,ae))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,q){const J=this._cache.get(B),te=_.TypeHierarchyItem.from(q,B,J.size.toString(36));return J.set(te._itemId,q),te}_itemFromCache(B,q){return this._cache.get(B)?.get(q)}}class ie{constructor(B,q){this._documents=B,this._provider=q}async provideDocumentOnDropEdits(B,q,J,te){const K=this._documents.getDocument(B),ae=_.Position.to(q),de=E.DataTransferConverter.toDataTransfer(J),Be=await this._provider.provideDocumentOnDropEdits(K,ae,de,te);if(!!Be)return _.SnippetTextEdit.from(Be)}}class oe{constructor(B,q){this.adapter=B,this.extension=q}}class we{constructor(B,q,J,te,K,ae,de){this._adapter=new Map,this._uriTransformer=q,this._proxy=B.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=te,this._diagnostics=K,this._logService=ae,this._apiDeprecation=de}_transformDocumentSelector(B){return _.DocumentSelector.from(B,this._uriTransformer)}_createDisposable(B){return new A.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return we._handlePool++}async _withAdapter(B,q,J,te,K,ae=!1){const de=this._adapter.get(B);if(!de||!(de.adapter instanceof q))return te;const Be=Date.now();ae||this._logService.trace(`[${de.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const $e=J(de.adapter,de.extension);return Promise.resolve($e).catch(Ne=>{(0,f.isCancellationError)(Ne)||(this._logService.error(`[${de.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ae||this._logService.trace(`[${de.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),T.CancellationToken.isCancellationToken(K)?(0,h.raceCancellationError)($e,K):$e}_addNewAdapter(B,q){const J=this._nextHandle();return this._adapter.set(J,new oe(B,q)),J}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,q,J,te){const K=this._addNewAdapter(new r(this._documents,J),B),ae=te&&te.label||we._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(q),ae),this._createDisposable(K)}$provideDocumentSymbols(B,q,J){return this._withAdapter(B,r,te=>te.provideDocumentSymbols(d.URI.revive(q),J),void 0,J)}registerCodeLensProvider(B,q,J){const te=this._nextHandle(),K=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(te,new oe(new s(this._documents,this._commands.converter,J),B)),this._proxy.$registerCodeLensSupport(te,this._transformDocumentSelector(q),K);let ae=this._createDisposable(te);if(K!==void 0){const de=J.onDidChangeCodeLenses(Be=>this._proxy.$emitCodeLensEvent(K));ae=A.Disposable.from(ae,de)}return ae}$provideCodeLenses(B,q,J){return this._withAdapter(B,s,te=>te.provideCodeLenses(d.URI.revive(q),J),void 0,J)}$resolveCodeLens(B,q,J){return this._withAdapter(B,s,te=>te.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(B,q){this._withAdapter(B,s,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(B,q,J){const te=this._addNewAdapter(new t(this._documents,J),B);return this._proxy.$registerDefinitionSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideDefinition(B,q,J,te){return this._withAdapter(B,t,K=>K.provideDefinition(d.URI.revive(q),J,te),[],te)}registerDeclarationProvider(B,q,J){const te=this._addNewAdapter(new a(this._documents,J),B);return this._proxy.$registerDeclarationSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideDeclaration(B,q,J,te){return this._withAdapter(B,a,K=>K.provideDeclaration(d.URI.revive(q),J,te),[],te)}registerImplementationProvider(B,q,J){const te=this._addNewAdapter(new c(this._documents,J),B);return this._proxy.$registerImplementationSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideImplementation(B,q,J,te){return this._withAdapter(B,c,K=>K.provideImplementation(d.URI.revive(q),J,te),[],te)}registerTypeDefinitionProvider(B,q,J){const te=this._addNewAdapter(new u(this._documents,J),B);return this._proxy.$registerTypeDefinitionSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideTypeDefinition(B,q,J,te){return this._withAdapter(B,u,K=>K.provideTypeDefinition(d.URI.revive(q),J,te),[],te)}registerHoverProvider(B,q,J,te){const K=this._addNewAdapter(new S(this._documents,J),B);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(q)),this._createDisposable(K)}$provideHover(B,q,J,te){return this._withAdapter(B,S,K=>K.provideHover(d.URI.revive(q),J,te),void 0,te)}registerEvaluatableExpressionProvider(B,q,J,te){const K=this._addNewAdapter(new R(this._documents,J),B);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(q)),this._createDisposable(K)}$provideEvaluatableExpression(B,q,J,te){return this._withAdapter(B,R,K=>K.provideEvaluatableExpression(d.URI.revive(q),J,te),void 0,te)}registerInlineValuesProvider(B,q,J,te){const K=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new O(this._documents,J),B);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(q),K);let de=this._createDisposable(ae);if(K!==void 0){const Be=J.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(K));de=A.Disposable.from(de,Be)}return de}$provideInlineValues(B,q,J,te,K){return this._withAdapter(B,O,ae=>ae.provideInlineValues(d.URI.revive(q),J,te,K),void 0,K)}registerDocumentHighlightProvider(B,q,J){const te=this._addNewAdapter(new N(this._documents,J),B);return this._proxy.$registerDocumentHighlightProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideDocumentHighlights(B,q,J,te){return this._withAdapter(B,N,K=>K.provideDocumentHighlights(d.URI.revive(q),J,te),void 0,te)}registerLinkedEditingRangeProvider(B,q,J){const te=this._addNewAdapter(new p(this._documents,J),B);return this._proxy.$registerLinkedEditingRangeProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideLinkedEditingRanges(B,q,J,te){return this._withAdapter(B,p,async K=>{const ae=await K.provideLinkedEditingRanges(d.URI.revive(q),J,te);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?we._serializeRegExp(ae.wordPattern):void 0}},void 0,te)}registerReferenceProvider(B,q,J){const te=this._addNewAdapter(new M(this._documents,J),B);return this._proxy.$registerReferenceSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideReferences(B,q,J,te,K){return this._withAdapter(B,M,ae=>ae.provideReferences(d.URI.revive(q),J,te,K),void 0,K)}registerCodeActionProvider(B,q,J,te){const K=new C.DisposableStore,ae=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,J,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(q),{providedKinds:te?.providedCodeActionKinds?.map(de=>de.value),documentation:te?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,K)}))},we._extLabel(B),Boolean(J.resolveCodeAction)),K.add(this._createDisposable(ae)),K}$provideCodeActions(B,q,J,te,K){return this._withAdapter(B,U,ae=>ae.provideCodeActions(d.URI.revive(q),J,te,K),void 0,K)}$resolveCodeAction(B,q,J){return this._withAdapter(B,U,te=>te.resolveCodeAction(q,J),void 0,void 0)}$releaseCodeActions(B,q){this._withAdapter(B,U,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,q,J){const te=this._addNewAdapter(new z(this._documents,J),B);return this._proxy.$registerDocumentFormattingSupport(te,this._transformDocumentSelector(q),B.identifier,B.displayName||B.name),this._createDisposable(te)}$provideDocumentFormattingEdits(B,q,J,te){return this._withAdapter(B,z,K=>K.provideDocumentFormattingEdits(d.URI.revive(q),J,te),void 0,te)}registerDocumentRangeFormattingEditProvider(B,q,J){const te=this._addNewAdapter(new re(this._documents,J),B);return this._proxy.$registerRangeFormattingSupport(te,this._transformDocumentSelector(q),B.identifier,B.displayName||B.name),this._createDisposable(te)}$provideDocumentRangeFormattingEdits(B,q,J,te,K){return this._withAdapter(B,re,ae=>ae.provideDocumentRangeFormattingEdits(d.URI.revive(q),J,te,K),void 0,K)}registerOnTypeFormattingEditProvider(B,q,J,te){const K=this._addNewAdapter(new H(this._documents,J),B);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(q),te,B.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits(B,q,J,te,K,ae){return this._withAdapter(B,H,de=>de.provideOnTypeFormattingEdits(d.URI.revive(q),J,te,K,ae),void 0,ae)}registerWorkspaceSymbolProvider(B,q){const J=this._addNewAdapter(new F(q,this._logService),B);return this._proxy.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this._createDisposable(J)}$provideWorkspaceSymbols(B,q,J){return this._withAdapter(B,F,te=>te.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(B,q,J){return this._withAdapter(B,F,te=>te.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(B,q){this._withAdapter(B,F,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(B,q,J){const te=this._addNewAdapter(new j(this._documents,J,this._logService),B);return this._proxy.$registerRenameSupport(te,this._transformDocumentSelector(q),j.supportsResolving(J)),this._createDisposable(te)}$provideRenameEdits(B,q,J,te,K){return this._withAdapter(B,j,ae=>ae.provideRenameEdits(d.URI.revive(q),J,te,K),void 0,K)}$resolveRenameLocation(B,q,J,te){return this._withAdapter(B,j,K=>K.resolveRenameLocation(d.URI.revive(q),J,te),void 0,te)}registerDocumentSemanticTokensProvider(B,q,J,te){const K=this._addNewAdapter(new V(this._documents,J),B),ae=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(q),te,ae);let de=this._createDisposable(K);if(ae){const Be=J.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(ae));de=A.Disposable.from(de,Be)}return de}$provideDocumentSemanticTokens(B,q,J,te){return this._withAdapter(B,V,K=>K.provideDocumentSemanticTokens(d.URI.revive(q),J,te),null,te)}$releaseDocumentSemanticTokens(B,q){this._withAdapter(B,V,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,q,J,te){const K=this._addNewAdapter(new ne(this._documents,J),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(q),te),this._createDisposable(K)}$provideDocumentRangeSemanticTokens(B,q,J,te){return this._withAdapter(B,ne,K=>K.provideDocumentRangeSemanticTokens(d.URI.revive(q),J,te),null,te)}registerCompletionItemProvider(B,q,J,te){const K=this._addNewAdapter(new Q(this._documents,this._commands.converter,J,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(K,this._transformDocumentSelector(q),te,Q.supportsResolving(J),`${B.identifier.value}(${te.join("")})`),this._createDisposable(K)}$provideCompletionItems(B,q,J,te,K){return this._withAdapter(B,Q,ae=>ae.provideCompletionItems(d.URI.revive(q),J,te,K),void 0,K)}$resolveCompletionItem(B,q,J){return this._withAdapter(B,Q,te=>te.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(B,q){this._withAdapter(B,Q,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(B,q,J){const te=this._addNewAdapter(new fe(this._documents,J,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}registerInlineCompletionsProviderNew(B,q,J){const te=this._addNewAdapter(new G(B,this._documents,J,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideInlineCompletions(B,q,J,te,K){return this._withAdapter(B,he,ae=>ae.provideInlineCompletions(d.URI.revive(q),J,te,K),void 0,K)}$handleInlineCompletionDidShow(B,q,J){this._withAdapter(B,he,async te=>{te.handleDidShowCompletionItem(q,J)},void 0,void 0)}$freeInlineCompletionsList(B,q){this._withAdapter(B,he,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(B,q,J,te){const K=Array.isArray(te)?{triggerCharacters:te,retriggerCharacters:[]}:te,ae=this._addNewAdapter(new pe(this._documents,J),B);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(q),K),this._createDisposable(ae)}$provideSignatureHelp(B,q,J,te,K){return this._withAdapter(B,pe,ae=>ae.provideSignatureHelp(d.URI.revive(q),J,te,K),void 0,K)}$releaseSignatureHelp(B,q){this._withAdapter(B,pe,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(B,q,J){const te=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new Ie(this._documents,this._commands.converter,J,this._logService,B),B);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(q),typeof J.resolveInlayHint=="function",te,we._extLabel(B));let ae=this._createDisposable(K);if(te!==void 0){const de=J.onDidChangeInlayHints(Be=>this._proxy.$emitInlayHintsEvent(te));ae=A.Disposable.from(ae,de)}return ae}$provideInlayHints(B,q,J,te){return this._withAdapter(B,Ie,K=>K.provideInlayHints(d.URI.revive(q),J,te),void 0,te)}$resolveInlayHint(B,q,J){return this._withAdapter(B,Ie,te=>te.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(B,q){this._withAdapter(B,Ie,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(B,q,J){const te=this._addNewAdapter(new Re(this._documents,J),B);return this._proxy.$registerDocumentLinkProvider(te,this._transformDocumentSelector(q),typeof J.resolveDocumentLink=="function"),this._createDisposable(te)}$provideDocumentLinks(B,q,J){return this._withAdapter(B,Re,te=>te.provideLinks(d.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(B,q,J){return this._withAdapter(B,Re,te=>te.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(B,q){this._withAdapter(B,Re,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(B,q,J){const te=this._addNewAdapter(new Ce(this._documents,J),B);return this._proxy.$registerDocumentColorProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideDocumentColors(B,q,J){return this._withAdapter(B,Ce,te=>te.provideColors(d.URI.revive(q),J),[],J)}$provideColorPresentations(B,q,J,te){return this._withAdapter(B,Ce,K=>K.provideColorPresentations(d.URI.revive(q),J,te),void 0,te)}registerFoldingRangeProvider(B,q,J){const te=this._nextHandle(),K=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(te,new oe(new ke(this._documents,J),B)),this._proxy.$registerFoldingRangeProvider(te,this._transformDocumentSelector(q),K);let ae=this._createDisposable(te);if(K!==void 0){const de=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));ae=A.Disposable.from(ae,de)}return ae}$provideFoldingRanges(B,q,J,te){return this._withAdapter(B,ke,K=>K.provideFoldingRanges(d.URI.revive(q),J,te),void 0,te)}registerSelectionRangeProvider(B,q,J){const te=this._addNewAdapter(new Ae(this._documents,J,this._logService),B);return this._proxy.$registerSelectionRangeProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideSelectionRanges(B,q,J,te){return this._withAdapter(B,Ae,K=>K.provideSelectionRanges(d.URI.revive(q),J,te),[],te)}registerCallHierarchyProvider(B,q,J){const te=this._addNewAdapter(new ue(this._documents,J),B);return this._proxy.$registerCallHierarchyProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$prepareCallHierarchy(B,q,J,te){return this._withAdapter(B,ue,K=>Promise.resolve(K.prepareSession(d.URI.revive(q),J,te)),void 0,te)}$provideCallHierarchyIncomingCalls(B,q,J,te){return this._withAdapter(B,ue,K=>K.provideCallsTo(q,J,te),void 0,te)}$provideCallHierarchyOutgoingCalls(B,q,J,te){return this._withAdapter(B,ue,K=>K.provideCallsFrom(q,J,te),void 0,te)}$releaseCallHierarchy(B,q){this._withAdapter(B,ue,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(B,q,J){const te=this._addNewAdapter(new ve(this._documents,J),B);return this._proxy.$registerTypeHierarchyProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$prepareTypeHierarchy(B,q,J,te){return this._withAdapter(B,ve,K=>Promise.resolve(K.prepareSession(d.URI.revive(q),J,te)),void 0,te)}$provideTypeHierarchySupertypes(B,q,J,te){return this._withAdapter(B,ve,K=>K.provideSupertypes(q,J,te),void 0,te)}$provideTypeHierarchySubtypes(B,q,J,te){return this._withAdapter(B,ve,K=>K.provideSubtypes(q,J,te),void 0,te)}$releaseTypeHierarchy(B,q){this._withAdapter(B,ve,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropProvider(B,q,J){const te=this._addNewAdapter(new ie(this._documents,J),B);return this._proxy.$registerDocumentOnDropProvider(te,this._transformDocumentSelector(q)),this._createDisposable(te)}$provideDocumentOnDropEdits(B,q,J,te,K){return this._withAdapter(B,ie,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(d.URI.revive(q),J,te,K)),void 0,void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,w.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:we._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:we._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?we._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?we._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:we._serializeRegExp(B.beforeText),afterText:B.afterText?we._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?we._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(we._serializeOnEnterRule)}setLanguageConfiguration(B,q,J){let{wordPattern:te}=J;if(te&&(0,w.regExpLeadsToEndlessLoop)(te))throw new Error(`Invalid language configuration: wordPattern '${te}' is not allowed to match the empty string.`);te?this._documents.setWordDefinitionFor(q,te):this._documents.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const K=this._nextHandle(),ae={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?we._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?we._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?we._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,q,ae),this._createDisposable(K)}$setWordDefinitions(B){for(const q of B)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=we,we._handlePool=0}),define(ye[244],De([0,1,5,15,7,43,17,6]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(L,I,D,T){this._documents=I,this._commands=D,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,I){await this._proxy.$changeLanguage(L,I);const D=this._documents.getDocumentData(L);if(!D)throw new Error(`document '${L.toString()}' NOT found`);return D.document}async tokenAtPosition(L,I){const D=L.version,T=i.Position.from(I),C=await this._proxy.$tokensAtPosition(L.uri,T),m={type:_.StandardTokenType.Other,range:L.getWordRangeAtPosition(I)??new _.Range(I.line,I.character,I.line,I.character)};if(!C)return m;const v={range:i.Range.to(C.range),type:i.TokenType.to(C.type)};return!v.range.contains(I)||D!==L.version?m:v}createLanguageStatusItem(L,I,D){const T=this._handlePool++,C=this._proxy,m=this._ids,v=`${L.identifier.value}/${I}`;if(m.has(v))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);m.add(v);const g={selector:D,id:I,name:L.displayName??L.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,f=new y.DisposableStore;const l=()=>{b?.dispose(),b=(0,k.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(T,{id:v,name:g.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(g.selector,this._uriTransformer),label:g.text,detail:g.detail??"",severity:g.severity===_.LanguageStatusSeverity.Error?A.default.Error:g.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:g.command&&this._commands.toInternal(g.command,f),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},h={dispose(){f.dispose(),b?.dispose(),C.$removeLanguageStatus(T),m.delete(v)},get id(){return g.id},get name(){return g.name},set name(o){g.name=o,l()},get selector(){return g.selector},set selector(o){g.selector=o,l()},get text(){return g.text},set text(o){g.text=o,l()},get detail(){return g.detail},set detail(o){g.detail=o,l()},get severity(){return g.severity},set severity(o){g.severity=o,l()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(o){g.accessibilityInformation=o,l()},get command(){return g.command},set command(o){g.command=o,l()},get busy(){return g.busy},set busy(o){g.busy=o,l()}};return l(),h}}e.ExtHostLanguages=w}),define(ye[136],De([0,1,13,5,27,18,3]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends d.AbstractLoggerService{constructor(L,I){const D=new k.Emitter;super(I.logLevel,D.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(D)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,I,D){return new w(this._proxy,L,I,D)}};y=je([xe(0,A.IExtHostRpcService),xe(1,_.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class w extends d.AbstractMessageLogger{constructor(L,I,D,T){super(T?.always);this.proxy=L,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(D),this.proxy.$createLogger(I,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,I){const D=[[L,I]];this.isLoggerCreated?this.doLog(D):this.buffer.push(...D)}doLog(L){this.proxy.$log(this.file,L)}}}),define(ye[245],De([0,1,5,13,25]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(y){return y&&y.title}let k=class{constructor(w,P){this._logService=P,this._proxy=w.getProxy(d.MainContext.MainThreadMessageService)}showMessage(w,P,L,I,D){const T={source:{identifier:w.identifier,label:w.displayName||w.name}};let C;typeof I=="string"||A(I)?C=[I,...D]:(T.modal=I?.modal,T.useCustom=I?.useCustom,T.detail=I?.detail,C=D),T.useCustom&&(0,_.checkProposedApiEnabled)(w,"resolvers");const m=[];for(let v=0;v<C.length;v++){const g=C[v];if(typeof g=="string")m.push({title:g,handle:v,isCloseAffordance:!1});else if(typeof g=="object"){let{title:b,isCloseAffordance:f}=g;m.push({title:b,isCloseAffordance:!!f,handle:v})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(P,L,T,m).then(v=>{if(typeof v=="number")return C[v]})}};k=je([xe(1,i.ILogService)],k),e.ExtHostMessageService=k}),define(ye[246],De([0,1,23,3,59,6,24,8,14,2,86,5,38,15,7,53,223,131]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(l,h,o,E,r){this._textDocumentsAndEditors=o,this._textDocuments=E,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,t=s.cell.handle,c=this._documents.get(n)?.getCell(t);if(c)return c.apiCell}return s}}),b._registerApiCommands(h)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const h=this._editors.get(l);if(!h)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(l){for(const[h,o]of this._editors)if(o.apiEditor===l)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,h){const o=this._documents.get(l);if(!o&&!h)throw new Error(`NO notebook document for '${l}'`);return o}_getProviderData(l){const h=this._notebookContentProviders.get(l);if(!h)throw new Error(`NO provider for '${l}'`);return h}registerNotebookContentProvider(l,h,o,E,r){if((0,y.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:l,provider:o});let s;return o.onDidChangeNotebookContentOptions&&(s=o.onDidChangeNotebookContentOptions(()=>{const n=T.NotebookDocumentContentOptions.from(o.options);this._notebookProxy.$updateNotebookProviderOptions(h,n)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},h,T.NotebookDocumentContentOptions.from(E),b._convertNotebookRegistrationData(l,r)),new C.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(l,h){if(!h)return;const o=h.filenamePattern.map(E=>T.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(h.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:h.displayName,filenamePattern:o,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,h,o){const E=b._notebookStatusBarItemProviderHandlePool++,r=typeof o.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(E,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(E,r,h);let s;return r!==void 0&&(s=o.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(r))),new C.Disposable(()=>{this._notebookStatusBarItemProviders.delete(E),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(E,r),s&&s.dispose()})}async createNotebookDocument(l){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&T.NotebookData.from(l.content)});return P.URI.revive(h)}async openNotebookDocument(l){const h=this._documents.get(l);if(h)return h.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenNotebook(l),E=this._documents.get(P.URI.revive(o));return(0,w.assertIsDefined)(E?.apiNotebook)}async showNotebookDocument(l,h){P.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let o;typeof h=="object"?o={position:T.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(T.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:o={preserveFocus:!1};const E=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,o),r=E&&this._editors.get(E)?.apiEditor;if(r)return r;throw E?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,h,o,E){const r=this._notebookStatusBarItemProviders.get(l),s=P.URI.revive(h),n=this._documents.get(s);if(!n||!r)return;const t=n.getCellFromIndex(o);if(!t)return;const a=await r.provideCellStatusBarItems(t.apiCell,E);if(!a)return;const c=new A.DisposableStore,u=this._statusBarCache.add([c]),R=(Array.isArray(a)?a:[a]).map(O=>T.NotebookStatusBarItem.from(O,this._commandsConverter,c));return{cacheId:u,items:R}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,h,o,E,r){if((0,y.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,o),this._notebookProxy.$registerNotebookSerializer(s,{id:l.identifier,location:l.extensionLocation},h,T.NotebookDocumentContentOptions.from(E),b._convertNotebookRegistrationData(l,r)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(l,h,o){const E=this._notebookSerializer.get(l);if(!E)throw new Error("NO serializer found");const r=await E.deserializeNotebook(h.buffer,o);return new m.SerializableObjectWithBuffers(T.NotebookData.from(r))}async $notebookToData(l,h,o){const E=this._notebookSerializer.get(l);if(!E)throw new Error("NO serializer found");const r=await E.serializeNotebook(T.NotebookData.to(h.value),o);return d.VSBuffer.wrap(r)}async $openNotebook(l,h,o,E,r){const{provider:s}=this._getProviderData(l),n=await s.openNotebook(P.URI.revive(h),{backupId:o,untitledDocumentData:E?.buffer},r);return new m.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(T.NotebookCellData.from)})}async $saveNotebook(l,h,o){const E=this.getNotebookDocument(P.URI.revive(h)),{provider:r}=this._getProviderData(l);return await r.saveNotebook(E.apiNotebook,o),!0}async $saveNotebookAs(l,h,o,E){const r=this.getNotebookDocument(P.URI.revive(h)),{provider:s}=this._getProviderData(l);return await s.saveNotebookAs(P.URI.revive(o),r.apiNotebook,E),!0}async $backupNotebook(l,h,o){const E=this.getNotebookDocument(P.URI.revive(h)),r=this._getProviderData(l),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),n=String((0,_.hash)([E.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(s,n),a=await r.provider.backupNotebook(E.apiNotebook,{destination:t},o);return E.updateBackup(a),a.id}_createExtHostEditor(l,h,o){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const E=new g.ExtHostNotebookEditor(h,this._notebookEditorsProxy,l,o.visibleRanges.map(T.NotebookRange.to),o.selections.map(T.NotebookRange.to),typeof o.viewColumn=="number"?T.ViewColumn.to(o.viewColumn):void 0);this._editors.set(h,E)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const o of l.value.removedDocuments){const E=P.URI.revive(o),r=this._documents.get(E);r&&(r.dispose(),this._documents.delete(E),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===E.toString()&&this._editors.delete(s.id)}if(l.value.addedDocuments){const o=[];for(const E of l.value.addedDocuments){const r=P.URI.revive(E.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,E);o.push(...E.cells.map(n=>v.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(l.value.addedEditors)for(const o of l.value.addedEditors){if(this._editors.has(o.id))return;const E=P.URI.revive(o.documentUri),r=this._documents.get(E);r&&this._createExtHostEditor(r,o.id,o)}const h=[];if(l.value.removedEditors)for(const o of l.value.removedEditors){const E=this._editors.get(o);E&&(this._editors.delete(o),this._activeNotebookEditor?.id===E.id&&(this._activeNotebookEditor=void 0),h.push(E))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(E=>this._editors.get(E)).filter(E=>!!E);const o=new Set;this._visibleNotebookEditors.forEach(E=>o.add(E.id));for(const E of this._editors.values()){const r=o.has(E.id);E._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(E=>E).filter(E=>E.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const h=D.ApiCommandArgument.String.with("notebookType","A notebook type"),o=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new D.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>d.VSBuffer.wrap(r))],new D.ApiCommandResult("Notebook Data",r=>T.NotebookData.to(r.value))),E=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new m.SerializableObjectWithBuffers(T.NotebookData.from(r)))],new D.ApiCommandResult("Bytes",r=>r.buffer));l.registerApiCommand(o),l.registerApiCommand(E)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(ye[247],De([0,1,3,78,13,5,18,15]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class w{constructor(I,D){const T=w._Keys.nextId();I.$registerNotebookEditorDecorationType(T,y.NotebookDecorationRenderOptions.from(D)),this.value={key:T,dispose(){I.$removeNotebookEditorDecorationType(T)}}}}w._Keys=new i.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(I,D,T){this._logService=I,this._extHostRpc=D,this._notebooksAndEditors=T,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new w(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,D);const T=this._notebooksAndEditors.getEditorById(I);D.visibleRanges&&T._acceptVisibleRanges(D.visibleRanges.ranges.map(y.NotebookRange.to)),D.selections&&T._acceptSelections(D.selections.selections.map(y.NotebookRange.to)),D.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),D.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const D in I)this._notebooksAndEditors.getEditorById(D)._acceptViewColumn(y.ViewColumn.to(I[D]))}};P=je([xe(0,_.ILogService),xe(1,k.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(ye[137],De([0,1,16,17,21,3,6,24,2,28,13,5,38,15,7,87,217,25,53]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(s,n,t,a,c){this._initData=n,this._extHostNotebook=t,this._commands=a,this._logService=c,this._activeExecutions=new y.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(I.MainContext.MainThreadNotebookKernels);const u=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const R=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:R}}else if(S&&"notebookEditor"in S){const R=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return S})],D.ApiCommandResult.Void);this._commands.registerApiCommand(u)}createNotebookController(s,n,t,a,c,u){for(const ne of this._kernelData.values())if(ne.controller.id===n&&P.ExtensionIdentifier.equals(s.identifier,ne.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const S=this._handlePool++,R=this;this._logService.trace(`NotebookController[${S}], CREATED by ${s.identifier.value}, ${n}`);const O=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${s.identifier}'`);let N=!1;const p=new k.DisposableStore,M=new A.Emitter,U=new A.Emitter,z={id:E(s.identifier,n),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:a||s.identifier.value,preloads:u?u.map(T.NotebookRendererScript.from):[]};let re=c??O,H;this._proxy.$addKernel(S,z).catch(ne=>{console.log(ne),N=!0});let F=0;const j=()=>{if(N)return;const ne=++F;Promise.resolve().then(()=>{ne===F&&this._proxy.$updateKernel(S,z)})},x=new y.ResourceMap,V={get id(){return n},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return z.label},set label(ne){z.label=ne??s.displayName??s.name,j()},get detail(){return z.detail??""},set detail(ne){z.detail=ne,j()},get description(){return z.description??""},set description(ne){z.description=ne,j()},get kind(){return(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind??""},set kind(ne){(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind=ne,j()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ne){z.supportedLanguages=ne,j()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){z.supportsExecutionOrder=ne,j()},get rendererScripts(){return z.preloads?z.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ne){re=ne??O},get interruptHandler(){return H},set interruptHandler(ne){H=ne,z.supportsInterrupt=Boolean(ne),j()},createNotebookCellExecution(ne){if(N)throw new Error("notebook controller is DISPOSED");if(!x.has(ne.notebook.uri))throw R._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return R._createNotebookCellExecution(ne,E(s.identifier,this.id))},dispose:()=>{N||(this._logService.trace(`NotebookController[${S}], DISPOSED`),N=!0,this._kernelData.delete(S),p.dispose(),M.dispose(),U.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(ne,Q){R._proxy.$updateNotebookPriority(S,ne.uri,Q)},onDidReceiveMessage:U.event,postMessage(ne,Q){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),R._proxy.$postMessage(S,Q&&R._extHostNotebook.getIdByEditor(Q),ne)},asWebviewUri(ne){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),(0,m.asWebviewUri)(ne,R._initData.remote)}};return this._kernelData.set(S,{extensionId:s.identifier,controller:V,onDidReceiveMessage:U,onDidChangeSelection:M,associatedNotebooks:x}),V}getIdByController(s){for(const[n,t]of this._kernelData)if(t.controller===s)return E(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,n,t){const a=this._kernelData.get(s);if(a){const c=this._extHostNotebook.getNotebookDocument(w.URI.revive(n));t?a.associatedNotebooks.set(c.uri,!0):a.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,c.uri.toString(),t),a.onDidChangeSelection.fire({selected:t,notebook:c.apiNotebook})}}async $executeCells(s,n,t){const a=this._kernelData.get(s);if(!a)return;const c=this._extHostNotebook.getNotebookDocument(w.URI.revive(n)),u=[];for(const S of t){const R=c.getCell(S);R&&u.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,c.uri.toString(),u.length),await a.controller.executeHandler.call(a.controller,u,c.apiNotebook,a.controller)}catch(S){this._logService.error(`NotebookController[${s}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(s,n,t){const a=this._kernelData.get(s);if(!a)return;const c=this._extHostNotebook.getNotebookDocument(w.URI.revive(n));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,c.apiNotebook);else for(const u of t){const S=c.getCell(u);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,t){const a=this._kernelData.get(s);if(!a)return;const c=this._extHostNotebook.getEditorById(n);a.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:t}))}$cellExecutionChanged(s,n,t){const c=this._extHostNotebook.getNotebookDocument(w.URI.revive(s)).getCell(n);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:t?T.NotebookCellExecutionState.to(t):C.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,n){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const c=new h(n,a,this._proxy);this._activeExecutions.set(a.uri,c);const u=c.onDidChangeState(()=>{c.state===l.Resolved&&(c.dispose(),u.dispose(),this._activeExecutions.delete(a.uri))});return c.asApiObject()}};f=je([xe(4,L.ILogService)],f),e.ExtHostNotebookKernels=f;var l;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(l||(l={}));class h extends k.Disposable{constructor(s,n,t){super();this._cell=n,this._proxy=t,this._handle=h.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new o(10,a=>this.update(a)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(s){return s.map(n=>{const t=C.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?T.NotebookCellOutput.from(n):T.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,t){const a=this.validateAndConvertOutputs((0,d.asArray)(s));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:t,outputs:a})}async updateOutputItems(s,n,t){return s=C.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(s),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:s.map(T.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===l.Resolved||s._state===l.Started)throw new Error("Cannot call start again");s._state=l.Started,s._onDidChangeState.fire(),s.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,a){if(s._state===l.Resolved)throw new Error("Cannot call resolve twice");s._state=l.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new b.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,a){return s.verifyStateForOutput(),s.updateOutputs(t,a,!0)},replaceOutput(t,a){return s.verifyStateForOutput(),s.updateOutputs(t,a,!1)},appendOutputItems(t,a){return s.verifyStateForOutput(),s.updateOutputItems(t,a,!0)},replaceOutputItems(t,a){return s.verifyStateForOutput(),s.updateOutputItems(t,a,!1)}})}}h.HANDLE=0;class o{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}function E(r,s){return`${r.value}/${s}`}e.createKernelId=E}),define(ye[248],De([0,1,3,6,24,13,5,137,25]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookProxyKernels=void 0;let P=class{constructor(I,D,T){this.extHostNotebook=D,this._logService=T,this._proxyKernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new d.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=I.getProxy(k.MainContext.MainThreadNotebookProxyKernels)}createNotebookProxyController(I,D,T,C,m){const v=this._handlePool++;let g=!1;const b=new i.DisposableStore,f=new d.Emitter,l={id:(0,y.createKernelId)(I.identifier,D),notebookType:T,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:C||I.identifier.value};let h=m;this._proxy.$addProxyKernel(v,l).catch(n=>{console.log(n),g=!0});let o=0;const E=()=>{if(g)return;const n=++o;Promise.resolve().then(()=>{n===o&&this._proxy.$updateProxyKernel(v,l)})},r=new _.ResourceMap,s={get id(){return D},get notebookType(){return l.notebookType},onDidChangeSelectedNotebooks:f.event,get label(){return l.label},set label(n){l.label=n??I.displayName??I.name,E()},get detail(){return l.detail??""},set detail(n){l.detail=n,E()},get description(){return l.description??""},set description(n){l.description=n,E()},get kind(){return(0,w.checkProposedApiEnabled)(I,"notebookControllerKind"),l.kind??""},set kind(n){(0,w.checkProposedApiEnabled)(I,"notebookControllerKind"),l.kind=n,E()},get resolveHandler(){return h},dispose:()=>{g||(this._logService.trace(`NotebookProxyController[${v}], DISPOSED`),g=!0,this._proxyKernelData.delete(v),b.dispose(),f.dispose(),this._proxy.$removeProxyKernel(v))}};return this._proxyKernelData.set(v,{extensionId:I.identifier,controller:s,onDidChangeSelection:f,associatedNotebooks:r}),s}async $resolveKernel(I){const D=this._proxyKernelData.get(I);if(!D)return null;const T=await D.controller.resolveHandler();return typeof T=="string"?T:this.extHostNotebook.getIdByController(T)}};P=je([xe(2,A.ILogService)],P),e.ExtHostNotebookProxyKernels=P}),define(ye[249],De([0,1,3,5,131,25]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(w,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=w.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(w,P,L){const I=this._extHostNotebook.getEditorById(w);this._rendererMessageEmitters.get(P)?.fire({editor:I.apiEditor,message:L})}createRendererMessaging(w,P){if(!w.contributes?.notebookRenderer?.some(T=>T.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const L=(0,A.isProposedApiEnabled)(w,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(T,C,m)=>{const v=L?T:g=>{const b={};I.set(b,g.editor),T({editor:b,message:g.message})};return this.getOrCreateEmitterFor(P).event(v,C,m)},postMessage:(T,C)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,C]=[C,T]);const m=L?C:I.get(C),v=m&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(m);return this.proxy.$postMessage(v?.id,P,T)}}}getOrCreateEmitterFor(w){let P=this._rendererMessageEmitters.get(w);return P||(P=new d.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(w)}}),this._rendererMessageEmitters.set(w,P),P)}}e.ExtHostNotebookRenderers=k}),define(ye[250],De([0,1,21,3,6,5,2,7,11,16,43,85,25]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function T(C,m,v){const g=C.getProxy(A.MainContext.MainThreadQuickOpen);class b{constructor(t,a){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=a}showQuickPick(t,a,c=d.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(t),S=++this._instances,R=g.$show(S,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},c),O={},N=R.then(()=>O);return Promise.race([N,u]).then(p=>{if(p!==O)return u.then(M=>{const U=[];for(let z=0;z<M.length;z++){const re=M[z];typeof re=="string"?U.push({label:re,handle:z}):re.kind===y.QuickPickItemKind.Separator?U.push({type:"separator",label:re.label}):U.push({label:re.label,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,handle:z})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{a.onDidSelectItem(M[z])}),g.$setItems(S,U),R.then(z=>{if(typeof z=="number")return M[z];if(Array.isArray(z))return z.map(re=>M[re])})})}).then(void 0,p=>{if(!(0,w.isCancellationError)(p))return g.$setError(S,p),Promise.reject(p)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,a=d.CancellationToken.None){return this._validateInput=t?t.validateInput2??t.validateInput:void 0,g.$input(t,typeof this._validateInput=="function",a).then(void 0,c=>{if(!(0,w.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(t){if(!this._validateInput)return;const a=await this._validateInput(t);if(!a||typeof a=="string")return a;let c;switch(a.severity){case y.InputBoxValidationSeverity.Info:c=L.default.Info;break;case y.InputBoxValidationSeverity.Warning:c=L.default.Warning;break;case y.InputBoxValidationSeverity.Error:c=L.default.Error;break;default:c=a.message?L.default.Error:L.default.Ignore;break}return{content:a.message,severity:c}}async showWorkspaceFolderPick(t,a=d.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!c)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(S=>S.uri.toString()===c.uri.toString())}createQuickPick(t){const a=new r(t,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(t){const a=new s(t,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(t,a){const c=this._sessions.get(t);c&&c._fireDidChangeValue(a)}$onDidAccept(t){const a=this._sessions.get(t);a&&a._fireDidAccept()}$onDidChangeActive(t,a){const c=this._sessions.get(t);c instanceof r&&c._fireDidChangeActive(a)}$onDidChangeSelection(t,a){const c=this._sessions.get(t);c instanceof r&&c._fireDidChangeSelection(a)}$onDidTriggerButton(t,a){const c=this._sessions.get(t);c&&c._fireDidTriggerButton(a)}$onDidTriggerItemButton(t,a,c){const u=this._sessions.get(t);u instanceof r&&u._fireDidTriggerItemButton(a,c)}$onDidHide(t){const a=this._sessions.get(t);a&&a._fireDidHide()}}class f{constructor(t,a){this._extensionId=t,this._onDidDispose=a,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new i.Emitter,this._onDidChangeValueEmitter=new i.Emitter,this._onDidTriggerButtonEmitter=new i.Emitter,this._onDidHideEmitter=new i.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((a,c)=>{const u=a===y.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(u,a)}),this.update({buttons:t.map((a,c)=>({...E(a),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const a=this._handlesToButtons.get(t);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(t){if(!this._disposed){for(const a of Object.keys(t)){const c=t[a];this._pendingUpdate[a]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}f._nextId=1;function l(n){if(n instanceof y.ThemeIcon)return{id:n.id};const t=o(n),a=h(n);return{dark:typeof t=="string"?k.URI.file(t):t,light:typeof a=="string"?k.URI.file(a):a}}function h(n){return typeof n=="object"&&"light"in n?n.light:n}function o(n){return typeof n=="object"&&"dark"in n?n.dark:n}function E(n){const t=l(n.iconPath);let a,c;return"id"in t?c=I.ThemeIcon.asClassName(t):a=t,{iconPath:a,iconClass:c}}class r extends f{constructor(t,a){super(t.identifier,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new i.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new i.Emitter,this._onDidTriggerItemButtonEmitter=new i.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((c,u)=>{this._handlesToItems.set(u,c),this._itemsToHandles.set(c,u)});const a=[];for(let c=0;c<t.length;c++){const u=t[c];u.kind===y.QuickPickItemKind.Separator?a.push({type:"separator",label:u.label}):a.push({handle:c,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((S,R)=>({...E(S),tooltip:S.tooltip,handle:R}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(t){const a=(0,P.coalesce)(t.map(c=>this._handlesToItems.get(c)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(t){const a=(0,P.coalesce)(t.map(c=>this._handlesToItems.get(c)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(t,a){const c=this._handlesToItems.get(t);if(!c||!c.buttons||!c.buttons.length)return;const u=c.buttons[a];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:c})}}class s extends f{constructor(t,a){super(t.identifier,a);this.extension=t,this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?L.default.Error:L.default.Ignore})}get validationMessage2(){return this._validationMessage2}set validationMessage2(t){(0,D.checkProposedApiEnabled)(this.extension,"inputBoxSeverity"),this._validationMessage2=t,t?typeof t=="string"?this.update({validationMessage:t,severity:L.default.Error}):this.update({validationMessage:t.message,severity:t.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new b(m,v)}e.createExtHostQuickOpen=T});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[251],De([0,1,2,3,58,6,17,5,16,99,13,28,85,15,25]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C){"use strict";var m,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(c){if(c)return typeof c.iconPath=="string"?d.URI.file(c.iconPath):d.URI.isUri(c.iconPath)||D.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function b(c,u){if(!c.iconPath&&!u.iconPath)return 0;if(c.iconPath){if(!u.iconPath)return 1}else return-1;const S=typeof c.iconPath=="string"?c.iconPath:d.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,R=typeof u.iconPath=="string"?u.iconPath:d.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,P.comparePaths)(S,R)}function f(c,u){let S=0;if(c.strikeThrough!==u.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==u.faded)return c.faded?1:-1;if(c.tooltip!==u.tooltip)return(c.tooltip||"").localeCompare(u.tooltip||"");if(S=b(c,u),S!==0)return S;if(c.light&&u.light)S=b(c.light,u.light);else{if(c.light)return 1;if(u.light)return-1}if(S!==0)return S;if(c.dark&&u.dark)S=b(c.dark,u.dark);else{if(c.dark)return 1;if(u.dark)return-1}return S}function l(c,u){if(c.command!==u.command)return c.command<u.command?-1:1;if(c.title!==u.title)return c.title<u.title?-1:1;if(c.tooltip!==u.tooltip){if(c.tooltip!==void 0&&u.tooltip!==void 0)return c.tooltip<u.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(c.arguments===u.arguments)return 0;if(c.arguments)if(u.arguments){if(c.arguments.length!==u.arguments.length)return c.arguments.length-u.arguments.length}else return 1;else return-1;for(let S=0;S<c.arguments.length;S++){const R=c.arguments[S],O=u.arguments[S];if(R!==O)return R<O?-1:1}return 0}function h(c,u){let S=(0,P.comparePaths)(c.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(S!==0)return S;if(c.command&&u.command)S=l(c.command,u.command);else{if(c.command)return 1;if(u.command)return-1}if(S!==0)return S;if(c.decorations&&u.decorations)S=f(c.decorations,u.decorations);else{if(c.decorations)return 1;if(u.decorations)return-1}return S}function o(c,u){for(let S=0;S<c.length;S++)if(c[S]!==u[S])return!1;return!0}function E(c,u){return c.command===u.command&&c.title===u.title&&c.tooltip===u.tooltip&&(c.arguments&&u.arguments?o(c.arguments,u.arguments):c.arguments===u.arguments)}function r(c,u){return(0,w.equals)(c,u,E)}class s{constructor(u,S,R){this._extension=u,this._sourceControlHandle=R,m.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0,et(this,m,S,"f")}get value(){return this._value}set value(u){u=u??"",Ue(this,m,"f").$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){Ue(this,m,"f").$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,Ue(this,m,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,Ue(this,m,"f").$setInputBoxVisibility(this._sourceControlHandle,u))}showValidationMessage(u,S){(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,m,"f").$showValidationMessage(this._sourceControlHandle,u,S)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=s,m=new WeakMap;class n{constructor(u,S,R,O,N){this._proxy=u,this._commands=S,this._sourceControlHandle=R,this._id=O,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,S){const R=this._resourceStatesCommandsMap.get(u);return R?(0,k.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(h),R=(0,w.sortedDiff)(this._resourceSnapshot,u,h).map(p=>{const M=p.toInsert.map(U=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,U);const re=U.resourceUri;let H;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const X=new A.DisposableStore;H=this._commands.converter.toInternal(U.command,X),this._resourceStatesDisposablesMap.set(z,X)}else this._resourceStatesCommandsMap.set(z,U.command);const F=g(U.decorations),j=U.decorations&&g(U.decorations.light)||F,x=U.decorations&&g(U.decorations.dark)||F,V=[j,x],ne=U.decorations&&U.decorations.tooltip||"",Q=U.decorations&&!!U.decorations.strikeThrough,he=U.decorations&&!!U.decorations.faded,fe=U.contextValue||"";return{rawResource:[z,re,V,ne,Q,he,fe,H],handle:z}});return{start:p.start,deleteCount:p.deleteCount,toInsert:M}}),O=R.map(({start:p,deleteCount:M,toInsert:U})=>[p,M,U.map(z=>z.rawResource)]),N=R.reverse();for(const{start:p,deleteCount:M,toInsert:U}of N){const z=U.map(H=>H.handle),re=this._handlesSnapshot.splice(p,M,...z);for(const H of re)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=u,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(u,S,R,O,N,p){this._extension=u,this._commands=R,this._id=O,this._label=N,this._rootUri=p,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,et(this,v,S,"f"),this._inputBox=new s(u,Ue(this,v,"f"),this.handle),Ue(this,v,"f").$registerSourceControl(this.handle,O,N,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,Ue(this,v,"f").$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,Ue(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,Ue(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=u;const S=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);Ue(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=u;const S=u!==void 0?{command:this._commands.converter.toInternal(u.command,this._actionButtonDisposables.value),description:u.description}:void 0;Ue(this,v,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&r(this._statusBarCommands,u))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=u;const S=(u||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ue(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(u,S){const R=new n(Ue(this,v,"f"),this._commands,this.handle,u,S),O=i.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,O),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const u=[],S=[];for(const[R,O]of this.createdResourceGroups){O.dispose();const N=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});i.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),N.dispose(),this._groups.delete(R.handle),Ue(this,v,"f").$unregisterGroup(this.handle,R.handle)}),u.push([R.handle,R.id,R.label,R.features]);const p=R._takeResourceStateSnapshot();p.length>0&&S.push([R.handle,p]),this._groups.set(R.handle,R)}Ue(this,v,"f").$registerGroups(this.handle,u,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(S=>{const R=S._takeResourceStateSnapshot();R.length!==0&&u.push([S.handle,R])}),u.length>0&&Ue(this,v,"f").$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),Ue(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,t._handlePool=0,je([(0,_.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,_.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let a=class Qi{constructor(u,S,R){this._commands=S,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=u.getProxy(y.MainContext.MainThreadSCM),this._telemetry=u.getProxy(y.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const N=this._sourceControls.get(O.sourceControlHandle);if(!N)return O;const p=N.getResourceGroup(O.groupHandle);return p?p.getResourceState(O.handle):O}else if(O&&O.$mid===4){const N=this._sourceControls.get(O.sourceControlHandle);return N?N.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const N=this._sourceControls.get(O.handle);return N||O}return O}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,S,R,O){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,S,R,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const N=Qi._handlePool++,p=new t(u,this._proxy,this._commands,S,R,O);this._sourceControls.set(N,p);const M=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return M.push(p),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),M),p}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const S=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),R=S&&S[S.length-1];return R&&R.inputBox}$provideOriginalResource(u,S,R){const O=d.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,O.toString());const N=this._sourceControls.get(u);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(O,R)).then(p=>p||null)}$onInputBoxValueChange(u,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const R=this._sourceControls.get(u);return R&&R.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(u,S,R,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,S,R);const N=this._sourceControls.get(u);if(!N)return Promise.resolve(void 0);const p=N.getResourceGroup(S);return p?p.$executeResourceCommand(R,O):Promise.resolve(void 0)}$validateInput(u,S,R){this.logService.trace("ExtHostSCM#$validateInput",u);const O=this._sourceControls.get(u);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>O.inputBox.validateInput(S,R)).then(N=>{if(!N)return Promise.resolve(void 0);const p=T.MarkdownString.fromStrict(N.message);return p?Promise.resolve([p,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};a._handlePool=0,a=je([xe(2,L.ILogService)],a),e.ExtHostSCM=a});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[252],De([0,1,7,5,174,6,15,14]),function(Y,e,d,i,_,A,k,y){"use strict";var w,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(C,m,v,g,b=d.StatusBarAlignment.Left,f){w.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,w,C,"f"),et(this,P,m,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=g,this._alignment=b,this._priority=this.validatePriority(f)}validatePriority(C){if(!!(0,y.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(C){this._text=C,this.update()}set name(C){this._name=C,this.update()}set tooltip(C){this._tooltip=C,this.update()}set color(C){this._color=C,this.update()}set backgroundColor(C){C&&!L.ALLOWED_BACKGROUND_COLORS.has(C.id)&&(C=void 0),this._backgroundColor=C,this.update()}set command(C){this._command?.fromApi!==C&&(this._internalCommandRegistration.clear(),typeof C=="string"?this._command={fromApi:C,internal:Ue(this,P,"f").toInternal({title:"",command:C},this._internalCommandRegistration)}:C?this._command={fromApi:C,internal:Ue(this,P,"f").toInternal(C,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(C){this._accessibilityInformation=C,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let C;this._extension?this._id?C=`${this._extension.identifier.value}.${this._id}`:C=this._extension.identifier.value:C=this._id;let m;this._name?m=this._name:m=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=k.MarkdownString.fromStrict(this._tooltip);Ue(this,w,"f").$setEntry(this._entryId,C,m,this._text,g,this._command?.internal,v,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,w=new WeakMap,P=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(C){this._messages=[],this._item=C.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(C){const m={message:C};return this._messages.unshift(m),this._update(),new d.Disposable(()=>{const v=this._messages.indexOf(m);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class D{constructor(C,m){this._proxy=C.getProxy(i.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new I(this)}createStatusBarEntry(C,m,v,g){return new L(this._proxy,this._commands,C,m,v,g)}setStatusBarMessage(C,m){const v=this._statusMessage.setMessage(C);let g;return typeof m=="number"?g=setTimeout(()=>v.dispose(),m):typeof m!="undefined"&&m.then(()=>v.dispose(),()=>v.dispose()),new d.Disposable(()=>{v.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=D}),define(ye[90],De([0,1,5,3,4]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(y){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,w){this._proxy.$registerExtensionStorageKeysToSync(y,w)}initializeExtensionStorage(y,w,P){return this._proxy.$initializeExtensionStorage(y,w).then(L=>L||P)}setValue(y,w,P){return this._proxy.$setValue(y,w,P)}$acceptValue(y,w,P){this._onDidChangeStorage.fire({shared:y,key:w,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(ye[69],De([0,1,4,27,13,68,2]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let y=class{constructor(P,L,I){this._logService=L,this._extHostFileSystem=I,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(D=>this._value=D)}async _getWorkspaceStorageURI(P){return k.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,L=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(P){if(this._value)return k.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return k.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=je([xe(0,i.IExtHostInitDataService),xe(1,_.ILogService),xe(2,A.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(ye[39],De([0,1,3,5,4,2,18,6,7,175,11,219,21,36,202,85,14,17]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class b{constructor(t,a,c,u){this._proxy=t,this._id=a,this._creationOptions=c,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(R,O=!0){S._checkDisposed(),S._proxy.$sendText(S._id,R,O)},show(R){S._checkDisposed(),S._proxy.$show(S._id,R)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(t,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,v.withNullAsUndefined)(t.shellPath),shellArgs:(0,v.withNullAsUndefined)(t.shellArgs),cwd:(0,v.withNullAsUndefined)(t.cwd),env:(0,v.withNullAsUndefined)(t.env),icon:(0,v.withNullAsUndefined)(r(t.iconPath)),color:m.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,v.withNullAsUndefined)(t.message),strictEnv:(0,v.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(t.location,a?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,a,c,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:c,color:m.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(t,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,a){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,a){return t===this._cols&&a===this._rows||t===0||a===0?!1:(this._cols=t,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=b;class f{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new d.Emitter,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,a){this._pty.setDimensions?.({columns:t,rows:a})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let l=1,h=class extends y.Disposable{constructor(t,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new C.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[c,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,a){const c=new b(this._proxy,(0,T.generateUuid)(),t,t.name),u=new f(t.pty);return c.createExtensionTerminal(t.location,this._serializeParentTerminal(t,a).resolvedExtHostIdentifier,r(t.iconPath),s(t.color)).then(S=>{const R=this._setupExtHostProcessListeners(S,u);this._terminalProcessDisposables[S]=R}),this._terminals.push(c),c.value}_serializeParentTerminal(t,a){if(a=a||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const c=t.location.parentTerminal;if(c){const u=this._terminals.find(S=>S.value===c);u&&(a.resolvedExtHostIdentifier=u._id)}}else t.location&&typeof t.location!="object"?a.location=t.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(t,a){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const u=new f(a),S=this._setupExtHostProcessListeners(t,u);this._terminalProcessDisposables[t]=S}async $acceptActiveTerminalChanged(t){const a=this._activeTerminal;if(t===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const c=this._getTerminalById(t);c&&(this._activeTerminal=c,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,a){const c=this._getTerminalById(t);c&&this._onDidWriteTerminalData.fire({terminal:c.value,data:a})}async $acceptTerminalDimensions(t,a,c){const u=this._getTerminalById(t);u&&u.setDimensions(a,c)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(t,a,c){this._terminalProcesses.get(t)?.resize(a,c)}async $acceptTerminalTitleChange(t,a){const c=this._getTerminalById(t);c&&(c.name=a)}async $acceptTerminalClosed(t,a){const c=this._getTerminalObjectIndexById(this._terminals,t);if(c!==null){const u=this._terminals.splice(c,1)[0];u.setExitCode(a),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(t,a,c,u){if(a){const O=this._getTerminalObjectIndexById(this._terminals,a);if(O!==null){this._terminals[O]._id=t,this._onDidOpenTerminal.fire(this.terminals[O]),this._terminals[O].isOpen=!0;return}}const S={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:A.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},R=new b(this._proxy,t,S,c);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(t,a){const c=this._getTerminalById(t);c&&c._setProcessId(a)}async $startExtensionTerminal(t,a){const c=this._getTerminalById(t);if(!c)return{message:(0,P.localize)(0,null,t)};c.isOpen||await new Promise(S=>{const R=this.onDidOpenTerminal(async O=>{O===c.value&&(R.dispose(),S())})});const u=this._terminalProcesses.get(t);u?u.startSendingEvents(a):this._extensionTerminalAwaitingStart[t]={initialDimensions:a}}_setupExtHostProcessListeners(t,a){const c=new y.DisposableStore;c.add(a.onProcessReady(S=>this._proxy.$sendProcessReady(t,S.pid,S.cwd))),c.add(a.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(t,S))),this._bufferer.startBuffering(t,a.onProcessData),c.add(a.onProcessExit(S=>this._onProcessExit(t,S))),this._terminalProcesses.set(t,a);const u=this._extensionTerminalAwaitingStart[t];return u&&a instanceof f&&(a.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),c}$acceptProcessAckDataEvent(t,a){this._terminalProcesses.get(t)?.acknowledgeDataEvent(a)}$acceptProcessInput(t,a){this._terminalProcesses.get(t)?.input(a)}$acceptTerminalInteraction(t){const a=this._getTerminalById(t);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(t,a,c){try{this._terminalProcesses.get(t)?.resize(a,c)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,a){this._terminalProcesses.get(t)?.shutdown(a)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:a}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,a,c){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,c),this._proxy.$registerProfileProvider(a,t.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(t,a){const c=new D.CancellationTokenSource().token;let u=await this._profileProviders.get(t)?.provideTerminalProfile(c);if(!c.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,a);return}this.createTerminalFromOptions(u.options,a)}}async $provideLinks(t,a){const c=this._getTerminalById(t);if(!c)return[];this._terminalLinkCache.delete(t);const u=this._terminalLinkCancellationSource.get(t);u&&u.dispose(!0);const S=new D.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,S);const R=[],O={terminal:c.value,line:a},N=[];for(const U of this._linkProviders)N.push(g.Promises.withAsyncBody(async z=>{S.token.onCancellationRequested(()=>z({provider:U,links:[]}));const re=await U.provideTerminalLinks(O,S.token)||[];S.token.isCancellationRequested||z({provider:U,links:re})}));const p=await Promise.all(N);if(S.token.isCancellationRequested)return[];const M=new Map;for(const U of p)U&&U.links.length>0&&R.push(...U.links.map(z=>{const re={id:l++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return M.set(re.id,{provider:U.provider,link:z}),re}));return this._terminalLinkCache.set(t,M),R}$activateLink(t,a){const c=this._terminalLinkCache.get(t)?.get(a);!c||c.provider.handleTerminalLink(c.link)}_onProcessExit(t,a){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const c=this._terminalProcessDisposables[t];c&&(c.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,a)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,a){const c=this._getTerminalObjectIndexById(t,a);return c!==null?t[c]:null}_getTerminalObjectIndexById(t,a){let c=null;return t.some((u,S)=>u._id===a?(c=S,!0):!1),c}getEnvironmentVariableCollection(t){let a=this._environmentVariableCollections.get(t.identifier.value);return a||(a=new o,this._setEnvironmentVariableCollection(t.identifier.value,a)),a}_syncEnvironmentVariableCollection(t,a){const c=(0,I.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(t,a.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(t){t.forEach(a=>{const c=a[0],u=new o(a[1]);this._setEnvironmentVariableCollection(c,u)})}$acceptDefaultProfile(t,a){this._defaultProfile=t,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(t,a){this._environmentVariableCollections.set(t,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,a)})}};h=je([xe(1,k.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class o{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,a){this._setIfDiffers(t,{value:a,type:w.EnvironmentVariableMutatorType.Replace})}append(t,a){this._setIfDiffers(t,{value:a,type:w.EnvironmentVariableMutatorType.Append})}prepend(t,a){this._setIfDiffers(t,{value:a,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,a){const c=this.map.get(t);(!c||c.value!==a.value||c.type!==a.type)&&(this.map.set(t,a),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,a){this.map.forEach((c,u)=>t.call(a,u,c,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let E=class extends h{constructor(t){super(!1,t)}createTerminal(t,a,c){throw new L.NotSupportedError}createTerminalFromOptions(t,a){throw new L.NotSupportedError}};E=je([xe(0,k.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return m.ThemeColor.isThemeColor(n)?n:void 0}});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[253],De([0,1,16,23,21,3,77,59,6,26,14,36,5,18,132,15,7,65,88,66]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f){"use strict";var l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(N,p){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(D.MainContext.MainThreadTesting),this.observer=new u(this.proxy),this.runTracker=new r(this.proxy),p.registerArgumentProcessor({processArgument:M=>M?.$mid===13?(0,C.toItemFromContext)(M):M})}createTestController(N,p,M){if(this.controllers.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const U=new w.DisposableStore,z=U.add(new C.ExtHostTestItemCollection(N,p));z.root.label=p;const re=new Map,H=this.proxy,F={items:z.root.children,get label(){return p},set label(x){p=x,z.root.label=x,H.$updateController(N,{label:p})},get refreshHandler(){return M},set refreshHandler(x){M=x,H.$updateController(N,{canRefresh:!!x})},get id(){return N},createRunProfile:(x,V,ne,Q,he)=>{let fe=(0,y.hash)(x);for(;re.has(fe);)fe++;return new S(this.proxy,re,N,fe,x,V,ne,Q,he)},createTestItem(x,V,ne){return new C.TestItemImpl(N,x,V,ne)},createTestRun:(x,V,ne=!0)=>this.runTracker.createTestRun(N,z,x,V,ne),set resolveHandler(x){z.resolveHandler=x},get resolveHandler(){return z.resolveHandler},dispose:()=>{U.dispose()}};H.$registerTestController(N,p,!!M),U.add((0,w.toDisposable)(()=>H.$unregisterTestController(N)));const j={controller:F,collection:z,profiles:re};return this.controllers.set(N,j),U.add((0,w.toDisposable)(()=>this.controllers.delete(N))),U.add(z.onDidGenerateDiff(x=>H.$publishDiff(N,x.map(f.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(N,p=_.CancellationToken.None){const M=s(N);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(M.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(z=>g.TestId.fromExtHostTestItem(z,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:R[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:N.exclude?.map(z=>z.id)},p)}$provideFileCoverage(N,p,M){return(0,d.mapFind)(this.runTracker.trackers,z=>z.id===N?z.getCoverage(p):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(N,p,M,U){return(0,d.mapFind)(this.runTracker.trackers,re=>re.id===N?re.getCoverage(p):void 0)?.resolveFileCoverage(M,U)??Promise.resolve([])}$configureRunProfile(N,p){this.controllers.get(N)?.profiles.get(p)?.configureHandler?.()}async $refreshTests(N,p){await this.controllers.get(N)?.controller.refreshHandler?.(p)}$publishTestResults(N){this.results=Object.freeze(N.map(p=>(0,P.deepFreeze)(m.TestResults.to(p))).concat(this.results).sort((p,M)=>M.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,p){const M=this.controllers.get(g.TestId.fromString(N).controllerId)?.collection;M&&(await M.expand(N,p<0?1/0:p),M.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(f.TestsDiffOp.deserialize))}async $runControllerTests(N,p){const M=this.controllers.get(N.controllerId);if(!M)return;const{collection:U,profiles:z}=M,re=z.get(N.profileId);if(!re)return;const H=N.testIds.map(V=>U.tree.get(V)).filter(L.isDefined),F=N.excludeExtIds.map(V=>M.collection.tree.get(V)).filter(L.isDefined).filter(V=>H.some(ne=>ne.fullId.compare(V.fullId)===2));if(!H.length)return;const j=new v.TestRunRequest(H.some(V=>V.actual instanceof C.TestItemRootImpl)?void 0:H.map(V=>V.actual),F.map(V=>V.actual),re),x=this.runTracker.prepareForMainThreadTestRun(j,n.fromInternal(N,M.collection),p);try{await re.runHandler(j,p)}finally{x.isRunning&&!p.isCancellationRequested&&await A.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};o=je([xe(0,T.IExtHostRpcService)],o),e.ExtHostTesting=o;class E extends w.Disposable{constructor(N,p,M){super();this.dto=N,this.proxy=p,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(M)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const p=this.dto.id,M=this.dto.controllerId,U=(0,I.generateUuid)(),z=new t(this.proxy,p,U),re=x=>(V,...ne)=>{if(F){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),x(V,...ne))},H=(x,V)=>{const ne=V instanceof Array?V.map(m.TestMessage.from):[m.TestMessage.from(V)];if(x.uri&&x.range){const Q={range:m.Range.from(x.range),uri:x.uri};for(const he of ne)he.location=he.location||Q}this.proxy.$appendTestMessagesInRun(p,U,g.TestId.fromExtHostTestItem(x,M).toString(),ne)};let F=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return z.coverageProvider},set coverageProvider(x){z.coverageProvider=x},enqueued:re(x=>{this.proxy.$updateTestStateInRun(p,U,g.TestId.fromExtHostTestItem(x,M).toString(),1)}),skipped:re(x=>{this.proxy.$updateTestStateInRun(p,U,g.TestId.fromExtHostTestItem(x,M).toString(),5)}),started:re(x=>{this.proxy.$updateTestStateInRun(p,U,g.TestId.fromExtHostTestItem(x,M).toString(),2)}),errored:re((x,V,ne)=>{H(x,V),this.proxy.$updateTestStateInRun(p,U,g.TestId.fromExtHostTestItem(x,M).toString(),6,ne)}),failed:re((x,V,ne)=>{H(x,V),this.proxy.$updateTestStateInRun(p,U,g.TestId.fromExtHostTestItem(x,M).toString(),4,ne)}),passed:re((x,V)=>{this.proxy.$updateTestStateInRun(p,U,g.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,V)}),appendOutput:(x,V,ne)=>{F||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(p,U,i.VSBuffer.fromString(x),V&&m.location.from(V),ne&&g.TestId.fromExtHostTestItem(ne,M).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(p,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:j,coverage:z}),this.proxy.$startedTestRunTask(p,{id:U,name:N,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(N){if(!(N instanceof C.TestItemImpl))throw new b.InvalidTestItemError(N.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const p=[],M=this.dto.colllection.root;for(;;){const U=m.TestItem.from(N);if(p.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),N===M))break;N=N.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,p)}}class r{constructor(N){this.proxy=N,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(N,p,M){return this.getTracker(N,p,M)}cancelRunById(N){for(const p of this.tracked.values())if(p.id===N){p.dispose();return}}cancelAllRuns(){for(const N of this.tracked.values())N.dispose()}createTestRun(N,p,M,U,z){const re=this.tracked.get(M);if(re)return re.createRun(U);const H=n.fromPublic(N,p,M,z),F=s(M);this.proxy.$startedExtensionTestRun({controllerId:N,profile:F&&{group:R[F.kind],id:F.profileId},exclude:M.exclude?.map(x=>g.TestId.fromExtHostTestItem(x,p.root.id).toString())??[],id:H.id,include:M.include?.map(x=>g.TestId.fromExtHostTestItem(x,p.root.id).toString())??[p.root.id],persist:z});const j=this.getTracker(M,H);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),j.createRun(U)}getTracker(N,p,M){const U=new E(p,this.proxy,M);return this.tracked.set(N,U),U.onEnd(()=>this.tracked.delete(N)),U}}e.TestRunCoordinator=r;const s=O=>{if(!!O.profile){if(!(O.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class n{constructor(N,p,M,U,z,re){this.controllerId=N,this.id=p,this.isPersisted=z,this.colllection=re,this.includePrefix=M.map(H=>H+"\0"),this.excludePrefix=U.map(H=>H+"\0")}static fromPublic(N,p,M,U){return new n(N,(0,I.generateUuid)(),M.include?.map(z=>g.TestId.fromExtHostTestItem(z,N).toString())??[N],M.exclude?.map(z=>g.TestId.fromExtHostTestItem(z,N).toString())??[],U,p)}static fromInternal(N,p){return new n(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,p)}isIncluded(N){const p=g.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(p===M||p.startsWith(M))return!1;for(const M of this.includePrefix)if(p===M||p.startsWith(M))return!0;return!1}}e.TestRunDto=n;class t{constructor(N,p,M){this.proxy=N,this.runId=p,this.taskId=M}set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(p){throw this.fileCoverage=void 0,p}}async resolveFileCoverage(N,p){const M=await this.fileCoverage;let U=M?.[N];return!this._coverageProvider||!M||!U?[]:(U.detailedCoverage||(U=M[N]=await this._coverageProvider.resolveFileCoverage?.(U,p)??U),U.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class a extends f.IncrementalChangeCollector{constructor(N){super();this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(N){this.added.add(N)}update(N){Object.assign(N.revived,m.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}if(this.updated.delete(N),N.parent&&this.alreadyRemoved.has(N.parent)){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:p,removed:M}=this;return{get added(){return[...N].map(U=>U.revived)},get updated(){return[...p].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,p){return{...N,revived:m.TestItem.toPlain(N.item),depth:p?p.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=c;class u{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(p=>p.revived)},dispose:(0,k.once)(()=>{--N.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class S{constructor(N,p,M,U,z,re,H,F=!1,j=void 0){this.controllerId=M,this.profileId=U,this._label=z,this.kind=re,this.runHandler=H,this._isDefault=F,this._tag=j,l.set(this,void 0),h.set(this,void 0),et(this,l,N,"f"),et(this,h,p,"f"),p.set(U,this);const x=R[re];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);Ue(this,l,"f").$publishTestRunProfile({profileId:U,controllerId:M,tag:j?m.TestTag.namespace(this.controllerId,j.id):null,label:z,group:x,isDefault:F,hasConfigurationHandler:!1})}get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?m.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}dispose(){Ue(this,h,"f")?.delete(this.profileId)&&(et(this,h,void 0,"f"),Ue(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,l=new WeakMap,h=new WeakMap;const R={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(ye[254],De([0,1,16,3,5,133,15,7]),function(Y,e,d,i,_,A,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(L,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new i.Emitter,this._onDidChangeTextEditorOptions=new i.Emitter,this._onDidChangeTextEditorVisibleRanges=new i.Emitter,this._onDidChangeTextEditorViewColumn=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(D=>this._onDidChangeVisibleTextEditors.fire(D)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(D=>this._onDidChangeActiveTextEditor.fire(D))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const I=this._extHostDocumentsAndEditors.allEditors();return L?I:I.map(D=>D.value)}async showTextDocument(L,I,D){let T;typeof I=="number"?T={position:k.ViewColumn.from(I),preserveFocus:D}:typeof I=="object"?T={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:T={preserveFocus:!1};const C=await this._proxy.$tryShowTextDocument(L.uri,T),m=C&&this._extHostDocumentsAndEditors.getEditor(C);if(m)return m.value;throw C?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,I){return new A.TextEditorDecorationType(this._proxy,L,I).value}$acceptEditorPropertiesChanged(L,I){const D=this._extHostDocumentsAndEditors.getEditor(L);if(!D)throw new Error("unknown text editor");if(I.options&&D._acceptOptions(I.options),I.selections){const T=I.selections.selections.map(k.Selection.to);D._acceptSelections(T)}if(I.visibleRanges){const T=d.coalesce(I.visibleRanges.map(k.Range.to));D._acceptVisibleRanges(T)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:D.value,options:{...I.options,lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const T=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),C=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:D.value,selections:C,kind:T})}if(I.visibleRanges){const T=d.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:D.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const I in L){const D=this._extHostDocumentsAndEditors.getEditor(I);if(!D)throw new Error("Unknown text editor");const T=k.ViewColumn.to(L[I]);D.value.viewColumn!==T&&(D._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:D.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=w}),define(ye[255],De([0,1,2,4,5,6,7,15,14]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class P{constructor(D,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=D.getProxy(_.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===11){const m=C.uri===void 0?void 0:d.URI.revive(C.uri);return this._itemsBySourceAndUriMap.get(C.source)?.get(L(m))?.get(C.handle)}return C}})}async $getTimeline(D,T,C,m){return this._providers.get(D)?.provideTimeline(d.URI.revive(T),C,m)}registerTimelineProvider(D,T,C,m){const v=new A.DisposableStore,g=this.convertTimelineItem(T.id,m,v).bind(this);let b;T.onDidChange&&(b=T.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:T.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:D,onDidChange:void 0,async provideTimeline(l,h,o){h?.resetCache&&(v.clear(),f.get(T.id)?.clear());const E=await T.provideTimeline(l,h,o);if(E==null)return;const r=g(l,h);return{...E,source:T.id,items:E.items.map(r)}},dispose(){for(const l of f.values())l.get(T.id)?.clear();b?.dispose(),v.dispose()}})}convertTimelineItem(D,T,C){return(m,v)=>{let g;if(v?.cacheResults){let b=this._itemsBySourceAndUriMap.get(D);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(D,b));const f=L(m);g=b.get(f),g===void 0&&(g=new Map,b.set(f,g))}return b=>{const{iconPath:f,...l}=b,h=`${D}|${b.id??b.timestamp}`;g?.set(h,b);let o,E,r;b.iconPath&&(f instanceof k.ThemeIcon?r={id:f.id,color:f.color}:d.URI.isUri(f)?(o=f,E=f):{light:o,dark:E}=f);let s;return k.MarkdownString.isMarkdownString(l.tooltip)?s=y.MarkdownString.from(l.tooltip):(0,w.isString)(l.tooltip)?s=l.tooltip:k.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=y.MarkdownString.from(l.detail)):(0,w.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=l.detail),{...l,id:l.id??void 0,handle:h,source:D,command:b.command?T.toInternal(b.command,C):void 0,icon:o,iconDark:E,themeIcon:r,tooltip:s,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(D){if(this._providers.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this._proxy.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this._providers.set(D.id,D),(0,A.toDisposable)(()=>{for(const C of this._itemsBySourceAndUriMap.values())C.get(D.id)?.clear();this._providers.delete(D.id),this._proxy.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=P;function L(I){return I?.toString()}}),define(ye[256],De([0,1,6,10,2,5]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(w){this._openers=new Map,this._proxy=w.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,P,L,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const D=I.schemes.find(T=>!k.supportedSchemes.has(T));if(D)throw new Error(`Scheme '${D}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,L),this._proxy.$registerUriOpener(P,I.schemes,w,I.label),(0,d.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(w,P,L){const I=this._openers.get(w);if(!I)throw new Error(`Unknown opener with id: ${w}`);const D=_.URI.revive(P);return I.canOpenExternalUri(D,L)}async $openUri(w,P,L){const I=this._openers.get(w);if(!I)throw new Error(`Unknown opener id: '${w}'`);return I.openExternalUri(_.URI.revive(P.resolvedUri),{sourceUri:_.URI.revive(P.sourceUri)},L)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ye[257],De([0,1,5,2,6,11,28]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(P,L){if(this.handles.has(k.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=y.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(P)),this.handlers.set(I,L),this._proxy.$registerUriHandler(I,P),(0,_.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,L){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(i.URI.revive(L))}catch(D){(0,A.onUnexpectedError)(D)}return Promise.resolve(void 0)}async createAppUri(P){return i.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=y,y.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[70],De([0,1,3,10,2,189,209,87,5]),function(Y,e,d,i,_,A,k,y,w){"use strict";var P,L,I,D,T,C,m,v,g,b,f,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(c,u,S,R,O,N,p){P.set(this,void 0),L.set(this,void 0),I.set(this,void 0),D.set(this,void 0),T.set(this,void 0),C.set(this,void 0),m.set(this,""),v.set(this,void 0),g.set(this,!1),b.set(this,!1),f.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new d.Emitter),this._onDidDispose=Ue(this,l,"f").event,et(this,P,c,"f"),et(this,L,u,"f"),et(this,v,S,"f"),et(this,D,R,"f"),et(this,T,O,"f"),et(this,C,N,"f"),et(this,f,o(N),"f"),et(this,I,p,"f")}dispose(){et(this,g,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return et(this,b,!0,"f"),(0,y.asWebviewUri)(c,Ue(this,D,"f"))}get cspSource(){const c=Ue(this,C,"f").extensionLocation;if(c.scheme===i.Schemas.https||c.scheme===i.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,m,"f")}set html(c){this.assertNotDisposed(),Ue(this,m,"f")!==c&&(et(this,m,c,"f"),!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(et(this,b,!0,"f"),Ue(this,I,"f").report("Webview vscode-resource: uris",Ue(this,C,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,L,"f").$setHtml(Ue(this,P,"f"),c))}get options(){return this.assertNotDisposed(),Ue(this,v,"f")}set options(c){this.assertNotDisposed(),Ue(this,L,"f").$setOptions(Ue(this,P,"f"),s(Ue(this,C,"f"),Ue(this,T,"f"),c)),et(this,v,c,"f")}async postMessage(c){if(Ue(this,g,"f"))return!1;const u=(0,k.serializeWebviewMessage)(c,{serializeBuffersForPostMessage:Ue(this,f,"f")});return Ue(this,L,"f").$postMessage(Ue(this,P,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ue(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,P=new WeakMap,L=new WeakMap,I=new WeakMap,D=new WeakMap,T=new WeakMap,C=new WeakMap,m=new WeakMap,v=new WeakMap,g=new WeakMap,b=new WeakMap,f=new WeakMap,l=new WeakMap;function o(a){try{const c=(0,A.normalizeVersion)((0,A.parseVersion)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class E{constructor(c,u,S,R,O){this.remoteInfo=u,this.workspace=S,this._logService=R,this._deprecationService=O,this._webviews=new Map,this._webviewProxy=c.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(c,u,S){const R=this.getWebview(c);if(R){const{message:O}=(0,k.deserializeWebviewMessage)(u,S.value);R._onMessageEmitter.fire(O)}}$onMissingCsp(c,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,S){const R=new h(c,this._webviewProxy,n(u),this.remoteInfo,this.workspace,S,this._deprecationService);return this._webviews.set(c,R),R._onDidDispose(()=>{this._webviews.delete(c)}),R}deleteWebview(c){this._webviews.delete(c)}getWebview(c){return this._webviews.get(c)}}e.ExtHostWebviews=E;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=r;function s(a,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||t(a,c)}}e.serializeWebviewOptions=s;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>_.URI.from(c))}}e.reviveOptions=n;function t(a,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),a.extensionLocation]}}),define(ye[258],De([0,1,21,59,6,10,22,2,15,70,86,5,7]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(o,E){this.document=o,this._storagePath=E,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,E){await this.getEdit(o).undo(),E||this.disposeBackup()}async redo(o,E){await this.getEdit(o).redo(),E||this.disposeBackup()}disposeEdits(o){for(const E of o)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=l(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const E=this._edits.get(o,0);if(!E)throw new Error("No edit found");return E}}class C{constructor(){this._documents=new Map}get(o,E){return this._documents.get(this.key(o,E))}add(o,E,r){const s=this.key(o,E.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${o} resource:${E.uri}`);const n=new T(E,r);return this._documents.set(s,n),n}delete(o,E){const r=this.key(o,E.uri);this._documents.delete(r)}key(o,E){return`${o}@@@${E}`}}var m;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(m||(m={}));class v{constructor(){this._providers=new Map}addTextProvider(o,E,r){return this.add(0,o,E,r)}addCustomProvider(o,E,r){return this.add(1,o,E,r)}get(o){return this._providers.get(o)}add(o,E,r,s){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:o,extension:r,provider:s}),new D.Disposable(()=>this._providers.delete(E))}}class g{constructor(o,E,r,s,n){this._extHostDocuments=E,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=n,this._editorProviders=new v,this._documents=new C,this._proxy=o.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,E,r,s){const n=new _.DisposableStore;return b(r)?(n.add(this._editorProviders.addTextProvider(E,o,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(o),E,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(E,o,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(t=>{const a=this.getCustomDocumentEntry(E,t.document.uri);if(f(t)){const c=a.addEdit(t);this._proxy.$onDidEdit(t.document.uri,E,c,t.label)}else this._proxy.$onContentChange(t.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(o),E,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(o))),D.Disposable.from(n,new D.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(o,E,r,s,n){const t=this._editorProviders.get(E);if(!t)throw new Error(`No provider found for '${E}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${E}'`);const a=y.URI.revive(o),c=await t.provider.openCustomDocument(a,{backupId:r,untitledDocumentData:s?.buffer},n);let u;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(E,c,u),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(o,E){const r=this._editorProviders.get(E);if(!r)throw new Error(`No provider found for '${E}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${E}'`);const s=y.URI.revive(o),{document:n}=this.getCustomDocumentEntry(E,s);this._documents.delete(E,n),n.dispose()}async $resolveWebviewEditor(o,E,r,s,n,t){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);const c=w.ViewColumn.to(n),u=this._extHostWebview.createNewWebview(E,s.webviewOptions,a.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(E,r,s.title,c,s.panelOptions,u,!0),R=y.URI.revive(o);switch(a.type){case 1:{const{document:O}=this.getCustomDocumentEntry(r,R);return a.provider.resolveCustomEditor(O,S,t)}case 0:{const O=this._extHostDocuments.getDocument(R);return a.provider.resolveCustomTextEditor(O,S,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,E,r){this.getCustomDocumentEntry(E,o).disposeEdits(r)}async $onMoveCustomEditor(o,E,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const t=y.URI.revive(E),a=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(a,n,d.CancellationToken.None)}async $undo(o,E,r,s){return this.getCustomDocumentEntry(E,o).undo(r,s)}async $redo(o,E,r,s){return this.getCustomDocumentEntry(E,o).redo(r,s)}async $revert(o,E,r){const s=this.getCustomDocumentEntry(E,o);await this.getCustomEditorProvider(E).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(o,E,r){const s=this.getCustomDocumentEntry(E,o);await this.getCustomEditorProvider(E).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(o,E,r,s){const n=this.getCustomDocumentEntry(E,o);return this.getCustomEditorProvider(E).saveCustomDocumentAs(n.document,y.URI.revive(r),s)}async $backup(o,E,r){const s=this.getCustomDocumentEntry(E,o),t=await this.getCustomEditorProvider(E).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(t),t.id}getCustomDocumentEntry(o,E){const r=this._documents.get(o,y.URI.revive(E));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function b(h){return typeof h.resolveCustomTextEditor=="function"}function f(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function l(h){const o=h.scheme===A.Schemas.file||h.scheme===A.Schemas.untitled?h.fsPath:h.toString();return(0,i.hash)(o)+""}});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[259],De([0,1,3,6,2,36,15,70,5,7]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";var L,I,D,T,C,m,v,g,b,f,l,h,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends i.Disposable{constructor(t,a,c,u){super();L.set(this,void 0),I.set(this,void 0),D.set(this,void 0),T.set(this,void 0),C.set(this,void 0),m.set(this,void 0),v.set(this,void 0),g.set(this,void 0),b.set(this,!0),f.set(this,void 0),l.set(this,!1),h.set(this,this._register(new d.Emitter)),this.onDidDispose=Ue(this,h,"f").event,o.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ue(this,o,"f").event,et(this,L,t,"f"),et(this,I,a,"f"),et(this,T,c,"f"),et(this,D,u.viewType,"f"),et(this,C,u.panelOptions,"f"),et(this,g,u.viewColumn,"f"),et(this,m,u.title,"f"),et(this,f,u.active,"f")}dispose(){Ue(this,l,"f")||(et(this,l,!0,"f"),Ue(this,h,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,D,"f")}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(t){this.assertNotDisposed(),Ue(this,m,"f")!==t&&(et(this,m,t,"f"),Ue(this,I,"f").$setTitle(Ue(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),Ue(this,v,"f")}set iconPath(t){this.assertNotDisposed(),Ue(this,v,"f")!==t&&(et(this,v,t,"f"),Ue(this,I,"f").$setIconPath(Ue(this,L,"f"),_.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Ue(this,C,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,g,"f")=="number"&&Ue(this,g,"f")<0))return Ue(this,g,"f")}get active(){return this.assertNotDisposed(),Ue(this,f,"f")}get visible(){return this.assertNotDisposed(),Ue(this,b,"f")}_updateViewState(t){Ue(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(et(this,f,t.active,"f"),et(this,b,t.visible,"f"),et(this,g,t.viewColumn,"f"),Ue(this,o,"f").fire({webviewPanel:this}))}reveal(t,a){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:k.ViewColumn.from(t),preserveFocus:!!a})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,I=new WeakMap,D=new WeakMap,T=new WeakMap,C=new WeakMap,m=new WeakMap,v=new WeakMap,g=new WeakMap,b=new WeakMap,f=new WeakMap,l=new WeakMap,h=new WeakMap,o=new WeakMap;class r{constructor(t,a,c){this.webviews=a,this.workspace=c,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(w.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(t,a,c,u,S={}){const R=typeof u=="object"?u.viewColumn:u,O={viewColumn:k.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},N=(0,y.shouldSerializeBuffersForPostMessage)(t),p=r.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(t),p,a,{title:c,panelOptions:s(S),webviewOptions:(0,y.serializeWebviewOptions)(t,this.workspace,S),serializeBuffersForPostMessage:N},O);const M=this.webviews.createNewWebview(p,S,t);return this.createNewWebviewPanel(p,a,c,R,S,M,!0)}$onDidChangeWebviewPanelViewStates(t){const a=Object.keys(t);a.sort((c,u)=>{const S=t[c],R=t[u];return S.active?1:R.active?-1:+S.visible-+R.visible});for(const c of a){const u=this.getWebviewPanel(c);if(!u)continue;const S=t[c];u._updateViewState({active:S.active,visible:S.visible,viewColumn:k.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,a,c){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:c,extension:t}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(t,a,c,u){const S=this._serializers.get(a);if(!S)throw new Error(`No serializer found for '${a}'`);const{serializer:R,extension:O}=S,N=this.webviews.createNewWebview(t,c.webviewOptions,O),p=this.createNewWebviewPanel(t,a,c.title,u,c.panelOptions,N,c.active);await R.deserializeWebviewPanel(p,c.state)}createNewWebviewPanel(t,a,c,u,S,R,O){const N=new E(t,this._proxy,R,{viewType:a,title:c,viewColumn:u,panelOptions:S,active:O});return this._webviewPanels.set(t,N),N}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function s(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[260],De([0,1,3,6,70,25,15,5,7]),function(Y,e,d,i,_,A,k,y,w){"use strict";var P,L,I,D,T,C,m,v,g,b,f,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends i.Disposable{constructor(r,s,n,t,a,c,u){super();P.set(this,void 0),L.set(this,void 0),I.set(this,void 0),D.set(this,void 0),T.set(this,void 0),C.set(this,!1),m.set(this,void 0),v.set(this,void 0),g.set(this,void 0),b.set(this,void 0),f.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,l.set(this,this._register(new d.Emitter)),this.onDidDispose=Ue(this,l,"f").event,et(this,I,n,"f"),et(this,v,t,"f"),et(this,P,r,"f"),et(this,L,s,"f"),et(this,D,a,"f"),et(this,T,c,"f"),et(this,m,u,"f")}dispose(){Ue(this,C,"f")||(et(this,C,!0,"f"),Ue(this,l,"f").fire(),Ue(this,D,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,v,"f")}set title(r){this.assertNotDisposed(),Ue(this,v,"f")!==r&&(et(this,v,r,"f"),Ue(this,L,"f").$setWebviewViewTitle(Ue(this,P,"f"),r))}get description(){return this.assertNotDisposed(),Ue(this,g,"f")}set description(r){this.assertNotDisposed(),Ue(this,g,"f")!==r&&(et(this,g,r,"f"),Ue(this,L,"f").$setWebviewViewDescription(Ue(this,P,"f"),r))}get visible(){return Ue(this,m,"f")}get webview(){return Ue(this,D,"f")}get viewType(){return Ue(this,I,"f")}_setVisible(r){r===Ue(this,m,"f")||Ue(this,C,"f")||(et(this,m,r,"f"),Ue(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Ue(this,T,"f"),"badges"),Ue(this,b,"f")}set badge(r){this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Ue(this,T,"f"),"badges"),!(r?.value===Ue(this,b,"f")?.value&&r?.tooltip===Ue(this,b,"f")?.tooltip)&&(et(this,b,k.ViewBadge.from(r),"f"),Ue(this,L,"f").$setWebviewViewBadge(Ue(this,P,"f"),r))}show(r){this.assertNotDisposed(),Ue(this,L,"f").$show(Ue(this,P,"f"),!!r)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,L=new WeakMap,I=new WeakMap,D=new WeakMap,T=new WeakMap,C=new WeakMap,m=new WeakMap,v=new WeakMap,g=new WeakMap,b=new WeakMap,f=new WeakMap,l=new WeakMap;class o{constructor(r,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,n,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:n,extension:r}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(r),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new w.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,n,t,a){const c=this._viewProviders.get(s);if(!c)throw new Error(`No view provider found for '${s}'`);const{provider:u,extension:S}=c,R=this._extHostWebview.createNewWebview(r,{},S),O=new h(r,this._proxy,s,n,R,S,!0);this._webviewViews.set(r,O),await u.resolveWebviewView(O,{state:t},a)}async $onDidChangeWebviewViewVisibility(r,s){this.getWebviewView(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.getWebviewView(r);this._webviewViews.delete(r),s.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const s=this._webviewViews.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=o}),define(ye[138],De([0,1,3,5,2,10,8,4,18]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Yi{constructor(I){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yi.InitialState,this._proxy=I.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(D=>this.$onDidChangeWindowFocus(D))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,D){let T;if(typeof I=="string"){T=I;try{I=_.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,k.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,T,D)}async asExternalUri(I,D){if((0,k.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(I,D);return _.URI.from(T)}};P.InitialState={focused:!0},P=je([xe(0,w.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(ye[261],De([0,1,9,49,36,38,6,5,2,18]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends k.Disposable{constructor(D,T){super();const C=D.getProxy(y.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async m=>{const v=w.URI.file((0,d.join)((0,i.tmpdir)(),(0,_.generateUuid)()));return await C.$download(m,v),v})}};L=je([xe(0,P.IExtHostRpcService),xe(1,A.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[262],De([0,1,136,10,195,36]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class k extends d.ExtHostLoggerService{doCreateLogger(w,P,L){return w.scheme===i.Schemas.file?new _.SpdLogLogger(L?.name||(0,A.generateUuid)(),w.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,P):super.doCreateLogger(w,P,L)}}e.ExtHostLoggerService=k}),define(ye[263],De([0,1,61,9,2,69,6,10,17,29]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const E=await super._getWorkspaceStorageURI(o);if(E.scheme!==y.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const r=E.fsPath;let s=0;do{let n;s===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await I(n);const t=i.join(n,"vscode.lock"),a=await m(this._logService,t,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),_.URI.file(n);s++}while(s<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function I(h){try{await P.Promises.stat(h);return}catch{}try{await P.Promises.mkdir(h,{recursive:!0})}catch{}}const D=1e3,T=10*60*1e3;class C extends k.Disposable{constructor(o,E){super();this.logService=o,this.filename=E,this._timer=this._register(new w.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(o,E);(!r||r.pid!==process.pid)&&(o.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(E,new Date,new Date)}catch(s){o.error(s),o.info(`Lock '${E}': Could not update mtime.`)}},D)}dispose(){super.dispose();try{d.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+o};await P.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function m(h,o,E){try{const s={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(o,JSON.stringify(s),{flag:"wx"})}catch(s){h.error(s)}const r=await v(h,o);return!r||r.pid!==process.pid?E?(h.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),f(h,o)):(h.info(`Lock '${o}': Lock acquired.`),new C(h,o))}async function v(h,o){let E;try{E=await P.Promises.readFile(o)}catch(r){return h.error(r),null}try{return JSON.parse(String(E))}catch(r){return h.error(r),null}}async function g(h,o){let E;try{E=await P.Promises.stat(o)}catch(r){return h.error(r),0}return E.mtime.getTime()}function b(h){try{return process.kill(h,0),!0}catch{return!1}}async function f(h,o){const E=await v(h,o);if(!E)return h.info(`Lock '${o}': Could not read pid of lock holder.`),l(h,o);if(E.willReleaseAt){let a=E.willReleaseAt-Date.now();if(a<5e3){for(a>0?h.info(`Lock '${o}': The lockfile is scheduled to be released in ${a} ms.`):h.info(`Lock '${o}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,w.timeout)(Math.min(100,a)),await g(h,o)===0)return l(h,o);a=E.willReleaseAt-Date.now()}return l(h,o)}}if(!b(E.pid))return h.info(`Lock '${o}': The pid ${E.pid} appears to be gone.`),l(h,o);const r=await g(h,o),s=Date.now()-r;if(s<=T)return h.info(`Lock '${o}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;h.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,w.timeout)(2e3);const n=await g(h,o),t=Date.now()-n;return t<=T?(h.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(h.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),l(h,o))}async function l(h,o){h.info(`Lock '${o}': Deleting a stale lock.`);try{await P.Promises.unlink(o)}catch{}return m(h,o,!0)}}),define(ye[264],De([0,1,36,18,39]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends _.BaseExtHostTerminalService{constructor(y){super(!0,y)}createTerminal(y,w,P){return this.createTerminalFromOptions({name:y,shellPath:w,shellArgs:P})}createTerminalFromOptions(y,w){const P=new _.ExtHostTerminal(this._proxy,(0,d.generateUuid)(),y,y.name);return this._terminals.push(P),P.create(y,this._serializeParentTerminal(y,w)),P.value}};A=je([xe(0,i.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(ye[265],De([0,1,5,18,179,6,27,2,41,22,29,7,12,52,3,122,93,13]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(c,u,S){this.remoteAddress=c,this.localAddress=u,this._dispose=S,this._onDispose=new C.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function f(a){const c=a.trim().split(`
`),u=[];return c.forEach(R=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);O&&O.length>=3&&u.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),u.reduce((R,O)=>(R[O.socket]=O,R),{})}e.getSockets=f;function l(...a){const c=[].concat(...a.map(o));return[...new Map(c.filter(u=>u.st==="0A").map(u=>{const S=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:h(S[0]),port:parseInt(S[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=l;function h(a){let c="";if(a.length===8)for(let u=a.length-2;u>=0;u-=2)c+=parseInt(a.substr(u,2),16),u!==0&&(c+=".");else for(let u=a.length-4;u>=0;u-=4)c+=parseInt(a.substr(u,4),16).toString(16),u!==0&&(c+=":");return c}e.parseIpAddress=h;function o(a){const c=a.trim().split(`
`),u=c.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return c.map(R=>R.trim().split(/\s+/).reduce((O,N,p)=>(O[u[p]||p]=N,O),{}))}e.loadConnectionTable=o;function E(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/server-main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function r(a){const c=a.trim().split(`
`),u=[];return c.forEach(S=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);R&&R.length>=4&&u.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),u}e.getRootProcesses=r;async function s(a,c,u){const S=u.reduce((O,N)=>(O[N.pid]=N,O),{}),R=[];return a.forEach(({socket:O,ip:N,port:p})=>{const M=c[O]?c[O].pid:void 0,U=M?S[M]?.cmd:void 0;M&&U&&!E(U)&&R.push({host:N,port:p,detail:U,pid:M})}),R}e.findPorts=s;function n(a,c,u){const S=new Map,R=r(c);for(const O of a){const N=u.get(O.port);if(N){S.set(O.port,N);continue}const p=R.find(M=>M.cmd.includes(`${O.port}`));if(p){let M=p,U;do U=R.find(z=>z.ppid===M.pid),U&&(M=U);while(U);S.set(O.port,{host:O.ip,port:O.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else S.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=n;let t=class extends A.Disposable{constructor(c,u,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new C.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=c.getProxy(d.MainContext.MainThreadTunnelService),D.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(c,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(u,c.displayName);if(S){const R=new b(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(c){return Math.max(c*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(c,u){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:c,provider:u}),this._proxy.$registerPortsAttributesProvider(c,S),new I.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(c,u,S,R,O){const N=[];for(const M of c){const U=this._portAttributesProviders.get(M);if(!U)return[];N.push(...await Promise.all(u.map(async z=>U.provider.providePortAttributes(z,S,R,O))))}const p=N.filter(M=>!!M);return p.length>0?p.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(c){if(c&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=c;let u=new v.MovingAverage,S;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),O=(await this.findCandidatePorts()).filter(p=>(0,m.isLocalhost)(p.host)||(0,m.isAllInterfaces)(p.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(p=>p.port).join(", ")}`);const N=new Date().getTime()-R;u.update(N),(!S||JSON.stringify(S)!==JSON.stringify(O))&&(S=O,await this._proxy.$onFoundNewCandidates(S)),await new Promise(p=>setTimeout(()=>p(),this.calculateDelay(u.value)))}}async setTunnelFactory(c){if(c){if(c.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this._showCandidatePort=c.showCandidatePort,this._proxy.$setCandidateFilter()),c.tunnelFactory){this._forwardPortProvider=c.tunnelFactory;let u=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:_.localize(0,null),themeIcon:"lock"},{id:"public",label:_.localize(1,null),themeIcon:"eye"}]);const S=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:u}:void 0;this._proxy.$setTunnelProvider(S)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(c,u){if(this._extensionTunnels.has(c.host)){const S=this._extensionTunnels.get(c.host);S.has(c.port)&&(u&&S.get(c.port).disposeListener.dispose(),await S.get(c.port).tunnel.dispose(),S.delete(c.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(c,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(c,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const R=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(c.remoteAddress.host)||this._extensionTunnels.set(c.remoteAddress.host,new Map);const O=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:R,disposeListener:O}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(c){const u=await Promise.all(c.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),S=c.filter((R,O)=>u[O]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(R=>R.port).join(", ")} to ${S.map(R=>R.port).join(", ")}`),S}async findCandidatePorts(){let c="",u="";try{c=await L.Promises.readFile("/proc/net/tcp","utf8"),u=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=l(c,u),R=await new Promise(H=>{(0,w.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,j,x)=>{H(j)})}),O=f(R),N=await L.Promises.readdir("/proc"),p=[];for(let H of N)try{const F=Number(H),j=P.joinPath(y.URI.file("/proc"),H);if((await L.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(F)){const V=await L.Promises.readlink(P.joinPath(j,"cwd").fsPath),ne=await L.Promises.readFile(P.joinPath(j,"cmdline").fsPath,"utf8");p.push({pid:F,cwd:V,cmd:ne})}}catch{}const M=[],U=S.filter(H=>{const F=O[H.socket];return F||M.push(H),F}),z=s(U,O,p);let re;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const H=await new Promise(F=>{(0,w.exec)("ps -F -A -l | grep root",(j,x,V)=>{F(x)})});this._foundRootPorts=n(M,H,this._foundRootPorts),re=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${re.join(", ")}`)}return z.then(H=>re?H.concat(re):H)}};t=je([xe(0,i.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,g.ILogService)],t),e.ExtHostTunnelService=t}),define(ye[266],De([0,1,17,23,21,11,3,6,103,229,53]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function D(S,R){try{return JSON.stringify(S,R)}catch{return"null"}}const T="$$ref$$",C={[T]:-1};class m{constructor(R,O){this.jsonString=R,this.referencedBuffers=O}}function v(S,R=null,O=!1){const N=[];return{jsonString:(O?D:JSON.stringify)(S,(M,U)=>{if(typeof U=="undefined")return C;if(typeof U=="object"){if(U instanceof i.VSBuffer){const z=N.push(U)-1;return{[T]:z}}if(R)return R(M,U)}return U}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=v;function g(S,R,O){return JSON.parse(S,(N,p)=>{if(p){const M=p[T];if(typeof M=="number")return R[M];if(O&&p.$mid===1)return O.transformIncoming(p)}return p})}e.parseJsonAndRestoreBufferRefs=g;function b(S,R){return JSON.stringify(S,R)}function f(S){return S?(R,O)=>O&&O.$mid===1?S.transformOutgoing(O):O:null}var l;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var h;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(h=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},E=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends y.Disposable{constructor(R,O=null,N=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=O,this._uriTransformer=N,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let p=0,M=L.ProxyIdentifier.count;p<M;p++)this._locals[p]=null,this._proxies[p]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(p=>this._receiveOneMessage(p))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,w.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:O,sid:N}=R;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,N)),this._proxies[O]}_createProxy(R,O){let N={get:(p,M)=>(typeof M=="string"&&!p[M]&&M.charCodeAt(0)===36&&(p[M]=(...U)=>this._remoteCall(R,M,U)),M===r?O:p[M])};return new Proxy(Object.create(null),N)}set(R,O){return this._locals[R.nid]=O,O}assertRegistered(R){for(let O=0,N=R.length;O<N;O++){const p=R[O];if(!this._locals[p.nid])throw new Error(`Missing proxy instance ${p.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const O=R.byteLength,N=n.read(R,0),p=N.readUInt8(),M=N.readUInt32();switch(p){case 1:case 2:{let{rpcId:U,method:z,args:re}=a.deserializeRequestJSONArgs(N);this._uriTransformer&&(re=(0,w.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(O,M,U,z,re,p===2);break}case 3:case 4:{let{rpcId:U,method:z,args:re}=a.deserializeRequestMixedArgs(N);this._uriTransformer&&(re=(0,w.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(O,M,U,z,re,p===4);break}case 5:{this._logger&&this._logger.logIncoming(O,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(O,M);break}case 7:{this._receiveReply(O,M,void 0);break}case 9:{let U=a.deserializeReplyOKJSON(N);this._uriTransformer&&(U=(0,w.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(O,M,U);break}case 10:{const U=a.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(O,M,U);break}case 8:{let U=a.deserializeReplyOKVSBuffer(N);this._receiveReply(O,M,U);break}case 11:{let U=a.deserializeReplyErrError(N);this._uriTransformer&&(U=(0,w.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(O,M,U);break}case 12:{this._receiveReplyErr(O,M,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,O,N,p,M,U){this._logger&&this._logger.logIncoming(R,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${p}(`,M);const z=String(O);let re,H;if(U){const j=new _.CancellationTokenSource;M.push(j.token),re=this._invokeHandler(N,p,M),H=()=>j.cancel()}else re=this._invokeHandler(N,p,M),H=o;this._cancelInvokedHandlers[z]=H;const F=a.serializeAcknowledged(O);this._logger&&this._logger.logOutgoing(F.byteLength,O,1,"ack"),this._protocol.send(F),re.then(j=>{delete this._cancelInvokedHandlers[z];const x=a.serializeReplyOK(O,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,O,1,"reply:",j),this._protocol.send(x)},j=>{delete this._cancelInvokedHandlers[z];const x=a.serializeReplyErr(O,j);this._logger&&this._logger.logOutgoing(x.byteLength,O,1,"replyErr:",j),this._protocol.send(x)})}_receiveCancel(R,O){this._logger&&this._logger.logIncoming(R,O,1,"receiveCancel");const N=String(O);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(R,O,N){this._logger&&this._logger.logIncoming(R,O,0,"receiveReply:",N);const p=String(O);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const M=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p],M.resolveOk(N)}_receiveReplyErr(R,O,N){this._logger&&this._logger.logIncoming(R,O,0,"receiveReplyErr:",N);const p=String(O);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const M=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p];let U;N&&(N.$isError?(U=new Error,U.name=N.name,U.message=N.message,U.stack=N.stack):U=N),M.resolveErr(U)}_invokeHandler(R,O,N){try{return Promise.resolve(this._doInvokeHandler(R,O,N))}catch(p){return Promise.reject(p)}}_doInvokeHandler(R,O,N){const p=this._locals[R];if(!p)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));let M=p[O];if(typeof M!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(R));return M.apply(p,N)}_remoteCall(R,O,N){if(this._isDisposed)return Promise.reject(A.canceled());let p=null;if(N.length>0&&_.CancellationToken.isCancellationToken(N[N.length-1])&&(p=N.pop()),p&&p.isCancellationRequested)return Promise.reject(A.canceled());const M=a.serializeRequestArguments(N,this._uriReplacer),U=++this._lastMessageId,z=String(U),re=new P.LazyPromise;p&&p.onCancellationRequested(()=>{const F=a.serializeCancel(U);this._logger&&this._logger.logOutgoing(F.byteLength,U,0,"cancel"),this._protocol.send(a.serializeCancel(U))}),this._pendingRPCReplies[z]=re,this._onWillSendRequest(U);const H=a.serializeRequest(U,R,O,M,!!p);return this._logger&&this._logger.logOutgoing(H.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${O}(`,N),this._protocol.send(H),re}}e.RPCProtocol=s,I=E,s.UNRESPONSIVE_TIME=3*1e3;class n{constructor(R,O){this._buff=R,this._offset=O}static alloc(R,O,N){let p=new n(i.VSBuffer.alloc(N+1+4),0);return p.writeUInt8(R),p.writeUInt32(O),p}static read(R,O){return new n(R,O)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,N}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,N}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,O}static sizeMixedArray(R){let O=0;O+=1;for(let N=0,p=R.length;N<p;N++){const M=R[N];switch(O+=1,M.type){case 1:O+=this.sizeLongString(M.value);break;case 2:O+=this.sizeVSBuffer(M.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(M.value);for(let U=0;U<M.buffers.length;++U)O+=this.sizeVSBuffer(M.buffers[U]);break;case 4:break}}return O}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let O=0,N=R.length;O<N;O++){const p=R[O];switch(p.type){case 1:this.writeUInt8(1),this.writeLongString(p.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p.value);break;case 3:this.writeUInt8(3),this.writeUInt32(p.buffers.length),this.writeLongString(p.value);for(let M=0;M<p.buffers.length;++M)this.writeBuffer(p.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let O=new Array(R);for(let N=0;N<R;N++)switch(this.readUInt8()){case 1:O[N]=this.readLongString();break;case 2:O[N]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),U=this.readLongString(),z=[];for(let re=0;re<M;++re)z.push(this.readVSBuffer());O[N]=new L.SerializableObjectWithBuffers(g(U,z,null));break}case 4:O[N]=void 0;break}return O}}n.sizeUInt32=4;var t;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(t||(t={}));class a{static _useMixedArgSerialization(R){for(let O=0,N=R.length;O<N;O++)if(R[O]instanceof i.VSBuffer||R[O]instanceof L.SerializableObjectWithBuffers||typeof R[O]=="undefined")return!0;return!1}static serializeRequestArguments(R,O){if(this._useMixedArgSerialization(R)){const N=[];for(let p=0,M=R.length;p<M;p++){const U=R[p];if(U instanceof i.VSBuffer)N[p]={type:2,value:U};else if(typeof U=="undefined")N[p]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:re}=v(U.value,O);N[p]={type:3,value:i.VSBuffer.fromString(z),buffers:re}}else N[p]={type:1,value:i.VSBuffer.fromString(b(U,O))}}return{type:1,args:N}}return{type:0,args:b(R,O)}}static serializeRequest(R,O,N,p,M){switch(p.type){case 0:return this._requestJSONArgs(R,O,N,p.args,M);case 1:return this._requestMixedArgs(R,O,N,p.args,M)}}static _requestJSONArgs(R,O,N,p,M){const U=i.VSBuffer.fromString(N),z=i.VSBuffer.fromString(p);let re=0;re+=n.sizeUInt8(),re+=n.sizeShortString(U),re+=n.sizeLongString(z);let H=n.alloc(M?2:1,R,re);return H.writeUInt8(O),H.writeShortString(U),H.writeLongString(z),H.buffer}static deserializeRequestJSONArgs(R){const O=R.readUInt8(),N=R.readShortString(),p=R.readLongString();return{rpcId:O,method:N,args:JSON.parse(p)}}static _requestMixedArgs(R,O,N,p,M){const U=i.VSBuffer.fromString(N);let z=0;z+=n.sizeUInt8(),z+=n.sizeShortString(U),z+=n.sizeMixedArray(p);let re=n.alloc(M?4:3,R,z);return re.writeUInt8(O),re.writeShortString(U),re.writeMixedArray(p),re.buffer}static deserializeRequestMixedArgs(R){const O=R.readUInt8(),N=R.readShortString(),p=R.readMixedArray(),M=new Array(p.length);for(let U=0,z=p.length;U<z;U++){const re=p[U];typeof re=="string"?M[U]=JSON.parse(re):M[U]=re}return{rpcId:O,method:N,args:M}}static serializeAcknowledged(R){return n.alloc(5,R,0).buffer}static serializeCancel(R){return n.alloc(6,R,0).buffer}static serializeReplyOK(R,O,N){if(typeof O=="undefined")return this._serializeReplyOKEmpty(R);if(O instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(R,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:p,referencedBuffers:M}=v(O.value,N,!0);return this._serializeReplyOKJSONWithBuffers(R,p,M)}else return this._serializeReplyOKJSON(R,D(O,N))}static _serializeReplyOKEmpty(R){return n.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,O){let N=0;N+=n.sizeVSBuffer(O);let p=n.alloc(8,R,N);return p.writeVSBuffer(O),p.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,O){const N=i.VSBuffer.fromString(O);let p=0;p+=n.sizeLongString(N);let M=n.alloc(9,R,p);return M.writeLongString(N),M.buffer}static _serializeReplyOKJSONWithBuffers(R,O,N){const p=i.VSBuffer.fromString(O);let M=0;M+=n.sizeUInt32,M+=n.sizeLongString(p);for(const z of N)M+=n.sizeVSBuffer(z);let U=n.alloc(10,R,M);U.writeUInt32(N.length),U.writeLongString(p);for(const z of N)U.writeBuffer(z);return U.buffer}static deserializeReplyOKJSON(R){const O=R.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(R,O){const N=R.readUInt32(),p=R.readLongString(),M=[];for(let U=0;U<N;++U)M.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(g(p,M,O))}static serializeReplyErr(R,O){const N=O?D(A.transformErrorForSerialization(O),null):void 0;if(typeof N!="string")return this._serializeReplyErrEmpty(R);const p=i.VSBuffer.fromString(N);let M=0;M+=n.sizeLongString(p);let U=n.alloc(11,R,M);return U.writeLongString(p),U.buffer}static deserializeReplyErrError(R){const O=R.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(R){return n.alloc(12,R,0).buffer}}var c;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var u;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(u||(u={}))}),define(ye[267],De([0,1,3,44,63,4,42,11,17]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new _.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new _.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new _.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new d.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new d.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(C){this.channels.has(C.id)||(this.channels.set(C.id,C),this._onDidRegisterChannel.fire(C.id))}getChannels(){const C=[];return this.channels.forEach(m=>C.push(m)),C}getChannel(C){return this.channels.get(C)}removeChannel(C){this.channels.delete(C),this._onDidRemoveChannel.fire(C)}}i.Registry.add(e.Extensions.OutputChannels,new L);function I(T,C,m,v,g){return(0,w.createCancelablePromise)(async b=>{await(0,k.whenProviderRegistered)(m,v);const f=i.Registry.as(e.Extensions.OutputChannels);try{await D(m,1,v,g,b),f.registerChannel({id:T,label:C,file:m,log:!0})}catch(l){(0,y.isCancellationError)(l)||g.error("Error while registering log channel",m.toString(),(0,y.getErrorMessage)(l))}})}e.registerLogChannel=I;async function D(T,C,m,v,g){if(!await m.exists(T)){if(g.isCancellationRequested)throw new y.CancellationError;if(C>10)throw new Error("Timed out while waiting for file to be created");v.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,w.timeout)(1e3,g),await D(T,C+1,m,v,g)}}}),define(ye[139],De([0,1,5,6,4,18,13,267,68,27,46,160,23,14]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class C extends i.Disposable{constructor(g,b,f,l){super();this.id=g,this.name=b,this.logger=f,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Clear,g)}replace(g){const b=this.offset;this.write(g),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Replace,b),this.visible&&this.logger.flush()}show(g,b){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:b))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=D.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=C;let m=class{constructor(g,b,f,l,h){this.extHostFileSystem=f,this.extHostFileSystemInfo=l,this.loggerService=h,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(d.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(b.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[b,f]of this.channels)f.visible=b===this.visibleChannelId}createOutputChannel(g,b,f){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(b)&&!b.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(g,b,f);return l.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,l)}async doCreateOutputChannel(g,b,f){const l=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),E=await this.proxy.$register(g,!1,h,b,f.identifier.value);return new C(E,g,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,b){let f=!1;const l=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return g},append(h){l(),b.then(o=>o.append(h))},appendLine(h){l(),b.then(o=>o.appendLine(h))},clear(){l(),b.then(h=>h.clear())},replace(h){l(),b.then(o=>o.replace(h))},show(h,o){l(),b.then(E=>E.show(h,o))},hide(){l(),b.then(h=>h.hide())},dispose(){f=!0,b.then(h=>h.dispose())}}}};m=je([xe(0,A.IExtHostRpcService),xe(1,P.IExtHostInitDataService),xe(2,w.IExtHostConsumerFileSystem),xe(3,L.IExtHostFileSystemInfo),xe(4,k.ILoggerService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(ye[268],De([0,1,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(ye[269],De([0,1,30,10,9,12,22,2,4,204,45,225,268]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let T=class Ji{constructor(m,v,g,b){this.localUserHome=m,this.remoteAgentService=v,this.environmentService=g,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome||m})()}hasValidBasename(m,v,g){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(b=>this.doHasValidBasename(m,b,v)):this.doHasValidBasename(m,v,g)}doHasValidBasename(m,v,g){return m.scheme===i.Schemas.file||m.scheme===i.Schemas.vscodeRemote?(0,d.isValidBasename)(g??(0,k.basename)(m),v===1):!0}get defaultUriScheme(){return Ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,v){if(m.remoteAuthority)return i.Schemas.vscodeRemote;const g=(0,P.getVirtualWorkspaceScheme)(v.getWorkspace());if(g)return g;const b=v.getWorkspace().folders[0];if(b)return b.uri.scheme;const f=v.getWorkspace().configuration;return f?f.scheme:i.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?_.win32:_.posix)}async fileURI(m){let v="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const b=m.indexOf("/",2);b===-1?(v=m.substring(2),m="/"):(v=m.substring(2,b),m=m.substring(b)||"/")}return y.URI.from({scheme:i.Schemas.file,authority:v,path:m,query:"",fragment:""})}};T=je([xe(1,D.IRemoteAgentService),xe(2,I.IWorkbenchEnvironmentService),xe(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(ye[71],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(k,y){this.line=k,this.character=y}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,y){return new d(0,0)}with(k){return new d(0,0)}}e.Position=d;class i{constructor(k,y,w,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(k,y),this.end=new d(w,P)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new i(0,0,0,0)}with(k){return new i(0,0,0,0)}}e.Range=i;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([0,1,16,35,26,30,8,4,9,11,71,17]),function(Y,e,d,i,_,A,k,y,w,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const D="\u27EA ",T=" characters skipped \u27EB",C=(D.length+T.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var m;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function g(V){return!!V.preview}e.resultIsMatch=g;function b(V){return!!V.resource}e.isFileMatch=b;function f(V){return!!V.message}e.isProgressMessage=f;var l;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=h;class o{constructor(ne,Q,he){this.ranges=Q;const fe=Array.isArray(Q)?Q:[Q];if(he&&he.matchLines===1&&E(fe)){ne=(0,k.getNLines)(ne,he.matchLines);let G="",X=0,ce=0;const pe=Math.floor(he.charsPerLine/5),Ie=[];for(const Re of fe){const Ce=Math.max(Re.startColumn-pe,0),ke=Re.startColumn+he.charsPerLine;if(Ce>ce+pe+C){const Ae=D+(Ce-ce)+T;G+=Ae+ne.slice(Ce,ke),X+=Ce-(ce+Ae.length)}else G+=ne.slice(ce,ke);Ie.push(new s(0,Re.startColumn-X,Re.endColumn-X)),ce=ke}this.preview={text:G,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const G=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:ne,matches:(0,d.mapArrayOrNot)(Q,X=>new r(X.startLineNumber-G,X.startColumn,X.endLineNumber-G,X.endColumn))}}}}e.TextSearchMatch=o;function E(V){const ne=V[0].startLineNumber;for(const Q of V)if(Q.startLineNumber!==ne||Q.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,Q,he,fe){this.startLineNumber=ne,this.startColumn=Q,this.endLineNumber=he,this.endColumn=fe}}e.SearchRange=r;class s extends r{constructor(ne,Q,he){super(ne,Q,ne,he)}}e.OneLineRange=s;var n;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function t(V,ne=!0){const Q=V&&V.files&&V.files.exclude,he=ne&&V&&V.search&&V.search.exclude;if(!Q&&!he)return;if(!Q||!he)return Q||he;let fe=Object.create(null);return fe=_.mixin(fe,_.deepClone(Q)),fe=_.mixin(fe,_.deepClone(he),!0),fe}e.getExcludes=t;function a(V,ne){return V.excludePattern&&i.match(V.excludePattern,ne)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&i.match(V.includePattern,ne)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(Q=>{const he=Q.folder.fsPath;if(A.isEqualOrParent(ne,he)){const fe=w.relative(he,ne);return!Q.includePattern||!!i.match(Q.includePattern,fe)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var c;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(c=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(ne,Q){super(ne);this.code=Q}}e.SearchError=u;function S(V){const ne=V.message;if((0,P.isCancellationError)(V))return new u(ne,c.canceled);try{const Q=JSON.parse(ne);return new u(Q.message,Q.code)}catch{return new u(ne,c.other)}}e.deserializeSearchError=S;function R(V){const ne={message:V.message,code:V.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=R;function O(V){return V.type==="error"?!0:V.type==="success"}e.isSerializedSearchComplete=O;function N(V){return V.type==="success"}e.isSerializedSearchSuccess=N;function p(V){return!!V.path}e.isSerializedFileMatch=p;function M(V,ne){const Q=V.searchPath?V.searchPath:V.relativePath;return(0,k.fuzzyContains)(Q,ne)}e.isFilePatternMatch=M;class U{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function z(V,ne){const Q={...V||{},...ne||{}};return Object.keys(Q).filter(he=>{const fe=Q[he];return typeof fe=="boolean"&&fe})}e.resolvePatternsForProvider=z;class re{constructor(ne,Q){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let he=ne.includePattern;Q.includePattern&&(he?he={...he,...Q.includePattern}:he=Q.includePattern),he&&(this._parsedIncludeExpression=i.parse(he))}matchesExcludesSync(ne,Q,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,Q,he))}includedInQuerySync(ne,Q,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,Q,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,Q,he))}includedInQuery(ne,Q,he){const fe=this._parsedExcludeExpression(ne,Q,he),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,Q,he):!0;return(0,I.isThenable)(fe)?fe.then(X=>X?!1:G()):G()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=re;function H(V){for(const ne in V)if(typeof V[ne]!="boolean")return!0;return!1}function F(V){if(!V)return;let ne;return Q=>(ne||(ne=(V()||Promise.resolve([])).then(he=>he?x(he):{})),ne.then(he=>!!he[Q]))}e.hasSiblingPromiseFn=F;function j(V){if(!V)return;let ne;return Q=>{if(!ne){const he=V();ne=he?x(he):{}}return!!ne[Q]}}e.hasSiblingFn=j;function x(V){const ne={};for(const Q of V)ne[Q]=!0;return ne}}),define(ye[32],De([0,1,16,17,21,3,24,10,93,22,8,14,2,177,4,13,196,45,46,27,18,15,7,31,5]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l,h,o,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(O,N,p){return new P.ExtUri(M=>c(M,p)).isEqual(O,N)}function n(O,N,p){return s(O.uri,N.uri,p)?0:(0,L.compare)(O.uri.toString(),N.uri.toString())}function t(O,N,p){return O.index!==N.index?O.index<N.index?-1:1:s(O.uri,N.uri,p)?(0,L.compare)(O.name,N.name):(0,L.compare)(O.uri.toString(),N.uri.toString())}function a(O,N,p,M){const U=O.slice(0).sort((re,H)=>p(re,H,M)),z=N.slice(0).sort((re,H)=>p(re,H,M));return(0,d.delta)(U,z,(re,H)=>p(re,H,M))}function c(O,N){const p=N.getCapabilities(O.scheme);return!(p&&p&1024)}class u extends g.Workspace{constructor(N,p,M,U,z,re,H){super(N,M.map(F=>new g.WorkspaceFolder(F)),U,z,H);this._name=p,this._isUntitled=re,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(H),M.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(N,p,M,U){if(!N)return{workspace:null,added:[],removed:[]};const{id:z,name:re,folders:H,configuration:F,transient:j,isUntitled:x}=N,V=[],ne=p;p?H.forEach((G,X)=>{const ce=D.URI.revive(G.uri),pe=u._findFolder(M||p,ce,U);pe?(pe.name=G.name,pe.index=G.index,V.push(pe)):V.push({uri:ce,name:G.name,index:X})}):V.push(...H.map(({uri:G,name:X,index:ce})=>({uri:D.URI.revive(G),name:X,index:ce}))),V.sort((G,X)=>G.index<X.index?-1:1);const Q=new u(z,re,V,!!j,F?D.URI.revive(F):null,!!x,G=>c(G,U)),{added:he,removed:fe}=a(ne?ne.workspaceFolders:[],Q.workspaceFolders,n,U);return{workspace:Q,added:he,removed:fe}}static _findFolder(N,p,M){for(let U=0;U<N.folders.length;U++){const z=N.workspaceFolders[U];if(s(z.uri,p,M))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,p){return p&&this._structure.get(N)&&(N=(0,P.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let S=class{constructor(N,p,M,U){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=M,this._requestIdProvider=new w.Counter,this._barrier=new i.Barrier,this._proxy=N.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(r.MainContext.MainThreadMessageService);const z=p.workspace;this._confirmedWorkspace=z?new u(z.id,z.name,[],!!z.transient,z.configuration?D.URI.revive(z.configuration):null,!!z.isUntitled,re=>c(re,M)):void 0}$initializeWorkspace(N,p){this._trusted=p,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?D.URI.from({scheme:y.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,p,M,...U){const z=[];if(Array.isArray(U)&&U.forEach(x=>{D.URI.isUri(x.uri)&&!z.some(V=>s(V.uri,x.uri,this._extHostFileSystemInfo))&&z.push({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[p,M].some(x=>typeof x!="number"||x<0)||M===0&&z.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(p+M>re.length)return!1;const H=re.slice(0);H.splice(p,M,...z.map(x=>({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<H.length;x++){const V=H[x];if(H.some((ne,Q)=>Q!==x&&s(V.uri,ne.uri,this._extHostFileSystemInfo)))return!1}H.forEach((x,V)=>x.index=V);const{added:F,removed:j}=a(re,H,t,this._extHostFileSystemInfo);if(F.length===0&&j.length===0)return!1;if(this._proxy){const x=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(x,p,M,z).then(void 0,V=>{this._unconfirmedWorkspace=void 0;const ne={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(v.Severity.Error,(0,T.localize)(0,null,x,V.toString()),ne,[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(N,p){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,p)}async getWorkspaceFolder2(N,p){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,p)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,p){let M,U="";if(typeof N=="string"?(M=D.URI.file(N),U=N):typeof N!="undefined"&&(M=N,U=N.fsPath),!M)return U;const z=this.getWorkspaceFolder(M,!0);if(!z)return U;typeof p=="undefined"&&this._actualWorkspace&&(p=this._actualWorkspace.folders.length>1);let re=(0,P.relativePath)(z.uri,M);return p&&z.name&&(re=`${z.name}/${re}`),re}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=u.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:p,added:M,removed:U}=u.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=p||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:U}))}findFiles(N,p,M,U,z=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let re;if(p===null?re=!1:p&&(typeof p=="string"?re=p:re=p.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:F}=R(h.GlobPattern.from(N));return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(H),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(re),(0,I.withUndefinedAsNull)(M),z).then(j=>Array.isArray(j)?j.map(x=>D.URI.revive(x)):[])}async findTextInFiles(N,p,M,U,z=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),H=typeof p.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:p.previewOptions,{includePattern:F,folder:j}=R(h.GlobPattern.from(p.include)),x=typeof p.exclude=="string"?p.exclude:p.exclude?p.exclude.pattern:void 0,V={ignoreSymlinks:typeof p.followSymlinks=="boolean"?!p.followSymlinks:void 0,disregardIgnoreFiles:typeof p.useIgnoreFiles=="boolean"?!p.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof p.useGlobalIgnoreFiles=="boolean"?!p.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof p.useParentIgnoreFiles=="boolean"?!p.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof p.useDefaultExcludes=="boolean"?!p.useDefaultExcludes:!0,fileEncoding:p.encoding,maxResults:p.maxResults,previewOptions:H,afterContext:p.afterContext,beforeContext:p.beforeContext,includePattern:F,excludePattern:x},ne=!1;if(this._activeSearchCallbacks[re]=Q=>{if(ne)return;const he=D.URI.revive(Q.resource);Q.results.forEach(fe=>{(0,E.resultIsMatch)(fe)?M({uri:he,preview:{text:fe.preview.text,matches:(0,d.mapArrayOrNot)(fe.preview.matches,G=>new o.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,d.mapArrayOrNot)(fe.ranges,G=>new o.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):M({uri:he,text:fe.text,lineNumber:fe.lineNumber})})},z.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(N,(0,I.withUndefinedAsNull)(j),V,re,z);return delete this._activeSearchCallbacks[re],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[re],Q}}$handleTextSearchResult(N,p){this._activeSearchCallbacks[p]&&this._activeSearchCallbacks[p](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=je([xe(0,l.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,b.IExtHostFileSystemInfo),xe(3,m.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,C.createDecorator)("IExtHostWorkspace");function R(O){let N,p;return O&&(typeof O=="string"?N=O:(N=O.pattern,p=D.URI.revive(O.baseUri))),{includePattern:N,folder:p}}}),define(ye[33],De([0,1,26,3,32,5,7,199,119,14,17,4,18,13,2]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(E,r){if(r){const s=r.split(".");let n=E;for(let t=0;n&&t<s.length;t++)n=n[s[t]];return n}}function v(E){return E instanceof C.URI}function g(E){return E&&E.uri instanceof C.URI&&E.languageId&&typeof E.languageId=="string"}function b(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function f(E){return E&&E.uri instanceof C.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function l(E){if(v(E))return{resource:E};if(g(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(b(E))return{overrideIdentifier:E.languageId};if(f(E))return{resource:E.uri};if(E===null)return{resource:null}}let h=class{constructor(r,s,n){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=n,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,s))}};h=je([xe(0,D.IExtHostRpcService),xe(1,_.IExtHostWorkspace),xe(2,T.ILogService)],h),e.ExtHostConfiguration=h;class o{constructor(r,s,n,t){this._onDidChangeConfiguration=new i.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=s,this._configuration=y.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,n))}getConfiguration(r,s,n){const t=l(s)||{},a=this._toReadonlyValue(r?m(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,n?.identifier);function c(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(S){return typeof m(a,S)!="undefined"},get:(S,R)=>{this._validateConfigurationAccess(r?`${r}.${S}`:S,t,n?.identifier);let O=m(a,S);if(typeof O=="undefined")O=R;else{let N;const p=(M,U)=>{let z;const re=()=>{N=N||(0,d.deepClone)(a),z=z||m(N,U)};return(0,P.isObject)(M)?new Proxy(M,{get:(H,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return re(),()=>z;if(N)return z=z||m(N,U),z[F];const j=H[F];return typeof F=="string"?p(j,`${U}.${F}`):j},set:(H,F,j)=>(re(),z&&(z[F]=j),!0),deleteProperty:(H,F)=>(re(),z&&delete z[F],!0),defineProperty:(H,F,j)=>(re(),z&&Object.defineProperty(z,F,j),!0)}):M};O=p(O,S)}return O},update:(S,R,O,N)=>{S=r?`${r}.${S}`:S;const p=c(O);return R!==void 0?this._proxy.$updateConfigurationOption(p,S,R,t,N):this._proxy.$removeConfigurationOption(p,S,t,N)},inspect:S=>{S=r?`${r}.${S}`:S;const R=(0,d.deepClone)(this._configuration.inspect(S,t,this._extHostWorkspace.workspace));if(R)return{key:S,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof a=="object"&&(0,d.mixin)(u,a,!1),Object.freeze(u)}_toReadonlyValue(r){const s=n=>(0,P.isObject)(n)?new Proxy(n,{get:(t,a)=>s(t[a]),set:(t,a,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(t,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(t,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return s(r)}_validateConfigurationAccess(r,s,n){const t=w.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),a=n?`[${n.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const n=new y.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,a)=>n.affectsConfiguration(t,l(a))})}_toMap(r){return r.reduce((s,n)=>(s.set(n[0],n[1]),s),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[72],De([0,1,2,17,3,5,7,32,54,33,21,39,18,27,4,10,12,13,67,218,11]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(U){function z(H){if(H!=null)return H}U.from=z;function re(H){if(H!=null)return H}U.to=re})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(U){function z(H){if(H!=null)return H}U.from=z;function re(H){if(H!=null)return H}U.to=re})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(U){function z(H){if(H!=null)return H}U.from=z;function re(H){if(H!=null)return H}U.to=re})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(U){function z(F){if(F){const j=F;return j&&!!j.process}else return!1}U.is=z;function re(F){if(F==null)return;const j={process:F.process,args:F.args};return F.options&&(j.options=r.from(F.options)),j}U.from=re;function H(F){if(F!=null)return new k.ProcessExecution(F.process,F.args,F.options)}U.to=H})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(U){function z(H){if(H!=null)return H}U.from=z;function re(H){if(H!=null)return H}U.to=re})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(U){function z(F){if(F){const j=F;return j&&(!!j.commandLine||!!j.command)}else return!1}U.is=z;function re(F){if(F==null)return;const j={};return F.commandLine!==void 0?j.commandLine=F.commandLine:(j.command=F.command,j.args=F.args),F.options&&(j.options=n.from(F.options)),j}U.from=re;function H(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new k.ShellExecution(F.commandLine,F.options):new k.ShellExecution(F.command,F.args?F.args:[],F.options)}U.to=H})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(U){function z(F){if(F){let j=F;return j&&j.customExecution==="customExecution"}else return!1}U.is=z;function re(F){return{customExecution:"customExecution"}}U.from=re;function H(F,j){return j.get(F)}U.to=H})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(U){function z(re,H){let F;return re.scope!==void 0&&typeof re.scope!="number"?F=re.scope.uri:re.scope!==void 0&&typeof re.scope=="number"&&(re.scope===k.TaskScope.Workspace&&H&&H.workspaceFile?F=H.workspaceFile:F=f.USER_TASKS_GROUP_KEY),{id:re._id,workspaceFolder:F}}U.from=z})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(U){function z(re){if(re!=null)return{_id:re.id,isDefault:re.isDefault}}U.from=z})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function(U){function z(F,j){if(F==null)return[];const x=[];for(let V of F){const ne=re(V,j);ne&&x.push(ne)}return x}U.fromMany=z;function re(F,j){if(F==null)return;let x;F.execution instanceof k.ProcessExecution?x=s.from(F.execution):F.execution instanceof k.ShellExecution?x=t.from(F.execution):F.execution&&F.execution instanceof k.CustomExecution&&(x=a.from(F.execution));const V=o.from(F.definition);let ne;return F.scope?typeof F.scope=="number"?ne=F.scope:ne=F.scope.uri:ne=k.TaskScope.Workspace,!V||!ne?void 0:{_id:F._id,definition:V,name:F.name,source:{extensionId:j.identifier.value,label:F.source,scope:ne},execution:x,isBackground:F.isBackground,group:u.from(F.group),presentationOptions:E.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}U.from=re;async function H(F,j,x){if(F==null)return;let V;s.is(F.execution)?V=s.to(F.execution):t.is(F.execution)?V=t.to(F.execution):a.is(F.execution)&&(V=a.to(F._id,x));const ne=o.to(F.definition);let Q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Q=F.source.scope:Q=await j.resolveWorkspaceFolder(d.URI.revive(F.source.scope)):Q=k.TaskScope.Workspace),!ne||!Q)return;const he=new k.Task(ne,Q,F.name,F.source.label,V,F.problemMatchers);return F.isBackground!==void 0&&(he.isBackground=F.isBackground),F.group!==void 0&&(he.group=k.TaskGroup.from(F.group._id),he.group&&F.group.isDefault&&(he.group=new k.TaskGroup(he.group.id,he.group.label),F.group.isDefault&&(he.group.isDefault=F.group.isDefault))),F.presentationOptions&&(he.presentationOptions=E.to(F.presentationOptions)),F._id&&(he._id=F._id),F.detail&&(he.detail=F.detail),he}U.to=H})(S=e.TaskDTO||(e.TaskDTO={}));var R;(function(U){function z(H){return H}U.from=z;function re(H){if(!!H)return Object.assign(Object.create(null),H)}U.to=re})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(z,re,H){this._id=re,this._task=H,h.set(this,void 0),et(this,h,z,"f")}get task(){return this._task}terminate(){Ue(this,h,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}h=new WeakMap;var N;(function(U){function z(re){return{id:re._id,task:void 0}}U.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let p=class{constructor(z,re,H,F,j,x,V,ne){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=z.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=F,this._configurationService=j,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,re,H){if(!H)return new k.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:re,provider:H,extension:z}),this._proxy.$registerTaskProvider(F,re),new k.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(z,re){this._proxy.$registerTaskSystem(z,re)}fetchTasks(z){return this._proxy.$fetchTasks(R.from(z)).then(async re=>{const H=[];for(let F of re){const j=await S.to(F,this._workspaceProvider,this._providedCustomExecutions2);j&&H.push(j)}return H})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(re=>z.push(re)),z}terminateTask(z){if(!(z instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,re,H){const F=this._providedCustomExecutions2.get(z.id);F&&(this._activeCustomExecutions2.set(z.id,F),this._terminalService.attachPtyToTerminal(re,await F.callback(H))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const re=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:re})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const re=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:re,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const re=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:re,exitCode:z.exitCode})}$provideTasks(z,re){const H=this._handlers.get(z);if(!H)return Promise.reject(new Error("no handler found"));const F=[],j=(0,i.asPromise)(()=>H.provider.provideTasks(L.CancellationToken.None)).then(x=>this.provideTasksInternal(re,F,H,x));return new Promise(x=>{j.then(V=>{Promise.all(F).then(()=>{x(V)})})})}async $resolveTask(z,re){const H=this._handlers.get(z);if(!H)return Promise.reject(new Error("no handler found"));if(re.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${re.definition.type}] cannot be resolved by provider of type [${H.type}].`);const F=await S.to(re,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const j=await H.provider.resolveTask(F,L.CancellationToken.None);if(!j)return;this.checkDeprecation(j,H);const x=S.from(j,H.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(x.execution)&&await this.addCustomExecution(x,j,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,re,H){const F=await this._proxy.$createTaskId(z);!H&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,re.execution)),this._providedCustomExecutions2.set(F,re.execution)}async getTaskExecution(z,re){if(typeof z=="string"){const j=this._taskExecutionPromises.get(z);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let H=this._taskExecutionPromises.get(z.id);if(H)return H;const F=new Promise((j,x)=>{function V(ne,Q,he){he?j(new O(ne,Q.id,he)):x("Unexpected: Task does not exist.")}re?V(this,z,re):S.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(ne=>V(this,z,ne))});return this._taskExecutionPromises.set(z.id,F),F.then(j=>(this._taskExecutions.set(z.id,j),j),j=>Promise.reject(j))}checkDeprecation(z,re){z._deprecated&&this._deprecationService.report("Task.constructor",re.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let H=this._notProvidedCustomExecutions.values(),F=H.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=H.next()}};p=je([xe(0,D.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,y.IExtHostWorkspace),xe(3,w.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,g.ILogService),xe(7,b.IExtHostApiDeprecationService)],p),e.ExtHostTaskBase=p;let M=class extends p{constructor(z,re,H,F,j,x,V,ne){super(z,re,H,F,j,x,V,ne);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(z,re){if(!re.execution)throw new Error("Tasks to execute must include an execution");const H=S.from(re,z);if(H===void 0)throw new Error("Task is not valid");if(a.is(H.execution))await this.addCustomExecution(H,re,!1);else throw new l.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),re);return this._proxy.$executeTask(H).catch(j=>{throw new Error(j)}),F}provideTasksInternal(z,re,H,F){const j=[];if(F)for(let x of F){this.checkDeprecation(x,H),(!x.definition||!z[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const V=S.from(x,H.extension);V&&a.is(V.execution)?(j.push(V),re.push(this.addCustomExecution(V,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:H.extension}}async resolveTaskInternal(z){if(a.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,re){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,re,H){}};M=je([xe(0,D.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,y.IExtHostWorkspace),xe(3,w.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,g.ILogService),xe(7,b.IExtHostApiDeprecationService)],M),e.WorkerExtHostTask=M,e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(ye[270],De([0,1,9,21,51,35,22,48,31]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(D,T,C){this.config=D,this.provider=T,this.sessionToken=C,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=D.filePattern,this.includePattern=D.includePattern&&A.parse(D.includePattern),this.maxResults=D.maxResults||void 0,this.exists=D.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=D.excludePattern&&A.parse(D.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(D=>D.cancel()),this.activeCancellationTokens=new Set}search(D){const T=this.config.folderQueries||[];return new Promise((C,m)=>{const v=g=>{this.resultCount++,D(g)};if(this.isCanceled)return C({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(g=>{const b=g.toString(),f=d.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,f)||this.matchFile(v,{base:g,basename:f})}),Promise.all(T.map(g=>this.searchInFolder(g,v))).then(g=>{C({limitHit:this.isLimitHit,stats:g[0]||void 0})},g=>{m(new Error((0,_.toErrorMessage)(g)))})})}async searchInFolder(D,T){const C=new i.CancellationTokenSource,m=this.getSearchOptionsForFolder(D),v=this.initDirectoryTree(),g=new w.QueryGlobTester(this.config,D),b=!g.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(C),f=y.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,C.token),h=f.elapsed(),o=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(E=>{const r=d.posix.relative(D.folder.path,E.path);if(b){const s=d.basename(E.path);this.matchFile(T,{base:D.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(v,D.folder,r,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,g,T),{providerTime:h,postProcessTime:o.elapsed()})}finally{C.dispose(),this.activeCancellationTokens.delete(C)}}getSearchOptionsForFolder(D){const T=(0,w.resolvePatternsForProvider)(this.config.includePattern,D.includePattern),C=(0,w.resolvePatternsForProvider)(this.config.excludePattern,D.excludePattern);return{folder:D.folder,excludes:C,includes:T,useIgnoreFiles:!D.disregardIgnoreFiles,useGlobalIgnoreFiles:!D.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!D.disregardParentIgnoreFiles,followSymlinks:!D.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const D={rootEntries:[],pathToEntries:Object.create(null)};return D.pathToEntries["."]=D.rootEntries,D}addDirectoryEntries({pathToEntries:D},T,C,m){if(C===this.filePattern){const g=d.basename(this.filePattern);this.matchFile(m,{base:T,relativePath:this.filePattern,basename:g})}function v(g){const b=d.basename(g),f=d.dirname(g);let l=D[f];l||(l=D[f]=[],v(f)),l.push({base:T,relativePath:g,basename:b})}v(C)}matchDirectoryTree({rootEntries:D,pathToEntries:T},C,m){const v=this,g=this.filePattern;function b(f){const l=(0,w.hasSiblingFn)(()=>f.map(h=>h.basename));for(let h=0,o=f.length;h<o;h++){const E=f[h],{relativePath:r,basename:s}=E;if(C.matchesExcludesSync(r,s,g!==s?l:void 0))continue;const n=T[r];if(n)b(n);else{if(r===g)continue;v.matchFile(m,E)}if(v.isLimitHit)break}}b(D)}matchFile(D,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||D(T))}}class L{constructor(){this.sessions=new Map}fileSearch(D,T,C,m){const v=this.getSessionTokenSource(D.cacheKey),g=new P(D,T,v&&v.token);let b=0;const f=l=>{b+=l.length,C(l.map(h=>this.rawMatchToSearchItem(h)))};return this.doSearch(g,L.BATCH_SIZE,f,m).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:l.stats}}))}clearCache(D){const T=this.getSessionTokenSource(D);T&&T.cancel()}getSessionTokenSource(D){if(!!D)return this.sessions.has(D)||this.sessions.set(D,new i.CancellationTokenSource),this.sessions.get(D)}rawMatchToSearchItem(D){return D.relativePath?{resource:k.joinPath(D.base,D.relativePath)}:{resource:D.base}}doSearch(D,T,C,m){m.onCancellationRequested(()=>{D.cancel()});const v=b=>{b&&(g.push(b),T>0&&g.length>=T&&(C(g),g=[]))};let g=[];return D.search(v).then(b=>(g.length&&C(g),b),b=>(g.length&&C(g),Promise.reject(b)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(ye[271],De([0,1,16,57,35,102,24,10,9,22,8,14,2,157,186,83,13,45,130,269,31]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(u,S,R,O,N){this.configurationService=u,this.workspaceContextService=S,this.editorGroupsService=R,this.logService=O,this.pathService=N}text(u,S,R={}){u=this.getContentPattern(u,R);const O=this.configurationService.getValue(),N=S&&S.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(S?.map(g.toWorkspaceFolder),R),type:2,contentPattern:u,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(u,S){const R=this.configurationService.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const O={...u,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(u,S)&&(O.isCaseSensitive=!0),this.isMultiline(u)&&(O.isMultiline=!0),O}file(u,S={}){return{...this.commonQuery(u,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(u,S){return u?(u=Array.isArray(u)?u.map(n):n(u),S?this.parseSearchPaths(u):{pattern:E(...Array.isArray(u)?u:[u])}):{}}commonQuery(u=[],S={}){const R=this.handleIncludeExclude(S.includePattern,S.expandPatterns),O=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),N=u.length>1,p=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,S,O)):u.map(z=>this.getFolderQueryForRoot(z,S,O,N))).filter(z=>!!z),M={_reason:S._reason,folderQueries:p,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:O.pattern,includePattern:R.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const z=d.coalesce(d.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(j=>j.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const re=z.filter(F=>(0,l.pathIncludedInQuery)(M,F.fsPath)),H=this.commonQueryFromFileList(re);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...M,...H}}const U=S.extraFileResources&&S.extraFileResources.filter(z=>(0,l.pathIncludedInQuery)(M,z.fsPath));return M.extraFileResources=U&&U.length?U:void 0,M}commonQueryFromFileList(u){const S=[],R=new k.ResourceMap,O={};let N=!1;return u.forEach(p=>{if(p.scheme===y.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(p)){const U=this.workspaceContextService.getWorkspaceFolder(p)?.uri??p.with({path:w.dirname(p.fsPath)});let z=R.get(U);z||(N=!0,z={folder:U,includePattern:{}},S.push(z),R.set(U,z));const re=w.relative(U.fsPath,p.fsPath);(0,I.assertIsDefined)(z.includePattern)[re.replace(/\\/g,"/")]=!0}else p.fsPath&&(N=!0,O[p.fsPath]=!0)}),{folderQueries:S,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(u,S){if(S.isSmartCase){if(u.isRegExp){if(L.containsUppercaseCharacter(u.pattern,!0))return!0}else if(L.containsUppercaseCharacter(u.pattern))return!0}return!!u.isCaseSensitive}isMultiline(u){return u.isMultiline||u.isRegExp&&(0,T.isMultilineRegexSource)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const S=H=>w.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),O=(Array.isArray(u)?u:r(u)).map(H=>{const F=this.pathService.resolvedUserHome;return F?(0,A.untildify)(H,F.scheme===y.Schemas.file?F.fsPath:F.path):H}),N=i.groupBy(O,H=>S(H)?"searchPaths":"exprSegments"),p=(N.exprSegments||[]).map(H=>L.rtrim(H,"/")).map(H=>L.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),M={},U=this.expandSearchPathPatterns(N.searchPaths||[]);U&&U.length&&(M.searchPaths=U);const z=d.flatten(p),re=E(...z);return re&&(M.pattern=re),M}getExcludesForFolder(u,S){return S.disregardExcludeSettings?void 0:(0,l.getExcludes)(u,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(u){if(!u||!u.length)return[];const S=d.flatten(u.map(O=>{let{pathPortion:N,globPortion:p}=o(O);p&&(p=t(p));const M=this.expandOneSearchPath(N);return d.flatten(M.map(U=>this.resolveOneSearchPathPattern(U,p)))})),R=new Map;return S.forEach(O=>{const N=O.searchPath.toString(),p=R.get(N);p?O.pattern&&(p.pattern=p.pattern||{},p.pattern[O.pattern]=!0):R.set(N,{searchPath:O.searchPath,pattern:O.pattern?E(O.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(u){if(w.isAbsolute(u)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==y.Schemas.file?[{searchPath:S[0].uri.with({path:u})}]:[{searchPath:D.URI.file(w.normalize(u))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(u=n(u),u.startsWith("../")||u===".."){const O=w.posix.resolve(S.path,u);return[{searchPath:S.with({path:O})}]}const R=t(u);return[{searchPath:S,pattern:R}]}else{if(u==="./"||u===".\\")return[];{const S=u.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(N=>{const p=S.match(new RegExp(`^${L.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return p?{match:p,folder:N}:null}).filter(I.isDefined);if(O.length)return O.map(N=>{const p=N.match[1];return{searchPath:N.folder.uri,pattern:p&&t(p)}});{const N=u.match(/\.[\/\\](.+)[\/\\]?/),p=N?N[1]:u,M=C.localize(0,null,p);throw new Error(M)}}}}resolveOneSearchPathPattern(u,S){const R=u.pattern&&S?`${u.pattern}/${S}`:u.pattern||S,O=[{searchPath:u.searchPath,pattern:R}];return R&&!R.endsWith("**")&&O.push({searchPath:u.searchPath,pattern:R+"/**"}),O}getFolderQueryForSearchPath(u,S,R){const O=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(u.searchPath),S,R,!1);return O?{...O,includePattern:u.pattern}:null}getFolderQueryForRoot(u,S,R,O){let N;const p=D.URI.isUri(u)?u:u.uri;if(R.searchPaths){const H=R.searchPaths.filter(F=>(0,P.isEqual)(F.searchPath,p))[0];if(H&&!H.pattern)return null;H&&(N=H.pattern)}const M=this.configurationService.getValue({resource:p}),z={...this.getExcludesForFolder(M,S)||{},...N||{}},re=D.URI.isUri(u)?(0,P.basename)(u):u.name;return{folder:p,folderName:O?re:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!M.search.followSymlinks}}};h=je([xe(0,m.IConfigurationService),xe(1,g.IWorkspaceContextService),xe(2,b.IEditorGroupsService),xe(3,v.ILogService),xe(4,f.IPathService)],h),e.QueryBuilder=h;function o(c){const u=c.match(/[\*\{\}\(\)\[\]\?]/);if(u){const S=u.index,R=c.substr(0,S).match(/[/|\\][^/\\]*$/);if(R){let O=c.substr(0,R.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:c.substr((R.index||0)+1)}}}return{pathPortion:c}}function E(...c){return c.length?c.reduce((u,S)=>(u[S]=!0,u),Object.create(null)):void 0}function r(c){return _.splitGlobAware(c,",").map(u=>u.trim()).filter(u=>!!u.length)}function s(c){return[`**/${c}/**`,`**/${c}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function t(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(c,u){c=d.distinct(c,O=>O.toString());const S=[],R=u.getWorkspace();return c&&c.forEach(O=>{let N;if(u.getWorkbenchState()===2)N=(0,P.relativePath)(R.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const p=u.getWorkspaceFolder(O);if(p){const M=p.name;if(R.folders.filter(z=>z.name===M).length===1){const z=(0,P.relativePath)(p.uri,O);z===""?N=`./${p.name}`:N=`./${p.name}/${z}`}else N=O.fsPath}}N&&S.push(N)}),S}e.resolveResourcesForSearchIncludes=a}),define(ye[272],De([0,1,22,2,21,11,4,271,31,45]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function I(m,v){const g=v.activationEvents;if(!g)return Promise.resolve(void 0);const b=[],f=[];for(const s of g)if(/^workspaceContains:/.test(s)){const n=s.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||m.forceUsingSearch?f.push(n):b.push(n)}if(b.length===0&&f.length===0)return Promise.resolve(void 0);let l;const h=new Promise((s,n)=>{l=s}),o=s=>l({activationEvent:s}),E=Promise.all(b.map(s=>D(m,s,o))).then(()=>{}),r=T(m,v.identifier,f,o);return Promise.all([E,r]).then(()=>{l(void 0)}),h}e.checkActivateWorkspaceContainsExtension=I;async function D(m,v,g){for(const b of m.folders)if(await m.exists(d.joinPath(i.URI.revive(b),v))){g(`workspaceContains:${v}`);return}}async function T(m,v,g,b){if(g.length===0)return Promise.resolve(void 0);const f=new _.CancellationTokenSource,l=m.checkExists(m.folders,g,f.token),h=setTimeout(async()=>{f.cancel(),m.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},L);let o=!1;try{o=await l}catch(E){A.isCancellationError(E)||A.onUnexpectedError(E)}f.dispose(),clearTimeout(h),o&&b(`workspaceContains:${g.join(",")}`)}function C(m,v,g,b){const f=m.get(k.IInstantiationService),l=m.get(w.ISearchService),o=f.createInstance(y.QueryBuilder).file(v.map(E=>(0,P.toWorkspaceFolder)(i.URI.revive(E))),{_reason:"checkExists",includePattern:g,exists:!0});return l.fileSearch(o,b).then(E=>!!E.limitHit,E=>A.isCancellationError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=C});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,_){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?_.call(Y,d):_?_.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(ye[40],De([0,1,172,9,73,22,17,6,24,2,13,5,33,227,90,32,25,226,11,28,23,205,7,120,4,27,69,18,84,52,39,3,272,89,207,10]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l,h,o,E,r,s,n,t,a,c,u,S,R,O,N,p){"use strict";var M,U,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let re=class ki extends y.Disposable{constructor(Q,he,fe,G,X,ce,pe,Ie,Re,Ce){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=fe,this._initData=pe,this._extHostWorkspace=G,this._extHostConfiguration=X,this._logService=ce,this._extHostTunnelService=Re,this._extHostTerminalService=Ce,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._globalRegistry=new g.ExtensionDescriptionRegistry(this._initData.allExtensions);const ke=(0,v.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new g.ExtensionDescriptionRegistry(j(this._globalRegistry,ke)),this._storage=new C.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=Q.createChild(new a.ServiceCollection([C.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));let Ae=[],ue=[];this._initData.remote.isRemote&&(Ae=this._initData.allExtensions.filter(ie=>!ie.main&&!ie.browser).map(ie=>ie.identifier),ue=this._initData.allExtensions.filter(ie=>!ke.has(f.ExtensionIdentifier.toKey(ie.identifier.value))).filter(ie=>(ie.main||ie.browser)&&ie.api==="none").map(ie=>ie.identifier));const ve=(0,v.extensionIdentifiersArrayToSet)(ue);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,Ae,ue,{onExtensionActivationError:(ie,oe,we)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ie,b.transformErrorForSerialization(oe),we)},actualActivateExtension:async(ie,oe)=>{if(ve.has(f.ExtensionIdentifier.toKey(ie)))return await this._mainThreadExtensionsProxy.$activateExtension(ie,oe),new T.HostExtension;const we=this._myRegistry.getExtensionDescription(ie);return this._activateExtension(we,oe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){b.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this._deactivate(X))}catch{}await Promise.all(Q)}terminate(Q,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),b.setUnexpectedErrorHandler(G=>{this._logService.error(G)}),this._extHostContext.dispose();const fe=this._deactivateAll();Promise.race([(0,k.timeout)(5e3),fe]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const he=await this._mainThreadExtensionsProxy.$getExtension(Q);return he&&{...he,identifier:new f.ExtensionIdentifier(he.identifier.value),extensionLocation:P.URI.revive(he.extensionLocation)}}_activateByEvent(Q,he){return this._activator.activateByEvent(Q,he)}_activateById(Q,he){return this._activator.activateById(Q,he)}activateByIdWithErrors(Q,he){return this._activateById(Q,he).then(()=>{const fe=this._activator.getActivatedExtension(Q);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==p.Schemas.file)return Q;const he=await this._hostUtils.realpath(Q.fsPath);return P.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new V(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const he=w.TernarySearchTree.forUris(fe=>A.extUriBiasedIgnorePathCase.ignorePathCasing(fe));return await Promise.all(Q.map(async fe=>{if(this._getEntryPoint(fe)){const G=await this._realPathExtensionUri(fe.extensionLocation);he.set(G,fe)}})),he}_deactivate(Q){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return he;const fe=this._activator.getActivatedExtension(Q);if(!fe)return he;try{typeof fe.module.deactivate=="function"&&(he=Promise.resolve(fe.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(G)}try{(0,y.dispose)(fe.subscriptions)}catch(G){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(G)}return he}async _activateExtension(Q,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,he).then(fe=>{const G=fe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,he),this._logExtensionActivationTimes(Q,he,"success",G),fe},fe=>{throw this._logExtensionActivationTimes(Q,he,"failure"),fe})}_logExtensionActivationTimes(Q,he,fe,G){const X=H(Q,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...X,...G||{},outcome:fe})}_doActivateExtension(Q,he){const fe=H(Q,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",fe);const G=this._getEntryPoint(Q);if(!G)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${Q.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const X=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(Q.identifier,(0,A.joinPath)(Q.extensionLocation,G),X),this._loadExtensionContext(Q)]).then(ce=>(_.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),ki._callActivate(this._logService,Q.identifier,ce[0],ce[1],X))).then(ce=>(_.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),ce))}_loadExtensionContext(Q){const he=new h.ExtensionGlobalMemento(Q,this._storage),fe=new h.ExtensionMemento(Q.identifier.value,!1,this._storage),G=new N.ExtensionSecrets(Q,this._secretState),X=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,ce=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([he.whenReady,fe.whenReady,this._storagePath.whenReady]).then(()=>{const pe=this;let Ie,Re;const Ce=(0,v.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:fe,secrets:G,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(ke){return i.join(Q.extensionLocation.fsPath,ke)},get storagePath(){return pe._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return pe._storagePath.globalValue(Q).fsPath},get logPath(){return i.join(pe._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return P.URI.joinPath(pe._initData.logsLocation,Q.identifier.value)},get storageUri(){return pe._storagePath.workspaceValue(Q)},get globalStorageUri(){return pe._storagePath.globalValue(Q)},get extensionMode(){return X},get extension(){return Ie===void 0&&(Ie=new F(pe,Q.identifier,Q,ce,!1)),Ie},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(Q,"extensionRuntime"),pe.extensionRuntime},get environmentVariableCollection(){return pe._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!Re){if(!Ce)return;const ke=S.Event.buffer(S.Event.fromDOMEventEmitter(Ce,"message",Ae=>Ae.data));Ce.start(),Re={onDidReceiveMessage:ke,postMessage:Ce.postMessage.bind(Ce)}}return Re}})})}static _callActivate(Q,he,fe,G,X){return fe=fe||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,he,fe,G,X).then(ce=>new T.ActivatedExtension(!1,null,X.build(),fe,ce,G.subscriptions))}static _callActivateOptional(Q,he,fe,G,X){if(typeof fe.activate=="function")try{X.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ce=typeof global=="object"?global:self,pe=fe.activate.apply(ce,[G]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(pe).then(Ie=>(X.activateResolveStop(),Ie))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(fe)}_activateOneStartupFinished(Q,he){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:he}).then(void 0,fe=>{this._logService.error(fe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const he of Q.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(Q,he)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,X=>{this._logService.error(X)});this._register(this._extHostWorkspace.onDidChangeWorkspace(X=>this._handleWorkspaceContainsEagerExtensions(X.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],fe=this._handleWorkspaceContainsEagerExtensions(he),G=Promise.all([Q,fe]).then(()=>{});return Promise.race([G,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(Q,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,he){if(this.isActivated(he.identifier))return;const fe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={logService:this._logService,folders:Q.map(ce=>ce.uri),forceUsingSearch:fe,exists:ce=>this._hostUtils.exists(ce.fsPath),checkExists:(ce,pe,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(ce,pe,Ie)},X=await(0,R.checkActivateWorkspaceContainsExtension)(G,he);if(!!X)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:X.activationEvent}).then(void 0,ce=>this._logService.error(ce))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:he}=this._initData.environment;if(!Q||!he)throw new Error(d.localize(0,null));const fe=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(d.localize(1,null,he.toString()));return new Promise((G,X)=>{const ce=(Re,Ce)=>{Re?X(Re):G(typeof Ce=="number"&&Ce>0?1:0)},pe=(0,A.originalFSPath)(he),Ie=fe.run(pe,ce);Ie&&Ie.then&&Ie.then(()=>{G(0)}).catch(Re=>{X(Re instanceof Error&&Re.stack?Re.stack:String(Re))})})}async $extensionTestsExit(Q){this.terminate(`test runner requested exit with code ${Q}`,Q)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,he){return this._resolvers[Q]=he,(0,y.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const he=Q.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const fe=Q.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this._resolvers[fe]}}async $resolveAuthority(Q,he){this._logService.info(`$resolveAuthority invoked for authority (${x(Q)})`);const{authorityPrefix:fe,resolver:G}=await this._activateAndGetResolver(Q);if(!G)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${fe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(G)),_.mark(`code/extHost/willResolveAuthority/${fe}`);const X=await G.resolve(Q,{resolveAttempt:he});_.mark(`code/extHost/didResolveAuthorityOK/${fe}`);const ce={authority:Q,host:X.host,port:X.port,connectionToken:X.connectionToken},pe={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted,authenticationSession:X.authenticationSessionForInitializingExtensions?{id:X.authenticationSessionForInitializingExtensions.id,providerId:X.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ce,options:pe,tunnelInformation:{environmentTunnels:X.environmentTunnels,features:X.tunnelFeatures}}}}catch(X){if(_.mark(`code/extHost/didResolveAuthorityError/${fe}`),X instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X}}async $getCanonicalURI(Q,he){this._logService.info(`$getCanonicalURI invoked for authority (${x(Q)})`);const{resolver:fe}=await this._activateAndGetResolver(Q);if(!fe)return null;const G=P.URI.revive(he);if(typeof fe.getCanonicalURI=="undefined")return G;const X=await(0,k.asPromise)(()=>fe.getCanonicalURI(G));return X||G}static _applyExtensionsDelta(Q,he,fe){const G=new g.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());G.deltaExtensions(fe.toAdd,fe.toRemove);const X=(0,v.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(pe=>pe.identifier));for(const pe of fe.myToRemove)X.delete(f.ExtensionIdentifier.toKey(pe));for(const pe of fe.myToAdd)X.add(f.ExtensionIdentifier.toKey(pe));const ce=j(G,X);return{globalRegistry:G,myExtensions:ce}}$startExtensionHost(Q){Q.toAdd.forEach(G=>G.extensionLocation=P.URI.revive(G.extensionLocation));const{globalRegistry:he,myExtensions:fe}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(fe),this._startExtensionHost()}$activateByEvent(Q,he){return he===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(fe=>this._activateByEvent(Q,!1))}async $activate(Q,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,he),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(ce=>ce.extensionLocation=P.URI.revive(ce.extensionLocation));const{globalRegistry:he,myExtensions:fe}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),G=await this._createExtensionPathIndex(fe);return(await this.getExtensionPathIndex()).setSearchTree(G),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(fe),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){let he=l.VSBuffer.alloc(Q),fe=Math.random()%256;for(let G=0;G<Q;G++)he.writeUInt8(fe,G);return he}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};re=je([xe(0,r.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,m.IExtHostWorkspace),xe(4,D.IExtHostConfiguration),xe(5,L.ILogService),xe(6,s.IExtHostInitDataService),xe(7,n.IExtensionStoragePaths),xe(8,c.IExtHostTunnelService),xe(9,u.IExtHostTerminalService)],re),e.AbstractExtHostExtensionService=re;function H(ne,Q){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class F{constructor(Q,he,fe,G,X){M.set(this,void 0),U.set(this,void 0),z.set(this,void 0),et(this,M,Q,"f"),et(this,U,he,"f"),et(this,z,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=i.normalize((0,A.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=G,this.isFromDifferentExtensionHost=X}get isActive(){return Ue(this,M,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,M,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,M,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=F,M=new WeakMap,U=new WeakMap,z=new WeakMap;function j(ne,Q){return ne.getAllExtensionDescriptions().filter(he=>Q.has(f.ExtensionIdentifier.toKey(he.identifier)))}function x(ne){const Q=ne.indexOf("+");return Q===-1?ne:ne.substring(0,Q)}class V{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=V}),define(ye[273],De([0,1,73,2,5,33,25,28,18,27,4,40,34,13,8]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(h,o,E,r,s,n,t){this._apiFactory=h,this._extensionRegistry=o,this._instaService=E,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,o,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(b,o)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,o,this._initData.environment.appUriScheme))}register(h){if("nodeModuleName"in h)if(Array.isArray(h.nodeModuleName))for(let o of h.nodeModuleName)this._factories.set(o,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(o=>h.alternativeModuleName(o))}};m=je([xe(2,L.IInstantiationService),xe(3,A.IExtHostConfiguration),xe(4,I.IExtHostExtensionService),xe(5,P.IExtHostInitDataService),xe(6,T.ILogService)],m),e.RequireInterceptor=m;let v=class Ki{constructor(h){if(h.environment.appRoot&&Ki.aliased.size){const o=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(h.environment.appRoot.fsPath)),E="[a-z0-9_.-]",r=`@${E}+\\/${E}+|${E}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(h){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(h));if(!o)return;const[,E,r,s]=o,n=Ki.aliased.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),E+n+s}forceForwardSlashes(h){return h.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=je([xe(0,P.IExtHostInitDataService)],v);class g{constructor(h,o,E,r,s){this._apiFactory=h,this._extensionPaths=o,this._extensionRegistry=E,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,o){const E=this._extensionPaths.findSubstr(o);if(E){let r=this._extApiImpl.get(y.ExtensionIdentifier.toKey(E.identifier));return r||(r=this._apiFactory(E,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(E.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,n)=>r+=`	${n} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(h,o,E){this._extensionPaths=h,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(_.MainContext.MainThreadTelemetry);const{environment:r}=E,s=o.getProxy(_.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;D.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>s.$getPassword(n,t),setPassword:(n,t,a)=>s.$setPassword(n,t,a),deletePassword:(n,t)=>s.$deletePassword(n,t),findPassword:n=>s.$findPassword(n),findCredentials(n){return s.$findCredentials(n)}}}load(h,o){const E=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:E?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(h){const o=h.length;if(o<=7||!this.alternativeNames)return;const E=o-7;if((h.charAt(E)==="/"||h.charAt(E)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};b=je([xe(1,w.IExtHostRpcService),xe(2,P.IExtHostInitDataService)],b);let f=class{constructor(h,o,E){this._extensionPaths=h,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=E.getProxy(_.MainContext.MainThreadTelemetry);const r=E.getProxy(_.MainContext.MainThreadWindow);this._impl=(s,n)=>{const t=i.URI.parse(s);return n?this.callOriginal(s,n):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,s,{}):this.callOriginal(s,n)}}load(h,o,E){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=E(h),this._impl}callOriginal(h,o){return this.sendNoForwardTelemetry(),this._original(h,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=je([xe(2,w.IExtHostRpcService)],f)}),define(ye[47],De([0,1,80,6,9,34,4,54,55,40,7,32,220,33]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,k.createDecorator)("IExtHostVariableResolverProvider");class C extends D.AbstractVariableResolverService{constructor(g,b,f,l,h,o,E){function r(){if(f){const s=f.activeEditor();if(s)return s.document.uri;const n=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof L.TextDiffTabInput||n.input instanceof L.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof L.TextTabInput||n.input instanceof L.NotebookEditorTabInput||n.input instanceof L.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:s=>{const n=o.folders.filter(t=>t.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(s,n)=>h.getConfiguration(void 0,s).get(n),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return _.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const s=r();if(s){const n=b.getWorkspaceFolder(s);if(n)return _.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(f){const s=f.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(f){const s=f.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>g.getExtension(s)},void 0,E?Promise.resolve(E):void 0,Promise.resolve(A.env))}}let m=class extends i.Disposable{constructor(g,b,f,l,h){super();this.extensionService=g,this.workspaceService=b,this.editorService=f,this.configurationService=l,this.editorTabs=h,this._resolver=new d.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new C(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};m=je([xe(0,P.IExtHostExtensionService),xe(1,I.IExtHostWorkspace),xe(2,y.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(ye[74],De([0,1,17,3,14,2,4,5,55,40,18,7,32,126,214,33,47]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,k.createDecorator)("IExtHostDebugService");let g=class{constructor(r,s,n,t,a,c){this._workspaceService=s,this._extensionService=n,this._configurationService=t,this._editorTabs=a,this._variableResolver=c,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new i.Emitter,this._onDidTerminateDebugSession=new i.Emitter,this._onDidChangeActiveDebugSession=new i.Emitter,this._onDidReceiveDebugSessionCustomEvent=new i.Emitter,this._debugServiceProxy=r.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new i.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(u=>{u.onDidChange(S=>{this.registerAllDebugTypes(u)}),this.registerAllDebugTypes(u)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,s){const n=r;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,a="?";return s&&(t+=`${a}session=${encodeURIComponent(s.id)}`,a="&"),t+=`${a}ref=${n.sourceReference}`,A.URI.parse(t)}else{if(n.path)return A.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const n of r.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const a of t)(0,C.isDebuggerMainContribution)(a)&&s.push(a.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(a=>{const c=a.id;return this._breakpoints.has(c)?!1:(this._breakpoints.set(c,a),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],t=new Map;for(const a of s)if(a instanceof I.SourceBreakpoint){let c=t.get(a.location.uri.toString());c||(c={type:"sourceMulti",uri:a.location.uri,lines:[]},t.set(a.location.uri.toString(),c),n.push(c)),c.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof I.FunctionBreakpoint&&n.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(c=>this._breakpoints.delete(c.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(c=>c instanceof I.SourceBreakpoint).map(c=>c.id),t=s.filter(c=>c instanceof I.FunctionBreakpoint).map(c=>c.id),a=s.filter(c=>c instanceof I.DataBreakpoint).map(c=>c.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,a)}startDebugging(r,s,n){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,n){if(!s)return new I.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(a=>a.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,s,n){if(!n)return new I.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(a=>a.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new I.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:n,factory:s}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let n;const t=await this.getFolder(r);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new h(r.implementation)}createSignService(){}async $startDASession(r,s){const n=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const c=this.convertToDto(a),u=this.createDebugAdapter(c,t);if(!u)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const S=u;return this._debugAdapters.set(r,S),this.getDebugAdapterTrackers(t).then(R=>(R&&this._debugAdaptersTrackers.set(r,R),S.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const N=O,p={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(N.arguments.value);p.body={signature:M},S.sendResponse(p)}else throw new Error("no signer")}catch(M){p.success=!1,p.message=M.message,S.sendResponse(p)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(O),O=(0,C.convertToVSCPaths)(O,!0),n._debugServiceProxy.$acceptDAMessage(r,O)}),S.onError(O=>{R&&R.onError&&R.onError(O),this._debugServiceProxy.$acceptDAError(r,O.name,O.message,O.stack)}),S.onExit(O=>{R&&R.onExit&&R.onExit((0,_.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,_.withNullAsUndefined)(O),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),S.startSession()))})}$sendDAMessage(r,s){s=(0,C.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(r);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s);const t=this._debugAdapters.get(r);t&&t.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(r);return this._debugAdapters.delete(r),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],n=[],t=[];if(r.added)for(const a of r.added){const c=a.id;if(c&&!this._breakpoints.has(c)){let u;if(a.type==="function")u=new I.FunctionBreakpoint(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")u=new I.DataBreakpoint(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const S=A.URI.revive(a.uri);u=new I.SourceBreakpoint(new I.Location(S,new I.Position(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}u._id=c,this._breakpoints.set(c,u),s.push(u)}}if(r.removed)for(const a of r.removed){const c=this._breakpoints.get(a);c&&(this._breakpoints.delete(a),n.push(c))}if(r.changed){for(const a of r.changed)if(a.id){const c=this._breakpoints.get(a.id);if(c){if(c instanceof I.FunctionBreakpoint&&a.type==="function"){const u=c;u.enabled=a.enabled,u.condition=a.condition,u.hitCondition=a.hitCondition,u.logMessage=a.logMessage,u.functionName=a.functionName}else if(c instanceof I.SourceBreakpoint&&a.type==="source"){const u=c;u.enabled=a.enabled,u.condition=a.condition,u.hitCondition=a.hitCondition,u.logMessage=a.logMessage,u.location=new I.Location(A.URI.revive(a.uri),new I.Position(a.line,a.character))}t.push(c)}}}this.fireBreakpointChanges(s,n,t)}$provideDebugConfigurations(r,s,n){return(0,d.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.getFolder(s);return t.provideDebugConfigurations(a,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,s,n,t){return(0,d.asPromise)(async()=>{const a=this.getConfigProviderByHandle(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.getFolder(s);return a.resolveDebugConfiguration(c,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,n,t){return(0,d.asPromise)(async()=>{const a=this.getConfigProviderByHandle(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.getFolder(s);return a.resolveDebugConfigurationWithSubstitutedVariables(c,n,t)})}async $provideDebugAdapter(r,s){const n=this.getAdapterDescriptorFactoryByHandle(r);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(n,t).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(a)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){const n=await this.getSession(r);n&&n._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const t={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof I.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof I.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(n=>n.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(n=>n.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(n=>n.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const n=r.configuration.type,t=this._trackerFactories.filter(a=>a.type===n||a.type==="*").map(a=>(0,d.asPromise)(()=>a.factory.createDebugAdapterTracker(r)).then(c=>c,c=>null));return Promise.race([Promise.all(t).then(a=>{const c=a.filter(u=>!!u);if(c.length>0)return new l(c)}),new Promise((a,c)=>{const u=setTimeout(()=>{clearTimeout(u),c(new Error("timeout"))},1e3)})]).catch(a=>{})}async getAdapterDescriptor(r,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new I.DebugAdapterServer(n));if(r){const a=await this._extensionService.getExtensionRegistry();return(0,d.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,a))).then(c=>{if(c)return c})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,n){(r.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:n}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const n=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;s=new b(this._debugServiceProxy,r.id,r.type,r.name,n,r.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};g=je([xe(0,L.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,m.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],g),e.ExtHostDebugServiceBase=g;class b{constructor(r,s,n,t,a,c,u){this._debugServiceProxy=r,this._id=s,this._type=n,this._name=t,this._workspaceFolder=a,this._configuration=c,this._parentSession=u}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=b;class f{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=f;class l{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(n=>n.onExit?n.onExit(r,s):void 0)}}class h extends T.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends g{constructor(r,s,n,t,a,c){super(r,s,n,t,a,c)}};o=je([xe(0,L.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,m.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(ye[274],De([0,1,11,73,2,5,266,13,82,84,27,194,18,64,40]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class m{constructor(g,b,f,l,h){this._hostUtils=f,this._rpcProtocol=new k.RPCProtocol(g,null,l),b=m._transform(b,this._rpcProtocol);const o=new P.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...b,messagePorts:h}),o.set(D.IExtHostRpcService,new D.ExtHostRpcService(this._rpcProtocol)),o.set(T.IURITransformerService,new T.URITransformerService(l)),o.set(C.IHostUtils,f);const E=new I.InstantiationService(o,!0);this._logService=E.invokeFunction(t=>t.get(y.ILogService)),i.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",b),this._extensionService=E.invokeFunction(t=>t.get(C.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(a,c)=>{let u="",S,R;for(const O of c)u+=`
	at ${O.toString()}`,R=O.getFileName(),!S&&R&&(S=t.findSubstr(_.URI.file(R)));return r.set(a,S),`${a.name||"Error"}: ${a.message||""}${u}`}});const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);d.setUnexpectedErrorHandler(t=>{const a=d.transformErrorForSerialization(t),c=r.get(t);c?s.$onExtensionRuntimeError(c.identifier,a):n.$onUnexpectedError(a)})}async asBrowserUri(g){const b=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return _.URI.revive(await b.$asBrowserUri(g))}terminate(g){this._extensionService.terminate(g)}static _transform(g,b){g.allExtensions.forEach(l=>l.extensionLocation=_.URI.revive(b.transformIncomingURIs(l.extensionLocation))),g.environment.appRoot=_.URI.revive(b.transformIncomingURIs(g.environment.appRoot));const f=g.environment.extensionDevelopmentLocationURI;return f&&(g.environment.extensionDevelopmentLocationURI=f.map(l=>_.URI.revive(b.transformIncomingURIs(l)))),g.environment.extensionTestsLocationURI=_.URI.revive(b.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=_.URI.revive(b.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=_.URI.revive(b.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=_.URI.revive(b.transformIncomingURIs(g.logsLocation)),g.logFile=_.URI.revive(b.transformIncomingURIs(g.logFile)),g.workspace=b.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=m}),define(ye[275],De([0,1,17,12,178,193,201,74,55,40,18,39,7,47,32,215,216,33]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let b=class extends y.ExtHostDebugServiceBase{constructor(E,r,s,n,t,a,c){super(E,r,s,n,a,c);this._terminalService=t,this._integratedTerminalInstances=new h}createDebugAdapter(E,r){switch(E.type){case"server":return new m.SocketDebugAdapter(E);case"pipeServer":return new m.NamedPipeDebugAdapter(E);case"executable":return new m.ExecutableDebugAdapter(E,r.type)}return super.createDebugAdapter(E,r)}daExecutableFromPackage(E,r){const s=m.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),E.type);if(s)return new D.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new k.SignService}async $runInTerminal(E,r){if(E.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const s=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),a=E.title||_.localize(0,null),c=JSON.stringify({shell:n,shellArgs:t});let u=await this._integratedTerminalInstances.checkout(c,a),S,R=!1;if(u)S=E.cwd;else{const M={shellPath:n,shellArgs:t,cwd:E.cwd,name:a,iconPath:new D.ThemeIcon("debug")};R=!0,u=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,c)}u.show(!0);const O=await u.processId;R?await new Promise(M=>setTimeout(M,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?u.sendText("cls"):n.indexOf("bash")>=0?u.sendText("clear"):i.isWindows?u.sendText("cls"):u.sendText("clear"));const N=(0,v.prepareCommand)(n,E.args,S,E.env);u.sendText(N);const p=this.onDidTerminateDebugSession(M=>{M.id===r&&(this._integratedTerminalInstances.free(u),p.dispose())});return O}else if(E.kind==="external")return l(E,await this._configurationService.getConfigProvider());return super.$runInTerminal(E,r)}};b=je([xe(0,L.IExtHostRpcService),xe(1,C.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,g.IExtHostConfiguration),xe(4,I.IExtHostTerminalService),xe(5,w.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let f;function l(o,E){if(!f)if(i.isWindows)f=new A.WindowsExternalTerminalService;else if(i.isMacintosh)f=new A.MacExternalTerminalService;else if(i.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=E.getConfiguration("terminal");return f.runInTerminal(o.title,o.cwd,o.args,o.env||{},r.external||{})}e.runInExternalTerminal=l;class h{constructor(){this._terminalInstances=new Map}async checkout(E,r){const n=[...this._terminalInstances.entries()].map(([t,a])=>(0,d.createCancelablePromise)(async c=>{if(t.name!==r||a.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await t.processId))return null;const u=Date.now();return a.lastUsedAt+h.minUseDelay>u||c.isCancellationRequested||a.config!==E?null:(a.lastUsedAt=u,t)}));return await(0,d.firstParallel)(n,t=>!!t)}insert(E,r){this._terminalInstances.set(E,{lastUsedAt:Date.now(),config:r})}free(E){const r=this._terminalInstances.get(E);r&&(r.lastUsedAt=-1)}onTerminalClosed(E){this._terminalInstances.delete(E)}}h.minUseDelay=1e3}),define(ye[276],De([0,1,9,2,112,32,54,33,45,39,18,27,72,10,13,67,22,49,47]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends D.ExtHostTaskBase{constructor(h,o,E,r,s,n,t,a,c){super(h,o,E,r,s,n,t,a);this.workspaceService=E,this.variableResolver=c,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,o){const E=o;if(!o.execution&&E._id===void 0)throw new Error("Tasks to execute must include an execution");if(E._id!==void 0){const r=D.TaskHandleDTO.from(E,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(s,o);return this._proxy.$executeTask(r).catch(()=>{}),n}else{const r=D.TaskDTO.from(o,h);if(r===void 0)return Promise.reject(new Error("Task is not valid"));D.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,o,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),o);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(h,o,E,r){const s=[];if(r)for(let n of r){this.checkDeprecation(n,E),(!n.definition||!h[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const t=D.TaskDTO.from(n,E.extension);t&&(s.push(t),D.CustomExecutionDTO.is(t.execution)&&o.push(this.addCustomExecution(t,n,!0)))}return{tasks:s,extension:E.extension}}async resolveTaskInternal(h){return h}async getAFolder(h){let o=h&&h.length>0?h[0]:void 0;if(!o){const E=i.URI.file((0,g.homedir)());o=new w.WorkspaceFolder({uri:E,name:v.basename(E),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,o){const E=i.URI.revive(h),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(E),n=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),a=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let c of o.variables)r.variables[c]=await t.resolveAsync(a,c);if(o.process!==void 0){let c;if(o.process.path!==void 0){c=o.process.path.split(d.delimiter);for(let u=0;u<c.length;u++)c[u]=await t.resolveAsync(a,c[u])}r.process=await _.win32.findExecutable(await t.resolveAsync(a,o.process.name),o.process.cwd!==void 0?await t.resolveAsync(a,o.process.cwd):void 0,c)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(h,o,E){return _.win32.findExecutable(h,o,E)}};f=je([xe(0,L.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,y.IExtHostConfiguration),xe(5,P.IExtHostTerminalService),xe(6,C.ILogService),xe(7,m.IExtHostApiDeprecationService),xe(8,b.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(ye[277],De([0,1,49,47]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class _ extends i.ExtHostVariableResolverProviderService{homeDir(){return(0,d.homedir)()}}e.NodeExtHostVariableResolverProviderService=_}),define(ye[140],De([0,1,16,17,21,51,10,9,22,14,2,31]),function(Y,e,d,i,_,A,k,y,w,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(f,l,h,o){this.query=f,this.provider=l,this.fileUtils=h,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,l){const h=this.query.folderQueries||[],o=new _.CancellationTokenSource;return l.onCancellationRequested(()=>o.cancel()),new Promise((E,r)=>{this.collector=new C(f);let s=!1;const n=(t,a)=>{if(!s&&!this.isLimitHit){const c=this.resultSize(t);v(t)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,s=!0,o.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const u=this.resultSize(t);this.resultCount+=u,(u>0||!v(t))&&this.collector.add(t,a)}};Promise.all(h.map((t,a)=>this.searchInFolder(t,c=>n(c,a),o.token))).then(t=>{o.dispose(),this.collector.flush();const a=t.some(c=>!!c&&!!c.limitHit);E({limitHit:this.isLimitHit||a,messages:(0,d.flatten)(t.map(c=>c?.message?(0,P.isArray)(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},t=>{o.dispose();const a=(0,A.toErrorMessage)(t);r(new Error(a))})})}resultSize(f){return v(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,l){const h=Array.isArray(f.ranges)?f.ranges:[f.ranges],o=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:h.slice(0,l),preview:{matches:o.slice(0,l),text:f.preview.text},uri:f.uri}}async searchInFolder(f,l,h){const o=new I.QueryGlobTester(this.query,f),E=[],r={report:t=>{if(!this.validateProviderResult(t))return;const a=f.folder.scheme===k.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(t.uri))):void 0,c=w.relativePath(f.folder,t.uri);if(c){const u=o.includedInQuery(c,y.basename(c),a);(0,i.isThenable)(u)?E.push(u.then(S=>{S&&l(t)})):u&&l(t)}}},s=this.getSearchOptionsForFolder(f),n=await this.provider.provideTextSearchResults(T(this.query.contentPattern),s,r,h);return E.length&&await Promise.all(E),n}validateProviderResult(f){if(v(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const l=(0,I.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),h=(0,I.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),o={folder:L.URI.from(f.folder),excludes:h,includes:l,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=D;function T(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class C{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,l=>this.sendItems(l))}add(f,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!w.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(m(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=C;function m(b){return v(b)?{preview:{matches:(0,d.mapArrayOrNot)(b.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:b.preview.text},ranges:(0,d.mapArrayOrNot)(b.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function v(b){return!!b.preview}e.extensionResultIsMatch=v;class g{constructor(f,l){this.maxBatchSize=f,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,l){!f||this.addItemToBatch(f,l)}addItems(f,l){!f||this.addItemsToBatch(f,l)}addItemToBatch(f,l){this.batch.push(f),this.batchSize+=l,this.onUpdate()}addItemsToBatch(f,l){this.batch=this.batch.concat(f),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(ye[75],De([0,1,6,5,4,270,18,64,13,2,140]),function(Y,e,d,i,_,A,k,y,w,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let I=class{constructor(m,v,g){this.extHostRpc=m,this._uriTransformer=v,this._logService=g,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,v){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const g=this._handlePool++;return this._textSearchProvider.set(g,v),this._proxy.$registerTextSearchProvider(g,this._transformScheme(m)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(m,v){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const g=this._handlePool++;return this._fileSearchProvider.set(g,v),this._proxy.$registerFileSearchProvider(g,this._transformScheme(m)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(m,v,g,b){const f=D(g),l=this._fileSearchProvider.get(m);if(l)return this._fileSearchManager.fileSearch(f,l,h=>{this._proxy.$handleFileMatch(m,v,h.map(o=>o.resource))},b);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,v,g,b){const f=this._textSearchProvider.get(m);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const l=D(g);return this.createTextSearchManager(l,f).search(o=>this._proxy.$handleTextMatch(m,v,o),b)}$enableExtensionHostSearch(){}createTextSearchManager(m,v){return new L.TextSearchManager(m,v,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}};I=je([xe(0,k.IExtHostRpcService),xe(1,y.IURITransformerService),xe(2,w.ILogService)],I),e.ExtHostSearch=I;function D(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(T),extraFileResources:C.extraFileResources&&C.extraFileResources.map(m=>P.URI.revive(m))}}e.reviveQuery=D;function T(C){return{...C,folder:P.URI.revive(C.folder)}}}),define(ye[278],De([0,1,82,139,32,135,33,38,54,39,72,74,75,90,52,67,138,68,46,89,123,55,136,13,228,47]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l,h,o,E,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.ILoggerService,o.ExtHostLoggerService),(0,d.registerSingleton)(E.ILogService,r.ExtHostLogService),(0,d.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,d.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,d.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,d.registerSingleton)(g.IExtHostConsumerFileSystem,g.ExtHostConsumerFileSystem),(0,d.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,d.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,d.registerSingleton)(D.IExtHostSearch,D.ExtHostSearch),(0,d.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,d.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,d.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,d.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService),(0,d.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,d.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,d.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,d.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,d.registerSingleton)(h.IExtHostEditorTabs,h.ExtHostEditorTabs),(0,d.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(ye[91],De([0,1,16,13,31,71]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function k(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=k;function y(I,D,T,C){const m=(0,d.mapArrayOrNot)(T,w),v=new _.TextSearchMatch(D,m,C),g=v.preview.matches;return{ranges:(0,d.mapArrayOrNot)(m,P),uri:I,preview:{text:v.preview.text,matches:(0,d.mapArrayOrNot)(g,P)}}}e.createTextSearchResult=y;function w(I){return new _.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor(D,T){this.prefix=D,this.logService=T}appendLine(D){this.logService.debug(`${this.prefix}#search`,D)}};L=je([xe(1,i.ILogService)],L),e.OutputChannel=L}),define(ye[279],De([0,1,41,9,81,30,12,8,91,280]),function(Y,e,d,i,_,A,k,y,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(f,l,h,o){const E=D(f,l,h,o),r=l.folder.fsPath;return{cmd:d.spawn(L,E.args,{cwd:r}),rgDiskPath:L,siblingClauses:E.siblingClauses,rgArgs:E,cwd:r}}e.spawnRipgrepCmd=I;function D(f,l,h,o){const E=["--files","--hidden","--case-sensitive"];C([l],h,!1).forEach(s=>{const n=(0,w.anchorGlob)(s);if(E.push("-g",n),k.isMacintosh){const t=(0,_.normalizeNFD)(n);t!==n&&E.push("-g",t)}});const r=T([l],o,void 0,!1);return r.globArgs.forEach(s=>{const n=`!${(0,w.anchorGlob)(s)}`;if(E.push("-g",n),k.isMacintosh){const t=(0,_.normalizeNFD)(n);t!==n&&E.push("-g",t)}}),l.disregardIgnoreFiles!==!1?E.push("--no-ignore"):l.disregardParentIgnoreFiles!==!1&&E.push("--no-ignore-parent"),l.ignoreSymlinks||E.push("--follow"),f.exists&&E.push("--quiet"),E.push("--no-config"),l.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:r.siblingClauses}}function T(f,l,h,o=!0){const E=[];let r={};return f.forEach(s=>{const n=Object.assign({},s.excludePattern||{},l||{}),t=m(n,o?s.folder.fsPath:void 0,h);E.push(...t.globArgs),t.siblingClauses&&(r=Object.assign(r,t.siblingClauses))}),{globArgs:E,siblingClauses:r}}e.foldersToRgExcludeGlobs=T;function C(f,l,h=!0){const o=[];return f.forEach(E=>{const r=Object.assign({},l||{},E.includePattern||{}),s=m(r,h?E.folder.fsPath:void 0);o.push(...s.globArgs)}),o}e.foldersToIncludeGlobs=C;function m(f,l,h){const o=[],E={};return Object.keys(f).forEach(r=>{if(h&&h.has(r)||!r)return;const s=f[r];r=g(l?v(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),o.push(b(r))):s&&s.when&&(E[r]=s)}),{globArgs:o,siblingClauses:E}}function v(f,l){return i.isAbsolute(l)?l:i.join(f,l)}e.getAbsoluteGlob=v;function g(f){return f=y.rtrim(f,"\\"),y.rtrim(f,"/")}function b(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=b}),define(ye[281],De([0,1,41,61,9,104,16,51,35,81,30,12,48,8,14,29,31,279,100]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(r=>r())});class l{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&w.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&w.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(n=>{const t=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),a=n.folder.fsPath;s.folderQueries.map(c=>c.folder.fsPath).filter(c=>c!==a).forEach(c=>{(0,L.isEqualOrParent)(c,a)&&(t[_.relative(a,c)]=!0)}),this.folderExcludePatterns.set(a,new o(t,a))})}cancel(){this.isCanceled=!0,f.forEach(s=>s())}walk(s,n,t,a,c){if(this.fileWalkSW=D.StopWatch.create(!1),this.isCanceled)return c(null,this.isLimitHit);n.forEach(u=>{const S=_.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,S)||this.matchFile(t,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=D.StopWatch.create(!1),this.parallel(s,(u,S)=>{this.call(this.cmdTraversal,this,u,t,a,R=>{if(R){const O=(0,y.toErrorMessage)(R);console.error(O),this.errors.push(O),S(R,void 0)}else S(null,void 0)})},(u,S)=>{this.fileWalkSW.stop();const R=u?k.coalesce(u)[0]:null;c(R,this.isLimitHit)})}parallel(s,n,t){const a=new Array(s.length),c=new Array(s.length);let u=!1,S=0;if(s.length===0)return t(null,[]);s.forEach((R,O)=>{n(R,(N,p)=>{if(N?(u=!0,a[O]=null,c[O]=N):(a[O]=p,c[O]=null),++S===s.length)return t(u?c:null,a)})})}call(s,n,...t){try{s.apply(n,t)}catch(a){t[t.length-1](a)}}cmdTraversal(s,n,t,a){const c=s.folder.fsPath,u=I.isMacintosh;let S;const R=()=>S&&S.kill();f.add(R);let O=H=>{f.delete(R),O=()=>{},a(H)},N="";const p=this.initDirectoryTree();let M;const U=(0,g.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression);S=U.cmd,M=!Object.keys(U.siblingClauses).length;const z=U.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let re=`${U.rgDiskPath} ${z}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(re+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),t({message:re}),this.cmdResultCount=0,this.collectStdout(S,"utf8",t,(H,F,j)=>{if(H){O(H);return}if(this.isLimitHit){O();return}const V=(N+(u?P.normalizeNFC(F||""):F)).split(`
`);if(j){const ne=V.length;V[ne-1]=V[ne-1].trim(),V[ne-1]||V.pop()}else N=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,M){for(const ne of V)if(this.matchFile(n,{base:c,relativePath:ne,searchPath:this.getSearchPath(s,ne)}),this.isLimitHit){R();break}(j||this.isLimitHit)&&O();return}this.addDirectoryEntries(s,p,c,V,n),j&&(this.matchDirectoryTree(p,c,n),O())})}spawnFindCmd(s){const n=this.folderExcludePatterns.get(s.folder.fsPath),t=n.getBasenameTerms(),a=n.getPathTerms(),c=["-L","."];if(t.length||a.length){c.push("-not","(","(");for(const u of t)c.push("-name",u),c.push("-o");for(const u of a)c.push("-path",u),c.push("-o");c.pop(),c.push(")","-prune",")")}return c.push("-type","f"),d.spawn("find",c,{cwd:s.folder.fsPath})}readStdout(s,n,t){let a="";this.collectStdout(s,n,()=>{},(c,u,S)=>{if(c){t(c);return}a+=u,S&&t(null,a)})}collectStdout(s,n,t,a){let c=(R,O,N)=>{(R||N)&&(c=()=>{},this.cmdSW&&this.cmdSW.stop()),a(R,O,N)},u=!1;s.stdout?(this.forwardData(s.stdout,n,c),s.stdout.once("data",()=>u=!0)):t({message:"stdout is null"});let S;s.stderr?S=this.collectData(s.stderr):t({message:"stderr is null"}),s.on("error",R=>{c(R)}),s.on("close",R=>{let O;!u&&(O=this.decodeData(S,n))&&E(O)?c(new Error(`command failed with error code ${R}: ${this.decodeData(S,n)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),c(null,"",!0))})}forwardData(s,n,t){const a=new A.StringDecoder(n);return s.on("data",c=>{t(null,a.write(c))}),a}collectData(s){const n=[];return s.on("data",t=>{n.push(t)}),n}decodeData(s,n){const t=new A.StringDecoder(n);return s.map(a=>t.write(a)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:n},t,a,c){a.indexOf(this.filePattern)!==-1&&this.matchFile(c,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const u=S=>{const R=_.basename(S),O=_.dirname(S);let N=n[O];N||(N=n[O]=[],u(O)),N.push({base:t,relativePath:S,basename:R,searchPath:this.getSearchPath(s,S)})};a.forEach(u)}matchDirectoryTree({rootEntries:s,pathToEntries:n},t,a){const c=this,u=this.folderExcludePatterns.get(t),S=this.filePattern;function R(O){c.directoriesWalked++;const N=(0,v.hasSiblingFn)(()=>O.map(p=>p.basename));for(let p=0,M=O.length;p<M;p++){const U=O[p],{relativePath:z,basename:re}=U;if(u.test(z,re,S!==re?N:void 0))continue;const H=n[z];if(H)R(H);else{if(c.filesWalked++,z===S)continue;c.matchFile(a,U)}if(c.isLimitHit)break}}R(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,n,t,a,c){const u=s.folder,S=(0,v.hasSiblingFn)(()=>t);this.parallel(t,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const N=n?[n,R].join(_.sep):R;if(this.folderExcludePatterns.get(s.folder.fsPath).test(N,R,this.config.filePattern!==R?S:void 0))return O(null);const p=[u.fsPath,N].join(_.sep);i.lstat(p,(M,U)=>{if(M||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(p,U,(z,re)=>z||this.isCanceled||this.isLimitHit?O(null):re.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(p,U,(H,F)=>H||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?O(null):(this.walkedPaths[F]=!0,m.Promises.readdir(p).then(j=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(s,N,j,a,x=>O(x||null))},j=>{O(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&C.isNumber(re.size)&&re.size>this.maxFilesize||this.matchFile(a,{base:u.fsPath,relativePath:N,searchPath:this.getSearchPath(s,N)}),O(null,void 0)))})},R=>{const O=R&&k.coalesce(R);return c(O&&O.length>0?O[0]:void 0)})}matchFile(s,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,_.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(n))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,n,t){return n.isSymbolicLink()?i.stat(s,t):t(null,n)}realPathIfNeeded(s,n,t){return n.isSymbolicLink()?i.realpath(s,(a,c)=>a?t(a):t(null,c)):t(null,s)}getSearchPath(s,n){return s.folderName?_.join(s.folderName,n):n}}e.FileWalker=l;class h{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new l(s)}search(s,n,t){this.walker.walk(this.folderQueries,this.extraFiles,s,n,(a,c)=>{t(a,{limitHit:c,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=h;class o{constructor(s,n){this.expression=s,this.root=n,this.init(s)}init(s){let n,t;Object.keys(s).filter(a=>s[a]).forEach(a=>{_.isAbsolute(a)?(n=n||w.getEmptyExpression(),n[a]=s[a]):(t=t||w.getEmptyExpression(),t[a]=s[a])}),this.absoluteParsedExpr=n&&w.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=t&&w.parse(t,{trimForExclusions:!0})}test(s,n,t){return this.relativeParsedExpr&&this.relativeParsedExpr(s,n,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(_.join(this.root,s),n,t)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...w.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...w.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...w.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...w.getPathTerms(this.relativeParsedExpr)),s}}function E(r){const s=r.trim().split(`
`),n=s[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return T.uppercaseFirstLetter(s[s.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=E}),define(ye[282],De([0,1,96,23]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function _(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=_,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,k=512,y=512*8,w=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(s,n){super(s);this.decodeStreamErrorKind=n}}e.DecodeStreamError=L;class I{constructor(s){this.iconvLiteDecoder=s}static async create(s){let n;if(s!==e.UTF8)n=(await new Promise((a,c)=>{Y(["@vscode/iconv-lite-umd"],a,c)})).getDecoder(m(s));else{const t=new TextDecoder;n={write(a){return t.decode(a,{stream:!0})},end(){return t.decode()}}}return new I(n)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function D(r,s){const n=s.minBytesRequiredForDetection??s.guessEncoding?y:k;return new Promise((t,a)=>{const c=(0,d.newWriteableStream)(p=>p.join("")),u=[];let S=0,R,O;const N=async()=>{try{const p=await E({buffer:i.VSBuffer.concat(u),bytesRead:S},s.guessEncoding);if(p.seemsBinary&&s.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);p.encoding=await s.overwriteEncoding(p.encoding),R=await I.create(p.encoding);const M=R.write(i.VSBuffer.concat(u).buffer);c.write(M),u.length=0,S=0,t({stream:c,detected:p})}catch(p){O?.dispose(),c.destroy(),a(p)}};O=(0,d.listenStream)(r,{onData:async p=>{R?c.write(R.write(p.buffer)):(u.push(p),S+=p.byteLength,S>=n&&(r.pause(),await N(),setTimeout(()=>r.resume())))},onError:p=>c.error(p),onEnd:async()=>{R||await N(),c.end(R?.end())}})})}e.toDecodeStream=D;async function T(r,s,n){const a=(await new Promise((S,R)=>{Y(["@vscode/iconv-lite-umd"],S,R)})).getEncoder(m(s),n);let c=!1,u=!1;return{read(){if(u)return null;const S=r.read();if(typeof S!="string"){if(u=!0,!c&&n?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=a.end();return R&&R.length>0?(c=!0,i.VSBuffer.wrap(R)):null}return c=!0,i.VSBuffer.wrap(a.write(S))}}}e.toEncodeReadable=T;async function C(r){return(await new Promise((n,t)=>{Y(["@vscode/iconv-lite-umd"],n,t)})).encodingExists(m(r))}e.encodingExists=C;function m(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=m;function v(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),t=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const a=r.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const g=["ascii","utf-16","utf-32"];async function b(r){const s=await new Promise((u,S)=>{Y(["jschardet"],u,S)}),n=r.slice(0,w),t=h(n.buffer),a=s.detect(t);if(!a||!a.encoding)return null;const c=a.encoding.toLowerCase();return 0<=g.indexOf(c)?null:l(a.encoding)}const f={ibm866:"cp866",big5:"cp950"};function l(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[s]||s}function h(r){let s="";for(let n=0;n<r.length;n++)s+=String.fromCharCode(r[n]);return s}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=o;function E({buffer:r,bytesRead:s},n){let t=v(r,s),a=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let c=!0,u=!0,S=!1;for(let R=0;R<s&&R<A;R++){const O=R%2==1,N=r.readUInt8(R)===0;if(N&&(S=!0),c&&(O&&!N||!O&&N)&&(c=!1),u&&(O&&N||!O&&!N)&&(u=!1),N&&!c&&!u)break}S&&(c?t=e.UTF16le:u?t=e.UTF16be:a=!0)}return n&&!a&&!t&&r?b(r.slice(0,s)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:a,encoding:t}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[141],De([0,1,282,29,140]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends _.TextSearchManager{constructor(y,w,P=i,L="searchProcess"){super(y,w,{readdir:I=>P.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,d.toCanonicalName)(I)},L)}}e.NativeTextSearchManager=A}),define(ye[283],De([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class d{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(_){if(_&&this._dragOperations.has(_)){const A=this._dragOperations.get(_);return this._dragOperations.delete(_),A}}addDragOperationTransfer(_,A){this._dragOperations.set(_,A)}getRenderedTreeElement(_){if(this._renderedElements.has(_))return this._renderedElements.get(_)}addRenderedTreeItemElement(_,A){this._renderedElements.set(_,A)}removeRenderedTreeItemElement(_){this._renderedElements.has(_)&&this._renderedElements.delete(_)}}e.TreeviewsService=d}),define(ye[284],De([0,1,176,22,2,3,6,17,7,14,16,15,21,125,283,25]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(f,l){if((0,P.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let h;return Array.isArray(f.highlights)&&(h=f.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),h=h.length?h:void 0),{label:f.label,highlights:h}}}class g{constructor(l,h,o){this._proxy=l,this.commands=h,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new C.TreeviewsService;function E(r){return r&&r.$treeViewId&&r.$treeItemHandle}h.registerArgumentProcessor({processArgument:r=>E(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>E(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(l,h,o){const E=this.createTreeView(l,{treeDataProvider:h},o);return{dispose:()=>E.dispose()}}createTreeView(l,h,o){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const E=h.dragAndDropController?.dropMimeTypes??[],r=h.dragAndDropController?.dragMimeTypes??[],s=!!h.dragAndDropController?.handleDrag,n=!!h.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dropMimeTypes:E,dragMimeTypes:r,hasHandleDrag:s,hasHandleDrop:n}),a=this.createExtHostTreeView(l,h,o);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(c){a.message=c},get title(){return a.title},set title(c){a.title=c},get description(){return a.description},set description(c){a.description=c},get badge(){return(0,m.checkProposedApiEnabled)(o,"badges"),a.badge},set badge(c){(0,m.checkProposedApiEnabled)(o,"badges"),a.badge=c},reveal:(c,u)=>a.reveal(c,u),dispose:async()=>{await t,this.treeViews.delete(l),a.dispose()}}}$getChildren(l,h){const o=this.treeViews.get(l);return o?o.getChildren(h):Promise.reject(new Error((0,d.localize)(0,null,l)))}async $handleDrop(l,h,o,E,r,s,n){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,d.localize)(1,null,l)));const a=T.DataTransferConverter.toDataTransfer(h);return s===l&&n&&await this.addAdditionalTransferItems(a,t,n,E,r),t.onDrop(a,o,E)}async addAdditionalTransferItems(l,h,o,E,r){const s=this.treeDragAndDropService.removeDragOperationTransfer(r);if(s)(await s)?.forEach((n,t)=>{n&&l.set(t,n)});else if(r&&h.handleDrag){const n=h.handleDrag(o,l,E);this.treeDragAndDropService.addDragOperationTransfer(r,n),await n}return l}async $handleDrag(l,h,o,E){const r=this.treeViews.get(l);if(!r)return Promise.reject(new Error((0,d.localize)(2,null,l)));const s=await this.addAdditionalTransferItems(new Map,r,h,E,o);if(!!s)return T.DataTransferConverter.toDataTransferDTO(s)}async $hasResolve(l){const h=this.treeViews.get(l);if(!h)throw new Error((0,d.localize)(3,null,l));return h.hasResolve}$resolve(l,h,o){const E=this.treeViews.get(l);if(!E)throw new Error((0,d.localize)(4,null,l));return E.resolveTreeItem(h,o)}$setExpanded(l,h,o){const E=this.treeViews.get(l);if(!E)throw new Error((0,d.localize)(5,null,l));E.setExpanded(h,o)}$setSelection(l,h){const o=this.treeViews.get(l);if(!o)throw new Error((0,d.localize)(6,null,l));o.setSelection(h)}$setVisible(l,h){const o=this.treeViews.get(l);if(!o)throw new Error((0,d.localize)(7,null,l));o.setVisible(h)}createExtHostTreeView(l,h,o){const E=new b(l,h,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(l,E),E}convertArgument(l){const h=this.treeViews.get(l.$treeViewId);return h?h.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=g;class b extends k.Disposable{constructor(l,h,o,E,r,s){super();if(this.viewId=l,this.proxy=o,this.commands=E,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new D.CancellationTokenSource,s.contributes&&s.contributes.views)for(const a in s.contributes.views)for(const c of s.contributes.views[a])c.id===l&&(this._title=c.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let n,t;this._register(A.Event.debounce(this._onDidChangeData.event,(a,c)=>(a||(a={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(u=>t=u),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?a.elements.push(...c.element):a.elements.push(c.element)),c.message&&(a.message=!0),a),200,!0)(({message:a,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const u=t;return n=null,this.refresh(c).then(()=>u())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,P.isUndefinedOrNull)(l))}async getChildren(l){const h=l?this.getExtensionElement(l):void 0;if(l&&!h)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(l);return o||(o=await this.fetchChildrenNodes(h)),o?o.map(E=>E.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,h){h=h||{select:!0,focus:!1};const o=(0,P.isUndefinedOrNull)(h.select)?!0:h.select,E=(0,P.isUndefinedOrNull)(h.focus)?!1:h.focus,r=(0,P.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(s=>this.resolveTreeNode(l,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(t=>t.item)},{select:o,focus:E,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:E,expand:r})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=I.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,h){const o=this.getExtensionElement(l);o&&(h?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(l){(0,L.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,h,o){const E=[];for(const r of l){const s=this.getExtensionElement(r);s&&E.push(s)}if(!(!this.dndController?.handleDrag||E.length===0))return await this.dndController.handleDrag(E,h,o),h}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,h,o){const E=h?this.getExtensionElement(h):void 0;if(!(!E&&h||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(E,l,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,h){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(l);if(o){const E=this.nodes.get(o);if(E){const r=await this.dataProvider.resolveTreeItem(E.extensionItem,o,h)??E.extensionItem;return E.item.tooltip=this.getTooltip(r.tooltip),E.item.command=this.getCommand(E.disposableStore,r.command),E.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(h=>h?this.resolveUnknownParentChain(h).then(o=>this.resolveTreeNode(h,o[o.length-1]).then(E=>(o.push(E),o))):Promise.resolve([]))}resolveParent(l){const h=this.nodes.get(l);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,h){const o=this.nodes.get(l);return o?Promise.resolve(o):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(E=>this.createHandle(l,E,h,!0)).then(E=>this.getChildren(h?h.item.handle:void 0).then(()=>{const r=this.getExtensionElement(E);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${E}`)}))}getChildrenNodes(l){if(l){let h;if(typeof l=="string"){const o=this.getExtensionElement(l);h=o?this.nodes.get(o):void 0}else h=l;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const h=new D.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=l?this.nodes.get(l):void 0,E=await this.dataProvider.getChildren(l);if(h.token.isCancellationRequested)return;const r=await Promise.all((0,L.coalesce)(E||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,o):null}));return h.token.isCancellationRequested?void 0:(0,L.coalesce)(r)}finally{h.dispose()}}refresh(l){if(l.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new D.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(l);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const h=new Set,o=l.map(r=>this.nodes.get(r));for(const r of o)if(r&&!h.has(r.item.handle)){let s=r;for(;s&&s.parent&&o.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&h.add(r.item.handle)}const E=[];return h.forEach(r=>{const s=this.elements.get(r);if(s){const n=this.nodes.get(s);n&&(!n.parent||!h.has(n.parent.item.handle))&&E.push(r)}}),E}refreshHandles(l){const h={};return Promise.all(l.map(o=>this.refreshNode(o).then(E=>{E&&(h[o]=E.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(l){const h=this.getExtensionElement(l);if(h){const o=this.nodes.get(h);if(o)return this.clearChildren(h),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(E=>{if(E){const r=this.createTreeNode(h,E,o.parent);return this.updateNodeCache(h,r,o,o.parent),o.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,h,o){const E=this.createTreeNode(l,h,o);if(h.id&&this.elements.has(E.item.handle))throw new Error((0,d.localize)(8,null,h.id));return this.addNodeToCache(l,E),this.addNodeToParentCache(E,o),E}getTooltip(l){return w.MarkdownString.isMarkdownString(l)?I.MarkdownString.from(l):l}getCommand(l,h){return h?this.commands.toInternal(h,l):void 0}createTreeNode(l,h,o){const E=new k.DisposableStore,r=this.createHandle(l,h,o),s=this.getLightIconPath(h);return{item:{handle:r,parentHandle:o?o.item.handle:void 0,label:v(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(E,h.command),contextValue:h.contextValue,icon:s,iconDark:this.getDarkIconPath(h)||s,themeIcon:this.getThemeIcon(h),collapsibleState:(0,P.isUndefinedOrNull)(h.collapsibleState)?w.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:o,children:void 0,disposableStore:E,dispose(){E.dispose()}}}getThemeIcon(l){return l.iconPath instanceof w.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:h,label:o,resourceUri:E},r,s){if(h)return`${b.ID_HANDLE_PREFIX}/${h}`;const n=v(o,this.extension),t=r?r.item.handle:b.LABEL_HANDLE_PREFIX;let a=n?n.label:E?(0,i.basename)(E):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const c=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,u=this.getChildrenNodes(r)||[];let S,R=0;do{if(S=`${t}/${R}:${a}`,s||!this.elements.has(S)||c===S)break;R++}while(R<=u.length);return S}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof w.ThemeIcon))return typeof l.iconPath=="string"||_.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof w.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return _.URI.isUri(l)?l:_.URI.file(l)}addNodeToCache(l,h){this.elements.set(h.item.handle,l),this.nodes.set(l,h)}updateNodeCache(l,h,o,E){this.elements.delete(h.item.handle),this.nodes.delete(l),h.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(l,h);const r=this.getChildrenNodes(E)||[],s=r.filter(n=>n.item.handle===o.item.handle)[0];s&&r.splice(r.indexOf(s),1,h)}addNodeToParentCache(l,h){h?(h.children||(h.children=[]),h.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const h=this.nodes.get(l);if(h){if(h.children)for(const o of h.children){const E=this.elements.get(o.item.handle);E&&this.clear(E)}h.children=void 0}}else this.clearAll()}clear(l){const h=this.nodes.get(l);if(h){if(h.children)for(const o of h.children){const E=this.elements.get(o.item.handle);E&&this.clear(E)}this.nodes.delete(l),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(ye[285],De([0,1,21,11,3,43,2,113,110,153,152,42,5,134,233,232,38,234,33,235,236,237,222,238,54,40,239,240,243,244,245,139,224,250,251,252,90,39,254,284,15,7,257,70,138,32,57,212,242,121,135,72,74,75,13,64,18,27,246,208,52,67,230,255,69,68,260,258,259,231,46,253,256,89,55,123,137,71,249,10,117,247,206,241,6,25,213,248]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l,h,o,E,r,s,n,t,a,c,u,S,R,O,N,p,M,U,z,re,H,F,j,x,V,ne,Q,he,fe,G,X,ce,pe,Ie,Re,Ce,ke,Ae,ue,ve,ie,oe,we,Te,B,q,J,te,K,ae,de,Be,$e,Ne,Xe,ee,se,be,le,_e,Fe,He,qe,Ge,Ze,Qe,rt,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function pt(nt){const ut=nt.get(Ae.IExtHostInitDataService),Pt=nt.get(de.IExtHostFileSystemInfo),Nt=nt.get(q.IExtHostConsumerFileSystem),yt=nt.get(s.IExtHostExtensionService),ft=nt.get(ne.IExtHostWorkspace),Dt=nt.get(ee.IExtHostTelemetry),At=nt.get(b.IExtHostConfiguration),Ft=nt.get(Ce.IURITransformerService),Ke=nt.get(ke.IExtHostRpcService),zt=nt.get(M.IExtHostStorage),Rt=nt.get(B.IExtensionStoragePaths),Mt=nt.get(Re.ILoggerService),Pe=nt.get(Re.ILogService),Le=nt.get(ie.IExtHostTunnelService),Ee=nt.get(oe.IExtHostApiDeprecationService),Z=nt.get(V.IExtHostWindow),Me=nt.get(Ne.IExtHostSecretState),Ve=nt.get(Xe.IExtHostEditorTabs);Ke.set(D.ExtHostContext.ExtHostFileSystemInfo,Pt),Ke.set(D.ExtHostContext.ExtHostLogLevelServiceShape,Mt),Ke.set(D.ExtHostContext.ExtHostWorkspace,ft),Ke.set(D.ExtHostContext.ExtHostConfiguration,At),Ke.set(D.ExtHostContext.ExtHostExtensionService,yt),Ke.set(D.ExtHostContext.ExtHostStorage,zt),Ke.set(D.ExtHostContext.ExtHostTunnelService,Le),Ke.set(D.ExtHostContext.ExtHostWindow,Z),Ke.set(D.ExtHostContext.ExtHostSecretState,Me),Ke.set(D.ExtHostContext.ExtHostTelemetry,Dt),Ke.set(D.ExtHostContext.ExtHostEditorTabs,Ve);const st=Ke.set(D.ExtHostContext.ExtHostDecorations,nt.get(X.IExtHostDecorations)),Ye=Ke.set(D.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(r.IExtHostDocumentsAndEditors)),lt=Ke.set(D.ExtHostContext.ExtHostCommands,nt.get(v.IExtHostCommands)),dt=Ke.set(D.ExtHostContext.ExtHostTerminalService,nt.get(U.IExtHostTerminalService)),vt=Ke.set(D.ExtHostContext.ExtHostDebugService,nt.get(pe.IExtHostDebugService)),_t=Ke.set(D.ExtHostContext.ExtHostSearch,nt.get(Ie.IExtHostSearch)),mt=Ke.set(D.ExtHostContext.ExtHostTask,nt.get(ce.IExtHostTask)),wt=Ke.set(D.ExtHostContext.ExtHostOutputService,nt.get(S.IExtHostOutputService)),Lt=Ke.set(D.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(Ke)),bt=Ke.set(D.ExtHostContext.ExtHostDocuments,new E.ExtHostDocuments(Ke,Ye)),Kt=Ke.set(D.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Ke,Ye,Pe)),Qt=Ke.set(D.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(Pe,bt,Ke.getProxy(D.MainContext.MainThreadBulkEdits))),Et=Ke.set(D.ExtHostContext.ExtHostNotebook,new ue.ExtHostNotebookController(Ke,lt,Ye,bt,Rt)),$t=Ke.set(D.ExtHostContext.ExtHostNotebookDocuments,new qe.ExtHostNotebookDocuments(Et)),Yt=Ke.set(D.ExtHostContext.ExtHostNotebookEditors,new He.ExtHostNotebookEditors(Pe,Ke,Et)),Jt=Ke.set(D.ExtHostContext.ExtHostNotebookKernels,new se.ExtHostNotebookKernels(Ke,ut,Et,lt,Pe)),ci=Ke.set(D.ExtHostContext.ExtHostNotebookProxyKernels,new tt.ExtHostNotebookProxyKernels(Ke,Jt,Pe)),ui=Ke.set(D.ExtHostContext.ExtHostNotebookRenderers,new le.ExtHostNotebookRenderers(Ke,Et)),kt=Ke.set(D.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(Ke,Ye)),Zt=Ke.set(D.ExtHostContext.ExtHostTreeViews,new re.ExtHostTreeViews(Ke.getProxy(D.MainContext.MainThreadTreeViews),lt,Pe)),di=Ke.set(D.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Ke.getProxy(D.MainContext.MainThreadEditorInsets),kt,ut.remote)),Xt=Ke.set(D.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Ke,Pe,Pt)),ei=Ke.set(D.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ke,bt,lt.converter,Ft)),ht=Ke.set(D.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ke,Ft,bt,lt,Xt,Pe,Ee)),hi=Ke.set(D.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ke,ht)),Bt=Ke.set(D.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ke,Pe,Ye)),xt=Ke.set(D.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,ft,lt)),ti=Ke.set(D.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(Ke,lt,Pe)),Ti=Ke.set(D.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Ke,lt,bt)),ii=Ke.set(D.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Ke.getProxy(D.MainContext.MainThreadProgress))),fi=Ke.set(D.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Ke)),Si=Ke.set(D.ExtHostContext.ExtHostTheming,new ve.ExtHostTheming(Ke)),ni=Ke.set(D.ExtHostContext.ExtHostAuthentication,new we.ExtHostAuthentication(Ke)),Pi=Ke.set(D.ExtHostContext.ExtHostTimeline,new Te.ExtHostTimeline(Ke,lt)),mi=Ke.set(D.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Ke,ut.remote,ft,Pe,Ee)),gi=Ke.set(D.ExtHostContext.ExtHostWebviewPanels,new K.ExtHostWebviewPanels(Ke,mi,ft)),Ai=Ke.set(D.ExtHostContext.ExtHostCustomEditors,new te.ExtHostCustomEditors(Ke,bt,Rt,mi,gi)),pi=Ke.set(D.ExtHostContext.ExtHostWebviewViews,new J.ExtHostWebviewViews(Ke,mi)),Vt=Ke.set(D.ExtHostContext.ExtHostTesting,new Be.ExtHostTesting(Ke,lt)),Ri=Ke.set(D.ExtHostContext.ExtHostUriOpeners,new $e.ExtHostUriOpeners(Ke));Ke.set(D.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(Ke,Et,Ye,lt));const Li=(0,Q.values)(D.ExtHostContext);Ke.assertRegistered(Li);const Oi=new ae.ExtHostBulkEdits(Ke,Ye),ri=new m.ExtHostClipboard(Ke),vi=new u.ExtHostMessageService(Ke,Pe),_i=new l.ExtHostDialogs(Ke),Ci=new p.ExtHostStatusBar(Ke,lt.converter);return C.ExtHostApiCommands.register(lt),function(ze,Ut,yi){const gt=function(){let me=!ze.isUnderDevelopment;function Se(){me||(Pe.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function We(ot){if(Array.isArray(ot))ot.forEach(We);else if(typeof ot=="string")Se();else{const St=ot;typeof St.scheme=="undefined"&&Se(),typeof St.exclusive=="boolean"&&(0,Qe.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),jt={getSession(me,Se,We){return ni.getSession(ze,me,Se,We)},async hasSession(me,Se){return(0,Qe.checkProposedApiEnabled)(ze,"authSession"),!!await ni.getSession(ze,me,Se,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(me,Se,We,ot){return ni.registerAuthenticationProvider(me,Se,We,ot)}},Ni={registerCommand(me,Se,We){return lt.registerCommand(!0,me,Se,We,void 0,ze)},registerTextEditorCommand(me,Se,We){return lt.registerCommand(!0,me,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){Pe.warn("Cannot execute "+me+" because there is no active text editor.");return}return St.edit(It=>{Se.apply(We,[St,It,...ot])}).then(It=>{It||Pe.warn("Edits from command "+me+" were not applied.")},It=>{Pe.warn("An error occurred while running command "+me,It)})},void 0,void 0,ze)},registerDiffInformationCommand:(me,Se,We)=>((0,Qe.checkProposedApiEnabled)(ze,"diffCommand"),lt.registerCommand(!0,me,async(...ot)=>{const St=Ye.activeEditor(!0);if(!St){Pe.warn("Cannot execute "+me+" because there is no active text editor.");return}const It=await kt.getDiffInformation(St.id);Se.apply(We,[It,...ot])},void 0,void 0,ze)),executeCommand(me,...Se){return lt.executeCommand(me,...Se)},getCommands(me=!1){return lt.getCommands(me)}},Ot={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Qe.checkProposedApiEnabled)(ze,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Qe.checkProposedApiEnabled)(ze,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const me=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(me)?!1:me<1e3*60*60*24},openExternal(me,Se){return Z.openUri(me,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===ut.environment.appUriScheme)return Lt.createAppUri(me);try{return await Z.asExternalUri(me,{allowTunneling:!!ut.remote.authority})}catch(Se){if((0,Fe.matchesScheme)(me,_e.Schemas.http)||(0,Fe.matchesScheme)(me,_e.Schemas.https))return me;throw Se}},get remoteName(){return(0,G.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Qe.checkProposedApiEnabled)(ze,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(Ot);const si={createTestController(me,Se,We){return Vt.createTestController(me,Se,We)},createTestObserver(){return(0,Qe.checkProposedApiEnabled)(ze,"testObserver"),Vt.createTestObserver()},runTests(me){return(0,Qe.checkProposedApiEnabled)(ze,"testObserver"),Vt.runTests(me)},get onDidChangeTestResults(){return(0,Qe.checkProposedApiEnabled)(ze,"testObserver"),Vt.onResultsChanged},get testResults(){return(0,Qe.checkProposedApiEnabled)(ze,"testObserver"),Vt.results}},oi=ut.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Fi={getExtension(me,Se){(0,Qe.isProposedApiEnabled)(ze,"extensionsAny")||(Se=!1);const We=Ut.mine.getExtensionDescription(me);if(We)return new s.Extension(yt,ze.identifier,We,oi,!1);if(Se){const ot=Ut.all.getExtensionDescription(me);if(ot)return new s.Extension(yt,ze.identifier,ot,oi,!0)}},get all(){const me=[];for(const Se of Ut.mine.getAllExtensionDescriptions())me.push(new s.Extension(yt,ze.identifier,Se,oi,!1));return me},get allAcrossExtensionHosts(){(0,Qe.checkProposedApiEnabled)(ze,"extensionsAny");const me=new Qe.ExtensionIdentifierSet(Ut.mine.getAllExtensionDescriptions().map(We=>We.identifier)),Se=[];for(const We of Ut.all.getAllExtensionDescriptions()){const ot=!me.has(We.identifier);Se.push(new s.Extension(yt,ze.identifier,We,oi,ot))}return Se},get onDidChange(){return(0,Qe.isProposedApiEnabled)(ze,"extensionsAny")?_.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},Mi={createDiagnosticCollection(me){return Xt.createDiagnosticCollection(ze.identifier,me)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:me=>Xt.getDiagnostics(me),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(me,Se){return ei.changeLanguage(me.uri,Se)},match(me,Se){return(0,L.score)(H.LanguageSelector.from(me),Se.uri,Se.languageId,!0,Se.notebook?.notebookType)},registerCodeActionsProvider(me,Se,We){return ht.registerCodeActionProvider(ze,gt(me),Se,We)},registerCodeLensProvider(me,Se){return ht.registerCodeLensProvider(ze,gt(me),Se)},registerDefinitionProvider(me,Se){return ht.registerDefinitionProvider(ze,gt(me),Se)},registerDeclarationProvider(me,Se){return ht.registerDeclarationProvider(ze,gt(me),Se)},registerImplementationProvider(me,Se){return ht.registerImplementationProvider(ze,gt(me),Se)},registerTypeDefinitionProvider(me,Se){return ht.registerTypeDefinitionProvider(ze,gt(me),Se)},registerHoverProvider(me,Se){return ht.registerHoverProvider(ze,gt(me),Se,ze.identifier)},registerEvaluatableExpressionProvider(me,Se){return ht.registerEvaluatableExpressionProvider(ze,gt(me),Se,ze.identifier)},registerInlineValuesProvider(me,Se){return ht.registerInlineValuesProvider(ze,gt(me),Se,ze.identifier)},registerDocumentHighlightProvider(me,Se){return ht.registerDocumentHighlightProvider(ze,gt(me),Se)},registerLinkedEditingRangeProvider(me,Se){return ht.registerLinkedEditingRangeProvider(ze,gt(me),Se)},registerReferenceProvider(me,Se){return ht.registerReferenceProvider(ze,gt(me),Se)},registerRenameProvider(me,Se){return ht.registerRenameProvider(ze,gt(me),Se)},registerDocumentSymbolProvider(me,Se,We){return ht.registerDocumentSymbolProvider(ze,gt(me),Se,We)},registerWorkspaceSymbolProvider(me){return ht.registerWorkspaceSymbolProvider(ze,me)},registerDocumentFormattingEditProvider(me,Se){return ht.registerDocumentFormattingEditProvider(ze,gt(me),Se)},registerDocumentRangeFormattingEditProvider(me,Se){return ht.registerDocumentRangeFormattingEditProvider(ze,gt(me),Se)},registerOnTypeFormattingEditProvider(me,Se,We,...ot){return ht.registerOnTypeFormattingEditProvider(ze,gt(me),Se,[We].concat(ot))},registerDocumentSemanticTokensProvider(me,Se,We){return ht.registerDocumentSemanticTokensProvider(ze,gt(me),Se,We)},registerDocumentRangeSemanticTokensProvider(me,Se,We){return ht.registerDocumentRangeSemanticTokensProvider(ze,gt(me),Se,We)},registerSignatureHelpProvider(me,Se,We,...ot){return typeof We=="object"?ht.registerSignatureHelpProvider(ze,gt(me),Se,We):ht.registerSignatureHelpProvider(ze,gt(me),Se,typeof We=="undefined"?[]:[We,...ot])},registerCompletionItemProvider(me,Se,...We){return ht.registerCompletionItemProvider(ze,gt(me),Se,We)},registerInlineCompletionItemProvider(me,Se){return(0,Qe.checkProposedApiEnabled)(ze,"inlineCompletions"),ht.registerInlineCompletionsProvider(ze,gt(me),Se)},registerInlineCompletionItemProviderNew(me,Se){if((0,Qe.checkProposedApiEnabled)(ze,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Qe.isProposedApiEnabled)(ze,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ht.registerInlineCompletionsProviderNew(ze,gt(me),Se)},registerDocumentLinkProvider(me,Se){return ht.registerDocumentLinkProvider(ze,gt(me),Se)},registerColorProvider(me,Se){return ht.registerColorProvider(ze,gt(me),Se)},registerFoldingRangeProvider(me,Se){return ht.registerFoldingRangeProvider(ze,gt(me),Se)},registerSelectionRangeProvider(me,Se){return ht.registerSelectionRangeProvider(ze,me,Se)},registerCallHierarchyProvider(me,Se){return ht.registerCallHierarchyProvider(ze,me,Se)},registerTypeHierarchyProvider(me,Se){return ht.registerTypeHierarchyProvider(ze,me,Se)},setLanguageConfiguration:(me,Se)=>ht.setLanguageConfiguration(ze,me,Se),getTokenInformationAtPosition(me,Se){return(0,Qe.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(me,Se)},registerInlayHintsProvider(me,Se){return ht.registerInlayHintsProvider(ze,me,Se)},createLanguageStatusItem(me,Se){return ei.createLanguageStatusItem(ze,me,Se)},registerDocumentOnDropProvider(me,Se){return(0,Qe.checkProposedApiEnabled)(ze,"textEditorDrop"),ht.registerDocumentOnDropProvider(ze,me,Se)}},Ui={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(me,Se,We){const ot=await(k.URI.isUri(me)?Promise.resolve(Di.openTextDocument(me)):Promise.resolve(me));return kt.showTextDocument(ot,Se,We)},createTextEditorDecorationType(me){return kt.createTextEditorDecorationType(ze,me)},onDidChangeActiveTextEditor(me,Se,We){return kt.onDidChangeActiveTextEditor(me,Se,We)},onDidChangeVisibleTextEditors(me,Se,We){return kt.onDidChangeVisibleTextEditors(me,Se,We)},onDidChangeTextEditorSelection(me,Se,We){return kt.onDidChangeTextEditorSelection(me,Se,We)},onDidChangeTextEditorOptions(me,Se,We){return kt.onDidChangeTextEditorOptions(me,Se,We)},onDidChangeTextEditorVisibleRanges(me,Se,We){return kt.onDidChangeTextEditorVisibleRanges(me,Se,We)},onDidChangeTextEditorViewColumn(me,Se,We){return kt.onDidChangeTextEditorViewColumn(me,Se,We)},onDidCloseTerminal(me,Se,We){return dt.onDidCloseTerminal(me,Se,We)},onDidOpenTerminal(me,Se,We){return dt.onDidOpenTerminal(me,Se,We)},onDidChangeActiveTerminal(me,Se,We){return dt.onDidChangeActiveTerminal(me,Se,We)},onDidChangeTerminalDimensions(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"terminalDimensions"),dt.onDidChangeTerminalDimensions(me,Se,We)},onDidChangeTerminalState(me,Se,We){return dt.onDidChangeTerminalState(me,Se,We)},onDidWriteTerminalData(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(me,Se,We)},get state(){return Z.state},onDidChangeWindowState(me,Se,We){return Z.onDidChangeWindowState(me,Se,We)},showInformationMessage(me,...Se){return vi.showMessage(ze,A.default.Info,me,Se[0],Se.slice(1))},showWarningMessage(me,...Se){return vi.showMessage(ze,A.default.Warning,me,Se[0],Se.slice(1))},showErrorMessage(me,...Se){return vi.showMessage(ze,A.default.Error,me,Se[0],Se.slice(1))},showQuickPick(me,Se,We){return xt.showQuickPick(me,Se,We)},showWorkspaceFolderPick(me){return xt.showWorkspaceFolderPick(me)},showInputBox(me,Se){return me?.validateInput2&&(0,Qe.checkProposedApiEnabled)(ze,"inputBoxSeverity"),xt.showInput(me,Se)},showOpenDialog(me){return _i.showOpenDialog(me)},showSaveDialog(me){return _i.showSaveDialog(me)},createStatusBarItem(me,Se,We){let ot,St,It;return typeof me=="string"?(ot=me,St=Se,It=We):(St=me,It=Se),Ci.createStatusBarEntry(ze,ot,St,It)},setStatusBarMessage(me,Se){return Ci.setStatusBarMessage(me,Se)},withScmProgress(me){return Ee.report("window.withScmProgress",ze,"Use 'withProgress' instead."),ii.withProgress(ze,{location:F.ProgressLocation.SourceControl},(Se,We)=>me({report(ot){}}))},withProgress(me,Se){return ii.withProgress(ze,me,Se)},createOutputChannel(me,Se){return wt.createOutputChannel(me,Se,ze)},createWebviewPanel(me,Se,We,ot){return gi.createWebviewPanel(ze,me,Se,We,ot)},createWebviewTextEditorInset(me,Se,We,ot){return(0,Qe.checkProposedApiEnabled)(ze,"editorInsets"),di.createWebviewEditorInset(me,Se,We,ot,ze)},createTerminal(me,Se,We){return typeof me=="object"?"pty"in me?dt.createExtensionTerminal(me):dt.createTerminalFromOptions(me):dt.createTerminal(me,Se,We)},registerTerminalLinkProvider(me){return dt.registerLinkProvider(me)},registerTerminalProfileProvider(me,Se){return dt.registerProfileProvider(ze,me,Se)},registerTreeDataProvider(me,Se){return Zt.registerTreeDataProvider(me,Se,ze)},createTreeView(me,Se){return Zt.createTreeView(me,Se,ze)},registerWebviewPanelSerializer:(me,Se)=>gi.registerWebviewPanelSerializer(ze,me,Se),registerCustomEditorProvider:(me,Se,We={})=>Ai.registerCustomEditorProvider(ze,me,Se,We),registerFileDecorationProvider(me){return st.registerFileDecorationProvider(me,ze.identifier)},registerUriHandler(me){return Lt.registerUriHandler(ze.identifier,me)},createQuickPick(){return xt.createQuickPick(ze)},createInputBox(){return xt.createInputBox(ze)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(me,Se,We){return Si.onDidChangeActiveColorTheme(me,Se,We)},registerWebviewViewProvider(me,Se,We){return pi.registerWebviewViewProvider(ze,me,Se,We?.webviewOptions)},get activeNotebookEditor(){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(me,Se,We)},get visibleNotebookEditors(){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(me,Se,We)},onDidChangeNotebookEditorVisibleRanges(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(me,Se,We)},showNotebookDocument(me,Se){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.showNotebookDocument(me,Se)},registerExternalUriOpener(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"externalUriOpener"),Ri.registerExternalUriOpener(ze.identifier,me,Se,We)},get tabGroups(){return Ve.tabGroups},getInlineCompletionItemController(me){return(0,Qe.checkProposedApiEnabled)(ze,"inlineCompletions"),a.InlineCompletionController.get(me)}},Di={get rootPath(){return Ee.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(me){throw i.readonly()},getWorkspaceFolder(me){return ft.getWorkspaceFolder(me)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(me){throw i.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(me){throw i.readonly()},updateWorkspaceFolders:(me,Se,...We)=>ft.updateWorkspaceFolders(ze,me,Se||0,...We),onDidChangeWorkspaceFolders:function(me,Se,We){return ft.onDidChangeWorkspace(me,Se,We)},asRelativePath:(me,Se)=>ft.getRelativePath(me,Se),findFiles:(me,Se,We,ot)=>ft.findFiles(me,Se,We,ze.identifier,ot),findTextInFiles:(me,Se,We,ot)=>{(0,Qe.checkProposedApiEnabled)(ze,"findTextInFiles");let St,It;return typeof Se=="object"?(St=Se,It=We):(St={},It=Se,ot=We),ft.findTextInFiles(me,St||{},It,ze.identifier,ot)},saveAll:me=>ft.saveAll(me),applyEdit(me){return Oi.applyWorkspaceEdit(me)},createFileSystemWatcher:(me,Se,We,ot)=>Bt.createFileSystemWatcher(ft,ze,me,Se,We,ot),get textDocuments(){return bt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw i.readonly()},openTextDocument(me){let Se;const We=me;if(typeof me=="string")Se=Promise.resolve(k.URI.file(me));else if(k.URI.isUri(me))Se=Promise.resolve(me);else if(!We||typeof We=="object")Se=bt.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ot=>bt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(me,Se,We)=>bt.onDidAddDocument(me,Se,We),onDidCloseTextDocument:(me,Se,We)=>bt.onDidRemoveDocument(me,Se,We),onDidChangeTextDocument:(me,Se,We)=>bt.onDidChangeDocument(me,Se,We),onDidSaveTextDocument:(me,Se,We)=>bt.onDidSaveDocument(me,Se,We),onWillSaveTextDocument:(me,Se,We)=>Qt.getOnWillSaveTextDocumentEvent(ze)(me,Se,We),get notebookDocuments(){return Et.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,Se){let We;if(k.URI.isUri(me))We=me,await Et.openNotebookDocument(me);else if(typeof me=="string")We=k.URI.revive(await Et.createNotebookDocument({viewType:me,content:Se}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(me,Se,We){return $t.onDidSaveNotebookDocument(me,Se,We)},onDidChangeNotebookDocument(me,Se,We){return $t.onDidChangeNotebookDocument(me,Se,We)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(me,Se,We,ot){return Et.registerNotebookSerializer(ze,me,Se,We,(0,Qe.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(me,Se,We,ot)=>((0,Qe.checkProposedApiEnabled)(ze,"notebookContentProvider"),Et.registerNotebookContentProvider(ze,me,Se,We,(0,Qe.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(me,Se,We)=>yi.onDidChangeConfiguration(me,Se,We),getConfiguration(me,Se){return Se=arguments.length===1?void 0:Se,yi.getConfiguration(me,Se,ze)},registerTextDocumentContentProvider(me,Se){return Kt.registerTextDocumentContentProvider(me,Se)},registerTaskProvider:(me,Se)=>(Ee.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(ze,me,Se)),registerFileSystemProvider(me,Se,We){return(0,Ze.combinedDisposable)(hi.registerFileSystemProvider(ze,me,Se,We),Nt.addFileSystemProvider(me,Se))},get fs(){return Nt.value},registerFileSearchProvider:(me,Se)=>((0,Qe.checkProposedApiEnabled)(ze,"fileSearchProvider"),_t.registerFileSearchProvider(me,Se)),registerTextSearchProvider:(me,Se)=>((0,Qe.checkProposedApiEnabled)(ze,"textSearchProvider"),_t.registerTextSearchProvider(me,Se)),registerRemoteAuthorityResolver:(me,Se)=>((0,Qe.checkProposedApiEnabled)(ze,"resolvers"),yt.registerRemoteAuthorityResolver(me,Se)),registerResourceLabelFormatter:me=>((0,Qe.checkProposedApiEnabled)(ze,"resolvers"),fi.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,Se,We)=>Bt.onDidCreateFile(me,Se,We),onDidDeleteFiles:(me,Se,We)=>Bt.onDidDeleteFile(me,Se,We),onDidRenameFiles:(me,Se,We)=>Bt.onDidRenameFile(me,Se,We),onWillCreateFiles:(me,Se,We)=>Bt.getOnWillCreateFileEvent(ze)(me,Se,We),onWillDeleteFiles:(me,Se,We)=>Bt.getOnWillDeleteFileEvent(ze)(me,Se,We),onWillRenameFiles:(me,Se,We)=>Bt.getOnWillRenameFileEvent(ze)(me,Se,We),openTunnel:me=>((0,Qe.checkProposedApiEnabled)(ze,"resolvers"),Le.openTunnel(ze,me).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Qe.checkProposedApiEnabled)(ze,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(me,Se,We)=>((0,Qe.checkProposedApiEnabled)(ze,"resolvers"),Le.onDidChangeTunnels(me,Se,We)),registerPortAttributesProvider:(me,Se)=>((0,Qe.checkProposedApiEnabled)(ze,"portsAttributes"),Le.registerPortsAttributesProvider(me,Se)),registerTimelineProvider:(me,Se)=>((0,Qe.checkProposedApiEnabled)(ze,"timeline"),Pi.registerTimelineProvider(me,Se,ze.identifier,lt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:me=>((0,Qe.checkProposedApiEnabled)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,Se,We)=>ft.onDidGrantWorkspaceTrust(me,Se,We)},Bi={get inputBox(){return Ee.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ti.getLastInputBox(ze)},createSourceControl(me,Se,We){return ti.createSourceControl(ze,me,Se,We)}},Wi={createCommentController(me,Se){return Ti.createCommentController(ze,me,Se)}},wi={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(me,Se,We){return vt.onDidStartDebugSession(me,Se,We)},onDidTerminateDebugSession(me,Se,We){return vt.onDidTerminateDebugSession(me,Se,We)},onDidChangeActiveDebugSession(me,Se,We){return vt.onDidChangeActiveDebugSession(me,Se,We)},onDidReceiveDebugSessionCustomEvent(me,Se,We){return vt.onDidReceiveDebugSessionCustomEvent(me,Se,We)},onDidChangeBreakpoints(me,Se,We){return vt.onDidChangeBreakpoints(me,Se,We)},registerDebugConfigurationProvider(me,Se,We){return vt.registerDebugConfigurationProvider(me,Se,We||rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,Se){return vt.registerDebugAdapterDescriptorFactory(ze,me,Se)},registerDebugAdapterTrackerFactory(me,Se){return vt.registerDebugAdapterTrackerFactory(me,Se)},startDebugging(me,Se,We){return!We||typeof We=="object"&&"configuration"in We?vt.startDebugging(me,Se,{parentSession:We}):vt.startDebugging(me,Se,We||{})},stopDebugging(me){return vt.stopDebugging(me)},addBreakpoints(me){return vt.addBreakpoints(me)},removeBreakpoints(me){return vt.removeBreakpoints(me)},asDebugSourceUri(me,Se){return vt.asDebugSourceUri(me,Se)}},zi={registerTaskProvider:(me,Se)=>mt.registerTaskProvider(ze,me,Se),fetchTasks:me=>mt.fetchTasks(me),executeTask:me=>mt.executeTask(ze,me),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(me,Se,We)=>mt.onDidStartTask(me,Se,We),onDidEndTask:(me,Se,We)=>mt.onDidEndTask(me,Se,We),onDidStartTaskProcess:(me,Se,We)=>mt.onDidStartTaskProcess(me,Se,We),onDidEndTaskProcess:(me,Se,We)=>mt.onDidEndTaskProcess(me,Se,We)},Hi={createNotebookController(me,Se,We,ot,St){return Jt.createNotebookController(ze,me,Se,We,ot,(0,Qe.isProposedApiEnabled)(ze,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(me,Se)=>Et.registerNotebookCellStatusBarItemProvider(ze,me,Se),createNotebookEditorDecorationType(me){return(0,Qe.checkProposedApiEnabled)(ze,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(me)},createRendererMessaging(me){return ui.createRendererMessaging(ze,me)},onDidChangeNotebookCellExecutionState(me,Se,We){return(0,Qe.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(me,Se,We)},createNotebookProxyController(me,Se,We,ot){return(0,Qe.checkProposedApiEnabled)(ze,"notebookProxyController"),ci.createNotebookProxyController(ze,me,Se,We,ot)}};return{version:ut.version,authentication:jt,commands:Ni,comments:Wi,debug:wi,env:Ot,extensions:Fi,languages:Mi,notebooks:Hi,scm:Bi,tasks:zi,tests:si,window:Ui,workspace:Di,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:D.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:_.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestions,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:P.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SnippetTextEdit:F.SnippetTextEdit,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:T.UIKind,Uri:k.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:be.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=pt}),define(ye[286],De([0,1,287,298,299,2,300]),function(Y,e,d,i,_,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(I,D,T,C,m,v){const g=v.environment.useHostProxy,b=typeof g=="boolean"?g:!v.remote.isRemote,f=(0,k.createProxyResolver)({resolveProxy:h=>I.resolveProxy(h),getHttpProxySetting:()=>D.getConfiguration("http").get("proxy"),log:(h,o,...E)=>{switch(h){case k.LogLevel.Trace:C.trace(o,...E);break;case k.LogLevel.Debug:C.debug(o,...E);break;case k.LogLevel.Info:C.info(o,...E);break;case k.LogLevel.Warning:C.warn(o,...E);break;case k.LogLevel.Error:C.error(o,...E);break;case k.LogLevel.Critical:C.critical(o,...E);break;case k.LogLevel.Off:break;default:r(h,o,E);break}function r(s,n,...t){C.error("Unknown log level",s),C.error(n,...t)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),l=w(D,f);return L(T,l)}e.connectProxyResolver=y;function w(I,D){const T={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(m=>{T.config=I.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(m=>{C.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},d,(0,k.createHttpPatch)(d,D,{config:"off"},C,!0)),on:Object.assign({},d,(0,k.createHttpPatch)(d,D,{config:"on"},C,!0)),override:Object.assign({},d,(0,k.createHttpPatch)(d,D,{config:"override"},C,!0)),onRequest:Object.assign({},d,(0,k.createHttpPatch)(d,D,T,C,!0)),default:Object.assign(d,(0,k.createHttpPatch)(d,D,T,C,!1))},https:{off:Object.assign({},i,(0,k.createHttpPatch)(i,D,{config:"off"},C,!0)),on:Object.assign({},i,(0,k.createHttpPatch)(i,D,{config:"on"},C,!0)),override:Object.assign({},i,(0,k.createHttpPatch)(i,D,{config:"override"},C,!0)),onRequest:Object.assign({},i,(0,k.createHttpPatch)(i,D,T,C,!0)),default:Object.assign(i,(0,k.createHttpPatch)(i,D,T,C,!1))},tls:Object.assign(_,(0,k.createTlsPatch)(_))}}const P=new Map;function L(I,D){return I.getExtensionPathIndex().then(T=>{const C=Y.__$__nodeRequire("module"),m=C._load;C._load=function(g,b,f){if(g==="tls")return D.tls;if(g!=="http"&&g!=="https")return m.apply(this,arguments);const l=D[g],h=T.findSubstr(A.URI.file(b.filename));let o=P.get(h);if(o||P.set(h,o={}),!o[g]){let E=l.default;o[g]={...E}}return o[g]}})}}),define(ye[142],De([0,1,41,301,104,16,57,35,9,8,2,31,71,302,280,91]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(u){this.outputChannel=u}provideTextSearchResults(u,S,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((N,p)=>{O.onCancellationRequested(()=>x());const M=E(u,S),U=S.folder.fsPath,z=M.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${v} ${z}
 - cwd: ${U}`);let re=d.spawn(v,M,{cwd:U});re.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),p((0,I.serializeSearchError)(new I.SearchError(fe&&fe.message,I.SearchErrorCode.rgProcessError)))});let H=!1;const F=new l(S.maxResults,U,S.previewOptions);F.on("result",fe=>{H=!0,ne="",R.report(fe)});let j=!1;const x=()=>{j=!0,re&&re.kill(),F&&F.cancel()};let V=!1;F.on("hitLimit",()=>{V=!0,x()});let ne="";re.stdout.on("data",fe=>{F.handleData(fe),H||(ne+=fe)});let Q=!1;re.stdout.once("data",()=>Q=!0);let he="";re.stderr.on("data",fe=>{const G=fe.toString();this.outputChannel.appendLine(G),he+=G}),re.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(H?"Got result from parser":"No result from parser"),ne&&this.outputChannel.appendLine(`Got data without result: ${ne}`),this.outputChannel.appendLine(""),j)N({limitHit:V});else{F.flush(),re=null;let fe;he&&!Q&&(fe=b(he))?p((0,I.serializeSearchError)(new I.SearchError(fe.message,fe.code))):N({limitHit:V})}})})}}e.RipgrepTextSearchEngine=g;function b(c){const u=c.split(`
`),S=u[0].trim();if(u.some(O=>O.startsWith("regex parse error")))return new I.SearchError(f(u),I.SearchErrorCode.regexParseError);const R=S.match(/grep config error: unknown encoding: (.*)/);if(R)return new I.SearchError(`Unknown encoding: ${R[1]}`,I.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new I.SearchError(S.charAt(0).toUpperCase()+S.substr(1),I.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new I.SearchError(S.charAt(0).toUpperCase()+S.substr(1),I.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(S,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function f(c){const u=["Regex parse error"],S=c.filter(R=>R.startsWith("PCRE2:"));if(S.length>=1){const R=S[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];u.push(":"+O)}}return u.join("")}e.buildRegexParseError=f;class l extends i.EventEmitter{constructor(u,S,R){super();this.maxResults=u,this.rootFolder=S,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new _.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,S){return super.on(u,S),this}handleData(u){if(this.isDone)return;const S=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(S)}handleDecodedData(u){let S=u.indexOf(`
`);const R=this.remainder+u;if(S>=0)S+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;S>=0;)this.handleLine(R.substring(O,S).trim()),O=S+1,S=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(u){if(this.isDone||!u)return;let S;try{S=JSON.parse(u)}catch{throw new Error(`malformed line from rg: ${u}`)}if(S.type==="match"){const R=h(S.data.path),O=L.URI.file(w.join(this.rootFolder,R)),N=this.createTextSearchMatch(S.data,O);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const R=h(S.data.path),O=L.URI.file(w.join(this.rootFolder,R));this.createTextSearchContext(S.data,O).forEach(p=>this.onResult(p))}}createTextSearchMatch(u,S){const R=u.line_number-1,O=h(u.lines),N=Buffer.from(O);let p=0,M=0,U=R;u.submatches.length===0&&u.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const z=(0,A.coalesce)(u.submatches.map((re,H)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=h(re.match),j=N.slice(p,re.start).toString().length,x=M+j,V=o(F),ne=U,Q=V.numLines+ne,he=V.numLines>0?V.lastLineLength:V.lastLineLength+x;return p=re.end,M=he,U=Q,new D.Range(ne,x,Q,he)}));return(0,m.createTextSearchResult)(S,O,z,this.previewOptions)}createTextSearchContext(u,S){const R=h(u.lines),O=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((N,p)=>({text:N,uri:S,lineNumber:O+p}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=l;function h(c){return c.bytes?Buffer.from(c.bytes,"base64").toString():c.text}function o(c){const u=/\n/g;let S=0,R=-1,O;for(;O=u.exec(c);)S++,R=O.index;const N=R>=0?c.length-R-1:c.length;return{numLines:S,lastLineLength:N}}function E(c,u){const S=["--hidden"];S.push(c.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,k.groupBy)(u.includes,p=>p.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const p=new Set;O.forEach(M=>{p.add(M)}),S.push("-g","!*"),p.forEach(M=>{r(M).map(m.anchorGlob).forEach(U=>{S.push("-g",U)})})}R&&R.length&&R.forEach(p=>{S.push("-g",p)}),u.excludes.map(m.anchorGlob).forEach(p=>S.push("-g",`!${p}`)),u.maxFileSize&&S.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?u.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),u.followSymlinks&&S.push("--follow"),u.encoding&&u.encoding!=="utf8"&&S.push("--encoding",u.encoding),c.pattern==="--"&&(c.isRegExp=!0,c.pattern="\\-\\-"),c.isMultiline&&!c.isRegExp&&(c.pattern=(0,P.escapeRegExpCharacters)(c.pattern),c.isRegExp=!0),u.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),c.isRegExp&&(c.pattern=s(c.pattern),S.push("--engine","auto"));let N;if(c.isWordMatch){const M=(0,P.createRegExp)(c.pattern,!!c.isRegExp,{wholeWord:c.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",M)}else if(c.isRegExp){let p=t(c.pattern);p=a(p),S.push("--regexp",p)}else N=c.pattern,S.push("--fixed-strings");return S.push("--no-config"),u.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),c.isMultiline&&S.push("--multiline"),u.beforeContext&&S.push("--before-context",u.beforeContext+""),u.afterContext&&S.push("--after-context",u.afterContext+""),S.push("--"),N&&S.push(N),S.push("."),S}function r(c){const u=(0,y.splitGlobAware)(c,"/");return u.map((S,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function s(c){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;c.match(u);)c=c.replace(u,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;c.match(S);)c=c.replace(S,"$1\\x{$2}");return c}e.unicodeEscapesToPCRE2=s;const n=c=>c.type==="Assertion"&&c.kind==="lookbehind";function t(c){let u;try{u=new T.RegExpParser().parsePattern(c)}catch{return c}let S="",R=0;const O=(M,U,z)=>{S+=c.slice(R,M)+z,R=U},N=[];return new T.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const U=N[0];if(!U)O(M.start,M.end,"\\r?\\n");else if(!N.some(n))if(U.type==="CharacterClass")if(U.negate){const z=c.slice(U.start+2,M.start)+c.slice(M.end,U.end-1);U.parent?.type==="Quantifier"?O(U.start,U.end,z?`[^${z}]`:"."):O(U.start,U.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=c.slice(U.start+1,M.start)+c.slice(M.end,U.end-1);O(U.start,U.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else U.type==="Quantifier"&&O(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){N.unshift(M)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(M){N.unshift(M)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(M){N.unshift(M)},onCharacterClassLeave(){N.shift()},onAssertionEnter(M){n(M)&&N.push(M)},onAssertionLeave(M){N[0]===M&&N.shift()}}).visit(u),S+=c.slice(R),S}e.fixRegexNewline=t;function a(c){return c.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(ye[288],De([0,1,21,142,118,10]),function(Y,e,d,i,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class k{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,L,I,D){const T=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===A.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:A.Schemas.file})},m=new _.Progress(v=>I.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(D,v=>T.provideTextSearchResults(P,C,m,v))}else return this.withToken(D,C=>T.provideTextSearchResults(P,L,I,C))}async withToken(P,L){const I=y(P);this.inProgress.add(I);const D=await L(I.token);return this.inProgress.delete(I),D}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=k;function y(w){const P=new d.CancellationTokenSource;return w.onCancellationRequested(()=>P.cancel()),P}}),define(ye[289],De([0,1,29,142,141]),function(Y,e,d,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(w){this.query=w}search(w,P,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(T){L({message:T})}},D=new _.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(I),d);return new Promise((T,C)=>D.search(m=>{P(m.map(k))},w).then(m=>T({limitHit:m.limitHit,type:"success",stats:m.stats}),C))}}e.TextSearchEngineAdapter=A;function k(y){return{path:y.resource&&y.resource.fsPath,results:y.results,numMatches:(y.results||[]).reduce((w,P)=>{if(P.ranges){const L=P;return w+(Array.isArray(L.ranges)?L.ranges.length:1)}else return w+1},0)}}}),define(ye[290],De([0,1,16,17,11,3,100,9,48,2,42,31,281,289]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(l="searchProcess"){this.processType=l,this.caches=Object.create(null)}fileSearch(l){let h;const o=g(l),E=new A.Emitter({onFirstListenerDidAdd:()=>{h=(0,i.createCancelablePromise)(r=>this.doFileSearchWithEngine(D.Engine,o,s=>E.fire(s),r)),h.then(r=>E.fire(r),r=>E.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return E.event}textSearch(l){let h;const o=g(l),E=new A.Emitter({onFirstListenerDidAdd:()=>{h=(0,i.createCancelablePromise)(r=>this.ripgrepTextSearch(o,s=>E.fire(s),r)),h.then(r=>E.fire(r),r=>E.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return E.event}ripgrepTextSearch(l,h,o){return l.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(l).search(o,h,h)}doFileSearch(l,h,o){return this.doFileSearchWithEngine(D.Engine,l,h,o)}doFileSearchWithEngine(l,h,o,E,r=C.BATCH_SIZE){let s=0;const n=a=>{Array.isArray(a)?(s+=a.length,o(a.map(c=>this.rawMatchToSearchItem(c)))):a.relativePath?(s++,o(this.rawMatchToSearchItem(a))):o(a)};if(h.sortByScore){let a=this.trySortedSearchFromCache(h,n,E);if(!a){const c=h.maxResults?Object.assign({},h,{maxResults:null}):h,u=new l(c);a=this.doSortedSearch(u,h,o,n,E)}return new Promise((c,u)=>{a.then(([S,R])=>{const O=R.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(O,o,r),c(S)},u)})}const t=new l(h);return this.doSearch(t,n,r,E).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(l){return{path:l.base?(0,y.join)(l.base,l.relativePath):l.relativePath}}doSortedSearch(l,h,o,E,r){const s=new A.Emitter;let n=(0,i.createCancelablePromise)(a=>{let c=[];const u=S=>{Array.isArray(S)?c=S:(E(S),s.fire(S))};return this.doSearch(l,u,-1,a).then(S=>[S,c])}),t;if(h.cacheKey){t=this.getOrCreateCache(h.cacheKey);const a={promise:n,event:s.event,resolved:!1};t.resultsToSearchCache[h.filePattern||""]=a,n.then(()=>{a.resolved=!0},c=>{delete t.resultsToSearchCache[h.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([a,c])=>{const u=t?t.scorerCache:Object.create(null),S=(typeof h.maxResults!="number"||h.maxResults>0)&&w.StopWatch.create(!1);return this.sortResults(h,c,u,r).then(R=>{const O=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:h.folderQueries.length,resultCount:R.length},messages:a.messages,limitHit:a.limitHit||typeof h.maxResults=="number"&&c.length>h.maxResults},R]})})}getOrCreateCache(l){const h=this.caches[l];return h||(this.caches[l]=new m)}trySortedSearchFromCache(l,h,o){const E=l.cacheKey&&this.caches[l.cacheKey];if(!E)return;const r=this.getResultsFromCache(E,l.filePattern||"",h,o);if(r)return r.then(([s,n,t])=>{const a=w.StopWatch.create(!1);return this.sortResults(l,n,E.scorerCache,o).then(c=>{const u=a.elapsed(),S={fromCache:!0,detailStats:t,type:this.processType,resultCount:n.length,sortingTime:u};return[{type:"success",limitHit:s.limitHit||typeof l.maxResults=="number"&&n.length>l.maxResults,stats:S},c]})})}sortResults(l,h,o,E){const r=(0,k.prepareQuery)(l.filePattern||""),s=(t,a)=>(0,k.compareItemsByFuzzyScore)(t,a,r,!0,v,o),n=typeof l.maxResults=="number"?l.maxResults:Number.MAX_VALUE;return d.topAsync(h,s,n,1e4,E)}sendProgress(l,h,o){if(o&&o>0)for(let E=0;E<l.length;E+=o)h(l.slice(E,E+o));else h(l)}getResultsFromCache(l,h,o,E){const r=w.StopWatch.create(!1),s=h.indexOf(y.sep)>=0;let n;for(const u in l.resultsToSearchCache)if(h.startsWith(u)){if(s&&u.indexOf(y.sep)<0&&u!=="")continue;const S=l.resultsToSearchCache[u];n={promise:this.preventCancellation(S.promise),event:S.event,resolved:S.resolved};break}if(!n)return null;const t=r.elapsed(),a=w.StopWatch.create(!1),c=n.event(o);return E&&E.onCancellationRequested(()=>{c.dispose()}),n.promise.then(([u,S])=>{if(E&&E.isCancellationRequested)throw(0,_.canceled)();const R=[],O=(0,k.prepareQuery)(h).normalizedLowercase;for(const N of S)!(0,I.isFilePatternMatch)(N,O)||R.push(N);return[u,R,{cacheWasResolved:n.resolved,cacheLookupTime:t,cacheFilterTime:a.elapsed(),cacheEntryCount:S.length}]})}doSearch(l,h,o,E){return new Promise((r,s)=>{let n=[];E&&E.onCancellationRequested(()=>l.cancel()),l.search(t=>{t&&(o?(n.push(t),o>0&&n.length>=o&&(h(n),n=[])):h(t))},t=>{h(t)},(t,a)=>{n.length&&h(n),t?s(t):r(a)})})}clearCache(l){return delete this.caches[l],Promise.resolve(void 0)}preventCancellation(l){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,o){return l.then(h,o)}catch(h){return this.then(void 0,h)}finally(h){return l.finally(h)}}}}e.SearchService=C,C.BATCH_SIZE=512;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(f){return(0,y.basename)(f.relativePath)}getItemDescription(f){return(0,y.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(l=>P.URI.revive(l))}}function b(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(ye[291],De([0,1,6,10,2,29,13,27,18,75,64,31,290,288,91,141]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends P.ExtHostSearch{constructor(b,f,l,h){super(b,l,h);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.vscodeUserData,new T.RipgrepSearchProvider(o)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new T.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(i.Schemas.file,new D.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,f){const l=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(b)),(0,d.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(b,f,l,h){const o=(0,P.reviveQuery)(l);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,f,o,h):super.$provideFileSearchResults(b,f,l,h)}doInternalFileSearch(b,f,l,h){const o=E=>{if((0,I.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(b,f,E.map(r=>_.URI.file(r.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,o,h)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,f){return new m.NativeTextSearchManager(b,f,void 0,"textSearchProvider")}};v=je([xe(0,w.IExtHostRpcService),xe(1,y.IExtHostInitDataService),xe(2,L.IURITransformerService),xe(3,k.ILogService)],v),e.NativeExtHostSearch=v}),define(ye[143],De([0,1,303,127,49,23,11,3,6,9,12,36,106,107,304]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(S,R=""){this.debugLabel=R,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(S,R){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,R)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const R=O=>{this.traceSocketEvent("read",O),S(A.VSBuffer.wrap(O))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(S){const R=O=>{this.traceSocketEvent("close",{hadError:O}),S({type:0,hadError:O,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(S){const R=()=>{this.traceSocketEvent("nodeEndReceived"),S()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(S){if(!this.socket.destroyed)try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,k.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,k.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=m;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var g;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(g||(g={}));class b extends w.Disposable{constructor(S,R,O,N){super();this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new f(this,R,O,N,this._onData,(p,M)=>this._write(p,M))),this._register(this._flowManager.onError(p=>{console.error(p),(0,k.onUnexpectedError)(p),this._onClose.fire({type:0,hadError:!0,error:p})})),this._incomingData=new T.ChunkStream,this._register(this.socket.onData(p=>this._acceptChunk(p))),this._register(this.socket.onClose(p=>this._onClose.fire(p)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(S,R){this.socket.traceSocketEvent(S,R)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._flowManager.writeMessage(S)}_write(S,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let O=2;S.byteLength<126?O+=0:S.byteLength<2**16?O+=2:O+=8;const N=A.VSBuffer.alloc(O);if(R?N.writeUInt8(194,0):N.writeUInt8(130,0),S.byteLength<126)N.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){N.writeUInt8(126,1);let p=1;N.writeUInt8(S.byteLength>>>8&255,++p),N.writeUInt8(S.byteLength>>>0&255,++p)}else{N.writeUInt8(127,1);let p=1;N.writeUInt8(0,++p),N.writeUInt8(0,++p),N.writeUInt8(0,++p),N.writeUInt8(0,++p),N.writeUInt8(S.byteLength>>>24&255,++p),N.writeUInt8(S.byteLength>>>16&255,++p),N.writeUInt8(S.byteLength>>>8&255,++p),N.writeUInt8(S.byteLength>>>0&255,++p)}this.socket.write(A.VSBuffer.concat([N,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),O=R.readUInt8(0),N=(O&128)>>>7,p=(O&64)>>>6,M=R.readUInt8(1),U=(M&128)>>>7,z=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(p)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),O=R.readUInt8(1),N=(O&128)>>>7;let p=O&127,M=1;p===126?p=R.readUInt8(++M)*2**8+R.readUInt8(++M):p===127&&(p=R.readUInt8(++M)*0+R.readUInt8(++M)*0+R.readUInt8(++M)*0+R.readUInt8(++M)*0+R.readUInt8(++M)*2**24+R.readUInt8(++M)*2**16+R.readUInt8(++M)*2**8+R.readUInt8(++M));let U=0;N&&(U=R.readUInt8(++M)*2**24+R.readUInt8(++M)*2**16+R.readUInt8(++M)*2**8+R.readUInt8(++M)),this._state.state=3,this._state.readLen=p,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),o(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class f extends w.Disposable{constructor(S,R,O,N,p,M){super();this._tracer=S,this._onData=p,this._writeFn=M,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new l(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new h(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(S){this._writeQueue.push(S),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const S=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,S);this._writeFn(R,!0)}else this._writeFn(S,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(S,R){return new Promise((O,N)=>{S.write(R),S.flush(p=>O(p))})}acceptFrame(S,R,O){this._readQueue.push({data:S,isCompressed:R,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const S=this._readQueue.shift();if(this._zlibInflateStream&&S.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,S.data,S.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(S.data)}this._isProcessingReadQueue=!1}}_inflateFrame(S,R,O){return new Promise((N,p)=>{S.write(R),O&&S.write(A.VSBuffer.fromByteArray([0,0,255,255])),S.flush(M=>N(M))})}}class l extends w.Disposable{constructor(S,R,O,N){super();this._tracer=S,this._recordInflateBytes=R,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C.createInflateRaw(N),this._zlibInflate.on("error",p=>{this._tracer.traceSocketEvent("zlibInflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibInflate.on("data",p=>{this._tracer.traceSocketEvent("zlibInflateData",p),this._pendingInflateData.push(A.VSBuffer.wrap(p))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(S){this._recordInflateBytes&&this._recordedInflateBytes.push(S.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",S),this._zlibInflate.write(S.buffer)}flush(S){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,S(R)})}}class h extends w.Disposable{constructor(S,R){super();this._tracer=S,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(S){this._tracer.traceSocketEvent("zlibDeflateWrite",S.buffer),this._zlibDeflate.write(S.buffer)}flush(S){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),S(R)})}}function o(u,S){if(S===0)return;let R=u.byteLength>>>2;for(let z=0;z<R;z++){const re=u.readUInt32BE(z*4);u.writeUInt32BE(re^S,z*4)}let O=R*4,N=u.byteLength-O;const p=S>>>24&255,M=S>>>16&255,U=S>>>8&255;N>=1&&u.writeUInt8(u.readUInt8(O)^p,O),N>=2&&u.writeUInt8(u.readUInt8(O+1)^M,O+1),N>=3&&u.writeUInt8(u.readUInt8(O+2)^U,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function r(){const u=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):S=(0,P.join)((0,_.tmpdir)(),`vscode-ipc-${u}.sock`),n(S),S}e.createRandomIPCHandle=r;function s(u,S,R){const O=(0,d.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${R}-${S}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${R}-${S}.sock`):N=(0,P.join)(u,`${R}-${S}.sock`),n(N),N}e.createStaticIPCHandle=s;function n(u){const S=E[L.platform];typeof S=="number"&&u.length>=S&&console.warn(`WARNING: IPC handle "${u}" is longer than ${S} chars, try a shorter --user-data-dir`)}class t extends D.IPCServer{constructor(S){super(t.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const R=y.Event.fromNodeEventEmitter(S,"connection");return y.Event.map(R,O=>({protocol:new T.Protocol(new m(O,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function a(u){return new Promise((S,R)=>{const O=(0,i.createServer)();O.on("error",R),O.listen(u,()=>{O.removeListener("error",R),S(new t(O))})})}e.serve=a;function c(u,S){return new Promise((R,O)=>{const N=(0,i.createConnection)(u,()=>{N.removeListener("error",O),R(T.Client.fromSocket(new m(N,`ipc-client${S}`),S))});N.once("error",O)})}e.connect=c}),define(ye[292],De([0,1,143,287,61,38,2,13,45]),function(Y,e,d,i,_,A,k,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(D,T,C){this._commands=D,this.logService=T,this._ipcHandlePath=C,this._server=i.createServer((m,v)=>this.onRequest(m,v)),this.setup().catch(m=>(T.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",D=>this.logService.error(D))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(D,T){const C=(v,g)=>{T.writeHead(v,{"content-type":"application/json"}),T.end(JSON.stringify(g||null),b=>b&&this.logService.error(b))},m=[];D.setEncoding("utf8"),D.on("data",v=>m.push(v)),D.on("end",async()=>{try{const v=JSON.parse(m.join(""));let g;switch(v.type){case"open":g=await this.open(v);break;case"openExternal":g=await this.openExternal(v);break;case"status":g=await this.getStatus(v);break;case"extensionManagement":g=await this.manageExtensions(v);break;default:C(404,`Unknown message type: ${v.type}`);break}C(200,g)}catch(v){const g=v instanceof Error?v.message:JSON.stringify(v);C(500,g),this.logService.error("Error while processing pipe request",v)}})}async open(D){const{fileURIs:T,folderURIs:C,forceNewWindow:m,diffMode:v,addMode:g,forceReuseWindow:b,gotoLineMode:f,waitMarkerFilePath:l,remoteAuthority:h}=D,o=[];if(Array.isArray(C))for(const n of C)try{o.push({folderUri:k.URI.parse(n)})}catch{}if(Array.isArray(T))for(const n of T)try{(0,w.hasWorkspaceFileExtension)(n)?o.push({workspaceUri:k.URI.parse(n)}):o.push({fileUri:k.URI.parse(n)})}catch{}const E=l?k.URI.file(l):void 0,s={forceNewWindow:m,diffMode:v,addMode:g,gotoLineMode:f,forceReuseWindow:b,preferNewWindow:!b&&!E&&!g,waitMarkerFileURI:E,remoteAuthority:h};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(D){for(const T of D.uris){const C=k.URI.parse(T),m=C.scheme==="file"?C:T;await this._commands.executeCommand("_remoteCLI.openExternal",m)}}async manageExtensions(D){const T=m=>m?.map(v=>/\.vsix$/i.test(v)?k.URI.parse(v):v),C={list:D.list,install:T(D.install),uninstall:T(D.uninstall),force:D.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",C)}async getStatus(D){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&_.existsSync(this._ipcHandlePath)&&_.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let L=class extends P{constructor(D,T){super(D,T,(0,d.createRandomIPCHandle)())}};L=je([xe(0,A.IExtHostCommands),xe(1,y.ILogService)],L),e.CLIServer=L}),define(ye[293],De([0,1,73,285,273,5,286,40,261,2,10,7,292,105]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends _.RequireInterceptor{_installInterceptor(){const g=this,b=Y.__$__nodeRequire("module"),f=b._load;b._load=function(E,r,s){return E=h(E),g._factories.has(E)?g._factories.get(E).load(E,P.URI.file((0,T.realpathSync)(r.filename)),n=>f.apply(this,[n,r,s])):f.apply(this,arguments)};const l=b._resolveLookupPaths;b._resolveLookupPaths=(o,E)=>l.call(this,h(o),E);const h=o=>{for(let E of g._alternatives){let r=E(o);if(r){o=r;break}}return o}}}class m extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const g=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(w.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(D.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(C,g,{mine:this._myRegistry,all:this._globalRegistry}).install(),d.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,k.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),d.mark("code/extHost/didInitProxyResolver");const l=process.send,h=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?l.apply(process,o):(h.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(g){return g.main}_loadCommonJSModule(g,b,f){if(b.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let l=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{g&&d.mark(`code/extHost/willLoadExtensionCode/${g.value}`),l=Y.__$__nodeRequire(b.fsPath)}catch(h){return Promise.reject(h)}finally{g&&d.mark(`code/extHost/didLoadExtensionCode/${g.value}`),f.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(g){if(!!this._initData.remote.isRemote)for(const b in g){const f=g[b];f===null?delete process.env[b]:process.env[b]=f}}}e.ExtHostExtensionService=m}),define(ye[294],De([0,1,82,264,276,275,291,293,265,74,40,75,72,39,52,69,263,262,13,277,47]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v,g,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(L.IExtHostExtensionService,y.ExtHostExtensionService),(0,d.registerSingleton)(b.ILoggerService,g.ExtHostLoggerService),(0,d.registerSingleton)(m.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,d.registerSingleton)(P.IExtHostDebugService,A.ExtHostDebugService),(0,d.registerSingleton)(I.IExtHostSearch,k.NativeExtHostSearch),(0,d.registerSingleton)(D.IExtHostTask,_.ExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,i.ExtHostTerminalService),(0,d.registerSingleton)(C.IExtHostTunnelService,w.ExtHostTunnelService),(0,d.registerSingleton)(l.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService)}),define(ye[305],De([0,1,127,306,73,11,107,143,197,134,274,23,29,105,17,113,210,278,294]),function(Y,e,d,i,_,A,k,y,w,P,L,I,D,T,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const g=i(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=Y.__$__nodeRequire("module"),n=s._load;s._load=function(t){if(t==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const b=process.exit.bind(process);function f(s){process.exit=function(n){if(s)b(n);else{const t=new Error("An extension called process.exit() and this was prevented.");console.warn(t.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let l=function(s){b()};function h(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let t=null,a=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const c=108e5,u=3e5,S=new C.ProcessTimeRunOnceScheduler(()=>l("renderer disconnected for too long (1)"),c),R=new C.ProcessTimeRunOnceScheduler(()=>l("renderer disconnected for too long (2)"),u);process.on("message",(N,p)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){p.setNoDelay(!0);const M=I.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let U;if(N.skipWebSocketFrames)U=new y.NodeSocket(p,"extHost-socket");else{const z=I.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));U=new y.WebSocketNodeSocket(new y.NodeSocket(p,"extHost-socket"),N.permessageDeflate,z,!1)}t?(S.cancel(),R.cancel(),t.beginAcceptReconnection(U,M),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(a),t=new k.PersistentProtocol(U,M),t.sendResume(),t.onDidDispose(()=>l("renderer disconnected")),s(t),t.onSocketClose(()=>{S.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;S.isScheduled()&&R.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,t)=>{const a=d.createConnection(s,()=>{a.removeListener("error",t),n(new k.PersistentProtocol(new y.NodeSocket(a,"extHost-renderer")))});a.once("error",t),a.on("close",()=>{l("renderer closed the socket")})})}}async function o(){const s=await h();return new class{constructor(){this._onMessage=new k.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{(0,P.isMessageOfType)(n,2)?(this._terminating=!0,l("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}drain(){return s.drain()}}}function E(s){return new Promise(n=>{const t=s.onMessage(a=>{t.dispose();const c=JSON.parse(a.toString()),u=c.commit,S=w.default.commit;u&&S&&u!==S&&b(55);let R=0;setInterval(function(){try{process.kill(c.parentPid,0),R=0}catch(N){N&&N.code==="EPERM"?(R++,R>=3&&l(`parent process ${c.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):l(`parent process ${c.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=Y.__$__nodeRequire("native-watchdog"),O.start(c.parentPid)}catch(N){(0,A.onUnexpectedError)(N)}s.send((0,P.createMessageOfType)(0)),n({protocol:s,initData:c})});s.send((0,P.createMessageOfType)(1))})}async function r(){const s=[];process.on("unhandledRejection",(R,O)=>{s.push(O),setTimeout(()=>{const N=s.indexOf(O);N>=0&&O.catch(p=>{s.splice(N,1),(0,A.isCancellationError)(p)||(console.warn(`rejected promise not handled within 1 second: ${p}`),p&&p.stack&&console.warn(`stack trace: ${p.stack}`),R&&(0,A.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const O=s.indexOf(R);O>=0&&s.splice(O,1)}),process.on("uncaughtException",function(R){(0,A.onUnexpectedError)(R)}),_.mark("code/extHost/willConnectToRenderer");const n=await o();_.mark("code/extHost/didConnectToRenderer");const t=await E(n);_.mark("code/extHost/didWaitForInitData");const{initData:a}=t;f(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,m.boolean)(g.skipWorkspaceStorageLock,!1);const c=new class{constructor(){this.pid=process.pid}exit(O){b(O)}exists(O){return D.Promises.exists(O)}realpath(O){return(0,T.realpath)(O)}};let u=null;a.remote.authority&&g.transformURIs&&(u=(0,v.createURITransformer)(a.remote.authority));const S=new L.ExtensionHostMain(t.protocol,a,c,u);l=R=>S.terminate(R)}e.startExtensionHostProcess=r,r().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c3511e6c69bb39013c4a4b7b9566ec1ca73fc4d5/core/vs/workbench/api/node/extensionHostProcess.js.map
