/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/shared/dataTransfer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookProxyKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],De=function(ee){for(var e=[],a=0,D=ee.length;a<D;a++)e[a]=Se[ee[a]];return e};define(Se[41],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function a(D,g){if(!D)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=a}),define(Se[54],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const a=Object.prototype.hasOwnProperty;function D(R){const v=[];for(let p in R)a.call(R,p)&&v.push(R[p]);return v}e.values=D;function g(R,v){for(let p in R)if(a.call(R,p)&&v({key:p,value:R[p]},function(){delete R[p]})===!1)return}e.forEach=g;function L(R,v){const p=Object.create(null);for(const w of R){const f=v(w);let u=p[f];u||(u=p[f]=[]),u.push(w)}return p}e.groupBy=L;function I(R){const v=Object.create(null);return R&&R.forEach((p,w)=>{v[w]=p}),v}e.fromMap=I;function k(R,v){const p=[],w=[];for(let f of R)v.has(f)||p.push(f);for(let f of v)R.has(f)||w.push(f);return{removed:p,added:w}}e.diffSets=k;function b(R,v){const p=[],w=[];for(let[f,u]of R)v.has(f)||p.push(u);for(let[f,u]of v)R.has(f)||w.push(u);return{removed:p,added:w}}e.diffMaps=b;class P{constructor(){this.map=new Map}add(v,p){let w=this.map.get(v);w||(w=new Set,this.map.set(v,w)),w.add(p)}delete(v,p){const w=this.map.get(v);!w||(w.delete(p),w.size===0&&this.map.delete(v))}forEach(v,p){const w=this.map.get(v);!w||w.forEach(p)}}e.SetMap=P}),define(Se[55],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(I){return(k,b,P)=>{let R=null,v=null;if(typeof P.value=="function"?(R="value",v=P.value):typeof P.get=="function"&&(R="get",v=P.get),!v)throw new Error("not supported");P[R]=I(v,b)}}e.createDecorator=a;function D(I,k,b){let P=null,R=null;if(typeof b.value=="function"?(P="value",R=b.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(P="get",R=b.get),!R)throw new Error("not supported");const v=`$memoize$${k}`;b[P]=function(...p){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[v]}}e.memoize=D;function g(I,k,b){return a((P,R)=>{const v=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...w){this[p]||(this[p]=b?b():void 0),clearTimeout(this[v]),k&&(this[p]=k(this[p],...w),w=[this[p]]),this[v]=setTimeout(()=>{P.apply(this,w),this[p]=b?b():void 0},I)}})}e.debounce=g;function L(I,k,b){return a((P,R)=>{const v=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,w=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...u){if(this[p]||(this[p]=b?b():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),k&&(this[p]=k(this[p],...u)),this[f])return;const h=this[w]+I;h<=Date.now()?(this[w]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0):(this[f]=!0,this[v]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0},h-Date.now()))}})}e.throttle=L}),define(Se[56],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(g){this._prefix=g,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Se[104],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var D;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var g;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(g=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function I(n,T=!1){let i=0,o=n.length,r="",t=0,s=16,m=0;function d(x){let H=0,oe=0;for(;H<x;){const G=n.charCodeAt(i);if(G>=48&&G<=57)oe=oe*16+G-48;else if(G>=65&&G<=70)oe=oe*16+G-65+10;else if(G>=97&&G<=102)oe=oe*16+G-97+10;else break;i++,H++}return H<x&&(oe=-1),oe}function C(x){i=x,r="",t=0,s=16,m=0}function O(){const x=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&P(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&P(n.charCodeAt(i)))for(i++;i<n.length&&P(n.charCodeAt(i));)i++;else return m=3,n.substring(x,i);let H=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&P(n.charCodeAt(i))){for(i++;i<n.length&&P(n.charCodeAt(i));)i++;H=i}else m=3;return n.substring(x,H)}function U(){let x="",H=i;for(;;){if(i>=o){x+=n.substring(H,i),m=2;break}const oe=n.charCodeAt(i);if(oe===34){x+=n.substring(H,i),i++;break}if(oe===92){if(x+=n.substring(H,i),i++,i>=o){m=2;break}switch(n.charCodeAt(i++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const M=d(4);M>=0?x+=String.fromCharCode(M):m=4;break}default:m=5}H=i;continue}if(oe>=0&&oe<=31)if(b(oe)){x+=n.substring(H,i),m=2;break}else m=6;i++}return x}function A(){if(r="",m=0,t=i,i>=o)return t=o,s=17;let x=n.charCodeAt(i);if(k(x)){do i++,r+=String.fromCharCode(x),x=n.charCodeAt(i);while(k(x));return s=15}if(b(x))return i++,r+=String.fromCharCode(x),x===13&&n.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch(x){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=U(),s=10;case 47:{const H=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!b(n.charCodeAt(i));)i++;return r=n.substring(H,i),s=12}if(n.charCodeAt(i+1)===42){i+=2;const oe=o-1;let G=!1;for(;i<oe;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,m=1),r=n.substring(H,i),s=13}return r+=String.fromCharCode(x),i++,s=16}case 45:if(r+=String.fromCharCode(x),i++,i===o||!P(n.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),s=11;default:for(;i<o&&E(x);)i++,x=n.charCodeAt(i);if(t!==i){switch(r=n.substring(t,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(x),i++,s=16}}function E(x){if(k(x)||b(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let x;do x=A();while(x>=12&&x<=15);return x}return{setPosition:C,getPosition:()=>i,scan:T?$:A,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>t,getTokenLength:()=>i-t,getTokenError:()=>m}}e.createScanner=I;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function b(n){return n===10||n===13||n===8232||n===8233}function P(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function v(n,T){const i=[],o=new Object;let r;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function m(d,C,O,U){t.value=d,t.offset=C,t.length=O,t.type=U,t.colonOffset=void 0,r=t}try{_(n,{onObjectBegin:(d,C)=>{if(T<=d)throw o;r=void 0,s=T>d,i.push("")},onObjectProperty:(d,C,O)=>{if(T<C||(m(d,C,O,"property"),i[i.length-1]=d,T<=C+O))throw o},onObjectEnd:(d,C)=>{if(T<=d)throw o;r=void 0,i.pop()},onArrayBegin:(d,C)=>{if(T<=d)throw o;r=void 0,i.push(0)},onArrayEnd:(d,C)=>{if(T<=d)throw o;r=void 0,i.pop()},onLiteralValue:(d,C,O)=>{if(T<C||(m(d,C,O,S(d)),T<=C+O))throw o},onSeparator:(d,C,O)=>{if(T<=C)throw o;if(d===":"&&r&&r.type==="property")r.colonOffset=C,s=!1,r=void 0;else if(d===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(d){if(d!==o)throw d}return{path:i,previousNode:r,isAtPropertyKey:s,matches:d=>{let C=0;for(let O=0;C<d.length&&O<i.length;O++)if(d[C]===i[O]||d[C]==="*")C++;else if(d[C]!=="**")return!1;return C===d.length}}}e.getLocation=v;function p(n,T=[],i=L.DEFAULT){let o=null,r=[];const t=[];function s(d){Array.isArray(r)?r.push(d):o!==null&&(r[o]=d)}return _(n,{onObjectBegin:()=>{const d={};s(d),t.push(r),r=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const d=[];s(d),t.push(r),r=d,o=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:s,onError:(d,C,O)=>{T.push({error:d,offset:C,length:O})}},i),r[0]}e.parse=p;function w(n,T=[],i=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(d){o.type==="property"&&(o.length=d-o.offset,o=o.parent)}function t(d){return o.children.push(d),d}_(n,{onObjectBegin:d=>{o=t({type:"object",offset:d,length:-1,parent:o,children:[]})},onObjectProperty:(d,C,O)=>{o=t({type:"property",offset:C,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:d,offset:C,length:O,parent:o})},onObjectEnd:(d,C)=>{o.length=d+C-o.offset,o=o.parent,r(d+C)},onArrayBegin:(d,C)=>{o=t({type:"array",offset:d,length:-1,parent:o,children:[]})},onArrayEnd:(d,C)=>{o.length=d+C-o.offset,o=o.parent,r(d+C)},onLiteralValue:(d,C,O)=>{t({type:S(d),offset:C,length:O,parent:o,value:d}),r(C+O)},onSeparator:(d,C,O)=>{o.type==="property"&&(d===":"?o.colonOffset=C:d===","&&r(C))},onError:(d,C,O)=>{T.push({error:d,offset:C,length:O})}},i);const m=o.children[0];return m&&delete m.parent,m}e.parseTree=w;function f(n,T){if(!n)return;let i=n;for(let o of T)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const t of i.children)if(Array.isArray(t.children)&&t.children[0].value===o){i=t.children[1],r=!0;break}if(!r)return}else{const r=o;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=f;function u(n){if(!n.parent||!n.parent.children)return[];const T=u(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;T.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&T.push(i)}return T}e.getNodePath=u;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const T=Object.create(null);for(let i of n.children){const o=i.children[1];o&&(T[i.children[0].value]=h(o))}return T}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=h;function c(n,T,i=!1){return T>=n.offset&&T<n.offset+n.length||i&&T===n.offset+n.length}e.contains=c;function y(n,T,i=!1){if(c(n,T,i)){const o=n.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=T;r++){const t=y(o[r],T,i);if(t)return t}return n}}e.findNodeAtOffset=y;function _(n,T,i=L.DEFAULT){const o=I(n,!1);function r(Ee){return Ee?()=>Ee(o.getTokenOffset(),o.getTokenLength()):()=>!0}function t(Ee){return Ee?we=>Ee(we,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=r(T.onObjectBegin),m=t(T.onObjectProperty),d=r(T.onObjectEnd),C=r(T.onArrayBegin),O=r(T.onArrayEnd),U=t(T.onLiteralValue),A=t(T.onSeparator),E=r(T.onComment),$=t(T.onError),x=i&&i.disallowComments,H=i&&i.allowTrailingComma;function oe(){for(;;){const Ee=o.scan();switch(o.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:x||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Ee){case 12:case 13:x?G(10):E();break;case 16:G(1);break;case 15:case 14:break;default:return Ee}}}function G(Ee,we=[],Z=[]){if($(Ee),we.length+Z.length>0){let pe=o.getToken();for(;pe!==17;){if(we.indexOf(pe)!==-1){oe();break}else if(Z.indexOf(pe)!==-1)break;pe=oe()}}}function M(Ee){const we=o.getTokenValue();return Ee?U(we):m(we),oe(),!0}function le(){switch(o.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(o.getTokenValue()),typeof Ee!="number"&&(G(2),Ee=0)}catch{G(2)}U(Ee);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return oe(),!0}function me(){return o.getToken()!==10?(G(3,[],[2,5]),!1):(M(!1),o.getToken()===6?(A(":"),oe(),te()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function ae(){s(),oe();let Ee=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||G(4,[],[]),A(","),oe(),o.getToken()===2&&H)break}else Ee&&G(6,[],[]);me()||G(4,[],[2,5]),Ee=!0}return d(),o.getToken()!==2?G(7,[2],[]):oe(),!0}function ge(){C(),oe();let Ee=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||G(4,[],[]),A(","),oe(),o.getToken()===4&&H)break}else Ee&&G(6,[],[]);te()||G(4,[],[4,5]),Ee=!0}return O(),o.getToken()!==4?G(8,[4],[]):oe(),!0}function te(){switch(o.getToken()){case 3:return ge();case 1:return ae();case 10:return M(!0);default:return le()}}return oe(),o.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):te()?(o.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=_;function l(n,T){let i=I(n),o=[],r,t=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:t!==s&&o.push(n.substring(t,s)),T!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,T)),t=i.getPosition();break}while(r!==17);return o.join("")}e.stripComments=l;function S(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Se[105],De([0]),e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Ce,_e){for(var Te=0;Te<_e.length;Te++){var se=_e[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ce,se.key,se)}}function a(Ce,_e,Te){return _e&&e(Ce.prototype,_e),Te&&e(Ce,Te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function D(Ce,_e){if(!!Ce){if(typeof Ce=="string")return g(Ce,_e);var Te=Object.prototype.toString.call(Ce).slice(8,-1);if(Te==="Object"&&Ce.constructor&&(Te=Ce.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ce);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return g(Ce,_e)}}function g(Ce,_e){(_e==null||_e>Ce.length)&&(_e=Ce.length);for(var Te=0,se=new Array(_e);Te<_e;Te++)se[Te]=Ce[Te];return se}function L(Ce,_e){var Te=typeof Symbol!="undefined"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(Te)return(Te=Te.call(Ce)).next.bind(Te);if(Array.isArray(Ce)||(Te=D(Ce))||_e&&Ce&&typeof Ce.length=="number"){Te&&(Ce=Te);var se=0;return function(){return se>=Ce.length?{done:!0}:{done:!1,value:Ce[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=I();function k(Ce){ee.defaults=Ce}var b=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(_e){return p[_e]};function f(Ce,_e){if(_e){if(b.test(Ce))return Ce.replace(P,w)}else if(R.test(Ce))return Ce.replace(v,w);return Ce}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Ce){return Ce.replace(u,function(_e,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var c=/(^|[^\[])\^/g;function y(Ce,_e){Ce=Ce.source||Ce,_e=_e||"";var Te={replace:function(ue,Q){return Q=Q.source||Q,Q=Q.replace(c,"$1"),Ce=Ce.replace(ue,Q),Te},getRegex:function(){return new RegExp(Ce,_e)}};return Te}var _=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Ce,_e,Te){if(Ce){var se;try{se=decodeURIComponent(h(Te)).replace(_,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}_e&&!l.test(Te)&&(Te=r(_e,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch{return null}return Te}var n={},T=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ce,_e){n[" "+Ce]||(T.test(Ce)?n[" "+Ce]=Ce+"/":n[" "+Ce]=d(Ce,"/",!0)),Ce=n[" "+Ce];var Te=Ce.indexOf(":")===-1;return _e.substring(0,2)==="//"?Te?_e:Ce.replace(i,"$1")+_e:_e.charAt(0)==="/"?Te?_e:Ce.replace(o,"$1")+_e:Ce+_e}var t={exec:function(){}};function s(Ce){for(var _e=1,Te,se;_e<arguments.length;_e++){Te=arguments[_e];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Ce[se]=Te[se])}return Ce}function m(Ce,_e){var Te=Ce.replace(/\|/g,function(Q,J,ce){for(var ve=!1,F=J;--F>=0&&ce[F]==="\\";)ve=!ve;return ve?"|":" |"}),se=Te.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>_e)se.splice(_e);else for(;se.length<_e;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function d(Ce,_e,Te){var se=Ce.length;if(se===0)return"";for(var ue=0;ue<se;){var Q=Ce.charAt(se-ue-1);if(Q===_e&&!Te)ue++;else if(Q!==_e&&Te)ue++;else break}return Ce.substr(0,se-ue)}function C(Ce,_e){if(Ce.indexOf(_e[1])===-1)return-1;for(var Te=Ce.length,se=0,ue=0;ue<Te;ue++)if(Ce[ue]==="\\")ue++;else if(Ce[ue]===_e[0])se++;else if(Ce[ue]===_e[1]&&(se--,se<0))return ue;return-1}function O(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(Ce,_e){if(_e<1)return"";for(var Te="";_e>1;)_e&1&&(Te+=Ce),_e>>=1,Ce+=Ce;return Te+Ce}function A(Ce,_e,Te,se){var ue=_e.href,Q=_e.title?f(_e.title):null,J=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){se.state.inLink=!0;var ce={type:"link",raw:Te,href:ue,title:Q,text:J,tokens:se.inlineTokens(J,[])};return se.state.inLink=!1,ce}else return{type:"image",raw:Te,href:ue,title:Q,text:f(J)}}function E(Ce,_e){var Te=Ce.match(/^(\s+)(?:```)/);if(Te===null)return _e;var se=Te[1];return _e.split(`
`).map(function(ue){var Q=ue.match(/^\s+/);if(Q===null)return ue;var J=Q[0];return J.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var $=function(){function Ce(Te){this.options=Te||ee.defaults}var _e=Ce.prototype;return _e.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},_e.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var Q=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Q:d(Q,`
`)}}},_e.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var Q=ue[0],J=E(Q,ue[3]||"");return{type:"code",raw:Q,lang:ue[2]?ue[2].trim():ue[2],text:J}}},_e.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var Q=ue[2].trim();if(/#$/.test(Q)){var J=d(Q,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Q=J.trim())}var ce={type:"heading",raw:ue[0],depth:ue[1].length,text:Q,tokens:[]};return this.lexer.inline(ce.text,ce.tokens),ce}},_e.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},_e.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var Q=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Q,[]),text:Q}}},_e.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var Q,J,ce,ve,F,W,V,K,z,Y,ie,Fe,Ue=ue[1].trim(),ke=Ue.length>1,Ve={type:"list",raw:"",ordered:ke,start:ke?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=ke?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=ke?Ue:"[*+-]");for(var q=new RegExp("^( {0,3}"+Ue+")((?: [^\\n]*)?(?:\\n|$))");se&&(Fe=!1,!(!(ue=q.exec(se))||this.rules.block.hr.test(se)));){if(Q=ue[0],se=se.substring(Q.length),K=ue[2].split(`
`,1)[0],z=se.split(`
`,1)[0],this.options.pedantic?(ve=2,ie=K.trimLeft()):(ve=ue[2].search(/[^ ]/),ve=ve>4?1:ve,ie=K.slice(ve),ve+=ue[1].length),W=!1,!K&&/^ *$/.test(z)&&(Q+=z+`
`,se=se.substring(z.length+1),Fe=!0),!Fe)for(var X=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])");se&&(Y=se.split(`
`,1)[0],K=Y,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!X.test(K));){if(K.search(/[^ ]/)>=ve||!K.trim())ie+=`
`+K.slice(ve);else if(!W)ie+=`
`+K;else break;!W&&!K.trim()&&(W=!0),Q+=Y+`
`,se=se.substring(Y.length+1)}Ve.loose||(V?Ve.loose=!0:/\n *\n *$/.test(Q)&&(V=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(ie),J&&(ce=J[0]!=="[ ] ",ie=ie.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:Q,task:!!J,checked:ce,loose:!1,text:ie}),Ve.raw+=Q}Ve.items[Ve.items.length-1].raw=Q.trimRight(),Ve.items[Ve.items.length-1].text=ie.trimRight(),Ve.raw=Ve.raw.trimRight();var he=Ve.items.length;for(F=0;F<he;F++){this.lexer.state.top=!1,Ve.items[F].tokens=this.lexer.blockTokens(Ve.items[F].text,[]);var Le=Ve.items[F].tokens.filter(function(Xe){return Xe.type==="space"}),xe=Le.every(function(Xe){for(var Je=Xe.raw.split(""),rt=0,Ye=L(Je),Ze;!(Ze=Ye()).done;){var qe=Ze.value;if(qe===`
`&&(rt+=1),rt>1)return!0}return!1});!Ve.loose&&Le.length&&xe&&(Ve.loose=!0,Ve.items[F].loose=!0)}return Ve}},_e.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var Q={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(Q.type="paragraph",Q.text=this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]),Q.tokens=[],this.lexer.inline(Q.text,Q.tokens)),Q}},_e.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Q=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Q,raw:ue[0],href:ue[2],title:ue[3]}}},_e.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var Q={type:"table",header:m(ue[1]).map(function(V){return{text:V}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Q.header.length===Q.align.length){Q.raw=ue[0];var J=Q.align.length,ce,ve,F,W;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(Q.align[ce])?Q.align[ce]="right":/^ *:-+: *$/.test(Q.align[ce])?Q.align[ce]="center":/^ *:-+ *$/.test(Q.align[ce])?Q.align[ce]="left":Q.align[ce]=null;for(J=Q.rows.length,ce=0;ce<J;ce++)Q.rows[ce]=m(Q.rows[ce],Q.header.length).map(function(V){return{text:V}});for(J=Q.header.length,ve=0;ve<J;ve++)Q.header[ve].tokens=[],this.lexer.inlineTokens(Q.header[ve].text,Q.header[ve].tokens);for(J=Q.rows.length,ve=0;ve<J;ve++)for(W=Q.rows[ve],F=0;F<W.length;F++)W[F].tokens=[],this.lexer.inlineTokens(W[F].text,W[F].tokens);return Q}}},_e.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var Q={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},_e.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var Q={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},_e.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var Q={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},_e.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:f(ue[1])}},_e.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]):ue[0]}},_e.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var Q=ue[2].trim();if(!this.options.pedantic&&/^</.test(Q)){if(!/>$/.test(Q))return;var J=d(Q.slice(0,-1),"\\");if((Q.length-J.length)%2==0)return}else{var ce=C(ue[2],"()");if(ce>-1){var ve=ue[0].indexOf("!")===0?5:4,F=ve+ue[1].length+ce;ue[2]=ue[2].substring(0,ce),ue[0]=ue[0].substring(0,F).trim(),ue[3]=""}}var W=ue[2],V="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);K&&(W=K[1],V=K[3])}else V=ue[3]?ue[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(Q)?W=W.slice(1):W=W.slice(1,-1)),A(ue,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:V&&V.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},_e.reflink=function(se,ue){var Q;if((Q=this.rules.inline.reflink.exec(se))||(Q=this.rules.inline.nolink.exec(se))){var J=(Q[2]||Q[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var ce=Q[0].charAt(0);return{type:"text",raw:ce,text:ce}}return A(Q,J,Q[0],this.lexer)}},_e.emStrong=function(se,ue,Q){Q===void 0&&(Q="");var J=this.rules.inline.emStrong.lDelim.exec(se);if(!!J&&!(J[3]&&Q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=J[1]||J[2]||"";if(!ce||ce&&(Q===""||this.rules.inline.punctuation.exec(Q))){var ve=J[0].length-1,F,W,V=ve,K=0,z=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,ue=ue.slice(-1*se.length+ve);(J=z.exec(ue))!=null;)if(F=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!F){if(W=F.length,J[3]||J[4]){V+=W;continue}else if((J[5]||J[6])&&ve%3&&!((ve+W)%3)){K+=W;continue}if(V-=W,!(V>0)){if(W=Math.min(W,W+V+K),Math.min(ve,W)%2){var Y=se.slice(1,ve+J.index+W);return{type:"em",raw:se.slice(0,ve+J.index+W+1),text:Y,tokens:this.lexer.inlineTokens(Y,[])}}var ie=se.slice(2,ve+J.index+W-1);return{type:"strong",raw:se.slice(0,ve+J.index+W+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},_e.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var Q=ue[2].replace(/\n/g," "),J=/[^ ]/.test(Q),ce=/^ /.test(Q)&&/ $/.test(Q);return J&&ce&&(Q=Q.substring(1,Q.length-1)),Q=f(Q,!0),{type:"codespan",raw:ue[0],text:Q}}},_e.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},_e.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},_e.autolink=function(se,ue){var Q=this.rules.inline.autolink.exec(se);if(Q){var J,ce;return Q[2]==="@"?(J=f(this.options.mangle?ue(Q[1]):Q[1]),ce="mailto:"+J):(J=f(Q[1]),ce=J),{type:"link",raw:Q[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},_e.url=function(se,ue){var Q;if(Q=this.rules.inline.url.exec(se)){var J,ce;if(Q[2]==="@")J=f(this.options.mangle?ue(Q[0]):Q[0]),ce="mailto:"+J;else{var ve;do ve=Q[0],Q[0]=this.rules.inline._backpedal.exec(Q[0])[0];while(ve!==Q[0]);J=f(Q[0]),Q[1]==="www."?ce="http://"+J:ce=J}return{type:"link",raw:Q[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},_e.inlineText=function(se,ue){var Q=this.rules.inline.text.exec(se);if(Q){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]):Q[0]:J=f(this.options.smartypants?ue(Q[0]):Q[0]),{type:"text",raw:Q[0],text:J}}},Ce}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=y(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=y(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=y(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=y(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=y(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=y(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=s({},x),x.gfm=s({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=y(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=y(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=s({},x.normal,{html:y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:y(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var H={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};H._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",H.punctuation=y(H.punctuation).replace(/punctuation/g,H._punctuation).getRegex(),H.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,H.escapedEmSt=/\\\*|\\_/g,H._comment=y(x._comment).replace("(?:-->|$)","-->").getRegex(),H.emStrong.lDelim=y(H.emStrong.lDelim).replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimAst=y(H.emStrong.rDelimAst,"g").replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimUnd=y(H.emStrong.rDelimUnd,"g").replace(/punct/g,H._punctuation).getRegex(),H._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,H._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,H._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,H.autolink=y(H.autolink).replace("scheme",H._scheme).replace("email",H._email).getRegex(),H._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,H.tag=y(H.tag).replace("comment",H._comment).replace("attribute",H._attribute).getRegex(),H._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,H._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,H._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,H.link=y(H.link).replace("label",H._label).replace("href",H._href).replace("title",H._title).getRegex(),H.reflink=y(H.reflink).replace("label",H._label).replace("ref",x._label).getRegex(),H.nolink=y(H.nolink).replace("ref",x._label).getRegex(),H.reflinkSearch=y(H.reflinkSearch,"g").replace("reflink",H.reflink).replace("nolink",H.nolink).getRegex(),H.normal=s({},H),H.pedantic=s({},H.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:y(/^!?\[(label)\]\((.*?)\)/).replace("label",H._label).getRegex(),reflink:y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",H._label).getRegex()}),H.gfm=s({},H.normal,{escape:y(H.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),H.gfm.url=y(H.gfm.url,"i").replace("email",H.gfm._extended_email).getRegex(),H.breaks=s({},H.gfm,{br:y(H.br).replace("{2,}","*").getRegex(),text:y(H.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function oe(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Ce){var _e="",Te,se,ue=Ce.length;for(Te=0;Te<ue;Te++)se=Ce.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),_e+="&#"+se+";";return _e}var M=function(){function Ce(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||ee.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:x.normal,inline:H.normal};this.options.pedantic?(se.block=x.pedantic,se.inline=H.pedantic):this.options.gfm&&(se.block=x.gfm,this.options.breaks?se.inline=H.breaks:se.inline=H.gfm),this.tokenizer.rules=se}Ce.lex=function(se,ue){var Q=new Ce(ue);return Q.lex(se)},Ce.lexInline=function(se,ue){var Q=new Ce(ue);return Q.inlineTokens(se)};var _e=Ce.prototype;return _e.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},_e.blockTokens=function(se,ue){var Q=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var J,ce,ve,F;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(V){return(J=V.call({lexer:Q},se,ue))?(se=se.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.space(se)){se=se.substring(J.raw.length),J.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(J);continue}if(J=this.tokenizer.code(se)){se=se.substring(J.raw.length),ce=ue[ue.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+J.raw,ce.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):ue.push(J);continue}if(J=this.tokenizer.fences(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.list(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.html(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.def(se)){se=se.substring(J.raw.length),ce=ue[ue.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+J.raw,ce.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(ve=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var V=1/0,K=se.slice(1),z=void 0;Q.options.extensions.startBlock.forEach(function(Y){z=Y.call({lexer:this},K),typeof z=="number"&&z>=0&&(V=Math.min(V,z))}),V<1/0&&V>=0&&(ve=se.substring(0,V+1))}(),this.state.top&&(J=this.tokenizer.paragraph(ve))){ce=ue[ue.length-1],F&&ce.type==="paragraph"?(ce.raw+=`
`+J.raw,ce.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):ue.push(J),F=ve.length!==se.length,se=se.substring(J.raw.length);continue}if(J=this.tokenizer.text(se)){se=se.substring(J.raw.length),ce=ue[ue.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+J.raw,ce.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):ue.push(J);continue}if(se){var W="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,ue},_e.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},_e.inlineTokens=function(se,ue){var Q=this;ue===void 0&&(ue=[]);var J,ce,ve,F=se,W,V,K;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)z.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,W.index)+"["+U("a",W[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,W.index)+"["+U("a",W[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,W.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(V||(K=""),V=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(J=ie.call({lexer:Q},se,ue))?(se=se.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.escape(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.tag(se)){se=se.substring(J.raw.length),ce=ue[ue.length-1],ce&&J.type==="text"&&ce.type==="text"?(ce.raw+=J.raw,ce.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.link(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(J.raw.length),ce=ue[ue.length-1],ce&&J.type==="text"&&ce.type==="text"?(ce.raw+=J.raw,ce.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.emStrong(se,F,K)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.codespan(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.br(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.del(se)){se=se.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.autolink(se,G)){se=se.substring(J.raw.length),ue.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(se,G))){se=se.substring(J.raw.length),ue.push(J);continue}if(ve=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=1/0,Fe=se.slice(1),Ue=void 0;Q.options.extensions.startInline.forEach(function(ke){Ue=ke.call({lexer:this},Fe),typeof Ue=="number"&&Ue>=0&&(ie=Math.min(ie,Ue))}),ie<1/0&&ie>=0&&(ve=se.substring(0,ie+1))}(),J=this.tokenizer.inlineText(ve,oe)){se=se.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(K=J.raw.slice(-1)),V=!0,ce=ue[ue.length-1],ce&&ce.type==="text"?(ce.raw+=J.raw,ce.text+=J.text):ue.push(J);continue}if(se){var Y="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return ue},a(Ce,null,[{key:"rules",get:function(){return{block:x,inline:H}}}]),Ce}(),le=function(){function Ce(Te){this.options=Te||ee.defaults}var _e=Ce.prototype;return _e.code=function(se,ue,Q){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(se,J);ce!=null&&ce!==se&&(Q=!0,se=ce)}return se=se.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+f(J,!0)+'">'+(Q?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(Q?se:f(se,!0))+`</code></pre>
`},_e.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},_e.html=function(se){return se},_e.heading=function(se,ue,Q,J){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+J.slug(Q)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(se,ue,Q){var J=ue?"ol":"ul",ce=ue&&Q!==1?' start="'+Q+'"':"";return"<"+J+ce+`>
`+se+"</"+J+`>
`},_e.listitem=function(se){return"<li>"+se+`</li>
`},_e.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(se){return"<p>"+se+`</p>
`},_e.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},_e.tablerow=function(se){return`<tr>
`+se+`</tr>
`},_e.tablecell=function(se,ue){var Q=ue.header?"th":"td",J=ue.align?"<"+Q+' align="'+ue.align+'">':"<"+Q+">";return J+se+"</"+Q+`>
`},_e.strong=function(se){return"<strong>"+se+"</strong>"},_e.em=function(se){return"<em>"+se+"</em>"},_e.codespan=function(se){return"<code>"+se+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(se){return"<del>"+se+"</del>"},_e.link=function(se,ue,Q){if(se=S(this.options.sanitize,this.options.baseUrl,se),se===null)return Q;var J='<a href="'+f(se)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+Q+"</a>",J},_e.image=function(se,ue,Q){if(se=S(this.options.sanitize,this.options.baseUrl,se),se===null)return Q;var J='<img src="'+se+'" alt="'+Q+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},_e.text=function(se){return se},Ce}(),me=function(){function Ce(){}var _e=Ce.prototype;return _e.strong=function(se){return se},_e.em=function(se){return se},_e.codespan=function(se){return se},_e.del=function(se){return se},_e.html=function(se){return se},_e.text=function(se){return se},_e.link=function(se,ue,Q){return""+Q},_e.image=function(se,ue,Q){return""+Q},_e.br=function(){return""},Ce}(),ae=function(){function Ce(){this.seen={}}var _e=Ce.prototype;return _e.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(se,ue){var Q=se,J=0;if(this.seen.hasOwnProperty(Q)){J=this.seen[se];do J++,Q=se+"-"+J;while(this.seen.hasOwnProperty(Q))}return ue||(this.seen[se]=J,this.seen[Q]=0),Q},_e.slug=function(se,ue){ue===void 0&&(ue={});var Q=this.serialize(se);return this.getNextSafeSlug(Q,ue.dryrun)},Ce}(),ge=function(){function Ce(Te){this.options=Te||ee.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new ae}Ce.parse=function(se,ue){var Q=new Ce(ue);return Q.parse(se)},Ce.parseInline=function(se,ue){var Q=new Ce(ue);return Q.parseInline(se)};var _e=Ce.prototype;return _e.parse=function(se,ue){ue===void 0&&(ue=!0);var Q="",J,ce,ve,F,W,V,K,z,Y,ie,Fe,Ue,ke,Ve,q,X,he,Le,xe,Xe=se.length;for(J=0;J<Xe;J++){if(ie=se[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(xe=this.options.extensions.renderers[ie.type].call({parser:this},ie),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){Q+=xe||"";continue}switch(ie.type){case"space":continue;case"hr":{Q+=this.renderer.hr();continue}case"heading":{Q+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,h(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{Q+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(z="",K="",F=ie.header.length,ce=0;ce<F;ce++)K+=this.renderer.tablecell(this.parseInline(ie.header[ce].tokens),{header:!0,align:ie.align[ce]});for(z+=this.renderer.tablerow(K),Y="",F=ie.rows.length,ce=0;ce<F;ce++){for(V=ie.rows[ce],K="",W=V.length,ve=0;ve<W;ve++)K+=this.renderer.tablecell(this.parseInline(V[ve].tokens),{header:!1,align:ie.align[ve]});Y+=this.renderer.tablerow(K)}Q+=this.renderer.table(z,Y);continue}case"blockquote":{Y=this.parse(ie.tokens),Q+=this.renderer.blockquote(Y);continue}case"list":{for(Fe=ie.ordered,Ue=ie.start,ke=ie.loose,F=ie.items.length,Y="",ce=0;ce<F;ce++)q=ie.items[ce],X=q.checked,he=q.task,Ve="",q.task&&(Le=this.renderer.checkbox(X),ke?q.tokens.length>0&&q.tokens[0].type==="paragraph"?(q.tokens[0].text=Le+" "+q.tokens[0].text,q.tokens[0].tokens&&q.tokens[0].tokens.length>0&&q.tokens[0].tokens[0].type==="text"&&(q.tokens[0].tokens[0].text=Le+" "+q.tokens[0].tokens[0].text)):q.tokens.unshift({type:"text",text:Le}):Ve+=Le),Ve+=this.parse(q.tokens,ke),Y+=this.renderer.listitem(Ve,he,X);Q+=this.renderer.list(Y,Fe,Ue);continue}case"html":{Q+=this.renderer.html(ie.text);continue}case"paragraph":{Q+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(Y=ie.tokens?this.parseInline(ie.tokens):ie.text;J+1<Xe&&se[J+1].type==="text";)ie=se[++J],Y+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);Q+=ue?this.renderer.paragraph(Y):Y;continue}default:{var Je='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return Q},_e.parseInline=function(se,ue){ue=ue||this.renderer;var Q="",J,ce,ve,F=se.length;for(J=0;J<F;J++){if(ce=se[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(ve=this.options.extensions.renderers[ce.type].call({parser:this},ce),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){Q+=ve||"";continue}switch(ce.type){case"escape":{Q+=ue.text(ce.text);break}case"html":{Q+=ue.html(ce.text);break}case"link":{Q+=ue.link(ce.href,ce.title,this.parseInline(ce.tokens,ue));break}case"image":{Q+=ue.image(ce.href,ce.title,ce.text);break}case"strong":{Q+=ue.strong(this.parseInline(ce.tokens,ue));break}case"em":{Q+=ue.em(this.parseInline(ce.tokens,ue));break}case"codespan":{Q+=ue.codespan(ce.text);break}case"br":{Q+=ue.br();break}case"del":{Q+=ue.del(this.parseInline(ce.tokens,ue));break}case"text":{Q+=ue.text(ce.text);break}default:{var W='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return Q},Ce}();function te(Ce,_e,Te){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof _e=="function"&&(Te=_e,_e=null),_e=s({},te.defaults,_e||{}),O(_e),Te){var se=_e.highlight,ue;try{ue=M.lex(Ce,_e)}catch(ve){return Te(ve)}var Q=function(F){var W;if(!F)try{_e.walkTokens&&te.walkTokens(ue,_e.walkTokens),W=ge.parse(ue,_e)}catch(V){F=V}return _e.highlight=se,F?Te(F):Te(null,W)};if(!se||se.length<3||(delete _e.highlight,!ue.length))return Q();var J=0;te.walkTokens(ue,function(ve){ve.type==="code"&&(J++,setTimeout(function(){se(ve.text,ve.lang,function(F,W){if(F)return Q(F);W!=null&&W!==ve.text&&(ve.text=W,ve.escaped=!0),J--,J===0&&Q()})},0))}),J===0&&Q();return}try{var ce=M.lex(Ce,_e);return _e.walkTokens&&te.walkTokens(ce,_e.walkTokens),ge.parse(ce,_e)}catch(ve){if(ve.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(ve.message+"",!0)+"</pre>";throw ve}}te.options=te.setOptions=function(Ce){return s(te.defaults,Ce),k(te.defaults),te},te.getDefaults=I,te.defaults=ee.defaults,te.use=function(){for(var Ce=arguments.length,_e=new Array(Ce),Te=0;Te<Ce;Te++)_e[Te]=arguments[Te];var se=s.apply(void 0,[{}].concat(_e)),ue=te.defaults.extensions||{renderers:{},childTokens:{}},Q;_e.forEach(function(J){if(J.extensions&&(Q=!0,J.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var F=ue.renderers?ue.renderers[ve.name]:null;F?ue.renderers[ve.name]=function(){for(var W=arguments.length,V=new Array(W),K=0;K<W;K++)V[K]=arguments[K];var z=ve.renderer.apply(this,V);return z===!1&&(z=F.apply(this,V)),z}:ue.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[ve.level]?ue[ve.level].unshift(ve.tokenizer):ue[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?ue.startBlock?ue.startBlock.push(ve.start):ue.startBlock=[ve.start]:ve.level==="inline"&&(ue.startInline?ue.startInline.push(ve.start):ue.startInline=[ve.start]))}ve.childTokens&&(ue.childTokens[ve.name]=ve.childTokens)})),J.renderer&&function(){var ve=te.defaults.renderer||new le,F=function(K){var z=ve[K];ve[K]=function(){for(var Y=arguments.length,ie=new Array(Y),Fe=0;Fe<Y;Fe++)ie[Fe]=arguments[Fe];var Ue=J.renderer[K].apply(ve,ie);return Ue===!1&&(Ue=z.apply(ve,ie)),Ue}};for(var W in J.renderer)F(W);se.renderer=ve}(),J.tokenizer&&function(){var ve=te.defaults.tokenizer||new $,F=function(K){var z=ve[K];ve[K]=function(){for(var Y=arguments.length,ie=new Array(Y),Fe=0;Fe<Y;Fe++)ie[Fe]=arguments[Fe];var Ue=J.tokenizer[K].apply(ve,ie);return Ue===!1&&(Ue=z.apply(ve,ie)),Ue}};for(var W in J.tokenizer)F(W);se.tokenizer=ve}(),J.walkTokens){var ce=te.defaults.walkTokens;se.walkTokens=function(ve){J.walkTokens.call(this,ve),ce&&ce.call(this,ve)}}Q&&(se.extensions=ue),te.setOptions(se)})},te.walkTokens=function(Ce,_e){for(var Te=function(){var J=ue.value;switch(_e.call(te,J),J.type){case"table":{for(var ce=L(J.header),ve;!(ve=ce()).done;){var F=ve.value;te.walkTokens(F.tokens,_e)}for(var W=L(J.rows),V;!(V=W()).done;)for(var K=V.value,z=L(K),Y;!(Y=z()).done;){var ie=Y.value;te.walkTokens(ie.tokens,_e)}break}case"list":{te.walkTokens(J.items,_e);break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[J.type]?te.defaults.extensions.childTokens[J.type].forEach(function(Fe){te.walkTokens(J[Fe],_e)}):J.tokens&&te.walkTokens(J.tokens,_e)}},se=L(Ce),ue;!(ue=se()).done;)Te()},te.parseInline=function(Ce,_e){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");_e=s({},te.defaults,_e||{}),O(_e);try{var Te=M.lexInline(Ce,_e);return _e.walkTokens&&te.walkTokens(Te,_e.walkTokens),ge.parseInline(Te,_e)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},te.Parser=ge,te.parser=ge.parse,te.Renderer=le,te.TextRenderer=me,te.Lexer=M,te.lexer=M.lex,te.Tokenizer=$,te.Slugger=ae,te.parse=te;var Ee=te.options,we=te.setOptions,Z=te.use,pe=te.walkTokens,Pe=te.parseInline,Ne=te,We=ge.parse,Ge=M.lex;ee.Lexer=M,ee.Parser=ge,ee.Renderer=le,ee.Slugger=ae,ee.TextRenderer=me,ee.Tokenizer=$,ee.getDefaults=I,ee.lexer=Ge,ee.marked=te,ee.options=Ee,ee.parse=Ne,ee.parseInline=Pe,ee.parser=We,ee.setOptions=we,ee.use=Z,ee.walkTokens=pe,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Se[106],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,b,P){return Math.min(Math.max(k,b),P)}e.clamp=a;function D(k,b){return(b+k%b)%b}e.rot=D;class g{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=g;class L{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class I{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const P=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function ee(g){const L=[];typeof g=="number"&&L.push("code/timeOrigin",g);function I(b){L.push(b,Date.now())}function k(){const b=[];for(let P=0;P<L.length;P+=2)b.push({name:L[P],startTime:L[P+1]});return b}return{mark:I,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(g+I.startTime)});return L}};if(typeof process=="object"){const g=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function a(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=a(D))}(),define(Se[74],De([1,0,17]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var D;(function(v){v.text="text/plain",v.binary="application/octet-stream",v.unknown="application/unknown",v.markdown="text/markdown",v.latex="text/latex",v.uriList="text/uri-list"})(D=e.Mimes||(e.Mimes={}));const g={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(v){const p=(0,a.extname)(v),w=g[p.toLowerCase()];return w!==void 0?w:k(v)}e.getMediaOrTextMime=I;function k(v){const p=(0,a.extname)(v);return L[p.toLowerCase()]}e.getMediaMime=k;function b(v){for(const p in L)if(L[p]===v)return p}e.getExtensionForMimeType=b;const P=/^(.+)\/(.+?)(;.+)?$/;function R(v,p){const w=P.exec(v);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:p?void 0:v}e.normalizeMimeType=R}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var D in a)(typeof exports=="object"?exports:ee)[D]=a[D]}}(typeof self!="undefined"?self:this,function(){return function(ee){var e={};function a(D){if(e[D])return e[D].exports;var g=e[D]={i:D,l:!1,exports:{}};return ee[D].call(g.exports,g,g.exports,a),g.l=!0,g.exports}return a.m=ee,a.c=e,a.d=function(D,g,L){a.o(D,g)||Object.defineProperty(D,g,{enumerable:!0,get:L})},a.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},a.t=function(D,g){if(1&g&&(D=a(D)),8&g||4&g&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(a.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&g&&typeof D!="string")for(var I in D)a.d(L,I,function(k){return D[k]}.bind(null,I));return L},a.n=function(D){var g=D&&D.__esModule?function(){return D.default}:function(){return D};return a.d(g,"a",g),g},a.o=function(D,g){return Object.prototype.hasOwnProperty.call(D,g)},a.p="",a(a.s=0)}([function(ee,e,a){(function(D){var g;e=ee.exports=Z,g=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],b=e.src=[],P=0,R=P++;b[R]="0|[1-9]\\d*";var v=P++;b[v]="[0-9]+";var p=P++;b[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=P++;b[w]="("+b[R]+")\\.("+b[R]+")\\.("+b[R]+")";var f=P++;b[f]="("+b[v]+")\\.("+b[v]+")\\.("+b[v]+")";var u=P++;b[u]="(?:"+b[R]+"|"+b[p]+")";var h=P++;b[h]="(?:"+b[v]+"|"+b[p]+")";var c=P++;b[c]="(?:-("+b[u]+"(?:\\."+b[u]+")*))";var y=P++;b[y]="(?:-?("+b[h]+"(?:\\."+b[h]+")*))";var _=P++;b[_]="[0-9A-Za-z-]+";var l=P++;b[l]="(?:\\+("+b[_]+"(?:\\."+b[_]+")*))";var S=P++,n="v?"+b[w]+b[c]+"?"+b[l]+"?";b[S]="^"+n+"$";var T="[v=\\s]*"+b[f]+b[y]+"?"+b[l]+"?",i=P++;b[i]="^"+T+"$";var o=P++;b[o]="((?:<|>)?=?)";var r=P++;b[r]=b[v]+"|x|X|\\*";var t=P++;b[t]=b[R]+"|x|X|\\*";var s=P++;b[s]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[c]+")?"+b[l]+"?)?)?";var m=P++;b[m]="[v=\\s]*("+b[r]+")(?:\\.("+b[r]+")(?:\\.("+b[r]+")(?:"+b[y]+")?"+b[l]+"?)?)?";var d=P++;b[d]="^"+b[o]+"\\s*"+b[s]+"$";var C=P++;b[C]="^"+b[o]+"\\s*"+b[m]+"$";var O=P++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=P++;b[U]="(?:~>?)";var A=P++;b[A]="(\\s*)"+b[U]+"\\s+",k[A]=new RegExp(b[A],"g");var E=P++;b[E]="^"+b[U]+b[s]+"$";var $=P++;b[$]="^"+b[U]+b[m]+"$";var x=P++;b[x]="(?:\\^)";var H=P++;b[H]="(\\s*)"+b[x]+"\\s+",k[H]=new RegExp(b[H],"g");var oe=P++;b[oe]="^"+b[x]+b[s]+"$";var G=P++;b[G]="^"+b[x]+b[m]+"$";var M=P++;b[M]="^"+b[o]+"\\s*("+T+")$|^$";var le=P++;b[le]="^"+b[o]+"\\s*("+n+")$|^$";var me=P++;b[me]="(\\s*)"+b[o]+"\\s*("+T+"|"+b[s]+")",k[me]=new RegExp(b[me],"g");var ae=P++;b[ae]="^\\s*("+b[s]+")\\s+-\\s+("+b[s]+")\\s*$";var ge=P++;b[ge]="^\\s*("+b[m]+")\\s+-\\s+("+b[m]+")\\s*$";var te=P++;b[te]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)g(Ee,b[Ee]),k[Ee]||(k[Ee]=new RegExp(b[Ee]));function we(z,Y){if(z instanceof Z)return z;if(typeof z!="string"||z.length>L||!(Y?k[i]:k[S]).test(z))return null;try{return new Z(z,Y)}catch{return null}}function Z(z,Y){if(z instanceof Z){if(z.loose===Y)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Z))return new Z(z,Y);g("SemVer",z,Y),this.loose=Y;var ie=z.trim().match(Y?k[i]:k[S]);if(!ie)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var Ue=+Fe;if(Ue>=0&&Ue<I)return Ue}return Fe}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}e.parse=we,e.valid=function(z,Y){var ie=we(z,Y);return ie?ie.version:null},e.clean=function(z,Y){var ie=we(z.trim().replace(/^[=v]+/,""),Y);return ie?ie.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(z){return g("SemVer.compare",this.version,this.loose,z),z instanceof Z||(z=new Z(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Z.prototype.compareMain=function(z){return z instanceof Z||(z=new Z(z,this.loose)),Pe(this.major,z.major)||Pe(this.minor,z.minor)||Pe(this.patch,z.patch)},Z.prototype.comparePre=function(z){if(z instanceof Z||(z=new Z(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var Y=0;do{var ie=this.prerelease[Y],Fe=z.prerelease[Y];if(g("prerelease compare",Y,ie,Fe),ie===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ie===void 0)return-1;if(ie!==Fe)return Pe(ie,Fe)}while(++Y)},Z.prototype.inc=function(z,Y){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,Y,ie,Fe){typeof ie=="string"&&(Fe=ie,ie=void 0);try{return new Z(z,ie).inc(Y,Fe).version}catch{return null}},e.diff=function(z,Y){if(Ce(z,Y))return null;var ie=we(z),Fe=we(Y);if(ie.prerelease.length||Fe.prerelease.length){for(var Ue in ie)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ie[Ue]!==Fe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ie)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ie[Ue]!==Fe[Ue])return Ue},e.compareIdentifiers=Pe;var pe=/^[0-9]+$/;function Pe(z,Y){var ie=pe.test(z),Fe=pe.test(Y);return ie&&Fe&&(z=+z,Y=+Y),ie&&!Fe?-1:Fe&&!ie?1:z<Y?-1:z>Y?1:0}function Ne(z,Y,ie){return new Z(z,ie).compare(new Z(Y,ie))}function We(z,Y,ie){return Ne(z,Y,ie)>0}function Ge(z,Y,ie){return Ne(z,Y,ie)<0}function Ce(z,Y,ie){return Ne(z,Y,ie)===0}function _e(z,Y,ie){return Ne(z,Y,ie)!==0}function Te(z,Y,ie){return Ne(z,Y,ie)>=0}function se(z,Y,ie){return Ne(z,Y,ie)<=0}function ue(z,Y,ie,Fe){var Ue;switch(Y){case"===":typeof z=="object"&&(z=z.version),typeof ie=="object"&&(ie=ie.version),Ue=z===ie;break;case"!==":typeof z=="object"&&(z=z.version),typeof ie=="object"&&(ie=ie.version),Ue=z!==ie;break;case"":case"=":case"==":Ue=Ce(z,ie,Fe);break;case"!=":Ue=_e(z,ie,Fe);break;case">":Ue=We(z,ie,Fe);break;case">=":Ue=Te(z,ie,Fe);break;case"<":Ue=Ge(z,ie,Fe);break;case"<=":Ue=se(z,ie,Fe);break;default:throw new TypeError("Invalid operator: "+Y)}return Ue}function Q(z,Y){if(z instanceof Q){if(z.loose===Y)return z;z=z.value}if(!(this instanceof Q))return new Q(z,Y);g("comparator",z,Y),this.loose=Y,this.parse(z),this.semver===J?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(z,Y){return Pe(Y,z)},e.major=function(z,Y){return new Z(z,Y).major},e.minor=function(z,Y){return new Z(z,Y).minor},e.patch=function(z,Y){return new Z(z,Y).patch},e.compare=Ne,e.compareLoose=function(z,Y){return Ne(z,Y,!0)},e.rcompare=function(z,Y,ie){return Ne(Y,z,ie)},e.sort=function(z,Y){return z.sort(function(ie,Fe){return e.compare(ie,Fe,Y)})},e.rsort=function(z,Y){return z.sort(function(ie,Fe){return e.rcompare(ie,Fe,Y)})},e.gt=We,e.lt=Ge,e.eq=Ce,e.neq=_e,e.gte=Te,e.lte=se,e.cmp=ue,e.Comparator=Q;var J={};function ce(z,Y){if(z instanceof ce)return z.loose===Y?z:new ce(z.raw,Y);if(z instanceof Q)return new ce(z.value,Y);if(!(this instanceof ce))return new ce(z,Y);if(this.loose=Y,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ve(z){return!z||z.toLowerCase()==="x"||z==="*"}function F(z,Y,ie,Fe,Ue,ke,Ve,q,X,he,Le,xe,Xe){return((Y=ve(ie)?"":ve(Fe)?">="+ie+".0.0":ve(Ue)?">="+ie+"."+Fe+".0":">="+Y)+" "+(q=ve(X)?"":ve(he)?"<"+(+X+1)+".0.0":ve(Le)?"<"+X+"."+(+he+1)+".0":xe?"<="+X+"."+he+"."+Le+"-"+xe:"<="+q)).trim()}function W(z,Y){for(var ie=0;ie<z.length;ie++)if(!z[ie].test(Y))return!1;if(Y.prerelease.length){for(ie=0;ie<z.length;ie++)if(g(z[ie].semver),z[ie].semver!==J&&z[ie].semver.prerelease.length>0){var Fe=z[ie].semver;if(Fe.major===Y.major&&Fe.minor===Y.minor&&Fe.patch===Y.patch)return!0}return!1}return!0}function V(z,Y,ie){try{Y=new ce(Y,ie)}catch{return!1}return Y.test(z)}function K(z,Y,ie,Fe){var Ue,ke,Ve,q,X;switch(z=new Z(z,Fe),Y=new ce(Y,Fe),ie){case">":Ue=We,ke=se,Ve=Ge,q=">",X=">=";break;case"<":Ue=Ge,ke=Te,Ve=We,q="<",X="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(V(z,Y,Fe))return!1;for(var he=0;he<Y.set.length;++he){var Le=Y.set[he],xe=null,Xe=null;if(Le.forEach(function(Je){Je.semver===J&&(Je=new Q(">=0.0.0")),xe=xe||Je,Xe=Xe||Je,Ue(Je.semver,xe.semver,Fe)?xe=Je:Ve(Je.semver,Xe.semver,Fe)&&(Xe=Je)}),xe.operator===q||xe.operator===X||(!Xe.operator||Xe.operator===q)&&ke(z,Xe.semver)||Xe.operator===X&&Ve(z,Xe.semver))return!1}return!0}Q.prototype.parse=function(z){var Y=this.loose?k[M]:k[le],ie=z.match(Y);if(!ie)throw new TypeError("Invalid comparator: "+z);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new Z(ie[2],this.loose):this.semver=J},Q.prototype.toString=function(){return this.value},Q.prototype.test=function(z){return g("Comparator.test",z,this.loose),this.semver===J||(typeof z=="string"&&(z=new Z(z,this.loose)),ue(z,this.operator,this.semver,this.loose))},Q.prototype.intersects=function(z,Y){if(!(z instanceof Q))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new ce(z.value,Y),V(this.value,ie,Y);if(z.operator==="")return ie=new ce(this.value,Y),V(z.semver,ie,Y);var Fe=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),q=ue(this.semver,"<",z.semver,Y)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),X=ue(this.semver,">",z.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return Fe||Ue||ke&&Ve||q||X},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(z){var Y=this.loose;z=z.trim(),g("range",z,Y);var ie=Y?k[ge]:k[ae];z=z.replace(ie,F),g("hyphen replace",z),z=z.replace(k[me],"$1$2$3"),g("comparator trim",z,k[me]),z=(z=(z=z.replace(k[A],"$1~")).replace(k[H],"$1^")).split(/\s+/).join(" ");var Fe=Y?k[M]:k[le],Ue=z.split(" ").map(function(ke){return function(Ve,q){return g("comp",Ve),Ve=function(X,he){return X.trim().split(/\s+/).map(function(Le){return function(xe,Xe){g("caret",xe,Xe);var Je=Xe?k[G]:k[oe];return xe.replace(Je,function(rt,Ye,Ze,qe,lt){var st;return g("caret",xe,rt,Ye,Ze,qe,lt),ve(Ye)?st="":ve(Ze)?st=">="+Ye+".0.0 <"+(+Ye+1)+".0.0":ve(qe)?st=Ye==="0"?">="+Ye+"."+Ze+".0 <"+Ye+"."+(+Ze+1)+".0":">="+Ye+"."+Ze+".0 <"+(+Ye+1)+".0.0":lt?(g("replaceCaret pr",lt),lt.charAt(0)!=="-"&&(lt="-"+lt),st=Ye==="0"?Ze==="0"?">="+Ye+"."+Ze+"."+qe+lt+" <"+Ye+"."+Ze+"."+(+qe+1):">="+Ye+"."+Ze+"."+qe+lt+" <"+Ye+"."+(+Ze+1)+".0":">="+Ye+"."+Ze+"."+qe+lt+" <"+(+Ye+1)+".0.0"):(g("no pr"),st=Ye==="0"?Ze==="0"?">="+Ye+"."+Ze+"."+qe+" <"+Ye+"."+Ze+"."+(+qe+1):">="+Ye+"."+Ze+"."+qe+" <"+Ye+"."+(+Ze+1)+".0":">="+Ye+"."+Ze+"."+qe+" <"+(+Ye+1)+".0.0"),g("caret return",st),st})}(Le,he)}).join(" ")}(Ve,q),g("caret",Ve),Ve=function(X,he){return X.trim().split(/\s+/).map(function(Le){return function(xe,Xe){var Je=Xe?k[$]:k[E];return xe.replace(Je,function(rt,Ye,Ze,qe,lt){var st;return g("tilde",xe,rt,Ye,Ze,qe,lt),ve(Ye)?st="":ve(Ze)?st=">="+Ye+".0.0 <"+(+Ye+1)+".0.0":ve(qe)?st=">="+Ye+"."+Ze+".0 <"+Ye+"."+(+Ze+1)+".0":lt?(g("replaceTilde pr",lt),lt.charAt(0)!=="-"&&(lt="-"+lt),st=">="+Ye+"."+Ze+"."+qe+lt+" <"+Ye+"."+(+Ze+1)+".0"):st=">="+Ye+"."+Ze+"."+qe+" <"+Ye+"."+(+Ze+1)+".0",g("tilde return",st),st})}(Le,he)}).join(" ")}(Ve,q),g("tildes",Ve),Ve=function(X,he){return g("replaceXRanges",X,he),X.split(/\s+/).map(function(Le){return function(xe,Xe){xe=xe.trim();var Je=Xe?k[C]:k[d];return xe.replace(Je,function(rt,Ye,Ze,qe,lt,st){g("xRange",xe,rt,Ye,Ze,qe,lt,st);var It=ve(Ze),at=It||ve(qe),ht=at||ve(lt);return Ye==="="&&ht&&(Ye=""),It?rt=Ye===">"||Ye==="<"?"<0.0.0":"*":Ye&&ht?(at&&(qe=0),ht&&(lt=0),Ye===">"?(Ye=">=",at?(Ze=+Ze+1,qe=0,lt=0):ht&&(qe=+qe+1,lt=0)):Ye==="<="&&(Ye="<",at?Ze=+Ze+1:qe=+qe+1),rt=Ye+Ze+"."+qe+"."+lt):at?rt=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":ht&&(rt=">="+Ze+"."+qe+".0 <"+Ze+"."+(+qe+1)+".0"),g("xRange return",rt),rt})}(Le,he)}).join(" ")}(Ve,q),g("xrange",Ve),Ve=function(X,he){return g("replaceStars",X,he),X.trim().replace(k[te],"")}(Ve,q),g("stars",Ve),Ve}(ke,Y)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(ke){return!!ke.match(Fe)})),Ue=Ue.map(function(ke){return new Q(ke,Y)})},ce.prototype.intersects=function(z,Y){if(!(z instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function(Fe){return z.set.some(function(Ue){return Ue.every(function(ke){return Fe.intersects(ke,Y)})})})})},e.toComparators=function(z,Y){return new ce(z,Y).set.map(function(ie){return ie.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Z(z,this.loose));for(var Y=0;Y<this.set.length;Y++)if(W(this.set[Y],z))return!0;return!1},e.satisfies=V,e.maxSatisfying=function(z,Y,ie){var Fe=null,Ue=null;try{var ke=new ce(Y,ie)}catch{return null}return z.forEach(function(Ve){ke.test(Ve)&&(Fe&&Ue.compare(Ve)!==-1||(Ue=new Z(Fe=Ve,ie)))}),Fe},e.minSatisfying=function(z,Y,ie){var Fe=null,Ue=null;try{var ke=new ce(Y,ie)}catch{return null}return z.forEach(function(Ve){ke.test(Ve)&&(Fe&&Ue.compare(Ve)!==1||(Ue=new Z(Fe=Ve,ie)))}),Fe},e.validRange=function(z,Y){try{return new ce(z,Y).range||"*"}catch{return null}},e.ltr=function(z,Y,ie){return K(z,Y,"<",ie)},e.gtr=function(z,Y,ie){return K(z,Y,">",ie)},e.outside=K,e.prerelease=function(z,Y){var ie=we(z,Y);return ie&&ie.prerelease.length?ie.prerelease:null},e.intersects=function(z,Y,ie){return z=new ce(z,ie),Y=new ce(Y,ie),z.intersects(Y)},e.coerce=function(z){if(z instanceof Z)return z;if(typeof z!="string")return null;var Y=z.match(k[O]);return Y==null?null:we((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,a(1))},function(ee,e){var a,D,g=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function k(h){if(a===setTimeout)return setTimeout(h,0);if((a===L||!a)&&setTimeout)return a=setTimeout,setTimeout(h,0);try{return a(h,0)}catch{try{return a.call(null,h,0)}catch{return a.call(this,h,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:L}catch{a=L}try{D=typeof clearTimeout=="function"?clearTimeout:I}catch{D=I}})();var b,P=[],R=!1,v=-1;function p(){R&&b&&(R=!1,b.length?P=b.concat(P):v=-1,P.length&&w())}function w(){if(!R){var h=k(p);R=!0;for(var c=P.length;c;){for(b=P,P=[];++v<c;)b&&b[v].run();v=-1,c=P.length}b=null,R=!1,function(y){if(D===clearTimeout)return clearTimeout(y);if((D===I||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(y);try{D(y)}catch{try{return D.call(null,y)}catch{return D.call(this,y)}}}(h)}}function f(h,c){this.fun=h,this.array=c}function u(){}g.nextTick=function(h){var c=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)c[y-1]=arguments[y];P.push(new f(h,c)),P.length!==1||R||k(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=u,g.addListener=u,g.once=u,g.off=u,g.removeListener=u,g.removeAllListeners=u,g.emit=u,g.prependListener=u,g.prependOnceListener=u,g.listeners=function(h){return[]},g.binding=function(h){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(h){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[107],De([1,0,12,7]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function g(l){const S=l;return S?typeof S.read=="function":!1}e.isReadable=g;function L(l){const S=l;return S?[S.on,S.pause,S.resume,S.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function I(l){const S=l;return S?L(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=I;function k(l,S){return new b(l,S)}e.newWriteableStream=k;class b{constructor(S,n){this.reducer=S,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(n=>n(S))}emitError(S){this.listeners.error.length===0?(0,a.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(n=>n(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,n){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(S,n){if(this.state.destroyed)return;let T;switch(S){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const i=T.indexOf(n);i>=0&&T.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(l,S){const n=[];let T;for(;(T=l.read())!==null;)n.push(T);return S(n)}e.consumeReadable=P;function R(l,S,n){const T=[];let i;for(;(i=l.read())!==null&&T.length<n;)T.push(i);return i===null&&T.length>0?S(T):{read:()=>{if(T.length>0)return T.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return l.read()}}}e.peekReadable=R;function v(l,S){return new Promise((n,T)=>{const i=[];p(l,{onData:o=>{S&&i.push(o)},onError:o=>{S?T(o):n(void 0)},onEnd:()=>{n(S?S(i):void 0)}})})}e.consumeStream=v;function p(l,S){let n=!1;return l.on("error",T=>{n||S.onError(T)}),l.on("end",()=>{n||S.onEnd()}),l.on("data",T=>{n||S.onData(T)}),(0,D.toDisposable)(()=>n=!0)}e.listenStream=p;function w(l,S){return new Promise((n,T)=>{const i=new D.DisposableStore,o=[],r=m=>{if(o.push(m),o.length>S)return i.dispose(),l.pause(),n({stream:l,buffer:o,ended:!1})},t=m=>T(m),s=()=>n({stream:l,buffer:o,ended:!0});i.add((0,D.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),i.add((0,D.toDisposable)(()=>l.removeListener("end",s))),l.on("end",s),i.add((0,D.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=w;function f(l,S){const n=k(S);return n.end(l),n}e.toStream=f;function u(){const l=k(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=u;function h(l){let S=!1;return{read:()=>S?null:(S=!0,l)}}e.toReadable=h;function c(l,S,n){const T=k(n);return p(l,{onData:i=>T.write(S.data(i)),onError:i=>T.error(S.error?S.error(i):i),onEnd:()=>T.end()}),T}e.transform=c;function y(l,S,n){let T=!1;return{read:()=>{const i=S.read();return T?i:(T=!0,i!==null?n([l,i]):l)}}}e.prefixedReadable=y;function _(l,S,n){let T=!1;const i=k(n);return p(S,{onData:o=>T?i.write(o):(T=!0,i.write(n([l,o]))),onError:o=>i.error(o),onEnd:()=>{T||(T=!0,i.write(l)),i.end()}}),i}e.prefixedStream=_}),define(Se[25],De([1,0,107]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined";let g,L;class I{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return D?new I(Buffer.allocUnsafe(m)):new I(new Uint8Array(m))}static wrap(m){return D&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new I(m)}static fromString(m,d){return!(d?.dontUseNodeBuffer||!1)&&D?new I(Buffer.from(m)):(g||(g=new TextEncoder),new I(g.encode(m)))}static fromByteArray(m){const d=I.alloc(m.length);for(let C=0,O=m.length;C<O;C++)d.buffer[C]=m[C];return d}static concat(m,d){if(typeof d=="undefined"){d=0;for(let U=0,A=m.length;U<A;U++)d+=m[U].byteLength}const C=I.alloc(d);let O=0;for(let U=0,A=m.length;U<A;U++){const E=m[U];C.set(E,O),O+=E.byteLength}return C}clone(){const m=I.alloc(this.byteLength);return m.set(this),m}toString(){return D?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(m,d){return new I(this.buffer.subarray(m,d))}set(m,d){if(m instanceof I)this.buffer.set(m.buffer,d);else if(m instanceof Uint8Array)this.buffer.set(m,d);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),d);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return P(this.buffer,m)}writeUInt32BE(m,d){R(this.buffer,m,d)}readUInt32LE(m){return v(this.buffer,m)}writeUInt32LE(m,d){p(this.buffer,m,d)}readUInt8(m){return w(this.buffer,m)}writeUInt8(m,d){f(this.buffer,m,d)}}e.VSBuffer=I;function k(s,m){return s[m+0]<<0>>>0|s[m+1]<<8>>>0}e.readUInt16LE=k;function b(s,m,d){s[d+0]=m&255,m=m>>>8,s[d+1]=m&255}e.writeUInt16LE=b;function P(s,m){return s[m]*2**24+s[m+1]*2**16+s[m+2]*2**8+s[m+3]}e.readUInt32BE=P;function R(s,m,d){s[d+3]=m,m=m>>>8,s[d+2]=m,m=m>>>8,s[d+1]=m,m=m>>>8,s[d]=m}e.writeUInt32BE=R;function v(s,m){return s[m+0]<<0>>>0|s[m+1]<<8>>>0|s[m+2]<<16>>>0|s[m+3]<<24>>>0}e.readUInt32LE=v;function p(s,m,d){s[d+0]=m&255,m=m>>>8,s[d+1]=m&255,m=m>>>8,s[d+2]=m&255,m=m>>>8,s[d+3]=m&255}e.writeUInt32LE=p;function w(s,m){return s[m]}e.readUInt8=w;function f(s,m,d){s[d]=m}e.writeUInt8=f;function u(s){return a.consumeReadable(s,m=>I.concat(m))}e.readableToBuffer=u;function h(s){return a.toReadable(s)}e.bufferToReadable=h;function c(s){return a.consumeStream(s,m=>I.concat(m))}e.streamToBuffer=c;async function y(s){return s.ended?I.concat(s.buffer):I.concat([...s.buffer,await c(s.stream)])}e.bufferedStreamToBuffer=y;function _(s){return a.toStream(s,m=>I.concat(m))}e.bufferToStream=_;function l(s){return a.transform(s,{data:m=>typeof m=="string"?I.fromString(m):I.wrap(m)},m=>I.concat(m))}e.streamToBufferReadableStream=l;function S(s){return a.newWriteableStream(m=>I.concat(m),s)}e.newWriteableBufferStream=S;function n(s,m){return a.prefixedReadable(s,m,d=>I.concat(d))}e.prefixedBufferReadable=n;function T(s,m){return a.prefixedStream(s,m,d=>I.concat(d))}e.prefixedBufferStream=T;function i(s){let m=0,d=0,C=0;const O=new Uint8Array(Math.floor(s.length/4*3)),U=E=>{switch(d){case 3:O[C++]=m|E,d=0;break;case 2:O[C++]=m|E>>>2,m=E<<6,d=3;break;case 1:O[C++]=m|E>>>4,m=E<<4,d=2;break;default:m=E<<2,d=1}};for(let E=0;E<s.length;E++){const $=s.charCodeAt(E);if($>=65&&$<=90)U($-65);else if($>=97&&$<=122)U($-97+26);else if($>=48&&$<=57)U($-48+52);else if($===43||$===45)U(62);else if($===47||$===95)U(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${s[E]}`)}}const A=C;for(;d>0;)U(0);return I.wrap(O).slice(0,A)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:s},m=!0,d=!1){const C=d?r:o;let O="";const U=s.byteLength%3;let A=0;for(;A<s.byteLength-U;A+=3){const E=s[A+0],$=s[A+1],x=s[A+2];O+=C[E>>>2],O+=C[(E<<4|$>>>4)&63],O+=C[($<<2|x>>>6)&63],O+=C[x&63]}if(U===1){const E=s[A+0];O+=C[E>>>2],O+=C[E<<4&63],m&&(O+="==")}else if(U===2){const E=s[A+0],$=s[A+1];O+=C[E>>>2],O+=C[(E<<4|$>>>4)&63],O+=C[$<<2&63],m&&(O+="=")}return O}e.encodeBase64=t});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[22],De([1,0,15,9]),function(ee,e,a,D){"use strict";var g,L,I,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(r,t,s){let m=r.get(t);return m===void 0&&(m=s,r.set(t,m)),m}e.getOrSet=b;function P(r){const t=[];return r.forEach((s,m)=>{t.push(`${m} => ${s}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=P;function R(r){const t=[];return r.forEach(s=>{t.push(s)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=R;class v{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),m=this._value.charCodeAt(this._pos);return s-m}value(){return this._value[this._pos]}}e.StringIterator=v;class p{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,D.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class w{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const m=this._value.charCodeAt(s);if(!(m===47||this._splitOnBackslash&&m===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,D.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var f;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(f||(f={}));class u{constructor(t,s){this._ignorePathCasing=t,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,D.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(c||(c={}));class y{constructor(t){this._iter=t}static forUris(t=()=>!1,s=()=>!1){return new y(new u(t,s))}static forPaths(t=!1){return new y(new w(void 0,!t))}static forStrings(){return new y(new v)}static forConfigKeys(){return new y(new p)}clear(){this._root=void 0}fill(t,s){if(s){const m=s.slice(0);(0,a.shuffle)(m);for(let d of m)this.set(d,t)}else{const m=t.slice(0);(0,a.shuffle)(m);for(let d of m)this.set(d[0],d[1])}}set(t,s){const m=this._iter.reset(t);let d;this._root||(this._root=new h,this._root.segment=m.value());const C=[];for(d=this._root;;){const U=m.cmp(d.segment);if(U>0)d.left||(d.left=new h,d.left.segment=m.value()),C.push([-1,d]),d=d.left;else if(U<0)d.right||(d.right=new h,d.right.segment=m.value()),C.push([1,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new h,d.mid.segment=m.value()),C.push([0,d]),d=d.mid;else break}const O=d.value;d.value=s,d.key=t;for(let U=C.length-1;U>=0;U--){const A=C[U][1];A.updateHeight();const E=A.balanceFactor();if(E<-1||E>1){const $=C[U][0],x=C[U+1][0];if($===1&&x===1)C[U][1]=A.rotateLeft();else if($===-1&&x===-1)C[U][1]=A.rotateRight();else if($===1&&x===-1)A.right=C[U+1][1]=C[U+1][1].rotateRight(),C[U][1]=A.rotateLeft();else if($===-1&&x===1)A.left=C[U+1][1]=C[U+1][1].rotateLeft(),C[U][1]=A.rotateRight();else throw new Error;if(U>0)switch(C[U-1][0]){case-1:C[U-1][1].left=C[U][1];break;case 1:C[U-1][1].right=C[U][1];break;case 0:C[U-1][1].mid=C[U][1];break}else this._root=C[0][1]}}return O}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let m=this._root;for(;m;){const d=s.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(s.hasNext())s.next(),m=m.mid;else break}return m}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const m=this._iter.reset(t),d=[];let C=this._root;for(;C;){const O=m.cmp(C.segment);if(O>0)d.push([-1,C]),C=C.left;else if(O<0)d.push([1,C]),C=C.right;else if(m.hasNext())m.next(),d.push([0,C]),C=C.mid;else break}if(!!C){if(s?(C.left=void 0,C.mid=void 0,C.right=void 0,C.height=1):(C.key=void 0,C.value=void 0),!C.mid&&!C.value)if(C.left&&C.right){const O=this._min(C.right),{key:U,value:A,segment:E}=O;this._delete(O.key,!1),C.key=U,C.value=A,C.segment=E}else{const O=C.left??C.right;if(d.length>0){const[U,A]=d[d.length-1];switch(U){case-1:A.left=O;break;case 0:A.mid=O;break;case 1:A.right=O;break}}else this._root=O}for(let O=d.length-1;O>=0;O--){const U=d[O][1];U.updateHeight();const A=U.balanceFactor();if(A>1?(U.right.balanceFactor()>=0||(U.right=U.right.rotateRight()),d[O][1]=U.rotateLeft()):A<-1&&(U.left.balanceFactor()<=0||(U.left=U.left.rotateLeft()),d[O][1]=U.rotateRight()),O>0)switch(d[O-1][0]){case-1:d[O-1][1].left=d[O][1];break;case 1:d[O-1][1].right=d[O][1];break;case 0:d[O-1][1].mid=d[O][1];break}else this._root=d[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let m=this._root,d;for(;m;){const C=s.cmp(m.segment);if(C>0)m=m.left;else if(C<0)m=m.right;else if(s.hasNext())s.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(t){const s=this._iter.reset(t);let m=this._root;for(;m;){const d=s.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(s.hasNext())s.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(t){for(const[s,m]of this)t(m,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const m=s.balanceFactor();return m<-1||m>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=y;class _{constructor(t,s){this.uri=t,this.value=s}}class l{constructor(t,s){this[g]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=s??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new _(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[m,d]of this.map)t(d.value,d.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=l,l.defaultToKey=r=>r.toString();class S{constructor(t,s){this[L]="ResourceSet",!t||typeof t=="function"?this._map=new l(t):(this._map=new l(s),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,s){this._map.forEach((m,d)=>t.call(s,d,d,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var n;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class T{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const m=this._map.get(t);if(!!m)return s!==0&&this.touch(m,s),m.value}set(t,s,m=0){let d=this._map.get(t);if(d)d.value=s,m!==0&&this.touch(d,m);else{switch(d={key:t,value:s,next:void 0,previous:void 0},m){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(t,d),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const m=this._state;let d=this._head;for(;d;){if(s?t.bind(s)(d.value,d.key,this):t(d.value,d.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const t=this,s=this._state;let m=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:m.key,done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return d}values(){const t=this,s=this._state;let m=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:m.value,done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return d}entries(){const t=this,s=this._state;let m=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:[m.key,m.value],done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return d}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,m=this.size;for(;s&&m>t;)this._map.delete(s.key),s=s.next,m--;this._head=s,this._size=m,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,m=t.previous;if(!s||!m)throw new Error("Invalid list");s.previous=m,m.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const m=t.next,d=t.previous;t===this._tail?(d.next=void 0,this._tail=d):(m.previous=d,d.next=m),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const m=t.next,d=t.previous;t===this._head?(m.previous=void 0,this._head=m):(m.previous=d,d.next=m),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,m)=>{t.push([m,s])}),t}fromJSON(t){this.clear();for(const[s,m]of t)this.set(s,m)}}e.LinkedMap=T;class i extends T{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{constructor(t){k.set(this,void 0),Qe(this,k,t,"f")}get size(){return Re(this,k,"f").size}forEach(t,s){Re(this,k,"f").forEach(t,s)}get(t){return Re(this,k,"f").get(t)}has(t){return Re(this,k,"f").has(t)}entries(){return Re(this,k,"f").entries()}keys(){return Re(this,k,"f").keys()}values(){return Re(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Re(this,k,"f").entries()}}e.ReadonlyMapView=o}),define(Se[108],De([1,0,22,9]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function g(...Q){return function(J,ce){for(let ve=0,F=Q.length;ve<F;ve++){const W=Q[ve](J,ce);if(W)return W}return null}}e.or=g,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Q,J,ce){if(!ce||ce.length<J.length)return null;let ve;return Q?ve=D.startsWithIgnoreCase(ce,J):ve=ce.indexOf(J)===0,ve?J.length>0?[{start:0,end:J.length}]:[]:null}function I(Q,J){const ce=J.toLowerCase().indexOf(Q.toLowerCase());return ce===-1?null:[{start:ce,end:ce+Q.length}]}e.matchesContiguousSubString=I;function k(Q,J){return b(Q.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=k;function b(Q,J,ce,ve){if(ce===Q.length)return[];if(ve===J.length)return null;if(Q[ce]===J[ve]){let F=null;return(F=b(Q,J,ce+1,ve+1))?c({start:ve,end:ve+1},F):null}return b(Q,J,ce,ve+1)}function P(Q){return 97<=Q&&Q<=122}function R(Q){return 65<=Q&&Q<=90}e.isUpper=R;function v(Q){return 48<=Q&&Q<=57}function p(Q){return Q===32||Q===9||Q===10||Q===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Q=>w.add(Q.charCodeAt(0)));function f(Q){return p(Q)||w.has(Q)}function u(Q,J){return Q===J||f(Q)&&f(J)}function h(Q){return P(Q)||R(Q)||v(Q)}function c(Q,J){return J.length===0?J=[Q]:Q.end===J[0].start?J[0].start=Q.start:J.unshift(Q),J}function y(Q,J){for(let ce=J;ce<Q.length;ce++){const ve=Q.charCodeAt(ce);if(R(ve)||v(ve)||ce>0&&!h(Q.charCodeAt(ce-1)))return ce}return Q.length}function _(Q,J,ce,ve){if(ce===Q.length)return[];if(ve===J.length)return null;if(Q[ce]!==J[ve].toLowerCase())return null;{let F=null,W=ve+1;for(F=_(Q,J,ce+1,ve+1);!F&&(W=y(J,W))<J.length;)F=_(Q,J,ce+1,W),W++;return F===null?null:c({start:ve,end:ve+1},F)}}function l(Q){let J=0,ce=0,ve=0,F=0,W=0;for(let ie=0;ie<Q.length;ie++)W=Q.charCodeAt(ie),R(W)&&J++,P(W)&&ce++,h(W)&&ve++,v(W)&&F++;const V=J/Q.length,K=ce/Q.length,z=ve/Q.length,Y=F/Q.length;return{upperPercent:V,lowerPercent:K,alphaPercent:z,numericPercent:Y}}function S(Q){const{upperPercent:J,lowerPercent:ce}=Q;return ce===0&&J>.6}function n(Q){const{upperPercent:J,lowerPercent:ce,alphaPercent:ve,numericPercent:F}=Q;return ce>.2&&J<.8&&ve>.6&&F<.2}function T(Q){let J=0,ce=0,ve=0,F=0;for(let W=0;W<Q.length;W++)ve=Q.charCodeAt(W),R(ve)&&J++,P(ve)&&ce++,p(ve)&&F++;return(J===0||ce===0)&&F===0?Q.length<=30:J<=5}function i(Q,J){if(!J||(J=J.trim(),J.length===0)||!T(Q)||J.length>60)return null;const ce=l(J);if(!n(ce)){if(!S(ce))return null;J=J.toLowerCase()}let ve=null,F=0;for(Q=Q.toLowerCase();F<J.length&&(ve=_(Q,J,0,F))===null;)F=y(J,F+1);return ve}e.matchesCamelCase=i;function o(Q,J,ce=!1){if(!J||J.length===0)return null;let ve=null,F=0;for(Q=Q.toLowerCase(),J=J.toLowerCase();F<J.length&&(ve=r(Q,J,0,F,ce))===null;)F=t(J,F+1);return ve}e.matchesWords=o;function r(Q,J,ce,ve,F){if(ce===Q.length)return[];if(ve===J.length)return null;if(u(Q.charCodeAt(ce),J.charCodeAt(ve))){let W=null,V=ve+1;if(W=r(Q,J,ce+1,ve+1,F),!F)for(;!W&&(V=t(J,V))<J.length;)W=r(Q,J,ce+1,V,F),V++;return W===null?null:c({start:ve,end:ve+1},W)}else return null}function t(Q,J){for(let ce=J;ce<Q.length;ce++)if(f(Q.charCodeAt(ce))||ce>0&&f(Q.charCodeAt(ce-1)))return ce;return Q.length}const s=g(e.matchesPrefix,i,I),m=g(e.matchesPrefix,i,k),d=new a.LRUCache(1e4);function C(Q,J,ce=!1){if(typeof Q!="string"||typeof J!="string")return null;let ve=d.get(Q);ve||(ve=new RegExp(D.convertSimple2RegExpPattern(Q),"i"),d.set(Q,ve));const F=ve.exec(J);return F?[{start:F.index,end:F.index+F[0].length}]:ce?m(Q,J):s(Q,J)}e.matchesFuzzy=C;function O(Q,J){const ce=We(Q,Q.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?A(ce):null}e.matchesFuzzy2=O;function U(Q,J,ce,ve,F,W){const V=Math.min(13,Q.length);for(;ce<V;ce++){const K=We(Q,J,ce,ve,F,W,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(K)return K}return[0,W]}e.anyScore=U;function A(Q){if(typeof Q=="undefined")return[];const J=[],ce=Q[1];for(let ve=Q.length-1;ve>1;ve--){const F=Q[ve]+ce,W=J[J.length-1];W&&W.end===F?W.end=F+1:J.push({start:F,end:F+1})}return J}e.createMatches=A;const E=128;function $(){const Q=[],J=[];for(let ce=0;ce<=E;ce++)J[ce]=0;for(let ce=0;ce<=E;ce++)Q.push(J.slice(0));return Q}function x(Q){const J=[];for(let ce=0;ce<=Q;ce++)J[ce]=0;return J}const H=x(2*E),oe=x(2*E),G=$(),M=$(),le=$(),me=!1;function ae(Q,J,ce,ve,F){function W(K,z,Y=" "){for(;K.length<z;)K=Y+K;return K}let V=` |   |${ve.split("").map(K=>W(K,3)).join("|")}
`;for(let K=0;K<=ce;K++)K===0?V+=" |":V+=`${J[K-1]}|`,V+=Q[K].slice(0,F+1).map(z=>W(z.toString(),3)).join("|")+`
`;return V}function ge(Q,J,ce,ve){Q=Q.substr(J),ce=ce.substr(ve),console.log(ae(M,Q,Q.length,ce,ce.length)),console.log(ae(le,Q,Q.length,ce,ce.length)),console.log(ae(G,Q,Q.length,ce,ce.length))}function te(Q,J){if(J<0||J>=Q.length)return!1;const ce=Q.codePointAt(J);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(ce)}}function Ee(Q,J){if(J<0||J>=Q.length)return!1;switch(Q.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function we(Q,J,ce){return J[Q]!==ce[Q]}function Z(Q,J,ce,ve,F,W,V=!1){for(;J<ce&&F<W;)Q[J]===ve[F]&&(V&&(H[J]=F),J+=1),F+=1;return J===ce}e.isPatternInWord=Z;var pe;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Pe;(function(Q){Q.Default=[-100,0];function J(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}Q.isDefault=J})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Ne{constructor(J,ce){this.firstMatchCanBeWeak=J,this.boostFullMatch=ce}}e.FuzzyScoreOptions=Ne,Ne.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(Q,J,ce,ve,F,W,V=Ne.default){const K=Q.length>E?E:Q.length,z=ve.length>E?E:ve.length;if(ce>=K||W>=z||K-ce>z-W||!Z(J,ce,K,F,W,z,!0))return;Ge(K,z,ce,W,J,F);let Y=1,ie=1,Fe=ce,Ue=W;const ke=[!1];for(Y=1,Fe=ce;Fe<K;Y++,Fe++){const Le=H[Fe],xe=oe[Fe],Xe=Fe+1<K?oe[Fe+1]:z;for(ie=Le-W+1,Ue=Le;Ue<Xe;ie++,Ue++){let Je=Number.MIN_SAFE_INTEGER,rt=!1;Ue<=xe&&(Je=Ce(Q,J,Fe,ce,ve,F,Ue,z,W,G[Y-1][ie-1]===0,ke));let Ye=0;Je!==Number.MAX_SAFE_INTEGER&&(rt=!0,Ye=Je+M[Y-1][ie-1]);const Ze=Ue>Le,qe=Ze?M[Y][ie-1]+(G[Y][ie-1]>0?-5:0):0,lt=Ue>Le+1&&G[Y][ie-1]>0,st=lt?M[Y][ie-2]+(G[Y][ie-2]>0?-5:0):0;if(lt&&(!Ze||st>=qe)&&(!rt||st>=Ye))M[Y][ie]=st,le[Y][ie]=3,G[Y][ie]=0;else if(Ze&&(!rt||qe>=Ye))M[Y][ie]=qe,le[Y][ie]=2,G[Y][ie]=0;else if(rt)M[Y][ie]=Ye,le[Y][ie]=1,G[Y][ie]=G[Y-1][ie-1]+1;else throw new Error("not possible")}}if(me&&ge(Q,ce,ve,W),!ke[0]&&!V.firstMatchCanBeWeak)return;Y--,ie--;const Ve=[M[Y][ie],W];let q=0,X=0;for(;Y>=1;){let Le=ie;do{const xe=le[Y][Le];if(xe===3)Le=Le-2;else if(xe===2)Le=Le-1;else break}while(Le>=1);q>1&&J[ce+Y-1]===F[W+ie-1]&&!we(Le+W-1,ve,F)&&q+1>G[Y][Le]&&(Le=ie),Le===ie?q++:q=1,X||(X=Le),Y--,ie=Le-1,Ve.push(ie)}z===K&&V.boostFullMatch&&(Ve[0]+=2);const he=X-K;return Ve[0]-=he,Ve}e.fuzzyScore=We;function Ge(Q,J,ce,ve,F,W){let V=Q-1,K=J-1;for(;V>=ce&&K>=ve;)F[V]===W[K]&&(oe[V]=K,V--),K--}function Ce(Q,J,ce,ve,F,W,V,K,z,Y,ie){if(J[ce]!==W[V])return Number.MIN_SAFE_INTEGER;let Fe=1,Ue=!1;return V===ce-ve?Fe=Q[ce]===F[V]?7:5:we(V,F,W)&&(V===0||!we(V-1,F,W))?(Fe=Q[ce]===F[V]?7:5,Ue=!0):te(W,V)&&(V===0||!te(W,V-1))?Fe=5:(te(W,V-1)||Ee(W,V-1))&&(Fe=5,Ue=!0),Fe>1&&ce===ve&&(ie[0]=!0),Ue||(Ue=we(V,F,W)||te(W,V-1)||Ee(W,V-1)),ce===ve?V>z&&(Fe-=Ue?3:5):Y?Fe+=Ue?2:0:Fe+=Ue?0:1,V+1===K&&(Fe-=Ue?3:5),Fe}function _e(Q,J,ce,ve,F,W,V){return se(Q,J,ce,ve,F,W,!0,V)}e.fuzzyScoreGracefulAggressive=_e;function Te(Q,J,ce,ve,F,W,V){return se(Q,J,ce,ve,F,W,!1,V)}e.fuzzyScoreGraceful=Te;function se(Q,J,ce,ve,F,W,V,K){let z=We(Q,J,ce,ve,F,W,K);if(z&&!V)return z;if(Q.length>=3){const Y=Math.min(7,Q.length-1);for(let ie=ce+1;ie<Y;ie++){const Fe=ue(Q,ie);if(Fe){const Ue=We(Fe,Fe.toLowerCase(),ce,ve,F,W,K);Ue&&(Ue[0]-=3,(!z||Ue[0]>z[0])&&(z=Ue))}}}return z}function ue(Q,J){if(J+1>=Q.length)return;const ce=Q[J],ve=Q[J+1];if(ce!==ve)return Q.slice(0,J)+ve+ce+Q.slice(J+2)}}),define(Se[109],De([1,0,110,108,9]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const L=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(a.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${L.source}`,"g");function b(h){return h.replace(k,(c,y)=>y?c:`\\${c}`)}e.escapeIcons=b;const P=new RegExp(`\\\\${L.source}`,"g");function R(h){return h.replace(P,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=R;const v=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function p(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(v,(c,y,_,l)=>_?c:y||l||"")}e.stripIcons=p;function w(h){const c=h.indexOf(e.iconStartMarker);return c===-1?{text:h}:f(h,c)}e.parseLabelWithIcons=w;function f(h,c){const y=[];let _="";function l(s){if(s){_+=s;for(const m of s)y.push(T)}}let S=-1,n="",T=0,i,o,r=c;const t=h.length;for(l(h.substr(0,c));r<t;)i=h[r],o=h[r+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(S=r,l(n),n=e.iconStartMarker,r++):i===")"&&S!==-1?(T+=r-S+1,S=-1,n=""):S!==-1?I.test(i)?n+=i:(l(n),S=-1,n=""):l(i),r++;return l(n),{text:_,iconOffsets:y}}function u(h,c,y=!1){const{text:_,iconOffsets:l}=c;if(!l||l.length===0)return(0,D.matchesFuzzy)(h,_,y);const S=(0,g.ltrim)(_," "),n=_.length-S.length,T=(0,D.matchesFuzzy)(h,S,y);if(T)for(const i of T){const o=l[i.start+n]+n;i.start+=o,i.end+=o}return T}e.matchesFuzzyIconAware=u}),define(Se[32],De([1,0,9]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(D||(D={})),function(g){const L="error",I="warning",k="warn",b="info",P="ignore";function R(p){return p?a.equalsIgnoreCase(L,p)?g.Error:a.equalsIgnoreCase(I,p)||a.equalsIgnoreCase(k,p)?g.Warning:a.equalsIgnoreCase(b,p)?g.Info:g.Ignore:g.Ignore}g.fromValue=R;function v(p){switch(p){case g.Error:return L;case g.Warning:return I;case g.Info:return b;default:return P}}g.toString=v}(D||(D={})),e.default=D}),define(Se[37],De([1,0,17,23,9,10]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(r){return r===47||r===92}e.isPathSeparator=I;function k(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=k;function b(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=b;function P(r,t=a.posix.sep){if(!r)return"";const s=r.length,m=r.charCodeAt(0);if(I(m)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let C=3;const O=C;for(;C<s&&!I(r.charCodeAt(C));C++);if(O!==C&&!I(r.charCodeAt(C+1))){for(C+=1;C<s;C++)if(I(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,t)}}return t}else if(c(m)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<s;d++)if(I(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=P;function R(r){if(!D.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let s=2;const m=s;for(;s<r.length&&(t=r.charCodeAt(s),t!==92);s++);return!(m===s||(t=r.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=R;const v=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,t=D.isWindows){const s=t?v:p;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||t&&w.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function u(r,t,s){const m=r===t;return!s||m?m:!r||!t?!1:(0,g.equalsIgnoreCase)(r,t)}e.isEqual=u;function h(r,t,s,m=a.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(s){if(!(0,g.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let C=t.length;return t.charAt(t.length-1)===m&&C--,r.charAt(C)===m}return t.charAt(t.length-1)!==m&&(t+=m),r.indexOf(t)===0}e.isEqualOrParent=h;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=c;function y(r,t){return D.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(t,r)),r=(0,a.normalize)(r),D.isWindows?(r=(0,g.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,g.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=y;function _(r){const t=(0,a.normalize)(r);return D.isWindows?r.length>3?!1:l(t)&&(r.length===2||t.charCodeAt(2)===92):t===a.posix.sep}e.isRootOrDriveLetter=_;function l(r,t=D.isWindows){return t?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function S(r){return l(r)?r[0]:void 0}e.getDriveLetter=S;function n(r,t,s){return t.length>r.length?-1:r===t?0:(s&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function T(r){const t=r.split(":");let s,m,d;for(const C of t){const O=Number(C);(0,L.isNumber)(O)?m===void 0?m=O:d===void 0&&(d=O):s=s?[s,C].join(":"):C}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:m!==void 0?m:void 0,column:d!==void 0?d:m!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(r,t,s=8){let m="";for(let C=0;C<s;C++)m+=i.charAt(Math.floor(Math.random()*i.length));let d;return t?d=`${t}-${m}`:d=m,r?(0,a.join)(r,d):d}e.randomPath=o}),define(Se[57],De([1,0,25,9,2]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(P){return JSON.stringify(P,k)}e.stringify=L;function I(P){let R=JSON.parse(P);return R=b(R),R}e.parse=I;function k(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,D.regExpFlags)(R)}:R}function b(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return g.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof a.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let v=0;v<P.length;++v)P[v]=b(P[v],R+1);else for(const v in P)Object.hasOwnProperty.call(P,v)&&(P[v]=b(P[v],R+1))}return P}e.revive=b}),define(Se[11],De([1,0,23,2]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var g;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(g=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,P,R){this._hosts[b]=P,this._ports[b]=R}setConnectionToken(b,P){this._connectionTokens[b]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const P=b.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const v=this._ports[P],p=this._connectionTokens[P];let w=`path=${encodeURIComponent(b.path)}`;return typeof p=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),D.URI.from({scheme:a.isWeb?this._preferredWebSchema:g.vscodeRemoteResource,authority:`${R}:${v}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new L;class I{asBrowserUri(b,P){const R=this.toUri(b,P);return R.scheme===g.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===g.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${g.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?R.with({scheme:g.vscodeFileResource,authority:R.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(b,P){const R=this.toUri(b,P);return R.scheme===g.vscodeFileResource?R.with({scheme:g.file,authority:R.authority!==I.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(b,P){return D.URI.isUri(b)?b:D.URI.parse(P.toUrl(b))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Se[24],De([1,0,37,11,17,23,9,2]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(w){return(0,k.uriToFsPath)(w,!0)}e.originalFSPath=b;class P{constructor(f){this._ignorePathCasing=f}compare(f,u,h=!1){return f===u?0:(0,I.compare)(this.getComparisonKey(f,h),this.getComparisonKey(u,h))}isEqual(f,u,h=!1){return f===u?!0:!f||!u?!1:this.getComparisonKey(f,h)===this.getComparisonKey(u,h)}getComparisonKey(f,u=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,u,h=!1){if(f.scheme===u.scheme){if(f.scheme===D.Schemas.file)return a.isEqualOrParent(b(f),b(u),this._ignorePathCasing(f))&&f.query===u.query&&(h||f.fragment===u.fragment);if((0,e.isEqualAuthority)(f.authority,u.authority))return a.isEqualOrParent(f.path,u.path,this._ignorePathCasing(f),"/")&&f.query===u.query&&(h||f.fragment===u.fragment)}return!1}joinPath(f,...u){return k.URI.joinPath(f,...u)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return g.posix.basename(f.path)}extname(f){return g.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let u;return f.scheme===D.Schemas.file?u=k.URI.file(g.dirname(b(f))).path:(u=g.posix.dirname(f.path),f.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),u="/")),f.with({path:u})}normalizePath(f){if(!f.path.length)return f;let u;return f.scheme===D.Schemas.file?u=k.URI.file(g.normalize(b(f))).path:u=g.posix.normalize(f.path),f.with({path:u})}relativePath(f,u){if(f.scheme!==u.scheme||!(0,e.isEqualAuthority)(f.authority,u.authority))return;if(f.scheme===D.Schemas.file){const y=g.relative(b(f),b(u));return L.isWindows?a.toSlashes(y):y}let h=f.path||"/",c=u.path||"/";if(this._ignorePathCasing(f)){let y=0;for(const _=Math.min(h.length,c.length);y<_&&!(h.charCodeAt(y)!==c.charCodeAt(y)&&h.charAt(y).toLowerCase()!==c.charAt(y).toLowerCase());y++);h=c.substr(0,y)+h.substr(y)}return g.posix.relative(h,c)}resolvePath(f,u){if(f.scheme===D.Schemas.file){const h=k.URI.file(g.resolve(b(f),u));return f.with({authority:h.authority,path:h.path})}return u=a.toPosixPath(u),f.with({path:g.posix.resolve(f.path,u)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,u){return f===u||f!==void 0&&u!==void 0&&(0,I.equalsIgnoreCase)(f,u)}hasTrailingPathSeparator(f,u=g.sep){if(f.scheme===D.Schemas.file){const h=b(f);return h.length>a.getRoot(h).length&&h[h.length-1]===u}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,u=g.sep){return(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,u=g.sep){let h=!1;if(f.scheme===D.Schemas.file){const c=b(f);h=c!==void 0&&c.length===a.getRoot(c).length&&c[c.length-1]===u}else{u="/";const c=f.path;h=c.length===1&&c.charCodeAt(c.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path+"/"}):f}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(w=>w.scheme===D.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new P(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(w,f){const u=[];for(let h=0;h<w.length;h++){const c=f(w[h]);w.some((y,_)=>_===h?!1:(0,e.isEqualOrParent)(c,f(y)))||u.push(w[h])}return u}e.distinctParents=R;var v;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(u){const h=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(_=>{const[l,S]=_.split(":");l&&S&&h.set(l,S)});const y=u.path.substring(0,u.path.indexOf(";"));return y&&h.set(w.META_DATA_MIME,y),h}w.parseMetaData=f})(v=e.DataUri||(e.DataUri={}));function p(w,f,u){if(f){let h=w.path;return h&&h[0]!==g.posix.sep&&(h=g.posix.sep+h),w.with({scheme:u,authority:f,path:h})}return w.with({scheme:u})}e.toLocalResource=p}),define(Se[14],De([1,0,20,12,5,7,24,23]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(we){return!!we&&typeof we.then=="function"}e.isThenable=b;function P(we){const Z=new a.CancellationTokenSource,pe=we(Z.token),Pe=new Promise((Ne,We)=>{const Ge=Z.token.onCancellationRequested(()=>{Ge.dispose(),Z.dispose(),We(new D.CancellationError)});Promise.resolve(pe).then(Ce=>{Ge.dispose(),Z.dispose(),Ne(Ce)},Ce=>{Ge.dispose(),Z.dispose(),We(Ce)})});return new class{cancel(){Z.cancel()}then(Ne,We){return Pe.then(Ne,We)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return Pe.finally(Ne)}}}e.createCancelablePromise=P;function R(we,Z,pe){return new Promise((Pe,Ne)=>{const We=Z.onCancellationRequested(()=>{We.dispose(),Pe(pe)});we.then(Pe,Ne).finally(()=>We.dispose())})}e.raceCancellation=R;function v(we,Z){return new Promise((pe,Pe)=>{const Ne=Z.onCancellationRequested(()=>{Ne.dispose(),Pe(new D.CancellationError)});we.then(pe,Pe).finally(()=>Ne.dispose())})}e.raceCancellationError=v;async function p(we){let Z=-1;const pe=we.map((Ne,We)=>Ne.then(Ge=>(Z=We,Ge))),Pe=await Promise.race(pe);return we.forEach((Ne,We)=>{We!==Z&&Ne.cancel()}),Pe}e.raceCancellablePromises=p;function w(we,Z,pe){let Pe;const Ne=setTimeout(()=>{Pe?.(void 0),pe?.()},Z);return Promise.race([we.finally(()=>clearTimeout(Ne)),new Promise(We=>Pe=We)])}e.raceTimeout=w;function f(we){return new Promise((Z,pe)=>{const Pe=we();b(Pe)?Pe.then(Z,pe):Z(Pe)})}e.asPromise=f;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Z){if(this.activePromise){if(this.queuedPromiseFactory=Z,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(pe,pe).then(Pe)})}return new Promise((pe,Pe)=>{this.queuedPromise.then(pe,Pe)})}return this.activePromise=Z(),new Promise((pe,Pe)=>{this.activePromise.then(Ne=>{this.activePromise=null,pe(Ne)},Ne=>{this.activePromise=null,Pe(Ne)})})}}e.Throttler=u;class h{constructor(){this.current=Promise.resolve(null)}queue(Z){return this.current=this.current.then(()=>Z(),()=>Z())}}e.Sequencer=h;class c{constructor(){this.promiseMap=new Map}queue(Z,pe){const Ne=(this.promiseMap.get(Z)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Z)===Ne&&this.promiseMap.delete(Z)});return this.promiseMap.set(Z,Ne),Ne}}e.SequencerByKey=c;const y=(we,Z)=>{let pe=!0;const Pe=setTimeout(()=>{pe=!1,Z()},we);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Pe),pe=!1}}},_=we=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,we())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(Z){this.defaultDelay=Z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Z,pe=this.defaultDelay){this.task=Z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ne,We)=>{this.doResolve=Ne,this.doReject=We}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ne=this.task;return this.task=null,Ne()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?_(Pe):y(pe,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class S{constructor(Z){this.delayer=new l(Z),this.throttler=new u}trigger(Z,pe){return this.delayer.trigger(()=>this.throttler.queue(Z),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class n{constructor(){this._isOpen=!1,this._promise=new Promise((Z,pe)=>{this._completePromise=Z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class T extends n{constructor(Z){super();this._timeout=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=T;function i(we,Z){return Z?new Promise((pe,Pe)=>{const Ne=setTimeout(()=>{We.dispose(),pe()},we),We=Z.onCancellationRequested(()=>{clearTimeout(Ne),We.dispose(),Pe(new D.CancellationError)})}):P(pe=>i(we,pe))}e.timeout=i;function o(we,Z=0){const pe=setTimeout(we,Z);return(0,L.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=o;function r(we){const Z=[];let pe=0;const Pe=we.length;function Ne(){return pe<Pe?we[pe++]():null}function We(Ge){Ge!=null&&Z.push(Ge);const Ce=Ne();return Ce?Ce.then(We):Promise.resolve(Z)}return Promise.resolve(null).then(We)}e.sequence=r;function t(we,Z=Pe=>!!Pe,pe=null){let Pe=0;const Ne=we.length,We=()=>{if(Pe>=Ne)return Promise.resolve(pe);const Ge=we[Pe++];return Promise.resolve(Ge()).then(_e=>Z(_e)?Promise.resolve(_e):We())};return We()}e.first=t;function s(we,Z=Pe=>!!Pe,pe=null){if(we.length===0)return Promise.resolve(pe);let Pe=we.length;const Ne=()=>{Pe=-1;for(const We of we)We.cancel?.()};return new Promise((We,Ge)=>{for(const Ce of we)Ce.then(_e=>{--Pe>=0&&Z(_e)?(Ne(),We(_e)):Pe===0&&We(pe)}).catch(_e=>{--Pe>=0&&(Ne(),Ge(_e))})})}e.firstParallel=s;class m{constructor(Z){this._size=0,this.maxDegreeOfParalellism=Z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new g.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Z){return this._size++,new Promise((pe,Pe)=>{this.outstandingPromises.push({factory:Z,c:pe,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Z=this.outstandingPromises.shift();this.runningPromises++;const pe=Z.factory();pe.then(Z.c,Z.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class d extends m{constructor(){super(1)}}e.Queue=d;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Z=new le;return this.drainers.add(Z),Z.p}isDrained(){for(const[,Z]of this.queues)if(Z.size>0)return!1;return!0}queueFor(Z,pe=I.extUri){const Pe=pe.getComparisonKey(Z);let Ne=this.queues.get(Pe);return Ne||(Ne=new d,g.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Ne)),Ne}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Z of this.drainers)Z.complete();this.drainers.clear()}dispose(){for(const[,Z]of this.queues)Z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class O{constructor(Z,pe){this._token=-1,typeof Z=="function"&&typeof pe=="number"&&this.setIfNotSet(Z,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Z,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Z()},pe)}setIfNotSet(Z,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Z()},pe))}}e.TimeoutTimer=O;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Z,pe){this.cancel(),this._token=setInterval(()=>{Z()},pe)}}e.IntervalTimer=U;class A{constructor(Z,pe){this.timeoutToken=-1,this.runner=Z,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Z)}get delay(){return this.timeout}set delay(Z){this.timeout=Z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class E{constructor(Z,pe){pe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Z,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Z=this.timeout){Z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class $ extends A{constructor(Z,pe){super(Z,pe);this.units=[]}work(Z){this.units.push(Z),this.isScheduled()||this.schedule()}doRun(){const Z=this.units;this.units=[],this.runner&&this.runner(Z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class x extends L.Disposable{constructor(Z,pe){super();this.options=Z,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Z.length>this.options.maxBufferedWork)return!1}else if(this.pending+Z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=we=>{(0,k.setTimeout0)(()=>{if(Z)return;const pe=Date.now()+15;we(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(we,Z)=>{const pe=requestIdleCallback(we,typeof Z=="number"?{timeout:Z}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(pe))}}}}();class H{constructor(Z){this._didRun=!1,this._executor=()=>{try{this._value=Z()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function oe(we,Z,pe){let Pe;for(let Ne=0;Ne<pe;Ne++)try{return await we()}catch(We){Pe=We,await i(Z)}throw Pe}e.retry=oe;class G{hasPending(Z){return this._pending?typeof Z=="number"?this._pending.taskId===Z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Z,pe,Pe){return this._pending={taskId:Z,cancel:()=>Pe?.(),promise:pe},pe.then(()=>this.donePending(Z),()=>this.donePending(Z)),pe}donePending(Z){this._pending&&Z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Z=this._next;this._next=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this._next)this._next.run=Z;else{let pe,Pe;const Ne=new Promise((We,Ge)=>{pe=We,Pe=Ge});this._next={run:Z,promise:Ne,promiseResolve:pe,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=G;class M{constructor(Z,pe=()=>Date.now()){this.interval=Z,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Z=this.nowFn();return Z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Z,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class le{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Z,pe)=>{this.completeCallback=Z,this.errorCallback=pe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Z){return new Promise(pe=>{this.completeCallback(Z),this.resolved=!0,pe()})}error(Z){return new Promise(pe=>{this.errorCallback(Z),this.rejected=!0,pe()})}cancel(){new Promise(Z=>{this.errorCallback(new D.CancellationError),this.rejected=!0,Z()})}}e.DeferredPromise=le;var me;(function(we){async function Z(Pe){let Ne;const We=await Promise.all(Pe.map(Ge=>Ge.then(Ce=>Ce,Ce=>{Ne||(Ne=Ce)})));if(typeof Ne!="undefined")throw Ne;return We}we.settled=Z;function pe(Pe){return new Promise(async(Ne,We)=>{try{await Pe(Ne,We)}catch(Ge){We(Ge)}})}we.withAsyncBody=pe})(me=e.Promises||(e.Promises={}));var ae;(function(we){we[we.Initial=0]="Initial",we[we.DoneOK=1]="DoneOK",we[we.DoneError=2]="DoneError"})(ae||(ae={}));class ge{constructor(Z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new g.Emitter,queueMicrotask(async()=>{const pe={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(Z(pe)),this.resolve()}catch(Pe){this.reject(Pe)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}static fromArray(Z){return new ge(pe=>{pe.emitMany(Z)})}static fromPromise(Z){return new ge(async pe=>{pe.emitMany(await Z)})}static fromPromises(Z){return new ge(async pe=>{await Promise.all(Z.map(async Pe=>pe.emitOne(await Pe)))})}static merge(Z){return new ge(async pe=>{await Promise.all(Z.map(async Pe=>{for await(const Ne of Pe)pe.emitOne(Ne)}))})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Z<this._results.length)return{done:!1,value:this._results[Z++]};if(this._state===1)return{done:!0,value:void 0};await g.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Z,pe){return new ge(async Pe=>{for await(const Ne of Z)Pe.emitOne(pe(Ne))})}map(Z){return ge.map(this,Z)}static filter(Z,pe){return new ge(async Pe=>{for await(const Ne of Z)pe(Ne)&&Pe.emitOne(Ne)})}filter(Z){return ge.filter(this,Z)}static coalesce(Z){return ge.filter(Z,pe=>!!pe)}coalesce(){return ge.coalesce(this)}static async toPromise(Z){const pe=[];for await(const Pe of Z)pe.push(Pe);return pe}toPromise(){return ge.toPromise(this)}emitOne(Z){this._state===0&&(this._results.push(Z),this._onStateChanged.fire())}emitMany(Z){this._state===0&&(this._results=this._results.concat(Z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Z){this._state===0&&(this._state=2,this._error=Z,this._onStateChanged.fire())}}e.AsyncIterableObject=ge,ge.EMPTY=ge.fromArray([]);class te extends ge{constructor(Z,pe){super(pe);this._source=Z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function Ee(we){const Z=new a.CancellationTokenSource,pe=we(Z.token);return new te(Z,async Pe=>{const Ne=Z.token.onCancellationRequested(()=>{Ne.dispose(),Z.dispose(),Pe.reject(new D.CancellationError)});try{for await(const We of pe){if(Z.token.isCancellationRequested)return;Pe.emitOne(We)}Ne.dispose(),Z.dispose()}catch(We){Ne.dispose(),Z.dispose(),Pe.reject(We)}})}e.createCancelableAsyncIterable=Ee}),define(Se[111],De([1,0,14,17]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const g=new a.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),L=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(d,C,O=!1){const U=d||"",A=C||"",E=g.value.collator.compare(U,A);return g.value.collatorIsNumeric&&E===0&&U!==A?U<A?-1:1:E}e.compareFileNames=k;function b(d,C){const O=L.value.collator;return d=d||"",C=C||"",S(O,d,C)}e.compareFileNamesDefault=b;function P(d,C){const O=L.value.collator;return d=d||"",C=C||"",o(d,C)||S(O,d,C)}e.compareFileNamesUpper=P;function R(d,C){const O=L.value.collator;return d=d||"",C=C||"",i(d,C)||S(O,d,C)}e.compareFileNamesLower=R;function v(d,C){return d=d||"",C=C||"",d===C?0:d<C?-1:1}e.compareFileNamesUnicode=v;function p(d,C,O=!1){O||(d=d&&d.toLowerCase(),C=C&&C.toLowerCase());const[U,A]=_(d),[E,$]=_(C);return U!==E?U<E?-1:1:A===$?0:A<$?-1:1}e.noIntlCompareFileNames=p;function w(d,C){const[O,U]=_(d),[A,E]=_(C);let $=g.value.collator.compare(U,E);if($===0){if(g.value.collatorIsNumeric&&U!==E)return U<E?-1:1;if($=g.value.collator.compare(O,A),g.value.collatorIsNumeric&&$===0&&O!==A)return O<A?-1:1}return $}e.compareFileExtensions=w;function f(d,C){d=d||"",C=C||"";const O=l(d),U=l(C),A=L.value.collator,E=I.value.collator;return S(E,O,U)||S(A,d,C)}e.compareFileExtensionsDefault=f;function u(d,C){d=d||"",C=C||"";const O=l(d),U=l(C),A=L.value.collator,E=I.value.collator;return S(E,O,U)||o(d,C)||S(A,d,C)}e.compareFileExtensionsUpper=u;function h(d,C){d=d||"",C=C||"";const O=l(d),U=l(C),A=L.value.collator,E=I.value.collator;return S(E,O,U)||i(d,C)||S(A,d,C)}e.compareFileExtensionsLower=h;function c(d,C){d=d||"",C=C||"";const O=l(d).toLowerCase(),U=l(C).toLowerCase();return O!==U?O<U?-1:1:d!==C?d<C?-1:1:0}e.compareFileExtensionsUnicode=c;const y=/^(.*?)(\.([^.]*))?$/;function _(d,C=!1){const O=d?y.exec(d):[];let U=[O&&O[1]||"",O&&O[3]||""];return C&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function l(d){const C=d?y.exec(d):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function S(d,C,O){let U=d.compare(C,O);return U!==0?U:C.length!==O.length?C.length<O.length?-1:1:0}function n(d){const C=d.charAt(0);return C.toLocaleUpperCase()!==C}function T(d){const C=d.charAt(0);return C.toLocaleLowerCase()!==C}function i(d,C){return n(d)&&T(C)?-1:T(d)&&n(C)?1:0}function o(d,C){return T(d)&&n(C)?-1:n(d)&&T(C)?1:0}function r(d,C,O=!1){return O||(d=d&&d.toLowerCase(),C=C&&C.toLowerCase()),d===C?0:d<C?-1:1}function t(d,C,O=!1){const U=d.split(D.sep),A=C.split(D.sep),E=U.length-1,$=A.length-1;let x,H;for(let oe=0;;oe++){if(x=E===oe,H=$===oe,x&&H)return k(U[oe],A[oe],O);if(x)return-1;if(H)return 1;const G=r(U[oe],A[oe],O);if(G!==0)return G}}e.comparePaths=t;function s(d,C,O){const U=d.toLowerCase(),A=C.toLowerCase(),E=m(d,C,O);if(E)return E;const $=U.endsWith(O),x=A.endsWith(O);if($!==x)return $?-1:1;const H=k(U,A);return H!==0?H:U.localeCompare(A)}e.compareAnything=s;function m(d,C,O){const U=d.toLowerCase(),A=C.toLowerCase(),E=U.startsWith(O),$=A.startsWith(O);if(E!==$)return E?-1:1;if(E&&$){if(U.length<A.length)return-1;if(U.length>A.length)return 1}return 0}e.compareByPrefix=m}),define(Se[33],De([1,0,15,14,37,22,17,23,9]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",v="[^/\\\\]",p=/\//g;function w(le,me){switch(le){case 0:return"";case 1:return`${v}*?`;default:return`(?:${R}|${v}+${R}${me?`|${R}${v}+`:""})*?`}}function f(le,me){if(!le)return[];const ae=[];let ge=!1,te=!1,Ee="";for(const we of le){switch(we){case me:if(!ge&&!te){ae.push(Ee),Ee="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":te=!0;break;case"]":te=!1;break}Ee+=we}return Ee&&ae.push(Ee),ae}e.splitGlobAware=f;function u(le){if(!le)return"";let me="";const ae=f(le,e.GLOB_SPLIT);if(ae.every(ge=>ge===e.GLOBSTAR))me=".*";else{let ge=!1;ae.forEach((te,Ee)=>{if(te===e.GLOBSTAR){if(ge)return;me+=w(2,Ee===ae.length-1)}else{let we=!1,Z="",pe=!1,Pe="";for(const Ne of te){if(Ne!=="}"&&we){Z+=Ne;continue}if(pe&&(Ne!=="]"||!Pe)){let We;Ne==="-"?We=Ne:(Ne==="^"||Ne==="!")&&!Pe?We="^":Ne===e.GLOB_SPLIT?We="":We=(0,b.escapeRegExpCharacters)(Ne),Pe+=We;continue}switch(Ne){case"{":we=!0;continue;case"[":pe=!0;continue;case"}":{me+=`(?:${f(Z,",").map(Ce=>u(Ce)).join("|")})`,we=!1,Z="";break}case"]":{me+="["+Pe+"]",pe=!1,Pe="";break}case"?":me+=v;continue;case"*":me+=w(1);continue;default:me+=(0,b.escapeRegExpCharacters)(Ne)}}Ee<ae.length-1&&(ae[Ee+1]!==e.GLOBSTAR||Ee+2<ae.length)&&(me+=R)}ge=te===e.GLOBSTAR})}return me}const h=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,_=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),T=function(){return!1},i=function(){return null};function o(le,me){if(!le)return i;let ae;typeof le!="string"?ae=le.pattern:ae=le,ae=ae.trim();const ge=`${ae}_${!!me.trimForExclusions}`;let te=n.get(ge);if(te)return r(te,le);let Ee;return h.test(ae)?te=s(ae.substr(4),ae):(Ee=c.exec(t(ae,me)))?te=m(Ee[1],ae):(me.trimForExclusions?_:y).test(ae)?te=d(ae,me):(Ee=l.exec(t(ae,me)))?te=C(Ee[1].substr(1),ae,!0):(Ee=S.exec(t(ae,me)))?te=C(Ee[1],ae,!1):te=O(ae),n.set(ge,te),r(te,le)}function r(le,me){if(typeof me=="string")return le;const ae=function(ge,te){return(0,g.isEqualOrParent)(ge,me.base,!k.isLinux)?le(ge.substr(me.base.length+1),te):null};return ae.allBasenames=le.allBasenames,ae.allPaths=le.allPaths,ae.basenames=le.basenames,ae.patterns=le.patterns,ae}function t(le,me){return me.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function s(le,me){return function(ae,ge){return typeof ae=="string"&&ae.endsWith(le)?me:null}}function m(le,me){const ae=`/${le}`,ge=`\\${le}`,te=function(we,Z){return typeof we!="string"?null:Z?Z===le?me:null:we===le||we.endsWith(ae)||we.endsWith(ge)?me:null},Ee=[le];return te.basenames=Ee,te.patterns=[me],te.allBasenames=Ee,te}function d(le,me){const ae=G(le.slice(1,-1).split(",").map(Z=>o(Z,me)).filter(Z=>Z!==i),le),ge=ae.length;if(!ge)return i;if(ge===1)return ae[0];const te=function(Z,pe){for(let Pe=0,Ne=ae.length;Pe<Ne;Pe++)if(ae[Pe](Z,pe))return le;return null},Ee=ae.find(Z=>!!Z.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const we=ae.reduce((Z,pe)=>pe.allPaths?Z.concat(pe.allPaths):Z,[]);return we.length&&(te.allPaths=we),te}function C(le,me,ae){const ge=I.sep===I.posix.sep,te=ge?le:le.replace(p,I.sep),Ee=I.sep+te,we=I.posix.sep+le;let Z;return ae?Z=function(pe,Pe){return typeof pe=="string"&&(pe===te||pe.endsWith(Ee)||!ge&&(pe===le||pe.endsWith(we)))?me:null}:Z=function(pe,Pe){return typeof pe=="string"&&(pe===te||!ge&&pe===le)?me:null},Z.allPaths=[(ae?"*/":"./")+le],Z}function O(le){try{const me=new RegExp(`^${u(le)}$`);return function(ae){return me.lastIndex=0,typeof ae=="string"&&me.test(ae)?le:null}}catch{return i}}function U(le,me,ae){return!le||typeof me!="string"?!1:A(le)(me,void 0,ae)}e.match=U;function A(le,me={}){if(!le)return T;if(typeof le=="string"||E(le)){const ae=o(le,me);if(ae===i)return T;const ge=function(te,Ee){return!!ae(te,Ee)};return ae.allBasenames&&(ge.allBasenames=ae.allBasenames),ae.allPaths&&(ge.allPaths=ae.allPaths),ge}return H(le,me)}e.parse=A;function E(le){const me=le;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}e.isRelativePattern=E;function $(le){return le.allBasenames||[]}e.getBasenameTerms=$;function x(le){return le.allPaths||[]}e.getPathTerms=x;function H(le,me){const ae=G(Object.getOwnPropertyNames(le).map(Z=>oe(Z,le[Z],me)).filter(Z=>Z!==i)),ge=ae.length;if(!ge)return i;if(!ae.some(Z=>!!Z.requiresSiblings)){if(ge===1)return ae[0];const Z=function(Ne,We){let Ge;for(let Ce=0,_e=ae.length;Ce<_e;Ce++){const Te=ae[Ce](Ne,We);if(typeof Te=="string")return Te;(0,D.isThenable)(Te)&&(Ge||(Ge=[]),Ge.push(Te))}return Ge?(async()=>{for(const Ce of Ge){const _e=await Ce;if(typeof _e=="string")return _e}return null})():null},pe=ae.find(Ne=>!!Ne.allBasenames);pe&&(Z.allBasenames=pe.allBasenames);const Pe=ae.reduce((Ne,We)=>We.allPaths?Ne.concat(We.allPaths):Ne,[]);return Pe.length&&(Z.allPaths=Pe),Z}const te=function(Z,pe,Pe){let Ne,We;for(let Ge=0,Ce=ae.length;Ge<Ce;Ge++){const _e=ae[Ge];_e.requiresSiblings&&Pe&&(pe||(pe=(0,I.basename)(Z)),Ne||(Ne=pe.substr(0,pe.length-(0,I.extname)(Z).length)));const Te=_e(Z,pe,Ne,Pe);if(typeof Te=="string")return Te;(0,D.isThenable)(Te)&&(We||(We=[]),We.push(Te))}return We?(async()=>{for(const Ge of We){const Ce=await Ge;if(typeof Ce=="string")return Ce}return null})():null},Ee=ae.find(Z=>!!Z.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const we=ae.reduce((Z,pe)=>pe.allPaths?Z.concat(pe.allPaths):Z,[]);return we.length&&(te.allPaths=we),te}function oe(le,me,ae){if(me===!1)return i;const ge=o(le,ae);if(ge===i)return i;if(typeof me=="boolean")return ge;if(me){const te=me.when;if(typeof te=="string"){const Ee=(we,Z,pe,Pe)=>{if(!Pe||!ge(we,Z))return null;const Ne=te.replace("$(basename)",pe),We=Pe(Ne);return(0,D.isThenable)(We)?We.then(Ge=>Ge?le:null):We?le:null};return Ee.requiresSiblings=!0,Ee}}return ge}function G(le,me){const ae=le.filter(Z=>!!Z.basenames);if(ae.length<2)return le;const ge=ae.reduce((Z,pe)=>{const Pe=pe.basenames;return Pe?Z.concat(Pe):Z},[]);let te;if(me){te=[];for(let Z=0,pe=ge.length;Z<pe;Z++)te.push(me)}else te=ae.reduce((Z,pe)=>{const Pe=pe.patterns;return Pe?Z.concat(Pe):Z},[]);const Ee=function(Z,pe){if(typeof Z!="string")return null;if(!pe){let Ne;for(Ne=Z.length;Ne>0;Ne--){const We=Z.charCodeAt(Ne-1);if(We===47||We===92)break}pe=Z.substr(Ne)}const Pe=ge.indexOf(pe);return Pe!==-1?te[Pe]:null};Ee.basenames=ge,Ee.patterns=te,Ee.allBasenames=ge;const we=le.filter(Z=>!Z.basenames);return we.push(Ee),we}function M(le,me){return(0,a.equals)(le,me,(ae,ge)=>typeof ae=="string"&&typeof ge=="string"?ae===ge:typeof ae!="string"&&typeof ge!="string"?ae.base===ge.base&&ae.pattern===ge.pattern:!1)}e.patternsEquals=M}),define(Se[75],De([1,0,12,109,24,9,2]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(h="",c=!1){if(this.value=h,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(h,c=0){return this.value+=p(this.supportThemeIcons?(0,D.escapeIcons)(h):h).replace(/([ \t]+)/g,(y,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,c){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(h,c,y){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(h),")"),y&&(this.value+=` "${this._escape(this._escape(y,'"'),")")}"`),this.value+=")",this}_escape(h,c){const y=new RegExp((0,L.escapeRegExpCharacters)(c),"g");return h.replace(y,(_,l)=>h.charAt(l-1)!=="\\"?`\\${_}`:_)}}e.MarkdownString=b;function P(u){return R(u)?!u.value:Array.isArray(u)?u.every(P):!0}e.isEmptyMarkdownString=P;function R(u){return u instanceof b?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function v(u,h){return u===h?!0:!u||!h?!1:u.value===h.value&&u.isTrusted===h.isTrusted&&u.supportThemeIcons===h.supportThemeIcons&&u.supportHtml===h.supportHtml&&(u.baseUri===h.baseUri||!!u.baseUri&&!!h.baseUri&&(0,g.isEqual)(I.URI.from(u.baseUri),I.URI.from(h.baseUri)))}e.markdownStringEqual=v;function p(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=p;function w(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function f(u){const h=[],c=u.split("|").map(_=>_.trim());u=c[0];const y=c[1];if(y){const _=/height=(\d+)/.exec(y),l=/width=(\d+)/.exec(y),S=_?_[1]:"",n=l?l[1]:"",T=isFinite(parseInt(n)),i=isFinite(parseInt(S));T&&h.push(`width="${n}"`),i&&h.push(`height="${S}"`)}return{href:u,dimensions:h}}e.parseHrefAndDimensions=f}),define(Se[76],De([1,0,15,37,11,17,23,24,9,2]),function(ee,e,a,D,g,L,I,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(t,s){const{os:m,tildify:d,relative:C}=s;if(C){const A=v(t,C,m);if(typeof A=="string")return A}let O=t.fsPath;if(m===1&&!I.isWindows?O=O.replace(/\//g,"\\"):m!==1&&I.isWindows&&(O=O.replace(/\\/g,"/")),m!==1&&d?.userHome){let A=d.userHome.fsPath,E;t.scheme!==d.userHome.scheme&&t.path.startsWith(L.posix.sep)?E=d.userHome.with({path:t.path}).fsPath:E=t.fsPath,I.isWindows&&(E=(0,D.toSlashes)(E),A=(0,D.toSlashes)(A)),O=u(E,A,m)}return(m===1?L.win32:L.posix).normalize(w(O,m===1))}e.getPathLabel=R;function v(t,s,m){const d=m===1?L.win32:L.posix,C=m===3?k.extUri:k.extUriIgnorePathCase,O=s.getWorkspace(),U=(0,a.firstOrDefault)(O.folders);if(!U)return;t.scheme!==U.uri.scheme&&t.path.startsWith(L.posix.sep)&&(t=U.uri.with({path:t.path}));const A=s.getWorkspaceFolder(t);if(!A)return;let E;if(C.isEqual(A.uri,t)?E="":E=C.relativePath(A.uri,t)??"",E&&(E=d.normalize(E)),O.folders.length>1&&!s.noPrefix){const $=A.name?A.name:C.basenameOrAuthority(A.uri);E=E?`${$} \u2022 ${E}`:$}return E}function p(t){if(!t)return;typeof t=="string"&&(t=P.URI.file(t));const s=(0,k.basename)(t)||(t.scheme===g.Schemas.file?t.fsPath:t.path);return I.isWindows&&(0,D.isRootOrDriveLetter)(s)?w(s):s}e.getBaseLabel=p;function w(t,s=I.isWindows){return(0,D.hasDriveLetter)(t,s)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=w;let f=Object.create(null);function u(t,s,m=I.OS){if(m===1||!t||!s)return t;let d=f.original===s?f.normalized:void 0;return d||(d=`${(0,b.rtrim)(s,L.posix.sep)}${L.posix.sep}`,f={original:s,normalized:d}),(m===3?t.startsWith(d):(0,b.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=u;function h(t,s){return t.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=h;const c="\u2026",y="\\\\",_="~";function l(t,s=L.sep){const m=new Array(t.length);let d=!1;for(let C=0;C<t.length;C++){let O=t[C];if(O===""){m[C]=`.${s}`;continue}if(!O){m[C]=O;continue}d=!0;let U="";O.indexOf(y)===0?(U=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(s)===0?(U=O.substr(0,O.indexOf(s)+s.length),O=O.substr(O.indexOf(s)+s.length)):O.indexOf(_)===0&&(U=O.substr(0,O.indexOf(_)+_.length),O=O.substr(O.indexOf(_)+_.length));const A=O.split(s);for(let E=1;d&&E<=A.length;E++)for(let $=A.length-E;d&&$>=0;$--){d=!1;let x=A.slice($,$+E).join(s);for(let H=0;!d&&H<t.length;H++)if(H!==C&&t[H]&&t[H].indexOf(x)>-1){const oe=$+E===A.length,G=$>0&&t[H].indexOf(s)>-1?s+x:x,M=t[H].endsWith(G);d=!oe||M}if(!d){let H="";(A[0].endsWith(":")||U!=="")&&($===1&&($=0,E++,x=A[0]+s+x),$>0&&(H=A[0]+s),H=U+H),$>0&&(H=H+c+s),H=H+x,$+E<A.length&&(H=H+s+c),m[C]=H}}d&&(m[C]=O)}return m}e.shorten=l;var S;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function n(t,s=Object.create(null)){const m=[];let d=!1,C="";for(const O of t)if(O==="$"||d&&O==="{")C&&m.push({value:C,type:S.TEXT}),C="",d=!0;else if(O==="}"&&d){const U=s[C];if(typeof U=="string")U.length&&m.push({value:U,type:S.VARIABLE});else if(U){const A=m[m.length-1];(!A||A.type!==S.SEPARATOR)&&m.push({value:U.label,type:S.SEPARATOR})}C="",d=!1}else C+=O;return C&&!d&&m.push({value:C,type:S.TEXT}),m.filter((O,U)=>{if(O.type===S.SEPARATOR){const A=m[U-1],E=m[U+1];return[A,E].every($=>$&&($.type===S.VARIABLE||$.type===S.TEXT)&&$.value.length>0)}return!0}).map(O=>O.value).join("")}e.template=n;function T(t,s){return I.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):t.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=T;function i(t,s){return I.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,""):I.isWindows?t.replace(/&&|&/g,m=>m==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function o(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=o;function r(t){const s=t.indexOf("/")!==-1?L.posix:L.win32,m=s.basename(t),d=s.dirname(t);return m.length?{name:m,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(Se[112],De([1,0,2]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(R){return R.toJSON()}class g{constructor(v){this._uriTransformer=v}transformIncoming(v){const p=this._uriTransformer.transformIncoming(v);return p===v?v:D(a.URI.from(p))}transformOutgoing(v){const p=this._uriTransformer.transformOutgoing(v);return p===v?v:D(a.URI.from(p))}transformOutgoingURI(v){const p=this._uriTransformer.transformOutgoing(v);return p===v?v:a.URI.from(p)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=g,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,v,p){if(!R||p>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return v.transformOutgoing(R);for(let w in R)if(Object.hasOwnProperty.call(R,w)){const f=L(R[w],v,p+1);f!==null&&(R[w]=f)}}return null}function I(R,v){const p=L(R,v,0);return p===null?R:p}e.transformOutgoingURIs=I;function k(R,v,p,w){if(!R||w>200)return null;if(typeof R=="object"){if(R.$mid===1)return p?a.URI.revive(v.transformIncoming(R)):v.transformIncoming(R);for(let f in R)if(Object.hasOwnProperty.call(R,f)){const u=k(R[f],v,p,w+1);u!==null&&(R[f]=u)}}return null}function b(R,v){const p=k(R,v,!1,0);return p===null?R:p}e.transformIncomingURIs=b;function P(R,v){const p=k(R,v,!0,0);return p===null?R:p}e.transformAndReviveIncomingURIs=P}),define(Se[42],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(b){return a.test(b)}e.isUUID=D;const g=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(b){for(let P=0;P<b.length;P++)b[P]=Math.floor(Math.random()*256);return b};function k(){I(g),g[6]=g[6]&15|64,g[8]=g[8]&63|128;let b=0,P="";return P+=L[g[b++]],P+=L[g[b++]],P+=L[g[b++]],P+=L[g[b++]],P+="-",P+=L[g[b++]],P+=L[g[b++]],P+="-",P+=L[g[b++]],P+=L[g[b++]],P+="-",P+=L[g[b++]],P+=L[g[b++]],P+="-",P+=L[g[b++]],P+=L[g[b++]],P+=L[g[b++]],P+=L[g[b++]],P+=L[g[b++]],P+=L[g[b++]],P}e.generateUuid=k}),define(Se[113],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[114],De([1,0,33,17]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function g(L,I,k,b,P){if(Array.isArray(L)){let R=0;for(const v of L){const p=g(v,I,k,b,P);if(p===10)return p;p>R&&(R=p)}return R}else{if(typeof L=="string")return b?L==="*"?5:L===k?10:0:0;if(L){const{language:R,pattern:v,scheme:p,hasAccessToAllModels:w,notebookType:f}=L;if(!b&&!w)return 0;let u=0;if(p)if(p===I.scheme)u=10;else if(p==="*")u=5;else return 0;if(R)if(R===k)u=10;else if(R==="*")u=Math.max(u,5);else return 0;if(f)if(f===P)u=10;else if(f==="*"&&P!==void 0)u=Math.max(u,5);else return 0;if(v){let h;if(typeof v=="string"?h=v:h={...v,base:(0,D.normalize)(v.base)},h===I.fsPath||(0,a.match)(h,I.fsPath))u=10;else return 0}return u}else return 0}}e.score=g}),define(Se[115],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class D{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let b=0,P=k.notIn.length;b<P;b++)switch(k.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,b){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(b-2),R=k.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(k,b){for(let P=k;P<=b;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=D;class g{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of k)L(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),L(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),L(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),L(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&L(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=g;function L(I,k,b){I.has(k)?I.get(k).push(b):I.set(k,[b])}}),define(Se[77],De([1,0,25,23]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var g;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(g||(g={}));function L(v){for(let p=0,w=v.length;p<w;p+=4){const f=v[p+0],u=v[p+1],h=v[p+2],c=v[p+3];v[p+0]=c,v[p+1]=h,v[p+2]=u,v[p+3]=f}}function I(v){const p=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return D.isLittleEndian()||L(p),a.VSBuffer.wrap(p)}function k(v){const p=v.buffer;if(D.isLittleEndian()||L(p),p.byteOffset%4==0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const w=new Uint8Array(p.byteLength);return w.set(p),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function b(v){const p=new Uint32Array(P(v));let w=0;if(p[w++]=v.id,v.type==="full")p[w++]=1,p[w++]=v.data.length,p.set(v.data,w),w+=v.data.length;else{p[w++]=2,p[w++]=v.deltas.length;for(const f of v.deltas)p[w++]=f.start,p[w++]=f.deleteCount,f.data?(p[w++]=f.data.length,p.set(f.data,w),w+=f.data.length):p[w++]=0}return I(p)}e.encodeSemanticTokensDto=b;function P(v){let p=0;if(p+=1+1,v.type==="full")p+=1+v.data.length;else{p+=1,p+=(1+1+1)*v.deltas.length;for(const w of v.deltas)w.data&&(p+=w.data.length)}return p}function R(v){const p=k(v);let w=0;const f=p[w++];if(p[w++]===1){const y=p[w++],_=p.subarray(w,w+y);return w+=y,{id:f,type:"full",data:_}}const h=p[w++],c=[];for(let y=0;y<h;y++){const _=p[w++],l=p[w++],S=p[w++];let n;S>0&&(n=p.subarray(w,w+S),w+=S),c[y]={start:_,deleteCount:l,data:n}}return{id:f,type:"delta",deltas:c}}e.decodeSemanticTokensDto=R}),define(Se[116],De([18,19]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Se[117],De([1,0,116]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,g=D*60,L=g*24,I=L*7,k=L*30,b=L*365;function P(v,p,w){typeof v!="number"&&(v=v.getTime());const f=Math.round((new Date().getTime()-v)/1e3);if(f<-30)return(0,a.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let u;return f<D?(u=f,p?u===1?w?(0,a.localize)(2,null,u):(0,a.localize)(3,null,u):w?(0,a.localize)(4,null,u):(0,a.localize)(5,null,u):u===1?w?(0,a.localize)(6,null,u):(0,a.localize)(7,null,u):w?(0,a.localize)(8,null,u):(0,a.localize)(9,null,u)):f<g?(u=Math.floor(f/D),p?u===1?w?(0,a.localize)(10,null,u):(0,a.localize)(11,null,u):w?(0,a.localize)(12,null,u):(0,a.localize)(13,null,u):u===1?w?(0,a.localize)(14,null,u):(0,a.localize)(15,null,u):w?(0,a.localize)(16,null,u):(0,a.localize)(17,null,u)):f<L?(u=Math.floor(f/g),p?u===1?w?(0,a.localize)(18,null,u):(0,a.localize)(19,null,u):w?(0,a.localize)(20,null,u):(0,a.localize)(21,null,u):u===1?w?(0,a.localize)(22,null,u):(0,a.localize)(23,null,u):w?(0,a.localize)(24,null,u):(0,a.localize)(25,null,u)):f<I?(u=Math.floor(f/L),p?u===1?(0,a.localize)(26,null,u):(0,a.localize)(27,null,u):u===1?(0,a.localize)(28,null,u):(0,a.localize)(29,null,u)):f<k?(u=Math.floor(f/I),p?u===1?w?(0,a.localize)(30,null,u):(0,a.localize)(31,null,u):w?(0,a.localize)(32,null,u):(0,a.localize)(33,null,u):u===1?w?(0,a.localize)(34,null,u):(0,a.localize)(35,null,u):w?(0,a.localize)(36,null,u):(0,a.localize)(37,null,u)):f<b?(u=Math.floor(f/k),p?u===1?w?(0,a.localize)(38,null,u):(0,a.localize)(39,null,u):w?(0,a.localize)(40,null,u):(0,a.localize)(41,null,u):u===1?w?(0,a.localize)(42,null,u):(0,a.localize)(43,null,u):w?(0,a.localize)(44,null,u):(0,a.localize)(45,null,u)):(u=Math.floor(f/b),p?u===1?w?(0,a.localize)(46,null,u):(0,a.localize)(47,null,u):w?(0,a.localize)(48,null,u):(0,a.localize)(49,null,u):u===1?w?(0,a.localize)(50,null,u):(0,a.localize)(51,null,u):w?(0,a.localize)(52,null,u):(0,a.localize)(53,null,u))}e.fromNow=P;function R(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[118],De([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Se[43],De([1,0,15,10,118]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(v,p){return p&&(v.stack||v.stacktrace)?g.localize(0,null,k(v),I(v.stack)||I(v.stacktrace)):k(v)}function I(v){return Array.isArray(v)?v.join(`
`):v}function k(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?g.localize(1,null,v.message):v.message||g.localize(2,null)}function b(v=null,p=!1){if(!v)return g.localize(3,null);if(Array.isArray(v)){const w=a.coalesce(v),f=b(w[0],p);return w.length>1?g.localize(4,null,f,w.length):f}if(D.isString(v))return v;if(v.detail){const w=v.detail;if(w.error)return L(w.error,p);if(w.exception)return L(w.exception,p)}return v.stack?L(v,p):v.message?v.message:g.localize(5,null)}e.toErrorMessage=b;function P(v){const p=v;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=P;function R(v,p){let w;return typeof v=="string"?w=new Error(v):w=v,w.actions=p,w}e.createErrorWithActions=R}),define(Se[119],De([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Se[120],De([1,0,119,23,121,15,27,113]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=P;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class v{constructor(X,he,Le,xe){this.id=X,this.name=he,this.defaultValue=Le,this.schema=xe}applyUpdate(X,he){return w(X,he)}compute(X,he,Le){return Le}}class p{constructor(X,he){this.newValue=X,this.didChange=he}}e.ApplyUpdateResult=p;function w(q,X){if(typeof q!="object"||typeof X!="object"||!q||!X)return new p(X,q!==X);if(Array.isArray(q)||Array.isArray(X)){const Le=Array.isArray(q)&&Array.isArray(X)&&L.equals(q,X);return new p(X,Le)}let he=!1;for(const Le in X)if(X.hasOwnProperty(Le)){const xe=w(q[Le],X[Le]);xe.didChange&&(q[Le]=xe.newValue,he=!0)}return new p(q,he)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,he){return w(X,he)}validate(X){return this.defaultValue}}class u{constructor(X,he,Le,xe){this.id=X,this.name=he,this.defaultValue=Le,this.schema=xe}applyUpdate(X,he){return w(X,he)}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,he,Le){return Le}}function h(q,X){return typeof q=="undefined"?X:q==="false"?!1:Boolean(q)}e.boolean=h;class c extends u{constructor(X,he,Le,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Le);super(X,he,Le,xe)}validate(X){return h(X,this.defaultValue)}}function y(q,X,he,Le){if(typeof q=="undefined")return X;let xe=parseInt(q,10);return isNaN(xe)?X:(xe=Math.max(he,xe),xe=Math.min(Le,xe),xe|0)}e.clampedInt=y;class _ extends u{constructor(X,he,Le,xe,Xe,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Le,Je.minimum=xe,Je.maximum=Xe);super(X,he,Le,Je);this.minimum=xe,this.maximum=Xe}static clampedInt(X,he,Le,xe){return y(X,he,Le,xe)}validate(X){return _.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class l extends u{constructor(X,he,Le,xe,Xe){typeof Xe!="undefined"&&(Xe.type="number",Xe.default=Le);super(X,he,Le,Xe);this.validationFn=xe}static clamp(X,he,Le){return X<he?he:X>Le?Le:X}static float(X,he){if(typeof X=="number")return X;if(typeof X=="undefined")return he;const Le=parseFloat(X);return isNaN(Le)?he:Le}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class S extends u{static string(X,he){return typeof X!="string"?he:X}constructor(X,he,Le,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Le);super(X,he,Le,xe)}validate(X){return S.string(X,this.defaultValue)}}function n(q,X,he){return typeof q!="string"||he.indexOf(q)===-1?X:q}e.stringSet=n;class T extends u{constructor(X,he,Le,xe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=xe,Xe.default=Le);super(X,he,Le,Xe);this._allowedValues=xe}validate(X){return n(X,this.defaultValue,this._allowedValues)}}class i extends v{constructor(X,he,Le,xe,Xe,Je,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Xe,rt.default=xe);super(X,he,Le,rt);this._allowedValues=Xe,this._convert=Je}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function o(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends v{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,he,Le){return Le===0?X.accessibilitySupport:Le}}class t extends v{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:a.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{insertSpace:h(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(q){switch(q){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function O(q){switch(q){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class U extends f{constructor(){super(128)}compute(X,he,Le){const xe=["monaco-editor"];return he.get(33)&&xe.push(he.get(33)),X.extraEditorClassName&&xe.push(X.extraEditorClassName),he.get(66)==="default"?xe.push("mouse-default"):he.get(66)==="copy"&&xe.push("mouse-copy"),he.get(100)&&xe.push("showUnused"),he.get(126)&&xe.push("showDeprecated"),xe.join(" ")}}class A extends c{constructor(){super(32,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(X,he,Le){return Le&&X.emptySelectionClipboard}}class E extends v{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:a.localize(16,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:a.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{cursorMoveOnType:h(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":n(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":n(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(he.loop,this.defaultValue.loop)}}}class $ extends v{constructor(){super(45,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?$.OFF:X==="true"?$.ON:X:Boolean(X)?$.ON:$.OFF}}e.EditorFontLigatures=$,$.OFF='"liga" off, "calt" off',$.ON='"liga" on, "calt" on';class x extends f{constructor(){super(44)}compute(X,he,Le){return X.fontInfo}}class H extends u{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(X){const he=l.float(X,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(he,6,100)}compute(X,he,Le){return X.fontInfo.fontSize}}class oe extends v{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:oe.MINIMUM_VALUE,maximum:oe.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:oe.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(_.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,oe.MINIMUM_VALUE,oe.MAXIMUM_VALUE))}}oe.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],oe.MINIMUM_VALUE=1,oe.MAXIMUM_VALUE=1e3;class G extends v{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Le,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Le,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Le,description:a.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{multiple:n(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??n(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??n(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??n(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??n(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??n(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class M extends v{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:a.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),delay:_.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:h(he.sticky,this.defaultValue.sticky),above:h(he.above,this.defaultValue.above)}}}var le;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(le=e.RenderMinimap||(e.RenderMinimap={}));class me extends f{constructor(){super(131)}compute(X,he,Le){return me.computeLayout(he,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const he=X.height/X.lineHeight,Le=X.scrollBeyondLastLine?he-1:0,xe=(X.viewLineCount+Le)/(X.pixelRatio*X.height),Xe=Math.floor(X.viewLineCount/xe);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:xe,minimapLineCount:Xe}}static _computeMinimapLayout(X,he){const Le=X.outerWidth,xe=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Je=he.stableMinimapLayoutInput,rt=Je&&X.outerHeight===Je.outerHeight&&X.lineHeight===Je.lineHeight&&X.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&X.pixelRatio===Je.pixelRatio&&X.scrollBeyondLastLine===Je.scrollBeyondLastLine&&X.minimap.enabled===Je.minimap.enabled&&X.minimap.side===Je.minimap.side&&X.minimap.size===Je.minimap.size&&X.minimap.showSlider===Je.minimap.showSlider&&X.minimap.renderCharacters===Je.minimap.renderCharacters&&X.minimap.maxColumn===Je.minimap.maxColumn&&X.minimap.scale===Je.minimap.scale&&X.verticalScrollbarWidth===Je.verticalScrollbarWidth&&X.isViewportWrapping===Je.isViewportWrapping,Ye=X.lineHeight,Ze=X.typicalHalfwidthCharacterWidth,qe=X.scrollBeyondLastLine,lt=X.minimap.renderCharacters;let st=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const It=X.minimap.maxColumn,at=X.minimap.size,ht=X.minimap.side,Ut=X.verticalScrollbarWidth,Ft=X.viewLineCount,yt=X.remainingWidth,ft=X.isViewportWrapping,Dt=lt?2:3;let Pt=Math.floor(Xe*xe);const Nt=Pt/Xe;let He=!1,$t=!1,At=Dt*st,Mt=st/Xe,be=1;if(at==="fill"||at==="fit"){const{typicalViewportLineCount:je,extraLinesBeyondLastLine:ot,desiredRatio:ct,minimapLineCount:pt}=me.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:qe,height:xe,lineHeight:Ye,pixelRatio:Xe});if(Ft/pt>1)He=!0,$t=!0,st=1,At=1,Mt=st/Xe;else{let mt=!1,vt=st+1;if(at==="fit"){const Rt=Math.ceil((Ft+ot)*At);ft&&rt&&yt<=he.stableFitRemainingWidth?(mt=!0,vt=he.stableFitMaxMinimapScale):mt=Rt>Pt}if(at==="fill"||mt){He=!0;const Rt=st;At=Math.min(Ye*Xe,Math.max(1,Math.floor(1/ct))),ft&&rt&&yt<=he.stableFitRemainingWidth&&(vt=he.stableFitMaxMinimapScale),st=Math.min(vt,Math.max(1,Math.floor(At/Dt))),st>Rt&&(be=Math.min(2,st/Rt)),Mt=st/Xe/be,Pt=Math.ceil(Math.max(je,Ft+ot)*At),ft?(he.stableMinimapLayoutInput=X,he.stableFitRemainingWidth=yt,he.stableFitMaxMinimapScale=st):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const ye=Math.floor(It*Mt),de=Math.min(ye,Math.max(0,Math.floor((yt-Ut-2)*Mt/(Ze+Mt)))+e.MINIMAP_GUTTER_WIDTH);let j=Math.floor(Xe*de);const Ae=j/Xe;j=Math.floor(j*be);const Be=lt?1:2,tt=ht==="left"?0:Le-de-Ut;return{renderMinimap:Be,minimapLeft:tt,minimapWidth:de,minimapHeightIsEditorHeight:He,minimapIsSampling:$t,minimapScale:st,minimapLineHeight:At,minimapCanvasInnerWidth:j,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:Ae,minimapCanvasOuterHeight:Nt}}static computeLayout(X,he){const Le=he.outerWidth|0,xe=he.outerHeight|0,Xe=he.lineHeight|0,Je=he.lineNumbersDigitCount|0,rt=he.typicalHalfwidthCharacterWidth,Ye=he.maxDigitWidth,Ze=he.pixelRatio,qe=he.viewLineCount,lt=X.get(123),st=lt==="inherit"?X.get(122):lt,It=st==="inherit"?X.get(118):st,at=X.get(121),ht=X.get(2),Ut=he.isDominatedByLongLines,Ft=X.get(50),yt=X.get(60).renderType!==0,ft=X.get(61),Dt=X.get(94),Pt=X.get(65),Nt=X.get(92),He=Nt.verticalScrollbarSize,$t=Nt.verticalHasArrows,At=Nt.arrowSize,Mt=Nt.horizontalScrollbarSize,be=X.get(58),ye=X.get(37);let de;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Qt=parseFloat(be.substr(0,be.length-2));de=_.clampedInt(Qt*rt,0,0,1e3)}else de=_.clampedInt(be,0,0,1e3);ye&&(de+=16);let j=0;if(yt){const Qt=Math.max(Je,ft);j=Math.round(Qt*Ye)}let Ae=0;Ft&&(Ae=Xe);let Be=0,tt=Be+Ae,je=tt+j,ot=je+de;const ct=Le-Ae-j-de;let pt=!1,_t=!1,mt=-1;ht!==2&&(st==="inherit"&&Ut?(pt=!0,_t=!0):It==="on"||It==="bounded"?_t=!0:It==="wordWrapColumn"&&(mt=at));const vt=me._computeMinimapLayout({outerWidth:Le,outerHeight:xe,lineHeight:Xe,typicalHalfwidthCharacterWidth:rt,pixelRatio:Ze,scrollBeyondLastLine:Dt,minimap:Pt,verticalScrollbarWidth:He,viewLineCount:qe,remainingWidth:ct,isViewportWrapping:_t},he.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Be+=vt.minimapWidth,tt+=vt.minimapWidth,je+=vt.minimapWidth,ot+=vt.minimapWidth);const Rt=ct-vt.minimapWidth,Et=Math.max(1,Math.floor((Rt-He-2)/rt)),Gt=$t?At:0;return _t&&(mt=Math.max(1,Et),It==="bounded"&&(mt=Math.min(mt,at))),{width:Le,height:xe,glyphMarginLeft:Be,glyphMarginWidth:Ae,lineNumbersLeft:tt,lineNumbersWidth:j,decorationsLeft:je,decorationsWidth:de,contentLeft:ot,contentWidth:Rt,minimap:vt,viewportColumn:Et,isWordWrapMinified:pt,isViewportWrapping:_t,wrappingColumn:mt,verticalScrollbarWidth:He,horizontalScrollbarHeight:Mt,overviewRuler:{top:Gt,width:He,height:xe-2*Gt,right:0}}}}e.EditorLayoutInfoComputer=me;class ae extends v{constructor(){const X={enabled:!0};super(57,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:a.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}class ge extends v{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",displayStyle:"compact"};super(127,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:a.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(45,null),a.localize(46,null),a.localize(47,null),a.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:a.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:a.localize(50,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:n(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:_.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(he.fontFamily,this.defaultValue.fontFamily),displayStyle:n(he.displayStyle,this.defaultValue.displayStyle,["standard","compact"])}}}class te extends l{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:a.localize(51,null)})}compute(X,he,Le){return X.fontInfo.lineHeight}}class Ee extends v{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:a.localize(52,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(53,null),a.localize(54,null),a.localize(55,null)],default:X.size,description:a.localize(56,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:a.localize(57,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:a.localize(58,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(59,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:a.localize(60,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:a.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),size:n(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(he.side,this.defaultValue.side,["right","left"]),showSlider:n(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(he.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(he.scale,1,1,3),maxColumn:_.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(q){return q==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends v{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(62,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(63,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{top:_.clampedInt(he.top,0,0,1e3),bottom:_.clampedInt(he.bottom,0,0,1e3)}}}class pe extends v{constructor(){const X={enabled:!0,cycle:!1};super(76,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:a.localize(64,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:a.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),cycle:h(he.cycle,this.defaultValue.cycle)}}}class Pe extends f{constructor(){super(129)}compute(X,he,Le){return X.pixelRatio}}class Ne extends v{constructor(){const X={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]}];super(79,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{anyOf:he,default:X.strings,description:a.localize(69,null)},comments:{anyOf:he,default:X.comments,description:a.localize(70,null)},other:{anyOf:he,default:X.other,description:a.localize(71,null)}}}],default:X,markdownDescription:a.localize(72,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Ze=X?"on":"off";return{comments:Ze,strings:Ze,other:Ze}}if(!X||typeof X!="object")return this.defaultValue;const{other:he,comments:Le,strings:xe}=X,Xe=["on","inline","off"];let Je,rt,Ye;return typeof he=="boolean"?Je=he?"on":"off":Je=n(he,this.defaultValue.other,Xe),typeof Le=="boolean"?rt=Le?"on":"off":rt=n(Le,this.defaultValue.comments,Xe),typeof xe=="boolean"?Ye=xe?"on":"off":Ye=n(xe,this.defaultValue.strings,Xe),{other:Je,comments:rt,strings:Ye}}}var We;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ge extends v{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(73,null),a.localize(74,null),a.localize(75,null),a.localize(76,null)],default:"on",description:a.localize(77,null)})}validate(X){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(he=4,Le=X):X==="interval"?he=3:X==="relative"?he=2:X==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function Ce(q){const X=q.get(87);return X==="editable"?q.get(81):X!=="on"}e.filterValidationDecorations=Ce;class _e extends v{constructor(){const X=[],he={type:"number",description:a.localize(78,null)};super(91,"rulers",X,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:a.localize(79,null),format:"color-hex"}}}]},default:X,description:a.localize(80,null)})}validate(X){if(Array.isArray(X)){const he=[];for(let Le of X)if(typeof Le=="number")he.push({column:_.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const xe=Le;he.push({column:_.clampedInt(xe.column,0,0,1e4),color:xe.color})}return he.sort((Le,xe)=>Le.column-xe.column),he}return this.defaultValue}}function Te(q,X){if(typeof q!="string")return X;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class se extends v{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(81,null),a.localize(82,null),a.localize(83,null)],default:"auto",description:a.localize(84,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"auto",description:a.localize(88,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:a.localize(89,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:a.localize(90,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:a.localize(91,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X,Le=_.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=_.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Te(he.vertical,this.defaultValue.vertical),horizontal:Te(he.horizontal,this.defaultValue.horizontal),useShadows:h(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:_.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:_.clampedInt(he.verticalSliderSize,xe,0,1e3),scrollByPage:h(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ue extends v{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:a.localize(92,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:a.localize(93,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:a.localize(94,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:a.localize(95,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:a.localize(96,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:a.localize(97,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:a.localize(98,null)}})}applyUpdate(X,he){let Le=!1;he.allowedCharacters&&(I.equals(X.allowedCharacters,he.allowedCharacters)||(X={...X,allowedCharacters:he.allowedCharacters},Le=!0)),he.allowedLocales&&(I.equals(X.allowedLocales,he.allowedLocales)||(X={...X,allowedLocales:he.allowedLocales},Le=!0));const xe=super.applyUpdate(X,he);return Le?new p(xe.newValue,!0):xe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{nonBasicASCII:ve(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ve(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ve(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,he){if(typeof X!="object"||!X)return he;const Le={};for(const[xe,Xe]of Object.entries(X))Xe===!0&&(Le[xe]=!0);return Le}}class Q extends v{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:a.localize(99,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),mode:n(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class J extends v{constructor(){const X={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(100,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:a.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ce extends v{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(102,null),a.localize(103,null),a.localize(104,null)],default:X.bracketPairs,description:a.localize(105,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(106,null),a.localize(107,null),a.localize(108,null)],default:X.bracketPairsHorizontal,description:a.localize(109,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:a.localize(110,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:a.localize(111,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(112,null),a.localize(113,null),a.localize(114,null)],default:X.highlightActiveIndentation,description:a.localize(115,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{bracketPairs:ve(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ve(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:ve(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ve(q,X,he){const Le=he.indexOf(q);return Le===-1?X:he[Le]}class F extends v{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(116,null),a.localize(117,null)],default:X.insertMode,description:a.localize(118,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:a.localize(119,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:a.localize(120,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:a.localize(121,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:a.localize(122,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:a.localize(123,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:a.localize(124,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:a.localize(125,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:a.localize(126,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(127,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(128,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(129,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(130,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(131,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{insertMode:n(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(he.showIcons,this.defaultValue.showIcons),showStatusBar:h(he.showStatusBar,this.defaultValue.showStatusBar),preview:h(he.preview,this.defaultValue.preview),previewMode:n(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(he.showMethods,this.defaultValue.showMethods),showFunctions:h(he.showFunctions,this.defaultValue.showFunctions),showConstructors:h(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(he.showDeprecated,this.defaultValue.showDeprecated),showFields:h(he.showFields,this.defaultValue.showFields),showVariables:h(he.showVariables,this.defaultValue.showVariables),showClasses:h(he.showClasses,this.defaultValue.showClasses),showStructs:h(he.showStructs,this.defaultValue.showStructs),showInterfaces:h(he.showInterfaces,this.defaultValue.showInterfaces),showModules:h(he.showModules,this.defaultValue.showModules),showProperties:h(he.showProperties,this.defaultValue.showProperties),showEvents:h(he.showEvents,this.defaultValue.showEvents),showOperators:h(he.showOperators,this.defaultValue.showOperators),showUnits:h(he.showUnits,this.defaultValue.showUnits),showValues:h(he.showValues,this.defaultValue.showValues),showConstants:h(he.showConstants,this.defaultValue.showConstants),showEnums:h(he.showEnums,this.defaultValue.showEnums),showEnumMembers:h(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(he.showKeywords,this.defaultValue.showKeywords),showWords:h(he.showWords,this.defaultValue.showWords),showColors:h(he.showColors,this.defaultValue.showColors),showFiles:h(he.showFiles,this.defaultValue.showFiles),showReferences:h(he.showReferences,this.defaultValue.showReferences),showFolders:h(he.showFolders,this.defaultValue.showFolders),showTypeParameters:h(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(he.showSnippets,this.defaultValue.showSnippets),showUsers:h(he.showUsers,this.defaultValue.showUsers),showIssues:h(he.showIssues,this.defaultValue.showIssues)}}}class W extends v{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(158,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class V extends f{constructor(){super(130)}compute(X,he,Le){return he.get(81)?!0:X.tabFocusMode}}var K;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(K=e.WrappingIndent||(e.WrappingIndent={}));function z(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Y extends f{constructor(){super(132)}compute(X,he,Le){const xe=he.get(131);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const ie="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Fe:D.isLinux?Ue:ie,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(q){return e.editorOptionsRegistry[q.id]=q,q}var Ve;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.foldingMaximumRegions=41]="foldingMaximumRegions",q[q.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=43]="fontFamily",q[q.fontInfo=44]="fontInfo",q[q.fontLigatures=45]="fontLigatures",q[q.fontSize=46]="fontSize",q[q.fontWeight=47]="fontWeight",q[q.formatOnPaste=48]="formatOnPaste",q[q.formatOnType=49]="formatOnType",q[q.glyphMargin=50]="glyphMargin",q[q.gotoLocation=51]="gotoLocation",q[q.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",q[q.hover=53]="hover",q[q.inDiffEditor=54]="inDiffEditor",q[q.inlineSuggest=55]="inlineSuggest",q[q.letterSpacing=56]="letterSpacing",q[q.lightbulb=57]="lightbulb",q[q.lineDecorationsWidth=58]="lineDecorationsWidth",q[q.lineHeight=59]="lineHeight",q[q.lineNumbers=60]="lineNumbers",q[q.lineNumbersMinChars=61]="lineNumbersMinChars",q[q.linkedEditing=62]="linkedEditing",q[q.links=63]="links",q[q.matchBrackets=64]="matchBrackets",q[q.minimap=65]="minimap",q[q.mouseStyle=66]="mouseStyle",q[q.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=68]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",q[q.multiCursorModifier=70]="multiCursorModifier",q[q.multiCursorPaste=71]="multiCursorPaste",q[q.occurrencesHighlight=72]="occurrencesHighlight",q[q.overviewRulerBorder=73]="overviewRulerBorder",q[q.overviewRulerLanes=74]="overviewRulerLanes",q[q.padding=75]="padding",q[q.parameterHints=76]="parameterHints",q[q.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",q[q.quickSuggestions=79]="quickSuggestions",q[q.quickSuggestionsDelay=80]="quickSuggestionsDelay",q[q.readOnly=81]="readOnly",q[q.renameOnType=82]="renameOnType",q[q.renderControlCharacters=83]="renderControlCharacters",q[q.renderFinalNewline=84]="renderFinalNewline",q[q.renderLineHighlight=85]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=87]="renderValidationDecorations",q[q.renderWhitespace=88]="renderWhitespace",q[q.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",q[q.roundedSelection=90]="roundedSelection",q[q.rulers=91]="rulers",q[q.scrollbar=92]="scrollbar",q[q.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=94]="scrollBeyondLastLine",q[q.scrollPredominantAxis=95]="scrollPredominantAxis",q[q.selectionClipboard=96]="selectionClipboard",q[q.selectionHighlight=97]="selectionHighlight",q[q.selectOnLineNumbers=98]="selectOnLineNumbers",q[q.showFoldingControls=99]="showFoldingControls",q[q.showUnused=100]="showUnused",q[q.snippetSuggestions=101]="snippetSuggestions",q[q.smartSelect=102]="smartSelect",q[q.smoothScrolling=103]="smoothScrolling",q[q.stickyTabStops=104]="stickyTabStops",q[q.stopRenderingLineAfter=105]="stopRenderingLineAfter",q[q.suggest=106]="suggest",q[q.suggestFontSize=107]="suggestFontSize",q[q.suggestLineHeight=108]="suggestLineHeight",q[q.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",q[q.suggestSelection=110]="suggestSelection",q[q.tabCompletion=111]="tabCompletion",q[q.tabIndex=112]="tabIndex",q[q.unicodeHighlighting=113]="unicodeHighlighting",q[q.unusualLineTerminators=114]="unusualLineTerminators",q[q.useShadowDOM=115]="useShadowDOM",q[q.useTabStops=116]="useTabStops",q[q.wordSeparators=117]="wordSeparators",q[q.wordWrap=118]="wordWrap",q[q.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=121]="wordWrapColumn",q[q.wordWrapOverride1=122]="wordWrapOverride1",q[q.wordWrapOverride2=123]="wordWrapOverride2",q[q.wrappingIndent=124]="wrappingIndent",q[q.wrappingStrategy=125]="wrappingStrategy",q[q.showDeprecated=126]="showDeprecated",q[q.inlayHints=127]="inlayHints",q[q.editorClassName=128]="editorClassName",q[q.pixelRatio=129]="pixelRatio",q[q.tabFocusMode=130]="tabFocusMode",q[q.layoutInfo=131]="layoutInfo",q[q.wrappingInfo=132]="wrappingInfo"})(Ve=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(159,null)})),acceptSuggestionOnEnter:ke(new T(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(160,null),""],markdownDescription:a.localize(161,null)})),accessibilitySupport:ke(new r),accessibilityPageSize:ke(new _(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(162,null)})),ariaLabel:ke(new S(4,"ariaLabel",a.localize(163,null))),autoClosingBrackets:ke(new T(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(164,null),a.localize(165,null),""],description:a.localize(166,null)})),autoClosingDelete:ke(new T(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(167,null),""],description:a.localize(168,null)})),autoClosingOvertype:ke(new T(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(169,null),""],description:a.localize(170,null)})),autoClosingQuotes:ke(new T(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(171,null),a.localize(172,null),""],description:a.localize(173,null)})),autoIndent:ke(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[a.localize(174,null),a.localize(175,null),a.localize(176,null),a.localize(177,null),a.localize(178,null)],description:a.localize(179,null)})),automaticLayout:ke(new c(10,"automaticLayout",!1)),autoSurround:ke(new T(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(180,null),a.localize(181,null),a.localize(182,null),""],description:a.localize(183,null)})),bracketPairColorization:ke(new J),bracketPairGuides:ke(new ce),stickyTabStops:ke(new c(104,"stickyTabStops",!1,{description:a.localize(184,null)})),codeLens:ke(new c(14,"codeLens",!0,{description:a.localize(185,null)})),codeLensFontFamily:ke(new S(15,"codeLensFontFamily","",{description:a.localize(186,null)})),codeLensFontSize:ke(new _(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(187,null)})),colorDecorators:ke(new c(17,"colorDecorators",!0,{description:a.localize(188,null)})),columnSelection:ke(new c(18,"columnSelection",!1,{description:a.localize(189,null)})),comments:ke(new t),contextmenu:ke(new c(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new c(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(190,null)})),cursorBlinking:ke(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:a.localize(191,null)})),cursorSmoothCaretAnimation:ke(new c(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(192,null)})),cursorStyle:ke(new i(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:a.localize(193,null)})),cursorSurroundingLines:ke(new _(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(194,null)})),cursorSurroundingLinesStyle:ke(new T(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(195,null),a.localize(196,null)],description:a.localize(197,null)})),cursorWidth:ke(new _(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(198,null)})),disableLayerHinting:ke(new c(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new c(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new c(30,"domReadOnly",!1)),dragAndDrop:ke(new c(31,"dragAndDrop",!0,{description:a.localize(199,null)})),emptySelectionClipboard:ke(new A),extraEditorClassName:ke(new S(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:a.localize(200,null)})),find:ke(new E),fixedOverflowWidgets:ke(new c(36,"fixedOverflowWidgets",!1)),folding:ke(new c(37,"folding",!0,{description:a.localize(201,null)})),foldingStrategy:ke(new T(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),foldingHighlight:ke(new c(39,"foldingHighlight",!0,{description:a.localize(205,null)})),foldingImportsByDefault:ke(new c(40,"foldingImportsByDefault",!1,{description:a.localize(206,null)})),foldingMaximumRegions:ke(new _(41,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(207,null)})),unfoldOnClickAfterEndOfLine:ke(new c(42,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(208,null)})),fontFamily:ke(new S(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(209,null)})),fontInfo:ke(new x),fontLigatures2:ke(new $),fontSize:ke(new H),fontWeight:ke(new oe),formatOnPaste:ke(new c(48,"formatOnPaste",!1,{description:a.localize(210,null)})),formatOnType:ke(new c(49,"formatOnType",!1,{description:a.localize(211,null)})),glyphMargin:ke(new c(50,"glyphMargin",!0,{description:a.localize(212,null)})),gotoLocation:ke(new G),hideCursorInOverviewRuler:ke(new c(52,"hideCursorInOverviewRuler",!1,{description:a.localize(213,null)})),hover:ke(new M),inDiffEditor:ke(new c(54,"inDiffEditor",!1)),letterSpacing:ke(new l(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>l.clamp(q,-5,20),{description:a.localize(214,null)})),lightbulb:ke(new ae),lineDecorationsWidth:ke(new u(58,"lineDecorationsWidth",10)),lineHeight:ke(new te),lineNumbers:ke(new Ge),lineNumbersMinChars:ke(new _(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new c(62,"linkedEditing",!1,{description:a.localize(215,null)})),links:ke(new c(63,"links",!0,{description:a.localize(216,null)})),matchBrackets:ke(new T(64,"matchBrackets","always",["always","near","never"],{description:a.localize(217,null)})),minimap:ke(new Ee),mouseStyle:ke(new T(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(67,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:a.localize(218,null)})),mouseWheelZoom:ke(new c(68,"mouseWheelZoom",!1,{markdownDescription:a.localize(219,null)})),multiCursorMergeOverlapping:ke(new c(69,"multiCursorMergeOverlapping",!0,{description:a.localize(220,null)})),multiCursorModifier:ke(new i(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[a.localize(221,null),a.localize(222,null)],markdownDescription:a.localize(223,null)})),multiCursorPaste:ke(new T(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(224,null),a.localize(225,null)],markdownDescription:a.localize(226,null)})),occurrencesHighlight:ke(new c(72,"occurrencesHighlight",!0,{description:a.localize(227,null)})),overviewRulerBorder:ke(new c(73,"overviewRulerBorder",!0,{description:a.localize(228,null)})),overviewRulerLanes:ke(new _(74,"overviewRulerLanes",3,0,3)),padding:ke(new Z),parameterHints:ke(new pe),peekWidgetDefaultFocus:ke(new T(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(229,null),a.localize(230,null)],description:a.localize(231,null)})),definitionLinkOpensInPeek:ke(new c(78,"definitionLinkOpensInPeek",!1,{description:a.localize(232,null)})),quickSuggestions:ke(new Ne),quickSuggestionsDelay:ke(new _(80,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(233,null)})),readOnly:ke(new c(81,"readOnly",!1)),renameOnType:ke(new c(82,"renameOnType",!1,{description:a.localize(234,null),markdownDeprecationMessage:a.localize(235,null)})),renderControlCharacters:ke(new c(83,"renderControlCharacters",!0,{description:a.localize(236,null),restricted:!0})),renderFinalNewline:ke(new c(84,"renderFinalNewline",!0,{description:a.localize(237,null)})),renderLineHighlight:ke(new T(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(238,null)],description:a.localize(239,null)})),renderLineHighlightOnlyWhenFocus:ke(new c(86,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(240,null)})),renderValidationDecorations:ke(new T(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new T(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(241,null),a.localize(242,null),a.localize(243,null),""],description:a.localize(244,null)})),revealHorizontalRightPadding:ke(new _(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new c(90,"roundedSelection",!0,{description:a.localize(245,null)})),rulers:ke(new _e),scrollbar:ke(new se),scrollBeyondLastColumn:ke(new _(93,"scrollBeyondLastColumn",5,0,1073741824,{description:a.localize(246,null)})),scrollBeyondLastLine:ke(new c(94,"scrollBeyondLastLine",!0,{description:a.localize(247,null)})),scrollPredominantAxis:ke(new c(95,"scrollPredominantAxis",!0,{description:a.localize(248,null)})),selectionClipboard:ke(new c(96,"selectionClipboard",!0,{description:a.localize(249,null),included:D.isLinux})),selectionHighlight:ke(new c(97,"selectionHighlight",!0,{description:a.localize(250,null)})),selectOnLineNumbers:ke(new c(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new T(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[a.localize(251,null),a.localize(252,null)],description:a.localize(253,null)})),showUnused:ke(new c(100,"showUnused",!0,{description:a.localize(254,null)})),showDeprecated:ke(new c(126,"showDeprecated",!0,{description:a.localize(255,null)})),inlayHints:ke(new ge),snippetSuggestions:ke(new T(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(256,null),a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),smartSelect:ke(new W),smoothScrolling:ke(new c(103,"smoothScrolling",!1,{description:a.localize(261,null)})),stopRenderingLineAfter:ke(new _(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new F),inlineSuggest:ke(new Q),suggestFontSize:ke(new _(107,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(262,null)})),suggestLineHeight:ke(new _(108,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(263,null)})),suggestOnTriggerCharacters:ke(new c(109,"suggestOnTriggerCharacters",!0,{description:a.localize(264,null)})),suggestSelection:ke(new T(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(265,null),a.localize(266,null),a.localize(267,null)],description:a.localize(268,null)})),tabCompletion:ke(new T(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(269,null),a.localize(270,null),a.localize(271,null)],description:a.localize(272,null)})),tabIndex:ke(new _(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new ue),unusualLineTerminators:ke(new T(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(273,null),a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),useShadowDOM:ke(new c(115,"useShadowDOM",!0)),useTabStops:ke(new c(116,"useTabStops",!0,{description:a.localize(277,null)})),wordSeparators:ke(new S(117,"wordSeparators",g.USUAL_WORD_SEPARATORS,{description:a.localize(278,null)})),wordWrap:ke(new T(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(279,null),a.localize(280,null),a.localize(281,null),a.localize(282,null)],description:a.localize(283,null)})),wordWrapBreakAfterCharacters:ke(new S(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new S(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new _(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(284,null)})),wordWrapOverride1:ke(new T(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new T(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new i(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],z,{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null),a.localize(288,null)],description:a.localize(289,null)})),wrappingStrategy:ke(new T(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(290,null),a.localize(291,null)],description:a.localize(292,null)})),editorClassName:ke(new U),pixelRatio:ke(new Pe),tabFocusMode:ke(new V),layoutInfo:ke(new me),wrappingInfo:ke(new Y)}}),define(Se[122],De([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[123],De([18,19]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[124],De([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[125],De([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Se[126],De([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Se[127],De([18,19]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Se[128],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[129],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[130],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[131],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[132],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[133],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[134],De([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[135],De([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Se[136],De([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[137],De([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[138],De([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Se[139],De([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[140],De([18,19]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[141],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var a;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var D;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(D=e.EditorResolution||(e.EditorResolution={}));var g;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(g=e.EditorOpenSource||(e.EditorOpenSource={}));var L;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(L=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var I;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(I=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Se[142],De([1,0,24,32,124,231]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function b(c){return c=c.trim(),c==="*"||I.test(c)}e.isValidVersionStr=b;function P(c){if(!b(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=c.match(I);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=P;function R(c){if(!c)return null;let y=c.majorBase,_=c.majorMustEqual,l=c.minorBase,S=c.minorMustEqual,n=c.patchBase,T=c.patchMustEqual;c.hasCaret&&(y===0||(S=!1),T=!1);let i=0;if(c.preRelease){const o=k.exec(c.preRelease);if(o){const[,r,t,s]=o;i=Date.UTC(Number(r),Number(t)-1,Number(s))}}return{majorBase:y,majorMustEqual:_,minorBase:l,minorMustEqual:S,patchBase:n,patchMustEqual:T,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function v(c,y,_){let l;typeof c=="string"?l=R(P(c)):l=c;let S;y instanceof Date?S=y.getTime():typeof y=="string"&&(S=new Date(y).getTime());let n;if(typeof _=="string"?n=R(P(_)):n=_,!l||!n)return!1;let T=l.majorBase,i=l.minorBase,o=l.patchBase,r=n.majorBase,t=n.minorBase,s=n.patchBase,m=n.notBefore,d=n.majorMustEqual,C=n.minorMustEqual,O=n.patchMustEqual;return n.isMinimum?T>r?!0:T<r?!1:i>t?!0:i<t||S&&S<m?!1:o>=s:(T===1&&r===0&&(!d||!C||!O)&&(r=1,t=0,s=0,d=!0,C=!1,O=!1),T<r?!1:T>r?!d:i<t?!1:i>t?!C:o<s?!1:o>s?!O:!(S&&S<m))}e.isValidVersion=v;function p(c,y,_,l,S){const n=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return n.push([D.default.Error,g.localize(0,null)]),n;if(typeof l.name!="string")return n.push([D.default.Error,g.localize(1,null,"name")]),n;if(typeof l.version!="string")return n.push([D.default.Error,g.localize(2,null,"version")]),n;if(!l.engines)return n.push([D.default.Error,g.localize(3,null,"engines")]),n;if(typeof l.engines.vscode!="string")return n.push([D.default.Error,g.localize(4,null,"engines.vscode")]),n;if(typeof l.extensionDependencies!="undefined"&&!h(l.extensionDependencies))return n.push([D.default.Error,g.localize(5,null,"extensionDependencies")]),n;if(typeof l.activationEvents!="undefined"){if(!h(l.activationEvents))return n.push([D.default.Error,g.localize(6,null,"activationEvents")]),n;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return n.push([D.default.Error,g.localize(7,null,"activationEvents","main")]),n}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&n.push([D.default.Warning,g.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return n.push([D.default.Error,g.localize(9,null,"main")]),n;{const o=(0,a.joinPath)(_,l.main);(0,a.isEqualOrParent)(o,_)||n.push([D.default.Warning,g.localize(10,null,o.path,_.path)])}if(typeof l.activationEvents=="undefined")return n.push([D.default.Error,g.localize(11,null,"activationEvents","main")]),n}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return n.push([D.default.Error,g.localize(12,null,"browser")]),n;{const o=(0,a.joinPath)(_,l.browser);(0,a.isEqualOrParent)(o,_)||n.push([D.default.Warning,g.localize(13,null,o.path,_.path)])}if(typeof l.activationEvents=="undefined")return n.push([D.default.Error,g.localize(14,null,"activationEvents","browser")]),n}if(!L.valid(l.version))return n.push([D.default.Error,g.localize(15,null)]),n;const T=[];if(!w(c,y,l,S,T))for(const o of T)n.push([D.default.Error,o]);return n}e.validateExtensionManifest=p;function w(c,y,_,l,S){return l||typeof _.main=="undefined"&&typeof _.browser=="undefined"?!0:u(c,y,_.engines.vscode,S)}e.isValidExtensionVersion=w;function f(c,y,_){return c==="*"||u(y,_,c)}e.isEngineValid=f;function u(c,y,_,l=[]){let S=R(P(_));if(!S)return l.push(g.localize(16,null,_)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return l.push(g.localize(17,null,_)),!1}else if(!S.majorMustEqual)return l.push(g.localize(18,null,_)),!1;return v(c,y,S)?!0:(l.push(g.localize(19,null,c,_)),!1)}function h(c){if(!Array.isArray(c))return!1;for(let y=0,_=c.length;y<_;y++)if(typeof c[y]!="string")return!1;return!0}}),define(Se[78],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(g,L=[],I=!1){this.ctor=g,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=a}),define(Se[58],De([1,0,78]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const D=[];function g(I,k,b){k instanceof a.SyncDescriptor||(k=new a.SyncDescriptor(k,[],b)),D.push([I,k])}e.registerSingleton=g;function L(){return D}e.getSingletonServiceDescriptors=L}),define(Se[143],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=a;class D{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let I of this._nodes.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const k=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(I);k.outgoing.set(this._hashFn(I),b),b.incoming.set(this._hashFn(L),k)}removeNode(L){const I=this._hashFn(L);this._nodes.delete(I);for(let k of this._nodes.values())k.outgoing.delete(I),k.incoming.delete(I)}lookupOrInsertNode(L){const I=this._hashFn(L);let k=this._nodes.get(I);return k||(k=new a(L),this._nodes.set(I,k)),k}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[I,k]of this._nodes)L.push(`${I}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,I]of this._nodes){const k=new Set([L]),b=this._findCycle(I,k);if(b)return b}}_findCycle(L,I){for(let[k,b]of L.outgoing){if(I.has(k))return[...I,k].join(" -> ");I.add(k);const P=this._findCycle(b,I);if(P)return P;I.delete(k)}}}e.Graph=D}),define(Se[3],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function k(b){return b[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=k})(a=e._util||(e._util={})),e.IInstantiationService=g("instantiationService");function D(I,k,b){k[a.DI_TARGET]===k?k[a.DI_DEPENDENCIES].push({id:I,index:b}):(k[a.DI_DEPENDENCIES]=[{id:I,index:b}],k[a.DI_TARGET]=k)}function g(I){if(a.serviceIds.has(I))return a.serviceIds.get(I);const k=function(b,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(k,b,R)};return k.toString=()=>I,a.serviceIds.set(I,k),k}e.createDecorator=g;function L(I){return I}e.refineServiceDecorator=L}),define(Se[59],De([1,0,10,2,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,g.createDecorator)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.isConfigurationOverrides=L;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||a.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=I;var k;(function(c){c[c.USER=1]="USER",c[c.USER_LOCAL=2]="USER_LOCAL",c[c.USER_REMOTE=3]="USER_REMOTE",c[c.WORKSPACE=4]="WORKSPACE",c[c.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",c[c.DEFAULT=6]="DEFAULT",c[c.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(c){switch(c){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function P(c,y){const _=Object.create(null);for(let l in c)R(_,l,c[l],y);return _}e.toValuesTree=P;function R(c,y,_,l){const S=y.split("."),n=S.pop();let T=c;for(let i=0;i<S.length;i++){let o=S[i],r=T[o];switch(typeof r){case"undefined":r=T[o]=Object.create(null);break;case"object":break;default:l(`Ignoring ${y} as ${S.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}T=r}if(typeof T=="object"&&T!==null)try{T[n]=_}catch{l(`Ignoring ${y} as ${S.join(".")} is ${JSON.stringify(T)}`)}else l(`Ignoring ${y} as ${S.join(".")} is ${JSON.stringify(T)}`)}e.addToValueTree=R;function v(c,y){const _=y.split(".");p(c,_)}e.removeFromValueTree=v;function p(c,y){const _=y.shift();if(y.length===0){delete c[_];return}if(Object.keys(c).indexOf(_)!==-1){const l=c[_];typeof l=="object"&&!Array.isArray(l)&&(p(l,y),Object.keys(l).length===0&&delete c[_])}}function w(c,y,_){function l(T,i){let o=T;for(const r of i){if(typeof o!="object"||o===null)return;o=o[r]}return o}const S=y.split("."),n=l(c,S);return typeof n=="undefined"?_:n}e.getConfigurationValue=w;function f(c,y,_){Object.keys(y).forEach(l=>{l!=="__proto__"&&(l in c?a.isObject(c[l])&&a.isObject(y[l])?f(c[l],y[l],_):_&&(c[l]=y[l]):c[l]=y[l])})}e.merge=f;function u(c,y,_){const l=c.inspect(y),S=c.inspect(_);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:l.defaultValue}e.getMigratedSettingValue=u;function h(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(Se[44],De([1,0,23,9,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",a.isMacintosh),L.set("isLinux",a.isLinux),L.set("isWindows",a.isWindows),L.set("isWeb",a.isWeb),L.set("isMacNative",a.isMacintosh&&!a.isWeb),L.set("isEdge",a.isEdge),L.set("isFirefox",a.isFirefox),L.set("isChrome",a.isChrome),L.set("isSafari",a.isSafari);const I=Object.prototype.hasOwnProperty;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return v.INSTANCE}static true(){return p.INSTANCE}static has(E){return w.create(E)}static equals(E,$){return f.create(E,$)}static notEquals(E,$){return c.create(E,$)}static regex(E,$){return i.create(E,$)}static in(E,$){return u.create(E,$)}static not(E){return y.create(E)}static and(...E){return t.create(E,null)}static or(...E){return s.create(E,null,!0)}static greater(E,$){return l.create(E,$)}static greaterEquals(E,$){return S.create(E,$)}static smaller(E,$){return n.create(E,$)}static smallerEquals(E,$){return T.create(E,$)}static deserialize(E,$=!1){if(!!E)return this._deserializeOrExpression(E,$)}static _deserializeOrExpression(E,$){let x=E.split("||");return s.create(x.map(H=>this._deserializeAndExpression(H,$)),null,!0)}static _deserializeAndExpression(E,$){let x=E.split("&&");return t.create(x.map(H=>this._deserializeOne(H,$)),null)}static _deserializeOne(E,$){if(E=E.trim(),E.indexOf("!=")>=0){let x=E.split("!=");return c.create(x[0].trim(),this._deserializeValue(x[1],$))}if(E.indexOf("==")>=0){let x=E.split("==");return f.create(x[0].trim(),this._deserializeValue(x[1],$))}if(E.indexOf("=~")>=0){let x=E.split("=~");return i.create(x[0].trim(),this._deserializeRegexValue(x[1],$))}if(E.indexOf(" in ")>=0){let x=E.split(" in ");return u.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const x=E.split(">=");return S.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const x=E.split(">");return l.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const x=E.split("<=");return T.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const x=E.split("<");return n.create(x[0].trim(),x[1].trim())}return/^\!\s*/.test(E)?y.create(E.substr(1).trim()):w.create(E)}static _deserializeValue(E,$){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let x=/^'([^']*)'$/.exec(E);return x?x[1].trim():E}static _deserializeRegexValue(E,$){if((0,D.isFalsyOrWhitespace)(E)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let x=E.indexOf("/"),H=E.lastIndexOf("/");if(x===H||x<0){if($)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let oe=E.slice(x+1,H),G=E[H+1]==="i"?"i":"";try{return new RegExp(oe,G)}catch(M){if($)throw new Error(`bad regexp-value '${E}', parse error: ${M}`);return console.warn(`bad regexp-value '${E}', parse error: ${M}`),null}}}e.ContextKeyExpr=b;function P(A,E){const $=A?A.substituteConstants():void 0,x=E?E.substituteConstants():void 0;return!$&&!x?!0:!$||!x?!1:$.equals(x)}e.expressionsAreEqualWithConstantSubstitution=P;function R(A,E){return A.cmp(E)}class v{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class p{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class w{constructor(E,$){this.key=E,this.negated=$,this.type=2}static create(E,$=null){const x=L.get(E);return typeof x=="boolean"?x?p.INSTANCE:v.INSTANCE:new w(E,$)}cmp(E){return E.type!==this.type?this.type-E.type:d(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=L.get(this.key);return typeof E=="boolean"?E?p.INSTANCE:v.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class f{constructor(E,$,x){this.key=E,this.value=$,this.negated=x,this.type=4}static create(E,$,x=null){if(typeof $=="boolean")return $?w.create(E,x):y.create(E,x);const H=L.get(E);return typeof H=="boolean"?$===(H?"true":"false")?p.INSTANCE:v.INSTANCE:new f(E,$,x)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=L.get(this.key);if(typeof E=="boolean"){const $=E?"true":"false";return this.value===$?p.INSTANCE:v.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class u{constructor(E,$){this.key=E,this.valueKey=$,this.type=10,this.negated=null}static create(E,$){return new u(E,$)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const $=E.getValue(this.valueKey),x=E.getValue(this.key);return Array.isArray($)?$.indexOf(x)>=0:typeof x=="string"&&typeof $=="object"&&$!==null?I.call($,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this)),this.negated}}e.ContextKeyInExpr=u;class h{constructor(E){this._actual=E,this.type=11}static create(E){return new h(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new h(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=h;class c{constructor(E,$,x){this.key=E,this.value=$,this.negated=x,this.type=5}static create(E,$,x=null){if(typeof $=="boolean")return $?y.create(E,x):w.create(E,x);const H=L.get(E);return typeof H=="boolean"?$===(H?"true":"false")?v.INSTANCE:p.INSTANCE:new c(E,$,x)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=L.get(this.key);if(typeof E=="boolean"){const $=E?"true":"false";return this.value===$?v.INSTANCE:p.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=c;class y{constructor(E,$){this.key=E,this.negated=$,this.type=3}static create(E,$=null){const x=L.get(E);return typeof x=="boolean"?x?v.INSTANCE:p.INSTANCE:new y(E,$)}cmp(E){return E.type!==this.type?this.type-E.type:d(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=L.get(this.key);return typeof E=="boolean"?E?v.INSTANCE:p.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;function _(A,E){if(typeof A=="string"){const $=parseFloat(A);isNaN($)||(A=$)}return typeof A=="string"||typeof A=="number"?E(A):v.INSTANCE}class l{constructor(E,$,x){this.key=E,this.value=$,this.negated=x,this.type=12}static create(E,$,x=null){return _($,H=>new l(E,H,x))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class S{constructor(E,$,x){this.key=E,this.value=$,this.negated=x,this.type=13}static create(E,$,x=null){return _($,H=>new S(E,H,x))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=S;class n{constructor(E,$,x){this.key=E,this.value=$,this.negated=x,this.type=14}static create(E,$,x=null){return _($,H=>new n(E,H,x))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class T{constructor(E,$,x){this.key=E,this.value=$,this.negated=x,this.type=15}static create(E,$,x=null){return _($,H=>new T(E,H,x))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=T;class i{constructor(E,$){this.key=E,this.regexp=$,this.type=7,this.negated=null}static create(E,$){return new i(E,$)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const $=this.regexp?this.regexp.source:"",x=E.regexp?E.regexp.source:"";return $<x?-1:$>x?1:0}equals(E){if(E.type===this.type){const $=this.regexp?this.regexp.source:"",x=E.regexp?E.regexp.source:"";return this.key===E.key&&$===x}return!1}substituteConstants(){return this}evaluate(E){let $=E.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{constructor(E){this._actual=E,this.type=8}static create(E){return new o(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new o(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function r(A){let E=null;for(let $=0,x=A.length;$<x;$++){const H=A[$].substituteConstants();if(A[$]!==H&&E===null){E=[];for(let oe=0;oe<$;oe++)E[oe]=A[oe]}E!==null&&(E[$]=H)}return E===null?A:E}class t{constructor(E,$){this.expr=E,this.negated=$,this.type=6}static create(E,$){return t._normalizeArr(E,$)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let $=0,x=this.expr.length;$<x;$++){const H=R(this.expr[$],E.expr[$]);if(H!==0)return H}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let $=0,x=this.expr.length;$<x;$++)if(!this.expr[$].equals(E.expr[$]))return!1;return!0}return!1}substituteConstants(){const E=r(this.expr);return E===this.expr?this:t.create(E,this.negated)}evaluate(E){for(let $=0,x=this.expr.length;$<x;$++)if(!this.expr[$].evaluate(E))return!1;return!0}static _normalizeArr(E,$){const x=[];let H=!1;for(const oe of E)if(!!oe){if(oe.type===1){H=!0;continue}if(oe.type===0)return v.INSTANCE;if(oe.type===6){x.push(...oe.expr);continue}x.push(oe)}if(x.length===0&&H)return p.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(R);for(let oe=1;oe<x.length;oe++)x[oe-1].equals(x[oe])&&(x.splice(oe,1),oe--);if(x.length===1)return x[0];for(;x.length>1;){const oe=x[x.length-1];if(oe.type!==9)break;x.pop();const G=x.pop(),M=x.length===0,le=s.create(oe.expr.map(me=>t.create([me,G],null)),null,M);le&&(x.push(le),x.sort(R))}return x.length===1?x[0]:new t(x,$)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let $ of this.expr)E.push(...$.keys());return E}map(E){return new t(this.expr.map($=>$.map(E)),null)}negate(){if(!this.negated){const E=[];for(let $ of this.expr)E.push($.negate());this.negated=s.create(E,this,!0)}return this.negated}}class s{constructor(E,$){this.expr=E,this.negated=$,this.type=9}static create(E,$,x){return s._normalizeArr(E,$,x)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let $=0,x=this.expr.length;$<x;$++){const H=R(this.expr[$],E.expr[$]);if(H!==0)return H}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let $=0,x=this.expr.length;$<x;$++)if(!this.expr[$].equals(E.expr[$]))return!1;return!0}return!1}substituteConstants(){const E=r(this.expr);return E===this.expr?this:s.create(E,this.negated,!1)}evaluate(E){for(let $=0,x=this.expr.length;$<x;$++)if(this.expr[$].evaluate(E))return!0;return!1}static _normalizeArr(E,$,x){let H=[],oe=!1;if(E){for(let G=0,M=E.length;G<M;G++){const le=E[G];if(!!le){if(le.type===0){oe=!0;continue}if(le.type===1)return p.INSTANCE;if(le.type===9){H=H.concat(le.expr);continue}H.push(le)}}if(H.length===0&&oe)return v.INSTANCE;H.sort(R)}if(H.length!==0){if(H.length===1)return H[0];for(let G=1;G<H.length;G++)H[G-1].equals(H[G])&&(H.splice(G,1),G--);if(H.length===1)return H[0];if(x){for(let G=0;G<H.length;G++)for(let M=G+1;M<H.length;M++)O(H[G],H[M])&&(H.splice(M,1),M--);if(H.length===1)return H[0]}return new s(H,$)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let $ of this.expr)E.push(...$.keys());return E}map(E){return new s(this.expr.map($=>$.map(E)),null)}negate(){if(!this.negated){let E=[];for(let $ of this.expr)E.push($.negate());for(;E.length>1;){const $=E.shift(),x=E.shift(),H=[];for(const G of U($))for(const M of U(x))H.push(t.create([G,M],null));const oe=E.length===0;E.unshift(s.create(H,null,oe))}this.negated=E[0]}return this.negated}}class m extends w{constructor(E,$,x){super(E,null);this._defaultValue=$,typeof x=="object"?m._info.push({...x,key:E}):x!==!0&&m._info.push({key:E,description:x,type:$!=null?typeof $:void 0})}static all(){return m._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return f.create(this.key,E)}notEqualsTo(E){return c.create(this.key,E)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,g.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(A,E){return A<E?-1:A>E?1:0}function C(A,E,$,x){return A<$?-1:A>$?1:E<x?-1:E>x?1:0}function O(A,E){if(E.type===6&&A.type!==9&&A.type!==6){for(const H of E.expr)if(A.equals(H))return!0}const $=A.negate(),x=U($).concat(U(E));x.sort(R);for(let H=0;H<x.length;H++){const G=x[H].negate();for(let M=H+1;M<x.length;M++){const le=x[M];if(G.equals(le))return!0}}return!1}e.implies=O;function U(A){return A.type===9?A.expr:[A]}}),define(Se[144],De([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[145],De([1,0,123,3]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function g(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=g;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function I(c,y){switch(c){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function k(c,y){return y==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function b(c,y,_){return k(y,_)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===_?!0:P(_).includes(c)}e.isTargetPlatformCompatible=b;function P(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=R;var v;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var p;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var w;(function(c){c.Install="install",c.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var u;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(u=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(y,_){super(y);this.code=_,this.name=_}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Se[38],De([1,0,12,22,17,9,10,2,125,3]),function(ee,e,a,D,g,L,I,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function R(M){return M.create===!0}e.isFileOpenForWriteOptions=R;var v;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var p;(function(M){M[M.Readonly=1]="Readonly"})(p=e.FilePermission||(e.FilePermission={}));var w;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=f;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function h(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=h;function c(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function y(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=y;function _(M){return f(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=_;var l;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(le,me){super(le);this.code=me}}e.FileSystemProviderError=S;function n(M,le){const me=new S(M.toString(),le);return i(me,le),me}e.createFileSystemProviderError=n;function T(M){return M||n((0,b.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=T;function i(M,le){return M.name=le?`${le} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=i;function o(M){if(!M)return l.Unknown;if(M instanceof S)return M.code;const le=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!le)return l.Unknown;switch(le[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=o;function r(M){if(M instanceof O)return M.fileOperationResult;switch(o(M)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(le,me,ae){this.resource=le,this.operation=me,this.target=ae}isOperation(le){return this.operation===le}}e.FileOperationEvent=s;var m;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class d{constructor(le,me){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const ae=new Map;for(const ge of le){const te=ae.get(ge.type);switch(te?te.push([ge.resource,ge]):ae.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,te]of ae)switch(ge){case 1:this.added=D.TernarySearchTree.forUris(()=>me),this.added.fill(te);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>me),this.updated.fill(te);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>me),this.deleted.fill(te);break}}contains(le,...me){return this.doContains(le,{includeChildren:!1},...me)}affects(le,...me){return this.doContains(le,{includeChildren:!0},...me)}doContains(le,me,...ae){if(!le)return!1;const ge=ae.length>0;return!!((!ge||ae.includes(1))&&(this.added?.get(le)||me.includeChildren&&this.added?.findSuperstr(le))||(!ge||ae.includes(0))&&(this.updated?.get(le)||me.includeChildren&&this.updated?.findSuperstr(le))||(!ge||ae.includes(2))&&(this.deleted?.findSubstr(le)||me.includeChildren&&this.deleted?.findSuperstr(le)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function C(M,le,me){return!M||!le||M===le||le.length>M.length?!1:(le.charAt(le.length-1)!==g.sep&&(le+=g.sep),me?(0,L.startsWithIgnoreCase)(M,le):M.indexOf(le)===0)}e.isParent=C;class O extends a.ErrorNoTelemetry{constructor(le,me,ae){super(le);this.fileOperationResult=me,this.options=ae}}e.FileOperationError=O;class U extends O{constructor(le,me,ae){super(le,2,ae);this.stat=me}}e.NotModifiedSinceFileOperationError=U;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=$;async function x(M,le){if(!le.hasProvider(k.URI.from({scheme:M.scheme})))return new Promise(me=>{const ae=le.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===M.scheme&&ge.added&&(ae.dispose(),me())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(le){return(0,I.isNumber)(le)||(le=0),le<H.KB?(0,b.localize)(1,null,le.toFixed(0)):le<H.MB?(0,b.localize)(2,null,(le/H.KB).toFixed(2)):le<H.GB?(0,b.localize)(3,null,(le/H.MB).toFixed(2)):le<H.TB?(0,b.localize)(4,null,(le/H.GB).toFixed(2)):(0,b.localize)(5,null,(le/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var oe;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function G(M){return{maxFileSize:M===0?300*H.MB:16*H.GB,maxHeapSize:M===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=G}),define(Se[60],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...g){this._entries=new Map;for(let[L,I]of g)this.set(L,I)}set(g,L){const I=this._entries.get(g);return this._entries.set(g,L),I}has(g){return this._entries.has(g)}get(g){return this._entries.get(g)}}e.ServiceCollection=a}),define(Se[146],De([1,0,14,12,78,143,3,60]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class P extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new k.ServiceCollection,u=!1,h){this._activeInstantiations=new Set,this._services=f,this._strict=u,this._parent=h,this._services.set(I.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...u){let h=p.traceInvocation(f),c=!1;try{return f({get:_=>{if(c)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(_,h);if(!l)throw new Error(`[invokeFunction] unknown service '${_}'`);return l}},...u)}finally{c=!0,h.stop()}}createInstance(f,...u){let h,c;return f instanceof g.SyncDescriptor?(h=p.traceCreation(f.ctor),c=this._createInstance(f.ctor,f.staticArguments.concat(u),h)):(h=p.traceCreation(f),c=this._createInstance(f,u,h)),h.stop(),c}_createInstance(f,u=[],h){let c=I._util.getServiceDependencies(f).sort((l,S)=>l.index-S.index),y=[];for(const l of c){let S=this._getOrCreateServiceInstance(l.id,h);S||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),y.push(S)}let _=c.length>0?c[0].index:u.length;if(u.length!==_){console.trace(`[createInstance] First service dependency of ${f.name} at position ${_+1} conflicts with ${u.length} static arguments`);let l=_-u.length;l>0?u=u.concat(new Array(l)):u=u.slice(0,_)}return new f(...[...u,...y])}_setServiceInstance(f,u){if(this._services.get(f)instanceof g.SyncDescriptor)this._services.set(f,u);else if(this._parent)this._parent._setServiceInstance(f,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let u=this._services.get(f);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):u}_getOrCreateServiceInstance(f,u){let h=this._getServiceInstanceOrDescriptor(f);return h instanceof g.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,h,u.branch(f,!0)):(u.branch(f,!1),h)}_safeCreateAndCacheServiceInstance(f,u,h){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,u,h)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,u,h){const c=new L.Graph(l=>l.id.toString());let y=0;const _=[{id:f,desc:u,_trace:h}];for(;_.length;){const l=_.pop();if(c.lookupOrInsertNode(l),y++>1e3)throw new P(c);for(let S of I._util.getServiceDependencies(l.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(S.id);if(n||this._throwIfStrict(`[createInstance] ${f} depends on ${S.id} which is NOT registered.`,!0),n instanceof g.SyncDescriptor){const T={id:S.id,desc:n,_trace:l._trace.branch(S.id,!0)};c.insertEdge(l,T),_.push(T)}}}for(;;){const l=c.roots();if(l.length===0){if(!c.isEmpty())throw new P(c);break}for(const{data:S}of l){if(this._getServiceInstanceOrDescriptor(S.id)instanceof g.SyncDescriptor){const T=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,T)}c.removeNode(S)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,u,h=[],c,y){if(this._services.get(f)instanceof g.SyncDescriptor)return this._createServiceInstance(u,h,c,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,u,h,c,y);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(f,u=[],h,c){if(h){const y=new a.IdleValue(()=>this._createInstance(f,u,c));return new Proxy(Object.create(null),{get(_,l){if(l in _)return _[l];let S=y.value,n=S[l];return typeof n!="function"||(n=n.bind(S),_[l]=n),n},set(_,l,S){return y.value[l]=S,!0}})}else return this._createInstance(f,u,c)}_throwIfStrict(f,u){if(u&&console.warn(u),this._strict)throw new Error(f)}}e.InstantiationService=R;var v;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(v||(v={}));class p{constructor(f,u){this.type=f,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return b?new p(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(f){return b?new p(0,f.name):p._None}branch(f,u){let h=new p(2,f.toString());return this._dep.push([f,u,h]),h}stop(){let f=Date.now()-this._start;p._totals+=f;let u=!1;function h(y,_){let l=[],S=new Array(y+1).join("	");for(const[n,T,i]of _._dep)if(T&&i){u=!0,l.push(`${S}CREATES -> ${n}`);let o=h(y+1,i);o&&l.push(o)}else l.push(`${S}uses -> ${n}`);return l.join(`
`)}let c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(f>2||u)&&console.log(c.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(Se[13],De([1,0,43,5,7,23,3]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function k(){return new Date().toISOString()}var b;(function(T){T[T.Trace=0]="Trace",T[T.Debug=1]="Debug",T[T.Info=2]="Info",T[T.Warning=3]="Warning",T[T.Error=4]="Error",T[T.Critical=5]="Critical",T[T.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function P(T,i,o){switch(i){case b.Trace:T.trace(o);break;case b.Debug:T.debug(o);break;case b.Info:T.info(o);break;case b.Warning:T.warn(o);break;case b.Error:T.error(o);break;case b.Critical:T.critical(o);break;default:throw new Error("Invalid log level")}}e.log=P;function R(T){let i="";for(let o=0;o<T.length;o++){let r=T[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(o>0?" ":"")+r}return i}e.format=R;class v extends g.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class p extends v{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(b.Trace)&&this.log(b.Trace,R([i,...o]))}debug(i,...o){this.checkLogLevel(b.Debug)&&this.log(b.Debug,R([i,...o]))}info(i,...o){this.checkLogLevel(b.Info)&&this.log(b.Info,R([i,...o]))}warn(i,...o){this.checkLogLevel(b.Warning)&&this.log(b.Warning,R([i,...o]))}error(i,...o){if(this.checkLogLevel(b.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(b.Error,R(r))}else this.log(b.Error,R([i,...o]))}critical(i,...o){this.checkLogLevel(b.Critical)&&this.log(b.Critical,R([i,...o]))}flush(){}}e.AbstractMessageLogger=p;class w extends v{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...o){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...o):console.log(`[main ${k()}]`,i,...o))}debug(i,...o){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...o):console.log(`[main ${k()}]`,i,...o))}info(i,...o){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...o):console.log(`[main ${k()}]`,i,...o))}warn(i,...o){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...o):console.warn(`[main ${k()}]`,i,...o))}error(i,...o){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...o):console.error(`[main ${k()}]`,i,...o))}critical(i,...o){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...o):console.error(`[main ${k()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class f extends v{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=f;class u extends v{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,a.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class h extends v{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const r of this.logServices)r.trace(i,...o)}debug(i,...o){for(const r of this.logServices)r.debug(i,...o)}info(i,...o){for(const r of this.logServices)r.info(i,...o)}warn(i,...o){for(const r of this.logServices)r.warn(i,...o)}error(i,...o){for(const r of this.logServices)r.error(i,...o)}critical(i,...o){for(const r of this.logServices)r.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class c extends g.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=c;class y extends g.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,o?.always?b.Trace:this.logLevel,o),this.loggers.set(i.toString(),r),o?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class _{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=_;function l(T){if(T.verbose)return b.Trace;if(typeof T.logLevel=="string"){const i=S(T.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function S(T){switch(T){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=S;function n(T){switch(T){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=n}),define(Se[79],De([1,0,32,126,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var I;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function P(f,u){return u-f}b.compare=P;const R=Object.create(null);R[b.Error]=(0,D.localize)(0,null),R[b.Warning]=(0,D.localize)(1,null),R[b.Info]=(0,D.localize)(2,null);function v(f){return R[f]||""}b.toString=v;function p(f){switch(f){case a.default.Error:return b.Error;case a.default.Warning:return b.Warning;case a.default.Info:return b.Info;case a.default.Ignore:return b.Hint}}b.fromSeverity=p;function w(f){switch(f){case b.Error:return a.default.Error;case b.Warning:return a.default.Warning;case b.Info:return a.default.Info;case b.Hint:return a.default.Ignore}}b.toSeverity=w}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(b){const P="";function R(p){return v(p,!0)}b.makeKey=R;function v(p,w){let f=[P];return p.source?f.push(p.source.replace("\xA6","\\\xA6")):f.push(P),p.code?typeof p.code=="string"?f.push(p.code.replace("\xA6","\\\xA6")):f.push(p.code.value.replace("\xA6","\\\xA6")):f.push(P),p.severity!==void 0&&p.severity!==null?f.push(I.toString(p.severity)):f.push(P),p.message&&w?f.push(p.message.replace("\xA6","\\\xA6")):f.push(P),p.startLineNumber!==void 0&&p.startLineNumber!==null?f.push(p.startLineNumber.toString()):f.push(P),p.startColumn!==void 0&&p.startColumn!==null?f.push(p.startColumn.toString()):f.push(P),p.endLineNumber!==void 0&&p.endLineNumber!==null?f.push(p.endLineNumber.toString()):f.push(P),p.endColumn!==void 0&&p.endColumn!==null?f.push(p.endColumn.toString()):f.push(P),f.push(P),f.join("\xA6")}b.makeKeyOptionalMessage=v})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(Se[147],De([1,0,5,32,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=D.default,e.INotificationService=(0,g.createDecorator)("notificationService");var L;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new b,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class b{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=b}),define(Se[80],De([1,0,7,9,2,3]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,L.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function I(R,v){return g.URI.isUri(R)?(0,D.equalsIgnoreCase)(R.scheme,v):(0,D.startsWithIgnoreCase)(R,v+":")}e.matchesScheme=I;function k(R,...v){return v.some(p=>I(R,p))}e.matchesSomeScheme=k;function b(R,v){return R.with({fragment:`${v.startLineNumber},${v.startColumn}${v.endLineNumber?`-${v.endLineNumber}${v.endColumn?`,${v.endColumn}`:""}`:""}`})}e.withSelection=b;function P(R){let v;const p=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return p&&(v={startLineNumber:parseInt(p[1]),startColumn:p[2]?parseInt(p[2]):1,endLineNumber:p[4]?parseInt(p[4]):void 0,endColumn:p[4]?p[5]?parseInt(p[5]):1:void 0},R=R.with({fragment:""})),{selection:v,uri:R}}e.extractSelection=P});var $e=this&&this.__decorate||function(ee,e,a,D){var g=arguments.length,L=g<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,a):D,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,a,D);else for(var k=ee.length-1;k>=0;k--)(I=ee[k])&&(L=(g<3?I(L):g>3?I(e,a,L):I(e,a))||L);return g>3&&L&&Object.defineProperty(e,a,L),L},ze=this&&this.__param||function(ee,e){return function(a,D){e(a,D,ee)}};define(Se[148],De([1,0,14,20,7,3]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var I;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(v){this.callback=v}get value(){return this._value}report(v){this._value=v,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let b=class extends g.Disposable{constructor(v,p){super();this.deferred=new a.DeferredPromise,p.withProgress(v,w=>(this.reporter=w,this.lastStep&&w.report(this.lastStep),this.deferred.p)),this._register((0,g.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};b=$e([ze(1,e.IProgressService)],b),e.UnmanagedProgress=b;class P extends g.Disposable{constructor(v){super();this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new g.DisposableStore)}start(v){this.stop();const p=++this.currentOperationId,w=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,g.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,g.toDisposable)(()=>w.cancel())),this.currentOperationDisposables.add((0,g.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:w.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Se[34],De([1,0,41,10]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class g{constructor(){this.data=new Map}add(I,k){a.ok(D.isString(I)),a.ok(D.isObject(k)),a.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,k)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new g}),define(Se[149],De([1,0,5,34]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function g(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,P){this.schemasById[g(b)]=P,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new L;D.Registry.add(e.Extensions.JSONContribution,I)}),define(Se[81],De([1,0,15,5,10,122,59,149,34]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=b.Registry.as(k.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,T=!0){this.registerConfigurations([n],T)}registerConfigurations(n,T=!0){const i=this.doRegisterConfigurations(n,T);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const T=this.doDeregisterConfigurations(n);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T})}updateConfigurations({add:n,remove:T}){const i=[];i.push(...this.doDeregisterConfigurations(T)),i.push(...this.doRegisterConfigurations(n,!1)),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(i)})}registerDefaultConfigurations(n){const T=[],i=[];for(const{overrides:o,source:r}of n)for(const t in o)if(T.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const s={...this.configurationDefaultsOverrides.get(t)?.value||{},...o[t]};this.configurationDefaultsOverrides.set(t,{source:r,value:s});const m=(0,I.getLanguageTagSettingPlainKey)(t),d={type:"object",default:s,description:L.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:g.isString(r)?void 0:r};i.push(...u(t)),this.configurationProperties[t]=d,this.defaultLanguageConfigurationOverridesNode.properties[t]=d}else{this.configurationDefaultsOverrides.set(t,{value:o[t],source:r});const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const T=[];for(const{overrides:i,source:o}of n)for(const r in i){const t=this.configurationDefaultsOverrides.get(r),s=g.isString(o)?o:o?.id,m=g.isString(t?.source)?t?.source:t?.source?.id;if(s===m)if(T.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const d=this.configurationProperties[r];d&&(this.updatePropertyDefaultValue(r,d),this.updateSchema(r,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const T of n)this.overrideIdentifiers.add(T);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,T){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,T,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const T=[],i=o=>{if(o.properties)for(const r in o.properties)T.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r]);o.allOf&&o.allOf.forEach(r=>i(r))};for(const o of n){i(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}return T}validateAndRegisterProperties(n,T=!0,i,o,r=3){r=g.isUndefinedOrNull(n.scope)?r:n.scope;let t=[],s=n.properties;if(s)for(let d in s){if(T&&_(d)){delete s[d];continue}const C=s[d];if(C.source=i,C.defaultDefaultValue=s[d].default,this.updatePropertyDefaultValue(d,C),e.OVERRIDE_PROPERTY_REGEX.test(d)?C.scope=void 0:(C.scope=g.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=g.isUndefinedOrNull(C.restricted)?!!o?.includes(d):C.restricted),s[d].hasOwnProperty("included")&&!s[d].included){this.excludedConfigurationProperties[d]=s[d],delete s[d];continue}else this.configurationProperties[d]=s[d];!s[d].deprecationMessage&&s[d].markdownDeprecationMessage&&(s[d].deprecationMessage=s[d].markdownDeprecationMessage),t.push(d)}let m=n.allOf;if(m)for(let d of m)t.push(...this.validateAndRegisterProperties(d,T,i,o,r));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const T=i=>{let o=i.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let r=i.allOf;r&&r.forEach(T)};T(n)}updateSchema(n,T){switch(e.allSettings.properties[n]=T,T.scope){case 1:e.applicationSettings.properties[n]=T;break;case 2:e.machineSettings.properties[n]=T;break;case 6:e.machineOverridableSettings.properties[n]=T;break;case 3:e.windowSettings.properties[n]=T;break;case 4:e.resourceSettings.properties[n]=T;break;case 5:e.resourceSettings.properties[n]=T,this.resourceLanguageSettingsSchema.properties[n]=T;break}}removeFromSchema(n,T){switch(delete e.allSettings.properties[n],T.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const T=`[${n}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(T,i),e.allSettings.properties[T]=i,e.applicationSettings.properties[T]=i,e.machineSettings.properties[T]=i,e.machineOverridableSettings.properties[T]=i,e.windowSettings.properties[T]=i,e.resourceSettings.properties[T]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,T){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,r=i?.source;g.isUndefined(o)&&(o=T.defaultDefaultValue,r=void 0),g.isUndefined(o)&&(o=c(T.type)),T.default=o,T.defaultValueSource=r}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(S){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let T=f.exec(S);for(;T?.length;){const i=T[1].trim();i&&n.push(i),T=f.exec(S)}}return(0,a.distinct)(n)}e.overrideIdentifiersFromKey=u;function h(S){return S.reduce((n,T)=>`${n}[${T}]`,"")}e.keyFromOverrideIdentifiers=h;function c(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const y=new p;b.Registry.add(e.Extensions.Configuration,y);function _(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?L.localize(7,null,S):y.getConfigurationProperties()[S]!==void 0?L.localize(8,null,S):null:L.localize(6,null)}e.validateProperty=_;function l(){const S=[],n=y.getConfigurationProperties();for(const T of Object.keys(n))S.push([T,n[T].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=l}),define(Se[150],De([1,0,15,5,104,7,22,27,10,2,59,81,34]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(i={},o=[],r=[]){this._contents=i,this._keys=o,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const r=this.getContentsForOverrideIdentifer(o);return r?i?(0,R.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const r of this.overrides)r.identifiers.includes(i)&&o.push(...r.keys);return a.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return a.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=k.deepClone(this.contents),r=k.deepClone(this.overrides),t=[...this.keys];for(const s of i){this.mergeContents(o,s.contents);for(const m of s.overrides){const[d]=r.filter(C=>a.equals(C.identifiers,m.identifiers));d?(this.mergeContents(d.contents,m.contents),d.keys.push(...m.keys),d.keys=a.distinct(d.keys)):r.push(k.deepClone(m))}for(const m of s.keys)t.indexOf(m)===-1&&t.push(m)}return new w(o,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let r={};for(const t of a.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[t],m=o[t];m&&(typeof s=="object"&&typeof m=="object"?(s=k.deepClone(s),this.mergeContents(s,m)):s=m),r[t]=s}return new w(r,this.keys,this.overrides)}mergeContents(i,o){for(const r of Object.keys(o)){if(r in i&&b.isObject(i[r])&&b.isObject(o[r])){this.mergeContents(i[r],o[r]);continue}i[r]=k.deepClone(o[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,r=null;const t=s=>{s&&(r?this.mergeContents(r,s):r=k.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&t(s.contents);return t(o),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,R.addToValueTree)(this.contents,i,o,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let r=0;r<o;r++)i.indexOf(this.keys[r])===0&&(o=r);this.keys.splice(o,1,i)}removeKey(i){let o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=w;class f extends w{constructor(i={}){const o=p.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(o),t=Object.create(null),s=[];for(const m in o){const d=i[m],C=d!==void 0?d:o[m].default;(0,R.addToValueTree)(t,m,C,O=>console.error(`Conflict in default settings: ${O}`))}for(const m of Object.keys(t))v.OVERRIDE_PROPERTY_REGEX.test(m)&&s.push({identifiers:(0,v.overrideIdentifiersFromKey)(m),keys:Object.keys(t[m]),contents:(0,R.toValuesTree)(t[m],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,r,s)}}e.DefaultConfigurationModel=f;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!b.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:r,keys:t,overrides:s,restricted:m}=this.doParseRaw(i,o);this._configurationModel=new w(r,t,s),this._restrictedConfigurations=m||[]}doParseContent(i){let o={},r=null,t=[],s=[],m=[];function d(O){Array.isArray(t)?t.push(O):r!==null&&(t[r]=O)}let C={onObjectBegin:()=>{let O={};d(O),s.push(t),t=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{let O=[];d(O),s.push(t),t=O,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:d,onError:(O,U,A)=>{m.push({error:O,offset:U,length:A})}};if(i)try{g.visit(i,C),o=t[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return o}doParseRaw(i,o){const r=p.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),t=this.filter(i,r,!0,o);i=t.raw;const s=(0,R.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),m=Object.keys(i),d=this.toOverrides(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:s,keys:m,overrides:d,restricted:t.restricted}}filter(i,o,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:i,restricted:[]};const s={},m=[];for(let d in i)if(v.OVERRIDE_PROPERTY_REGEX.test(d)&&r){const C=this.filter(i[d],o,!1,t);s[d]=C.raw,m.push(...C.restricted)}else{const C=o[d],O=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&m.push(d),(O===void 0||t.scopes===void 0||t.scopes.includes(O))&&(t.skipRestricted&&C?.restricted||(s[d]=i[d]))}return{raw:s,restricted:m}}toOverrides(i,o){const r=[];for(const t of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(t)){const s={};for(const m in i[t])s[m]=i[t][m];r.push({identifiers:(0,v.overrideIdentifiersFromKey)(t),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,o)})}return r}}e.ConfigurationModelParser=u;class h extends L.Disposable{constructor(i,o,r,t){super();this.userSettingsResource=i,this.scopes=o,this.fileService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class c{constructor(i,o,r=new w,t=new w,s=new I.ResourceMap,m=new w,d=new I.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=s,this._memoryConfiguration=m,this._memoryConfigurationByResource=d,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(i,o,r){return this.getConsolidateConfigurationModel(o,r).getValue(i)}updateValue(i,o,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new w,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,o===void 0?t.removeValue(i):t.setValue(i,o),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,r){const t=this.getConsolidateConfigurationModel(o,r),s=this.getFolderConfigurationModelForResource(o.resource,r),m=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,d=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),A=r?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,E=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,$=o.overrideIdentifier?m.override(o.overrideIdentifier).getValue(i):m.getValue(i),x=t.getValue(i),H=a.distinct(a.flatten(t.overrides.map(oe=>oe.identifiers))).filter(oe=>t.getOverrideValue(i,oe)!==void 0);return{defaultValue:d,userValue:C,userLocalValue:O,userRemoteValue:U,workspaceValue:A,workspaceFolderValue:E,memoryValue:$,value:x,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:s?.freeze().getValue(i),override:o.overrideIdentifier?s?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:m.getValue(i),override:o.overrideIdentifier?m.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const r=[];if(!o){const{added:t,updated:s,removed:m}=S(this._defaultConfiguration,i);o=[...t,...s,...m]}for(const t of o)for(const s of(0,v.overrideIdentifiersFromKey)(t)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(s),d=i.getKeysForOverrideIdentifier(s),C=[...d.filter(O=>m.indexOf(O)===-1),...m.filter(O=>d.indexOf(O)===-1),...m.filter(O=>!k.equals(this._defaultConfiguration.override(s).getValue(O),i.override(s).getValue(O)))];r.push([s,C])}return this.updateDefaultConfiguration(i),{keys:o,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:r,removed:t,overrides:s}=S(this.localUserConfiguration,i),m=[...o,...r,...t];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:r,removed:t,overrides:s}=S(this.remoteUserConfiguration,i);let m=[...o,...r,...t];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:r,removed:t,overrides:s}=S(this.workspaceConfiguration,i);let m=[...o,...r,...t];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const r=this.folderConfigurations.get(i),{added:t,updated:s,removed:m,overrides:d}=S(r,o);let C=[...t,...s,...m];return(C.length||!r)&&this.updateFolderConfiguration(i,o),{keys:C,overrides:d}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:t,removed:s,overrides:m}=S(o,void 0);return{keys:[...r,...t,...s],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,o){let r=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},o){let r=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const t=o.getFolder(i);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const s=this._memoryConfigurationByResource.get(i);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(i);t?(o=r.merge(t),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=r}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const r=o.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:r,overrides:t,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:r,overrides:t,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),t=this.parseConfigurationModel(i.workspace),s=i.folders.reduce((m,d)=>(m.set(P.URI.revive(d[0]),this.parseConfigurationModel(d[1])),m),new I.ResourceMap);return new c(o,r,new w,t,s,new w,new I.ResourceMap,!1)}static parseConfigurationModel(i){return new w(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=c;function y(...T){if(T.length===0)return{keys:[],overrides:[]};if(T.length===1)return T[0];const i=new Set,o=new Map;for(const t of T)t.keys.forEach(s=>i.add(s)),t.overrides.forEach(([s,m])=>{const d=(0,I.getOrSet)(o,s,new Set);m.forEach(C=>d.add(C))});const r=[];return o.forEach((t,s)=>r.push([s,[...t.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=y;class _{constructor(i,o,r,t){this.change=i,this.previous=o,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(d=>s.add(d)),i.overrides.forEach(([,d])=>d.forEach(C=>s.add(C))),this.affectedKeys=[...s.values()];const m=new w;this.affectedKeys.forEach(d=>m.setValue(d,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!k.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let r=(0,R.toValuesTree)({[o]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(i=i[t],!i)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=_;class l extends _{constructor(i,o,r,t){super({keys:i.allKeys(),overrides:[]},void 0,i,o);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=l;function S(T,i){const{added:o,removed:r,updated:t}=n(i,T),s=[],m=T?.getAllOverrideIdentifiers()||[],d=i?.getAllOverrideIdentifiers()||[];if(i){const C=d.filter(O=>!m.includes(O));for(const O of C)s.push([O,i.getKeysForOverrideIdentifier(O)])}if(T){const C=m.filter(O=>!d.includes(O));for(const O of C)s.push([O,T.getKeysForOverrideIdentifier(O)])}if(i&&T){for(const C of m)if(d.includes(C)){const O=n({contents:T.getOverrideValue(void 0,C)||{},keys:T.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});s.push([C,[...O.added,...O.removed,...O.updated]])}}return{added:o,removed:r,updated:t,overrides:s}}function n(T,i){const o=T?i?T.keys.filter(s=>i.keys.indexOf(s)===-1):[...T.keys]:[],r=i?T?i.keys.filter(s=>T.keys.indexOf(s)===-1):[...i.keys]:[],t=[];if(T&&i){for(const s of i.keys)if(T.keys.indexOf(s)!==-1){const m=(0,R.getConfigurationValue)(i.contents,s),d=(0,R.getConfigurationValue)(T.contents,s);k.equals(m,d)||t.push(s)}}return{added:o,removed:r,updated:t}}}),define(Se[82],De([1,0,12,3]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var g;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(g=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends a.ErrorNoTelemetry{constructor(k,b=g.Unknown,P){super(k);this._message=k,this._code=b,this._detail=P,this.isHandled=b===g.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(k){return k instanceof L&&k._code===g.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof L&&k._code===g.NoResolverFound}static isHandled(k){return k instanceof L&&k.isHandled}}e.RemoteAuthorityResolverError=L}),define(Se[83],De([1,0,11]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function D(L){return L.scheme===a.Schemas.vscodeRemote?L.authority:void 0}e.getRemoteAuthority=D;function g(L){if(!L)return;const I=L.indexOf("+");return I<0?L:L.substr(0,I)}e.getRemoteName=g}),define(Se[26],De([1,0,9,3,83]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=L;function I(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var b;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,u){if(typeof f=="undefined"||f===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof f=="string"||typeof u=="string"){let h=typeof f=="string"?f:f.value,c=typeof u=="string"?u:u.value;return a.equalsIgnoreCase(h,c)}return f._lower===u._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=P;function R(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function v(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function p(w,f){if(f){const u=`onResolveRemoteAuthority:${(0,g.getRemoteName)(f)}`;return w.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[151],De([1,0,9,145,26,23,2,12,61]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,a.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{constructor(o,r,t="undefined"){this.version=r,this.targetPlatform=t,this.id=o.id}static create(o){const r=o.manifest?o.manifest.version:o.version,t=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new v(o.identifier,r,t)}static parse(o){const r=R.exec(o);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof v?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=v;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const o=p.exec(i);return o&&o[1]?[u(o[1]),o[2]]:[u(i),void 0]}e.getIdAndVersion=w;function f(i,o){return`${i}.${o}`}e.getExtensionId=f;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function h(i,o){return u(f(i,o))}e.getGalleryExtensionId=h;function c(i,o){const r=[],t=s=>{for(const m of r)if(m.some(d=>P(o(d),o(s))))return m;return null};for(const s of i){const m=t(s);m?m.push(s):r.push([s])}return r}e.groupByExtension=c;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function _(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new g.ExtensionIdentifier("pprice.better-merge");function l(i){const o=new Set;if(i.malicious)for(const r of i.malicious)o.add(r.id);return o}e.getMaliciousExtensionsSet=l;function S(i,o){const r=[],t=o.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const s=t.shift();if(s&&r.every(m=>!P(m.identifier,{id:s}))){const m=i.filter(d=>P(d.identifier,{id:s}));m.length===1&&(r.push(m[0]),t.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=S;async function n(i,o){if(!L.isLinux)return!1;let r;try{r=(await i.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){o.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function T(i,o){const r=await n(i,o),t=(0,D.getTargetPlatform)(r?"alpine":L.platform,b.arch);return o.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=T}),define(Se[152],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(g){this._callback=g,this._terminalBufferMap=new Map}dispose(){for(const g of this._terminalBufferMap.values())g.dispose()}startBuffering(g,L,I=5){let k;return k=L(b=>{const P=typeof b=="string"?b:b.data;let R=this._terminalBufferMap.get(g);if(R){R.data.push(P);return}const v=setTimeout(()=>this.flushBuffer(g),I);R={data:[P],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(g),k.dispose()}},this._terminalBufferMap.set(g,R)}),k}stopBuffering(g){const L=this._terminalBufferMap.get(g);L&&L.dispose()}flushBuffer(g){const L=this._terminalBufferMap.get(g);L&&(this._terminalBufferMap.delete(g),this._callback(g,L.data.join("")))}}e.TerminalDataBufferer=a}),define(Se[153],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var a;(function(g){g.DARK="dark",g.LIGHT="light",g.HIGH_CONTRAST_DARK="hcDark",g.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function D(g){return g===a.HIGH_CONTRAST_DARK||g===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=D}),define(Se[62],De([1,0,110,5,7,3,34,153]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var b;(function(h){function c(y){return y&&typeof y=="object"&&typeof y.id=="string"}h.isThemeColor=c})(b=e.ThemeColor||(e.ThemeColor={}));function P(h){return{id:h}}e.themeColorFromId=P;var R;(function(h){function c(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||b.isThemeColor(o.color))}h.isThemeIcon=c;const y=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function _(o){const r=y.exec(o);if(!r)return;let[,t]=r;return{id:t}}h.fromString=_;function l(o){return{id:o}}h.fromId=l;function S(o,r){let t=o.id;const s=t.lastIndexOf("~");return s!==-1&&(t=t.substring(0,s)),r&&(t=`${t}~${r}`),{id:t}}h.modify=S;function n(o){const r=o.id.lastIndexOf("~");if(r!==-1)return o.id.substring(r+1)}h.getModifier=n;function T(o,r){return o.id===r.id&&o.color?.id===r.color?.id}h.isEqual=T;function i(o,r){return{id:o.id,color:r?P(r):void 0}}h.asThemeIcon=i,h.asClassNameArray=a.CSSIcon.asClassNameArray,h.asClassName=a.CSSIcon.asClassName,h.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function v(h){switch(h){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(c){return this.themingParticipants.push(c),this.onThemingParticipantAddedEmitter.fire(c),(0,g.toDisposable)(()=>{const y=this.themingParticipants.indexOf(c);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new p;I.Registry.add(e.Extensions.ThemingContribution,w);function f(h){return w.onColorThemeChange(h)}e.registerThemingParticipant=f;class u extends g.Disposable{constructor(c){super();this.themeService=c,this.theme=c.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(c){this.theme=c,this.updateStyles()}updateStyles(){}getColor(c,y){let _=this.theme.getColor(c);return _&&y&&(_=y(_,this.theme)),_?_.toString():null}}e.Themable=u}),define(Se[154],De([1,0,5,23,3,13]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,g.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,g.createDecorator)("sharedTunnelsService");var I;(function(f){f.Http="http",f.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=v;function p(f,u){return u?u!==1&&f<1024:!D.isWindows&&f<1024}e.isPortPrivileged=p;let w=class{constructor(u){this.logService=u,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],h=Array.from(this._tunnels.values());for(let c of h){const y=Array.from(c.values());for(let _ of y){const l=await _.value;l&&u.push(l)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:h}of u.values())await h.then(c=>c?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,h,c,y,_=!1,l=k.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${c} on local port ${y}.`),!u)return;h||(h="localhost");const n=this.retainOrCreateTunnel(u,h,c,y,_,l,S);return n?n.then(T=>{if(!T){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(T);return(T.tunnelRemoteHost!==h||T.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const h=this._tunnels.get(u.tunnelRemoteHost);if(h){const c=h.get(u.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,c))}}}}async tryDisposeTunnel(u,h,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${h}.`);const y=c.value.then(async _=>{_&&(await _.dispose(!0),this._onTunnelClosed.fire({host:_.tunnelRemoteHost,port:_.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(h),y}}async closeTunnel(u,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${h} `);const c=this._tunnels.get(u);if(c&&c.has(h)){const y=c.get(h);y.refcount=0,await this.tryDisposeTunnel(u,h,y)}}addTunnelToMap(u,h,c){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(h,{refcount:1,value:c})}async removeEmptyTunnelFromMap(u,h){const c=this._tunnels.get(u);c&&(await c.get(h)||c.delete(h),c.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,h){let c=[u];R(u)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):v(u)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const y=c.map(_=>this._tunnels.get(_));for(const _ of y){const l=_?.get(h);if(l)return l}}canTunnel(u){return!!P(u)}createWithProvider(u,h,c,y,_,l,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${c} on local port ${y}.`);const T={elevationRequired:_?p(y===void 0?c:y):!1},i={remoteAddress:{host:h,port:c},localAddressPort:y,privacy:l,public:l!==k.Private,protocol:S},o=u.forwardPort(i,T);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(h,c,o),o}};w=$e([ze(0,L.ILogService)],w),e.AbstractTunnelService=w}),define(Se[155],De([1,0,11]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function D(b){return b.scheme!==a.Schemas.file&&b.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=D;function g(b){if(b.folders.length)return b.folders.every(P=>D(P.uri))?b.folders[0].uri:void 0;if(b.configuration&&D(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=g;function L(b){return g(b)?.scheme}e.getVirtualWorkspaceScheme=L;function I(b){return g(b)?.authority}e.getVirtualWorkspaceAuthority=I;function k(b){return g(b)!==void 0}e.isVirtualWorkspace=k}),define(Se[45],De([1,0,127,17,22,24,2,3,11]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function P(i){const o=i;return typeof o?.id=="string"&&I.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=P;function R(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function v(i){const o=i;return typeof o?.id=="string"&&I.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=v;function p(i){const o=i;if(o?.uri)return{id:o.id,uri:I.URI.revive(o.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=p;var w;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function f(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=f;function u(i){const o=i;return!!(o&&typeof o=="object"&&I.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=u;class h{constructor(o,r,t,s,m){this._id=o,this._transient=t,this._configuration=s,this._ignorePathCasing=m,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o.with({scheme:o.scheme,authority:o.authority,path:o.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class c{constructor(o,r){this.raw=r,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,L.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function y(i){return new c({uri:i,index:0,name:(0,L.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace";const _=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(i,o){return L.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function S(i){let o;return I.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=S;function n(i,o){return!l(i,o)&&!S(i)}e.isSavedWorkspace=n;function T(i){return(typeof i=="string"?(0,D.extname)(i):(0,L.extname)(i))===_}e.hasWorkspaceFileExtension=T}),define(Se[63],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(g){this.id=g,this._data=new Map,this._idPool=1}add(g){const L=this._idPool++;return this._data.set(L,g),this.logDebugInfo(),L}get(g,L){return this._data.has(g)?this._data.get(g)[L]:void 0}delete(g){this._data.delete(g),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Se[35],De([1,0,11,24,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new D.ExtUri(k=>{const b=this._providerInfo.get(k.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(k,b){b===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,b)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,g.createDecorator)("IExtHostFileSystemInfo")}),define(Se[28],De([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Se[156],De([1,0,14]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class D{constructor(I,k,b){this._deferredPromises=new Map,this._id=I,this._shared=k,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const v of P.values())v.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,k){let b=this._value[I];return typeof b=="undefined"&&(b=k),b}update(I,k){this._value[I]=k;let b=this._deferredPromises.get(I);if(b!==void 0)return b.p;const P=new a.DeferredPromise;return this._deferredPromises.set(I,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=D;class g extends D{constructor(I,k){super(I.identifier.value,!0,k);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=g}),define(Se[157],De([1,0,5,2]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class g{constructor(I){this._notebooksAndEditors=I,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(I,k,b,P){const v=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(I)).acceptModelChanged(k.value,b,P);this._onDidChangeNotebookDocument.fire(v)}$acceptDirtyStateChanged(I,k){this._notebooksAndEditors.getNotebookDocument(D.URI.revive(I)).acceptDirty(k)}$acceptModelSaved(I){const k=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(I));this._onDidSaveNotebookDocument.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=g}),define(Se[16],De([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class D{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=D});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[158],De([1,0,26,5]),function(ee,e,a,D){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(k,b){g.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(k.identifier),Qe(this,g,b,"f"),Re(this,g,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Re(this,g,"f").get(this._id,k)}store(k,b){return Re(this,g,"f").store(this._id,k,b)}delete(k){return Re(this,g,"f").delete(this._id,k)}}e.ExtensionSecrets=L,g=new WeakMap}),define(Se[84],De([1,0,3,5]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class g{constructor(){this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new D.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(I,k){this._level=I,this._productConfig=k||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(I){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=I,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=g,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Se[64],De([1,0,3,154,5,16]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(b){function P(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:v.protocol}}b.fromApiTunnel=P;function R(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==D.TunnelPrivacyId.ConstantPrivate&&v.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}b.fromServiceTunnel=R})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new g.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,v,p,w){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([ze(0,L.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[6],De([1,0,15,12,75,22,74,9,10,2,42,38,82]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p){"use strict";var w,f,u,h,c,y,_,l,S,n,T,i,o,r,t,s,m,d,C,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function U(B){function N(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(N,B),Object.setPrototypeOf(N.prototype,B.prototype),N}let A=c=class{constructor(N){w.set(this,void 0),Qe(this,w,N,"f")}static from(...N){let re=N;return new c(function(){if(re){for(const Ie of re)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();re=void 0}})}dispose(){typeof Re(this,w,"f")=="function"&&(Re(this,w,"f").call(this),Qe(this,w,void 0,"f"))}};w=new WeakMap,A=c=$e([U],A),e.Disposable=A;let E=y=class{constructor(N,re){if(N<0)throw(0,D.illegalArgument)("line must be non-negative");if(re<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=N,this._character=re}static Min(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ke=N[Ie];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ke=N[Ie];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(N){if(!N)return!1;if(N instanceof y)return!0;let{line:re,character:Ie}=N;return typeof re=="number"&&typeof Ie=="number"}static of(N){if(N instanceof y)return N;if(this.isPosition(N))return new y(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,re=0){if(N===null||re===null)throw(0,D.illegalArgument)();let Ie;return typeof N=="undefined"?Ie=0:typeof N=="number"?Ie=N:(Ie=typeof N.lineDelta=="number"?N.lineDelta:0,re=typeof N.characterDelta=="number"?N.characterDelta:0),Ie===0&&re===0?this:new y(this.line+Ie,this.character+re)}with(N,re=this.character){if(N===null||re===null)throw(0,D.illegalArgument)();let Ie;return typeof N=="undefined"?Ie=this.line:typeof N=="number"?Ie=N:(Ie=typeof N.line=="number"?N.line:this.line,re=typeof N.character=="number"?N.character:this.character),Ie===this.line&&re===this.character?this:new y(Ie,re)}toJSON(){return{line:this.line,character:this.character}}};E=y=$e([U],E),e.Position=E;let $=_=class{constructor(N,re,Ie,Ke){let et,nt;if(typeof N=="number"&&typeof re=="number"&&typeof Ie=="number"&&typeof Ke=="number"?(et=new E(N,re),nt=new E(Ie,Ke)):E.isPosition(N)&&E.isPosition(re)&&(et=E.of(N),nt=E.of(re)),!et||!nt)throw new Error("Invalid arguments");et.isBefore(nt)?(this._start=et,this._end=nt):(this._start=nt,this._end=et)}static isRange(N){return N instanceof _?!0:N?E.isPosition(N.start)&&E.isPosition(N.end):!1}static of(N){if(N instanceof _)return N;if(this.isRange(N))return new _(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return _.isRange(N)?this.contains(N.start)&&this.contains(N.end):E.isPosition(N)?!(E.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const re=E.Max(N.start,this._start),Ie=E.Min(N.end,this._end);if(!re.isAfter(Ie))return new _(re,Ie)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const re=E.Min(N.start,this._start),Ie=E.Max(N.end,this.end);return new _(re,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,re=this.end){if(N===null||re===null)throw(0,D.illegalArgument)();let Ie;return N?E.isPosition(N)?Ie=N:(Ie=N.start||this.start,re=N.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&re.isEqual(this.end)?this:new _(Ie,re)}toJSON(){return[this.start,this.end]}};$=_=$e([U],$),e.Range=$;let x=l=class extends ${constructor(N,re,Ie,Ke){let et,nt;if(typeof N=="number"&&typeof re=="number"&&typeof Ie=="number"&&typeof Ke=="number"?(et=new E(N,re),nt=new E(Ie,Ke)):E.isPosition(N)&&E.isPosition(re)&&(et=E.of(N),nt=E.of(re)),!et||!nt)throw new Error("Invalid arguments");super(et,nt);this._anchor=et,this._active=nt}static isSelection(N){return N instanceof l?!0:N?$.isRange(N)&&E.isPosition(N.anchor)&&E.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=l=$e([U],x),e.Selection=x;class H{constructor(N,re,Ie){if(typeof N!="string"||N.length===0)throw(0,D.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,D.illegalArgument)("port");if(typeof Ie!="undefined"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw(0,D.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(re),this.connectionToken=Ie}}e.ResolvedAuthority=H;class oe extends Error{constructor(N,re=p.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(N);this._message=N,this._code=re,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,oe.prototype)}static NotAvailable(N,re){return new oe(N,p.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(N){return new oe(N,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=oe;var G;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(G=e.EndOfLine||(e.EndOfLine={}));var M;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=S=class{constructor(N,re){this._range=N,this._newText=re}static isTextEdit(N){return N instanceof S?!0:N?$.isRange(N)&&typeof N.newText=="string":!1}static replace(N,re){return new S(N,re)}static insert(N,re){return S.replace(new $(N,N),re)}static delete(N){return S.replace(N,"")}static setEndOfLine(N){const re=new S(new $(new E(0,0),new E(0,0)),"");return re.newEol=N,re}get range(){return this._range}set range(N){if(N&&!$.isRange(N))throw(0,D.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,D.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,D.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=S=$e([U],le),e.TextEdit=le;class me{constructor(N,re){this.range=N,this.snippet=re}}e.SnippetTextEdit=me;var ae;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace"})(ae=e.FileEditType||(e.FileEditType={}));let ge=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,re,Ie,Ke){this._edits.push({_type:1,from:N,to:re,options:Ie,metadata:Ke})}createFile(N,re,Ie){this._edits.push({_type:1,from:void 0,to:N,options:re,metadata:Ie})}deleteFile(N,re,Ie){this._edits.push({_type:1,from:N,to:void 0,options:re,metadata:Ie})}replaceNotebookMetadata(N,re,Ie){this._edits.push({_type:3,metadata:Ie,uri:N,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(N,re,Ie,Ke,et){let nt,ut,St=[],kt;if(gt.isNotebookRange(re)&&jt.isNotebookCellDataArray(Ie)&&!jt.isNotebookCellDataArray(Ke)?(nt=re.start,ut=re.end,St=Ie,kt=Ke):typeof re=="number"&&typeof Ie=="number"&&jt.isNotebookCellDataArray(Ke)&&(nt=re,ut=Ie,St=Ke,kt=et),nt===void 0||ut===void 0)throw new Error("Invalid arguments");(nt!==ut||St.length>0)&&this._edits.push({_type:5,uri:N,index:nt,count:ut-nt,cells:St,metadata:kt})}replaceNotebookCellMetadata(N,re,Ie,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:re,metadata:Ie}})}replace(N,re,Ie,Ke){this._edits.push({_type:2,uri:N,edit:new le(re,Ie),metadata:Ke})}insert(N,re,Ie,Ke){this.replace(N,new $(re,re),Ie,Ke)}delete(N,re,Ie){this.replace(N,re,"",Ie)}has(N){return this._edits.some(re=>re._type===2&&re.uri.toString()===N.toString())}set(N,re){if(re)for(const Ie of re)Ie&&this._edits.push({_type:2,uri:N,edit:Ie});else{for(let Ie=0;Ie<this._edits.length;Ie++){const Ke=this._edits[Ie];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[Ie]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(N){const re=[];for(let Ie of this._edits)Ie._type===2&&Ie.uri.toString()===N.toString()&&re.push(Ie.edit);return re}entries(){const N=new L.ResourceMap;for(let re of this._edits)if(re._type===2){let Ie=N.get(re.uri);Ie||(Ie=[re.uri,[]],N.set(re.uri,Ie)),Ie[1].push(re.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ge=$e([U],ge),e.WorkspaceEdit=ge;let te=n=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof n?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=n._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,re=this._tabstop++){if(typeof N=="function"){const Ie=new n;Ie._tabstop=this._tabstop,N(Ie),this._tabstop=Ie._tabstop,N=Ie.value}else N=n._escape(N);return this.value+="${",this.value+=re,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,re=this._tabstop++){const Ie=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(N,re){if(typeof re=="function"){const Ie=new n;Ie._tabstop=this._tabstop,re(Ie),this._tabstop=Ie._tabstop,re=Ie.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,re&&(this.value+=":",this.value+=re),this.value+="}",this}};te=n=$e([U],te),e.SnippetString=te;var Ee;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Ee=e.DiagnosticTag||(e.DiagnosticTag={}));var we;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(we=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=T=class{constructor(N,re){if(this.uri=N,re)if($.isRange(re))this.range=$.of(re);else if(E.isPosition(re))this.range=new $(re,re);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof T?!0:N?$.isRange(N.range)&&P.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=T=$e([U],Z),e.Location=Z;let pe=class{constructor(N,re){this.location=N,this.message=re}static is(N){return N?typeof N.message=="string"&&N.location&&$.isRange(N.location.range)&&P.URI.isUri(N.location.uri):!1}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.location.range.isEqual(re.location.range)&&N.location.uri.toString()===re.location.uri.toString()}};pe=$e([U],pe),e.DiagnosticRelatedInformation=pe;let Pe=class{constructor(N,re,Ie=we.Error){if(!$.isRange(N))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=N,this.message=re,this.severity=Ie}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.severity===re.severity&&N.code===re.code&&N.severity===re.severity&&N.source===re.source&&N.range.isEqual(re.range)&&(0,a.equals)(N.tags,re.tags)&&(0,a.equals)(N.relatedInformation,re.relatedInformation,pe.isEqual)}};Pe=$e([U],Pe),e.Diagnostic=Pe;let Ne=class{constructor(N,re){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=re}};Ne=$e([U],Ne),e.Hover=Ne;var We;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(We=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ge=class{constructor(N,re=We.Text){this.range=N,this.kind=re}toJSON(){return{range:this.range,kind:We[this.kind]}}};Ge=$e([U],Ge),e.DocumentHighlight=Ge;var Ce;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Ce=e.SymbolKind||(e.SymbolKind={}));var _e;(function(B){B[B.Deprecated=1]="Deprecated"})(_e=e.SymbolTag||(e.SymbolTag={}));let Te=i=class{constructor(N,re,Ie,Ke,et){this.name=N,this.kind=re,this.containerName=et,typeof Ie=="string"&&(this.containerName=Ie),Ke instanceof Z?this.location=Ke:Ie instanceof $&&(this.location=new Z(Ke,Ie)),i.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};Te=i=$e([U],Te),e.SymbolInformation=Te;let se=o=class{constructor(N,re,Ie,Ke,et){this.name=N,this.detail=re,this.kind=Ie,this.range=Ke,this.selectionRange=et,this.children=[],o.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(o.validate)}};se=o=$e([U],se),e.DocumentSymbol=se;var ue;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Q=class{constructor(N,re){this.title=N,this.kind=re}};Q=$e([U],Q),e.CodeAction=Q;let J=r=class{constructor(N){this.value=N}append(N){return new r(this.value?this.value+r.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+r.sep)}};J.sep=".",J=r=$e([U],J),e.CodeActionKind=J,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll");let ce=class{constructor(N,re){if(this.range=N,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=$e([U],ce),e.SelectionRange=ce;class ve{constructor(N,re,Ie,Ke,et,nt){this.kind=N,this.name=re,this.detail=Ie,this.uri=Ke,this.range=et,this.selectionRange=nt}}e.CallHierarchyItem=ve;class F{constructor(N,re){this.fromRanges=re,this.from=N}}e.CallHierarchyIncomingCall=F;class W{constructor(N,re){this.fromRanges=re,this.to=N}}e.CallHierarchyOutgoingCall=W;var V;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(V=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let K=class{constructor(N,re){this.range=N,this.command=re}get isResolved(){return!!this.command}};K=$e([U],K),e.CodeLens=K;let z=t=class{constructor(N,re=!1){f.set(this,void 0),Qe(this,f,new g.MarkdownString(N,{supportThemeIcons:re}),"f")}static isMarkdownString(N){return N instanceof t?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Re(this,f,"f").value}set value(N){Re(this,f,"f").value=N}get isTrusted(){return Re(this,f,"f").isTrusted}set isTrusted(N){Re(this,f,"f").isTrusted=N}get supportThemeIcons(){return Re(this,f,"f").supportThemeIcons}set supportThemeIcons(N){Re(this,f,"f").supportThemeIcons=N}get supportHtml(){return Re(this,f,"f").supportHtml}set supportHtml(N){Re(this,f,"f").supportHtml=N}get baseUri(){return Re(this,f,"f").baseUri}set baseUri(N){Re(this,f,"f").baseUri=N}appendText(N){return Re(this,f,"f").appendText(N),this}appendMarkdown(N){return Re(this,f,"f").appendMarkdown(N),this}appendCodeblock(N,re){return Re(this,f,"f").appendCodeblock(re??"",N),this}};f=new WeakMap,z=t=$e([U],z),e.MarkdownString=z;let Y=class{constructor(N,re){this.label=N,this.documentation=re}};Y=$e([U],Y),e.ParameterInformation=Y;let ie=class{constructor(N,re){this.label=N,this.documentation=re,this.parameters=[]}};ie=$e([U],ie),e.SignatureInformation=ie;let Fe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Fe=$e([U],Fe),e.SignatureHelp=Fe;var Ue;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Ue=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ke;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ke=e.InlayHintKind||(e.InlayHintKind={}));let Ve=class{constructor(N){this.value=N}};Ve=$e([U],Ve),e.InlayHintLabelPart=Ve;let q=class{constructor(N,re,Ie){this.position=N,this.label=re,this.kind=Ie}};q=$e([U],q),e.InlayHint=q;var X;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var he;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(he=e.CompletionItemKind||(e.CompletionItemKind={}));var Le;(function(B){B[B.Deprecated=1]="Deprecated"})(Le=e.CompletionItemTag||(e.CompletionItemTag={}));let xe=class{constructor(N,re){this.label=N,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};xe=$e([U],xe),e.CompletionItem=xe;let Xe=class{constructor(N=[],re=!1){this.items=N,this.isIncomplete=re}};Xe=$e([U],Xe),e.CompletionList=Xe;let Je=class{constructor(N,re,Ie){this.insertText=N,this.range=re,this.command=Ie}};Je=$e([U],Je),e.InlineSuggestion=Je;let rt=class{constructor(N){this.items=N}};rt=$e([U],rt),e.InlineSuggestions=rt;let Ye=class{constructor(N,re,Ie){this.insertText=N,this.range=re,this.command=Ie}};Ye=$e([U],Ye),e.InlineSuggestionNew=Ye;let Ze=class{constructor(N,re){this.items=N,this.commands=re}};Ze=$e([U],Ze),e.InlineSuggestionsNew=Ze;var qe;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(qe=e.ViewColumn||(e.ViewColumn={}));var lt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var st;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var It;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(It=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(at=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ht;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ht=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ut;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ft;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ft=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function N(re){switch(re){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=N}(ht=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let yt=class{constructor(N,re){if(re&&!P.URI.isUri(re))throw(0,D.illegalArgument)("target");if(!$.isRange(N)||N.isEmpty)throw(0,D.illegalArgument)("range");this.range=N,this.target=re}};yt=$e([U],yt),e.DocumentLink=yt;let ft=class{constructor(N,re,Ie,Ke){this.red=N,this.green=re,this.blue=Ie,this.alpha=Ke}};ft=$e([U],ft),e.Color=ft;let Dt=class{constructor(N,re){if(re&&!(re instanceof ft))throw(0,D.illegalArgument)("color");if(!$.isRange(N)||N.isEmpty)throw(0,D.illegalArgument)("range");this.range=N,this.color=re}};Dt=$e([U],Dt),e.ColorInformation=Dt;let Pt=class{constructor(N){if(!N||typeof N!="string")throw(0,D.illegalArgument)("label");this.label=N}};Pt=$e([U],Pt),e.ColorPresentation=Pt;var Nt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var He;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(He=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class $t{constructor(N,re,Ie){if(this.startIndex=N,this.length=re,this.tooltip=Ie,typeof N!="number"||N<0)throw(0,D.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,D.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,D.illegalArgument)("tooltip")}}e.TerminalLink=$t;var At;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(At=e.TerminalLocation||(e.TerminalLocation={}));class Mt{constructor(N){if(this.options=N,typeof N!="object")throw(0,D.illegalArgument)("options")}}e.TerminalProfile=Mt;var be;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(be=e.TaskRevealKind||(e.TaskRevealKind={}));var ye;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ye=e.TaskPanelKind||(e.TaskPanelKind={}));let de=s=class{constructor(N,re){if(this.label=re,typeof N!="string"||typeof re!="string")throw(0,D.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};de.Clean=new s("clean","Clean"),de.Build=new s("build","Build"),de.Rebuild=new s("rebuild","Rebuild"),de.Test=new s("test","Test"),de=s=$e([U],de),e.TaskGroup=de;function j(B){let N="";for(let re=0;re<B.length;re++)N+=B[re].replace(/,/g,",,")+",";return N}let Ae=class{constructor(N,re,Ie){if(typeof N!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=N,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=Ie):this._options=re)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,D.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let re of this._args)N.push(re);return j(N)}};Ae=$e([U],Ae),e.ProcessExecution=Ae;let Be=class{constructor(N,re,Ie){if(this._args=[],Array.isArray(re)){if(!N)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,D.illegalArgument)("command");this._command=N,this._args=re,this._options=Ie}else{if(typeof N!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=N,this._options=re}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,D.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)N.push(typeof re=="string"?re:re.value);return j(N)}};Be=$e([U],Be),e.ShellExecution=Be;var tt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(tt=e.ShellQuoting||(e.ShellQuoting={}));var je;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(je=e.TaskScope||(e.TaskScope={}));class ot{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=ot;let ct=m=class{constructor(N,re,Ie,Ke,et,nt){this.__deprecated=!1,this._definition=this.definition=N;let ut;typeof re=="string"?(this._name=this.name=re,this._source=this.source=Ie,this.execution=Ke,ut=et,this.__deprecated=!0):re===je.Global||re===je.Workspace?(this.target=re,this._name=this.name=Ie,this._source=this.source=Ke,this.execution=et,ut=nt):(this.target=re,this._name=this.name=Ie,this._source=this.source=Ke,this.execution=et,ut=nt),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ae?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Be?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof ot?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const re=this._definition.type;(m.EmptyType===re||m.ProcessType===re||m.ShellType===re||m.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=m=$e([U],ct),e.Task=ct;var pt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(pt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(N,re=mt.None){this.collapsibleState=re,P.URI.isUri(N)?this.resourceUri=N:this.label=N}};_t=$e([U],_t),e.TreeItem=_t;var mt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let vt=class{constructor(N){this.value=N}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};vt=$e([U],vt),e.DataTransferItem=vt;let Rt=class{constructor(){this._items=new Map}get(N){return this._items.get(N)}set(N,re){this._items.set(N,re)}forEach(N){this._items.forEach(N)}};Rt=$e([U],Rt),e.DataTransfer=Rt;let Et=class{constructor(N,re){this.id=N,this.color=re}};Et=$e([U],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let Gt=class{constructor(N){this.id=N}};Gt=$e([U],Gt),e.ThemeColor=Gt;var Qt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let bt=class{constructor(N,re){if(typeof N!="string"&&(!N||!P.URI.isUri(N)&&!P.URI.isUri(N.uri)))throw(0,D.illegalArgument)("base");if(typeof re!="string")throw(0,D.illegalArgument)("pattern");typeof N=="string"?this.baseUri=P.URI.file(N):P.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=re}get base(){return this._base}set base(N){this._base=N,this._baseUri=P.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};bt=$e([U],bt),e.RelativePattern=bt;let zt=class{constructor(N,re,Ie,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof re=="string"&&(this.condition=re),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};zt=$e([U],zt),e.Breakpoint=zt;let Yt=class extends zt{constructor(N,re,Ie,Ke,et){super(re,Ie,Ke,et);if(N===null)throw(0,D.illegalArgument)("location");this.location=N}};Yt=$e([U],Yt),e.SourceBreakpoint=Yt;let Jt=class extends zt{constructor(N,re,Ie,Ke,et){super(re,Ie,Ke,et);this.functionName=N}};Jt=$e([U],Jt),e.FunctionBreakpoint=Jt;let ui=class extends zt{constructor(N,re,Ie,Ke,et,nt,ut){super(Ke,et,nt,ut);if(!re)throw(0,D.illegalArgument)("dataId");this.label=N,this.dataId=re,this.canPersist=Ie}};ui=$e([U],ui),e.DataBreakpoint=ui;let ci=class{constructor(N,re,Ie){this.command=N,this.args=re||[],this.options=Ie}};ci=$e([U],ci),e.DebugAdapterExecutable=ci;let Tt=class{constructor(N,re){this.port=N,this.host=re}};Tt=$e([U],Tt),e.DebugAdapterServer=Tt;let Zt=class{constructor(N){this.path=N}};Zt=$e([U],Zt),e.DebugAdapterNamedPipeServer=Zt;let di=class{constructor(N){this.implementation=N}};di=$e([U],di),e.DebugAdapterInlineImplementation=di;let Xt=class{constructor(N,re){this.range=N,this.expression=re}};Xt=$e([U],Xt),e.EvaluatableExpression=Xt;var ei;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(ei=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var dt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(dt=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let hi=class{constructor(N,re){this.range=N,this.text=re}};hi=$e([U],hi),e.InlineValueText=hi;let Bt=class{constructor(N,re,Ie=!0){this.range=N,this.variableName=re,this.caseSensitiveLookup=Ie}};Bt=$e([U],Bt),e.InlineValueVariableLookup=Bt;let Ht=class{constructor(N,re){this.range=N,this.expression=re}};Ht=$e([U],Ht),e.InlineValueEvaluatableExpression=Ht;let ti=class{constructor(N,re){this.frameId=N,this.stoppedLocation=re}};ti=$e([U],ti),e.InlineValueContext=ti;var ki;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(ki=e.FileChangeType||(e.FileChangeType={}));let ii=d=class extends Error{constructor(N,re=v.FileSystemProviderErrorCode.Unknown,Ie){super(P.URI.isUri(N)?N.toString(!0):N);this.code=Ie?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}static FileExists(N){return new d(N,v.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(N){return new d(N,v.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(N){return new d(N,v.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(N){return new d(N,v.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(N){return new d(N,v.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(N){return new d(N,v.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};ii=d=$e([U],ii),e.FileSystemError=ii;let fi=class{constructor(N,re,Ie){this.start=N,this.end=re,this.kind=Ie}};fi=$e([U],fi),e.FoldingRange=fi;var _i;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ni;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Pi=e.CommentMode||(e.CommentMode={}));var mi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class gi{constructor(N,re=[]){this.tokenTypes=N,this.tokenModifiers=re}}e.SemanticTokensLegend=gi;function Ai(B){return typeof B=="undefined"||(0,b.isStringArray)(B)}class pi{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let re=0,Ie=N.tokenTypes.length;re<Ie;re++)this._tokenTypeStrToInt.set(N.tokenTypes[re],re);for(let re=0,Ie=N.tokenModifiers.length;re<Ie;re++)this._tokenModifierStrToInt.set(N.tokenModifiers[re],re)}}push(N,re,Ie,Ke,et){if(typeof N=="number"&&typeof re=="number"&&typeof Ie=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(N,re,Ie,Ke,et);if($.isRange(N)&&typeof re=="string"&&Ai(Ie))return this._push(N,re,Ie);throw(0,D.illegalArgument)()}_push(N,re,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,et=N.start.character,nt=N.end.character-N.start.character,ut=this._tokenTypeStrToInt.get(re);let St=0;if(Ie)for(const kt of Ie){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(kt);St|=1<<xt>>>0}this._pushEncoded(Ke,et,nt,ut,St)}_pushEncoded(N,re,Ie,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,xt=0;for(let Wt=0;Wt<St;Wt++){let qt=this._data[5*Wt],bi=this._data[5*Wt+1];qt===0?(qt=kt,bi+=xt):qt+=kt,this._data[5*Wt]=qt,this._data[5*Wt+1]=bi,kt=qt,xt=bi}}let nt=N,ut=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=N,this._prevChar=re}static _sortAndDeltaEncode(N){let re=[];const Ie=N.length/5|0;for(let ut=0;ut<Ie;ut++)re[ut]=ut;re.sort((ut,St)=>{const kt=N[5*ut],xt=N[5*St];if(kt===xt){const Wt=N[5*ut+1],qt=N[5*St+1];return Wt-qt}return kt-xt});const Ke=new Uint32Array(N.length);let et=0,nt=0;for(let ut=0;ut<Ie;ut++){const St=5*re[ut],kt=N[St+0],xt=N[St+1],Wt=N[St+2],qt=N[St+3],bi=N[St+4],Xi=kt-et,dn=Xi===0?xt-nt:xt,wi=5*ut;Ke[wi+0]=Xi,Ke[wi+1]=dn,Ke[wi+2]=Wt,Ke[wi+3]=qt,Ke[wi+4]=bi,et=kt,nt=xt}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new Vt(new Uint32Array(this._data),N):new Vt(pi._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=pi;class Vt{constructor(N,re){this.resultId=re,this.data=N}}e.SemanticTokens=Vt;class Ri{constructor(N,re,Ie){this.start=N,this.deleteCount=re,this.data=Ie}}e.SemanticTokensEdit=Ri;class Oi{constructor(N,re){this.resultId=re,this.edits=N}}e.SemanticTokensEdits=Oi;var Fi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Fi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ri=class{constructor(){}};ri.Back={iconPath:new Et("arrow-left")},ri=$e([U],ri),e.QuickInputButtons=ri;var vi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(vi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Si;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Si=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var yi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(yi=e.ExtensionKind||(e.ExtensionKind={}));class Me{constructor(N,re,Ie){this.badge=N,this.tooltip=re,this.color=Ie}static validate(N){if(N.badge){let re=(0,k.nextCharLength)(N.badge,0);if(re<N.badge.length&&(re+=(0,k.nextCharLength)(N.badge,re)),N.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Me;let Lt=class{constructor(N){this.kind=N}};Lt=$e([U],Lt),e.ColorTheme=Lt;var Di;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Di=e.ColorThemeKind||(e.ColorThemeKind={}));class gt{constructor(N,re){if(N<0)throw(0,D.illegalArgument)("start must be positive");if(re<0)throw(0,D.illegalArgument)("end must be positive");N<=re?(this._start=N,this._end=re):(this._start=re,this._end=N)}static isNotebookRange(N){return N instanceof gt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let re=this._start,Ie=this._end;return N.start!==void 0&&(re=N.start),N.end!==void 0&&(Ie=N.end),re===this._start&&Ie===this._end?this:new gt(re,Ie)}}e.NotebookRange=gt;class jt{constructor(N,re,Ie,Ke,et,nt,ut){this.kind=N,this.value=re,this.languageId=Ie,this.mime=Ke,this.outputs=et??[],this.metadata=nt,this.executionSummary=ut,jt.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(re=>jt.isNotebookCellData(re))}static isNotebookCellData(N){return!0}}e.NotebookCellData=jt;class Ni{constructor(N){this.cells=N}}e.NotebookData=Ni;class Ot{constructor(N,re){this.data=N,this.mime=re;const Ie=(0,I.normalizeMimeType)(re,!0);if(!Ie)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}static isNotebookCellOutputItem(N){return N instanceof Ot?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const re={name:N.name,message:N.message,stack:N.stack};return Ot.json(re,"application/vnd.code.notebook.error")}static stdout(N){return Ot.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Ot.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,re="application/octet-stream"){return new Ot(N,re)}static text(N,re=I.Mimes.text){const Ie=Re(Ot,u,"f",h).encode(String(N));return new Ot(Ie,re)}static json(N,re="text/x-json"){const Ie=JSON.stringify(N,void 0,"	");return Ot.text(Ie,re)}}e.NotebookCellOutputItem=Ot,u=Ot,h={value:new TextEncoder};class si{constructor(N,re,Ie){this.items=si.ensureUniqueMimeTypes(N,!0),typeof re=="string"?(this.id=re,this.metadata=Ie):(this.id=(0,R.generateUuid)(),this.metadata=re??Ie)}static isNotebookCellOutput(N){return N instanceof si?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&(0,b.isArray)(N.items)}static ensureUniqueMimeTypes(N,re=!1){const Ie=new Set,Ke=new Set;for(let et=0;et<N.length;et++){const nt=N[et],ut=(0,I.normalizeMimeType)(nt.mime);if(!Ie.has(ut)){Ie.add(ut);continue}Ke.add(et),re&&console.warn(`DUPLICATED mime type '${nt.mime}' will be dropped`)}return Ke.size===0?N:N.filter((et,nt)=>!Ke.has(nt))}}e.NotebookCellOutput=si;var oi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(oi=e.NotebookCellKind||(e.NotebookCellKind={}));var Mi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Mi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Li;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Li=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ui;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ui=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ci{constructor(N,re){this.text=N,this.alignment=re}}e.NotebookCellStatusBarItem=Ci;var Bi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Bi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class xi{constructor(N,re=[]){this.uri=N,this.provides=(0,a.asArray)(re)}}e.NotebookRendererScript=xi;let Ei=class{constructor(N,re){this.label=N,this.timestamp=re}};Ei=$e([U],Ei),e.TimelineItem=Ei;var $i;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})($i=e.ExtensionMode||(e.ExtensionMode={}));var Wi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Wi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ne;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ne=e.StandardTokenType||(e.StandardTokenType={}));class fe{constructor(N,re){this.ranges=N,this.wordPattern=re}}e.LinkedEditingRanges=fe;class Oe{constructor(N,re){this._port=N,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Oe;var it;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(it=e.TestResultState||(e.TestResultState={}));var wt;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(wt=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ct=class{constructor(N=void 0,re=void 0,Ie=void 0){this.include=N,this.exclude=re,this.profile=Ie}};Ct=$e([U],Ct),e.TestRunRequest=Ct;let zi=C=class{constructor(N){this.message=N}static diff(N,re,Ie){const Ke=new C(N);return Ke.expectedOutput=re,Ke.actualOutput=Ie,Ke}};zi=C=$e([U],zi),e.TestMessage=zi;let Hi=class{constructor(N){this.id=N}};Hi=$e([U],Hi),e.TestTag=Hi;let ai=class{constructor(N,re){this.covered=N,this.total=re}};ai=$e([U],ai),e.CoveredCount=ai;let Vi=O=class{constructor(N,re,Ie,Ke){this.uri=N,this.statementCoverage=re,this.branchCoverage=Ie,this.functionCoverage=Ke}static fromDetails(N,re){const Ie=new ai(0,0),Ke=new ai(0,0),et=new ai(0,0);for(const ut of re)if("branches"in ut){Ie.total+=1,Ie.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ke.total+=1,Ke.covered+=St.executionCount>0?1:0}else et.total+=1,et.covered+=ut.executionCount>0?1:0;const nt=new O(N,Ie,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return nt.detailedCoverage=re,nt}};Vi=O=$e([U],Vi),e.FileCoverage=Vi;let ji=class{constructor(N,re,Ie=[]){this.executionCount=N,this.location=re,this.branches=Ie}};ji=$e([U],ji),e.StatementCoverage=ji;let qi=class{constructor(N,re){this.executionCount=N,this.location=re}};qi=$e([U],qi),e.BranchCoverage=qi;let Ki=class{constructor(N,re){this.executionCount=N,this.location=re}};Ki=$e([U],Ki),e.FunctionCoverage=Ki;var Zi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var en;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(en=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var tn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(tn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class nn{constructor(N,re,Ie,Ke,et,nt){this.kind=N,this.name=re,this.detail=Ie,this.uri=Ke,this.range=et,this.selectionRange=nt}}e.TypeHierarchyItem=nn;class rn{constructor(N){this.uri=N}}e.TextTabInput=rn;class sn{constructor(N,re){this.original=N,this.modified=re}}e.TextDiffTabInput=sn;class on{constructor(N,re){this.uri=N,this.viewType=re}}e.CustomEditorTabInput=on;class an{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=an;class ln{constructor(N,re){this.uri=N,this.notebookType=re}}e.NotebookEditorTabInput=ln;class un{constructor(N,re,Ie){this.original=N,this.modified=re,this.notebookType=Ie}}e.NotebookDiffEditorTabInput=un;class cn{constructor(){}}e.TerminalEditorTabInput=cn}),define(Se[85],De([1,0,41,11,9,232,121,6,15]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(f,u){u?P.set(f,u):P.delete(f)}e.setWordDefinitionFor=R;function v(f){return P.get(f)}e.getWordDefinitionFor=v;class p extends L.MirrorTextModel{constructor(u,h,c,y,_,l,S,n){super(h,c,y,_);this._proxy=u,this._languageId=l,this._isDirty=S,this._notebook=n,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,b.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===D.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(h){return h?u._getTextInRange(h):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(h){return u._lineAt(h)},offsetAt(h){return u._offsetAt(h)},positionAt(h){return u._positionAt(h)},validateRange(h){return u._validateRange(h)},validatePosition(h){return u._validatePosition(h)},getWordRangeAtPosition(h,c){return u._getWordRangeAtPosition(h,c)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,a.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,a.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const h=this._validateRange(u);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const c=this._eol,y=h.start.line,_=h.end.line,l=[];l.push(this._lines[y].substring(h.start.character));for(let S=y+1;S<_;S++)l.push(this._lines[S]);return l.push(this._lines[_].substring(0,h.end.character)),l.join(c)}_lineAt(u){let h;if(u instanceof k.Position?h=u.line:typeof u=="number"&&(h=u),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new w(h,this._lines[h],h===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(u),c=this._lines[h.index].length;return new k.Position(h.index,Math.min(h.remainder,c))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const h=this._validatePosition(u.start),c=this._validatePosition(u.end);return h===u.start&&c===u.end?u:new k.Range(h.line,h.character,c.line,c.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:h,character:c}=u,y=!1;if(h<0)h=0,c=0,y=!0;else if(h>=this._lines.length)h=this._lines.length-1,c=this._lines[h].length,y=!0;else{const _=this._lines[h].length;c<0?(c=0,y=!0):c>_&&(c=_,y=!0)}return y?new k.Position(h,c):u}_getWordRangeAtPosition(u,h){const c=this._validatePosition(u);if(!h)h=v(this._languageId);else if((0,g.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const y=(0,I.getWordAtText)(c.character+1,(0,I.ensureValidWordDefinition)(h),this._lines[c.line],0);if(y)return new k.Range(c.line,y.startColumn-1,c.line,y.endColumn-1)}}e.ExtHostDocumentData=p;class w{constructor(u,h,c){this._line=u,this._text=h,this._isLastLine=c}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(Se[159],De([1,0,6,16,5]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(k){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new g.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let b;switch(k){case"light":b=a.ColorThemeKind.Light;break;case"hcDark":b=a.ColorThemeKind.HighContrast;break;case"hcLight":b=a.ColorThemeKind.HighContrastLight;break;default:b=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};L=$e([ze(0,D.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Se[65],De([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class D{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=D}),define(Se[160],De([1,0,25]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class D{constructor(){this.buffers=[]}add(b){let P=this.buffers.indexOf(b);return P<0&&(P=this.buffers.length,this.buffers.push(b)),P}}function g(k,b){if(b.serializeBuffersForPostMessage){const P=new D,R=(w,f)=>{if(f instanceof ArrayBuffer){const u=P.add(f);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(f)){const u=L(f);if(u){const h=P.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:u,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},v=JSON.stringify(k,R),p=P.buffers.map(w=>{const f=new Uint8Array(w);return a.VSBuffer.wrap(f)});return{message:v,buffers:p}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=g;function L(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(k,b){const P=b.map(p=>{const w=new ArrayBuffer(p.byteLength);return new Uint8Array(w).set(p.buffer),w}),R=b.length?(p,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const f=w,{index:u}=f,h=P[u];if(f.view)switch(f.view.type){case 1:return new Int8Array(h,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return w}:void 0;return{message:JSON.parse(k,R),arrayBuffers:P}}e.deserializeWebviewMessage=I}),define(Se[86],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransferConverter=void 0;var a;(function(D){function g(I){const k=new Map;return I.types.forEach((b,P)=>{k.set(b,{asString:async()=>I.items[P].asString,value:void 0})}),k}D.toDataTransfer=g;async function L(I){const k={types:[],items:[]},b=Array.from(I.entries());for(const P of b)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}D.toDataTransferDTO=L})(a=e.DataTransferConverter||(e.DataTransferConverter={}))}),define(Se[161],De([1,0,135,10,2,7,3,34,38,15,11]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(v=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function w(G){const M=G;return!!M&&typeof M.getSelection=="function"&&!!M.onDidChangeSelection}e.isEditorPaneWithSelection=w;function f(G,M,le){for(const me of le.visibleEditorPanes)if(me.group.id===M&&G.matches(me.input))return me.getViewState()}e.findViewStateForEditor=f;function u(G){if(i(G))return!1;const M=G;return g.URI.isUri(M?.resource)}e.isResourceEditorInput=u;function h(G){if(i(G))return!1;const M=G;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=h;function c(G){if(i(G)||h(G))return!1;const M=G;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function y(G){if(i(G))return!1;const M=G;return M?M.resource===void 0||M.resource.scheme===R.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;var _;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(_=e.Verbosity||(e.Verbosity={}));var l;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class S{constructor(){this.mapIdToSaveSource=new Map}registerSource(M,le){let me=this.mapIdToSaveSource.get(M);return me||(me={source:M,label:le},this.mapIdToSaveSource.set(M,me)),me.source}getSourceLabel(M){return this.mapIdToSaveSource.get(M)?.label??M}}e.SaveSourceRegistry=new S;var n;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class T extends L.Disposable{}e.AbstractEditorInput=T;function i(G){return G instanceof T}e.isEditorInput=i;function o(G){const M=G;return g.URI.isUri(M?.preferredResource)}function r(G){const M=G;return i(M?.primary)&&i(M?.secondary)}e.isSideBySideEditorInput=r;function t(G){const M=G;return i(M?.modified)&&i(M?.original)}e.isDiffEditorInput=t;function s(G){return i(G?.editor)}e.isEditorInputWithOptions=s;function m(G){const M=G;return s(G)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function d(G){const M=G;return typeof M?.groupId=="number"&&i(M.editor)}e.isEditorIdentifier=d;var C;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(C=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(M,le){if(!M)return;if(le?.supportSideBySide){const{primary:ae,secondary:ge}=this.getSideEditors(M);if(ae&&ge){if(le?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:le.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===U.ANY)return this.getOriginalUri(ae,{filterByScheme:le.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:le.filterByScheme});M=le.supportSideBySide===U.PRIMARY?ae:ge}}if(h(M)||c(M))return;const me=o(M)?M.preferredResource:M.resource;return!me||!le||!le.filterByScheme?me:this.filterUri(me,le.filterByScheme)}getSideEditors(M){return r(M)||c(M)?{primary:M.primary,secondary:M.secondary}:t(M)||h(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,le){if(!M)return;if(le?.supportSideBySide){const{primary:ae,secondary:ge}=this.getSideEditors(M);if(ae&&ge){if(le?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:le.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===U.ANY)return this.getCanonicalUri(ae,{filterByScheme:le.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:le.filterByScheme});M=le.supportSideBySide===U.PRIMARY?ae:ge}}if(h(M)||c(M))return;const me=M.resource;return!me||!le||!le.filterByScheme?me:this.filterUri(me,le.filterByScheme)}filterUri(M,le){if(Array.isArray(le)){if(le.some(me=>M.scheme===me))return M}else if(le===M.scheme)return M}}e.EditorResourceAccessor=new A;var E;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const le=this.instantiationService=M.get(I.IInstantiationService);for(const[me,ae]of this.editorSerializerConstructors)this.createEditorSerializer(me,ae,le);this.editorSerializerConstructors.clear()}createEditorSerializer(M,le,me){const ae=me.createInstance(le);this.editorSerializerInstances.set(M,ae)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,D.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,le){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,le,this.instantiationService):this.editorSerializerConstructors.set(M,le),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new $);async function x(G,M){if(!G||!G.length)return[];const le=await Promise.all(G.map(async me=>{const ae=g.URI.revive(me.fileUri);if(!ae||!await M.canHandleResource(ae))return;let te=me.exists,Ee=me.type;if(typeof te!="boolean"||typeof Ee!="number")try{Ee=(await M.stat(ae)).isDirectory?b.FileType.Directory:b.FileType.Unknown,te=!0}catch{te=!1}if(!te&&me.openOnlyIfExists||Ee===b.FileType.Directory)return;const we={...me.options,pinned:!0};let Z;return te?Z={resource:ae,options:we}:Z={resource:ae,options:we,forceUntitled:!0},Z}));return(0,P.coalesce)(le)}e.pathsToEditors=x;var H;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function oe(G){const M=G;if(!M)return!1;const le=M;if(le.modified)return oe(le.modified);const me=M;return!!(me.contributionsState&&me.viewState&&Array.isArray(me.cursorState))}e.isTextEditorViewState=oe}),define(Se[66],De([1,0,11,2]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function g(k,b){return k.scheme===a.Schemas.http||k.scheme===a.Schemas.https?k:(b&&b.authority&&b.isRemote&&k.scheme===a.Schemas.file&&(k=D.URI.from({scheme:a.Schemas.vscodeRemote,authority:b.authority,path:k.path})),D.URI.from({scheme:a.Schemas.https,authority:`${k.scheme}+${L(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=g;function L(k){return k.replace(/./g,b=>{const P=b.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?b:"-"+P.toString(16).padStart(4,"0")})}function I(k){return k.replace(/-([0-9a-f]{4})/g,(b,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=I}),define(Se[162],De([1,0,5,7,66]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(k,b,P){this._proxy=k,this._editors=b,this._remoteInfo=P,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const R=b.getVisibleTextEditors();for(const v of this._insets.values())R.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,b,P,R,v){let p;for(const _ of this._editors.getVisibleTextEditors(!0))if(_.value===k){p=_;break}if(!p)throw new Error("not a visible editor");const w=this,f=this._handlePool++,u=new a.Emitter,h=new a.Emitter,c=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(_){return(0,g.asWebviewUri)(_,w._remoteInfo)}get cspSource(){return g.webviewGenericCspSource}set options(_){this._options=_,w._proxy.$setOptions(f,_)}get options(){return this._options}set html(_){this._html=_,w._proxy.$setHtml(f,_)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(_){return w._proxy.$postMessage(f,_)}},y=new class{constructor(){this.editor=k,this.line=b,this.height=P,this.webview=c,this.onDidDispose=h.event}dispose(){w._insets.has(f)&&(w._insets.delete(f),w._proxy.$disposeEditorInset(f),h.fire(),h.dispose(),u.dispose())}};return this._proxy.$createEditorInset(f,p.id,p.value.document.uri,b+1,P,R||{},v.identifier,v.extensionLocation),this._insets.set(f,{editor:k,inset:y,onDidReceiveMessage:u}),y}$onDidDispose(k){const b=this._insets.get(k);b&&b.inset.dispose()}$onDidReceiveMessage(k,b){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=L}),define(Se[163],De([1,0,5,14,136]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,b,P,R){const v={command:k};if(b&&Object.keys(b).length>0&&(v.arguments=b),this.internalSend("request",v),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const w=this.pendingRequests.get(v.seq);if(w){this.pendingRequests.delete(v.seq);const f={type:"response",seq:0,request_seq:v.seq,success:!1,command:k,message:(0,g.localize)(0,null,R,k)};w(f)}},R)}return P&&this.pendingRequests.set(v.seq,P),v.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,b){return k.type!=="event"||b.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,D.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const b=k,P=this.pendingRequests.get(b.request_seq);P&&(this.pendingRequests.delete(b.request_seq),P(b));break}}}}internalSend(k,b){b.type=k,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((b,P)=>k.set(P,b)),await(0,D.timeout)(500),k.forEach((b,P)=>{b({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(Se[164],De([1,0,137,44,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new D.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new D.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new D.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new D.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new D.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new D.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new D.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new D.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new D.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new D.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new D.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new D.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new D.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new D.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new D.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new D.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new D.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new D.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new D.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new D.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new D.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new D.RawContextKey("breakpointAccessType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new D.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new D.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new D.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new D.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new D.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new D.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new D.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new D.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new D.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new D.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new D.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new D.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new D.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new D.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new D.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new D.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new D.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new D.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new D.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new D.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new D.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new D.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new D.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new D.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new D.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new D.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new D.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new D.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new D.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const L=v=>a.localize(51,null,v);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var I;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(I=e.State||(e.State={}));function k(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var b;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,g.createDecorator)(e.DEBUG_SERVICE_ID);var R;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(R=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[165],De([1,0,9,2,17,27,11]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function b(i,o,r){return i.replace(k,function(t,s){return o&&s.length>0&&s[0]!=="_"?t:r&&r.hasOwnProperty(s)?r[s]:t})}e.formatPII=b;function P(i){const o={};for(const r of Object.keys(i))r.startsWith("!")||(o[r]=i[r]);return o}e.filterExceptionsFromTelemetry=P;function R(i){return i.configuration.request==="attach"&&!v(i)&&(!i.parentSession||R(i.parentSession))}e.isSessionAttach=R;function v(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(o,"extensionhost")||(0,a.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?v(i.parentSession):void 0}e.getExtensionHostDebugSession=v;function p(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=p;function w(i,o,r){let t,s=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=m.exec(i);){const C=d.index+1,O=C+d[0].length;if(C<=o&&O>=r){t=d[0],s=C;break}}if(t){const C=/\w+/g;let O=null;for(;(O=C.exec(t))&&!(O.index+1+s+O[0].length>=r););O&&(t=t.substring(0,C.lastIndex))}return t?{start:s,end:s+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=w;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(i){return!!(i&&i.match(f))}e.isUri=u;function h(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(u(i.path))return D.URI.parse(i.path);if((0,g.isAbsolute)(i.path))return D.URI.file(i.path)}return i.path}function c(i){if(typeof i.path=="object"){const o=D.URI.revive(i.path);if(o)return o.scheme===I.Schemas.file?o.fsPath:o.toString()}return i.path}function y(i,o){const r=o?h:c,t=(0,L.deepClone)(i);return l(t,(s,m)=>{s&&m&&(m.path=r(m))}),t}e.convertToDAPaths=y;function _(i,o){const r=o?h:c,t=(0,L.deepClone)(i);return l(t,(s,m)=>{!s&&m&&(m.path=r(m))}),t}e.convertToVSCPaths=_;function l(i,o){switch(i.type){case"event":{const r=i;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=i;switch(r.command){case"setBreakpoints":o(!0,r.arguments.source);break;case"breakpointLocations":o(!0,r.arguments.source);break;case"source":o(!0,r.arguments.source);break;case"gotoTargets":o(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(t=>o(!1,t));break;default:break}break}case"response":{const r=i;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(t=>o(!1,t.source));break;case"loadedSources":r.body.sources.forEach(t=>o(!1,t));break;case"scopes":r.body.scopes.forEach(t=>o(!1,t.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(t=>o(!1,t.source));break;case"setBreakpoints":r.body.breakpoints.forEach(t=>o(!1,t.source));break;case"disassemble":{const t=r;t.body&&t.body.instructions.forEach(s=>o(!1,s.location))}break;default:break}break}}}function S(i){return i.filter(o=>!o.presentation?.hidden).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):n(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:n(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=S;function n(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}async function T(i,o){const r=i.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(r!=="none"&&(await o.saveAll(),r==="allEditorsInActiveGroup")){const t=o.activeEditorPane;t&&t.input.resource?.scheme===I.Schemas.untitled&&await o.save({editor:t.input,groupId:t.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=T}),define(Se[87],De([1,0,33,166,74,11,17,23,44]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",g.Mimes.latex,g.Mimes.markdown,"image/png","image/jpeg",g.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[g.Mimes.latex,g.Mimes.markdown,"application/json",g.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(r){r[r.Unconfirmed=1]="Unconfirmed",r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeCellLanguage=5]="ChangeCellLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var c;(function(r){r.scheme=L.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function s(A,E){return A.with({scheme:r.scheme,fragment:`ch${E.toString().padStart(7,"0")}${A.scheme!==L.Schemas.file?A.scheme:""}`})}r.generate=s;function m(A){if(A.scheme!==r.scheme)return;const E=t.exec(A.fragment);return E?{handle:Number(E[1]),notebook:A.with({scheme:A.fragment.substring(E[0].length)||L.Schemas.file,fragment:null})}:void 0}r.parse=m;function d(A,E){return A.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${E??""},${A.scheme!==L.Schemas.file?A.scheme:""}`})}r.generateCellOutputUri=d;function C(A){if(A.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const E=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(A.fragment);if(!E)return;const $=E[1]&&E[1]!==""?E[1]:void 0,x=E[2];return{outputId:$,notebook:A.with({scheme:x||L.Schemas.file,fragment:null})}}r.parseCellOutputUri=C;function O(A,E,$){return A.with({scheme:$,fragment:`ch${E.toString().padStart(7,"0")}${A.scheme!==L.Schemas.file?A.scheme:""}`})}r.generateCellUri=O;function U(A,E){if(A.scheme!==E)return;const $=t.exec(A.fragment);return $?{handle:Number($[1]),notebook:A.with({scheme:A.fragment.substring($[0].length)||L.Schemas.file,fragment:null})}:void 0}r.parseCellUri=U})(c=e.CellUri||(e.CellUri={}));const y=r=>k.isWindows?r.replace(/\//g,"\\"):r;class _{constructor(t=[],s=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=s,this.order=[...new Set(t)].map(m=>({pattern:m,matches:a.parse(y(m))}))}sort(t){const s=new Map(D.Iterable.map(t,d=>[d,y(d)]));let m=[];for(const{matches:d}of this.order)for(const[C,O]of s)if(d(O)){m.push(C),s.delete(C);break}return s.size&&(m=m.concat([...s.keys()].sort((d,C)=>this.defaultOrder.indexOf(d)-this.defaultOrder.indexOf(C)))),m}prioritize(t,s){const m=this.findIndex(t);if(m===-1){this.order.unshift({pattern:t,matches:a.parse(y(t))});return}const d=new Set(s.map(O=>this.findIndex(O,m)));d.delete(-1);const C=Array.from(d).sort();this.order.splice(m+1,0,...C.map(O=>this.order[O]));for(let O=C.length-1;O>=0;O--)this.order.splice(C[O],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,s=this.order.length){const m=y(t);for(let d=0;d<s;d++)if(this.order[d].matches(m))return d;return-1}}e.MimeTypeDisplayOrder=_;function l(r,t,s,m=(d,C)=>d===C){const d=[];function C(A,E,$){if(E===0&&$.length===0)return;const x=d[d.length-1];x&&x.start+x.deleteCount===A?(x.deleteCount+=E,x.toInsert.push(...$)):d.push({start:A,deleteCount:E,toInsert:$})}let O=0,U=0;for(;;){if(O===r.length){C(O,0,t.slice(U));break}if(U===t.length){C(O,r.length-O,[]);break}const A=r[O],E=t[U];if(m(A,E)){O+=1,U+=1;continue}s(E)?(C(O,1,[]),O+=1):(C(O,0,[E]),U+=1)}return d}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var S;(function(r){r.default="default",r.option="option"})(S=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(r){const t=r;return!!((typeof t.include=="string"||a.isRelativePattern(t.include))&&(typeof t.exclude=="string"||a.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=n;function T(r,t,s){if(Array.isArray(r.viewType)&&r.viewType.indexOf(t)>=0||r.viewType===t)return!0;if(r.filenamePattern){const m=n(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,d=n(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(a.match(m,(0,I.basename)(s.fsPath).toLowerCase()))return!(d&&a.match(d,(0,I.basename)(s.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=T,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(t){return`${o._prefix}${t}`}static parse(t){if(t.startsWith(o._prefix))return t.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/"}),define(Se[167],De([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var D;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(D=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Se[168],De([1,0,138,3,44]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new g.RawContextKey("customExecutionSupported",!0,a.localize(0,null)),e.ShellExecutionSupportedContext=new g.RawContextKey("shellExecutionSupported",!1,a.localize(1,null)),e.ProcessExecutionSupportedContext=new g.RawContextKey("processExecutionSupported",!1,a.localize(2,null)),e.ITaskService=(0,D.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Se[169],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=a;function D(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=D}),define(Se[46],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(L){L.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var D;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(D=e.TestPosition||(e.TestPosition={}));class g{constructor(I,k=I.length){if(this.path=I,this.viewEnd=k,I.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,k,b=I.parent){if(I.id===k)return new g([k]);let P=[I.id];for(let R=b;R&&R.id!==k;R=R.parent)P.push(R.id);return P.push(k),new g(P.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const k=I.indexOf("\0");return k===-1?I:I.slice(0,k)}static fromString(I){return new g(I.split("\0"))}static join(I,k){return new g([...I.path,k])}static joinToString(I,k){return I.toString()+"\0"+k}static compare(I,k){return I===k?0:k.startsWith(I+"\0")?2:I.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new g(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new g(this.path,I)}compare(I){if(typeof I=="string")return g.compare(this.toString(),I);for(let k=0;k<I.viewEnd&&k<this.viewEnd;k++)if(I.path[k]!==this.path[k])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=g}),define(Se[47],De([1,0,2,48]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(r){r.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),r.deserialize=t=>({range:D.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var b;(function(r){r.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.deserialize(t.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(r){r.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(r){r.serialize=t=>t.type===0?b.serialize(t):P.serialize(t),r.deserialize=t=>t.type===0?b.deserialize(t):P.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var v;(function(r){r.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),r.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",w=(r,t)=>r+p+t;e.namespaceTestTag=w;const f=r=>{const t=r.indexOf(p);return{ctrlId:r.slice(0,t),tagId:r.slice(t+1)}};e.denamespaceTestTag=f;var u;(function(r){r.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),r.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?D.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(u=e.ITestItem||(e.ITestItem={}));var h;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var c;(function(r){r.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:u.serialize(t.item)}),r.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:u.deserialize(t.item)})})(c=e.InternalTestItem||(e.InternalTestItem={}));var y;(function(r){r.serialize=t=>{let s;return t.item&&(s={},t.item.label!==void 0&&(s.label=t.item.label),t.item.tags!==void 0&&(s.tags=t.item.tags),t.item.busy!==void 0&&(s.busy=t.item.busy),t.item.uri!==void 0&&(s.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(s.range=t.item.range?.toJSON()),t.item.description!==void 0&&(s.description=t.item.description),t.item.error!==void 0&&(s.error=t.item.error),t.item.sortText!==void 0&&(s.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:s}},r.deserialize=t=>{let s;return t.item&&(s={},t.item.label!==void 0&&(s.label=t.item.label),t.item.tags!==void 0&&(s.tags=t.item.tags),t.item.busy!==void 0&&(s.busy=t.item.busy),t.item.range!==void 0&&(s.range=t.item.range?D.Range.lift(t.item.range):null),t.item.description!==void 0&&(s.description=t.item.description),t.item.error!==void 0&&(s.error=t.item.error),t.item.sortText!==void 0&&(s.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:s}}})(y=e.ITestItemUpdate||(e.ITestItemUpdate={}));const _=(r,t)=>{t.expand!==void 0&&(r.expand=t.expand),t.item!==void 0&&(r.item=r.item?Object.assign(r.item,t.item):t.item)};e.applyTestItemUpdate=_;var l;(function(r){r.serialize=(t,s)=>({...c.serialize(t),children:s,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var S;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(S=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var T;(function(r){r.deserialize=t=>t.op===0?{op:t.op,item:c.deserialize(t.item)}:t.op===1?{op:t.op,item:y.deserialize(t.item)}:t,r.serialize=t=>t.op===0?{op:t.op,item:c.serialize(t.item)}:t.op===1?{op:t.op,item:y.serialize(t.item)}:t})(T=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(t){}update(t){}remove(t,s){}complete(){}}e.IncrementalChangeCollector=i;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const s=this.createChangeCollector();for(const m of t)switch(m.op){case 0:{const d=c.deserialize(m.item);if(d.parent){if(this.items.has(d.parent)){const C=this.items.get(d.parent);C.children.add(d.item.extId);const O=this.createItem(d,C);this.items.set(d.item.extId,O),s.add(O)}}else{const C=this.createItem(d);this.roots.add(C),this.items.set(d.item.extId,C),s.add(C)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=y.deserialize(m.item),C=this.items.get(d.extId);if(!C)break;d.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,d),s.update(C);break}case 2:{const d=this.items.get(m.itemId);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const C=[[m.itemId]];for(;C.length;)for(const O of C.pop()){const U=this.items.get(O);U&&(C.push(U.children),this.items.delete(O),s.remove(U,U!==d),U.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}s.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=o}),define(Se[67],De([1,0,14,5,7,10,47,46]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(c,y)=>c===y,R={range:(c,y)=>c===y?!0:!c||!y?!1:c.equalsRange(y),busy:P,label:P,description:P,error:P,tags:(c,y)=>!(c.length!==y.length||c.some(_=>!y.includes(_)))},v=(c,y)=>{let _;for(const[l,S]of Object.entries(R))S(c[l],y[l])||(_?_[l]=y[l]:_={[l]:y[l]});return _};class p extends g.Disposable{constructor(y){super();this.options=y,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new D.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(y){this._resolveHandler=y;for(const _ of this.tree.values())this.updateExpandability(_)}collectDiff(){const y=this.diff;return this.diff=[],y}pushDiff(y){const _=this.diff[this.diff.length-1];if(_&&y.op===1){if(_.op===1&&_.item.extId===y.item.extId){(0,I.applyTestItemUpdate)(_.item,y.item);return}if(_.op===0&&_.item.item.extId===y.item.extId){(0,I.applyTestItemUpdate)(_.item,y.item);return}}this.diff.push(y),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(y,_){const l=this.tree.get(y);if(!!l){if((l.expandLevels===void 0||_>l.expandLevels)&&(l.expandLevels=_),l.expand===1){const S=this.resolveChildren(l);return S.isOpen()?this.expandChildren(l,_-1):S.wait().then(()=>this.expandChildren(l,_-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,_-1)):this.expandChildren(l,_-1)}}dispose(){for(const y of this.tree.values())this.options.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(y,_){switch(_.op){case 3:this.removeItem(k.TestId.joinToString(y.fullId,_.id));break;case 0:this.upsertItem(_.item,y);break;case 5:for(const l of _.ops)this.onTestItemEvent(y,l);break;case 1:this.diffTagRefs(_.new,_.old,y.fullId.toString());break;case 2:this.updateExpandability(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:_.update}});break;default:(0,L.assertNever)(_)}}upsertItem(y,_){const l=k.TestId.fromExtHostTestItem(y,this.root.id,_?.actual),S=this.options.getApiFor(y);S.parent&&S.parent!==_?.actual&&this.options.getChildren(S.parent).delete(y.id);let n=this.tree.get(l.toString());if(!n){n={fullId:l,actual:y,parent:_?l.parentId:null,expandLevels:_?.expandLevels?_.expandLevels-1:void 0,expand:0},y.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(y,_),this.pushDiff({op:0,item:{parent:n.parent&&n.parent.toString(),controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(y)}}),this.connectItemAndChildren(y,n,_);return}if(n.actual===y){this.connectItem(y,n,_);return}const T=this.options.getChildren(n.actual),i=n.actual,o=v(this.options.toITestItem(i),this.options.toITestItem(y));this.options.getApiFor(i).listener=void 0,n.actual=y,n.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(y.tags,i.tags,l.toString()),delete o.tags),this.onTestItemEvent(n,{op:4,update:o})),this.connectItemAndChildren(y,n,_);for(const r of T)this.options.getChildren(y).get(r.id)||this.removeItem(k.TestId.joinToString(l,r.id))}diffTagRefs(y,_,l){const S=new Set(_.map(n=>n.id));for(const n of y)S.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:l,item:{tags:y.map(n=>(0,I.namespaceTestTag)(this.options.controllerId,n.id))}}}),S.forEach(this.decrementTagRefs,this)}incrementTagRefs(y){const _=this.tags.get(y.id);_?_.refCount++:(this.tags.set(y.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,I.namespaceTestTag)(this.options.controllerId,y.id)}}))}decrementTagRefs(y){const _=this.tags.get(y);_&&!--_.refCount&&(this.tags.delete(y),this.pushDiff({op:6,id:(0,I.namespaceTestTag)(this.options.controllerId,y)}))}setItemParent(y,_){this.options.getApiFor(y).parent=_&&_.actual!==this.root?_.actual:void 0}connectItem(y,_,l){this.setItemParent(y,l);const S=this.options.getApiFor(y);S.parent=l?.actual,S.listener=n=>this.onTestItemEvent(_,n),this.updateExpandability(_)}connectItemAndChildren(y,_,l){this.connectItem(y,_,l);for(const S of this.options.getChildren(y))this.upsertItem(S,_)}updateExpandability(y){let _;this._resolveHandler?y.resolveBarrier?_=y.resolveBarrier.isOpen()?3:2:_=y.actual.canResolveChildren?1:0:_=0,_!==y.expand&&(y.expand=_,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:_}}),_===1&&y.expandLevels!==void 0&&this.resolveChildren(y))}expandChildren(y,_){if(_<0)return;const l=[];for(const S of this.options.getChildren(y.actual)){const n=this.expand(k.TestId.joinToString(y.fullId,S.id),_);(0,a.isThenable)(n)&&l.push(n)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this._resolveHandler){const n=new a.Barrier;return n.open(),n}y.expand=2,this.pushExpandStateUpdate(y);const _=y.resolveBarrier=new a.Barrier,l=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let S;try{S=this._resolveHandler(y.actual===this.root?void 0:y.actual)}catch(n){l(n)}return(0,a.isThenable)(S)?S.catch(l).then(()=>{_.open(),this.updateExpandability(y)}):(_.open(),this.updateExpandability(y)),y.resolveBarrier}pushExpandStateUpdate(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}removeItem(y){const _=this.tree.get(y);if(!_)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:y});const l=[_];for(;l.length;){const S=l.pop();if(!!S){this.options.getApiFor(S.actual).listener=void 0;for(const n of S.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(S.fullId.toString());for(const n of this.options.getChildren(S.actual))l.push(this.tree.get(k.TestId.joinToString(S.fullId,n.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.diffOpEmitter.fire(y)}}e.TestItemCollection=p;class w extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=w;class f extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class u extends Error{constructor(y,_,l){super(`TestItem with ID "${y}" is from controller "${_}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=u;const h=(c,y,_)=>{let l=new Map;return{get size(){return l.size},forEach(S,n){for(const T of l.values())S.call(n,T,this)},replace(S){const n=new Map,T=new Set(l.keys()),i={op:5,ops:[]};for(const o of S){if(!(o instanceof _))throw new f(o.id);const r=y(o).controllerId;if(r!==c.controllerId)throw new u(o.id,r,c.controllerId);if(n.has(o.id))throw new w(o.id);n.set(o.id,o),T.delete(o.id),i.ops.push({op:0,item:o})}for(const o of T.keys())i.ops.push({op:3,id:o});c.listener?.(i),l=n},add(S){if(!(S instanceof _))throw new f(S.id);l.set(S.id,S),c.listener?.({op:0,item:S})},delete(S){l.delete(S)&&c.listener?.({op:3,id:S})},get(S){return l.get(S)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};e.createTestItemChildren=h}),define(Se[88],De([1,0,67]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const D=new WeakMap,g=(I,k)=>{const b={controllerId:k};return D.set(I,b),b};e.createPrivateApiFor=g;const L=I=>{const k=D.get(I);if(!k)throw new a.InvalidTestItemError(I?.id||"<unknown>");return k};e.getPrivateApiFor=L}),define(Se[170],De([1,0,17,61,10,27,23,76,139,9]),function(ee,e,a,D,g,L,I,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(p,w,f,u){this._contributedVariables=new Map,this._context=p,this._labelService=w,this._userHomePromise=f,u&&(this._envVariablesPromise=u.then(h=>this.prepareEnv(h)))}prepareEnv(p){if(I.isWindows){const w=Object.create(null);return Object.keys(p).forEach(f=>{w[f.toLowerCase()]=p[f]}),w}return p}resolveWithEnvironment(p,w,f){return this.recursiveResolve({env:this.prepareEnv(p),userHome:void 0},w?w.uri:void 0,f)}async resolveAsync(p,w){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,p?p.uri:void 0,w)}async resolveAnyBase(p,w,f,u){const h=L.deepClone(w);I.isWindows&&h.windows?Object.keys(h.windows).forEach(y=>h[y]=h.windows[y]):I.isMacintosh&&h.osx?Object.keys(h.osx).forEach(y=>h[y]=h.osx[y]):I.isLinux&&h.linux&&Object.keys(h.linux).forEach(y=>h[y]=h.linux[y]),delete h.windows,delete h.osx,delete h.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,p?p.uri:void 0,h,f,u)}async resolveAnyAsync(p,w,f){return this.resolveAnyBase(p,w,f)}async resolveAnyMap(p,w,f){const u=new Map;return{newConfig:await this.resolveAnyBase(p,w,f,u),resolvedVariables:u}}resolveWithInteractionReplace(p,w,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,w,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,w){if(this._contributedVariables.has(p))throw new Error("Variable "+p+" is contributed twice.");this._contributedVariables.set(p,w)}async recursiveResolve(p,w,f,u,h){if(g.isString(f))return this.resolveString(p,w,f,u,h);if(g.isArray(f))return Promise.all(f.map(c=>this.recursiveResolve(p,w,c,u,h)));if(g.isObject(f)){let c=Object.create(null);const y=await Promise.all(Object.keys(f).map(async _=>[await this.resolveString(p,w,_,u,h),await this.recursiveResolve(p,w,f[_],u,h)]));for(const[_,l]of y)c[_]=l;return c}return f}resolveString(p,w,f,u,h){return(0,P.replaceAsync)(f,R.VARIABLE_REGEXP,async(c,y)=>{if(y.includes(R.VARIABLE_LHS))return c;let _=await this.evaluateSingleVariable(p,c,y,w,u);return h&&h.set(y,_),_!==c&&g.isString(_)&&_.match(R.VARIABLE_REGEXP)&&(_=await this.resolveString(p,w,_,u,h)),_})}fsPath(p){return this._labelService?this._labelService.getUriLabel(p,{noPrefix:!0}):p.fsPath}async evaluateSingleVariable(p,w,f,u,h){let c;const y=f.split(":");y.length>1&&(f=y[0],c=y[1]);const _=()=>{const n=this._context.getFilePath();if(n)return n;throw new Error((0,b.localize)(0,null,w))},l=()=>{const n=_();if(this._context.getWorkspaceFolderPathForFile){const T=this._context.getWorkspaceFolderPathForFile();if(T)return T}throw new Error((0,b.localize)(1,null,w,a.basename(n)))},S=()=>{if(c){const n=this._context.getFolderUri(c);if(n)return n;throw new Error((0,b.localize)(2,null,w,c))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,w)):new Error((0,b.localize)(4,null,w))};switch(f){case"env":if(c){if(p.env){const n=p.env[I.isWindows?c.toLowerCase():c];if(g.isString(n))return n}return""}throw new Error((0,b.localize)(5,null,w));case"config":if(c){const n=this._context.getConfigurationValue(u,c);if(g.isUndefinedOrNull(n))throw new Error((0,b.localize)(6,null,w,c));if(g.isObject(n))throw new Error((0,b.localize)(7,null,w,c));return n}throw new Error((0,b.localize)(8,null,w));case"command":return this.resolveFromMap(w,c,h,"command");case"input":return this.resolveFromMap(w,c,h,"input");case"extensionInstallFolder":if(c){const n=await this._context.getExtension(c);if(!n)throw new Error((0,b.localize)(9,null,w,c));return this.fsPath(n.extensionLocation)}throw new Error((0,b.localize)(10,null,w));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(S()));case"cwd":return u||c?(0,k.normalizeDriveLetter)(this.fsPath(S())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(S()));case"userHome":{if(p.userHome)return p.userHome;throw new Error((0,b.localize)(11,null,w))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new Error((0,b.localize)(12,null,w))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new Error((0,b.localize)(13,null,w))}case"file":return _();case"fileWorkspaceFolder":return l();case"relativeFile":return u||c?a.relative(this.fsPath(S()),_()):_();case"relativeFileDirname":{const n=a.dirname(_());if(u||c){const T=a.relative(this.fsPath(S()),n);return T.length===0?".":T}return n}case"fileDirname":return a.dirname(_());case"fileExtname":return a.extname(_());case"fileBasename":return a.basename(_());case"fileBasenameNoExtension":{const n=a.basename(_());return n.slice(0,n.length-a.extname(n).length)}case"fileDirnameBasename":return a.basename(a.dirname(_()));case"execPath":{const n=this._context.getExecPath();return n||w}case"execInstallFolder":{const n=this._context.getAppRoot();return n||w}case"pathSeparator":return a.sep;default:try{const n=c?`${f}:${c}`:f;return this.resolveFromMap(w,n,h,void 0)}catch{return w}}}}resolveFromMap(p,w,f,u){if(w&&f){const h=u===void 0?f[w]:f[u+":"+w];if(typeof h=="string")return h;throw new Error((0,b.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[89],De([1,0,3,161]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var g;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(g=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var k;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function P(f){const u=f;return(0,D.isEditorInput)(u?.editor)&&(0,D.isEditorInput)(u?.replacement)}e.isEditorReplacement=P;var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var v;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(v=e.OpenEditorContext||(e.OpenEditorContext={}));function p(f){const u=f;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=p;function w(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(Se[171],De([1,0,3,89]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function g(L){const I=L;return typeof L=="number"||(0,D.isEditorGroup)(I)}e.isPreferredGroup=g}),define(Se[8],De([1,0,15,25,75,22,105,57,27,10,2,48,68,141,79,88,87,46,47,171,6]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(be){function ye(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Be,positionLineNumber:tt,positionColumn:je}=j,ot=new l.Position(Ae-1,Be-1),ct=new l.Position(tt-1,je-1);return new l.Selection(ot,ct)}be.to=ye;function de(j){const{anchor:Ae,active:Be}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}be.from=de})(S=e.Selection||(e.Selection={}));var n;(function(be){function ye(j){if(!j)return;const{start:Ae,end:Be}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}be.from=ye;function de(j){if(!j)return;const{startLineNumber:Ae,startColumn:Be,endLineNumber:tt,endColumn:je}=j;return new l.Range(Ae-1,Be-1,tt-1,je-1)}be.to=de})(n=e.Range||(e.Range={}));var T;(function(be){function ye(de){switch(de){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}be.to=ye})(T=e.TokenType||(e.TokenType={}));var i;(function(be){function ye(j){return new l.Position(j.lineNumber-1,j.column-1)}be.to=ye;function de(j){return{lineNumber:j.line+1,column:j.character+1}}be.from=de})(i=e.Position||(e.Position={}));var o;(function(be){function ye(Ae,Be){return(0,a.coalesce)((0,a.asArray)(Ae).map(tt=>de(tt,Be)))}be.from=ye;function de(Ae,Be){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:j(Ae.scheme,Be),pattern:xe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function j(Ae,Be){return Be&&typeof Ae=="string"?Be.transformOutgoingScheme(Ae):Ae}})(o=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(be){function ye(j){switch(j){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}be.from=ye;function de(j){switch(j){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}be.to=de})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(be){function ye(j){let Ae;return j.code&&((0,P.isString)(j.code)||(0,P.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),{...n.from(j.range),message:j.message,source:j.source,code:Ae,severity:m.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(s.from),tags:Array.isArray(j.tags)?(0,a.coalesce)(j.tags.map(r.from)):void 0}}be.from=ye;function de(j){const Ae=new l.Diagnostic(n.to(j),j.message,m.to(j.severity));return Ae.source=j.source,Ae.code=(0,P.isString)(j.code)?j.code:j.code?.value,Ae.relatedInformation=j.relatedInformation&&j.relatedInformation.map(s.to),Ae.tags=j.tags&&(0,a.coalesce)(j.tags.map(r.to)),Ae}be.to=de})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(be){function ye(j){return{...n.from(j.location.range),message:j.message,resource:j.location.uri}}be.from=ye;function de(j){return new l.DiagnosticRelatedInformation(new l.Location(j.resource,n.to(j)),j.message)}be.to=de})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(be){function ye(j){switch(j){case l.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}be.from=ye;function de(j){switch(j){case f.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}be.to=de})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(be){function ye(j){return typeof j=="number"&&j>=l.ViewColumn.One?j-1:j===l.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}be.from=ye;function de(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=de})(d=e.ViewColumn||(e.ViewColumn={}));function C(be){return typeof be.range!="undefined"}function O(be){return be.length===0?!0:!!C(be[0])}e.isDecorationOptionsArr=O;var U;(function(be){function ye(je){return je.map(be.from)}be.fromMany=ye;function de(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function j(je){let ot;if(de(je)){const{language:mt,value:vt}=je;ot={value:"```"+mt+`
`+vt+"\n```\n"}}else l.MarkdownString.isMarkdownString(je)?ot={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?ot={value:je}:ot={value:""};const ct=Object.create(null);ot.uris=ct;const pt=mt=>{try{let vt=R.URI.parse(mt,!0);vt=vt.with({query:Ae(vt.query,ct)}),ct[mt]=vt}catch{}return""},_t=new I.marked.Renderer;return _t.link=pt,_t.image=mt=>typeof mt=="string"?pt(g.parseHrefAndDimensions(mt).href):"",(0,I.marked)(ot.value,{renderer:_t}),ot}be.from=j;function Ae(je,ot){if(!je)return je;let ct;try{ct=(0,k.parse)(je)}catch{}if(!ct)return je;let pt=!1;return ct=(0,b.cloneAndChange)(ct,_t=>{if(R.URI.isUri(_t)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[mt]=_t,pt=!0,mt}else return}),pt?JSON.stringify(ct):je}function Be(je){const ot=new l.MarkdownString(je.value,je.supportThemeIcons);return ot.isTrusted=je.isTrusted,ot.supportHtml=je.supportHtml,ot.baseUri=je.baseUri?R.URI.from(je.baseUri):void 0,ot}be.to=Be;function tt(je){if(!!je)return typeof je=="string"?je:be.from(je)}be.fromStrict=tt})(U=e.MarkdownString||(e.MarkdownString={}));function A(be){return O(be)?be.map(ye=>({range:n.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?U.fromMany(ye.hoverMessage):ye.hoverMessage?U.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):be.map(ye=>({range:n.from(ye)}))}e.fromRangeOrRangeWithMessage=A;function E(be){return typeof be=="undefined"?be:typeof be=="string"?R.URI.file(be):be}e.pathOrURIToURI=E;var $;(function(be){function ye(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?E(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}be.from=ye})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(be){function ye(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?$.from(de.before):void 0,after:de.after?$.from(de.after):void 0}}be.from=ye})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(be){function ye(de){if(typeof de=="undefined")return de;switch(de){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=ye})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var oe;(function(be){function ye(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?H.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?x.from(de.light):void 0,dark:de.dark?x.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?$.from(de.before):void 0,after:de.after?$.from(de.after):void 0}}be.from=ye})(oe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(be){function ye(j){return{text:j.newText,eol:j.newEol&&Ve.from(j.newEol),range:n.from(j.range)}}be.from=ye;function de(j){const Ae=new l.TextEdit(n.to(j.range),j.text);return Ae.newEol=typeof j.eol=="undefined"?void 0:Ve.to(j.eol),Ae}be.to=de})(G=e.TextEdit||(e.TextEdit={}));var M;(function(be){function ye(de){return{range:n.from(de.range),snippet:de.snippet.value}}be.from=ye})(M=e.SnippetTextEdit||(e.SnippetTextEdit={}));var le;(function(be){function ye(j,Ae){const Be={edits:[]};if(j instanceof l.WorkspaceEdit){const tt=new L.ResourceSet;for(const je of j._allEntries())je._type===1&&R.URI.isUri(je.to)&&je.from===void 0&&tt.add(je.to);for(const je of j._allEntries())je._type===1?Be.edits.push({_type:1,oldUri:je.from,newUri:je.to,options:je.options,metadata:je.metadata}):je._type===2?Be.edits.push({_type:2,resource:je.uri,edit:G.from(je.edit),modelVersionId:tt.has(je.uri)?void 0:Ae?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Be.edits.push({_type:3,metadata:je.metadata,resource:je.uri,edit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Be.edits.push({_type:3,metadata:je.metadata,resource:je.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(je.uri),edit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(lt.from)}})}return Be}be.from=ye;function de(j){const Ae=new l.WorkspaceEdit;for(const Be of j.edits)Be.edit?Ae.replace(R.URI.revive(Be.resource),n.to(Be.edit.range),Be.edit.text):Ae.renameFile(R.URI.revive(Be.oldUri),R.URI.revive(Be.newUri),Be.options);return Ae}be.to=de})(le=e.WorkspaceEdit||(e.WorkspaceEdit={}));var me;(function(be){const ye=Object.create(null);ye[l.SymbolKind.File]=0,ye[l.SymbolKind.Module]=1,ye[l.SymbolKind.Namespace]=2,ye[l.SymbolKind.Package]=3,ye[l.SymbolKind.Class]=4,ye[l.SymbolKind.Method]=5,ye[l.SymbolKind.Property]=6,ye[l.SymbolKind.Field]=7,ye[l.SymbolKind.Constructor]=8,ye[l.SymbolKind.Enum]=9,ye[l.SymbolKind.Interface]=10,ye[l.SymbolKind.Function]=11,ye[l.SymbolKind.Variable]=12,ye[l.SymbolKind.Constant]=13,ye[l.SymbolKind.String]=14,ye[l.SymbolKind.Number]=15,ye[l.SymbolKind.Boolean]=16,ye[l.SymbolKind.Array]=17,ye[l.SymbolKind.Object]=18,ye[l.SymbolKind.Key]=19,ye[l.SymbolKind.Null]=20,ye[l.SymbolKind.EnumMember]=21,ye[l.SymbolKind.Struct]=22,ye[l.SymbolKind.Event]=23,ye[l.SymbolKind.Operator]=24,ye[l.SymbolKind.TypeParameter]=25;function de(Ae){return typeof ye[Ae]=="number"?ye[Ae]:6}be.from=de;function j(Ae){for(const Be in ye)if(ye[Be]===Ae)return Number(Be);return l.SymbolKind.Property}be.to=j})(me=e.SymbolKind||(e.SymbolKind={}));var ae;(function(be){function ye(j){switch(j){case l.SymbolTag.Deprecated:return 1}}be.from=ye;function de(j){switch(j){case 1:return l.SymbolTag.Deprecated}}be.to=de})(ae=e.SymbolTag||(e.SymbolTag={}));var ge;(function(be){function ye(j){return{name:j.name,kind:me.from(j.kind),tags:j.tags&&j.tags.map(ae.from),containerName:j.containerName,location:pe.from(j.location)}}be.from=ye;function de(j){const Ae=new l.SymbolInformation(j.name,me.to(j.kind),j.containerName,pe.to(j.location));return Ae.tags=j.tags&&j.tags.map(ae.to),Ae}be.to=de})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(be){function ye(j){const Ae={name:j.name||"!!MISSING: name!!",detail:j.detail,range:n.from(j.range),selectionRange:n.from(j.selectionRange),kind:me.from(j.kind),tags:j.tags?.map(ae.from)??[]};return j.children&&(Ae.children=j.children.map(ye)),Ae}be.from=ye;function de(j){const Ae=new l.DocumentSymbol(j.name,j.detail,me.to(j.kind),n.to(j.range),n.to(j.selectionRange));return(0,a.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(ae.to)),j.children&&(Ae.children=j.children.map(de)),Ae}be.to=de})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(be){function ye(j){const Ae=new l.CallHierarchyItem(me.to(j.kind),j.name,j.detail||"",R.URI.revive(j.uri),n.to(j.range),n.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}be.to=ye;function de(j,Ae,Be){if(Ae=Ae??j._sessionId,Be=Be??j._itemId,Ae===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Be,name:j.name,detail:j.detail,kind:me.from(j.kind),uri:j.uri,range:n.from(j.range),selectionRange:n.from(j.selectionRange),tags:j.tags?.map(ae.from)}}be.from=de})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var we;(function(be){function ye(de){return new l.CallHierarchyIncomingCall(Ee.to(de.from),de.fromRanges.map(j=>n.to(j)))}be.to=ye})(we=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Z;(function(be){function ye(de){return new l.CallHierarchyOutgoingCall(Ee.to(de.to),de.fromRanges.map(j=>n.to(j)))}be.to=ye})(Z=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(be){function ye(j){return{range:j.range&&n.from(j.range),uri:j.uri}}be.from=ye;function de(j){return new l.Location(R.URI.revive(j.uri),n.to(j.range))}be.to=de})(pe=e.location||(e.location={}));var Pe;(function(be){function ye(j){const Ae=j,Be=j;return{originSelectionRange:Ae.originSelectionRange?n.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Be.uri,range:n.from(Ae.targetRange?Ae.targetRange:Be.range),targetSelectionRange:Ae.targetSelectionRange?n.from(Ae.targetSelectionRange):void 0}}be.from=ye;function de(j){return{targetUri:R.URI.revive(j.uri),targetRange:n.to(j.range),targetSelectionRange:j.targetSelectionRange?n.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?n.to(j.originSelectionRange):void 0}}be.to=de})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Ne;(function(be){function ye(j){return{range:n.from(j.range),contents:U.fromMany(j.contents)}}be.from=ye;function de(j){return new l.Hover(j.contents.map(U.to),n.to(j.range))}be.to=de})(Ne=e.Hover||(e.Hover={}));var We;(function(be){function ye(j){return{range:n.from(j.range),expression:j.expression}}be.from=ye;function de(j){return new l.EvaluatableExpression(n.to(j.range),j.expression)}be.to=de})(We=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ge;(function(be){function ye(j){if(j instanceof l.InlineValueText)return{type:"text",range:n.from(j.range),text:j.text};if(j instanceof l.InlineValueVariableLookup)return{type:"variable",range:n.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:n.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}be.from=ye;function de(j){switch(j.type){case"text":return{range:n.to(j.range),text:j.text};case"variable":return{range:n.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:n.to(j.range),expression:j.expression}}}be.to=de})(Ge=e.InlineValue||(e.InlineValue={}));var Ce;(function(be){function ye(j){return{frameId:j.frameId,stoppedLocation:n.from(j.stoppedLocation)}}be.from=ye;function de(j){return new l.InlineValueContext(j.frameId,n.to(j.stoppedLocation))}be.to=de})(Ce=e.InlineValueContext||(e.InlineValueContext={}));var _e;(function(be){function ye(j){return{range:n.from(j.range),kind:j.kind}}be.from=ye;function de(j){return new l.DocumentHighlight(n.to(j.range),j.kind)}be.to=de})(_e=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(be){function ye(de){switch(de){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}be.to=ye})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(be){function ye(de){return{triggerKind:Te.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}be.to=ye})(se=e.CompletionContext||(e.CompletionContext={}));var ue;(function(be){function ye(j){switch(j){case l.CompletionItemTag.Deprecated:return 1}}be.from=ye;function de(j){switch(j){case 1:return l.CompletionItemTag.Deprecated}}be.to=de})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(be){const ye=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function de(Be){return ye.get(Be)??9}be.from=de;const j=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Be){return j.get(Be)??l.CompletionItemKind.Property}be.to=Ae})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(be){function ye(de,j){const Ae=new l.CompletionItem(de.label);return Ae.insertText=de.insertText,Ae.kind=Q.to(de.kind),Ae.tags=de.tags?.map(ue.to),Ae.detail=de.detail,Ae.documentation=g.isMarkdownString(de.documentation)?U.to(de.documentation):de.documentation,Ae.sortText=de.sortText,Ae.filterText=de.filterText,Ae.preselect=de.preselect,Ae.commitCharacters=de.commitCharacters,v.Range.isIRange(de.range)?Ae.range=n.to(de.range):typeof de.range=="object"&&(Ae.range={inserting:n.to(de.range.insert),replacing:n.to(de.range.replace)}),Ae.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Ae.insertText=new l.SnippetString(de.insertText):(Ae.insertText=de.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Ae.additionalTextEdits=de.additionalTextEdits.map(Be=>G.to(Be))),Ae.command=j&&de.command?j.fromInternal(de.command):void 0,Ae}be.to=ye})(J=e.CompletionItem||(e.CompletionItem={}));var ce;(function(be){function ye(j){return{label:j.label,documentation:U.fromStrict(j.documentation)}}be.from=ye;function de(j){return{label:j.label,documentation:g.isMarkdownString(j.documentation)?U.to(j.documentation):j.documentation}}be.to=de})(ce=e.ParameterInformation||(e.ParameterInformation={}));var ve;(function(be){function ye(j){return{label:j.label,documentation:U.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(ce.from):[],activeParameter:j.activeParameter}}be.from=ye;function de(j){return{label:j.label,documentation:g.isMarkdownString(j.documentation)?U.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(ce.to):[],activeParameter:j.activeParameter}}be.to=de})(ve=e.SignatureInformation||(e.SignatureInformation={}));var F;(function(be){function ye(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(ve.from):[]}}be.from=ye;function de(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(ve.to):[]}}be.to=de})(F=e.SignatureHelp||(e.SignatureHelp={}));var W;(function(be){function ye(de,j){const Ae=new l.InlayHint(i.to(j.position),typeof j.label=="string"?j.label:j.label.map(V.to.bind(void 0,de)),j.kind&&K.to(j.kind));return Ae.textEdits=j.textEdits&&j.textEdits.map(G.to),Ae.tooltip=g.isMarkdownString(j.tooltip)?U.to(j.tooltip):j.tooltip,Ae.paddingLeft=j.paddingLeft,Ae.paddingRight=j.paddingRight,Ae}be.to=ye})(W=e.InlayHint||(e.InlayHint={}));var V;(function(be){function ye(de,j){const Ae=new l.InlayHintLabelPart(j.label);return Ae.tooltip=g.isMarkdownString(j.tooltip)?U.to(j.tooltip):j.tooltip,p.Command.is(j.command)&&(Ae.command=de.fromInternal(j.command)),j.location&&(Ae.location=pe.to(j.location)),Ae}be.to=ye})(V=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var K;(function(be){function ye(j){return j}be.from=ye;function de(j){return j}be.to=de})(K=e.InlayHintKind||(e.InlayHintKind={}));var z;(function(be){function ye(j){return{range:n.from(j.range),url:j.target,tooltip:j.tooltip}}be.from=ye;function de(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?R.URI.parse(j.url,!0):R.URI.revive(j.url)}catch{}return new l.DocumentLink(n.to(j.range),Ae)}be.to=de})(z=e.DocumentLink||(e.DocumentLink={}));var Y;(function(be){function ye(j){const Ae=new l.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=G.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Be=>G.to(Be))),Ae}be.to=ye;function de(j){return{label:j.label,textEdit:j.textEdit?G.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>G.from(Ae)):void 0}}be.from=de})(Y=e.ColorPresentation||(e.ColorPresentation={}));var ie;(function(be){function ye(j){return new l.Color(j[0],j[1],j[2],j[3])}be.to=ye;function de(j){return[j.red,j.green,j.blue,j.alpha]}be.from=de})(ie=e.Color||(e.Color={}));var Fe;(function(be){function ye(j){return{range:n.from(j.range)}}be.from=ye;function de(j){return new l.SelectionRange(n.to(j.range))}be.to=de})(Fe=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(be){function ye(de){switch(de){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}be.to=ye})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ke;(function(be){function ye(j){switch(j){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}be.from=ye;function de(j){switch(j){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}be.to=de})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ve;(function(be){function ye(j){if(j===l.EndOfLine.CRLF)return 1;if(j===l.EndOfLine.LF)return 0}be.from=ye;function de(j){if(j===1)return l.EndOfLine.CRLF;if(j===0)return l.EndOfLine.LF}be.to=de})(Ve=e.EndOfLine||(e.EndOfLine={}));var q;(function(be){function ye(de){if(typeof de=="object")return de.viewId;switch(de){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=ye})(q=e.ProgressLocation||(e.ProgressLocation={}));var X;(function(be){function ye(de){const j={start:de.start+1,end:de.end+1};return de.kind&&(j.kind=he.from(de.kind)),j}be.from=ye})(X=e.FoldingRange||(e.FoldingRange={}));var he;(function(be){function ye(de){if(de)switch(de){case l.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}be.from=ye})(he=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Le;(function(be){function ye(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?n.from(de.selection):void 0,override:typeof de.override=="boolean"?w.EditorResolution.DISABLED:void 0}}be.from=ye})(Le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var xe;(function(be){function ye(Be){return Be instanceof l.RelativePattern?Be.toJSON():typeof Be=="string"?Be:de(Be)||j(Be)?new l.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}be.from=ye;function de(Be){const tt=Be;return tt?R.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function j(Be){const tt=Be;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Ae(Be){return typeof Be=="string"?Be:new l.RelativePattern(R.URI.revive(Be.baseUri),Be.pattern)}be.to=Ae})(xe=e.GlobPattern||(e.GlobPattern={}));var Xe;(function(be){function ye(de){if(de){if(Array.isArray(de))return de.map(ye);if(typeof de=="string")return de;{const j=de;return{language:j.language,scheme:j.scheme,pattern:xe.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}be.from=ye})(Xe=e.LanguageSelector||(e.LanguageSelector={}));var Je;(function(be){function ye(j){return{start:j.start,end:j.end}}be.from=ye;function de(j){return new l.NotebookRange(j.start,j.end)}be.to=de})(Je=e.NotebookRange||(e.NotebookRange={}));var rt;(function(be){function ye(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}be.to=ye;function de(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}be.from=de})(rt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(be){function ye(de){if(de===h.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(de===h.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(de===h.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${de}`)}be.to=ye})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(be){function ye(j){switch(j){case l.NotebookCellKind.Markup:return h.CellKind.Markup;case l.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=ye;function de(j){switch(j){case h.CellKind.Markup:return l.NotebookCellKind.Markup;case h.CellKind.Code:default:return l.NotebookCellKind.Code}}be.to=de})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var qe;(function(be){function ye(j){const Ae={metadata:j.metadata??Object.create(null),cells:[]};for(let Be of j.cells)l.NotebookCellData.validate(Be),Ae.cells.push(lt.from(Be));return Ae}be.from=ye;function de(j){const Ae=new l.NotebookData(j.cells.map(lt.to));return(0,P.isEmptyObject)(j.metadata)||(Ae.metadata=j.metadata),Ae}be.to=de})(qe=e.NotebookData||(e.NotebookData={}));var lt;(function(be){function ye(j){return{cellKind:Ze.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:rt.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(It.from):[]}}be.from=ye;function de(j){return new l.NotebookCellData(Ze.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(It.to):void 0,j.metadata,j.internalMetadata?rt.to(j.internalMetadata):void 0)}be.to=de})(lt=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(be){function ye(j){return{mime:j.mime,valueBytes:D.VSBuffer.wrap(j.data)}}be.from=ye;function de(j){return new l.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}be.to=de})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(be){function ye(j){return{outputId:j.id,items:j.items.map(st.from),metadata:j.metadata}}be.from=ye;function de(j){const Ae=j.items.map(st.to);return new l.NotebookCellOutput(Ae,j.outputId,j.metadata)}be.to=de})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(be){function ye(Ae){return j(Ae)?{include:(0,P.withNullAsUndefined)(xe.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(xe.from(Ae.exclude))}:(0,P.withNullAsUndefined)(xe.from(Ae))}be.from=ye;function de(Ae){return j(Ae)?{include:xe.to(Ae.include),exclude:xe.to(Ae.exclude)}:xe.to(Ae)}be.to=de;function j(Ae){const Be=Ae;return Be?!(0,P.isUndefinedOrNull)(Be.include)&&!(0,P.isUndefinedOrNull)(Be.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ht;(function(be){function ye(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?$.from(de.top):void 0}}be.from=ye})(ht=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ut;(function(be){function ye(de,j,Ae){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Be,Ae),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}be.from=ye})(Ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ft;(function(be){function ye(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{}}}be.from=ye})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(be){function ye(j){return{uri:j.uri,provides:j.provides}}be.from=ye;function de(j){return new l.NotebookRendererScript(R.URI.revive(j.uri),j.provides)}be.to=de})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(be){function ye(j){return{message:U.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:n.from(j.location.range),uri:j.location.uri}}}be.from=ye;function de(j){const Ae=new l.TestMessage(typeof j.message=="string"?j.message:U.to(j.message));return Ae.actualOutput=j.actual,Ae.expectedOutput=j.expected,Ae.location=j.location?pe.to(j.location):void 0,Ae}be.to=de})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(be){be.namespace=y.namespaceTestTag,be.denamespace=y.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Pt;(function(be){function ye(j){const Ae=(0,u.getPrivateApiFor)(j).controllerId;return{extId:c.TestId.fromExtHostTestItem(j,Ae).toString(),label:j.label,uri:R.URI.revive(j.uri),busy:!1,tags:j.tags.map(Be=>Dt.namespace(Ae,Be.id)),range:v.Range.lift(n.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&U.fromStrict(j.error)||null}}be.from=ye;function de(j){return{parent:void 0,error:void 0,id:c.TestId.fromString(j.extId).localId,label:j.label,uri:R.URI.revive(j.uri),tags:(j.tags||[]).map(Ae=>{const{tagId:Be}=Dt.denamespace(Ae);return new l.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:n.to(j.range||void 0),canResolveChildren:!1,busy:!1,description:j.description||void 0,sortText:j.sortText||void 0}}be.toPlain=de})(Pt=e.TestItem||(e.TestItem={})),function(be){function ye(j){return{id:j.id}}be.from=ye;function de(j){return new l.TestTag(j.id)}be.to=de}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(be){const ye=(j,Ae)=>{const Be={...Pt.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.filter(je=>je.type===0).map(ft.to)})),children:j.children.map(tt=>Ae.get(tt)).filter(P.isDefined).map(tt=>ye(tt,Ae))};for(const tt of Be.children)tt.parent=Be;return Be};function de(j){const Ae=[],Be=new Map;for(const tt of j.items)Be.set(tt.item.extId,tt),j.request.targets.some(je=>je.controllerId===tt.controllerId&&je.testIds.includes(tt.item.extId))&&Ae.push(tt);return{completedAt:j.completedAt,results:Ae.map(tt=>ye(tt,Be))}}be.to=de})(Nt=e.TestResults||(e.TestResults={}));var He;(function(be){function ye(Be){return{covered:Be.covered,total:Be.covered}}function de(Be){return"line"in Be?i.from(Be):n.from(Be)}function j(Be){return"branches"in Be?{count:Be.executionCount,location:de(Be.location),type:1,branches:Be.branches.length?Be.branches.map(tt=>({count:tt.executionCount,location:tt.location&&de(tt.location)})):void 0}:{type:0,count:Be.executionCount,location:de(Be.location)}}be.fromDetailed=j;function Ae(Be){return{uri:Be.uri,statement:ye(Be.statementCoverage),branch:Be.branchCoverage&&ye(Be.branchCoverage),function:Be.functionCoverage&&ye(Be.functionCoverage),details:Be.detailedCoverage?.map(j)}}be.fromFile=Ae})(He=e.TestCoverage||(e.TestCoverage={}));var $t;(function(be){function ye(de){switch(de){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}be.to=ye})($t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(be){function ye(j){const Ae=new l.TypeHierarchyItem(me.to(j.kind),j.name,j.detail||"",R.URI.revive(j.uri),n.to(j.range),n.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}be.to=ye;function de(j,Ae,Be){if(Ae=Ae??j._sessionId,Be=Be??j._itemId,Ae===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Be,kind:me.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:n.from(j.range),selectionRange:n.from(j.selectionRange),tags:j.tags?.map(ae.from)}}be.from=de})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(be){function ye(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}be.from=ye})(Mt=e.ViewBadge||(e.ViewBadge={}))}),define(Se[172],De([1,0,2,12,6,8,233]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,R,v,p={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=v,this._thresholds=p,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,v,p)=>{const f={dispose:this._callbacks.push([R,v,P])};return Array.isArray(p)&&p.push(f),f}}async $participateInSave(P,R){const v=a.URI.revive(P);let p=!1;const w=setTimeout(()=>p=!0,this._thresholds.timeout),f=[];try{for(let u of[...this._callbacks]){if(p)break;const h=this._documents.getDocument(v),c=await this._deliverEventAsyncAndBlameBadListeners(u,{document:h,reason:L.TextDocumentSaveReason.to(R)});f.push(c)}}finally{clearTimeout(w)}return f}_deliverEventAsyncAndBlameBadListeners([P,R,v],p){const w=this._badListeners.get(P);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(v,P,R,p).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const u=this._badListeners.get(P);this._badListeners.set(P,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,v,p){const w=[],f=Date.now(),{document:u,reason:h}=p,{version:c}=u,y=Object.freeze({document:u,reason:h,waitUntil(_){if(Object.isFrozen(w))throw(0,D.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(_))}});try{R.apply(v,[y])}catch(_){return Promise.reject(_)}return Object.freeze(w),new Promise((_,l)=>{const S=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(S),_(n)}).catch(n=>{clearTimeout(S),l(n)})}).then(_=>{const l={edits:[]};for(const S of _)if(Array.isArray(S)&&S.every(n=>n instanceof g.TextEdit))for(const{newText:n,newEol:T,range:i}of S)l.edits.push({_type:2,resource:u.uri,edit:{range:i&&L.Range.from(i),text:n,eol:T&&L.EndOfLine.from(T)}});if(l.edits.length!==0)return c===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(Se[173],De([1,0,11,2,8,6,87]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(v,p,w,f){this.start=v,this.deletedCount=p,this.deletedItems=w,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class b{constructor(v,p,w){this.notebook=v,this._extHostDocument=p,this._cellData=w,this.handle=w.handle,this.uri=D.URI.revive(w.uri),this.cellKind=w.cellKind,this._outputs=w.outputs.map(g.NotebookCellOutput.to),this._internalMetadata=w.internalMetadata??{},this._metadata=Object.freeze(w.metadata??{}),this._previousResult=Object.freeze(g.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}static asModelAddData(v,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:v}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const v=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:g.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return v._mime},set mime(f){v._mime=f},get outputs(){return v._outputs.slice(0)},get metadata(){return v._metadata},get executionSummary(){return v._previousResult}};this._apiCell=Object.freeze(w)}return this._apiCell}setOutputs(v){this._outputs=v.map(g.NotebookCellOutput.to)}setOutputItems(v,p,w){const f=w.map(g.NotebookCellOutputItem.to),u=this._outputs.find(h=>h.id===v);u&&(p||(u.items.length=0),u.items.push(...f))}setMetadata(v){this._metadata=Object.freeze(v)}setInternalMetadata(v){this._internalMetadata=v,this._previousResult=Object.freeze(g.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.ExtHostCell=b;class P{constructor(v,p,w,f,u){this._proxy=v,this._textDocumentsAndEditors=p,this._textDocuments=w,this.uri=f,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0,void 0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const v=this,p={get uri(){return v.uri},get version(){return v._versionId},get notebookType(){return v._notebookType},get isDirty(){return v._isDirty},get isUntitled(){return v.uri.scheme===a.Schemas.untitled},get isClosed(){return v._disposed},get metadata(){return v._metadata},get cellCount(){return v._cells.length},cellAt(w){return w=v._validateIndex(w),v._cells[w].apiCell},getCells(w){return(w?v._getCells(w):v._cells).map(u=>u.apiCell)},save(){return v._save()}};this._notebook=Object.freeze(p)}return this._notebook}updateBackup(v){this._backup?.delete(),this._backup=v}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(v){v.metadata&&(this._metadata=Object.freeze({...this._metadata,...v.metadata}))}acceptDirty(v){this._isDirty=v}acceptModelChanged(v,p,w){this._versionId=v.versionId,this._isDirty=p,this.acceptDocumentPropertiesChanged({metadata:w});const f={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},u=[];for(const c of v.rawEvents)c.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1,f.contentChanges):c.kind===I.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx,f.contentChanges):c.kind===I.NotebookCellsChangeType.Output?(this._setCellOutputs(c.index,c.outputs),u.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems),u.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(c.index,c.language),u.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document})):c.kind===I.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document}):c.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(c.index,c.metadata),u.push({cell:this._cells[c.index].apiCell,metadata:this._cells[c.index].apiCell.metadata})):c.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(c.index,c.internalMetadata),u.push({cell:this._cells[c.index].apiCell,executionSummary:this._cells[c.index].apiCell.executionSummary}));const h=new Map;for(let c=0;c<u.length;c++){const y=u[c],_=h.get(y.cell);if(_===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...y});h.set(y.cell,l-1)}else f.cellChanges[_]={...f.cellChanges[_],...y}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(v){return v=v|0,v<0?0:v>=this._cells.length?this._cells.length-1:v}_validateRange(v){let p=v.start|0,w=v.end|0;return p<0&&(p=0),w>this._cells.length&&(w=this._cells.length),v.with({start:p,end:w})}_getCells(v){v=this._validateRange(v);const p=[];for(let w=v.start;w<v.end;w++)p.push(this._cells[w]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(v,p,w){if(this._disposed)return;const f=[],u=[],h=[];if(v.reverse().forEach(c=>{const _=c[2].map(n=>{const T=new b(this,this._textDocumentsAndEditors,n);return p||u.push(b.asModelAddData(this.apiNotebook,n)),T}),l=new k(c[0],c[1],[],_),S=this._cells.splice(c[0],c[1],..._);for(const n of S)h.push(n.uri),l.deletedItems.push(n.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:h}),w)for(let c of f)w.push(c.asApiEvent())}_moveCell(v,p,w){const f=this._cells.splice(v,1);this._cells.splice(p,0,...f);const u=[new k(v,1,f.map(h=>h.apiCell),[]),new k(p,0,[],f)];for(const h of u)w.push(h.asApiEvent())}_setCellOutputs(v,p){this._cells[v].setOutputs(p)}_setCellOutputItems(v,p,w,f){this._cells[v].setOutputItems(p,w,f)}_changeCellLanguage(v,p){const w=this._cells[v];w.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(w.uri,p)}_changeCellMime(v,p){const w=this._cells[v];w.apiCell.mime=p}_changeCellMetadata(v,p){this._cells[v].setMetadata(p)}_changeCellInternalMetadata(v,p){this._cells[v].setInternalMetadata(p)}getCellFromApiCell(v){return this._cells.find(p=>p.apiCell===v)}getCellFromIndex(v){return this._cells[v]}getCell(v){return this._cells.find(p=>p.handle===v)}getCellIndex(v){return this._cells.indexOf(v)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Se[90],De([1,0,6,8,12]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:P})}replaceCells(b,P,R){this._throwIfFinalized(),!(b===P&&R.length===0)&&this._collectedEdits.push({editType:1,index:b,count:P-b,cells:R.map(D.NotebookCellData.from)})}}class I{constructor(b,P,R,v,p,w){this.id=b,this._proxy=P,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._visibleRanges=v,this._viewColumn=w}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get selections(){return b._selections},set selections(P){if(!Array.isArray(P)||!P.every(a.NotebookRange.isNotebookRange))throw(0,g.illegalArgument)("selections");b._selections=P,b._trySetSelections(P)},get visibleRanges(){return b._visibleRanges},revealRange(P,R){b._proxy.$tryRevealRange(b.id,D.NotebookRange.from(P),R??a.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(P){const R=new L(this.document.version);return P(R),b._applyEdit(R.finalize())},setDecorations(P,R){return b.setDecorations(P,R)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(D.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const P=[];let R=-1;for(let v=0;v<b.cellEdits.length;v++){if(R<0){P.push(b.cellEdits[v]),R++;continue}const w=P[R],f=b.cellEdits[v];if(w.editType===1&&f.editType===1&&w.index===f.index){w.cells.push(...b.cellEdits[v].cells),w.count+=b.cellEdits[v].count;continue}P.push(b.cellEdits[v]),R++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,P)}setDecorations(b,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(b.key)))return P.isEmpty?this._hasDecorationsForKey.delete(b.key):this._hasDecorationsForKey.add(b.key),this._proxy.$trySetDecorations(this.id,D.NotebookRange.from(P),b.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(Se[174],De([1,0,8,148,130,20,55,12]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,w,f){const u=this._handles++,{title:h,location:c,cancellable:y}=w,_={label:(0,g.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(u,{location:a.ProgressLocation.from(c),title:h,source:_,cancellable:y},p.isUnderDevelopment?void 0:p.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(u,f,!!y)}_withProgress(p,w,f){let u;f&&(u=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,u));const h=y=>{this._proxy.$progressEnd(y),this._mapHandleToCancellationSource.delete(y),u&&u.dispose()};let c;try{c=w(new R(this._proxy,p),f&&u?u.token:L.CancellationToken.None)}catch(y){throw h(p),y}return c.then(y=>h(p),y=>h(p)),c}$acceptProgressCanceled(p){const w=this._mapHandleToCancellationSource.get(p);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=b;function P(v,p){return v.message=p.message,typeof p.increment=="number"&&(typeof v.increment=="number"?v.increment+=p.increment:v.increment=p.increment),v}class R extends D.Progress{constructor(p,w){super(f=>this.throttledReport(f));this._proxy=p,this._handle=w}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}$e([(0,I.throttle)(100,(v,p)=>P(v,p),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[91],De([1,0,48,88,46,67,47,8,2]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(_,l,S,n)=>{let T=l;return{enumerable:!0,configurable:!1,get(){return T},set(i){if(!S(T,i)){const o=T;T=i,_.listener?.(n(i,o))}}}},R=(_,l)=>_===l,v={range:(_,l)=>_===l?!0:!_||!l?!1:_.isEqual(l),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(_,l)=>!(_.length!==l.length||_.some(S=>!l.find(n=>S.id===n.id)))},p=_=>l=>({op:4,update:_(l)}),w=(_,l)=>({range:P(_,void 0,v.range,p(S=>({range:a.Range.lift(k.Range.from(S))}))),label:P(_,l,v.label,p(S=>({label:S}))),description:P(_,void 0,v.description,p(S=>({description:S}))),sortText:P(_,void 0,v.sortText,p(S=>({sortText:S}))),canResolveChildren:P(_,!1,v.canResolveChildren,S=>({op:2,state:S})),busy:P(_,!1,v.busy,p(S=>({busy:S}))),error:P(_,void 0,v.error,p(S=>({error:k.MarkdownString.fromStrict(S)||null}))),tags:P(_,[],v.tags,(S,n)=>({op:1,new:S.map(k.TestTag.from),old:n.map(k.TestTag.from)}))}),f=_=>{const l=g.TestId.fromString(_.extId),S=new h(l.controllerId,l.localId,_.label,b.URI.revive(_.uri)||void 0);return S.range=k.Range.to(_.range||void 0),S.description=_.description||void 0,S.sortText=_.sortText||void 0,S.tags=_.tags.map(n=>k.TestTag.to({id:(0,I.denamespaceTestTag)(n).tagId})),S},u=_=>{let l;for(const S of _.tests){const n=f(S.item);(0,D.getPrivateApiFor)(n).parent=l,l=n}return l};e.toItemFromContext=u;class h{constructor(l,S,n,T){if(S.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(S)} symbol`);const i=(0,D.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:S,enumerable:!0,writable:!1},uri:{value:T,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof c?void 0:i.parent}},children:{value:(0,L.createTestItemChildren)(i,D.getPrivateApiFor,h),enumerable:!0,writable:!1},...w(i,n)})}}e.TestItemImpl=h;class c extends h{constructor(l,S){super(l,l,S,void 0)}}e.TestItemRootImpl=c;class y extends L.TestItemCollection{constructor(l,S){super({controllerId:l,getApiFor:D.getPrivateApiFor,getChildren:n=>n.children,root:new c(l,S),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=y}),define(Se[92],De([1,0,41,12,56,8,6]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(p,w,f){const u=k._Keys.nextId();p.$registerTextEditorDecorationType(w.identifier,u,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:u,dispose(){p.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=k,k._Keys=new g.IdGenerator("TextEditorDecorationType");class b{constructor(p,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,w){this._throwIfFinalized();let f=null;if(p instanceof I.Position)f=new I.Range(p,p);else if(p instanceof I.Range)f=p;else throw new Error("Unrecognized location");this._pushEdit(f,w,!1)}insert(p,w){this._throwIfFinalized(),this._pushEdit(new I.Range(p,p),w,!0)}delete(p){this._throwIfFinalized();let w=null;if(p instanceof I.Range)w=p;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(p,w,f){const u=this._document.validateRange(p);this._collectedEdits.push({range:u,text:w,forceMoveMarkers:f})}setEndOfLine(p){if(this._throwIfFinalized(),p!==I.EndOfLine.LF&&p!==I.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=b;class P{constructor(p,w,f,u){this._proxy=p,this._id=w,this._accept(f),this._logService=u;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(c){h._setTabSize(c)},get insertSpaces(){return h._insertSpaces},set insertSpaces(c){h._setInsertSpaces(c)},get cursorStyle(){return h._cursorStyle},set cursorStyle(c){h._setCursorStyle(c)},get lineNumbers(){return h._lineNumbers},set lineNumbers(c){h._setLineNumbers(c)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const w=Math.floor(p);return w>0?w:null}if(typeof p=="string"){const w=parseInt(p,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(p){const w=this._validateTabSize(p);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const w=this._validateInsertSpaces(p);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(p)})))}assign(p){const w={};let f=!1;if(typeof p.tabSize!="undefined"){const u=this._validateTabSize(p.tabSize);u==="auto"?(f=!0,w.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,f=!0,w.tabSize=u)}if(typeof p.insertSpaces!="undefined"){const u=this._validateInsertSpaces(p.insertSpaces);u==="auto"?(f=!0,w.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,f=!0,w.insertSpaces=u)}typeof p.cursorStyle!="undefined"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,f=!0,w.cursorStyle=p.cursorStyle),typeof p.lineNumbers!="undefined"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,f=!0,w.lineNumbers=L.TextEditorLineNumbersStyle.from(p.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(p,w){w.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=P;class R{constructor(p,w,f,u,h,c,y,_){this.id=p,this._proxy=w,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new P(this._proxy,this.id,c,f),this._visibleRanges=y,this._viewColumn=_;const l=this;this.value=Object.freeze({get document(){return u.getValue()},set document(S){throw(0,D.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(S){if(!(S instanceof I.Selection))throw(0,D.illegalArgument)("selection");l._selections=[S],l._trySetSelection()},get selections(){return l._selections},set selections(S){if(!Array.isArray(S)||S.some(n=>!(n instanceof I.Selection)))throw(0,D.illegalArgument)("selections");l._selections=S,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(S){throw(0,D.readonly)("visibleRanges")},get options(){return l._options.value},set options(S){l._disposed||l._options.assign(S)},get viewColumn(){return l._viewColumn},set viewColumn(S){throw(0,D.readonly)("viewColumn")},edit(S,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const T=new b(u.getValue(),n);return S(T),l._applyEdit(T)},insertSnippet(S,n,T={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!n||Array.isArray(n)&&n.length===0)i=l._selections.map(o=>L.Range.from(o));else if(n instanceof I.Position){const{lineNumber:o,column:r}=L.Position.from(n);i=[{startLineNumber:o,startColumn:r,endLineNumber:o,endColumn:r}]}else if(n instanceof I.Range)i=[L.Range.from(n)];else{i=[];for(const o of n)if(o instanceof I.Range)i.push(L.Range.from(o));else{const{lineNumber:r,column:t}=L.Position.from(o);i.push({startLineNumber:r,startColumn:t,endLineNumber:r,endColumn:t})}}return w.$tryInsertSnippet(p,u.getValue().version,S.value,i,T)},setDecorations(S,n){const T=n.length===0;T&&!l._hasDecorationsForKey.has(S.key)||(T?l._hasDecorationsForKey.delete(S.key):l._hasDecorationsForKey.add(S.key),l._runOnProxy(()=>{if(L.isDecorationOptionsArr(n))return w.$trySetDecorations(p,S.key,L.fromRangeOrRangeWithMessage(n));{const i=new Array(4*n.length);for(let o=0,r=n.length;o<r;o++){const t=n[o];i[4*o]=t.start.line+1,i[4*o+1]=t.start.character+1,i[4*o+2]=t.end.line+1,i[4*o+3]=t.end.character+1}return w.$trySetDecorationsFast(p,S.key,i)}}))},revealRange(S,n){l._runOnProxy(()=>w.$tryRevealRange(p,L.Range.from(S),n||I.TextEditorRevealType.Default))},show(S){w.$tryShowEditor(p,L.ViewColumn.from(S))},hide(){w.$tryHideEditor(p)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,a.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,a.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,a.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,a.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const w=p.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const f=w.edits.map(h=>h.range);f.sort((h,c)=>h.end.line===c.end.line?h.end.character===c.end.character?h.start.line===c.start.line?h.start.character-c.start.character:h.start.line-c.start.line:h.end.character-c.end.character:h.end.line-c.end.line);for(let h=0,c=f.length-1;h<c;h++){const y=f[h].end;if(f[h+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=w.edits.map(h=>({range:L.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,u,{setEndOfLine:typeof w.setEndOfLine=="number"?L.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=R}),define(Se[175],De([1,0,3,144]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(D.IEnvironmentService)}),define(Se[176],De([1,0,26,5,17]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=L;class I{constructor(R){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let v of R.activationEvents)v==="onUri"&&(v=`onUri:${a.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(v)||this._activationMap.set(v,[]),this._activationMap.get(v).push(R)}}set(R){this._extensionDescriptions=R,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,v){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const p=I._findLoopingExtensions(this._extensionDescriptions);if(v=v.concat(p.map(w=>w.identifier)),v.length>0){const w=new Set;v.forEach(f=>w.add(a.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!w.has(a.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new L(p)}static _findLoopingExtensions(R){const v=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,c){this.addNode(h),this.addNode(c),this._arcs.has(h)?this._arcs.get(h).push(c):this._arcs.set(h,[c])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,c){const y=v.getArcs(h);for(let _=0;_<y.length;_++)if(!c.has(y[_]))return!1;return!0}getNodes(){return this._nodesArr}};let p=new Map;for(let h of R){const c=a.ExtensionIdentifier.toKey(h.identifier);if(p.set(c,h),h.extensionDependencies)for(let y of h.extensionDependencies){const _=a.ExtensionIdentifier.toKey(y);v.addArc(c,_)}}let w=new Set;v.getNodes().filter(h=>v.getArcs(h).length===0).forEach(h=>w.add(h));let f=v.getNodes().filter(h=>!w.has(h)),u;do{u=!1;for(let h=0;h<f.length;h++){const c=f[h];v.hasOnlyGoodArcs(c,w)&&(f.splice(h,1),h--,w.add(c),u=!0)}}while(u);return f.map(h=>p.get(h))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const v=this._activationMap.get(R);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const v=this._extensionsMap.get(a.ExtensionIdentifier.toKey(R));return v||void 0}}e.ExtensionDescriptionRegistry=I;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function b(P,R){const v=P.isBuiltin?0:P.isUnderDevelopment?2:1,p=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(v!==p)return v-p;const w=g.posix.basename(P.extensionLocation.path),f=g.posix.basename(R.extensionLocation.path);return w<f?-1:w>f?1:0}}),define(Se[93],De([1,0,25]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var D;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var g;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(g=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function I(b){const P=a.VSBuffer.alloc(1);switch(b){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.createMessageOfType=I;function k(b,P){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.isMessageOfType=k}),define(Se[21],De([1,0,5,2,3,26,151]),function(ee,e,a,D,g,L,I){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class v{constructor(t){this.dependency=t}}e.MissingExtensionDependency=v;var p;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(p=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=w;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,s){const m=[],d=[],C=[],O=[],U=c(this._allExtensions),A=c(t),E=(oe,G)=>oe.extensionLocation.toString()===G.extensionLocation.toString()||oe.isBuiltin===G.isBuiltin||oe.isUserBuiltin===G.isUserBuiltin||oe.isUnderDevelopment===G.isUnderDevelopment;for(const oe of this._allExtensions){const G=A.get(L.ExtensionIdentifier.toKey(oe.identifier));if(!G){m.push(oe.identifier),U.delete(L.ExtensionIdentifier.toKey(oe.identifier));continue}if(!E(oe,G)){m.push(oe.identifier),U.delete(L.ExtensionIdentifier.toKey(oe.identifier));continue}}for(const oe of t){const G=U.get(L.ExtensionIdentifier.toKey(oe.identifier));if(!G){d.push(oe);continue}if(!E(G,oe)){m.push(G.identifier),U.delete(L.ExtensionIdentifier.toKey(G.identifier));continue}}const $=h(this._myExtensions),x=h(s);for(const oe of this._myExtensions)x.has(L.ExtensionIdentifier.toKey(oe))||C.push(oe);for(const oe of s)$.has(L.ExtensionIdentifier.toKey(oe))||O.push(oe);const H={toRemove:m,toAdd:d,myToRemove:C,myToAdd:O};return this.delta(H),H}delta(t){const{toRemove:s,toAdd:m,myToRemove:d,myToAdd:C}=t,O=h(s),U=h(d);for(let A=0;A<this._allExtensions.length;A++)O.has(L.ExtensionIdentifier.toKey(this._allExtensions[A].identifier))&&(this._allExtensions.splice(A,1),A--);for(let A=0;A<this._myExtensions.length;A++)U.has(L.ExtensionIdentifier.toKey(this._myExtensions[A]))&&(this._myExtensions.splice(A,1),A--);for(const A of m)this._allExtensions.push(A);for(const A of C)this._myExtensions.push(A)}containsExtension(t){for(const s of this._myExtensions)if(L.ExtensionIdentifier.equals(s,t))return!0;return!1}}e.ExtensionHostExtensions=f;class u{constructor(t){if(this[k]="ExtensionIdentifierSet",this._map=new Map,this._toKey=L.ExtensionIdentifier.toKey,t)for(const s of t)this.add(s)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,s){this._map.forEach(m=>t.call(s,m,m,this))}*entries(){for(let[t,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=u;function h(r){const t=new Set;for(const s of r)t.add(L.ExtensionIdentifier.toKey(s));return t}e.extensionIdentifiersArrayToSet=h;function c(r){const t=new Map;for(const s of r)t.set(L.ExtensionIdentifier.toKey(s.identifier),s);return t}function y(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=y;function _(r,t){if(!y(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=_;class l{constructor(t,s,m,d){this.codeLoadingTime=t,this.activateCallTime=s,this.activateResolvedTime=m,this.activationReason=d}}e.ActivationTimes=l;class S{constructor(t,s){this.description=t,this.value=s}}e.ExtensionPointContribution=S,e.ExtensionHostLogFileName="exthost";var n;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function T(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=T;function i(r,t){return{identifier:new L.ExtensionIdentifier((0,I.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.toExtensionDescription=i;class o{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,s){return Promise.resolve(0)}getInspectPorts(t,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,s){return Promise.resolve()}}e.NullExtensionService=o}),define(Se[177],De([1,0,12,26,21,13,14]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class k{constructor(h,c,y,_){this.startup=h,this.codeLoadingTime=c,this.activateCallTime=y,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class b{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,c){return h===-1||c===-1?-1:c-h}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class P{constructor(h,c,y,_,l,S){this.activationFailed=h,this.activationFailedError=c,this.activationTimes=y,this.module=_,this.exports=l,this.subscriptions=S}}e.ActivatedExtension=P;class R extends P{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class v extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class p extends P{constructor(h){super(!0,h,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=p;let w=class{constructor(h,c,y,_,l){this._logService=l,this._registry=h,this._resolvedExtensionsSet=new Set,c.forEach(S=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(S))),this._externalExtensionsMap=new Map,y.forEach(S=>this._externalExtensionsMap.set(D.ExtensionIdentifier.toKey(S),S)),this._host=_,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,c]of this._operations)c.dispose()}isActivated(h){const c=this._operations.get(D.ExtensionIdentifier.toKey(h));return Boolean(c&&c.value)}getActivatedExtension(h){const c=this._operations.get(D.ExtensionIdentifier.toKey(h));if(!c||!c.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return c.value}async activateByEvent(h,c){if(this._alreadyActivatedEvents[h])return;const y=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(y.map(_=>({id:_.identifier,reason:{startup:c,extensionId:_.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,c){const y=this._registry.getExtensionDescription(h);if(!y)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:y.identifier,reason:c}])}async _activateExtensions(h){const c=h.filter(y=>!this.isActivated(y.id)).map(y=>this._handleActivationRequest(y));await Promise.all(c.map(y=>y.wait()))}_handleActivationRequest(h){if(this._operations.has(D.ExtensionIdentifier.toKey(h.id)))return this._operations.get(D.ExtensionIdentifier.toKey(h.id));if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(h.id)))return this._createAndSaveOperation(h,null,[],null);const c=this._registry.getExtensionDescription(h.id);if(!c){const l=new Error(`Cannot activate unknown extension '${h.id.value}'`),S=this._createAndSaveOperation(h,null,[],new p(l));return this._host.onExtensionActivationError(h.id,l,new g.MissingExtensionDependency(h.id.value)),S}const y=[],_=typeof c.extensionDependencies=="undefined"?[]:c.extensionDependencies;for(const l of _){if(this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(l)))continue;const S=this._operations.get(D.ExtensionIdentifier.toKey(l));if(S){y.push(S);continue}if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(l))){y.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(D.ExtensionIdentifier.toKey(l)),reason:h.reason}));continue}const n=this._registry.getExtensionDescription(l);if(n){if(!n.main&&!n.browser)continue;y.push(this._handleActivationRequest({id:n.identifier,reason:h.reason}));continue}const T=c.displayName||c.identifier.value,i=new Error(`Cannot activate the '${T}' extension because it depends on unknown extension '${l}'`),o=this._createAndSaveOperation(h,c.displayName,[],new p(i));return this._host.onExtensionActivationError(c.identifier,i,new g.MissingExtensionDependency(l)),o}return this._createAndSaveOperation(h,c.displayName,y,null)}_createAndSaveOperation(h,c,y,_){const l=new f(h.id,c,h.reason,y,_,this._host,this._logService);return this._operations.set(D.ExtensionIdentifier.toKey(h.id),l),l}};w=$e([ze(4,L.ILogService)],w),e.ExtensionsActivator=w;let f=class{constructor(h,c,y,_,l,S,n){this._id=h,this._displayName=c,this._reason=y,this._deps=_,this._value=l,this._host=S,this._logService=n,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const c=this._deps[h];if(c.value&&!c.value.activationFailed){this._deps.splice(h,1),h--;continue}if(c.value&&c.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);y.detail=c.value.activationFailedError,this._value=new p(y),this._host.onExtensionActivationError(this._id,y,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const c=new Error;if(h&&h.name&&(c.name=h.name),h&&h.message?c.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(c.stack=h.stack),this._value=new p(c),this._isDisposed&&a.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};f=$e([ze(6,L.ILogService)],f)}),define(Se[178],De([1,0,13,28,21]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends a.LogService{constructor(k,b){super(k.createLogger(b.logFile,{name:g.ExtensionHostLogFileName}))}};L=$e([ze(0,a.ILoggerService),ze(1,D.IExtHostInitDataService)],L),e.ExtHostLogService=L}),define(Se[179],De([1,0,12]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((L,I)=>{this._actualOk=L,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(L){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=L,this._actual&&this._actualOk(L))}resolveErr(L){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=L,this._actual?this._actualErr(L):(0,a.onUnexpectedError)(L))}then(L,I){return this._ensureActual().then(L,I)}catch(L){return this._ensureActual().then(void 0,L)}finally(L){return this._ensureActual().finally(L)}}e.LazyPromise=D}),define(Se[39],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const D=[];function g(k){const b=new a(k);return D[b.nid]=b,b}e.createProxyIdentifier=g;function L(k){return D[k].sid}e.getStringIdentifierForProxy=L;class I{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=I}),define(Se[4],De([1,0,57,2,39]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(L=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(_){_[_.UnknownInput=0]="UnknownInput",_[_.TextInput=1]="TextInput",_[_.TextDiffInput=2]="TextDiffInput",_[_.NotebookInput=3]="NotebookInput",_[_.NotebookDiffInput=4]="NotebookDiffInput",_[_.CustomEditorInput=5]="CustomEditorInput",_[_.WebviewEditorInput=6]="WebviewEditorInput",_[_.TerminalEditorInput=7]="TerminalEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var k;(function(_){_[_.TAB_OPEN=0]="TAB_OPEN",_[_.TAB_CLOSE=1]="TAB_CLOSE",_[_.TAB_UPDATE=2]="TAB_UPDATE",_[_.TAB_MOVE=3]="TAB_MOVE"})(k=e.TabModelOperationKind||(e.TabModelOperationKind={}));var b;(function(_){_[_.Editable=0]="Editable",_[_.SupportsHotExit=1]="SupportsHotExit"})(b=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(_){_[_.Int8Array=1]="Int8Array",_[_.Uint8Array=2]="Uint8Array",_[_.Uint8ClampedArray=3]="Uint8ClampedArray",_[_.Int16Array=4]="Int16Array",_[_.Uint16Array=5]="Uint16Array",_[_.Int32Array=6]="Int32Array",_[_.Uint32Array=7]="Uint32Array",_[_.Float32Array=8]="Float32Array",_[_.Float64Array=9]="Float64Array",_[_.BigInt64Array=10]="BigInt64Array",_[_.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(_){_[_.Text=1]="Text",_[_.Error=2]="Error",_[_.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var v;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(v=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var p;(function(_){_[_.None=0]="None",_[_.Process=1]="Process",_[_.Output=2]="Output"})(p=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(l){return l._id=w._n++,l}}e.IdObject=w,w._n=0;var f;(function(_){_.label="a",_.kind="b",_.detail="c",_.documentation="d",_.sortText="e",_.filterText="f",_.preselect="g",_.insertText="h",_.insertTextRules="i",_.range="j",_.commitCharacters="k",_.additionalTextEdits="l",_.command="m",_.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(_){_.defaultRanges="a",_.completions="b",_.isIncomplete="c",_.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function c(_){if(_&&_.edits)for(const l of _.edits)typeof l.resource=="object"?l.resource=D.URI.revive(l.resource):(l.newUri=D.URI.revive(l.newUri),l.oldUri=D.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,a.revive)(l.metadata));return _}e.reviveWorkspaceEditDto=c;var y;(function(_){_[_.Workspace=0]="Workspace",_[_.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,g.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,g.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,g.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,g.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,g.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,g.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,g.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,g.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,g.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,g.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,g.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,g.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,g.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,g.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,g.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,g.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,g.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,g.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,g.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,g.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,g.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,g.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,g.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,g.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,g.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,g.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,g.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,g.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,g.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookProxyKernels:(0,g.createProxyIdentifier)("MainThreadNotebookProxyKernels"),MainThreadNotebookRenderers:(0,g.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,g.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,g.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,g.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,g.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,g.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,g.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,g.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,g.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,g.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,g.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,g.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,g.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,g.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,g.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,g.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,g.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,g.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,g.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,g.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,g.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,g.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,g.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,g.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,g.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,g.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,g.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,g.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,g.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookProxyKernels:(0,g.createProxyIdentifier)("ExtHostNotebookProxyKernels"),ExtHostNotebookRenderers:(0,g.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,g.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,g.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,g.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,g.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,g.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,g.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,g.createProxyIdentifier)("ExtHostTelemetry")}}),define(Se[69],De([1,0,4,5,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(k){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,b){return this._proxy.$getPassword(k,b)}store(k,b,P){return this._proxy.$setPassword(k,b,P)}delete(k,b){return this._proxy.$deletePassword(k,b)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,g.createDecorator)("IExtHostSecretState")}),define(Se[70],De([1,0,3,13,4,16]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(b,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(g.MainContext.MainThreadTelemetry)}report(b,P,R){const v=this.getUsageKey(b,P);this._reportedUsages.has(v)||(this._reportedUsages.add(v),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:b}))}getUsageKey(b,P){return`${b}-${P.identifier.value}`}};I=$e([ze(0,L.IExtHostRpcService),ze(1,D.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(k,b,P){}})}),define(Se[180],De([1,0,5,4,6,26]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,P,R,v={}){const p=L.ExtensionIdentifier.toKey(b.identifier),w=this._inFlightRequests.get(p)||[],f=[...R].sort().join(" ");let u=w.find(h=>h.scopes===f);if(u)return u.result;{const h=this._getSession(b,p,P,R,v);u={scopes:f,result:h},w.push(u),this._inFlightRequests.set(p,w);try{await h}finally{const c=w.findIndex(y=>y.scopes===f);c>-1&&(w.splice(c),this._inFlightRequests.set(p,w))}return h}}async _getSession(b,P,R,v,p={}){await this._proxy.$ensureProvider(R);const w=b.displayName||b.name;return this._proxy.$getSession(R,v,P,w,p)}async removeSession(b,P){const R=this._authenticationProviders.get(b);return R?R.provider.removeSession(P):this._proxy.$removeSession(b,P)}registerAuthenticationProvider(b,P,R,v){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:P,provider:R,options:v??{supportsMultipleAccounts:!1}}),this._providers.find(w=>w.id===b)||this._providers.push({id:b,label:P});const p=R.onDidChangeSessions(w=>{this._proxy.$sendDidChangeSessions(b,{added:w.added??[],changed:w.changed??[],removed:w.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,P,v?.supportsMultipleAccounts??!1),new g.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(b);const w=this._providers.findIndex(f=>f.id===b);w>-1&&this._providers.splice(w),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,P){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,P){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,P){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,P){return this._onDidChangeSessions.fire({provider:{id:b,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Se[181],De([1,0,4,16,8]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(k,b){this._proxy=k.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>b.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k){const b=g.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(b)}};L=$e([ze(0,D.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Se[182],De([1,0,4]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(L){const I=L.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(k){return I.$writeText(k)}})}}e.ExtHostClipboard=D});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[36],De([1,0,10,6,8,27,4,15,13,57,48,234,2,7,3,16,91,25,39,43]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_){"use strict";var l,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(s,m){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,S.set(this,void 0),Qe(this,l,s.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=m,Qe(this,S,s.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new T(this,d=>{const C=this._apiCommands.get(d);return C?.result===o.Void?C:void 0},m),this._argumentProcessors=[{processArgument(d){return(0,P.revive)(d)}},{processArgument(d){return(0,L.cloneAndChange)(d,function(C){if(R.Range.isIRange(C))return g.Range.to(C);if(v.Position.isIPosition(C))return g.Position.to(C);if(R.Range.isIRange(C.range)&&p.URI.isUri(C.uri))return g.location.to(C);if(C instanceof c.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const m=this.registerCommand(!1,s.id,async(...d)=>{const C=s.args.map((U,A)=>{if(!U.validate(d[A]))throw new Error(`Invalid argument '${U.name}' when running '${s.id}', received: ${d[A]}`);return U.convert(d[A])}),O=await this.executeCommand(s.internalId,...C);return s.result.convert(O,d,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new D.Disposable(()=>{m.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,m,d,C,O,U){if(this._logService.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this._commands.has(m))throw new Error(`command '${m}' already exists`);return this._commands.set(m,{callback:d,thisArg:C,description:O,extension:U}),s&&Re(this,l,"f").$registerCommand(m),new D.Disposable(()=>{this._commands.delete(m)&&s&&Re(this,l,"f").$unregisterCommand(m)})}executeCommand(s,...m){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,m,!0)}async _doExecuteCommand(s,m,d){if(this._commands.has(s))return this._executeContributedCommand(s,m,!1);{let C=!1;const O=(0,L.cloneAndChange)(m,function(U){if(U instanceof D.Position)return g.Position.from(U);if(U instanceof D.Range)return g.Range.from(U);if(U instanceof D.Location)return g.location.from(U);if(D.NotebookRange.isNotebookRange(U))return g.NotebookRange.from(U);if(U instanceof ArrayBuffer)return C=!0,c.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return C=!0,c.VSBuffer.wrap(U);if(U instanceof c.VSBuffer)return C=!0,U;if(!Array.isArray(U))return U});try{const U=await Re(this,l,"f").$executeCommand(s,C?new y.SerializableObjectWithBuffers(O):O,d);return(0,P.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(s,m,!1);throw U}}}async _executeContributedCommand(s,m,d){const C=this._commands.get(s);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,s);let{callback:O,thisArg:U,description:A}=C;if(A)for(let E=0;E<A.args.length;E++)try{(0,a.validateConstraint)(m[E],A.args[E].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${A.args[E].name}' - ${A.args[E].description}`)}try{return await O.apply(U,m)}catch(E){if(s===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...m);$&&(s=$.command)}throw this._logService.error(E,s,C.extension?.identifier),d?new class extends Error{constructor(){super((0,_.toErrorMessage)(E));this.id=s,this.source=C.extension?.displayName??C.extension?.name}}:E}}_reportTelemetry(s,m){!s.extension||s.extension.isBuiltin||Re(this,S,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:m})}$executeContributedCommand(s,...m){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(m=m.map(d=>this._argumentProcessors.reduce((C,O)=>O.processArgument(C),d)),this._executeContributedCommand(s,m,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Re(this,l,"f").$getCommands().then(m=>(s&&(m=m.filter(d=>d[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[m,d]of this._commands){let{description:C}=d;C&&(s[m]=C)}return Promise.resolve(s)}};l=new WeakMap,S=new WeakMap,n=$e([ze(0,u.IExtHostRpcService),ze(1,b.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class T{constructor(s,m,d){this._commands=s,this._lookupApiCommand=m,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,m){if(!s)return;const d={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return d;const C=this._lookupApiCommand(s.command);if(C)d.id=C.internalId,d.arguments=C.args.map((O,U)=>O.convert(s.arguments&&s.arguments[U]));else if((0,k.isNonEmptyArray)(s.arguments)){const O=++this._cachIdPool;this._cache.set(O,s),m.add((0,w.toDisposable)(()=>{this._cache.delete(O),this._logService.trace("CommandsConverter#DISPOSE",O)})),d.$ident=O,d.id=this.delegatingCommandId,d.arguments=[O],this._logService.trace("CommandsConverter#CREATE",s.command,O)}return d}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const m=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],m?m.command:"MISSING"),m?this._commands.executeCommand(m.command,...m.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=T;class i{constructor(s,m,d,C){this.name=s,this.description=m,this.validate=d,this.convert=C}optional(){return new i(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,m){return new i(s??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",t=>p.URI.isUri(t),t=>t),i.Position=new i("position","A position in a text document",t=>D.Position.isPosition(t),g.Position.from),i.Range=new i("range","A range in a text document",t=>D.Range.isRange(t),g.Range.from),i.Selection=new i("selection","A selection in a text document",t=>D.Selection.isSelection(t),g.Selection.from),i.Number=new i("number","",t=>typeof t=="number",t=>t),i.String=new i("string","",t=>typeof t=="string",t=>t),i.CallHierarchyItem=new i("item","A call hierarchy item",t=>t instanceof D.CallHierarchyItem,g.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",t=>t instanceof D.TypeHierarchyItem,g.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",t=>t instanceof h.TestItemImpl,g.TestItem.from);class o{constructor(s,m){this.description=s,this.convert=m}}e.ApiCommandResult=o,o.Void=new o("no result",t=>t);class r{constructor(s,m,d,C,O){this.id=s,this.internalId=m,this.description=d,this.args=C,this.result=O}}e.ApiCommand=r}),define(Se[183],De([1,0,2,8,6,68,36,15,77,80,11]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",w(D.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,h)=>{if((0,k.isFalsyOrEmpty)(u))return;class c extends g.SymbolInformation{static to(_){const l=new c(_.name,D.SymbolKind.to(_.kind),_.containerName||"",new g.Location(h[0],D.Range.to(_.range)));return l.detail=_.detail,l.range=l.location.range,l.selectionRange=D.Range.to(_.selectionRange),l.children=_.children?_.children.map(c.to):[],l}}return u.map(c.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(D.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(D.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(h=>g.Position.isPosition(h)),u=>u.map(D.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(h=>{let c;for(const y of h.reverse())c=new g.SelectionRange(D.Range.to(y),c);return c}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(D.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(D.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(D.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(D.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:D.Range.to(u.range),placeholder:u.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return D.WorkspaceEdit.to(u)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(D.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new g.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const h=(0,b.decodeSemanticTokensDto)(u);if(h.type==="full")return new g.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new g.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const h=(0,b.decodeSemanticTokensDto)(u);if(h.type==="full")return new g.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,h,c)=>{if(!u)return new g.CompletionList([]);const y=u.suggestions.map(_=>D.CompletionItem.to(_,c));return new g.CompletionList(y,u.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return D.SignatureHelp.to(u)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,h,c)=>w(y=>new g.CodeLens(D.Range.to(y.range),y.command&&c.fromInternal(y.command)))(u))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>g.Range.isRange(u),u=>g.Selection.isSelection(u)?D.Selection.from(u):D.Range.from(u)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,h,c)=>w(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(y.command)}else{const _=new g.CodeAction(y.title,y.kind?new g.CodeActionKind(y.kind):void 0);return y.edit&&(_.edit=D.WorkspaceEdit.to(y.edit)),y.command&&(_.command=c.fromInternal(y.command)),_.isPreferred=y.isPreferred,_}})(u))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(h=>new g.ColorInformation(D.Range.to(h.range),D.Color.to(h.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",u=>u instanceof g.Color,D.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:D.Range.from(u.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(D.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,h,c)=>u.map(D.InlayHint.to.bind(void 0,c)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(h=>D.NotebookExclusiveDocumentPattern.to(h))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(D.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>a.URI.isUri(u)||typeof u=="string"&&(0,P.matchesSomeScheme)(u,R.Schemas.http,R.Schemas.https),u=>u),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[D.ViewColumn.from(u),void 0]:[D.ViewColumn.from(u.viewColumn),D.TextEditorOpenOptions.from(u)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[D.ViewColumn.from(u),void 0]:[D.ViewColumn.from(u.viewColumn),D.TextEditorOpenOptions.from(u)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[D.ViewColumn.from(u.viewColumn),D.TextEditorOpenOptions.from(u)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(D.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(D.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(D.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class p{static register(h){v.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=p;function w(u){return h=>{if(Array.isArray(h))return h.map(u)}}function f(u){if(!Array.isArray(u))return;const h=[];for(const c of u)L.isLocationLink(c)?h.push(D.DefinitionLink.to(c)):h.push(D.location.to(c));return h}}),define(Se[184],De([1,0,14,55,5,7,2,68,26,8,6,21,4]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function w(f,u,h){const c=f.getProxy(p.MainContext.MainThreadComments);class y{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const s=this._commentControllers.get(t.handle);return s?s.value:t}else if(t&&t.$mid===7){const s=this._commentControllers.get(t.commentControlHandle);if(!s)return t;const m=s.getCommentThread(t.commentThreadHandle);return m?m.value:t}else if(t&&t.$mid===8){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const m=s.getCommentThread(t.thread.commentThreadHandle);return m?{thread:m.value,text:t.text}:t}else if(t&&t.$mid===9){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const m=s.getCommentThread(t.thread.commentThreadHandle);if(!m)return t;let d=t.commentUniqueId,C=m.getCommentByUniqueId(d);return C||t}else if(t&&t.$mid===10){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const m=s.getCommentThread(t.thread.commentThreadHandle);if(!m)return t;let d=t.text,C=t.commentUniqueId,O=m.getCommentByUniqueId(C);return O?(O.body=d,O):t}return t}})}createCommentController(t,s,m){const d=y.handlePool++,C=new l(t,d,s,m);this._commentControllers.set(C.handle,C);const O=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return O.push(C),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),O),C.value}$createCommentThreadTemplate(t,s,m){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(s,m)}async $updateCommentThreadTemplate(t,s,m){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(s,m)}$deleteCommentThread(t,s){const m=this._commentControllers.get(t);m&&m.$deleteCommentThread(s)}$provideCommentingRanges(t,s,m){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const C=h.getDocument(I.URI.revive(s));return(0,a.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(C,m)).then(O=>O?O.map(U=>P.Range.from(U)):void 0)}$toggleReaction(t,s,m,d,C){const O=this._commentControllers.get(t);return!O||!O.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const U=O.getCommentThread(s);if(U){const A=U.getCommentByUniqueId(d.uniqueIdInThread);if(O!==void 0&&A&&O.reactionHandler)return O.reactionHandler(A,T(C))}return Promise.resolve(void 0)})}dispose(){}}y.handlePool=0;class _{constructor(t,s,m,d,C,O,U){this._commentControllerHandle=s,this._id=m,this._uri=d,this._range=C,this._comments=O,this.extensionDescription=U,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new g.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),c.$createCommentThread(s,this.handle,this._id,this._uri,P.Range.from(this._range),U.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=O,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(s,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(E){A.range=E},get comments(){return A.comments},set comments(E){A.comments=E},get collapsibleState(){return A.collapsibleState},set collapsibleState(E){A.collapsibleState=E},get canReply(){return A.canReply},set canReply(E){A.canReply=E},get contextValue(){return A.contextValue},set contextValue(E){A.contextValue=E},get label(){return A.label},set label(E){A.label=E},get state(){return A.state},set state(E){A.state=E},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,v.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,v.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const t=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),s={};t("range")&&(s.range=P.Range.from(this._range)),t("label")&&(s.label=this.label),t("contextValue")&&(s.contextValue=this.contextValue??null),t("comments")&&(s.comments=this._comments.map(m=>S(this,m,this._commentsMap))),t("collapsibleState")&&(s.collapseState=i(this._collapseState)),t("canReply")&&(s.canReply=this.canReply),t("state")&&(s.state=o(this._state)),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(t){for(let s of this._commentsMap){let m=s[0],d=s[1];if(t===d)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}_._handlePool=0,$e([(0,D.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,s,m,d){this._extension=t,this._handle=s,this._id=m,this._label=d,this._threads=new Map,c.$registerCommentController(this.handle,m,d);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(O){C.options=O},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(O){C.commentingRangeProvider=O},get reactionHandler(){return C.reactionHandler},set reactionHandler(O){C.reactionHandler=O},createCommentThread(O,U,A){return C.createCommentThread(O,U,A).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,s,m,d){if(typeof t=="string"){const C=new _(this.id,this.handle,t,s,m,d,this._extension);return this._threads.set(C.handle,C),C}else{const C=new _(this.id,this.handle,void 0,t,s,m,this._extension);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(t,s){const m=new _(this.id,this.handle,void 0,I.URI.revive(t),P.Range.to(s),[],this._extension);return m.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(t,s){let m=this._threads.get(t);m&&(m.range=P.Range.to(s))}$deleteCommentThread(t){let s=this._threads.get(t);s&&s.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function S(r,t,s){let m=s.get(t);m||(m=++r.commentHandle,s.set(t,m));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:m,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(C=>n(C)):void 0,timestamp:t.timestamp?.toJSON()}}function n(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function T(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?I.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function i(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function o(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new y}e.createExtHostComments=w}),define(Se[94],De([1,0,2,4,6,3,16,13,15,9,17]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Ii{constructor(w,f){this._logService=f,this._provider=new Map,this._proxy=w.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,f){const u=Ii._handlePool++;this._provider.set(u,{provider:w,extensionId:f}),this._proxy.$registerDecorationProvider(u,f.value);const h=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(u,null);return}let y=(0,b.asArray)(c);if(y.length<=Ii._maxEventSize){this._proxy.$onDidChange(u,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,y.length);const _=y.map(n=>({uri:n,rank:(0,P.count)(n.path,"/")})),l=(0,b.groupBy)(_,(n,T)=>n.rank-T.rank||(0,P.compare)(n.uri.path,T.uri.path));let S=[];e:for(let n of l){let T;for(let i of n){let o=(0,R.dirname)(i.uri.path);if(T!==o&&(T=o,S.push(i.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(u,S)});return new g.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(w,f,u){if(!this._provider.has(w))return Object.create(null);const h=Object.create(null),{provider:c,extensionId:y}=this._provider.get(w);return await Promise.all(f.map(async _=>{try{const{uri:l,id:S}=_,n=await Promise.resolve(c.provideFileDecoration(a.URI.revive(l),u));if(!n)return;try{g.FileDecoration.validate(n),h[S]=[n.propagate,n.tooltip,n.badge,n.color]}catch(T){this._logService.warn(`INVALID decoration from extension '${y.value}': ${T}`)}}catch(l){this._logService.error(l)}})),h}};v._handlePool=0,v._maxEventSize=250,v=$e([ze(0,I.IExtHostRpcService),ze(1,k.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[185],De([1,0,128,79,2,4,6,8,5,13,22,35]),function(ee,e,a,D,g,L,I,k,b,P,R,v){"use strict";var p,w,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(y,_,l,S,n,T){this._name=y,this._owner=_,this._maxDiagnosticsPerFile=l,p.set(this,void 0),w.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Qe(this,f,new R.ResourceMap(i=>S.getComparisonKey(i)),"f"),Qe(this,p,n,"f"),Qe(this,w,T,"f")}dispose(){this._isDisposed||(Re(this,w,"f").fire([...Re(this,f,"f").keys()]),Re(this,p,"f")&&Re(this,p,"f").$clear(this._owner),Re(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,_){if(!y){this.clear();return}this._checkDisposed();let l=[];if(g.URI.isUri(y)){if(!_){this.delete(y);return}Re(this,f,"f").set(y,_.slice()),l=[y]}else if(Array.isArray(y)){l=[];let n;y=[...y].sort(u._compareIndexedTuplesByUri);for(const T of y){const[i,o]=T;if((!n||i.toString()!==n.toString())&&(n&&Re(this,f,"f").get(n).length===0&&Re(this,f,"f").delete(n),n=i,l.push(i),Re(this,f,"f").set(i,[])),o){const r=Re(this,f,"f").get(i);r&&r.push(...o)}else{const r=Re(this,f,"f").get(i);r&&(r.length=0)}}}if(Re(this,w,"f").fire(l),!Re(this,p,"f"))return;const S=[];for(let n of l){let T=[];const i=Re(this,f,"f").get(n);if(i)if(i.length>this._maxDiagnosticsPerFile){T=[];const o=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let t of i)if(t.severity===o[r]&&T.push(k.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;T.push({severity:D.MarkerSeverity.Info,message:(0,a.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:T[T.length-1].startLineNumber,startColumn:T[T.length-1].startColumn,endLineNumber:T[T.length-1].endLineNumber,endColumn:T[T.length-1].endColumn})}else T=i.map(o=>k.Diagnostic.from(o));S.push([n,T])}Re(this,p,"f").$changeMany(this._owner,S)}delete(y){this._checkDisposed(),Re(this,w,"f").fire([y]),Re(this,f,"f").delete(y),Re(this,p,"f")&&Re(this,p,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),Re(this,w,"f").fire([...Re(this,f,"f").keys()]),Re(this,f,"f").clear(),Re(this,p,"f")&&Re(this,p,"f").$clear(this._owner)}forEach(y,_){this._checkDisposed();for(let l of Re(this,f,"f").keys())y.apply(_,[l,this.get(l),this])}get(y){this._checkDisposed();const _=Re(this,f,"f").get(y);return Array.isArray(_)?Object.freeze(_.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(Re(this,f,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,_){return y[0].toString()<_[0].toString()?-1:y[0].toString()>_[0].toString()?1:0}}e.DiagnosticCollection=u,p=new WeakMap,w=new WeakMap,f=new WeakMap;let h=class li{constructor(y,_,l){this._logService=_,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=y.getProxy(L.MainContext.MainThreadDiagnostics)}static _mapper(y){const _=new R.ResourceMap;for(const l of y)_.set(l,l);return{uris:Object.freeze(Array.from(_.values()))}}createDiagnosticCollection(y,_){const{_collections:l,_proxy:S,_onDidChangeDiagnostics:n,_logService:T,_fileSystemInfoService:i}=this,o=new class{$changeMany(s,m){S.$changeMany(s,m),T.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,s,m.length===0?"CLEARING":m)}$clear(s){S.$clear(s),T.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,s)}dispose(){S.dispose()}};let r;if(!_)_="_generated_diagnostic_collection_name_#"+li._idPool++,r=_;else if(!l.has(_))r=_;else{this._logService.warn(`DiagnosticCollection with name '${_}' does already exist.`);do r=_+li._idPool++;while(l.has(r))}return new class extends u{constructor(){super(_,r,li._maxDiagnosticsPerFile,i.extUri,o,n);l.set(r,this)}dispose(){super.dispose(),l.delete(r)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const _=new Map,l=[];for(const S of this._collections.values())S.forEach((n,T)=>{let i=_.get(n.toString());typeof i=="undefined"&&(i=l.length,_.set(n.toString(),i),l.push([n,[]])),l[i][1]=l[i][1].concat(...T)});return l}}_getDiagnostics(y){let _=[];for(let l of this._collections.values())l.has(y)&&(_=_.concat(l.get(y)));return _}$acceptMarkersChange(y){if(!this._mirrorCollection){const _="_generated_mirror",l=new u(_,_,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(_,l),this._mirrorCollection=l}for(const[_,l]of y)this._mirrorCollection.set(g.URI.revive(_),l.map(k.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=$e([ze(1,P.ILogService),ze(2,v.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(Se[186],De([1,0,2,4]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class g{constructor(I){this._proxy=I.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(k=>k?k.map(b=>a.URI.revive(b)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(k=>k?a.URI.revive(k):void 0)}}e.ExtHostDialogs=g}),define(Se[187],De([1,0,12,2,6,4,11,20,9]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(v,p,w){this._documentsAndEditors=p,this._logService=w,this._documentContentProviders=new Map,this._proxy=v.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,p){if(Object.keys(I.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const w=P._handlePool++;this._documentContentProviders.set(w,p),this._proxy.$registerTextContentProvider(w,v);let f;return typeof p.onDidChange=="function"&&(f=p.onDidChange(u=>{if(u.scheme!==v){this._logService.warn(`Provider for scheme '${v}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(w,u).then(h=>{if(!h&&typeof h!="string")return;const c=this._documentsAndEditors.getDocument(u);if(!c)return;const y=(0,b.splitLines)(h);if(!c.equalLines(y))return this._proxy.$onVirtualDocumentChange(u,h)},a.onUnexpectedError)})),new g.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(v,p){const w=this._documentContentProviders.get(v);return w?Promise.resolve(w.provideTextDocumentContent(D.URI.revive(p),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Se[188],De([1,0,5,7,2,4,85,8,10,27,6]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class v{constructor(w,f){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const h of u)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const h of u)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!w)return;const f=this._documentsAndEditors.getDocument(w);if(f)return f}getDocument(w){const f=this.getDocumentData(w);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this._documentsAndEditors.getDocument(w);if(f)return Promise.resolve(f);let u=this._documentLoader.get(w.toString());return u||(u=this._proxy.$tryOpenDocument(w).then(h=>{this._documentLoader.delete(w.toString());const c=g.URI.revive(h);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(c))},h=>(this._documentLoader.delete(w.toString()),Promise.reject(h))),this._documentLoader.set(w.toString(),u)),u}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(f=>g.URI.revive(f))}$acceptModelLanguageChanged(w,f){const u=g.URI.revive(w),h=this._documentsAndEditors.getDocument(u);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(w){const f=g.URI.revive(w),u=this._documentsAndEditors.getDocument(f);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(w,f){const u=g.URI.revive(w),h=this._documentsAndEditors.getDocument(u);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,f,u){const h=g.URI.revive(w),c=this._documentsAndEditors.getDocument(h);if(!c)throw new Error("unknown document");c._acceptIsDirty(u),c.onEvents(f);let y;f.isUndoing?y=R.TextDocumentChangeReason.Undo:f.isRedoing&&(y=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:c.document,contentChanges:f.changes.map(_=>({range:k.Range.to(_.range),rangeOffset:_.rangeOffset,rangeLength:_.rangeLength,text:_.text})),reason:y}))}setWordDefinitionFor(w,f){(0,I.setWordDefinitionFor)(w,f)}}e.ExtHostDocuments=v}),define(Se[49],De([1,0,41,5,7,2,3,4,85,16,92,8,13,22,11,166,189]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class c{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(l,S){this._extHostRpc=l,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const S=[],n=[],T=[];if(l.removedDocuments)for(const i of l.removedDocuments){const o=L.URI.revive(i),r=this._documents.get(o);r?.unref()&&(this._documents.delete(o),S.push(r.value))}if(l.addedDocuments)for(const i of l.addedDocuments){const o=L.URI.revive(i.uri);let r=this._documents.get(o);if(r&&o.scheme!==f.Schemas.vscodeNotebookCell&&o.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);r||(r=new c(new b.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(o,r),n.push(r.value)),r.ref()}if(l.removedEditors)for(const i of l.removedEditors){const o=this._editors.get(i);this._editors.delete(i),o&&T.push(o)}if(l.addedEditors)for(const i of l.addedEditors){const o=L.URI.revive(i.documentUri);a.ok(this._documents.has(o),`document '${o}' does not exist`),a.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const r=this._documents.get(o).value,t=new R.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>r.document),i.selections.map(v.Selection.to),i.options,i.visibleRanges.map(s=>v.Range.to(s)),typeof i.editorPosition=="number"?v.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,t)}l.newActiveEditor!==void 0&&(a.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,g.dispose)(S),(0,g.dispose)(T),l.removedDocuments&&this._onDidRemoveDocuments.fire(S),l.addedDocuments&&this._onDidAddDocuments.fire(n),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return l?S:S?.value}allEditors(){return[...this._editors.values()]}};y=$e([ze(0,P.IExtHostRpcService),ze(1,p.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[50],De([1,0,8,4,2,5,3,6,16,10,54]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class v{constructor(h,c,y){this._activeTabIdGetter=y,this._parentGroup=c,this.acceptDtoUpdate(h)}get apiObject(){if(!this._apiObject){const h=this,c={get isActive(){return h._dto.id===h._activeTabIdGetter()},get label(){return h._dto.label},get input(){return h._input},get isDirty(){return h._dto.isDirty},get isPinned(){return h._dto.isPinned},get isPreview(){return h._dto.isPreview},get group(){return h._parentGroup.apiObject}};this._apiObject=Object.freeze(c)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(h){this._dto=h,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new k.TextTabInput(g.URI.revive(this._dto.input.uri));case 2:return new k.TextDiffTabInput(g.URI.revive(this._dto.input.original),g.URI.revive(this._dto.input.modified));case 5:return new k.CustomEditorTabInput(g.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new k.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new k.NotebookEditorTabInput(g.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new k.NotebookDiffEditorTabInput(g.URI.revive(this._dto.input.original),g.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new k.TerminalEditorTabInput;default:return}}}class p{constructor(h,c,y){this._tabs=[],this._activeTabId="",this._dto=h,this._activeGroupIdGetter=y;for(const _ of h.tabs)_.isActive&&(this._activeTabId=_.id),this._tabs.push(new v(_,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const h=this,c={get isActive(){return h._dto.groupId===h._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(h._dto.viewColumn)},get activeTab(){return h._tabs.find(y=>y.tabId===h._activeTabId)?.apiObject},get tabs(){return Object.freeze(h._tabs.map(y=>y.apiObject))}};this._apiObject=Object.freeze(c)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(h){this._dto=h}acceptTabOperation(h){if(h.kind===0){const y=new v(h.tabDto,this,()=>this.activeTabId());return this._tabs.splice(h.index,0,y),h.tabDto.isActive&&(this._activeTabId=y.tabId),y}else if(h.kind===1){const y=this._tabs.splice(h.index,1)[0];if(!y)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return y.tabId===this._activeTabId&&(this._activeTabId=""),y}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const y=this._tabs.splice(h.oldIndex,1)[0];if(!y)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this._tabs.splice(h.index,0,y),y}const c=this._tabs.find(y=>y.tabId===h.tabDto.id);if(!c)throw new Error("INVALID tab");return h.tabDto.isActive?this._activeTabId=h.tabDto.id:this._activeTabId===h.tabDto.id&&!h.tabDto.isActive&&(this._activeTabId=""),c.acceptDtoUpdate(h.tabDto),c}activeTabId(){return this._activeTabId}}let w=class{constructor(h){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=h.getProxy(D.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const h=this,c={onDidChangeTabGroups:h._onDidChangeTabGroups.event,onDidChangeTabs:h._onDidChangeTabs.event,get all(){return Object.freeze(h._extHostTabGroups.map(y=>y.apiObject))},get activeTabGroup(){const y=h._activeGroupId;return(0,P.assertIsDefined)(h._extHostTabGroups.find(l=>l.groupId===y)?.apiObject)},close:async(y,_)=>{const l=Array.isArray(y)?y:[y];return l.length?f(l[0])?this._closeGroups(l,_):this._closeTabs(l,_):!0}};this._apiObject=Object.freeze(c)}return this._apiObject}$acceptEditorTabModel(h){const c=new Set(this._extHostTabGroups.map(i=>i.groupId)),y=new Set(h.map(i=>i.groupId)),_=(0,R.diffSets)(c,y),l=this._extHostTabGroups.filter(i=>_.removed.includes(i.groupId)).map(i=>i.apiObject),S=[],n=[];this._extHostTabGroups=h.map(i=>{const o=new p(i,this._proxy,()=>this._activeGroupId);return _.added.includes(o.groupId)?S.push(o.apiObject):n.push(o.apiObject),o});const T=(0,P.assertIsDefined)(h.find(i=>i.isActive===!0)?.groupId);T!==void 0&&this._activeGroupId!==T&&(this._activeGroupId=T),this._onDidChangeTabGroups.fire(Object.freeze({opened:S,closed:l,changed:n}))}$acceptTabGroupUpdate(h){const c=this._extHostTabGroups.find(y=>y.groupId===h.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(h),h.isActive&&(this._activeGroupId=h.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const c=this._extHostTabGroups.find(_=>_.groupId===h.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const y=c.acceptTabOperation(h);switch(h.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[y.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[y.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[y.apiObject]}));return}}_findExtHostTabFromApi(h){for(const c of this._extHostTabGroups)for(const y of c.tabs)if(y.apiObject===h)return y}_findExtHostTabGroupFromApi(h){return this._extHostTabGroups.find(c=>c.apiObject===h)}async _closeTabs(h,c){const y=[];for(const _ of h){const l=this._findExtHostTabFromApi(_);if(!l)throw new Error("Tab close: Invalid tab not found!");y.push(l.tabId)}return this._proxy.$closeTab(y,c)}async _closeGroups(h,c){const y=[];for(const _ of h){const l=this._findExtHostTabGroupFromApi(_);if(!l)throw new Error("Group close: Invalid group not found!");y.push(l.groupId)}return this._proxy.$closeGroup(y,c)}};w=$e([ze(0,b.IExtHostRpcService)],w),e.ExtHostEditorTabs=w;function f(u){return u.tabs!==void 0}}),define(Se[190],De([1,0,2,4,7,6,8,235,9,25,21]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let h,c,y=14,_=14;for(const l of f){let S=h?(0,b.commonPrefixLength)(h,l):0;for(S===0?c=1:c=_;S<l.length;S++)S+1===l.length?(y=_,_=9):_+=1,u.push([c,l.toUpperCase().charCodeAt(S),_]),u.push([c,l.toLowerCase().charCodeAt(S),_]),c=_;h=l,_=y}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new k.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],h=k.LinkComputer.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const c of h){const y=I.DocumentLink.to(c);y.target&&u.push(y)}return u}}class p{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,u,h,c={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const y=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(y,h);let _=2;c.isCaseSensitive&&(_+=1024),c.isReadonly&&(_+=2048),typeof h.copy=="function"&&(_+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,R.checkProposedApiEnabled)(f,"fsChunks"),_+=4),this._proxy.$registerFileSystemProvider(y,u,_).catch(S=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${u}`),console.error(S)});const l=h.onDidChangeFile(S=>{const n=[];for(const T of S){let{uri:i,type:o}=T;if(i.scheme!==u)continue;let r;switch(o){case L.FileChangeType.Changed:r=0;break;case L.FileChangeType.Created:r=1;break;case L.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:i,type:r})}this._proxy.$onFileSystemChange(y,n)});return(0,g.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(f){const{type:u,ctime:h,mtime:c,size:y,permissions:_}=f;return{type:u,ctime:h,mtime:c,size:y,permissions:_}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(a.URI.revive(u))).then(h=>p._asIStat(h))}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(a.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(a.URI.revive(u))).then(h=>P.VSBuffer.wrap(h))}$writeFile(f,u,h,c){return Promise.resolve(this._getFsProvider(f).writeFile(a.URI.revive(u),h.buffer,c))}$delete(f,u,h){return Promise.resolve(this._getFsProvider(f).delete(a.URI.revive(u),h))}$rename(f,u,h,c){return Promise.resolve(this._getFsProvider(f).rename(a.URI.revive(u),a.URI.revive(h),c))}$copy(f,u,h,c){const y=this._getFsProvider(f);if(!y.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(y.copy(a.URI.revive(u),a.URI.revive(h),c))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(a.URI.revive(u)))}$watch(f,u,h,c){const y=this._getFsProvider(f).watch(a.URI.revive(h),c);this._watches.set(u,y)}$unwatch(f,u){const h=this._watches.get(u);h&&(h.dispose(),this._watches.delete(u))}$open(f,u,h){const c=this._getFsProvider(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(a.URI.revive(u),h))}$close(f,u){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(u))}$read(f,u,h,c){const y=this._getFsProvider(f);if(!y.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(c);return Promise.resolve(y.read(u,h,_.buffer,0,c)).then(l=>_.slice(0,l))}$write(f,u,h,c){const y=this._getFsProvider(f);if(!y.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(y.write(u,h,c.buffer,0,c.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return u}}e.ExtHostFileSystem=p}),define(Se[51],De([1,0,4,38,6,25,3,16,35,7]),function(ee,e,a,D,g,L,I,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Kt{constructor(p,w){this._fileSystemProvider=new Map,this._proxy=p.getProxy(a.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(u){try{const h=f._fileSystemProvider.get(u.scheme);if(!h)return await f._proxy.$stat(u);await f._proxy.$ensureActivation(u.scheme);const c=await h.stat(u);return{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions}}catch(h){Kt._handleError(h)}},async readDirectory(u){try{const h=f._fileSystemProvider.get(u.scheme);return h?(await f._proxy.$ensureActivation(u.scheme),(await h.readDirectory(u)).slice()):await f._proxy.$readdir(u)}catch(h){return Kt._handleError(h)}},async createDirectory(u){try{return await f._proxy.$mkdir(u)}catch(h){return Kt._handleError(h)}},async readFile(u){try{const h=f._fileSystemProvider.get(u.scheme);return h?(await f._proxy.$ensureActivation(u.scheme),(await h.readFile(u)).slice()):(await f._proxy.$readFile(u)).buffer}catch(h){return Kt._handleError(h)}},async writeFile(u,h){try{return await f._proxy.$writeFile(u,L.VSBuffer.wrap(h))}catch(c){return Kt._handleError(c)}},async delete(u,h){try{const c=f._fileSystemProvider.get(u.scheme);return c?(await f._proxy.$ensureActivation(u.scheme),await c.delete(u,{recursive:!1,...h})):await f._proxy.$delete(u,{recursive:!1,useTrash:!1,...h})}catch(c){return Kt._handleError(c)}},async rename(u,h,c){try{return await f._proxy.$rename(u,h,{overwrite:!1,...c})}catch(y){return Kt._handleError(y)}},async copy(u,h,c){try{return await f._proxy.$copy(u,h,{overwrite:!1,...c})}catch(y){return Kt._handleError(y)}},isWritableFileSystem(u){const h=w.getCapabilities(u);if(typeof h=="number")return!(h&2048)}})}static _handleError(p){if(p instanceof g.FileSystemError)throw p;if(!(p instanceof Error))throw new g.FileSystemError(String(p));if(p.name==="ENOPRO")throw g.FileSystemError.Unavailable(p.message);switch(p.name){case D.FileSystemProviderErrorCode.FileExists:throw g.FileSystemError.FileExists(p.message);case D.FileSystemProviderErrorCode.FileNotFound:throw g.FileSystemError.FileNotFound(p.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw g.FileSystemError.FileNotADirectory(p.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw g.FileSystemError.FileIsADirectory(p.message);case D.FileSystemProviderErrorCode.NoPermissions:throw g.FileSystemError.NoPermissions(p.message);case D.FileSystemProviderErrorCode.Unavailable:throw g.FileSystemError.Unavailable(p.message);default:throw new g.FileSystemError(p.message,p.name)}}addFileSystemProvider(p,w){return this._fileSystemProvider.set(p,w),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(p))}};R=$e([ze(0,k.IExtHostRpcService),ze(1,b.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[191],De([1,0,5,33,2,4,8,6]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{constructor(v,p,w,f,u,h,c,y){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const _=this.ensureWatching(v,w,u);this._config=0,h&&(this._config+=1),c&&(this._config+=2),y&&(this._config+=4);const l=(0,D.parse)(u),S=typeof u=="string",n=f(T=>{if(!h)for(let i of T.created){const o=g.URI.revive(i);l(o.fsPath)&&(!S||p.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!c)for(let i of T.changed){const o=g.URI.revive(i);l(o.fsPath)&&(!S||p.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!y)for(let i of T.deleted){const o=g.URI.revive(i);l(o.fsPath)&&(!S||p.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}});this._disposable=k.Disposable.from(_,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(v,p,w){let f=k.Disposable.from();if(typeof w=="string")return f;const u=v.getProxy(L.MainContext.MainThreadFileSystem);let h=!1;(w.pattern.includes(D.GLOBSTAR)||w.pattern.includes(D.GLOB_SPLIT))&&(h=!0);const c=Math.random();return u.$watch(p.identifier.value,c,w.baseUri,{recursive:h,excludes:[]}),k.Disposable.from({dispose:()=>u.$unwatch(c)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(v,p,w){this._mainContext=v,this._logService=p,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,p,w,f,u,h){return new b(this._mainContext,v,p,this._onFileSystemEvent.event,I.GlobPattern.from(w),f,u,h)}$onFileEvent(v){this._onFileSystemEvent.fire(v)}$onDidRunFileOperation(v,p){switch(v){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(w=>({oldUri:g.URI.revive(w.source),newUri:g.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(w=>g.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(w=>g.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,p){return(w,f,u)=>{const h=function(y){w.call(f,y)};return h.extension=v,p.event(h,void 0,u)}}async $onWillRunFileOperation(v,p,w,f){switch(v){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(u=>({oldUri:g.URI.revive(u.source),newUri:g.URI.revive(u.target)}))},w,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(u=>g.URI.revive(u.target))},w,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(u=>g.URI.revive(u.target))},w,f)}}async _fireWillEvent(v,p,w,f){const u=new Set,h=[];if(await v.fireAsync(p,f,async(y,_)=>{const l=Date.now(),S=await Promise.resolve(y);S instanceof k.WorkspaceEdit&&(h.push(S),u.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-l>w&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),f.isCancellationRequested||h.length===0)return;const c={edits:[]};for(let y of h){let{edits:_}=I.WorkspaceEdit.from(y,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(_)}return{edit:c,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=P}),define(Se[192],De([1,0,2,36]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class g{constructor(I,k,b,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=b,this._commands=P;const R=new D.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new D.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new D.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new D.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new D.ApiCommandResult("Notebook and input URI",v=>{if(v.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(v.notebookEditorId);return{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri),notebookEditor:p.apiEditor}}return{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(I,k,b,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:b,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=g}),define(Se[193],De([1,0,7,4]),function(ee,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class g{constructor(I){this._handlePool=0,this._proxy=I.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,I),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=g}),define(Se[194],De([1,0,2,27,8,6,68,4,9,48,15,10,236,20,7,77,56,63,195,12,5,14,21,86]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l,S,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class i{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentSymbols(F,W){const V=this._documents.getDocument(F),K=await this._provider.provideDocumentSymbols(V,W);if(!(0,R.isFalsyOrEmpty)(K))return K[0]instanceof L.DocumentSymbol?K.map(g.DocumentSymbol.from):i._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((K,z)=>{let Y=K.location.range.start.compareTo(z.location.range.start);return Y===0&&(Y=z.location.range.end.compareTo(K.location.range.end)),Y});const W=[],V=[];for(const K of F){const z={name:K.name||"!!MISSING: name!!",kind:g.SymbolKind.from(K.kind),tags:K.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:g.Range.from(K.location.range),selectionRange:g.Range.from(K.location.range),children:[]};for(;;){if(V.length===0){V.push(z),W.push(z);break}const Y=V[V.length-1];if(P.Range.containsRange(Y.range,z.range)&&!P.Range.equalsRange(Y.range,z.range)){Y.children&&Y.children.push(z),V.push(z);break}V.pop()}}return W}}class o{constructor(F,W,V){this._documents=F,this._commands=W,this._provider=V,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,W){const V=this._documents.getDocument(F),K=await this._provider.provideCodeLenses(V,W);if(!K||W.isCancellationRequested)return;const z=this._cache.add(K),Y=new f.DisposableStore;this._disposables.set(z,Y);const ie={cacheId:z,lenses:[]};for(let Fe=0;Fe<K.length;Fe++)ie.lenses.push({cacheId:[z,Fe],range:g.Range.from(K[Fe].range),command:this._commands.toInternal(K[Fe].command,Y)});return ie}async resolveCodeLens(F,W){const V=F.cacheId&&this._cache.get(...F.cacheId);if(!V)return;let K;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?K=V:K=await this._provider.resolveCodeLens(V,W),K||(K=V),W.isCancellationRequested)return;const z=F.cacheId&&this._disposables.get(F.cacheId[0]);if(!!z)return F.command=this._commands.toInternal(K.command??o._badCmd,z),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ve){return Array.isArray(ve)?ve.map(g.DefinitionLink.from):ve?[g.DefinitionLink.from(ve)]:[]}class t{constructor(F,W){this._documents=F,this._provider=W}async provideDefinition(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideDefinition(K,z,V);return r(Y)}}class s{constructor(F,W){this._documents=F,this._provider=W}async provideDeclaration(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideDeclaration(K,z,V);return r(Y)}}class m{constructor(F,W){this._documents=F,this._provider=W}async provideImplementation(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideImplementation(K,z,V);return r(Y)}}class d{constructor(F,W){this._documents=F,this._provider=W}async provideTypeDefinition(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideTypeDefinition(K,z,V);return r(Y)}}class C{constructor(F,W){this._documents=F,this._provider=W}async provideHover(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideHover(K,z,V);if(!(!Y||(0,R.isFalsyOrEmpty)(Y.contents)))return Y.range||(Y.range=K.getWordRangeAtPosition(z)),Y.range||(Y.range=new L.Range(z,z)),g.Hover.from(Y)}}class O{constructor(F,W){this._documents=F,this._provider=W}async provideEvaluatableExpression(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideEvaluatableExpression(K,z,V);if(Y)return g.EvaluatableExpression.from(Y)}}class U{constructor(F,W){this._documents=F,this._provider=W}async provideInlineValues(F,W,V,K){const z=this._documents.getDocument(F),Y=await this._provider.provideInlineValues(z,g.Range.to(W),g.InlineValueContext.to(V),K);if(Array.isArray(Y))return Y.map(ie=>g.InlineValue.from(ie))}}class A{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentHighlights(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideDocumentHighlights(K,z,V);if(Array.isArray(Y))return Y.map(g.DocumentHighlight.from)}}class E{constructor(F,W){this._documents=F,this._provider=W}async provideLinkedEditingRanges(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.provideLinkedEditingRanges(K,z,V);if(Y&&Array.isArray(Y.ranges))return{ranges:(0,R.coalesce)(Y.ranges.map(g.Range.from)),wordPattern:Y.wordPattern}}}class ${constructor(F,W){this._documents=F,this._provider=W}async provideReferences(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W),ie=await this._provider.provideReferences(z,Y,V,K);if(Array.isArray(ie))return ie.map(g.location.from)}}class x{constructor(F,W,V,K,z,Y,ie){this._documents=F,this._commands=W,this._diagnostics=V,this._provider=K,this._logService=z,this._extension=Y,this._apiDeprecation=ie,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,W,V,K){const z=this._documents.getDocument(F),Y=p.Selection.isISelection(W)?g.Selection.to(W):g.Range.to(W),ie=[];for(const X of this._diagnostics.getDiagnostics(F))if(Y.intersection(X.range)&&ie.push(X)>x._maxCodeActionsPerFile)break;const Fe={diagnostics:ie,only:V.only?new L.CodeActionKind(V.only):void 0,triggerKind:g.CodeActionTriggerKind.to(V.trigger)},Ue=await this._provider.provideCodeActions(z,Y,Fe,K);if(!(0,R.isNonEmptyArray)(Ue)||K.isCancellationRequested)return;const ke=this._cache.add(Ue),Ve=new f.DisposableStore;this._disposables.set(ke,Ve);const q=[];for(let X=0;X<Ue.length;X++){const he=Ue[X];!he||(x._isCommand(he)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),q.push({_isSynthetic:!0,title:he.title,command:this._commands.toInternal(he,Ve)})):(Fe.only&&(he.kind?Fe.only.contains(he.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${he.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),q.push({cacheId:[ke,X],title:he.title,command:he.command&&this._commands.toInternal(he.command,Ve),diagnostics:he.diagnostics&&he.diagnostics.map(g.Diagnostic.from),edit:he.edit&&g.WorkspaceEdit.from(he.edit),kind:he.kind&&he.kind.value,isPreferred:he.isPreferred,disabled:he.disabled?.reason})))}return{cacheId:ke,actions:q}}async resolveCodeAction(F,W){const[V,K]=F,z=this._cache.get(V,K);if(!z||x._isCommand(z)||!this._provider.resolveCodeAction)return;const Y=await this._provider.resolveCodeAction(z,W)??z;return Y?.edit?g.WorkspaceEdit.from(Y.edit):void 0}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}x._maxCodeActionsPerFile=1e3;class H{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentFormattingEdits(F,W,V){const K=this._documents.getDocument(F),z=await this._provider.provideDocumentFormattingEdits(K,W,V);if(Array.isArray(z))return z.map(g.TextEdit.from)}}class oe{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentRangeFormattingEdits(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Range.to(W),ie=await this._provider.provideDocumentRangeFormattingEdits(z,Y,V,K);if(Array.isArray(ie))return ie.map(g.TextEdit.from)}}class G{constructor(F,W){this._documents=F,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,W,V,K,z){const Y=this._documents.getDocument(F),ie=g.Position.to(W),Fe=await this._provider.provideOnTypeFormattingEdits(Y,ie,V,K,z);if(Array.isArray(Fe))return Fe.map(g.TextEdit.from)}}class M{constructor(F,W){this._provider=F,this._logService=W,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,W){const V=await this._provider.provideWorkspaceSymbols(F,W);if(!(0,R.isNonEmptyArray)(V))return{symbols:[]};const K=this._cache.add(V),z={cacheId:K,symbols:[]};for(let Y=0;Y<V.length;Y++){const ie=V[Y];if(!ie||!ie.name){this._logService.warn("INVALID SymbolInformation",ie);continue}z.symbols.push({...g.WorkspaceSymbol.from(ie),cacheId:[K,Y]})}return z}async resolveWorkspaceSymbol(F,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const V=this._cache.get(...F.cacheId);if(V){const K=await this._provider.resolveWorkspaceSymbol(V,W);return K&&(0,D.mixin)(F,g.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class le{constructor(F,W,V){this._documents=F,this._provider=W,this._logService=V}static supportsResolving(F){return typeof F.prepareRename=="function"}async provideRenameEdits(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W);try{const ie=await this._provider.provideRenameEdits(z,Y,V,K);return ie?g.WorkspaceEdit.from(ie):void 0}catch(ie){const Fe=le._asMessage(ie);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(ie)}}async resolveRenameLocation(F,W,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(F),z=g.Position.to(W);try{const Y=await this._provider.prepareRename(K,z,V);let ie,Fe;if(L.Range.isRange(Y)?(ie=Y,Fe=K.getText(Y)):(0,v.isObject)(Y)&&(ie=Y.range,Fe=Y.placeholder),!ie||!Fe)return;if(ie.start.line>z.line||ie.end.line<z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(ie),text:Fe}}catch(Y){const ie=le._asMessage(Y);return ie?{rejectReason:ie,range:void 0,text:void 0}:Promise.reject(Y)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class me{constructor(F,W){this.resultId=F,this.tokens=W}}class ae{constructor(F,W){this._documents=F,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,W,V){const K=this._documents.getDocument(F),z=W!==0?this._previousResults.get(W):null;let Y=typeof z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,z.resultId,V):await this._provider.provideDocumentSemanticTokens(K,V);return z&&this._previousResults.delete(W),Y?(Y=ae._fixProvidedSemanticTokens(Y),this._send(ae._convertToEdits(z,Y),Y)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return ae._isSemanticTokens(F)?ae._isCorrectSemanticTokens(F)?F:new L.SemanticTokens(new Uint32Array(F.data),F.resultId):ae._isSemanticTokensEdits(F)?ae._isCorrectSemanticTokensEdits(F)?F:new L.SemanticTokensEdits(F.edits.map(W=>new L.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const W of F.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,W){if(!ae._isSemanticTokens(W)||!F||!F.tokens)return W;const V=F.tokens,K=V.length,z=W.data,Y=z.length;let ie=0;const Fe=Math.min(K,Y);for(;ie<Fe&&V[ie]===z[ie];)ie++;if(ie===K&&ie===Y)return new L.SemanticTokensEdits([],W.resultId);let Ue=0;const ke=Fe-ie;for(;Ue<ke&&V[K-Ue-1]===z[Y-Ue-1];)Ue++;return new L.SemanticTokensEdits([{start:ie,deleteCount:K-ie-Ue,data:z.subarray(ie,Y-Ue)}],W.resultId)}_send(F,W){if(ae._isSemanticTokens(F)){const V=this._nextResultId++;return this._previousResults.set(V,new me(F.resultId,F.data)),(0,u.encodeSemanticTokensDto)({id:V,type:"full",data:F.data})}if(ae._isSemanticTokensEdits(F)){const V=this._nextResultId++;return ae._isSemanticTokens(W)?this._previousResults.set(V,new me(W.resultId,W.data)):this._previousResults.set(V,new me(F.resultId)),(0,u.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(F.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}e.DocumentSemanticTokensAdapter=ae;class ge{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentRangeSemanticTokens(F,W,V){const K=this._documents.getDocument(F),z=await this._provider.provideDocumentRangeSemanticTokens(K,g.Range.to(W),V);return z?this._send(z):null}_send(F){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}e.DocumentRangeSemanticTokensAdapter=ge;class te{constructor(F,W,V,K,z){this._documents=F,this._commands=W,this._provider=V,this._apiDeprecation=K,this._extension=z,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}async provideCompletionItems(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W),ie=z.getWordRangeAtPosition(Y)||new L.Range(Y,Y),Fe=ie.with({end:Y}),Ue=new y.StopWatch(!0),ke=await this._provider.provideCompletionItems(z,Y,K,g.CompletionContext.to(V));if(!ke||K.isCancellationRequested)return;const Ve=Array.isArray(ke)?new L.CompletionList(ke):ke,q=te.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),X=new f.DisposableStore;this._disposables.set(q,X);const he=[],Le={x:q,b:he,a:{replace:g.Range.from(ie),insert:g.Range.from(Fe)},c:Ve.isIncomplete||void 0,d:Ue.elapsed()};for(let xe=0;xe<Ve.items.length;xe++){const Xe=Ve.items[xe],Je=this._convertCompletionItem(Xe,[q,xe],Fe,ie);he.push(Je)}return Le}async resolveCompletionItem(F,W){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...F);if(!V)return;const K=await this._provider.resolveCompletionItem(V,W);if(!!K)return this._convertCompletionItem(K,F)}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,W,V,K){const z=this._disposables.get(W[0]);if(!z)throw Error("DisposableStore is missing...");const Y={x:W,a:F.label,b:F.kind!==void 0?g.CompletionItemKind.from(F.kind):void 0,n:F.tags&&F.tags.map(g.CompletionItemTag.from),c:F.detail,d:typeof F.documentation=="undefined"?void 0:g.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters,l:F.additionalTextEdits&&F.additionalTextEdits.map(g.TextEdit.from),m:this._commands.toInternal(F.command,z)};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Y.h=F.textEdit.newText):typeof F.insertText=="string"?Y.h=F.insertText:F.insertText instanceof L.SnippetString&&(Y.h=F.insertText.value,Y.i|=4);let ie;return F.textEdit?ie=F.textEdit.range:F.range&&(ie=F.range),L.Range.isRange(ie)?Y.j=g.Range.from(ie):ie&&(!V?.isEqual(ie.inserting)||!K?.isEqual(ie.replacing))&&(Y.j={insert:g.Range.from(ie.inserting),replace:g.Range.from(ie.replacing)}),Y}}class Ee{async provideInlineCompletions(F,W,V,K){}disposeCompletions(F){}handleDidShowCompletionItem(F,W){}}class we extends Ee{constructor(F,W,V){super();this._documents=F,this._provider=W,this._commands=V,this._cache=new c.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W),ie=await this._provider.provideInlineCompletionItems(z,Y,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:g.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text,isSnippetText:V.selectedSuggestionInfo.isSnippetText,completionKind:g.CompletionItemKind.to(V.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:V.triggerKind},K);if(!ie||K.isCancellationRequested)return;const Fe=(0,v.isArray)(ie)?ie:ie.items,Ue=this._cache.add(Fe);let ke;return{pid:Ue,items:Fe.map((Ve,q)=>{let X;Ve.command&&(ke||(ke=new f.DisposableStore,this._disposables.set(Ue,ke)),X=this._commands.toInternal(Ve.command,ke));const he=Ve.insertText??Ve.text;if(he===void 0)throw new Error("text or insertText must be defined");return{insertText:typeof he=="string"?he:{snippet:he.value},range:Ve.range?g.Range.from(Ve.range):void 0,command:X,idx:q,completeBracketPairs:Ve.completeBracketPairs}})}}disposeCompletions(F){this._cache.delete(F);const W=this._disposables.get(F);W&&W.clear(),this._disposables.delete(F)}handleDidShowCompletionItem(F,W){const V=this._cache.get(F,W);V&&Pe.get(this._provider).fireOnDidShowCompletionItem({completionItem:V})}}class Z extends Ee{constructor(F,W,V,K){super();this.extension=F,this._documents=W,this._provider=V,this._commands=K,this._references=new pe,this.isAdditionProposedApiEnabled=(0,n.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKindNew.Automatic,[I.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W),ie=await this._provider.provideInlineCompletionItems(z,Y,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:g.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},K);if(!ie||K.isCancellationRequested)return;const Fe=(0,v.isArray)(ie)?ie:ie.items,Ue=(0,v.isArray)(ie)?[]:ie.commands||[];let ke;return{pid:this._references.createReferenceId({dispose(){ke&&ke.dispose()},items:Fe}),items:Fe.map((q,X)=>{let he;q.command&&(ke||(ke=new f.DisposableStore),he=this._commands.toInternal(q.command,ke));const Le=q.insertText;return{insertText:typeof Le=="string"?Le:{snippet:Le.value},filterText:q.filterText,range:q.range?g.Range.from(q.range):void 0,command:he,idx:X,completeBracketPairs:this.isAdditionProposedApiEnabled?q.completeBracketPairs:!1}}),commands:Ue.map(q=>(ke||(ke=new f.DisposableStore),this._commands.toInternal(q,ke)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,W){const V=this._references.get(F)?.items[W];V&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class pe{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const W=this._idPool++;return this._references.set(W,F),W}disposeReferenceId(F){const W=this._references.get(F);return this._references.delete(F),W}get(F){return this._references.get(F)}}class Pe{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(F){let W=Pe.map.get(F);return W||(W=new Pe,Pe.map.set(F,W)),W}fireOnDidShowCompletionItem(F){this._onDidShowCompletionItemEmitter.fire(F)}}e.InlineCompletionController=Pe,Pe.map=new WeakMap;class Ne{constructor(F,W){this._documents=F,this._provider=W,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W),ie=this.reviveContext(V),Fe=await this._provider.provideSignatureHelp(z,Y,K,ie);if(Fe){const Ue=this._cache.add([Fe]);return{...g.SignatureHelp.from(Fe),id:Ue}}}reviveContext(F){let W;if(F.activeSignatureHelp){const V=g.SignatureHelp.to(F.activeSignatureHelp),K=this._cache.get(F.activeSignatureHelp.id,0);K?(W=K,W.activeSignature=V.activeSignature,W.activeParameter=V.activeParameter):W=V}return{...F,activeSignatureHelp:W}}releaseSignatureHelp(F){this._cache.delete(F)}}class We{constructor(F,W,V,K,z){this._documents=F,this._commands=W,this._provider=V,this._logService=K,this._extension=z,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,W,V){const K=this._documents.getDocument(F),z=g.Range.to(W),Y=await this._provider.provideInlayHints(K,z,V);if(!Array.isArray(Y)||Y.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(V.isCancellationRequested)return;const ie=this._cache.add(Y);this._disposables.set(ie,new f.DisposableStore);const Fe={hints:[],cacheId:ie};for(let Ue=0;Ue<Y.length;Ue++)this._isValidInlayHint(Y[Ue],z)&&Fe.hints.push(this._convertInlayHint(Y[Ue],[ie,Ue]));return this._logService.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),Fe}async resolveInlayHint(F,W){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...F);if(!V)return;const K=await this._provider.resolveInlayHint(V,W);if(!!K&&!!this._isValidInlayHint(K))return this._convertInlayHint(K,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,W){return F.label.length===0||Array.isArray(F.label)&&F.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(W&&!W.contains(F.position))}_convertInlayHint(F,W){const V=this._disposables.get(W[0]);if(!V)throw Error("DisposableStore is missing...");const K={label:"",cacheId:W,tooltip:g.MarkdownString.fromStrict(F.tooltip),position:g.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(g.TextEdit.from),kind:F.kind&&g.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?K.label=F.label:K.label=F.label.map(z=>{let Y={label:z.value};return Y.tooltip=g.MarkdownString.fromStrict(z.tooltip),L.Location.isLocation(z.location)&&(Y.location=g.location.from(z.location)),z.command&&(Y.command=this._commands.toInternal(z.command,V)),Y}),K}}class Ge{constructor(F,W){this._documents=F,this._provider=W,this._cache=new c.Cache("DocumentLink")}async provideLinks(F,W){const V=this._documents.getDocument(F),K=await this._provider.provideDocumentLinks(V,W);if(!(!Array.isArray(K)||K.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(Ge._validateLink).map(g.DocumentLink.from)};{const z=this._cache.add(K),Y={links:[],cacheId:z};for(let ie=0;ie<K.length;ie++){if(!Ge._validateLink(K[ie]))continue;const Fe=g.DocumentLink.from(K[ie]);Fe.cacheId=[z,ie],Y.links.push(Fe)}return Y}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,W){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...F);if(!V)return;const K=await this._provider.resolveDocumentLink(V,W);if(!(!K||!Ge._validateLink(K)))return g.DocumentLink.from(K)}releaseLinks(F){this._cache.delete(F)}}class Ce{constructor(F,W){this._documents=F,this._provider=W}async provideColors(F,W){const V=this._documents.getDocument(F),K=await this._provider.provideDocumentColors(V,W);return Array.isArray(K)?K.map(Y=>({color:g.Color.from(Y.color),range:g.Range.from(Y.range)})):[]}async provideColorPresentations(F,W,V){const K=this._documents.getDocument(F),z=g.Range.to(W.range),Y=g.Color.to(W.color),ie=await this._provider.provideColorPresentations(Y,{document:K,range:z},V);if(!!Array.isArray(ie))return ie.map(g.ColorPresentation.from)}}class _e{constructor(F,W){this._documents=F,this._provider=W}async provideFoldingRanges(F,W,V){const K=this._documents.getDocument(F),z=await this._provider.provideFoldingRanges(K,W,V);if(!!Array.isArray(z))return z.map(g.FoldingRange.from)}}class Te{constructor(F,W,V){this._documents=F,this._provider=W,this._logService=V}async provideSelectionRanges(F,W,V){const K=this._documents.getDocument(F),z=W.map(g.Position.to),Y=await this._provider.provideSelectionRanges(K,z,V);if(!(0,R.isNonEmptyArray)(Y))return[];if(Y.length!==z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ie=[];for(let Fe=0;Fe<z.length;Fe++){const Ue=[];ie.push(Ue);let ke=z[Fe],Ve=Y[Fe];for(;;){if(!Ve.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(g.SelectionRange.from(Ve)),!Ve.parent)break;ke=Ve.range,Ve=Ve.parent}}return ie}}class se{constructor(F,W){this._documents=F,this._provider=W,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.prepareCallHierarchy(K,z,V);if(!Y)return;const ie=this._idPool.nextId();return this._cache.set(ie,new Map),Array.isArray(Y)?Y.map(Fe=>this._cacheAndConvertItem(ie,Fe)):[this._cacheAndConvertItem(ie,Y)]}async provideCallsTo(F,W,V){const K=this._itemFromCache(F,W);if(!K)throw new Error("missing call hierarchy item");const z=await this._provider.provideCallHierarchyIncomingCalls(K,V);if(!!z)return z.map(Y=>({from:this._cacheAndConvertItem(F,Y.from),fromRanges:Y.fromRanges.map(ie=>g.Range.from(ie))}))}async provideCallsFrom(F,W,V){const K=this._itemFromCache(F,W);if(!K)throw new Error("missing call hierarchy item");const z=await this._provider.provideCallHierarchyOutgoingCalls(K,V);if(!!z)return z.map(Y=>({to:this._cacheAndConvertItem(F,Y.to),fromRanges:Y.fromRanges.map(ie=>g.Range.from(ie))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,W){const V=this._cache.get(F),K=g.CallHierarchyItem.from(W,F,V.size.toString(36));return V.set(K._itemId,W),K}_itemFromCache(F,W){return this._cache.get(F)?.get(W)}}class ue{constructor(F,W){this._documents=F,this._provider=W,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(F,W,V){const K=this._documents.getDocument(F),z=g.Position.to(W),Y=await this._provider.prepareTypeHierarchy(K,z,V);if(!Y)return;const ie=this._idPool.nextId();return this._cache.set(ie,new Map),Array.isArray(Y)?Y.map(Fe=>this._cacheAndConvertItem(ie,Fe)):[this._cacheAndConvertItem(ie,Y)]}async provideSupertypes(F,W,V){const K=this._itemFromCache(F,W);if(!K)throw new Error("missing type hierarchy item");const z=await this._provider.provideTypeHierarchySupertypes(K,V);if(!!z)return z.map(Y=>this._cacheAndConvertItem(F,Y))}async provideSubtypes(F,W,V){const K=this._itemFromCache(F,W);if(!K)throw new Error("missing type hierarchy item");const z=await this._provider.provideTypeHierarchySubtypes(K,V);if(!!z)return z.map(Y=>this._cacheAndConvertItem(F,Y))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,W){const V=this._cache.get(F),K=g.TypeHierarchyItem.from(W,F,V.size.toString(36));return V.set(K._itemId,W),K}_itemFromCache(F,W){return this._cache.get(F)?.get(W)}}class Q{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentOnDropEdits(F,W,V,K){const z=this._documents.getDocument(F),Y=g.Position.to(W),ie=T.DataTransferConverter.toDataTransfer(V),Fe=await this._provider.provideDocumentOnDropEdits(z,Y,ie,K);if(!!Fe)return g.SnippetTextEdit.from(Fe)}}class J{constructor(F,W){this.adapter=F,this.extension=W}}class ce{constructor(F,W,V,K,z,Y,ie){this._adapter=new Map,this._uriTransformer=W,this._proxy=F.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=V,this._commands=K,this._diagnostics=z,this._logService=Y,this._apiDeprecation=ie}_transformDocumentSelector(F){return g.DocumentSelector.from(F,this._uriTransformer)}_createDisposable(F){return new L.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return ce._handlePool++}async _withAdapter(F,W,V,K,z,Y=!1){const ie=this._adapter.get(F);if(!ie||!(ie.adapter instanceof W))return K;const Fe=Date.now();Y||this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const Ue=V(ie.adapter,ie.extension);return Promise.resolve(Ue).catch(ke=>{(0,_.isCancellationError)(ke)||(this._logService.error(`[${ie.extension.identifier.value}] provider FAILED`),this._logService.error(ke))}).finally(()=>{Y||this._logService.trace(`[${ie.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),w.CancellationToken.isCancellationToken(z)?(0,S.raceCancellationError)(Ue,z):Ue}_addNewAdapter(F,W){const V=this._nextHandle();return this._adapter.set(V,new J(F,W)),V}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,W,V,K){const z=this._addNewAdapter(new i(this._documents,V),F),Y=K&&K.label||ce._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(z,this._transformDocumentSelector(W),Y),this._createDisposable(z)}$provideDocumentSymbols(F,W,V){return this._withAdapter(F,i,K=>K.provideDocumentSymbols(a.URI.revive(W),V),void 0,V)}registerCodeLensProvider(F,W,V){const K=this._nextHandle(),z=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new J(new o(this._documents,this._commands.converter,V),F)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector(W),z);let Y=this._createDisposable(K);if(z!==void 0){const ie=V.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(z));Y=L.Disposable.from(Y,ie)}return Y}$provideCodeLenses(F,W,V){return this._withAdapter(F,o,K=>K.provideCodeLenses(a.URI.revive(W),V),void 0,V)}$resolveCodeLens(F,W,V){return this._withAdapter(F,o,K=>K.resolveCodeLens(W,V),void 0,void 0)}$releaseCodeLenses(F,W){this._withAdapter(F,o,V=>Promise.resolve(V.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(F,W,V){const K=this._addNewAdapter(new t(this._documents,V),F);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideDefinition(F,W,V,K){return this._withAdapter(F,t,z=>z.provideDefinition(a.URI.revive(W),V,K),[],K)}registerDeclarationProvider(F,W,V){const K=this._addNewAdapter(new s(this._documents,V),F);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideDeclaration(F,W,V,K){return this._withAdapter(F,s,z=>z.provideDeclaration(a.URI.revive(W),V,K),[],K)}registerImplementationProvider(F,W,V){const K=this._addNewAdapter(new m(this._documents,V),F);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideImplementation(F,W,V,K){return this._withAdapter(F,m,z=>z.provideImplementation(a.URI.revive(W),V,K),[],K)}registerTypeDefinitionProvider(F,W,V){const K=this._addNewAdapter(new d(this._documents,V),F);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideTypeDefinition(F,W,V,K){return this._withAdapter(F,d,z=>z.provideTypeDefinition(a.URI.revive(W),V,K),[],K)}registerHoverProvider(F,W,V,K){const z=this._addNewAdapter(new C(this._documents,V),F);return this._proxy.$registerHoverProvider(z,this._transformDocumentSelector(W)),this._createDisposable(z)}$provideHover(F,W,V,K){return this._withAdapter(F,C,z=>z.provideHover(a.URI.revive(W),V,K),void 0,K)}registerEvaluatableExpressionProvider(F,W,V,K){const z=this._addNewAdapter(new O(this._documents,V),F);return this._proxy.$registerEvaluatableExpressionProvider(z,this._transformDocumentSelector(W)),this._createDisposable(z)}$provideEvaluatableExpression(F,W,V,K){return this._withAdapter(F,O,z=>z.provideEvaluatableExpression(a.URI.revive(W),V,K),void 0,K)}registerInlineValuesProvider(F,W,V,K){const z=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new U(this._documents,V),F);this._proxy.$registerInlineValuesProvider(Y,this._transformDocumentSelector(W),z);let ie=this._createDisposable(Y);if(z!==void 0){const Fe=V.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(z));ie=L.Disposable.from(ie,Fe)}return ie}$provideInlineValues(F,W,V,K,z){return this._withAdapter(F,U,Y=>Y.provideInlineValues(a.URI.revive(W),V,K,z),void 0,z)}registerDocumentHighlightProvider(F,W,V){const K=this._addNewAdapter(new A(this._documents,V),F);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideDocumentHighlights(F,W,V,K){return this._withAdapter(F,A,z=>z.provideDocumentHighlights(a.URI.revive(W),V,K),void 0,K)}registerLinkedEditingRangeProvider(F,W,V){const K=this._addNewAdapter(new E(this._documents,V),F);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideLinkedEditingRanges(F,W,V,K){return this._withAdapter(F,E,async z=>{const Y=await z.provideLinkedEditingRanges(a.URI.revive(W),V,K);if(Y)return{ranges:Y.ranges,wordPattern:Y.wordPattern?ce._serializeRegExp(Y.wordPattern):void 0}},void 0,K)}registerReferenceProvider(F,W,V){const K=this._addNewAdapter(new $(this._documents,V),F);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideReferences(F,W,V,K,z){return this._withAdapter(F,$,Y=>Y.provideReferences(a.URI.revive(W),V,K,z),void 0,z)}registerCodeActionProvider(F,W,V,K){const z=new f.DisposableStore,Y=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,V,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(Y,this._transformDocumentSelector(W),{providedKinds:K?.providedCodeActionKinds?.map(ie=>ie.value),documentation:K?.documentation?.map(ie=>({kind:ie.kind.value,command:this._commands.converter.toInternal(ie.command,z)}))},ce._extLabel(F),Boolean(V.resolveCodeAction)),z.add(this._createDisposable(Y)),z}$provideCodeActions(F,W,V,K,z){return this._withAdapter(F,x,Y=>Y.provideCodeActions(a.URI.revive(W),V,K,z),void 0,z)}$resolveCodeAction(F,W,V){return this._withAdapter(F,x,K=>K.resolveCodeAction(W,V),void 0,void 0)}$releaseCodeActions(F,W){this._withAdapter(F,x,V=>Promise.resolve(V.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(F,W,V){const K=this._addNewAdapter(new H(this._documents,V),F);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector(W),F.identifier,F.displayName||F.name),this._createDisposable(K)}$provideDocumentFormattingEdits(F,W,V,K){return this._withAdapter(F,H,z=>z.provideDocumentFormattingEdits(a.URI.revive(W),V,K),void 0,K)}registerDocumentRangeFormattingEditProvider(F,W,V){const K=this._addNewAdapter(new oe(this._documents,V),F);return this._proxy.$registerRangeFormattingSupport(K,this._transformDocumentSelector(W),F.identifier,F.displayName||F.name),this._createDisposable(K)}$provideDocumentRangeFormattingEdits(F,W,V,K,z){return this._withAdapter(F,oe,Y=>Y.provideDocumentRangeFormattingEdits(a.URI.revive(W),V,K,z),void 0,z)}registerOnTypeFormattingEditProvider(F,W,V,K){const z=this._addNewAdapter(new G(this._documents,V),F);return this._proxy.$registerOnTypeFormattingSupport(z,this._transformDocumentSelector(W),K,F.identifier),this._createDisposable(z)}$provideOnTypeFormattingEdits(F,W,V,K,z,Y){return this._withAdapter(F,G,ie=>ie.provideOnTypeFormattingEdits(a.URI.revive(W),V,K,z,Y),void 0,Y)}registerWorkspaceSymbolProvider(F,W){const V=this._addNewAdapter(new M(W,this._logService),F);return this._proxy.$registerNavigateTypeSupport(V,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(F,W,V){return this._withAdapter(F,M,K=>K.provideWorkspaceSymbols(W,V),{symbols:[]},V)}$resolveWorkspaceSymbol(F,W,V){return this._withAdapter(F,M,K=>K.resolveWorkspaceSymbol(W,V),void 0,void 0)}$releaseWorkspaceSymbols(F,W){this._withAdapter(F,M,V=>V.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(F,W,V){const K=this._addNewAdapter(new le(this._documents,V,this._logService),F);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector(W),le.supportsResolving(V)),this._createDisposable(K)}$provideRenameEdits(F,W,V,K,z){return this._withAdapter(F,le,Y=>Y.provideRenameEdits(a.URI.revive(W),V,K,z),void 0,z)}$resolveRenameLocation(F,W,V,K){return this._withAdapter(F,le,z=>z.resolveRenameLocation(a.URI.revive(W),V,K),void 0,K)}registerDocumentSemanticTokensProvider(F,W,V,K){const z=this._addNewAdapter(new ae(this._documents,V),F),Y=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(z,this._transformDocumentSelector(W),K,Y);let ie=this._createDisposable(z);if(Y){const Fe=V.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(Y));ie=L.Disposable.from(ie,Fe)}return ie}$provideDocumentSemanticTokens(F,W,V,K){return this._withAdapter(F,ae,z=>z.provideDocumentSemanticTokens(a.URI.revive(W),V,K),null,K)}$releaseDocumentSemanticTokens(F,W){this._withAdapter(F,ae,V=>V.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,W,V,K){const z=this._addNewAdapter(new ge(this._documents,V),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(z,this._transformDocumentSelector(W),K),this._createDisposable(z)}$provideDocumentRangeSemanticTokens(F,W,V,K){return this._withAdapter(F,ge,z=>z.provideDocumentRangeSemanticTokens(a.URI.revive(W),V,K),null,K)}registerCompletionItemProvider(F,W,V,K){const z=this._addNewAdapter(new te(this._documents,this._commands.converter,V,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(z,this._transformDocumentSelector(W),K,te.supportsResolving(V),`${F.identifier.value}(${K.join("")})`),this._createDisposable(z)}$provideCompletionItems(F,W,V,K,z){return this._withAdapter(F,te,Y=>Y.provideCompletionItems(a.URI.revive(W),V,K,z),void 0,z)}$resolveCompletionItem(F,W,V){return this._withAdapter(F,te,K=>K.resolveCompletionItem(W,V),void 0,V)}$releaseCompletionItems(F,W){this._withAdapter(F,te,V=>V.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(F,W,V){const K=this._addNewAdapter(new we(this._documents,V,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}registerInlineCompletionsProviderNew(F,W,V){const K=this._addNewAdapter(new Z(F,this._documents,V,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideInlineCompletions(F,W,V,K,z){return this._withAdapter(F,Ee,Y=>Y.provideInlineCompletions(a.URI.revive(W),V,K,z),void 0,z)}$handleInlineCompletionDidShow(F,W,V){this._withAdapter(F,Ee,async K=>{K.handleDidShowCompletionItem(W,V)},void 0,void 0)}$freeInlineCompletionsList(F,W){this._withAdapter(F,Ee,async V=>{V.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(F,W,V,K){const z=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,Y=this._addNewAdapter(new Ne(this._documents,V),F);return this._proxy.$registerSignatureHelpProvider(Y,this._transformDocumentSelector(W),z),this._createDisposable(Y)}$provideSignatureHelp(F,W,V,K,z){return this._withAdapter(F,Ne,Y=>Y.provideSignatureHelp(a.URI.revive(W),V,K,z),void 0,z)}$releaseSignatureHelp(F,W){this._withAdapter(F,Ne,V=>V.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(F,W,V){const K=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,z=this._addNewAdapter(new We(this._documents,this._commands.converter,V,this._logService,F),F);this._proxy.$registerInlayHintsProvider(z,this._transformDocumentSelector(W),typeof V.resolveInlayHint=="function",K,ce._extLabel(F));let Y=this._createDisposable(z);if(K!==void 0){const ie=V.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(K));Y=L.Disposable.from(Y,ie)}return Y}$provideInlayHints(F,W,V,K){return this._withAdapter(F,We,z=>z.provideInlayHints(a.URI.revive(W),V,K),void 0,K)}$resolveInlayHint(F,W,V){return this._withAdapter(F,We,K=>K.resolveInlayHint(W,V),void 0,V)}$releaseInlayHints(F,W){this._withAdapter(F,We,V=>V.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(F,W,V){const K=this._addNewAdapter(new Ge(this._documents,V),F);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector(W),typeof V.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(F,W,V){return this._withAdapter(F,Ge,K=>K.provideLinks(a.URI.revive(W),V),void 0,V,W.scheme==="output")}$resolveDocumentLink(F,W,V){return this._withAdapter(F,Ge,K=>K.resolveLink(W,V),void 0,void 0,!0)}$releaseDocumentLinks(F,W){this._withAdapter(F,Ge,V=>V.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(F,W,V){const K=this._addNewAdapter(new Ce(this._documents,V),F);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideDocumentColors(F,W,V){return this._withAdapter(F,Ce,K=>K.provideColors(a.URI.revive(W),V),[],V)}$provideColorPresentations(F,W,V,K){return this._withAdapter(F,Ce,z=>z.provideColorPresentations(a.URI.revive(W),V,K),void 0,K)}registerFoldingRangeProvider(F,W,V){const K=this._nextHandle(),z=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new J(new _e(this._documents,V),F)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector(W),z);let Y=this._createDisposable(K);if(z!==void 0){const ie=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(z));Y=L.Disposable.from(Y,ie)}return Y}$provideFoldingRanges(F,W,V,K){return this._withAdapter(F,_e,z=>z.provideFoldingRanges(a.URI.revive(W),V,K),void 0,K)}registerSelectionRangeProvider(F,W,V){const K=this._addNewAdapter(new Te(this._documents,V,this._logService),F);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideSelectionRanges(F,W,V,K){return this._withAdapter(F,Te,z=>z.provideSelectionRanges(a.URI.revive(W),V,K),[],K)}registerCallHierarchyProvider(F,W,V){const K=this._addNewAdapter(new se(this._documents,V),F);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$prepareCallHierarchy(F,W,V,K){return this._withAdapter(F,se,z=>Promise.resolve(z.prepareSession(a.URI.revive(W),V,K)),void 0,K)}$provideCallHierarchyIncomingCalls(F,W,V,K){return this._withAdapter(F,se,z=>z.provideCallsTo(W,V,K),void 0,K)}$provideCallHierarchyOutgoingCalls(F,W,V,K){return this._withAdapter(F,se,z=>z.provideCallsFrom(W,V,K),void 0,K)}$releaseCallHierarchy(F,W){this._withAdapter(F,se,V=>Promise.resolve(V.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(F,W,V){const K=this._addNewAdapter(new ue(this._documents,V),F);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$prepareTypeHierarchy(F,W,V,K){return this._withAdapter(F,ue,z=>Promise.resolve(z.prepareSession(a.URI.revive(W),V,K)),void 0,K)}$provideTypeHierarchySupertypes(F,W,V,K){return this._withAdapter(F,ue,z=>z.provideSupertypes(W,V,K),void 0,K)}$provideTypeHierarchySubtypes(F,W,V,K){return this._withAdapter(F,ue,z=>z.provideSubtypes(W,V,K),void 0,K)}$releaseTypeHierarchy(F,W){this._withAdapter(F,ue,V=>Promise.resolve(V.releaseSession(W)),void 0,void 0)}registerDocumentOnDropProvider(F,W,V){const K=this._addNewAdapter(new Q(this._documents,V),F);return this._proxy.$registerDocumentOnDropProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideDocumentOnDropEdits(F,W,V,K,z){return this._withAdapter(F,Q,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(a.URI.revive(W),V,K,z)),void 0,void 0)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,b.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:ce._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:ce._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ce._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ce._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:ce._serializeRegExp(F.beforeText),afterText:F.afterText?ce._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?ce._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(ce._serializeOnEnterRule)}setLanguageConfiguration(F,W,V){let{wordPattern:K}=V;if(K&&(0,b.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor(W,K):this._documents.setWordDefinitionFor(W,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const z=this._nextHandle(),Y={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ce._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ce._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ce._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(z,W,Y),this._createDisposable(z)}$setWordDefinitions(F){for(const W of F)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce._handlePool=0}),define(Se[196],De([1,0,4,8,6,32,14,7]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(R,v,p,w){this._documents=v,this._commands=p,this._uriTransformer=w,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,v){await this._proxy.$changeLanguage(R,v);const p=this._documents.getDocumentData(R);if(!p)throw new Error(`document '${R.toString()}' NOT found`);return p.document}async tokenAtPosition(R,v){const p=R.version,w=D.Position.from(v),f=await this._proxy.$tokensAtPosition(R.uri,w),u={type:g.StandardTokenType.Other,range:R.getWordRangeAtPosition(v)??new g.Range(v.line,v.character,v.line,v.character)};if(!f)return u;const h={range:D.Range.to(f.range),type:D.TokenType.to(f.type)};return!h.range.contains(v)||p!==R.version?u:h}createLanguageStatusItem(R,v,p){const w=this._handlePool++,f=this._proxy,u=this._ids,h=`${R.identifier.value}/${v}`;if(u.has(h))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);u.add(h);const c={selector:p,id:v,name:R.displayName??R.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let y,_=new k.DisposableStore;const l=()=>{y?.dispose(),y=(0,I.disposableTimeout)(()=>{_.clear(),this._proxy.$setLanguageStatus(w,{id:h,name:c.name??R.displayName??R.name,source:R.displayName??R.name,selector:D.DocumentSelector.from(c.selector,this._uriTransformer),label:c.text,detail:c.detail??"",severity:c.severity===g.LanguageStatusSeverity.Error?L.default.Error:c.severity===g.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:c.command&&this._commands.toInternal(c.command,_),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},S={dispose(){_.dispose(),y?.dispose(),f.$removeLanguageStatus(w),u.delete(h)},get id(){return c.id},get name(){return c.name},set name(n){c.name=n,l()},get selector(){return c.selector},set selector(n){c.selector=n,l()},get text(){return c.text},set text(n){c.text=n,l()},get detail(){return c.detail},set detail(n){c.detail=n,l()},get severity(){return c.severity},set severity(n){c.severity=n,l()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(n){c.accessibilityInformation=n,l()},get command(){return c.command},set command(n){c.command=n,l()},get busy(){return c.busy},set busy(n){c.busy=n,l()}};return l(),S}}e.ExtHostLanguages=b}),define(Se[197],De([1,0,13,4,28,16,5]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends a.AbstractLoggerService{constructor(R,v){const p=new I.Emitter;super(v.logLevel,p.event);this._proxy=R.getProxy(D.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(p)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,v,p){return new b(this._proxy,R,v,p)}};k=$e([ze(0,L.IExtHostRpcService),ze(1,g.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class b extends a.AbstractMessageLogger{constructor(R,v,p,w){super(w?.always);this.proxy=R,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(v,w).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,v){const p=[[R,v]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Se[198],De([1,0,4,13,21]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(k){return k&&k.title}let I=class{constructor(b,P){this._logService=P,this._proxy=b.getProxy(a.MainContext.MainThreadMessageService)}showMessage(b,P,R,v,p){const w={source:{identifier:b.identifier,label:b.displayName||b.name}};let f;typeof v=="string"||L(v)?f=[v,...p]:(w.modal=v?.modal,w.useCustom=v?.useCustom,w.detail=v?.detail,f=p),w.useCustom&&(0,g.checkProposedApiEnabled)(b,"resolvers");const u=[];for(let h=0;h<f.length;h++){const c=f[h];if(typeof c=="string")u.push({title:c,handle:h,isCloseAffordance:!1});else if(typeof c=="object"){let{title:y,isCloseAffordance:_}=c;u.push({title:y,isCloseAffordance:!!_,handle:h})}else this._logService.warn("Invalid message item:",c)}return this._proxy.$showMessage(P,R,w,u).then(h=>{if(typeof h=="number")return f[h]})}};I=$e([ze(1,D.ILogService)],I),e.ExtHostMessageService=I}),define(Se[199],De([1,0,25,5,95,7,22,9,10,2,63,4,36,8,6,39,173,90]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class y{constructor(l,S,n,T,i){this._textDocumentsAndEditors=n,this._textDocuments=T,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=S.converter,S.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const r=o.notebookEditor?.notebookUri,t=o.cell.handle,m=this._documents.get(r)?.getCell(t);if(m)return m.apiCell}return o}}),y._registerApiCommands(S)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const S=this._editors.get(l);if(!S)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return S}getIdByEditor(l){for(const[S,n]of this._editors)if(n.apiEditor===l)return S}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,S){const n=this._documents.get(l);if(!n&&!S)throw new Error(`NO notebook document for '${l}'`);return n}_getProviderData(l){const S=this._notebookContentProviders.get(l);if(!S)throw new Error(`NO provider for '${l}'`);return S}registerNotebookContentProvider(l,S,n,T,i){if((0,k.isFalsyOrWhitespace)(S))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(S))throw new Error(`Notebook provider for '${S}' already registered`);this._notebookContentProviders.set(S,{extension:l,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const r=w.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(S,r)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},S,w.NotebookDocumentContentOptions.from(T),y._convertNotebookRegistrationData(l,i)),new f.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(S),this._notebookProxy.$unregisterNotebookProvider(S)})}static _convertNotebookRegistrationData(l,S){if(!S)return;const n=S.filenamePattern.map(T=>w.NotebookExclusiveDocumentPattern.from(T)).filter(T=>T!==void 0);if(S.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:S.displayName,filenamePattern:n,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,S,n){const T=y._notebookStatusBarItemProviderHandlePool++,i=typeof n.onDidChangeCellStatusBarItems=="function"?y._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(T,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(T,i,S);let o;return i!==void 0&&(o=n.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(i))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(T),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(T,i),o&&o.dispose()})}async createNotebookDocument(l){const S=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&w.NotebookData.from(l.content)});return P.URI.revive(S)}async openNotebookDocument(l){const S=this._documents.get(l);if(S)return S.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(l),T=this._documents.get(P.URI.revive(n));return(0,b.assertIsDefined)(T?.apiNotebook)}async showNotebookDocument(l,S){P.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let n;typeof S=="object"?n={position:w.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(w.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:n={preserveFocus:!1};const T=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,n),i=T&&this._editors.get(T)?.apiEditor;if(i)return i;throw T?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,S,n,T){const i=this._notebookStatusBarItemProviders.get(l),o=P.URI.revive(S),r=this._documents.get(o);if(!r||!i)return;const t=r.getCellFromIndex(n);if(!t)return;const s=await i.provideCellStatusBarItems(t.apiCell,T);if(!s)return;const m=new L.DisposableStore,d=this._statusBarCache.add([m]),O=(Array.isArray(s)?s:[s]).map(U=>w.NotebookStatusBarItem.from(U,this._commandsConverter,m));return{cacheId:d,items:O}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,S,n,T,i){if((0,k.isFalsyOrWhitespace)(S))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:l.identifier,location:l.extensionLocation},S,w.NotebookDocumentContentOptions.from(T),y._convertNotebookRegistrationData(l,i)),(0,L.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(l,S,n){const T=this._notebookSerializer.get(l);if(!T)throw new Error("NO serializer found");const i=await T.deserializeNotebook(S.buffer,n);return new u.SerializableObjectWithBuffers(w.NotebookData.from(i))}async $notebookToData(l,S,n){const T=this._notebookSerializer.get(l);if(!T)throw new Error("NO serializer found");const i=await T.serializeNotebook(w.NotebookData.to(S.value),n);return a.VSBuffer.wrap(i)}async $openNotebook(l,S,n,T,i){const{provider:o}=this._getProviderData(l),r=await o.openNotebook(P.URI.revive(S),{backupId:n,untitledDocumentData:T?.buffer},i);return new u.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(w.NotebookCellData.from)})}async $saveNotebook(l,S,n){const T=this.getNotebookDocument(P.URI.revive(S)),{provider:i}=this._getProviderData(l);return await i.saveNotebook(T.apiNotebook,n),!0}async $saveNotebookAs(l,S,n,T){const i=this.getNotebookDocument(P.URI.revive(S)),{provider:o}=this._getProviderData(l);return await o.saveNotebookAs(P.URI.revive(n),i.apiNotebook,T),!0}async $backupNotebook(l,S,n){const T=this.getNotebookDocument(P.URI.revive(S)),i=this._getProviderData(l),o=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),r=String((0,g.hash)([T.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(o,r),s=await i.provider.backupNotebook(T.apiNotebook,{destination:t},n);return T.updateBackup(s),s.id}_createExtHostEditor(l,S,n){if(this._editors.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const T=new c.ExtHostNotebookEditor(S,this._notebookEditorsProxy,l,n.visibleRanges.map(w.NotebookRange.to),n.selections.map(w.NotebookRange.to),typeof n.viewColumn=="number"?w.ViewColumn.to(n.viewColumn):void 0);this._editors.set(S,T)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const n of l.value.removedDocuments){const T=P.URI.revive(n),i=this._documents.get(T);i&&(i.dispose(),this._documents.delete(T),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===T.toString()&&this._editors.delete(o.id)}if(l.value.addedDocuments){const n=[];for(const T of l.value.addedDocuments){const i=P.URI.revive(T.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const o=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,i,T);n.push(...T.cells.map(r=>h.ExtHostCell.asModelAddData(o.apiNotebook,r))),this._documents.get(i)?.dispose(),this._documents.set(i,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:n}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(l.value.addedEditors)for(const n of l.value.addedEditors){if(this._editors.has(n.id))return;const T=P.URI.revive(n.documentUri),i=this._documents.get(T);i&&this._createExtHostEditor(i,n.id,n)}const S=[];if(l.value.removedEditors)for(const n of l.value.removedEditors){const T=this._editors.get(n);T&&(this._editors.delete(n),this._activeNotebookEditor?.id===T.id&&(this._activeNotebookEditor=void 0),S.push(T))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(T=>this._editors.get(T)).filter(T=>!!T);const n=new Set;this._visibleNotebookEditors.forEach(T=>n.add(T.id));for(const T of this._editors.values()){const i=n.has(T.id);T._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(T=>T).filter(T=>T.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const S=p.ApiCommandArgument.String.with("notebookType","A notebook type"),n=new p.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new p.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>a.VSBuffer.wrap(i))],new p.ApiCommandResult("Notebook Data",i=>w.NotebookData.to(i.value))),T=new p.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new p.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new u.SerializableObjectWithBuffers(w.NotebookData.from(i)))],new p.ApiCommandResult("Bytes",i=>i.buffer));l.registerApiCommand(n),l.registerApiCommand(T)}}e.ExtHostNotebookController=y,y._notebookStatusBarItemProviderHandlePool=0}),define(Se[200],De([1,0,5,56,13,4,16,8]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class b{constructor(v,p){const w=b._Keys.nextId();v.$registerNotebookEditorDecorationType(w,k.NotebookDecorationRenderOptions.from(p)),this.value={key:w,dispose(){v.$removeNotebookEditorDecorationType(w)}}}}b._Keys=new D.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(v,p,w){this._logService=v,this._extHostRpc=p,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(v){return new b(this._extHostRpc.getProxy(L.MainContext.MainThreadNotebookEditors),v).value}$acceptEditorPropertiesChanged(v,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,p);const w=this._notebooksAndEditors.getEditorById(v);p.visibleRanges&&w._acceptVisibleRanges(p.visibleRanges.ranges.map(k.NotebookRange.to)),p.selections&&w._acceptSelections(p.selections.selections.map(k.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const p in v)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(k.ViewColumn.to(v[p]))}};P=$e([ze(0,g.ILogService),ze(1,I.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(Se[96],De([1,0,15,14,20,5,7,22,2,26,13,4,36,8,6,66,167,21,39]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let _=class{constructor(o,r,t,s,m){this._initData=r,this._extHostNotebook=t,this._commands=s,this._logService=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(v.MainContext.MainThreadNotebookKernels);const d=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const O=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:O}}else if(C&&"notebookEditor"in C){const O=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:O}}return C})],p.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(o,r,t,s,m,d){for(const ge of this._kernelData.values())if(ge.controller.id===r&&P.ExtensionIdentifier.equals(o.identifier,ge.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,O=this;this._logService.trace(`NotebookController[${C}], CREATED by ${o.identifier.value}, ${r}`);const U=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${o.identifier}'`);let A=!1;const E=new I.DisposableStore,$=new L.Emitter,x=new L.Emitter,H={id:T(o.identifier,r),notebookType:t,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:s||o.identifier.value,preloads:d?d.map(w.NotebookRendererScript.from):[]};let oe=m??U,G;this._proxy.$addKernel(C,H).catch(ge=>{console.log(ge),A=!0});let M=0;const le=()=>{if(A)return;const ge=++M;Promise.resolve().then(()=>{ge===M&&this._proxy.$updateKernel(C,H)})},me=new k.ResourceMap,ae={get id(){return r},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return H.label},set label(ge){H.label=ge??o.displayName??o.name,le()},get detail(){return H.detail??""},set detail(ge){H.detail=ge,le()},get description(){return H.description??""},set description(ge){H.description=ge,le()},get kind(){return(0,c.checkProposedApiEnabled)(o,"notebookControllerKind"),H.kind??""},set kind(ge){(0,c.checkProposedApiEnabled)(o,"notebookControllerKind"),H.kind=ge,le()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ge){H.supportedLanguages=ge,le()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){H.supportsExecutionOrder=ge,le()},get rendererScripts(){return H.preloads?H.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(ge){oe=ge??U},get interruptHandler(){return G},set interruptHandler(ge){G=ge,H.supportsInterrupt=Boolean(ge),le()},createNotebookCellExecution(ge){if(A)throw new Error("notebook controller is DISPOSED");if(!me.has(ge.notebook.uri))throw O._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return O._createNotebookCellExecution(ge,T(o.identifier,this.id))},dispose:()=>{A||(this._logService.trace(`NotebookController[${C}], DISPOSED`),A=!0,this._kernelData.delete(C),E.dispose(),$.dispose(),x.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(ge,te){O._proxy.$updateNotebookPriority(C,ge.uri,te)},onDidReceiveMessage:x.event,postMessage(ge,te){return(0,c.checkProposedApiEnabled)(o,"notebookMessaging"),O._proxy.$postMessage(C,te&&O._extHostNotebook.getIdByEditor(te),ge)},asWebviewUri(ge){return(0,c.checkProposedApiEnabled)(o,"notebookMessaging"),(0,u.asWebviewUri)(ge,O._initData.remote)}};return this._kernelData.set(C,{extensionId:o.identifier,controller:ae,onDidReceiveMessage:x,onDidChangeSelection:$,associatedNotebooks:me}),ae}getIdByController(o){for(const[r,t]of this._kernelData)if(t.controller===o)return T(t.extensionId,o.id);return null}$acceptNotebookAssociation(o,r,t){const s=this._kernelData.get(o);if(s){const m=this._extHostNotebook.getNotebookDocument(b.URI.revive(r));t?s.associatedNotebooks.set(m.uri,!0):s.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,m.uri.toString(),t),s.onDidChangeSelection.fire({selected:t,notebook:m.apiNotebook})}}async $executeCells(o,r,t){const s=this._kernelData.get(o);if(!s)return;const m=this._extHostNotebook.getNotebookDocument(b.URI.revive(r)),d=[];for(const C of t){const O=m.getCell(C);O&&d.push(O.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,m.uri.toString(),d.length),await s.controller.executeHandler.call(s.controller,d,m.apiNotebook,s.controller)}catch(C){this._logService.error(`NotebookController[${o}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(o,r,t){const s=this._kernelData.get(o);if(!s)return;const m=this._extHostNotebook.getNotebookDocument(b.URI.revive(r));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,m.apiNotebook);else for(const d of t){const C=m.getCell(d);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,r,t){const s=this._kernelData.get(o);if(!s)return;const m=this._extHostNotebook.getEditorById(r);s.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:t}))}$cellExecutionChanged(o,r,t){const m=this._extHostNotebook.getNotebookDocument(b.URI.revive(o)).getCell(r);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:t?w.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o,r){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const m=new S(r,s,this._proxy);this._activeExecutions.set(s.uri,m);const d=m.onDidChangeState(()=>{m.state===l.Resolved&&(m.dispose(),d.dispose(),this._activeExecutions.delete(s.uri))});return m.asApiObject()}};_=$e([ze(4,R.ILogService)],_),e.ExtHostNotebookKernels=_;var l;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(l||(l={}));class S extends I.Disposable{constructor(o,r,t){super();this._cell=r,this._proxy=t,this._handle=S.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new g.CancellationTokenSource),this._collector=new n(10,s=>this.update(s)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,o,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const r=Array.isArray(o)?o:[o];return this._proxy.$updateExecution(this._handle,new y.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(o){return o.map(r=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?w.NotebookCellOutput.from(r):w.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(o,r,t){const s=this.validateAndConvertOutputs((0,a.asArray)(o));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,append:t,outputs:s})}async updateOutputItems(o,r,t){return o=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(o),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:o.map(w.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(t){o._executionOrder=t,o.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:o._executionOrder}])},start(t){if(o._state===l.Resolved||o._state===l.Started)throw new Error("Cannot call start again");o._state=l.Started,o._onDidChangeState.fire(),o.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,s){if(o._state===l.Resolved)throw new Error("Cannot call resolve twice");o._state=l.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._handle,new y.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:t}))},clearOutput(t){return o.verifyStateForOutput(),o.updateOutputs([],t,!1)},appendOutput(t,s){return o.verifyStateForOutput(),o.updateOutputs(t,s,!0)},replaceOutput(t,s){return o.verifyStateForOutput(),o.updateOutputs(t,s,!1)},appendOutputItems(t,s){return o.verifyStateForOutput(),o.updateOutputItems(t,s,!0)},replaceOutputItems(t,s){return o.verifyStateForOutput(),o.updateOutputItems(t,s,!1)}})}}S.HANDLE=0;class n{constructor(o,r){this.delay=o,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new D.DeferredPromise,this.startedTimer=Date.now(),(0,D.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>o.complete())}}function T(i,o){return`${i.value}/${o}`}e.createKernelId=T}),define(Se[201],De([1,0,5,7,22,13,4,96,21]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookProxyKernels=void 0;let P=class{constructor(v,p,w){this.extHostNotebook=p,this._logService=w,this._proxyKernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new a.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=v.getProxy(I.MainContext.MainThreadNotebookProxyKernels)}createNotebookProxyController(v,p,w,f,u){const h=this._handlePool++;let c=!1;const y=new D.DisposableStore,_=new a.Emitter,l={id:(0,k.createKernelId)(v.identifier,p),notebookType:w,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:f||v.identifier.value};let S=u;this._proxy.$addProxyKernel(h,l).catch(r=>{console.log(r),c=!0});let n=0;const T=()=>{if(c)return;const r=++n;Promise.resolve().then(()=>{r===n&&this._proxy.$updateProxyKernel(h,l)})},i=new g.ResourceMap,o={get id(){return p},get notebookType(){return l.notebookType},onDidChangeSelectedNotebooks:_.event,get label(){return l.label},set label(r){l.label=r??v.displayName??v.name,T()},get detail(){return l.detail??""},set detail(r){l.detail=r,T()},get description(){return l.description??""},set description(r){l.description=r,T()},get kind(){return(0,b.checkProposedApiEnabled)(v,"notebookControllerKind"),l.kind??""},set kind(r){(0,b.checkProposedApiEnabled)(v,"notebookControllerKind"),l.kind=r,T()},get resolveHandler(){return S},dispose:()=>{c||(this._logService.trace(`NotebookProxyController[${h}], DISPOSED`),c=!0,this._proxyKernelData.delete(h),y.dispose(),_.dispose(),this._proxy.$removeProxyKernel(h))}};return this._proxyKernelData.set(h,{extensionId:v.identifier,controller:o,onDidChangeSelection:_,associatedNotebooks:i}),o}async $resolveKernel(v){const p=this._proxyKernelData.get(v);if(!p)return null;const w=await p.controller.resolveHandler();return typeof w=="string"?w:this.extHostNotebook.getIdByController(w)}};P=$e([ze(2,L.ILogService)],P),e.ExtHostNotebookProxyKernels=P}),define(Se[202],De([1,0,5,4,90,21]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class I{constructor(b,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=b.getProxy(D.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(b,P,R){const v=this._extHostNotebook.getEditorById(b);this._rendererMessageEmitters.get(P)?.fire({editor:v.apiEditor,message:R})}createRendererMessaging(b,P){if(!b.contributes?.notebookRenderer?.some(w=>w.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const R=(0,L.isProposedApiEnabled)(b,"notebookEditor"),v=new WeakMap;return{onDidReceiveMessage:(w,f,u)=>{const h=R?w:c=>{const y={};v.set(y,c.editor),w({editor:y,message:c.message})};return this.getOrCreateEmitterFor(P).event(h,f,u)},postMessage:(w,f)=>{g.ExtHostNotebookEditor.apiEditorsToExtHost.has(w)&&([w,f]=[f,w]);const u=R?f:v.get(f),h=u&&g.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(h?.id,P,w)}}}getOrCreateEmitterFor(b){let P=this._rendererMessageEmitters.get(b);return P||(P=new a.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(b)}}),this._rendererMessageEmitters.set(b,P),P)}}e.ExtHostNotebookRenderers=I}),define(Se[203],De([1,0,20,5,7,4,2,6,12,15,32,62,21]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(f,u,h){const c=f.getProxy(L.MainContext.MainThreadQuickOpen);class y{constructor(t,s){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=s}showQuickPick(t,s,m=a.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(t),C=++this._instances,O=c.$show(C,{title:s?.title,placeHolder:s?.placeHolder,matchOnDescription:s?.matchOnDescription,matchOnDetail:s?.matchOnDetail,ignoreFocusLost:s?.ignoreFocusOut,canPickMany:s?.canPickMany},m),U={},A=O.then(()=>U);return Promise.race([A,d]).then(E=>{if(E!==U)return d.then($=>{const x=[];for(let H=0;H<$.length;H++){const oe=$[H];typeof oe=="string"?x.push({label:oe,handle:H}):oe.kind===k.QuickPickItemKind.Separator?x.push({type:"separator",label:oe.label}):x.push({label:oe.label,description:oe.description,detail:oe.detail,picked:oe.picked,alwaysShow:oe.alwaysShow,handle:H})}return s&&typeof s.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{s.onDidSelectItem($[H])}),c.$setItems(C,x),O.then(H=>{if(typeof H=="number")return $[H];if(Array.isArray(H))return H.map(oe=>$[oe])})})}).then(void 0,E=>{if(!(0,b.isCancellationError)(E))return c.$setError(C,E),Promise.reject(E)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,s=a.CancellationToken.None){return this._validateInput=t?t.validateInput2??t.validateInput:void 0,c.$input(t,typeof this._validateInput=="function",s).then(void 0,m=>{if(!(0,b.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(t){if(!this._validateInput)return;const s=await this._validateInput(t);if(!s||typeof s=="string")return s;let m;switch(s.severity){case k.InputBoxValidationSeverity.Info:m=R.default.Info;break;case k.InputBoxValidationSeverity.Warning:m=R.default.Warning;break;case k.InputBoxValidationSeverity.Error:m=R.default.Error;break;default:m=s.message?R.default.Error:R.default.Ignore;break}return{content:s.message,severity:m}}async showWorkspaceFolderPick(t,s=a.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!m)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(C=>C.uri.toString()===m.uri.toString())}createQuickPick(t){const s=new i(t,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}createInputBox(t){const s=new o(t,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(t,s){const m=this._sessions.get(t);m&&m._fireDidChangeValue(s)}$onDidAccept(t){const s=this._sessions.get(t);s&&s._fireDidAccept()}$onDidChangeActive(t,s){const m=this._sessions.get(t);m instanceof i&&m._fireDidChangeActive(s)}$onDidChangeSelection(t,s){const m=this._sessions.get(t);m instanceof i&&m._fireDidChangeSelection(s)}$onDidTriggerButton(t,s){const m=this._sessions.get(t);m&&m._fireDidTriggerButton(s)}$onDidTriggerItemButton(t,s,m){const d=this._sessions.get(t);d instanceof i&&d._fireDidTriggerItemButton(s,m)}$onDidHide(t){const s=this._sessions.get(t);s&&s._fireDidHide()}}class _{constructor(t,s){this._extensionId=t,this._onDidDispose=s,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((s,m)=>{const d=s===k.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(d,s)}),this.update({buttons:t.map((s,m)=>({...T(s),tooltip:s.tooltip,handle:s===k.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const s=this._handlesToButtons.get(t);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,g.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(t){if(!this._disposed){for(const s of Object.keys(t)){const m=t[s];this._pendingUpdate[s]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function l(r){if(r instanceof k.ThemeIcon)return{id:r.id};const t=n(r),s=S(r);return{dark:typeof t=="string"?I.URI.file(t):t,light:typeof s=="string"?I.URI.file(s):s}}function S(r){return typeof r=="object"&&"light"in r?r.light:r}function n(r){return typeof r=="object"&&"dark"in r?r.dark:r}function T(r){const t=l(r.iconPath);let s,m;return"id"in t?m=v.ThemeIcon.asClassName(t):s=t,{iconPath:s,iconClass:m}}class i extends _{constructor(t,s){super(t.identifier,s);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((m,d)=>{this._handlesToItems.set(d,m),this._itemsToHandles.set(m,d)});const s=[];for(let m=0;m<t.length;m++){const d=t[m];d.kind===k.QuickPickItemKind.Separator?s.push({type:"separator",label:d.label}):s.push({handle:m,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((C,O)=>({...T(C),tooltip:C.tooltip,handle:O}))})}this.update({items:s})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(t){const s=(0,P.coalesce)(t.map(m=>this._handlesToItems.get(m)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(t){const s=(0,P.coalesce)(t.map(m=>this._handlesToItems.get(m)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}_fireDidTriggerItemButton(t,s){const m=this._handlesToItems.get(t);if(!m||!m.buttons||!m.buttons.length)return;const d=m.buttons[s];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:m})}}class o extends _{constructor(t,s){super(t.identifier,s);this.extension=t,this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?R.default.Error:R.default.Ignore})}get validationMessage2(){return this._validationMessage2}set validationMessage2(t){(0,p.checkProposedApiEnabled)(this.extension,"inputBoxSeverity"),this._validationMessage2=t,t?typeof t=="string"?this.update({validationMessage:t,severity:R.default.Error}):this.update({validationMessage:t.message,severity:t.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new y(u,h)}e.createExtHostQuickOpen=w});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[204],De([1,0,2,5,55,7,14,4,15,111,13,26,62,8,21]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f){"use strict";var u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(m){if(m)return typeof m.iconPath=="string"?a.URI.file(m.iconPath):a.URI.isUri(m.iconPath)||p.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function y(m,d){if(!m.iconPath&&!d.iconPath)return 0;if(m.iconPath){if(!d.iconPath)return 1}else return-1;const C=typeof m.iconPath=="string"?m.iconPath:a.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,O=typeof d.iconPath=="string"?d.iconPath:a.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,P.comparePaths)(C,O)}function _(m,d){let C=0;if(m.strikeThrough!==d.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==d.faded)return m.faded?1:-1;if(m.tooltip!==d.tooltip)return(m.tooltip||"").localeCompare(d.tooltip||"");if(C=y(m,d),C!==0)return C;if(m.light&&d.light)C=y(m.light,d.light);else{if(m.light)return 1;if(d.light)return-1}if(C!==0)return C;if(m.dark&&d.dark)C=y(m.dark,d.dark);else{if(m.dark)return 1;if(d.dark)return-1}return C}function l(m,d){if(m.command!==d.command)return m.command<d.command?-1:1;if(m.title!==d.title)return m.title<d.title?-1:1;if(m.tooltip!==d.tooltip){if(m.tooltip!==void 0&&d.tooltip!==void 0)return m.tooltip<d.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(m.arguments===d.arguments)return 0;if(m.arguments)if(d.arguments){if(m.arguments.length!==d.arguments.length)return m.arguments.length-d.arguments.length}else return 1;else return-1;for(let C=0;C<m.arguments.length;C++){const O=m.arguments[C],U=d.arguments[C];if(O!==U)return O<U?-1:1}return 0}function S(m,d){let C=(0,P.comparePaths)(m.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(C!==0)return C;if(m.command&&d.command)C=l(m.command,d.command);else{if(m.command)return 1;if(d.command)return-1}if(C!==0)return C;if(m.decorations&&d.decorations)C=_(m.decorations,d.decorations);else{if(m.decorations)return 1;if(d.decorations)return-1}return C}function n(m,d){for(let C=0;C<m.length;C++)if(m[C]!==d[C])return!1;return!0}function T(m,d){return m.command===d.command&&m.title===d.title&&m.tooltip===d.tooltip&&(m.arguments&&d.arguments?n(m.arguments,d.arguments):m.arguments===d.arguments)}function i(m,d){return(0,b.equals)(m,d,T)}class o{constructor(d,C,O){this._extension=d,this._sourceControlHandle=O,u.set(this,void 0),this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._visible=!0,Qe(this,u,C,"f")}get value(){return this._value}set value(d){d=d??"",Re(this,u,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Re(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Re(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Re(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,C){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Re(this,u,"f").$showValidationMessage(this._sourceControlHandle,d,C)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=o,u=new WeakMap;class r{constructor(d,C,O,U,A){this._proxy=d,this._commands=C,this._sourceControlHandle=O,this._id=U,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,C){const O=this._resourceStatesCommandsMap.get(d);return O?(0,I.asPromise)(()=>this._commands.executeCommand(O.command,...O.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(S),O=(0,b.sortedDiff)(this._resourceSnapshot,d,S).map(E=>{const $=E.toInsert.map(x=>{const H=this._resourceHandlePool++;this._resourceStatesMap.set(H,x);const oe=x.resourceUri;let G;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const pe=new L.DisposableStore;G=this._commands.converter.toInternal(x.command,pe),this._resourceStatesDisposablesMap.set(H,pe)}else this._resourceStatesCommandsMap.set(H,x.command);const M=c(x.decorations),le=x.decorations&&c(x.decorations.light)||M,me=x.decorations&&c(x.decorations.dark)||M,ae=[le,me],ge=x.decorations&&x.decorations.tooltip||"",te=x.decorations&&!!x.decorations.strikeThrough,Ee=x.decorations&&!!x.decorations.faded,we=x.contextValue||"";return{rawResource:[H,oe,ae,ge,te,Ee,we,G],handle:H}});return{start:E.start,deleteCount:E.deleteCount,toInsert:$}}),U=O.map(({start:E,deleteCount:$,toInsert:x})=>[E,$,x.map(H=>H.rawResource)]),A=O.reverse();for(const{start:E,deleteCount:$,toInsert:x}of A){const H=x.map(G=>G.handle),oe=this._handlesSnapshot.splice(E,$,...H);for(const G of oe)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),this._resourceStatesDisposablesMap.get(G)?.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=d,U}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(d,C,O,U,A,E){this._extension=d,this._commands=O,this._id=U,this._label=A,this._rootUri=E,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Qe(this,h,C,"f"),this._inputBox=new o(d,Re(this,h,"f"),this.handle),Re(this,h,"f").$registerSourceControl(this.handle,U,A,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Re(this,h,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Re(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Re(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=d;const C=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Re(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=d;const C=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),description:d.description}:void 0;Re(this,h,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&i(this._statusBarCommands,d))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=d;const C=(d||[]).map(O=>this._commands.converter.toInternal(O,this._statusBarDisposables.value));Re(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(d,C){const O=new r(Re(this,h,"f"),this._commands,this.handle,d,C),U=D.Event.once(O.onDidDispose)(()=>this.createdResourceGroups.delete(O));return this.createdResourceGroups.set(O,U),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const d=[],C=[];for(const[O,U]of this.createdResourceGroups){U.dispose();const A=O.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(O),this.eventuallyUpdateResourceStates()});D.Event.once(O.onDidDispose)(()=>{this.updatedResourceGroups.delete(O),A.dispose(),this._groups.delete(O.handle),Re(this,h,"f").$unregisterGroup(this.handle,O.handle)}),d.push([O.handle,O.id,O.label,O.features]);const E=O._takeResourceStateSnapshot();E.length>0&&C.push([O.handle,E]),this._groups.set(O.handle,O)}Re(this,h,"f").$registerGroups(this.handle,d,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(C=>{const O=C._takeResourceStateSnapshot();O.length!==0&&d.push([C.handle,O])}),d.length>0&&Re(this,h,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Re(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,t._handlePool=0,$e([(0,g.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),$e([(0,g.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let s=class Qi{constructor(d,C,O){this._commands=C,this.logService=O,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=d.getProxy(k.MainContext.MainThreadSCM),this._telemetry=d.getProxy(k.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const A=this._sourceControls.get(U.sourceControlHandle);if(!A)return U;const E=A.getResourceGroup(U.groupHandle);return E?E.getResourceState(U.handle):U}else if(U&&U.$mid===4){const A=this._sourceControls.get(U.sourceControlHandle);return A?A.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const A=this._sourceControls.get(U.handle);return A||U}return U}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,C,O,U){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,C,O,U),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const A=Qi._handlePool++,E=new t(d,this._proxy,this._commands,C,O,U);this._sourceControls.set(A,E);const $=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(d.identifier))||[];return $.push(E),this._sourceControlsByExtension.set(v.ExtensionIdentifier.toKey(d.identifier),$),E}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const C=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(d.identifier)),O=C&&C[C.length-1];return O&&O.inputBox}$provideOriginalResource(d,C,O){const U=a.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,U.toString());const A=this._sourceControls.get(d);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(U,O)).then(E=>E||null)}$onInputBoxValueChange(d,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const O=this._sourceControls.get(d);return O&&O.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(d,C,O,U){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,C,O);const A=this._sourceControls.get(d);if(!A)return Promise.resolve(void 0);const E=A.getResourceGroup(C);return E?E.$executeResourceCommand(O,U):Promise.resolve(void 0)}$validateInput(d,C,O){this.logService.trace("ExtHostSCM#$validateInput",d);const U=this._sourceControls.get(d);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>U.inputBox.validateInput(C,O)).then(A=>{if(!A)return Promise.resolve(void 0);const E=w.MarkdownString.fromStrict(A.message);return E?Promise.resolve([E,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};s._handlePool=0,s=$e([ze(2,R.ILogService)],s),e.ExtHostSCM=s});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[205],De([1,0,6,4,131,7,8,10]),function(ee,e,a,D,g,L,I,k){"use strict";var b,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(f,u,h,c,y=a.StatusBarAlignment.Left,_){b.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new L.DisposableStore,Qe(this,b,f,"f"),Qe(this,P,u,"f"),this._entryId=R.ID_GEN++,this._extension=h,this._id=c,this._alignment=y,this._priority=this.validatePriority(_)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!R.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Re(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Re(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let u;this._name?u=this._name:u=(0,g.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const c=I.MarkdownString.fromStrict(this._tooltip);Re(this,b,"f").$setEntry(this._entryId,f,u,this._text,c,this._command?.internal,h,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,b=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class v{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,g.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const u={message:f};return this._messages.unshift(u),this._update(),new a.Disposable(()=>{const h=this._messages.indexOf(u);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class p{constructor(f,u){this._proxy=f.getProxy(D.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new v(this)}createStatusBarEntry(f,u,h,c){return new R(this._proxy,this._commands,f,u,h,c)}setStatusBarMessage(f,u){const h=this._statusMessage.setMessage(f);let c;return typeof u=="number"?c=setTimeout(()=>h.dispose(),u):typeof u!="undefined"&&u.then(()=>h.dispose(),()=>h.dispose()),new a.Disposable(()=>{h.dispose(),clearTimeout(c)})}}e.ExtHostStatusBar=p}),define(Se[71],De([1,0,4,5,3]),function(ee,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(k){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,b){this._proxy.$registerExtensionStorageKeysToSync(k,b)}initializeExtensionStorage(k,b,P){return this._proxy.$initializeExtensionStorage(k,b).then(R=>R||P)}setValue(k,b,P){return this._proxy.$setValue(k,b,P)}$acceptValue(k,b,P){this._onDidChangeStorage.fire({shared:k,key:b,value:P})}}e.ExtHostStorage=L,e.IExtHostStorage=(0,g.createDecorator)("IExtHostStorage")}),define(Se[72],De([1,0,3,28,13,51,2]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,R,v){this._logService=R,this._extHostFileSystem=v,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(P){return I.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(P){if(this._value)return I.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return I.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([ze(0,D.IExtHostInitDataService),ze(1,g.ILogService),ze(2,L.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(Se[52],De([1,0,5,4,3,2,16,7,6,132,12,169,20,42,152,62,10,14]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,g.createDecorator)("IExtHostTerminalService");class y{constructor(t,s,m,d){this._proxy=t,this._id=s,this._creationOptions=m,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(O=>this._pidPromiseComplete=O);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(O,U=!0){C._checkDisposed(),C._proxy.$sendText(C._id,O,U)},show(O){C._checkDisposed(),C._proxy.$show(C._id,O)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(t,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,h.withNullAsUndefined)(t.shellPath),shellArgs:(0,h.withNullAsUndefined)(t.shellArgs),cwd:(0,h.withNullAsUndefined)(t.cwd),env:(0,h.withNullAsUndefined)(t.env),icon:(0,h.withNullAsUndefined)(i(t.iconPath)),color:u.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,h.withNullAsUndefined)(t.message),strictEnv:(0,h.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(t.location,s?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,s,m,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:u.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(t,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,s){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,s){return t===this._cols&&s===this._rows||t===0||s===0?!1:(this._cols=t,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=y;class _{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,s){this._pty.setDimensions?.({columns:t,rows:s})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let l=1,S=class extends k.Disposable{constructor(t,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[m,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,s){const m=new y(this._proxy,(0,w.generateUuid)(),t,t.name),d=new _(t.pty);return m.createExtensionTerminal(t.location,this._serializeParentTerminal(t,s).resolvedExtHostIdentifier,i(t.iconPath),o(t.color)).then(C=>{const O=this._setupExtHostProcessListeners(C,d);this._terminalProcessDisposables[C]=O}),this._terminals.push(m),m.value}_serializeParentTerminal(t,s){if(s=s||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const m=t.location.parentTerminal;if(m){const d=this._terminals.find(C=>C.value===m);d&&(s.resolvedExtHostIdentifier=d._id)}}else t.location&&typeof t.location!="object"?s.location=t.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(t,s){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const d=new _(s),C=this._setupExtHostProcessListeners(t,d);this._terminalProcessDisposables[t]=C}async $acceptActiveTerminalChanged(t){const s=this._activeTerminal;if(t===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(t);m&&(this._activeTerminal=m,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,s){const m=this._getTerminalById(t);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:s})}async $acceptTerminalDimensions(t,s,m){const d=this._getTerminalById(t);d&&d.setDimensions(s,m)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(t,s,m){this._terminalProcesses.get(t)?.resize(s,m)}async $acceptTerminalTitleChange(t,s){const m=this._getTerminalById(t);m&&(m.name=s)}async $acceptTerminalClosed(t,s){const m=this._getTerminalObjectIndexById(this._terminals,t);if(m!==null){const d=this._terminals.splice(m,1)[0];d.setExitCode(s),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(t,s,m,d){if(s){const U=this._getTerminalObjectIndexById(this._terminals,s);if(U!==null){this._terminals[U]._id=t,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const C={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:L.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},O=new y(this._proxy,t,C,m);this._terminals.push(O),this._onDidOpenTerminal.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(t,s){const m=this._getTerminalById(t);m&&m._setProcessId(s)}async $startExtensionTerminal(t,s){const m=this._getTerminalById(t);if(!m)return{message:(0,P.localize)(0,null,t)};m.isOpen||await new Promise(C=>{const O=this.onDidOpenTerminal(async U=>{U===m.value&&(O.dispose(),C())})});const d=this._terminalProcesses.get(t);d?d.startSendingEvents(s):this._extensionTerminalAwaitingStart[t]={initialDimensions:s}}_setupExtHostProcessListeners(t,s){const m=new k.DisposableStore;m.add(s.onProcessReady(C=>this._proxy.$sendProcessReady(t,C.pid,C.cwd))),m.add(s.onDidChangeProperty(C=>this._proxy.$sendProcessProperty(t,C))),this._bufferer.startBuffering(t,s.onProcessData),m.add(s.onProcessExit(C=>this._onProcessExit(t,C))),this._terminalProcesses.set(t,s);const d=this._extensionTerminalAwaitingStart[t];return d&&s instanceof _&&(s.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),m}$acceptProcessAckDataEvent(t,s){this._terminalProcesses.get(t)?.acknowledgeDataEvent(s)}$acceptProcessInput(t,s){this._terminalProcesses.get(t)?.input(s)}$acceptTerminalInteraction(t){const s=this._getTerminalById(t);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(t,s,m){try{this._terminalProcesses.get(t)?.resize(s,m)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(t,s){this._terminalProcesses.get(t)?.shutdown(s)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(s=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:s}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,s,m){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,m),this._proxy.$registerProfileProvider(s,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(t,s){const m=new p.CancellationTokenSource().token;let d=await this._profileProviders.get(t)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,s);return}this.createTerminalFromOptions(d.options,s)}}async $provideLinks(t,s){const m=this._getTerminalById(t);if(!m)return[];this._terminalLinkCache.delete(t);const d=this._terminalLinkCancellationSource.get(t);d&&d.dispose(!0);const C=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,C);const O=[],U={terminal:m.value,line:s},A=[];for(const x of this._linkProviders)A.push(c.Promises.withAsyncBody(async H=>{C.token.onCancellationRequested(()=>H({provider:x,links:[]}));const oe=await x.provideTerminalLinks(U,C.token)||[];C.token.isCancellationRequested||H({provider:x,links:oe})}));const E=await Promise.all(A);if(C.token.isCancellationRequested)return[];const $=new Map;for(const x of E)x&&x.links.length>0&&O.push(...x.links.map(H=>{const oe={id:l++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return $.set(oe.id,{provider:x.provider,link:H}),oe}));return this._terminalLinkCache.set(t,$),O}$activateLink(t,s){const m=this._terminalLinkCache.get(t)?.get(s);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(t,s){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const m=this._terminalProcessDisposables[t];m&&(m.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,s)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,s){const m=this._getTerminalObjectIndexById(t,s);return m!==null?t[m]:null}_getTerminalObjectIndexById(t,s){let m=null;return t.some((d,C)=>d._id===s?(m=C,!0):!1),m}getEnvironmentVariableCollection(t){let s=this._environmentVariableCollections.get(t.identifier.value);return s||(s=new n,this._setEnvironmentVariableCollection(t.identifier.value,s)),s}_syncEnvironmentVariableCollection(t,s){const m=(0,v.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(t,s.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(t){t.forEach(s=>{const m=s[0],d=new n(s[1]);this._setEnvironmentVariableCollection(m,d)})}$acceptDefaultProfile(t,s){this._defaultProfile=t,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(t,s){this._environmentVariableCollections.set(t,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,s)})}};S=$e([ze(1,I.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class n{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,s){this._setIfDiffers(t,{value:s,type:b.EnvironmentVariableMutatorType.Replace})}append(t,s){this._setIfDiffers(t,{value:s,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,s){this._setIfDiffers(t,{value:s,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,s){const m=this.map.get(t);(!m||m.value!==s.value||m.type!==s.type)&&(this.map.set(t,s),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,s){this.map.forEach((m,d)=>t.call(s,d,m,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let T=class extends S{constructor(t){super(!1,t)}createTerminal(t,s,m){throw new R.NotSupportedError}createTerminalFromOptions(t,s){throw new R.NotSupportedError}};T=$e([ze(0,I.IExtHostRpcService)],T),e.WorkerExtHostTerminalService=T;function i(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function o(r){return u.ThemeColor.isThemeColor(r)?r:void 0}});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[206],De([1,0,15,25,20,5,237,95,7,27,10,42,4,16,91,8,6,46,67,47]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_){"use strict";var l,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(A,E){this.resultsChangedEmitter=new L.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(p.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new i(this.proxy),E.registerArgumentProcessor({processArgument:$=>$?.$mid===13?(0,f.toItemFromContext)($):$})}createTestController(A,E,$){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const x=new b.DisposableStore,H=x.add(new f.ExtHostTestItemCollection(A,E));H.root.label=E;const oe=new Map,G=this.proxy,M={items:H.root.children,get label(){return E},set label(me){E=me,H.root.label=me,G.$updateController(A,{label:E})},get refreshHandler(){return $},set refreshHandler(me){$=me,G.$updateController(A,{canRefresh:!!me})},get id(){return A},createRunProfile:(me,ae,ge,te,Ee)=>{let we=(0,k.hash)(me);for(;oe.has(we);)we++;return new C(this.proxy,oe,A,we,me,ae,ge,te,Ee)},createTestItem(me,ae,ge){return new f.TestItemImpl(A,me,ae,ge)},createTestRun:(me,ae,ge=!0)=>this.runTracker.createTestRun(A,H,me,ae,ge),set resolveHandler(me){H.resolveHandler=me},get resolveHandler(){return H.resolveHandler},dispose:()=>{x.dispose()}};G.$registerTestController(A,E,!!$),x.add((0,b.toDisposable)(()=>G.$unregisterTestController(A)));const le={controller:M,collection:H,profiles:oe};return this.controllers.set(A,le),x.add((0,b.toDisposable)(()=>this.controllers.delete(A))),x.add(H.onDidGenerateDiff(me=>G.$publishDiff(A,me.map(_.TestsDiffOp.serialize)))),M}createTestObserver(){return this.observer.checkout()}async runTests(A,E=g.CancellationToken.None){const $=o(A);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const x=this.controllers.get($.controllerId);if(!x)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:A.include?.map(H=>c.TestId.fromExtHostTestItem(H,x.collection.root.id).toString())??[x.collection.root.id],profileGroup:O[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:A.exclude?.map(H=>H.id)},E)}$provideFileCoverage(A,E,$){return(0,a.mapFind)(this.runTracker.trackers,H=>H.id===A?H.getCoverage(E):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(A,E,$,x){return(0,a.mapFind)(this.runTracker.trackers,oe=>oe.id===A?oe.getCoverage(E):void 0)?.resolveFileCoverage($,x)??Promise.resolve([])}$configureRunProfile(A,E){this.controllers.get(A)?.profiles.get(E)?.configureHandler?.()}async $refreshTests(A,E){await this.controllers.get(A)?.controller.refreshHandler?.(E)}$publishTestResults(A){this.results=Object.freeze(A.map(E=>(0,P.deepFreeze)(u.TestResults.to(E))).concat(this.results).sort((E,$)=>$.completedAt-E.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,E){const $=this.controllers.get(c.TestId.fromString(A).controllerId)?.collection;$&&(await $.expand(A,E<0?1/0:E),$.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A.map(_.TestsDiffOp.deserialize))}async $runControllerTests(A,E){const $=this.controllers.get(A.controllerId);if(!$)return;const{collection:x,profiles:H}=$,oe=H.get(A.profileId);if(!oe)return;const G=A.testIds.map(ae=>x.tree.get(ae)).filter(R.isDefined),M=A.excludeExtIds.map(ae=>$.collection.tree.get(ae)).filter(R.isDefined).filter(ae=>G.some(ge=>ge.fullId.compare(ae.fullId)===2));if(!G.length)return;const le=new h.TestRunRequest(G.some(ae=>ae.actual instanceof f.TestItemRootImpl)?void 0:G.map(ae=>ae.actual),M.map(ae=>ae.actual),oe),me=this.runTracker.prepareForMainThreadTestRun(le,r.fromInternal(A,$.collection),E);try{await oe.runHandler(le,E)}finally{me.isRunning&&!E.isCancellationRequested&&await L.Event.toPromise(me.onEnd),me.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};n=$e([ze(0,w.IExtHostRpcService)],n),e.ExtHostTesting=n;class T extends b.Disposable{constructor(A,E,$){super();this.dto=A,this.proxy=E,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new L.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new g.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:x}of this.tasks.values())x.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const E=this.dto.id,$=this.dto.controllerId,x=(0,v.generateUuid)(),H=new t(this.proxy,E,x),oe=me=>(ae,...ge)=>{if(M){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ae)||(this.ensureTestIsKnown(ae),me(ae,...ge))},G=(me,ae)=>{const ge=ae instanceof Array?ae.map(u.TestMessage.from):[u.TestMessage.from(ae)];if(me.uri&&me.range){const te={range:u.Range.from(me.range),uri:me.uri};for(const Ee of ge)Ee.location=Ee.location||te}this.proxy.$appendTestMessagesInRun(E,x,c.TestId.fromExtHostTestItem(me,$).toString(),ge)};let M=!1;const le={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return H.coverageProvider},set coverageProvider(me){H.coverageProvider=me},enqueued:oe(me=>{this.proxy.$updateTestStateInRun(E,x,c.TestId.fromExtHostTestItem(me,$).toString(),1)}),skipped:oe(me=>{this.proxy.$updateTestStateInRun(E,x,c.TestId.fromExtHostTestItem(me,$).toString(),5)}),started:oe(me=>{this.proxy.$updateTestStateInRun(E,x,c.TestId.fromExtHostTestItem(me,$).toString(),2)}),errored:oe((me,ae,ge)=>{G(me,ae),this.proxy.$updateTestStateInRun(E,x,c.TestId.fromExtHostTestItem(me,$).toString(),6,ge)}),failed:oe((me,ae,ge)=>{G(me,ae),this.proxy.$updateTestStateInRun(E,x,c.TestId.fromExtHostTestItem(me,$).toString(),4,ge)}),passed:oe((me,ae)=>{this.proxy.$updateTestStateInRun(E,x,c.TestId.fromExtHostTestItem(me,this.dto.controllerId).toString(),3,ae)}),appendOutput:(me,ae,ge)=>{M||(ge&&(this.dto.isIncluded(ge)?this.ensureTestIsKnown(ge):ge=void 0),this.proxy.$appendOutputToRun(E,x,D.VSBuffer.fromString(me),ae&&u.location.from(ae),ge&&c.TestId.fromExtHostTestItem(ge,$).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(E,x),this.tasks.delete(x),this.isRunning||this.dispose())}};return this.tasks.set(x,{run:le,coverage:H}),this.proxy.$startedTestRunTask(E,{id:x,name:A,running:!0}),le}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof f.TestItemImpl))throw new y.InvalidTestItemError(A.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const E=[],$=this.dto.colllection.root;for(;;){const x=u.TestItem.from(A);if(E.unshift(x),this.sharedTestIds.has(x.extId)||(this.sharedTestIds.add(x.extId),A===$))break;A=A.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,E)}}class i{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,E,$){return this.getTracker(A,E,$)}cancelRunById(A){for(const E of this.tracked.values())if(E.id===A){E.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,E,$,x,H){const oe=this.tracked.get($);if(oe)return oe.createRun(x);const G=r.fromPublic(A,E,$,H),M=o($);this.proxy.$startedExtensionTestRun({controllerId:A,profile:M&&{group:O[M.kind],id:M.profileId},exclude:$.exclude?.map(me=>c.TestId.fromExtHostTestItem(me,E.root.id).toString())??[],id:G.id,include:$.include?.map(me=>c.TestId.fromExtHostTestItem(me,E.root.id).toString())??[E.root.id],persist:H});const le=this.getTracker($,G);return le.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),le.createRun(x)}getTracker(A,E,$){const x=new T(E,this.proxy,$);return this.tracked.set(A,x),x.onEnd(()=>this.tracked.delete(A)),x}}e.TestRunCoordinator=i;const o=U=>{if(!!U.profile){if(!(U.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class r{constructor(A,E,$,x,H,oe){this.controllerId=A,this.id=E,this.isPersisted=H,this.colllection=oe,this.includePrefix=$.map(G=>G+"\0"),this.excludePrefix=x.map(G=>G+"\0")}static fromPublic(A,E,$,x){return new r(A,(0,v.generateUuid)(),$.include?.map(H=>c.TestId.fromExtHostTestItem(H,A).toString())??[A],$.exclude?.map(H=>c.TestId.fromExtHostTestItem(H,A).toString())??[],x,E)}static fromInternal(A,E){return new r(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,E)}isIncluded(A){const E=c.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(E===$||E.startsWith($))return!1;for(const $ of this.includePrefix)if(E===$||E.startsWith($))return!0;return!1}}e.TestRunDto=r;class t{constructor(A,E,$){this.proxy=A,this.runId=E,this.taskId=$}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(E){throw this.fileCoverage=void 0,E}}async resolveFileCoverage(A,E){const $=await this.fileCoverage;let x=$?.[A];return!this._coverageProvider||!$||!x?[]:(x.detailedCoverage||(x=$[A]=await this._coverageProvider.resolveFileCoverage?.(x,E)??x),x.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class s extends _.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,u.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:E,removed:$}=this;return{get added(){return[...A].map(x=>x.revived)},get updated(){return[...E].map(x=>x.revived)},get removed(){return[...$].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new L.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,E){return{...A,revived:u.TestItem.toPlain(A.item),depth:E?E.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=m;class d{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(E=>E.revived)},dispose:(0,I.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class C{constructor(A,E,$,x,H,oe,G,M=!1,le=void 0){this.controllerId=$,this.profileId=x,this._label=H,this.kind=oe,this.runHandler=G,this._isDefault=M,this._tag=le,l.set(this,void 0),S.set(this,void 0),Qe(this,l,A,"f"),Qe(this,S,E,"f"),E.set(x,this);const me=O[oe];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${oe}`);Re(this,l,"f").$publishTestRunProfile({profileId:x,controllerId:$,tag:le?u.TestTag.namespace(this.controllerId,le.id):null,label:H,group:me,isDefault:M,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?u.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Re(this,S,"f")?.delete(this.profileId)&&(Qe(this,S,void 0,"f"),Re(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,l=new WeakMap,S=new WeakMap;const O={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Se[207],De([1,0,15,5,4,92,8,6]),function(ee,e,a,D,g,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(R,v){this._extHostDocumentsAndEditors=v,this._onDidChangeTextEditorSelection=new D.Emitter,this._onDidChangeTextEditorOptions=new D.Emitter,this._onDidChangeTextEditorVisibleRanges=new D.Emitter,this._onDidChangeTextEditorViewColumn=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(g.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const v=this._extHostDocumentsAndEditors.allEditors();return R?v:v.map(p=>p.value)}async showTextDocument(R,v,p){let w;typeof v=="number"?w={position:I.ViewColumn.from(v),preserveFocus:p}:typeof v=="object"?w={position:I.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?I.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:w={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(R.uri,w),u=f&&this._extHostDocumentsAndEditors.getEditor(f);if(u)return u.value;throw f?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,v){return new L.TextEditorDecorationType(this._proxy,R,v).value}$acceptEditorPropertiesChanged(R,v){const p=this._extHostDocumentsAndEditors.getEditor(R);if(!p)throw new Error("unknown text editor");if(v.options&&p._acceptOptions(v.options),v.selections){const w=v.selections.selections.map(I.Selection.to);p._acceptSelections(w)}if(v.visibleRanges){const w=a.coalesce(v.visibleRanges.map(I.Range.to));p._acceptVisibleRanges(w)}if(v.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...v.options,lineNumbers:I.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const w=k.TextEditorSelectionChangeKind.fromValue(v.selections.source),f=v.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:f,kind:w})}if(v.visibleRanges){const w=a.coalesce(v.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:w})}}$acceptEditorPositionData(R){for(const v in R){const p=this._extHostDocumentsAndEditors.getEditor(v);if(!p)throw new Error("Unknown text editor");const w=I.ViewColumn.to(R[v]);p.value.viewColumn!==w&&(p._acceptViewColumn(w),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:w}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=b}),define(Se[208],De([1,0,2,3,4,7,6,8,10]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class P{constructor(p,w){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(g.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const u=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(R(u))?.get(f.handle)}return f}})}async $getTimeline(p,w,f,u){return this._providers.get(p)?.provideTimeline(a.URI.revive(w),f,u)}registerTimelineProvider(p,w,f,u){const h=new L.DisposableStore,c=this.convertTimelineItem(w.id,u,h).bind(this);let y;w.onDidChange&&(y=w.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:w.id}),this));const _=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...w,scheme:p,onDidChange:void 0,async provideTimeline(l,S,n){S?.resetCache&&(h.clear(),_.get(w.id)?.clear());const T=await w.provideTimeline(l,S,n);if(T==null)return;const i=c(l,S);return{...T,source:w.id,items:T.items.map(i)}},dispose(){for(const l of _.values())l.get(w.id)?.clear();y?.dispose(),h.dispose()}})}convertTimelineItem(p,w,f){return(u,h)=>{let c;if(h?.cacheResults){let y=this._itemsBySourceAndUriMap.get(p);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(p,y));const _=R(u);c=y.get(_),c===void 0&&(c=new Map,y.set(_,c))}return y=>{const{iconPath:_,...l}=y,S=`${p}|${y.id??y.timestamp}`;c?.set(S,y);let n,T,i;y.iconPath&&(_ instanceof I.ThemeIcon?i={id:_.id,color:_.color}:a.URI.isUri(_)?(n=_,T=_):{light:n,dark:T}=_);let o;return I.MarkdownString.isMarkdownString(l.tooltip)?o=k.MarkdownString.from(l.tooltip):(0,b.isString)(l.tooltip)?o=l.tooltip:I.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=k.MarkdownString.from(l.detail)):(0,b.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=l.detail),{...l,id:l.id??void 0,handle:S,source:p,command:y.command?w.toInternal(y.command,f):void 0,icon:n,iconDark:T,themeIcon:i,tooltip:o,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(p){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,p),(0,L.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=P;function R(v){return v?.toString()}}),define(Se[209],De([1,0,7,11,2,4]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(b){this._openers=new Map,this._proxy=b.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,P,R,v){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const p=v.schemes.find(w=>!I.supportedSchemes.has(w));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,v.schemes,b,v.label),(0,a.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(b,P,R){const v=this._openers.get(b);if(!v)throw new Error(`Unknown opener with id: ${b}`);const p=g.URI.revive(P);return v.canOpenExternalUri(p,R)}async $openUri(b,P,R){const v=this._openers.get(b);if(!v)throw new Error(`Unknown opener id: '${b}'`);return v.openExternalUri(g.URI.revive(P.resolvedUri),{sourceUri:g.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(Se[210],De([1,0,4,2,7,12,26]),function(ee,e,a,D,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(I.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const v=k.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(P)),this.handlers.set(v,R),this._proxy.$registerUriHandler(v,P),(0,g.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(P)),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(P,R){const v=this.handlers.get(P);if(!v)return Promise.resolve(void 0);try{v.handleUri(D.URI.revive(R))}catch(p){(0,L.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(P){return D.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[53],De([1,0,5,11,2,142,160,66,4]),function(ee,e,a,D,g,L,I,k,b){"use strict";var P,R,v,p,w,f,u,h,c,y,_,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class S{constructor(m,d,C,O,U,A,E){P.set(this,void 0),R.set(this,void 0),v.set(this,void 0),p.set(this,void 0),w.set(this,void 0),f.set(this,void 0),u.set(this,""),h.set(this,void 0),c.set(this,!1),y.set(this,!1),_.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new a.Emitter),this._onDidDispose=Re(this,l,"f").event,Qe(this,P,m,"f"),Qe(this,R,d,"f"),Qe(this,h,C,"f"),Qe(this,p,O,"f"),Qe(this,w,U,"f"),Qe(this,f,A,"f"),Qe(this,_,n(A),"f"),Qe(this,v,E,"f")}dispose(){Qe(this,c,!0,"f"),Re(this,l,"f").fire(),Re(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Qe(this,y,!0,"f"),(0,k.asWebviewUri)(m,Re(this,p,"f"))}get cspSource(){const m=Re(this,f,"f").extensionLocation;if(m.scheme===D.Schemas.https||m.scheme===D.Schemas.http){let d=m.toString();return d.endsWith("/")||(d+="/"),d+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,u,"f")}set html(m){this.assertNotDisposed(),Re(this,u,"f")!==m&&(Qe(this,u,m,"f"),!Re(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Qe(this,y,!0,"f"),Re(this,v,"f").report("Webview vscode-resource: uris",Re(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,R,"f").$setHtml(Re(this,P,"f"),m))}get options(){return this.assertNotDisposed(),Re(this,h,"f")}set options(m){this.assertNotDisposed(),Re(this,R,"f").$setOptions(Re(this,P,"f"),o(Re(this,f,"f"),Re(this,w,"f"),m)),Qe(this,h,m,"f")}async postMessage(m){if(Re(this,c,"f"))return!1;const d=(0,I.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Re(this,_,"f")});return Re(this,R,"f").$postMessage(Re(this,P,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Re(this,c,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=S,P=new WeakMap,R=new WeakMap,v=new WeakMap,p=new WeakMap,w=new WeakMap,f=new WeakMap,u=new WeakMap,h=new WeakMap,c=new WeakMap,y=new WeakMap,_=new WeakMap,l=new WeakMap;function n(s){try{const m=(0,L.normalizeVersion)((0,L.parseVersion)(s.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class T{constructor(m,d,C,O,U){this.remoteInfo=d,this.workspace=C,this._logService=O,this._deprecationService=U,this._webviews=new Map,this._webviewProxy=m.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(m,d,C){const O=this.getWebview(m);if(O){const{message:U}=(0,I.deserializeWebviewMessage)(d,C.value);O._onMessageEmitter.fire(U)}}$onMissingCsp(m,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,d,C){const O=new S(m,this._webviewProxy,r(d),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(m,O),O._onDidDispose(()=>{this._webviews.delete(m)}),O}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=T;function i(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=i;function o(s,m,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||t(s,m)}}e.serializeWebviewOptions=o;function r(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(m=>g.URI.from(m))}}e.reviveOptions=r;function t(s,m){return[...(m?.getWorkspaceFolders()||[]).map(d=>d.uri),s.extensionLocation]}}),define(Se[211],De([1,0,20,95,7,11,24,2,8,53,63,4,6]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(n,T){this.document=n,this._storagePath=T,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,T){await this.getEdit(n).undo(),T||this.disposeBackup()}async redo(n,T){await this.getEdit(n).redo(),T||this.disposeBackup()}disposeEdits(n){for(const T of n)this._edits.delete(T)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=l(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const T=this._edits.get(n,0);if(!T)throw new Error("No edit found");return T}}class f{constructor(){this._documents=new Map}get(n,T){return this._documents.get(this.key(n,T))}add(n,T,i){const o=this.key(n,T.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${n} resource:${T.uri}`);const r=new w(T,i);return this._documents.set(o,r),r}delete(n,T){const i=this.key(n,T.uri);this._documents.delete(i)}key(n,T){return`${n}@@@${T}`}}var u;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(u||(u={}));class h{constructor(){this._providers=new Map}addTextProvider(n,T,i){return this.add(0,n,T,i)}addCustomProvider(n,T,i){return this.add(1,n,T,i)}get(n){return this._providers.get(n)}add(n,T,i,o){if(this._providers.has(T))throw new Error(`Provider for viewType:${T} already registered`);return this._providers.set(T,{type:n,extension:i,provider:o}),new p.Disposable(()=>this._providers.delete(T))}}class c{constructor(n,T,i,o,r){this._extHostDocuments=T,this._extensionStoragePaths=i,this._extHostWebview=o,this._extHostWebviewPanels=r,this._editorProviders=new h,this._documents=new f,this._proxy=n.getProxy(v.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,T,i,o){const r=new g.DisposableStore;return y(i)?(r.add(this._editorProviders.addTextProvider(T,n,i)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(n),T,o.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(n))):(r.add(this._editorProviders.addCustomProvider(T,n,i)),this.supportEditing(i)&&r.add(i.onDidChangeCustomDocument(t=>{const s=this.getCustomDocumentEntry(T,t.document.uri);if(_(t)){const m=s.addEdit(t);this._proxy.$onDidEdit(t.document.uri,T,m,t.label)}else this._proxy.$onContentChange(t.document.uri,T)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(n),T,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(n))),p.Disposable.from(r,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(T)}))}async $createCustomDocument(n,T,i,o,r){const t=this._editorProviders.get(T);if(!t)throw new Error(`No provider found for '${T}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${T}'`);const s=k.URI.revive(n),m=await t.provider.openCustomDocument(s,{backupId:i,untitledDocumentData:o?.buffer},r);let d;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(T,m,d),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(n,T){const i=this._editorProviders.get(T);if(!i)throw new Error(`No provider found for '${T}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${T}'`);const o=k.URI.revive(n),{document:r}=this.getCustomDocumentEntry(T,o);this._documents.delete(T,r),r.dispose()}async $resolveWebviewEditor(n,T,i,o,r,t){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);const m=b.ViewColumn.to(r),d=this._extHostWebview.createNewWebview(T,o.webviewOptions,s.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(T,i,o.title,m,o.panelOptions,d,!0),O=k.URI.revive(n);switch(s.type){case 1:{const{document:U}=this.getCustomDocumentEntry(i,O);return s.provider.resolveCustomEditor(U,C,t)}case 0:{const U=this._extHostDocuments.getDocument(O);return s.provider.resolveCustomTextEditor(U,C,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,T,i){this.getCustomDocumentEntry(T,n).disposeEdits(i)}async $onMoveCustomEditor(n,T,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const r=this._extHostWebviewPanels.getWebviewPanel(n);if(!r)throw new Error("No webview found");const t=k.URI.revive(T),s=this._extHostDocuments.getDocument(t);await o.provider.moveCustomTextEditor(s,r,a.CancellationToken.None)}async $undo(n,T,i,o){return this.getCustomDocumentEntry(T,n).undo(i,o)}async $redo(n,T,i,o){return this.getCustomDocumentEntry(T,n).redo(i,o)}async $revert(n,T,i){const o=this.getCustomDocumentEntry(T,n);await this.getCustomEditorProvider(T).revertCustomDocument(o.document,i),o.disposeBackup()}async $onSave(n,T,i){const o=this.getCustomDocumentEntry(T,n);await this.getCustomEditorProvider(T).saveCustomDocument(o.document,i),o.disposeBackup()}async $onSaveAs(n,T,i,o){const r=this.getCustomDocumentEntry(T,n);return this.getCustomEditorProvider(T).saveCustomDocumentAs(r.document,k.URI.revive(i),o)}async $backup(n,T,i){const o=this.getCustomDocumentEntry(T,n),t=await this.getCustomEditorProvider(T).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},i);return o.updateBackup(t),t.id}getCustomDocumentEntry(n,T){const i=this._documents.get(n,k.URI.revive(T));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(n){const i=this._editorProviders.get(n)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=c;function y(S){return typeof S.resolveCustomTextEditor=="function"}function _(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function l(S){const n=S.scheme===L.Schemas.file||S.scheme===L.Schemas.untitled?S.fsPath:S.toString();return(0,D.hash)(n)+""}});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[212],De([1,0,5,7,2,42,8,53,4,6]),function(ee,e,a,D,g,L,I,k,b,P){"use strict";var R,v,p,w,f,u,h,c,y,_,l,S,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends D.Disposable{constructor(t,s,m,d){super();R.set(this,void 0),v.set(this,void 0),p.set(this,void 0),w.set(this,void 0),f.set(this,void 0),u.set(this,void 0),h.set(this,void 0),c.set(this,void 0),y.set(this,!0),_.set(this,void 0),l.set(this,!1),S.set(this,this._register(new a.Emitter)),this.onDidDispose=Re(this,S,"f").event,n.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Re(this,n,"f").event,Qe(this,R,t,"f"),Qe(this,v,s,"f"),Qe(this,w,m,"f"),Qe(this,p,d.viewType,"f"),Qe(this,f,d.panelOptions,"f"),Qe(this,c,d.viewColumn,"f"),Qe(this,u,d.title,"f"),Qe(this,_,d.active,"f")}dispose(){Re(this,l,"f")||(Qe(this,l,!0,"f"),Re(this,S,"f").fire(),Re(this,v,"f").$disposeWebview(Re(this,R,"f")),Re(this,w,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,w,"f")}get viewType(){return this.assertNotDisposed(),Re(this,p,"f")}get title(){return this.assertNotDisposed(),Re(this,u,"f")}set title(t){this.assertNotDisposed(),Re(this,u,"f")!==t&&(Qe(this,u,t,"f"),Re(this,v,"f").$setTitle(Re(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Re(this,h,"f")}set iconPath(t){this.assertNotDisposed(),Re(this,h,"f")!==t&&(Qe(this,h,t,"f"),Re(this,v,"f").$setIconPath(Re(this,R,"f"),g.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Re(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,c,"f")=="number"&&Re(this,c,"f")<0))return Re(this,c,"f")}get active(){return this.assertNotDisposed(),Re(this,_,"f")}get visible(){return this.assertNotDisposed(),Re(this,y,"f")}_updateViewState(t){Re(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Qe(this,_,t.active,"f"),Qe(this,y,t.visible,"f"),Qe(this,c,t.viewColumn,"f"),Re(this,n,"f").fire({webviewPanel:this}))}reveal(t,s){this.assertNotDisposed(),Re(this,v,"f").$reveal(Re(this,R,"f"),{viewColumn:typeof t=="undefined"?void 0:I.ViewColumn.from(t),preserveFocus:!!s})}assertNotDisposed(){if(Re(this,l,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,v=new WeakMap,p=new WeakMap,w=new WeakMap,f=new WeakMap,u=new WeakMap,h=new WeakMap,c=new WeakMap,y=new WeakMap,_=new WeakMap,l=new WeakMap,S=new WeakMap,n=new WeakMap;class i{constructor(t,s,m){this.webviews=s,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,L.generateUuid)()}createWebviewPanel(t,s,m,d,C={}){const O=typeof d=="object"?d.viewColumn:d,U={viewColumn:I.ViewColumn.from(O),preserveFocus:typeof d=="object"&&!!d.preserveFocus},A=(0,k.shouldSerializeBuffersForPostMessage)(t),E=i.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(t),E,s,{title:m,panelOptions:o(C),webviewOptions:(0,k.serializeWebviewOptions)(t,this.workspace,C),serializeBuffersForPostMessage:A},U);const $=this.webviews.createNewWebview(E,C,t);return this.createNewWebviewPanel(E,s,m,O,C,$,!0)}$onDidChangeWebviewPanelViewStates(t){const s=Object.keys(t);s.sort((m,d)=>{const C=t[m],O=t[d];return C.active?1:O.active?-1:+C.visible-+O.visible});for(const m of s){const d=this.getWebviewPanel(m);if(!d)continue;const C=t[m];d._updateViewState({active:C.active,visible:C.visible,viewColumn:I.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,s,m){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:m,extension:t}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(t,s,m,d){const C=this._serializers.get(s);if(!C)throw new Error(`No serializer found for '${s}'`);const{serializer:O,extension:U}=C,A=this.webviews.createNewWebview(t,m.webviewOptions,U),E=this.createNewWebviewPanel(t,s,m.title,d,m.panelOptions,A,m.active);await O.deserializeWebviewPanel(E,m.state)}createNewWebviewPanel(t,s,m,d,C,O,U){const A=new T(t,this._proxy,O,{viewType:s,title:m,viewColumn:d,panelOptions:C,active:U});return this._webviewPanels.set(t,A),A}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=i;function o(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[213],De([1,0,5,7,53,21,8,4,6]),function(ee,e,a,D,g,L,I,k,b){"use strict";var P,R,v,p,w,f,u,h,c,y,_,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends D.Disposable{constructor(i,o,r,t,s,m,d){super();P.set(this,void 0),R.set(this,void 0),v.set(this,void 0),p.set(this,void 0),w.set(this,void 0),f.set(this,!1),u.set(this,void 0),h.set(this,void 0),c.set(this,void 0),y.set(this,void 0),_.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Re(this,_,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidDispose=Re(this,l,"f").event,Qe(this,v,r,"f"),Qe(this,h,t,"f"),Qe(this,P,i,"f"),Qe(this,R,o,"f"),Qe(this,p,s,"f"),Qe(this,w,m,"f"),Qe(this,u,d,"f")}dispose(){Re(this,f,"f")||(Qe(this,f,!0,"f"),Re(this,l,"f").fire(),Re(this,p,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,h,"f")}set title(i){this.assertNotDisposed(),Re(this,h,"f")!==i&&(Qe(this,h,i,"f"),Re(this,R,"f").$setWebviewViewTitle(Re(this,P,"f"),i))}get description(){return this.assertNotDisposed(),Re(this,c,"f")}set description(i){this.assertNotDisposed(),Re(this,c,"f")!==i&&(Qe(this,c,i,"f"),Re(this,R,"f").$setWebviewViewDescription(Re(this,P,"f"),i))}get visible(){return Re(this,u,"f")}get webview(){return Re(this,p,"f")}get viewType(){return Re(this,v,"f")}_setVisible(i){i===Re(this,u,"f")||Re(this,f,"f")||(Qe(this,u,i,"f"),Re(this,_,"f").fire())}get badge(){return this.assertNotDisposed(),(0,L.checkProposedApiEnabled)(Re(this,w,"f"),"badges"),Re(this,y,"f")}set badge(i){this.assertNotDisposed(),(0,L.checkProposedApiEnabled)(Re(this,w,"f"),"badges"),!(i?.value===Re(this,y,"f")?.value&&i?.tooltip===Re(this,y,"f")?.tooltip)&&(Qe(this,y,I.ViewBadge.from(i),"f"),Re(this,R,"f").$setWebviewViewBadge(Re(this,P,"f"),i))}show(i){this.assertNotDisposed(),Re(this,R,"f").$show(Re(this,P,"f"),!!i)}assertNotDisposed(){if(Re(this,f,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,R=new WeakMap,v=new WeakMap,p=new WeakMap,w=new WeakMap,f=new WeakMap,u=new WeakMap,h=new WeakMap,c=new WeakMap,y=new WeakMap,_=new WeakMap,l=new WeakMap;class n{constructor(i,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,r,t){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:r,extension:i}),this._proxy.$registerWebviewViewProvider((0,g.toExtensionData)(i),o,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new b.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,r,t,s){const m=this._viewProviders.get(o);if(!m)throw new Error(`No view provider found for '${o}'`);const{provider:d,extension:C}=m,O=this._extHostWebview.createNewWebview(i,{},C),U=new S(i,this._proxy,o,r,O,C,!0);this._webviewViews.set(i,U),await d.resolveWebviewView(U,{state:t},s)}async $onDidChangeWebviewViewVisibility(i,o){this.getWebviewView(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.getWebviewView(i);this._webviewViews.delete(i),o.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const o=this._webviewViews.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=n}),define(Se[97],De([1,0,5,4,2,11,9,3,16]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Yi{constructor(v){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yi.InitialState,this._proxy=v.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}get state(){return this._state}$onDidChangeWindowFocus(v){v!==this._state.focused&&(this._state={...this._state,focused:v},this._onDidChangeWindowState.fire(this._state))}openUri(v,p){let w;if(typeof v=="string"){w=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,I.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,w,p)}async asExternalUri(v,p){if((0,I.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(v,p);return g.URI.from(w)}};P.InitialState={focused:!0},P=$e([ze(0,b.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(Se[214],De([1,0,14,25,20,12,5,7,112,179,39]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(C,O){try{return JSON.stringify(C,O)}catch{return"null"}}const w="$$ref$$",f={[w]:-1};class u{constructor(O,U){this.jsonString=O,this.referencedBuffers=U}}function h(C,O=null,U=!1){const A=[];return{jsonString:(U?p:JSON.stringify)(C,($,x)=>{if(typeof x=="undefined")return f;if(typeof x=="object"){if(x instanceof D.VSBuffer){const H=A.push(x)-1;return{[w]:H}}if(O)return O($,x)}return x}),referencedBuffers:A}}e.stringifyJsonWithBufferRefs=h;function c(C,O,U){return JSON.parse(C,(A,E)=>{if(E){const $=E[w];if(typeof $=="number")return O[$];if(U&&E.$mid===1)return U.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=c;function y(C,O){return JSON.stringify(C,O)}function _(C){return C?(O,U)=>U&&U.$mid===1?C.transformOutgoing(U):U:null}var l;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},T=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends k.Disposable{constructor(O,U=null,A=null){super();this[v]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=O,this._logger=U,this._uriTransformer=A,this._uriReplacer=_(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,$=R.ProxyIdentifier.count;E<$;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(O=>{this._pendingRPCReplies[O].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(O){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(O){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(O){this._responsiveState!==O&&(this._responsiveState=O,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(O){return this._uriTransformer?(0,b.transformIncomingURIs)(O,this._uriTransformer):O}getProxy(O){const{nid:U,sid:A}=O;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,A)),this._proxies[U]}_createProxy(O,U){let A={get:(E,$)=>(typeof $=="string"&&!E[$]&&$.charCodeAt(0)===36&&(E[$]=(...x)=>this._remoteCall(O,$,x)),$===i?U:E[$])};return new Proxy(Object.create(null),A)}set(O,U){return this._locals[O.nid]=U,U}assertRegistered(O){for(let U=0,A=O.length;U<A;U++){const E=O[U];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(O){if(this._isDisposed)return;const U=O.byteLength,A=r.read(O,0),E=A.readUInt8(),$=A.readUInt32();switch(E){case 1:case 2:{let{rpcId:x,method:H,args:oe}=s.deserializeRequestJSONArgs(A);this._uriTransformer&&(oe=(0,b.transformIncomingURIs)(oe,this._uriTransformer)),this._receiveRequest(U,$,x,H,oe,E===2);break}case 3:case 4:{let{rpcId:x,method:H,args:oe}=s.deserializeRequestMixedArgs(A);this._uriTransformer&&(oe=(0,b.transformIncomingURIs)(oe,this._uriTransformer)),this._receiveRequest(U,$,x,H,oe,E===4);break}case 5:{this._logger&&this._logger.logIncoming(U,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(U,$);break}case 7:{this._receiveReply(U,$,void 0);break}case 9:{let x=s.deserializeReplyOKJSON(A);this._uriTransformer&&(x=(0,b.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(U,$,x);break}case 10:{const x=s.deserializeReplyOKJSONWithBuffers(A,this._uriTransformer);this._receiveReply(U,$,x);break}case 8:{let x=s.deserializeReplyOKVSBuffer(A);this._receiveReply(U,$,x);break}case 11:{let x=s.deserializeReplyErrError(A);this._uriTransformer&&(x=(0,b.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(U,$,x);break}case 12:{this._receiveReplyErr(U,$,void 0);break}default:console.error("received unexpected message"),console.error(O)}}_receiveRequest(O,U,A,E,$,x){this._logger&&this._logger.logIncoming(O,U,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(A)}.${E}(`,$);const H=String(U);let oe,G;if(x){const le=new g.CancellationTokenSource;$.push(le.token),oe=this._invokeHandler(A,E,$),G=()=>le.cancel()}else oe=this._invokeHandler(A,E,$),G=n;this._cancelInvokedHandlers[H]=G;const M=s.serializeAcknowledged(U);this._logger&&this._logger.logOutgoing(M.byteLength,U,1,"ack"),this._protocol.send(M),oe.then(le=>{delete this._cancelInvokedHandlers[H];const me=s.serializeReplyOK(U,le,this._uriReplacer);this._logger&&this._logger.logOutgoing(me.byteLength,U,1,"reply:",le),this._protocol.send(me)},le=>{delete this._cancelInvokedHandlers[H];const me=s.serializeReplyErr(U,le);this._logger&&this._logger.logOutgoing(me.byteLength,U,1,"replyErr:",le),this._protocol.send(me)})}_receiveCancel(O,U){this._logger&&this._logger.logIncoming(O,U,1,"receiveCancel");const A=String(U);this._cancelInvokedHandlers[A]&&this._cancelInvokedHandlers[A]()}_receiveReply(O,U,A){this._logger&&this._logger.logIncoming(O,U,0,"receiveReply:",A);const E=String(U);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const $=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],$.resolveOk(A)}_receiveReplyErr(O,U,A){this._logger&&this._logger.logIncoming(O,U,0,"receiveReplyErr:",A);const E=String(U);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const $=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let x;A&&(A.$isError?(x=new Error,x.name=A.name,x.message=A.message,x.stack=A.stack):x=A),$.resolveErr(x)}_invokeHandler(O,U,A){try{return Promise.resolve(this._doInvokeHandler(O,U,A))}catch(E){return Promise.reject(E)}}_doInvokeHandler(O,U,A){const E=this._locals[O];if(!E)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(O));let $=E[U];if(typeof $!="function")throw new Error("Unknown method "+U+" on actor "+(0,R.getStringIdentifierForProxy)(O));return $.apply(E,A)}_remoteCall(O,U,A){if(this._isDisposed)return Promise.reject(L.canceled());let E=null;if(A.length>0&&g.CancellationToken.isCancellationToken(A[A.length-1])&&(E=A.pop()),E&&E.isCancellationRequested)return Promise.reject(L.canceled());const $=s.serializeRequestArguments(A,this._uriReplacer),x=++this._lastMessageId,H=String(x),oe=new P.LazyPromise;E&&E.onCancellationRequested(()=>{const M=s.serializeCancel(x);this._logger&&this._logger.logOutgoing(M.byteLength,x,0,"cancel"),this._protocol.send(s.serializeCancel(x))}),this._pendingRPCReplies[H]=oe,this._onWillSendRequest(x);const G=s.serializeRequest(x,O,U,$,!!E);return this._logger&&this._logger.logOutgoing(G.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(O)}.${U}(`,A),this._protocol.send(G),oe}}e.RPCProtocol=o,v=T,o.UNRESPONSIVE_TIME=3*1e3;class r{constructor(O,U){this._buff=O,this._offset=U}static alloc(O,U,A){let E=new r(D.VSBuffer.alloc(A+1+4),0);return E.writeUInt8(O),E.writeUInt32(U),E}static read(O,U){return new r(O,U)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(O){this._buff.writeUInt8(O,this._offset),this._offset+=1}readUInt8(){const O=this._buff.readUInt8(this._offset);return this._offset+=1,O}writeUInt32(O){this._buff.writeUInt32BE(O,this._offset),this._offset+=4}readUInt32(){const O=this._buff.readUInt32BE(this._offset);return this._offset+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this._buff.writeUInt8(O.byteLength,this._offset),this._offset+=1,this._buff.set(O,this._offset),this._offset+=O.byteLength}readShortString(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const A=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,A}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readLongString(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,A}writeBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readVSBuffer(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+O);return this._offset+=O,U}static sizeMixedArray(O){let U=0;U+=1;for(let A=0,E=O.length;A<E;A++){const $=O[A];switch(U+=1,$.type){case 1:U+=this.sizeLongString($.value);break;case 2:U+=this.sizeVSBuffer($.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString($.value);for(let x=0;x<$.buffers.length;++x)U+=this.sizeVSBuffer($.buffers[x]);break;case 4:break}}return U}writeMixedArray(O){this._buff.writeUInt8(O.length,this._offset),this._offset+=1;for(let U=0,A=O.length;U<A;U++){const E=O[U];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let $=0;$<E.buffers.length;++$)this.writeBuffer(E.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this._buff.readUInt8(this._offset);this._offset+=1;let U=new Array(O);for(let A=0;A<O;A++)switch(this.readUInt8()){case 1:U[A]=this.readLongString();break;case 2:U[A]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),x=this.readLongString(),H=[];for(let oe=0;oe<$;++oe)H.push(this.readVSBuffer());U[A]=new R.SerializableObjectWithBuffers(c(x,H,null));break}case 4:U[A]=void 0;break}return U}}r.sizeUInt32=4;var t;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(t||(t={}));class s{static _useMixedArgSerialization(O){for(let U=0,A=O.length;U<A;U++)if(O[U]instanceof D.VSBuffer||O[U]instanceof R.SerializableObjectWithBuffers||typeof O[U]=="undefined")return!0;return!1}static serializeRequestArguments(O,U){if(this._useMixedArgSerialization(O)){const A=[];for(let E=0,$=O.length;E<$;E++){const x=O[E];if(x instanceof D.VSBuffer)A[E]={type:2,value:x};else if(typeof x=="undefined")A[E]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:oe}=h(x.value,U);A[E]={type:3,value:D.VSBuffer.fromString(H),buffers:oe}}else A[E]={type:1,value:D.VSBuffer.fromString(y(x,U))}}return{type:1,args:A}}return{type:0,args:y(O,U)}}static serializeRequest(O,U,A,E,$){switch(E.type){case 0:return this._requestJSONArgs(O,U,A,E.args,$);case 1:return this._requestMixedArgs(O,U,A,E.args,$)}}static _requestJSONArgs(O,U,A,E,$){const x=D.VSBuffer.fromString(A),H=D.VSBuffer.fromString(E);let oe=0;oe+=r.sizeUInt8(),oe+=r.sizeShortString(x),oe+=r.sizeLongString(H);let G=r.alloc($?2:1,O,oe);return G.writeUInt8(U),G.writeShortString(x),G.writeLongString(H),G.buffer}static deserializeRequestJSONArgs(O){const U=O.readUInt8(),A=O.readShortString(),E=O.readLongString();return{rpcId:U,method:A,args:JSON.parse(E)}}static _requestMixedArgs(O,U,A,E,$){const x=D.VSBuffer.fromString(A);let H=0;H+=r.sizeUInt8(),H+=r.sizeShortString(x),H+=r.sizeMixedArray(E);let oe=r.alloc($?4:3,O,H);return oe.writeUInt8(U),oe.writeShortString(x),oe.writeMixedArray(E),oe.buffer}static deserializeRequestMixedArgs(O){const U=O.readUInt8(),A=O.readShortString(),E=O.readMixedArray(),$=new Array(E.length);for(let x=0,H=E.length;x<H;x++){const oe=E[x];typeof oe=="string"?$[x]=JSON.parse(oe):$[x]=oe}return{rpcId:U,method:A,args:$}}static serializeAcknowledged(O){return r.alloc(5,O,0).buffer}static serializeCancel(O){return r.alloc(6,O,0).buffer}static serializeReplyOK(O,U,A){if(typeof U=="undefined")return this._serializeReplyOKEmpty(O);if(U instanceof D.VSBuffer)return this._serializeReplyOKVSBuffer(O,U);if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:$}=h(U.value,A,!0);return this._serializeReplyOKJSONWithBuffers(O,E,$)}else return this._serializeReplyOKJSON(O,p(U,A))}static _serializeReplyOKEmpty(O){return r.alloc(7,O,0).buffer}static _serializeReplyOKVSBuffer(O,U){let A=0;A+=r.sizeVSBuffer(U);let E=r.alloc(8,O,A);return E.writeVSBuffer(U),E.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static _serializeReplyOKJSON(O,U){const A=D.VSBuffer.fromString(U);let E=0;E+=r.sizeLongString(A);let $=r.alloc(9,O,E);return $.writeLongString(A),$.buffer}static _serializeReplyOKJSONWithBuffers(O,U,A){const E=D.VSBuffer.fromString(U);let $=0;$+=r.sizeUInt32,$+=r.sizeLongString(E);for(const H of A)$+=r.sizeVSBuffer(H);let x=r.alloc(10,O,$);x.writeUInt32(A.length),x.writeLongString(E);for(const H of A)x.writeBuffer(H);return x.buffer}static deserializeReplyOKJSON(O){const U=O.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(O,U){const A=O.readUInt32(),E=O.readLongString(),$=[];for(let x=0;x<A;++x)$.push(O.readVSBuffer());return new R.SerializableObjectWithBuffers(c(E,$,U))}static serializeReplyErr(O,U){const A=U?p(L.transformErrorForSerialization(U),null):void 0;if(typeof A!="string")return this._serializeReplyErrEmpty(O);const E=D.VSBuffer.fromString(A);let $=0;$+=r.sizeLongString(E);let x=r.alloc(11,O,$);return x.writeLongString(E),x.buffer}static deserializeReplyErrError(O){const U=O.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(O){return r.alloc(12,O,0).buffer}}var m;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var d;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(d||(d={}))}),define(Se[215],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(L){const I=k=>{self.removeEventListener("message",I);const b=k.data;Object.defineProperties(self,{postMessage:{value(P,R){b.postMessage(P,R)}},onmessage:{get(){return b.onmessage},set(P){b.onmessage=P}}}),b.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",I)}.toString();class D extends EventTarget{constructor(L,I,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${a})('${I}'))`,P=new Blob([b],{type:"application/javascript"}),R=URL.createObjectURL(P),v=new MessageChannel,p=R,w={type:"_newWorker",id:p,port:v.port2,url:R,options:k};L(w,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{L({type:"_terminateWorker",id:p}),URL.revokeObjectURL(R),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(f){v.port1.onmessage=f}},onmessageerror:{get(){return v.port1.onmessageerror},set(f){v.port1.onmessageerror=f}}}),v.port1.addEventListener("messageerror",f=>{const u=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(u)}),v.port1.addEventListener("message",f=>{const u=new MessageEvent("message",{data:f.data});this.dispatchEvent(u)}),v.port1.start()}}e.NestedWorker=D}),define(Se[216],De([1,0,5,34,44,3,38,12,14]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new g.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new g.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new g.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(u=>f.push(u)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}D.Registry.add(e.Extensions.OutputChannels,new R);function v(w,f,u,h,c){return(0,b.createCancelablePromise)(async y=>{await(0,I.whenProviderRegistered)(u,h);const _=D.Registry.as(e.Extensions.OutputChannels);try{await p(u,1,h,c,y),_.registerChannel({id:w,label:f,file:u,log:!0})}catch(l){(0,k.isCancellationError)(l)||c.error("Error while registering log channel",u.toString(),(0,k.getErrorMessage)(l))}})}e.registerLogChannel=v;async function p(w,f,u,h,c){if(!await u.exists(w)){if(c.isCancellationRequested)throw new k.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");h.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",w.toString()),await(0,b.timeout)(1e3,c),await p(w,f+1,u,h,c)}}}),define(Se[98],De([1,0,4,7,3,16,13,216,51,28,35,117,25,10]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends D.Disposable{constructor(c,y,_,l){super();this.id=c,this.name=y,this.logger=_,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(c){this.append(c+`
`)}append(c){this.write(c),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const c=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,c)}replace(c){const y=this.offset;this.write(c),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,y),this.visible&&this.logger.flush()}show(c,y){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof c=="boolean"?c:y))}hide(){this.proxy.$close(this.id)}write(c){this.offset+=p.VSBuffer.fromString(c).byteLength,this.logger.info(c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let u=class{constructor(c,y,_,l,S){this.extHostFileSystem=_,this.extHostFileSystemInfo=l,this.loggerService=S,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=c.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(y.logsLocation,`output_logging_${(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.visibleChannelId=c;for(const[y,_]of this.channels)_.visible=y===this.visibleChannelId}createOutputChannel(c,y,_){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if((0,w.isString)(y)&&!y.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(c,y,_);return l.then(S=>{this.channels.set(S.id,S),S.visible=S.id===this.visibleChannelId}),this.createExtHostOutputChannel(c,l)}async doCreateOutputChannel(c,y,_){const l=await this.createOutputDirectory(),S=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.loggerService.createLogger(S,{always:!0,donotRotate:!0,donotUseFormatters:!0}),T=await this.proxy.$register(c,!1,S,y,_.identifier.value);return new f(T,c,n,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(c,y){let _=!1;const l=()=>{if(_)throw new Error("Channel has been closed")};return{get name(){return c},append(S){l(),y.then(n=>n.append(S))},appendLine(S){l(),y.then(n=>n.appendLine(S))},clear(){l(),y.then(S=>S.clear())},replace(S){l(),y.then(n=>n.replace(S))},show(S,n){l(),y.then(T=>T.show(S,n))},hide(){l(),y.then(S=>S.hide())},dispose(){_=!0,y.then(S=>S.dispose())}}}};u=$e([ze(0,L.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,b.IExtHostConsumerFileSystem),ze(3,R.IExtHostFileSystemInfo),ze(4,I.ILoggerService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,g.createDecorator)("IExtHostOutputService")}),define(Se[217],De([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Se[218],De([1,0,37,11,17,23,24,2,3,155,45,175,217]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let w=class Ji{constructor(u,h,c,y){this.localUserHome=u,this.remoteAgentService=h,this.environmentService=c,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome||u})()}hasValidBasename(u,h,c){return typeof h=="string"||typeof h=="undefined"?this.resolveOS.then(y=>this.doHasValidBasename(u,y,h)):this.doHasValidBasename(u,h,c)}doHasValidBasename(u,h,c){return u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote?(0,a.isValidBasename)(c??(0,I.basename)(u),h===1):!0}get defaultUriScheme(){return Ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,h){if(u.remoteAuthority)return D.Schemas.vscodeRemote;const c=(0,P.getVirtualWorkspaceScheme)(h.getWorkspace());if(c)return c;const y=h.getWorkspace().folders[0];if(y)return y.uri.scheme;const _=h.getWorkspace().configuration;return _?_.scheme:D.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?g.win32:g.posix)}async fileURI(u){let h="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const y=u.indexOf("/",2);y===-1?(h=u.substring(2),u="/"):(h=u.substring(2,y),u=u.substring(y)||"/")}return k.URI.from({scheme:D.Schemas.file,authority:h,path:u,query:"",fragment:""})}};w=$e([ze(1,p.IRemoteAgentService),ze(2,v.IWorkbenchEnvironmentService),ze(3,R.IWorkspaceContextService)],w),e.AbstractPathService=w}),define(Se[99],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(I,k){this.line=I,this.character=k}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,k){return new a(0,0)}with(I){return new a(0,0)}}e.Position=a;class D{constructor(I,k,b,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(I,k),this.end=new a(b,P)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new D(0,0,0,0)}with(I){return new D(0,0,0,0)}}e.Range=D;var g;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(g=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[40],De([1,0,15,33,27,37,9,3,17,12,99,14]),function(ee,e,a,D,g,L,I,k,b,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",w=" characters skipped \u27EB",f=(p.length+w.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var u;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function c(ae){return!!ae.preview}e.resultIsMatch=c;function y(ae){return!!ae.resource}e.isFileMatch=y;function _(ae){return!!ae.message}e.isProgressMessage=_;var l;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(ge){this.resource=ge,this.results=[]}}e.FileMatch=S;class n{constructor(ge,te,Ee){this.ranges=te;const we=Array.isArray(te)?te:[te];if(Ee&&Ee.matchLines===1&&T(we)){ge=(0,I.getNLines)(ge,Ee.matchLines);let Z="",pe=0,Pe=0;const Ne=Math.floor(Ee.charsPerLine/5),We=[];for(const Ge of we){const Ce=Math.max(Ge.startColumn-Ne,0),_e=Ge.startColumn+Ee.charsPerLine;if(Ce>Pe+Ne+f){const Te=p+(Ce-Pe)+w;Z+=Te+ge.slice(Ce,_e),pe+=Ce-(Pe+Te.length)}else Z+=ge.slice(Pe,_e);We.push(new o(0,Ge.startColumn-pe,Ge.endColumn-pe)),Pe=_e}this.preview={text:Z,matches:Array.isArray(this.ranges)?We:We[0]}}else{const Z=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ge,matches:(0,a.mapArrayOrNot)(te,pe=>new i(pe.startLineNumber-Z,pe.startColumn,pe.endLineNumber-Z,pe.endColumn))}}}}e.TextSearchMatch=n;function T(ae){const ge=ae[0].startLineNumber;for(const te of ae)if(te.startLineNumber!==ge||te.endLineNumber!==ge)return!1;return!0}class i{constructor(ge,te,Ee,we){this.startLineNumber=ge,this.startColumn=te,this.endLineNumber=Ee,this.endColumn=we}}e.SearchRange=i;class o extends i{constructor(ge,te,Ee){super(ge,te,ge,Ee)}}e.OneLineRange=o;var r;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function t(ae,ge=!0){const te=ae&&ae.files&&ae.files.exclude,Ee=ge&&ae&&ae.search&&ae.search.exclude;if(!te&&!Ee)return;if(!te||!Ee)return te||Ee;let we=Object.create(null);return we=g.mixin(we,g.deepClone(te)),we=g.mixin(we,g.deepClone(Ee),!0),we}e.getExcludes=t;function s(ae,ge){return ae.excludePattern&&D.match(ae.excludePattern,ge)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&D.match(ae.includePattern,ge)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some(te=>{const Ee=te.folder.fsPath;if(L.isEqualOrParent(ge,Ee)){const we=b.relative(Ee,ge);return!te.includePattern||!!D.match(te.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var m;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(ge,te){super(ge);this.code=te}}e.SearchError=d;function C(ae){const ge=ae.message;if((0,P.isCancellationError)(ae))return new d(ge,m.canceled);try{const te=JSON.parse(ge);return new d(te.message,te.code)}catch{return new d(ge,m.other)}}e.deserializeSearchError=C;function O(ae){const ge={message:ae.message,code:ae.code};return new Error(JSON.stringify(ge))}e.serializeSearchError=O;function U(ae){return ae.type==="error"?!0:ae.type==="success"}e.isSerializedSearchComplete=U;function A(ae){return ae.type==="success"}e.isSerializedSearchSuccess=A;function E(ae){return!!ae.path}e.isSerializedFileMatch=E;function $(ae,ge){const te=ae.searchPath?ae.searchPath:ae.relativePath;return(0,I.fuzzyContains)(te,ge)}e.isFilePatternMatch=$;class x{constructor(ge){this.path=ge,this.results=[]}addMatch(ge){this.results.push(ge)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function H(ae,ge){const te={...ae||{},...ge||{}};return Object.keys(te).filter(Ee=>{const we=te[Ee];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=H;class oe{constructor(ge,te){this._parsedIncludeExpression=null,this._excludeExpression={...ge.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=D.parse(this._excludeExpression);let Ee=ge.includePattern;te.includePattern&&(Ee?Ee={...Ee,...te.includePattern}:Ee=te.includePattern),Ee&&(this._parsedIncludeExpression=D.parse(Ee))}matchesExcludesSync(ge,te,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ge,te,Ee))}includedInQuerySync(ge,te,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ge,te,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ge,te,Ee))}includedInQuery(ge,te,Ee){const we=this._parsedExcludeExpression(ge,te,Ee),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ge,te,Ee):!0;return(0,v.isThenable)(we)?we.then(pe=>pe?!1:Z()):Z()}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=oe;function G(ae){for(const ge in ae)if(typeof ae[ge]!="boolean")return!0;return!1}function M(ae){if(!ae)return;let ge;return te=>(ge||(ge=(ae()||Promise.resolve([])).then(Ee=>Ee?me(Ee):{})),ge.then(Ee=>!!Ee[te]))}e.hasSiblingPromiseFn=M;function le(ae){if(!ae)return;let ge;return te=>{if(!ge){const Ee=ae();ge=Ee?me(Ee):{}}return!!ge[te]}}e.hasSiblingFn=le;function me(ae){const ge={};for(const te of ae)ge[te]=!0;return ge}}),define(Se[29],De([1,0,15,14,20,5,22,11,106,24,9,10,2,134,3,13,147,45,35,28,16,8,6,40,4]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l,S,n,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(U,A,E){return new P.ExtUri($=>m($,E)).isEqual(U,A)}function r(U,A,E){return o(U.uri,A.uri,E)?0:(0,R.compare)(U.uri.toString(),A.uri.toString())}function t(U,A,E){return U.index!==A.index?U.index<A.index?-1:1:o(U.uri,A.uri,E)?(0,R.compare)(U.name,A.name):(0,R.compare)(U.uri.toString(),A.uri.toString())}function s(U,A,E,$){const x=U.slice(0).sort((oe,G)=>E(oe,G,$)),H=A.slice(0).sort((oe,G)=>E(oe,G,$));return(0,a.delta)(x,H,(oe,G)=>E(oe,G,$))}function m(U,A){const E=A.getCapabilities(U.scheme);return!(E&&E&1024)}class d extends c.Workspace{constructor(A,E,$,x,H,oe,G){super(A,$.map(M=>new c.WorkspaceFolder(M)),x,H,G);this._name=E,this._isUntitled=oe,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(G),$.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(A,E,$,x){if(!A)return{workspace:null,added:[],removed:[]};const{id:H,name:oe,folders:G,configuration:M,transient:le,isUntitled:me}=A,ae=[],ge=E;E?G.forEach((Z,pe)=>{const Pe=p.URI.revive(Z.uri),Ne=d._findFolder($||E,Pe,x);Ne?(Ne.name=Z.name,Ne.index=Z.index,ae.push(Ne)):ae.push({uri:Pe,name:Z.name,index:pe})}):ae.push(...G.map(({uri:Z,name:pe,index:Pe})=>({uri:p.URI.revive(Z),name:pe,index:Pe}))),ae.sort((Z,pe)=>Z.index<pe.index?-1:1);const te=new d(H,oe,ae,!!le,M?p.URI.revive(M):null,!!me,Z=>m(Z,x)),{added:Ee,removed:we}=s(ge?ge.workspaceFolders:[],te.workspaceFolders,r,x);return{workspace:te,added:Ee,removed:we}}static _findFolder(A,E,$){for(let x=0;x<A.folders.length;x++){const H=A.workspaceFolders[x];if(o(H.uri,E,$))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,E){return E&&this._structure.get(A)&&(A=(0,P.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let C=class{constructor(A,E,$,x){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=$,this._requestIdProvider=new b.Counter,this._barrier=new D.Barrier,this._proxy=A.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(i.MainContext.MainThreadMessageService);const H=E.workspace;this._confirmedWorkspace=H?new d(H.id,H.name,[],!!H.transient,H.configuration?p.URI.revive(H.configuration):null,!!H.isUntitled,oe=>m(oe,$)):void 0}$initializeWorkspace(A,E){this._trusted=E,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,E,$,...x){const H=[];if(Array.isArray(x)&&x.forEach(me=>{p.URI.isUri(me.uri)&&!H.some(ae=>o(ae.uri,me.uri,this._extHostFileSystemInfo))&&H.push({uri:me.uri,name:me.name||(0,P.basenameOrAuthority)(me.uri)})}),this._unconfirmedWorkspace||[E,$].some(me=>typeof me!="number"||me<0)||$===0&&H.length===0)return!1;const oe=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+$>oe.length)return!1;const G=oe.slice(0);G.splice(E,$,...H.map(me=>({uri:me.uri,name:me.name||(0,P.basenameOrAuthority)(me.uri),index:void 0})));for(let me=0;me<G.length;me++){const ae=G[me];if(G.some((ge,te)=>te!==me&&o(ae.uri,ge.uri,this._extHostFileSystemInfo)))return!1}G.forEach((me,ae)=>me.index=ae);const{added:M,removed:le}=s(oe,G,t,this._extHostFileSystemInfo);if(M.length===0&&le.length===0)return!1;if(this._proxy){const me=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(me,E,$,H).then(void 0,ae=>{this._unconfirmedWorkspace=void 0;const ge={source:{identifier:A.identifier,label:A.displayName||A.name}};this._messageService.$showMessage(h.Severity.Error,(0,w.localize)(0,null,me,ae.toString()),ge,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(A,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,E)}async getWorkspaceFolder2(A,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,E)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,E){let $,x="";if(typeof A=="string"?($=p.URI.file(A),x=A):typeof A!="undefined"&&($=A,x=A.fsPath),!$)return x;const H=this.getWorkspaceFolder($,!0);if(!H)return x;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let oe=(0,P.relativePath)(H.uri,$);return E&&H.name&&(oe=`${H.name}/${oe}`),oe}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:E,added:$,removed:x}=d.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:x}))}findFiles(A,E,$,x,H=g.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let oe;if(E===null?oe=!1:E&&(typeof E=="string"?oe=E:oe=E.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:M}=O(S.GlobPattern.from(A));return this._proxy.$startFileSearch((0,v.withUndefinedAsNull)(G),(0,v.withUndefinedAsNull)(M),(0,v.withUndefinedAsNull)(oe),(0,v.withUndefinedAsNull)($),H).then(le=>Array.isArray(le)?le.map(me=>p.URI.revive(me)):[])}async findTextInFiles(A,E,$,x,H=g.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const oe=this._requestIdProvider.getNext(),G=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:M,folder:le}=O(S.GlobPattern.from(E.include)),me=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,ae={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:G,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:M,excludePattern:me},ge=!1;if(this._activeSearchCallbacks[oe]=te=>{if(ge)return;const Ee=p.URI.revive(te.resource);te.results.forEach(we=>{(0,T.resultIsMatch)(we)?$({uri:Ee,preview:{text:we.preview.text,matches:(0,a.mapArrayOrNot)(we.preview.matches,Z=>new n.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))},ranges:(0,a.mapArrayOrNot)(we.ranges,Z=>new n.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))}):$({uri:Ee,text:we.text,lineNumber:we.lineNumber})})},H.isCancellationRequested)return{};try{const te=await this._proxy.$startTextSearch(A,(0,v.withUndefinedAsNull)(le),ae,oe,H);return delete this._activeSearchCallbacks[oe],te||{}}catch(te){throw delete this._activeSearchCallbacks[oe],te}}$handleTextSearchResult(A,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=$e([ze(0,l.IExtHostRpcService),ze(1,_.IExtHostInitDataService),ze(2,y.IExtHostFileSystemInfo),ze(3,u.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function O(U){let A,E;return U&&(typeof U=="string"?A=U:(A=U.pattern,E=p.URI.revive(U.baseUri))),{includePattern:A,folder:E}}}),define(Se[30],De([1,0,27,5,29,4,6,150,81,10,14,3,16,13,2]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(T,i){if(i){const o=i.split(".");let r=T;for(let t=0;r&&t<o.length;t++)r=r[o[t]];return r}}function h(T){return T instanceof f.URI}function c(T){return T&&T.uri instanceof f.URI&&T.languageId&&typeof T.languageId=="string"}function y(T){return T&&!T.uri&&T.languageId&&typeof T.languageId=="string"}function _(T){return T&&T.uri instanceof f.URI&&(!T.name||typeof T.name=="string")&&(!T.index||typeof T.index=="number")}function l(T){if(h(T))return{resource:T};if(c(T))return{resource:T.uri,overrideIdentifier:T.languageId};if(y(T))return{overrideIdentifier:T.languageId};if(_(T))return{resource:T.uri};if(T===null)return{resource:null}}let S=class{constructor(i,o,r){this._proxy=i.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new n(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(i,o))}};S=$e([ze(0,p.IExtHostRpcService),ze(1,g.IExtHostWorkspace),ze(2,w.ILogService)],S),e.ExtHostConfiguration=S;class n{constructor(i,o,r,t){this._onDidChangeConfiguration=new D.Emitter,this._proxy=i,this._logService=t,this._extHostWorkspace=o,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,o){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,r))}getConfiguration(i,o,r){const t=l(o)||{},s=this._toReadonlyValue(i?u(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,t,r?.identifier);function m(C){if(C==null)return null;if(typeof C=="boolean")return C?1:4;switch(C){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(C){return typeof u(s,C)!="undefined"},get:(C,O)=>{this._validateConfigurationAccess(i?`${i}.${C}`:C,t,r?.identifier);let U=u(s,C);if(typeof U=="undefined")U=O;else{let A;const E=($,x)=>{let H;const oe=()=>{A=A||(0,a.deepClone)(s),H=H||u(A,x)};return(0,P.isObject)($)?new Proxy($,{get:(G,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return oe(),()=>H;if(A)return H=H||u(A,x),H[M];const le=G[M];return typeof M=="string"?E(le,`${x}.${M}`):le},set:(G,M,le)=>(oe(),H&&(H[M]=le),!0),deleteProperty:(G,M)=>(oe(),H&&delete H[M],!0),defineProperty:(G,M,le)=>(oe(),H&&Object.defineProperty(H,M,le),!0)}):$};U=E(U,C)}return U},update:(C,O,U,A)=>{C=i?`${i}.${C}`:C;const E=m(U);return O!==void 0?this._proxy.$updateConfigurationOption(E,C,O,t,A):this._proxy.$removeConfigurationOption(E,C,t,A)},inspect:C=>{C=i?`${i}.${C}`:C;const O=(0,a.deepClone)(this._configuration.inspect(C,t,this._extHostWorkspace.workspace));if(O)return{key:C,defaultValue:O.default?.value,globalValue:O.user?.value,workspaceValue:O.workspace?.value,workspaceFolderValue:O.workspaceFolder?.value,defaultLanguageValue:O.default?.override,globalLanguageValue:O.user?.override,workspaceLanguageValue:O.workspace?.override,workspaceFolderLanguageValue:O.workspaceFolder?.override,languageIds:O.overrideIdentifiers}}};return typeof s=="object"&&(0,a.mixin)(d,s,!1),Object.freeze(d)}_toReadonlyValue(i){const o=r=>(0,P.isObject)(r)?new Proxy(r,{get:(t,s)=>o(t[s]),set:(t,s,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(t,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(t,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return o(i)}_validateConfigurationAccess(i,o,r){const t=b.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),s=r?`[${r.value}] `:"";if(t===4){typeof o?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){o?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,o){const r=new k.ConfigurationChangeEvent(i,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,s)=>r.affectsConfiguration(t,l(s))})}_toMap(i){return i.reduce((o,r)=>(o.set(r[0],r[1]),o),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,v.createDecorator)("IExtHostConfiguration")});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[100],De([1,0,2,14,5,4,6,29,49,30,20,52,16,28,3,11,23,13,70,168,12]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(x){function H(G){if(G!=null)return G}x.from=H;function oe(G){if(G!=null)return G}x.to=oe})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var T;(function(x){function H(G){if(G!=null)return G}x.from=H;function oe(G){if(G!=null)return G}x.to=oe})(T=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(x){function H(G){if(G!=null)return G}x.from=H;function oe(G){if(G!=null)return G}x.to=oe})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(x){function H(M){if(M){const le=M;return le&&!!le.process}else return!1}x.is=H;function oe(M){if(M==null)return;const le={process:M.process,args:M.args};return M.options&&(le.options=i.from(M.options)),le}x.from=oe;function G(M){if(M!=null)return new I.ProcessExecution(M.process,M.args,M.options)}x.to=G})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(x){function H(G){if(G!=null)return G}x.from=H;function oe(G){if(G!=null)return G}x.to=oe})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(x){function H(M){if(M){const le=M;return le&&(!!le.commandLine||!!le.command)}else return!1}x.is=H;function oe(M){if(M==null)return;const le={};return M.commandLine!==void 0?le.commandLine=M.commandLine:(le.command=M.command,le.args=M.args),M.options&&(le.options=r.from(M.options)),le}x.from=oe;function G(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new I.ShellExecution(M.commandLine,M.options):new I.ShellExecution(M.command,M.args?M.args:[],M.options)}x.to=G})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(x){function H(M){if(M){let le=M;return le&&le.customExecution==="customExecution"}else return!1}x.is=H;function oe(M){return{customExecution:"customExecution"}}x.from=oe;function G(M,le){return le.get(M)}x.to=G})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(x){function H(oe,G){let M;return oe.scope!==void 0&&typeof oe.scope!="number"?M=oe.scope.uri:oe.scope!==void 0&&typeof oe.scope=="number"&&(oe.scope===I.TaskScope.Workspace&&G&&G.workspaceFile?M=G.workspaceFile:M=_.USER_TASKS_GROUP_KEY),{id:oe._id,workspaceFolder:M}}x.from=H})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(x){function H(oe){if(oe!=null)return{_id:oe.id,isDefault:oe.isDefault}}x.from=H})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function(x){function H(M,le){if(M==null)return[];const me=[];for(let ae of M){const ge=oe(ae,le);ge&&me.push(ge)}return me}x.fromMany=H;function oe(M,le){if(M==null)return;let me;M.execution instanceof I.ProcessExecution?me=o.from(M.execution):M.execution instanceof I.ShellExecution?me=t.from(M.execution):M.execution&&M.execution instanceof I.CustomExecution&&(me=s.from(M.execution));const ae=n.from(M.definition);let ge;return M.scope?typeof M.scope=="number"?ge=M.scope:ge=M.scope.uri:ge=I.TaskScope.Workspace,!ae||!ge?void 0:{_id:M._id,definition:ae,name:M.name,source:{extensionId:le.identifier.value,label:M.source,scope:ge},execution:me,isBackground:M.isBackground,group:d.from(M.group),presentationOptions:T.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}x.from=oe;async function G(M,le,me){if(M==null)return;let ae;o.is(M.execution)?ae=o.to(M.execution):t.is(M.execution)?ae=t.to(M.execution):s.is(M.execution)&&(ae=s.to(M._id,me));const ge=n.to(M.definition);let te;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?te=M.source.scope:te=await le.resolveWorkspaceFolder(a.URI.revive(M.source.scope)):te=I.TaskScope.Workspace),!ge||!te)return;const Ee=new I.Task(ge,te,M.name,M.source.label,ae,M.problemMatchers);return M.isBackground!==void 0&&(Ee.isBackground=M.isBackground),M.group!==void 0&&(Ee.group=I.TaskGroup.from(M.group._id),Ee.group&&M.group.isDefault&&(Ee.group=new I.TaskGroup(Ee.group.id,Ee.group.label),M.group.isDefault&&(Ee.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Ee.presentationOptions=T.to(M.presentationOptions)),M._id&&(Ee._id=M._id),M.detail&&(Ee.detail=M.detail),Ee}x.to=G})(C=e.TaskDTO||(e.TaskDTO={}));var O;(function(x){function H(G){return G}x.from=H;function oe(G){if(!!G)return Object.assign(Object.create(null),G)}x.to=oe})(O=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(H,oe,G){this._id=oe,this._task=G,S.set(this,void 0),Qe(this,S,H,"f")}get task(){return this._task}terminate(){Re(this,S,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}S=new WeakMap;var A;(function(x){function H(oe){return{id:oe._id,task:void 0}}x.from=H})(A=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(H,oe,G,M,le,me,ae,ge){this._onDidExecuteTask=new g.Emitter,this._onDidTerminateTask=new g.Emitter,this._onDidTaskProcessStarted=new g.Emitter,this._onDidTaskProcessEnded=new g.Emitter,this._proxy=H.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=G,this._editorService=M,this._configurationService=le,this._terminalService=me,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ae,this._deprecationService=ge,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,oe,G){if(!G)return new I.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:oe,provider:G,extension:H}),this._proxy.$registerTaskProvider(M,oe),new I.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(H,oe){this._proxy.$registerTaskSystem(H,oe)}fetchTasks(H){return this._proxy.$fetchTasks(O.from(H)).then(async oe=>{const G=[];for(let M of oe){const le=await C.to(M,this._workspaceProvider,this._providedCustomExecutions2);le&&G.push(le)}return G})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(oe=>H.push(oe)),H}terminateTask(H){if(!(H instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,oe,G){const M=this._providedCustomExecutions2.get(H.id);M&&(this._activeCustomExecutions2.set(H.id,M),this._terminalService.attachPtyToTerminal(oe,await M.callback(G))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const oe=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:oe})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const oe=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:oe,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const oe=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:oe,exitCode:H.exitCode})}$provideTasks(H,oe){const G=this._handlers.get(H);if(!G)return Promise.reject(new Error("no handler found"));const M=[],le=(0,D.asPromise)(()=>G.provider.provideTasks(R.CancellationToken.None)).then(me=>this.provideTasksInternal(oe,M,G,me));return new Promise(me=>{le.then(ae=>{Promise.all(M).then(()=>{me(ae)})})})}async $resolveTask(H,oe){const G=this._handlers.get(H);if(!G)return Promise.reject(new Error("no handler found"));if(oe.definition.type!==G.type)throw new Error(`Unexpected: Task of type [${oe.definition.type}] cannot be resolved by provider of type [${G.type}].`);const M=await C.to(oe,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const le=await G.provider.resolveTask(M,R.CancellationToken.None);if(!le)return;this.checkDeprecation(le,G);const me=C.from(le,G.extension);if(!me)throw new Error("Unexpected: Task cannot be resolved.");if(le.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(me.execution)&&await this.addCustomExecution(me,le,!0),await this.resolveTaskInternal(me)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,oe,G){const M=await this._proxy.$createTaskId(H);!G&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,oe.execution)),this._providedCustomExecutions2.set(M,oe.execution)}async getTaskExecution(H,oe){if(typeof H=="string"){const le=this._taskExecutionPromises.get(H);if(!le)throw new Error("Unexpected: The specified task is missing an execution");return le}let G=this._taskExecutionPromises.get(H.id);if(G)return G;const M=new Promise((le,me)=>{function ae(ge,te,Ee){Ee?le(new U(ge,te.id,Ee)):me("Unexpected: Task does not exist.")}oe?ae(this,H,oe):C.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(ge=>ae(this,H,ge))});return this._taskExecutionPromises.set(H.id,M),M.then(le=>(this._taskExecutions.set(H.id,le),le),le=>Promise.reject(le))}checkDeprecation(H,oe){H._deprecated&&this._deprecationService.report("Task.constructor",oe.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let G=this._notProvidedCustomExecutions.values(),M=G.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=G.next()}};E=$e([ze(0,p.IExtHostRpcService),ze(1,w.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,b.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,v.IExtHostTerminalService),ze(6,c.ILogService),ze(7,y.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let $=class extends E{constructor(H,oe,G,M,le,me,ae,ge){super(H,oe,G,M,le,me,ae,ge);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(H,oe){if(!oe.execution)throw new Error("Tasks to execute must include an execution");const G=C.from(oe,H);if(G===void 0)throw new Error("Task is not valid");if(s.is(G.execution))await this.addCustomExecution(G,oe,!1);else throw new l.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(G),oe);return this._proxy.$executeTask(G).catch(le=>{throw new Error(le)}),M}provideTasksInternal(H,oe,G,M){const le=[];if(M)for(let me of M){this.checkDeprecation(me,G),(!me.definition||!H[me.definition.type])&&this._logService.warn(`The task [${me.source}, ${me.name}] uses an undefined task type. The task will be ignored in the future.`);const ae=C.from(me,G.extension);ae&&s.is(ae.execution)?(le.push(ae),oe.push(this.addCustomExecution(ae,me,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:le,extension:G.extension}}async resolveTaskInternal(H){if(s.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,oe){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,oe,G){}};$=$e([ze(0,p.IExtHostRpcService),ze(1,w.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,b.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,v.IExtHostTerminalService),ze(6,c.ILogService),ze(7,y.IExtHostApiDeprecationService)],$),e.WorkerExtHostTask=$,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Se[219],De([1,0,17,20,43,33,24,195,40]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(p,w,f){this.config=p,this.provider=w,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&L.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&L.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const w=this.config.folderQueries||[];return new Promise((f,u)=>{const h=c=>{this.resultCount++,p(c)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(c=>{const y=c.toString(),_=a.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,_)||this.matchFile(h,{base:c,basename:_})}),Promise.all(w.map(c=>this.searchInFolder(c,h))).then(c=>{f({limitHit:this.isLimitHit,stats:c[0]||void 0})},c=>{u(new Error((0,g.toErrorMessage)(c)))})})}async searchInFolder(p,w){const f=new D.CancellationTokenSource,u=this.getSearchOptionsForFolder(p),h=this.initDirectoryTree(),c=new b.QueryGlobTester(this.config,p),y=!c.hasSiblingExcludeClauses();let _;try{this.activeCancellationTokens.add(f),_=k.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,f.token),S=_.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(T=>{const i=a.posix.relative(p.folder.path,T.path);if(y){const o=a.basename(T.path);this.matchFile(w,{base:p.folder,relativePath:i,basename:o});return}this.addDirectoryEntries(h,p.folder,i,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,c,w),{providerTime:S,postProcessTime:n.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(p){const w=(0,b.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),f=(0,b.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:f,includes:w,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},w,f,u){if(f===this.filePattern){const c=a.basename(this.filePattern);this.matchFile(u,{base:w,relativePath:this.filePattern,basename:c})}function h(c){const y=a.basename(c),_=a.dirname(c);let l=p[_];l||(l=p[_]=[],h(_)),l.push({base:w,relativePath:c,basename:y})}h(f)}matchDirectoryTree({rootEntries:p,pathToEntries:w},f,u){const h=this,c=this.filePattern;function y(_){const l=(0,b.hasSiblingFn)(()=>_.map(S=>S.basename));for(let S=0,n=_.length;S<n;S++){const T=_[S],{relativePath:i,basename:o}=T;if(f.matchesExcludesSync(i,o,c!==o?l:void 0))continue;const r=w[i];if(r)y(r);else{if(i===c)continue;h.matchFile(u,T)}if(h.isLimitHit)break}}y(p)}matchFile(p,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(w))}}class R{constructor(){this.sessions=new Map}fileSearch(p,w,f,u){const h=this.getSessionTokenSource(p.cacheKey),c=new P(p,w,h&&h.token);let y=0;const _=l=>{y+=l.length,f(l.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(c,R.BATCH_SIZE,_,u).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:l.stats}}))}clearCache(p){const w=this.getSessionTokenSource(p);w&&w.cancel()}getSessionTokenSource(p){if(!!p)return this.sessions.has(p)||this.sessions.set(p,new D.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:I.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,w,f,u){u.onCancellationRequested(()=>{p.cancel()});const h=y=>{y&&(c.push(y),w>0&&c.length>=w&&(f(c),c=[]))};let c=[];return p.search(h).then(y=>(c.length&&f(c),y),y=>(c.length&&f(c),Promise.reject(y)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Se[220],De([1,0,15,54,33,76,22,11,17,24,9,10,2,238,140,59,13,45,89,218,40]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let S=class{constructor(d,C,O,U,A){this.configurationService=d,this.workspaceContextService=C,this.editorGroupsService=O,this.logService=U,this.pathService=A}text(d,C,O={}){d=this.getContentPattern(d,O);const U=this.configurationService.getValue(),A=C&&C.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(C?.map(c.toWorkspaceFolder),O),type:2,contentPattern:d,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:U.search.usePCRE2||A||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}getContentPattern(d,C){const O=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const U={...d,wordSeparators:O.editor.wordSeparators};return this.isCaseSensitive(d,C)&&(U.isCaseSensitive=!0),this.isMultiline(d)&&(U.isMultiline=!0),U}file(d,C={}){return{...this.commonQuery(d,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(d,C){return d?(d=Array.isArray(d)?d.map(r):r(d),C?this.parseSearchPaths(d):{pattern:T(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],C={}){const O=this.handleIncludeExclude(C.includePattern,C.expandPatterns),U=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),A=d.length>1,E=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,C,U)):d.map(H=>this.getFolderQueryForRoot(H,C,U,A))).filter(H=>!!H),$={_reason:C._reason,folderQueries:E,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:U.pattern,includePattern:O.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const H=a.coalesce(a.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(le=>le.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(H));const oe=H.filter(M=>(0,l.pathIncludedInQuery)($,M.fsPath)),G=this.commonQueryFromFileList(oe);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(G)),{...$,...G}}const x=C.extraFileResources&&C.extraFileResources.filter(H=>(0,l.pathIncludedInQuery)($,H.fsPath));return $.extraFileResources=x&&x.length?x:void 0,$}commonQueryFromFileList(d){const C=[],O=new I.ResourceMap,U={};let A=!1;return d.forEach(E=>{if(E.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(E)){const x=this.workspaceContextService.getWorkspaceFolder(E)?.uri??E.with({path:b.dirname(E.fsPath)});let H=O.get(x);H||(A=!0,H={folder:x,includePattern:{}},C.push(H),O.set(x,H));const oe=b.relative(x.fsPath,E.fsPath);(0,v.assertIsDefined)(H.includePattern)[oe.replace(/\\/g,"/")]=!0}else E.fsPath&&(A=!0,U[E.fsPath]=!0)}),{folderQueries:C,includePattern:U,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(d,C){if(C.isSmartCase){if(d.isRegExp){if(R.containsUppercaseCharacter(d.pattern,!0))return!0}else if(R.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,w.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const C=G=>b.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),U=(Array.isArray(d)?d:i(d)).map(G=>{const M=this.pathService.resolvedUserHome;return M?(0,L.untildify)(G,M.scheme===k.Schemas.file?M.fsPath:M.path):G}),A=D.groupBy(U,G=>C(G)?"searchPaths":"exprSegments"),E=(A.exprSegments||[]).map(G=>R.rtrim(G,"/")).map(G=>R.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),o(G))),$={},x=this.expandSearchPathPatterns(A.searchPaths||[]);x&&x.length&&($.searchPaths=x);const H=a.flatten(E),oe=T(...H);return oe&&($.pattern=oe),$}getExcludesForFolder(d,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(d,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const C=a.flatten(d.map(U=>{let{pathPortion:A,globPortion:E}=n(U);E&&(E=t(E));const $=this.expandOneSearchPath(A);return a.flatten($.map(x=>this.resolveOneSearchPathPattern(x,E)))})),O=new Map;return C.forEach(U=>{const A=U.searchPath.toString(),E=O.get(A);E?U.pattern&&(E.pattern=E.pattern||{},E.pattern[U.pattern]=!0):O.set(A,{searchPath:U.searchPath,pattern:U.pattern?T(U.pattern):void 0})}),Array.from(O.values())}expandOneSearchPath(d){if(b.isAbsolute(d)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==k.Schemas.file?[{searchPath:C[0].uri.with({path:d})}]:[{searchPath:p.URI.file(b.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=r(d),d.startsWith("../")||d===".."){const U=b.posix.resolve(C.path,d);return[{searchPath:C.with({path:U})}]}const O=t(d);return[{searchPath:C,pattern:O}]}else{if(d==="./"||d===".\\")return[];{const C=d.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(A=>{const E=C.match(new RegExp(`^${R.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return E?{match:E,folder:A}:null}).filter(v.isDefined);if(U.length)return U.map(A=>{const E=A.match[1];return{searchPath:A.folder.uri,pattern:E&&t(E)}});{const A=d.match(/\.[\/\\](.+)[\/\\]?/),E=A?A[1]:d,$=f.localize(0,null,E);throw new Error($)}}}}resolveOneSearchPathPattern(d,C){const O=d.pattern&&C?`${d.pattern}/${C}`:d.pattern||C,U=[{searchPath:d.searchPath,pattern:O}];return O&&!O.endsWith("**")&&U.push({searchPath:d.searchPath,pattern:O+"/**"}),U}getFolderQueryForSearchPath(d,C,O){const U=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(d.searchPath),C,O,!1);return U?{...U,includePattern:d.pattern}:null}getFolderQueryForRoot(d,C,O,U){let A;const E=p.URI.isUri(d)?d:d.uri;if(O.searchPaths){const G=O.searchPaths.filter(M=>(0,P.isEqual)(M.searchPath,E))[0];if(G&&!G.pattern)return null;G&&(A=G.pattern)}const $=this.configurationService.getValue({resource:E}),H={...this.getExcludesForFolder($,C)||{},...A||{}},oe=p.URI.isUri(d)?(0,P.basename)(d):d.name;return{folder:E,folderName:U?oe:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!$.search.followSymlinks}}};S=$e([ze(0,u.IConfigurationService),ze(1,c.IWorkspaceContextService),ze(2,y.IEditorGroupsService),ze(3,h.ILogService),ze(4,_.IPathService)],S),e.QueryBuilder=S;function n(m){const d=m.match(/[\*\{\}\(\)\[\]\?]/);if(d){const C=d.index,O=m.substr(0,C).match(/[/|\\][^/\\]*$/);if(O){let U=m.substr(0,O.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:m.substr((O.index||0)+1)}}}return{pathPortion:m}}function T(...m){return m.length?m.reduce((d,C)=>(d[C]=!0,d),Object.create(null)):void 0}function i(m){return g.splitGlobAware(m,",").map(d=>d.trim()).filter(d=>!!d.length)}function o(m){return[`**/${m}/**`,`**/${m}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function t(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(m,d){m=a.distinct(m,U=>U.toString());const C=[],O=d.getWorkspace();return m&&m.forEach(U=>{let A;if(d.getWorkbenchState()===2)A=(0,P.relativePath)(O.folders[0].uri,U),A&&A!=="."&&(A="./"+A);else{const E=d.getWorkspaceFolder(U);if(E){const $=E.name;if(O.folders.filter(H=>H.name===$).length===1){const H=(0,P.relativePath)(E.uri,U);H===""?A=`./${E.name}`:A=`./${E.name}/${H}`}else A=U.fsPath}}A&&C.push(A)}),C}e.resolveResourcesForSearchIncludes=s}),define(Se[221],De([1,0,24,2,20,12,3,220,40,45]),function(ee,e,a,D,g,L,I,k,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function v(u,h){const c=h.activationEvents;if(!c)return Promise.resolve(void 0);const y=[],_=[];for(const o of c)if(/^workspaceContains:/.test(o)){const r=o.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||u.forceUsingSearch?_.push(r):y.push(r)}if(y.length===0&&_.length===0)return Promise.resolve(void 0);let l;const S=new Promise((o,r)=>{l=o}),n=o=>l({activationEvent:o}),T=Promise.all(y.map(o=>p(u,o,n))).then(()=>{}),i=w(u,h.identifier,_,n);return Promise.all([T,i]).then(()=>{l(void 0)}),S}e.checkActivateWorkspaceContainsExtension=v;async function p(u,h,c){for(const y of u.folders)if(await u.exists(a.joinPath(D.URI.revive(y),h))){c(`workspaceContains:${h}`);return}}async function w(u,h,c,y){if(c.length===0)return Promise.resolve(void 0);const _=new g.CancellationTokenSource,l=u.checkExists(u.folders,c,_.token),S=setTimeout(async()=>{_.cancel(),u.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},R);let n=!1;try{n=await l}catch(T){L.isCancellationError(T)||L.onUnexpectedError(T)}_.dispose(),clearTimeout(S),n&&y(`workspaceContains:${c.join(",")}`)}function f(u,h,c,y){const _=u.get(I.IInstantiationService),l=u.get(b.ISearchService),n=_.createInstance(k.QueryBuilder).file(h.map(T=>(0,P.toWorkspaceFolder)(D.URI.revive(T))),{_reason:"checkExists",includePattern:c,exists:!0});return l.fileSearch(n,y).then(T=>!!T.limitHit,T=>L.isCancellationError(T)?!1:Promise.reject(T))}e.checkGlobFileExists=f});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!g:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(ee,a):g?g.value=a:e.set(ee,a),a},Re=this&&this.__classPrivateFieldGet||function(ee,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(ee):D?D.value:e.get(ee)};define(Se[31],De([1,0,129,17,73,24,14,7,22,2,13,4,30,177,71,29,21,176,12,26,25,156,6,82,3,28,72,16,60,64,52,5,221,69,158,11]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l,S,n,T,i,o,r,t,s,m,d,C,O,U,A,E){"use strict";var $,x,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let oe=class Ti extends k.Disposable{constructor(te,Ee,we,Z,pe,Pe,Ne,We,Ge,Ce){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=we,this._initData=Ne,this._extHostWorkspace=Z,this._extHostConfiguration=pe,this._logService=Pe,this._extHostTunnelService=Ge,this._extHostTerminalService=Ce,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(v.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(v.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(v.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._globalRegistry=new c.ExtensionDescriptionRegistry(this._initData.allExtensions);const _e=(0,h.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new c.ExtensionDescriptionRegistry(le(this._globalRegistry,_e)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=te.createChild(new s.ServiceCollection([f.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));let Te=[],se=[];this._initData.remote.isRemote&&(Te=this._initData.allExtensions.filter(Q=>!Q.main&&!Q.browser).map(Q=>Q.identifier),se=this._initData.allExtensions.filter(Q=>!_e.has(_.ExtensionIdentifier.toKey(Q.identifier.value))).filter(Q=>(Q.main||Q.browser)&&Q.api==="none").map(Q=>Q.identifier));const ue=(0,h.extensionIdentifiersArrayToSet)(se);this._activator=this._register(new w.ExtensionsActivator(this._myRegistry,Te,se,{onExtensionActivationError:(Q,J,ce)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Q,y.transformErrorForSerialization(J),ce)},actualActivateExtension:async(Q,J)=>{if(ue.has(_.ExtensionIdentifier.toKey(Q)))return await this._mainThreadExtensionsProxy.$activateExtension(Q,J),new w.HostExtension;const ce=this._myRegistry.getExtensionDescription(Q);return this._activateExtension(ce,J)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),g.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){y.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch{}await Promise.all(te)}terminate(te,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),y.setUnexpectedErrorHandler(Z=>{this._logService.error(Z)}),this._extHostContext.dispose();const we=this._deactivateAll();Promise.race([(0,I.timeout)(5e3),we]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const Ee=await this._mainThreadExtensionsProxy.$getExtension(te);return Ee&&{...Ee,identifier:new _.ExtensionIdentifier(Ee.identifier.value),extensionLocation:P.URI.revive(Ee.extensionLocation)}}_activateByEvent(te,Ee){return this._activator.activateByEvent(te,Ee)}_activateById(te,Ee){return this._activator.activateById(te,Ee)}activateByIdWithErrors(te,Ee){return this._activateById(te,Ee).then(()=>{const we=this._activator.getActivatedExtension(te);if(we.activationFailed)return Promise.reject(we.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==E.Schemas.file)return te;const Ee=await this._hostUtils.realpath(te.fsPath);return P.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new ae(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const Ee=b.TernarySearchTree.forUris(we=>L.extUriBiasedIgnorePathCase.ignorePathCasing(we));return await Promise.all(te.map(async we=>{if(this._getEntryPoint(we)){const Z=await this._realPathExtensionUri(we.extensionLocation);Ee.set(Z,we)}})),Ee}_deactivate(te){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return Ee;const we=this._activator.getActivatedExtension(te);if(!we)return Ee;try{typeof we.module.deactivate=="function"&&(Ee=Promise.resolve(we.module.deactivate()).then(void 0,Z=>(this._logService.error(Z),Promise.resolve(void 0))))}catch(Z){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(Z)}try{(0,k.dispose)(we.subscriptions)}catch(Z){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(Z)}return Ee}async _activateExtension(te,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,Ee).then(we=>{const Z=we.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,Z.codeLoadingTime,Z.activateCallTime,Z.activateResolvedTime,Ee),this._logExtensionActivationTimes(te,Ee,"success",Z),we},we=>{throw this._logExtensionActivationTimes(te,Ee,"failure"),we})}_logExtensionActivationTimes(te,Ee,we,Z){const pe=G(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...Z||{},outcome:we})}_doActivateExtension(te,Ee){const we=G(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",we);const Z=this._getEntryPoint(te);if(!Z)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${te.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const pe=new w.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(te.identifier,(0,L.joinPath)(te.extensionLocation,Z),pe),this._loadExtensionContext(te)]).then(Pe=>(g.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ti._callActivate(this._logService,te.identifier,Pe[0],Pe[1],pe))).then(Pe=>(g.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Pe))}_loadExtensionContext(te){const Ee=new S.ExtensionGlobalMemento(te,this._storage),we=new S.ExtensionMemento(te.identifier.value,!1,this._storage),Z=new A.ExtensionSecrets(te,this._secretState),pe=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Pe=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([Ee.whenReady,we.whenReady,this._storagePath.whenReady]).then(()=>{const Ne=this;let We,Ge;const Ce=(0,h.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(_.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:we,secrets:Z,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(_e){return D.join(te.extensionLocation.fsPath,_e)},get storagePath(){return Ne._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Ne._storagePath.globalValue(te).fsPath},get logPath(){return D.join(Ne._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return P.URI.joinPath(Ne._initData.logsLocation,te.identifier.value)},get storageUri(){return Ne._storagePath.workspaceValue(te)},get globalStorageUri(){return Ne._storagePath.globalValue(te)},get extensionMode(){return pe},get extension(){return We===void 0&&(We=new M(Ne,te.identifier,te,Pe,!1)),We},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(te,"extensionRuntime"),Ne.extensionRuntime},get environmentVariableCollection(){return Ne._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Ge){if(!Ce)return;const _e=C.Event.buffer(C.Event.fromDOMEventEmitter(Ce,"message",Te=>Te.data));Ce.start(),Ge={onDidReceiveMessage:_e,postMessage:Ce.postMessage.bind(Ce)}}return Ge}})})}static _callActivate(te,Ee,we,Z,pe){return we=we||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,Ee,we,Z,pe).then(Pe=>new w.ActivatedExtension(!1,null,pe.build(),we,Pe,Z.subscriptions))}static _callActivateOptional(te,Ee,we,Z,pe){if(typeof we.activate=="function")try{pe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Pe=typeof global=="object"?global:self,Ne=we.activate.apply(Pe,[Z]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Ne).then(We=>(pe.activateResolveStop(),We))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(we)}_activateOneStartupFinished(te,Ee){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:Ee}).then(void 0,we=>{this._logService.error(we)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(g.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const Ee of te.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(te,Ee)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],we=this._handleWorkspaceContainsEagerExtensions(Ee),Z=Promise.all([te,we]).then(()=>{});return Promise.race([Z,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(te,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,Ee){if(this.isActivated(Ee.identifier))return;const we=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Z={logService:this._logService,folders:te.map(Pe=>Pe.uri),forceUsingSearch:we,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Ne,We)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Ne,We)},pe=await(0,O.checkActivateWorkspaceContainsExtension)(Z,Ee);if(!!pe)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:pe.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:Ee}=this._initData.environment;if(!te||!Ee)throw new Error(a.localize(0,null));const we=await this._loadCommonJSModule(null,Ee,new w.ExtensionActivationTimesBuilder(!1));if(!we||typeof we.run!="function")throw new Error(a.localize(1,null,Ee.toString()));return new Promise((Z,pe)=>{const Pe=(Ge,Ce)=>{Ge?pe(Ge):Z(typeof Ce=="number"&&Ce>0?1:0)},Ne=(0,L.originalFSPath)(Ee),We=we.run(Ne,Pe);We&&We.then&&We.then(()=>{Z(0)}).catch(Ge=>{pe(Ge instanceof Error&&Ge.stack?Ge.stack:String(Ge))})})}async $extensionTestsExit(te){this.terminate(`test runner requested exit with code ${te}`,te)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,Ee){return this._resolvers[te]=Ee,(0,k.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const Ee=te.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const we=te.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${we}`,!1),{authorityPrefix:we,resolver:this._resolvers[we]}}async $resolveAuthority(te,Ee){this._logService.info(`$resolveAuthority invoked for authority (${me(te)})`);const{authorityPrefix:we,resolver:Z}=await this._activateAndGetResolver(te);if(!Z)return{type:"error",error:{code:T.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${we}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Z)),g.mark(`code/extHost/willResolveAuthority/${we}`);const pe=await Z.resolve(te,{resolveAttempt:Ee});g.mark(`code/extHost/didResolveAuthorityOK/${we}`);const Pe={authority:te,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},Ne={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Ne,tunnelInformation:{environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures}}}}catch(pe){if(g.mark(`code/extHost/didResolveAuthorityError/${we}`),pe instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}async $getCanonicalURI(te,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${me(te)})`);const{resolver:we}=await this._activateAndGetResolver(te);if(!we)return null;const Z=P.URI.revive(Ee);if(typeof we.getCanonicalURI=="undefined")return Z;const pe=await(0,I.asPromise)(()=>we.getCanonicalURI(Z));return pe||Z}static _applyExtensionsDelta(te,Ee,we){const Z=new c.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());Z.deltaExtensions(we.toAdd,we.toRemove);const pe=(0,h.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Ne=>Ne.identifier));for(const Ne of we.myToRemove)pe.delete(_.ExtensionIdentifier.toKey(Ne));for(const Ne of we.myToAdd)pe.add(_.ExtensionIdentifier.toKey(Ne));const Pe=le(Z,pe);return{globalRegistry:Z,myExtensions:Pe}}$startExtensionHost(te){te.toAdd.forEach(Z=>Z.extensionLocation=P.URI.revive(Z.extensionLocation));const{globalRegistry:Ee,myExtensions:we}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(we),this._startExtensionHost()}$activateByEvent(te,Ee){return Ee===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(we=>this._activateByEvent(te,!1))}async $activate(te,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,Ee),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Pe=>Pe.extensionLocation=P.URI.revive(Pe.extensionLocation));const{globalRegistry:Ee,myExtensions:we}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),Z=await this._createExtensionPathIndex(we);return(await this.getExtensionPathIndex()).setSearchTree(Z),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(we),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){let Ee=l.VSBuffer.alloc(te),we=Math.random()%256;for(let Z=0;Z<te;Z++)Ee.writeUInt8(we,Z);return Ee}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};oe=$e([ze(0,i.IInstantiationService),ze(1,e.IHostUtils),ze(2,t.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,p.IExtHostConfiguration),ze(5,R.ILogService),ze(6,o.IExtHostInitDataService),ze(7,r.IExtensionStoragePaths),ze(8,m.IExtHostTunnelService),ze(9,d.IExtHostTerminalService)],oe),e.AbstractExtHostExtensionService=oe;function G(ge,te){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class M{constructor(te,Ee,we,Z,pe){$.set(this,void 0),x.set(this,void 0),H.set(this,void 0),Qe(this,$,te,"f"),Qe(this,x,Ee,"f"),Qe(this,H,we.identifier,"f"),this.id=we.identifier.value,this.extensionUri=we.extensionLocation,this.extensionPath=D.normalize((0,L.originalFSPath)(we.extensionLocation)),this.packageJSON=we,this.extensionKind=Z,this.isFromDifferentExtensionHost=pe}get isActive(){return Re(this,$,"f").isActivated(Re(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,$,"f").getExtensionExports(Re(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,$,"f").activateByIdWithErrors(Re(this,H,"f"),{startup:!1,extensionId:Re(this,x,"f"),activationEvent:"api"}),this.exports}}e.Extension=M,$=new WeakMap,x=new WeakMap,H=new WeakMap;function le(ge,te){return ge.getAllExtensionDescriptions().filter(Ee=>te.has(_.ExtensionIdentifier.toKey(Ee.identifier)))}function me(ge){const te=ge.indexOf("+");return te===-1?ge:ge.substring(0,te)}class ae{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=ae}),define(Se[222],De([1,0,73,2,4,30,21,26,16,28,3,31,61,13,9]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(S,n,T,i,o,r,t){this._apiFactory=S,this._extensionRegistry=n,this._instaService=T,this._extHostConfiguration=i,this._extHostExtensionService=o,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const S=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,n,this._extensionRegistry,S,this._logService)),this.register(this._instaService.createInstance(y,n)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,n,this._initData.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(let n of S.nodeModuleName)this._factories.set(n,S);else this._factories.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this._alternatives.push(n=>S.alternativeModuleName(n))}};u=$e([ze(2,R.IInstantiationService),ze(3,L.IExtHostConfiguration),ze(4,v.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,w.ILogService)],u),e.RequireInterceptor=u;let h=class Gi{constructor(S){if(S.environment.appRoot&&Gi.aliased.size){const n=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(S.environment.appRoot.fsPath)),T="[a-z0-9_.-]",i=`@${T}+\\/${T}+|${T}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${o}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(S){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(S));if(!n)return;const[,T,i,o]=n,r=Gi.aliased.get(i);if(r!==void 0)return console.warn(`${i} as been renamed to ${r}, please update your imports`),T+r+o}forceForwardSlashes(S){return S.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=$e([ze(0,P.IExtHostInitDataService)],h);class c{constructor(S,n,T,i,o){this._apiFactory=S,this._extensionPaths=n,this._extensionRegistry=T,this._configProvider=i,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(S,n){const T=this._extensionPaths.findSubstr(n);if(T){let i=this._extApiImpl.get(k.ExtensionIdentifier.toKey(T.identifier));return i||(i=this._apiFactory(T,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(T.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((o,r)=>i+=`	${r} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(S,n,T){this._extensionPaths=S,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(g.MainContext.MainThreadTelemetry);const{environment:i}=T,o=n.getProxy(g.MainContext.MainThreadKeytar);if(i.appRoot){let r=i.appRoot.fsPath;p.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>o.$getPassword(r,t),setPassword:(r,t,s)=>o.$setPassword(r,t,s),deletePassword:(r,t)=>o.$deletePassword(r,t),findPassword:r=>o.$findPassword(r),findCredentials(r){return o.$findCredentials(r)}}}load(S,n){const T=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:T?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(S){const n=S.length;if(n<=7||!this.alternativeNames)return;const T=n-7;if((S.charAt(T)==="/"||S.charAt(T)==="\\")&&S.endsWith("keytar")&&(S=S.replace(/\\/g,"/"),this.alternativeNames.has(S)))return"keytar"}};y=$e([ze(1,b.IExtHostRpcService),ze(2,P.IExtHostInitDataService)],y);let _=class{constructor(S,n,T){this._extensionPaths=S,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=T.getProxy(g.MainContext.MainThreadTelemetry);const i=T.getProxy(g.MainContext.MainThreadWindow);this._impl=(o,r)=>{const t=D.URI.parse(o);return r?this.callOriginal(o,r):t.scheme==="http"||t.scheme==="https"?i.$openUri(t,o,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?i.$openUri(t,o,{}):this.callOriginal(o,r)}}load(S,n,T){const i=this._extensionPaths.findSubstr(n);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=T(S),this._impl}callOriginal(S,n){return this.sendNoForwardTelemetry(),this._original(S,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};_=$e([ze(2,b.IExtHostRpcService)],_)}),define(Se[101],De([1,0,189,7,17,61,3,49,50,31,6,29,170,30]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends p.AbstractVariableResolverService{constructor(c,y,_,l,S,n,T){function i(){if(_){const o=_.activeEditor();if(o)return o.document.uri;const r=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:o=>{const r=n.folders.filter(t=>t.name===o);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,r)=>S.getConfiguration(void 0,o).get(r),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return g.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(y){const o=i();if(o){const r=y.getWorkspaceFolder(o);if(r)return g.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(_){const o=_.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(_){const o=_.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>c.getExtension(o)},void 0,T?Promise.resolve(T):void 0,Promise.resolve(L.env))}}let u=class extends D.Disposable{constructor(c,y,_,l,S){super();this.extensionService=c,this.workspaceService=y,this.editorService=_,this.configurationService=l,this.editorTabs=S,this._resolver=new a.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};u=$e([ze(0,P.IExtHostExtensionService),ze(1,v.IExtHostWorkspace),ze(2,k.IExtHostDocumentsAndEditors),ze(3,w.IExtHostConfiguration),ze(4,b.IExtHostEditorTabs)],u),e.ExtHostVariableResolverProviderService=u}),define(Se[102],De([1,0,14,5,10,2,3,4,50,31,16,6,29,163,165,30,101]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let c=class{constructor(i,o,r,t,s,m){this._workspaceService=o,this._extensionService=r,this._configurationService=t,this._editorTabs=s,this._variableResolver=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=i.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new _(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(d=>{d.onDidChange(C=>{this.registerAllDebugTypes(d)}),this.registerAllDebugTypes(d)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,o){const r=i;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let t=`debug:${encodeURIComponent(r.path||"")}`,s="?";return o&&(t+=`${s}session=${encodeURIComponent(o.id)}`,s="&"),t+=`${s}ref=${r.sourceReference}`,L.URI.parse(t)}else{if(r.path)return L.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const o=[];for(const r of i.getAllExtensionDescriptions())if(r.contributes){const t=r.contributes.debuggers;if(t&&t.length>0)for(const s of t)(0,f.isDebuggerMainContribution)(s)&&o.push(s.type)}this._debugServiceProxy.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(o=>i.push(o)),i}addBreakpoints(i){this.startBreakpoints();const o=i.filter(s=>{const m=s.id;return this._breakpoints.has(m)?!1:(this._breakpoints.set(m,s),!0)});this.fireBreakpointChanges(o,[],[]);const r=[],t=new Map;for(const s of o)if(s instanceof v.SourceBreakpoint){let m=t.get(s.location.uri.toString());m||(m={type:"sourceMulti",uri:s.location.uri,lines:[]},t.set(s.location.uri.toString(),m),r.push(m)),m.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof v.FunctionBreakpoint&&r.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(i){this.startBreakpoints();const o=i.filter(m=>this._breakpoints.delete(m.id));this.fireBreakpointChanges([],o,[]);const r=o.filter(m=>m instanceof v.SourceBreakpoint).map(m=>m.id),t=o.filter(m=>m instanceof v.FunctionBreakpoint).map(m=>m.id),s=o.filter(m=>m instanceof v.DataBreakpoint).map(m=>m.id);return this._debugServiceProxy.$unregisterBreakpoints(r,t,s)}startDebugging(i,o,r){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,o,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===v.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,o,r){if(!o)return new v.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:t,provider:o}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,r,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,t),new v.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==o),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(i,o,r){if(!r)return new v.Disposable(()=>{});if(!this.definesDebugType(i,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.getAdapterDescriptorFactoryByType(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:o,handle:t,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(o,t),new v.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(i,o){if(!o)return new v.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:r,factory:o}),new v.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==o)})}async $runInTerminal(i,o){return Promise.resolve(void 0)}async $substituteVariables(i,o){let r;const t=await this.getFolder(i);return t&&(r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,o)}createDebugAdapter(i,o){if(i.type==="implementation")return new S(i.implementation)}createSignService(){}async $startDASession(i,o){const r=this,t=await this.getSession(o);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const m=this.convertToDto(s),d=this.createDebugAdapter(m,t);if(!d)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const C=d;return this._debugAdapters.set(i,C),this.getDebugAdapterTrackers(t).then(O=>(O&&this._debugAdaptersTrackers.set(i,O),C.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const A=U,E={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(A.arguments.value);E.body={signature:$},C.sendResponse(E)}else throw new Error("no signer")}catch($){E.success=!1,E.message=$.message,C.sendResponse(E)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(U),U=(0,f.convertToVSCPaths)(U,!0),r._debugServiceProxy.$acceptDAMessage(i,U)}),C.onError(U=>{O&&O.onError&&O.onError(U),this._debugServiceProxy.$acceptDAError(i,U.name,U.message,U.stack)}),C.onExit(U=>{O&&O.onExit&&O.onExit((0,g.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,g.withNullAsUndefined)(U),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),C.startSession()))})}$sendDAMessage(i,o){o=(0,f.convertToDAPaths)(o,!1);const r=this._debugAdaptersTrackers.get(i);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(o);const t=this._debugAdapters.get(i);t&&t.sendMessage(o)}$stopDASession(i){const o=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),o&&o.onWillStopSession&&o.onWillStopSession();const r=this._debugAdapters.get(i);return this._debugAdapters.delete(i),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const o=[],r=[],t=[];if(i.added)for(const s of i.added){const m=s.id;if(m&&!this._breakpoints.has(m)){let d;if(s.type==="function")d=new v.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")d=new v.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const C=L.URI.revive(s.uri);d=new v.SourceBreakpoint(new v.Location(C,new v.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}d._id=m,this._breakpoints.set(m,d),o.push(d)}}if(i.removed)for(const s of i.removed){const m=this._breakpoints.get(s);m&&(this._breakpoints.delete(s),r.push(m))}if(i.changed){for(const s of i.changed)if(s.id){const m=this._breakpoints.get(s.id);if(m){if(m instanceof v.FunctionBreakpoint&&s.type==="function"){const d=m;d.enabled=s.enabled,d.condition=s.condition,d.hitCondition=s.hitCondition,d.logMessage=s.logMessage,d.functionName=s.functionName}else if(m instanceof v.SourceBreakpoint&&s.type==="source"){const d=m;d.enabled=s.enabled,d.condition=s.condition,d.hitCondition=s.hitCondition,d.logMessage=s.logMessage,d.location=new v.Location(L.URI.revive(s.uri),new v.Position(s.line,s.character))}t.push(m)}}}this.fireBreakpointChanges(o,r,t)}$provideDebugConfigurations(i,o,r){return(0,a.asPromise)(async()=>{const t=this.getConfigProviderByHandle(i);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(o);return t.provideDebugConfigurations(s,r)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(i,o,r,t){return(0,a.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.getFolder(o);return s.resolveDebugConfiguration(m,r,t)})}$resolveDebugConfigurationWithSubstitutedVariables(i,o,r,t){return(0,a.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.getFolder(o);return s.resolveDebugConfigurationWithSubstitutedVariables(m,r,t)})}async $provideDebugAdapter(i,o){const r=this.getAdapterDescriptorFactoryByHandle(i);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(o);return this.getAdapterDescriptor(r,t).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(i){const o=await this.getSession(i);this._onDidStartDebugSession.fire(o)}async $acceptDebugSessionTerminated(i){const o=await this.getSession(i);o&&(this._onDidTerminateDebugSession.fire(o),this._debugSessions.delete(o.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,o){const r=await this.getSession(i);r&&r._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(i,o){const t={session:await this.getSession(i),event:o.event,body:o.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(i){if(i instanceof v.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof v.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof v.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof v.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const o=this._adapterFactories.filter(r=>r.type===i);if(o.length>0)return o[0].factory}getAdapterDescriptorFactoryByHandle(i){const o=this._adapterFactories.filter(r=>r.handle===i);if(o.length>0)return o[0].factory}getConfigProviderByHandle(i){const o=this._configProviders.filter(r=>r.handle===i);if(o.length>0)return o[0].provider}definesDebugType(i,o){if(i.contributes){const r=i.contributes.debuggers;if(r&&r.length>0){for(const t of r)if(t.label&&t.type&&t.type===o)return!0}}return!1}getDebugAdapterTrackers(i){const r=i.configuration.type,t=this._trackerFactories.filter(s=>s.type===r||s.type==="*").map(s=>(0,a.asPromise)(()=>s.factory.createDebugAdapterTracker(i)).then(m=>m,m=>null));return Promise.race([Promise.all(t).then(s=>{const m=s.filter(d=>!!d);if(m.length>0)return new l(m)}),new Promise((s,m)=>{const d=setTimeout(()=>{clearTimeout(d),m(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(i,o){const r=o.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new v.DebugAdapterServer(r));if(i){const s=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>i.createDebugAdapterDescriptor(o,this.daExecutableFromPackage(o,s))).then(m=>{if(m)return m})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(o,t))}daExecutableFromPackage(i,o){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,o,r){(i.length>0||o.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:o,changed:r}))}async getSession(i){if(i)if(typeof i=="string"){const o=this._debugSessions.get(i);if(o)return o}else{let o=this._debugSessions.get(i.id);if(!o){const r=await this.getFolder(i.folderUri),t=i.parent?this._debugSessions.get(i.parent):void 0;o=new y(this._debugServiceProxy,i.id,i.type,i.name,r,i.configuration,t),this._debugSessions.set(o.id,o),this._debugServiceProxy.$sessionCached(o.id)}return o}throw new Error("cannot find session")}getFolder(i){if(i){const o=L.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};c=$e([ze(0,R.IExtHostRpcService),ze(1,p.IExtHostWorkspace),ze(2,P.IExtHostExtensionService),ze(3,u.IExtHostConfiguration),ze(4,b.IExtHostEditorTabs),ze(5,h.IExtHostVariableResolverProvider)],c),e.ExtHostDebugServiceBase=c;class y{constructor(i,o,r,t,s,m,d){this._debugServiceProxy=i,this._id=o,this._type=r,this._name=t,this._workspaceFolder=s,this._configuration=m,this._parentSession=d}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,o){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,o)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=y;class _{constructor(i){this.value=Object.freeze({append(o){i.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=_;class l{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(o=>o.onError?o.onError(i):void 0)}onExit(i,o){this.trackers.forEach(r=>r.onExit?r.onExit(i,o):void 0)}}class S extends w.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends c{constructor(i,o,r,t,s,m){super(i,o,r,t,s,m)}};n=$e([ze(0,R.IExtHostRpcService),ze(1,p.IExtHostWorkspace),ze(2,P.IExtHostExtensionService),ze(3,u.IExtHostConfiguration),ze(4,b.IExtHostEditorTabs),ze(5,h.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(Se[223],De([1,0,12,73,2,4,214,13,58,60,28,146,16,65,31]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class u{constructor(c,y,_,l,S){this._hostUtils=_,this._rpcProtocol=new I.RPCProtocol(c,null,l),y=u._transform(y,this._rpcProtocol);const n=new P.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());n.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:S}),n.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),n.set(w.IURITransformerService,new w.URITransformerService(l)),n.set(f.IHostUtils,_);const T=new v.InstantiationService(n,!0);this._logService=T.invokeFunction(t=>t.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",y),this._extensionService=T.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(s,m)=>{let d="",C,O;for(const U of m)d+=`
	at ${U.toString()}`,O=U.getFileName(),!C&&O&&(C=t.findSubstr(g.URI.file(O)));return i.set(s,C),`${s.name||"Error"}: ${s.message||""}${d}`}});const o=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(L.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(t=>{const s=a.transformErrorForSerialization(t),m=i.get(t);m?o.$onExtensionRuntimeError(m.identifier,s):r.$onUnexpectedError(s)})}async asBrowserUri(c){const y=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return g.URI.revive(await y.$asBrowserUri(c))}terminate(c){this._extensionService.terminate(c)}static _transform(c,y){c.allExtensions.forEach(l=>l.extensionLocation=g.URI.revive(y.transformIncomingURIs(l.extensionLocation))),c.environment.appRoot=g.URI.revive(y.transformIncomingURIs(c.environment.appRoot));const _=c.environment.extensionDevelopmentLocationURI;return _&&(c.environment.extensionDevelopmentLocationURI=_.map(l=>g.URI.revive(y.transformIncomingURIs(l)))),c.environment.extensionTestsLocationURI=g.URI.revive(y.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=g.URI.revive(y.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=g.URI.revive(y.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=g.URI.revive(y.transformIncomingURIs(c.logsLocation)),c.logFile=g.URI.revive(y.transformIncomingURIs(c.logFile)),c.workspace=y.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=u}),define(Se[224],De([1,0,15,14,20,43,11,17,24,10,2,40]),function(ee,e,a,D,g,L,I,k,b,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class p{constructor(_,l,S,n){this.query=_,this.provider=l,this.fileUtils=S,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,l){const S=this.query.folderQueries||[],n=new g.CancellationTokenSource;return l.onCancellationRequested(()=>n.cancel()),new Promise((T,i)=>{this.collector=new f(_);let o=!1;const r=(t,s)=>{if(!o&&!this.isLimitHit){const m=this.resultSize(t);h(t)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,o=!0,n.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const d=this.resultSize(t);this.resultCount+=d,(d>0||!h(t))&&this.collector.add(t,s)}};Promise.all(S.map((t,s)=>this.searchInFolder(t,m=>r(m,s),n.token))).then(t=>{n.dispose(),this.collector.flush();const s=t.some(m=>!!m&&!!m.limitHit);T({limitHit:this.isLimitHit||s,messages:(0,a.flatten)(t.map(m=>m?.message?(0,P.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},t=>{n.dispose();const s=(0,L.toErrorMessage)(t);i(new Error(s))})})}resultSize(_){return h(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,l){const S=Array.isArray(_.ranges)?_.ranges:[_.ranges],n=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:S.slice(0,l),preview:{matches:n.slice(0,l),text:_.preview.text},uri:_.uri}}async searchInFolder(_,l,S){const n=new v.QueryGlobTester(this.query,_),T=[],i={report:t=>{if(!this.validateProviderResult(t))return;const s=_.folder.scheme===I.Schemas.file?(0,v.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(t.uri))):void 0,m=b.relativePath(_.folder,t.uri);if(m){const d=n.includedInQuery(m,k.basename(m),s);(0,D.isThenable)(d)?T.push(d.then(C=>{C&&l(t)})):d&&l(t)}}},o=this.getSearchOptionsForFolder(_),r=await this.provider.provideTextSearchResults(w(this.query.contentPattern),o,i,S);return T.length&&await Promise.all(T),r}validateProviderResult(_){if(h(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const l=(0,v.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),S=(0,v.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),n={folder:R.URI.from(_.folder),excludes:S,includes:l,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return n.usePCRE2=this.query.usePCRE2,n}}e.TextSearchManager=p;function w(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class f{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new c(512,l=>this.sendItems(l))}add(_,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!b.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(u(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=f;function u(y){return h(y)?{preview:{matches:(0,a.mapArrayOrNot)(y.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:y.preview.text},ranges:(0,a.mapArrayOrNot)(y.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function h(y){return!!y.preview}e.extensionResultIsMatch=h;class c{constructor(_,l){this.maxBatchSize=_,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,l){!_||this.addItemToBatch(_,l)}addItems(_,l){!_||this.addItemsToBatch(_,l)}addItemToBatch(_,l){this.batch.push(_),this.batchSize+=l,this.onUpdate()}addItemsToBatch(_,l){this.batch=this.batch.concat(_),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<c.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},c.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=c,c.TIMEOUT=4e3,c.START_BATCH_AFTER_COUNT=50}),define(Se[103],De([1,0,7,4,3,219,16,65,13,2,224]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,g.createDecorator)("IExtHostSearch");let v=class{constructor(u,h,c){this.extHostRpc=u,this._uriTransformer=h,this._logService=c,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,h){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const c=this._handlePool++;return this._textSearchProvider.set(c,h),this._proxy.$registerTextSearchProvider(c,this._transformScheme(u)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}registerFileSearchProvider(u,h){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const c=this._handlePool++;return this._fileSearchProvider.set(c,h),this._proxy.$registerFileSearchProvider(c,this._transformScheme(u)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(u,h,c,y){const _=p(c),l=this._fileSearchProvider.get(u);if(l)return this._fileSearchManager.fileSearch(_,l,S=>{this._proxy.$handleFileMatch(u,h,S.map(n=>n.resource))},y);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,h,c,y){const _=this._textSearchProvider.get(u);if(!_||!_.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const l=p(c);return this.createTextSearchManager(l,_).search(n=>this._proxy.$handleTextMatch(u,h,n),y)}$enableExtensionHostSearch(){}createTextSearchManager(u,h){return new R.TextSearchManager(u,h,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};v=$e([ze(0,I.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,b.ILogService)],v),e.ExtHostSearch=v;function p(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(u=>P.URI.revive(u))}}e.reviveQuery=p;function w(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(Se[225],De([1,0,58,98,29,94,30,36,49,52,100,102,103,71,64,70,97,51,35,69,84,50,197,13,178,101]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l,S,n,T,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(T.ILoggerService,n.ExtHostLoggerService),(0,a.registerSingleton)(T.ILogService,i.ExtHostLogService),(0,a.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,a.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,a.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,a.registerSingleton)(c.IExtHostConsumerFileSystem,c.ExtHostConsumerFileSystem),(0,a.registerSingleton)(v.IExtHostDebugService,v.WorkerExtHostDebugService),(0,a.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations),(0,a.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,a.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService),(0,a.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch),(0,a.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,a.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,a.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,a.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,a.registerSingleton)(g.IExtHostWorkspace,g.ExtHostWorkspace),(0,a.registerSingleton)(_.IExtHostSecretState,_.ExtHostSecretState),(0,a.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,a.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs),(0,a.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService)}),define(Se[226],De([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(g){if(g&&this._dragOperations.has(g)){const L=this._dragOperations.get(g);return this._dragOperations.delete(g),L}}addDragOperationTransfer(g,L){this._dragOperations.set(g,L)}getRenderedTreeElement(g){if(this._renderedElements.has(g))return this._renderedElements.get(g)}addRenderedTreeItemElement(g,L){this._renderedElements.set(g,L)}removeRenderedTreeItemElement(g){this._renderedElements.has(g)&&this._renderedElements.delete(g)}}e.TreeviewsService=a}),define(Se[227],De([1,0,133,24,2,5,7,14,6,10,15,8,20,86,226,21]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(_,l){if((0,P.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let S;return Array.isArray(_.highlights)&&(S=_.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),S=S.length?S:void 0),{label:_.label,highlights:S}}}class c{constructor(l,S,n){this._proxy=l,this.commands=S,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function T(i){return i&&i.$treeViewId&&i.$treeItemHandle}S.registerArgumentProcessor({processArgument:i=>T(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(o=>T(o)?this.convertArgument(o):o):i})}registerTreeDataProvider(l,S,n){const T=this.createTreeView(l,{treeDataProvider:S},n);return{dispose:()=>T.dispose()}}createTreeView(l,S,n){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const T=S.dragAndDropController?.dropMimeTypes??[],i=S.dragAndDropController?.dragMimeTypes??[],o=!!S.dragAndDropController?.handleDrag,r=!!S.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,dropMimeTypes:T,dragMimeTypes:i,hasHandleDrag:o,hasHandleDrop:r}),s=this.createExtHostTreeView(l,S,n);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(m){s.message=m},get title(){return s.title},set title(m){s.title=m},get description(){return s.description},set description(m){s.description=m},get badge(){return(0,u.checkProposedApiEnabled)(n,"badges"),s.badge},set badge(m){(0,u.checkProposedApiEnabled)(n,"badges"),s.badge=m},reveal:(m,d)=>s.reveal(m,d),dispose:async()=>{await t,this.treeViews.delete(l),s.dispose()}}}$getChildren(l,S){const n=this.treeViews.get(l);return n?n.getChildren(S):Promise.reject(new Error((0,a.localize)(0,null,l)))}async $handleDrop(l,S,n,T,i,o,r){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,a.localize)(1,null,l)));const s=w.DataTransferConverter.toDataTransfer(S);return o===l&&r&&await this.addAdditionalTransferItems(s,t,r,T,i),t.onDrop(s,n,T)}async addAdditionalTransferItems(l,S,n,T,i){const o=this.treeDragAndDropService.removeDragOperationTransfer(i);if(o)(await o)?.forEach((r,t)=>{r&&l.set(t,r)});else if(i&&S.handleDrag){const r=S.handleDrag(n,l,T);this.treeDragAndDropService.addDragOperationTransfer(i,r),await r}return l}async $handleDrag(l,S,n,T){const i=this.treeViews.get(l);if(!i)return Promise.reject(new Error((0,a.localize)(2,null,l)));const o=await this.addAdditionalTransferItems(new Map,i,S,T,n);if(!!o)return w.DataTransferConverter.toDataTransferDTO(o)}async $hasResolve(l){const S=this.treeViews.get(l);if(!S)throw new Error((0,a.localize)(3,null,l));return S.hasResolve}$resolve(l,S,n){const T=this.treeViews.get(l);if(!T)throw new Error((0,a.localize)(4,null,l));return T.resolveTreeItem(S,n)}$setExpanded(l,S,n){const T=this.treeViews.get(l);if(!T)throw new Error((0,a.localize)(5,null,l));T.setExpanded(S,n)}$setSelection(l,S){const n=this.treeViews.get(l);if(!n)throw new Error((0,a.localize)(6,null,l));n.setSelection(S)}$setVisible(l,S){const n=this.treeViews.get(l);if(!n)throw new Error((0,a.localize)(7,null,l));n.setVisible(S)}createExtHostTreeView(l,S,n){const T=new y(l,S,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(l,T),T}convertArgument(l){const S=this.treeViews.get(l.$treeViewId);return S?S.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=c;class y extends I.Disposable{constructor(l,S,n,T,i,o){super();if(this.viewId=l,this.proxy=n,this.commands=T,this.logService=i,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new L.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new L.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new L.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new L.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,o.contributes&&o.contributes.views)for(const s in o.contributes.views)for(const m of o.contributes.views[s])m.id===l&&(this._title=m.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let r,t;this._register(L.Event.debounce(this._onDidChangeData.event,(s,m)=>(s||(s={message:!1,elements:[]}),m.element!==!1&&(r||(r=new Promise(d=>t=d),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(m.element)?s.elements.push(...m.element):s.elements.push(m.element)),m.message&&(s.message=!0),s),200,!0)(({message:s,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=t;return r=null,this.refresh(m).then(()=>d())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,P.isUndefinedOrNull)(l))}async getChildren(l){const S=l?this.getExtensionElement(l):void 0;if(l&&!S)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(l);return n||(n=await this.fetchChildrenNodes(S)),n?n.map(T=>T.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,S){S=S||{select:!0,focus:!1};const n=(0,P.isUndefinedOrNull)(S.select)?!0:S.select,T=(0,P.isUndefinedOrNull)(S.focus)?!1:S.focus,i=(0,P.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(o=>this.resolveTreeNode(l,o[o.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:o.map(t=>t.item)},{select:n,focus:T,expand:i})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:T,expand:i})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=v.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,S){const n=this.getExtensionElement(l);n&&(S?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(l){(0,R.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,S,n){const T=[];for(const i of l){const o=this.getExtensionElement(i);o&&T.push(o)}if(!(!this.dndController?.handleDrag||T.length===0))return await this.dndController.handleDrag(T,S,n),S}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,S,n){const T=S?this.getExtensionElement(S):void 0;if(!(!T&&S||!this.dndController?.handleDrop))return(0,k.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(T,l,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,S){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(l);if(n){const T=this.nodes.get(n);if(T){const i=await this.dataProvider.resolveTreeItem(T.extensionItem,n,S)??T.extensionItem;return T.item.tooltip=this.getTooltip(i.tooltip),T.item.command=this.getCommand(T.disposableStore,i.command),T.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(S=>S?this.resolveUnknownParentChain(S).then(n=>this.resolveTreeNode(S,n[n.length-1]).then(T=>(n.push(T),n))):Promise.resolve([]))}resolveParent(l){const S=this.nodes.get(l);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,S){const n=this.nodes.get(l);return n?Promise.resolve(n):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(T=>this.createHandle(l,T,S,!0)).then(T=>this.getChildren(S?S.item.handle:void 0).then(()=>{const i=this.getExtensionElement(T);if(i){const o=this.nodes.get(i);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${T}`)}))}getChildrenNodes(l){if(l){let S;if(typeof l=="string"){const n=this.getExtensionElement(l);S=n?this.nodes.get(n):void 0}else S=l;return S&&S.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const S=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=l?this.nodes.get(l):void 0,T=await this.dataProvider.getChildren(l);if(S.token.isCancellationRequested)return;const i=await Promise.all((0,R.coalesce)(T||[]).map(async o=>{const r=await this.dataProvider.getTreeItem(o);return r&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(o,r,n):null}));return S.token.isCancellationRequested?void 0:(0,R.coalesce)(i)}finally{S.dispose()}}refresh(l){if(l.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(l);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const S=new Set,n=l.map(i=>this.nodes.get(i));for(const i of n)if(i&&!S.has(i.item.handle)){let o=i;for(;o&&o.parent&&n.findIndex(r=>o&&o.parent&&r&&r.item.handle===o.parent.item.handle)===-1;){const r=this.elements.get(o.parent.item.handle);o=r?this.nodes.get(r):void 0}o&&!o.parent&&S.add(i.item.handle)}const T=[];return S.forEach(i=>{const o=this.elements.get(i);if(o){const r=this.nodes.get(o);r&&(!r.parent||!S.has(r.parent.item.handle))&&T.push(i)}}),T}refreshHandles(l){const S={};return Promise.all(l.map(n=>this.refreshNode(n).then(T=>{T&&(S[n]=T.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(l){const S=this.getExtensionElement(l);if(S){const n=this.nodes.get(S);if(n)return this.clearChildren(S),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(T=>{if(T){const i=this.createTreeNode(S,T,n.parent);return this.updateNodeCache(S,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,S,n){const T=this.createTreeNode(l,S,n);if(S.id&&this.elements.has(T.item.handle))throw new Error((0,a.localize)(8,null,S.id));return this.addNodeToCache(l,T),this.addNodeToParentCache(T,n),T}getTooltip(l){return b.MarkdownString.isMarkdownString(l)?v.MarkdownString.from(l):l}getCommand(l,S){return S?this.commands.toInternal(S,l):void 0}createTreeNode(l,S,n){const T=new I.DisposableStore,i=this.createHandle(l,S,n),o=this.getLightIconPath(S);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:h(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(T,S.command),contextValue:S.contextValue,icon:o,iconDark:this.getDarkIconPath(S)||o,themeIcon:this.getThemeIcon(S),collapsibleState:(0,P.isUndefinedOrNull)(S.collapsibleState)?b.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:n,children:void 0,disposableStore:T,dispose(){T.dispose()}}}getThemeIcon(l){return l.iconPath instanceof b.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:S,label:n,resourceUri:T},i,o){if(S)return`${y.ID_HANDLE_PREFIX}/${S}`;const r=h(n,this.extension),t=i?i.item.handle:y.LABEL_HANDLE_PREFIX;let s=r?r.label:T?(0,D.basename)(T):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const m=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,d=this.getChildrenNodes(i)||[];let C,O=0;do{if(C=`${t}/${O}:${s}`,o||!this.elements.has(C)||m===C)break;O++}while(O<=d.length);return C}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof b.ThemeIcon))return typeof l.iconPath=="string"||g.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof b.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return g.URI.isUri(l)?l:g.URI.file(l)}addNodeToCache(l,S){this.elements.set(S.item.handle,l),this.nodes.set(l,S)}updateNodeCache(l,S,n,T){this.elements.delete(S.item.handle),this.nodes.delete(l),S.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(l,S);const i=this.getChildrenNodes(T)||[],o=i.filter(r=>r.item.handle===n.item.handle)[0];o&&i.splice(i.indexOf(o),1,S)}addNodeToParentCache(l,S){S?(S.children||(S.children=[]),S.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const S=this.nodes.get(l);if(S){if(S.children)for(const n of S.children){const T=this.elements.get(n.item.handle);T&&this.clear(T)}S.children=void 0}}else this.clearAll()}clear(l){const S=this.nodes.get(l);if(S){if(S.children)for(const n of S.children){const T=this.elements.get(n.item.handle);T&&this.clear(T)}this.nodes.delete(l),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}y.LABEL_HANDLE_PREFIX="0",y.ID_HANDLE_PREFIX="1"}),define(Se[228],De([1,0,20,12,5,32,2,120,239,115,114,38,4,93,183,182,36,184,30,185,186,187,172,188,49,31,190,191,194,196,198,98,174,203,204,205,71,52,207,227,8,6,210,53,97,29,54,162,193,83,94,100,102,103,13,65,16,28,199,159,64,70,180,208,72,51,213,211,212,181,35,206,209,69,50,84,96,99,202,11,80,200,157,192,7,21,164,201]),function(ee,e,a,D,g,L,I,k,b,P,R,v,p,w,f,u,h,c,y,_,l,S,n,T,i,o,r,t,s,m,d,C,O,U,A,E,$,x,H,oe,G,M,le,me,ae,ge,te,Ee,we,Z,pe,Pe,Ne,We,Ge,Ce,_e,Te,se,ue,Q,J,ce,ve,F,W,V,K,z,Y,ie,Fe,Ue,ke,Ve,q,X,he,Le,xe,Xe,Je,rt,Ye,Ze,qe,lt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function It(at){const ht=at.get(Te.IExtHostInitDataService),Ut=at.get(ie.IExtHostFileSystemInfo),Ft=at.get(W.IExtHostConsumerFileSystem),yt=at.get(o.IExtHostExtensionService),ft=at.get(ge.IExtHostWorkspace),Dt=at.get(q.IExtHostTelemetry),Pt=at.get(y.IExtHostConfiguration),Nt=at.get(Ce.IURITransformerService),He=at.get(_e.IExtHostRpcService),$t=at.get($.IExtHostStorage),At=at.get(F.IExtensionStoragePaths),Mt=at.get(Ge.ILoggerService),be=at.get(Ge.ILogService),ye=at.get(Q.IExtHostTunnelService),de=at.get(J.IExtHostApiDeprecationService),j=at.get(ae.IExtHostWindow),Ae=at.get(ke.IExtHostSecretState),Be=at.get(Ve.IExtHostEditorTabs);He.set(p.ExtHostContext.ExtHostFileSystemInfo,Ut),He.set(p.ExtHostContext.ExtHostLogLevelServiceShape,Mt),He.set(p.ExtHostContext.ExtHostWorkspace,ft),He.set(p.ExtHostContext.ExtHostConfiguration,Pt),He.set(p.ExtHostContext.ExtHostExtensionService,yt),He.set(p.ExtHostContext.ExtHostStorage,$t),He.set(p.ExtHostContext.ExtHostTunnelService,ye),He.set(p.ExtHostContext.ExtHostWindow,j),He.set(p.ExtHostContext.ExtHostSecretState,Ae),He.set(p.ExtHostContext.ExtHostTelemetry,Dt),He.set(p.ExtHostContext.ExtHostEditorTabs,Be);const tt=He.set(p.ExtHostContext.ExtHostDecorations,at.get(pe.IExtHostDecorations)),je=He.set(p.ExtHostContext.ExtHostDocumentsAndEditors,at.get(i.IExtHostDocumentsAndEditors)),ot=He.set(p.ExtHostContext.ExtHostCommands,at.get(h.IExtHostCommands)),ct=He.set(p.ExtHostContext.ExtHostTerminalService,at.get(x.IExtHostTerminalService)),pt=He.set(p.ExtHostContext.ExtHostDebugService,at.get(Ne.IExtHostDebugService)),_t=He.set(p.ExtHostContext.ExtHostSearch,at.get(We.IExtHostSearch)),mt=He.set(p.ExtHostContext.ExtHostTask,at.get(Pe.IExtHostTask)),vt=He.set(p.ExtHostContext.ExtHostOutputService,at.get(C.IExtHostOutputService)),Rt=He.set(p.ExtHostContext.ExtHostUrls,new le.ExtHostUrls(He)),Et=He.set(p.ExtHostContext.ExtHostDocuments,new T.ExtHostDocuments(He,je)),Gt=He.set(p.ExtHostContext.ExtHostDocumentContentProviders,new S.ExtHostDocumentContentProvider(He,je,be)),Qt=He.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(be,Et,He.getProxy(p.MainContext.MainThreadBulkEdits))),bt=He.set(p.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(He,ot,je,Et,At)),zt=He.set(p.ExtHostContext.ExtHostNotebookDocuments,new rt.ExtHostNotebookDocuments(bt)),Yt=He.set(p.ExtHostContext.ExtHostNotebookEditors,new Je.ExtHostNotebookEditors(be,He,bt)),Jt=He.set(p.ExtHostContext.ExtHostNotebookKernels,new X.ExtHostNotebookKernels(He,ht,bt,ot,be)),ui=He.set(p.ExtHostContext.ExtHostNotebookProxyKernels,new st.ExtHostNotebookProxyKernels(He,Jt,be)),ci=He.set(p.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(He,bt)),Tt=He.set(p.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(He,je)),Zt=He.set(p.ExtHostContext.ExtHostTreeViews,new oe.ExtHostTreeViews(He.getProxy(p.MainContext.MainThreadTreeViews),ot,be)),di=He.set(p.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(He.getProxy(p.MainContext.MainThreadEditorInsets),Tt,ht.remote)),Xt=He.set(p.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(He,be,Ut)),ei=He.set(p.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(He,Et,ot.converter,Nt)),dt=He.set(p.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(He,Nt,Et,ot,Xt,be,de)),hi=He.set(p.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(He,dt)),Bt=He.set(p.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(He,be,je)),Ht=He.set(p.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(He,ft,ot)),ti=He.set(p.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(He,ot,be)),ki=He.set(p.ExtHostContext.ExtHostComments,(0,c.createExtHostComments)(He,ot,Et)),ii=He.set(p.ExtHostContext.ExtHostProgress,new O.ExtHostProgress(He.getProxy(p.MainContext.MainThreadProgress))),fi=He.set(p.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(He)),_i=He.set(p.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(He)),ni=He.set(p.ExtHostContext.ExtHostAuthentication,new ce.ExtHostAuthentication(He)),Pi=He.set(p.ExtHostContext.ExtHostTimeline,new ve.ExtHostTimeline(He,ot)),mi=He.set(p.ExtHostContext.ExtHostWebviews,new me.ExtHostWebviews(He,ht.remote,ft,be,de)),gi=He.set(p.ExtHostContext.ExtHostWebviewPanels,new z.ExtHostWebviewPanels(He,mi,ft)),Ai=He.set(p.ExtHostContext.ExtHostCustomEditors,new K.ExtHostCustomEditors(He,Et,At,mi,gi)),pi=He.set(p.ExtHostContext.ExtHostWebviewViews,new V.ExtHostWebviewViews(He,mi)),Vt=He.set(p.ExtHostContext.ExtHostTesting,new Fe.ExtHostTesting(He,ot)),Ri=He.set(p.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(He));He.set(p.ExtHostContext.ExtHostInteractive,new Ye.ExtHostInteractive(He,bt,je,ot));const Oi=(0,te.values)(p.ExtHostContext);He.assertRegistered(Oi);const Fi=new Y.ExtHostBulkEdits(He,je),ri=new u.ExtHostClipboard(He),vi=new d.ExtHostMessageService(He,be),Si=new l.ExtHostDialogs(He),yi=new E.ExtHostStatusBar(He,ot.converter);return f.ExtHostApiCommands.register(ot),function(Me,Lt,Di){const gt=function(){let ne=!Me.isUnderDevelopment;function fe(){ne||(be.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(it){if(Array.isArray(it))it.forEach(Oe);else if(typeof it=="string")fe();else{const wt=it;typeof wt.scheme=="undefined"&&fe(),typeof wt.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return it}}(),jt={getSession(ne,fe,Oe){return ni.getSession(Me,ne,fe,Oe)},async hasSession(ne,fe){return(0,qe.checkProposedApiEnabled)(Me,"authSession"),!!await ni.getSession(Me,ne,fe,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Oe,it){return ni.registerAuthenticationProvider(ne,fe,Oe,it)}},Ni={registerCommand(ne,fe,Oe){return ot.registerCommand(!0,ne,fe,Oe,void 0,Me)},registerTextEditorCommand(ne,fe,Oe){return ot.registerCommand(!0,ne,(...it)=>{const wt=Tt.getActiveTextEditor();if(!wt){be.warn("Cannot execute "+ne+" because there is no active text editor.");return}return wt.edit(Ct=>{fe.apply(Oe,[wt,Ct,...it])}).then(Ct=>{Ct||be.warn("Edits from command "+ne+" were not applied.")},Ct=>{be.warn("An error occurred while running command "+ne,Ct)})},void 0,void 0,Me)},registerDiffInformationCommand:(ne,fe,Oe)=>((0,qe.checkProposedApiEnabled)(Me,"diffCommand"),ot.registerCommand(!0,ne,async(...it)=>{const wt=je.activeEditor(!0);if(!wt){be.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Ct=await Tt.getDiffInformation(wt.id);fe.apply(Oe,[Ct,...it])},void 0,void 0,Me)),executeCommand(ne,...fe){return ot.executeCommand(ne,...fe)},getCommands(ne=!1){return ot.getCommands(ne)}},Ot={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ne=Date.now()-new Date(ht.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,fe){return j.openUri(ne,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ht.environment.appUriScheme)return Rt.createAppUri(ne);try{return await j.asExternalUri(ne,{allowTunneling:!!ht.remote.authority})}catch(fe){if((0,Xe.matchesScheme)(ne,xe.Schemas.http)||(0,Xe.matchesScheme)(ne,xe.Schemas.https))return ne;throw fe}},get remoteName(){return(0,Z.getRemoteName)(ht.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Me,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind}};ht.environment.extensionTestsLocationURI||Object.freeze(Ot);const si={createTestController(ne,fe,Oe){return Vt.createTestController(ne,fe,Oe)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),Vt.createTestObserver()},runTests(ne){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),Vt.runTests(ne)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),Vt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),Vt.results}},oi=ht.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Mi={getExtension(ne,fe){(0,qe.isProposedApiEnabled)(Me,"extensionsAny")||(fe=!1);const Oe=Lt.mine.getExtensionDescription(ne);if(Oe)return new o.Extension(yt,Me.identifier,Oe,oi,!1);if(fe){const it=Lt.all.getExtensionDescription(ne);if(it)return new o.Extension(yt,Me.identifier,it,oi,!0)}},get all(){const ne=[];for(const fe of Lt.mine.getAllExtensionDescriptions())ne.push(new o.Extension(yt,Me.identifier,fe,oi,!1));return ne},get allAcrossExtensionHosts(){(0,qe.checkProposedApiEnabled)(Me,"extensionsAny");const ne=new qe.ExtensionIdentifierSet(Lt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),fe=[];for(const Oe of Lt.all.getAllExtensionDescriptions()){const it=!ne.has(Oe.identifier);fe.push(new o.Extension(yt,Me.identifier,Oe,oi,it))}return fe},get onDidChange(){return(0,qe.isProposedApiEnabled)(Me,"extensionsAny")?g.Event.any(Lt.mine.onDidChange,Lt.all.onDidChange):Lt.mine.onDidChange}},Li={createDiagnosticCollection(ne){return Xt.createDiagnosticCollection(Me.identifier,ne)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:ne=>Xt.getDiagnostics(ne),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ne,fe){return ei.changeLanguage(ne.uri,fe)},match(ne,fe){return(0,R.score)(G.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,fe.notebook?.notebookType)},registerCodeActionsProvider(ne,fe,Oe){return dt.registerCodeActionProvider(Me,gt(ne),fe,Oe)},registerCodeLensProvider(ne,fe){return dt.registerCodeLensProvider(Me,gt(ne),fe)},registerDefinitionProvider(ne,fe){return dt.registerDefinitionProvider(Me,gt(ne),fe)},registerDeclarationProvider(ne,fe){return dt.registerDeclarationProvider(Me,gt(ne),fe)},registerImplementationProvider(ne,fe){return dt.registerImplementationProvider(Me,gt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return dt.registerTypeDefinitionProvider(Me,gt(ne),fe)},registerHoverProvider(ne,fe){return dt.registerHoverProvider(Me,gt(ne),fe,Me.identifier)},registerEvaluatableExpressionProvider(ne,fe){return dt.registerEvaluatableExpressionProvider(Me,gt(ne),fe,Me.identifier)},registerInlineValuesProvider(ne,fe){return dt.registerInlineValuesProvider(Me,gt(ne),fe,Me.identifier)},registerDocumentHighlightProvider(ne,fe){return dt.registerDocumentHighlightProvider(Me,gt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return dt.registerLinkedEditingRangeProvider(Me,gt(ne),fe)},registerReferenceProvider(ne,fe){return dt.registerReferenceProvider(Me,gt(ne),fe)},registerRenameProvider(ne,fe){return dt.registerRenameProvider(Me,gt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Oe){return dt.registerDocumentSymbolProvider(Me,gt(ne),fe,Oe)},registerWorkspaceSymbolProvider(ne){return dt.registerWorkspaceSymbolProvider(Me,ne)},registerDocumentFormattingEditProvider(ne,fe){return dt.registerDocumentFormattingEditProvider(Me,gt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return dt.registerDocumentRangeFormattingEditProvider(Me,gt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Oe,...it){return dt.registerOnTypeFormattingEditProvider(Me,gt(ne),fe,[Oe].concat(it))},registerDocumentSemanticTokensProvider(ne,fe,Oe){return dt.registerDocumentSemanticTokensProvider(Me,gt(ne),fe,Oe)},registerDocumentRangeSemanticTokensProvider(ne,fe,Oe){return dt.registerDocumentRangeSemanticTokensProvider(Me,gt(ne),fe,Oe)},registerSignatureHelpProvider(ne,fe,Oe,...it){return typeof Oe=="object"?dt.registerSignatureHelpProvider(Me,gt(ne),fe,Oe):dt.registerSignatureHelpProvider(Me,gt(ne),fe,typeof Oe=="undefined"?[]:[Oe,...it])},registerCompletionItemProvider(ne,fe,...Oe){return dt.registerCompletionItemProvider(Me,gt(ne),fe,Oe)},registerInlineCompletionItemProvider(ne,fe){return(0,qe.checkProposedApiEnabled)(Me,"inlineCompletions"),dt.registerInlineCompletionsProvider(Me,gt(ne),fe)},registerInlineCompletionItemProviderNew(ne,fe){if((0,qe.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),fe.handleDidShowCompletionItem&&!(0,qe.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(Me,gt(ne),fe)},registerDocumentLinkProvider(ne,fe){return dt.registerDocumentLinkProvider(Me,gt(ne),fe)},registerColorProvider(ne,fe){return dt.registerColorProvider(Me,gt(ne),fe)},registerFoldingRangeProvider(ne,fe){return dt.registerFoldingRangeProvider(Me,gt(ne),fe)},registerSelectionRangeProvider(ne,fe){return dt.registerSelectionRangeProvider(Me,ne,fe)},registerCallHierarchyProvider(ne,fe){return dt.registerCallHierarchyProvider(Me,ne,fe)},registerTypeHierarchyProvider(ne,fe){return dt.registerTypeHierarchyProvider(Me,ne,fe)},setLanguageConfiguration:(ne,fe)=>dt.setLanguageConfiguration(Me,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,qe.checkProposedApiEnabled)(Me,"tokenInformation"),ei.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return dt.registerInlayHintsProvider(Me,ne,fe)},createLanguageStatusItem(ne,fe){return ei.createLanguageStatusItem(Me,ne,fe)},registerDocumentOnDropProvider(ne,fe){return(0,qe.checkProposedApiEnabled)(Me,"textEditorDrop"),dt.registerDocumentOnDropProvider(Me,ne,fe)}},Ui={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(ne,fe,Oe){const it=await(I.URI.isUri(ne)?Promise.resolve(Ci.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(it,fe,Oe)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Me,ne)},onDidChangeActiveTextEditor(ne,fe,Oe){return Tt.onDidChangeActiveTextEditor(ne,fe,Oe)},onDidChangeVisibleTextEditors(ne,fe,Oe){return Tt.onDidChangeVisibleTextEditors(ne,fe,Oe)},onDidChangeTextEditorSelection(ne,fe,Oe){return Tt.onDidChangeTextEditorSelection(ne,fe,Oe)},onDidChangeTextEditorOptions(ne,fe,Oe){return Tt.onDidChangeTextEditorOptions(ne,fe,Oe)},onDidChangeTextEditorVisibleRanges(ne,fe,Oe){return Tt.onDidChangeTextEditorVisibleRanges(ne,fe,Oe)},onDidChangeTextEditorViewColumn(ne,fe,Oe){return Tt.onDidChangeTextEditorViewColumn(ne,fe,Oe)},onDidCloseTerminal(ne,fe,Oe){return ct.onDidCloseTerminal(ne,fe,Oe)},onDidOpenTerminal(ne,fe,Oe){return ct.onDidOpenTerminal(ne,fe,Oe)},onDidChangeActiveTerminal(ne,fe,Oe){return ct.onDidChangeActiveTerminal(ne,fe,Oe)},onDidChangeTerminalDimensions(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"terminalDimensions"),ct.onDidChangeTerminalDimensions(ne,fe,Oe)},onDidChangeTerminalState(ne,fe,Oe){return ct.onDidChangeTerminalState(ne,fe,Oe)},onDidWriteTerminalData(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ct.onDidWriteTerminalData(ne,fe,Oe)},get state(){return j.state},onDidChangeWindowState(ne,fe,Oe){return j.onDidChangeWindowState(ne,fe,Oe)},showInformationMessage(ne,...fe){return vi.showMessage(Me,L.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return vi.showMessage(Me,L.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return vi.showMessage(Me,L.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Oe){return Ht.showQuickPick(ne,fe,Oe)},showWorkspaceFolderPick(ne){return Ht.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return ne?.validateInput2&&(0,qe.checkProposedApiEnabled)(Me,"inputBoxSeverity"),Ht.showInput(ne,fe)},showOpenDialog(ne){return Si.showOpenDialog(ne)},showSaveDialog(ne){return Si.showSaveDialog(ne)},createStatusBarItem(ne,fe,Oe){let it,wt,Ct;return typeof ne=="string"?(it=ne,wt=fe,Ct=Oe):(wt=ne,Ct=fe),yi.createStatusBarEntry(Me,it,wt,Ct)},setStatusBarMessage(ne,fe){return yi.setStatusBarMessage(ne,fe)},withScmProgress(ne){return de.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ii.withProgress(Me,{location:M.ProgressLocation.SourceControl},(fe,Oe)=>ne({report(it){}}))},withProgress(ne,fe){return ii.withProgress(Me,ne,fe)},createOutputChannel(ne,fe){return vt.createOutputChannel(ne,fe,Me)},createWebviewPanel(ne,fe,Oe,it){return gi.createWebviewPanel(Me,ne,fe,Oe,it)},createWebviewTextEditorInset(ne,fe,Oe,it){return(0,qe.checkProposedApiEnabled)(Me,"editorInsets"),di.createWebviewEditorInset(ne,fe,Oe,it,Me)},createTerminal(ne,fe,Oe){return typeof ne=="object"?"pty"in ne?ct.createExtensionTerminal(ne):ct.createTerminalFromOptions(ne):ct.createTerminal(ne,fe,Oe)},registerTerminalLinkProvider(ne){return ct.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return ct.registerProfileProvider(Me,ne,fe)},registerTreeDataProvider(ne,fe){return Zt.registerTreeDataProvider(ne,fe,Me)},createTreeView(ne,fe){return Zt.createTreeView(ne,fe,Me)},registerWebviewPanelSerializer:(ne,fe)=>gi.registerWebviewPanelSerializer(Me,ne,fe),registerCustomEditorProvider:(ne,fe,Oe={})=>Ai.registerCustomEditorProvider(Me,ne,fe,Oe),registerFileDecorationProvider(ne){return tt.registerFileDecorationProvider(ne,Me.identifier)},registerUriHandler(ne){return Rt.registerUriHandler(Me.identifier,ne)},createQuickPick(){return Ht.createQuickPick(Me)},createInputBox(){return Ht.createInputBox(Me)},get activeColorTheme(){return _i.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Oe){return _i.onDidChangeActiveColorTheme(ne,fe,Oe)},registerWebviewViewProvider(ne,fe,Oe){return pi.registerWebviewViewProvider(Me,ne,fe,Oe?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(ne,fe,Oe)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(ne,fe,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(ne,fe,Oe)},showNotebookDocument(ne,fe){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),bt.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"externalUriOpener"),Ri.registerExternalUriOpener(Me.identifier,ne,fe,Oe)},get tabGroups(){return Be.tabGroups},getInlineCompletionItemController(ne){return(0,qe.checkProposedApiEnabled)(Me,"inlineCompletions"),s.InlineCompletionController.get(ne)}},Ci={get rootPath(){return de.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw D.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw D.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw D.readonly()},updateWorkspaceFolders:(ne,fe,...Oe)=>ft.updateWorkspaceFolders(Me,ne,fe||0,...Oe),onDidChangeWorkspaceFolders:function(ne,fe,Oe){return ft.onDidChangeWorkspace(ne,fe,Oe)},asRelativePath:(ne,fe)=>ft.getRelativePath(ne,fe),findFiles:(ne,fe,Oe,it)=>ft.findFiles(ne,fe,Oe,Me.identifier,it),findTextInFiles:(ne,fe,Oe,it)=>{(0,qe.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Ct;return typeof fe=="object"?(wt=fe,Ct=Oe):(wt={},Ct=fe,it=Oe),ft.findTextInFiles(ne,wt||{},Ct,Me.identifier,it)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne){return Fi.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,fe,Oe,it)=>Bt.createFileSystemWatcher(ft,Me,ne,fe,Oe,it),get textDocuments(){return Et.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw D.readonly()},openTextDocument(ne){let fe;const Oe=ne;if(typeof ne=="string")fe=Promise.resolve(I.URI.file(ne));else if(I.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")fe=Et.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(it=>Et.ensureDocumentData(it).then(wt=>wt.document))},onDidOpenTextDocument:(ne,fe,Oe)=>Et.onDidAddDocument(ne,fe,Oe),onDidCloseTextDocument:(ne,fe,Oe)=>Et.onDidRemoveDocument(ne,fe,Oe),onDidChangeTextDocument:(ne,fe,Oe)=>Et.onDidChangeDocument(ne,fe,Oe),onDidSaveTextDocument:(ne,fe,Oe)=>Et.onDidSaveDocument(ne,fe,Oe),onWillSaveTextDocument:(ne,fe,Oe)=>Qt.getOnWillSaveTextDocumentEvent(Me)(ne,fe,Oe),get notebookDocuments(){return bt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Oe;if(I.URI.isUri(ne))Oe=ne,await bt.openNotebookDocument(ne);else if(typeof ne=="string")Oe=I.URI.revive(await bt.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,fe,Oe){return zt.onDidSaveNotebookDocument(ne,fe,Oe)},onDidChangeNotebookDocument(ne,fe,Oe){return zt.onDidChangeNotebookDocument(ne,fe,Oe)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Oe,it){return bt.registerNotebookSerializer(Me,ne,fe,Oe,(0,qe.isProposedApiEnabled)(Me,"notebookLiveShare")?it:void 0)},registerNotebookContentProvider:(ne,fe,Oe,it)=>((0,qe.checkProposedApiEnabled)(Me,"notebookContentProvider"),bt.registerNotebookContentProvider(Me,ne,fe,Oe,(0,qe.isProposedApiEnabled)(Me,"notebookLiveShare")?it:void 0)),onDidChangeConfiguration:(ne,fe,Oe)=>Di.onDidChangeConfiguration(ne,fe,Oe),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,Di.getConfiguration(ne,fe,Me)},registerTextDocumentContentProvider(ne,fe){return Gt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(de.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Me,ne,fe)),registerFileSystemProvider(ne,fe,Oe){return(0,Ze.combinedDisposable)(hi.registerFileSystemProvider(Me,ne,fe,Oe),Ft.addFileSystemProvider(ne,fe))},get fs(){return Ft.value},registerFileSearchProvider:(ne,fe)=>((0,qe.checkProposedApiEnabled)(Me,"fileSearchProvider"),_t.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,qe.checkProposedApiEnabled)(Me,"textSearchProvider"),_t.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),yt.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),fi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Oe)=>Bt.onDidCreateFile(ne,fe,Oe),onDidDeleteFiles:(ne,fe,Oe)=>Bt.onDidDeleteFile(ne,fe,Oe),onDidRenameFiles:(ne,fe,Oe)=>Bt.onDidRenameFile(ne,fe,Oe),onWillCreateFiles:(ne,fe,Oe)=>Bt.getOnWillCreateFileEvent(Me)(ne,fe,Oe),onWillDeleteFiles:(ne,fe,Oe)=>Bt.getOnWillDeleteFileEvent(Me)(ne,fe,Oe),onWillRenameFiles:(ne,fe,Oe)=>Bt.getOnWillRenameFileEvent(Me)(ne,fe,Oe),openTunnel:ne=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),ye.openTunnel(Me,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Me,"resolvers"),ye.getTunnels()},onDidChangeTunnels:(ne,fe,Oe)=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),ye.onDidChangeTunnels(ne,fe,Oe)),registerPortAttributesProvider:(ne,fe)=>((0,qe.checkProposedApiEnabled)(Me,"portsAttributes"),ye.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,qe.checkProposedApiEnabled)(Me,"timeline"),Pi.registerTimelineProvider(ne,fe,Me.identifier,ot.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,qe.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Oe)=>ft.onDidGrantWorkspaceTrust(ne,fe,Oe)},Bi={get inputBox(){return de.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ti.getLastInputBox(Me)},createSourceControl(ne,fe,Oe){return ti.createSourceControl(Me,ne,fe,Oe)}},xi={createCommentController(ne,fe){return ki.createCommentController(Me,ne,fe)}},Ei={get activeDebugSession(){return pt.activeDebugSession},get activeDebugConsole(){return pt.activeDebugConsole},get breakpoints(){return pt.breakpoints},onDidStartDebugSession(ne,fe,Oe){return pt.onDidStartDebugSession(ne,fe,Oe)},onDidTerminateDebugSession(ne,fe,Oe){return pt.onDidTerminateDebugSession(ne,fe,Oe)},onDidChangeActiveDebugSession(ne,fe,Oe){return pt.onDidChangeActiveDebugSession(ne,fe,Oe)},onDidReceiveDebugSessionCustomEvent(ne,fe,Oe){return pt.onDidReceiveDebugSessionCustomEvent(ne,fe,Oe)},onDidChangeBreakpoints(ne,fe,Oe){return pt.onDidChangeBreakpoints(ne,fe,Oe)},registerDebugConfigurationProvider(ne,fe,Oe){return pt.registerDebugConfigurationProvider(ne,fe,Oe||lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return pt.registerDebugAdapterDescriptorFactory(Me,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return pt.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?pt.startDebugging(ne,fe,{parentSession:Oe}):pt.startDebugging(ne,fe,Oe||{})},stopDebugging(ne){return pt.stopDebugging(ne)},addBreakpoints(ne){return pt.addBreakpoints(ne)},removeBreakpoints(ne){return pt.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return pt.asDebugSourceUri(ne,fe)}},$i={registerTaskProvider:(ne,fe)=>mt.registerTaskProvider(Me,ne,fe),fetchTasks:ne=>mt.fetchTasks(ne),executeTask:ne=>mt.executeTask(Me,ne),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(ne,fe,Oe)=>mt.onDidStartTask(ne,fe,Oe),onDidEndTask:(ne,fe,Oe)=>mt.onDidEndTask(ne,fe,Oe),onDidStartTaskProcess:(ne,fe,Oe)=>mt.onDidStartTaskProcess(ne,fe,Oe),onDidEndTaskProcess:(ne,fe,Oe)=>mt.onDidEndTaskProcess(ne,fe,Oe)},Wi={createNotebookController(ne,fe,Oe,it,wt){return Jt.createNotebookController(Me,ne,fe,Oe,it,(0,qe.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>bt.registerNotebookCellStatusBarItemProvider(Me,ne,fe),createNotebookEditorDecorationType(ne){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return ci.createRendererMessaging(Me,ne)},onDidChangeNotebookCellExecutionState(ne,fe,Oe){return(0,qe.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(ne,fe,Oe)},createNotebookProxyController(ne,fe,Oe,it){return(0,qe.checkProposedApiEnabled)(Me,"notebookProxyController"),ui.createNotebookProxyController(Me,ne,fe,Oe,it)}};return{version:ht.version,authentication:jt,commands:Ni,comments:xi,debug:Ei,env:Ot,extensions:Mi,languages:Li,notebooks:Wi,scm:Bi,tasks:$i,tests:si,window:Ui,workspace:Ci,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:D.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CommentThreadState:M.CommentThreadState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:M.InlineCompletionTriggerKindNew,EventEmitter:g.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionItemNew:M.InlineSuggestionNew,InlineCompletionList:M.InlineSuggestions,InlineCompletionListNew:M.InlineSuggestionsNew,Hover:M.Hover,IndentAction:P.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SnippetTextEdit:M.SnippetTextEdit,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:w.UIKind,Uri:I.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintLabelPart:M.InlayHintLabelPart,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:he.TextSearchCompleteMessageType,DataTransfer:M.DataTransfer,DataTransferItem:M.DataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind,InputBoxValidationSeverity:M.InputBoxValidationSeverity,TabInputText:M.TextTabInput,TabInputTextDiff:M.TextDiffTabInput,TabInputCustom:M.CustomEditorTabInput,TabInputNotebook:M.NotebookEditorTabInput,TabInputNotebookDiff:M.NotebookDiffEditorTabInput,TabInputWebview:M.WebviewEditorTabInput,TabInputTerminal:M.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=It}),define(Se[229],De([1,0,228,31,2,222,6,14,4]),function(ee,e,a,D,g,L,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends L.RequireInterceptor{_installInterceptor(){}getModule(f,u){for(let h of this._alternatives){let c=h(f);if(c){f=c;break}}if(this._factories.has(f))return this._factories.get(f).load(f,u,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._extHostContext.getProxy(b.MainContext.MainThreadConsole);p(f,this._initData.environment.isExtensionDevelopmentDebug);const u=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,u,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,u,h){u=u.with({path:v(u.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const c=g.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(u)),y=await fetch(c.toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),y.status!==200)throw new Error(y.statusText);const _=await y.text(),l=`${u.toString(!0)}#vscode-extension`,S=`${_}
//# sourceURL=${l}`;let n;try{n=new Function("module","exports","require",S)}catch(r){throw console.error(f?`Loading code for extension ${f.value} failed: ${r.message}`:`Loading code failed: ${r.message}`),console.error(`${u.toString(!0)}${typeof r.line=="number"?` line ${r.line}`:""}${typeof r.column=="number"?` column ${r.column}`:""}`),console.error(r),r}const T={},i={exports:T},o=r=>{const t=this._fakeModules.getModule(r,u);if(t===void 0)throw new Error(`Cannot load module '${r}'`);return t};try{return h.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),n(i,T,o),i.exports!==T?i.exports:T}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const u=Date.now()+f;for(;Date.now()<u&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=R;function v(w,f){return w.endsWith(f)?w:w+f}function p(w,f){u("info","log"),u("log","log"),u("warn","warn"),u("error","error");function u(y,_){const l=console[y];console[y]=function(){w.$logExtensionHostMessage({type:"__$console",severity:_,arguments:c(arguments)}),f&&l.apply(console,arguments)}}const h=1e5;function c(y){const _=[],l=[];if(y.length)for(let S=0;S<y.length;S++){if(typeof y[S]=="undefined")y[S]="undefined";else if(y[S]instanceof Error){const n=y[S];n.stack?y[S]=n.stack:y[S]=n.toString()}l.push(y[S])}try{const S=JSON.stringify(l,function(n,T){if(T&&typeof T=="object"){if(_.indexOf(T)!==-1)return"[Circular]";_.push(T)}return T});return S.length>h?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}}),define(Se[230],De([1,0,58,31,72,229]),function(ee,e,a,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(D.IExtHostExtensionService,L.ExtHostExtensionService),(0,a.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths)}),define(Se[240],De([1,0,25,5,93,223,215,17,73,11,2,225,230]),function(ee,e,a,D,g,L,I,k,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const p=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(n){return/^(file|vscode-remote):/i.test(n)}const f=fetch.bind(self);function u(n){self.fetch=async function(T,i){return T instanceof Request||w(String(T))&&(T=(await n(R.URI.parse(String(T)))).toString(!0)),f(T,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,i,o,r,t){(async()=>{w(i.toString())&&(i=(await n(R.URI.parse(i.toString()))).toString(!0)),super.open(T,i,o??!0,r,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(T,i){if(/^file:/i.test(T.toString()))T=P.FileAccess.asBrowserUri(R.URI.parse(T.toString())).toString(!0);else if(/^vscode-remote:/i.test(T.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const r=`(${function(d){function C(A){return typeof A=="string"||A instanceof URL?String(A).replace(/^file:\/\//i,"vscode-file://vscode-app"):A}const O=fetch.bind(self);self.fetch=function(A,E){return A instanceof Request?O(A,E):O(C(A),E)},self.XMLHttpRequest=class extends XMLHttpRequest{open(A,E,$,x,H){return super.open(A,C(E),$??!0,x,H)}};const U=importScripts.bind(self);self.importScripts=(...A)=>{U(...A.map(C))},U(d)}.toString()}('${T}'))`;i=i||{},i.name=i.name||k.basename(T.toString());const t=new Blob([r],{type:"application/javascript"}),s=URL.createObjectURL(t);return new n(s,i)}}else self.Worker=class extends I.NestedWorker{constructor(n,T){super(p,n,{name:k.basename(n.toString()),...T})}};const h=new class{constructor(){this.pid=void 0}exit(n){v()}async exists(n){return!0}async realpath(n){return n}};class c{constructor(){const T=new MessageChannel,i=new D.Emitter;let o=!1;p(T.port2,[T.port2]),T.port1.onmessage=r=>{const{data:t}=r;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const s=a.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,g.isMessageOfType)(s,2)){o=!0,_("received terminate message from renderer");return}i.fire(s)},this.protocol={onMessage:i.event,send:r=>{if(!o){const t=r.buffer.buffer.slice(r.buffer.byteOffset,r.buffer.byteOffset+r.buffer.byteLength);T.port1.postMessage(t,[t])}}}}}function y(n){return new Promise(T=>{const i=n.onMessage(o=>{i.dispose();const r=JSON.parse(o.toString());n.send((0,g.createMessageOfType)(0)),T({protocol:n,initData:r})});n.send((0,g.createMessageOfType)(1))})}let _=n=>v();function l(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function S(){b.mark("code/extHost/willConnectToRenderer");const n=new c;return{onmessage(T){!l(T)||y(n.protocol).then(i=>{b.mark("code/extHost/didWaitForInitData");const o=new L.ExtensionHostMain(i.protocol,i.initData,h,null,T.data);u(r=>o.asBrowserUri(r)),_=r=>o.terminate(r)})}}}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c3511e6c69bb39013c4a4b7b9566ec1ca73fc4d5/core/vs/workbench/api/worker/extensionHostWorker.js.map
